
var GameScene = cc.Scene.extend({

	gameConfig:null,
	updateView:null,
	updateMgr:null,
	startBg:null, 

	ctor:function(jsc, config, updateView)
	{
		this._super();
		this.jsc = jsc;
		this.gameConfig = config;
		this.gameConfig.bigVersion = jsc.versionCode;
		this.updateView = updateView;
		this.updateView.setTips("正在检测游戏...");
		this.addChild(this.updateView, 100);

		// print("#md5", "123", md5("123"));

		//镜头层次设置
		// cc.director.setProjection(cc.Director.PROJECTION_2D);
		// var camera1 = cc.Camera.createOrthographic(cc.winSize.width,cc.winSize.height,-1000,1000);
		// camera1.setDepth(-5);
		// camera1.setCameraFlag(cc.CameraFlag.USER1);
		// this.addChild(camera1);
		// var camera2 = cc.Camera.createOrthographic(cc.winSize.width,cc.winSize.height,-1000,1000);
		// camera2.setDepth(-4);
		// camera2.setCameraFlag(cc.CameraFlag.USER2);
		// this.addChild(camera2);
		// var camera3 = cc.Camera.createOrthographic(cc.winSize.width,cc.winSize.height,-1000,1000);
		// camera3.setDepth(-3);
		// camera3.setCameraFlag(cc.CameraFlag.USER3);
		// this.addChild(camera3);
		// var camera4 = cc.Camera.createOrthographic(cc.winSize.width,cc.winSize.height,-1000,1000);
		// camera4.setDepth(-2);
		// camera4.setCameraFlag(cc.CameraFlag.USER4);
		// this.addChild(camera4);
	},
	startGame : function() {
		print("#resVersion", this.gameConfig.resVersion);
		//存储渠道ID
		var LOCALAGENTID = "LOCALAGENTID",
			localAgentId = this.jsc.readKV(LOCALAGENTID);
		if(!localAgentId || localAgentId.length == 0) {
			print("#写入cache", LOCALAGENTID, this.gameConfig.agentId);
			this.jsc.writeKV(LOCALAGENTID, this.gameConfig.agentId);
		}
		else {
			print("#代理ID设置为", localAgentId);
			this.gameConfig.setAgentId(parseInt(localAgentId));
		}
		if(this.gameConfig.isRuntime)
		{
			//runtime直接进入游戏
		}
		else
		{
			//非runtime执行更新
			var sdkId = 0,
				this_ = this;
			if( this.gameConfig.isAndroid() || this.gameConfig.isIOS() ) {
				sdkId = parseInt(this.jsc.getSdkId() || "0");
			}
			this.gameConfig.setSdkId(sdkId);

			this.updateMgr = new GameUpdate(this); 
			// this.sdkApi = new SdkAPI(this,en,className);
			if(this.gameConfig.isNoSdkOrTestSdk())
			{
				this.startUpdate();
			}
			else
			{
				this.initGameSDK();
			}
		}
	},
	initGameSDK : function() {
		var this_ = this;
		this.jsc.initSdk(function(code, vals) {
			if(code == 1) {	//初始化失败
				//TODO:做提示并重新初始化？
				this_.initGameSDK();
			}
			else {	//其它当成功
				this_.startUpdate();
			}
		});
	},
	initGame : function() { 
		if(this.gameConfig.isWin()) {
			try {
				new GameStart(this);
			}
			catch(e) {
				this.printError(e);
			}
		}
		else {
			new GameStart(this);
		}
	},
	enterGame:function()
	{
		var this_ = this;

		if(!!cc.game.config.externList) {
			print("#cc.externList", cc.game.config.externList);
			cc.loader.loadJs(cc.game.config.externList, function(){
				this_.initGame();
			});
		}
		else {
			this.initGame();
		}
	},
	startUpdate:function()
	{
		print("#startUpdate");
		this.updateMgr.checkUpdate();

		//跳过更新
		// this.updateMgr.updateComplete();
	},
	printError:function(e)
	{
		print("---------------------------------------------");
		var arr = e.stack.split("\n");
		var content = "";
		for(var i = 0; i < arr.length; i++)
		{
			var t = arr[i].split("@");
			if(t.length >= 2)
			{
				content += t[1] + "\n";
			}
		}
		print(e.message);
		print(content);
		print("---------------------------------------------");
	},

	clearUpdateView:function()
	{
		if(this.updateView != null && !!this.updateView.getParent())
		{
			this.updateView.getParent().removeChild(this.updateView);
		}
	},
	showUpdateView : function() {
		if(!!this.updateView) {
			this.addChild(this.updateView, 100);
		}
	},
	startDownBPackage : function(completeCallback, downList) {
		if(!this.updateMgr) return false;
		if(!!this.updateMgr && this.updateMgr.isLoading()) return false;
		var list = downList || this.updateMgr.getLeastBPackage();
		this.updateMgr.downloadPackage(list, completeCallback);
		return true;
	},
	needBPackage : function() {
		var list = this.updateMgr.getLeastBPackage();
		return !!list && list.length > 0;
	}

});

var GameUpdate = cc.Class.extend({
	scene : null,

	isNeedRestart : false,
	mgr : null,

	_additionKey : "ADDITIONVERSION",
	// _bPackageKey : "BPACKAGEKEY",
	_plusSubffix : "bhijk",
	_updatePaths : null,
	_additionPackets : null,
	_updateCount : 0,
	_currentItem : null,
	_tryTime : 300,
	_dispose : false,
	_restartList : null,
	_completeCallback : null,

	percentPast : -1,
	_hasError : 0,
	_downUrls : null,
	_writablePath : null,
	_versionPath : null,
	_tmpFile : null,
	ctor : function(gameScene) {
		this.scene = gameScene;
		this._updatePaths = [];
		this._additionPackets = [];
		this._restartList = [];
		this._downUrls = [];
		this._tryTime = 300;

		this.init();
	},
	setNowProgress : function(percent, addStr) { 
		addStr = addStr || "";
		var count = this._updateCount,
			idx = count - this._updatePaths.length;
		if(addStr == "..") {
			var tpercent = Math.ceil( (idx - 1) / count * 100 );
			percent = tpercent + Math.ceil( percent * (100 / count) / 100 );
		}
		percent = Math.max(this.percentPast, percent);
		percent = Math.max(0, Math.min(100, percent));
		if( percent != this.percentPast) {
			this.scene.updateView.setProgress(percent);
		}
		var tipStr = "正在更新资源{4} {0} ({1}/{2}) {3}%".format(this._currentItem.p, idx, count, percent, addStr);
		this.scene.updateView.setTips(tipStr);
		this.percentPast = percent;
	},
	init : function() {

		print("### (.)准备更新，(..)正在下载，(...)正在解压缩，!Error(序号)，");

		var AssetsManager = jsb.AssetsUpdateMgr,
			writePath = jsb.fileUtils.getWritablePath(),
			version = this.scene.jsc.getVerionPath(),
			tmpFile = version + ".zip",
			verPath = writePath + version,
			this_ = this;
		AssetsManager.setVersion(version);
		var mgr = AssetsManager.create(function(obj, code) {
				print("#errorCall", code);
				switch(code) {
					case 0:
						// 创建文件失败,直接提示
						print("#创建文件失败");
						this_.setNowProgress(this_.percentPast, "!");
						this_.redownload();
						break;
					case 1:
						// 网络问题  提示，并且重新下载
						print("#网络问题或文件不存在");
						this_.setNowProgress(this_.percentPast, "!.");
						this_.redownload();
						break;
					case 2:
						// 没有新版本
						print("#没有新版本");
						this_.setNowProgress(this_.percentPast, "!..");
						this_.updateComplete();
						break;
					case 3:
						// 解压缩失败,重新下载
						print("#解压缩失败,重新下载");
						this_.setNowProgress(this_.percentPast, "!...");
						this_.redownload();
						break;
				}
			},
			function(obj, progress) {
				// print("#progress", obj, progress);
				this_.setNowProgress(progress, "..");
			},
			function(obj, code) {
				//code: 3:单个开始, 4:单个结束, 5:解压开始, 6:解压结束
				print("#success", obj, code);
				switch(code) {
					case 4:
						//开始解压
						mgr.uncompress();
						break;
					case 5:
						this_.setNowProgress(this_.percentPast, "...");
						break;
					case 6:
						mgr.removeDownloadPacket();
						if(this_._currentItem.t == "a") {
							this_.scene.jsc.writeKV(this_._additionKey, this_._currentItem.v);
						}
						// if(this_._currentItem.t == "b") {
						// 	this_.scene.jsc.writeKV(this_._bPackageKey, this_._currentItem.v);
						// }
						else if(this_._currentItem.t == "c") {
							this_.scene.jsc.writeKV(this_.scene.jsc.CODE_VERSION, this_._currentItem.v);
						}
						if("cdfugv".indexOf(this_._currentItem.t) > -1) {
							this_.scene.gameConfig.resVersion = parseInt(this_._currentItem.v);
						}
						if(!this_.isNeedRestart) {
							for (var i = 0; i < this_._restartList.length; i++) {
								if(this_._restartList[i] == this_._currentItem.v) {
									this_.isNeedRestart = true;
									print("#isNeedRestart!!!");
								}
							}
						}
						if(!!this_._completeCallback) {
							this_._completeCallback(this_._currentItem.p);
						}
						// cc.director.restart();
						this_._hasError = 0;
						this_.updateNext();
						break;
				}
			}
		);
		mgr.setWriteablePath(verPath);
		mgr.setTempZipFilename(tmpFile);
		mgr.setUncompressPath(verPath);
		print("#删除文件:", verPath + "/" + tmpFile, verPath + "/" + tmpFile + ".tmp");
		mgr.removeFile(verPath + "/" + tmpFile);
		mgr.removeFile(verPath + "/" + tmpFile + ".tmp");

		this.mgr = mgr;
		this._writablePath = writePath;
		this._versionPath = verPath;
		this._tmpFile = tmpFile;
	},
	isLoading : function() {
		return this._currentItem != null;
	},
	redownload : function() {
		if(this._tryTime > 0) {
			this._tryTime--;
			this._updatePaths.unshift(this._currentItem);
			this.mgr.removeDownloadPacket();
			this.mgr.removeFile(this._versionPath + "/" + this._tmpFile + ".tmp");
			this.updateNext();
		}
	},
	updateNext : function() {
		if(!!this._updatePaths && this._updatePaths.length > 0) {
			this._currentItem = this._updatePaths.splice(0, 1)[0];
			this.setNowProgress(this.percentPast, ".");
			var url = this._downUrls[0];
			if(this._hasError == 1 && !!this._downUrls[1]) {
				url = this._downUrls[1];
			}
			this._hasError++;
			var downloadFile = url + this._currentItem.p + ".zip";
			if(this._currentItem.t == "a" || this._plusSubffix.indexOf(this._currentItem.t) > -1) {
				this.mgr.setWriteablePath(this._writablePath);
				this.mgr.setUncompressPath(this._writablePath);
			}
			else {
				this.mgr.setWriteablePath(this._versionPath);
				this.mgr.setUncompressPath(this._versionPath);
			}
			this.mgr.download(downloadFile);
		}
		else {
			if(!!this.scene.updateView) {
				this.scene.updateView.setTips("正在为您启动游戏,请稍等...");
			}
			this._currentItem = null;
			this.updateComplete();
		}
	},
	updateComplete : function() {
		if(!!this._completeCallback) {
			this._completeCallback();
			this._completeCallback = null;
		}
		else {
			if(this.isNeedRestart) {
				var tips = "正在重新启动游戏",
					count = 0,
					this_ = this;
				function callback() {
					if(count < 3) {
						tips += ".";
						this_.scene.updateView.setTips(tips);
					}
					else {
						this_.scene.unschedule(callback);
						cc.director.restart();
					}
					count++;
				}
				this.scene.schedule(callback, 0.5);
			}
			else { 
				if(this.scene.updateView != null) {
					this.scene.updateView.setTips("资源检测中...");
				}
				this.scene.enterGame();
			} 
		}
		this.dispose();
	}, 
	checkUpdate : function() {
		var this_ = this,
			sdkId = this_.scene.gameConfig.sdkId;

		function loadVersion() {
			var url = this_._downUrls[0];
			if(this_._hasError == 1 && !!this_._downUrls[1]) {
				url = this_._downUrls[1];
			}
			print("#version url", url);
			if(!!url) {
				this_.scene.updateView.setTips("游戏启动中...");
				this_.load(url + "version.txt", requestVersionCallback);
			}
			else {
				this_.updateComplete();
			}
			this_._hasError++;
		}

		function requestVersionCallback(txt) {
			print("#requestVersionCallback", txt);
			if(!txt || txt.length == 0) {
				print("#version.txt 加载失败");
				loadVersion();
				return;
			}
			this_.scene.updateView.setTips("正在为您启动游戏!..");
			var vals = txt.split("\r\n"),
				codes = [],
				passVer = this_.scene.gameConfig.resVersion,
				currentVer = 0,
				additionStr = "",
				validStr = "cdf";
			for(var i = 0; i < vals.length; i++) {
				var t = vals[i].substring(0, 1);
				if(t == "p") {	//审核版本
					var vars = [];
					var allVer = vals[i].split(",");
					for(var j = 0; j < allVer.length; j++) {
						vars.push(allVer[j].substring(1));
						print("#config bigversion", vars[j]);
					}
					print("#bigversion:", this_.scene.gameConfig.bigVersion);
					this_.scene.gameConfig.shenHeBigVersion = vars;
				}
				else if("cdfug".indexOf(t) > -1) { //普通更新内容
					if(this_.scene.gameConfig.needUpdate()) {
						currentVer = parseInt(vals[i].substring(1));
						if(currentVer > passVer) {
							codes.push({ v : currentVer, p : vals[i], t : t });
						}
					}
					validStr = validStr.replace(t, "");
				}
				else if(t == "v") { //普通资源更新 
					if(this_.scene.gameConfig.needUpdate()) {
						var vers = vals[i].split(",");
						for(var j = 0; j < vers.length; j++) {
							currentVer = parseInt(vers[j].substring(1))
							if(currentVer > passVer) {
								codes.push({ v : currentVer, p : vers[j], t : t });
							}
						}
					}
				}
				else if(this_._plusSubffix.indexOf(t) > -1) { //增量包 
					if(!this_.scene.gameConfig.plusList) this_.scene.gameConfig.plusList = [];
					// var vers = vals[i].split(",");
					this_.scene.gameConfig.plusList.push(vals[i]);
					print("#bpackage", vals[i]);
				}
				else if(t == "r") {
					this_._restartList = [];
					var vers = vals[i].split(",");
					for(var j = 0; j < vers.length; j++) {
						this_._restartList.push(vers[j].substring(1));
					}
				}
				else if(t == "a") { //分包,用于进游戏就会立即更新 
					additionStr = vals[i];
				}
			}
			if(validStr.length > 0) {
				print("#验证不通过", validStr);
				loadVersion();
				return;
			}

			codes.sort(function(a,b){
				return a.v - b.v;
			}); 

			var additionVersion = this_.scene.jsc.readKV(this_._additionKey);
			passVer = 0;
			if(!!additionVersion && additionVersion.length > 0) {
				passVer = parseInt(additionVersion);
			}
			var vers = additionStr.split(",");
			for(var j = vers.length - 1; j >= 0; j--) {
				currentVer = parseInt(vers[j].substring(1));
				if(currentVer > passVer) {
					if(this_.scene.gameConfig.needAdditionUpdate()) {
						codes.unshift({ v : currentVer, p : vers[j], t : "a", idx : j, count : vers.length });
					}
				}
			}

			//过滤审核版本
			var vlist = this_.scene.gameConfig.shenHeBigVersion,
				bigV = this_.scene.gameConfig.bigVersion;
			if(!!vlist) {
				for(var i = 0; i < vlist.length; i++) {
					if(vlist[i] == bigV) {
						codes = [];
					}
				}
			}

			this_._updatePaths = codes;
			this_._updateCount = codes.length;

			if(this_._updateCount > 0) {
				this_.scene.updateView.setTips("正在为您启动游戏...");
				print("#start update", this_._updateCount);
				this_._hasError = 0;
				this_.updateNext();
			}
			else {
				print("#没有版本更新");
				this_.updateComplete();
			}
		}

		function urlHandler(txt) {
			print("#urlHandler:", txt);
			if(!!txt && txt.length > 0) {
				var vals = txt.split("\r\n");
				if(!!vals && vals.length > 0) {
					var hasUrl = false, dict = {};
					for(var i = 0; i < vals.length; i++) {
						var item = vals[i].split("###");
						print("#sdkId:{0}, url:{1}".format(item[0], item[1]));
						if(!!item && item.length == 2) {
							dict[item[0]] = item[1];
							hasUrl = true;
						}
					}
					if(hasUrl) {
						var key = sdkId.toString(),
							url = dict[key];
						if(!url) {
							key = "0";
							url = dict[key];
						}
						print("#sdkId", sdkId, key, dict[key], dict["0"], url);
						if(this_.scene.gameConfig.isNoSdkOrTestSdk()) {
							key = "-1";
							url = dict[key];
						}
						print("#first Url:{0}".format(url));
						this_._downUrls.push(url);
						var newUrl = dict[(parseInt(key) + 20000).toString()];
						if(!!newUrl) {
							this_._downUrls.push(newUrl);
							print("#second Url:{0}".format(newUrl));
						} 
						loadVersion();
					}
					else {
						this_.updateComplete();
					}
				}
			}
		}

		if(this.scene.gameConfig.needUpdate()) {
			this.load(this.scene.gameConfig.verUrl + "url.txt", urlHandler, true);
		}
		else {
			this.updateComplete();
		}
	}, 
	// getLeastBPackage : function() { 
	// 	var vers = this.scene.gameConfig.plusList,
	// 		bcodes = [],
	// 		bPassVer = 0,
	// 		version = this.scene.jsc.readKV(this._bPackageKey);
	// 	if(!!version && version.length > 0) {
	// 		bPassVer = parseInt(version);
	// 	}
	// 	if(!!vers) {
	// 		for(var j = vers.length - 1; j >= 0; j--) {
	// 			currentVer = parseInt(vers[j].substring(1));
	// 			if(currentVer > bPassVer) {
	// 				bcodes.unshift(vers[j]);
	// 			}
	// 		}	
	// 	}
	// 	print("#bcodes", JSON.stringify(bcodes));
	// 	return bcodes;
	// },
	downloadPackage : function(list, completeCallback) {
		this._completeCallback = completeCallback;
		if(!!list && list.length > 0) { 
			var codes = [],
				currentVer = 0;
			for(var j = list.length - 1; j >= 0; j--) {
				if(!!list[j]) {
					currentVer = parseInt(list[j].substring(1)); 
					codes.unshift({ v : currentVer, p : list[j], t : list[j].substring(0, 1), idx : j, count : list.length });
				}
			}

			this._updatePaths = codes;
			this._updateCount = codes.length;

			if(this._updateCount > 0) {
				this.scene.updateView.setTips("正在为您下载更新包...");
				print("#start update", this._updateCount);
				this._hasError = 0;
				this._dispose = false;
				this.percentPast = 0;
				this.updateNext();
				return;
			} 
		}
		if(!!this._completeCallback) {
			this._completeCallback();
		}
	},
	load : function(url, callback, utilSuccess) {
		var randomNum = Math.random(),
			loadUrl = url,
			this_ = this;
		if(loadUrl.indexOf("?") > -1) loadUrl += "&" + randomNum;
		else loadUrl += "?" + randomNum;
		print("#update loadUrl", loadUrl);
		cc.loader.loadTxtRemote(loadUrl, function(errInfo, txt) {
			if(!!callback) {
				if(!!errInfo || !txt || txt.length == 0) {
					print("#load failed:{0}, reason:{1}".format(url, errInfo));
					callback(null);
					if(!!utilSuccess && !this._dispose) {
						this_.load(url, callback, utilSuccess);
					}
				}
				else {
					callback(txt);
				}
			}
		});
	},
	dispose : function() {
		this._dispose = true;
	}
});