var FlashInfo = cc.Class.extend({
	path : null,
	time : 2,
	fadeInTime : 1,
	fadeOutTime : 1,
	ctor : function(path, time, fadeInTime, fadeOutTime) {
		this.path = path;
		this.time = time;
		this.fadeInTime = fadeInTime;
		this.fadeOutTime = fadeOutTime;
	}
});

var UpdateView = cc.Layer.extend({

	_bg:null,
	_img:null,
	_tipLabel:null,
    _barBg:null,
    _bar:null,
	// scene : null,
    gameConfig : null,
    startGameCall : null,
    startGameCallTarget : null,

	flashes : null,
	flashInfo : null,
	flashImg : null,
	flashIdx : 0,

	ctor:function(gameConfig, callback, target)
	{
		this._super();
		// this.scene = scene;
        this.gameConfig = gameConfig; 
        this.startGameCall = callback;
        this.startGameCallTarget = target;

		//普通显示
		this._bg = ccui.ImageView.create();
		this._bg.retain();
		this._bg.loadTexture("res/GameUI/outPic/loadingBg.png");
		this._bg.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2));
		this._img = ccui.ImageView.create();
		this._img.retain();
		var index = Math.floor(Math.random()*5) + 1;
		this._img.loadTexture("res/GameUI/outPic/advertImg_" + index.toString() + ".png");
		this._img.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2 + 7));
        this._tipLabel = new cc.LabelTTF("","",26);
        this._tipLabel.retain();
        this._tipLabel.setFontFillColor(cc.color(255, 255, 255));
        this._tipLabel.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2 - 230));
        this._tipLabel.enableShadow(cc.color(0,0,0,1),cc.size(1,-1),0);
        this._barBg = ccui.ImageView.create();
        this._barBg.retain();
        this._barBg.loadTexture("res/GameUI/outPic/ui_readingBarBg.png");
        this._barBg.setScale9Enabled(true);
        this._barBg.setCapInsets(cc.rect(105,15,1,1));
        this._barBg.setSize(cc.size(940,31));
        this._barBg.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2 - 280));
        this._bar = ccui.LoadingBar.create();
        this._bar.retain();
        this._bar.loadTexture("res/GameUI/outPic/ui_readingBar.png");
        this._bar.setScale9Enabled(true);
        this._bar.setCapInsets(cc.rect(89,9,1,1));
        this._bar.setSize(cc.size(908,19));
        this._bar.setPosition(cc.p(cc.winSize.width / 2,cc.winSize.height / 2 - 280));

		//闪屏显示
		var srcList = this.gameConfig.flashes;
		this.flashes = [];
		for(var i = 0; i < srcList.length; i++) {
			this.flashes.push(new FlashInfo(srcList[i], 2, 1, 1));
		}
		print("#this.flashes", this.flashes.length);
		if(this.flashes.length == 0) {
			this.completeFlash();
		}
		else {
			this.showFlash();
		}
 
		this.retain();
	}, 
	setProgress : function(progress)
	{
		print("#progress", progress);
        this._bar.setPercent(progress);
	},
	setTips:function(value)
	{ 
		this._tipLabel.setString(value); 
	},

	completeFlash : function() {
		print("#completeFlashcompleteFlashcompleteFlash");
		this.addChild(this._bg);
		this.addChild(this._img);
		this.addChild(this._tipLabel);
        this.addChild(this._barBg);
        this.addChild(this._bar);
		// this.scene.startGame();
        if(!!this.startGameCall) {
            this.startGameCall.call(this.startGameCallTarget);
        }
	},
	showFlash : function() {
		var this_ = this; 
		if(!!this.flashInfo) {
			this.removeChild(this.flashImg);
			this.flashImg.stopAllActions();
			this.flashImg.release();
			this.flashImg = null;
			this.flashInfo = null;
		} 
		if(this.flashes.length <= this.flashIdx) { 
			this.completeFlash();
		}
		else { 
			var size = cc.winSize;
			this.flashInfo = this.flashes[this.flashIdx];
			this.flashIdx++;
			if(!!this.flashInfo && jsb.fileUtils.isFileExist(this.flashInfo.path)) {
				this.flashImg = new cc.Sprite(this.flashInfo.path);
				if(!!this.flashImg) {
					var actionOut = cc.fadeOut(this.flashInfo.fadeOutTime), //淡出
						actionIn = cc.fadeIn(this.flashInfo.fadeInTime), // 渐入
						action = cc.rotateBy(this.flashInfo.time,0), // 旋转
						callback = cc.callFunc(function() {
							this_.showFlash(); 
						}),
						anima = cc.sequence(actionIn, action, actionOut, callback);

					this.flashImg.setOpacity(0);
					this.flashImg.retain();
					this.flashImg.setAnchorPoint(cc.p(.5,.5));
					this.flashImg.setPosition(size.width / 2, size.height / 2);
					this.addChild(this.flashImg);
					this.flashImg.runAction(anima);
				}
				else {
					this.flashInfo = null;
					this.showFlash();
				}

			}
			else {
				this.completeFlash();
			}
		}
	},

	dispose:function()
	{ 
		if(this._tipLabel != null)
		{
			this._tipLabel.release();
			this._tipLabel = null;
		}
		if(this._bg != null)
		{
			this._bg.release();
			this._bg = null;
		}
		if(this._img != null)
		{
			this._img.release();
			this._img = null;
		}
        if(this._barBg != null)
        {
            this._barBg.release();
            this._barBg = null;
        }
        if(this._bar != null)
        {
            this._bar.release();
            this._bar = null;
        }
		if(this.getParent() != null)
		{
			this.removeFromParent(true);
		}
		this.release();
	}
})