var KYNode = cc.Node.extend({
    _eventDispatcher: null,
    _mouse: null,
    _isTouchEnabled: true,
    ctor: function(jsonName) {
        this._super();
        if (jsonName != null) {
            ____654.uiCreator.create(____655.uiDataListII.____292(jsonName), this)
        }
        this.retain()
    },
    setTouchEnabled: function(value) {
        this._isTouchEnabled = value
    },
    isTouchEnabled: function() {
        return this._isTouchEnabled
    },
    addEventListener: function(type, listener, target) {
        if (this._eventDispatcher == null) this._eventDispatcher = new ____591();
        this._eventDispatcher.addEventListener(type, listener, target)
    },
    removeEventListener: function(type, listener, target) {
        if (this._eventDispatcher == null) return;
        this._eventDispatcher.removeEventListener(type, listener, target)
    },
    dispatchEvent: function(evt) {
        if (this._eventDispatcher == null) return;
        this._eventDispatcher.dispatchEvent(evt)
    },
    addListener: function(target, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove) {
        if (this._mouse == null) {
            this._mouse = new KYMouse(this, target, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove)
        }
    },
    dispose: function() {
        if (this._eventDispatcher != null) {
            this._eventDispatcher.dispose();
            this._eventDispatcher = null
        }
        if (this._mouse != null) {
            this._mouse.dispose();
            this._mouse = null
        }
        if (this.___uiClearList != null) {
            for (var i = this.___uiClearList.length - 1; i >= 0; i--) {
                var node = this.___uiClearList[i];
                if (node != null && node.dispose != null) {
                    node.dispose()
                }
            }
            this.___uiClearList = null
        }
        ____654.____673.release(this)
    },
});
var KYPanel = KYNode.extend({
    modeValue: 0,
    hideFormContainer: function() {},
    dispose: function() {
        ____654.____676.____127(this);
        ____654.____672.dispatchEvent(new ____590(____655.____661.global_panelClose, ____654.____672, this));
        this._super()
    },
});
var KYSprite = cc.Sprite.extend({
    _eventDispatcher: null,
    _mouse: null,
    _isTouchEnabled: true,
    ctor: function() {
        this._super();
        this._eventDispatcher = new ____591();
        this.retain()
    },
    setTouchEnabled: function(value) {
        this._isTouchEnabled = value
    },
    isTouchEnabled: function() {
        return this._isTouchEnabled
    },
    addEventListener: function(type, listener, target) {
        this._eventDispatcher.addEventListener(type, listener, target)
    },
    removeEventListener: function(type, listener, target) {
        this._eventDispatcher.removeEventListener(type, listener, target)
    },
    dispatchEvent: function(evt) {
        this._eventDispatcher.dispatchEvent(type, listener, target)
    },
    setFrame: function(path) {
        this.setSpriteFrame(path)
    },
    addListener: function(target, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove) {
        if (this._mouse == null) {
            this._mouse = new KYMouse(this, target, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove)
        }
    },
    addTouchEventListener: function(handler, target) {
        this.addListener(target, handler)
    },
    getMouseRect: function() {
        return ____654.____673.____161(this.getPositionX(), this.getPositionY(), this.getContentSize().width, this.getContentSize().height)
    },
    dispose: function() {
        if (this._eventDispatcher != null) {
            this._eventDispatcher.dispose();
            this._eventDispatcher = null
        }
        if (this._mouse != null) {
            this._mouse.dispose();
            this._mouse = null
        }
        ____654.____673.release(this)
    },
});
var KYButton = KYSprite.extend({
    _enabled: true,
    ctor: function() {
        this._super()
    },
    getEnabled: function() {
        return this._enabled
    },
    setEnabled: function(value) {
        if (this._enabled == value) return;
        this._enabled = true
    },
});
var KYImageView = ccui.ImageView.extend({
    _mouse: null,
    _isTouchEnabled: true,
    ctor: function() {
        this._super();
        this.retain()
    },
    setTouchEnabled: function(value) {
        this._isTouchEnabled = value
    },
    isTouchEnabled: function() {
        return this._isTouchEnabled
    },
    setFrame: function(path) {
        this.loadTexture(path, 1)
    },
    addListener: function(target, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove) {
        if (this._mouse == null) {
            this._mouse = new KYMouse(this, target, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove)
        }
    },
    addTouchEventListener: function(handler, target) {
        this.addListener(target, handler)
    },
    dispose: function() {
        if (this._mouse != null) {
            this._mouse.dispose();
            this._mouse = null
        }
        ____654.____673.release(this)
    },
});
var KYScrollView = KYNode.extend({
    _contentSp: null,
    _clippingNode: null,
    _stencil: null,
    _scrollDir: -1,
    _mouse: null,
    ____1431: null,
    ctor: function() {
        this._super()
    },
    initUI: function(size) {
        this._clippingNode = ____654.____673.newClippingNode();
        this.addChild(this._clippingNode);
        this._clippingNode.width = size.width;
        this._clippingNode.height = size.height;
        this._stencil = ____654.____673.newKYDrawNode();
        var color = ____655.____659.____688.white;
        this._stencil.drawRect(____654.____673.____159(0, 0), ____654.____673.____159(size.width, size.height), color);
        this._clippingNode.stencil = this._stencil;
        this._contentSp = ____654.____673.newKYNode();
        this._clippingNode.addChild(this._contentSp);
        this.addListener()
    },
    getShowWidth: function() {
        return this._clippingNode.width
    },
    getShowHeight: function() {
        return this._clippingNode.height
    },
    setMoveController: function(mc) {
        this.____1431 = mc
    },
    getMoveController: function() {
        if (this.____1431 != null) return this.____1431;
        this.____1431 = new KYScrollMoveController(this);
        return this.____1431
    },
    setCanScrollWhenLess: function(value) {
        this.getMoveController().setCanScrollWhenLess(value)
    },
    resetSize: function(size) {
        this._clippingNode.width = size.width;
        this._clippingNode.height = size.height;
        var color = ____655.____659.____688.white;
        this._stencil.clear();
        this._stencil.drawRect(____654.____673.____159(0, 0), ____654.____673.____159(size.width, size.height), color)
    },
    setInnerSize: function(size) {
        this._contentSp.setContentSize(size)
    },
    getInnerSize: function() {
        return this._contentSp.getContentSize()
    },
    addContent: function(node) {
        this._contentSp.addChild(node)
    },
    setScrollDir: function(value) {
        this._scrollDir = value;
        this.getMoveController().stopRoll()
    },
    getScrollDir: function() {
        return this._scrollDir
    },
    addListener: function() {
        if (this._mouse == null) {
            this._mouse = new KYMouse(this._clippingNode, this, null, this.downCB, this.upCB, this.moveCB)
        }
    },
    printInMouseRect: function(pos) {
        if (this._mouse != null) {
            return this._mouse.pointInRect(pos)
        }
        return false
    },
    downCB: function(sender, eventType, p) {
        this.getMoveController().downHandler(p)
    },
    upCB: function(sender, eventType, p) {
        this.getMoveController().upHandler(p)
    },
    moveCB: function(sender, eventType, p) {
        this.getMoveController().____358(p)
    },
    moveDis: function(dx, dy) {
        var pos = this._contentSp.getPosition();
        if (this._scrollDir == ccui.ScrollView.DIR_VERTICAL) {
            var tmpY = this._contentSp.getPositionY() + dy;
            var tmp = this._clippingNode.height - this._contentSp.getContentSize().height;
            var startY, endY;
            if (tmp > 0) {
                startY = 0;
                endY = tmp
            } else {
                startY = tmp;
                endY = 0
            }
            if (tmpY < startY) tmpY = startY;
            else if (tmpY > endY) tmpY = endY;
            this._contentSp.setPositionY(tmpY)
        } else {
            var tmpX = this._contentSp.getPositionX() + dx;
            var tmp = this._clippingNode.width - this._contentSp.getContentSize().width;
            var startX, endX;
            if (tmp > 0) {
                startX = 0;
                endX = tmp
            } else {
                startX = tmp;
                endX = 0
            }
            if (tmpX < startX) tmpX = startX;
            else if (tmpX > endX) tmpX = endX;
            this._contentSp.setPositionX(tmpX)
        }
        this.dispatchEvent(new ____590(____655.____661.UI_scrollView_scroll, this))
    },
    jumpToBottom: function() {
        if (this._scrollDir == ccui.ScrollView.DIR_HORIZONTAL) return;
        this._contentSp.setPositionY(0)
    },
    jumpToTop: function() {
        if (this._scrollDir == ccui.ScrollView.DIR_HORIZONTAL) return;
        var ch = this.getInnerSize().height;
        var wh = this._clippingNode.height;
        this._contentSp.setPositionY(wh - ch)
    },
    jumpToLeft: function() {
        if (this._scrollDir == ccui.ScrollView.DIR_VERTICAL) return;
        this._contentSp.setPositionX(0)
    },
    jumpToRight: function() {
        if (this._scrollDir == ccui.ScrollView.DIR_VERTICAL) return;
        var cw = this.getInnerSize().width;
        var ww = this._clippingNode.width;
        this._contentSp.setPositionY(ww - cw)
    },
    jumpToPercent: function(percent) {
        if (percent < 0) {
            percent = 0
        } else if (percent > 100) {
            percent = 100
        }
        if (this._scrollDir == ccui.ScrollView.DIR_HORIZONTAL) {
            var dx = (this.getInnerSize().width - this._clippingNode.width) * percent / 100;
            this.moveDis(-dx, this._contentSp.getPositionY())
        } else {
            var dy = (this.getInnerSize().height - this._clippingNode.height) * (100 - percent) / 100;
            this.moveDis(this._contentSp.getPositionX(), -dy)
        }
    },
    getContentSp: function() {
        return this._contentSp
    },
    setScrollBarEnabled: function(value) {},
    dispose: function() {
        if (this._contentSp != null) {
            this._contentSp.dispose();
            this._contentSp = null
        }
        if (this._clippingNode != null) {
            ____654.____673.release(this._clippingNode);
            this._clippingNode = null
        }
        if (this._mouse != null) {
            this._mouse.dispose();
            this._mouse = null
        }
        if (this._stencil != null) {
            this._stencil.dispose();
            this._stencil = null
        }
        if (this.____1431 != null) {
            this.____1431.dispose();
            this.____1431 = null
        }
        this._super()
    },
});
var BaseContainer = cc.Class.extend({
    _container: null,
    _orderIndex: 1,
    ____1539: 0,
    ____1540: 0,
    _alpha: 255,
    ____1613: 1,
    _scaleY: 1,
    init: function(container, orderIndex) {
        this._container = container;
        this._orderIndex = orderIndex || this._orderIndex
    },
    setZIndex: function(value) {
        if (this._orderIndex == value) return;
        this._orderIndex = value;
        this.updateZIndex()
    },
    updateZIndex: function() {},
    show: function() {},
    hide: function() {},
    getPosX: function() {
        return this.____1539
    },
    getPosY: function() {
        return this.____1540
    },
    move: function(x, y) {
        if (this.____1539 == x && this.____1540 == y) return;
        this.____1539 = x;
        this.____1540 = y;
        this.setToPos()
    },
    setToPos: function() {},
    setAlpha: function(value) {
        if (this._alpha == value) return;
        this._alpha = value;
        this.updateAlpha()
    },
    getAlpha: function() {
        return this._alpha
    },
    updateAlpha: function() {},
    getScaleX: function() {
        return this.____1613
    },
    getScaleY: function() {
        return this._scaleY
    },
    setScale: function(sx, sy) {
        sy = sy || sx;
        if (this.____1613 == sx && this._scaleY == sy) return;
        this.____1613 = sx;
        this._scaleY = sy;
        this.updateScale()
    },
    updateScale: function() {},
});
var ____591 = cc.Class.extend({
    ____1349: null,
    ____1095: null,
    ctor: function() {
        this.____1349 = {};
        this.____1095 = {}
    },
    addEventListener: function(type, listener, target) {
        assert(target, "#addEventListener:target cannot be undefined.");
        var tmp = this.____293(type, listener, target);
        if (tmp == null) {
            if (this.____1349[type] == null) {
                this.____1349[type] = []
            }
            var qd = new ____480(listener, target);
            qd.flag = 1;
            this.____1349[type].push(qd)
        } else {
            tmp.flag = 1
        }
    },
    removeEventListener: function(type, listener, target) {
        assert(target, "#removeEventListener:target cannot be undefined.");
        if (this.____1349 == null) return;
        var list = this.____1349[type];
        if (list != null) {
            var len = list.length;
            for (var i = 0; i < len; i++) {
                if (list[i].target == target && list[i].callback == listener) {
                    list[i].flag = 0;
                    this.____1095[type] = type;
                    ____654.____678.____298(this.delTick, this);
                    break
                }
            }
        }
    },
    delTick: function(delta, tickCount) {
        if (this.____1349 != null) {
            for (var i in this.____1095) {
                var list = this.____1349[this.____1095[i]];
                var count = list.length;
                for (var j = count - 1; j >= 0; j--) {
                    if (list[j].flag == 0) {
                        list[j].dispose();
                        list.splice(j, 1)
                    }
                }
            }
        }
        this.____1095 = {};
        ____654.____678.____299(this.delTick, this)
    },
    dispatchEvent: function(evt) {
        if (this.____1349 == null) return;
        var list = this.____1349[evt.type];
        if (list != null) {
            var len = list.length;
            for (var i = len - 1; i >= 0; i--) {
                if (list[i].flag == 1) {
                    if (list[i].callback != null) {
                        try {
                            list[i].callback.call(list[i].target, evt)
                        } catch (e) {
                            ____654.doPrintError(e)
                        }
                    }
                }
            }
        }
    },
    ____293: function(type, listener, target) {
        assert(target, "#____293:target cannot be undefined.");
        var list = this.____1349[type];
        if (list != null) {
            var len = list.length;
            for (var i = 0; i < len; i++) {
                if (list[i].callback == listener && list[i].target == target) return list[i]
            }
        }
        return null
    },
    ____294: function(type, listener, target) {
        assert(target, "#____294:target cannot be undefined.");
        var list = this.____1349[type];
        if (list != null) {
            var len = list.length;
            for (var i = 0; i < len; i++) {
                if (list[i].callback == listener && list[i].target == target) return i
            }
        }
        return -1
    },
    dispose: function() {
        ____654.____678.____299(this.delTick, this);
        this.____1095 = null;
        this.____1349 = null
    }
});
var ____590 = cc.Class.extend({
    type: null,
    target: null,
    data: null,
    stopImmediately: false,
    ctor: function(type, target, data) {
        this.type = type;
        this.target = target;
        this.data = data
    }
});
var ByteArray = cc.Class.extend({
    ____915: null,
    ____1338: 0,
    ____1536: 0,
    ____1086: null,
    ____1805: null,
    ctor: function(len) {
        if (Uint8Array == Array) this.____1805 = Uint8ClampedArray;
        else this.____1805 = Uint8Array;
        if (len > 0) {
            this.____915 = new ArrayBuffer(len);
            this.____1086 = new DataView(this.____915);
            this.____1338 = len;
            this.setPosition(0)
        }
    },
    ____284: function(strData) {
        this.____915 = new this.____1805(strData).buffer;
        this.____1086 = new DataView(this.____915);
        this.____1338 = this.____1086.byteLength;
        this.setPosition(0)
    },
    ____285: function(strData) {
        this.____915 = new ArrayBuffer(strData.length);
        this.____1086 = new DataView(this.____915);
        this.____1338 = strData.length;
        for (var i = 0; i < strData.length; i++) {
            this.____1086.setInt8(i, strData.charCodeAt(i) & 0xff)
        }
        this.setPosition(0)
    },
    getBuffer: function() {
        return this.____915
    },
    setPosition: function(p) {
        this.____1536 = p
    },
    addPosition: function(value) {
        this.____1536 += value
    },
    getPosition: function() {
        return this.____1536
    },
    getLength: function() {
        return this.____1338
    },
    getBytesAvailable: function() {
        return this.____1338 - this.____1536
    },
    readByte: function() {
        var value = this.____1086.getInt8(this.____1536);
        this.addPosition(1);
        return value
    },
    readUByte: function() {
        var value = this.____1086.getUint8(this.____1536);
        this.addPosition(1);
        return value
    },
    readShort: function() {
        var value = this.____1086.getInt16(this.____1536);
        this.addPosition(2);
        return value
    },
    readUShort: function() {
        var value = this.____1086.getUint16(this.____1536);
        this.addPosition(2);
        return value
    },
    readInt: function() {
        var value = this.____1086.getInt32(this.____1536);
        this.addPosition(4);
        return value
    },
    readUInt: function() {
        var value = this.____1086.getUint32(this.____1536);
        this.addPosition(4);
        return value
    },
    readNumber: function() {
        var value = this.readInt() * 4294967296;
        value += this.readUInt();
        return value
    },
    readTmpFloat: function() {
        var tmp = this.readInt();
        var power = this.readByte();
        return tmp / Math.pow(10, power)
    },
    pad: function(n) {
        return n.length < 2 ? "0" + n : n
    },
    readString: function() {
        var len = this.readShort();
        var array = new this.____1805(this.____915, this.____1536, len);
        var str = "";
        for (var i = 0, len = array.length; i < len; ++i) {
            str += ("%" + this.pad(array[i].toString(16)))
        }
        this.addPosition(len);
        str = decodeURIComponent(str);
        return str
    },
    readIntString: function() {
        var len = this.readInt();
        var array = new this.____1805(this.____915, this.____1536, len);
        var str = "";
        for (var i = 0, len = array.length; i < len; ++i) {
            str += ("%" + this.pad(array[i].toString(16)))
        }
        this.addPosition(len);
        str = decodeURIComponent(str);
        return str
    },
    readBoolean: function() {
        return this.readByte() == 1
    },
    writeByte: function(value) {
        this.____1086.setInt8(this.____1536, value);
        this.addPosition(1)
    },
    writeShort: function(value) {
        this.____1086.setInt16(this.____1536, value);
        this.addPosition(2)
    },
    writeInt: function(value) {
        this.____1086.setInt32(this.____1536, value);
        this.addPosition(4)
    },
    writeNumber: function(value) {
        var val2 = value & 0xffffffff;
        var val = (value - val2) / 4294967296;
        this.writeInt(val);
        this.writeInt(val2)
    },
    writeString: function(value) {
        var str = encodeURIComponent(value);
        var len = str.length,
            count = 0,
            oriPos = this.____1536;
        for (var i = 0; i < len; i++) {
            if (str.substr(i, 1) == "%") {
                var val = parseInt(str.substr(i + 1, 2), 16);
                if (val >= 128) {
                    val -= 256
                }
                this.____1086.setUint8(this.____1536 + count + 2, val);
                i += 2
            } else {
                this.____1086.setUint8(this.____1536 + count + 2, str[i].charCodeAt(0))
            }
            count += 1
        }
        this.____1086.setInt16(this.____1536, count);
        this.addPosition(count + 2)
    },
    ____8: function(sourceBuff, startIndex, len) {
        for (var i = 0; i < len; i++) {
            this.____1086.setUint8(this.____1536 + i, sourceBuff.____287(startIndex + i))
        }
        this.addPosition(len)
    },
    ____287: function(index) {
        return this.____1086.getUint8(index)
    },
    setUint8ValueAt: function(index, value) {
        return this.____1086.setUint8(index, value)
    },
    ____288: function() {
        if (this.____1536 > this.____1338) {
            print("ByteArrayError:::##################")
        }
    },
    toArray: function() {
        var arr = [];
        var len = this.____1338;
        for (var i = 0; i < len; i++) {
            arr[i] = this.____287(i)
        }
        return arr
    }
});
var ____495 = ____591.extend({
    serverId: 0,
    userId: 0,
    nick: "",
    level: 0,
    career: 0,
    vipLevel: 0,
    gm: 0,
    ____64: function(level) {
        if (this.level == level) return;
        var isDispatch = true;
        if (this.level == 0) {
            isDispatch = false
        }
        this.level = level;
        if (isDispatch) {
            this.dispatchEvent(new ____590(____655.____661.____703, this, null))
        }
    },
    ____65: function(value) {
        if (this.vipLevel == value) return;
        this.vipLevel = value;
        this.dispatchEvent(new ____590(____655.____661.____704, this, null))
    },
    setNick: function(value) {
        this.nick = value;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_nick, this, null))
    },
    setCareer: function(value) {
        this.career = value
    },
    getSex: function() {
        return this.career == 1
    },
    ____61: function() {
        this.level = 0;
        this.vipLevel = 0
    },
});
var ____499 = ____495.extend({
    clubId: 0,
    clubName: "",
    clubJob: 0,
    clubLevel: 0,
    pvpMode: 0,
    combat: 0,
    mountAvoid: false,
    teamId: 0,
    isMarry: 0,
    marryType: 0,
    marryName: "",
    isOath: 0,
    oathType: 0,
    characterInfo: null,
    xianwei: 0,
    ctor: function() {
        this._super();
        this.characterInfo = new ____501(____655.____659.commonStaticType.style_player, this)
    },
    setXianwei: function(xianwei) {
        if (this.xianwei == xianwei) {
            return
        }
        if (this.xianwei != 0 && xianwei > this.xianwei && this.userId == ____655.____667.userId) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.open_xianWeiUpLevelPanel, ____654.____672, xianwei))
        }
        this.xianwei = xianwei;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_xianweiUpdate, this, null))
    },
    setIsHorse: function(value) {
        this.characterInfo.setIsHorse(value)
    },
    getHorseFigure: function() {
        return this.characterInfo.getHorseFigure()
    },
    setCareer: function(value) {
        if (this.career == value) return;
        this._super(value);
        this.characterInfo.reflesh()
    },
    setPKmode: function(mode, isShowTip) {
        if (this.pvpMode != mode) {
            this.pvpMode = mode;
            if (isShowTip) {
                print("切换了PK模式", mode)
            }
            this.dispatchEvent(new ____590(____655.____661.playerInfo_modeUpdate, this, null))
        }
    },
    ____75: function(value) {
        if (this.combat == value) {
            return
        }
        this.combat = value;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_combatUpdate, this, null))
    },
    initClub: function(bytes) {
        this.clubId = bytes.readNumber();
        this.clubName = bytes.readString();
        this.clubJob = bytes.readUByte();
        this.dispatchEvent(new ____590(____655.____661.playerInfo_club, this, null))
    },
    ____61: function() {
        this._super()
    },
    ____76: function() {
        if (this.characterInfo != null) {
            this.characterInfo.dispose()
        }
        this.characterInfo = new ____501(____655.____659.commonStaticType.style_player, this)
    },
    dispose: function() {
        if (this.characterInfo != null) {
            this.characterInfo.dispose();
            this.characterInfo = null
        }
        this._super()
    },
});
var ____514 = cc.Class.extend({
    ____1755: null,
    ____1757: 0,
    parseComplete: false,
    ____1055: 0,
    ctor: function() {},
    init: function(data) {
        this.____1755 = data;
        this.____1757 = data.readInt();
        this.____1055 = 0;
        this.parseComplete = false;
        if (this.____1757 == 0) {
            this.____105()
        }
    },
    parse: function() {
        var len = this.____103();
        for (var i = 0; i < len; i++) {
            this.____104();
            this.____1055++;
            if (this.____1055 >= this.____1757) {
                this.____105();
                break
            }
        }
    },
    ____103: function() {
        return this.____1757
    },
    ____104: function() {},
    ____105: function() {
        this.____1755 = null, this.parseComplete = true
    },
});
var ____626 = ____591.extend({
    ____1474: 0,
    ____1476: "",
    ____1536: null,
    ____1112: 0,
    ____1276: false,
    ____1657: 0,
    sceneModule: null,
    ctor: function(sceneModule) {
        this._super();
        this.sceneModule = sceneModule;
        this.____1536 = ____654.____673.____159(0, 0)
    },
    ____355: function() {
        return this.____1536
    },
    ____354: function(value, dispatcher) {
        if (this.____1536.x == value.x && this.____1536.y == value.y) return;
        this.____1536.x = value.x;
        this.____1536.y = value.y;
        if (dispatcher != false) {
            this.dispatchEvent(new ____590(____655.____661.playerInfo_move, this, null))
        }
    },
    ____96: function() {
        return this.____1112
    },
    ____206: function(value) {
        if (this.____1112 == value) return;
        this.____1112 = value;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_dir, this, null))
    },
    ____409: function() {
        return this.____1276
    },
    ____408: function(value) {
        if (this.____1276 == value) return;
        this.____1276 = value;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_select, this, null))
    },
    getObjServerId: function() {
        return this.____357()
    },
    ____357: function() {
        return this.____1474
    },
    ____407: function(value) {
        this.____1474 = value;
        this.____1476 = this.____402() + "_" + this.____357()
    },
    ____402: function() {
        return 0
    },
    getName: function() {
        return ""
    },
    getObjTypeId: function() {
        if (this.____1476 == "") this.____1476 = this.____402() + "_" + this.____357();
        return this.____1476
    },
    ____410: function() {
        return ____655.____659.____688.white
    },
    ____411: function() {
        return 0
    },
    canBeSelect: function() {
        return true
    },
    getServerId: function() {
        return this.____1657
    },
    dispose: function() {
        this.sceneModule = null;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_dispose, this, null));
        this.____1536 = null;
        this._super()
    },
});
var ____631 = ____626.extend({
    ____1857: null,
    ____1726: 0,
    ____1856: null,
    speed: 0,
    isWalking: false,
    ____1319: null,
    pathTarget: null,
    currentAngle: 0,
    ctor: function(sceneModule) {
        this._super(sceneModule);
        this.pathTarget = ____654.____673.____159(-1, -1);
        this.____1856 = new ____601(this, this.walkPathComplete)
    },
    walkPathComplete: function() {
        var tmpComplete = this.____1857;
        this.isWalking = false;
        this.dispatchEvent(new ____590(____655.____661.sceneInfo_walkComplete, this, null));
        this.____1857 = null;
        this.____1726 = 0;
        if (tmpComplete != null) {
            tmpComplete()
        }
        tmpComplete = null
    },
    walkStop: function() {
        this.isWalking = false;
        this.____1857 = null, this.____1726 = 0;
        this.pathTarget.x = -1;
        this.pathTarget.y = -1;
        if (this.____1856 != null) {
            this.____1856.walkStop()
        }
    },
    setPath: function(path, walkComplete, stopAtDistance) {
        if (path == null || path.length == 0) {
            this.walkStop();
            return
        }
        this.____1726 = stopAtDistance;
        this.____1857 = walkComplete;
        var len = path.length;
        var doEnd = false;
        if (len == 0) {
            doEnd = true
        } else {
            var pp = path[len - 1];
            if (____654.____674.____180(this.____355(), pp)) doEnd = true
        }
        if (doEnd) {
            this.walkPathComplete()
        } else {
            var p = path[len - 1];
            this.pathTarget.x = p.x;
            this.pathTarget.y = p.y;
            this.isWalking = true;
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_walkStart, this, null));
            this.____1856.setPath(path)
        }
    },
    faceToPoint: function(p) {
        this.____206(____655.____659.____686.____96(this.____355(), p));
        this.currentAngle = ____655.____659.____686.____98(this.____355(), p)
    },
    dispose: function() {
        this.isWalking = false;
        this.____1857 = null;
        this.____1726 = 0;
        if (this.____1856 != null) {
            this.____1856.dispose();
            this.____1856 = null
        }
        this.____1319 = null;
        this.pathTarget = null;
        this._super()
    },
});
var ____621 = ____631.extend({
    stateInfo: null,
    buffInfo: null,
    warState: 0,
    ____1809: 0,
    ____1041: 0,
    attackBehavior: null,
    behitBehavior: null,
    ctor: function(sceneModule) {
        this._super(sceneModule);
        this.stateInfo = new ____503();
        this.buffInfo = new ____502();
        this.attackBehavior = new ____2401(this, sceneModule.sceneController);
        this.behitBehavior = new ____2402(this, sceneModule.sceneController)
    },
    ____384: function() {
        return this.____1809
    },
    ____386: function() {
        return this.____1041
    },
    setHP: function(current, total) {
        if (this.____1041 == current && this.____1809 == total) return;
        this.____1041 = current;
        this.____1809 = total;
        if (this.____1041 > this.____384()) this.____1041 = this.____384();
        if (this.____1041 < 0) this.____1041 = 0;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_hpUpdate, this, null))
    },
    getHitPos: function() {
        return this.____355()
    },
    isCanMove: function() {
        return this.buffInfo.getCanMove() && this.stateInfo.getCanMove()
    },
    ____397: function() {
        return this.buffInfo.____87() && this.stateInfo.____87()
    },
    ____398: function() {
        return !this.buffInfo.getIsWudi() && this.stateInfo.getCanBeAttack()
    },
    isCanUseSkill: function() {
        return this.buffInfo.getCanUseSkill() && this.stateInfo.getCanUseSkill()
    },
    ____399: function() {
        return this.buffInfo.____88()
    },
    isAlpha: function() {
        return this.buffInfo.getIsAlpha()
    },
    ____91: function(value) {
        this.stateInfo.____91(value)
    },
    doAttackBehavior: function(behaviorInfo) {
        if (this.attackBehavior != null) {
            this.attackBehavior.init(behaviorInfo)
        }
    },
    doBehitBehavior: function(behaviorInfo) {
        if (this.behitBehavior != null) {
            this.behitBehavior.init(behaviorInfo)
        }
    },
    dispose: function() {
        if (this.stateInfo != null) {
            this.stateInfo.dispose();
            this.stateInfo = null
        }
        if (this.buffInfo != null) {
            this.buffInfo.dispose();
            this.buffInfo = null
        }
        if (this.attackBehavior != null) {
            this.attackBehavior.dispose();
            this.attackBehavior = null
        }
        if (this.behitBehavior != null) {
            this.behitBehavior.dispose();
            this.behitBehavior = null
        }
        this._super()
    },
});
var ____627 = ____621.extend({
    figureInfo: null,
    ____992: -1,
    currentTitleId: 0,
    ctor: function(figurePlayer, sceneModule) {
        this._super(sceneModule);
        this.figureInfo = figurePlayer
    },
    setCollectTemplateId: function(id) {
        if (this.____992 == id) return;
        this.____992 = id
    },
    getCollectTemplateId: function() {
        return this.____992
    },
    setCurrentTitle: function(title) {
        if (this.currentTitleId == title) return;
        this.currentTitleId = title;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_titleChange, this, null))
    },
    getHitPos: function() {
        return ____654.____673.____159(this.____355().x, this.____355().y - 50);
        if (this.figureInfo.getHorseFigure()) {
            return ____654.____673.____159(this.____355().x, this.____355().y - 120)
        } else {
            return ____654.____673.____159(this.____355().x, this.____355().y - 50)
        }
    },
    ____402: function() {
        return ____655.____659.commonStaticType.soType_player
    },
    getName: function() {
        return this.figureInfo.nick
    },
    ____411: function() {
        return this.figureInfo.level
    },
    ____357: function() {
        return this.figureInfo.userId
    },
    getServerId: function() {
        return this.figureInfo.serverId
    },
    getCareer: function() {
        return this.figureInfo.career
    },
    ____413: function() {
        return this.figureInfo.titleInfo.getCurrentTitleId()
    },
    ____410: function() {
        if (this == this.sceneModule.sceneController.sceneInfo.scenePlayerList.chenZhuPlayer) {
            return ____655.____659.____688.purple
        } else if (this.sceneModule != null && this.sceneModule.attackTester.playerCanBeAttack(this, false)) {
            return ____655.____659.____688.red
        }
        return ____655.____659.____688.nameBlue
    },
    clearFigureInfo: function() {
        if (this.figureInfo != null) {
            this.figureInfo.dispose();
            this.figureInfo = null
        }
    },
    dispose: function() {
        this._super();
        this.clearFigureInfo()
    },
});
var BaseItemInfo = cc.Class.extend({
    templateId: 0,
    _picPath: "",
    iconPath: "",
    categoryId: 0,
    ____27: function() {
        return this._picPath
    },
});
var ItemTemplateInfo = BaseItemInfo.extend({
    name: "",
    quality: 0,
    bindType: 0,
    needLevel: 0,
    needCareer: 0,
    canBatchUse: 0,
    propertys: null,
    sellType: 0,
    sellPrice: 0,
    triggers: null,
    description: "",
    ____1100: "",
    init: function(data, categoryId) {
        this.categoryId = categoryId;
        this.templateId = data.readInt();
        this.name = data.readString();
        this._picPath = data.readInt();
        this.iconPath = data.readInt();
        this.____1100 = data.readString();
        this.description = ____654.____682.____108(this.____1100);
        this.quality = data.readByte();
        this.needLevel = data.readShort();
        this.needCareer = data.readByte();
        this.sellPrice = data.readInt();
        this.sellType = data.readByte();
        this.propertys = [];
        for (var i = 0; i < 8; i++) {
            this.propertys.push(data.readInt())
        }
        this.triggers = [];
        var len = data.readInt();
        for (var i = 0; i < len; i++) {
            var triggerInfo = new ____539();
            triggerInfo.init(data);
            this.triggers.push(triggerInfo)
        }
        this.canBatchUse = data.readBoolean();
        this.vaildDate = data.readInt()
    },
});
var ____2412 = cc.Class.extend({
    ____1539: -1,
    ____1540: -1,
    _roleInfo: null,
    _container: null,
    _nameLabel: null,
    ____1439: true,
    ____1535: true,
    ctor: function(roleInfo, container) {
        this._roleInfo = roleInfo;
        this._container = container;
        this.____5();
        this.____6();
        ____654.____678.____298(this.tick, this)
    },
    ____5: function() {},
    ____6: function() {
        this._roleInfo.addEventListener(____655.____661.playerInfo_nameChange, this.nameChangeHandler, this)
    },
    ____17: function() {
        this._roleInfo.removeEventListener(____655.____661.playerInfo_nameChange, this.nameChangeHandler, this)
    },
    tick: function(delta, count) {
        this.updateLabels();
        if (this.____1535) {
            this.____1535 = false;
            this.____344()
        }
    },
    updateLabels: function() {
        this.updateNameLabel()
    },
    nameChangeHandler: function(evt) {
        if (this._nameLabel != null) this._nameLabel.setString(this._roleInfo.getName())
    },
    updateNameLabel: function() {
        if (this.____1439 == false) return;
        this.____1439 = false;
        if (this._nameLabel == null) {
            this._nameLabel = ____654.____673.newKYLabel(null, true);
            this._container.addChild(this._nameLabel, 10)
        }
        this._nameLabel.setString(this._roleInfo.getName());
        this._nameLabel.setColor(this._roleInfo.____410())
    },
    ____344: function() {
        if (this._nameLabel != null && this._nameLabel.getParent() != null) {
            this._nameLabel.setPosition(this.____1539, this.____1540)
        }
    },
    move: function(x, y) {
        this.____1539 = x;
        this.____1540 = y;
        this.____344()
    },
    show: function() {
        if (this._nameLabel != null && this._nameLabel.getParent() == null) {
            this._container.addChild(this._nameLabel, 10)
        }
        this.____344()
    },
    hide: function() {
        if (this._nameLabel != null) {
            this._nameLabel.removeFromParent(false)
        }
    },
    setOpacity: function(value) {
        if (this._nameLabel != null) {
            this._nameLabel.setOpacity(value)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____17();
        this._roleInfo = null;
        if (this._nameLabel != null) {
            this._nameLabel.dispose();
            this._nameLabel = null
        }
        this._container = null
    },
});
var ____2428 = KYNode.extend({
    _info: null,
    ____1615: null,
    _controller: null,
    ____1003: null,
    ____1437: null,
    ____1160: null,
    ____1643: null,
    ____1687: null,
    ____1666: null,
    _zIndex: 0,
    ctor: function() {
        this._super(null);
        this.setPosition(____654.____673.____159(-1000, -1))
    },
    getContentSize: function() {
        return this.____1003
    },
    updateContentSize: function() {
        this.____1003 = ____654.____673.____160(80, 100)
    },
    ____5: function(info, controller) {
        this._info = info;
        this._controller = controller;
        this.____1615 = controller.sceneModule;
        this.____1687 = this._controller.sceneModule.mapController.getSoController();
        this.updateContentSize();
        this.____6();
        this.____349();
        this.____345();
        if (this.showShadow()) {
            this.____1666 = ____654.____673.newKYSprite();
            this.____1666.setFrame("sceneShadow.png");
            ____654.____676.shadowContainer.addChild(this.____1666);
            this.____1666.setPosition(this._info.____355().x, -this._info.____355().y)
        }
    },
    showShadow: function() {
        return false
    },
    ____6: function() {
        this._info.addEventListener(____655.____661.playerInfo_move, this.____358, this);
        this._info.addEventListener(____655.____661.playerInfo_dir, this.dirHandler, this);
        this._info.addEventListener(____655.____661.playerInfo_select, this.selectHandler, this)
    },
    ____17: function() {
        this._info.removeEventListener(____655.____661.playerInfo_move, this.____358, this);
        this._info.removeEventListener(____655.____661.playerInfo_dir, this.dirHandler, this);
        this._info.removeEventListener(____655.____661.playerInfo_select, this.selectHandler, this)
    },
    ____358: function(evt) {
        this.____1687.____457(this);
        if (this.____1666 != null) this.____1666.setPosition(this._info.____355().x, -this._info.____355().y);
        if (this.____1643 != null) this.____1643.setPosition(this._info.____355().x, -this._info.____355().y)
    },
    dirHandler: function(evt) {},
    selectHandler: function(evt) {
        if (this._info.____1276) {
            if (this.showSelectImg()) {
                this.____1643 = this._controller.showRoleSelectView(this.getSelectViewPath());
                this.____1643.setPosition(this._info.____355().x, -this._info.____355().y)
            }
        } else {
            this.clearSelectView()
        }
    },
    clearSelectView: function() {
        if (this.____1643 != null) {
            this._controller.hideRoleSelectView(this.getSelectViewPath());
            this.____1643 = null
        }
    },
    showSelectImg: function() {
        return false
    },
    getSelectViewPath: function() {
        return ""
    },
    setZIndex: function(value) {
        if (this._zIndex == value) return;
        this._zIndex = value;
        this.updateZIndex()
    },
    updateZIndex: function() {
        this.setLocalZOrder(this._zIndex)
    },
    ____345: function() {
        if (this.____347()) {
            if (this.____1437 == null) {
                this.____1437 = this.createNameLabel()
            }
            this.____1437.move(0, this.____348());
            this.____1437.show()
        } else {
            if (this.____1437 != null) {
                this.____1437.hide()
            }
        }
    },
    createNameLabel: function() {
        return new ____2412(this.____356(), this)
    },
    ____347: function() {
        return true
    },
    ____348: function() {
        return 135
    },
    ____350: function(value) {
        if (this.____1160 == value) return;
        this.____1160 = value;
        if (this.____1160) {
            this.____352()
        } else {
            this.____353()
        }
    },
    ____351: function() {
        return this.____1160
    },
    ____352: function() {
        this.____1687.addSceneObj(this);
        if (this.____1666 != null && this.____1666.getParent() == null) {
            ____654.____676.shadowContainer.addChild(this.____1666)
        }
        this.____345()
    },
    ____353: function() {
        this.____1687.removeSceneObj(this);
        if (this.____1666 != null) {
            this.____1666.removeFromParent(false)
        }
        if (this.____1437 != null) {
            this.____1437.hide()
        }
    },
    ____349: function() {},
    ____356: function() {
        return this._info
    },
    ____354: function(p) {
        this._info.____354(p);
        this.____1687.____457(this)
    },
    ____355: function() {
        return this._info.____355()
    },
    isMouseOver: function() {
        return false
    },
    doMouseOver: function() {},
    doMouseOut: function() {},
    doMouseClick: function() {},
    responseMouse: function() {
        return this._info.canBeSelect()
    },
    ____357: function() {
        return this._info.____357()
    },
    ____402: function() {
        return this._info.____402()
    },
    getObjTypeId: function() {
        return this._info.getObjTypeId()
    },
    dispose: function() {
        this.____17();
        this.clearSelectView();
        if (this._controller.sceneInfo.getCurrentSelectObjInfo() == this._info) {
            this._controller.sceneInfo.setCurrentSelectObjInfo(null)
        }
        if (this.____1437 != null) {
            this.____1437.dispose();
            this.____1437 = null
        }
        if (this.____1666 != null) {
            this.____1666.dispose();
            this.____1666 = null
        }
        this.____353();
        this._info = null;
        this.____1615 = null;
        this._controller = null;
        this.____1687 = null;
        this.____1003 = null;
        this._super()
    },
});
var ____609 = ____2428.extend({
    character: null,
    ____5: function(info, controller) {
        this._super(info, controller);
        this.cancelAnima()
    },
    showShadow: function() {
        return true
    },
    ____358: function() {
        this._super();
        this.updateCharacterPos()
    },
    updateCharacterPos: function() {
        if (this.character != null) {
            this.character.move(this._info.____355().x, -this._info.____355().y)
        }
    },
    updateZIndex: function() {
        this._super();
        if (this.character != null) {
            this.character.setZIndex(this._zIndex)
        }
    },
    dirHandler: function(evt) {
        this._super(evt);
        if (this.character != null) {
            this.character.updateDir(this._info.____96())
        }
    },
    ____203: function(anima) {
        if (this.character != null) {
            return this.character.____203(anima)
        }
        return false
    },
    ____352: function() {
        this._super();
        if (this.character != null) {
            this.character.show()
        }
    },
    ____353: function() {
        this._super();
        if (this.character != null) {
            this.character.hide()
        }
    },
    cancelAnima: function() {},
    dispose: function() {
        if (this.character != null) {
            this.character.dispose();
            this.character = null
        }
        this._super()
    },
});
var ____613 = ____609.extend({
    ____1048: null,
    ____1312: false,
    ____6: function() {
        this._super();
        this._info.addEventListener(____655.____661.sceneInfo_walkStart, this.walkStartHandler, this);
        this._info.addEventListener(____655.____661.sceneInfo_walkComplete, this.walkCompleteHandler, this)
    },
    ____17: function() {
        this._super();
        this._info.removeEventListener(____655.____661.sceneInfo_walkStart, this.walkStartHandler, this);
        this._info.removeEventListener(____655.____661.sceneInfo_walkComplete, this.walkCompleteHandler, this)
    },
    ____5: function(info, controller) {
        this._super(info, controller);
        this.____1048 = this._controller.sceneInfo.sceneMapList.getMap(____655.currentMapId);
        this.updateAlpha()
    },
    ____358: function(evt) {
        this._super(evt);
        this.updateAlpha()
    },
    updateAlpha: function() {
        var p = this.____355();
        if (this.____1048 == null) {
            return
        }
        var value = this.____1048.getValue(p.x, p.y) == ____655.____659.commonStaticType.mapBlock_alpha;
        if (value != this.____1312) {
            this.____1312 = value;
            if (value) this.setAlpha(100);
            else this.setAlpha(255)
        }
    },
    setAlpha: function(value) {
        if (this.____1437 != null) {
            this.____1437.setOpacity(value)
        }
        if (this.____1643 != null) {
            this.____1643.setOpacity(value)
        }
        if (this.character != null) {
            this.character.setAlpha(value)
        }
    },
    walkStartHandler: function(evt) {
        if (!this.character) return;
        this.playWalk()
    },
    walkCompleteHandler: function(evt) {
        if (!this.character) return;
        this.cancelAnima(true)
    },
    playWalk: function() {},
    setCharacterYOffset: function(yoffset) {
        if (this.character != null) {
            var y = this.character.getPosY();
            var x = this.character.getPosX();
            this.character.move(x, y + yoffset)
        }
    },
    dispose: function() {
        this.____1048 = null;
        this._super()
    },
});
var ____335 = ____613.extend({
    ____913: null,
    ____914: 0,
    ____917: 1,
    ____1299: null,
    ____5: function(info, controller) {
        this._super(info, controller);
        this.____1299 = new ____2405(this);
        this.stateUpdateHandler(null);
        this.____338(null)
    },
    ____6: function() {
        this._super();
        this._info.stateInfo.addEventListener(____655.____661.____708, this.stateUpdateHandler, this);
        this._info.buffInfo.addEventListener(____655.____661.playerInfo_updateBuff, this.____338, this)
    },
    ____17: function() {
        this._super();
        this._info.stateInfo.removeEventListener(____655.____661.____708, this.stateUpdateHandler, this);
        this._info.buffInfo.removeEventListener(____655.____661.playerInfo_updateBuff, this.____338, this)
    },
    createNameLabel: function() {
        return new ____2411(this.____356(), this)
    },
    stateUpdateHandler: function(evt) {
        if (this._info.stateInfo.getIsDead()) {
            this.doDead()
        } else {
            this.cancelAnima()
        }
    },
    doDead: function() {
        this.playDead();
        this._controller.sceneInfo.clearSelectObjWhenDead(this._info)
    },
    ____338: function(evt) {
        if (this.____914 != this._info.buffInfo.effect) {
            this.____914 = this._info.buffInfo.effect;
            if (this.____913 != null) {
                this.____913.dispose();
                this.____913 = null
            }
            if (this.____914 > 0) {
                this.____913 = ____654.effectManager.create(this.____914, false, null, false);
                if (this.____913 != null) {
                    this.____913.addTo(this, 20);
                    this.____913.play()
                }
            }
        }
        if (this._info.buffInfo.scale != this.____917) {
            this.____917 = this._info.buffInfo.scale;
            this.scaleValueUpdate()
        }
    },
    scaleValueUpdate: function() {
        if (this.character != null) {
            this.character.setScale(this.getTotalScale())
        }
    },
    getTotalScale: function() {
        return this.____917
    },
    playDead: function() {
        this.cancelAnima()
    },
    playAttack: function() {},
    playBehit: function() {},
    playHitdown: function() {
        this._info.walkStop()
    },
    doJump: function(pos, jumpType) {
        if (this.____1299 != null) this.____1299.init(pos, jumpType)
    },
    doShake: function() {},
    setCharacterColor: function(color) {
        if (this.character != null) this.character.setColor(color)
    },
    dispose: function() {
        if (this.____913 != null) {
            this.____913.dispose();
            this.____913 = null
        }
        if (this.____1299 != null) {
            this.____1299.dispose();
            this.____1299 = null
        }
        this._super()
    },
});
var ____2431 = ____335.extend({
    ____1314: 0,
    ____1323: 0,
    ____1331: 0,
    ____1146: null,
    _fabaoBehavior: null,
    ____1889: null,
    ____1668: null,
    _shenjianBehavior: null,
    _weaponEffect: null,
    _weaponEffectList: null,
    _buffChangeScale: 1,
    ctor: function() {
        this._super();
        this._weaponEffectList = []
    },
    ____6: function() {
        this._super();
        this._info.figureInfo.characterInfo.addEventListener(____655.____661.playerInfo_styleReload, this.styleUpdate, this);
        this._info.figureInfo.addEventListener(____655.____661.playerInfo_nick, this.nickUpdate, this)
    },
    ____17: function() {
        this._super();
        this._info.figureInfo.characterInfo.removeEventListener(____655.____661.playerInfo_styleReload, this.styleUpdate, this);
        this._info.figureInfo.removeEventListener(____655.____661.playerInfo_nick, this.nickUpdate, this)
    },
    ____349: function() {
        this.character = new ____545(this._info.figureInfo.characterInfo, this.____209, this);
        this.character.init(this._info.____96(), ____654.____676.characterContainer, 2);
        this.updateCharacterPos();
        if (this._info.figureInfo.characterInfo.getIsBuffChange()) {
            this._buffChangeScale = this._info.figureInfo.characterInfo.getBuffChangeScale()
        } else {
            this._buffChangeScale = 1
        }
        this.scaleValueUpdate();
        this.initFabao();
        this.initShenJian();
        this.initZhengLing()
    },
    styleUpdate: function(evt) {
        this.initFabao();
        this.initShenJian();
        this.initZhengLing();
        if (this._info.figureInfo.characterInfo != null && this._info.figureInfo.characterInfo.getIsBuffChange()) {
            this._buffChangeScale = this._info.figureInfo.characterInfo.getBuffChangeScale()
        } else {
            this._buffChangeScale = 1
        }
        this.scaleValueUpdate();
        this.cancelAnima();
        this.____345();
        this.updateCharacterPos()
    },
    updateCharacterPos: function() {
        if (this.character != null) {
            if (this._info.figureInfo.getHorseFigure()) {
                this.character.move(this._info.____355().x, -(this._info.____355().y - this._info.figureInfo.characterInfo.getYOffset()))
            } else {
                this.character.move(this._info.____355().x, -(this._info.____355().y - 20))
            }
        }
    },
    nickUpdate: function(evt) {
        if (this.____1437 != null) {
            this.____1437.____1439 = true;
            this.____1437._marryFlag = true;
            this.____1437._oathFlag = true
        }
    },
    ____209: function(anima) {
        this.cancelAnima()
    },
    cancelAnima: function() {
        if (!this.character) return;
        if (this._info.stateInfo.getIsDead()) {
            this.playDead()
        } else {
            if (this._info.isWalking) this.playWalk();
            else this.playStand()
        }
    },
    ____348: function() {
        if (this.character != null) {
            if (this._info.figureInfo.characterInfo != null) {
                return this._info.figureInfo.characterInfo.getFigureHeight()
            }
        }
        return 135
    },
    doMouseClick: function() {
        if (this.character == null) return;
        this._super();
        this.____1615.scenePlayerController.playerClick(this)
    },
    playWalk: function() {
        if (this.____203(____655.____659.____687.walk)) {
            this.stopWeaponEffect()
        }
    },
    playStand: function() {
        if (this.____203(____655.____659.____687.stand)) {
            this.stopWeaponEffect()
        }
    },
    playDead: function() {
        if (this.____203(____655.____659.____687.dead)) {
            this.stopWeaponEffect()
        }
    },
    stopWeaponEffect: function() {
        if (!!this._weaponEffect) {
            this._weaponEffect.stop();
            this._weaponEffect.removeFromContainer();
            this._weaponEffect = null
        }
    },
    initWeaponEffect: function() {
        if (!!this.character && !this._info.figureInfo.characterInfo.getIsBuffChange()) {
            var dir = this.character.____96(),
                scaleX = ____655.____659.____686.isLeft(dir) ? -1 : 1,
                idx = ____655.____659.____686.isTop(dir) ? 0 : 1;
            this.createWeaponEffect(idx, dir);
            this._weaponEffect = this._weaponEffectList[idx];
            this._weaponEffect.move(this._info.____355().x, this._info.____355().y);
            this._weaponEffect.setScaleDir(scaleX);
            this._weaponEffect.addToContainer();
            this._weaponEffect.play()
        }
    },
    dirHandler: function(evt) {
        this._super(evt);
        if (this._weaponEffect != null) {
            var dir = this.character.____96(),
                scaleX = ____655.____659.____686.isLeft(dir) ? -1 : 1,
                idx = ____655.____659.____686.isTop(dir) ? 0 : 1;
            if (this._weaponEffectList[idx] != this._weaponEffect) {
                var effectCurFrame = this._weaponEffect.getCurrentFrame();
                this.stopWeaponEffect();
                this.createWeaponEffect(idx, dir);
                this._weaponEffect = this._weaponEffectList[idx];
                this._weaponEffect.move(this._info.____355().x, this._info.____355().y);
                this._weaponEffect.addToContainer();
                this._weaponEffect.play(effectCurFrame)
            }
            this._weaponEffect.setScaleDir(scaleX)
        }
    },
    createWeaponEffect: function(idx, dir) {
        if (!this._weaponEffectList[idx]) {
            var effectId = ____655.allTemplates.____789.getWeaponEffectId(dir);
            var effect = ____654.effectManager.create(effectId, true, null, false, null, null, ____655.____659.commonStaticType.source_neverClear);
            var path = effect.getPath();
            var container = ____654.____676.getBatchNodeByType(path, 4);
            effect.setContainer(container, true);
            this._weaponEffectList[idx] = effect
        }
    },
    clearWeaponEffect: function() {
        if (!!this._weaponEffectList) {
            for (var k in this._weaponEffectList) {
                if (!!this._weaponEffectList[k]) {
                    this._weaponEffectList[k].dispose()
                }
            }
            this._weaponEffectList = null
        }
    },
    stopAttack: function() {
        if (!!this.character) {
            this.character.stopAttack()
        }
    },
    playAttack: function(force) {
        if (this.____203(____655.____659.____687.attack, force)) {
            this.stopWeaponEffect();
            this.initWeaponEffect()
        }
    },
    playBehit: function() {},
    createNameLabel: function() {
        return new ____2414(this.____356(), this)
    },
    getTotalScale: function() {
        return this.____917 * this._buffChangeScale
    },
    initFabao: function() {
        if (!____655.allTemplates.copyTemplateList.isShowFabao(____655.copyInfo.currentId)) return;
        var tmpFabaoId = this._info.figureInfo.characterInfo.getFabao();
        if (tmpFabaoId == this.____1314) return;
        this.clearFabao();
        this.____1314 = tmpFabaoId;
        if (this.____1314 > 0) {
            this.createFabao()
        }
    },
    initShenJian: function() {
        if (!____655.allTemplates.copyTemplateList.isShowShenJian(____655.copyInfo.currentId)) return;
        var tmpShenJianId = this._info.figureInfo.characterInfo.getShenJian();
        if (tmpShenJianId == this.____1323) return;
        this.clearShenJian();
        this.____1323 = tmpShenJianId;
        if (this.____1323 > 0) {
            this.createShenJian()
        }
    },
    initZhengLing: function() {
        if (!____655.allTemplates.copyTemplateList.isShowZhenLing(____655.copyInfo.currentId)) return;
        var tmpZhengLingId = this._info.figureInfo.characterInfo.getZhengLing();
        if (tmpZhengLingId == this.____1331) return;
        this.clearZhengLing();
        this.____1331 = tmpZhengLingId;
        if (this.____1331 > 0) {
            this.createZhengLing()
        }
    },
    clearFabao: function() {
        if (this.____1146 != null) {
            this.____1146.dispose();
            this.____1146 = null
        }
        if (this._fabaoBehavior != null) {
            this._fabaoBehavior.dispose();
            this._fabaoBehavior = null
        }
    },
    createFabao: function() {
        var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_FaBao, this.____1314).figureId);
        this.____1146 = ____654.effectManager.create(effectId, true, null, false, 0.5, null, ____655.____659.commonStaticType.source_clearOneM);
        this._fabaoBehavior = new FabaoFlyBehavior();
        this._fabaoBehavior.init(this.____1146, 0, 14);
        var path = this.____1146.getPath();
        var container = ____654.____676.getBatchNodeByType(path, 3);
        this.____1146.setContainer(container, true);
        this._fabaoBehavior.move(this._info.____355().x + 100, this._info.____355().y - 120);
        this.____1146.play()
    },
    clearShenJian: function() {
        if (this.____1668 != null) {
            this.____1668.dispose();
            this.____1668 = null
        }
        if (this._shenjianBehavior != null) {
            this._shenjianBehavior.dispose();
            this._shenjianBehavior = null
        }
    },
    createShenJian: function() {
        var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ShenJian, this.____1323).figureId);
        this.____1668 = ____654.effectManager.create(effectId, true, null, false, 0.5, null, ____655.____659.commonStaticType.source_clearOneM);
        this._shenjianBehavior = new FabaoFlyBehavior();
        this._shenjianBehavior.init(this.____1668, 0, -14);
        var path = this.____1668.getPath();
        var container = ____654.____676.getBatchNodeByType(path, 3);
        this.____1668.setContainer(container, true);
        this._shenjianBehavior.move(this._info.____355().x - 100, this._info.____355().y - 120);
        this.____1668.play()
    },
    clearZhengLing: function() {
        if (this.____1889 != null) {
            this.____1889.dispose();
            this.____1889 = null
        }
    },
    createZhengLing: function() {
        var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ZhengLing, this.____1331).figureId);
        this.____1889 = ____654.effectManager.create(effectId, true, null, false, null, null, ____655.____659.commonStaticType.source_clearOneM);
        var path = this.____1889.getPath();
        var container = ____654.____676.getBatchNodeByType(path, 2);
        this.____1889.setContainer(container, true);
        this.____1889.move(this._info.____355().x, this._info.____355().y);
        this.____1889.play()
    },
    ____358: function(evt) {
        this._super(evt);
        if (this.____1889 != null) {
            this.____1889.move(this._info.____355().x, this._info.____355().y)
        }
        if (this._shenjianBehavior != null) {
            this._shenjianBehavior.move(this._info.____355().x - 100, this._info.____355().y - 120)
        }
        if (this._fabaoBehavior != null) {
            this._fabaoBehavior.move(this._info.____355().x + 100, this._info.____355().y - 120)
        }
        if (!!this._weaponEffect) {
            this._weaponEffect.move(this._info.____355().x, this._info.____355().y)
        }
    },
    showSelectImg: function() {
        return true
    },
    getSelectViewPath: function() {
        return "ui_redBottom.png"
    },
    ____352: function() {
        this._super();
        if (this.____1146 != null) {
            this.____1146.addToContainer()
        }
        if (this.____1889 != null) {
            this.____1889.addToContainer()
        }
        if (this.____1668 != null) {
            this.____1668.addToContainer()
        }
        if (this._weaponEffect != null) {
            this._weaponEffect.addToContainer()
        }
    },
    ____353: function() {
        this._super();
        if (this.____1146 != null) {
            this.____1146.removeFromContainer()
        }
        if (this.____1889 != null) {
            this.____1889.removeFromContainer()
        }
        if (this.____1668 != null) {
            this.____1668.removeFromContainer()
        }
        if (this._weaponEffect != null) {
            this._weaponEffect.removeFromContainer()
        }
    },
    dispose: function() {
        this.clearFabao();
        this.clearZhengLing();
        this.clearShenJian();
        this.clearWeaponEffect();
        this._super()
    },
});
var ____2128 = KYNode.extend({
    ____867: null,
    ____1477: 0,
    ____1478: 0,
    ____1512: null,
    _picPath: null,
    ____1677: null,
    _scale: 1,
    ____1267: false,
    ____857: null,
    ____1269: true,
    ____1711: null,
    _isSwallow: false,
    ctor: function(isGround, offsetX, offsetY, isSwallow, isListener) {
        this._super();
        if (offsetX != null) {
            this.____1477 = offsetX
        }
        if (offsetY != null) {
            this.____1478 = offsetY
        }
        this.initSize();
        this.____1512 = ____654.____673.newKYSprite();
        this.____1512.setPosition(____654.____673.____159(this.____1477, this.____1478));
        this.____1512.setScale(this._scale);
        this.addChild(this.____1512, 1);
        if (isGround == null) {
            isGround = false
        }
        this.setGround(isGround);
        if (isSwallow != null) {
            this._isSwallow = isSwallow
        }
        if (isListener != false) {
            this.____6()
        }
    },
    initSize: function() {},
    ____6: function() {
        this.____1512.addListener(this, this.clickHandler, this.downHandler, this.upHandler, this.____358, this._isSwallow, true)
    },
    ____17: function() {},
    setBaseItemInfo: function(baseInfo) {
        this.____25();
        this.____867 = baseInfo;
        if (this.____867 != null) {
            this.setPic()
        } else {
            this.____1512.setFrame("board/ui_alphaBoard.png")
        }
    },
    ____25: function() {
        if (this._path != null) {
            ____654.____677.removeImageQuote(this._path, this.____1512)
        }
        this._path = null
    },
    setPic: function() {
        this._path = this.getPath();
        if (this._path == null) {
            return
        }
        var this_ = this;

        function complateHandler() {
            if (this_.____1267) {
                ____654.shaderCache.setColor(this_.____1512, 1)
            } else {
                ____654.shaderCache.setColor(this_.____1512, 0)
            }
        };
        ____654.____677.____146(this.____1512, this._path, complateHandler)
    },
    downHandler: function(sender, eventType, pos) {
        if (this.____1269 == false) {
            return
        }
        this.showTip();
        this.____1711 = pos
    },
    upHandler: function(sender, eventType, pos) {
        if (this.____1269 == false) {
            return
        }
        this.hideTip();
        this.____1711 = null
    },
    ____358: function(sender, eventType, pos) {
        if (this.____1269 == false) {
            return
        }
        if (Math.abs(pos.x - this.____1711.x) > 15 || Math.abs(pos.y - this.____1711.y) > 15) {
            this.hideTip()
        }
    },
    clickHandler: function(sender, eventType, pos) {},
    showTip: function() {},
    hideTip: function() {},
    setGround: function(value) {
        if (value) {
            if (this.____857 == null) {
                this.____857 = ____654.____673.newKYSprite();
                this.____857.setFrame(this.getBgPath());
                this.____857.setPosition(____654.____673.____159(this.____1477, this.____1478));
                this.addChild(this.____857, 0)
            }
        } else {
            if (this.____857 != null) {
                this.____857.dispose();
                this.____857 = null
            }
        }
    },
    getPath: function() {},
    getBgPath: function() {},
    ____238: function() {
        return this.____867
    },
    setMouseEnabled: function(value) {
        this.____1269 = value
    },
    getMouseEnabled: function() {
        return this.____1269
    },
    setGray: function(value) {
        if (this.____1267 == value) {
            return
        }
        this.____1267 = value;
        if (value) {
            ____654.shaderCache.setColor(this.____1512, 1)
        } else {
            ____654.shaderCache.setColor(this.____1512, 0)
        }
    },
    getTouchObj: function() {
        return this.____1512
    },
    dispose: function() {
        this.____17();
        this.setGround(false);
        this.____867 = null;
        this.____25();
        ____654.shaderCache.removeColor(this.____1512);
        this.____1512.dispose();
        this.____1512 = null;
        this.____1677 = null;
        this.____1711 = null;
        this._super()
    },
});
var HelloWorldLayer = cc.Layer.extend({
    sprite: null,
    ctor: function() {
        this._super();
        var size = cc.winSize;
        var helloLabel = new cc.LabelTTF("Hello World", "Arial", 38);
        helloLabel.x = size.width / 2;
        helloLabel.y = size.height / 2 + 200;
        this.addChild(helloLabel, 5);
        this.sprite = new cc.Sprite(res.HelloWorld_png);
        this.sprite.attr({
            x: size.width / 2,
            y: size.height / 2
        });
        this.addChild(this.sprite, 0);
        return true
    }
});
var HelloWorldScene = cc.Scene.extend({
    onEnter: function() {
        this._super();
        var layer = new HelloWorldLayer();
        this.addChild(layer)
    }
});
var ____1894 = KYPanel.extend({
    ____877: null,
    ____1311: null,
    _btnList: null,
    ____1085: null,
    ____1875: null,
    _pos: null,
    ctor: function(dataList, width, pos) {
        this._super();
        this._pos = pos;
        this.____857 = ____654.____673.newKYImageView();
        this.____857.setFrame("board/ui_blackBoard.png");
        this.____857.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____857.setScale9Enabled(true);
        this.____857.setCapInsets(____654.____673.____161(4, 4, 1, 1));
        this.____857.setOpacity(0);
        this.____857.setSize(____654.____673.____160(____655.____656, ____655.____657));
        this.____857.setPosition(____654.____673.____159(-____655.____656 * 0.5, -____655.____657 * 0.5));
        this.addChild(this.____857);
        this.____877 = ____654.____673.newKYImageView();
        this.____877.setFrame("board/ui_board9.png");
        this.____877.setScale9Enabled(true);
        this.____877.setCapInsets(cc.rect(20, 20, 1, 1));
        this.____877.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____877.setPosition(pos);
        this.addChild(this.____877, 3);
        this.____1311 = [];
        this._btnList = [];
        this.____1085 = dataList;
        this.____1875 = width;
        this.____6()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____857) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                ____654.____672.dispatchEvent(new ____590(____655.____661.global_comboBox, ____654.____672, 0))
            }
        }
    },
    btnIndexClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this._btnList.indexOf(sender);
            index = this._btnList.length - index;
            ____654.____672.dispatchEvent(new ____590(____655.____661.global_comboBox, ____654.____672, index))
        }
    },
    ____6: function() {
        this.____857.addListener(this, this.____16);
        for (var i = this.____1085.length - 1; i >= 0; i--) {
            var label = ____654.____673.newKYLabel();
            label.setColor(____655.____659.____688.system);
            label.setAnchorPoint(____654.____673.anchorPoints[6]);
            label.setString(this.____1085[i]);
            label.setPosition(____654.____673.____159(15, 5 + (i + 1) * 30 - 28));
            this.____877.addChild(label);
            this.____1311.push(label);
            var btn = ____654.____673.newKYImageView();
            btn.setFrame("board/ui_board3.png");
            btn.setScale9Enabled(true);
            btn.setOpacity(0);
            btn.setSize(____654.____673.____160(this.____1875, 35));
            btn.setAnchorPoint(____654.____673.anchorPoints[6]);
            btn.setPosition(____654.____673.____159(15, 5 + (i + 1) * 30 - 28));
            btn.addListener(this, this.btnIndexClickHandler);
            this.____877.addChild(btn);
            this._btnList.push(btn)
        }
        this.____877.setSize(____654.____673.____160(this.____1875 + 20, this.____1085.length * 40 - 20));
        ____654.____676.____125(this, true)
    },
    dispose: function() {
        this.____1085 = null;
        for (var i = 0; i < this.____1311.length; i++) {
            this.____1311[i].dispose()
        }
        this.____1311 = null;
        for (var i = 0; i < this._btnList.length; i++) {
            this._btnList[i].dispose()
        }
        this._btnList = null;
        this.____857.dispose();
        this.____857 = null;
        this.____877.dispose();
        this.____877 = null;
        this._pos = null;
        this._super()
    },
});
var ____1895 = cc.Class.extend({
    _count: 0,
    _countSound: 0,
    ____1189: null,
    ctor: function() {
        ____654.____678.____298(this.tick, this);
        this.____1189 = []
    },
    tick: function(delta, count) {
        this._count++;
        this._countSound++;
        if (this._count % 5 == 0) {
            this.popGetItemEffect()
        }
    },
    addGetItemEffect: function(templateId, type) {
        this.____1189.push([templateId, type])
    },
    popGetItemEffect: function() {
        if (this.____1189.length == 0) return;
        var data = this.____1189.splice(0, 1)[0];
        new GetItemEffect(data);
        if (this._countSound >= 20) {
            ____654.soundManager.playSound(____654.soundManager.PICKUP);
            this._countSound = 0
        }
    },
});
var OpacityEffect = KYNode.extend({
    _icon: null,
    _tickCount: 0,
    ____1692: 0,
    _currentOpacity: 255,
    ctor: function(path, speed) {
        this._super();
        this._icon = ____654.____673.newKYSprite();
        this._icon.setFrame(path);
        this.addChild(this._icon);
        this.____1692 = speed;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount++;
        this._currentOpacity += this.____1692;
        if (this._currentOpacity <= 0) {
            this._currentOpacity = 0;
            this.____1692 = Math.abs(this.____1692)
        } else if (this._currentOpacity >= 255) {
            this._currentOpacity = 255;
            this.____1692 = -Math.abs(this.____1692)
        }
        this._icon.setOpacity(this._currentOpacity)
    },
    move: function(x, y) {
        this.setPosition(____654.____673.____159(x, y))
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this._icon.dispose();
        this._icon = null;
        this._super()
    }
});
var RotationEffect = KYNode.extend({
    _icon: null,
    _tickCount: 0,
    ____1692: 0,
    ctor: function(path, speed) {
        this._super();
        this._icon = ____654.____673.newKYSprite();
        this._icon.setFrame(path);
        this.addChild(this._icon);
        this.____1692 = speed;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount++;
        this._icon.setRotation(this._tickCount * this.____1692)
    },
    move: function(x, y) {
        this.setPosition(____654.____673.____159(x, y))
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this._icon.dispose();
        this._icon = null;
        this._super()
    }
});
var InputLabelController = cc.Class.extend({
    _label: null,
    _container: null,
    _inputBg: null,
    _pos: null,
    ____1677: null,
    _attachCB: null,
    _detachCB: null,
    _executor: null,
    ctor: function(pos, size, container, maxLen, fontSize, defaultText) {
        this._pos = pos;
        this.____1677 = size;
        if (maxLen == null) {
            maxLen = 20
        }
        if (fontSize == null) {
            fontSize = 20
        }
        this._label = ____654.____673.newKYTextField(size, maxLen, fontSize, null, null, defaultText);
        this._label.setPosition(pos);
        this._container = container;
        this._container.addChild(this._label, 9);
        this.____6()
    },
    setCallBack: function(attachCB, detachCB, executor) {
        this._attachCB = attachCB;
        this._detachCB = detachCB;
        this._executor = executor
    },
    setString: function(value) {
        this._label.setString(value)
    },
    getString: function() {
        return this._label.getString()
    },
    setTouchEnabled: function(value) {
        this._label.setTouchEnabled(value)
    },
    setOpacity: function(value) {
        this._label.setOpacity(value)
    },
    ____6: function() {
        this._label.addEventListener(this.textFieldHandler, this)
    },
    ____17: function() {},
    textFieldHandler: function(sender, eventType) {
        if (eventType == ccui.TextField.EVENT_ATTACH_WITH_IME) {
            this.startInput();
            if (this._attachCB != null) {
                this._attachCB.call(this._executor)
            }
        } else if (eventType == ccui.TextField.EVENT_DETACH_WITH_IME) {
            this.endInput();
            if (this._detachCB != null) {
                this._detachCB.call(this._executor)
            }
        }
    },
    startInput: function() {
        this._label.removeFromParent(false);
        ____654.____676.____802.addChild(this._label, 97);
        var size = ____654.____673.____160(____655.____656 - 100, 36);
        this._label.setContentSize(size);
        this._label.setTouchSize(size);
        this._label.setPosition(____654.____673.____159(0, ____655.____657 - 20));
        if (this._inputBg == null) {
            this._inputBg = ____654.____673.newKYImageView();
            this._inputBg.setFrame("board/ui_board3.png");
            this._inputBg.setScale9Enabled(true);
            this._inputBg.setAnchorPoint(____654.____673.anchorPoints[6]);
            this._inputBg.setCapInsets(____654.____673.____161(20, 20, 1, 1));
            this._inputBg.setSize(____654.____673.____160(____655.____656, 43));
            this._inputBg.setPosition(____654.____673.____159(0, ____655.____657 - 43));
            ____654.____676.____802.addChild(this._inputBg, 96)
        }
    },
    endInput: function() {
        this._label.removeFromParent(false);
        this._container.addChild(this._label, 9);
        this._label.setContentSize(this.____1677);
        this._label.setTouchSize(this.____1677);
        this._label.setPosition(this._pos);
        if (this._inputBg != null) {
            this._inputBg.dispose();
            this._inputBg = null
        }
    },
    dispose: function() {
        this.____17();
        if (this._label != null) {
            this._label.dispose();
            this._label = null
        }
        if (this._inputBg != null) {
            this._inputBg.dispose();
            this._inputBg = null
        }
        this._pos = null;
        this.____1677 = null;
        this._container = null;
        this._attachCB = null;
        this._detachCB = null;
        this._executor = null
    },
});
var NumberView = KYNode.extend({
    _numList: null,
    _numStr: null,
    _type: 0,
    ____993: null,
    ____1255: 0,
    ____1815: 0,
    _name: null,
    ctor: function() {
        this._super();
        this.setAnchorPoint(____654.____673.anchorPoints[0]);
        this._numList = []
    },
    setType: function(type, color, scale) {
        this._type = type;
        this.____993 = color;
        if (scale != null) {
            this.setScale(scale)
        }
        if (type == 101 || type == 102 || type == 103 || type == 104) {
            this.____1255 = -6
        }
    },
    setToPos: function() {
        var tmpX = 0;
        var tmpY = null;
        var halfW = null;
        for (var i = 0; i < this._numList.length; i++) {
            var item = this._numList[i];
            if (tmpY == null) {
                tmpY = -item.getContentSize().height * this.getAnchorPoint().y + item.getContentSize().height / 2
            }
            halfW = item.getContentSize().width / 2;
            item.setPosition(tmpX - this.____1815 * this.getAnchorPoint().x + halfW, tmpY);
            tmpX += item.getContentSize().width + this.____1255
        }
    },
    setString: function(str) {
        this.setNumber(str)
    },
    setNumber: function(str) {
        this._name = str;
        str = str.toString();
        if (this._numStr == str) {
            return
        }
        var i = 0;
        var newLen = str.length;
        this.____1815 = 0;
        for (i = 0; i < newLen; i++) {
            var c = str.charAt(i);
            if (this._numStr != null && this._numStr.charAt(i) == str) {
                continue
            }
            var item = this._numList[i];
            var frameName = this.getPath(c);
            if (frameName != "" && frameName != null) {
                if (item == null) {
                    item = ____654.____673.newKYSprite();
                    item.setFrame(frameName);
                    if (this.____993 != null) {
                        item.setColor(this.____993)
                    }
                    this._numList.push(item)
                }
                if (item.getParent() == null) {
                    this.addChild(item)
                }
                item.setFrame(frameName);
                this.____1815 += item.getContentSize().width
            }
        }
        var oldLen = this._numList.length;
        if (newLen < oldLen) {
            for (i = oldLen - 1; i >= newLen; i--) {
                var item = this._numList.pop();
                item.dispose()
            }
        }
        this._numStr = str;
        this.setToPos()
    },
    getTotalWidth: function() {
        return this.____1815
    },
    setColor: function(color) {
        if (this.____993 == color) {
            return
        }
        this.____993 = color;
        if (this._numList == null) {
            return
        }
        for (var i = 0; i < this._numList.length; i++) {
            if (color == null) {
                this._numList[i].setColor(____655.____659.____688.white)
            } else {
                this._numList[i].setColor(color)
            }
        }
    },
    getPath: function(str) {
        if (this._type == 0 || this._type > 100) {
            var path = ____655.____659.nameType.numberPathList[this._type][str];
            if (path != null) {
                return path
            }
        } else {
            var code = str.charCodeAt(0);
            if (code >= 48 && code <= 57) {
                return "number/number" + this._type + "_" + str + ".png"
            }
        }
        return ""
    },
    numberToDouble: function(num, list) {
        var str = "";
        if (num < 10) {
            str += "0"
        }
        str += num.toString();
        return str
    },
    clear: function() {
        if (this._numList == null) {
            return
        }
        for (var i = 0; i < this._numList.length; i++) {
            this._numList[i].dispose()
        }
        this._numList = null;
        this._numStr = null
    },
    dispose: function() {
        this.clear();
        this.____993 = null;
        this._super()
    },
});
PropController = cc.Class.extend({
    ____1251: null,
    ____1258: false,
    _executor: null,
    _callBack: null,
    _currentIndex: -1,
    ctor: function(isAutoDispose) {
        if (isAutoDispose != null) {
            this.____1258 = isAutoDispose
        }
        this.____1251 = []
    },
    ____363: function(infoList) {
        ____654.____678.____299(this.tick, this);
        for (i = 0; i < this.____1251.length; i++) {
            this.____1251[i].dispose()
        }
        this.____1251 = infoList;
        this._currentIndex = -1
    },
    addInfo: function(info) {
        this.____1251.push(info)
    },
    setCallBack: function(executor, callBack) {
        this._executor = executor;
        this._callBack = callBack
    },
    pStart: function() {
        if (this.____1251.length == 0) {
            return
        }
        this._currentIndex = 0;
        ____654.____678.____298(this.tick, this)
    },
    pEnd: function() {
        ____654.____678.____299(this.tick, this);
        if (this._callBack != null && this._executor != null) {
            this._callBack.call(this._executor, this)
        }
        this._currentIndex = -1;
        if (this.____1258) {
            this.dispose()
        }
    },
    tick: function(delta, count) {
        if (this.____1251[this._currentIndex].run()) {
            this._currentIndex += 1;
            if (this._currentIndex >= this.____1251.length) {
                this.pEnd()
            }
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        for (i = 0; i < this.____1251.length; i++) {
            this.____1251[i].dispose()
        }
        this.____1251 = null;
        this._executor = null;
        this._callBack = null
    },
});
PropInfo = cc.Class.extend({
    _target: null,
    _type: null,
    ____1713: 0,
    ____1134: 0,
    ____1692: 0,
    ____838: 0,
    _tickCount: 0,
    ____1837: 0,
    ____1065: 0,
    _count: 0,
    ____1664: null,
    ctor: function(target, type, tickCount, startValue, endValue, speed, aSpeed) {
        this._target = target;
        this._type = type;
        this._tickCount = tickCount;
        this.____1713 = startValue;
        this.____1134 = endValue;
        this.____1692 = speed;
        this.____838 = aSpeed;
        this.____1837 = startValue;
        this.____1065 = speed;
        if (this._type == 1) {
            this.____1664 = this.setX
        } else if (this._type == 2) {
            this.____1664 = this.setY
        } else if (this._type == 3) {
            this.____1664 = this.setAlpha
        } else if (this._type == 4) {
            this.____1664 = this.wait
        } else if (this._type == 5) {
            this.____1664 = this.setScale
        } else if (this._type == 6) {
            this.____1664 = this.setScaleX
        } else if (this._type == 7) {
            this.____1664 = this.setScaleY
        }
    },
    setX: function() {
        this._target.setPositionX(this.____1837)
    },
    setY: function() {
        this._target.setPositionY(this.____1837)
    },
    setAlpha: function() {
        this._target.setOpacity(this.____1837)
    },
    wait: function() {},
    setScale: function() {
        this._target.setScale(this.____1837)
    },
    setScaleX: function() {
        this._target.setScaleX(this.____1837)
    },
    setScaleY: function() {
        this._target.setScaleY(this.____1837)
    },
    run: function() {
        var dobreak = false;
        if (this._tickCount > 0) {
            this._count += 1;
            if (this._count > this._tickCount) {
                this.over();
                dobreak = true
            }
        }
        if (!dobreak) {
            this.____1837 += this.____1065;
            if (Math.abs(this.____1134 - this.____1837) < Math.abs(this.____1065)) {
                this.over();
                dobreak = true
            } else {
                this.____1664.call(this);
                this.____1065 += this.____838
            }
        }
        return dobreak
    },
    over: function() {
        this.____1837 = this.____1134;
        this.____1664.call(this);
        this.____1837 = this.____1713;
        this._count = 0;
        this.____1065 = this.____1692
    },
    dispose: function() {
        this._target = null;
        this.____1664 = null
    }
});
var ____1898 = cc.Class.extend({
    type: 0,
    startTime: -1,
    endTime: 0,
    isShow: false,
    timeType: 0,
    initActivity: function(data) {
        this.type = data.readUByte();
        this.isShow = data.readBoolean();
        this.endTime = data.readInt()
    },
    initTiming: function(type, data) {
        this.type = type;
        this.timeType = data.readByte();
        this.startTime = data.readInt();
        this.endTime = data.readInt()
    },
    dispose: function() {},
});
var ____1899 = ____591.extend({
    activityIcons: null,
    timingIcons: null,
    ctor: function() {
        this.activityIcons = {};
        this.timingIcons = {};
        this._super()
    },
    initActivityIcon: function(bytes) {
        var len = bytes.readUByte();
        for (var i = 0; i < len; i++) {
            var info = new ____1898();
            info.initActivity(bytes);
            this.activityIcons[info.type] = info
        }
        this.dispatchEvent(new ____590(____655.____661.mainmenu_actIconUpdate, this, null))
    },
    initTimingIcon: function(bytes) {
        var type = bytes.readUByte();
        var info = new ____1898();
        info.initTiming(type, bytes);
        this.timingIcons[type] = info;
        this.dispatchEvent(new ____590(____655.____661.mainmenu_timeIconUpdate, this, type))
    },
    removeTimingIcon: function(type) {
        if (this.timingIcons[type] != null) {
            this.timingIcons[type].dispose();
            this.timingIcons[type] = null
        }
        this.dispatchEvent(new ____590(____655.____661.mainmenu_timeIconRemove, this, type))
    },
    ____61: function() {
        if (this.activityIcons != null) {
            for (var i in this.activityIcons) {
                if (this.activityIcons[i] != null) this.activityIcons[i].dispose()
            }
        }
        this.activityIcons = {};
        if (this.timingIcons != null) {
            for (var i in this.timingIcons) {
                if (this.timingIcons[i] != null) this.timingIcons[i].dispose()
            }
        }
        this.timingIcons = {}
    },
});
var ____481 = cc.Class.extend({
    playerInfo: null,
    channel: 0,
    toUserId: 0,
    message: null,
    time: 0,
    unread: false,
    isDownLoad: false,
    ctor: function() {
        this.playerInfo = new ____495()
    },
    ____34: function(value) {
        if (this.unread == value) {
            return
        }
        this.unread = value;
        ____654.____672.dispatchEvent(new ____590(____655.____661.chat_read, ____654.____672))
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var ____482 = ____591.extend({
    maxCount: 30,
    itemList: null,
    privatList: null,
    sendTime: null,
    _voiceName: null,
    _voiceStartTime: 0,
    _isVoicePlaying: false,
    _voiceNameList: null,
    _playList: null,
    isAutoVoice1: false,
    isAutoVoice2: false,
    _playTime: 0,
    ctor: function() {
        this._super();
        this.itemList = {};
        this.privatList = {};
        this.sendTime = {};
        this._playList = [];
        for (var i = 0; i < ____655.____659.____693.channelList.length; i++) {
            this.itemList[____655.____659.____693.channelList[i]] = []
        }
        this.deleteVoiceList()
    },
    ____36: function(itemInfo) {
        if (itemInfo.message == null || itemInfo.message == "") {
            return
        }
        var list = null;
        if (itemInfo.channel == ____655.____659.____693.privat) {
            if (itemInfo.toUserId != ____655.____667.userId) {
                if (this.privatList[itemInfo.toUserId] == null) {
                    this.privatList[itemInfo.toUserId] = []
                }
                list = this.privatList[itemInfo.toUserId];
                list.push(itemInfo);
                if (list.length > this.maxCount) {
                    var info = list.shift();
                    this.deleteFromPlayList(info);
                    info.dispose()
                }
            } else {
                if (this.privatList[itemInfo.playerInfo.userId] == null) {
                    this.privatList[itemInfo.playerInfo.userId] = []
                }
                list = this.privatList[itemInfo.playerInfo.userId];
                list.push(itemInfo);
                if (list.length > this.maxCount) {
                    var info = list.shift();
                    this.deleteFromPlayList(info);
                    info.dispose()
                }
                itemInfo.____34(true)
            }
        } else {
            for (var i = 0; i < ____655.____659.____693.channelShowType.length; i++) {
                var index = ____655.____659.____693.channelShowType[i].indexOf(itemInfo.channel);
                if (index > -1) {
                    list = this.itemList[____655.____659.____693.channelList[i]];
                    list.push(itemInfo);
                    if (list.length > this.maxCount) {
                        var info = list.shift();
                        this.deleteFromPlayList(info);
                        info.dispose()
                    }
                    break
                }
            }
            if (itemInfo.channel == ____655.____659.____693.worldNotice) {
                ____654.tipsManager.quickTip.showNotice(itemInfo.message)
            } else if (itemInfo.channel == ____655.____659.____693.world) {
                if (this.isAutoVoice1 && itemInfo.toUserId != ____655.____667.userId) {
                    this.playVoice(itemInfo)
                }
            } else if (itemInfo.channel == ____655.____659.____693.club) {
                if (this.isAutoVoice2 && itemInfo.toUserId != ____655.____667.userId) {
                    this.playVoice(itemInfo)
                }
            }
        }
        this.dispatchEvent(new ____590(____655.____661.____761, this, itemInfo))
    },
    appendSystemItem: function(string, isNotice) {
        if (____655.isShowGetTip && isNotice != true) {
            ____654.tipsManager.quickTip.show(string)
        }
        var itemInfo = new ____481();
        if (isNotice == true) {
            itemInfo.channel = ____655.____659.____693.worldNotice
        } else {
            itemInfo.channel = ____655.____659.____693.system
        }
        itemInfo.message = string;
        this.____36(itemInfo)
    },
    setOffLineMessage: function(list) {
        function sortFunc(info1, info2) {
            return info1[1] - info2[1]
        }
        list.sort(sortFunc);
        for (var i = 0; i < list.length; i++) {
            var friendInfo = ____655.____668.getFriend(list[i][0]);
            if (friendInfo != null) {
                var info = new ____481();
                info.playerInfo.serverId = friendInfo.info.serverId;
                info.playerInfo.vipLevel = friendInfo.info.vipLevel;
                info.playerInfo.gm = ____655.____667.gm;
                info.playerInfo.nick = friendInfo.info.nick;
                info.playerInfo.userId = list[i][0];
                info.toUserId = ____655.____667.userId;
                info.playerInfo.career = friendInfo.info.career;
                info.channel = ____655.____659.____693.privat;
                info.message = list[i][2];
                info.time = ____655.____662.secondsToDateString(list[i][1]);
                this.____36(info)
            }
        }
        list = []
    },
    getChatItemList: function(channel) {
        return this.itemList[channel]
    },
    getPrivatChatList: function(userId) {
        return this.privatList[userId]
    },
    getUnreadCountByUserId: function(userId) {
        var list = this.getPrivatChatList(userId);
        if (list == null) {
            return 0
        }
        var count = 0;
        for (var i = 0; i < list.length; i++) {
            if (list[i].unread) {
                count++
            }
        }
        return count
    },
    ____39: function() {
        var count = 0;
        for (var userId in this.privatList) {
            count = count + this.getUnreadCountByUserId(userId)
        }
        return count
    },
    getAUnreadPlayerId: function() {
        for (var userId in this.privatList) {
            if (this.getUnreadCountByUserId(userId) > 0) {
                return userId
            }
        }
        return userId
    },
    getLastTimeByUserId: function(userId) {
        var list = this.getPrivatChatList(userId);
        if (list == null) {
            return 0
        }
        if (list.length > 0 && list[list.length - 1] != null) {
            return list[list.length - 1].time
        }
        return 0
    },
    deleteChatById: function(userId) {
        if (this.privatList[userId] != null) {
            for (var i = 0; i < this.privatList[userId].length; i++) {
                this.deleteFromPlayList(this.privatList[userId][i]);
                this.privatList[userId][i].dispose()
            }
            this.privatList[userId] = null
        }
    },
    checkCanSendChat: function(channel) {
        var errorMessage = "";
        var errorType = channel;
        var nowTime = ____655.____662.getSystemTimeSec();
        var delta = nowTime;
        if (this.sendTime[channel] != null) {
            delta = nowTime - this.sendTime[channel]
        }
        if (channel == ____655.____659.____693.world) {
            if (____655.____667.level < 30) {
                errorMessage = ____654.yuyanbaoManager.getYuyanbao("chatPanel.sendTip3", 30)
            } else if (delta < 10) {
                errorMessage = ____654.yuyanbaoManager.getYuyanbao("chatPanel.sendTip5", 10 - delta)
            }
        } else if (channel == ____655.____659.____693.club) {
            if (____655.____667.clubId == 0) {
                errorMessage = ____654.yuyanbaoManager.getYuyanbao("chatPanel.sendTip4")
            }
        } else if (channel == ____655.____659.____693.speaker) {}
        if (errorMessage != "") {
            var info = new ____481();
            info.channel = errorType;
            info.message = errorMessage;
            this.____36(info);
            return false
        }
        return true
    },
    startVioce: function() {
        print("--开始录音");
        ____654.soundManager.setMusicVolume(0);
        ____654.soundManager.setSoundVolume(0);
        this._voiceStartTime = ____655.____662.getSystemTimeSec();
        this._voiceName = ____655.____667.userId.toString() + "_" + this._voiceStartTime.toString();
        ____654.sdk.startVoice(this._voiceName)
    },
    endVioce: function() {
        print("--取消录音", this._voiceName);
        ____654.soundManager.setMusicVolume(____654.soundManager.DEFAULT);
        ____654.soundManager.setSoundVolume(1);
        if (this._voiceName == null) {
            return
        }
        ____654.sdk.stopVoice();
        ____654.sdk.delVoice(this._voiceName);
        this._voiceName = null
    },
    getVoiceTime: function() {
        if (this._voiceStartTime == 0) {
            return 0
        }
        return ____655.____662.getSystemTimeSec() - this._voiceStartTime
    },
    sendVioce: function(sendType, toUserId) {
        print("--发送录音", this._voiceName);
        ____654.soundManager.setMusicVolume(____654.soundManager.DEFAULT);
        ____654.soundManager.setSoundVolume(1);
        if (this._voiceName == null) {
            return
        }
        var this_ = this;
        var name = this._voiceName;
        var time = this.getVoiceTime();
        this._voiceStartTime = 0;
        if (time < 1) {
            time = 1
        }

        function uploadVoiceHandler(result) {
            print("--录音上传结果", result);
            var info = new ____481();
            info.playerInfo.serverId = ____655.____667.serverId;
            info.playerInfo.vipLevel = ____655.____667.vipLevel;
            info.playerInfo.gm = ____655.____667.gm;
            info.playerInfo.nick = ____655.____667.nick;
            info.playerInfo.userId = ____655.____667.userId;
            info.toUserId = toUserId;
            info.isDownLoad = true;
            info.playerInfo.career = ____655.____667.career;
            info.channel = sendType;
            var type = "0";
            if (result) {
                type = "1"
            }
            info.message = " voice|" + type + "|" + time.toString() + "|" + name;
            info.time = ____655.____662.secondsToDateString(____655.____662.getSystemTimeSec());
            this_.____36(info);
            if (result) {
                ____654.____683.sendChat(sendType, info.message, ____655.____667.nick, ____655.____667.userId)
            }
        };
        var hasVoice = ____654.sdk.stopVoice();
        if (hasVoice == "false") {
            this._voiceName = null;
            return
        }
        var index = this._voiceNameList.indexOf(this._voiceName);
        if (index < 0) {
            this._voiceNameList += "|" + this._voiceName;
            ____654.sdk.writeKV("voiceList", this._voiceNameList)
        }
        ____654.sdk.uploadVoice(this._voiceName, uploadVoiceHandler);
        this.sendTime[sendType] = ____655.____662.getSystemTimeSec();
        this._voiceName = null
    },
    updateVoice: function(chatInfo, callBack, executor) {
        var strList = chatInfo.message.split("|");

        function uploadVoiceHandler(result) {
            print("--录音重传结果", result);
            chatInfo.time = ____655.____662.secondsToDateString(____655.____662.getSystemTimeSec());
            if (result) {
                chatInfo.message = " voice|1|" + strList[2] + "|" + strList[3];
                ____654.____683.sendChat(chatInfo.channel, chatInfo.message, ____655.____667.nick, ____655.____667.userId)
            }
            if (callBack != null && executor != null) {
                callBack.call(executor, result)
            }
        };
        ____654.sdk.uploadVoice(strList[3], uploadVoiceHandler)
    },
    playVoice: function(chatInfo) {
        if (____655.isCanVoice == false) {
            ____654.tipsManager.quickTip.show("当前版本不支持语音");
            return
        }
        if (chatInfo.message.charAt(0) != " ") {
            return
        }
        if (this._isVoicePlaying) {
            if (this._playList.indexOf(chatInfo) >= 0) {
                return
            }
            this._playList.push(chatInfo);
            return
        }
        var this_ = this;

        function playComplateHandler() {
            this_.playEnd();
            if (this_._playList.length > 0) {
                this_.playVoice(this_._playList.shift())
            }
        };

        function downloadVoiceHandler(result) {
            if (result) {
                chatInfo.isDownLoad = true;
                ____654.soundManager.setMusicVolume(0);
                ____654.soundManager.setSoundVolume(0);
                var index = this_._voiceNameList.indexOf(strList[3]);
                if (index < 0) {
                    this_._voiceNameList += "|" + strList[3];
                    ____654.sdk.writeKV("voiceList", this_._voiceNameList)
                }
                ____654.sdk.playVoice(strList[3], playComplateHandler);
                this_._playTime = 600;
                ____654.____678.____298(this_.playTick, this_)
            } else {
                playComplateHandler()
            }
        };
        var strList = chatInfo.message.split("|");
        if (strList[0] == " voice") {
            this._isVoicePlaying = true;
            if (!chatInfo.isDownLoad) {
                ____654.sdk.downloadVoice(strList[3], downloadVoiceHandler)
            } else {
                downloadVoiceHandler(true)
            }
        } else {
            if (this._playList.length > 0) {
                this_.playVoice(this._playList.shift())
            }
        }
    },
    playTick: function(count, delta) {
        this._playTime--;
        if (this._playTime <= 0) {
            this.playEnd()
        }
    },
    playEnd: function() {
        this._isVoicePlaying = false;
        ____654.soundManager.setMusicVolume(____654.soundManager.DEFAULT);
        ____654.soundManager.setSoundVolume(1);
        ____654.____678.____299(this.playTick, this)
    },
    deleteVoiceList: function() {
        var list = [];
        if (this._voiceNameList == null) {
            this._voiceNameList = ____654.sdk.readKV("voiceList");
            if (this._voiceNameList != null && this._voiceNameList != "") {
                list = this._voiceNameList.split("|")
            }
        }
        var delList = [];
        for (var i = 0; i < list.length; i++) {
            var index = delList.indexOf(list[i]);
            if (index < 0) {
                ____654.sdk.delVoice(list[i]);
                delList.push(list[i])
            }
        }
        this._voiceNameList = "";
        ____654.sdk.writeKV("voiceList", this._voiceNameList)
    },
    deleteFromPlayList: function(chatInfo) {
        if (chatInfo.message.charAt(0) == "") {
            var strList = chatInfo.message.split("|");
            if (strList[0] == " voice") {
                var index = this._playList.indexOf(chatInfo);
                if (index >= 0) {
                    this._playList.splice(index, 1)
                }
            }
        }
    },
    ____61: function() {
        this.deleteVoiceList();
        if (this._voiceName != null) {
            ____654.sdk.stopVoice();
            this._voiceName = null
        }
        for (var i in this.itemList) {
            for (var j = 0; j < this.itemList[i].length; j++) {
                this.itemList[i][j].dispose()
            }
            this.itemList[i] = []
        }
        for (var k in this.privatList) {
            if (this.privatList[k] != null) {
                for (var l = 0; l < this.privatList[k].length; l++) {
                    this.privatList[k][l].dispose()
                }
            }
        }
        this.privatList = {};
        this.sendTime = {};
        this._playList = [];
        this.playEnd()
    },
});
var ____483 = cc.Class.extend({
    faceList: null,
    ctor: function() {
        this.faceList = [
            [2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4],
            [15, 15, 15, 15, 16, 16, 16, 16],
            [17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22, 23, 23, 24, 24, 25, 25, 26, 26],
            [27, 27, 28, 28],
            [29, 29, 29, 29, 29, 29, 30, 30, 30, 30, 30, 30],
            [31, 31, 32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 37, 37],
            [38, 38, 38, 38, 38, 38, 39, 39, 39, 39, 39, 39],
            [42, 42, 43, 43, 44, 44, 45, 45],
            [454, 454, 455, 455, 456, 456, 457, 457, 458, 458, 459, 459, 460, 460, 460, 460, 458, 458, 461, 461, 462, 462, 461, 461],
            [50, 50, 51, 51],
            [52, 52, 53, 53, 54, 54, 55, 55, 56, 56, 57, 57, 58, 58, 59, 59, 60, 60, 61, 61, 62, 62, 63, 63, 64, 64, 65, 65, 66, 66, 67, 67, 68, 68, 69, 69, 70, 70],
            [75, 75, 75, 75, 75, 75, 76, 76, 76, 76, 76, 76, 77, 77, 77, 77, 77, 77, 78, 78, 78, 78, 78, 78],
            [79, 79, 80, 80, 81, 81, 82, 82],
            [83, 83, 83, 83, 83, 83, 84, 84, 84, 84, 84, 84, 85, 85, 85, 85, 85, 85, 86, 86, 86, 86, 86, 86, 87, 87, 87, 87, 87, 87, 88, 88, 88, 88, 88, 88, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 90, 90, 91, 91, 92, 92, 93, 93, 97, 97, 95, 95, 96, 96, 97, 97, 98, 98, 99, 99],
            [106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 107, 107, 108, 108, 109, 109, 110, 110, 111, 111, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112],
            [113, 113, 114, 114, 115, 115, 116, 116, 117, 117, 118, 118, 119, 119, 120, 120],
            [121, 121, 121, 121, 121, 121, 122, 122, 122, 122, 122, 122, 123, 123, 123, 123, 123, 123, 124, 124, 124, 124, 124, 124, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125],
            [126, 126, 127, 127, 128, 128, 129, 129, 130, 130, 131, 131, 132, 132, 133, 133, 134, 134, 135, 135, 136, 136],
            [155, 155, 156, 156, 156, 156, 156, 156, 156, 156, 155, 155, 155, 155, 155, 155, 155, 155, 156, 156, 157, 157, 158, 158, 157, 157, 158, 158],
            [159, 159, 160, 160, 161, 161, 162, 162, 163, 163, 164, 164, 165, 165, 166, 166, 167, 167, 168, 168, 169, 169, 170, 170, 171, 171, 172, 172, 172, 172, 172, 172],
            [180, 180, 180, 180, 180, 180, 181, 182, 181, 182, 183, 183, 184, 184, 185, 185, 186, 186, 187, 187, 188, 188, 189, 189, 190, 190, 191, 191, 192, 192, 193, 193, 194, 194, 195, 195, 196, 196, 197, 197, 198, 198, 199, 199, 200, 200, 201, 201, 202, 202, 203, 203, 204, 204, 205, 205, 206, 206, 207, 207, 208, 208, 209, 209, 209, 209, 209, 209, 209, 209],
            [210, 210, 210, 210, 211, 211, 211, 211, 212, 212, 212, 212, 213, 213, 214, 214, 215, 215, 214, 214, 215, 215, 214, 214, 214, 214],
            [226, 226, 226, 226, 226, 226, 227, 227, 227, 227, 227, 227, 228, 228, 228, 228, 228, 228, 226, 226, 226, 226, 226, 226, 228, 228, 228, 228, 228, 228, 227, 227, 227, 227, 227, 227, 228, 228, 228, 228, 228, 228, 226, 226, 226, 226, 226, 226, 228, 228, 228, 228, 228, 228, 226, 226, 226, 226, 226, 226, 227, 227, 227, 227, 227, 227, 229, 229, 229, 229, 229, 229, 230, 230, 230, 230, 230, 230, 231, 231, 232, 232],
            [238, 238, 238, 238, 239, 239, 239, 239, 240, 240, 240, 241, 241, 241],
            [262, 262, 262, 262, 262, 262, 263, 263, 263, 263, 264, 264, 264, 264, 264, 264, 265, 265, 265, 265, 265, 265, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266, 266],
            [300, 300, 301, 301, 302, 302],
            [303, 303, 304, 304, 303, 303, 305, 305],
            [392],
            [405, 405, 405, 405, 406, 406, 406, 406],
            [407],
            [413, 413, 414, 414, 415, 415, 414, 414],
            [416, 416, 416, 416, 416, 416, 417, 417, 417, 416, 416, 416, 416, 416, 416, 416, 416, 416, 417, 417, 417, 416, 416, 416, 418, 418, 418, 419, 418, 419, 418, 419, 418, 419, 418, 419, 418, 419, 418, 419, 418, 419, 418],
            [420],
            [433, 434, 433, 433, 434, 433, 434, 434, 433, 433, 433, 433, 433, 433, 433, 433, 433, 433, 433, 433, 433],
            [452, 452, 452, 452, 452, 452, 453, 453, 453, 453, 453, 453]
        ];
        ____654.____677.____147(____654.____675.____139("face/face.png"), this.____40, this)
    },
    ____40: function(data) {
        cc.spriteFrameCache.addSpriteFrames(____654.____675.____139("face/face.plist"))
    },
});
var ____1903 = cc.Class.extend({
    id: 0,
    type: 0,
    needItems: null,
    needLevel: -1,
    needTime: -1,
    needMoneys: null,
    needCopys: null,
    doCheck: function() {
        if (this.needItems != null) {
            for (var i = 0; i < this.needItems.length; i += 2) {
                if (____655.itemInfoList.getCount()[this.needItems[i]] < this.needItems[i + 1]) {
                    return false
                }
            }
        }
        if (this.needLevel > -1) {
            if (____655.____667.level < this.needLevel) return false
        }
        if (this.needTime > -1) {
            if (____655.____662.getSystemTimeSec() < this.needTime) return false
        }
        return false
    },
});
var ____1904 = cc.Class.extend({
    serverId: 0,
    userId: 0,
    name: "",
    level: 0,
    career: 0,
    vipLevel: 0,
    init: function(data) {
        this.serverId = data.readShort();
        this.userId = data.readNumber();
        this.name = data.readString();
        this.level = data.readShort();
        this.career = data.readByte();
        this.vipLevel = data.readByte();
        this.fight = data.readInt()
    },
    getSex: function() {
        return this.career == 1
    },
});
var ClubInfo = ____591.extend({
    id: 0,
    name: "",
    level: 0,
    serverId: 0,
    wealth: 0,
    descript: "",
    rank: 0,
    fight: 0,
    memberCount: 0,
    masterName: "",
    autoInFightLevel: 1,
    myJob: 0,
    myTotalGongxian: 0,
    myYuanbaoCount: 0,
    myCopperCount: 0,
    totalCopperCount: 0,
    members: null,
    applys: null,
    selfRequteNum: 0,
    selfRequteList: null,
    xinFaLevel: 0,
    xinFaAttrList: null,
    xinFaFight: 0,
    godTreeNum: 0,
    godTreeAwardList: null,
    bossMissionList: null,
    bossExpeditionRestNum: 0,
    clubBossState: 0,
    clubBossTime: 0,
    ctor: function() {
        this._super();
        this.members = [];
        this.applys = [];
        this.selfRequteList = [];
        this.xinFaAttrList = {};
        this.godTreeAwardList = {}
    },
    init: function(data) {
        this.serverId = data.readShort();
        this.id = data.readNumber();
        this.level = data.readShort();
        this.name = data.readString();
        this.wealth = data.readInt();
        this.descript = data.readString();
        this.rank = data.readInt();
        this.fight = data.readInt();
        this.memberCount = data.readByte();
        this.masterName = data.readString();
        this.autoInFightLevel = data.readByte();
        this.totalCopperCount = data.readInt();
        this.godTreeNum = data.readInt();
        this.dispatchEvent(new ____590(____655.____661.club_info_update, this, null))
    },
    initMyData: function(data) {
        this.myJob = data.readByte();
        ____655.____667.moneyInfo.setMoney6(data.readInt());
        this.myTotalGongxian = data.readInt();
        this.myYuanbaoCount = data.readByte();
        this.myCopperCount = data.readByte();
        this.godTreeAwardList = {};
        var len = data.readByte();
        for (var i = 1; i <= len; i++) {
            var type = data.readByte();
            this.godTreeAwardList[type] = type
        }
        this.dispatchEvent(new ____590(____655.____661.club_myData_update, this, null))
    },
    requteClubInfo: function(data) {
        this.selfRequteList = [];
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var clubId = data.readNumber();
            this.selfRequteList.push(clubId)
        }
        this.selfRequteNum = data.readByte();
        if (len > 0) {
            this.dispatchEvent(new ____590(____655.____661.club_RequteInfo, this, null))
        }
    },
    clearMember: function() {
        this.members = []
    },
    initMember: function(data) {
        function sortHandler(info1, info2) {
            if (info1.onlineState != info2.onlineState) {
                return info2.onlineState - info1.onlineState
            }
            if (info1.job != info2.job) {
                if (info1.job != 0 && info2.job != 0) {
                    return info1.job - info2.job
                } else {
                    return info2.job - info1.job
                }
            }
            if (info1.fight != info2.fight) {
                return info2.fight - info1.fight
            }
            if (info1.onlineState == false && info2.onlineState == false) {
                return info2.lastOnlineTime - info1.lastOnlineTime
            }
        }
        this.clearMember();
        var len = data.readShort();
        for (var i = 0; i < len; i++) {
            var mem = new ____1908();
            mem.init(data);
            this.members.push(mem)
        }
        this.members.sort(sortHandler);
        this.dispatchEvent(new ____590(____655.____661.club_memberList_update, this, null))
    },
    initApplyList: function(data) {
        this.clearApplyList();
        var len = data.readShort();
        for (var i = 0; i < len; i++) {
            var applyInfo = new ____1904();
            applyInfo.init(data);
            this.applys.push(applyInfo)
        }
        this.dispatchEvent(new ____590(____655.____661.club_applyList_update, this, null))
    },
    clearApplyList: function() {
        this.applys = []
    },
    clubPlayerApplyDeal: function(data) {
        var userId = data.readNumber();
        for (var index in this.applys) {
            if (this.applys[index].userId == userId) {
                this.applys.splice(index, 1)
            }
        }
        this.dispatchEvent(new ____590(____655.____661.club_applyList_update, this, null))
    },
    getJobName: function(job) {
        if (job == 1) return ____654.yuyanbaoManager.getYuyanbao("ClubInfo.text1");
        else if (job == 2) return ____654.yuyanbaoManager.getYuyanbao("ClubInfo.text2");
        return ____654.yuyanbaoManager.getYuyanbao("ClubInfo.text3")
    },
    clubXinFaInfo: function(data) {
        this.xinFaLevel = data.readShort();
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var attrId = data.readShort();
            var attrValue = data.readInt();
            this.xinFaAttrList[attrId] = attrValue
        }
        this.xinFaFight = data.readNumber();
        this.dispatchEvent(new ____590(____655.____661.club_xinfaInfo_update, this, null))
    },
    clubPlayerGodTreeInfo: function(data) {},
    clubExpeditionBossHPInfo: function(data) {
        var copyId = data.readInt();
        var missionId = data.readInt();
        var hp = data.readNumber();
        this.bossMissionList = {};
        if (this.bossMissionList[copyId] == null) {
            this.bossMissionList[copyId] = []
        }
        this.bossMissionList[copyId] = [missionId, hp];
        this.bossExpeditionRestNum = data.readByte();
        this.dispatchEvent(new ____590(____655.____661.club_expeditionBossHp, this, null))
    },
    clubExpeditionHurtInfo: function(data) {
        var copyId = data.readInt();
        var missionId = data.readInt();
        var hp = data.readNumber();
        if (copyId == ____655.copyInfo.currentId) {
            this.dispatchEvent(new ____590(____655.____661.club_expeditionHurtInfo, this, hp))
        }
    },
    clubExpeditionResetInfo: function(data) {
        var state = data.readByte();
        var copyId = data.readInt();
        if (state == 1) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text4"))
        } else if (state == 2) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text5"))
        } else {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text6"));
            var missionId = ____655.allTemplates.copyTemplateList.getCopy(copyId).missionIds[0];
            this.bossMissionList = {}
            if (this.bossMissionList[copyId] == null) {
                this.bossMissionList[copyId] = []
            }
            this.bossMissionList[copyId] = [missionId, 0];
            if (this.bossExpeditionRestNum > 0) {
                this.bossExpeditionRestNum = this.bossExpeditionRestNum - 1
            }
            this.dispatchEvent(new ____590(____655.____661.club_expeditionBossHp, this, null))
        }
    },
    clubBossCopyInfo: function(data) {
        this.clubBossState = data.readByte();
        this.clubBossTime = data.readInt();
        this.sendChangeBossState()
    },
    clubJobUpdate: function(data) {
        var userId = data.readNumber();
        var job = data.readByte();
        var indexItem = 0;
        for (var index in this.members) {
            if (this.members[index].userId == userId) {
                this.members[index].job = job;
                indexItem = index;
                break
            }
        }
        this.dispatchEvent(new ____590(____655.____661.club_memberList_update_jobUpdate, this, indexItem))
    },
    ClubMemberkick: function(data) {
        var userId = data.readNumber();
        var indexItem = 0;
        for (var index in this.members) {
            if (this.members[index].userId == userId) {
                this.members.splice(index, 1);
                indexItem = index;
                break
            }
        }
        this.dispatchEvent(new ____590(____655.____661.club_memberList_update_Kick, this, indexItem))
    },
    sendChangeBossState: function() {
        this.dispatchEvent(new ____590(____655.____661.club_bossInfoUpdate, this, null))
    },
    ____61: function() {
        this.clearMember();
        this.clearApplyList();
        this.members = [];
        this.applys = [];
        this.selfRequteList = [];
        this.xinFaAttrList = {};
        this.godTreeAwardList = {};
        this.bossMissionList = {};
        this.selfRequteNum = 0;
        this.xinFaLevel = 0;
        this.xinFaFight = 0;
        this.godTreeNum = 0;
        this.bossExpeditionRestNum = 0;
        this.clubBossState = 0;
        this.clubBossTime = 0
    },
});
var ____1906 = cc.Class.extend({
    serverId: 0,
    clubId: 0,
    clubName: "",
    clubLevel: 0,
    rank: 0,
    totalFight: 0,
    memberCount: 0,
    masterId: 0,
    masterName: "",
    autoInFightLevel: 0,
    init: function(data) {
        this.serverId = data.readShort();
        this.clubId = data.readNumber();
        this.clubName = data.readString();
        this.clubLevel = data.readShort();
        this.rank = data.readShort();
        this.totalFight = data.readInt();
        this.memberCount = data.readByte();
        this.masterId = data.readNumber();
        this.masterName = data.readString();
        this.autoInFightLevel = data.readByte()
    },
});
var ____1907 = ____591.extend({
    pageCount: 6,
    clubMemberNums: 35,
    totalClubCount: 0,
    clubList: null,
    ctor: function() {
        this._super();
        this.clubList = {}
    },
    init: function(bytes) {
        this.totalClubCount = bytes.readInt();
        var pageIndex = bytes.readShort();
        var len = bytes.readByte();
        var start = pageIndex * this.pageCount;
        var index = (pageIndex - 1) * this.pageCount + 1;
        for (var i = index; i < index + len; i++) {
            var info = new ____1906();
            info.init(bytes);
            this.clubList[i] = info
        }
        if (len > 0) {
            this.dispatchEvent(new ____590(____655.____661.club_list_update, this, start))
        }
    },
    ____61: function() {
        this.clubList = {};
        this.totalClubCount = 0
    },
});
var ____1908 = cc.Class.extend({
    userId: 0,
    serverId: 0,
    name: "",
    level: 0,
    gongxian: 0,
    fight: 0,
    onlineState: false,
    lastOnlineTime: 0,
    job: 0,
    vipLevel: 0,
    init: function(bytes) {
        this.serverId = bytes.readShort();
        this.userId = bytes.readNumber();
        this.name = bytes.readString();
        this.level = bytes.readShort();
        this.gongxian = bytes.readInt();
        this.fight = bytes.readInt();
        this.onlineState = bytes.readBoolean();
        this.lastOnlineTime = bytes.readInt();
        this.job = bytes.readByte();
        this.vipLevel = bytes.readByte()
    },
});
var ____1909 = ____591.extend({
    PLAYMUSIC: "isPlayMusic",
    SHOWPLAYER: "showOtherPlayer",
    TONGZHITYPES: null,
    TONGZHINAMES: null,
    isPlayMusic: true,
    showOtherPlayer: true,
    tongzhiList: null,
    ctor: function() {
        this._super();
        this.TONGZHITYPES = ["xiuxianzhilu", "personalBoss", "farmAward", "familyFight", "quanming", "tiangong"];
        this.TONGZHINAMES = [____654.yuyanbaoManager.getYuyanbao("____2274.text1"), ____654.yuyanbaoManager.getYuyanbao("____2274.text2"), ____654.yuyanbaoManager.getYuyanbao("____2274.text3"), ____654.yuyanbaoManager.getYuyanbao("____2274.text4"), ____654.yuyanbaoManager.getYuyanbao("____2274.text5"), ____654.yuyanbaoManager.getYuyanbao("____2274.text6")];
        this.initValues()
    },
    initValues: function() {
        this.isPlayMusic = this.readBoolValue(this.PLAYMUSIC, true);
        ____654.soundManager.setSoundMute(!this.isPlayMusic);
        ____654.soundManager.setMusicMute(!this.isPlayMusic);
        this.showOtherPlayer = this.readBoolValue(this.SHOWPLAYER, true);
        this.tongzhiList = [];
        for (var i = 0; i < this.TONGZHITYPES.length; i++) {
            this.tongzhiList.push(this.readBoolValue(this.TONGZHITYPES[i], true))
        }
    },
    readBoolValue: function(key, defaultValue) {
        var value = this.readValue(key);
        if (value == "" || value == null) return defaultValue;
        return value == "true"
    },
    changeSet: function(key, value) {
        if (key == this.PLAYMUSIC) {
            this.isPlayMusic = value;
            ____654.soundManager.setSoundMute(!value);
            ____654.soundManager.setMusicMute(!value)
        } else if (key == this.SHOWPLAYER) {
            this.showOtherPlayer = value;
            ____654.____672.dispatchEvent(new ____590(____655.____661.setting_showPlayerChange, ____654.____672, null))
        } else {
            var index = this.TONGZHITYPES.indexOf(key);
            this.tongzhiList[index] = value;
            ____654.____672.dispatchEvent(new ____590(____655.____661.setting_tongzhiChange, ____654.____672, index))
        }
        this.saveValue(key, value)
    },
    saveValue: function(key, value) {
        ____654.sdk.writeKV(key, value.toString())
    },
    readValue: function(key) {
        return ____654.sdk.readKV(key)
    },
});
var ____484 = cc.Class.extend({
    id: 0,
    value: 0,
    percent: -1,
});
var RandomNameInfo = ____591.extend({
    _xingList: null,
    _ming1List: null,
    _ming2List: null,
    initData: function(datas) {
        this._xingList = [];
        this._ming1List = [];
        this._ming2List = [];
        datas.readInt();
        var str = datas.readIntString();
        if (str != "" && str != null) {
            this._xingList = str.split(",")
        }
        str = datas.readIntString();
        if (str != "" && str != null) {
            this._ming1List = str.split(",")
        }
        str = datas.readIntString();
        if (str != "" && str != null) {
            this._ming2List = str.split(",")
        }
    },
    getName: function(career) {
        var name = "";
        name += this._xingList[Math.floor(Math.random() * this._xingList.length)];
        if (career == 1) {
            name += this._ming1List[Math.floor(Math.random() * this._ming1List.length)]
        } else {
            name += this._ming2List[Math.floor(Math.random() * this._ming2List.length)]
        }
        return name
    },
});
var ReturnGiftInfo = cc.Class.extend({
    lastTimeOnLine: 0,
    backTime: 0,
    isLeftGetAward: 0,
    isRightGetAward: 0,
    init: function(bytes) {
        this.lastTimeOnLine = bytes.readInt();
        this.backTime = bytes.readInt();
        this.isLeftGetAward = bytes.readUByte();
        this.isRightGetAward = bytes.readUByte()
    },
    ____61: function() {
        this.lastTimeOnLine = 0;
        this.backTime = 0;
        this.isLeftGetAward = 0;
        this.isRightGetAward = 0
    },
});
var RollPropertyInfo = cc.Class.extend({
    place: 0,
    id: 0,
    value: -1,
    star: 0,
    quality: 0,
    getClone: function() {
        var rollPro = new RollPropertyInfo();
        rollPro.place = this.place;
        rollPro.id = this.id;
        rollPro.value = this.value;
        rollPro.star = this.star;
        rollPro.quality = this.quality;
        return rollPro
    },
});
var ServerItem = cc.Class.extend({
    id: 0,
    title: null,
    state: 0,
    msg: null,
    isPay: false,
    area: null,
    ip: null,
    port: 0,
    lowValue: 0,
    selfRankPos: 0,
    totalRank: 0,
    ctor: function(data, area) {
        this.area = area;
        if (!!data) this.parse(data)
    },
    parse: function(data) {
        this.id = data.sid;
        this.title = data.tt;
        this.msg = data.msg;
        if (!this.msg || this.msg.length == 0) {
            this.msg = this.area.msg
        }
        if (cc.isUndefined(data.st) || data.st == "0") {
            this.state = this.area.state
        } else {
            this.state = parseInt(data.st || "0")
        }
        if (cc.isUndefined(data.p)) {
            this.isPay = this.area.isPay
        } else {
            this.isPay = (data.p == "1")
        }
        var strIP = data.ip;
        if (!!strIP && strIP.length > 0) {
            var arrIP = strIP.split(":");
            if (!!arrIP && arrIP.length == 2) {
                this.ip = arrIP[0];
                this.port = parseInt(arrIP[1])
            }
        }
    },
    name: function() {
        return this.area.name + this.title + "服"
    },
    stateName: function() {
        switch (this.state) {
            case 0:
                return ""
        }
        return ""
    },
    getAreaId: function() {
        return this.area.id
    },
    getIPPortUrl: function() {
        return this.area.url.format(this.id)
    },
    getIPPort: function(cb) {
        if (!!this.ip && !!this.port) {
            if (!!cb) cb(this.ip, this.port)
        } else {
            var this_ = this;
            ____654.____677.loadRemoteTxt(this.getIPPortUrl(), function(loader) {
                var data = loader.data;
                print("#getIPPort", data);
                if (!!data && data != "") {
                    var json = JSON.parse(data || "{}");
                    this_.ip = json.ip || null;
                    this_.port = json.port || 0;
                    this_.selfRankPos = json.position || 0;
                    this_.totalRank = json.num || 0;
                    this_.lowValue = json.low || 0;
                    if (!!cb) cb(this_.ip, this_.port)
                } else {
                    print("#getIPPort ERR", data)
                }
            })
        }
    }
});
var ServerArea = cc.Class.extend({
    id: 0,
    state: 0,
    url: null,
    name: null,
    msg: null,
    isPay: false,
    list: null,
    ctor: function(data) {
        this.list = [];
        if (!!data) {
            this.parse(data)
        }
    },
    parse: function(data) {
        var ai = data.ai,
            sl = data.sl;
        this.state = parseInt(ai.st);
        this.url = ai.pre + "{0}" + ai.suf;
        this.name = ai.name;
        this.msg = ai.msg;
        this.isPay = ai.p == "1";
        if (sl instanceof Array) {
            for (var k in sl) {
                this.____104(sl[k])
            }
        } else {
            this.____104(sl)
        }
    },
    ____104: function(server) {
        var id = server.sid,
            info = this.____238(id);
        if (!info) {
            info = new ServerItem(null, this);
            this.list.push(info)
        }
        info.parse(server)
    },
    ____238: function(id) {
        if (id == 0) return null;
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].id == id) return this.list[i]
        }
        return null
    }
});
var ____493 = ____591.extend({
    userName: "",
    userId: 0,
    ip: "",
    port: 0,
    time: 0,
    sign: "",
    cm: "",
    accessToken: null,
    orderMD5Type: 0,
    agentId: 0,
    isLogined: false,
    lastServer: null,
    rs: -999,
    msg: "未登录",
    serverId: 0,
    serverName: null,
    roleList: null,
    isImei: 0,
    serverList: null,
    ____1064: null,
    _isLoaded: false,
    dataComplete: false,
    ctor: function() {
        this._super();
        this.isLogined = false;
        this.roleList = [];
        this.serverList = [];
        this.lastServer = []
    },
    isLoaded: function() {
        return this._isLoaded
    },
    parseUserInfo: function(data) {
        this.time = data.time;
        this.sign = data.sign;
        this.userName = data.un;
        this.agentId = data.aid || 0;
        this.isImei = parseInt(data.im);
        this.orderMD5Type = parseInt(data.md);
        this.accessToken = data.access_token;
        this.dataComplete = true;
        this.parseServerList(data, false);
        this.setCurrent(this.getLastServer());
        ____655.gameConfig.setAgentId(this.agentId);
        ____654.sdk.sendAccessToken()
    },
    parseServerList: function(data, isLoaded) {
        var asl = data.asl;
        this.lastServer = data.ls || [];
        this.____1064 = null;
        for (var aid in asl) {
            var area = this.getServerArea(aid);
            area.parse(asl[aid])
        }
        if (!this._isLoaded) this._isLoaded = isLoaded
    },
    getServerArea: function(areaId) {
        for (var i = 0; i < this.serverList.length; i++) {
            if (this.serverList[i].id == areaId) {
                return this.serverList[i]
            }
        }
        var info = new ServerArea();
        this.serverList.push(info);
        info.id = areaId;
        return info
    },
    ____238: function(areaId, id, force) {
        var force = force || false,
            ret = null;
        if (areaId > 0 && id > 0) {
            for (var i = 0; i < this.serverList.length; i++) {
                if (this.serverList[i].id == areaId) {
                    ret = this.serverList[i].____238(id);
                    if (!!ret) return ret
                }
            }
        }
        if (!!force) return null;
        return this.getNewServerList(1)[0]
    },
    getNewServerList: function(count) {
        var ret = [],
            infoCount = 0,
            info = null,
            stateLis = [1, 3, 2, 4, 5];
        for (var j = 0; j < stateLis.length; j++) {
            var state = stateLis[j];
            for (var k = this.serverList.length - 1; k >= 0; k--) {
                var serverList = this.serverList[k].list;
                for (var i = 0; i < serverList.length; i++) {
                    if (serverList[i].state == state) {
                        ret.push(serverList[i]);
                        infoCount++;
                        if (infoCount >= count) return ret
                    }
                }
            }
        }
        return ret
    },
    setCurrent: function(serverInfo) {
        this.____1064 = serverInfo;
        ____654.____672.dispatchEvent(new ____590(____655.____661.start_selectServer, ____654.____672))
    },
    getCurrent: function() {
        if (!this.____1064) {
            this.____1064 = this.getNewServerList(1)[0]
        }
        return this.____1064
    },
    getLastServer: function() {
        if (!!this.lastServer && this.lastServer.length > 0) {
            var lastInfo = this.lastServer[0];
            return this.____238(lastInfo.aid, lastInfo.sid, true)
        }
        return this.getNewServerList(1)[0]
    },
    uploadLastServer: function() {
        if (____655.gameConfig.isNoSdkOrTestSdk()) return;
        var server = this.getCurrent(),
            url = ____655.gameConfig.lastServerUrl.format(this.userName, server.id, server.getAreaId());
        print("#lastServer url", url);
        ____654.____677.loadRemoteTxt(url, function() {
            print("#最后服务器上报回调")
        })
    },
    getShortAccount: function() {
        if (!____655.gameConfig.isNoSdkOrTestSdk()) {
            var userName = this.userName;
            if (userName != null && userName != "") {
                var strList = userName.split("_");
                var shortAccount = ""
                for (var i = 1; i < strList.length; i++) {
                    shortAccount += strList[i];
                    if (i != strList.length - 1) {
                        shortAccount += "_"
                    }
                }
                return shortAccount
            }
        }
        return ""
    },
    clearAllView: function() {
        this.dispatchEvent(new ____590(____655.____661.start_clearAllView, this, null))
    },
    ____62: function(roleList) {
        this.roleList = roleList;
        this.dispatchEvent(new ____590(____655.____661.____699, this, null))
    },
    ____61: function() {
        this.isLogined = false;
        this.roleList = [];
        this.serverList = [];
        this.lastServer = [];
        this.userName = "";
        this.userId = 0;
        this.ip = "";
        this.port = 0;
        this.time = 0;
        this.sign = "";
        this.cm = "";
        this.accessToken = null;
        this.orderMD5Type = 0;
        this.agentId = 0;
        this.rs = -999;
        this.msg = "未登录";
        this.serverId = 0;
        this.serverName = null;
        this.isImei = 0;
        this.____1064 = null;
        this._isLoaded = false;
        this.dataComplete = false
    },
});
var ____494 = cc.Class.extend({
    userId: 0,
    level: 0,
    userName: "",
    nickName: "",
    serverId: 0,
    career: 0,
    xianwei: 0,
    getSex: function() {
        return this.career == 1
    },
});
var ____1916 = cc.Class.extend({
    copyId: 0,
    currentEnterCount: 0,
    lastRevertTime: 0,
    maxMission: 0,
    todayMaxMission: 0,
    resetNum: -1,
    init: function(id, data) {
        this.copyId = id;
        this.currentEnterCount = data.readInt();
        this.lastRevertTime = data.readInt();
        this.maxMission = data.readInt();
        this.todayMaxMission = data.readInt();
        print("更新数据-----@@@", this.copyId, this.currentEnterCount, this.copyId, this.maxMission, this.todayMaxMission)
    },
});
var ____1917 = ____591.extend({
    onlineAward_time: 0,
    onlineAward_items: null,
    statCopyList: null,
    statShopItemList: null,
    vipGetAwardList: null,
    returnGiftInfo: null,
    kuozhanGiftState: 0,
    welcomeState: null,
    mobaiCount: 0,
    ctor: function() {
        this._super();
        this.statCopyList = {};
        this.statShopItemList = {};
        this.onlineAward_items = [];
        this.vipGetAwardList = {};
        this.returnGiftInfo = new ReturnGiftInfo()
    },
    setWelcomeState: function(data) {
        this.welcomeState = data.readUByte()
    },
    onlineAwardUpdate: function(data) {
        this.onlineAward_time = data.readInt();
        this.onlineAward_items = [];
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            this.onlineAward_items.push([data.readInt(), data.readInt(), data.readUByte(), data.readUByte()])
        }
        this.dispatchEvent(new ____590(____655.____661.stat_online_update, this, null))
    },
    addShopItem: function(shopItemId, count) {
        var isAdd = false;
        var statShopItem = this.getShopItem(shopItemId);
        if (statShopItem == null) {
            statShopItem = new ____1918(shopItemId);
            this.statShopItemList[shopItemId] = statShopItem;
            isAdd = true
        }
        statShopItem.init(count);
        return isAdd
    },
    getShopItem: function(shopItemId) {
        return this.statShopItemList[shopItemId]
    },
    shopItemListUpdate: function(shopItemIdList) {
        this.dispatchEvent(new ____590(____655.____661.stat_shopList_update, this, shopItemIdList))
    },
    initCopyList: function(bytes) {
        var len = bytes.readInt();
        print("副本统计数据更新", len);
        for (var i = 0; i < len; i++) {
            var copyId = bytes.readInt();
            var info = this.statCopyList[copyId];
            if (info == null) {
                info = new ____1916();
                this.statCopyList[copyId] = info
            }
            info.init(copyId, bytes)
        }
        this.dispatchEvent(new ____590(____655.____661.stat_copyStat_update, this, null))
    },
    addCopyEnterCount: function(id, count) {
        var info = this.getCopyInfo(id);
        if (info.currentEnterCount == 0) {
            if (____655.allTemplates.copyTemplateList.WORLDBOSSPERSON_IDLIST.indexOf(id) != -1) {
                info.lastRevertTime = ____655.____662.getSystemTimeSec() + ____655.allTemplates.copyTemplateList.COPYPERSONBOSSREST_CD
            } else if (id == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
                info.lastRevertTime = ____655.____662.getSystemTimeSec() + ____655.allTemplates.copyTemplateList.COPYXIUXIANRESET_CD
            }
        }
        info.currentEnterCount += count;
        this.dispatchEvent(new ____590(____655.____661.stat_copyEnter_update, this, id))
    },
    setCopyEnterCount: function(id, count, time) {
        print("副本进入次数重设@@@@@@@@@@", id, count, time);
        var info = this.getCopyInfo(id);
        info.currentEnterCount = count;
        info.lastRevertTime = time;
        this.dispatchEvent(new ____590(____655.____661.stat_copyEnter_update, this, id))
    },
    setCopyReset: function(id, resetNum) {
        print("副本重置次数剩余@@@@@@@@@@", id, resetNum);
        var info = this.getCopyInfo(id);
        info.resetNum = resetNum;
        this.dispatchEvent(new ____590(____655.____661.stat_copyReset_update, this, id))
    },
    setCopyMission: function(id, max, day) {
        print("最高关卡改变@@@@@@@@@@", id, max, day);
        var info = this.getCopyInfo(id);
        info.maxMission = max;
        info.todayMaxMission = day;
        this.dispatchEvent(new ____590(____655.____661.stat_copyMission_update, this, id))
    },
    getCopyInfo: function(copyId) {
        var info = this.statCopyList[copyId];
        if (info == null) {
            info = new ____1916();
            this.statCopyList[copyId] = info;
            info.copyId = copyId
        }
        return info
    },
    getVipAwardInfo: function(bytes) {
        var len = bytes.readUByte();
        for (var i = 0; i < len; i++) {
            var id = bytes.readShort();
            this.vipGetAwardList[id] = true
        }
        this.dispatchEvent(new ____590(____655.____661.vip_awardUpdate, this, null))
    },
    getReturnGiftInfo: function(bytes) {
        this.returnGiftInfo.init(bytes);
        this.dispatchEvent(new ____590(____655.____661.returnGiftInfo, this, null))
    },
    setKuozhanGiftInfo: function(state) {
        if (this.kuozhanGiftState == state) {
            return
        }
        this.kuozhanGiftState = state;
        ____654.____672.dispatchEvent(new ____590(____655.____661.kuozhanUpdate, ____654.____672, null))
    },
    ____61: function() {
        this.onlineAward_time = 0;
        this.onlineAward_items = [];
        this.statCopyList = {};
        if (this.statShopItemList != null) {
            for (var i in this.statShopItemList) {
                if (this.statShopItemList[i] != null) {
                    this.statShopItemList[i].dispose()
                }
            }
        }
        this.statShopItemList = {};
        this.vipGetAwardList = {};
        this.returnGiftInfo.____61();
        this.kuozhanGiftState = 0;
        this.mobaiCount = 0;
        this.welcomeState = null
    },
});
var ____1918 = ____591.extend({
    shopItemId: 0,
    hasBuyCount: 0,
    template: null,
    ctor: function(shopItemId) {
        this._super();
        this.shopItemId = shopItemId;
        this.template = ____655.allTemplates.shopTemplateList.getShopItem(this.shopItemId)
    },
    init: function(count) {
        if (this.hasBuyCount == count) return;
        this.hasBuyCount = count;
        this.dispatchEvent(new ____590(____655.____661.stat_shopItem_update, this, null))
    },
    canBuy: function() {
        if (this.template.limitBuyCount == null) return false;
        if (this.hasBuyCount >= this.template.limitBuyCount) return false;
        if (this.template.needLevel > ____655.____667.level) return false;
        return true
    },
});
var ____485 = ____591.extend({
    ____1656: 0,
    ____971: 0,
    ____1712: 0,
    ____1487: -1,
    ____1888: 0,
    secondsOfDay: 86400,
    millSecOfDay: 86400000,
    start: function() {
        ____654.____678.____298(this.tick, this);
        if (this.____1712 == 0) {
            this.____1712 = new Date().getTime()
        }
    },
    tick: function(delta, tickCount) {
        this.____971 = this.____1656 + (new Date().getTime() - this.____1712)
    },
    getSystemTime: function() {
        return this.____971
    },
    getSystemTimeSec: function() {
        return Math.floor(this.getSystemTime() / 1000)
    },
    ____42: function(time) {
        this.____1656 = time * 1000;
        this.____1712 = new Date().getTime();
        this.____971 = this.____1656;
        this.start();
        var hour = Math.floor((this.getSystemTimeSec() + this.____1888) / 3600);
        if (this.____1487 < hour) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.global_hourUpdate, ____654.____672, hour));
            this.____1487 = hour;
            if (hour % 24 == 0) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.global_dayUpdate, ____654.____672, null))
            }
        }
    },
    ____43: function(timeZone) {
        this.____1888 = timeZone * 3600
    },
    getClientDate: function() {
        return this.getDate(this.____971)
    },
    getDate: function(time) {
        var date = new Date();
        date.setTime(time);
        return date
    },
    getBetweenTimeDay: function(startTime, endTime) {
        var start = Math.floor((startTime - this.____1888) / this.secondsOfDay);
        var end = Math.floor((endTime - this.____1888) / this.secondsOfDay);
        return end - start
    },
    singleToDouble: function(value) {
        if (value > 9) {
            return value.toString()
        }
        return "0" + value.toString()
    },
    getZeroPassTime: function(second) {
        if (second == null) {
            second = this.getSystemTimeSec()
        }
        return (second + this.____1888) % this.secondsOfDay
    },
    secondsToDateString: function(seconds) {
        var hour = Math.floor(seconds / 3600);
        var min = Math.floor(seconds / 60) % 60;
        var sec = seconds % 60;
        return this.singleToDouble(hour) + ":" + this.singleToDouble(min) + ":" + this.singleToDouble(sec)
    },
    secondsToDateString2: function(seconds) {
        var min = this.singleToDouble(Math.floor(seconds / 60));
        var sec = this.singleToDouble(seconds % 60);
        return ____654.yuyanbaoManager.getYuyanbao("common.timeTips2", min, sec)
    },
    secondsToDateString3: function(seconds) {
        var hour = Math.floor(seconds / 3600);
        var min = Math.floor(seconds / 60) % 60;
        return this.singleToDouble(hour) + ":" + this.singleToDouble(min)
    },
    secondsToDateString4: function(seconds) {
        var hour = Math.floor(seconds / 60);
        var min = seconds % 60;
        return this.singleToDouble(hour) + ":" + this.singleToDouble(min)
    },
    secondsToDateString5: function(seconds) {
        var hour = Math.floor(seconds / 3600);
        var min = Math.floor(seconds / 60) % 60;
        var secc = seconds % 60;
        var res = "";
        if (hour > 0) {
            res += ____654.yuyanbaoManager.getYuyanbao("common.timeTips4", hour)
        }
        if (min > 0) {
            res += ____654.yuyanbaoManager.getYuyanbao("common.timeTips5", min)
        }
        if (secc > 0) {
            res += ____654.yuyanbaoManager.getYuyanbao("common.timeTips3", secc)
        }
        return res
    },
    getTimesByDay: function(day) {
        var openZeroTime = ____655.____665 - (____655.____665 - this.____1888) % this.secondsOfDay;
        return (day - 1) * this.secondsOfDay + openZeroTime + this.____1888
    },
    getOpenDayByCurrentTime: function() {
        var ____665 = ____655.____665;
        var systemTime = this.getSystemTimeSec();
        var openDay = Math.ceil((systemTime - ____665) / this.secondsOfDay);
        return openDay
    },
    getDayByCreatRoleTime: function() {
        var createZoreTime = ____655.____667.createRoleTime * 0.001 - ((____655.____667.createRoleTime * 0.001 + this.____1888) % this.secondsOfDay);
        var openDay = parseInt(Math.abs(this.getSystemTimeSec() - createZoreTime) / 60 / 60 / 24) + 1;
        return openDay
    },
    dateToString: function(date) {
        return date.getFullYear().toString() + this.singleToDouble(date.getMonth() + 1) + this.singleToDouble(date.getDate())
    },
});
var TipStoneInfo = cc.Class.extend({
    stoneLevel: 1,
    openLevel: 0,
    stoneType: -1,
    template: null,
});
var TipStoneInfoList = cc.Class.extend({
    playerLevel: null,
    stoneList: null,
    ctor: function(level) {
        this.playerLevel = level;
        this.stoneList = []
    },
});
var ____1920 = ____591.extend({
    ____1438: null,
    ____958: null,
    ____1878: null,
    _numberCodeList: null,
    initData: function(datas) {
        this.____1438 = [];
        this.____958 = [];
        this.____1878 = [];
        this._numberCodeList = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "零", "一", "二", "三", "四", "五", "六", "七", "八", "九", "十", "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖", "拾"];
        datas.readInt();
        var str = datas.readIntString();
        if (str != "" && str != null) {
            this.____1438 = str.split(",")
        }
        str = datas.readIntString();
        if (str != "" && str != null) {
            this.____958 = str.split(",")
        }
        str = datas.readIntString();
        var tempList = str.split(",");
        var len = tempList.length;
        for (var i = 0; i < len; i++) {
            this.____1878.push(tempList[i].split("-"))
        }
    },
    getStringLen: function(str) {
        var result = 0;
        var len = str.length;
        for (var i = 0; i < len; i++) {
            var temp = str.charCodeAt(i);
            if (temp > 127 || temp == 94) {
                result++
            }
        }
        return result + len
    },
    checkName: function(name) {
        if (this.checkNumber(name)) {
            var len = this.____1438.length;
            var i = 0;
            for (i = 0; i < len; i++) {
                if (name.indexOf(this.____1438[i]) >= 0) {
                    return false
                }
            }
            return this.checkChat(name)
        }
        return false
    },
    checkChat: function(chat) {
        var len = this.____958.length;
        var i = 0;
        for (i = 0; i < len; i++) {
            if (chat.indexOf(this.____958[i]) >= 0) {
                return false
            }
        }
        len = chat.length;
        for (i = 0; i < len; i++) {
            if (!this.checkWord(chat.charCodeAt(i))) {
                return false
            }
        }
        return true
    },
    filtChat: function(chat) {
        chat = chat.replace(/\n/g, "");
        chat = chat.replace(/ /g, "");
        if (chat.length == 0) {
            return ""
        }
        var len = chat.length;
        var i = 0;
        for (i = 0; i < len; i++) {
            if (!this.checkWord(chat.charCodeAt(i))) {
                return null
            }
        }
        len = this.____958.length;
        for (i = 0; i < len; i++) {
            var reg = new RegExp(this.____958[i], "g");
            chat = chat.replace(reg, "*")
        }
        return chat
    },
    checkWord: function(code) {
        var len = this.____1878.length;
        for (var i = 0; i < len; i++) {
            var filter = this.____1878[i];
            if (filter.length > 1) {
                if (code >= filter[0] && code <= filter[1]) {
                    return false
                }
            } else {
                if (code == filter[0]) {
                    return false
                }
            }
        }
        return true
    },
    checkNumber: function(content) {
        var len = content.length;
        var i = 0;
        var count = 0;
        var max = 0;
        for (i = 0; i < len; i++) {
            var code = content.charAt(i);
            if (this._numberCodeList.indexOf(code) >= 0) {
                count++;
                if (count > max) {
                    max = count
                }
            } else {
                count = 0
            }
        }
        if (max >= 4) {
            return false
        }
        return true
    },
});
var ____1921 = ____591.extend({
    copyId: 0,
    missionId: 0,
    copyTemplateInfo: null,
    leftTime: 0,
    totalTime: 0,
    leftMonster: 0,
    totalMonster: 0,
    currentWave: 0,
    totalWave: 0,
    exp: 0,
    copper: 0,
    boxAcceptState: null,
    ctor: function(copyId) {
        this._super();
        this.copyId = copyId;
        this.copyTemplateInfo = ____655.allTemplates.copyTemplateList.getCopy(copyId);
        this.boxAcceptState = {}
    },
    updateMonster: function(leftMonster, totalMonster) {
        if (leftMonster != null) {
            this.leftMonster = leftMonster
        }
        if (totalMonster != null) {
            this.totalMonster = totalMonster
        }
        this.dispatchEvent(new ____590(____655.____661.copy_monsterUpdate, this, null))
    },
    updateWave: function(currentWave, totalWave) {
        if (currentWave != null) {
            this.currentWave = currentWave
        }
        if (totalWave != null) {
            this.totalWave = totalWave
        }
        this.dispatchEvent(new ____590(____655.____661.copy_waveUpdate, this, null))
    },
    updateTime: function(leftTime, totalTime) {
        if (leftTime != null) {
            this.leftTime = leftTime
        }
        if (totalTime != null) {
            this.totalTime = totalTime
        }
        this.dispatchEvent(new ____590(____655.____661.copy_timeUpdate, this, null))
    },
    setAwardInfo: function(data) {
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            data.readInt();
            data.readByte()
        }
        len = data.readByte();
        if (len == 0) {
            this.boxAcceptState = {}
        }
        for (var j = 0; j < len; j++) {
            var awardId = data.readShort();
            this.boxAcceptState[awardId] = true
        }
    },
    reset: function() {
        this.leftTime = 0;
        this.totalTime = 0;
        this.leftMonster = 0;
        this.totalMonster = 0;
        this.currentWave = 0;
        this.totalWave = 0;
        this.boxAcceptState = {}
    },
    clear: function() {
        this.leftTime = 0;
        this.totalTime = 0;
        this.leftMonster = 0;
        this.totalMonster = 0;
        this.currentWave = 0;
        this.totalWave = 0;
        this.boxAcceptState = {}
    },
});
var CopyInfo = ____591.extend({
    currentId: 0,
    lastId: 0,
    currentCopyInfo: null,
    copyInfoList: null,
    worldBossInfo: null,
    ctor: function() {
        this._super();
        this.copyInfoList = {};
        this.worldBossInfo = new ____1925()
    },
    setCopyId: function(copyId, missionId) {
        this.currentId = copyId;
        this.currentCopyInfo = this.getCopyInfo(copyId);
        this.currentCopyInfo.reset();
        this.currentCopyInfo.missionId = missionId
    },
    getCopyInfo: function(copyId) {
        var info = this.copyInfoList[copyId];
        if (info == null) {
            info = this.createCopyInfo(copyId)
        }
        this.copyInfoList[copyId] = info;
        return info
    },
    createCopyInfo: function(copyId) {
        var info = null;
        if (copyId == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
            info = new ____1924(copyId)
        } else if (copyId == ____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID) {
            info = new ____1923(copyId)
        } else if (copyId == ____655.allTemplates.copyTemplateList.SHOUHU_COPYID) {
            info = new TeamCopyInfo(copyId)
        } else {
            info = new ____1921(copyId)
        }
        return info
    },
    setCopyAwardState: function(copyId, data) {
        var info = this.getCopyInfo(copyId);
        if (info == null) {
            return
        }
        info.setAwardInfo(data);
        this.dispatchEvent(new ____590(____655.____661.copy_awardStateUpdate, this, copyId))
    },
    sweepComplate: function(sweepCopyInfo) {
        this.dispatchEvent(new ____590(____655.____661.copy_sweepComplate, this, sweepCopyInfo))
    },
    clearCopyId: function() {
        if (this.currentCopyInfo != null) {
            this.currentCopyInfo.clear()
        }
        this.currentId = -1;
        this.currentCopyInfo = null
    },
    ____61: function() {
        this.currentId = 0;
        this.lastId = 0;
        this.currentCopyInfo = null;
        if (this.copyInfoList != null) {
            for (var i in this.copyInfoList) {
                this.copyInfoList[i].dispose()
            }
        }
        this.worldBossInfo.____61();
        this.copyInfoList = {}
    },
});
var CopySweepInfo = cc.Class.extend({
    copyId: 0,
    missionId: 0,
    itemList: null,
    ctor: function() {
        this.itemList = []
    },
    init: function(data) {
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            this.itemList.push([data.readInt(), data.readInt(), data.readUByte(), data.readUByte()])
        }
        this.copyId = data.readInt();
        this.missionId = data.readInt()
    },
    dispose: function() {
        this.itemList = null
    },
});
var ____1923 = ____1921.extend({
    remainTime: 0,
    monsterId: 0,
    monsterMaxHp: 0,
    monsterCurHp: 0,
    damageRankList: null,
    bossIdList: null,
    ctor: function(copyId) {
        this._super(copyId);
        this.damageRankList = [];
        this.bossIdList = [901401, 901402, 901403]
    },
    setDamageRankInfo: function(data) {
        this.remainTime = data.readInt();
        this.monsterId = data.readInt();
        this.monsterMaxHp = data.readNumber();
        this.monsterCurHp = data.readNumber();
        this.damageRankList = [];
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var rank = data.readByte();
            var userId = data.readNumber();
            var nick = data.readString();
            var hurt = data.readNumber();
            this.damageRankList.push([rank, userId, nick, hurt])
        }
        this.dispatchEvent(new ____590(____655.____661.club_bossRankDamageUpdate, this, null))
    },
});
var ____1924 = ____1921.extend({
    starCount: 0,
    missionStarList: null,
    awardStarList: null,
    currentStar: 0,
    ctor: function(copyId) {
        this._super(copyId);
        this.missionStarList = {};
        this.awardStarList = {}
    },
    setAwardInfo: function(data) {
        this.starCount = 0;
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var missionId = data.readInt();
            var starCount = data.readByte();
            this.starCount += starCount;
            this.missionStarList[missionId] = starCount
        }
        len = data.readByte();
        if (len == 0) {
            this.awardStarList = {}
        } else {
            for (var j = 0; j < len; j++) {
                var awardId = data.readShort();
                this.awardStarList[awardId] = true
            }
        }
    },
    reset: function() {
        this._super();
        this.currentStar = 0
    },
});
var TeamCopyInfo = ____1921.extend({
    npcHp: 100,
    teamList: null,
    ctor: function(copyId) {
        this._super(copyId);
        this.teamList = []
    },
    setTeamInfo: function(data) {
        var len = data.readByte();
        if (len > 0) {
            this.teamList = [];
            for (var i = 0; i < len; i++) {
                var career = data.readByte();
                var level = data.readByte();
                var nick = data.readString();
                this.teamList.push([career, level, nick])
            }
            this.dispatchEvent(new ____590(____655.____661.copy_teamUpdate, this, null))
        }
    },
    setNpcHp: function(hp) {
        if (this.npcHp == hp) {
            return
        }
        this.npcHp = hp;
        this.dispatchEvent(new ____590(____655.____661.copy_npcHpUpdate, this, null))
    },
    reset: function() {
        this._super();
        this.npcHp = 100
    },
    clear: function() {
        this._super();
        this.teamList = []
    },
});
var ____1925 = ____1921.extend({
    monsterCurHp: 0,
    damageRankList: null,
    selfInfo: null,
    ctor: function(copyId) {
        this._super(copyId);
        this.damageRankList = [];
        this.selfInfo = []
    },
    setDamageRankInfo: function(data) {
        this.monsterCurHp = data.readNumber();
        this.damageRankList = [];
        var len1 = data.readByte();
        for (var i = 0; i < len1; i++) {
            var userId = data.readNumber();
            var nickName = data.readString();
            var hurtValue = data.readNumber();
            this.damageRankList.push([0, userId, nickName, hurtValue])
        }

        function sortHandler(info1, info2) {
            if (info2[3] == info1[3]) {
                return -1
            }
            return info2[3] - info1[3]
        }
        this.damageRankList.sort(sortHandler);
        this.dispatchEvent(new ____590(____655.____661.worldBoss_hurtUpdate, this, null))
    },
    setSelfDamageInfo: function(data) {
        this.selfInfo = [];
        var userId = data.readNumber();
        var hurt = data.readNumber();
        var nick = data.readString();
        var serverId = data.readShort();
        this.selfInfo.push([serverId, userId, nick, hurt]);
        this.dispatchEvent(new ____590(____655.____661.worldBossSelf_hurtUpdate, this, null))
    },
    ____61: function() {
        this.damageRankList = [];
        this.selfInfo = [];
        this.monsterCurHp = 0
    },
});
var ____1926 = ____591.extend({
    godWeaponlist: null,
    currentShenBin: null,
    GOD_WEAPON_TYPE: null,
    weaponSoulLevel: 0,
    stoneInfoList: null,
    weaponPotLevel: 0,
    weaponPotExp: 0,
    ctor: function() {
        this._super();
        this.godWeaponlist = {};
        this.GOD_WEAPON_TYPE = [1, 2, 3];
        this.stoneInfoList = {}
    },
    updateGodWeaponInfo: function(data) {
        this.currentShenBin = ____654.____685.setGodWeaponInfo(this.godWeaponlist, data);
        this.dispatchEvent(new ____590(____655.____661.weapon_godInfoUpdate, this, null))
    },
    updatePotInfo: function(level, exp) {
        this.weaponPotLevel = level;
        this.weaponPotExp = exp;
        this.dispatchEvent(new ____590(____655.____661.weapon_potInfoUpdate, this, null))
    },
    getGodWeaponInfoByType: function(type) {
        return this.godWeaponlist[type]
    },
    getUseGodWeaponType: function() {
        if (this.currentShenBin == null) {
            return -1
        }
        return this.currentShenBin.type
    },
    updateWeaponSoul: function(data) {
        this.weaponSoulLevel = data.readShort();
        print("武魂等级更新", this.weaponSoulLevel);
        this.dispatchEvent(new ____590(____655.____661.weapon_soulInfoUpdate, this, null))
    },
    updateStoneInfo: function(data) {
        print("宝石信息更新");
        ____654.____685.setStoneInfo(this.stoneInfoList, data);
        this.dispatchEvent(new ____590(____655.____661.weapon_stoneInfoUpdate, this, null))
    },
    getStoneExpByType: function(equipType, stoneType) {
        var exp = 0;
        if (this.stoneInfoList[equipType] != null && this.stoneInfoList[equipType][stoneType] != null) {
            exp = this.stoneInfoList[equipType][stoneType]
        }
        return exp
    },
    xilianResult: function(index) {
        this.dispatchEvent(new ____590(____655.____661.weapon_xilianResult, this, index))
    },
    getPotEquipList: function() {
        var list = ____655.itemInfoList.bagTypeList[2];
        var result1 = [];
        var count1 = 0;
        var potValue1 = 0;
        var result2 = [];
        var count2 = 0;
        var potValue2 = 0;
        var secondaryGoods = {};
        for (var i = 0; i < list.length; i++) {
            var info = list[i];
            var categoryId = info.template.categoryId;
            if (____655.____659.categoryType.isWaiXingEquip(categoryId)) {
                var placeInfo = ____655.____659.categoryType.getAdvanceEquipPlace(categoryId);
                var acvanceInfo = ____655.advanceItemList.getItemByType(placeInfo[0]);
                var mark = false;
                if (acvanceInfo != null) {
                    var acvanceEquipInfo = acvanceInfo.equipList[placeInfo[1]];
                    if (acvanceEquipInfo != null) {
                        if (info.getWaiXingFight() <= acvanceEquipInfo.getWaiXingFight()) {
                            result1.push([info.id, info.count]);
                            count1 += info.count;
                            potValue1 += (info.count * ____655.____659.categoryType.getWaiXingEquipRongLianByQuality(info.quality, info.qhLevel))
                        } else {
                            mark = true
                        }
                    } else {
                        mark = true
                    }
                } else {
                    mark = true
                }
                if (mark) {
                    if (secondaryGoods[info.template.templateId] == null) {
                        secondaryGoods[info.template.templateId] = []
                    }
                    secondaryGoods[info.template.templateId].push(info)
                }
            } else if (____655.____659.categoryType.isEquip(categoryId)) {
                var bodyEquip = ____655.itemInfoList.getBodyEquipByType(categoryId);
                if (bodyEquip != null) {
                    var equiQuality = info.____57();
                    var bodyQuality = bodyEquip.____57();
                    if (equiQuality == bodyQuality) {
                        result2.push([info.id, info.count]);
                        count2 += info.count;
                        potValue2 += (info.count * ____655.____659.categoryType.getRenWuEquipRongLianByQuality(info.____57()))
                    } else if (equiQuality < bodyQuality) {
                        result1.push([info.id, info.count]);
                        count1 += info.count;
                        potValue1 += (info.count * ____655.____659.categoryType.getRenWuEquipRongLianByQuality(info.____57()))
                    }
                }
            }
        }
        for (var key in secondaryGoods) {
            var hasThisStageTab = {};
            var goodsList = secondaryGoods[key];
            for (var i = 0; i < goodsList.length; i++) {
                var info = goodsList[i];
                if (hasThisStageTab[goodsList[i].quality]) {
                    result1.push([info, info.count]);
                    count1 += info.count;
                    potValue1 += (info.count * ____655.____659.categoryType.getWaiXingEquipRongLianByQuality(info.quality, info.qhLevel))
                } else {
                    hasThisStageTab[goodsList[i].quality] = true;
                    if (goodsList[i].count > 1) {
                        result1.push([info.id, info.count - 1]);
                        count1 += (info.count - 1);
                        potValue1 += ((info.count - 1) * ____655.____659.categoryType.getWaiXingEquipRongLianByQuality(info.quality, info.qhLevel))
                    }
                }
            }
        }
        return [
            [result1, count1, potValue1],
            [result2, count2, potValue2]
        ]
    },
    checkBodyCanQh: function() {
        var equipItemList = ____655.____659.categoryType.equipList;
        for (var i = 0; i < equipItemList.length; i++) {
            if (this.checkQHByCategoryType(equipItemList[i])) {
                return true
            }
        }
        return false
    },
    checkQHByCategoryType: function(categoryType) {
        var itemInfo = ____655.itemInfoList.getBodyEquipByType(categoryType);
        if (itemInfo != null) {
            var costTemplateInfo = ____655.allTemplates.strengthCostTemplateList.getCost(itemInfo.qhLevel + 1);
            if (costTemplateInfo != null) {
                if (!____655.____667.moneyInfo.moneyEnoughByType(3, costTemplateInfo.needCopper)) {
                    return false
                }
                for (var i = 0; i < costTemplateInfo.items.length; i++) {
                    var count = ____655.itemInfoList.getCountByTempId(costTemplateInfo.items[i][0]);
                    if (count < costTemplateInfo.items[i][1]) {
                        return false
                    }
                }
                return true
            } else {
                return false
            }
        } else {
            return false
        }
    },
    checkBodyStoneCanUpgrad: function() {
        var equipItemList = ____655.____659.categoryType.equipList;
        for (var i = 0; i < equipItemList.length; i++) {
            if (this.checkEquipStoneByCategoryType(equipItemList[i])) {
                return true
            }
        }
        return false
    },
    checkEquipStoneByCategoryType: function(categoryType) {
        var itemInfo = ____655.itemInfoList.getBodyEquipByType(categoryType);
        if (itemInfo != null) {
            var baoshiEquipTemplate = ____655.allTemplates.baoShiEquipTemplateList.getTemplateInfoByType(categoryType);
            for (var i = 0; i < baoshiEquipTemplate.baoshiList.length; i++) {
                var stoneType = baoshiEquipTemplate.baoshiList[i][0];
                var openLevel = baoshiEquipTemplate.baoshiList[i][1];
                if (____655.____667.level >= openLevel) {
                    var exp = this.getStoneExpByType(categoryType, stoneType);
                    if (this.checkStoneByTypeAndExp(stoneType, exp)) {
                        return true
                    }
                }
            }
            return false
        } else {
            return false
        }
    },
    checkStoneByTypeAndExp: function(stoneType, exp) {
        var nextTemplate = ____655.allTemplates.baoShiTemplateList.getNextTemplateByTypeAndExp(stoneType, exp);
        if (nextTemplate != null) {
            var needExp = nextTemplate.needExp - exp;
            var exp = 0;
            for (var i = 0; i < nextTemplate.itemList.length; i++) {
                var tempId = nextTemplate.itemList[i];
                var info = ____655.itemInfoList.getItemInfoByTempId(tempId);
                if (info != null && info.template != null) {
                    exp += (info.count * info.template.propertys[3]);
                    if (exp >= needExp) {
                        return true
                    }
                }
            }
            return false
        } else {
            return false
        }
    },
    ____61: function() {
        this.godWeaponlist = {};
        this.stoneInfoList = {};
        this.currentShenBin = null;
        this.weaponSoulLevel = 0;
        this.weaponPotLevel = 0;
        this.weaponPotExp = 0
    },
});
var WeaponGodInfo = cc.Class.extend({
    type: 0,
    level: 0,
    isUse: false,
});
var ____479 = cc.Class.extend({
    ____658: 44,
    sources: null,
    frameNameCache: null,
    logoutType: null,
    ____659: null,
    allTemplates: null,
    uiDataList: null,
    uiDataListII: null,
    ____662: null,
    kuozhanList: null,
    kuozhanIsComplate: false,
    ____661: null,
    wordFiltersInfo: null,
    randomNameInfo: null,
    faceInfo: null,
    ____663: null,
    statInfo: null,
    copyInfo: null,
    warDatas: null,
    rankInfo: null,
    clubInfo: null,
    clubItemList: null,
    skillItemList: null,
    ____670: null,
    itemInfoList: null,
    titleList: null,
    mailItemList: null,
    ____668: null,
    ____669: null,
    activityInfo: null,
    activityIconList: null,
    bossItemList: null,
    fashionInfo: null,
    advanceItemList: null,
    gameConfig: null,
    gameSetting: null,
    furnaceInfo: null,
    welfareInfo: null,
    familyTreasuresInfo: null,
    feiXianInfo: null,
    particleInfoList: null,
    serverName: null,
    homeInfo: null,
    openInfo: null,
    ____656: 0,
    ____657: 0,
    BROAD_WIDTH: 500,
    BROAD_HEIGHT: 300,
    GRID_SIZE: 40,
    MAP_TILE_SIZE: 512,
    areaTag: -1,
    commonCD: 800,
    monsterDeadRemoveCount: 60,
    speedOffset: 20,
    petFollowDistance: 130,
    petFollowMaxDistance: 180,
    pickupRadius: 1000,
    afkRadius: 400,
    currentMapId: -1,
    currentMapPath: "",
    currentMapDataPath: "",
    preMapId: 0,
    preMapPath: "",
    preMapDataPath: "",
    ____667: null,
    lookInfo: null,
    defaultFontName: "Microsoft YaHei",
    createRole: false,
    ____665: 0,
    padWalkRadian: 0,
    touchWalkValue: 1000,
    guideCopyId: 0,
    chatPanelFlag: false,
    isShowGetTip: true,
    isLogout: false,
    isCanVoice: true,
    lowValue: 0,
    selfRankPos: 0,
    totalRank: 0,
    showProtocolNum: false,
    yaoqingTime: 0,
    isYaoqing: false,
    testUI: false,
    init: function(gameConfig) {
        this.gameConfig = gameConfig;
        this.____659 = new ____1944();
        this.allTemplates = new ____513();
        this.uiDataListII = new UIDataListII();
        this.____661 = new ____510();
        this.____662 = new ____485();
        this.statInfo = new ____1917();
        this.copyInfo = new CopyInfo();
        this.warDatas = new ____2305();
        this.rankInfo = new RankInfo();
        this.clubInfo = new ClubInfo();
        this.clubItemList = new ____1907();
        this.skillItemList = new ____2051();
        this.____670 = new ____529();
        this.itemInfoList = new ____2026();
        this.titleList = new ____2059();
        this.mailItemList = new ____1928();
        this.____668 = new FriendList();
        this.activityInfo = new ActivityInfo();
        this.activityIconList = new ____1899();
        this.fashionInfo = new FashionInfo();
        this.advanceItemList = new ____1974();
        this.bossItemList = new ____1986();
        this.furnaceInfo = new ____1926();
        this.familyTreasuresInfo = new FamilyTreasuresInfo();
        this.feiXianInfo = new FeiXianInfo();
        this.marryOathInfo = new MarryOathInfo();
        this.particleInfoList = new ParticleInfoList();
        this.____656 = cc.winSize.width;
        this.____657 = cc.winSize.height;
        this.homeInfo = new HomeInfo();
        this.____663 = new ____493();
        this.dailyFirstRechargeInfo = new DailyFirstRechargeInfo();
        this.frameNameCache = {}
    },
    needLoadExtSource: function() {
        if (____655.gameConfig.plusList == null) return false;
        if (this.kuozhanList == null) return true;
        if (this.kuozhanList.length == 0) return false;
        return !this.kuozhanIsComplate
    },
    getAlert: function(type, text, showType, time, executor, callback1, callback2, title) {
        return new Alert()
    },
    templateComplete: function() {
        this.skillItemList.templateComplete()
    },
    isShenHe: function() {
        if (____655.gameConfig.shenHeBigVersion == null) {
            return false
        }
        return ____655.gameConfig.shenHeBigVersion.indexOf(____655.gameConfig.bigVersion) >= 0
    },
    ____61: function() {
        this.logoutType = null;
        this.statInfo.____61();
        this.copyInfo.____61();
        this.warDatas.____61();
        this.rankInfo.____61();
        this.clubInfo.____61();
        this.clubItemList.____61();
        this.skillItemList.____61();
        this.____670.____61();
        this.itemInfoList.____61();
        this.titleList.____61();
        this.mailItemList.____61();
        this.____668.____61();
        this.____669.____61();
        this.activityInfo.____61();
        this.activityIconList.____61();
        this.bossItemList.____61();
        this.fashionInfo.____61();
        this.advanceItemList.____61();
        this.furnaceInfo.____61();
        this.welfareInfo.____61();
        this.familyTreasuresInfo.____61();
        this.marryOathInfo.____61();
        this.homeInfo.____61();
        this.openInfo.____61();
        this.dailyFirstRechargeInfo.____61();
        this.guideCopyId = 0;
        this.chatPanelFlag = false;
        this.isShowGetTip = true;
        if (this.____667 != null) {
            this.____667.____61()
        }
        if (this.lookInfo != null) {
            this.lookInfo.____61()
        }
        this.yaoqingTime = 0;
        this.isYaoqing = false
    },
});
var HomeFriendInfo = cc.Class.extend({
    userId: 0,
    nick: "",
    career: 0,
    homeLevel: 0,
    homeExp: 0,
    landAmount: 0,
    landQuality: 0,
    waterTime: 0,
    seedTime: 0,
    seedId: 0,
    caressTime: 0,
    caressNum: 0,
    homePet: 0,
    feedNum: 0,
    helpFeed: 0,
    ohterHelpFeedCount: 0,
    stealCount: 0,
    STEAL_TIME: 10800,
    getCanWater: function() {
        if (this.seedId > 0) {
            var time = ____655.____662.getSystemTimeSec();
            var tempInfo = ____655.allTemplates.seedTemplateList.getInfoById(this.seedId);
            if (this.seedTime + tempInfo.ripeTime > time && this.waterTime + tempInfo.target.waterTime < time) {
                return true
            }
        }
        return false
    },
    getCanSteal: function() {
        if (this.seedId > 0 && this.stealCount < ____655.allTemplates.homeTemplateList.MAX_CAN_STEAL) {
            var time = ____655.____662.getSystemTimeSec();
            var tempInfo = ____655.allTemplates.seedTemplateList.getInfoById(this.seedId);
            var stealTime = ____655.homeInfo.stealList[this.userId] || 0;
            if (this.seedTime + tempInfo.ripeTime <= time && time - stealTime > this.STEAL_TIME) {
                return true
            }
        }
        return false
    },
    getCanFeed: function() {
        if (this.caressNum >= ____655.allTemplates.homeTemplateList.MAX_CARESS_COUNT) {
            if (____655.homeInfo.helpFeed < ____655.allTemplates.homePetTemplateList.MAX_HELP_FEED && this.ohterHelpFeedCount < ____655.allTemplates.homeTemplateList.MAX_OTHER_HELP_FEED) {
                return !____655.homeInfo.helpFeedList[this.userId]
            } else {
                return false
            }
        } else {
            if (____655.homeInfo.helpCaressNum < ____655.allTemplates.homePetTemplateList.MAX_HELP_CARESS) {
                return !____655.homeInfo.caressList[this.userId]
            } else {
                return false
            }
        }
    },
    getSortWeight: function() {
        var res = 0;
        if (this.getCanWater()) {
            res += 1
        }
        if (this.getCanSteal()) {
            res += 1
        }
        if (this.getCanFeed()) {
            res += 1
        }
        return res
    },
    getTipWeight: function() {
        if (____655.homeInfo.helpCount < ____655.allTemplates.homeTemplateList.MAX_WATER && this.getCanWater()) {
            return 1
        }
        if (____655.homeInfo.stealCount < ____655.allTemplates.homeTemplateList.MAX_STEAL && this.getCanSteal()) {
            return 1
        }
        if (this.getCanFeed()) {
            return 1
        }
        return 0
    },
});
var HomeInfo = ____591.extend({
    homeLevel: 0,
    homeExp: 0,
    landAmount: 0,
    landQuality: 0,
    waterTime: 0,
    seedTime: 0,
    seedId: 0,
    caressTime: 0,
    caressNum: 0,
    helpCaressNum: 0,
    homePet: 0,
    feedNum: 0,
    helpFeed: 0,
    huntType: 0,
    huntTime: 0,
    huntCount: 0,
    ohterHelpFeedCount: 0,
    plantCount: 0,
    helpCount: 0,
    stealCount: 0,
    itemList: null,
    stealList: null,
    caressList: null,
    helpFeedList: null,
    friendInfoList: null,
    friendInfoTab: null,
    liandanRewardList: null,
    addExp: 0,
    awardType: -1,
    friendReflashCount: 0,
    ctor: function() {
        this._super();
        this.itemList = {};
        this.stealList = {};
        this.caressList = {};
        this.helpFeedList = {};
        this.friendInfoList = [];
        this.friendInfoTab = {}
    },
    updateHomeInfo: function(bytes) {
        this.homeLevel = bytes.readShort();
        this.homeExp = bytes.readInt();
        this.landAmount = bytes.readShort();
        this.landQuality = bytes.readByte();
        this.waterTime = bytes.readInt();
        this.seedTime = bytes.readInt();
        this.seedId = bytes.readInt();
        var len = bytes.readByte();
        this.itemList = {};
        for (var i = 0; i < len; i++) {
            var tempId = bytes.readInt();
            var count = bytes.readInt();
            this.itemList[tempId] = count
        }
        len = bytes.readByte();
        this.stealList = {};
        for (var i = 0; i < len; i++) {
            this.stealList[bytes.readNumber()] = bytes.readNumber()
        }
        this.plantCount = bytes.readByte();
        this.helpCount = bytes.readByte();
        this.stealCount = bytes.readByte();
        this.caressTime = bytes.readInt();
        this.caressNum = bytes.readByte();
        this.helpCaressNum = bytes.readByte();
        len = bytes.readByte();
        this.caressList = {};
        for (var i = 0; i < len; i++) {
            this.caressList[bytes.readNumber()] = true
        }
        this.homePet = bytes.readByte();
        this.feedNum = bytes.readInt();
        this.helpFeed = bytes.readByte();
        len = bytes.readByte();
        this.helpFeedList = {};
        for (var i = 0; i < len; i++) {
            this.helpFeedList[bytes.readNumber()] = true
        }
        this.ohterHelpFeedCount = bytes.readByte();
        this.huntType = bytes.readByte();
        this.huntTime = bytes.readInt();
        this.huntCount = bytes.readByte();
        this.dispatchEvent(new ____590(____655.____661.home_infoUpdate, this, null));
        this.friendInfoSort()
    },
    updatePersonHomeInfo: function(bytes) {
        this.friendInfoList = [];
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var userId = bytes.readNumber();
            var info = this.friendInfoTab[userId];
            if (!info) {
                info = new HomeFriendInfo();
                this.friendInfoTab[userId] = info;
                info.userId = userId
            }
            info.nick = bytes.readString();
            info.career = bytes.readByte();
            info.homeLevel = bytes.readByte();
            info.landAmount = bytes.readByte();
            info.landQuality = bytes.readByte();
            info.homeExp = bytes.readInt();
            info.seedId = bytes.readInt();
            info.seedTime = bytes.readInt();
            info.waterTime = bytes.readInt();
            info.stealCount = bytes.readByte();
            info.caressTime = bytes.readInt();
            info.caressNum = bytes.readByte();
            info.homePet = bytes.readByte();
            info.feedNum = bytes.readInt();
            info.helpFeed = bytes.readByte();
            info.ohterHelpFeedCount = bytes.readByte()
        }
        for (var k in this.friendInfoTab) {
            this.friendInfoList.push(this.friendInfoTab[k].userId)
        }
        this.friendInfoSort()
    },
    friendDelete: function(bytes) {
        var userId = bytes.readNumber();
        delete this.friendInfoTab[userId];
        this.friendInfoList = [];
        for (var k in this.friendInfoTab) {
            this.friendInfoList.push(this.friendInfoTab[k].userId)
        }
        this.friendInfoSort()
    },
    friendInfoSort: function(isNow) {
        if (this.friendInfoList != null && this.friendInfoList.length > 1) {
            var this_ = this;

            function sortHandler(userId1, userId2) {
                var info1 = this_.friendInfoTab[userId1];
                var info2 = this_.friendInfoTab[userId2];
                if (info1 == null || info2 == null) {
                    return -1
                }
                var weight1 = info1.getSortWeight();
                var weight2 = info2.getSortWeight();
                if (weight1 != weight2) {
                    return weight2 - weight1
                } else {
                    return info2.homeExp - info1.homeExp
                }
            }
            this.friendInfoList.sort(sortHandler)
        }
        if (!!isNow) {
            ____654.____678.____299(this.____241, this);
            this.friendReflashCount = 0;
            this.dispatchEvent(new ____590(____655.____661.home_friendInfoUpdate, this, null))
        } else if (this.friendReflashCount <= 0) {
            this.friendReflashCount = 30;
            ____654.____678.____298(this.____241, this)
        }
    },
    ____241: function() {
        this.friendReflashCount--;
        if (this.friendReflashCount <= 0) {
            this.dispatchEvent(new ____590(____655.____661.home_friendInfoUpdate, this, null));
            ____654.____678.____299(this.____241, this)
        }
    },
    getCanJinjie: function() {
        var curTemplate = ____655.allTemplates.homeJinjieTemplateList.getInfoByQuality(this.landQuality);
        var nexTemplate = ____655.allTemplates.homeJinjieTemplateList.getInfoByQuality(this.landQuality + 1);
        if (!!nexTemplate && nexTemplate.needHomeLevel <= this.homeLevel) {
            var list = curTemplate.metarialList;
            if (!!list && list.length > 0) {
                for (var i = 0; i < list.length; i++) {
                    var count = this.itemList[list[i][0]] || 0;
                    if (count < list[i][1]) {
                        return false
                    }
                }
                return true
            } else {
                return false
            }
        }
        return false
    },
    getHomeTip: function() {
        if (____655.____667.level < ____655.____659.levelType.homeLevel) {
            return false
        }
        if (this.seedId > 0) {
            var time = ____655.____662.getSystemTimeSec();
            var tempInfo = ____655.allTemplates.seedTemplateList.getInfoById(this.seedId);
            if (this.seedTime + tempInfo.ripeTime <= time) {
                return true
            }
            if (this.waterTime + tempInfo.target.waterTime < time) {
                return true
            }
        } else if (____655.allTemplates.homeTemplateList.MAX_FLANT - this.plantCount > 0) {
            return true
        }
        var res = this.getLianDanTip();
        if (res) {
            return true
        }
        res = this.getCanJinjie();
        if (res) {
            return true
        }
        res = this.getPetTip();
        if (res) {
            return true
        }
        return this.getFriendTip()
    },
    getPetTip: function() {
        if (this.caressNum < ____655.allTemplates.homeTemplateList.MAX_CARESS_COUNT) {
            return Math.floor((____655.____662.getSystemTimeSec() - ____655.____665) / ____655.____662.secondsOfDay) > Math.floor((this.caressTime - ____655.____665) / ____655.____662.secondsOfDay)
        } else {
            var foodCount = ____655.itemInfoList.getCountByTempId(____655.allTemplates.homePetTemplateList.FOOD_TEMPLATE_ID);
            if (foodCount > 0) {
                return true
            }
            if (this.homeLevel >= 2) {
                if (this.huntType > 0) {
                    var time = ____655.____662.getSystemTimeSec();
                    var needTime = this.huntTime - time;
                    return needTime <= 0
                } else {
                    var count = ____655.allTemplates.homeTemplateList.MAX_HUNT - this.huntCount;
                    return count > 0
                }
            }
        }
        return false
    },
    getLianDanTip: function() {
        var list = ____655.allTemplates.homeTemplateList.LIANDAN_MATERAL_LIST;
        var countList = [];
        var itemList = ____655.itemInfoList.list;
        for (var k in itemList) {
            var info = itemList[k];
            if (!!info) {
                for (var i = 0; i < list.length; i++) {
                    if (list[i] == info.templateId) {
                        if (!countList[i]) {
                            countList[i] = 0
                        }
                        countList[i] += info.count;
                        if (countList[i] >= ____655.allTemplates.homeTemplateList.LIANDAN_MATERAL_COUNT) {
                            return true
                        }
                        break
                    }
                }
            }
        }
        return false
    },
    getFriendTip: function() {
        if (this.friendInfoList != null && this.friendInfoList.length > 0) {
            for (var i = 0; i < this.friendInfoList.length; i++) {
                var info = this.friendInfoTab[this.friendInfoList[i]];
                if (!!info && info.getTipWeight() > 0) {
                    return true
                }
            }
        }
        return false
    },
    updateLianDanReward: function(bytes) {
        this.liandanRewardList = [];
        this.awardType = bytes.readByte();
        this.addExp = bytes.readInt();
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var item = new LianDanRewardItemInfo();
            item.templateId = bytes.readInt();
            item.count = bytes.readInt();
            this.liandanRewardList.push(item)
        }
        this.dispatchEvent(new ____590(____655.____661.home_LianDanReward, this, null))
    },
    ____61: function() {
        ____654.____678.____299(this.____241, this);
        this.friendInfoList = [];
        this.friendInfoTab = {};
        this.friendInfoList = {};
        this.plantCount = 0;
        this.helpCount = 0;
        this.stealCount = 0;
        this.homeLevel = 0;
        this.homeExp = 0;
        this.landAmount = 0;
        this.landQuality = 0;
        this.waterTime = 0;
        this.seedTime = 0;
        this.seedId = 0;
        this.caressTime = 0;
        this.caressNum = 0;
        this.helpCaressNum = 0;
        this.homePet = 0;
        this.feedNum = 0;
        this.helpFeed = 0;
        this.huntType = 0;
        this.huntTime = 0;
        this.huntCount = 0;
        this.ohterHelpFeedCount = 0;
        this.itemList = {};
        this.stealList = {};
        this.caressList = {};
        this.helpFeedList = {};
        this.friendInfoList = [];
        this.friendInfoTab = {};
        this.liandanRewardList = [];
        this.awardType = -1;
        this.addExp = 0;
        this.friendReflashCount = 0
    },
});
var LianDanRewardItemInfo = cc.Class.extend({
    templateId: 0,
    count: 0,
});
var LookInfo = cc.Class.extend({
    playerInfo: null,
    equipList: null,
    skillList: null,
    stoneInfoList: null,
    godWeaponlist: null,
    currentShenBin: null,
    advanceItemList: null,
    fashionList: null,
    baoShiFight: 0,
    wuHunLevel: 0,
    rongLuLevel: 0,
    huanZhuangFight: 0,
    tujianFight: 0,
    liLianLevel: 0,
    xinFaLevel: 0,
    xinFaFight: 0,
    marryName: "",
    oathNamelist: null,
    lookType: 0,
    panelType: 0,
    initDataFinish1: false,
    initDataFinish2: false,
    initDataFinish3: false,
    ctor: function() {
        this.playerInfo = new ____498();
        this.advanceItemList = new ____1974();
        this.equipList = [];
        this.skillList = {};
        this.stoneInfoList = {};
        this.godWeaponlist = {};
        this.fashionList = {};
        this.oathNamelist = []
    },
    initData: function(data) {
        this.____61();
        this.playerInfo.userId = data.readNumber(data);
        ____654.____685.____190(this.playerInfo, data);
        var len = data.readUByte();
        var i = 0;
        for (i = 0; i < len; i++) {
            var item = new ItemInfo();
            item.id = i;
            ____654.____685.setItem(item, data);
            this.equipList.push(item)
        }
        len = data.readUByte();
        for (i = 0; i < len; i++) {
            var skillId = data.readInt();
            this.skillList[skillId] = data.readShort()
        }
        var isHas = data.readUByte();
        if (isHas == 1) {
            ____654.____685.setStoneInfo(this.stoneInfoList, data)
        }
        isHas = data.readUByte();
        if (isHas == 1) {
            this.currentShenBin = ____654.____685.setGodWeaponInfo(this.godWeaponlist, data)
        }
        this.marryName = data.readString();
        len = data.readByte();
        for (var i = 0; i < len; i++) {
            var pos = data.readByte();
            var brotherName = data.readString();
            this.oathNamelist.push(brotherName)
        }
        this.initDataFinish1 = true
    },
    advanceFashionInitData: function(data) {
        this.advanceItemList.init(data);
        isHas = data.readUByte();
        if (isHas == 1) {
            this.advanceItemList.petInit(data)
        }
        isHas = data.readUByte();
        if (isHas == 1) {
            this.advanceItemList.addEquipList(data)
        }
        this.advanceItemList.soulLevelUpdate(data);
        this.advanceItemList.soulLevelUpdate(data);
        len = data.readUByte();
        for (i = 0; i < len; i++) {
            var type = data.readShort();
            if (this.fashionList[type] == null) {
                this.fashionList[type] = new ____2008(type)
            }
            this.fashionList[type].init(data)
        }
        this.initDataFinish2 = true
    },
    compareInitData: function(data) {
        this.baoShiFight = data.readInt();
        isHas = data.readUByte();
        if (isHas == 1) {
            this.wuHunLevel = data.readShort()
        }
        isHas = data.readUByte();
        if (isHas == 1) {
            this.rongLuLevel = data.readShort()
        }
        this.huanZhuangFight = data.readInt();
        this.tujianFight = data.readInt();
        isHas = data.readUByte();
        if (isHas == 1) {
            this.liLianLevel = data.readShort()
        }
        isHas = data.readUByte();
        if (isHas == 1) {
            this.xinFaLevel = data.readShort();
            this.xinFaFight = data.readInt()
        }
        this.initDataFinish3 = true
    },
    getGodWeaponInfoByType: function(type) {
        return this.godWeaponlist[type]
    },
    getBodyEquipByType: function(categoryId) {
        for (var i = 0; i < this.equipList.length; i++) {
            if (this.equipList[i].template.categoryId == categoryId) {
                return this.equipList[i]
            }
        }
        return null
    },
    getFashion: function(type) {
        return this.fashionList[type]
    },
    getFashionInfo: function(type, templateId) {
        var fashion = this.fashionList[type];
        if (fashion == null) return null;
        return fashion.huaxingList[templateId]
    },
    getStoneExpByType: function(equipType, stoneType) {
        var exp = 0;
        if (this.stoneInfoList[equipType] != null && this.stoneInfoList[equipType][stoneType] != null) {
            exp = this.stoneInfoList[equipType][stoneType]
        }
        return exp
    },
    getUseGodWeaponType: function() {
        if (this.currentShenBin == null) {
            return -1
        }
        return this.currentShenBin.type
    },
    getSkillLevel: function(id) {
        if (this.skillList[id] == null) {
            return 0
        }
        return this.skillList[id].level
    },
    openLastPanel: function() {
        if (____655.lookInfo.panelType == 2) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 2)
        } else if (____655.lookInfo.panelType == 3) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 3)
        } else if (____655.lookInfo.panelType == 4) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 4)
        } else if (____655.lookInfo.panelType == 5) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 5)
        } else if (____655.lookInfo.panelType == 6) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 6)
        } else if (____655.lookInfo.panelType == 7) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 7)
        } else if (____655.lookInfo.panelType == 8) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 8)
        } else if (____655.lookInfo.panelType == 9) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 9)
        } else if (____655.lookInfo.panelType == 10) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 10)
        } else if (____655.lookInfo.panelType == 11) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, 11)
        } else if (____655.lookInfo.panelType == 13) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_club, 2)
        }
        ____655.lookInfo.panelType = 0
    },
    addFriend: function() {
        if (____655.____659.levelType.shejiaoLevel > ____655.____667.level) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2238.text3", ____655.____659.levelType.shejiaoLevel));
            return
        }
        if (____655.____659.levelType.shejiaoLevel > this.playerInfo.level) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2088.text2", ____655.____659.levelType.shejiaoLevel));
            return
        }
        if (____655.____668.getFriend(this.playerInfo.userId) != null) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2238.text2"));
            return
        }
        if (____655.____667.vipLevel <= 1 && ____655.____667.level <= 55 && this.playerInfo.vipLevel >= 2) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2103.text2"))
        } else {
            ____654.selfDataMessageSender.sendAddFriend(this.playerInfo.serverId, this.playerInfo.nick, 0)
        }
    },
    ____61: function() {
        this.playerInfo.____61();
        for (var i = 0; i < this.equipList.length; i++) {
            this.equipList[i].dispose()
        }
        this.equipList = [];
        this.skillList = {};
        this.stoneInfoList = {};
        this.godWeaponlist = {};
        this.currentShenBin = null;
        this.advanceItemList.____61();
        for (var j in this.fashionList) {
            if (this.fashionList[j] != null) this.fashionList[j].dispose()
        }
        this.fashionList = {};
        this.baoShiFight = 0;
        this.wuHunLevel = 0;
        this.rongLuLevel = 0;
        this.huanZhuangFight = 0;
        this.tujianFight = 0;
        this.liLianLevel = 0;
        this.xinFaLevel = 0;
        this.xinFaFight = 0;
        this.marryName = "";
        this.oathNamelist = []
    },
});
var ____492 = cc.Class.extend({
    id: 0,
    fromServerId: 0,
    fromId: 0,
    fromNick: "",
    title: "",
    content: "",
    read: false,
    money0: 0,
    money1: 0,
    money2: 0,
    items: null,
    type: 0,
    sendDate: 0,
    fetchState: 0,
    validDate: 0,
    leftDay: 0,
    itemCount: 0,
    init: function(data) {
        this.fromServerId = data.readUShort();
        this.fromId = data.readNumber();
        this.fromNick = data.readString();
        this.title = data.readString();
        this.content = data.readString();
        this.sendDate = data.readInt();
        this.read = data.readBoolean();
        this.money2 = data.readInt();
        this.money0 = data.readInt();
        this.money1 = data.readInt();
        this.fetchState = data.readUByte();
        this.type = data.readUByte();
        this.validDate = data.readInt();
        this.itemCount = data.readUByte();
        this.items = [];
        for (var i = 0; i < this.itemCount; i++) {
            var item = new ItemInfo();
            ____654.____685.setItem(item, data);
            this.items.push(item)
        }
        if (this.money0 > 0) {
            var money0Item = new ItemInfo();
            money0Item.____107(____655.allTemplates.____794.money0Item);
            money0Item.count = this.money0;
            this.items.push(money0Item)
        }
        if (this.money1 > 0) {
            var money1Item = new ItemInfo();
            money1Item.____107(____655.allTemplates.____794.money1Item);
            money1Item.count = this.money1;
            this.items.push(money1Item)
        }
        if (this.money2 > 0) {
            var money2Item = new ItemInfo();
            money2Item.____107(____655.allTemplates.____794.money2Item);
            money2Item.count = this.money2;
            this.items.push(money2Item)
        }
        this.leftDay = this.validDate / 24 - ____655.____662.getBetweenTimeDay(this.sendDate, ____655.____662.getSystemTimeSec())
    },
    hasItemReceive: function() {
        if (this.items.length == 0 && this.money0 == 0 && this.money1 == 0 && this.money2 == 0) return false;
        return this.fetchState == 0
    },
    setFetchFlag: function(value) {
        if (this.fetchState == value) return;
        this.fetchState = value;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_mailFetchUpdate, ____654.____672, this.id));
        ____655.mailItemList.updateMailCount()
    },
    setRead: function(value) {
        if (this.read == value) return;
        this.read = value;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_mailReadUpdate, ____654.____672, this.id));
        ____655.mailItemList.updateMailCount()
    },
    dispose: function() {
        for (var i = 0; i < this.items.length; i++) {
            this.items[i].dispose()
        }
        this.items = []
    },
});
var ____1928 = ____591.extend({
    mailList: null,
    ____1367: 0,
    ctor: function() {
        this._super();
        this.mailList = []
    },
    addMail: function(mailInfo) {
        this.mailList.push(mailInfo)
    },
    ____59: function(id) {
        var index = -1;
        for (var i = 0; i < this.mailList.length; i++) {
            if (this.mailList[i].id == id) {
                index = i;
                break
            }
        }
        if (index != -1) {
            this.dispatchEvent(new ____590(____655.____661.common_mailDelete, this, id));
            this.mailList[index].dispose();
            this.mailList.splice(index, 1)
        }
    },
    getMail: function(id) {
        for (var i = 0; i < this.mailList.length; i++) {
            if (this.mailList[i].id == id) return this.mailList[i]
        }
        return null
    },
    sortAndDispatch: function() {
        function sortFunc(m1, m2) {
            if (m1.read == m2.read) {
                if (m1.sendDate == m2.sendDate) {
                    return m2.id - m1.id
                }
                return m2.sendDate - m1.sendDate
            }
            if (m1.read) {
                return 1
            } else {
                return -1
            }
        }
        this.mailList.sort(sortFunc);
        this.dispatchEvent(new ____590(____655.____661.common_mailListUpdate, this, null));
        this.updateMailCount()
    },
    getUnreadOrAttachCount: function() {
        var c = 0;
        for (var i = 0; i < this.mailList.length; i++) {
            var mail = this.mailList[i];
            if (!mail.read || mail.hasItemReceive()) c++
        }
        return c
    },
    updateMailCount: function() {
        this.____1367 = 60;
        ____654.____678.____298(this.mailUpdateTick, this)
    },
    mailUpdateTick: function(delta, count) {
        this.____1367--;
        if (this.____1367 <= 0) {
            this.____1367 = 0;
            ____654.____678.____299(this.mailUpdateTick, this);
            var mailCount = this.mailList.length;
            if (mailCount > 0) {
                this.dispatchEvent(new ____590(____655.____661.mainmenu_mailBtn, this, this.getUnreadOrAttachCount()))
            } else {
                this.dispatchEvent(new ____590(____655.____661.mainmenu_mailBtn, this, -1))
            }
        }
    },
    ____61: function() {
        for (var i = 0; i < this.mailList.length; i++) {
            this.mailList[i].dispose()
        }
        this.mailList = []
    },
});
var MarryOathInfo = ____591.extend({
    marryId: 0,
    marryName: "",
    marryType: 0,
    marryLevel: 0,
    oathPos: 0,
    oathType: 0,
    oathLevel: 0,
    oathBrotherList: null,
    ctor: function() {
        this._super();
        this.oathBrotherList = {}
    },
    marryInfoUpate: function(data) {
        this.marryId = data.readNumber();
        this.marryName = data.readString();
        this.marryType = data.readByte();
        this.marryLevel = data.readShort();
        this.dispatchEvent(new ____590(____655.____661.marry_infoUpdate, this, null))
    },
    oathInfoUpdate: function(data) {
        var pos = data.readByte();
        if (pos != this.oathPos) {
            ____654.marryOathMessageSender.sendGetBrotherInfo()
        }
        this.oathPos = pos;
        this.oathType = data.readByte();
        this.oathLevel = data.readShort();
        this.dispatchEvent(new ____590(____655.____661.oath_infoUpdate, this, null))
    },
    brotherInfoUpdate: function(data) {
        this.clearBrothersInfo();
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var brotherInfo = new OathBrotherInfo();
            brotherInfo.initData(data);
            this.oathBrotherList[brotherInfo.pos] = brotherInfo
        }
        this.dispatchEvent(new ____590(____655.____661.oath_brotherInfoUpdate, this, null))
    },
    clearBrothersInfo: function() {
        for (var pos in this.oathBrotherList) {
            if (this.oathBrotherList[pos] != null) {
                this.oathBrotherList[pos].dispose()
            }
        }
        this.oathBrotherList = {}
    },
    getBrotherTitle: function(career, pos) {
        if (career == 1) {
            if (pos == 1) {
                return "大哥"
            } else if (pos == 2) {
                return "二哥"
            } else if (pos == 3) {
                return "三弟"
            }
        } else if (career == 2) {
            if (pos == 1) {
                return "大姐"
            } else if (pos == 2) {
                return "二姐"
            } else if (pos == 3) {
                return "三妹"
            }
        } else {
            return ""
        }
    },
    ____61: function() {
        this.marryId = 0;
        this.marryName = "";
        this.marryType = 0;
        this.marryLevel = 0;
        this.oathPos = 0;
        this.oathType = 0;
        this.oathLevel = 0;
        this.clearBrothersInfo()
    },
});
var OathBrotherInfo = cc.Class.extend({
    userId: 0,
    nick: "",
    pos: 0,
    career: 0,
    online: 0,
    brotherTitle: "",
    initData: function(data) {
        this.userId = data.readNumber();
        this.pos = data.readByte();
        this.career = data.readByte();
        this.online = data.readByte();
        this.nick = data.readString();
        this.brotherTitle = ____655.marryOathInfo.getBrotherTitle(this.career, this.pos)
    },
    dispose: function() {
        this.userId = null;
        this.nick = null;
        this.pos = null;
        this.career = null;
        this.online = null;
        this.brotherTitle = null
    },
});
var DailyFirstRechargeInfo = ____591.extend({
    record: null,
    ctor: function() {
        this._super();
        this.record = {}
    },
    infoUpdate: function(data) {
        this.record = {};
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var weekDay = data.readByte();
            this.record[weekDay] = [];
            this.record[weekDay].push(data.readShort());
            this.record[weekDay].push(data.readShort());
            this.record[weekDay].push(data.readShort());
            this.record[weekDay].push(data.readShort());
        }
        this.dispatchEvent(new ____590(____655.____661.dailyRechargeInfoUpdate))
    },
    getRecordTimes: function(day, index) {
        if (this.record[day] != null) {
            return this.record[day][index]
        }
        return 1
    },
    ____61: function() {
        this.record = {}
    },
});
var CharacterInfo = ____591.extend({
    ____1732: null,
    ____1089: null,
    ____1691: 0,
    _roleHeight: 0,
    _figure: null,
    ctor: function(sourceType, anima) {
        this.____1691 = sourceType;
        this.____1089 = anima;
        this._super()
    },
    ____74: function() {
        return this.____1089
    },
    getAnima: function(animaType) {
        if (animaType == ____655.____659.____687.stand) {
            if (this.isNpcStyle()) {
                return ____655.____659.____687.npcStand
            } else if (this.isMonsterStyle()) {
                if (!!this.figure) {
                    if (this.isMonsterFigure()) {
                        return ____655.____659.____687.monsterStand
                    } else if (this.isPetFigure()) {
                        return ____655.____659.____687.petStand
                    }
                }
                return ____655.____659.____687.monsterStand
            }
        } else if (animaType == ____655.____659.____687.walk) {
            if (this.isMonsterStyle()) {
                if (!!this.figure) {
                    if (this.isMonsterFigure()) {
                        return ____655.____659.____687.monsterWalk
                    } else if (this.isPetFigure()) {
                        return ____655.____659.____687.petWalk
                    }
                }
                return ____655.____659.____687.monsterWalk
            }
        } else if (animaType == ____655.____659.____687.attack) {
            if (this.isMonsterStyle()) {
                if (!!this.figure) {
                    if (this.isMonsterFigure()) {
                        return ____655.____659.____687.monsterAttack
                    } else if (this.isPetFigure()) {
                        return ____655.____659.____687.petAttack
                    }
                }
                return ____655.____659.____687.monsterAttack
            }
        }
        return animaType
    },
    isNpcStyle: function() {
        return this.____1691 == ____655.____659.commonStaticType.style_npc
    },
    isMonsterStyle: function() {
        return this.____1691 == ____655.____659.commonStaticType.style_monster
    },
    isMonsterFigure: function() {
        return !!this.figure && this.figure.frameType == ____655.allTemplates.figureTemplateList.monsterFigure
    },
    isPetFigure: function() {
        return !!this.figure && this.figure.frameType == ____655.allTemplates.figureTemplateList.petFigure
    },
    getFigureHeight: function() {
        return this._roleHeight
    },
    needReload: function(currentAnima, anima) {
        if (currentAnima == null) return true;
        return this.checkNeedReload(currentAnima, anima)
    },
    checkNeedReload: function(currentAnima, anima) {
        return false
    },
    getLayerCount: function() {
        return 1
    },
    getOrders: function() {
        return [0]
    },
    getStyleList: function() {
        return this.____1732
    },
    getSourceType: function() {
        return this.____1691
    },
    ____73: function(picPath, animaId) {
        return this.doGetSourceTypeValue(this.getSourceType(), picPath, animaId)
    },
    doGetSourceTypeValue: function(type, picPath, animaId) {
        if (type == ____655.____659.commonStaticType.style_monster || type == ____655.____659.commonStaticType.style_Pet) {
            return "{0}_{1}_{2}_".format("8", picPath, animaId)
        } else if (type == ____655.____659.commonStaticType.style_npc) {
            return "{0}_{1}_".format("3", picPath)
        } else if (type == ____655.____659.commonStaticType.style_player || type == ____655.____659.commonStaticType.style_Horse || type == ____655.____659.commonStaticType.style_Weapon || type == ____655.____659.commonStaticType.style_Wind || type == ____655.____659.commonStaticType.style_Cloth) {
            return "{0}_{1}_{2}_".format("1", picPath, animaId)
        }
    },
    updateStyle: function(style) {
        if (____654.____674.dicEquote(this.____1732, style)) return;
        this.____1732 = style;
        this.reflesh()
    },
    reflesh: function() {
        this.dispatchEvent(new ____590(____655.____661.playerInfo_styleReload, this, null))
    },
    ____72: function(anima) {
        var paths = [],
            fullpaths = [];
        var tmpPicPath = "";
        var id = 0;
        this._roleHeight = 135;
        id = this.____1732[this.____1691];
        if (id <= 0) {
            paths.push(null);
            fullpaths.push(null);
            this.figure = null
        } else {
            var figure = ____655.allTemplates.figureTemplateList.getFigure(id);
            tmpPicPath = figure.____27();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(figure.getType(), tmpPicPath) + ".png");
            this.figure = figure;
            this._roleHeight = figure.getPicHeight()
        }
        return [paths, fullpaths]
    },
    dispose: function() {
        this.____1732 = null;
        this.____1089 = null;
        this._super()
    },
});
var ____498 = ____499.extend({
    maxHP: 0,
    currentHp: 0,
    attack: 0,
    defense: 0,
    propertys: null,
    ctor: function() {
        this._super();
        this.propertys = []
    },
    ____61: function() {
        this.propertys = [];
        this._super()
    },
    dispose: function() {
        this._super();
        this.propertys = null
    },
});
var FriendInfo = ____591.extend({
    online: 0,
    info: null,
    combat: 0,
    ctor: function() {
        this._super();
        this.info = new ____495()
    },
    init: function(data) {
        ____654.____685.____186(this.info, data);
        this.updateFriendState(data);
        this.setCombat(data);
        this.dispatchEvent(new ____590(____655.____661.common_friendInfoUpdate, this, null))
    },
    setCombat: function(data) {
        this.combat = data.readInt()
    },
    updateFriendState: function(data) {
        this.online = data.readUByte();
        this.dispatchEvent(new ____590(____655.____661.common_friendStateUpdate, this, null))
    },
    setId: function(value) {
        this.info.userId = value
    },
    getId: function() {
        return this.info.userId
    },
    dispose: function() {
        if (this.info != null) {
            this.info.dispose()
        }
        this.info = null;
        this._super()
    },
});
var FriendList = ____591.extend({
    maxCount: 35,
    list: null,
    tuiJianCount: 0,
    tuiJianList: null,
    responseList: null,
    ctor: function() {
        this._super();
        this.list = [];
        this.tuiJianList = [];
        this.responseList = []
    },
    addFriend: function(friend) {
        this.list.push(friend)
    },
    addFriendDispatch: function(userId) {
        this.dispatchEvent(new ____590(____655.____661.common_addFriend, this, userId))
    },
    removeFriend: function(id) {
        var index = -1;
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].info.userId == id) {
                index = i;
                break
            }
        }
        if (index != -1) {
            this.list[index].dispose();
            this.list.splice(index, 1)
        }
    },
    removeFriendDispatch: function(userId) {
        this.dispatchEvent(new ____590(____655.____661.common_deleteFriend, this, userId))
    },
    addResponseInfo: function(info) {
        for (var i = 0; i < this.responseList.length; i++) {
            if (this.responseList[i][0] == info[0]) {
                info = null;
                return
            }
        }
        this.responseList.push(info);
        this.doResponseDispatch(info)
    },
    clearResponseList: function() {
        this.responseList = [];
        this.doResponseDispatch()
    },
    doResponseDispatch: function(info) {
        this.dispatchEvent(new ____590(____655.____661.common_friendResponseUpdate, this, info))
    },
    setTuiJianCount: function(count) {
        this.tuiJianCount = count;
        this.dispatchEvent(new ____590(____655.____661.common_friendTJCountUpdate, this, null))
    },
    setTuiJianList: function(list) {
        this.tuiJianList = [];
        this.tuiJianList = list;
        this.dispatchEvent(new ____590(____655.____661.commom_friendTJListUpdate, this, null))
    },
    getFriend: function(id) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].info.userId == id) return this.list[i]
        }
        return null
    },
    sortAndDispatch: function() {
        function sortFunc(p1, p2) {
            if (p1.online == p2.online) {
                return p2.getId() - p1.getId()
            }
            return p2.online - p1.online
        }
        this.list.sort(sortFunc);
        this.dispatchEvent(new ____590(____655.____661.common_friendListUpdate, this, null))
    },
    getOnlineList: function(career) {
        var list = [];
        for (var i = 0; i < this.list.length; i++) {
            if (career != null) {
                if (this.list[i].online == 1 && this.list[i].info.career == career) {
                    list.push(this.list[i])
                }
            } else {
                if (this.list[i].online == 1) {
                    list.push(this.list[i])
                }
            }
        }
        return list
    },
    ____61: function() {
        for (var i = 0; i < this.list.length; i++) {
            var friend = this.list[i];
            if (friend != null) {
                friend.dispose()
            }
        }
        this.list = [];
        this.tuiJianCount = 0;
        this.tuiJianList = [];
        this.responseList = []
    },
});
var ____500 = ____591.extend({
    list: null,
    chongZhiScore: null,
    xiaoFeiScore: null,
    banggong: -1,
    ctor: function() {
        this._super();
        this.list = [-1, -1, -1, -1, -1, -1];
        this.chongZhiScore = {};
        this.xiaoFeiScore = {}
    },
    ____77: function(data) {
        var list = [data.readInt(), data.readInt(), data.readInt(), data.readInt(), data.readInt(), data.readInt()];
        if (this.list[0] >= 0 && list[0] > this.list[0]) {
            ____655.____669.appendSystemItem("获得[0xFFF100]" + (list[0] - this.list[0]) + "钻石[-]");
            ____654.commonTick.addGetItemEffect(____655.allTemplates.____794.money0Item, 1)
        }
        if (this.list[1] >= 0 && list[1] > this.list[1]) {
            ____655.____669.appendSystemItem("获得[0xFFF100]" + (list[1] - this.list[1]) + "绑定钻石[-]");
            ____654.commonTick.addGetItemEffect(____655.allTemplates.____794.money1Item, 1)
        }
        if (this.list[2] >= 0 && list[2] > this.list[2]) {
            ____655.____669.appendSystemItem("获得[0xFFF100]" + (list[2] - this.list[2]) + "铜币[-]");
            ____654.commonTick.addGetItemEffect(____655.allTemplates.____794.money2Item, 1)
        }
        if (this.list[5] >= 0 && list[5] > this.list[5]) {
            ____655.____669.appendSystemItem("获得[0xFFF100]" + (list[5] - this.list[5]) + "荣誉[-]")
        }
        this.list = list;
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            this.chongZhiScore[data.readByte()] = data.readInt()
        }
        len = data.readByte();
        for (var i = 0; i < len; i++) {
            this.xiaoFeiScore[data.readByte()] = data.readInt()
        }
        this.dispatchEvent(new ____590(____655.____661.____701))
    },
    setMoney6: function(value) {
        if (this.banggong == value) return;
        if (this.banggong >= 0 && value > this.banggong) {
            ____655.____669.appendSystemItem("获得[0xFFF100]" + (value - this.banggong) + "贡献[-]")
        }
        this.banggong = value;
        this.dispatchEvent(new ____590(____655.____661.____701))
    },
    moneyEnough: function(mlist) {
        if (mlist == null) return true;
        for (var i = 0; i < this.list.length; i++) {
            if (mlist[i] != null && this.list[i] < mlist[i]) return false
        }
        return true
    },
    money0Enough: function(money0) {
        return money0 <= this.list[0]
    },
    money1Enough: function(money1) {
        return money1 <= this.list[0] + this.list[1]
    },
    money2Enough: function(money2) {
        return money2 <= this.list[2]
    },
    moneyEnoughByType: function(type, money) {
        if (type == 1) {
            return money <= this.list[0]
        } else if (type == 2) {
            return money <= this.list[1]
        } else if (type == 3) {
            return money <= this.list[2]
        } else if (type == 4) {
            return money <= this.banggong
        } else if (type == 5) {
            return money <= this.list[0] + this.list[1]
        } else if (type == 6) {
            return money <= this.list[5]
        } else if (type == 8) {
            return false
        } else if (type == 9) {
            return money <= this.list[3]
        } else if (type == 10) {
            return money <= this.list[4]
        }
    },
    getMoneyCountByType: function(type) {
        if (type == 1) {
            return this.list[0]
        } else if (type == 2) {
            return this.list[1]
        } else if (type == 3) {
            return this.list[2]
        } else if (type == 4) {
            return this.banggong
        } else if (type == 6) {
            return this.list[5]
        } else if (type == 8) {
            return 0
        } else if (type == 9) {
            return this.list[3]
        } else if (type == 10) {
            return this.list[4]
        }
    },
    getMoneyNameByType: function(type) {
        if (type == 1) {
            return ____654.yuyanbaoManager.getYuyanbao("money.name1")
        } else if (type == 2) {
            return ____654.yuyanbaoManager.getYuyanbao("money.name2")
        } else if (type == 3) {
            return ____654.yuyanbaoManager.getYuyanbao("money.name3")
        } else if (type == 4) {
            return ____654.yuyanbaoManager.getYuyanbao("money.name4")
        } else if (type == 6) {
            return ____654.yuyanbaoManager.getYuyanbao("money.name5")
        } else if (type == 8) {
            return ____654.yuyanbaoManager.getYuyanbao("money.name6")
        }
        return ""
    },
    showNotEnoughTip: function(type) {
        if (type == 1) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips1"))
        } else if (type == 2) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips2"))
        } else if (type == 3) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips3"))
        } else if (type == 4) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips4"))
        } else if (type == 6) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips5"))
        } else if (type == 8) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips6"))
        }
    },
    getChongZhiScore: function(startTime) {
        var tmp = this.chongZhiScore[____655.____662.getBetweenTimeDay(startTime, ____655.____662.getSystemTimeSec()) + 1];
        return this.list[3] - tmp
    },
    getScore: function() {
        return this.list[3]
    },
    getTodayRecharge: function() {
        return this.getScore() - this.chongZhiScore[1]
    },
    ____61: function() {
        this.list = [-1, -1, -1, -1, -1, -1];
        this.banggong = -1;
        this.chongZhiScore = {};
        this.xiaoFeiScore = {}
    },
});
var ____501 = CharacterInfo.extend({
    ____1523: null,
    _horseFigureTemplate: null,
    _buffChangeType: 0,
    _buffChangeScale: 1,
    _showDefaultCloth: true,
    ____1478: 0,
    ctor: function(sourceType, figurePlayerInfo) {
        this.____1523 = figurePlayerInfo;
        var defaultAnima = ____655.____659.____687.stand;
        this._super(sourceType, defaultAnima)
    },
    setShowDefaultCloth: function(value) {
        this._showDefaultCloth = value
    },
    checkNeedReload: function(currentAnima, anima) {
        var isAtt1 = ____655.____659.____687.isAttackAnima(currentAnima),
            isAtt2 = ____655.____659.____687.isAttackAnima(anima),
            isRide1 = ____655.____659.____687.isRiderAnima(currentAnima),
            isRide2 = ____655.____659.____687.isRiderAnima(anima);
        return (isAtt1 && !isAtt2) || (!isAtt1 && isAtt2) || (isRide1 && !isRide2) || (!isRide1 && isRide2)
    },
    getLayerCount: function() {
        return 4
    },
    getAnima: function(animaType) {
        if (animaType == ____655.____659.____687.stand) {
            if (this.getIsBuffChange()) {
                return ____655.____659.____687.monsterStand
            } else {
                if (this.getHorseFigure()) {
                    return ____655.____659.____687.playerStand2
                } else {
                    return ____655.____659.____687.playerStand1
                }
            }
        } else if (animaType == ____655.____659.____687.walk) {
            if (this.getIsBuffChange()) {
                return ____655.____659.____687.monsterWalk
            } else {
                if (this.getHorseFigure()) {
                    return ____655.____659.____687.playerWalk2
                } else {
                    return ____655.____659.____687.playerWalk1
                }
            }
        } else if (animaType == ____655.____659.____687.attack) {
            if (this.getIsBuffChange()) {
                return ____655.____659.____687.monsterAttack
            } else {
                return ____655.____659.____687.playerAttack
            }
        } else if (animaType == ____655.____659.____687.dead) {
            if (this.getIsBuffChange()) {
                return ____655.____659.____687.monsterDead
            } else {
                return ____655.____659.____687.playerDead
            }
        }
        return animaType
    },
    getOrders: function(anima, dir) {
        if (dir == ____655.____659.____686.leftTop) {
            return anima.layerOrders[0]
        } else if (dir == ____655.____659.____686.rightTop) {
            return anima.layerOrders[1]
        } else if (dir == ____655.____659.____686.leftBottom) {
            return anima.layerOrders[2]
        } else {
            return anima.layerOrders[3]
        }
    },
    getBuffChangeScale: function() {
        return this._buffChangeScale
    },
    ____72: function(anima) {
        var paths = [],
            fullpaths = [];
        var tmpPicPath = "";
        var figureTemplate = null;
        var figureId = 0;
        this._buffChangeType = 0;
        this._roleHeight = 135;
        this._buffChangeScale = 1;
        this.____1478 = 0;
        if (this.getIsBuffChange()) {
            figureId = ____655.allTemplates.____790.____55(this.____1732[____655.____659.commonStaticType.style_Buff]).effect;
            figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId);
            tmpPicPath = figureTemplate.____27();
            this._buffChangeType = figureTemplate.getType();
            this._roleHeight = figureTemplate.getPicHeight();
            this._buffChangeScale = figureTemplate.getScale();
            this.____1478 = figureTemplate.getOffsetY();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(figureTemplate.getType(), tmpPicPath) + ".png")
        } else if (this.____1732[____655.____659.commonStaticType.style_fashion_cloth] > 0) {
            figureId = ____655.allTemplates.fashionTemplateList.getFashion(this.____1732[____655.____659.commonStaticType.style_fashion_cloth]).figureId;
            figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId);
            tmpPicPath = figureTemplate.____27();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(figureTemplate.getType(), tmpPicPath) + ".png")
        } else if (this._showDefaultCloth) {
            if (this.____1523.getSex()) {
                tmpPicPath = "110800"
            } else {
                tmpPicPath = "120800"
            }
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(____655.____659.commonStaticType.style_player, tmpPicPath) + ".png")
        } else {
            paths.push(null);
            fullpaths.push(null)
        }
        if (this.getIsBuffChange() || this.getIsHorse()) {
            paths.push(null);
            fullpaths.push(null)
        } else if (this.____1732[____655.____659.commonStaticType.style_ShenBin] > 0) {
            figureId = ____655.allTemplates.fashionTemplateList.getFashion(this.____1732[____655.____659.commonStaticType.style_ShenBin]).figureId;
            figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId);
            tmpPicPath = figureTemplate.____27();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(figureTemplate.getType(), tmpPicPath) + ".png")
        } else if (this.____1732[____655.____659.commonStaticType.style_Weapon] > 0) {
            tmpPicPath = ____655.allTemplates.____794.getItem(this.____1732[____655.____659.commonStaticType.style_Weapon]).____27();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(____655.____659.commonStaticType.style_player, tmpPicPath) + ".png")
        } else {
            paths.push(null);
            fullpaths.push(null)
        }
        if (!____655.____659.____687.isRiderAnima(anima) || !this.getIsHorse() || this.getIsBuffChange() || ____655.____659.____687.isPlayerDead(anima)) {
            this.____1230 = null;
            paths.push(null);
            fullpaths.push(null)
        } else if (this.____1732[____655.____659.commonStaticType.style_fashion_horse] > 0) {
            figureId = ____655.allTemplates.fashionTemplateList.getFashion(this.____1732[____655.____659.commonStaticType.style_fashion_horse]).figureId;
            figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId);
            this.____1478 = figureTemplate.getOffsetY();
            this._roleHeight = figureTemplate.getPicHeight();
            tmpPicPath = figureTemplate.____27();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(figureTemplate.getType(), tmpPicPath) + ".png")
        } else if (this.____1732[____655.____659.commonStaticType.style_Horse] > 0) {
            figureId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Horse, this.____1732[____655.____659.commonStaticType.style_Horse]).figureId;
            figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId);
            this.____1478 = figureTemplate.getOffsetY();
            this._roleHeight = figureTemplate.getPicHeight();
            tmpPicPath = figureTemplate.____27();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(figureTemplate.getType(), tmpPicPath) + ".png")
        } else {
            this.____1230 = null;
            paths.push(null);
            fullpaths.push(null)
        }
        if (this.getIsBuffChange()) {
            paths.push(null);
            fullpaths.push(null)
        } else if (this.____1732[____655.____659.commonStaticType.style_fashion_wing] > 0) {
            figureId = ____655.allTemplates.fashionTemplateList.getFashion(this.____1732[____655.____659.commonStaticType.style_fashion_wing]).figureId;
            figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId);
            tmpPicPath = figureTemplate.____27();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(figureTemplate.getType(), tmpPicPath) + ".png")
        } else if (this.____1732[____655.____659.commonStaticType.style_Wind] > 0) {
            figureId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Wind, this.____1732[____655.____659.commonStaticType.style_Wind]).figureId;
            figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId);
            tmpPicPath = figureTemplate.____27();
            paths.push(tmpPicPath);
            fullpaths.push(____654.____675.getCharacterPath(figureTemplate.getType(), tmpPicPath) + ".png")
        } else {
            paths.push(null);
            fullpaths.push(null)
        }
        return [paths, fullpaths]
    },
    ____74: function() {
        return this._super()
    },
    getSourceType: function() {
        if (this._buffChangeType != 0) return this._buffChangeType;
        return this.____1691
    },
    setIsHorse: function(value) {
        var old = this.____1732[____655.____659.commonStaticType.style_isHorse];
        if (old == value) return;
        this.____1732[____655.____659.commonStaticType.style_isHorse] = value;
        this.reflesh()
    },
    getIsHorse: function() {
        return this.____1732[____655.____659.commonStaticType.style_isHorse] == true
    },
    getHorseFigure: function() {
        return this.getIsHorse() && !this.getIsBuffChange() && (this.____1732[____655.____659.commonStaticType.style_fashion_horse] > 0 || this.____1732[____655.____659.commonStaticType.style_Horse] > 0)
    },
    getYOffset: function() {
        return this.____1478
    },
    getIsBuffChange: function() {
        return this.____1732[____655.____659.commonStaticType.style_Buff] > 0
    },
    hasPet: function() {
        return this.____1732[____655.____659.commonStaticType.style_Pet] > 0 || this.____1732[____655.____659.commonStaticType.style_fashion_pet] > 0
    },
    getFabao: function() {
        var fabao = this.____1732[____655.____659.commonStaticType.style_FaBao];
        if (fabao == null) return 0;
        return fabao
    },
    getShenJian: function() {
        var sj = this.____1732[____655.____659.commonStaticType.style_ShenJian];
        if (sj == null) return 0;
        return sj
    },
    getZuji: function() {
        var zj = this.____1732[____655.____659.commonStaticType.style_Foot];
        if (zj == null) return 0;
        return zj
    },
    getZhengLing: function() {
        var zl = this.____1732[____655.____659.commonStaticType.style_ZhengLing];
        if (zl == null) return 0;
        return zl
    },
    getShenBin: function() {
        var sb = this.____1732[____655.____659.commonStaticType.style_ShenBin];
        if (sb == null) return 0;
        return sb
    },
    dispose: function() {
        this.____1523 = null;
        this._super()
    },
});
var ____502 = ____591.extend({
    ____916: null,
    ____918: null,
    _buffStateItemList: null,
    effect: 0,
    scale: 1,
    ctor: function() {
        this._super();
        this.____916 = {};
        this.____918 = {};
        this._buffStateItemList = {}
    },
    addBuff: function(buff) {
        this.____916[buff.templateId] = buff;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_addBuff, this, buff))
    },
    ____82: function(id) {
        var b = this.____916[id];
        if (b != null) {
            this.____916[id] = null;
            this.dispatchEvent(new ____590(____655.____661.playerInfo_removeBuff, this, b));
            b.dispose()
        }
    },
    ____85: function(id) {
        return this.____916[id]
    },
    addBuffStateItem: function(stateId) {
        print("添加buff状态", stateId);
        this._buffStateItemList[stateId] = ____655.allTemplates.____790.____55(stateId)
    },
    removeBuffStateItem: function(stateId) {
        this._buffStateItemList[stateId] = null
    },
    getBuffStateItem: function(stateId) {
        return this._buffStateItemList[stateId]
    },
    clearBuffStateItems: function() {
        this._buffStateItemList = {}
    },
    ____83: function() {
        this.____918 = {};
        this.effect = 0;
        this.scale = 1;
        var tmpPriority = -1;
        for (var i in this._buffStateItemList) {
            var stateTemplate = this._buffStateItemList[i];
            if (stateTemplate != null) {
                var len = stateTemplate.states.length;
                for (var j = 0; j < len; j++) {
                    this.____918[stateTemplate.states[j]] = true
                }
                if (stateTemplate.priority > tmpPriority && stateTemplate.effect != 0) {
                    tmpPriority = stateTemplate.priority;
                    if (stateTemplate.type == 1) {
                        this.effect = stateTemplate.effect
                    } else if (stateTemplate.type == 3) {
                        this.scale = stateTemplate.effect / 100
                    }
                }
            }
        }
        this.dispatchEvent(new ____590(____655.____661.playerInfo_updateBuff, this, null))
    },
    getCanMove: function() {
        if (this.____918[1]) return false;
        return true
    },
    ____87: function() {
        if (this.____918[2]) return false;
        return true
    },
    ____88: function() {
        if (this.____918[3]) return false;
        return true
    },
    getCanUseSkill: function() {
        if (this.____918[4]) return false;
        return true
    },
    getIsHide: function() {
        if (this.____918[5]) return true;
        return false
    },
    getIsFear: function() {
        if (this.____918[6]) return true;
        return false
    },
    getIsWudi: function() {
        if (this.____918[7]) return true;
        return false
    },
    getIsAlpha: function() {
        if (this.____918[8]) return true;
        return false
    },
    getCanCollect: function() {
        if (this.____918[9]) return false;
        return true
    },
    ____90: function() {
        if (this.____916 != null) {
            for (var i in this.____916) {
                if (this.____916[i] != null) {
                    this.____916[i].dispose()
                }
            }
        }
        this.____916 = {}
    },
    dispose: function() {
        this.____90();
        this.____916 = null;
        this.____918 = null;
        this._buffStateItemList = null;
        this._super()
    },
});
var ____503 = ____591.extend({
    ____1662: 2147483649,
    FIGHT_FALSE: 4294967293,
    DEAD_FALSE: 4294967291,
    attackState: 0,
    jumping: false,
    ____91: function(value) {
        if (this.____1662 == value) return;
        this.____1662 = value;
        this.dispatchEvent(new ____590(____655.____661.____708, this, null))
    },
    setServerCommon: function() {
        if (!this.getIsFight() && !this.getIsDead()) return;
        this.____1662 = this.____1662 ^ this.FIGHT_FALSE;
        this.____1662 = this.____1662 ^ this.DEAD_FALSE;
        this.dispatchEvent(new ____590(____655.____661.____708, this, null))
    },
    getIsCommon: function() {
        return (this.____1662 & Math.pow(2, 0)) > 0
    },
    getIsFight: function() {
        return (this.____1662 & Math.pow(2, 1)) > 0
    },
    getIsDead: function() {
        return (this.____1662 & Math.pow(2, 2)) > 0
    },
    getCanMove: function() {
        if (this.getIsDead() || this.jumping) return false;
        return true
    },
    ____87: function() {
        if (this.getIsDead()) return false;
        return true
    },
    getCanBeAttack: function() {
        if (this.getIsDead()) return false;
        return true
    },
    getCanUseSkill: function() {
        if (this.getIsDead()) return false;
        return true
    },
    getAFK: function() {
        return this.attackState == 2
    },
    setAFK: function() {
        if (this.attackState == 2) return;
        this.attackState = 2;
        this.dispatchEvent(new ____590(____655.____661.____709, this, null))
    },
    getAttacking: function() {
        return this.attackState == 1
    },
    setAttacking: function() {
        if (this.attackState == 1) return;
        this.attackState = 1;
        this.dispatchEvent(new ____590(____655.____661.____709, this, null))
    },
    getAttackCommon: function() {
        return this.attackState == 0
    },
    setAttackCommon: function() {
        if (this.attackState == 0) return;
        this.attackState = 0;
        this.dispatchEvent(new ____590(____655.____661.____709, this, null))
    },
});
var ____504 = ____498.extend({
    account: "",
    shortAccount: "",
    moneyInfo: null,
    baggageMaxCount: null,
    exp: 0,
    pvpChangeDate: 0,
    scenePath: null,
    scenePathTarget: null,
    scenePathCallback: null,
    scenePathStopAtDistance: 0,
    flyCallback: null,
    outCopyTrigger: null,
    scenePos: null,
    levelUpTime: 0,
    createRoleTime: 0,
    hefuTime: 0,
    ctor: function() {
        this._super();
        this.moneyInfo = new ____500()
    },
    setShortAccount: function() {
        this.shortAccount = ____655.____663.getShortAccount()
    },
    ____64: function(level) {
        var oldLevel = this.level;
        var isNew = false;
        if (oldLevel == 0) {
            isNew = true
        }
        this._super(level);
        if (oldLevel == level) {
            return
        }
        ____655.____670.checkAutoAccept();
        if (isNew) {
            return
        }
        ____654.sdk.levelUp()
    },
    initClub: function(bytes) {
        var oldClubId = this.clubId;
        this._super(bytes);
        if (oldClubId == this.clubId) {
            return
        }
        ____655.____670.checkAutoAccept();
        ____655.familyTreasuresInfo.updatePopState(1);
        ____655.familyTreasuresInfo.updatePopState(2);
        ____655.familyTreasuresInfo.updatePopState(3);
        if (this.clubId <= 0) {
            ____655.clubInfo.____61();
            ____655.clubInfo.sendChangeBossState()
        }
    },
    setExp: function(value) {
        if (this.exp == value) return;
        if (value - this.exp >= 1000) {
            ____655.____669.appendSystemItem("获得[0x9B0DB4]" + (value - this.exp) + "经验[-]")
        }
        this.exp = value;
        this.dispatchEvent(new ____590(____655.____661.____702, this, null))
    },
    setScenePath: function(path, target, callback, stopAtDistance) {
        this.scenePath = path;
        this.scenePathTarget = target;
        this.scenePathCallback = callback;
        this.scenePathStopAtDistance = stopAtDistance
    },
    changeInfo: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.playerInfo_selfInfo, ____654.____672, null))
    },
    updateBagMaxCount: function(count) {
        if (this.baggageMaxCount != count) {
            this.baggageMaxCount = count
        }
    },
    ____61: function() {
        this.account = "";
        this.shortAccount = "";
        if (this.moneyInfo != null) {
            this.moneyInfo.____61()
        }
        this.baggageMaxCount = 0;
        this.scenePath = null;
        this.scenePathTarget = null;
        this.scenePathCallback = null;
        this.scenePathStopAtDistance = 0;
        this.exp = 0;
        this.pvpChangeDate = 0;
        this.flyCallback = null;
        this.outCopyTrigger = null;
        this.scenePos = null;
        this.xianwei = 0;
        this.teamId = 0;
        this.isMarry = 0;
        this.marryType = 0;
        this.marryName = "";
        this.isOath = 0;
        this.oathType = 0;
        this._super()
    },
});
var ____480 = cc.Class.extend({
    flag: 0,
    target: null,
    callback: null,
    ctor: function(callback, target) {
        this.callback = callback;
        this.target = target
    },
    dispose: function() {
        this.callback = null;
        this.target = null
    }
});
var CheckRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    totalStar: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.totalStar = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        if (this.clubName == "") {
            this.clubName = "无"
        }
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var ClubRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var CopyBazhuInfo = cc.Class.extend({
    playerInfo: null,
    record: 0,
    ctor: function() {
        this.playerInfo = new ____499()
    },
    init: function(data) {
        this.playerInfo.nick = data.readString();
        this.record = data.readInt();
        this.playerInfo.combat = data.readInt();
        this.playerInfo.setCareer(data.readByte());
        ____654.____685.____187(this.playerInfo, data)
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var FabaoRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var FashionRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fashionValue: 0,
    serverId: 0,
    vipLevel: 0,
    petValue: 0,
    riderValue: 0,
    userName: "",
    petName: "",
    clubName: "",
    wingValue: 0,
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fashionValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.petValue = data.readInt();
        this.riderValue = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.wingValue = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var FootPrintRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var PetRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var ____1940 = cc.Class.extend({
    rank: 0,
    totalHp: 0,
    playerInfo: null,
    ctor: function() {
        this.playerInfo = new ____499()
    },
    setPlayerInfo: function() {
        var tmpInfo = ____655.allTemplates.douShenTemplateList.getInfoByRank(this.rank);
        this.playerInfo.level = tmpInfo.level;
        this.totalHp = tmpInfo.hp;
        this.playerInfo.combat = tmpInfo.fight;
        this.playerInfo.nick = "守关者";
        var career = (this.rank % 2) + 1;
        var weaponId = 180001;
        if (career == 2) {
            weaponId = 180101
        }
        this.playerInfo.setCareer(career);
        this.playerInfo.serverId = -1;
        var styleBin = {};
        if (this.rank == 1) {
            styleBin[____655.____659.commonStaticType.style_ShenBin] = 2;
            styleBin[____655.____659.commonStaticType.style_Wind] = 10
        } else if (this.rank == 2) {
            styleBin[____655.____659.commonStaticType.style_ShenBin] = 1;
            styleBin[____655.____659.commonStaticType.style_Wind] = 7
        } else if (this.rank == 3) {
            styleBin[____655.____659.commonStaticType.style_ShenBin] = 1;
            styleBin[____655.____659.commonStaticType.style_Wind] = 4
        } else {
            styleBin[____655.____659.commonStaticType.style_Weapon] = weaponId;
            styleBin[____655.____659.commonStaticType.style_Wind] = 1
        }
        this.playerInfo.characterInfo.updateStyle(styleBin)
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var RankInfo = ____591.extend({
    personalRanksList: null,
    totalPageList: null,
    clubRankList: null,
    xianWeiRankList: null,
    checkRankList: null,
    fashionRankList: null,
    riderRankList: null,
    petRankList: null,
    wingRankList: null,
    footPrintRankList: null,
    fabaoRankList: null,
    zhenLingRankList: null,
    shenJiangRankList: null,
    lengthList: null,
    copyYaotaSelfRank: 0,
    copyYaotaBazhuInfo: null,
    jiazuWarRanks: null,
    jiazuWarSelfScore: 0,
    jiazuWarSelfRank: 0,
    doushenRanks: null,
    doushenTopList: null,
    doushenSelfRank: 0,
    doushenCount: 0,
    doushenCD: 0,
    doushenAwardState: 0,
    doushenAwardRank: 0,
    doushenActiveTimes: 0,
    doushenActiveFight: 0,
    doushenFightCount: 0,
    doushenCDTime: 900,
    wushenRanks: null,
    wushenSelfRank: 0,
    wushenSelfScore: 0,
    wushenJoinTimes: 5,
    ctor: function() {
        this._super();
        this.personalRanksList = {};
        this.totalPageList = {};
        this.clubRankList = {};
        this.xianWeiRankList = {};
        this.checkRankList = {};
        this.fashionRankList = {};
        this.riderRankList = {};
        this.petRankList = {};
        this.wingRankList = {};
        this.footPrintRankList = {};
        this.fabaoRankList = {};
        this.zhenLingRankList = {};
        this.shenJiangRankList = {};
        this.lengthList = {};
        this.jiazuWarRanks = [];
        this.doushenRanks = [];
        this.doushenTopList = {};
        this.wushenRanks = [];
        this.copyRankList = {}
    },
    init: function() {
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_hourUpdate, this.hourUpdateHandler, this)
    },
    hourUpdateHandler: function(evt) {
        this.____61()
    },
    initRankInfo: function(data) {
        var type = data.readUByte();
        var selfRank = data.readUByte();
        var totalPage = data.readUByte();
        if (this.personalRanksList[type] == null) {
            this.personalRanksList[type] = []
        }
        this.personalRanksList[type] = selfRank;
        if (this.totalPageList[type] == null) {
            this.totalPageList[type] = []
        }
        this.totalPageList[type] = totalPage;
        var len = data.readUByte();
        this.lengthList[type] = len;
        if (type == 1) {
            this.clearClubRankList();
            for (var i = 0; i < len; i++) {
                var item = new ClubRankItemInfo();
                item.init(data);
                this.clubRankList[item.rank] = item
            }
        } else if (type == 2) {
            this.clearXianweiRankList();
            for (var i = 0; i < len; i++) {
                var item = new XianWeiRankItemInfo();
                item.init(data);
                this.xianWeiRankList[item.rank] = item
            }
        } else if (type == 3) {
            this.clearCheckRankList();
            for (var i = 0; i < len; i++) {
                var item = new CheckRankItemInfo();
                item.init(data);
                this.checkRankList[item.rank] = item
            }
        } else if (type == 4) {
            this.clearFashionRankList();
            for (var i = 0; i < len; i++) {
                var item = new FashionRankItemInfo();
                item.init(data);
                this.fashionRankList[item.rank] = item
            }
        } else if (type == 5) {
            this.clearRiderRankList();
            for (var i = 0; i < len; i++) {
                var item = new RiderRankItemInfo();
                item.init(data);
                this.riderRankList[item.rank] = item
            }
        } else if (type == 6) {
            this.clearPetRankList();
            for (var i = 0; i < len; i++) {
                var item = new PetRankItemInfo();
                item.init(data);
                this.petRankList[item.rank] = item
            }
        } else if (type == 7) {
            this.clearWingRankList();
            for (var i = 0; i < len; i++) {
                var item = new WingRankItemInfo();
                item.init(data);
                this.wingRankList[item.rank] = item
            }
        } else if (type == 8) {
            this.clearFootPrintRankList();
            for (var i = 0; i < len; i++) {
                var item = new FootPrintRankItemInfo();
                item.init(data);
                this.footPrintRankList[item.rank] = item
            }
        } else if (type == 9) {
            this.clearFabaoRankList();
            for (var i = 0; i < len; i++) {
                var item = new FabaoRankItemInfo();
                item.init(data);
                this.fabaoRankList[item.rank] = item
            }
        } else if (type == 10) {
            this.clearZhenLingRankList();
            for (var i = 0; i < len; i++) {
                var item = new ZhenLingRankItemInfo();
                item.init(data);
                this.zhenLingRankList[item.rank] = item
            }
        } else if (type == 11) {
            this.clearShenJiangRankList();
            for (var i = 0; i < len; i++) {
                var item = new ShenJiangRankItemInfo();
                item.init(data);
                this.shenJiangRankList[item.rank] = item
            }
        }
        this.dispatchEvent(new ____590(____655.____661.common_rankInfoUpdate, this, type))
    },
    clearClubRankList: function() {
        for (var i in this.clubRankList) {
            if (this.clubRankList[i] != null) {
                this.clubRankList[i].dispose()
            }
        }
        this.clubRankList = {}
    },
    clearXianweiRankList: function() {
        for (var i in this.xianWeiRankList) {
            if (this.xianWeiRankList[i] != null) {
                this.xianWeiRankList[i].dispose()
            }
        }
        this.xianWeiRankList = {}
    },
    clearCheckRankList: function() {
        for (var i in this.checkRankList) {
            if (this.checkRankList[i] != null) {
                this.checkRankList[i].dispose()
            }
        }
        this.checkRankList = {}
    },
    clearFashionRankList: function() {
        for (var i in this.fashionRankList) {
            if (this.fashionRankList[i] != null) {
                this.fashionRankList[i].dispose()
            }
        }
        this.fashionRankList = {}
    },
    clearRiderRankList: function() {
        for (var i in this.riderRankList) {
            if (this.riderRankList[i] != null) {
                this.riderRankList[i].dispose()
            }
        }
        this.riderRankList = {}
    },
    clearPetRankList: function() {
        for (var i in this.petRankList) {
            if (this.petRankList[i] != null) {
                this.petRankList[i].dispose()
            }
        }
        this.petRankList = {}
    },
    clearWingRankList: function() {
        for (var i in this.wingRankList) {
            if (this.wingRankList[i] != null) {
                this.wingRankList[i].dispose()
            }
        }
        this.wingRankList = {}
    },
    clearFootPrintRankList: function() {
        for (var i in this.footPrintRankList) {
            if (this.footPrintRankList[i] != null) {
                this.footPrintRankList[i].dispose()
            }
        }
        this.footPrintRankList = {}
    },
    clearFabaoRankList: function() {
        for (var i in this.fabaoRankList) {
            if (this.fabaoRankList[i] != null) {
                this.fabaoRankList[i].dispose()
            }
        }
        this.fabaoRankList = {}
    },
    clearZhenLingRankList: function() {
        for (var i in this.zhenLingRankList) {
            if (this.zhenLingRankList[i] != null) {
                this.zhenLingRankList[i].dispose()
            }
        }
        this.zhenLingRankList = {}
    },
    clearShenJiangRankList: function() {
        for (var i in this.shenJiangRankList) {
            if (this.shenJiangRankList[i] != null) {
                this.shenJiangRankList[i].dispose()
            }
        }
        this.shenJiangRankList = {}
    },
    clearCopyYaTaRankInfo: function() {
        if (this.copyYaotaBazhuInfo != null) {
            this.copyYaotaBazhuInfo.dispose();
            this.copyYaotaBazhuInfo = null
        }
    },
    initCopyYaotaRankInfo: function(data) {
        this.clearCopyYaTaRankInfo();
        this.copyYaotaSelfRank = data.readUByte();
        var len = data.readByte();
        if (len > 0) {
            this.copyYaotaBazhuInfo = new CopyBazhuInfo();
            this.copyYaotaBazhuInfo.init(data)
        }
        this.dispatchEvent(new ____590(____655.____661.common_rankCopyUpdate, this))
    },
    clearJiazuWarRanks: function() {
        if (this.jiazuWarRanks != null) {
            for (var i = 0; i < this.jiazuWarRanks.length; i++) {
                this.jiazuWarRanks[i].dispose()
            }
            this.jiazuWarRanks = []
        }
    },
    initJiazuWarInfo: function(data) {
        data.readByte();
        data.readByte();
        this.jiazuWarSelfScore = data.readInt();
        this.jiazuWarSelfRank = data.readShort();
        this.clearJiazuWarRanks();
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var info = new ____1943();
            info.init(data);
            this.jiazuWarRanks.push(info)
        }

        function listSort(info1, info2) {
            return info1.rank - info2.rank
        }
        this.jiazuWarRanks.sort(listSort);
        this.dispatchEvent(new ____590(____655.____661.common_rankJiazuWarUpdate, this))
    },
    initDoushenRank: function(data) {
        this.clearDoushenRank();
        var len = data.readShort();
        for (var i = 0; i < len; i++) {
            var info = new ____1940();
            if (data.readByte() == 0) {
                info.rank = data.readInt();
                info.setPlayerInfo()
            } else {
                info.playerInfo.userId = data.readNumber();
                info.playerInfo.level = data.readShort();
                info.playerInfo.serverId = data.readInt();
                info.rank = data.readInt();
                info.totalHp = data.readNumber();
                info.playerInfo.combat = data.readInt();
                info.playerInfo.setCareer(data.readInt());
                info.playerInfo.nick = data.readString();
                ____654.____685.____187(info.playerInfo, data, 0)
            }
            if (i < 3) {
                this.doushenTopList[i + 1] = info
            } else {
                this.doushenRanks.push(info)
            }
        }
        this.dispatchEvent(new ____590(____655.____661.common_rankDoushenRankUpdate, this))
    },
    clearDoushenRank: function() {
        if (this.doushenRanks != null) {
            for (var i = 0; i < this.doushenRanks.length; i++) {
                this.doushenRanks[i].dispose()
            }
        }
        this.doushenRanks = [];
        for (var i in this.doushenTopList) {
            this.doushenTopList[i].dispose()
        }
        this.doushenTopList = {}
    },
    initDoushenInfo: function(bytes) {
        this.doushenSelfRank = bytes.readInt();
        this.doushenAwardState = bytes.readByte();
        this.doushenAwardRank = bytes.readInt();
        this.doushenCount = bytes.readByte();
        this.doushenCD = bytes.readInt();
        this.doushenActiveTimes = bytes.readByte();
        this.doushenActiveFight = bytes.readInt();
        this.doushenFightCount = bytes.readShort();
        this.dispatchEvent(new ____590(____655.____661.common_rankDoushenInfoUpdate, this))
    },
    reduceDoushenCount: function() {
        this.doushenCount--;
        var currentT = ____655.____662.getSystemTimeSec();
        if (this.doushenCD <= currentT) {
            this.doushenCD = currentT + this.doushenCDTime
        }
        this.dispatchEvent(new ____590(____655.____661.common_doushenCountUpdate, this))
    },
    getDoushenItemByRank: function(rank) {
        for (var i = 0; i < this.doushenRanks.length; i++) {
            if (this.doushenRanks[i].rank == rank) return this.doushenRanks[i]
        }
        for (var i in this.doushenTopList) {
            if (this.doushenTopList[i].rank == rank) return this.doushenTopList[i]
        }
        return null
    },
    initWushenRank: function(bytes) {
        this.clearWushenRanks();
        this.wushenSelfRank = bytes.readByte();
        this.wushenSelfScore = bytes.readInt();
        this.wushenJoinTimes = bytes.readByte();
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var info = new RankWuShenItemInfo();
            info.init(bytes);
            this.wushenRanks.push(info)
        }

        function listSort(info1, info2) {
            return info1.rank - info2.rank
        }
        this.wushenRanks.sort(listSort);
        this.dispatchEvent(new ____590(____655.____661.common_rankWushenRankUpdate, this))
    },
    clearWushenRanks: function() {
        for (var i = 0; i < this.wushenRanks.length; i++) {
            this.wushenRanks[i].dispose()
        }
        this.wushenRanks = []
    },
    initWushenTimes: function() {
        this.wushenJoinTimes = 5
    },
    ____61: function() {
        this.personalRanksList = {};
        this.lengthList = {};
        this.totalPageList = {};
        this.clearClubRankList();
        this.clearXianweiRankList();
        this.clearCheckRankList();
        this.clearFashionRankList();
        this.clearRiderRankList();
        this.clearPetRankList();
        this.clearWingRankList();
        this.clearFootPrintRankList();
        this.clearFabaoRankList();
        this.clearZhenLingRankList();
        this.clearShenJiangRankList();
        this.clearCopyYaTaRankInfo();
        this.clearJiazuWarRanks();
        this.jiazuWarSelfScore = 0;
        this.jiazuWarSelfRank = 0;
        this.clearWushenRanks();
        this.wushenSelfScore = 0;
        this.wushenSelfRank = 0;
        this.clearDoushenRank();
        this.doushenSelfRank = 0;
        this.doushenCount = 0;
        this.doushenCD = 0;
        this.doushenAwardState = 0;
        this.doushenAwardRank = 0;
        this.doushenActiveTimes = 0;
        this.doushenActiveFight = 0;
        this.doushenFightCount = 0
    },
});
var RankItemInfo = cc.Class.extend({
    userId: 0,
    userName: "",
    rank: 0,
    serverId: 0,
    fight: 0,
    property1: "",
    property2: 0,
    property3: 0,
    property4: 0,
    property5: 0,
    property6: 0,
    init: function(data) {
        this.userId = data.readNumber();
        this.userName = data.readString();
        this.rank = data.readInt();
        this.serverId = data.readInt();
        this.fight = data.readInt();
        this.property1 = data.readString();
        this.property2 = data.readInt();
        this.property3 = data.readInt();
        this.property4 = data.readInt();
        this.property5 = data.readInt();
        this.property6 = data.readInt()
    },
});
var ____1943 = cc.Class.extend({
    rank: 0,
    clubName: "",
    fight: 0,
    score: 0,
    playerNum: 0,
    playerNick: "",
    style: null,
    playerInfo: null,
    init: function(bytes) {
        this.rank = bytes.readByte();
        this.fight = bytes.readInt();
        this.score = bytes.readInt();
        this.playerNum = bytes.readShort();
        this.clubName = bytes.readString();
        if (this.rank <= 3) {
            this.playerNick = bytes.readString();
            this.style = ____654.____685.getPlayerStyleBin(bytes);
            this.playerInfo = new ____499();
            this.playerInfo.characterInfo.updateStyle(this.style);
            this.playerInfo.setCareer(bytes.readByte())
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var RankWuShenItemInfo = cc.Class.extend({
    rank: 0,
    playerInfo: null,
    score: 0,
    xianwei: 0,
    ctor: function() {
        this.playerInfo = new ____499()
    },
    init: function(bytes) {
        this.rank = bytes.readByte();
        this.playerInfo.userId = bytes.readNumber();
        this.playerInfo.serverId = bytes.readShort();
        this.playerInfo.____64(bytes.readShort());
        this.playerInfo.setCareer(bytes.readByte());
        this.xianwei = bytes.readByte();
        this.score = bytes.readInt();
        this.playerInfo.combat = bytes.readInt();
        this.playerInfo.nick = bytes.readString();
        if (this.rank <= 3) {
            var style = ____654.____685.getPlayerStyleBin(bytes);
            this.playerInfo.characterInfo.updateStyle(style)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var RiderRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var ShenJiangRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var WingRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var XianWeiRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        if (this.clubName == "") {
            this.clubName = "无"
        }
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var ZhenLingRankItemInfo = cc.Class.extend({
    userId: 0,
    rank: 0,
    level: 0,
    carrer: 0,
    fightValue: 0,
    serverId: 0,
    vipLevel: 0,
    otherStage: 0,
    otherFight: 0,
    userName: "",
    petName: "",
    clubName: "",
    xianWei: "",
    playerInfo: null,
    init: function(data) {
        this.userId = data.readNumber();
        this.rank = data.readUByte();
        this.level = data.readShort();
        this.carrer = data.readUByte();
        this.fightValue = data.readInt();
        this.serverId = data.readShort();
        this.vipLevel = data.readShort();
        this.otherStage = data.readInt();
        this.otherFight = data.readInt();
        this.userName = data.readString();
        this.petName = data.readString();
        this.clubName = data.readString();
        this.xianWei = data.readInt();
        if (this.rank <= 3) {
            this.playerInfo = new ____499();
            this.playerInfo.userId = this.userId;
            this.playerInfo.career = this.carrer;
            ____654.____685.____187(this.playerInfo, data)
        }
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
    },
});
var ____1944 = cc.Class.extend({
    ____688: null,
    ____686: null,
    ____691: null,
    ____690: null,
    packPaths: null,
    triggerEventType: null,
    commonStaticType: null,
    categoryType: null,
    ____687: null,
    panelTabType: null,
    iconPathType: null,
    ____693: null,
    propertyType: null,
    nameType: null,
    levelType: null,
    ctor: function() {
        this.____688 = new ColorType();
        this.____686 = new ____509();
        this.____691 = new ____1952();
        this.____690 = new ____1953();
        this.triggerEventType = new ____1957();
        this.commonStaticType = new ____1948();
        this.categoryType = new CategoryType();
        this.____687 = new ____506();
        this.panelTabType = new ____1955();
        this.iconPathType = new ____1951();
        this.____693 = new ChannelType();
        this.propertyType = new ____1956();
        this.nameType = new ____1954();
        this.levelType = new LevelType();
        this.packPaths = {}
    },
});
var CategoryType = cc.Class.extend({
    WEAPON: 1,
    RING: 2,
    NECKLACK: 3,
    AMULET: 4,
    CLOTH: 5,
    CUFF: 6,
    CAESTUS: 7,
    SHOES: 8,
    BOX: 1001,
    COPPER: 1002,
    EXP: 1003,
    BANGGONG: 1004,
    RONGYU: 1005,
    ZUANSHI: 1006,
    BINDZUANSHI: 1106,
    DUIHUAN: 1007,
    CHENGHAO: 1008,
    XUNBAO_GOLD: 1009,
    HUNPODAN: 1072,
    TONGXINJIE: 1027,
    JINLANPU: 1028,
    DIAOLUOCOPPER: 1011,
    QIANGHUASHI: 1021,
    HUNSHI: 1022,
    ZUANSHIKA: 1023,
    ZHUANZHIKA: 1024,
    XIANLU: 1026,
    JINJIEDAN: null,
    CHENGZHANGDAN: null,
    QIANNENG: null,
    FEISHENG: null,
    BAOSHI: null,
    equipList: null,
    waixingEquipFight: 500,
    waixingEquipQuality: null,
    ctor: function() {
        this.equipList = [this.WEAPON, this.RING, this.NECKLACK, this.AMULET, this.CLOTH, this.CUFF, this.CAESTUS, this.SHOES];
        this.JINJIEDAN = [1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038];
        this.CHENGZHANGDAN = [1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048];
        this.QIANNENG = [1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058];
        this.FEISHENG = [1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068];
        this.BAOSHI = [1081, 1082, 1083, 1084, 1085, 1086];
        this.waixingEquipQuality = [1, 1.2]
    },
    isEquip: function(categoryId) {
        return categoryId > 0 && categoryId < 100
    },
    isWaiXingEquip: function(categoryId) {
        return categoryId > 200 && categoryId < 300
    },
    isBaoshi: function(categoryId) {
        return categoryId > 1080 && categoryId < 1100
    },
    getAdvanceEquipCategoryId: function(type, place) {
        var categoryId = 0;
        if (type == ____655.____659.commonStaticType.style_Pet) {
            categoryId = 200 + place
        } else if (type == ____655.____659.commonStaticType.style_Horse) {
            categoryId = 210 + place
        } else if (type == ____655.____659.commonStaticType.style_Foot) {
            categoryId = 220 + place
        } else if (type == ____655.____659.commonStaticType.style_Wind) {
            categoryId = 230 + place
        } else if (type == ____655.____659.commonStaticType.style_FaBao) {
            categoryId = 240 + place
        } else if (type == ____655.____659.commonStaticType.style_ZhengLing) {
            categoryId = 250 + place
        } else if (type == ____655.____659.commonStaticType.style_ShenJian) {
            categoryId = 260 + place
        }
        return categoryId
    },
    getAdvanceEquipPlace: function(categoryId) {
        var place = categoryId % 10;
        if (categoryId < 200) {
            return null
        } else if (categoryId < 210) {
            return [____655.____659.commonStaticType.style_Pet, place]
        } else if (categoryId < 220) {
            return [____655.____659.commonStaticType.style_Horse, place]
        } else if (categoryId < 230) {
            return [____655.____659.commonStaticType.style_Foot, place]
        } else if (categoryId < 240) {
            return [____655.____659.commonStaticType.style_Wind, place]
        } else if (categoryId < 250) {
            return [____655.____659.commonStaticType.style_FaBao, place]
        } else if (categoryId < 260) {
            return [____655.____659.commonStaticType.style_ZhengLing, place]
        } else if (categoryId < 270) {
            return [____655.____659.commonStaticType.style_ShenJian, place]
        }
        return null
    },
    getCategoryName: function(categoryId) {
        if (categoryId < 1) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType1")
        } else if (categoryId < 100) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType2")
        } else if (categoryId < 210) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType4")
        } else if (categoryId < 220) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType3")
        } else if (categoryId < 230) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType6")
        } else if (categoryId < 240) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType5")
        } else if (categoryId < 250) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType7")
        } else if (categoryId < 260) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType8")
        } else if (categoryId < 270) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType9")
        } else if (categoryId < 2000) {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType10")
        } else {
            return ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType1")
        }
    },
    getNameByCategoryType: function(place) {
        if (place == this.WEAPON) {
            return ____654.yuyanbaoManager.getYuyanbao("common.personEquipName1")
        } else if (place == this.RING) {
            return ____654.yuyanbaoManager.getYuyanbao("common.personEquipName2")
        } else if (place == this.NECKLACK) {
            return ____654.yuyanbaoManager.getYuyanbao("common.personEquipName3")
        } else if (place == this.AMULET) {
            return ____654.yuyanbaoManager.getYuyanbao("common.personEquipName4")
        } else if (place == this.CLOTH) {
            return ____654.yuyanbaoManager.getYuyanbao("common.personEquipName5")
        } else if (place == this.CUFF) {
            return ____654.yuyanbaoManager.getYuyanbao("common.personEquipName6")
        } else if (place == this.CAESTUS) {
            return ____654.yuyanbaoManager.getYuyanbao("common.personEquipName7")
        } else if (place == this.SHOES) {
            return ____654.yuyanbaoManager.getYuyanbao("common.personEquipName8")
        } else {
            return ""
        }
    },
    getWaiXingEquipRongLianByQuality: function(star, quality) {
        if (star == null) {
            return 0
        }
        return Math.floor(quality * 10 * this.waixingEquipQuality[quality])
    },
    getRenWuEquipRongLianByQuality: function(quality) {
        if (quality == null) {
            return 0
        }
        if (quality == 0) {
            return 1
        } else if (quality == 1) {
            return 2
        } else if (quality == 2) {
            return 5
        } else if (quality == 3) {
            return 25
        } else if (quality == 4) {
            return 50
        } else if (quality == 5) {
            return 100
        } else if (quality == 6) {
            return 200
        }
        return 0
    },
    getWaiXingFight: function(star, quality) {
        return star * this.waixingEquipFight * this.waixingEquipQuality[quality]
    },
});
var ChannelType = cc.Class.extend({
    world: 1,
    club: 3,
    speaker: 6,
    system: 99,
    privat: 100,
    systemNotice: 901,
    worldNotice: 902,
    clubNotice: 903,
    channelList: null,
    channelShowType: null,
    ctor: function() {
        this.channelList = [this.world, this.club, this.system];
        this.channelShowType = [
            [this.world, this.speaker, this.systemNotice, this.worldNotice],
            [this.club, this.clubNotice],
            [this.system]
        ]
    },
});
var ColorType = cc.Class.extend({
    white: null,
    green: null,
    red: null,
    yellow: null,
    purple: null,
    purpleStr: null,
    black: null,
    gray: null,
    smoke: null,
    orange: null,
    lightGreen: null,
    darkGold: null,
    darkGoldStr: null,
    nameBlue: null,
    namePurple: null,
    behitWhite: null,
    blueStr: null,
    redStr: null,
    system: null,
    playerHit_color: null,
    petHit_color: null,
    beHit_color: null,
    addBlood_color: null,
    itemColorList: null,
    itemColorStrList: null,
    ctor: function() {
        this.white = cc.color(255, 255, 255);
        this.green = cc.color(0, 152, 0);
        this.lightGreen = cc.color(0, 255, 0);
        this.lightGreenStr = "0x00FF00";
        this.nameBlue = cc.color(0, 183, 238);
        this.blueStr = "0x00B7EE";
        this.namePurple = cc.color(244, 60, 108);
        this.red = cc.color(188, 32, 32);
        this.redStr = "0xBC2020";
        this.yellow = cc.color(255, 244, 92);
        this.yellowStr = "0xFFF45C";
        this.purple = cc.color(155, 13, 180);
        this.purpleStr = "0x9B0DB4";
        this.black = cc.color(0, 0, 0);
        this.gray = cc.color(70, 82, 95);
        this.smoke = cc.color(110, 110, 110);
        this.orange = cc.color(234, 110, 0);
        this.system = cc.color(241, 230, 210);
        this.behitWhite = cc.color(160, 160, 160);
        this.darkGold = cc.color(195, 171, 111);
        this.darkGoldStr = "0xC3AB6F";
        this.playerHit_color = cc.color(239, 191, 77);
        this.petHit_color = cc.color(242, 102, 33);
        this.beHit_color = cc.color(234, 116, 129);
        this.addBlood_color = cc.color(242, 102, 33);
        this.itemColorList = [cc.color(170, 184, 199), cc.color(0, 152, 0), cc.color(0, 138, 180), cc.color(155, 13, 180), cc.color(234, 110, 0), cc.color(195, 172, 112), cc.color(188, 32, 32)];
        this.itemColorStrList = ["0xAAB8C7", "0x009800", "0x008AB4", "0x9B0DB4", "0xEA6E00", "0xC3AC70", "0xBC2020"];
        this.bossHpColorList = [cc.color(255, 150, 0), cc.color(0, 255, 0), cc.color(200, 13, 255), cc.color(255, 0, 30)]
    },
    getColorByQuality: function(quality) {
        return this.itemColorList[quality]
    },
    getColorStrByQuality: function(str, quality) {
        return "[" + this.itemColorStrList[quality] + "]" + str + "[-]"
    },
    stringToColor3b: function(str) {
        var r = parseInt(str.slice(0, 2), 16);
        var g = parseInt(str.slice(2, 4), 16);
        var b = parseInt(str.slice(4, 6), 16);
        return cc.color(r, g, b)
    },
});
var ____1948 = cc.Class.extend({
    triggerPattern: /\{\d+\$[\S\s]*?\}/,
    colorPattern: /\[0x\w{6}\][\S\s]*?\[\-\]/,
    facePattern: /#\d{2}/,
    enterPattern: "\n",
    mapBlock_empty: 0,
    mapBlock_full: 100,
    mapBlock_alpha: 200,
    source_neverClear: 0,
    source_clearImmedia: 1,
    source_clearOneM: 2,
    source_changeSceneAndOneM: 3,
    soType_player: 1,
    soType_npc: 3,
    soType_pet: 4,
    soType_gate: 5,
    soType_collect: 6,
    soType_monster: 8,
    soType_chenZhu: 9,
    soType_ActionList: null,
    task_conntAccept: 10001,
    task_canAccept: 10002,
    task_acceptNotFinish: 10003,
    task_finishNotSubmit: 10004,
    task_submit: 10005,
    task_outOfDate: 10006,
    attackResult_common: 1,
    attackResult_miss: 2,
    attackResult_block: 3,
    attackResult_powerHit: 4,
    bagType_common: 1,
    bagType_bagEquip: 2,
    bagType_material: 3,
    bagType_equip: 4,
    style_None: 0,
    style_Cloth: 1,
    style_Weapon: 2,
    style_Horse: 3,
    style_Wind: 4,
    style_FaBao: 5,
    style_ZhengLing: 6,
    style_ShenJian: 7,
    style_Foot: 8,
    style_Pet: 9,
    style_Buff: 10,
    style_ShenBin: 11,
    style_fashion_cloth: 20,
    style_fashion_horse: 21,
    style_fashion_wing: 22,
    style_fashion_pet: 23,
    style_fashion_faBao: 24,
    style_fashion_zhengLing: 25,
    style_fashion_shenJian: 26,
    style_fashion_foot: 27,
    style_monster: 90,
    style_npc: 91,
    style_player: 92,
    style_isHorse: 100,
    style_shenJiang: 10001,
    style_moWang: 10002,
    style_xianZun: 10003,
    style_shangGuShenBing: 10004,
    style_tianShenBaoWu: 10005,
    style_tuJianYaoJing: 11001,
    sheJiao_marry: 15,
    sheJiao_oath: 16,
    fashionTypeList: null,
    advanceTypeList: null,
    ctor: function() {
        this.soType_ActionList = [this.style_player, this.style_monster, this.style_Pet];
        this.fashionTypeList = [this.style_fashion_horse, this.style_fashion_wing, this.style_fashion_faBao, this.style_fashion_zhengLing, this.style_fashion_shenJian, this.style_fashion_foot, this.style_fashion_pet, this.style_fashion_cloth];
        this.advanceTypeList = [this.style_Horse, this.style_Wind, this.style_FaBao, this.style_ZhengLing, this.style_ShenJian, this.style_Foot, this.style_Pet]
    },
    soTypeHasAction: function(sotype) {
        return this.soType_ActionList.indexOf(sotype) > -1
    },
    isFashion: function(type) {
        return this.fashionTypeList.indexOf(type) > -1
    },
});
var ____509 = cc.Class.extend({
    leftTop: 1,
    top: 2,
    rightTop: 3,
    left: 4,
    right: 5,
    leftBottom: 6,
    bottom: 7,
    rightBottom: 8,
    ____95: function() {
        var tmp = Math.random();
        if (tmp < 0.25) return this.leftTop;
        else if (tmp < 0.5) return this.rightTop;
        else if (tmp < 0.75) return this.leftBottom;
        return this.rightBottom
    },
    ____96: function(p1, p2) {
        var degree = this.____97(p1, p2);
        if (degree > 0 && degree <= 90) return this.rightBottom;
        else if (degree > 90 && degree <= 180) return this.leftBottom;
        else if (degree < 0 && degree >= -90) return this.rightTop;
        else if (degree < -90 && degree >= -180) return this.leftTop;
        return this.rightBottom
    },
    ____97: function(p1, p2) {
        return this.____98(p1, p2) / Math.PI * 180
    },
    ____98: function(p1, p2) {
        var dx = p2.x - p1.x;
        var dy = p2.y - p1.y;
        return Math.atan2(dy, dx)
    },
    ____99: function(p, angle, distance) {
        return ____654.____673.____159(p.x + Math.cos(angle) * distance, p.y + Math.sin(angle) * distance)
    },
    isLeft: function(dir) {
        if (dir == this.leftTop || dir == this.left || dir == this.leftBottom) return true;
        return false
    },
    isTop: function(dir) {
        return dir == this.leftTop || dir == this.top || dir == this.rightTop
    }
});
var ____510 = cc.Class.extend({
    global_triggerNext: 100002,
    ____698: 100003,
    global_panelClose: 100004,
    global_hourUpdate: 100005,
    global_dayUpdate: 100006,
    global_controllPadReset: 100007,
    global_socketClose: 100008,
    UI_scrollView_scroll: 100501,
    ____699: 101001,
    start_clearAllView: 101002,
    start_selectServer: 101003,
    start_restart: 101004,
    common_taskStateUpdate: 102001,
    common_taskCountUpdate: 102002,
    common_taskSubmit: 102003,
    common_taskAccept: 102004,
    common_taskDelete: 102005,
    common_itemListUpdate: 102020,
    common_itemInfoUpdate: 102021,
    common_itemInfoDelete: 102022,
    common_itemCountUpdate: 102023,
    common_testerItemUpdate: 102024,
    common_equipQualityUp: 102025,
    common_mailReadUpdate: 102040,
    common_mailFetchUpdate: 102041,
    common_mailListUpdate: 102042,
    common_mailDelete: 102043,
    common_friendListUpdate: 102060,
    common_friendStateUpdate: 102061,
    common_friendInfoUpdate: 102062,
    common_rankInfoUpdate: 102063,
    common_friendTJCountUpdate: 102064,
    commom_friendTJListUpdate: 102065,
    common_friendSelectItem: 102066,
    common_addFriend: 102067,
    common_deleteFriend: 102068,
    common_friendResponseUpdate: 102069,
    common_showFollowPanel: 102070,
    common_closeOtherPanel: 102080,
    common_showNumberPanel: 102081,
    common_rankJiazuWarUpdate: 102082,
    common_showTeamPanel: 102083,
    common_hideTeamPanel: 102084,
    common_rankDoushenRankUpdate: 102085,
    common_rankDoushenInfoUpdate: 102086,
    common_rankWushenRankUpdate: 102087,
    common_showChatPanel: 102088,
    common_rankCopyUpdate: 102089,
    common_hideChatPanel: 102090,
    common_changeTabIndex: 102500,
    common_clearAllData: 102501,
    common_taskClubAndDailyUpdate: 102502,
    playerInfo_selfInfo: 103000,
    ____703: 103001,
    ____704: 103002,
    playerInfo_move: 103004,
    playerInfo_dir: 103005,
    playerInfo_select: 103006,
    playerInfo_styleReload: 103007,
    ____708: 103008,
    playerInfo_addBuff: 103009,
    playerInfo_removeBuff: 103010,
    playerInfo_updateBuff: 103011,
    playerInfo_hpUpdate: 103012,
    playerInfo_nick: 103013,
    playerInfo_updateTitle: 103014,
    playerInfo_addTitle: 103015,
    playerInfo_removeTitle: 103016,
    ____702: 103017,
    ____701: 103018,
    playerInfo_collect: 103019,
    playerInfo_skillCD: 103020,
    playerInfo_addSkill: 103021,
    playerInfo_skillUpdate: 103022,
    playerInfo_removeSkill: 103023,
    ____709: 103024,
    playerInfo_modeUpdate: 103025,
    playerInfo_dispose: 103026,
    playerInfo_skillListUpdate: 103027,
    playerInfo_xianweiUpdate: 103028,
    playerInfo_combatUpdate: 103029,
    playerInfo_club: 103030,
    playerInfo_titleChange: 103031,
    playerInfo_nameChange: 103032,
    playerInfo_skillStateChange: 103033,
    playerInfo_afkChange: 103034,
    sceneInfo_addNpc: 104001,
    sceneInfo_removeNpc: 104002,
    sceneInfo_walkComplete: 104003,
    sceneInfo_walkStart: 104004,
    sceneInfo_mapData: 104005,
    sceneInfo_selfInfo: 104006,
    sceneInfo_addPlayer: 104007,
    sceneInfo_removePlayer: 104008,
    sceneInfo_selectChange: 104009,
    sceneInfo_monsterDead: 104010,
    sceneInfo_addMonster: 104011,
    sceneInfo_removeMonster: 104012,
    sceneInfo_addDrop: 104013,
    sceneInfo_removeDrop: 104014,
    sceneInfo_addCollect: 104015,
    sceneInfo_removeCollect: 104016,
    sceneInfo_addGate: 104017,
    sceneInfo_removeGate: 104018,
    sceneInfo_addPet: 104019,
    sceneInfo_removePet: 104020,
    sceneInfo_npcState: 104021,
    sceneInfo_defaultSkillClick: 104022,
    sceneInfo_afkUpdate: 104023,
    sceneInfo_sendSkillOnce: 104024,
    sceneInfo_petUpdate: 104025,
    sceneInfo_selectAttackTarget: 104026,
    sceneInfo_chenZhuUpdate: 104027,
    stat_online_update: 105001,
    stat_shopItem_update: 105002,
    stat_shopList_update: 105003,
    stat_copyStat_update: 105004,
    stat_copyEnter_update: 105005,
    stat_copyReset_update: 105006,
    stat_copyMission_update: 105007,
    mainmenu_foldBtn: 106001,
    mainmenu_mailBtn: 106002,
    mainmenu_exitBtn: 106003,
    mainmenu_fightMode: 106004,
    mainmenu_actIconUpdate: 106005,
    mainmenu_timeIconUpdate: 106006,
    mainmenu_timeIconRemove: 106008,
    mainmenu_headClick: 106009,
    mainmenu_exitTimeUpdate: 106010,
    club_list_update: 107001,
    club_info_update: 107002,
    club_memberList_update: 107003,
    club_myData_update: 107004,
    club_applyList_update: 107005,
    club_xinfaInfo_update: 107006,
    club_godTreeInfo_update: 107007,
    club_RequteInfo: 107008,
    club_join: 107009,
    club_leave: 107010,
    club_expeditionBossHp: 107011,
    club_expeditionHurtInfo: 107012,
    club_bossInfoUpdate: 107013,
    club_bossRankDamageUpdate: 107014,
    club_memberList_update_Kick: 107015,
    club_memberList_update_jobUpdate: 107016,
    chat_read: 108001,
    ____761: 108002,
    chat_unreadCountReset: 108003,
    activity_infoUpdate: 109001,
    activity_awardUpdate: 109002,
    global_comboBox: 199999,
    activity_infoUpdate: 109001,
    activity_awardUpdate: 109002,
    activity_totalActivityUpdate: 109003,
    fashion_infoUpdate: 109501,
    fashion_hauxingUpdate: 109502,
    copy_monsterUpdate: 110001,
    copy_waveUpdate: 110002,
    copy_timeUpdate: 110003,
    copy_showComplatePanel: 110005,
    copy_exit: 110006,
    copy_awardStateUpdate: 110007,
    copy_starUpdate: 110008,
    copy_teamUpdate: 110009,
    copy_npcHpUpdate: 110010,
    copy_sweepComplate: 110011,
    copy_finish: 110012,
    copy_reset: 110013,
    advance_infoUpdate: 111001,
    advance_useStarUpdate: 111002,
    advance_equipUpdate: 111003,
    advance_danUpdate: 111004,
    advance_soulUpdate: 111005,
    adavnce_propertyUpdate: 111006,
    weapon_godInfoUpdate: 112001,
    weapon_strengthResult: 112011,
    weapon_soulInfoUpdate: 112021,
    weapon_stoneInfoUpdate: 112022,
    weapon_showXiLianPanel: 112023,
    weapon_xilianResult: 112024,
    weapon_potInfoUpdate: 112025,
    panel_open_payPanel: 200001,
    panel_open_awardPanel: 200002,
    panel_close_awardPanel: 200003,
    panel_open_dailyFirst: 200004,
    panel_open_waiXingChongJie: 200005,
    trigger_walkToNpc: 113001,
    trigger_walkToMonster: 113002,
    trigger_walkToCollect: 113003,
    trigger_flyToMap: 113004,
    trigger_walkStop: 113005,
    trigger_walkToPoint: 113006,
    worldBoss_hurtUpdate: 114000,
    worldBoss_stateUpdate: 114001,
    godBoss_infoUpdate: 114002,
    personBoss_infoUpdate: 114003,
    godBoss_restinfoUpdate: 114004,
    worldBossSelf_hurtUpdate: 114005,
    xuanshang_infoUpdate: 114006,
    war_daluandou_info: 115000,
    war_daluandou_rank: 115001,
    war_showWushenMatchPanel: 115002,
    war_wushen_info: 115003,
    war_jiazu_signUpdate: 115004,
    war_jiazu_infoUpdate: 115005,
    war_jiazu_guwuUpdate: 115006,
    war_jiazu_collectUpdate: 115007,
    war_jiazu_pointUpdate: 115008,
    war_doushen_result: 115009,
    war_cifu_state: 115010,
    war_cifu_get: 115011,
    war_zhuoyao_info: 115012,
    war_zhuoyao_monsterTime: 115013,
    war_xunbao_info: 115014,
    war_showXunBaoMatchPanel: 115015,
    war_showZhuoYaoMatchPanel: 115016,
    war_showTGHJMatchPanel: 115017,
    war_tghj_info: 115018,
    war_tghj_boxComplete: 115019,
    war_tghj_boxTrans: 115020,
    war_tghj_nextFloor: 115021,
    war_wushen_enterCount: 115022,
    welfare_weekSignUpdate: 116001,
    welfare_MonthCardUpdate: 116002,
    welfare_ResRecoverUpdate: 116003,
    welfare_ZhuanShuUpdate: 116004,
    welfare_ZhuanShuShowBuyView: 116005,
    luckyTreasure_infoUpdate: 116006,
    luckyTreasure_pickUpdate: 116007,
    open_luckyTreasurePanel: 116008,
    open_xianweiTipsPanel: 116009,
    warPlacePanel: 116500,
    team_quit: 117002,
    team_update: 117003,
    vip_awardUpdate: 118001,
    returnGiftInfo: 119001,
    kuozhanUpdate: 119002,
    playerInfo_openTemplate: 121001,
    playerInfo_loginGiftInfo_Update: 121002,
    playerInfo_selfInfo_Update: 121003,
    playerInfo_waiXingChongJie: 121004,
    playerInfo_feiXianInfo_Update: 122001,
    tuJian_awardUpdate: 123001,
    welcome_awardPanel: 124001,
    guide_npcTalkView: 124002,
    timing_active_jumpTo: 124003,
    open_xianWeiUpLevelPanel: 124004,
    open_guideRiderPanel: 124005,
    open_onlineAwardPanel: 125001,
    guide_strength: 130001,
    guide_enterXiuXianCopy: 130002,
    guide_enterCaiLiaoCopy: 130003,
    guide_advanceUp: 130004,
    guide_wuHunLevelUp: 130005,
    guide_challengePersonBoss: 130006,
    guide_equipRiderEquip: 130007,
    guide_openRiderEquip: 130008,
    guide_openEquipBag: 130009,
    guide_clickXiLianBtn: 130010,
    guide_confirmXiLianPro: 130011,
    guide_closeXiLianPanel: 130012,
    guide_confirmXiLianAgain: 130013,
    guide_doTask: 130014,
    look_InfoReturn: 140001,
    setting_showPlayerChange: 150001,
    setting_tongzhiChange: 150003,
    marry_infoUpdate: 155001,
    marry_chooseFriend: 155002,
    oath_infoUpdate: 155005,
    oath_brotherInfoUpdate: 155006,
    home_infoUpdate: 156001,
    home_friendInfoUpdate: 156002,
    home_LianDanReward: 156003,
    dailyRechargeInfoUpdate: 156501,
    familyTreasuresListUpdate: 156601,
    myFamilyTreasuresListUpdate: 156602,
    familyTreasuresHelpListUpdate: 156603,
    familyTreasuresPopUpdate: 156604,
    closeFamilyTreasuresPanel: 156605,
    common_popData: 199999,
});
var ____1951 = cc.Class.extend({
    item: null,
    skill: null,
    buff: null,
    ctor: function() {
        this.item = "icon.jpg";
        this.skill = "skillIcon.png";
        this.buff = "buffIcon.jpg"
    },
});
var LevelType = cc.Class.extend({
    openLevel: 35,
    feixianLevel: 20,
    loginGiftLevel: 20,
    onlineLevel: 20,
    bossLevel: 50,
    lilianLevel: 40,
    copyLevel: 40,
    warLevel: 45,
    waiguanLevel: 5,
    weaponLevel: 30,
    tujianLevel: 50,
    shejiaoLevel: 45,
    rankLevel: 55,
    homeLevel: 60,
    xiuxianCopyLevel: 40,
    waiguanCopyLevel: 40,
    cailiaoCopyLevel: 45,
    yaotaCopyLevel: 45,
    tongtianLevel: 50,
    shouhuLevel: 50,
    xianjieLevel: 65,
    godLevel: 30,
    strengthLevel: 30,
    baoshiLevel: 48,
    wuhunLevel: 48,
    ronglianLevel: 48,
    marryLevel: 65,
    jieYiLevel: 65,
    riderLevel: 5,
    petLevel: 10,
    wingLevel: 15,
    footLevel: 20,
    fabaoLevel: 25,
    zhenlingLevel: 30,
    shenjianLevel: 35,
    dailyFirstRechargeLevel: 22,
    waiXingChongJieLevel: 35,
    downloadLevel: 12,
    showIconLevel: 44,
});
var ____1952 = cc.Class.extend({
    ____762: 10001,
    ____763: 10002,
    ____764: 10003,
    ____765: 10004,
    ____766: 10006,
    ACCOUNT_DELETE: 10007,
    LOGOUT: 10012,
    LOGIN: 10013,
    CLUB_CREATE: 11001,
    CLUB_APPLY: 11003,
    CLUB_APPLY_LIST: 11004,
    CLUB_APPLY_DEAL: 11005,
    CLUB_INFO: 11006,
    CLUB_LIST: 11007,
    CLUB_MEMBER_LIST: 11008,
    CLUB_LEAVE: 11009,
    CLUB_AUTO_JOIN_LEVEL: 11010,
    CLUB_DEVOTE: 11011,
    CLUB_MYDATA: 11013,
    CLUB_NOTICE_SAVE: 11014,
    CLUB_JOB_UPDATE: 11015,
    CLUB_MASTER_UPDATE: 11016,
    CLUB_MEMBER_KICK: 11017,
    CLUB_REQUTENUM: 11020,
    CLUB_JOIN_TIP: 11021,
    CLUB_XINFA_UP: 11051,
    CLUB_XINFA_INFO: 11052,
    CLUB_AUTO_JOIN: 11062,
    CLUB_GODTREE_INFO: 11071,
    CLUB_GODTREE_GETAWARD: 11072,
    CLUB_GODTREE_UP: 11073,
    MAP_ENTER: 12001,
    MAP_USER_ADD: 12003,
    MAP_USER_REMOVE: 12004,
    MAP_MONSTER_UPDATE: 12005,
    MAP_ROUND_INFO: 12007,
    MAP_MONSTER_MOVE: 12009,
    PLAYER_MOVE: 12010,
    PLAYER_MOVE_STEP: 12011,
    PLAYER_RELIVE: 12013,
    PLAYER_CLUB_UPDATE: 12014,
    MAP_FLY: 12015,
    PLAYER_STYLE_UPDATE: 12017,
    PLAYER_NAME_CHANGE: 12018,
    PLAYER_MAP_TITLE: 12021,
    COLLECT_STATE: 12023,
    MAP_MONSTER_REMOVE: 12030,
    COLLECT_UPDATE: 12031,
    COLLECT_START: 12032,
    PLAYER_FIX_POS: 12033,
    COPY_FINISH: 12040,
    COPY_ENTER: 12041,
    COPY_INFO_UPDATE: 12042,
    COPY_EXIT: 12043,
    COPY_SHOWHU_UPDATE: 12044,
    COPY_MAXMISSION: 12045,
    COPY_ENTERCOUNT: 12051,
    COMMONRANK_INFO: 12055,
    COPYRANK_BAZHU: 12056,
    PLAYER_JUMP: 12510,
    COPY_TIMEUPDATE: 12800,
    COPY_MONSTERUPDATE: 12801,
    COPY_EXIT_PANEL: 12803,
    COPY_SWEEP_START: 13004,
    COPY_SWEEP_COMPLATE: 13008,
    COPY_AWARDUPDATE: 13030,
    COPY_STARCOUNT: 13031,
    COPY_STARACCEPT: 13032,
    COPY_STARCOMPLATE: 13033,
    COPY_REST: 13040,
    COPY_RESTINFO: 13041,
    COPY_XUNBAO_INFO: 13080,
    COPY_XUNBAO_RANK: 13081,
    COPY_XUNBAO_MATCH_EXIT: 13083,
    COPY_XUNBAO_MATCH: 13084,
    COPY_STARTMATCH: 13090,
    COPY_ENDMATCH: 13091,
    COPY_CREATETEAM: 13092,
    COPY_YAOQINGPLAYER: 13093,
    COPY_YAOQINGNOTICE: 13094,
    COPY_YAOQINGBACK: 13095,
    COPY_QUITTEAM: 13096,
    COPY_KICKOUTTEAM: 13097,
    COPY_TEAMINFO: 13098,
    COPY_TEAMENTER: 13099,
    DOUSHEN_INFO: 13100,
    DOUSHEN_RANK: 13101,
    DOUSHEN_SPEED: 13102,
    DOUSHEN_TIMES: 13103,
    DOUSHEN_FIGTH: 13104,
    DOUSHEN_ACTIVE: 13105,
    DOUSHEN_AWARD: 13106,
    DOUSHEN_AWARD_INFO: 13107,
    DALUANDOU_INFO: 13150,
    DALUANDOU_RANK: 13151,
    DALUANDOU_AWARD: 13152,
    ZHUOYAO_INFO: 13161,
    ZHUOYAO_AWARD: 13162,
    ZHUOYAO_MATCH: 13163,
    ZHUOYAO_MATCH_EXIT: 13164,
    ZHUOYAO_TIME: 13165,
    JIAZU_WAR_INFO: 13170,
    JIAZU_WAR_SUBMIT: 13171,
    JIAZU_WAR_AWARD: 13172,
    JIAZU_WAR_COLLECT: 13173,
    JIAZU_WAR_GUWU: 13174,
    JIAZU_WAR_SIGN: 13175,
    JIAZU_WAR_SIGNNUM: 13176,
    JIAZU_WAR_SIGNRANK: 13177,
    JIAZU_WAR_POINT: 13178,
    JIAZU_WAR_GUWURESULT: 13179,
    TIMING_ICON_UPDATE: 13200,
    CLUB_EXPEDITION_AWARD: 13300,
    CLUB_EXPEDITION_BOSS_HP: 13301,
    CLUB_EXPEDITION_HURT: 13302,
    CLUB_EXPEDITION_RESET: 13303,
    SHOUHU_INFO_UPDATE: 13311,
    WUSHEN_RANK: 13400,
    WUSHEN_INFO: 13401,
    WUSHEN_MATCH_START: 13402,
    WUSHEN_MATCH_CANCEL: 13403,
    WUSHEN_BEGIN_TIME: 13404,
    XUANSHANG_INFO: 13510,
    XUANSHANG_FRESH: 13511,
    XUANSHANG_CREATETEAM: 13512,
    XUANSHANG_YAOQINGPLAYER: 13513,
    XUANSHANG_YAOQINGNOTICE: 13514,
    XUANSHANG_YAOQINGBACK: 13515,
    XUANSHANG_QUITTEAM: 13516,
    XUANSHANG_KICKOUTTEAM: 13517,
    XUANSHANG_TEAMINFO: 13518,
    XUANSHANG_TEAMENTER: 13519,
    COPY_PERSONBOSS_INFO: 13714,
    CLUB_BOSS_STARTCOPY: 13801,
    CLUB_BOSS_COPYINFO: 13802,
    CLUB_BOSS_RANKINFO: 13803,
    TGHJ_MATCH: 13901,
    TGHJ_MATCH_EXTI: 13902,
    TGHJ_INFO: 13903,
    TGHJ_BOX: 13904,
    TGHJ_TRANS: 13905,
    TGHJ_REFLESH: 13906,
    TGHJ_NEXT_FLOOR: 13907,
    ITEM_PLACE_UPDATE: 14006,
    ITEM_MOVEEQUIP: 14007,
    ITEM_STRENGTH: 14011,
    ITEM_USE: 14012,
    ITEM_SELL: 14029,
    ITEM_XILIAN: 14040,
    ITEM_XILIAN_CHOOSE: 14041,
    ITEM_EQUIP_FUSION: 14042,
    ITEM_GET_MSG: 14363,
    FASHION_INFO_LIST: 14400,
    FASHION_MOVEEQUIP: 14401,
    FASHION_ACTIVE: 14402,
    FASHION_UPSTAR: 14403,
    FASHION_INFO: 14404,
    SHOP_INFOS: 14701,
    SHOP_BUY: 14702,
    RES_RECOVER_INFO: 15003,
    RETURNGIFT_INFO: 15007,
    ACTIVITY_INFO: 15031,
    ACTIVITY_AWARD: 15032,
    ACTIVITY_TOTAL: 15034,
    ACTIVITY_UPGRADE: 15035,
    ACTIVITY_BOX: 15033,
    VIP_INFO: 15041,
    VIP_GETAWARD: 15042,
    VIP_LEVEL: 15043,
    ZHUANSHU_GIFT_INFO: 15051,
    ACTIVE_CODE: 15060,
    OPEN_SELFINFO_UPDATE: 15071,
    OPENACTIVITY_GET_AWARD: 15072,
    MONTH_CARD_INFO: 15200,
    MONTH_CARD_GET_AWARD: 15201,
    PLAYER_RENAMW: 15211,
    WELCOME_AWARD: 15300,
    TU_JIAN_GET_AWARD: 15703,
    FEIXIAN_INFO_UPDATE: 15705,
    FEIXIAN_GETAWARD: 15706,
    ACTIVITY_ICON_CONFIG: 15803,
    FAMILY_TREASURES_BASE_INFO: 15811,
    FAMILY_TREASURES_MY_TRE: 15812,
    FAMILY_TREASURES_OPEN_TRE: 15813,
    FAMILY_TREASURES_FRESH: 15814,
    FAMILY_TREASURES_FOR_HELP: 15815,
    FAMILY_TREASURES_GET_AWARD: 15816,
    FAMILY_TREASURES_HELP_WABAO: 15817,
    FAMILY_TREASURES_HELP_LIST: 15818,
    FAMILY_TREASURES_GET_HELP_AWARD: 15819,
    KUOZHAN_AWARD: 15885,
    WEEK_SIGN_GET_AWARD: 15886,
    CIFU_GET: 15892,
    CIFU_STATE: 15893,
    LOGINGIFT_INFO_UPDATE: 15095,
    CHAT_MESSAGE: 16001,
    NOTICE_MESSAGE: 16011,
    LIANZHAN: 16021,
    FRIEND_OFF_LINE_MESSAGE: 16023,
    FRIEND_UPDATE: 18002,
    FRIEND_LIST_UPDATE: 18004,
    FRIEND_RECOMMEND_COUNT: 18006,
    FRIEND_DELETE: 18012,
    RECOMMEND_FRIEND_LIST: 18005,
    FRIEND_RESPONSE: 18014,
    FRIEND_ONLINE_UPDATE: 18015,
    ____779: 18016,
    LOOK_PLAYER: 18022,
    LOOK_PLAYER_ERROR: 18023,
    LOOK_PLAYER_FASHION: 18031,
    LOOK_PLAYER_COMPARE: 18032,
    BATCH_FRIEND_ACCPET: 18056,
    ADD_FRIEND_TIPS: 18060,
    MAIL_ATTACH: 19002,
    MAIL_READ: 19003,
    ____770: 19007,
    ____769: 19008,
    ____775: 20002,
    MONEY_UPDATE: 20003,
    UPDATE_USER_INFO: 20004,
    EXP_UPDATE: 20006,
    PLAYER_UPGRADE: 20007,
    BUFF_UPDATE: 20012,
    SKILL_INIT: 20014,
    TITLE_CHOOSE: 20018,
    BUFF_STATE_UPDATE: 20020,
    TITLE_LIST_UPDATE: 20021,
    PLAYER_ATTACK: 20031,
    PLAYER_GET_DROP: 20032,
    PLAYER_COLLECT: 20062,
    ONLINE_AWARD_INFO: 20501,
    ONLINE_AWARD_GET: 20503,
    LUKCY_TREASURE_INFO: 20520,
    LUKCY_TREASURE_PICK: 20521,
    LUKCY_TREASURE_GETAWARD: 20523,
    DAILY_FIRST_RECHARGE_INFO: 20525,
    WAI_XING_CHONG_JIE_INFO: 20526,
    WEAPON_STONE_INFO: 20531,
    WEAPON_STONE_UP: 20532,
    WEAPON_SOUL_INFO: 20601,
    WEAPON_SOUL_UP: 20602,
    HOME_INFO: 20801,
    HOME_SEED: 20802,
    HOME_LIANDAN_REWARD: 20804,
    HOME_PERSON_INFO: 20805,
    HOME_LIANDAN: 20807,
    HOME_FRIEND_DELETE: 20808,
    HOME_TIP_FLAG: 20809,
    WEAPON_POT_UPDATE: 20911,
    BOSS_UPDATE: 21001,
    BOSS_HURT_UPFATE: 21002,
    BOSS_SELFDAMAGE_UPDATE: 21005,
    TARGET_ATTACK: 23001,
    DROPITEM_ADD: 23002,
    DROPITEM_REMOVE: 23003,
    DROPITEM_UPDATE: 23005,
    TARGET_UPDATE_BLOOD: 23007,
    SCENE_WORD_SHOW: 23021,
    SERVERSTATE_UPDATE: 23022,
    TASK_ACCEPT: 24001,
    ____777: 24002,
    TASK_CANCEL: 24003,
    TASK_SUBMIT: 24004,
    TASK_CLIENT: 24005,
    TASK_QUICKFINISH: 24032,
    TASK_RESET: 24033,
    TASK_CLUB_DAILY_COMPLETE: 24034,
    PET_INFO_UPDATE: 25001,
    PET_ATTACK: 25002,
    PET_ADVANCE: 25003,
    PET_QN_WX: 25004,
    WEAPON_GOD_INFO: 25101,
    WEAPON_GOD_UP: 25102,
    WEAPON_GOD_USE: 25103,
    WEAPON_GOD_LIVE: 25104,
    CITYKING_INFO: 25105,
    CITYKING_MOBAI: 25106,
    ADVANCE_UPDATE: 26001,
    ADVANCE_JIHUO: 26003,
    ADVANCE_QN_WX: 26006,
    HORSE_UP: 26008,
    ADVANCE_SOUL_UPDATE: 26014,
    ADVANCE_EQUIP_UPDATE: 26400,
    MARRY_REQUEST: 29001,
    MARRY_REPLEY: 29002,
    MARRY_DIVORCE: 29003,
    MARRY_INFOUPDATE: 29004,
    MARRY_UP_LEVEL: 29005,
    MARRY_ADVANCED: 29006,
    OATH_REQUEST: 29100,
    OATH_REPLAY: 29101,
    OATH_INFO: 29102,
    OATH_DEVOICE: 29103,
    OATH_ADVANCE: 29104,
    OATH_TIPS: 29105,
    OATH_BROTHER_INFO: 29106,
    GM_MESSAGE: 30030,
    SYS_MESS: 30005,
    SYS_DATE: 30006,
});
var ____1953 = cc.Class.extend({
    startLib: 1,
    sceneModule: 2,
    role: 3,
    shop: 4,
    weapon: 5,
    club: 6,
    copy: 7,
    boss: 8,
    friend: 9,
    jieHunjieYi: 10,
    waiGuan: 11,
    ll: 12,
    welfare: 13,
    warPlace: 14,
    rank: 15,
    vip: 16,
    open: 18,
    feiXian: 19,
    tuJian: 20,
    loginGift: 21,
    openLeiChong: 22,
    look: 23,
    home: 24,
    marryOath: 25,
});
var ____1954 = cc.Class.extend({
    xianweiList: null,
    weekList: null,
    numberList: null,
    advanceName: null,
    careerName: null,
    baoshiName: null,
    compareNameList: null,
    numberPathList: null,
    ctor: function() {
        this.numberPathList = {};
        this.numberPathList[0] = {};
        this.numberPathList[0][":"] = "number/iconTip_time.png";
        this.numberPathList[0]["d"] = "number/iconTip_day.png";
        this.numberPathList[0]["o"] = "number/iconTip_open.png";
        this.numberPathList[0]["a"] = "number/iconTip_canAccept.png";
        this.numberPathList[0]["l"] = "number/iconTip_levelopen.png";
        this.numberPathList[0]["s"] = "number/iconTip_secopen.png";
        this.numberPathList[0]["."] = "number/iconTip_dot.png";
        this.numberPathList[0]["万"] = "number/iconTip_wan.png";
        this.numberPathList[0]["X"] = "number/iconTip_x.png";
        this.numberPathList[0]["x"] = "number/iconTip_x.png";
        this.numberPathList[0]["0"] = "number/iconTip_0.png";
        this.numberPathList[0]["1"] = "number/iconTip_1.png";
        this.numberPathList[0]["2"] = "number/iconTip_2.png";
        this.numberPathList[0]["3"] = "number/iconTip_3.png";
        this.numberPathList[0]["4"] = "number/iconTip_4.png";
        this.numberPathList[0]["5"] = "number/iconTip_5.png";
        this.numberPathList[0]["6"] = "number/iconTip_6.png";
        this.numberPathList[0]["7"] = "number/iconTip_7.png";
        this.numberPathList[0]["8"] = "number/iconTip_8.png";
        this.numberPathList[0]["9"] = "number/iconTip_9.png";
        this.numberPathList[101] = {};
        this.numberPathList[101]["m"] = "scene/bloodMiss.png";
        this.numberPathList[101]["-"] = "scene/bloodPlus2.png";
        this.numberPathList[101]["0"] = "scene/bloodNum3_0.png";
        this.numberPathList[101]["1"] = "scene/bloodNum3_1.png";
        this.numberPathList[101]["2"] = "scene/bloodNum3_2.png";
        this.numberPathList[101]["3"] = "scene/bloodNum3_3.png";
        this.numberPathList[101]["4"] = "scene/bloodNum3_4.png";
        this.numberPathList[101]["5"] = "scene/bloodNum3_5.png";
        this.numberPathList[101]["6"] = "scene/bloodNum3_6.png";
        this.numberPathList[101]["7"] = "scene/bloodNum3_7.png";
        this.numberPathList[101]["8"] = "scene/bloodNum3_8.png";
        this.numberPathList[101]["9"] = "scene/bloodNum3_9.png";
        this.numberPathList[102] = {};
        this.numberPathList[102]["+"] = "scene/bloodPlus1.png";
        this.numberPathList[102]["0"] = "scene/bloodNum2_0.png";
        this.numberPathList[102]["1"] = "scene/bloodNum2_1.png";
        this.numberPathList[102]["2"] = "scene/bloodNum2_2.png";
        this.numberPathList[102]["3"] = "scene/bloodNum2_3.png";
        this.numberPathList[102]["4"] = "scene/bloodNum2_4.png";
        this.numberPathList[102]["5"] = "scene/bloodNum2_5.png";
        this.numberPathList[102]["6"] = "scene/bloodNum2_6.png";
        this.numberPathList[102]["7"] = "scene/bloodNum2_7.png";
        this.numberPathList[102]["8"] = "scene/bloodNum2_8.png";
        this.numberPathList[102]["9"] = "scene/bloodNum2_9.png";
        this.numberPathList[103] = {};
        this.numberPathList[103]["m"] = "scene/bloodMiss.png";
        this.numberPathList[103]["b"] = "scene/bloodNum0_hit.png";
        this.numberPathList[103]["0"] = "scene/bloodNum0_0.png";
        this.numberPathList[103]["1"] = "scene/bloodNum0_1.png";
        this.numberPathList[103]["2"] = "scene/bloodNum0_2.png";
        this.numberPathList[103]["3"] = "scene/bloodNum0_3.png";
        this.numberPathList[103]["4"] = "scene/bloodNum0_4.png";
        this.numberPathList[103]["5"] = "scene/bloodNum0_5.png";
        this.numberPathList[103]["6"] = "scene/bloodNum0_6.png";
        this.numberPathList[103]["7"] = "scene/bloodNum0_7.png";
        this.numberPathList[103]["8"] = "scene/bloodNum0_8.png";
        this.numberPathList[103]["9"] = "scene/bloodNum0_9.png";
        this.numberPathList[104] = {};
        this.numberPathList[104]["m"] = "scene/bloodMiss.png";
        this.numberPathList[104]["b"] = "scene/bloodNum1_hit.png";
        this.numberPathList[104]["0"] = "scene/bloodNum1_0.png";
        this.numberPathList[104]["1"] = "scene/bloodNum1_1.png";
        this.numberPathList[104]["2"] = "scene/bloodNum1_2.png";
        this.numberPathList[104]["3"] = "scene/bloodNum1_3.png";
        this.numberPathList[104]["4"] = "scene/bloodNum1_4.png";
        this.numberPathList[104]["5"] = "scene/bloodNum1_5.png";
        this.numberPathList[104]["6"] = "scene/bloodNum1_6.png";
        this.numberPathList[104]["7"] = "scene/bloodNum1_7.png";
        this.numberPathList[104]["8"] = "scene/bloodNum1_8.png";
        this.numberPathList[104]["9"] = "scene/bloodNum1_9.png"
    },
    getXianweiName: function(xianwei) {
        if (xianwei == null || xianwei < 1) {
            xianwei = 1
        }
        return this.xianweiList[xianwei - 1]
    },
    getCareerName: function(career) {
        if (career != null) {
            if (this.careerName[career - 1] != null) {
                return this.careerName[career - 1]
            }
        }
        return ""
    },
    getSelfXianweiName: function() {
        return this.getXianweiName(____655.____667.xianwei)
    },
    getWeekName: function(day) {
        return this.weekList[day]
    },
    getAdvanceName: function(type) {
        if (type == ____655.____659.commonStaticType.style_Pet) {
            return this.advanceName[1]
        } else if (type == ____655.____659.commonStaticType.style_Horse) {
            return this.advanceName[0]
        } else if (type == ____655.____659.commonStaticType.style_Foot) {
            return this.advanceName[3]
        } else if (type == ____655.____659.commonStaticType.style_Wind) {
            return this.advanceName[2]
        } else if (type == ____655.____659.commonStaticType.style_FaBao) {
            return this.advanceName[4]
        } else if (type == ____655.____659.commonStaticType.style_ZhengLing) {
            return this.advanceName[5]
        } else if (type == ____655.____659.commonStaticType.style_ShenJian) {
            return this.advanceName[6]
        }
        return ""
    },
    getChineseNumber: function(number) {
        if (number % 10 == 0) {
            var num2 = Math.max(Math.floor(number / 10) * 10 - 1, 0);
            return num2
        } else {
            var num1 = (number % 10 - 1);
            var num2 = Math.max(Math.floor(number / 10) * 10 - 1, 0);
            return num2 * 10 + num1
        }
    },
    getChineseNumber2: function(number) {
        var num = number;
        var str = "";
        for (var i = 0; i < 2; i++) {
            var num2 = num % 10;
            str = this.numberList[num2] + str;
            num = Math.floor(num / 10);
            if (num <= 0) {
                break
            } else if (num == 1) {
                str = this.numberList[10] + str;
                break
            } else {
                str = this.numberList[10] + str
            }
        }
        return str
    },
});
var ____1955 = cc.Class.extend({
    tabGroup1: null,
    tabGroup2: null,
    sheJiaoGroup: null,
    weaponTabGroup: null,
    copyTab: null,
    bossTab: null,
    llTab: null,
    welfareTab: null,
    waiGuanTab: null,
    warPlaceTab: null,
    openTab: null,
    rankTab: null,
    vipTab: null,
    feiXianTab: null,
    loginGiftTab: null,
    tuJianTab: null,
    openLeiChongTab: null,
    lookTab: null,
    xuanshangTab: null,
    allTabs: null,
    bag: 100,
    property: 101,
    fashion: 102,
    title: 103,
    score: 104,
    copy: 201,
    shop: 501,
    weaponGod: 601,
    weaponStrength: 602,
    weaponStone: 603,
    weaponSoul: 604,
    weaponPot: 605,
    sheJiao_club: 901,
    sheJiao_xianYuan: 902,
    sheJiao_jieYi: 903,
    sheJiao_friend: 904,
    sheJiao_marryAccept: 905,
    sheJiao_oathAccept: 906,
    boss_world: 1001,
    boss_person: 1002,
    boss_shenJiang: 1003,
    boss_kuaFu: 1004,
    ll: 1005,
    active: 1006,
    warPlace: 1007,
    advance: 1201,
    waiGuan_soul: 1202,
    huaXing_rider: 1203,
    huaXing_pet: 1204,
    huaXing_wing: 1205,
    welfare: 1301,
    rank: 1401,
    vip: 1501,
    open: 1700,
    feiXian: 1710,
    loginGift: 1720,
    openLeiChong: 1730,
    tuJian: 1750,
    huanZhuang: 1751,
    tuJianYaoJing: 1752,
    lookRole: 1801,
    lookWaiguan: 1802,
    lookSoul: 1803,
    lookFashion: 1804,
    lookCompare: 1805,
    xuanshang: 1900,
    homeLianDan: 2000,
    ctor: function() {
        this.tabGroup1 = [this.bag, this.property, this.fashion, this.title];
        this.tabGroup2 = [this.shop];
        this.sheJiaoGroup = [this.sheJiao_club, this.sheJiao_friend];
        this.weaponTabGroup = [this.weaponGod, this.weaponStrength, this.weaponStone, this.weaponSoul, this.weaponPot];
        this.copyTab = [this.copy];
        this.bossTab = [this.boss_world, this.boss_person, this.boss_shenJiang];
        this.waiGuanTab = [this.advance, this.waiGuan_soul, this.huaXing_rider, this.huaXing_pet, this.huaXing_wing];
        this.llTab = [this.ll, this.active];
        this.welfareTab = [this.welfare];
        this.warPlaceTab = [this.warPlace];
        this.rankTab = [this.rank];
        this.vipTab = [this.vip];
        this.openTab = [this.open];
        this.feiXianTab = [this.feiXian];
        this.loginGiftTab = [this.loginGift];
        this.openLeiChongTab = [this.openLeiChong];
        this.lookTab = [this.lookRole, this.lookWaiguan, this.lookSoul, this.lookFashion, this.lookCompare];
        this.xuanshangTab = [this.xuanshang];
        this.tuJianTab = [this.tuJian, this.huanZhuang, this.tuJianYaoJing];
        this.allTabs = [this.tabGroup1, this.tabGroup2, this.sheJiaoGroup, this.weaponTabGroup, this.copyTab, this.bossTab, this.waiGuanTab, this.llTab, this.welfareTab, this.warPlaceTab, this.rankTab, this.vipTab, this.openTab, this.feiXianTab, this.loginGiftTab, this.openLeiChongTab, this.tuJianTab, this.lookTab, this.xuanshangTab]
    },
    getTabTitle: function(tabType) {
        if (tabType == this.bag) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle1")
        } else if (tabType == this.property) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle2")
        } else if (tabType == this.fashion) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle3")
        } else if (tabType == this.title) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle4")
        } else if (tabType == this.score) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle5")
        } else if (tabType == this.shop) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle6")
        } else if (tabType == this.weaponGod) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle8")
        } else if (tabType == this.weaponStrength) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle10")
        } else if (tabType == this.weaponStone) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle11")
        } else if (tabType == this.weaponSoul) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle12")
        } else if (tabType == this.weaponPot) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle13")
        } else if (tabType == this.copy) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle14")
        } else if (tabType == this.boss_world) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle15")
        } else if (tabType == this.boss_person) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle16")
        } else if (tabType == this.boss_shenJiang) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle17")
        } else if (tabType == this.boss_kuaFu) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle18")
        } else if (tabType == this.ll) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle29")
        } else if (tabType == this.active) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle30")
        } else if (tabType == this.advance) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle19")
        } else if (tabType == this.waiGuan_soul) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle20")
        } else if (tabType == this.huaXing_rider) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle21")
        } else if (tabType == this.huaXing_pet) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle22")
        } else if (tabType == this.huaXing_wing) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle23")
        } else if (tabType == this.sheJiao_club) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle25")
        } else if (tabType == this.sheJiao_xianYuan) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle26")
        } else if (tabType == this.sheJiao_jieYi) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle27")
        } else if (tabType == this.sheJiao_friend) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle28")
        } else if (tabType == this.welfare) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle31")
        } else if (tabType == this.warPlace) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle32")
        } else if (tabType == this.rank) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle33")
        } else if (tabType == this.vip) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle34")
        } else if (tabType == this.open) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle40")
        } else if (tabType == this.feiXian) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle41")
        } else if (tabType == this.loginGift) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle44")
        } else if (tabType == this.openLeiChong) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle45")
        } else if (tabType == this.tuJian) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle42")
        } else if (tabType == this.huanZhuang) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle43")
        } else if (tabType == this.tuJianYaoJing) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle48")
        } else if (tabType == this.lookRole) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle35")
        } else if (tabType == this.lookWaiguan) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle36")
        } else if (tabType == this.lookSoul) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle37")
        } else if (tabType == this.lookFashion) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle38")
        } else if (tabType == this.lookCompare) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle39")
        } else if (tabType == this.xuanshang) {
            return ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle47")
        }
    },
    handleByTab: function(tabType, data) {
        if (tabType == this.bag || tabType == this.fashion || tabType == this.property || tabType == this.title) {
            ____654.____679.____155(____655.____659.____690.role, [tabType, data])
        } else if (tabType == this.shop) {
            ____654.____679.____155(____655.____659.____690.shop, [tabType, data])
        } else if (tabType == this.sheJiao_club) {
            ____654.____679.____155(____655.____659.____690.club, [tabType, data])
        } else if (tabType == this.sheJiao_friend) {
            ____654.____679.____155(____655.____659.____690.friend, [tabType, data]);
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_friendSelectItem, ____654.____672, null))
        } else if (tabType == this.sheJiao_xianYuan || tabType == this.sheJiao_jieYi) {
            ____654.____679.____155(____655.____659.____690.marryOath, [tabType, data])
        } else if (tabType == this.weaponGod || tabType == this.weaponStrength || tabType == this.weaponStone || tabType == this.weaponSoul || tabType == this.weaponPot) {
            ____654.____679.____155(____655.____659.____690.weapon, [tabType, data])
        } else if (tabType == this.copy || tabType == this.xuanshang) {
            ____654.____679.____155(____655.____659.____690.copy, [tabType, data])
        } else if (tabType == this.ll || tabType == this.active) {
            ____654.____679.____155(____655.____659.____690.ll, [tabType, data])
        } else if (tabType == this.warPlace) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.warPlacePanel, ____654.____672, data))
        } else if (tabType == this.boss_world || tabType == this.boss_person || tabType == this.boss_shenJiang || tabType == this.boss_kuaFu) {
            ____654.____679.____155(____655.____659.____690.boss, [tabType, data])
        } else if (tabType == this.advance || tabType == this.huaXing_rider || tabType == this.waiGuan_soul || tabType == this.huaXing_pet || tabType == this.huaXing_wing) {
            ____654.____679.____155(____655.____659.____690.waiGuan, [tabType, data])
        } else if (tabType == this.welfare) {
            ____654.____679.____155(____655.____659.____690.welfare, [tabType, data])
        } else if (tabType == this.rank) {
            ____654.____679.____155(____655.____659.____690.rank, [tabType, data])
        } else if (tabType == this.vip) {
            ____654.____679.____155(____655.____659.____690.vip, [tabType, data])
        } else if (tabType == this.open) {
            ____654.____679.____155(____655.____659.____690.open, [tabType, data])
        } else if (tabType == this.feiXian) {
            ____654.____679.____155(____655.____659.____690.feiXian, [tabType, data])
        } else if (tabType == this.loginGift) {
            ____654.____679.____155(____655.____659.____690.loginGift, [tabType, data])
        } else if (tabType == this.openLeiChong) {
            ____654.____679.____155(____655.____659.____690.openLeiChong, [tabType, data])
        } else if (tabType == this.tuJian || tabType == this.huanZhuang || tabType == this.tuJianYaoJing) {
            ____654.____679.____155(____655.____659.____690.tuJian, [tabType, data])
        } else if (tabType == this.lookRole || tabType == this.lookWaiguan || tabType == this.lookSoul || tabType == this.lookFashion || tabType == this.lookCompare) {
            ____654.____679.____155(____655.____659.____690.look, [tabType, data])
        }
    },
    isCanShow: function(tabType) {
        var level = ____655.____667.level;
        if (tabType == this.weaponStone) {
            return level >= ____655.____659.levelType.baoshiLevel
        } else if (tabType == this.weaponSoul) {
            return level >= ____655.____659.levelType.wuhunLevel
        } else if (tabType == this.weaponPot) {
            return level >= ____655.____659.levelType.ronglianLevel
        } else if (tabType == this.huaXing_pet) {
            return level >= ____655.____659.levelType.petLevel
        } else if (tabType == this.huaXing_wing) {
            return level >= ____655.____659.levelType.wingLevel
        } else if (tabType == this.lookWaiguan) {
            return ____655.lookInfo.playerInfo.level >= ____655.____659.levelType.riderLevel
        } else if (tabType == this.lookSoul) {
            var openDay = ____655.____662.getOpenDayByCurrentTime();
            if (openDay > 1 && ____655.lookInfo.playerInfo.level >= ____655.____659.levelType.riderLevel) {
                return true
            } else {
                return false
            }
        } else if (tabType == this.waiGuan_soul) {
            var openDay = ____655.____662.getOpenDayByCurrentTime();
            if (openDay > 1 && level >= ____655.____659.levelType.dailyFirstRechargeLevel) {
                return true
            } else {
                return false
            }
        } else if (tabType == this.sheJiao_xianYuan) {
            return level >= ____655.____659.levelType.marryLevel
        } else if (tabType == this.sheJiao_jieYi) {
            return level >= ____655.____659.levelType.jieYiLevel
        } else if (tabType == this.tuJianYaoJing) {
            var openDay = ____655.____662.getOpenDayByCurrentTime();
            if (openDay > 1 && level >= ____655.____659.levelType.dailyFirstRechargeLevel) {
                return true
            } else {
                return false
            }
        }
        return true
    },
});
var ____1956 = cc.Class.extend({
    PU_GONG: 1,
    PU_FANG: 2,
    PVE_HURT: 3,
    PVP_HURT: 4,
    EXP_PER: 5,
    HP_HUIFU: 6,
    MOVE_ADD: 7,
    SHENG_MING: 8,
    BAO_JI: 9,
    JIAN_REN: 10,
    MING_ZHONG: 11,
    SHAN_BI: 12,
    MOVE_SPEED: 19,
    HP_MAX_ADD: 20,
    HURT_PER1: 25,
    HURT_PER2: 26,
    SHANG_HAI: 27,
    FANG_YU: 28,
    FIXED_HP: 29,
    CHAT_ID: 30,
    propertyIdList: null,
    perPropertyIdList: null,
    PU_GONG_par: 5,
    PU_FANG_par: 5,
    SHENG_MING_par: 1,
    BAO_JI_par: 20,
    JIAN_REN_par: 20,
    MING_ZHONG_par: 20,
    SHAN_BI_par: 20,
    SHANG_HAI_par: 10,
    propertyParList: null,
    ctor: function() {
        this.propertyIdList = [this.PU_GONG, this.PU_FANG, this.SHENG_MING, this.BAO_JI, this.JIAN_REN, this.MING_ZHONG, this.SHAN_BI, this.SHANG_HAI];
        this.propertyParList = [this.PU_GONG_par, this.PU_FANG_par, this.SHENG_MING_par, this.BAO_JI_par, this.JIAN_REN_par, this.MING_ZHONG_par, this.SHAN_BI_par, this.SHANG_HAI_par];
        this.perPropertyIdList = [this.PVE_HURT, this.PVP_HURT, this.EXP_PER, this.HP_HUIFU, this.HURT_PER1, this.HURT_PER2, this.MOVE_ADD]
    },
    getNameByType: function(propertyId) {
        var str = ____654.yuyanbaoManager.getYuyanbao("common.propertyName" + propertyId);
        if (str == "") {
            return propertyId.toString()
        }
        return str
    },
    getFight: function(propertyId, value) {
        var index = this.propertyIdList.indexOf(propertyId);
        if (index == -1) {
            print("+++++找不到该属性的战斗力系数+++++", propertyId);
            return 0
        }
        return value * this.propertyParList[index]
    },
    getProperty: function(propertyId, fight) {
        var index = this.propertyIdList.indexOf(propertyId);
        if (index == -1) {
            print("+++++找不到该属性的战斗力系数+++++", propertyId);
            return 0
        }
        return Math.floor(fight / this.propertyParList[index])
    },
    isPerProperty: function(propertyId) {
        var index = this.perPropertyIdList.indexOf(propertyId);
        return index >= 0
    },
    getPropertyPar: function(propertyId) {
        var index = this.propertyIdList.indexOf(propertyId);
        return this.propertyParList[index]
    },
});
var ____1957 = cc.Class.extend({
    guide: 1,
    popup: 2,
    walk: 3,
    fly: 4,
    moduleEvent: 5,
    task: 6,
    waitToNext: 1000,
    newlyNpcTalk: 1005,
    newlyRiderTip: 1006,
    newlyGuideClick: 1007,
    walkToNpc: 103,
    walkToMonster: 104,
    walkToPoint: 105,
    walkToCollect: 107,
    popupChatPanel: 201,
    popupClubPanel: 202,
    popupActivePanel: 203,
    popupWarPanel: 204,
    popupShenjiangBossPanel: 205,
    popupLilianPanel: 206,
    popupWuhunPanel: 207,
    popupBaoshiPanel: 208,
    popupJinjiePanel: 209,
    popupQianghuaPanel: 210,
    popupShenbingPanel: 211,
    popupWaiguanPanel: 212,
    popupFashionPanel: 213,
    popupShopPanel: 214,
    popupVipPanel: 215,
    popupCopyPanel: 216,
    popupShejiaoPanel: 217,
    popupTujianPanel: 218,
    popupRankPanel: 219,
    popupHuanZhuangPanel: 220,
    popupWuShenMatchPanel: 1654,
    popupXunBaoMatchPanel: 1655,
    popupZhuoYaoMatchPanel: 1656,
    popupTGHJMatchPanel: 1657,
    popupHuanRiderPanel: 1001,
    popupHuanWingPanel: 1002,
    popupHuanPetPanel: 1003,
    popupXianYuanPanel: 1100,
    popupOathPanel: 1101,
    popupPayPanel: 1151,
    popupOnlineAwardPanel: 1201,
    popupRongLuPanel: 1202,
    popupPersonBossPanel: 1203,
    popupWorldBossPanel: 1204,
    popupWelfarePanel: 1205,
    popupTitlePanel: 1206,
    popupHunPoPanel: 1207,
    popupTGXSPanel: 1208,
    popupLuckyTresurePanel: 1209,
    popupHomeLiandan: 1210,
    popupHome: 1211,
    popupYaoJing: 1212,
    enterCopy: 1500,
    taskAccept: 601,
    ____129: 5001,
});
var ____1958 = ____591.extend({
    taskId: 0,
    leftCount: 0,
    finishDate: 0,
    isNewSubmit: false,
    _template: null,
    setTaskId: function(templateId) {
        this.taskId = templateId;
        this._template = ____655.allTemplates.taskTemplateList.____121(templateId)
    },
    ____55: function() {
        return this._template
    },
    getCanAccept: function() {
        if (this._template.repeatCount == 0) return false;
        var dd = ____655.____662.getBetweenTimeDay(this.finishDate, ____655.____662.getSystemTimeSec());
        if (dd < this._template.repeatDay) {
            return this.leftCount > 0
        }
        return false
    },
    dispose: function() {
        this._template = null;
        this._super()
    },
});
var ____528 = ____591.extend({
    taskId: 0,
    isNewAccept: false,
    needCounts: null,
    _template: null,
    state: 0,
    setTaskId: function(templateId) {
        this.taskId = templateId;
        this._template = ____655.allTemplates.taskTemplateList.____121(templateId)
    },
    ____55: function() {
        return this._template
    },
    ____115: function(str, isDispatchEvent) {
        var counts = ____654.____674.____183(str, ",");
        if (this.checkSame(this.needCounts, counts)) {
            return
        }
        this.needCounts = counts;
        if (isDispatchEvent == true) {
            this.dispatchEvent(new ____590(____655.____661.common_taskCountUpdate, this, null))
        }
    },
    getNeedCounts: function() {
        return this.needCounts
    },
    checkSame: function(counts1, counts2) {
        if (counts1 == null && counts2 == null) {
            return true
        }
        if ((counts1 == null && counts2 != null) || (counts1 != null && counts2 == null)) {
            return false
        }
        if (counts1.length != counts2.length) {
            return false
        }
        for (var i = 0; i < counts1.length; i++) {
            if (counts1[i] != counts2[i]) {
                return false
            }
        }
        return true
    },
    ____116: function() {
        for (var i = 0; i < this.needCounts.length; i++) {
            if (this.needCounts[i] > 0) {
                return false
            }
        }
        return true
    },
    ____117: function(isFirst) {
        if (isFirst == true && ____655.____667.level <= 1) {
            isFirst = false
        }
        var state = 0;
        if (this.____116()) {
            state = ____655.____659.commonStaticType.task_finishNotSubmit
        } else {
            state = ____655.____659.commonStaticType.task_acceptNotFinish
        }
        if (state == this.state) {
            return
        }
        this.state = state;
        if (this.state == ____655.____659.commonStaticType.task_finishNotSubmit) {
            if (this._template.isAutoSubmit()) {
                ____654.selfDataMessageSender.sendTaskSubmit(this.taskId)
            } else if (isFirst != true) {
                ____655.allTemplates.taskTemplateList.handleFinishTrigger(this.taskId)
            }
        } else if (this.state == ____655.____659.commonStaticType.task_acceptNotFinish) {
            if (this.isNewAccept && this._template.type != 5) {
                if ((!this._template.isAutoAccept() || this._template.preTaskIds.length > 0) && isFirst != true) {
                    ____655.allTemplates.taskTemplateList.handleNotFinishTrigger(this.taskId)
                }
            }
        }
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_taskStateUpdate, ____654.____672, this))
    },
    dispose: function() {
        this.needCounts = null;
        this._template = null;
        this._super()
    },
});
var ____529 = ____591.extend({
    currentList: null,
    complateList: null,
    ____966: 0,
    ctor: function() {
        this._super();
        this.currentList = {};
        this.complateList = {}
    },
    ____120: function(taskInfo) {
        this.currentList[taskInfo.taskId] = taskInfo;
        if (taskInfo.____55().condition == 3) {
            ____654.taskTester.addCheck(taskInfo.taskId)
        }
    },
    ____121: function(taskId) {
        return this.currentList[taskId]
    },
    removeTask: function(taskId) {
        var taskInfo = this.currentList[taskId];
        if (taskInfo != null) {
            if (taskInfo.____55().condition == 3) {
                ____654.taskTester.removeCheck(taskInfo)
            }
            taskInfo.dispose();
            this.currentList[taskId] = null;
            this.dispatchEvent(new ____590(____655.____661.common_taskDelete, this, taskId))
        }
    },
    removeTaskByGroupId: function(groupId) {
        for (var k in this.currentList) {
            var info = this.currentList[k];
            if (info != null && info.____55().groupId == groupId) {
                this.removeTask(info.taskId)
            }
        }
    },
    getTaskByType: function(type) {
        for (var k in this.currentList) {
            if (this.currentList[k] != null && this.currentList[k].____55().type == type) {
                return this.currentList[k]
            }
        }
        return null
    },
    getComplateTaskByType: function(type) {
        for (var k in this.complateList) {
            if (this.complateList[k] != null && this.complateList[k].____55().type == type) {
                return this.complateList[k]
            }
        }
        return null
    },
    addCompleteTask: function(completeInfo) {
        this.complateList[completeInfo.taskId] = completeInfo
    },
    getCompleteTask: function(taskId) {
        return this.complateList[taskId]
    },
    removeCompleteTask: function(taskId) {
        var completeInfo = this.complateList[taskId];
        if (completeInfo != null) {
            completeInfo.dispose();
            this.complateList[taskId] = null
        }
    },
    removeCompleteTaskByGroupId: function(groupId) {
        for (var k in this.complateList) {
            var info = this.complateList[k];
            if (info != null && info.____55().groupId == groupId) {
                this.removeCompleteTask(info.taskId)
            }
        }
    },
    isCanAccept: function(taskId) {
        var template = ____655.allTemplates.taskTemplateList.____121(taskId);
        var taskInfo = this.____121(taskId);
        if (taskInfo != null) return 0;
        var completeInfo = this.getCompleteTask(taskId);
        if (completeInfo != null && !completeInfo.getCanAccept()) {
            return 0
        }
        if (template.preTaskIds.length == 0) {
            var type = template.type;
            var groupId = template.groupId;
            for (var k1 in this.currentList) {
                var info = this.currentList[k1];
                if (info == null) {
                    continue
                }
                if (type == 3 || type == 4) {
                    if (info.____55().type == type) {
                        return 0
                    }
                } else {
                    if (info.____55().groupId == groupId) {
                        return 0
                    }
                }
            }
            for (var k2 in this.complateList) {
                var info = this.complateList[k2];
                if (info == null) {
                    continue
                }
                if (type == 3 || type == 4) {
                    if (info.____55().type == type) {
                        return 0
                    }
                } else {
                    if (info.____55().groupId == groupId) {
                        return 0
                    }
                }
            }
        }
        return template.getCanAccept()
    },
    getCanAcceptByNpcId: function(npcId) {
        var result = [];
        if (npcId == 0) return result;
        var list = ____655.allTemplates.taskTemplateList.listByAcceptNpc[npcId];
        for (var key in list) {
            var info = list[key];
            if (this.isCanAccept(info.id) == 2) {
                result.push(info)
            }
        }
        return result
    },
    getNotSumbitByNpcId: function(npcId) {
        var canSumbit = [];
        var cannotSumbit = [];
        for (var key in this.currentList) {
            var info = this.currentList[key];
            if (info == null) {
                continue
            }
            if (info.____55().finishNpc == npcId) {
                if (info.state == ____655.____659.commonStaticType.task_acceptNotFinish) {
                    cannotSumbit.push(info)
                } else if (____655.____659.commonStaticType.task_finishNotSubmit) {
                    canSumbit.push(info)
                }
            }
        }
        return [canSumbit, cannotSumbit]
    },
    getFollowViewTemplateList: function() {
        var result = [];
        var list = ____655.allTemplates.taskTemplateList.list;
        var isHasMain = false;
        for (var key in list) {
            var info = list[key];
            if (info.isAutoAccept()) {
                continue
            }
            if (info.type == 1 && isHasMain) {
                continue
            }
            if (this.isCanAccept(info.id) > 0) {
                result.push(info);
                if (info.type == 1) {
                    isHasMain = true
                }
            }
        }
        return result
    },
    checkAutoAccept: function() {
        this.____966 = 10;
        ____654.____678.____298(this.checkAutoAcceptTick, this)
    },
    checkAutoAcceptTick: function(delta, count) {
        this.____966--;
        if (this.____966 <= 0) {
            this.____966 = 0;
            ____654.____678.____299(this.checkAutoAcceptTick, this);
            var list = ____655.allTemplates.taskTemplateList.list;
            for (var key in list) {
                var info = list[key];
                if (info.isAutoAccept() && this.isCanAccept(info.id) == 2) {
                    ____654.selfDataMessageSender.sendTaskAccept(info.id)
                }
            }
        }
    },
    ____61: function() {
        ____654.____678.____299(this.checkAutoAcceptTick, this);
        for (var key in this.currentList) {
            if (this.currentList[key] != null) {
                this.currentList[key].dispose()
            }
        }
        this.currentList = {};
        for (var key in this.complateList) {
            if (this.complateList[key] != null) {
                this.complateList[key].dispose()
            }
        }
        this.complateList = {}
    },
});
var ____1963 = cc.Class.extend({
    id: 0,
    group: 0,
    condition: 0,
    name: "",
    des: "",
    awardList: null,
    triggers: null,
    init: function(data) {
        this.id = data.readInt();
        this.group = data.readUShort();
        this.condition = data.readInt();
        this.name = data.readString();
        this.des = data.readString();
        this.awardList = ____654.____674.strItemSplitToInts(data.readString(), ",");
        var triLen = data.readInt();
        this.triggers = [];
        for (var i = 0; i < triLen; i++) {
            var trigger = new ____539();
            trigger.init(data);
            this.triggers.push(trigger)
        }
    },
});
var ____1964 = ____514.extend({
    list: null,
    groupList: null,
    ctor: function() {
        this.list = {};
        this.groupList = {};
        this._super()
    },
    ____104: function() {
        var info = new ____1963();
        info.init(this.____1755);
        this.list[info.id] = info;
        if (this.groupList[info.group] == null) {
            this.groupList[info.group] = []
        }
        this.groupList[info.group].push(info)
    },
    getGroup: function(group) {
        return this.groupList[group]
    },
    ____238: function(id) {
        return this.list[id]
    },
});
var ActivityInfo = ____591.extend({
    activity: 0,
    totalActivity: 0,
    lilianLevel: 0,
    currentAtts: null,
    infoList: null,
    awardList: null,
    ctor: function() {
        this._super();
        this.infoList = {};
        this.awardList = {};
        this.currentAtts = [0, 0, 0, 0, 0, 0]
    },
    initInfo: function(data) {
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var id = data.readInt();
            var isOK = data.readInt();
            this.infoList[id] = isOK
        }
        this.dispatchEvent(new ____590(____655.____661.activity_infoUpdate, this))
    },
    initAward: function(data) {
        this.awardList = {};
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            this.awardList[data.readShort()] = 1
        }
        this.activity = data.readShort();
        this.dispatchEvent(new ____590(____655.____661.activity_awardUpdate, this))
    },
    initTotalActivity: function(data) {
        this.totalActivity = data.readInt();
        var tmpLevel = data.readInt();
        if (tmpLevel != 0) {
            this.currentAtts = ____655.allTemplates.lilianTemplateList.getTotalPropertyByLevel(tmpLevel)
        }
        this.lilianLevel = tmpLevel;
        this.dispatchEvent(new ____590(____655.____661.activity_totalActivityUpdate, this))
    },
    ____61: function() {
        this.activity = 0;
        this.lilianLevel = 0;
        this.totalActivity = 0;
        this.awardList = {};
        this.currentAtts = [0, 0, 0, 0, 0, 0];
        this.infoList = {}
    },
});
var ____1966 = cc.Class.extend({
    templateId: 0,
    type: 0,
    name: "",
    count: 0,
    level: 0,
    activity: 0,
    triggers: null,
    init: function(data) {
        this.templateId = data.readUByte();
        this.type = data.readUByte();
        this.name = data.readString();
        this.count = data.readInt();
        this.level = data.readUShort();
        this.activity = data.readUByte();
        var triLen = data.readInt();
        this.triggers = [];
        for (var i = 0; i < triLen; i++) {
            var trigger = new ____539();
            trigger.init(data);
            this.triggers.push(trigger)
        }
    },
});
var ____1967 = ____514.extend({
    ____1824: null,
    _list: null,
    ctor: function() {
        this._list = {};
        this.____1824 = [];
        this._super()
    },
    ____104: function() {
        var info = new ____1966();
        info.init(this.____1755);
        this.____1824.push(info);
        this._list[info.templateId] = info
    },
    sortFunc: function() {
        function listSort(info1, info2) {
            var activityInfoList = ____655.activityInfo.infoList;
            var num1 = activityInfoList[info1.templateId];
            var num2 = activityInfoList[info2.templateId];
            if (num1 != 0) {
                num1 = 9
            }
            if (num2 != 0) {
                num2 = 9
            }
            return num2 - num1
        }
        this.____1824.sort(listSort)
    },
    getListByType: function(type) {
        return this.____1824[type]
    },
    ____238: function(id) {
        return this._list[id]
    },
});
var ____1968 = cc.Class.extend({
    maxLevel: 0,
    addAtts: null,
    needLilian: 0,
    init: function(bytes) {
        this.maxLevel = bytes.readShort();
        this.addAtts = ____654.____674.____184(bytes.readString());
        this.needLilian = bytes.readInt()
    },
});
var ____1969 = ____514.extend({
    list: null,
    levelPerRound: 6,
    proTypeList: null,
    ctor: function() {
        this._super();
        this.list = []
    },
    ____104: function() {
        var info = new ____1968();
        info.init(this.____1755);
        this.list.push(info);
        if (this.proTypeList == null) {
            this.proTypeList = [];
            var list = info.addAtts;
            for (var i = 0; i < list.length; i++) {
                this.proTypeList.push(list[i].id)
            }
        }
    },
    ____105: function() {
        this._super();
        if (this.list.length <= 0) {
            return
        }

        function listSort(info1, info2) {
            return info1.maxLevel - info2.maxLevel
        }
        this.list.sort(listSort)
    },
    getInfoByLevel: function(level) {
        for (var i = 0; i < this.list.length; i++) {
            var info = this.list[i];
            if (info.maxLevel > level) return info
        }
        return null
    },
    getAddPropertyByLevel: function(nextLevel) {
        var index = (nextLevel - 1) % this.levelPerRound;
        for (var i = 0; i < this.list.length; i++) {
            if (nextLevel <= this.list[i].maxLevel) {
                return this.list[i].addAtts[index].value
            }
        }
        return 0
    },
    getTotalPropertyByLevel: function(level) {
        var roundLevel = Math.floor(level / this.levelPerRound);
        var nextLevel = Math.ceil(level / this.levelPerRound);
        var higherNum = level % this.levelPerRound;
        var levelList = [];
        var propertyList = [];
        for (var l = 0; l < this.levelPerRound; l++) {
            if (l >= higherNum) {
                levelList.push(roundLevel)
            } else {
                levelList.push(nextLevel)
            }
            propertyList.push(0)
        }
        var lastLevel = 0;
        for (var i = 0; i < this.list.length; i++) {
            var maxLevel = Math.floor(this.list[i].maxLevel / this.levelPerRound);
            for (var j = 0; j < this.levelPerRound; j++) {
                if (levelList[j] >= maxLevel) {
                    propertyList[j] += this.list[i].addAtts[j].value * (maxLevel - lastLevel)
                } else {
                    if (levelList[j] > lastLevel) {
                        propertyList[j] += this.list[i].addAtts[j].value * (levelList[j] - lastLevel)
                    }
                }
            }
            lastLevel = maxLevel
        }
        return propertyList
    },
});
var ____1970 = cc.Class.extend({
    templateId: 0,
    name: "",
    level: 0,
    startTime: 0,
    endTime: 0,
    dec: "",
    day: null,
    award: null,
    triggers: null,
    path: "",
    init: function(data) {
        this.templateId = data.readInt();
        this.level = data.readUShort();
        this.name = data.readString();
        this.startTime = data.readInt();
        this.endTime = data.readInt();
        this.dec = data.readString();
        this.day = ____654.____674.____183(data.readString(), ",");
        this.award = ____654.____674.____183(data.readString(), ",");
        var len = data.readInt();
        this.triggers = [];
        for (var i = 0; i < len; i++) {
            var trigger = new ____539();
            trigger.init(data);
            this.triggers.push(trigger)
        }
        this.path = data.readString()
    },
    isInTime: function(time) {
        return false
    },
});
var ____1971 = ____514.extend({
    todayList: null,
    list: null,
    listDic: null,
    ctor: function() {
        this.list = [];
        this.listDic = {};
        this._super()
    },
    ____104: function() {
        var info = new ____1970();
        info.init(this.____1755);
        this.list.push(info);
        this.listDic[info.templateId] = info
    },
    ____105: function() {
        this._super();

        function sortFuc(info1, info2) {
            return info1.startTime - info2.startTime
        };
        this.list.sort(sortFuc)
    },
    updateList: function() {
        if (this.todayList == null) {
            this.todayList = [];
            var day = ____655.____662.getClientDate().getDay();
            if (day == 0) {
                day = 7
            }
            for (var i in this.list) {
                if (this.list[i].day.indexOf(day) >= 0) {
                    this.todayList.push(this.list[i])
                }
            }
        }
    },
    ____238: function(id) {
        return this.listDic[id]
    },
});
var ____1972 = ____591.extend({
    templateId: 0,
    star: 0,
    quality: 0,
    template: null,
    ____107: function(id) {
        if (this.templateId == id) return;
        this.templateId = id;
        this.template = ____655.allTemplates.____794.getOtherItem(id)
    },
    init: function(data) {
        this.____107(data.readInt());
        this.star = data.readUByte();
        this.quality = data.readUByte()
    },
    getWaiXingFight: function() {
        return Math.floor(this.star * ____655.____659.categoryType.waixingEquipFight * ____655.____659.categoryType.waixingEquipQuality[this.quality])
    },
    dispose: function() {
        this.template = null;
        this._super()
    },
});
var ____1973 = ____591.extend({
    type: 0,
    qiangNeng: 0,
    wuxing: 0,
    fight: 0,
    template: null,
    skillList: null,
    afkSkillList: null,
    equipList: null,
    attList: null,
    starCount: 0,
    currentUseStar: 0,
    soulLevel: 0,
    ctor: function() {
        this._super();
        this.equipList = {}
    },
    init: function(type, data) {
        this.type = type;
        var currentCount = data.readUShort();
        var isUpdate = (this.starCount != currentCount);
        this.starCount = currentCount;
        this.template = ____655.allTemplates.advanceTemplateList.getStarInfo(this.type, this.starCount);
        if (this.template == null) {
            print("+++++进阶系统-服务器发的总星数在模板表找不到匹配的数据+++++", this.type, this.starCount)
        }
        var qiangNeng = data.readUShort();
        var wuxing = data.readUShort();
        var isDanUpdate = false;
        if (qiangNeng != this.qiangNeng || wuxing != this.wuxing) {
            this.qiangNeng = qiangNeng;
            this.wuxing = wuxing;
            isDanUpdate = true
        }
        this.fight = data.readUInt();
        this.skillList = {};
        this.afkSkillList = [];
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var skill = new ____2050();
            skill.____54(data.readInt());
            skill.level = data.readUByte();
            this.skillList[skill.id] = skill;
            if (skill.template != null && skill.template.isAFKUse) {
                this.afkSkillList.push(skill)
            }
            if (skill.template == null) {
                print("+++++进阶系统-技能在模板表找不到匹配的数据+++++", skill.id)
            }
        }
        this.attList = [];
        len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var prop = new ____484();
            prop.id = data.readInt();
            prop.value = data.readUInt();
            this.attList.push(prop)
        }
        if (isUpdate) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.advance_infoUpdate, this, this))
        }
        if (isDanUpdate) {
            this.dispatchEvent(new ____590(____655.____661.advance_danUpdate, this, this))
        }
        if (!isUpdate && !isDanUpdate) {
            this.dispatchEvent(new ____590(____655.____661.adavnce_propertyUpdate, this, this))
        }
    },
    setCurrentUseStar: function(currentUseStar) {
        this.currentUseStar = currentUseStar;
        if (!____655.fashionInfo.isFirstUpdate) {
            this.dispatchEvent(new ____590(____655.____661.advance_useStarUpdate, this, this.currentUseStar))
        }
    },
    setSoulLevel: function(level) {
        if (this.soulLevel == level) return;
        this.soulLevel = level
    },
    moveAFKSkillToBack: function(skillId) {
        for (var i = 0; i < this.afkSkillList.length; i++) {
            if (this.afkSkillList[i].id == skillId) {
                var s = this.afkSkillList.splice(i, 1)[0];
                this.afkSkillList.push(s);
                break
            }
        }
    },
    dispose: function() {
        this.type = 0;
        this.qiangNeng = 0;
        this.wuxing = 0;
        this.fight = 0;
        this.starCount = 0;
        this.currentUseStar = 0;
        this.template = null;
        this.soulLevel = 0;
        if (this.skillList != null) {
            for (var i = 0; i < this.skillList.length; i++) {
                this.skillList[i].dispose()
            }
            this.skillList = {}
        }
        if (this.equipList != null) {
            for (var i in this.equipList) {
                if (this.equipList[i] != null) {
                    this.equipList[i].dispose()
                }
            }
            this.equipList = {}
        }
        this.afkSkillList = [];
        this.attList = []
    },
});
var ____1974 = ____591.extend({
    list: null,
    _isFirstUpdate: true,
    ctor: function() {
        this._super();
        this.list = {}
    },
    init: function(data) {
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var type = data.readUByte();
            var item = this.getItemByType(type);
            if (item == null) {
                item = new ____1973();
                this.list[type] = item
            }
            item.init(type, data)
        }
    },
    petInit: function(data) {
        var type = ____655.____659.commonStaticType.style_Pet;
        var item = this.getItemByType(type);
        if (item == null) {
            item = new ____1973();
            this.list[type] = item
        }
        item.init(type, data)
    },
    setUseStar: function(type, starCount) {
        if (this.list[type] != null) {
            this.list[type].setCurrentUseStar(starCount)
        }
    },
    getItemByType: function(type) {
        return this.list[type]
    },
    addEquipList: function(data) {
        var len = data.readByte();
        var list = [];
        for (var i = 0; i < len; i++) {
            var info = new ____1972();
            info.init(data);
            list = ____655.____659.categoryType.getAdvanceEquipPlace(info.template.categoryId);
            if (list != null) {
                var item = this.getItemByType(list[0]);
                if (item != null) {
                    if (item.equipList[list[1]] != null) {
                        item.equipList[list[1]].dispose()
                    }
                    item.equipList[list[1]] = info
                }
            }
        }
        if (len == 1) {
            this.dispatchEvent(new ____590(____655.____661.advance_equipUpdate, this, list))
        }
    },
    soulLevelUpdate: function(data) {
        var len = data.readByte();
        var type = 0;
        var level = 0;
        for (var i = 0; i < len; i++) {
            type = data.readByte();
            level = data.readShort();
            if (this.list[type] != null) {
                this.list[type].setSoulLevel(level)
            }
        }
        if (!this._isFirstUpdate) {
            this.dispatchEvent(new ____590(____655.____661.advance_soulUpdate, this, type))
        } else {
            this._isFirstUpdate = false
        }
    },
    getSoulLevelByType: function(type) {
        if (this.list[type] != null) {
            return this.list[type].soulLevel
        }
        return 0
    },
    getStarByType: function(type) {
        if (this.list[type] != null) {
            return this.list[type].starCount
        }
        return 0
    },
    ____61: function() {
        if (this.list != null) {
            for (var i in this.list) {
                if (this.list[i] != null) this.list[i].dispose()
            }
        }
        this.list = {};
        this._isFirstUpdate = true
    },
});
var ____1975 = cc.Class.extend({
    type: 0,
    stage: 0,
    name: "",
    quality: 0,
    figureId: 0,
    qianNengMax: 0,
    qianNengId: 0,
    wuxingMax: 0,
    wuxingId: 0,
    stars: null,
    ctor: function() {},
    init: function(data, type) {
        this.type = type;
        this.qianNengId = data.readInt();
        this.qianNengMax = data.readUInt();
        this.wuxingId = data.readInt();
        this.wuxingMax = data.readUInt();
        this.figureId = data.readInt();
        this.name = data.readString();
        this.quality = data.readUByte();
        this.stars = {};
        this.starCount = data.readShort();
        var firstStar = null;
        for (var i = 0; i < this.starCount; i++) {
            var starInfo = new ____1976(this);
            starInfo.init(data);
            this.stars[starInfo.starIndex] = starInfo;
            if (!firstStar) firstStar = starInfo
        }
        this.stage = ____655.allTemplates.advanceTemplateList.getStageByStar(firstStar.starIndex)
    },
    getStarInfo: function(star) {
        return this.stars[star]
    },
});
var ____1976 = cc.Class.extend({
    starIndex: 0,
    baseAttrs: null,
    needItems: null,
    parentStage: null,
    ctor: function(parentStage) {
        this.parentStage = parentStage
    },
    init: function(data) {
        this.starIndex = data.readShort();
        this.baseAttrs = ____654.____674.____184(data.readString());
        this.needItems = ____654.____674.strItemSplitToInts(data.readString());
        ____655.allTemplates.advanceTemplateList.addStarInfo(this.parentStage.type, this)
    },
});
var ____1977 = cc.Class.extend({
    type: 0,
    discount: 0,
    stages: null,
    maxStages: 0,
    ctor: function() {},
    init: function(data, type) {
        this.type = type;
        this.discount = data.readInt() * 0.01;
        this.stages = {};
        this.maxStages = 0;
        var len = data.readShort();
        for (var i = 0; i < len; i++) {
            var stageInfo = new ____1975();
            stageInfo.init(data, this.type);
            this.stages[stageInfo.stage] = stageInfo;
            if (this.maxStages < stageInfo.stage) {
                this.maxStages = stageInfo.stage
            }
        }
    },
});
var ____1978 = ____514.extend({
    _list: null,
    ____1707: null,
    ctor: function() {
        this._super();
        this._list = {};
        this.____1707 = {}
    },
    ____104: function() {
        var type = this.____1755.readUByte();
        if (this._list[type] == null) this._list[type] = {};
        var info = new ____1977(this);
        info.init(this.____1755, type);
        this._list[type] = info
    },
    addStarInfo: function(type, starInfo) {
        if (this.____1707[type] == null) this.____1707[type] = {};
        this.____1707[type][starInfo.starIndex] = starInfo
    },
    getInfoByType: function(type) {
        return this._list[type]
    },
    getStageInfo: function(type, starIndex) {
        var stageIndex = this.getStageByStar(starIndex),
            info = this._list[type].stages[stageIndex];
        assert(info, "#进阶数据不存在, type:{0}, startIndex:{1}".format(type, starIndex));
        return info
    },
    getStarInfo: function(type, starIndex) {
        return this.____1707[type][starIndex]
    },
    getMaxStage: function(type) {
        return this._list[type].maxStages
    },
    getStageByStar: function(star) {
        stage = Math.ceil(star / 5);
        return stage
    },
    getTotalStarByStage: function(stage) {
        star = stage * 5;
        return star
    },
    getCurrentStar: function(starCount) {
        star = (starCount - 1) % 5 + 1;
        return star
    },
    getCurTotalStar: function(stage) {
        return 5
    },
});
var HunPoTemplateInfo = cc.Class.extend({
    level: 0,
    attList: null,
    baseFight: 0,
    perFight: 0,
    needItem: 0,
    needStarCount: 0,
    type: 0,
    init: function(data) {
        this.level = data.readInt();
        this.type = data.readUByte();
        var fightData = data.readString();
        var tmpList = fightData.split("|");
        this.baseFight = parseInt(tmpList[0]);
        this.perFight = parseInt(tmpList[1]);
        this.attList = [];
        for (var i = 2; i < tmpList.length; i++) {
            var list = tmpList[i].split(",");
            if (list.length >= 2) {
                var tmpInfo = new ____484();
                tmpInfo.id = parseInt(list[0]);
                tmpInfo.value = parseInt(list[1]);
                this.attList.push(tmpInfo)
            }
        }
        this.needStarCount = data.readShort();
        this.needItem = ____654.____674.____183(data.readString(), ",")
    },
});
var HunPoTemplateList = ____514.extend({
    typeList: null,
    proTypeList: null,
    levelPerRound: 8,
    maxLevelList: 0,
    xinWuMaxLevelList: null,
    ctor: function() {
        this.typeList = {};
        this.proTypeList = {};
        this.maxLevelList = {};
        this.xinWuMaxLevelList = {};
        this._super()
    },
    ____104: function() {
        var info = new HunPoTemplateInfo();
        info.init(this.____1755);
        if (this.typeList[info.type] == null) {
            this.typeList[info.type] = []
        }
        this.typeList[info.type].push(info);
        if (this.proTypeList[info.type] == null) {
            this.proTypeList[info.type] = [];
            var list = info.attList;
            for (var i = 0; i < list.length; i++) {
                if (this.proTypeList[info.type].indexOf(list[i].id) == -1) {
                    this.proTypeList[info.type].push(list[i].id)
                }
            }
        }
        if (info.type == ____655.____659.commonStaticType.sheJiao_marry || info.type == ____655.____659.commonStaticType.sheJiao_oath) {
            if (this.xinWuMaxLevelList[info.type] == null) {
                this.xinWuMaxLevelList[info.type] = {}
            }
            if (this.xinWuMaxLevelList[info.type][info.needStarCount] == null) {
                this.xinWuMaxLevelList[info.type][info.needStarCount] = 0
            }
            if (this.xinWuMaxLevelList[info.type][info.needStarCount] < info.level) {
                this.xinWuMaxLevelList[info.type][info.needStarCount] = info.level
            }
        }
        if (this.maxLevelList[info.type] == null) {
            this.maxLevelList[info.type] = 0
        }
        if (this.maxLevelList[info.type] < info.level) {
            this.maxLevelList[info.type] = info.level
        }
    },
    getMaxLevel: function(type, xinWuType) {
        if (type == ____655.____659.commonStaticType.sheJiao_marry || type == ____655.____659.commonStaticType.sheJiao_oath) {
            if (xinWuType == null) {
                return this.maxLevelList[type]
            } else {
                return this.xinWuMaxLevelList[type][xinWuType]
            }
        } else {
            return this.maxLevelList[type]
        }
        return 0
    },
    getLevelPerRound: function() {
        return this.levelPerRound
    },
    getProTypeList: function(type) {
        return this.proTypeList[type]
    },
    getInfoByLevel: function(type, level) {
        if (this.typeList[type] != null) {
            for (var i = 0; i < this.typeList[type].length; i++) {
                var info = this.typeList[type][i];
                if (info.level >= level) return info
            }
        }
        return null
    },
    getNeedCountByLevel: function(type, nextLevel) {
        if (nextLevel > this.getMaxLevel(type)) return 0;
        return 1
    },
    getFightByLevel: function(type, level) {
        if (level > 0) {
            for (var i = 0; i < this.typeList[type].length; i++) {
                var info = this.typeList[type][i];
                if (level <= info.level) {
                    return info.baseFight + (((level - 1) % this.levelPerRound) + 1) * info.perFight
                }
            }
        }
        return 0
    },
    getTotalPropertyByLevel: function(type, level) {
        var propertyList = {};
        var fight = 0;
        var info = null;
        if (level > 0) {
            for (var i = 0; i < this.typeList[type].length; i++) {
                info = this.typeList[type][i];
                if (level <= info.level) {
                    fight = info.baseFight + (((level - 1) % this.levelPerRound) + 1) * info.perFight
                    break
                }
            }
        }
        if (info == null) {
            info = this.typeList[type][0]
        }
        for (var j = 0; j < info.attList.length; j++) {
            propertyList[info.attList[j].id] = ____655.____659.propertyType.getProperty(info.attList[j].id, info.attList[j].value * 0.01 * fight)
        }
        return propertyList
    },
    getXinWuAddProperty: function(type, nextLevel) {
        if (nextLevel > this.getMaxLevel(type)) return null;
        var propertyList = {};
        var lastLevel = 0;
        if (this.typeList[type] != null) {
            for (var i = 0; i < this.typeList[type].length; i++) {
                var info = this.typeList[type];
                var maxLevel = info[i].level;
                for (var j = 0; j < this.proTypeList[type].length; j++) {
                    var id = info[i].attList[j].id;
                    if (nextLevel <= maxLevel && nextLevel > lastLevel) {
                        propertyList[id] = info[i].attList[j].value
                    }
                }
                if (nextLevel <= maxLevel && nextLevel > lastLevel) {
                    break
                }
                lastLevel = maxLevel
            }
        }
        return propertyList
    },
    getXinWuNeedCount: function(type, nextLevel) {
        if (nextLevel > this.getMaxLevel(type)) return 0;
        var count = 0;
        var lastLevel = 0;
        if (this.typeList[type] != null) {
            for (var i = 0; i < this.typeList[type].length; i++) {
                var info = this.typeList[type];
                var maxLevel = info[i].level;
                for (var j = 0; j < this.proTypeList[type].length; j++) {
                    var id = info[i].attList[j].id;
                    if (nextLevel <= maxLevel && nextLevel > lastLevel) {
                        count = info[i].needItem[1]
                    }
                }
                if (nextLevel <= maxLevel && nextLevel > lastLevel) {
                    break
                }
                lastLevel = maxLevel
            }
        }
        return count
    },
    getXinWuTotalProperty: function(type, level) {
        var propertyList = {};
        var lastLevel = 0;
        if (this.typeList[type] != null) {
            for (var i = 0; i < this.typeList[type].length; i++) {
                var info = this.typeList[type];
                var maxLevel = info[i].level;
                for (var j = 0; j < this.proTypeList[type].length; j++) {
                    var id = info[i].attList[j].id;
                    if (propertyList[id] == null) {
                        propertyList[id] = 0
                    }
                    if (level >= maxLevel) {
                        propertyList[id] += info[i].attList[j].value * (maxLevel - lastLevel)
                    } else {
                        if (level > lastLevel) {
                            propertyList[id] += info[i].attList[j].value * (level - lastLevel)
                        }
                    }
                }
                lastLevel = maxLevel
            }
        }
        return propertyList
    },
});
var ____513 = cc.Class.extend({
    mapTemplateList: null,
    npcTemplateList: null,
    monsterTemplateList: null,
    titleTemplateList: null,
    ____794: null,
    ____790: null,
    skillTemplateList: null,
    gateTemplateList: null,
    copyTemplateList: null,
    collectTemplateList: null,
    shopTemplateList: null,
    payTemplateList: null,
    ____789: null,
    taskTemplateList: null,
    fashionTemplateList: null,
    advanceTemplateList: null,
    strengthCostTemplateList: null,
    strengthPropertyTemplateList: null,
    rongluTemplateList: null,
    wuhunTemplateList: null,
    dailyActivityTemplateList: null,
    timingActivityTemplateList: null,
    vipTemplateList: null,
    bossTemplateList: null,
    lilianTemplateList: null,
    clubTreeAwardTemplateList: null,
    baoShiTemplateList: null,
    baoShiEquipTemplateList: null,
    rankAwardTemplateList: null,
    awardTemplateList: null,
    expTemplateList: null,
    weekSignTemplateList: null,
    resRecoverTemplateList: null,
    douShenTemplateList: null,
    openActivityTemplateList: null,
    feiXianTemplateList: null,
    figureTemplateList: null,
    tuJianTemplateList: null,
    xianWeiTemplateList: null,
    newlyGuideTemplateList: null,
    hunPoTemplateList: null,
    luckyTreasureTemplateList: null,
    homeTemplateList: null,
    marryOathTemplateList: null,
    seedTemplateList: null,
    dailyFirstRechargeTemplateList: null,
    homePetTemplateList: null,
    familyTreasuresBaseTemplateList: null,
    familyTreasuresBoxTemplateList: null,
    homeJinjieTemplateList: null,
    ctor: function() {
        this.mapTemplateList = new ____2030();
        this.npcTemplateList = new ____2034();
        this.monsterTemplateList = new ____2032();
        this.titleTemplateList = new ____2061();
        this.____794 = new ____2028();
        this.____790 = new ____517();
        this.skillTemplateList = new ____2054();
        this.gateTemplateList = new ____2022();
        this.copyTemplateList = new ____2000();
        this.collectTemplateList = new ____1997();
        this.shopTemplateList = new ____2049();
        this.payTemplateList = new ____2040();
        this.____789 = new ____521();
        this.taskTemplateList = new ____531();
        this.fashionTemplateList = new ____2012();
        this.advanceTemplateList = new ____1978();
        this.strengthCostTemplateList = new ____2016();
        this.strengthPropertyTemplateList = new ____2018();
        this.rongluTemplateList = new ____2014();
        this.wuhunTemplateList = new ____2020();
        this.dailyActivityTemplateList = new ____1967();
        this.timingActivityTemplateList = new ____1971();
        this.vipTemplateList = new ____2063();
        this.bossTemplateList = new ____1988();
        this.lilianTemplateList = new ____1969();
        this.clubTreeAwardTemplateList = new ____1995();
        this.baoShiTemplateList = new ____1984();
        this.baoShiEquipTemplateList = new ____1982();
        this.rankAwardTemplateList = new ____2044();
        this.awardTemplateList = new AwardTemplateList();
        this.expTemplateList = new ____2006();
        this.weekSignTemplateList = new ____2067();
        this.resRecoverTemplateList = new ____2065();
        this.douShenTemplateList = new ____2002();
        this.openActivityTemplateList = new ____2036();
        this.feiXianTemplateList = new FeiXianTemplateList();
        this.figureTemplateList = new FigureTemplateList();
        this.tuJianTemplateList = new TuJianTemplateList();
        this.xianWeiTemplateList = new XianWeiTemplateList();
        this.newlyGuideTemplateList = new NewlyGuideTemplateList();
        this.hunPoTemplateList = new HunPoTemplateList();
        this.luckyTreasureTemplateList = new LuckyTreasureTemplateList();
        this.homeTemplateList = new HomeTemplateList();
        this.marryOathTemplateList = new MarryOathTemplateList();
        this.seedTemplateList = new SeedTemplateList();
        this.dailyFirstRechargeTemplateList = new DailyFirstRechargeTemplateList();
        this.homePetTemplateList = new HomePetTemplateList();
        this.familyTreasuresBaseTemplateList = new FamilyTreasuresBaseTemplateList();
        this.familyTreasuresBoxTemplateList = new FamilyTreasuresBoxTemplateList();
        this.homeJinjieTemplateList = new HomeJinjieTemplateList()
    },
});
var AwardTemplateInfo = cc.Class.extend({
    id: 0,
    type: 0,
    condition: 0,
    awardList: null,
    init: function(data) {
        this.id = data.readInt();
        this.type = data.readShort();
        this.condition = data.readString();
        this.awardList = ____654.____674.strItemSplitToInts(data.readString())
    },
});
var AwardTemplateList = ____514.extend({
    list: null,
    typeList: null,
    ctor: function() {
        this.list = {};
        this.typeList = {};
        this._super()
    },
    ____104: function() {
        var info = new AwardTemplateInfo();
        info.init(this.____1755);
        this.list[info.id] = info;
        if (this.typeList[info.type] == null) {
            this.typeList[info.type] = []
        }
        this.typeList[info.type].push(info)
    },
    getTypeList: function(type) {
        return this.typeList[type]
    },
    ____238: function(id) {
        return this.list[id]
    },
});
var ____1981 = cc.Class.extend({
    categoryId: 0,
    baoshiList: null,
    init: function(bytes) {
        this.categoryId = bytes.readUShort();
        this.baoshiList = ____654.____674.strItemSplitToInts(bytes.readString())
    },
});
var ____1982 = ____514.extend({
    list: null,
    ctor: function() {
        this.list = {}
    },
    ____104: function() {
        var item = new ____1981();
        item.init(this.____1755);
        this.list[item.categoryId] = item
    },
    getTemplateInfoByType: function(type) {
        if (this.list == null) {
            return
        }
        return this.list[type]
    },
});
var ____1983 = cc.Class.extend({
    id: 0,
    type: 0,
    level: 0,
    needExp: 0,
    atrrList: null,
    itemList: null,
    icon: null,
    init: function(bytes) {
        this.id = bytes.readInt();
        this.type = bytes.readInt();
        this.level = bytes.readUShort();
        this.needExp = bytes.readNumber();
        this.atrrList = ____654.____674.____184(bytes.readString());
        this.itemList = ____654.____674.____183(bytes.readString(), ",");
        this.icon = bytes.readString()
    },
});
var ____1984 = ____514.extend({
    list: null,
    typeList: null,
    ctor: function() {
        this._super();
        this.list = {};
        this.typeList = {}
    },
    ____104: function() {
        var item = new ____1983();
        item.init(this.____1755);
        this.list[item.id] = item;
        if (this.typeList[item.type] == null) {
            this.typeList[item.type] = []
        }
        this.typeList[item.type].push(item)
    },
    ____105: function() {
        this._super();

        function sortFunc(item1, item2) {
            return item1.level - item2.level
        }
        for (var i in this.typeList) {
            if (this.typeList[i].length > 1) {
                this.typeList[i].sort(sortFunc)
            }
        }
    },
    getTemplateByTypeAndExp: function(type, exp) {
        var list = this.typeList[type];
        if (list == null) {
            return
        }
        for (var i = list.length - 1; i >= 0; i--) {
            if (exp >= list[i].needExp) {
                return list[i]
            }
        }
    },
    getNextTemplateByTypeAndExp: function(type, exp) {
        var list = this.typeList[type];
        if (list == null) {
            return
        }
        for (var i = list.length - 1; i >= 0; i--) {
            if (exp >= list[i].needExp) {
                return list[i + 1]
            }
        }
        return list[0]
    },
    getTemplateByTypeAndLv: function(type, level) {
        var list = this.typeList[type];
        if (list == null) {
            return
        }
        for (var i = list.length - 1; i >= 0; i--) {
            if (level == list[i].level) {
                return list[i]
            }
        }
    },
});
var ____1985 = cc.Class.extend({
    bossId: 0,
    fleshState: 0,
    init: function(id, data) {
        this.bossId = id;
        this.fleshState = data.readInt()
    },
});
var ____1986 = ____591.extend({
    list: null,
    godBossRestNum: 0,
    godBossList: null,
    godBossRestNumList: null,
    personBossRemainNum: 0,
    personBossCopyList: null,
    xuanshangList: null,
    xuanshangFreshCount: 0,
    xuanshangTeamCount: 0,
    ctor: function() {
        this._super();
        this.list = {};
        this.godBossList = {};
        this.personBossCopyList = [];
        this.godBossRestNumList = {};
        this.xuanshangList = {}
    },
    init: function(data) {
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var id = data.readInt();
            var bossInfo = this.getBossInfo(id);
            if (bossInfo == null) {
                bossInfo = new ____1985();
                this.list[id] = bossInfo
            }
            bossInfo.init(id, data)
        }
        this.dispatchEvent(new ____590(____655.____661.worldBoss_stateUpdate, this, null))
    },
    getBossInfo: function(bossId) {
        return this.list[bossId]
    },
    infoReset: function() {
        this.dispatchEvent(new ____590(____655.____661.godBoss_infoUpdate, this, null))
    },
    setPersonBossInfo: function(data) {
        this.personBossRemainNum = data.readUByte();
        this.personBossCopyList = [];
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var copyId = data.readInt();
            this.personBossCopyList.push(copyId)
        }
        this.dispatchEvent(new ____590(____655.____661.personBoss_infoUpdate, this, null))
    },
    setXuanshangInfo: function(data) {
        this.xuanshangFreshCount = data.readUByte();
        this.xuanshangTeamCount = data.readUByte();
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var pos = data.readUByte();
            if (this.xuanshangList[pos] == null) {
                this.xuanshangList[pos] = new XuanshangItemInfo()
            }
            this.xuanshangList[pos].init(data)
        }
        this.dispatchEvent(new ____590(____655.____661.xuanshang_infoUpdate, this, null))
    },
    ____61: function() {
        this.list = {};
        this.personBossCopyList = [];
        this.godBossRestNum = 0;
        this.godBossList = {};
        this.godBossRestNumList = {};
        this.xuanshangList = {};
        this.xuanshangFreshCount = 0;
        this.xuanshangTeamCount = 0
    },
});
var ____1987 = cc.Class.extend({
    monsterId: 0,
    bossType: 0,
    description: null,
    items: null,
    flagShow: null,
    init: function(bytes) {
        this.monsterId = bytes.readInt();
        this.bossType = bytes.readByte();
        this.description = bytes.readString();
        this.items = ____654.____674.strItemSplitToInts(bytes.readString());
        this.flagShow = ____654.____674.____183(bytes.readString(), ",")
    },
});
var ____1988 = ____514.extend({
    list: null,
    sortList: null,
    ctor: function() {
        this._super();
        this.list = {};
        this.sortList = []
    },
    ____104: function() {
        var item = new ____1987();
        item.init(this.____1755);
        this.list[item.monsterId] = item;
        this.sortList.push(item)
    },
    ____105: function() {
        this._super();

        function sortFunc(item1, item2) {
            return item1.monsterId - item2.monsterId
        };
        this.sortList.sort(sortFunc)
    },
    ____55: function(bossId) {
        return this.list[bossId]
    },
});
var XuanshangItemInfo = cc.Class.extend({
    bossId: 0,
    star: 0,
    isKill: false,
    init: function(data) {
        this.bossId = data.readInt();
        this.star = data.readUByte();
        this.isKill = data.readBoolean()
    },
});
var ____515 = cc.Class.extend({
    templateId: 0,
    template: null,
    endTime: 0,
    ____106: function(time) {
        this.endTime = time
    },
    ____107: function(id) {
        if (id == this.templateId) return;
        this.templateId = id;
        this.template = ____655.allTemplates.____791.____85(this.templateId)
    },
    dispose: function() {
        this.template = null
    },
});
var ____516 = cc.Class.extend({
    id: 0,
    type: 0,
    states: null,
    effect: 0,
    priority: 0,
    ctor: function() {
        this.states = []
    },
    init: function(data) {
        this.id = data.readInt();
        this.type = data.readInt();
        this.states = ____654.____674.____183(data.readString(), "");
        this.effect = data.readInt();
        this.priority = data.readInt()
    },
});
var ____517 = ____514.extend({
    _list: null,
    ctor: function() {
        this._super();
        this._list = {}
    },
    ____104: function() {
        var info = new ____516();
        info.init(this.____1755);
        this._list[info.id] = info
    },
    ____55: function(id) {
        return this._list[id]
    },
});
var ____518 = BaseItemInfo.extend({
    name: "",
    descript: "",
    stateId: 0,
    ctor: function() {
        this.skillEffectList = []
    },
    init: function(data) {
        this.templateId = data.readShort();
        this.name = data.readString();
        this.picPath = data.readString();
        this.iconPath = data.picPath;
        this.descript = data.readString();
        this.stateId = data.readInt()
    },
    ____109: function() {
        return ____655.allTemplates.____790.____55(this.stateId)
    },
});
var ____519 = ____514.extend({
    _list: null,
    ctor: function() {
        this._super();
        this._list = {}
    },
    ____104: function() {
        var buff = new ____518();
        buff.init(this.____1755);
        this._list[buff.templateId] = buff
    },
    ____85: function(id) {
        return this._list[id]
    },
});
var ____1994 = cc.Class.extend({
    id: 0,
    value: 0,
    items: null,
    init: function(data) {
        this.id = data.readInt();
        this.value = data.readUInt();
        this.items = ____654.____674.strItemSplitToInts(data.readString())
    },
});
var ____1995 = ____514.extend({
    list: null,
    ctor: function() {
        this._super();
        this.list = {}
    },
    ____104: function() {
        var item = new ____1994();
        item.init(this.____1755);
        this.list[item.id] = item
    },
});
var ____1996 = cc.Class.extend({
    id: 0,
    mapId: 0,
    name: "",
    quality: 0,
    collectTime: 0,
    resetTime: 0,
    pos: null,
    picPath: "",
    width: 0,
    height: 0,
    offsetX: 0,
    offsetY: 0,
    scale: 1,
    barDescript: "",
    canAFK: false,
    minLevel: 0,
    maxLevel: 0,
    init: function(data) {
        this.id = data.readInt();
        this.name = data.readString();
        this.width = data.readShort();
        this.height = data.readShort();
        if (this.width == 0) this.width = 80;
        if (this.height == 0) this.height = 100;
        this.offsetX = data.readShort();
        this.offsetY = data.readShort();
        this.scale = data.readShort() * 0.01;
        this.collectTime = data.readInt();
        this.resetTime = data.readInt();
        this.picPath = data.readString();
        this.mapId = data.readInt();
        var tmp = ____654.____674.strSplitToPoints(data.readString());
        this.pos = tmp[Math.floor(Math.random() * tmp.length)];
        this.canAFK = data.readBoolean();
        this.quality = data.readByte();
        this.minLevel = data.readShort();
        this.maxLevel = data.readShort();
        this.barDescript = data.readString()
    },
});
var ____1997 = ____514.extend({
    list: null,
    ctor: function() {
        this.list = {};
        this._super()
    },
    ____104: function() {
        var item = new ____1996();
        item.init(this.____1755);
        this.list[item.id] = item
    },
    getCollect: function(id) {
        return this.list[id]
    },
});
var ____1998 = cc.Class.extend({
    id: 0,
    name: null,
    bossId: 0,
    diff: 0,
    needLevel: 0,
    needXianwei: 0,
    needItems: null,
    firstAwards: null,
    awards: null,
    recommendCombat: 0,
    copyTime: 0,
    init: function(data) {
        this.id = data.readInt();
        this.needXianwei = data.readByte();
        this.name = data.readString();
        this.bossId = data.readInt();
        this.diff = data.readByte();
        this.needLevel = data.readShort();
        this.needItems = [];
        var tmp = data.readString().split("|");
        for (var i = 0; i < tmp.length; i++) {
            var tt = tmp[i].split(",");
            if (tt.length == 2) {
                var arr = [parseInt(tt[0]), parseInt(tt[1])];
                this.needItems.push(arr)
            }
        }
        this.firstAwards = ____654.____674.strItemSplitToInts(data.readString());
        this.awards = [];
        var tmp = data.readString().split("#");
        for (var i = 0; i < tmp.length; i++) {
            this.awards[i] = ____654.____674.strItemSplitToInts(tmp[i])
        }
        this.recommendCombat = data.readNumber();
        this.copyTime = data.readInt()
    },
});
var ____1999 = cc.Class.extend({
    id: 0,
    name: "",
    dayTimes: 0,
    descriptId: "",
    ____1097: "",
    missions: null,
    missionIds: null,
    clubFight: 0,
    resetNum: 0,
    init: function(data) {
        this.id = data.readInt();
        this.name = data.readString();
        this.dayTimes = data.readUShort();
        this.descriptId = data.readString();
        this.clubFight = data.readNumber();
        this.resetNum = data.readByte();
        this.missions = [];
        this.missionIds = [];
        var missionLen = data.readInt();
        for (var i = 0; i < missionLen; i++) {
            var mission = new ____1998();
            mission.init(data);
            this.missions.push(mission);
            this.missionIds.push(mission.id)
        }
    },
    ____108: function() {
        if (this.____1097 == "") {
            this.____1097 = ____654.____682.____108(this.descriptId)
        }
        return this.____1097
    },
    getMissionById: function(missionId) {
        var index = this.missionIds.indexOf(missionId);
        if (index == -1) {
            index = 0
        }
        return this.missions[index]
    },
});
var ____2000 = ____514.extend({
    copyList: null,
    YAOTA_COPYID: 10003,
    TONGTIAN_COPYID: 10004,
    CAILIAO_COPYID: 50101,
    XIUXIAN_COPYID: 50201,
    XIANYUAN_COPYID: 50301,
    JIEYI_COPYID: 50401,
    WAIGUAN_COPYID: 50501,
    SHOUHU_COPYID: 51101,
    clubExpeditionCopyList: null,
    CLUBBOSS_COPYID: 16610,
    WORLDBOSSMAPID_MIN: 4001,
    WORLDBOSSMAPID_MAX: 4036,
    WORLDBOSSGOD_IDLIST: null,
    WORLDBOSSPERSON_IDLIST: null,
    WUSHEN_COPYID: 91012,
    DALUANDOU_COPYID: 30301,
    JIAZUWAR_COPYID: 30701,
    WANGZHE_COPYID: 30901,
    ZUOYAO_COPYID: 30501,
    XUNBAO_COPYID: 30601,
    TGHJ_COPYID: 92011,
    TGXS_COPYID: 80006,
    NEWLY_COPYIDLIST: null,
    CAILIAO_COSTLIST: null,
    TONGTIAN_RESETCOST: null,
    XIANJIE_COSTLIST: null,
    COPYXIUXIANRESET_CD: 1800,
    COPYPERSONBOSSREST_CD: 10800,
    DALUANDOU_CHANGE_BUFFID: null,
    XUNBAO_CHANGE_BUFFID: null,
    ZHUOYAO_CHANGE_BUFFID: null,
    WAIGUAN_TYPE: 11,
    CAILIAO_TYPE: 12,
    YAOTA_TYPE: 13,
    TONGTIAN_TYPE: 14,
    SHENJIANG_TYPE: 15,
    FUMO_TYPE: 16,
    ctor: function() {
        this._super();
        this.copyList = {};
        this.clubExpeditionCopyList = [16110, 16210, 16310, 16410, 16510];
        this.WORLDBOSSGOD_IDLIST = [80001, 80002, 80003];
        this.WORLDBOSSPERSON_IDLIST = [70102, 70104, 70105, 70106, 70103, 70101];
        this.DALUANDOU_CHANGE_BUFFID = [71, 72, 70];
        this.XUNBAO_CHANGE_BUFFID = [65];
        this.ZHUOYAO_CHANGE_BUFFID = [66, 67, 68];
        this.NEWLY_COPYIDLIST = [20101, 20102, 20103, 20104, 20105, 20106, 20107];
        this.CAILIAO_COSTLIST = [-1, 150, 120, 100, 0, 0, 0];
        this.TONGTIAN_RESETCOST = [-1, 50, 30, 0];
        this.XIANJIE_COSTLIST = [-1, 50, 30, 0]
    },
    ____104: function() {
        var item = new ____1999();
        item.init(this.____1755);
        this.copyList[item.id] = item
    },
    getYaoTaLevel: function(total) {
        var result = [0, 0];
        var i = 1;
        for (i = 1; i < 4; i++) {
            if (total <= i * 10) {
                result[0] = i;
                result[1] = (total - 1) % 10 + 1;
                return result
            }
        }
        total -= 30;
        for (i = 1; i < 4; i++) {
            if (total <= i * 15) {
                result[0] = i + 3;
                result[1] = (total - 1) % 15 + 1;
                return result
            }
        }
        total -= 45;
        for (i = 1; i < 4; i++) {
            if (total <= i * 20) {
                result[0] = i + 6;
                result[1] = (total - 1) % 20 + 1;
                return result
            }
        }
        result = [0, 0];
        return result
    },
    getTongtianFight: function(level) {
        var xianwei = ____655.____667.xianwei;
        if (xianwei == 0) {
            return 50000 + 1000 * level
        } else if (xianwei == 1) {
            return 100000 + 2000 * level
        } else if (xianwei == 2) {
            return 200000 + 6000 * level
        } else if (xianwei == 3) {
            return 500000 + 10000 * level
        } else if (xianwei == 4) {
            return 1000000 + 20000 * level
        } else if (xianwei == 5) {
            return 2000000 + 60000 * level
        } else if (xianwei == 6) {
            return 5000000 + 60000 * level
        } else if (xianwei == 7) {
            return 8000000 + 80000 * level
        } else if (xianwei == 8) {
            return 12000000 + 80000 * level
        }
    },
    canAFK: function(copyId) {
        if (copyId == this.XUNBAO_COPYID || copyId == this.DALUANDOU_COPYID || copyId == this.JIAZUWAR_COPYID || copyId == this.WUSHEN_COPYID || copyId == this.WANGZHE_COPYID) return false;
        return true
    },
    canHidePlayer: function(copyId) {
        return true
    },
    getCopy: function(copyId) {
        return this.copyList[copyId]
    },
    isShowPet: function(copyId) {
        if (copyId == this.WUSHEN_COPYID || copyId == this.WANGZHE_COPYID || copyId == this.ZUOYAO_COPYID || copyId == this.XUNBAO_COPYID) return false;
        return true
    },
    isShowPetCharacter: function(copyId) {
        if (copyId == this.DALUANDOU_COPYID || copyId == this.JIAZUWAR_COPYID) return false;
        return true
    },
    isShowFabao: function(copyId) {
        if (copyId == this.JIAZUWAR_COPYID || copyId == this.WUSHEN_COPYID || copyId == this.WANGZHE_COPYID || copyId == this.TGHJ_COPYID || copyId == this.DALUANDOU_COPYID || copyId == this.ZUOYAO_COPYID || copyId == this.XUNBAO_COPYID) return false;
        return true
    },
    isShowShenJian: function(copyId) {
        if (copyId == this.JIAZUWAR_COPYID || copyId == this.WUSHEN_COPYID || copyId == this.WANGZHE_COPYID || copyId == this.TGHJ_COPYID || copyId == this.DALUANDOU_COPYID || copyId == this.ZUOYAO_COPYID || copyId == this.XUNBAO_COPYID) return false;
        return true
    },
    isShowZhenLing: function(copyId) {
        if (copyId == this.JIAZUWAR_COPYID || copyId == this.WUSHEN_COPYID || copyId == this.WANGZHE_COPYID || copyId == this.TGHJ_COPYID || copyId == this.DALUANDOU_COPYID || copyId == this.ZUOYAO_COPYID || copyId == this.XUNBAO_COPYID) return false;
        return true
    },
    isShowZuJi: function(copyId) {
        if (copyId == this.JIAZUWAR_COPYID || copyId == this.WUSHEN_COPYID || copyId == this.WANGZHE_COPYID || copyId == this.TGHJ_COPYID || copyId == this.DALUANDOU_COPYID || copyId == this.ZUOYAO_COPYID || copyId == this.XUNBAO_COPYID) return false;
        return true
    },
    isShowClubName: function(copyId) {
        return true
    },
    isShowTitle: function(copyId) {
        if (copyId == this.DALUANDOU_COPYID || copyId == this.ZUOYAO_COPYID || copyId == this.XUNBAO_COPYID) return false;
        return true
    },
    canRider: function(copyId) {
        if (copyId == this.JIAZUWAR_COPYID || copyId == this.WUSHEN_COPYID || copyId == this.WANGZHE_COPYID || copyId == this.TGHJ_COPYID) return false;
        return true
    },
    collectCanBeStop: function(copyId) {
        return false
    },
    walkCompleteSelectPlayer: function(copyId) {
        if (copyId == this.DALUANDOU_COPYID || copyId == this.WUSHEN_COPYID || copyId == this.JIAZUWAR_COPYID) return true;
        return false
    },
    getBuffIdByWarState: function(copyId, warState) {
        if (copyId == this.DALUANDOU_COPYID) {
            return this.DALUANDOU_CHANGE_BUFFID[warState + 1]
        } else if (copyId == this.XUNBAO_COPYID) {
            return this.XUNBAO_CHANGE_BUFFID[0]
        } else if (copyId == this.ZUOYAO_COPYID) {
            return this.ZHUOYAO_CHANGE_BUFFID[warState]
        }
        return 0
    },
    canUseDefaultSkill: function(copyId) {
        if (copyId == this.XUNBAO_COPYID) return false;
        return true
    },
    canUseCommonAFKSkill: function(copyId) {
        if (copyId == this.XUNBAO_COPYID) return false;
        return true
    },
    getExitDes: function(copyId) {
        if (copyId == this.ZUOYAO_COPYID || copyId == this.XUNBAO_COPYID || copyId == this.TGHJ_COPYID || copyId == this.JIAZUWAR_COPYID || copyId == this.DALUANDOU_COPYID || copyId == this.WUSHEN_COPYID) return ____654.____682.____108("copy_exit_" + ____655.copyInfo.currentId);
        return ____654.____682.____108("copy_exit_1002")
    },
    ____462: function(copyId) {
        if (copyId == this.WUSHEN_COPYID || copyId == this.DALUANDOU_COPYID || copyId == this.JIAZUWAR_COPYID || copyId == this.WANGZHE_COPYID || copyId == this.XUNBAO_COPYID) {
            return true
        }
        return false
    },
    isAutoAFK: function(copyId) {
        if (this.NEWLY_COPYIDLIST.indexOf(copyId) >= 0) {
            return false
        }
        return this.canAFK(copyId)
    },
    isAllBrost: function(copyId) {
        return false
    },
});
var ____2001 = cc.Class.extend({
    min: 0,
    max: 0,
    type: 0,
    fight: 0,
    hp: 0,
    level: 0,
    init: function(bytes) {
        this.min = bytes.readShort();
        this.max = bytes.readShort();
        this.type = bytes.readByte();
        this.fight = bytes.readInt();
        this.hp = bytes.readNumber();
        this.level = bytes.readShort()
    },
});
var ____2002 = ____514.extend({
    list: null,
    ctor: function() {
        this.list = [];
        this._super()
    },
    ____104: function() {
        var item = new ____2001();
        item.init(this.____1755);
        this.list.push(item)
    },
    ____105: function() {
        function sortFunc(item1, item2) {
            return item1.min - item2.min
        }
        this.list.sort(sortFunc);
        this._super()
    },
    getInfoByRank: function(rank) {
        for (var i = this.list.length - 1; i >= 0; i--) {
            if (rank >= this.list[i].min) {
                return this.list[i]
            }
        }
        return null
    },
});
var ____520 = cc.Class.extend({
    id: 0,
    frames: null,
    frameCount: 0,
    xoffset: 0,
    yoffset: 0,
    pHeight: 0,
    picPath: 0,
    defaultPath: 0,
    time: 0,
    addMode: 0,
    completeEffect: 0,
    stopAtEnd: false,
    type: 0,
    param1: 0,
    param2: 0,
    param3: 0,
    param4: 0,
    param5: 0,
    param6: 0,
    scale: 0,
    init: function(data) {
        this.id = data.readInt();
        this.frames = data.readString().split(",");
        this.frameCount = this.frames.length;
        this.xoffset = data.readShort();
        this.yoffset = data.readShort();
        this.pHeight = data.readShort();
        this.picPath = data.readInt();
        this.defaultPath = data.readInt();
        this.time = data.readInt();
        this.addMode = data.readByte();
        this.completeEffect = data.readInt();
        this.type = data.readShort();
        this.param1 = data.readShort();
        this.param2 = data.readShort();
        this.param3 = data.readShort();
        this.param4 = data.readShort();
        this.param5 = data.readShort();
        this.param6 = data.readShort();
        this.scale = data.readShort() / 1000
    },
    isFlash: function() {
        return this.type == 4
    },
    getLoadPath: function() {
        var path = this.picPath;
        if (this.defaultPath > 0) path = this.defaultPath;
        return ____654.____675.getEffectPath(path) + ".png"
    }
});
var ____521 = ____514.extend({
    list: null,
    gate: 1,
    stageClick: 2,
    DROP_COPPER: 102,
    DROP_XUNBAO_GOLD: 99,
    DROP_OTHER: 98,
    CIFU_BAG_EFFECT: 17,
    GIFT_ICON_EFFECT: 25,
    CHARACTER_BG_EFFECT: 26,
    BTN_EFFECT: 23,
    FINGER_EFFECT: 14,
    WORLDMAP_EFFECT: 24,
    TYPE_FLASH: 4,
    UPGRADE: 5,
    TASK_SUBMIT: 7,
    TASK_ACCEPT: 21,
    WEAPON_TOP_EFFECT: 27,
    WEAPON_BOTTOM_EFFECT: 28,
    BEHIT_EFFECT1: 106,
    SHENBING_EFFECT1: 30001,
    SHENBING_EFFECT2: 30002,
    SHENBING_EFFECT3: 30003,
    SHENJIAN_EFFECT1: 60001,
    ZHENLING_EFFECT1: 70001,
    FAZHEN_EFFECT1: 80001,
    ZUJI_EFFECT1: 90001,
    ctor: function() {
        this._super();
        this.list = {}
    },
    ____104: function() {
        var effect = new ____520();
        effect.init(this.____1755);
        this.list[effect.id] = effect
    },
    getEffect: function(id) {
        var info = this.list[id];
        return info
    },
    isFlash: function(id) {
        var info = this.getEffect(id);
        if (!!info) return info.type == this.TYPE_FLASH;
        return false
    },
    getWeaponEffectId: function(dir) {
        var effectId = this.WEAPON_TOP_EFFECT;
        if (dir == ____655.____659.____686.leftTop || dir == ____655.____659.____686.rightTop) {
            effectId = this.WEAPON_BOTTOM_EFFECT
        }
        return effectId
    }
});
var ____2005 = cc.Class.extend({
    level: 0,
    exp: 0,
    totalExp: 0,
    init: function(bytes) {
        this.level = bytes.readInt();
        this.exp = bytes.readNumber();
        this.totalExp = bytes.readNumber()
    },
});
var ____2006 = ____514.extend({
    list: null,
    maxLevel: 0,
    ctor: function() {
        this.list = {};
        this._super()
    },
    ____104: function() {
        var info = new ____2005();
        info.init(this.____1755);
        this.list[info.level] = info;
        if (info.level > this.maxLevel) {
            this.maxLevel = info.level
        }
    },
    ____238: function(level) {
        return this.list[level]
    },
});
var FamilyTreasuresBaseTemplateInfo = cc.Class.extend({
    id: 0,
    wabao_times: 0,
    wabao_cd: 0,
    help_times: 0,
    fresh_cd: 0,
    init: function(data) {
        this.id = data.readShort();
        this.wabao_times = data.readByte();
        this.wabao_cd = data.readInt();
        this.help_times = data.readShort();
        this.fresh_cd = data.readInt()
    },
});
var FamilyTreasuresBaseTemplateList = ____514.extend({
    list: null,
    ctor: function() {
        this.list = {};
        this._super()
    },
    ____104: function() {
        var item = new FamilyTreasuresBaseTemplateInfo();
        item.init(this.____1755);
        this.list[item.id] = item
    },
});
var FamilyTreasuresBoxTemplateInfo = cc.Class.extend({
    id: 0,
    stage: 0,
    name: 0,
    icon: 0,
    need_time: 0,
    common_award: null,
    cost_per_10: 0,
    wabao_cost: 0,
    help_cd: 0,
    init: function(data) {
        this.id = data.readShort();
        this.stage = data.readByte();
        this.name = data.readString();
        this.icon = data.readInt();
        this.need_time = data.readInt();
        this.common_award = ____654.____674.strItemSplitToInts(data.readString(), ",");
        this.cost_per_10 = data.readShort();
        this.wabao_cost = data.readShort();
        this.help_cd = data.readInt()
    },
});
var FamilyTreasuresBoxTemplateList = ____514.extend({
    list: null,
    ctor: function() {
        this.list = {};
        this._super()
    },
    ____104: function() {
        var item = new FamilyTreasuresBoxTemplateInfo();
        item.init(this.____1755);
        this.list[item.id] = item
    },
    getBoxInfoById: function(id) {
        return this.list[id]
    },
    getStageColor: function(id) {
        var stage = this.list[id].stage;
        var colorList = {
            "1": ____655.____659.____688.green,
            "2": ____655.____659.____688.nameBlue,
            "3": ____655.____659.____688.purple,
        };
        return colorList[stage]
    },
    getNoticeBoxColor: function(id) {
        var stage = this.list[id].stage;
        var colorList = {
            "1": ____655.____659.____688.lightGreenStr,
            "2": ____655.____659.____688.blueStr,
            "3": ____655.____659.____688.purpleStr,
        };
        return colorList[stage]
    },
});
var FamilyTreasuresInfo = ____591.extend({
    _wabaoTimes: 0,
    _wabaoBeginTimes: 0,
    _wabaoNextTimes: 0,
    _freshTimes: 0,
    _boxFreshTimes: 0,
    _helpTime: 0,
    ____885: null,
    _myBoxList: null,
    _helpBoxList: null,
    _isCanHelpOthers: null,
    ctor: function() {
        this._super();
        this.____885 = [];
        this._myBoxList = [];
        this._isCanHelpOthers = true
    },
    isNoClubButHasTask: function() {
        if (____655.____667.clubId == 0) {
            if (this._myBoxList.length != 0) {
                return true
            }
            if (!this._isCanHelpOthers) {
                return true
            }
            return false
        } else {
            return false
        }
    },
    updateHelpList: function(data) {
        this._helpBoxList = [];
        this._isCanHelpOthers = true;
        var len = data.readByte();
        if (len != 0) {
            for (var i = 1; i <= len; i++) {
                var userId = data.readNumber();
                var id = data.readShort();
                var boxId = data.readInt();
                var helpId = data.readNumber();
                var endTime = data.readInt();
                var career = data.readByte();
                var belongName = data.readString();
                this._helpBoxList.push([id, boxId, endTime, helpId, belongName, userId, career]);
                if (helpId > 0) {
                    this._isCanHelpOthers = false
                }
            }
        }

        function sortFunc(info1, info2) {
            var stage1 = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(info1[1]).stage;
            var stage2 = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(info2[1]).stage;
            return info2[3] * 10 + stage2 > info1[3] * 10 + stage1
        }
        this._helpBoxList.sort(sortFunc);
        this.updatePopState(3);
        this.dispatchEvent(new ____590(____655.____661.familyTreasuresHelpListUpdate, this))
    },
    updatePopState: function(index) {
        var nowTime = ____655.____662.getSystemTimeSec();
        var popList = [];
        popList[0] = index;
        popList[1] = false;
        if (index == 1) {
            var needTime = this._wabaoNextTimes - nowTime;
            var totaleTime = ____655.allTemplates.familyTreasuresBaseTemplateList.list[1].wabao_times;
            if ((needTime <= 0) && (totaleTime - this._wabaoTimes) >= 0) {
                popList[1] = true
            }
        } else if (index == 2) {
            for (var i = this._myBoxList.length - 1; i >= 0; i--) {
                if (this._myBoxList[i][2] <= nowTime) {
                    popList[1] = true;
                    break
                }
            }
        } else if (index == 3) {
            if (this._helpBoxList.length != 0) {
                for (var i = this._helpBoxList.length - 1; i >= 0; i--) {
                    if (this._helpBoxList[i][2] <= nowTime) {
                        popList[1] = true;
                        break
                    }
                }
                if (this._isCanHelpOthers) {
                    popList[1] = true
                }
            }
        }
        this.dispatchEvent(new ____590(____655.____661.familyTreasuresPopUpdate, this, popList))
    },
    updateMyTreasures: function(data) {
        this._myBoxList = [];
        var len = data.readByte();
        if (len != 0) {
            for (var i = 1; i <= len; i++) {
                var id = data.readShort();
                var boxId = data.readInt();
                var endTime = data.readInt();
                var helpTime = data.readInt();
                var helpName = data.readString();
                this._myBoxList.push([id, boxId, endTime, helpTime, helpName])
            }
        }

        function sortFunc(info1, info2) {
            var stage1 = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(info1[1]).stage;
            var stage2 = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(info2[1]).stage;
            return stage2 - stage1
        }
        this._myBoxList.sort(sortFunc);
        this.updatePopState(2);
        this.dispatchEvent(new ____590(____655.____661.myFamilyTreasuresListUpdate, this))
    },
    updateBaseInfo: function(data) {
        this.____885 = [];
        this._wabaoTimes = data.readByte();
        this._wabaoBeginTimes = data.readInt();
        this._wabaoNextTimes = data.readInt();
        this._freshTimes = data.readInt();
        this._boxFreshTimes = data.readInt();
        this._helpTime = data.readByte();
        var len = data.readByte();
        if (len != 0) {
            for (var i = 1; i <= len; i++) {
                var pos = data.readByte();
                var boxId = data.readInt();
                this.____885.push([boxId, pos])
            }
        }

        function sortFunc(info1, info2) {
            var stage1 = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(info1[0]).stage;
            var stage2 = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(info2[0]).stage;
            return stage2 - stage1
        }
        this.____885.sort(sortFunc);
        this.updatePopState(1);
        this.dispatchEvent(new ____590(____655.____661.familyTreasuresListUpdate, this))
    },
    ____61: function() {
        this._wabaoTimes = 0;
        this._wabaoBeginTimes = 0;
        this._wabaoNextTimes = 0;
        this._freshTimes = 0;
        this._boxFreshTimes = 0;
        this._helpTime = 0;
        this.____885 = [];
        this._myBoxList = [];
        this._helpBoxList = [];
        this._isCanHelpOthers = true
    },
});
var FashionInfo = ____591.extend({
    list: null,
    isFirstUpdate: true,
    tuJianAwardRecord: null,
    huanZhuangAwardRecord: null,
    ctor: function() {
        this._super();
        this.list = {};
        this.tuJianAwardRecord = [];
        this.huanZhuangAwardRecord = []
    },
    init: function(data) {
        var len = data.readUByte();
        var type = 0;
        for (var i = 0; i < len; i++) {
            type = data.readShort();
            if (this.list[type] == null) {
                this.list[type] = new ____2008(type)
            }
            var len1 = data.readByte();
            for (var j = 0; j < len1; j++) {
                var huaxingType = data.readShort();
                var currentHuaxing = data.readInt();
                this.setHuaXing(huaxingType, currentHuaxing)
            }
            this.list[type].init(data)
        }
        if (this.isFirstUpdate) {
            this.isFirstUpdate = false
        }
    },
    updateInfo: function(data) {
        var type = data.readShort();
        if (this.list[type] == null) {
            this.list[type] = new ____2008(type)
        }
        this.list[type].updateInfo(data)
    },
    setHuaXing: function(type, currentHuaxing) {
        if (____655.____659.commonStaticType.isFashion(type)) {
            if (this.list[type] != null) {
                this.list[type].setCurrentHuaxing(currentHuaxing)
            }
            var index = ____655.____659.commonStaticType.fashionTypeList.indexOf(type);
            var advanceType = ____655.____659.commonStaticType.advanceTypeList[index];
            if (advanceType != null) {
                ____655.advanceItemList.setUseStar(advanceType, 0)
            }
        } else {
            ____655.advanceItemList.setUseStar(type, currentHuaxing);
            var index = ____655.____659.commonStaticType.advanceTypeList.indexOf(type);
            var fashionType = ____655.____659.commonStaticType.fashionTypeList[index];
            if (fashionType != null && this.list[fashionType] != null) {
                this.list[fashionType].setCurrentHuaxing(0)
            }
        }
    },
    doDispatch: function(type, id) {
        if (!this.isFirstUpdate) {
            var data2 = [];
            data2[0] = type;
            data2[1] = id;
            this.dispatchEvent(new ____590(____655.____661.fashion_infoUpdate, this, data2))
        }
    },
    doHuaXingDispatch: function(type, currentHuaxing) {
        if (!this.isFirstUpdate) {
            var data = [];
            data[0] = type;
            data[1] = currentHuaxing;
            this.dispatchEvent(new ____590(____655.____661.fashion_hauxingUpdate, this, data))
        }
    },
    tuJianAwardRecordUpdate: function(data) {
        this.tuJianAwardRecord = [];
        this.huanZhuangAwardRecord = [];
        var len1 = data.readByte();
        for (var i = 0; i < len1; i++) {
            this.tuJianAwardRecord.push(data.readShort())
        }
        var len2 = data.readByte();
        for (var i = 0; i < len2; i++) {
            this.huanZhuangAwardRecord.push(data.readShort())
        }
        this.dispatchEvent(new ____590(____655.____661.tuJian_awardUpdate, this, null))
    },
    getFashion: function(type) {
        return this.list[type]
    },
    getFashionInfo: function(type, templateId) {
        var fashion = this.list[type];
        if (fashion == null) return null;
        return fashion.huaxingList[templateId]
    },
    ____61: function() {
        if (this.list != null) {
            for (var i in this.list) {
                if (this.list[i] != null) this.list[i].dispose()
            }
        }
        this.list = {};
        this.isFirstUpdate = true;
        this.tuJianAwardRecord = [];
        this.huanZhuangAwardRecord = []
    },
});
var ____2008 = ____591.extend({
    type: 0,
    huaxingList: null,
    currentHuaxing: 0,
    ctor: function(type) {
        this._super();
        this.type = type;
        this.huaxingList = {}
    },
    init: function(data) {
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var templateId = data.readInt();
            var star = data.readShort();
            if (this.huaxingList[templateId] != null) {
                this.huaxingList[templateId].dispose();
                this.huaxingList[templateId] = null
            }
            var huaxingInfo = new ____2009();
            huaxingInfo.____363(templateId, star);
            this.huaxingList[templateId] = huaxingInfo
        }
    },
    updateInfo: function(data) {
        var templateId = data.readInt();
        var star = data.readShort();
        if (this.huaxingList[templateId] != null) {
            this.huaxingList[templateId].dispose();
            this.huaxingList[templateId] = null
        }
        var huaxingInfo = new ____2009();
        huaxingInfo.____363(templateId, star);
        this.huaxingList[templateId] = huaxingInfo;
        ____655.fashionInfo.doDispatch(this.type, templateId)
    },
    setCurrentHuaxing: function(huaxing) {
        if (this.currentHuaxing == huaxing) return;
        this.currentHuaxing = huaxing;
        ____655.fashionInfo.doHuaXingDispatch(this.type, this.currentHuaxing)
    },
    dispose: function() {
        if (this.huaxingList != null) {
            for (var i = 0; i < this.huaxingList.length; i++) {
                this.huaxingList[i].dispose()
            }
            this.huaxingList = {}
        }
        this.currentHuaxing = 0
    },
});
var ____2009 = cc.Class.extend({
    templateId: 0,
    template: null,
    star: 0,
    ____363: function(templateId, star) {
        this.templateId = templateId;
        this.star = star;
        this.template = ____655.allTemplates.fashionTemplateList.getFashion(this.templateId).stars[this.star]
    },
    dispose: function() {
        this.templateId = null;
        this.star = null;
        this.template = null
    },
});
var ____2010 = cc.Class.extend({
    fightValue: 0,
    level: 0,
    attrStr: null,
    needItems: null,
    ctor: function() {
        this.attrStr = [];
        this.needItems = []
    },
    init: function(data) {
        this.fightValue = data.readInt();
        this.level = data.readShort();
        this.attrStr = ____654.____674.____184(data.readString());
        this.needItems = ____654.____674.strItemSplitToInts(data.readString())
    },
});
var ____2011 = cc.Class.extend({
    templateId: 0,
    type: 0,
    name: "",
    iconPath: "",
    carrer: 0,
    deploy: null,
    figureId: 0,
    stars: null,
    maxStars: 0,
    ctor: function() {
        this.deploy = [];
        this.stars = {}
    },
    init: function(data) {
        this.templateId = data.readInt();
        this.type = data.readShort();
        this.name = data.readString();
        this.iconPath = data.readString();
        this.figureId = data.readInt();
        this.carrer = data.readByte();
        this.deploy = [];
        var len = data.readInt();
        for (var i = 0; i < len; i++) {
            var triggerInfo = new ____539();
            triggerInfo.init(data);
            this.deploy.push(triggerInfo)
        }
        len = data.readShort();
        for (var i = 0; i < len; i++) {
            var fashionStar = new ____2010();
            fashionStar.init(data);
            this.stars[fashionStar.level] = fashionStar;
            if (fashionStar.level > this.maxStars) {
                this.maxStars = fashionStar.level
            }
        }
    },
});
var ____2012 = ____514.extend({
    list: null,
    listbyType: null,
    ctor: function() {
        this.list = {};
        this.listbyType = {}
    },
    ____104: function() {
        var fashionTemplateInfo = new ____2011();
        fashionTemplateInfo.init(this.____1755);
        this.list[fashionTemplateInfo.templateId] = fashionTemplateInfo;
        if (!this.listbyType[fashionTemplateInfo.type]) {
            this.listbyType[fashionTemplateInfo.type] = []
        }
        this.listbyType[fashionTemplateInfo.type].push(fashionTemplateInfo)
    },
    getFashion: function(id) {
        id = parseInt(id);
        var info = this.list[id];
        assert(info, "时装模板数据为空，id：{0}".format(id));
        return info
    },
    getList: function(type) {
        return this.listbyType[type]
    },
    getListByTypeAndCarrer: function(type, carrer) {
        var tempList = this.getList(type);
        if (tempList == null) return null;
        var infoList = [];
        for (var i in tempList) {
            if (tempList[i] != null && carrer == tempList[i].carrer) {
                infoList.push(tempList[i])
            }
        }
        return infoList
    },
});
var FeiXianInfo = ____591.extend({
    conditionList: null,
    itemGetAward: null,
    viewGetAward: null,
    ctor: function() {
        this._super();
        this.conditionList = {};
        this.itemGetAward = [];
        this.viewGetAward = [];
        this.____6()
    },
    ____6: function() {},
    ____363: function(data) {
        var len1 = data.readUByte();
        for (var i = 0; i < len1; i++) {
            var type = data.readUByte();
            var sign = data.readNumber();
            this.conditionList[type] = sign
        }
        var len3 = data.readUByte();
        for (var i = 0; i < len3; i++) {
            var day = data.readUByte();
            this.viewGetAward.push(day)
        }
        var len2 = data.readUByte();
        for (var i = 0; i < len2; i++) {
            var type = data.readUByte();
            this.itemGetAward.push(type)
        }
        this.dispatchEvent(new ____590(____655.____661.playerInfo_feiXianInfo_Update, this, null))
    },
    ____17: function() {},
    ____61: function() {
        this.____17();
        this.conditionList = {};
        this.itemGetAward = [];
        this.viewGetAward = [];
        this._super()
    },
});
var FeiXianTemplateInfo = cc.Class.extend({
    id: 0,
    type: 0,
    days: 0,
    condition: 0,
    content: null,
    awardList: null,
    typeAwardList: null,
    picPath: null,
    needNums: 0,
    deploy: null,
    weeks: 0,
    init: function(bytes) {
        this.id = bytes.readInt();
        this.type = bytes.readShort();
        this.days = bytes.readInt();
        this.condition = bytes.readInt();
        this.content = bytes.readString();
        this.awardList = ____654.____674.strItemSplitToInts(bytes.readString());
        this.picPath = bytes.readString();
        this.typeAwardList = ____654.____674.strItemSplitToInts(bytes.readString());
        this.needNums = bytes.readInt();
        this.deploy = [];
        var len = bytes.readInt();
        for (var i = 0; i < len; i++) {
            var trigger = new ____539();
            trigger.init(bytes);
            this.deploy.push(trigger)
        }
        this.weeks = bytes.readByte()
    },
});
var FeiXianTemplateList = ____514.extend({
    typeList: null,
    infoList: null,
    countDownTypeList: null,
    ctor: function() {
        this._super();
        this.typeList = [];
        this.infoList = {};
        this.countDownTypeList = []
    },
    ____104: function() {
        var info = new FeiXianTemplateInfo();
        info.init(this.____1755);
        if (this.typeList.indexOf(info.days) == -1) {
            this.typeList.push(info.days)
        }
        if (this.infoList[info.days] == null) {
            this.infoList[info.days] = []
        }
        this.infoList[info.days].push(info)
    },
    getCountDownTypeList: function() {
        this.countDownTypeList = [];
        var openDay = ____655.____662.getDayByCreatRoleTime();
        for (var i = 0; i < this.typeList.length; i++) {
            var days = this.typeList[i];
            if (openDay >= days) {
                this.countDownTypeList.push(days)
            }
        }
        return this.countDownTypeList
    },
});
var FigureTemplateInfo = cc.Class.extend({
    id: 0,
    _path: "",
    ____1477: 0,
    ____1478: 0,
    _scale: 0,
    _pwidth: 0,
    _pheight: 0,
    _hitPos: 0,
    defaultFigure: 0,
    type: 0,
    defaultFigureTemplate: null,
    frameType: 0,
    windowOffsetY: 0,
    windowScale: 0,
    init: function(bytes) {
        this.id = bytes.readInt();
        this.type = bytes.readByte();
        this._path = bytes.readString();
        this.____1477 = bytes.readShort();
        this.____1478 = bytes.readShort();
        this._scale = bytes.readByte() / 10;
        this._pwidth = bytes.readShort();
        this._pheight = bytes.readShort();
        this._hitPos = bytes.readShort();
        this.defaultFigure = bytes.readInt();
        this.frameType = bytes.readByte();
        this.windowOffsetY = bytes.readShort();
        this.windowScale = bytes.readByte() / 10
    },
    getFigureTemplate: function() {
        if (this.defaultFigure > 0 && ____655.needLoadExtSource()) {
            if (this.defaultFigureTemplate == null) {
                this.defaultFigureTemplate = ____655.allTemplates.figureTemplateList.getFigure(this.defaultFigure)
            }
            return this.defaultFigureTemplate
        }
        return this
    },
    getType: function() {
        return this.getFigureTemplate().type
    },
    ____27: function() {
        return this.getFigureTemplate()._path
    },
    getOffsetX: function() {
        return this.getFigureTemplate().____1477
    },
    getOffsetY: function() {
        return this.getFigureTemplate().____1478
    },
    getScale: function() {
        return this.getFigureTemplate()._scale
    },
    getPicWidth: function() {
        return this.getFigureTemplate()._pwidth
    },
    getPicHeight: function() {
        return this.getFigureTemplate()._pheight
    },
    getHitPosY: function() {
        return this.getFigureTemplate()._hitPos
    },
});
var FigureTemplateList = ____514.extend({
    list: null,
    monsterFigure: 1,
    petFigure: 2,
    ctor: function() {
        this._super();
        this.list = {}
    },
    ____104: function() {
        var info = new FigureTemplateInfo();
        info.init(this.____1755);
        this.list[info.id] = info
    },
    getFigure: function(id) {
        return this.list[id]
    },
});
var ____2013 = cc.Class.extend({
    level: 0,
    exp: 0,
    totalExp: 0,
    attList: null,
    init: function(data) {
        this.level = data.readUByte();
        this.exp = data.readNumber();
        this.attList = ____654.____674.____184(data.readString())
    },
    getProByType: function(type) {
        for (var i = 0; i < this.attList.length; i++) {
            if (this.attList[i].id == type) {
                return this.attList[i].value
            }
        }
        return 0
    }
});
var ____2014 = ____514.extend({
    list: null,
    ____1807: 0,
    ____1566: null,
    ctor: function() {
        this.list = {};
        this._super()
    },
    ____104: function() {
        var info = new ____2013();
        info.init(this.____1755);
        this.____1807 += info.exp;
        info.totalExp = this.____1807;
        this.list[info.level] = info;
        if (this.____1566 == null) {
            this.____1566 = [];
            var list = info.attList;
            for (var i = 0; i < list.length; i++) {
                this.____1566.push(list[i].id)
            }
        }
    },
    ____238: function(level) {
        return this.list[level]
    },
});
var ____2015 = cc.Class.extend({
    strengthLevel: 0,
    needCopper: 0,
    items: null,
    init: function(data) {
        this.strengthLevel = data.readUByte();
        this.needCopper = data.readUInt();
        this.items = ____654.____674.strItemSplitToInts(data.readString())
    },
});
var ____2016 = ____514.extend({
    list: null,
    ctor: function() {
        this.list = {}
    },
    ____104: function() {
        var info = new ____2015();
        info.init(this.____1755);
        this.list[info.strengthLevel] = info
    },
    getCost: function(strengthLevel) {
        return this.list[strengthLevel]
    }
});
var ____2017 = cc.Class.extend({
    strengthLevel: 0,
    categoryId: 0,
    propertyAdd: null,
    init: function(data) {
        this.strengthLevel = data.readUByte();
        this.categoryId = data.readUShort();
        this.propertyAdd = ____654.____674.____184(data.readString())
    },
});
var ____2018 = ____514.extend({
    list: null,
    MAX_STRENGTH_LEVEL: 0,
    init: function(data, type) {
        this._super(data, type);
        this.list = {}
    },
    ____104: function() {
        var info = new ____2017();
        info.init(this.____1755);
        if (this.list[info.categoryId] == null) {
            this.list[info.categoryId] = {}
        }
        this.list[info.categoryId][info.strengthLevel] = info;
        if (info.strengthLevel > this.MAX_STRENGTH_LEVEL) {
            this.MAX_STRENGTH_LEVEL = info.strengthLevel
        }
    },
    ____238: function(categoryId, strengthLevel) {
        if (this.list[categoryId] == null) return null;
        return this.list[categoryId][strengthLevel]
    },
});
var ____2019 = cc.Class.extend({
    level: 0,
    attList: null,
    needCopper: 0,
    needLevel: 0,
    init: function(data) {
        this.level = data.readInt();
        this.attList = ____654.____674.____184(data.readString());
        this.needLevel = data.readInt();
        this.needCopper = data.readInt()
    },
});
var ____2020 = ____514.extend({
    list: null,
    ____1566: null,
    levelPerRound: 7,
    ctor: function() {
        this.list = [];
        this._super()
    },
    ____104: function() {
        var info = new ____2019();
        info.init(this.____1755);
        this.list.push(info);
        if (this.____1566 == null) {
            this.____1566 = [];
            var list = info.attList;
            for (var i = 0; i < list.length; i++) {
                this.____1566.push(list[i].id)
            }
        }
    },
    ____105: function() {
        this._super();
        if (this.list.length <= 0) {
            return
        }

        function listSort(info1, info2) {
            return info1.level - info2.level
        }
        this.list.sort(listSort)
    },
    getInfoByLevel: function(level) {
        for (var i = 0; i < this.list.length; i++) {
            var info = this.list[i];
            if (info.level > level) return info
        }
        return null
    },
    getAddPropertyByLevel: function(nextLevel) {
        print("获取下等级属性", nextLevel);
        var index = (nextLevel - 1) % this.levelPerRound;
        print("圈序号", index);
        for (var i = 0; i < this.list.length; i++) {
            print("当前数据", i, this.list[i].level);
            if (nextLevel <= this.list[i].level) {
                return this.list[i].attList[index].value
            }
        }
    },
    getNeedCopperByLevel: function(nextLevel) {
        for (var i = 0; i < this.list.length; i++) {
            if (nextLevel <= this.list[i].level) {
                return this.list[i].needCopper * Math.ceil(nextLevel / this.levelPerRound)
            }
        }
    },
    getTotalPropertyByLevel: function(level) {
        var roundLevel = Math.floor(level / this.levelPerRound);
        var nextLevel = Math.ceil(level / this.levelPerRound);
        var higherNum = level % this.levelPerRound;
        var levelList = [];
        var propertyList = [];
        for (var l = 0; l < this.levelPerRound; l++) {
            if (l >= higherNum) {
                levelList.push(roundLevel)
            } else {
                levelList.push(nextLevel)
            }
            propertyList.push(0)
        }
        var lastLevel = 0;
        for (var i = 0; i < this.list.length; i++) {
            var maxLevel = Math.floor(this.list[i].level / this.levelPerRound);
            for (var j = 0; j < this.levelPerRound; j++) {
                if (levelList[j] >= maxLevel) {
                    propertyList[j] += this.list[i].attList[j].value * (maxLevel - lastLevel)
                } else {
                    if (levelList[j] > lastLevel) {
                        propertyList[j] += this.list[i].attList[j].value * (levelList[j] - lastLevel)
                    }
                }
            }
            lastLevel = maxLevel
        }
        return propertyList
    },
});
var ____2021 = cc.Class.extend({
    id: 0,
    mapId: 0,
    nextMapId: 0,
    isHide: false,
    pos: null,
    ____1455: "",
    init: function(data) {
        this.id = data.readInt();
        this.mapId = data.readInt();
        this.nextMapId = data.readInt();
        this.pos = ____654.____673.____159(data.readShort(), data.readShort());
        this.isHide = data.readBoolean()
    },
    getNextMapName: function() {
        if (this.____1455 == "") {
            this.____1455 = ____655.allTemplates.mapTemplateList.getMap(this.nextMapId).name
        }
        return this.____1455
    },
});
var ____2022 = ____514.extend({
    gateList: null,
    sceneGateList: null,
    ctor: function() {
        this._super();
        this.gateList = {};
        this.sceneGateList = {}
    },
    ____104: function() {
        var gate = new ____2021();
        gate.init(this.____1755);
        this.gateList[gate.id] = gate;
        if (this.sceneGateList[gate.mapId] == null) {
            this.sceneGateList[gate.mapId] = []
        }
        this.sceneGateList[gate.mapId].push(gate)
    },
    getGate: function(id) {
        return this.gateList[id]
    },
});
var HomeJinjieTemplateInfo = cc.Class.extend({
    quality: 0,
    name: "",
    metarialList: 0,
    needHomeLevel: 0,
    mulriple: 0,
    init: function(data) {
        this.quality = data.readShort();
        this.name = data.readString();
        this.metarialList = ____654.____674.strItemSplitToInts(data.readString());
        this.needHomeLevel = data.readShort();
        this.mulriple = data.readShort()
    },
});
var HomeJinjieTemplateList = ____514.extend({
    qualityList: null,
    MAX_QUALITY: 0,
    ctor: function() {
        this._super();
        this.qualityList = {}
    },
    ____104: function() {
        var info = new HomeJinjieTemplateInfo();
        info.init(this.____1755);
        this.qualityList[info.quality] = info;
        if (this.MAX_QUALITY < info.quality) {
            this.MAX_QUALITY = info.quality
        }
    },
    getInfoByQuality: function(quality) {
        return this.qualityList[quality]
    }
});
var HomePetTemplateInfo = cc.Class.extend({
    level: 0,
    minExp: 0,
    maxExp: 0,
    pos: 0,
    scale: 1,
    effectId: 0,
    freeAwardList: null,
    ybAwardList: null,
    freeHuntInfo: null,
    ybHuntInfo: null,
    timePrice: null,
    init: function(data) {
        this.level = data.readShort();
        this.minExp = data.readInt();
        this.maxExp = data.readInt();
        var list = ____654.____674.____183(data.readString(), ",") || [];
        this.effectId = list[0] || 0;
        var posX = list[1] || 0;
        var posY = list[2] || 0;
        this.pos = ____654.____673.____159(posX, posY);
        this.scale = list[3] || 100;
        this.scale = this.scale * 0.01;
        this.freeAwardList = ____654.____674.strItemSplitToInts(data.readString()) || [];
        this.ybAwardList = ____654.____674.strItemSplitToInts(data.readString()) || [];
        this.freeHuntInfo = ____654.____674.____183(data.readString(), ",") || [];
        this.ybHuntInfo = ____654.____674.____183(data.readString(), ",") || [];
        this.timePrice = ____654.____674.____183(data.readString(), ",") || []
    },
});
var HomePetTemplateList = ____514.extend({
    petList: null,
    MAX_LEVEL: 0,
    FOOD_TEMPLATE_ID: 0,
    MAX_HELP_FEED: 50,
    MAX_HELP_CARESS: 50,
    ctor: function() {
        this._super();
        this.petList = {};
        this.FOOD_TEMPLATE_ID = 300102
    },
    ____104: function() {
        var pet = new HomePetTemplateInfo();
        pet.init(this.____1755);
        this.petList[pet.level] = pet;
        if (this.MAX_LEVEL < pet.level) {
            this.MAX_LEVEL = pet.level
        }
    },
    getInfoByLevel: function(level) {
        return this.petList[level]
    },
    getInfoByExp: function(exp) {
        for (var i = this.MAX_LEVEL; i > 0; i--) {
            var info = this.petList[i];
            if (!!info && exp >= info.minExp) {
                return info
            }
        }
    },
});
var HomeTemplateInfo = cc.Class.extend({
    level: 0,
    maxExp: 0,
    landAmount: 0,
    landQuality: 0,
    init: function(data) {
        this.level = data.readShort();
        this.maxExp = data.readInt();
        this.landAmount = data.readByte();
        this.landQuality = data.readByte()
    },
});
var HomeTemplateList = ____514.extend({
    homeList: null,
    MAX_FLANT: 3,
    MAX_HUNT: 3,
    MAX_STEAL: 50,
    MAX_CAN_STEAL: 10,
    MAX_WATER: 50,
    MAX_OTHER_HELP_FEED: 20,
    LIANDAN_MATERAL_COUNT: 10,
    MAX_CARESS_COUNT: 10,
    HUNT_SPEED_TIME: 600,
    LIANDAN_MATERAL_LIST: null,
    ctor: function() {
        this._super();
        this.homeList = {};
        this.LIANDAN_MATERAL_LIST = [140101, 140104, 140107];
    },
    ____104: function() {
        var home = new HomeTemplateInfo();
        home.init(this.____1755);
        this.homeList[home.level] = home
    },
    getInfoByLevel: function(level) {
        return this.homeList[level]
    },
});
var SeedTemplateInfo = cc.Class.extend({
    type: 0,
    accPrice: 0,
    waterTime: 0,
    waterRedueTime: 0,
    name: "",
    qualityList: null,
    ctor: function() {
        this.qualityList = {}
    },
    init: function(data) {
        this.type = data.readByte();
        this.accPrice = data.readInt();
        this.waterTime = data.readInt();
        this.waterRedueTime = data.readInt();
        this.name = data.readString();
        var len = data.readShort();
        for (var i = 0; i < len; i++) {
            var qualityInfo = new SeedTemplateQualityInfo(this);
            qualityInfo.init(data);
            this.qualityList[qualityInfo.quality] = qualityInfo
        }
    },
});
var SeedTemplateList = ____514.extend({
    seedList: null,
    seedListById: null,
    ctor: function() {
        this._super();
        this.seedList = {};
        this.seedListById = {}
    },
    ____104: function() {
        var seed = new SeedTemplateInfo();
        seed.init(this.____1755);
        this.seedList[seed.type] = seed;
        for (var i in seed.qualityList) {
            this.seedListById[seed.qualityList[i].id] = seed.qualityList[i]
        }
    },
    getInfoByType: function(type) {
        return this.seedList[type]
    },
    getInfoById: function(id) {
        return this.seedListById[id]
    }
});
var SeedTemplateQualityInfo = cc.Class.extend({
    target: null,
    id: 0,
    ripeTime: 0,
    style: null,
    activeLevel: 0,
    price: 0,
    quality: 0,
    scale: 1,
    awardList: null,
    ctor: function(target) {
        this.target = target;
        this.style = [];
        this.awardList = []
    },
    init: function(data) {
        this.id = data.readInt();
        this.price = data.readInt();
        this.quality = data.readByte();
        this.style = ____654.____674.strItemSplitToInts(data.readString());
        this.ripeTime = data.readInt();
        this.activeLevel = data.readShort();
        this.scale = data.readShort() / 100;
        this.awardList = ____654.____674.strItemSplitToStrs(data.readString())
    },
});
var ____2024 = ItemTemplateInfo.extend({
    basePropertyList: null,
    defaultFigure: 0,
    defaultFigureTemplate: null,
    init: function(data, categoryId) {
        this._super(data, categoryId);
        this.basePropertyList = ____654.____674.____184(data.readString());
        var str = data.readString();
        if (str != "") {
            this.defaultFigure = parseInt(data.readString())
        }
    },
    getFigureTemplate: function() {
        if (this.defaultFigure > 0 && ____655.needLoadExtSource()) {
            if (this.defaultFigureTemplate == null) {
                this.defaultFigureTemplate = ____655.allTemplates.____794.getItem(this.defaultFigure)
            }
            return this.defaultFigureTemplate
        }
        return this
    },
    ____27: function() {
        return this.getFigureTemplate()._picPath
    },
});
var ItemInfo = ____591.extend({
    id: 0,
    isBind: false,
    count: 0,
    score: 0,
    exist: false,
    vaildDate: 0,
    templateId: 0,
    template: null,
    bagType: -1,
    quality: 0,
    qhLevel: 0,
    rollProperty: null,
    ctor: function() {
        this._super();
        this.rollProperty = {}
    },
    ____107: function(value) {
        if (this.templateId == value) return;
        var temp = ____655.allTemplates.____794.getItem(value);
        if (this.bagType == 4 && this.template != null && this.template.categoryId == temp.categoryId && this.template.quality < temp.quality) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_equipQualityUp, ____654.____672))
        }
        this.templateId = value;
        this.template = temp
    },
    getCanUse: function(isTip) {
        if (this.template.needCareer != 0 && this.template.needCareer != ____655.____667.career) {
            if (isTip == true) {
                ____654.tipsManager.quickTip.show("性别不符")
            }
            return false
        }
        if (this.template.needLevel > ____655.____667.level) {
            if (isTip == true) {
                ____654.tipsManager.quickTip.show(this.template.needLevel + "级才能使用")
            }
            return false
        }
        if (this.outOfDate()) return false;
        return true
    },
    outOfDate: function() {
        if (this.vaildDate <= 0) return false;
        return ____655.____662.getSystemTimeSec() > this.vaildDate
    },
    ____57: function() {
        return this.template.quality
    },
    getName: function() {
        return this.template.name
    },
    updateInfo: function() {
        this.dispatchEvent(new ____590(____655.____661.common_itemInfoUpdate, this, null))
    },
    getClone: function() {
        var info = new ItemInfo();
        info.id = this.id;
        info.isBind = this.isBind;
        info.count = this.count;
        info.score = this.score;
        info.exist = this.exist;
        info.vaildDate = this.vaildDate;
        info.templateId = this.templateId;
        info.template = this.template;
        info.bagType = this.bagType;
        info.quality = this.quality;
        info.qhLevel = this.qhLevel;
        for (k in this.rollProperty) {
            info.rollProperty[k] = this.rollProperty[k].getClone()
        }
        return info
    },
    getWaiXingFight: function() {
        return Math.floor(this.quality * ____655.____659.categoryType.waixingEquipFight * ____655.____659.categoryType.waixingEquipQuality[this.qhLevel])
    },
    dispose: function() {
        this.template = null;
        this.rollProperty = null;
        this._super()
    },
});
var ____2026 = ____591.extend({
    list: null,
    bagTypeList: null,
    itemCount: 0,
    ____1770: 0,
    ____1771: 0,
    _sortTickList: null,
    ctor: function() {
        this.list = {};
        this.bagTypeList = [null, [],
            [],
            [],
            []
        ];
        this._sortTickList = [0, 0, 0];
        this._super()
    },
    initTick: function() {
        ____654.____678.____298(this.tick, this)
    },
    ____367: function(itemInfo) {
        var item = this.list[itemInfo.id];
        if (item == null) {
            this.itemCount++;
            assert(this.bagTypeList[itemInfo.bagType], "#itemInfo.bagType:{0}, id:{1}数据为空".format(itemInfo.bagType, itemInfo.id));
            this.bagTypeList[itemInfo.bagType].push(itemInfo)
        }
        this.list[itemInfo.id] = itemInfo;
        if (itemInfo.bagType > 0 && itemInfo.bagType < 4) {
            this._sortTickList[itemInfo.bagType - 1] = 30
        }
    },
    removeItem: function(id) {
        var item = this.list[id];
        if (item != null) {
            var bagType = item.bagType;
            this.itemCount--;
            var index = this.bagTypeList[item.bagType].indexOf(item);
            if (index >= 0) {
                this.bagTypeList[item.bagType].splice(index, 1)
            }
            item.dispose();
            this.dispatchEvent(new ____590(____655.____661.common_itemInfoDelete, this, [bagType, id]))
        }
        this.list[id] = null
    },
    tick: function(deltaTime, count) {
        if (this.____1770 > 0) {
            this.____1770--;
            if (this.____1770 == 0) {
                this.dispatchEvent(new ____590(____655.____661.common_itemListUpdate, this))
            }
        }
        if (this.____1771 > 0) {
            this.____1771--;
            if (this.____1771 == 0) {
                this.dispatchEvent(new ____590(____655.____661.common_itemCountUpdate, this))
            }
        }
        for (var i = 0; i < 3; i++) {
            if (this._sortTickList[i] > 0) {
                this._sortTickList[i]--;
                if (this._sortTickList[i] == 0) {
                    this.sortBagByType(i + 1)
                }
            }
        }
    },
    sortAndDispatch: function() {
        this.____1770 = 5
    },
    countChangeDispatch: function() {
        this.____1771 = 5
    },
    getHasPos: function(count) {
        var isItemFull = (____655.____667.baggageMaxCount - this.bagTypeList[1].length) < count;
        var isMaterialFull = (____655.____667.baggageMaxCount - this.bagTypeList[2].length) < count;
        var isEquipFull = (____655.____667.baggageMaxCount - this.bagTypeList[3].length) < count;
        return !isItemFull && !isMaterialFull && !isEquipFull
    },
    getItemById: function(itemId) {
        return this.list[itemId]
    },
    getCountByTempId: function(templateId) {
        var count = 0;
        for (var i in this.list) {
            var info = this.list[i];
            if (info != null && info.templateId == templateId) {
                count += info.count
            }
        }
        return count
    },
    getCountByCategoryId: function(categoryId) {
        var count = 0;
        for (var i in this.list) {
            var info = this.list[i];
            if (info != null && info.template.categoryId == categoryId) {
                count += info.count
            }
        }
        return count
    },
    getItemInfoByTempId: function(templateId) {
        for (var i in this.list) {
            var info = this.list[i];
            if (info != null && info.templateId == templateId) {
                return info
            }
        }
        return null
    },
    strengthResult: function(bytes) {
        var result = bytes.readBoolean();
        var itemId = bytes.readNumber();
        this.dispatchEvent(new ____590(____655.____661.weapon_strengthResult, this, [result, itemId]))
    },
    getBodyEquipByType: function(categoryId) {
        for (var i = 0; i < this.bagTypeList[4].length; i++) {
            if (categoryId == this.bagTypeList[4][i].template.categoryId) {
                return this.bagTypeList[4][i]
            }
        }
        return null
    },
    sortBagByType: function(bagType) {
        function sortHandler(info1, info2) {
            if (info1.categoryId != info2.categoryId) {
                return info1.categoryId - info2.categoryId
            }
            if (info1.templateId != info2.templateId) {
                return info1.templateId - info2.templateId
            }
            return info2.count - info1.count
        }
        this.bagTypeList[bagType].sort(sortHandler)
    },
    ____61: function() {
        for (var i in this.list) {
            var info = this.list[i];
            if (info != null) {
                info.dispose()
            }
        }
        this.itemCount = 0;
        this.____1770 = 0, this.____1771 = 0, this._sortTickList = [0, 0, 0];
        this.list = {};
        this.bagTypeList = [null, [],
            [],
            [],
            []
        ]
    },
});
var ____2028 = ____514.extend({
    list: null,
    equipList: null,
    otherList: null,
    money0Item: 100004,
    money1Item: 100008,
    money2Item: 100003,
    expItem: 100002,
    money3Item: 100005,
    money4Item: 100006,
    tghjKeys: null,
    ctor: function() {
        this.list = {};
        this.equipList = {};
        this.otherList = {};
        this.tghjKeys = [300001, 300003];
        this._super()
    },
    ____104: function() {
        var categoryId = this.____1755.readInt();
        var item = null;
        var cateList = null;
        if (____655.____659.categoryType.isEquip(categoryId)) {
            item = new ____2024();
            cateList = this.equipList
        } else {
            item = new ItemTemplateInfo();
            cateList = this.otherList
        }
        item.init(this.____1755, categoryId);
        this.list[item.templateId] = item;
        cateList[item.templateId] = item
    },
    ____103: function() {
        return 500
    },
    getItem: function(id) {
        return this.list[id]
    },
    getEquipItem: function(id) {
        return this.equipList[id]
    },
    getOtherItem: function(id) {
        return this.otherList[id]
    },
});
var LuckyTreasureTemplateInfo = cc.Class.extend({
    id: 0,
    showItemList: null,
    needItemId: 0,
    oneFee: 0,
    tenFee: 0,
    itemList: null,
    init: function(bytes) {
        this.id = bytes.readByte();
        this.showItemList = ____654.____674.strItemSplitToInts(bytes.readString());
        this.needItemId = bytes.readInt();
        this.oneFee = bytes.readShort();
        this.tenFee = bytes.readShort();
        this.itemList = ____654.____674.strItemSplitToInts(bytes.readString())
    },
});
var LuckyTreasureTemplateList = ____514.extend({
    list: null,
    ctor: function() {
        this._super();
        this.list = []
    },
    ____104: function() {
        var info = new LuckyTreasureTemplateInfo();
        info.init(this.____1755);
        this.list.push(info)
    },
    getInfoById: function(id) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].id == id) {
                return this.list[i]
            }
        }
        return null
    },
});
var ____2029 = cc.Class.extend({
    mapId: 0,
    mapPath: "",
    mapDataPath: "",
    name: "",
    music: 0,
    minLevel: 0,
    maxLevel: 0,
    isOpen: false,
    triggerInfos: null,
    safeAreas: null,
    afkPath: null,
    init: function(data) {
        this.mapId = data.readInt();
        this.mapPath = data.readString();
        this.mapDataPath = data.readString();
        this.name = data.readString();
        this.music = data.readShort();
        var requirementArr = data.readString().split("|");
        for (var i = 0; i < requirementArr.length; i++) {
            var ra = requirementArr[i].split(",");
            if (ra.length > 1) {
                if (ra[0] == "1") this.minLevel = parseInt(ra[1]);
                if (ra[0] == "2") this.maxLevel = parseInt(ra[1])
            }
        }
        this.isOpen = data.readBoolean();
        this.afkPath = ____654.____674.strSplitToPoints(data.readString());
        var triLen = data.readInt();
        this.triggerInfos = [];
        for (var i = 0; i < triLen; i++) {
            var trigger = new ____539();
            trigger.init(data);
            this.triggerInfos.push(trigger)
        }
        this.safeAreas = [];
        var safeTmp = data.readString().split("|");
        for (var i = 0; i < safeTmp.length; i++) {
            var safeArr1 = ____654.____674.____183(safeTmp[i], ",");
            if (safeArr1.length == 5) {
                if (safeArr1[0] == 1) {
                    this.safeAreas.push([safeArr1[1], safeArr1[2], safeArr1[3], safeArr1[4]])
                }
            }
        }
    },
    isInSafeArea: function(p) {
        for (var i = 0; i < this.safeAreas.length; i++) {
            var safe = this.safeAreas[i];
            if (p.x > safe[0] && p.x < (safe[0] + safe[2]) && p.y > safe[1] && p.y < (safe[1] + safe[3])) return true
        }
        return false
    },
});
var ____2030 = ____514.extend({
    ____1378: null,
    CITY_ID: 1001,
    init: function(data) {
        this._super(data);
        this.____1378 = []
    },
    ____104: function() {
        var item = new ____2029();
        item.init(this.____1755);
        this.____1378[item.mapId] = item
    },
    getMap: function(mapId) {
        return this.____1378[mapId]
    },
    canAFK: function(mapId) {
        return true
    },
    ____462: function(mapId) {
        if (mapId == this.CITY_ID) return false;
        return true
    },
    canToCopy: function(mapId) {
        return true
    },
    isShowCityBtn: function(mapId) {
        if (mapId == this.CITY_ID) {
            return false
        } else {
            return true
        }
    },
});
var MarryOathTemplateInfo = cc.Class.extend({
    id: 0,
    name: "",
    iconPath: null,
    fee: 0,
    attList: null,
    type: 0,
    init: function(data) {
        this.id = data.readByte();
        this.type = data.readByte();
        this.name = data.readString();
        this.iconPath = data.readString();
        this.fee = data.readShort();
        this.attList = ____654.____674.____184(data.readString())
    },
    getFight: function() {
        var fight = 0;
        for (var i = 0; i < this.attList.length; i++) {
            fight += ____655.____659.propertyType.getFight(this.attList[i].id, this.attList[i].value)
        }
        return fight
    },
});
var MarryOathTemplateList = ____514.extend({
    list: null,
    ctor: function() {
        this.list = {};
        this._super()
    },
    ____104: function() {
        var info = new MarryOathTemplateInfo();
        info.init(this.____1755);
        if (this.list[info.type] == null) {
            this.list[info.type] = []
        }
        this.list[info.type].push(info)
    },
    ____105: function() {
        this._super();

        function sortFunc(item1, item2) {
            return item2.fee - item1.fee
        };
        for (var k in this.list) {
            this.list[k].sort(sortFunc)
        }
    },
    ____55: function(type, id) {
        if (this.list[type] == null) return null;
        for (var i = 0; i < this.list[type].length; i++) {
            var info = this.list[type][i];
            if (info.id == id) {
                return info
            }
        }
        return null
    },
    getTemplateList: function(type) {
        return this.list[type]
    },
    isCanAdvance: function(type, ringType) {
        var info = this.getBestTempInfo(type);
        if (info != null && info.id > ringType) {
            return true
        }
        return false
    },
    getBestTempInfo: function(type) {
        var info = null;
        var list = this.list[type];
        if (list == null) return null;
        for (var i = 0; i < list.length; i++) {
            if (info == null || info.id < list[i].id) {
                info = list[i]
            }
        }
        return info
    },
});
var ____2031 = cc.Class.extend({
    id: 0,
    name: "",
    face: 0,
    headPath: "",
    totalHp: 0,
    sceneId: 0,
    level: 0,
    rndPoints: null,
    type: 0,
    bornEffect: 0,
    deadEffect: 0,
    operateType: 0,
    characterType: 0,
    canBeAttack: false,
    canBeSelect: false,
    canBeAFKSelect: false,
    ____347: false,
    quality: 0,
    showOnSmallMap: false,
    figureId: 0,
    fightValue: 0,
    init: function(data) {
        this.id = data.readInt();
        this.name = data.readString();
        this.totalHp = data.readNumber();
        this.sceneId = data.readShort();
        this.level = data.readShort();
        var tmpStr = data.readString();
        var tmp = ____654.____674.strSplitToPoints(tmpStr);
        this.rndPoints = tmp[Math.floor(Math.random() * tmp.length)];
        this.figureId = data.readInt();
        this.headPath = data.readInt();
        this.bornEffect = data.readInt();
        this.deadEffect = data.readInt();
        this.operateType = data.readInt();
        this.type = data.readByte();
        this.face = data.readByte();
        this.characterType = this.operateType % 10;
        this.canBeAttack = Math.floor(this.operateType / 10) % 10 == 0;
        this.canBeSelect = Math.floor(this.operateType / 100) % 10 == 0;
        this.canBeAFKSelect = Math.floor(this.operateType / 1000) % 10 == 0;
        this.____347 = Math.floor(this.operateType / 10000) % 10 == 0;
        this.quality = Math.floor(this.operateType / 100000) % 10 == 0;
        this.showOnSmallMap = Math.floor(this.operateType / 1000000) % 10 == 0;
        this.fightValue = data.readInt()
    },
    isBoss: function() {
        return this.type == 1
    },
});
var ____2032 = ____514.extend({
    monsterList: null,
    mapMonsterList: null,
    afkMonsterList: null,
    ctor: function() {
        this._super();
        this.monsterList = {};
        this.mapMonsterList = {};
        this.afkMonsterList = {}
    },
    ____104: function() {
        var monster = new ____2031();
        monster.init(this.____1755);
        this.monsterList[monster.id] = monster;
        if (this.mapMonsterList[monster.sceneId] == null) {
            this.mapMonsterList[monster.sceneId] = []
        }
        if (this.afkMonsterList[monster.sceneId] == null) {
            this.afkMonsterList[monster.sceneId] = []
        }
        if (monster.canBeAttack) {
            this.mapMonsterList[monster.sceneId].push(monster);
            if (monster.canBeAFKSelect) {
                this.afkMonsterList[monster.sceneId].push(monster)
            }
        }
    },
    getMonster: function(id) {
        var monster = this.monsterList[id];
        assert(monster, "怪物ID:{0}，找不到对应的静态数据。".format(id));
        return monster
    },
    ____103: function() {
        return 400
    },
    getMonsterHpBarCount: function(hp) {
        hp = hp * 0.000001;
        if (hp <= 3) {
            return 3
        } else if (hp < 10) {
            return 5
        } else if (hp < 20) {
            return 10
        } else if (hp < 50) {
            return 15
        } else if (hp < 100) {
            return 20
        } else if (hp < 200) {
            return 25
        } else if (hp < 500) {
            return 30
        } else if (hp < 1000) {
            return 35
        } else if (hp < 2000) {
            return 40
        } else if (hp < 3000) {
            return 45
        }
        return 50
    },
});
var NewlyGuideTemplateInfo = cc.Class.extend({
    id: 0,
    x: 0,
    y: 0,
    w: 0,
    h: 0,
    movieType: 0,
    callbackType: 0,
    nextId: 0,
    param: null,
    ctor: function() {
        this.param = {};
    },
    init: function(data) {
        this.id = data.readInt();
        this.x = data.readShort();
        this.y = data.readShort();
        this.w = data.readShort();
        this.h = data.readShort();
        this.movieType = data.readByte();
        this.callbackType = data.readInt();
        this.nextId = data.readInt();
        this.param = ____654.____674.____183(data.readString(), ",")
    },
});
var NewlyGuideTemplateList = ____514.extend({
    list: null,
    ctor: function() {
        this._super();
        this.list = {}
    },
    ____104: function() {
        var info = new NewlyGuideTemplateInfo();
        info.init(this.____1755);
        this.list[info.id] = info
    },
    ____55: function(id) {
        return this.list[id]
    },
});
var ____2033 = cc.Class.extend({
    templateId: 0,
    name: "",
    face: 1,
    funcName: "",
    mapId: 0,
    sceneX: 0,
    sceneY: 0,
    triggers: null,
    rndPoints: null,
    figureId: 0,
    imagePath: "",
    chatList: null,
    ____1108: "",
    _dialog: "",
    operateType: 0,
    characterType: 0,
    defaultFigure: 0,
    defaultFigureTemplate: null,
    sound: 0,
    init: function(data) {
        this.templateId = data.readInt();
        this.name = data.readString();
        this.funcName = data.readString();
        this.____1108 = data.readString();
        this.mapId = data.readShort();
        this.sceneX = data.readShort();
        this.sceneY = data.readShort();
        this.operateType = data.readInt();
        this.characterType = this.operateType % 10;
        this.triggers = [];
        var len = data.readInt();
        for (var i = 0; i < len; i++) {
            var trigger = new ____539();
            trigger.init(data);
            this.triggers.push(trigger)
        }
        var tmp = ____654.____674.strSplitToPoints(data.readString());
        this.rndPoints = tmp[Math.floor(Math.random() * tmp.length)];
        this.figureId = data.readInt();
        this.defaultFigure = data.readInt();
        this.imagePath = data.readString();
        this.face = data.readByte();
        this.chatList = data.readString().split("|");
        this.sound = data.readShort()
    },
    getDialog: function() {
        if (this._dialog != "") return this._dialog;
        if (this.____1108 != "") {
            this._dialog = ____654.____682.____108(this.____1108);
            return this._dialog
        }
        return this.____1108
    },
});
var ____2034 = ____514.extend({
    list: null,
    sceneList: null,
    init: function(data) {
        this._super(data);
        this.list = {};
        this.sceneList = {}
    },
    ____104: function() {
        var npc = new ____2033();
        npc.init(this.____1755);
        this.list[npc.templateId] = npc;
        if (this.sceneList[npc.mapId] == null) {
            this.sceneList[npc.mapId] = []
        }
        if (npc.figureId != 0) {
            this.sceneList[npc.mapId].push(npc)
        }
    },
    getNpc: function(id) {
        var npc = this.list[id];
        assert(npc, "npc数据不存在：" + id);
        return npc
    },
    getNpcByScene: function(mapId) {
        return this.sceneList[mapId]
    },
});
var ____2035 = cc.Class.extend({
    id: 0,
    title: null,
    showType: 0,
    conditionList: null,
    awardList: null,
    openServerBegin: 0,
    openServerEnd: 0,
    beginDate: 0,
    endDate: 0,
    weeks: 0,
    agentIdList: "",
    property1: null,
    init: function(bytes) {
        this.id = bytes.readInt();
        this.title = bytes.readString();
        this.showType = bytes.readInt();
        this.conditionList = ____654.____674.strItemSplitToInts(bytes.readString());
        this.awardList = [];
        if (this.showType >= 10 && this.showType <= 12) {
            var str = bytes.readString();
            var list = str.split(";");
            var len = list.length;
            for (var i = 0; i < len; i++) {
                if (this.awardList[i] == null) {
                    this.awardList[i] = []
                }
                this.awardList[i] = ____654.____674.strItemSplitToInts(list[i])
            }
        } else {
            this.awardList = ____654.____674.strItemSplitToInts(bytes.readString())
        }
        this.openServerBegin = bytes.readUShort();
        this.openServerEnd = bytes.readUShort();
        this.beginDate = bytes.readInt();
        this.endDate = bytes.readInt();
        this.weeks = bytes.readUByte();
        this.agentIdList = bytes.readString();
        this.property1 = bytes.readString()
    },
});
var ____2036 = ____514.extend({
    list: null,
    openInfoList: null,
    typeList: null,
    countDownTypeList: null,
    loginGiftList: null,
    openLeiChongList: null,
    waiXingChongJieList: null,
    ctor: function() {
        this._super();
        this.list = [];
        this.waiXingChongJieList = {}
    },
    ____104: function() {
        var info = new ____2035();
        info.init(this.____1755);
        this.list.push(info);
        if (info.showType == 30) {
            this.waiXingChongJieList[info.id] = info
        }
    },
    updateList: function() {
        this.countDownTypeList = [];
        this.openInfoList = [];
        this.typeList = [];
        this.loginGiftList = [];
        this.openLeiChongList = [];
        var systemTime = ____655.____662.getSystemTimeSec();
        for (var i = 0; i < this.list.length; i++) {
            var info = this.list[i];
            var beginSecond = ____655.____662.getTimesByDay(info.openServerBegin);
            var finishSecond = ____655.____662.getTimesByDay(info.openServerEnd);
            if (finishSecond > systemTime && beginSecond <= systemTime) {
                if (info.weeks >= 1) {
                    var openDay = ____655.____662.getClientDate().getDay();
                    if (openDay == 0) {
                        openDay = 7
                    }
                    if (openDay == info.weeks) {
                        if (this.typeList.indexOf(info.showType) == -1) {
                            this.typeList.push(info.showType);
                            this.countDownTypeList.push(info.showType)
                        }
                        this.openInfoList.push(info)
                    }
                } else if (info.endDate > systemTime && info.beginDate <= systemTime) {
                    if (info.showType >= 1 && info.showType <= 100) {
                        if (this.typeList.indexOf(info.showType) == -1) {
                            this.typeList.push(info.showType)
                        }
                        if (systemTime + ____655.____662.secondsOfDay >= info.endDate || systemTime + ____655.____662.secondsOfDay >= finishSecond) {
                            if (this.countDownTypeList.indexOf(info.showType) == -1) {
                                this.countDownTypeList.push(info.showType)
                            }
                        }
                        this.openInfoList.push(info)
                    } else if (info.showType == 101) {
                        this.loginGiftList.push(info)
                    } else if (info.showType == 102) {
                        this.openLeiChongList.push(info)
                    }
                }
            }
        }
    },
});
var ____2037 = ____591.extend({
    loginGiftAwardList: null,
    selfInfoList: null,
    waiXingChongJieInfo: null,
    ctor: function() {
        this._super();
        this.loginGiftAwardList = [];
        this.selfInfoList = [];
        this.waiXingChongJieInfo = new WaiXingChongjieInfo();
        this.____6()
    },
    setOpenSelfInfo: function(data) {
        var len = data.readInt();
        for (var i = 0; i < len; i++) {
            var info = new ____2038();
            info.init(data);
            this.insertSelfInfo(info)
        }
        this.dispatchEvent(new ____590(____655.____661.playerInfo_selfInfo_Update, this, null))
    },
    getSelfInfoById: function(id) {
        for (var i = 0; i < this.selfInfoList.length; i++) {
            if (this.selfInfoList[i].id == id) {
                return this.selfInfoList[i]
            }
        }
        return null
    },
    insertSelfInfo: function(selfInfo) {
        if (this.selfInfoList.length > 0) {
            for (var i = 0; i < this.selfInfoList.length; i++) {
                if (this.selfInfoList[i].id == selfInfo.id) {
                    this.selfInfoList[i] = selfInfo;
                    this.dispatchEvent(new ____590(____655.____661.playerInfo_selfInfo_Update, this, selfInfo.id));
                    return
                }
            }
        }
        this.selfInfoList.push(selfInfo);
        this.dispatchEvent(new ____590(____655.____661.playerInfo_selfInfo_Update, this, selfInfo.id))
    },
    getInfoByShowType: function(showType) {
        var data = [];
        var infoList = ____655.allTemplates.openActivityTemplateList.openInfoList;
        for (var i = 0; i < infoList.length; i++) {
            if (infoList[i].showType == showType) {
                data.push(infoList[i])
            }
        }
        return data
    },
    setLoginGiftInfo: function(data) {
        this.loginGiftAwardList = [];
        var len = data.readUByte();
        for (var i = 0; i < len; i++) {
            var days = data.readUByte();
            this.loginGiftAwardList.push(days)
        }
        this.dispatchEvent(new ____590(____655.____661.playerInfo_loginGiftInfo_Update, this, null))
    },
    setTemplateInfo: function() {
        ____655.allTemplates.openActivityTemplateList.updateList();
        this.dispatchEvent(new ____590(____655.____661.playerInfo_openTemplate, this, null))
    },
    updateWaiXingChongJieInfo: function(data) {
        this.waiXingChongJieInfo.tempId = data.readShort();
        this.waiXingChongJieInfo.state = data.readByte();
        print("#外形冲阶活动信息", this.waiXingChongJieInfo.tempId, this.waiXingChongJieInfo.state);
        this.dispatchEvent(new ____590(____655.____661.playerInfo_waiXingChongJie, this, null))
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.setTemplateInfo, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.global_dayUpdate, this.setTemplateInfo, this)
    },
    ____61: function() {
        this.loginGiftAwardList = [];
        this.selfInfoList = [];
        this.waiXingChongJieInfo.____61()
    },
});
var ____2038 = cc.Class.extend({
    id: 0,
    time: 0,
    count: 0,
    init: function(data) {
        this.id = data.readInt();
        this.time = data.readInt();
        this.count = data.readInt()
    },
});
var WaiXingChongjieInfo = cc.Class.extend({
    tempId: -1,
    state: -1,
    ____61: function() {
        this.tempId = -1;
        this.state = -1
    },
});
var DailyFirstRechargeTemplateInfo = cc.Class.extend({
    id: 0,
    condition: 0,
    times: 0,
    weekDay: 0,
    isShowFlag: 0,
    awardList: null,
    init: function(data) {
        this.id = data.readShort();
        this.condition = data.readShort();
        this.times = data.readShort();
        this.weekDay = data.readByte();
        this.isShowFlag = data.readByte();
        this.awardList = ____654.____674.strItemSplitToInts(data.readString())
    },
});
var DailyFirstRechargeTemplateList = ____514.extend({
    list: null,
    conditionList: null,
    ctor: function() {
        this.list = {};
        this.conditionList = [];
        this._super()
    },
    ____104: function() {
        var info = new DailyFirstRechargeTemplateInfo();
        info.init(this.____1755);
        if (this.list[info.condition] == null) {
            this.list[info.condition] = {};
            this.conditionList.push(info.condition)
        }
        if (this.list[info.condition][info.weekDay] == null) {
            this.list[info.condition][info.weekDay] = []
        }
        this.list[info.condition][info.weekDay].push(info)
    },
    ____55: function(condition) {
        var day = ____655.____662.getClientDate().getDay();
        if (day == 0) {
            day = 7
        }
        if (this.list[condition] == null || this.list[condition][day] == null) {
            return null
        }
        var index = this.conditionList.indexOf(condition);
        var times = ____655.dailyFirstRechargeInfo.getRecordTimes(day, index);
        var rechargeValue = ____655.____667.moneyInfo.getTodayRecharge();
        if (condition <= rechargeValue) {
            times--
        }
        return this.list[condition][day][times - 1]
    },
    getConditionList: function() {
        var list = [];
        var day = ____655.____662.getClientDate().getDay();
        if (day == 0) {
            day = 7
        }
        for (var i = 0; i < this.conditionList.length; i++) {
            var condition = this.conditionList[i];
            var times = ____655.dailyFirstRechargeInfo.getRecordTimes(day, i);
            if (this.list[condition][day][times - 1] != null) {
                list.push(condition)
            }
        }
        return list
    },
    getMaxCondition: function() {
        var list = this.getConditionList();
        var condition = 0;
        for (var i = 0; i < list.length; i++) {
            condition = Math.max(condition, list[i])
        }
        return condition
    },
});
var ____2039 = cc.Class.extend({
    id: 0,
    payType: 0,
    agentId: 0,
    plat: 0,
    unit: null,
    count: 0,
    first_yuanbao: 0,
    gift_yuanbao: 0,
    pic: null,
    price: 0,
    sort: 0,
    produceId: null,
    descript: null,
    award: null,
    showAwardList: null,
    limitCount: 0,
    oldPrice: 0,
    beginDay: 0,
    endDay: 0,
    weekDay: 0,
    init: function(data) {
        this.id = data.readInt();
        this.plat = data.readByte();
        this.payType = data.readByte();
        this.unit = data.readString();
        this.count = data.readInt();
        this.first_yuanbao = data.readInt();
        this.gift_yuanbao = data.readInt();
        this.price = data.readInt();
        this.sort = data.readByte();
        this.pic = data.readString();
        this.produceId = data.readString();
        this.descript = data.readString();
        if (this.payType >= 10) {
            this.award = ____654.____674.strItemSplitToInts(data.readString());
            this.showAwardList = ____654.____674.strItemSplitToInts(data.readString());
            this.limitCount = data.readInt();
            this.oldPrice = data.readInt();
            this.beginDay = data.readShort();
            this.endDay = data.readShort();
            this.weekDay = data.readShort()
        } else {
            this.agentId = data.readShort()
        }
    },
});
var ____2040 = ____514.extend({
    list: null,
    monthCardInfo: null,
    rechargeList: null,
    ctor: function() {
        this._super();
        this.list = {}
    },
    ____104: function() {
        var item = new ____2039();
        item.init(this.____1755);
        this.list[item.id] = item
    },
    getTemplateInfoList: function() {
        var res = [];
        for (var key in this.list) {
            res.push(this.list[key])
        }
        return res
    },
    getTemplateInfoListByPayType: function(type) {
        var res = [];
        for (var key in this.list) {
            if (this.list[key].payType == type) {
                res.push(this.list[key])
            }
        }
        return res
    },
    getRechargeList: function() {
        if (this.rechargeList == null || this.rechargeList.length <= 0) {
            this.rechargeList = [];
            var temp = this.getTemplateInfoListByPayType(1);
            for (var i = 0; i < temp.length; i++) {
                if (temp[i].agentId == ____655.____663.agentId) {
                    this.rechargeList.push(temp[i])
                }
            }
            if (this.rechargeList.length <= 0) {
                for (var i = 0; i < temp.length; i++) {
                    if (temp[i].agentId == 0) {
                        this.rechargeList.push(temp[i])
                    }
                }
            }
        }
        return this.rechargeList
    },
    getProduceIdForTemplateInfo: function(templateInfo) {
        if (templateInfo.payType == 1 || templateInfo.payType == 2) {
            return templateInfo.produceId
        }
        if (this.rechargeList == null || this.rechargeList.length <= 0) {
            this.getRechargeList()
        }
        for (var i = 0; i < this.rechargeList.length; i++) {
            if (this.rechargeList[i].price == templateInfo.price) {
                return this.rechargeList[i].produceId
            }
        }
    },
    getMonthCardInfo: function() {
        if (this.monthCardInfo == null) {
            var temp = this.getTemplateInfoListByPayType(2);
            for (var i = 0; i < temp.length; i++) {
                if (temp[i].agentId == ____655.____663.agentId) {
                    this.monthCardInfo = temp[i];
                    break
                }
            }
            if (this.monthCardInfo == null) {
                for (var i = 0; i < temp.length; i++) {
                    if (temp[i].agentId == 0) {
                        this.monthCardInfo = temp[i];
                        break
                    }
                }
            }
        }
        return this.monthCardInfo
    },
    getInfoById: function(id) {
        return this.list[id]
    },
});
var ____2043 = cc.Class.extend({
    id: 0,
    type: 0,
    stage: 0,
    minLevel: 0,
    maxLevel: 0,
    tittleId: 0,
    awardList: null,
    exCondition: null,
    exAwardList: null,
    init: function(data) {
        this.id = data.readInt();
        this.type = data.readUByte();
        this.stage = data.readInt();
        this.minLevel = data.readInt();
        this.maxLevel = data.readInt();
        this.tittleId = data.readInt();
        this.awardList = ____654.____674.strItemSplitToInts(data.readString());
        this.exCondition = ____654.____674.____183(data.readString(), ",");
        this.exAwardList = ____654.____674.strItemSplitToInts(data.readString())
    },
});
var ____2044 = ____514.extend({
    list: null,
    typeList: null,
    ctor: function() {
        this.list = {};
        this.typeList = {};
        this._super()
    },
    ____104: function() {
        var info = new ____2043();
        info.init(this.____1755);
        this.list[info.id] = info;
        if (this.typeList[info.type] == null) {
            this.typeList[info.type] = []
        }
        this.typeList[info.type].push(info)
    },
    getTypeList: function(type) {
        return this.typeList[type]
    },
    ____238: function(id) {
        return this.list[id]
    },
});
var ____525 = cc.Class.extend({
    id: 0,
    shopType: 0,
    templateId: 0,
    amount: 0,
    payType: 0,
    oldPrice: 0,
    price: 0,
    tagType: 0,
    isLimit: false,
    itemTemplateInfo: null,
    isShow: false,
    init: function(data, shopType, isLimit) {
        this.id = data.readInt();
        this.shopType = shopType;
        this.isLimit = isLimit;
        this.templateId = data.readInt();
        this.amount = data.readInt();
        this.payType = data.readByte();
        this.oldPrice = data.readInt();
        this.price = data.readInt();
        this.tagType = data.readByte();
        this.isShow = data.readBoolean();
        this.itemTemplateInfo = ____655.allTemplates.____794.getItem(this.templateId)
    },
    getCanShow: function() {
        return true
    },
});
var ____2046 = ____525.extend({
    limitBuyCount: 0,
    needLevel: 0,
    needClubLevel: 0,
    beginDay: 0,
    endDay: 0,
    weekDay: 0,
    beginDate: 0,
    endDate: 0,
    init: function(data, shopType, isLimit) {
        this._super(data, shopType, isLimit);
        this.limitBuyCount = data.readInt();
        this.needLevel = data.readShort();
        this.needClubLevel = data.readShort();
        this.beginDay = data.readShort();
        this.endDay = data.readShort();
        this.weekDay = data.readShort();
        this.beginDate = data.readInt();
        this.endDate = data.readInt()
    },
    getCanShow: function() {
        return true
    },
});
var ____2047 = ____525.extend({
    count: 0,
    career: 0,
    strength: 0,
    stage: 0,
    init: function(data, shopType, isLimit) {
        this._super(data, shopType, isLimit);
        var tmp = ____654.____674.strItemSplitToInts(data.readString());
        this.templateId = tmp[0];
        this.count = tmp[1];
        this.career = tmp[2];
        this.strength = tmp[3];
        this.stage = tmp[4]
    },
});
var ____2048 = cc.Class.extend({
    type: 0,
    shopName: "",
    list: null,
    showList: null,
    ctor: function(type) {
        this.type = type;
        this.list = [];
        this.showList = []
    },
    ____367: function(item) {
        this.list.push(item);
        if (item.isShow) {
            this.showList.push(item)
        }
    },
});
var ____2049 = ____514.extend({
    shopItemList: null,
    shops: null,
    shopType_1: 1,
    shopType_2: 2,
    shopType_3: 3,
    shopType_9: 9,
    shopType_10: 10,
    shopType_101: 101,
    shopType_102: 102,
    ctor: function() {
        this.shopItemList = {};
        this.shops = {}
    },
    ____104: function() {
        var info = null,
            isLimit = false,
            shopType = this.____1755.readShort();
        if (shopType == this.shopType_9) {
            info = new ____2047()
        } else {
            isLimit = this.____1755.readByte();
            if (isLimit) {
                info = new ____2046()
            } else {
                info = new ____525()
            }
        }
        if (!!info) {
            info.init(this.____1755, shopType, isLimit);
            this.shopItemList[info.id] = info;
            if (this.shops[info.shopType] == null) {
                this.shops[info.shopType] = new ____2048(info.shopType)
            }
            this.shops[info.shopType].____367(info)
        }
    },
    getShopItem: function(id) {
        return this.shopItemList[id]
    },
    getZuanshiShopItemByTempId: function(templateId) {
        if (this.shops[this.shopType_1] == null) {
            return null
        }
        var list = this.shops[this.shopType_1].list;
        for (var i = 0; i < list.length; i++) {
            if (list[i].templateId == templateId) {
                return list[i]
            }
        }
        return null
    },
    getShopTempListByType: function(type) {
        if (this.shops[type] == null) {
            return []
        }
        return this.shops[type].showList
    },
    getShopAllTempListByType: function(type) {
        if (this.shops[type] == null) {
            return []
        }
        return this.shops[type].list
    },
});
var ____2050 = ____591.extend({
    id: 0,
    level: 0,
    template: null,
    lastUseTime: 0,
    isInCommon: false,
    ____54: function(id) {
        this.id = id;
        this.template = ____655.allTemplates.skillTemplateList.getSkill(id)
    },
    setLastUseTime: function(value) {
        if (this.lastUseTime == value) return;
        this.lastUseTime = value;
        var n = this.getLeftCD();
        if (n > 0) {
            this.dispatchEvent(new ____590(____655.____661.playerInfo_skillCD, this, n))
        }
    },
    getLeftCD: function() {
        var t = this.template.cd - (____655.____662.getSystemTime() - this.lastUseTime);
        if (t < 0) t = 0;
        return t
    },
    isInCD: function() {
        return (____655.____662.getSystemTime() - this.lastUseTime) < this.template.cd
    },
    getCanUse: function() {
        if (this.isInCD()) return false;
        return true
    },
    getCanAFKUse: function() {
        if (!this.template.isAFKUse) return false;
        return this.getCanUse()
    },
    getCanAFKUseWithoutCD: function() {
        if (!this.template.isAFKUse) return false;
        return true
    },
    isMaxLevel: function() {
        return this.level >= this.template.totalLevel
    },
    setCommonCD: function() {
        var cdLast = ____655.____662.getSystemTime() - this.template.cd + ____655.commonCD;
        if (cdLast > this.lastUseTime) {
            this.lastUseTime = cdLast
        }
    },
});
var ____2051 = ____591.extend({
    defaultSkill: null,
    skillList: null,
    afkList: null,
    jiazuwar_blood: null,
    jiazuwar_speed: null,
    _state: 0,
    zhuoYao_pugong: null,
    zhuoYao_qungong: null,
    zhuoYao_lianji: null,
    xunbao_tishen: null,
    xunbao_shuoxiao: null,
    xunbao_tiaoyue: null,
    xunbao_jianshu: null,
    xunbao_zhiliao: null,
    _zhuoYaoAfk: null,
    ctor: function() {
        this._super();
        this.skillList = {};
        this.afkList = [];
        this._zhuoYaoAfk = []
    },
    templateComplete: function() {
        this.jiazuwar_speed = new ____2050();
        this.jiazuwar_speed.____54(____655.allTemplates.skillTemplateList.JIAZUWAR_SPEED);
        this.jiazuwar_speed.level = 1;
        this.jiazuwar_blood = new ____2050();
        this.jiazuwar_blood.____54(____655.allTemplates.skillTemplateList.JIAZUWAR_BLOOD);
        this.jiazuwar_blood.level = 1;
        this.zhuoYao_pugong = new ____2050();
        this.zhuoYao_pugong.____54(____655.allTemplates.skillTemplateList.ZHUOYAO_PUGONG);
        this.zhuoYao_pugong.level = 1;
        this.zhuoYao_qungong = new ____2050();
        this.zhuoYao_qungong.____54(____655.allTemplates.skillTemplateList.ZHUOYAO_QUNGONG);
        this.zhuoYao_qungong.level = 1;
        this.zhuoYao_lianji = new ____2050();
        this.zhuoYao_lianji.____54(____655.allTemplates.skillTemplateList.ZHUOYAO_LIANJI);
        this.zhuoYao_lianji.level = 1;
        this._zhuoYaoAfk.push(this.zhuoYao_pugong);
        this._zhuoYaoAfk.push(this.zhuoYao_qungong);
        this._zhuoYaoAfk.push(this.zhuoYao_lianji);
        this.xunbao_tishen = new ____2050();
        this.xunbao_tishen.____54(____655.allTemplates.skillTemplateList.XUNBAO_TISHEN);
        this.xunbao_tishen.level = 1;
        this.xunbao_shuoxiao = new ____2050();
        this.xunbao_shuoxiao.____54(____655.allTemplates.skillTemplateList.XUNBAO_SHUOXIAO);
        this.xunbao_shuoxiao.level = 1;
        this.xunbao_tiaoyue = new ____2050();
        this.xunbao_tiaoyue.____54(____655.allTemplates.skillTemplateList.XUNBAO_TIAOYUE);
        this.xunbao_tiaoyue.level = 1;
        this.xunbao_jianshu = new ____2050();
        this.xunbao_jianshu.____54(____655.allTemplates.skillTemplateList.XUNBAO_JIANSHU);
        this.xunbao_jianshu.level = 1;
        this.xunbao_zhiliao = new ____2050();
        this.xunbao_zhiliao.____54(____655.allTemplates.skillTemplateList.XUNBAO_ZHILIAO);
        this.xunbao_zhiliao.level = 1
    },
    addSkill: function(skill) {
        this.skillList[skill.id] = skill;
        if (this.afkList.indexOf(skill) == -1) {
            if (skill.template.isDefault) {
                this.defaultSkill = skill
            } else if (skill.getCanAFKUseWithoutCD()) {
                this.afkList.push(skill)
            }
        }
        this.dispatchEvent(new ____590(____655.____661.playerInfo_addSkill, this, skill))
    },
    updateSkill: function(skill) {
        this.dispatchEvent(new ____590(____655.____661.playerInfo_skillUpdate, this, skill))
    },
    skillListUpdate: function() {
        this.dispatchEvent(new ____590(____655.____661.playerInfo_skillListUpdate, this))
    },
    getSkill: function(id) {
        return this.skillList[id]
    },
    getSkillLevel: function(id) {
        if (this.skillList[id] == null) {
            return 0
        }
        return this.skillList[id].level
    },
    removeSkill: function(id) {
        var skill = this.skillList[id];
        if (skill != null) {
            this.dispatchEvent(new ____590(____655.____661.playerInfo_removeSkill, this, skill));
            this.skillList[id] = null;
            delete this.skillList[id];
            skill.dispose()
        }
    },
    getSkillByCopyId: function(copyId) {
        var skills = [];
        if (copyId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID) {
            if (this._state == 0) {
                skills = this.getDefaultSkillList()
            } else {
                skills.push(null);
                skills.push(this.jiazuwar_speed);
                skills.push(this.jiazuwar_blood)
            }
        } else if (copyId == ____655.allTemplates.copyTemplateList.ZUOYAO_COPYID) {
            skills.push(this.zhuoYao_pugong);
            skills.push(this.zhuoYao_qungong);
            skills.push(this.zhuoYao_lianji)
        } else if (copyId == ____655.allTemplates.copyTemplateList.XUNBAO_COPYID) {
            skills.push(this.xunbao_tiaoyue);
            skills.push(this.xunbao_tishen);
            skills.push(this.xunbao_shuoxiao);
            skills.push(this.xunbao_jianshu);
            skills.push(this.xunbao_zhiliao)
        } else {
            skills = this.getDefaultSkillList()
        }
        skills = skills.sort(function(a, b) {
            if (a == null || b == null) return -1;
            return a.id - b.id
        });
        return skills
    },
    getDefaultSkillList: function() {
        var skills = [];
        for (var id in this.skillList) {
            if (this.skillList[id].template.isDefault) {
                skills.unshift(this.skillList[id])
            } else {
                skills.push(this.skillList[id])
            }
        }
        return skills
    },
    getDefaultSkillByCopyId: function(copyId) {
        if (this.copyId == ____655.allTemplates.copyTemplateList.ZUOYAO_COPYID) return this.zhuoYao_pugong;
        return this.defaultSkill
    },
    setState: function(value) {
        if (this._state == value) return;
        this._state = value;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_skillStateChange, this))
    },
    getState: function() {
        return this._state
    },
    getAFKSkill: function() {
        var list = this.getAFKListByCopyId();
        for (var i = 0; i < list.length; i++) {
            if (list[i].getCanAFKUse()) {
                return list[i]
            }
        }
        return null
    },
    moveAFKSkillToBack: function(skillId) {
        if (this.skillList[skillId] == null) return;
        if (!this.skillList[skillId].template.isAFKUse) return;
        var list = this.getAFKListByCopyId();
        for (var i = 0; i < list.length; i++) {
            if (list[i].id == skillId) {
                var s = list.splice(i, 1)[0];
                list.push(s);
                break
            }
        }
    },
    getAFKListByCopyId: function() {
        var list = null;
        if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.ZUOYAO_COPYID) {
            list = this._zhuoYaoAfk
        } else {
            list = this.afkList
        }
        return list
    },
    ____61: function() {
        this.defaultSkill = null;
        for (var i in this.skillList) {
            this.skillList[i].dispose()
        }
        this.skillList = {};
        this.afkList = [];
        this._state = 0
    },
});
var ____2052 = cc.Class.extend({
    activeNeedSkill: null,
    activeNeedMoney3: 0,
    activeNeedItem: null,
    upgradeNeedItem: null,
    upgradeNeedLevel: 0,
    init: function(data) {
        this.activeNeedSkill = [];
        var tmp = data.readString().split("|");
        for (var i = 0; i < tmp.length; i++) {
            var tt = tmp[i].split(",");
            if (tt.length == 2) {
                var arr = [parseInt(tt[0]), parseInt(tt[1])];
                this.activeNeedSkill.push(arr)
            }
        }
        this.activeNeedMoney3 = data.readInt();
        this.activeNeedItem = [];
        tmp = data.readString().split("|");
        for (var i = 0; i < tmp.length; i++) {
            var tt = tmp[i].split(",");
            if (tt.length == 2) {
                var arr = [parseInt(tt[0]), parseInt(tt[1])];
                this.activeNeedItem.push(arr)
            }
        }
        this.upgradeNeedItem = [];
        tmp = data.readString().split("|");
        for (var i = 0; i < tmp.length; i++) {
            var tt = tmp[i].split(",");
            if (tt.length == 2) {
                var arr = [parseInt(tt[0]), parseInt(tt[1])];
                this.upgradeNeedItem.push(arr)
            }
        }
        this.upgradeNeedLevel = data.readShort()
    },
});
var SkillTemplateInfo = BaseItemInfo.extend({
    name: "",
    totalLevel: 0,
    targetType: 0,
    skillType: 0,
    activeType: 0,
    cd: 0,
    attackEffect: 0,
    showWeaponEffect: 0,
    behitEffect: 0,
    isDefault: false,
    commonCD: false,
    distance: 0,
    place: 0,
    needCareer: 0,
    affectCount: 0,
    sound: 0,
    isShake: false,
    autoSelectTarget: false,
    isAFKUse: false,
    playAction: false,
    showSkillName: false,
    hitEffectDelay: 0,
    behitEffectDelay: 0,
    bloodDelay: 0,
    shakeDelay: 0,
    hitBackDelay: 0,
    breakCollect: false,
    needLevel: null,
    descriptText: null,
    init: function(data) {
        this.templateId = data.readInt();
        this.iconPath = data.readString();
        this._picPath = this.iconPath;
        this.name = data.readString();
        this.targetType = data.readByte();
        this.skillType = data.readByte();
        this.activeType = data.readByte();
        this.cd = data.readInt();
        this.commonCD = data.readBoolean();
        this.attackEffect = data.readInt();
        this.showWeaponEffect = data.readBoolean();
        this.behitEffect = data.readInt();
        this.isDefault = data.readBoolean();
        this.showSkillName = data.readBoolean();
        this.distance = data.readShort();
        this.place = data.readByte();
        this.needCareer = data.readByte();
        this.affectCount = data.readByte();
        this.sound = data.readShort();
        this.isShake = data.readBoolean();
        this.autoSelectTarget = data.readBoolean();
        this.isAFKUse = data.readBoolean();
        this.playAction = data.readBoolean();
        this.hitEffectDelay = data.readUByte();
        this.behitEffectDelay = data.readUByte();
        this.bloodDelay = data.readUByte();
        this.shakeDelay = data.readUByte();
        this.hitBackDelay = data.readUByte();
        this.needLevel = [];
        this.descriptText = [];
        var count = data.readShort();
        for (var i = 0; i < count; i++) {
            this.needLevel.push(data.readShort());
            this.descriptText.push(data.readString())
        }
    },
    isToSelf: function() {
        return this.targetType == 1 || this.targetType == 2 || this.targetType == 3
    },
    isForeword: function() {
        return this.targetType == 4
    },
    isStartAttack: function() {
        return this.targetType == 0
    },
});
var ____2054 = ____514.extend({
    skillList: null,
    skillListByType: null,
    JIAZUWAR_BLOOD: 3960,
    JIAZUWAR_SPEED: 3961,
    ZHUOYAO_PUGONG: 3940,
    ZHUOYAO_QUNGONG: 3942,
    ZHUOYAO_LIANJI: 3941,
    XUNBAO_TISHEN: 3950,
    XUNBAO_SHUOXIAO: 3951,
    XUNBAO_TIAOYUE: 3952,
    XUNBAO_JIANSHU: 3953,
    XUNBAO_ZHILIAO: 3954,
    _skillList1: null,
    _skillList2: null,
    ctor: function() {
        this.skillList = {};
        this.skillListByType = {};
        this._super()
    },
    ____104: function() {
        var skill = new SkillTemplateInfo();
        skill.init(this.____1755);
        this.skillList[skill.templateId] = skill;
        if (!this.skillListByType[skill.skillType]) {
            this.skillListByType[skill.skillType] = []
        }
        this.skillListByType[skill.skillType].push(skill)
    },
    ____105: function() {
        this._super();
        this._skillList1 = [3101, 4111, 4112, 4113, 4114];
        this._skillList2 = [3103, 4121, 4122, 4123, 4124]
    },
    getList: function(type) {
        return this.skillListByType[type]
    },
    getSkill: function(id) {
        return this.skillList[id]
    },
    getChangeSkillId: function(skillId, godType) {
        if (this._skillList1.indexOf(skillId) == -1 && this._skillList2.indexOf(skillId) == -1) return skillId;
        if (godType == 0) return skillId;
        else if (godType == 1) return skillId + 400;
        else if (godType == 2) return skillId + 500;
        else if (godType == 3) return skillId + 600;
        return skillId
    },
    getSkillName: function(skillId, godType) {
        return this.getSkill(this.getChangeSkillId(skillId, godType)).name
    },
    getSkillIconPath: function(skillId, godType) {
        return this.getSkill(this.getChangeSkillId(skillId, godType)).iconPath
    },
    getSkillFullPath: function(skillId, godType) {
        return ____654.____675.getSkillIconPath(this.getSkillIconPath(skillId, godType))
    },
    getSkillListByCareer: function(career) {
        if (career == 1) return this._skillList1;
        return this._skillList2
    },
    getSkillTypeName: function(type) {
        var res = "";
        if (type == 1) {
            res = ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle35")
        } else if (type == 3) {
            res = ____655.____659.nameType.advanceName[0]
        } else if (type == 4) {
            res = ____655.____659.nameType.advanceName[2]
        } else if (type == 5) {
            res = ____655.____659.nameType.advanceName[4]
        } else if (type == 6) {
            res = ____655.____659.nameType.advanceName[5]
        } else if (type == 7) {
            res = ____655.____659.nameType.advanceName[6]
        } else if (type == 8) {
            res = ____655.____659.nameType.advanceName[3]
        } else if (type == 9) {
            res = ____655.____659.nameType.advanceName[1]
        } else {
            res = ____654.yuyanbaoManager.getYuyanbao("itemTip.categoryType1")
        }
        return res
    }
});
var ____527 = cc.Class.extend({
    templateId: 0,
    count: 0,
    needCareer: 0,
    qhLevel: 0,
    quality: 0,
    init: function(data) {
        var arr = data.split(",");
        if (arr.length > 0) {
            this.templateId = parseInt(arr[0]);
            this.count = parseInt(arr[1]);
            if (arr[2] != null) {
                this.qhLevel = parseInt(arr[2])
            }
            if (arr[3] != null) {
                this.quality = parseInt(arr[3])
            }
            if (arr[4] != null) {
                this.needCareer = parseInt(arr[4])
            }
        }
    },
});
var TaskTemplateInfo = cc.Class.extend({
    id: 0,
    groupId: 0,
    type: 0,
    title: "",
    condition: 0,
    termList: null,
    acceptNpc: 0,
    acceptContentId: 0,
    acceptContent: null,
    finishNpc: 0,
    finishContentId: 0,
    finishContent: null,
    beginDate: 0,
    endDate: 0,
    maxLv: 0,
    minLv: 0,
    needCareer: 0,
    repeatCount: 0,
    repeatDay: 0,
    isAuto: true,
    preTaskIds: null,
    xianwei: 0,
    acceptTriggers: null,
    notFinishTrigger: null,
    finishTrigger: null,
    submitTriggers: null,
    awardList: null,
    init: function(bytes) {
        this.id = bytes.readInt();
        this.groupId = bytes.readInt();
        this.type = bytes.readByte();
        this.title = bytes.readString();
        this.condition = bytes.readInt();
        var termStr = bytes.readString();
        this.termList = ____654.____674.strItemSplitToInts(termStr);
        this.acceptNpc = bytes.readInt();
        this.acceptContentId = bytes.readString();
        this.finishNpc = bytes.readInt();
        this.finishContentId = bytes.readString();
        this.beginDate = bytes.readInt();
        this.endDate = bytes.readInt();
        this.xianwei = bytes.readShort();
        this.maxLv = bytes.readShort();
        this.minLv = bytes.readShort();
        this.needCareer = bytes.readByte();
        this.isAuto = bytes.readBoolean();
        var preStr = bytes.readString();
        this.preTaskIds = ____654.____674.____183(preStr, ",");
        var len = bytes.readInt();
        this.acceptTriggers = [];
        for (var i = 0; i < len; i++) {
            var trigger = new ____539();
            trigger.init(bytes);
            this.acceptTriggers.push(trigger)
        }
        len = bytes.readInt();
        this.notFinishTrigger = [];
        for (var i = 0; i < len; i++) {
            var trigger = new ____539();
            trigger.init(bytes);
            this.notFinishTrigger.push(trigger)
        }
        len = bytes.readInt();
        this.finishTrigger = [];
        for (var i = 0; i < len; i++) {
            var trigger = new ____539();
            trigger.init(bytes);
            this.finishTrigger.push(trigger)
        }
        len = bytes.readInt();
        this.submitTriggers = [];
        for (var i = 0; i < len; i++) {
            var trigger = new ____539();
            trigger.init(bytes);
            this.submitTriggers.push(trigger)
        }
        this.awardList = [];
        var taward = bytes.readString();
        if (taward != "") {
            var tmpAwardList = taward.split("|");
            for (var i = 0; i < tmpAwardList.length; i++) {
                if (tmpAwardList[i] != "") {
                    var award = new ____527();
                    award.init(tmpAwardList[i]);
                    this.awardList.push(award)
                }
            }
        }
    },
    getCanAccept: function() {
        if (this.type == 4 && ____655.____667.clubId == 0) {
            return 0
        }
        if (this.type != 1) {
            if (____655.____667.level < this.minLv || ____655.____667.level > this.maxLv) {
                return 0
            }
        } else {
            if (____655.____667.level > this.maxLv) {
                return 0
            }
        }
        var prelen = this.preTaskIds.length;
        var needPre = false;
        if (prelen > 0) {
            needPre = true;
            for (var i = 0; i < prelen; i++) {
                if (this.preTaskIds[i] > 0 && ____655.____670.getCompleteTask(this.preTaskIds[i]) != null) {
                    needPre = false;
                    break
                }
            }
        }
        if (needPre) return 0;
        var currentDate = ____655.____662.getSystemTimeSec();
        if (currentDate - this.beginDate < 0 || this.endDate - currentDate < 0) return 0;
        if (this.needCareer != -1 && this.needCareer != ____655.____667.career) return 0;
        if (prelen == 0 && this.xianwei != 0 && this.xianwei != ____655.____667.xianwei) {
            return 0
        }
        if (this.type == 1) {
            if (____655.____667.level < this.minLv) {
                return 1
            }
        }
        return 2
    },
    getTaskTypeName: function() {
        return ____654.yuyanbaoManager.getYuyanbao("____2278.typeName" + this.type)
    },
    getAcceptContent: function() {
        if (this.acceptContent == null) {
            this.acceptContent = ____654.____682.____108(this.acceptContentId)
        }
        return this.acceptContent
    },
    isAutoSubmit: function() {
        if (this.type == 3 || this.type == 4) {
            return true
        }
        return false
    },
    isAutoAccept: function() {
        if (this.type == 3 || this.type == 4 || this.type == 5) {
            return true
        }
        return false
    },
    getFinishContent: function() {
        if (this.finishContent == null) {
            this.finishContent = ____654.____682.____108(this.finishContentId)
        }
        return this.finishContent
    },
});
var ____531 = ____514.extend({
    MAINTASK: 1,
    OTHERTASK: 2,
    list: null,
    listByAcceptNpc: null,
    ctor: function() {
        this.list = {};
        this.listByAcceptNpc = {}
    },
    ____104: function() {
        var item = new TaskTemplateInfo();
        item.init(this.____1755);
        this.list[item.id] = item;
        if (this.listByAcceptNpc[item.acceptNpc] == null) {
            this.listByAcceptNpc[item.acceptNpc] = {}
        }
        this.listByAcceptNpc[item.acceptNpc][item.id] = item
    },
    ____121: function(id) {
        return this.list[id]
    },
    handleSubmitTrigger: function(id) {
        var info = this.____121(id);
        if (info != null) {
            ____654.triggerManager.handlerList(info.submitTriggers)
        }
    },
    handleNotFinishTrigger: function(id) {
        var info = this.____121(id);
        if (info != null) {
            ____654.triggerManager.handlerList(info.acceptTriggers)
        }
    },
    handleFinishTrigger: function(id) {
        var info = this.____121(id);
        if (info != null) {
            ____654.triggerManager.handlerList(info.finishTrigger)
        }
    },
    ____103: function() {
        return 300
    },
});
var ____2058 = cc.Class.extend({
    templateId: 0,
    endTime: 0,
    init: function(id, time) {
        this.templateId = id;
        this.endTime = time
    },
    ____55: function() {
        return ____655.allTemplates.titleTemplateList.getTitle(this.templateId)
    },
});
var ____2059 = ____591.extend({
    list: null,
    currentTitleId: 0,
    ctor: function() {
        this._super();
        this.list = {}
    },
    setCurrentTitleId: function(id) {
        if (this.currentTitleId == id) return;
        this.currentTitleId = id;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_updateTitle, this, id))
    },
    addTitle: function(title) {
        if (this.list[title.templateId] == null) {
            this.list[title.templateId] = title;
            this.dispatchEvent(new ____590(____655.____661.playerInfo_addTitle, this, title))
        }
    },
    getTitle: function(titleId) {
        var len = this.list.length;
        for (var i = 0; i < len; i++) {
            if (this.list[i].templateId == titleId) {
                return this.list[i]
            }
        }
        return null
    },
    removeTitle: function(id) {
        var title = this.list[id];
        if (title != null) {
            this.list[id] = null;
            this.dispatchEvent(new ____590(____655.____661.playerInfo_removeTitle, this, title))
        }
    },
    getTitle: function(id) {
        return this.list[id]
    },
    getTitleCount: function(type) {
        var result = 0;
        for (var k in this.list) {
            var info = this.list[k];
            if (info.____55().type == type) {
                result = result + 1
            }
        }
        return result
    },
    ____61: function() {
        this.list = {}
    },
    dispose: function() {
        this.____61();
        this.list = null;
        this._super()
    }
});
var ____2060 = cc.Class.extend({
    id: 0,
    name: "",
    time: 0,
    fight: 0,
    propertys: null,
    type: 0,
    resouceType: 0,
    descript: "",
    picPath: "",
    quality: 0,
    agentIdList: null,
    init: function(data) {
        this.id = data.readInt();
        this.name = data.readString();
        this.type = data.readByte();
        this.time = data.readInt();
        this.fight = data.readInt();
        this.propertys = ____654.____674.____184(data.readString());
        this.descript = data.readString();
        this.picPath = data.readString();
        this.quality = data.readByte();
        this.resouceType = data.readByte();
        this.agentIdList = data.readString().split(",")
    },
});
var ____2061 = ____514.extend({
    titles: null,
    titleTypes: null,
    ctor: function() {
        this.titles = {};
        this.titleTypes = {};
        this._super()
    },
    ____104: function() {
        var title = new ____2060();
        title.init(this.____1755);
        this.titles[title.id] = title;
        if (this.titleTypes[title.type] == null) {
            this.titleTypes[title.type] = []
        }
        this.titleTypes[title.type].push(title)
    },
    getTitle: function(id) {
        return this.titles[id]
    },
    getTitlesByType: function(type) {
        return this.titleTypes[type]
    },
});
var TuJianTemplateInfo = cc.Class.extend({
    id: 0,
    type: 0,
    name: "",
    iconPath: "",
    propertyList: null,
    deploy: null,
    fashionIdList: null,
    ctor: function() {
        this.deploy = [];
        this.propertyList = [];
        this.fashionIdList = []
    },
    init: function(data) {
        this.id = data.readInt();
        this.type = data.readByte();
        this.name = data.readString();
        this.iconPath = data.readString();
        this.fashionIdList = ____654.____674.strItemSplitToInts(data.readString());
        this.propertyList = ____654.____674.strItemSplitToInts(data.readString());
        var len = data.readInt();
        for (var i = 0; i < len; i++) {
            var triggerInfo = new ____539();
            triggerInfo.init(data);
            this.deploy.push(triggerInfo)
        }
    },
});
var TuJianTemplateList = ____514.extend({
    tuJianList: null,
    huanZhuangList: null,
    ctor: function() {
        this.tuJianList = [];
        this.huanZhuangList = [];
        this._super()
    },
    ____104: function() {
        var info = new TuJianTemplateInfo();
        info.init(this.____1755);
        if (info.id >= 10000) {
            this.tuJianList.push(info)
        } else {
            this.huanZhuangList.push(info)
        }
    },
    getTuJianList: function() {
        return this.tuJianList
    },
    getHuanZhuangList: function() {
        return this.huanZhuangList
    },
});
var ____2062 = cc.Class.extend({
    level: 0,
    show: null,
    propAdd: null,
    maxExp: 0,
    awardList: null,
    init: function(bytes) {
        this.level = bytes.readUByte();
        this.show = ____654.____674.strItemSplitToInts(bytes.readString());
        this.propAdd = ____654.____674.____184(bytes.readString());
        this.maxExp = bytes.readNumber();
        this.awardList = ____654.____674.strItemSplitToInts(bytes.readString())
    },
    ____229: function() {
        var len = this.show.length;
        var count = 0;
        for (var i = 0; i < len; i++) {
            if (this.show[i][1] != 0) {
                count = count + 1
            }
        }
        return count
    },
});
var ____2063 = ____514.extend({
    list: null,
    maxLevel: 0,
    ctor: function() {
        this.list = {};
        this._super()
    },
    ____104: function() {
        var info = new ____2062();
        info.init(this.____1755);
        this.list[info.level] = info;
        if (this.maxLevel < info.level) {
            this.maxLevel = info.level
        }
    },
    getVipTemplateByLevel: function(level) {
        return this.list[level]
    },
});
var ____2064 = cc.Class.extend({
    id: 0,
    exp: 0,
    copperPrecent: 0,
    copperFee: 0,
    goldPrecent: 0,
    goldFee: 0,
    awardList: null,
    init: function(data) {
        this.id = data.readByte();
        this.exp = data.readInt();
        this.copperPrecent = data.readShort();
        this.copperFee = data.readInt();
        this.goldPrecent = data.readShort();
        this.goldFee = data.readInt();
        this.awardList = ____654.____674.strItemSplitToInts(data.readString())
    },
});
var ____2065 = ____514.extend({
    list: null,
    ctor: function() {
        this.list = {};
        this._super()
    },
    ____104: function() {
        var info = new ____2064();
        info.init(this.____1755);
        this.list[info.id] = info
    },
    ____238: function(id) {
        return this.list[id]
    },
});
var ____2066 = cc.Class.extend({
    id: 0,
    day: 0,
    xianWei: 0,
    awardList: null,
    fee: 0,
    init: function(data) {
        this.id = data.readInt();
        this.day = data.readByte();
        this.awardList = ____654.____674.strItemSplitToInts(data.readString());
        this.xianWei = data.readByte();
        this.fee = data.readInt()
    },
});
var ____2067 = ____514.extend({
    list: null,
    typeList: null,
    ctor: function() {
        this.list = {};
        this.typeList = {};
        this._super()
    },
    ____104: function() {
        var info = new ____2066();
        info.init(this.____1755);
        this.list[info.id] = info;
        if (this.typeList[info.xianWei] == null) {
            this.typeList[info.xianWei] = []
        }
        this.typeList[info.xianWei].push(info)
    },
    getTypeList: function(xianWei) {
        return this.typeList[xianWei]
    },
    ____238: function(id) {
        return this.list[id]
    },
});
var XianWeiTemplateInfo = cc.Class.extend({
    id: 0,
    name: null,
    level: 0,
    fightValue: 0,
    titleId: 0,
    init: function(data) {
        this.id = data.readShort();
        this.name = data.readString();
        this.level = data.readShort();
        this.fightValue = data.readInt();
        this.titleId = data.readInt()
    },
});
var XianWeiTemplateList = ____514.extend({
    list: null,
    totalXianWeiNum: 0,
    ctor: function() {
        this._super();
        this.list = {}
    },
    ____104: function() {
        var info = new XianWeiTemplateInfo();
        info.init(this.____1755);
        this.list[info.id] = info;
        this.totalXianWeiNum = this.totalXianWeiNum + 1
    },
});
var ____2068 = cc.Class.extend({
    id: 0,
    showType: 0,
    conditionList: null,
    awardList: null,
    openServerBegin: 0,
    openServerEnd: 0,
    beginDate: 0,
    endDate: 0,
    weeks: 0,
    agentIdList: "",
    triggerInfos: null,
    init: function(bytes) {
        this.id = bytes.readInt();
        this.showType = bytes.readInt();
        this.conditionList = ____654.____674.strItemSplitToInts(bytes.readString());
        this.awardList = ____654.____674.strItemSplitToInts(bytes.readString());
        this.openServerBegin = bytes.readUShort();
        this.openServerEnd = bytes.readUShort();
        this.beginDate = bytes.readInt();
        this.endDate = bytes.readInt();
        this.weeks = bytes.readUByte();
        this.agentIdList = bytes.readString();
        var triLen = bytes.readInt();
        this.triggerInfos = [];
        for (var i = 0; i < triLen; i++) {
            var trigger = new ____539();
            trigger.init(bytes);
            this.triggerInfos.push(trigger)
        }
    },
});
var ____2069 = ____514.extend({
    list: null,
    listByType: null,
    ctor: function() {
        this._super();
        this.list = {};
        this.listByType = {}
    },
    ____104: function() {
        var info = new ____2068();
        info.init(this.____1755);
        this.list[info.id] = info;
        if (this.listByType[info.showType] == null) {
            this.listByType[info.showType] = []
        }
        this.listByType[info.showType].push(info)
    },
});
var ____2070 = ____591.extend({
    weekSignHasGotList: null,
    monthCardDays: 0,
    monthCardIsHasGot: 0,
    activityValue: 0,
    resHasBuy: 0,
    zhuanShuGiftList: null,
    firsRechargeList: null,
    luckyTotalNum: 0,
    getAwardList: null,
    itemAwardList: null,
    _tickCount: 0,
    ctor: function() {
        this._super();
        this.weekSignHasGotList = [];
        this.zhuanShuGiftList = {};
        this.firsRechargeList = {};
        this.getAwardList = [];
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.dayUpdateHandler, this)
    },
    dayUpdateHandler: function() {
        this._tickCount = 60;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            this.resetZhuanShuGiftInfo();
            ____654.____678.____299(this.tick, this)
        }
    },
    zhuanShuGiftInfoUpdate: function(infoList) {
        for (var i = 0; i < infoList.length; i++) {
            var template = ____655.allTemplates.payTemplateList.getInfoById(infoList[i][0]);
            if (!!template && template.payType == 1) {
                this.firsRechargeList[infoList[i][0]] = infoList[i][1]
            } else {
                this.zhuanShuGiftList[infoList[i][0]] = infoList[i][1]
            }
        }
        this.dispatchEvent(new ____590(____655.____661.welfare_ZhuanShuUpdate))
    },
    resetZhuanShuGiftInfo: function() {
        var list = {};
        for (var id in this.zhuanShuGiftList) {
            var day = ____655.____662.getClientDate().getDay();
            if (day == 0) {
                day = 7
            }
            var openDay = ____655.____662.getOpenDayByCurrentTime();
            var info = ____655.allTemplates.payTemplateList.getInfoById(id);
            if (info != null && openDay >= info.beginDay && openDay < info.endDay) {
                if (info.weekDay == 0 || day == info.weekDay) {
                    list[id] = zhuanShuGiftList[id]
                }
            }
        }
        this.zhuanShuGiftList = list;
        this.dispatchEvent(new ____590(____655.____661.welfare_ZhuanShuUpdate))
    },
    monthCardInfoUpdate: function(data) {
        this.monthCardDays = data.readShort();
        this.monthCardIsHasGot = data.readByte();
        this.dispatchEvent(new ____590(____655.____661.welfare_MonthCardUpdate))
    },
    weekSignInfoUpdate: function(data) {
        this.weekSignHasGotList = [];
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var day = data.readByte();
            this.weekSignHasGotList.push(day)
        }
        this.dispatchEvent(new ____590(____655.____661.welfare_weekSignUpdate))
    },
    resRecoverInfoUpdate: function(activityValue, resHasBuy) {
        this.activityValue = activityValue;
        this.resHasBuy = resHasBuy;
        this.dispatchEvent(new ____590(____655.____661.welfare_ResRecoverUpdate))
    },
    showActiveCodeTips: function(type) {
        if (type == 0) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ActiveCodeMessageHandler.text1"))
        } else if (type == 1) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ActiveCodeMessageHandler.text2"))
        } else if (type == 2) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ActiveCodeMessageHandler.text3"))
        } else if (type == 3) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ActiveCodeMessageHandler.text4"))
        } else if (type == 4) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ActiveCodeMessageHandler.text5"))
        }
    },
    setLuckyTreasureInfo: function(data) {
        this.luckyTotalNum = data.readShort();
        this.getAwardList = [];
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var index = data.readByte();
            this.getAwardList.push(index)
        }
        this.dispatchEvent(new ____590(____655.____661.luckyTreasure_infoUpdate))
    },
    setLuckyTreasurePickInfo: function(data) {
        var index = data.readByte();
        var itemType = data.readByte();
        this.itemAwardList = [];
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var itemId = data.readInt();
            var count = data.readInt();
            this.itemAwardList.push([itemId, count])
        }
        this.dispatchEvent(new ____590(____655.____661.luckyTreasure_pickUpdate, this, [index, itemType]))
    },
    ____61: function() {
        this.weekSignHasGotList = [];
        this.monthCardDays = 0;
        this.monthCardIsHasGot = 0;
        this.activityValue = 0;
        this.resHasBuy = 0;
        this.zhuanShuGiftList = {};
        this.firsRechargeList = {};
        this._tickCount = 0;
        this.getAwardList = [];
        this.luckyTotalNum = 0
    },
});
var GameStart = cc.Class.extend({
    ctor: function(gameScene) {
        ____655 = new ____479();
        ____655.init(gameScene.gameConfig);
        ____654 = new ____534();
        ____654.init(gameScene);
        var sdkHandler = null;
        var loginData = null;
        if (____655.gameConfig.inSDK()) {} else {
            loginData = {};
            var uData = {};
            loginData["rs"] = 1;
            loginData["msg"] = "成功";
            loginData["data"] = uData;
            uData["user_name"] = ____654.sdk.readKV("nosdk_usename") || "";
            uData["server_list"] = ____655.gameConfig.serverList;
            var lastServer = ____654.sdk.readKV("nosdk_lastServer");
            uData["last_server"] = JSON.parse(lastServer || "[1]");
            uData["agent_id"] = 0;
            uData["isimei"] = 0;
            uData["time"] = 0;
            uData["sign"] = ""
        }
        var sdkId = ____655.gameConfig.sdkId;
        ____655.sources = "default";
        if (sdkId == 101) {} else if (sdkId == 102) {} else if (sdkId == 103) {
            this.setQQServerUrl()
        } else if (sdkId == 1001) {} else if (sdkId == 1002) {} else if (sdkId == 1003) {} else if (sdkId == 1004) {} else if (sdkId == 1005) {} else if (sdkId == 1006) {} else if (sdkId == 1007) {} else if (sdkId == 1008) {} else if (sdkId == 1009) {} else if (sdkId == 1010) {}
        this.loginComplete(loginData)
    },
    setQQServerUrl: function() {
        var config = ____655.gameConfig,
            serverUrl = "ttxy.hulai.com";
        config.loginUrl = "http://login." + serverUrl + "/game/login_";
        config.serverUrl = "http://login." + serverUrl + "/game/api/get_server.php?agent_id={0}&user_name={1}";
        config.lastServerUrl = "http://login." + serverUrl + "/game/api/last_login_server.php?user_name={0}&server_id={1}&area_id={2}";
        config.verUrl = "http://login." + serverUrl + "/urlconfig/";
        config.payUrl = "http://login." + serverUrl + "/game/api/pay_";
        config.billUrl = "http://login." + serverUrl + "/game/api/o.php";
        config.uploadVoiceUrl = "http://admin{0}." + serverUrl + "/api/upload3gp.php";
        config.downloadVoiceUrl = "http://admin{0}." + serverUrl + "/api/download3gp.php?3gp_name={1}"
    },
    loginComplete: function(data) {
        ____654.____679.____155(____655.____659.____690.startLib)
    },
});
var ____655;
var ____654;
var ____532 = cc.Class.extend({
    ____1182: null,
    ____796: null,
    mapEffContainer: null,
    ____797: null,
    ____798: null,
    effect3DContainer: null,
    ____799: null,
    fixPanelContainer: null,
    uiPanelContainer: null,
    ____800: null,
    ____802: null,
    shadowContainer: null,
    characterContainer: null,
    nameContainer: null,
    mainMenuBgContainer: null,
    mainMenuContainer: null,
    mainmenuClickContainer: null,
    sceneBloodNode: null,
    footContainer: null,
    _footBatchNodeList: null,
    zhengLingContainer: null,
    _zhengLingBatchNodeList: null,
    shenJianContainer: null,
    _shenJianBatchNodeList: null,
    weaponContainer: null,
    _weaponBatchNodeList: null,
    behitEffectContainer: null,
    _behitEffectBatchNodeList: null,
    _panelList: null,
    ____1501: null,
    ____1831: null,
    ____1466: null,
    ctor: function(gameScene) {
        this.____1182 = gameScene;
        this.____796 = ____654.____673.newKYNode();
        this.mapEffContainer = ____654.____673.newKYNode();
        this.____797 = ____654.____673.newKYNode();
        this.____798 = ____654.____673.newKYNode();
        this.effect3DContainer = ____654.____673.newKYNode();
        this.____799 = ____654.____673.newKYNode();
        this.fixPanelContainer = ____654.____673.newKYNode();
        this.____800 = ____654.____673.newKYNode();
        this.____802 = ____654.____673.newKYNode();
        this.____1182.addChild(this.____796, 0);
        this.____1182.addChild(this.mapEffContainer, 1);
        this.____1182.addChild(this.____797, 2);
        this.____1182.addChild(this.____798, 3);
        this.____1182.addChild(this.effect3DContainer, 4);
        this.____1182.addChild(this.____799, 5);
        this.____1182.addChild(this.fixPanelContainer, 6);
        this.____1182.addChild(this.____800, 7);
        this.____1182.addChild(this.____802, 8);
        this.mainMenuBgContainer = ____654.____673.newKYNode();
        this.____799.addChild(this.mainMenuBgContainer, 0);
        this.mainMenuContainer = ____654.____673.newKYNode();
        this.____799.addChild(this.mainMenuContainer, 1);
        this.mainmenuClickContainer = ____654.____673.newKYNode();
        this.____799.addChild(this.mainmenuClickContainer, 2);
        this.shadowContainer = ____654.____673.newKYNode();
        this.mapEffContainer.addChild(this.shadowContainer, 2);
        this.footContainer = ____654.____673.newKYNode();
        this.mapEffContainer.addChild(this.footContainer, 3);
        this.characterContainer = ____654.____673.newKYNode();
        this.mapEffContainer.addChild(this.characterContainer, 4);
        this.nameContainer = ____654.____673.newKYNode();
        this.mapEffContainer.addChild(this.nameContainer, 5);
        this.zhengLingContainer = ____654.____673.newKYNode();
        this.mapEffContainer.addChild(this.zhengLingContainer, 1);
        this.shenJianContainer = ____654.____673.newKYNode();
        this.____798.addChild(this.shenJianContainer);
        this.weaponContainer = ____654.____673.newKYNode();
        this.____798.addChild(this.weaponContainer);
        this.behitEffectContainer = ____654.____673.newKYNode();
        this.____798.addChild(this.behitEffectContainer);
        this.sceneBloodNode = ____654.____673.newKYNode();
        this.____798.addChild(this.sceneBloodNode, 3);
        this._panelList = [];
        this._footBatchNodeList = {};
        this._zhengLingBatchNodeList = {};
        this._shenJianBatchNodeList = {};
        this._weaponBatchNodeList = {};
        this._behitEffectBatchNodeList = {}
    },
    getBatchNodeByType: function(filePath, type) {
        var list = this._footBatchNodeList;
        var par = this.footContainer;
        if (type == 2) {
            list = this._zhengLingBatchNodeList;
            par = this.zhengLingContainer
        } else if (type == 3) {
            list = this._shenJianBatchNodeList;
            par = this.shenJianContainer
        } else if (type == 4) {
            list = this._weaponBatchNodeList;
            par = this.weaponContainer
        } else if (type == 5) {
            list = this._behitEffectBatchNodeList;
            par = this.behitEffectContainer
        }
        var container = list[filePath];
        if (container == null) {
            container = ____654.____673.newKYNode();
            par.addChild(container);
            list[filePath] = container
        }
        return container
    },
    setupUIPanel: function() {
        if (this.uiPanelContainer == null) {
            this.uiPanelContainer = new ____2124();
            this.uiPanelContainer.retain()
        }
        if (____655.gameConfig.isWin()) {
            var btn = ____654.____673.newKYSprite();
            btn.setFrame("btn/ui_btn2.png");
            btn.setPosition(cc.p(40, ____655.____657 - 20));
            btn.setScale(0.3);
            this.____1182.addChild(btn, 8);
            btn.addListener(this, this.testBtn1ClickHandler);
            btn = ____654.____673.newKYSprite();
            btn.setFrame("btn/ui_btn2.png");
            btn.setPosition(cc.p(40, ____655.____657 - 40));
            btn.setScale(0.3);
            this.____1182.addChild(btn, 8);
            btn.addListener(this, this.testBtn2ClickHandler)
        }
    },
    testBtn1ClickHandler: function() {
        ____654.____678.resetShowMemory(!____654.____678.showMemory)
    },
    testBtn2ClickHandler: function() {
        print("#coutchild", this.countChild(), ____654.____680.getNodeCount())
    },
    countChild: function(parent) {
        parent = parent || this.____1182;
        if (!parent) return 0;
        var children = parent.getChildren(),
            ret = children.length,
            len = children.length;
        for (var i = 0; i < len; i++) {
            ret += this.countChild(children[i])
        }
        return ret
    },
    addMapEffect: function(effect) {
        this.mapEffContainer.addChild(effect)
    },
    addSceneEffect: function(effect) {
        this.effect3DContainer.addChild(effect)
    },
    addEffect: function(effect) {
        this.____798.addChild(effect)
    },
    ____354: function(pos) {
        this.____796.setPosition(pos);
        this.mapEffContainer.setPosition(pos);
        this.____797.setPosition(pos);
        this.____798.setPosition(pos);
        this.effect3DContainer.setPosition(pos)
    },
    hideBack: function() {
        this.____796.setVisible(false);
        this.mapEffContainer.setVisible(false);
        this.____797.setVisible(false);
        this.____798.setVisible(false);
        this.effect3DContainer.setVisible(false);
        this.____799.setVisible(false)
    },
    showBack: function() {
        this.____796.setVisible(true);
        this.mapEffContainer.setVisible(true);
        this.____797.setVisible(true);
        this.____798.setVisible(true);
        this.effect3DContainer.setVisible(true);
        this.____799.setVisible(true)
    },
    ____125: function(panel, toCenter) {
        if ((panel instanceof KYPanel) == false) {
            print("+++++++添加了非面板元素+++++++");
            return
        }
        if (panel.getParent() != null) {
            return
        }
        if (____654.____674.____181(this._panelList, panel) > -1) return;
        this._panelList.push(panel);
        if (toCenter == null) toCenter = true;
        if (toCenter) {
            panel.setPosition(____654.____673.____159(Math.floor((____655.____656 - panel.getContentSize().width) / 2), Math.floor((____655.____657 - panel.getContentSize().height) / 2)))
        }
        this.updatePanelToPos()
    },
    ____127: function(panel) {
        var index = ____654.____674.____181(this._panelList, panel);
        if (index == -1) return;
        this._panelList.splice(index, 1);
        this.updatePanelToPos()
    },
    updatePanelToPos: function() {
        var len = this._panelList.length;
        var zorderAdd = 1;
        for (var i = len - 1; i >= 0; i--) {
            var panel = this._panelList[i];
            if (panel.getParent() == null) {
                this.____800.addChild(panel)
            }
            panel.setLocalZOrder(i + zorderAdd);
            if (zorderAdd == 1 && panel.modeValue > -1) {
                if (this.____1501 == null) {
                    this.____1501 = ____654.____673.newKYImageView();
                    this.____1501.setFrame("board/ui_blackBoard.png");
                    this.____1501.setScale9Enabled(true);
                    this.____1501.setCapInsets(____654.____673.____161(4, 4, 1, 1));
                    this.____1501.setContentSize(____654.____673.____160(____655.____656, ____655.____657));
                    this.____1501.setAnchorPoint(____654.____673.anchorPoints[6]);
                    this.____1501.setTouchEnabled(true);
                    this.____1501.addListener(this, this.____124);
                    this.____800.addChild(this.____1501)
                }
                this.____1501.setLocalZOrder(i);
                this.____1501.setOpacity(panel.modeValue);
                this.____1831 = panel;
                zorderAdd = 0
            }
        }
        if (zorderAdd == 1 && this.____1501 != null) {
            this.____1501.dispose();
            this.____1501 = null;
            this.____1831 = null
        }
    },
    ____124: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this.____1831 != null) {
                this.____1831.hideFormContainer()
            }
        }
    },
    ____145: function() {
        if (this.uiPanelContainer != null) {
            this.uiPanelContainer.close()
        }
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_closeOtherPanel, ____654.____672))
    },
    showNpcPanel: function(npcId) {
        if (this.____1466 == null) {
            this.____1466 = new ____2134();
            this.____1466.setPosition(____654.____673.____159(5, 35))
        }
        this.____1466.setNpcId(npcId);
        if (this.____1466.getParent() == null) {
            this.____802.addChild(this.____1466)
        }
    },
    hideNpcPanel: function() {
        if (this.____1466 != null && this.____1466.getParent() != null) {
            this.____1466.hide()
        }
    },
    ____129: function() {
        if (this.____1501 != null) {
            this.____1501.dispose();
            this.____1501 = null
        }
        for (var i = this._panelList.length - 1; i >= 0; i--) {
            var p = this._panelList[0];
            this.____127(p);
            p.dispose()
        }
        this._panelList = []
    },
    ____61: function() {
        this.uiPanelContainer.close()
    },
});
var ____533 = cc.Class.extend({
    list: null,
    ____1083: null,
    ctor: function() {
        this.list = {}
    },
    init: function(datas) {
        this.____1083 = new ByteArray();
        this.____1083.____284(datas);
        this.____1083 = ____654.____674.____182(this.____1083);
        var len = this.____1083.readInt();
        for (var i = 0; i < len; i++) {
            this.list[this.____1083.readString()] = this.____1083.readString()
        }
    },
    ____108: function(id) {
        if (id == null) return "";
        var value = this.list[id];
        if (value == null) return "";
        value = value.replace(/\\n/g, "\n");
        return value
    },
    getDescriptReplace: function(id, args) {
        if (id == null) return "";
        var value = this.list[id];
        if (value == null) return "";
        value = value.replace(/\\n/g, "\n");
        if (args != null) {
            for (var i = 0; i < args.length; i++) {
                value = value.replace("{" + i + "}", args[i])
            }
        }
        return value
    },
});
var ____2073 = cc.Class.extend({
    create: function(id, isScene, pos, autoDispose, scale, stopAtEnd, clearFlag) {
        var info = ____655.allTemplates.____789.getEffect(id);
        assert(info, "找不到对应的特效:" + id);
        if (info == null) return null;
        pos = pos || ____654.____673.____159(0, 0);
        var eff = new BatchEffect(info, isScene, autoDispose, scale, stopAtEnd, clearFlag);
        eff.move(pos.x, pos.y);
        !!eff ? eff.info = info : 0;
        return eff
    },
    setEffect: function(id, isScene, pos, container, autoDispose, scale, stopAtEnd, clearFlag, zOrder) {
        var eff = this.create(id, isScene, pos, autoDispose, scale, stopAtEnd, clearFlag);
        if (!!eff) {
            container = container || ____654.____676.____798;
            eff.addTo(container, zOrder);
            eff.play();
            return eff
        }
        return null
    }
});
var ____534 = cc.Class.extend({
    gameScene: null,
    ____678: null,
    ____684: null,
    uiCreator: null,
    ____673: null,
    ____672: null,
    ____679: null,
    ____675: null,
    effectManager: null,
    panelQuote: null,
    ____680: null,
    ____676: null,
    ____674: null,
    triggerManager: null,
    ____677: null,
    ____682: null,
    tipsManager: null,
    playerNoticeManager: null,
    soundManager: null,
    ____685: null,
    ____683: null,
    selfDataMessageSender: null,
    statMessageSender: null,
    fashionMessageSender: null,
    copyMessageSender: null,
    weaponMessageSender: null,
    welfareMessageSender: null,
    rankMessageSender: null,
    playerNoticeMessageSender: null,
    homeMessageSender: null,
    familyTreasuresMessageSender: null,
    yuyanbaoManager: null,
    noAlertUtils: null,
    shaderCache: null,
    sdk: null,
    testRichText: null,
    ____681: null,
    itemTester: null,
    copyTester: null,
    playerInfoTester: null,
    taskTester: null,
    guideClickContainer: null,
    commonTick: null,
    clickZoneList: null,
    firstPreLoad: null,
    init: function(gameScene) {
        this.gameScene = gameScene;
        this.sdk = new ____2114(gameScene.jsc);
        this.____672 = new ____591();
        this.____675 = new ____535();
        this.____673 = new ____540();
        this.____684 = new ____595(this.____675.____135());
        this.uiCreator = new UICreator(this.____675.____135());
        this.____685 = new ____542();
        this.____679 = new ____538();
        this.____678 = new ____592(this.gameScene);
        this.panelQuote = new ____2076();
        this.____682 = new ____533();
        this.effectManager = new ____2073();
        this.soundManager = new SoundManager();
        if (____655.gameConfig.isRuntime) {
            this.____680 = new MessageManager()
        } else {
            this.____680 = new MessageManagerNative()
        }
        this.____676 = new ____532(gameScene);
        this.____674 = new ____541();
        this.triggerManager = new ____2094();
        this.____677 = new ____2392();
        this.____681 = new ____594();
        this.tipsManager = new ____2086();
        this.playerNoticeManager = new PlayerNoticeManager();
        this.itemTester = new ____2108();
        this.copyTester = new ____2107();
        this.taskTester = new TaskTester();
        this.____683 = new ____543();
        this.____683.add();
        this.selfDataMessageSender = new ____2103();
        this.selfDataMessageSender.add();
        this.statMessageSender = new ____2104();
        this.statMessageSender.add();
        this.clubMessageSender = new ____2098();
        this.clubMessageSender.add();
        this.fashionMessageSender = new ____2101();
        this.fashionMessageSender.add();
        this.copyMessageSender = new ____2100();
        this.copyMessageSender.add();
        this.weaponMessageSender = new ____2105();
        this.weaponMessageSender.add();
        this.welfareMessageSender = new ____2106();
        this.welfareMessageSender.add();
        this.rankMessageSender = new ____2102();
        this.rankMessageSender.add();
        this.playerNoticeMessageSender = new PlayerNoticeMessageSender();
        this.playerNoticeMessageSender.add();
        this.luckyTreasureMessageSender = new LuckyTreasureMessageSender();
        this.luckyTreasureMessageSender.add();
        this.marryOathMessageSender = new MarryOathMessageSender();
        this.marryOathMessageSender.add();
        this.yuyanbaoManager = new ____2097();
        this.noAlertUtils = new ____2113();
        this.shaderCache = new ____2115();
        this.testRichText = this.____673.newKYLabel();
        ____655.itemInfoList.initTick();
        ____655.rankInfo.init();
        ____655.faceInfo = new ____483();
        ____655.welfareInfo = new ____2070();
        ____655.openInfo = new ____2037();
        ____655.gameSetting = new ____1909();
        ____655.____669 = new ____482();
        var code = this.sdk.jsc.getVerionCode();
        var list = code.split(".");
        if (list[0] == "1" && (list[1] == "0" || list[1] == "1" || list[1] == "2")) {
            ____655.isCanVoice = false
        }
        this.commonTick = new ____1895();
        this.firstPreLoad = new FirstPreLoad();
        this.homeMessageSender = new HomeMessageSender();
        this.homeMessageSender.add();
        this.familyTreasuresMessageSender = new FamilyTreasuresMessageSender();
        this.familyTreasuresMessageSender.add();
        this.clickZoneList = {}
    },
    useTry: function() {
        return ____655.gameConfig.isWin()
    },
    doPrintError: function(error) {
        this.gameScene.printError(error)
    },
    guideShow: function(guideId) {
        if (this.guideClickContainer == null) {
            this.guideClickContainer = new GuideClickContainer()
        }
        this.guideClickContainer.showTip(guideId)
    },
    selfPlayerInit: function() {
        if (this.playerInfoTester == null) {
            this.playerInfoTester = new PlayerInfoTester()
        }
    },
    getCharacterInfo: function(figureId, anima, styleList) {
        var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId);
        var type = 0;
        if (figureTemplate != null) type = figureTemplate.getType();
        else {
            type = ____655.____659.commonStaticType.style_player
        }
        var characterInfo = new CharacterInfo(type, anima);
        var list = styleList;
        if (list == null) {
            list = {};
            list[type] = figureId
        }
        characterInfo.updateStyle(list);
        return characterInfo
    },
    setClickZone: function(type, x, y, w, h, callback) {
        if (this.clickZoneList[type] == null) {
            this.clickZoneList[type] = [x - w * 0.5, x + w * 0.5, y - h * 0.5, y + h * 0.5, callback]
        }
    },
    clearClickZone: function(type) {
        this.clickZoneList[type] = null
    },
    clearAll: function() {
        this.panelQuote.____61();
        this.selfDataMessageSender.____61();
        this.____676.____129();
        this.____676.____61();
        this.____672.dispatchEvent(new ____590(____655.____661.common_clearAllData, this.____672, null));
        ____655.____61()
    },
});
var MemoryTester = cc.Class.extend({
    _characters: null,
    _infos: null,
    ____886: null,
    ____887: null,
    _p: null,
    _container: null,
    ____1712: 0,
    _fileList: null,
    ctor: function(container) {
        this._container = container;
        this._characters = [];
        this._infos = [];
        this._fileList = [];
        this.____886 = ____654.____673.newKYImageView();
        this.____886.setFrame("btn/ui_closeBtn2.png");
        this.____886.setTouchEnabled(true);
        this.____886.setPosition(____654.____673.____159(50, 50));
        ____654.____676.____802.addChild(this.____886, 200);
        this.____886.addTouchEventListener(this.____234, this);
        this.____887 = ____654.____673.newKYImageView();
        this.____887.setFrame("btn/ui_closeBtn2.png");
        this.____887.setTouchEnabled(true);
        this.____887.setPosition(____654.____673.____159(100, 50));
        ____654.____676.____802.addChild(this.____887, 200);
        this.____887.addTouchEventListener(this.____235, this)
    },
    ____234: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            this.textParticle()
        }
    },
    getItemCallBack: function(index) {
        print("创建原件", index);
        var item = new KYSprite();
        item.retain();
        item.addListener(this, this.clickCB, null, null, null, false);
        item.setFrame("cell/ui_cell2.png");
        item.setAnchorPoint(____654.____673.anchorPoints[6]);
        return item
    },
    getIdCallBack: function(index) {
        return index
    },
    testKYProgressBar: function() {
        var t = new KYProgressBar();
        t.initUI("bar/ui_bar8.png", ccui.ScrollView.DIR_HORIZONTAL, 300);
        t.setPosition(100, 100);
        t.setPercent(100);
        t.setScaleY(2);
        t.setRotation(270);
        ____654.____676.____802.addChild(t)
    },
    testKYListView: function() {
        var l = new KYListView();
        l.initUI(ccui.ScrollView.DIR_HORIZONTAL, cc.size(150, 100));
        l.setPosition(100, 100);
        ____654.____676.____802.addChild(l);
        l.setItemsMargin(5);
        var item1 = new KYSprite();
        item1.setFrame("cell/ui_cell2.png");
        item1.setAnchorPoint(____654.____673.anchorPoints[6]);
        l.pushBackCustomItem(item1);
        var item2 = new KYSprite();
        item2.setFrame("btn/ui_btn2.png");
        item2.setAnchorPoint(____654.____673.anchorPoints[6]);
        l.pushBackCustomItem(item2);
        var item3 = new KYSprite();
        item3.setFrame("btn/ui_closeBtn2.png");
        item3.setAnchorPoint(____654.____673.anchorPoints[6]);
        l.pushBackCustomItem(item3)
    },
    testTileContainer: function() {
        var t = new KYTileContainer();
        t.initUI(ccui.ScrollView.DIR_HORIZONTAL, cc.size(150, 172));
        t.setFormat(2, 10, cc.size(86, 86), 5, 5, false);
        t.setCallbacks(this.getItemCallBack, this.getIdCallBack, this);
        t.setPosition(100, 100);
        ____654.____676.____802.addChild(t)
    },
    testKYSprite: function() {
        var s2 = new KYSprite();
        s2.setPosition(100, 100);
        s2.setFrame("btn/ui_checkBox1_1.png");
        ____654.____676.____802.addChild(s2);
        s2.addListener(this, this.clickCB, this.downCB, this.upCB, this.moveCB)
    },
    testKYCheckBox: function() {
        var c = new KYCheckBox("btn/ui_checkBox1_2.png", "btn/ui_checkBox1_1.png", false);
        c.setString("sdfsf3423sdf");
        c.setPosition(100, 100);
        ____654.____676.____802.addChild(c)
    },
    testKYScrollView: function() {
        var scroll = new KYScrollView();
        scroll.initUI(cc.size(200, 200));
        scroll.setPosition(100, 100);
        scroll.setInnerSize(cc.size(174 * 10, 174));
        scroll.setScrollDir(1);
        ____654.____676.____802.addChild(scroll);
        for (var i = 0; i < 10; i++) {
            var n = new KYSprite();
            n.loadTexture("cell/ui_cell2.png");
            n.setAnchorPoint(____654.____673.anchorPoints[6]);
            n.setScale(2);
            n.setPosition(174 * i, 0);
            scroll.addContent(n)
        }
    },
    testTextFieldTTF: function() {
        var f = new ccui.TextField();
        f.setPosition(100, 100);
        f.setString("sdfdsfsdfsdf");
        f.setContentSize(cc.size(100, 100));
        ____654.____676.____802.addChild(f)
    },
    showSpriteImage: function() {
        for (var i = 0; i < 5000; i++) {
            var sp = new cc.Sprite("#btn/ui_btn2.png");
            sp.x = 200;
            sp.y = 20;
            this._container.addChild(sp)
        }
    },
    testScale9Image: function() {
        var i = new TTScale9Image();
        i.setScaleType(3);
        i.setScale9Size(____654.____673.____160(200, 200));
        i.loadTexture("9/ui_btn1_1");
        i.setPosition(200, 200);
        i.addListener(this, this.clickCB);
        ____654.____676.____802.addChild(i)
    },
    testLabelTTF: function() {
        var n = cc.LabelTTF.create("", ____655.defaultFontName, 20);
        n.setString("454546345\n789798");
        n.setDimensions(cc.size(50, 50));
        n.setPosition(100, 100);
        ____654.____676.____802.addChild(n)
    },
    testProgressBar: function() {},
    releaseN: null,
    releaseP: null,
    releaseCount: 0,
    testRelease: function() {
        this.releaseP = cc.Node.create();
        this.releaseN = new cc.Node();
        this.releaseP.addChild(this.releaseN);
        this.releaseP.retain();
        ____654.____676.____802.addChild(this.releaseP);
        ____654.____678.____298(this.releaseTick, this)
    },
    releaseTick: function(delta, count) {
        this.releaseCount++;
        if (this.releaseCount == 60) {
            print("fuck");
            this.releaseN.removeFromParent(false)
        }
        print(this.releaseN.getParent(), "-=-=-=-=")
    },
    showClip: function() {
        for (var i = 0; i < 100; i++) {
            var clip = new cliptest();
            clip.setPosition(300 + Math.random() * 300, Math.random() * 300);
            this._container.addChild(clip)
        }
    },
    tickShowCount: 0,
    tickShowPlayer: function(delta, count) {
        this.tickShowCount++;
        if (this.tickShowCount == 10) {
            this.showPlayer()
        } else if (this.tickShowCount > 20) {
            this.clear();
            this.tickShowCount = 0
        }
    },
    ____235: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            this.clear()
        }
    },
    showEffect: function() {
        for (var i = 0; i < 700; i++) var effect = ____654.effectManager.setEffect(20001, false, cc.p(400 + Math.random() * 450, 100 + Math.random() * 450), this._container, false, 1)
    },
    showSprite: function() {
        var this_ = this;

        function playerImageComplete1() {
            for (var i = 0; i < 1000; i++) {
                var tmpp = ____654.____673.____159(this._p.x + Math.random() * 300, this._p.y + Math.random() * 300);
                var sp = ____654.____673.____174();
                var frame = ____654.____673.spriteFrameCache.getSpriteFrame("1_120801_2_200.png");
                sp.setSpriteFrame(frame);
                this_._container.addChild(sp);
                sp.setPosition(tmpp)
            }
        }
        var path = ____654.____675.getCharacterPath(____655.____659.commonStaticType.style_player, 120801) + ".png";
        print("#path", path);
        ____654.____677.____147(path, playerImageComplete1, this)
    },
    testWebp: function() {
        this.____1712 = new Date().getTime();
        for (var i = 1; i <= 597; i++) {
            if (i < 10) this._fileList.push("res/testspng8/pic_0" + i + ".png");
            else this._fileList.push("res/testspng8/pic_0" + i + ".png")
        }
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        for (var i = 0; i < 10; i++) {
            if (this._fileList.length == 0) break;
            var path = this._fileList.shift(),
                img = ____654.____673.newKYImageView(path);
            print("#load", path)
        }
        if (this._fileList.length == 0) {
            var time = new Date().getTime();
            print("#total time", time - this.____1712, time, this.____1712);
            ____654.____678.____299(this.tick, this)
        }
    },
    textParticle: function() {
        var pInfo1 = new ParticleInfo();
        pInfo1.effectId = 1057;
        pInfo1.life = 600;
        pInfo1.totalCount = 20;
        pInfo1.createPerFrame = 4;
        pInfo1.createDFrame = 12;
        var pInfo2 = new ParticleInfo();
        pInfo2.effectId = 1057;
        pInfo2.life = 600;
        pInfo2.totalCount = 18;
        pInfo2.createPerFrame = 3;
        pInfo2.createDFrame = 12;
        var pInfo3 = new ParticleInfo();
        pInfo3.effectId = 1057;
        pInfo3.life = 600;
        pInfo3.totalCount = 25;
        pInfo3.createPerFrame = 1;
        pInfo3.createDFrame = 4;
        var pInfo4 = new ParticleInfo();
        pInfo4.effectId = 4002;
        pInfo4.effectId2 = 4003;
        pInfo4.life = 600;
        pInfo4.totalCount = 10;
        pInfo4.createPerFrame = 9;
        pInfo4.createDFrame = 6;
        var pInfo5 = new ParticleInfo();
        pInfo5.effectId = 1119;
        pInfo5.life = 600;
        pInfo5.totalCount = 1000;
        pInfo5.createPerFrame = 1;
        pInfo5.createDFrame = 1;
        var pInfo6 = new ParticleInfo();
        pInfo6.effectId = 5004;
        pInfo6.life = 80;
        pInfo6.totalCount = 8;
        pInfo6.createPerFrame = 1;
        pInfo6.createDFrame = 4;
        var pInfo7 = new ParticleInfo();
        pInfo7.effectId = 5002;
        pInfo7.life = 150;
        pInfo7.totalCount = 60;
        pInfo7.createPerFrame = 3;
        pInfo7.createDFrame = 4;
        var pInfo8 = new ParticleInfo();
        pInfo8.effectId = 5003;
        pInfo8.life = 60;
        pInfo8.totalCount = 1;
        pInfo8.createPerFrame = 1;
        pInfo8.createDFrame = 1;
        var tmpInfo = ____655.particleInfoList.list["floower2"];
        var p = new tmpInfo.cls(____654.____676.____802, tmpInfo);
        p.play()
    },
    setP: function(p) {
        this._p = p
    },
    showBatch: function() {
        var plist = "res/GameUI/luaGameUI0.plist",
            png = "res/GameUI/luaGameUI0.png";
        cc.spriteFrameCache.addSpriteFrames(plist, png);
        var batch = new cc.SpriteBatchNode(png, 1);
        batch.retain();
        this._container.addChild(batch);
        for (var i = 1; i < 6; i++) {
            var sp = new cc.Sprite("#flag/zhangChangRankIcon" + i + ".png");
            sp.retain();
            sp.setPosition(cc.p(300 + Math.random() * 500, 200 + Math.random() * 300));
            batch.addChild(sp);
            this._characters.push(sp)
        }
        this._characters.sort(function(a, b) {
            return b.getPositionY() - a.getPositionY()
        });
        for (var i = 0; i < this._characters.length; i++) {
            this._characters[i].setLocalZOrder(i)
        }
    },
    showButton: function() {
        for (var i = 0; i < 200; i++) {
            var onlineBtn = new ____2283("sceneIcon/mainmenu_btn23.png", 1);
            onlineBtn.setLabel("活动图标");
            var tmpp = ____654.____673.____159(this._p.x + Math.random() * 300, this._p.y + Math.random() * 300);
            onlineBtn.setPosition(tmpp);
            this._container.addChild(onlineBtn);
            this._characters.push(onlineBtn)
        }
    },
    showText: function() {
        for (var i = 0; i < 1200; i++) {
            var text = ____654.____673.newKYLabel(50, false);
            text.setString("10:10");
            this._container.addChild(text);
            var tmpp = ____654.____673.____159(this._p.x + Math.random() * 300, this._p.y + Math.random() * 300);
            text.setPosition(tmpp);
            this._characters.push(text)
        }
    },
    showPlayer: function() {
        var dirList = [1, 3, 6, 8];
        for (var i = 0; i < 100; i++) {
            var figureInfo = new ____499();
            figureInfo.userId = i;
            var tmpStyle = {};
            tmpStyle[1] = 1;
            figureInfo.characterInfo.updateStyle(tmpStyle);
            var character = new ____545(figureInfo.characterInfo, null, this);
            character.init(dirList[Math.floor(Math.random() * dirList.length)], this._container, Math.floor(Math.random() * 200));
            var tmpp = ____654.____673.____159(this._p.x + Math.random() * 300, this._p.y + Math.random() * 300);
            character.move(tmpp.x, tmpp.y);
            this._characters.push(character);
            this._infos.push(figureInfo)
        }
    },
    tickCountPlayer: 0,
    tickPlayer: function(delta, count) {
        this.tickCountPlayer++;
        if (this.tickCountPlayer > 100) {
            for (var i = 0; i < this._characters.length; i++) {
                var container = this._container;
                if (i % 3 == 0) container = ____654.____676.____799;
                else if (i % 3 == 1) container = ____654.____676.fixPanelContainer;
                else if (i % 3 == 2) container = ____654.____676.____800;
                this._characters[i].show();
                var tmpp = ____654.____673.____159(this._p.x + Math.random() * 600 - 300, this._p.y + Math.random() * 500 - 200);
                this._characters[i].setPosition(tmpp)
            }
            ____654.____678.____299(this.tickPlayer, this)
        }
    },
    showMonter: function() {
        var figureList = [],
            facelist = [1, 2, 3, 4];
        for (var i = 0; i < 15; i++) {
            figureList.push(1001 + i)
        }
        for (var i = 0; i < 300; i++) {
            var figureId = figureList[Math.floor(Math.random() * figureList.length)],
                figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(figureId),
                characterInfo = ____654.getCharacterInfo(figureId, ____655.____659.____687.stand),
                character = new ____545(characterInfo, this.____209, this),
                face = facelist[Math.floor(Math.random() * facelist.length)],
                dir = ____655.____659.____686.rightBottom,
                tmpp = ____654.____673.____159(this._p.x + Math.random() * 300, this._p.y + Math.random() * 300);
            if (face == 1) dir = ____655.____659.____686.rightBottom;
            else if (face == 2) dir = ____655.____659.____686.leftBottom;
            else if (face == 3) dir = ____655.____659.____686.rightTop;
            else if (face == 4) dir = ____655.____659.____686.leftTop;
            character.setScale(.5, .5);
            character.move(tmpp.x, tmpp.y);
            character.init(dir, this._container);
            this._characters.push(character);
            this._infos.push(characterInfo)
        }
    },
    clickCB: function(p) {
        print("click", p.x, p.y)
    },
    downCB: function(p) {
        print("down", p.x, p.y)
    },
    upCB: function(p) {
        print("up", p.x, p.y)
    },
    moveCB: function(p) {
        print("move", p.x, p.y)
    },
    testNode: function() {
        var node = new cc.Node();
        node.setPosition(300, 300);
        ____654.____676.____802.addChild(node)
    },
    testScrollView: function() {},
    clear: function() {
        var parent = null;
        for (var i = 0; i < this._characters.length; i++) {
            if (!!this._characters[i].dispose) {
                this._characters[i].dispose()
            } else {
                parent = this._characters[i].getParent();
                this._characters[i].removeFromParent(true);
                this._characters[i].release()
            }
        }
        if (!!parent) {
            parent.removeFromParent(true);
            parent.release()
        }
        this._characters = [];
        for (var i = 0; i < this._infos.length; i++) {
            this._infos[i].dispose()
        }
        this._infos = []
    },
});
var cliptest = cc.Layer.extend({
    ctor: function() {
        this._super();
        var size = 230;
        var clipper = new cc.ClippingNode();
        clipper.width = size;
        clipper.height = size;
        clipper.anchorX = 0.5;
        clipper.anchorY = 0.5;
        clipper.x = 300;
        clipper.y = 300;
        this.addChild(clipper);
        var stencil = new cc.DrawNode();
        var rectangle = [cc.p(0, 0), cc.p(clipper.width, 0), cc.p(clipper.width, clipper.height), cc.p(0, clipper.height)];
        var white = cc.color(255, 255, 255, 255);
        stencil.drawPoly(rectangle, white, 1, white);
        clipper.stencil = stencil;
        var content = new cc.Sprite("res/imgs/map/1004/0_0.jpg");
        content.anchorX = 0.5;
        content.anchorY = 0.5;
        content.x = clipper.width / 2;
        content.y = clipper.height / 2;
        clipper.addChild(content)
    },
});
var ____537 = cc.Class.extend({
    ____1415: 0,
    ____149: function() {
        return this.____1415
    },
    ____150: function(____690) {
        this.____1415 = ____690
    },
    setup: function(data) {},
    ____151: function(data) {},
    clear: function() {},
});
var ____538 = cc.Class.extend({
    ____1414: null,
    ____1051: null,
    ctor: function() {
        this.____1414 = {}
    },
    ____152: function(____690) {
        return this.____1414[____690]
    },
    ____153: function(____690) {
        if (____690 == ____655.____659.____690.startLib) return new ____582();
        else if (____690 == ____655.____659.____690.sceneModule) return new ____596();
        else if (____690 == ____655.____659.____690.role) return new ____2232();
        else if (____690 == ____655.____659.____690.shop) return new ____574();
        else if (____690 == ____655.____659.____690.weapon) return new ____2333();
        else if (____690 == ____655.____659.____690.club) return new ____2158();
        else if (____690 == ____655.____659.____690.copy) return new ____2180();
        else if (____690 == ____655.____659.____690.boss) return new ____2149();
        else if (____690 == ____655.____659.____690.ll) return new ____2198();
        else if (____690 == ____655.____659.____690.friend) return new ____2191();
        else if (____690 == ____655.____659.____690.waiGuan) return new ____2324();
        else if (____690 == ____655.____659.____690.welfare) return new ____2344();
        else if (____690 == ____655.____659.____690.rank) return new ____2205();
        else if (____690 == ____655.____659.____690.vip) return new VipModule();
        else if (____690 == ____655.____659.____690.open) return new OpenModule();
        else if (____690 == ____655.____659.____690.feiXian) return new FeiXianModule();
        else if (____690 == ____655.____659.____690.loginGift) return new LoginGiftModule();
        else if (____690 == ____655.____659.____690.openLeiChong) return new OpenLeiChongModule();
        else if (____690 == ____655.____659.____690.tuJian) return new TuJianModule();
        else if (____690 == ____655.____659.____690.look) return new LookModule();
        else if (____690 == ____655.____659.____690.home) return new HomeModule();
        else if (____690 == ____655.____659.____690.marryOath) return new MarryOathModule();
        return null
    },
    ____155: function(____690, data) {
        var m = this.____152(____690);
        if (m != null) {
            m.____151(data);
            return m
        }
        m = this.____153(____690);
        if (m == null) return;
        this.____1414[____690] = m;
        m.____150(____690);
        m.setup(data);
        return m
    },
});
var ____2075 = cc.Class.extend({
    ____954: null,
    ctor: function() {
        this.____954 = []
    },
    getCharacterLayer: function() {
        var result = null;
        if (result == null) result = ____654.____673.newKYSprite();
        return result
    },
    recoverCharacterLayer: function(layer) {
        if (layer == null) return;
        layer.dispose()
    },
});
var ____2076 = cc.Class.extend({
    loadingView: null,
    loadingPanel: null,
    showLoading: function(type) {
        print("#showLoading", type);
        if (this.loadingView == null) {
            this.loadingView = new ____2121()
        }
        if (this.loadingView.isTypeShow(type)) {
            return
        }
        this.loadingView.setType(type)
    },
    hideLoading: function(type) {
        print("#hideLoading", type);
        if (this.loadingView != null) {
            this.loadingView.hideType(type)
        }
    },
    showLoadingPanel: function() {
        if (this.loadingPanel == null) {
            this.loadingPanel = new LoadingPanel()
        }
        this.loadingPanel.show()
    },
    hideLoadingPanel: function() {
        if (this.loadingPanel == null) return;
        this.loadingPanel.hide()
    },
    setLoadingPercent: function(value) {
        if (this.loadingPanel == null) return;
        this.loadingPanel.setValue(value)
    },
    getLoadingPercent: function() {
        if (this.loadingPanel == null) return 0;
        return this.loadingPanel.getPercent()
    },
    ____61: function() {},
});
var ____535 = cc.Class.extend({
    ____134: function() {
        return "res/GameUI/ui.data"
    },
    ____135: function() {
        return "res/GameUI/"
    },
    ____136: function() {
        return "res/data/kysy5.txt"
    },
    getNamePath: function() {
        return "res/data/name.txt"
    },
    ____137: function() {
        return "res/data/descriptC.txt"
    },
    getUIPlistPath: function() {
        return this.____135() + "luaGameUI0.png"
    },
    getUIPlistPath2: function() {
        return this.____135() + "luaGameUI1.png"
    },
    ____139: function(path) {
        return "res/GameUI/" + path
    },
    getEffectPath: function(path) {
        return "res/imgs/effects/" + path
    },
    getEffectPicPath: function(path, index) {
        return "7_" + path + "_" + (1000 + index).toString()
    },
    getMusicPath: function(id) {
        return "res/music/" + id + ".mp3"
    },
    getSkillNamePath: function(id) {
        return "res/imgs/skill/" + id + ".png"
    },
    getAnimation: function(name) {
        return "res/imgs/animas/" + name + "/" + name
    },
    getPathBySourceType: function(sourceType) {
        var ctype = ____655.____659.commonStaticType;
        switch (sourceType) {
            case ctype.style_player:
            case ctype.style_Horse:
            case ctype.style_Weapon:
            case ctype.style_Wind:
            case ctype.style_Cloth:
                return "player";
                break;
            case ctype.style_monster:
                return "monster";
                break;
            case ctype.style_Pet:
                return "pet";
                break;
            case ctype.style_npc:
                return "npc";
                break
        }
        return ""
    },
    getCharacterPath: function(sourceType, path) {
        return "res/imgs/{0}/{1}".format(this.getPathBySourceType(sourceType), path)
    },
    getMapConfigPath: function(path) {
        return "res/imgs/map/" + path + ".txt"
    },
    getMapPiecePath: function(path, row, col) {
        return "res/imgs/map/" + path + "/" + row + "_" + col + ".jpg"
    },
    getFontSource: function(path) {
        return "res/GameUI/font/" + path
    },
    getIconPath: function(path, type) {
        return "res/imgs/goods/" + path + "/" + type
    },
    getTuJianPath: function(path) {
        return "res/imgs/tuJian/" + path + ".png"
    },
    getTuJianYaoJingPath: function(path) {
        return "res/imgs/yaoJing/" + path + ".png"
    },
    getMoneyPathByType: function(priceType) {
        if (priceType == 1) {
            return "icon/ui_moneyIcon1.png"
        } else if (priceType == 2) {
            return "icon/ui_moneyIcon10.png"
        } else if (priceType == 3) {
            return "icon/ui_moneyIcon2.png"
        } else if (priceType == 6) {
            return "icon/ui_moneyIcon3.png"
        }
    },
    getPlatFromPath: function(sources, path) {
        if (sources == null) {
            sources = "default"
        }
        return "res/imgs/platForm/" + sources + "/" + path
    },
    getMonsterHead: function(path) {
        return "res/imgs/monsterhead/" + path + ".png"
    },
    getTilteImgPath: function(picPath) {
        return "res/imgs/title/" + picPath + ".png"
    },
    getSkillIconPath: function(path) {
        return "res/imgs/skillIcon/" + path + ".png"
    },
    getSkillNpcPath: function() {
        return ""
    },
    getSkillCollectPath: function() {
        return ""
    },
    getJiazuWarWalkIconPath: function() {
        return "res/imgs/skillIcon/902.png"
    },
});
var AdvanceEquipTip = KYPanel.extend({
    _itemInfo: null,
    _itemTempInfo: null,
    _equipInfo: null,
    _closeBtn: null,
    ____1777: null,
    _btnTitle1: null,
    ____1778: null,
    _btnTitle2: null,
    _nameLabel: null,
    ____1823: null,
    _layer: null,
    ____869: null,
    _grid: null,
    _star: 0,
    _type: 3,
    _stageLabel: null,
    ____1552: null,
    _proNameLabelList: null,
    ____1157: null,
    _plusFightLabel: null,
    ctor: function() {
        this._super("goodsTip.ExportJson");
        this.modeValue = 100;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1777 = this.getChildByName("tipBtn1");
        this._btnTitle1 = this.getChildByName("btnLabel1");
        this.____1778 = this.getChildByName("tipBtn2");
        this._btnTitle2 = this.getChildByName("btnLabel2");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1823 = this.getChildByName("typeLabel");
        this._layer = this.getChildByName("InfoLayer");
        this.____869 = this.getChildByName("bg1");
        this._grid = new AdvanceEquipGrid();
        this._grid.setMouseEnabled(false);
        this.getChildByName("cellBg").addChild(this._grid);
        this._btnTitle1.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel7"));
        this._btnTitle2.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel3"));
        this.initLabel();
        this.____6()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1777.addListener(this, this.____16);
        this.____1778.addListener(this, this.____16);
        this.____869.addListener(this, this.bgClickHandler);
        ____654.____672.addEventListener(____655.____661.guide_equipRiderEquip, this.guideHandler, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.guide_equipRiderEquip, this.guideHandler, this)
    },
    bgClickHandler: function(sender, eventType) {},
    guideHandler: function() {
        var list = ____655.____659.categoryType.getAdvanceEquipPlace(this._itemTempInfo.categoryId);
        if (list != null && list[0] == ____655.____659.commonStaticType.style_Horse && list[1] == 1 && this.____1777.isVisible()) {
            var info = ____655.advanceItemList.getItemByType(list[0]);
            if (info != null) {
                var equipInfo = info.equipList[list[1]];
                if (equipInfo == null || equipInfo.getWaiXingFight() < this.getWaiXingFight()) {
                    if (info.starCount >= this._star && this._itemInfo != null) {
                        ____654.itemTester.useAdvanceEquip(this._itemInfo);
                        ____654.tipsManager.hide()
                    }
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1777) {
                if (this._itemTempInfo == null) return;
                var list = ____655.____659.categoryType.getAdvanceEquipPlace(this._itemTempInfo.categoryId);
                if (list != null) {
                    var info = ____655.advanceItemList.getItemByType(list[0]);
                    if (info != null) {
                        var equipInfo = info.equipList[list[1]];
                        if (equipInfo != null && equipInfo.getWaiXingFight() >= this.getWaiXingFight()) {
                            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("AdvanceEquipTip.text3"))
                        } else {
                            if (info.starCount >= this._star) {
                                if (this._itemInfo != null) {
                                    ____654.itemTester.useAdvanceEquip(this._itemInfo)
                                }
                            } else {
                                var name = ____655.____659.nameType.getAdvanceName(list[0]);
                                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("AdvanceEquipTip.text2", name))
                            }
                        }
                    }
                }
            } else if (sender == this.____1778) {
                if (____655.____667.level >= ____655.____659.levelType.ronglianLevel) {
                    ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponPot)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2340.text1", ____655.____659.levelType.ronglianLevel))
                }
            }
            ____654.tipsManager.hide()
        }
    },
    initLabel: function() {
        this._stageLabel = ____654.____673.newKYLabel(18);
        this._stageLabel.setPosition(____654.____673.____159(180, 351));
        this._stageLabel.setColor(____655.____659.____688.green);
        this._stageLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this.addChild(this._stageLabel, 5);
        this.____1157 = ____654.____673.newKYLabel(18);
        this.____1157.setPosition(____654.____673.____159(80, 135));
        this.____1157.setColor(____655.____659.____688.orange);
        this.____1157.setAnchorPoint(____654.____673.anchorPoints[4]);
        this.addChild(this.____1157, 5);
        this._plusFightLabel = ____654.____673.newKYLabel(18);
        this._plusFightLabel.setPosition(____654.____673.____159(200, 135));
        this._plusFightLabel.setColor(____655.____659.____688.green);
        this._plusFightLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this.addChild(this._plusFightLabel, 5);
        this.____1552 = [];
        this._proNameLabelList = [];
        for (var i = 0; i < 2; i++) {
            this.____1552[i] = ____654.____673.newKYLabel(18);
            this.____1552[i].setPosition(____654.____673.____159(100, 250 - i * 30));
            this.____1552[i].setColor(____655.____659.____688.system);
            this.____1552[i].setAnchorPoint(____654.____673.anchorPoints[4]);
            this.addChild(this.____1552[i], 5);
            this._proNameLabelList[i] = ____654.____673.newKYLabel(18);
            this._proNameLabelList[i].setPosition(____654.____673.____159(38, 250 - i * 30));
            this._proNameLabelList[i].setColor(____655.____659.____688.darkGold);
            this._proNameLabelList[i].setAnchorPoint(____654.____673.anchorPoints[4]);
            this.addChild(this._proNameLabelList[i], 5)
        }
    },
    ____363: function(tempInfo, star, quality, type, info) {
        this._itemTempInfo = tempInfo;
        this._star = star;
        this._quality = quality;
        if (type != null) {
            this._type = type
        }
        this._itemInfo = info;
        this.updateView()
    },
    updateView: function() {
        this._equipInfo = new ____1972();
        this._equipInfo.templateId = this._itemTempInfo.templateId;
        this._equipInfo.template = this._itemTempInfo;
        this._equipInfo.star = this._star;
        this._equipInfo.quality = this._quality;
        this._grid.setEquipInfo(this._equipInfo, 0, 0, false);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(this._itemTempInfo.quality + this._quality));
        this._nameLabel.setString(this._itemTempInfo.name);
        this.____1823.setString(____655.____659.categoryType.getCategoryName(this._itemTempInfo.categoryId));
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(this._star);
        var fight = 0;
        for (var i = 0; i < 2; i++) {
            var propertyId = this._itemTempInfo.propertys[i * 2 + 2];
            var name = ____655.____659.propertyType.getNameByType(propertyId);
            this._proNameLabelList[i].setString(name + "：");
            var par = ____655.____659.propertyType.getPropertyPar(propertyId);
            var value = Math.floor(____655.____659.categoryType.getWaiXingFight(this._star, this._quality) * this._itemTempInfo.propertys[i * 2 + 3] / 100 / par);
            this.____1552[i].setString(value)
        }
        fight = this.getWaiXingFight();
        this.____1157.setString(____654.yuyanbaoManager.getYuyanbao("common.fightTip", fight));
        var plusFight = 0;
        var isShowPlus = true;
        var list = ____655.____659.categoryType.getAdvanceEquipPlace(this._itemTempInfo.categoryId);
        if (list != null) {
            var info = ____655.advanceItemList.getItemByType(list[0]);
            if (info != null) {
                var equipInfo = info.equipList[list[1]];
                var myFight = 0;
                if (equipInfo != null) {
                    myFight = equipInfo.getWaiXingFight();
                    plusFight = fight - myFight
                } else {
                    isShowPlus = false
                }
                if (info.starCount >= this._star) {
                    if (equipInfo == null || myFight < fight) {
                        this._stageLabel.setString(____654.yuyanbaoManager.getYuyanbao("AdvanceEquipTip.text4"))
                    } else {
                        this._stageLabel.setString("")
                    }
                } else {
                    var value = ____655.____659.nameType.getChineseNumber2(stage);
                    var star1 = ____655.allTemplates.advanceTemplateList.getCurrentStar(this._star);
                    this._stageLabel.setString(____654.yuyanbaoManager.getYuyanbao("AdvanceEquipTip.text1", value, star1));
                    this._stageLabel.setColor(____655.____659.____688.red)
                }
            }
        }
        if (!isShowPlus) {
            this._plusFightLabel.setString("")
        } else if (plusFight >= 0) {
            this._plusFightLabel.setString("+" + plusFight)
        } else {
            this._plusFightLabel.setString(plusFight);
            this._plusFightLabel.setColor(____655.____659.____688.red)
        }
        var width = this.____1157.getContentSize().width;
        var posX = this.____1157.getPositionX();
        this._plusFightLabel.setPositionX(posX + width + 20);
        this.updateBtn()
    },
    updateBtn: function() {
        if (this._type == 2) {
            this.____1777.setTouchEnabled(true);
            this.____1778.setTouchEnabled(true);
            this.____1777.setVisible(true);
            this._btnTitle1.setVisible(true);
            this.____1778.setVisible(true);
            this._btnTitle2.setVisible(true);
            this._stageLabel.setVisible(true);
            this._closeBtn.setVisible(true)
        } else {
            this.____1777.setTouchEnabled(false);
            this.____1778.setTouchEnabled(false);
            this.____1777.setVisible(false);
            this._btnTitle1.setVisible(false);
            this.____1778.setVisible(false);
            this._btnTitle2.setVisible(false);
            this._stageLabel.setVisible(false);
            this._closeBtn.setVisible(false)
        }
        if (this._type == 1) {
            this._plusFightLabel.setVisible(false);
            this.____1157.setPositionX(120)
        } else {
            this._plusFightLabel.setVisible(true)
        }
    },
    hideFormContainer: function() {
        ____654.tipsManager.hide()
    },
    getTipHeight: function() {
        return 410
    },
    getWaiXingFight: function() {
        return Math.floor(this._star * ____655.____659.categoryType.waixingEquipFight * ____655.____659.categoryType.waixingEquipQuality[this._quality])
    },
    dispose: function() {
        this.____17();
        this._stageLabel.dispose();
        this._stageLabel = null;
        this.____1157.dispose();
        this.____1157 = null;
        this._plusFightLabel.dispose();
        this._plusFightLabel = null;
        for (var i = 0; i < 2; i++) {
            this.____1552[i].dispose();
            this.____1552[i] = null;
            this._proNameLabelList[i].dispose();
            this._proNameLabelList[i] = null
        }
        this.____1552 = null;
        this._proNameLabelList = null;
        this._itemTempInfo = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._closeBtn = null;
        this.____1777 = null;
        this.____1778 = null;
        this._btnTitle1 = null;
        this._btnTitle2 = null;
        this._nameLabel = null;
        this.____1823 = null;
        this._layer = null;
        this.____869 = null;
        this._equipInfo.dispose();
        this._equipInfo = null;
        this._itemInfo = null;
        this._super()
    },
});
var DanFlashTip = KYPanel.extend({
    _info: null,
    ____1756: null,
    _nameLabel: null,
    _countLabel: null,
    _grid: null,
    _proNameLabelList: null,
    _proValueLabelList: null,
    ____1157: null,
    _plusFightLabel: null,
    _tipsLabel: null,
    ctor: function() {
        this._super("danFlashTip.ExportJson");
        this._nameLabel = this.getChildByName("nameLabel");
        this._countLabel = this.getChildByName("countLabel");
        this._proNameLabelList = [];
        this._proValueLabelList = [];
        for (var i = 1; i < 3; i++) {
            this._proNameLabelList.push(this.getChildByName("proName" + i));
            this._proValueLabelList.push(this.getChildByName("proValue" + i))
        }
        this.____1157 = this.getChildByName("fightLabel");
        this._plusFightLabel = this.getChildByName("plusFightLabel");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.getChildByName("countNameLabel").setString("使用数量：")
    },
    setItemTemplateInfo: function(itemTemplateInfo, type, count, maxCount, lookType) {
        this.____1756 = itemTemplateInfo;
        this._grid = new ____2129();
        this._grid.setMouseEnabled(false);
        this._grid.setIsShowCount(false);
        this.getChildByName("cellBg").addChild(this._grid);
        this._grid.setItemTemplateInfo(itemTemplateInfo);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTemplateInfo.quality));
        this._nameLabel.setString(itemTemplateInfo.name);
        this._countLabel.setString(count + "/" + maxCount);
        var fight = 0;
        for (var i = 0; i < 2; i++) {
            var propertyId = this.____1756.propertys[i * 2 + 2];
            var name = ____655.____659.propertyType.getNameByType(propertyId);
            this._proNameLabelList[i].setString(name + "：");
            var propertyValue = this.____1756.propertys[i * 2 + 3];
            this._proValueLabelList[i].setString(propertyValue * count);
            fight += ____655.____659.propertyType.getFight(propertyId, propertyValue)
        }
        this.____1157.setString(____654.yuyanbaoManager.getYuyanbao("common.fightTip", fight * count));
        if (lookType != 1) {
            this._plusFightLabel.setString("+" + Math.floor(fight));
            var posX = this.____1157.getPositionX();
            var width = this.____1157.getContentSize().width;
            this._plusFightLabel.setPositionX(posX + width + 30);
            var typeName = ____655.____659.nameType.getAdvanceName(type);
            if (count >= maxCount) {
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("DanFlashTip.text2", typeName, itemTemplateInfo.name));
                this._tipsLabel.setColor(____655.____659.____688.red)
            } else {
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("DanFlashTip.text1", typeName, itemTemplateInfo.name))
            }
        } else {
            this._plusFightLabel.setString("");
            this.____1157.setPosition(____654.____673.____159(this.____1157.getPositionX() + 30, this.____1157.getPositionY() - 10));
            this._tipsLabel.setString("");
            this.getChildByName("line2").setVisible(false)
        }
    },
    setPos: function(pos) {
        if (pos == null) return;
        if (this.____1040 + pos.y > ____655.____657) {
            pos.y = ____655.____657 - 372
        }
        if (pos.x < 0) {
            pos.x = 0
        } else if (pos.x > (____655.____656 - this.____1073)) {
            pos.x = ____655.____656 - 352
        }
        this.setPosition(pos)
    },
    getTipHeight: function() {
        return 372
    },
    dispose: function() {
        this._info = null;
        this.____1756 = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._nameLabel = null;
        this._countLabel = null;
        this._proNameLabelList = null;
        this._proValueLabelList = null;
        this.____1157 = null;
        this._plusFightLabel = null;
        this._tipsLabel = null;
        this._super()
    },
});
var FaceTip = KYPanel.extend({
    ____1150: null,
    ____922: null,
    _executor: null,
    ____856: null,
    ctor: function(callback, executor) {
        this._super();
        this.____856 = ____654.____673.newKYImageView();
        this.____856.setFrame("board/ui_board6.png");
        this.____856.setScale9Enabled(true);
        this.____856.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____856.setCapInsets(____654.____673.____161(40, 40, 1, 1));
        this.____856.setSize(____654.____673.____160(300, 386));
        this.addChild(this.____856);
        this.____922 = callback;
        this._executor = executor;
        this.____5()
    },
    ____5: function() {
        this.____1150 = [];
        var list = ____655.faceInfo.faceList;
        for (var i = 0; i < list.length; i++) {
            var face = new ____2087(2);
            face.setFaceData(list[i]);
            face.setPosition(____654.____673.____159((i % 5) * 53 + 20, Math.floor(i / 5) * 53 + 11));
            this.addChild(face);
            this.____1150.push(face);
            face.setTouchEnabled(true);
            face.addListener(this, this.faceClickHandler)
        }
    },
    faceClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var index = this.____1150.indexOf(sender);
            if (this.____922 != null && this._executor != null) {
                this.____922.call(this._executor, index)
            }
        }
    },
    hideFormContainer: function() {
        ____654.tipsManager.hide()
    },
    dispose: function() {
        this._super();
        for (var i = 0; i < this.____1150.length; i++) {
            this.____1150[i].dispose()
        }
        this.____1150 = null;
        this.____856.dispose();
        this.____856 = null;
        this.____922 = null;
        this._executor = null
    },
});
var FlashTip = KYPanel.extend({
    _info: null,
    ____1756: null,
    ____1311: null,
    _createList: null,
    _nameLabel: null,
    ____1823: null,
    ____1825: null,
    _layer: null,
    _bg: null,
    _grid: null,
    _panelHight: 0,
    ctor: function() {
        this._super("flashTip.ExportJson");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1823 = this.getChildByName("typeLabel");
        this.____1825 = this.getChildByName("typeNameLabel");
        this._layer = this.getChildByName("InfoLayer");
        this._bg = this.getChildByName("bg");
        this.____1311 = [];
        this._createList = [];
        this._panelHight = 372
    },
    setItemInfo: function(itemInfo, stoneInfo) {
        this._info = itemInfo;
        this._grid = new ____2129();
        this._grid.setMouseEnabled(false);
        this._grid.setIsShowCount(false);
        this.getChildByName("cellBg").addChild(this._grid);
        this._grid.setItemInfo(itemInfo);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemInfo.____57()));
        this._nameLabel.setString(itemInfo.template.name);
        this.____1823.setString(____655.____659.categoryType.getCategoryName(itemInfo.template.categoryId));
        if (____654.____674.____181(____655.____659.categoryType.equipList, itemInfo.template.categoryId) != -1) {
            this._grid.setIsShowQHLevel(true);
            var proStr = "";
            var curProTemplate = ____655.allTemplates.strengthPropertyTemplateList.____238(this._info.template.categoryId, this._info.qhLevel);
            var properList = this._info.template.basePropertyList;
            for (var i = 0; i < properList.length; i++) {
                var proName = ____655.____659.propertyType.getNameByType(properList[i].id);
                var proValue = properList[i].value;
                var pluProValue = " ";
                if (curProTemplate != null) {
                    for (j = 0; j < curProTemplate.propertyAdd.length; j++) {
                        if (curProTemplate.propertyAdd[j].id == properList[i].id) {
                            pluProValue = "+" + curProTemplate.propertyAdd[j].value
                        }
                    }
                }
                proStr = proStr + "[" + ____655.____659.____688.darkGoldStr + "]{0}： [-][" + ____655.____659.____688.itemColorStrList[0] + "]{1}[-][" + ____655.____659.____688.itemColorStrList[1] + "]{2}[-]\n";
                proStr = proStr.format(proName, proValue + ____654.____674.getPlaceStr(proValue, 7), pluProValue)
            }
            var label = ____654.____673.newRichLabel(320, proStr);
            label.setScale(0.9);
            this._layer.addChild(label, 1);
            this.____1311.push(label);
            var line = ____654.____673.newKYSprite();
            line.setFrame("bar/ui_bar5.png");
            line.setScaleX(0.65);
            line.setAnchorPoint(____654.____673.anchorPoints[0]);
            line.setPosition(____654.____673.____159(148, -35));
            this._layer.addChild(line, 1);
            this._createList.push(line);
            var rollPropertyList = this._info.rollProperty;
            var rollProStr = "";
            for (var i = 1; i <= 5; i++) {
                var rollProInfo = rollPropertyList[i];
                if (rollProInfo != null) {
                    rollProStr += ____655.____659.____688.getColorStrByQuality(____655.____659.propertyType.getNameByType(rollProInfo.id) + "+" + rollProInfo.value, rollProInfo.quality) + ____654.____674.getPlaceStr(parseInt(rollProInfo.value), 10) + ____655.____659.____688.getColorStrByQuality(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text1", rollProInfo.star), rollProInfo.quality) + "\n"
                } else {
                    rollProStr += "[" + ____655.____659.____688.itemColorStrList[0] + "]" + ____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text5") + "[-]\n"
                }
            }
            var label = ____654.____673.newRichLabel(320, rollProStr, ____655.____659.____688.itemColorList[3]);
            label.setScale(0.9);
            label.setPositionY(-66);
            this._layer.addChild(label, 1);
            this.____1311.push(label);
            if (stoneInfo != null) {
                var line = ____654.____673.newKYSprite();
                line.setFrame("bar/ui_bar5.png");
                line.setScaleX(0.65);
                line.setAnchorPoint(____654.____673.anchorPoints[0]);
                line.setPosition(____654.____673.____159(148, -190));
                this._layer.addChild(line, 1);
                this._createList.push(line);
                var posY = -210;
                for (var i = 0; i < stoneInfo.stoneList.length; i++) {
                    var stone = ____654.____673.newKYSprite();
                    stone.setFrame("icon/stoneType_" + stoneInfo.stoneList[i].stoneType + ".png");
                    stone.setPosition(____654.____673.____159(12, posY - (i * 30 + 2.5)));
                    this._layer.addChild(stone, 1);
                    this._createList.push(stone);
                    var str = ____655.____659.nameType.baoshiName[stoneInfo.stoneList[i].stoneType] + "Lv" + stoneInfo.stoneList[i].stoneLevel + " " + ____655.____659.propertyType.getNameByType(stoneInfo.stoneList[i].template.atrrList[0].id) + "+" + stoneInfo.stoneList[i].template.atrrList[0].value;
                    var label = ____654.____673.newKYLabel(18);
                    if (stoneInfo.stoneList[i].openLevel > stoneInfo.playerLevel) {
                        str += "  (" + ____654.yuyanbaoManager.getYuyanbao("____2340.text1", stoneInfo.stoneList[i].openLevel) + ")";
                        label.setColor(____655.____659.____688.red)
                    } else {
                        label.setColor(____655.____659.____688.itemColorList[0])
                    }
                    label.setString(str);
                    label.setAnchorPoint(____654.____673.anchorPoints[4]);
                    label.setPosition(____654.____673.____159(26, posY - (i * 30)));
                    this._layer.addChild(label, 1);
                    this._createList.push(label)
                }
                this._panelHight = 472;
                this._bg.setSize(____654.____673.____160(352, this._panelHight))
            }
        } else {
            var label = ____654.____673.newRichLabel(320, itemInfo.template.description, ____655.____659.____688.system);
            label.setScale(0.9);
            this._layer.addChild(label, 1);
            this.____1311.push(label);
            var addHeight = label.getHeight() * 0.9 - 220;
            if (addHeight > 0) {
                this._panelHight += addHeight;
                this._bg.setSize(____654.____673.____160(352, this._panelHight))
            }
        }
    },
    setItemTemplateInfo: function(itemTemplateInfo) {
        this.____1756 = itemTemplateInfo;
        this._grid = new ____2129();
        this._grid.setMouseEnabled(false);
        this._grid.setIsShowCount(false);
        this.getChildByName("cellBg").addChild(this._grid);
        this._grid.setItemTemplateInfo(itemTemplateInfo);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTemplateInfo.quality));
        this._nameLabel.setString(itemTemplateInfo.name);
        this.____1823.setString(____655.____659.categoryType.getCategoryName(itemTemplateInfo.categoryId));
        var label = ____654.____673.newRichLabel(320, itemTemplateInfo.description, ____655.____659.____688.system);
        label.setScale(0.9);
        this._layer.addChild(label, 1);
        this.____1311.push(label);
        var addHeight = label.getHeight() * 0.9 - 220;
        if (addHeight > 0) {
            this._panelHight += addHeight;
            this._bg.setSize(____654.____673.____160(352, this._panelHight))
        }
    },
    setSkillInfo: function(skillInfo, godType) {
        this.setSkillTemplateInfo(skillInfo.template, godType, skillInfo.level)
    },
    setSkillTemplateInfo: function(skillTemplateInfo, godType, level) {
        var tempLevel = level;
        if (level == 0) {
            tempLevel = 1
        }
        this.getChildByName("cellBg").setFrame("cell/ui_cell2.png", 1);
        this.____1756 = skillTemplateInfo;
        this._grid = new ____2131(false, 43, 43);
        this._grid.setSkillTemplateInfo(skillTemplateInfo, godType);
        this._grid.____64(level);
        this._grid.setMouseEnabled(false);
        this._grid.setIsShowCount(false);
        this.getChildByName("cellBg").addChild(this._grid);
        this._nameLabel.setColor(____655.____659.____688.system);
        this._nameLabel.setString(____655.allTemplates.skillTemplateList.getSkillName(skillTemplateInfo.templateId, godType) + " Lv." + tempLevel);
        var typeName = ____655.allTemplates.skillTemplateList.getSkillTypeName(skillTemplateInfo.skillType);
        this.____1823.setString(typeName);
        var descInfoList = skillTemplateInfo.descriptText[tempLevel - 1].split(",");
        var desc = ____654.____682.getDescriptReplace("skillDes" + skillTemplateInfo.templateId, descInfoList);
        var label = ____654.____673.newRichLabel(320, desc, ____655.____659.____688.system);
        label.setScale(0.9);
        this._layer.addChild(label, 1);
        this.____1311.push(label);
        var LevelDesc = "";
        var needLevel = skillTemplateInfo.needLevel[level];
        if (needLevel != null && needLevel > 0) {
            if (skillTemplateInfo.skillType >= 3 && skillTemplateInfo.skillType <= 9) {
                var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(needLevel);
                var value = ____655.____659.nameType.getChineseNumber2(stage);
                var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(needLevel);
                if (level == 0) {
                    LevelDesc = ____654.yuyanbaoManager.getYuyanbao("FlashTip.text1").format(value, star, typeName)
                } else {
                    LevelDesc = ____654.yuyanbaoManager.getYuyanbao("FlashTip.text3").format(value, star, typeName, level + 1)
                }
            } else if (skillTemplateInfo.skillType == 1) {
                if (level == 0) {
                    LevelDesc = ____654.yuyanbaoManager.getYuyanbao("FlashTip.text2", needLevel)
                } else {
                    LevelDesc = ____654.yuyanbaoManager.getYuyanbao("FlashTip.text4").format(needLevel, level + 1)
                }
            }
        } else {
            LevelDesc = ____654.yuyanbaoManager.getYuyanbao("FlashTip.text5")
        }
        label = ____654.____673.newRichLabel(320, LevelDesc, ____655.____659.____688.red);
        label.setScale(0.9);
        label.setPositionY(-150);
        this._layer.addChild(label, 1);
        this.____1311.push(label)
    },
    getTipHeight: function() {
        return this._panelHight
    },
    dispose: function() {
        this._super();
        this._info = null;
        this.____1756 = null;
        for (var i = 0; i < this.____1311.length; i++) {
            this.____1311[i].dispose()
        }
        for (var i = 0; i < this._createList.length; i++) {
            this._createList[i].dispose()
        }
        this._createList = null;
        this.____1311 = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._nameLabel = null;
        this.____1823 = null;
        this.____1825 = null;
        this._layer = null;
        this._panelHight = null;
        this._bg = null
    },
});
var GuideClickContainer = KYNode.extend({
    _image: null,
    _mask1: null,
    _mask2: null,
    _mask3: null,
    _mask4: null,
    _yellowBoard: null,
    _info: null,
    ____1774: 0,
    _addX: 0,
    _addY: 0,
    _targetW: 0,
    _targetH: 0,
    _count: 0,
    _fingerEffect: null,
    ctor: function() {
        this._super();
        this._image = ____654.____673.newKYSprite();
        this._image.setFrame("board/ui_alphaBoard.png");
        this._image.setScaleX(____655.____656 / this._image.getContentSize().width);
        this._image.setScaleY(____655.____657 / this._image.getContentSize().height);
        this._image.setAnchorPoint(____654.____673.anchorPoints[6]);
        this._image.setTouchEnabled(true);
        this._image.setOpacity(0);
        this.addChild(this._image);
        this._mask1 = ____654.____673.newKYImageView();
        this._mask1.setFrame("board/ui_blackBoard.png");
        this._mask1.setScale9Enabled(true);
        this._mask1.setOpacity(200);
        this._mask1.setCapInsets(cc.rect(4, 4, 2, 2));
        this._mask1.setAnchorPoint(____654.____673.anchorPoints[1]);
        this.addChild(this._mask1);
        this._mask2 = ____654.____673.newKYImageView();
        this._mask2.setFrame("board/ui_blackBoard.png");
        this._mask2.setScale9Enabled(true);
        this._mask2.setOpacity(200);
        this._mask2.setCapInsets(cc.rect(4, 4, 2, 2));
        this._mask2.setAnchorPoint(____654.____673.anchorPoints[1]);
        this.addChild(this._mask2);
        this._mask3 = ____654.____673.newKYImageView();
        this._mask3.setFrame("board/ui_blackBoard.png");
        this._mask3.setScale9Enabled(true);
        this._mask3.setOpacity(200);
        this._mask3.setCapInsets(cc.rect(4, 4, 2, 2));
        this._mask3.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.addChild(this._mask3);
        this._mask4 = ____654.____673.newKYImageView();
        this._mask4.setFrame("board/ui_blackBoard.png");
        this._mask4.setScale9Enabled(true);
        this._mask4.setOpacity(200);
        this._mask4.setCapInsets(cc.rect(4, 4, 2, 2));
        this._mask4.setAnchorPoint(____654.____673.anchorPoints[3]);
        this.addChild(this._mask4);
        this._yellowBoard = ____654.____673.newKYImageView();
        this._yellowBoard.setFrame("board/ui_board15.png");
        this._yellowBoard.setScale9Enabled(true);
        this._yellowBoard.setCapInsets(cc.rect(15, 15, 1, 1));
        this.____6()
    },
    ____6: function() {
        this._image.addListener(this, this.backgroundClickHandler)
    },
    backgroundClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this._info == null) {
                this.close()
            }
            if (this._info.callbackType == 999) {
                return
            }
            this.callBack();
            if (this._info.nextId > 0) {
                this.showTip(this._info.nextId)
            } else {
                this.close()
            }
        }
    },
    callBack: function() {
        var type = this._info.callbackType;
        if (type == 3) {
            ____654.____676.uiPanelContainer.close();
            var npcId = parseInt(this._info.param[0]);
            if (npcId > 0) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkToNpc, ____654.____672, npcId))
            }
        } else if (type == 4) {
            ____654.____676.uiPanelContainer.close();
            var taskId = parseInt(this._info.param[0]);
            if (taskId > 0) {
                ____654.selfDataMessageSender.sendTaskAccept(taskId)
            }
        } else if (type == 101) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_headClick, ____654.____672, true));
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_headClick, ____654.____672, false))
        } else if (type == 203) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup)
        } else if (type == 204) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab)
        } else if (type == 205) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab)
        } else if (type == 401) {
            var tabIndex = this._info.param[0];
            if (tabIndex > 0) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.common_changeTabIndex, ____654.____672, tabIndex - 1))
            }
        } else if (type == 402) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.bossTab, ____655.____659.panelTabType.boss_person)
        } else if (type == 403) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponStrength)
        } else if (type == 404) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponSoul)
        } else if (type == 501) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_advanceUp, ____654.____672, null))
        } else if (type == 503) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_strength, ____654.____672, null))
        } else if (type == 505) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_enterXiuXianCopy, ____654.____672, null));
            ____655.guideCopyId = ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID
        } else if (type == 602) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_enterCaiLiaoCopy, ____654.____672, null));
            ____655.guideCopyId = ____655.allTemplates.copyTemplateList.CAILIAO_COPYID
        } else if (type == 604) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_foldBtn, ____654.____672, false))
        } else if (type == 607) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.bossTab)
        } else if (type == 608) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_challengePersonBoss, ____654.____672, false));
            ____655.guideCopyId = 99
        } else if (type == 705) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_wuHunLevelUp, ____654.____672, false))
        } else if (type == 706) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_openRiderEquip, ____654.____672, false))
        } else if (type == 707) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_equipRiderEquip, ____654.____672, false))
        } else if (type == 708) {
            ____654.tipsManager.hide()
        } else if (type == 801) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_openEquipBag, ____654.____672, null))
        } else if (type == 802) {
            var itemInfo = ____655.itemInfoList.bagTypeList[2][0];
            if (itemInfo != null && ____655.____659.categoryType.isEquip(itemInfo.template.categoryId)) {
                ____654.tipsManager.showBagItemTip(itemInfo)
            }
        } else if (type == 803) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_clickXiLianBtn, ____654.____672, null))
        } else if (type == 804) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_confirmXiLianPro, ____654.____672, null))
        } else if (type == 805) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_closeXiLianPanel, ____654.____672, null))
        } else if (type == 806) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tabGroup1)
        } else if (type == 807) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_confirmXiLianAgain, ____654.____672, null))
        } else if (type == 997) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_doTask, ____654.____672, null))
        } else if (type == 998) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, true))
        }
    },
    showTip: function(tempId) {
        this._info = ____655.allTemplates.newlyGuideTemplateList.____55(tempId);
        if (this._info == null) {
            this.close();
            return
        }
        var type = this._info.callbackType;
        if (type == 101 || type == 997) {
            this._addX = this._info.x
        } else if (type == 203 || type == 204 || type == 205 || type == 604 || type == 607 || type == 806 || type == 998) {
            this._addX = this._info.x + ____655.____656 - 960
        } else {
            this._addX = this._info.x + ____655.____656 * 0.5 - 480
        }
        if (type == 101 || type == 997) {
            this._addY = this._info.y
        } else if (type == 203 || type == 204 || type == 205 || type == 604 || type == 607 || type == 806 || type == 998) {
            this._addY = this._info.y + ____655.____657 - 640
        } else {
            this._addY = this._info.y + ____655.____657 * 0.5 - 320
        }
        if (this._info.w != 0 || this._info.h != 0) {
            this._mask1.setSize(____654.____673.____160(____655.____656, this._addY + 0.2));
            this._mask1.setPosition(____654.____673.____159(0, ____655.____657));
            this._mask2.setSize(____654.____673.____160(this._addX, this._info.h));
            this._mask2.setPosition(____654.____673.____159(0, ____655.____657 - this._addY));
            this._mask3.setSize(____654.____673.____160(____655.____656, ____655.____657 - this._info.h - this._addY + 0.2));
            this._mask4.setSize(____654.____673.____160(____655.____656 - this._addX - this._info.w, this._info.h));
            this._mask4.setPosition(____654.____673.____159(____655.____656, ____655.____657 - this._addY))
        } else {
            this._mask1.setSize(____654.____673.____160(0, 0));
            this._mask2.setSize(____654.____673.____160(0, 0));
            this._mask3.setSize(____654.____673.____160(0, 0));
            this._mask4.setSize(____654.____673.____160(0, 0))
        }
        if (!this.getParent()) {
            ____654.____676.____802.addChild(this, 99)
        }
        if (type == 999) {
            this.____1774 = parseInt(this._info.param[0]);
            ____654.____678.____298(this.tick, this);
            this.hideYellowBoard();
            if (this._fingerEffect != null) {
                this.showFingerEffect(true, 9999, 9999)
            }
        } else {
            if (this._info.w != 0 || this._info.h != 0) {
                this.showYellowBoard()
            } else {
                this.hideYellowBoard()
            }
            var x = this._addX + this._info.w * 0.5;
            var y = ____655.____657 - this._addY - this._info.h * 0.5;
            this.showFingerEffect(true, x, y)
        }
    },
    showFingerEffect: function(isShow, x, y) {
        if (isShow) {
            if (this._fingerEffect == null) {
                this._fingerEffect = ____654.effectManager.create(14, false, null, false);
                this._fingerEffect.setScale(1.4);
                this._fingerEffect.play();
                this._fingerEffect.addTo(this, 10)
            }
            this._fingerEffect.move(x - 7, y + 14)
        } else {
            if (this._fingerEffect != null) {
                this._fingerEffect.dispose();
                this._fingerEffect = null
            }
        }
    },
    tick: function(delta, count) {
        this.____1774 = this.____1774 - delta * 1000;
        if (this.____1774 <= 0) {
            this.____1774 = 0;
            ____654.____678.____299(this.tick, this);
            if (this._info.nextId > 0) {
                this.showTip(this._info.nextId)
            } else {
                this.close()
            }
        }
    },
    yellowBoardTick: function(delta, count) {
        this._count--;
        if (this._count <= 20) {
            this._count = 20;
            ____654.____678.____299(this.yellowBoardTick, this)
        } else {
            this._yellowBoard.setSize(____654.____673.____160(this._targetW * this._count * 0.05, this._targetH * this._count * 0.05))
        }
    },
    showYellowBoard: function() {
        this._targetW = this._info.w;
        this._targetH = this._info.h;
        this._yellowBoard.setSize(____654.____673.____160(this._info.w * 3, this._info.h * 3));
        this._yellowBoard.setPosition(____654.____673.____159(this._addX + this._info.w * 0.5, ____655.____657 - this._addY - this._info.h * 0.5));
        if (this._yellowBoard.getParent() == null) {
            this.addChild(this._yellowBoard, 10)
        }
        this._count = 60;
        ____654.____678.____298(this.yellowBoardTick, this)
    },
    hideYellowBoard: function() {
        ____654.____678.____299(this.yellowBoardTick, this);
        if (this._yellowBoard.getParent() != null) {
            this._yellowBoard.removeFromParent(false)
        }
    },
    close: function() {
        this.hideYellowBoard();
        this.showFingerEffect(false);
        if (this.____1774 > 0) {
            ____654.____678.____299(this.tick, this)
        }
        this._info = null;
        this.removeFromParent(false)
    },
});
var ____2087 = KYNode.extend({
    ____1239: null,
    ____1175: 3,
    ____1149: null,
    _tickCount: 0,
    ____1037: 0,
    ____1396: 0,
    ctor: function(scale) {
        this._super();
        this.setContentSize(____654.____673.____160(53, 53));
        this.____1239 = ____654.____673.newKYSprite();
        this.____1239.setAnchorPoint(____654.____673.anchorPoints[6]);
        if (scale == null) {
            scale = 1
        }
        this.____1239.setScale(scale);
        this.addChild(this.____1239)
    },
    setFaceData: function(faceData) {
        this.____1149 = faceData;
        this.____1396 = faceData.length;
        this.showFrame();
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount % this.____1175 == 0) {
            this.____1037++;
            if (this.____1037 >= this.____1396) {
                this.____1037 = 0
            }
            this.showFrame()
        }
    },
    showFrame: function() {
        var frameName = this.____1149[this.____1037] + ".png";
        this.____1239.setFrame(frameName)
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____1239.dispose();
        this.____1239 = null;
        this._super();
        this.____1149 = null
    },
});
var NoticeItem = KYNode.extend({
    _bg: null,
    _label: null,
    ctor: function(content) {
        this._super();
        this._bg = ____654.____673.newKYImageView();
        this._bg.setFrame("bar/ui_bar17.png");
        this._bg.setScale9Enabled(true);
        this._bg.setCapInsets(____654.____673.____161(65, 16, 1, 1));
        this._bg.setAnchorPoint(____654.____673.anchorPoints[2]);
        this.addChild(this._bg);
        this._label = ____654.____673.newRichLabel(600, content, null, 1);
        var textW = this._label.getTextWidth();
        this._label.setPosition(____654.____673.____159(-textW * 0.5, -28));
        this.addChild(this._label);
        this._bg.setSize(____654.____673.____160(textW + 140, this._label.getHeight()))
    },
    dispose: function() {
        this._super();
        this._bg.dispose();
        this._bg = null;
        this._label.dispose();
        this._label = null
    },
});
var ____2088 = KYNode.extend({
    ____1236: null,
    _levelLabel: null,
    _info: null,
    ctor: function() {
        this._super();
        this.setContentSize(____654.____673.____160(100, 100))
    },
    ____18: function(info) {
        this._info = info;
        if (this._info == null) return;
        this.____1236 = ____654.____673.newKYSprite();
        this.____1236.setFrame(this._info[1]);
        this.____1236.setAnchorPoint(____654.____673.anchorPoints[0]);
        this.____1236.addListener(this, this.iconClickHandler);
        this.addChild(this.____1236);
        if (this._info[2] != null && ____655.____667.level < this._info[2]) {
            this._levelLabel = ____654.____673.newKYLabel();
            this._levelLabel.setPosition(____654.____673.____159(0, -42));
            this._levelLabel.setString(____654.yuyanbaoManager.getYuyanbao("common.tabGroupTips1", this._info[2].toString()));
            this._levelLabel.setColor(____655.____659.____688.red);
            this._levelLabel.setFontSize(18);
            this.addChild(this._levelLabel, 9);
            this.____1236.setTouchEnabled(false);
            ____654.shaderCache.setColor(this.____1236, 1)
        } else {
            this.____1236.setTouchEnabled(true)
        }
    },
    iconClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this._info[0] == 1) {
                if (this._info[3] != null) {
                    ____654.____683.sendLook(this._info[3].userId, this._info[3].serverId)
                }
                ____654.tipsManager.hide()
            } else if (this._info[0] == 2) {
                if (this._info[3] != null) {
                    if (____655.lookInfo == null) {
                        ____655.lookInfo = new LookInfo()
                    }
                    ____655.lookInfo.lookType = 1;
                    ____654.____683.sendLook(this._info[3].userId, this._info[3].serverId)
                }
                ____654.tipsManager.hide()
            } else if (this._info[0] == 3) {
                if (this._info[3] != null) {
                    if (____655.____668.getFriend(this._info[3].userId) != null) {
                        var userId = this._info[3].userId;
                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_friend);
                        ____654.____672.dispatchEvent(new ____590(____655.____661.common_friendSelectItem, ____654.____672, userId))
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2088.text1"))
                    }
                }
                ____654.tipsManager.hide()
            } else if (this._info[0] == 4) {
                if (this._info[3] != null) {
                    if (____655.marryOathInfo.marryId == this._info[3].userId) {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2088.text3"));
                        ____654.tipsManager.hide()
                    } else {
                        ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2088.tips1", this._info[3].nick), null, 0, this, this.deleteFriendHandler, null, null)
                    }
                }
            } else if (this._info[0] == 5) {
                if (this._info[3] != null) {
                    if (this._info[3].level >= ____655.____659.levelType.shejiaoLevel) {
                        if (____655.____667.vipLevel <= 1 && ____655.____667.level <= 55 && this._info[3].vipLevel >= 2) {
                            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2103.text2"))
                        } else {
                            ____654.selfDataMessageSender.sendAddFriend(this._info[3].serverId, this._info[3].nick, 0)
                        }
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2088.text2", ____655.____659.levelType.shejiaoLevel))
                    }
                }
                ____654.tipsManager.hide()
            } else if (this._info[0] == 11) {
                var myJob = ____655.____667.clubJob;
                if (this._info[3] != null) {
                    if (myJob == 1) {
                        if (this._info[3].job == 2) {
                            ____654.clubMessageSender.sendClubMasterChange(this._info[3].userId)
                        } else if (this._info[3].job == 0) {
                            ____654.clubMessageSender.sendClubJobChange(this._info[3].userId, 2)
                        }
                    } else if (myJob == 2) {
                        ____654.clubMessageSender.sendClubJobChange(this._info[3].userId, 2)
                    }
                }
                ____654.tipsManager.hide()
            } else if (this._info[0] == 12) {
                var myJob = ____655.____667.clubJob;
                if (this._info[3] != null) {
                    if (myJob == 1) {
                        ____654.clubMessageSender.sendClubJobChange(this._info[3].userId, 0)
                    } else if (myJob == 2) {
                        if (this._info[3].job == 0) {
                            ____654.clubMessageSender.sendClubJobChange(this._info[3].userId, 0)
                        }
                    }
                }
                ____654.tipsManager.hide()
            } else if (this._info[0] == 13) {
                var myJob = ____655.____667.clubJob;
                if (this._info[3] != null) {
                    if (myJob == 1) {
                        ____654.clubMessageSender.sendClubMemberCick(this._info[3].userId, 0)
                    } else if (myJob == 2) {
                        if (this._info[3].job == 0) {
                            ____654.clubMessageSender.sendClubMemberCick(this._info[3].userId, 0)
                        }
                    }
                }
                ____654.tipsManager.hide()
            } else if (this._info[0] == 14) {
                if (this._info[3] != null) {
                    ____654.____683.sendLook(this._info[3].userId, this._info[3].serverId)
                }
                ____654.tipsManager.hide()
            }
        }
    },
    deleteFriendHandler: function() {
        ____654.selfDataMessageSender.sendDeleteFriend(this._info[3].userId);
        ____654.tipsManager.hide()
    },
    dispose: function() {
        if (this.____1236 != null) {
            ____654.shaderCache.removeColor(this.____1236);
            this.____1236.dispose();
            this.____1236 = null
        }
        if (this._levelLabel != null) {
            this._levelLabel.dispose();
            this._levelLabel = null
        }
        this._info = null;
        this._super()
    },
});
var ____2089 = KYNode.extend({
    _bg: null,
    _label: null,
    ____1292: 340,
    count: 0,
    ctor: function(content) {
        this._super();
        this._bg = ____654.____673.newKYImageView();
        this._bg.setFrame("bar/ui_bar17.png");
        this._bg.setScale9Enabled(true);
        this._bg.setCapInsets(____654.____673.____161(65, 16, 1, 1));
        this._bg.setAnchorPoint(____654.____673.anchorPoints[6]);
        this._bg.setSize(____654.____673.____160(this.____1292, 37));
        this.addChild(this._bg);
        this._label = ____654.____673.newRichLabel(this.____1292 * 1.2 + 100, content);
        this._label.setScale(1.2);
        this._label.setPosition(____654.____673.____159((this.____1292 - this._label.getTextWidth()) / 2, 2));
        this.addChild(this._label)
    },
    dispose: function() {
        this._super();
        this._bg.dispose();
        this._bg = null;
        this._label.dispose();
        this._label = null
    },
});
var SceneTipItemView = KYNode.extend({
    _bg: null,
    _label: null,
    ctor: function() {
        this._super();
        this._bg = ____654.____673.newKYImageView();
        this._bg.setFrame("bar/ui_bar22.png");
        this._bg.setScale9Enabled(true);
        this._bg.setCapInsets(____654.____673.____161(158, 21, 1, 1));
        this.addChild(this._bg);
        this._label = ____654.____673.newKYLabel(26);
        this.addChild(this._label)
    },
    setString: function(content) {
        this._label.setString(content);
        this._bg.setSize(____654.____673.____160(this._label.getContentSize().width + 200, 56))
    },
    dispose: function() {
        this._super();
        this._bg.dispose();
        this._bg = null;
        this._label.dispose();
        this._label = null
    },
});
var ItemTip = KYPanel.extend({
    _itemInfo: null,
    ____1311: null,
    _createList: null,
    _closeBtn: null,
    ____1777: null,
    _btnTitle1: null,
    ____1778: null,
    _btnTitle2: null,
    _nameLabel: null,
    ____1823: null,
    _layer: null,
    ____869: null,
    _grid: null,
    _compareTip: null,
    ctor: function() {
        this._super("goodsTip.ExportJson");
        this.modeValue = 100;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1777 = this.getChildByName("tipBtn1");
        this._btnTitle1 = this.getChildByName("btnLabel1");
        this.____1778 = this.getChildByName("tipBtn2");
        this._btnTitle2 = this.getChildByName("btnLabel2");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1823 = this.getChildByName("typeLabel");
        this._layer = this.getChildByName("InfoLayer");
        this.____869 = this.getChildByName("bg1");
        this._grid = new ____2129();
        this._grid.setMouseEnabled(false);
        this._grid.setIsShowCount(false);
        this.getChildByName("cellBg").addChild(this._grid);
        this.____1311 = [];
        this._createList = [];
        this.____6();
        this.setPosition(____654.____673.____159((____655.____656 - this.getContentSize().width) / 2, (____655.____657 - this.getContentSize().height) / 2))
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1777.addListener(this, this.____16);
        this.____1778.addListener(this, this.____16);
        this.____869.addListener(this, this.bgClickHandler);
        ____654.____672.addEventListener(____655.____661.guide_clickXiLianBtn, this.guideHandler, this)
    },
    bgClickHandler: function(sender, eventType) {},
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.guide_clickXiLianBtn, this.guideHandler, this)
    },
    guideHandler: function() {
        if (this._itemInfo.bagType == 2) {
            this.xiLianHandler();
            ____654.tipsManager.hide()
        }
    },
    xiLianHandler: function() {
        var equipInfo = ____655.itemInfoList.getBodyEquipByType(this._itemInfo.template.categoryId);
        if (equipInfo == null) {
            ____654.selfDataMessageSender.sendMoveEquip(this._itemInfo.bagType, this._itemInfo.id)
        } else if (equipInfo.____57() < this._itemInfo.____57()) {
            ____654.selfDataMessageSender.sendEquipFusion(this._itemInfo.id)
        } else {
            ____654.____672.dispatchEvent(new ____590(____655.____661.weapon_showXiLianPanel, ____654.____672, this._itemInfo))
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1777) {
                if (this._itemInfo.bagType == 2) {
                    this.xiLianHandler()
                } else if (this._itemInfo.bagType == 4) {} else {
                    ____654.itemTester.useItem(this._itemInfo)
                }
            } else if (sender == this.____1778) {
                if (this._itemInfo.bagType == 2) {
                    if (____655.____659.levelType.ronglianLevel > ____655.____667.level) {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2340.text1", ____655.____659.levelType.ronglianLevel))
                    } else {
                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponPot)
                    }
                } else if (this._itemInfo.bagType == 4) {} else {
                    ____654.itemTester.sellItem(this._itemInfo)
                }
            }
            ____654.tipsManager.hide()
        }
    },
    ____363: function(itemInfo) {
        this._itemInfo = itemInfo;
        this._grid.setItemInfo(itemInfo);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemInfo.____57()));
        this._nameLabel.setString(itemInfo.getName());
        this.____1823.setString(____655.____659.categoryType.getCategoryName(itemInfo.template.categoryId));
        if (this._itemInfo.bagType == 2) {
            this._grid.setIsShowQHLevel(true);
            var proStr = "";
            var curProTemplate = ____655.allTemplates.strengthPropertyTemplateList.____238(this._itemInfo.template.categoryId, this._itemInfo.qhLevel);
            var properList = this._itemInfo.template.basePropertyList;
            for (var i = 0; i < properList.length; i++) {
                var proName = ____655.____659.propertyType.getNameByType(properList[i].id);
                var proValue = properList[i].value;
                var pluProValue = " ";
                if (curProTemplate != null) {
                    for (j = 0; j < curProTemplate.propertyAdd.length; j++) {
                        if (curProTemplate.propertyAdd[j].id == properList[i].id) {
                            pluProValue = "+" + curProTemplate.propertyAdd[j].value
                        }
                    }
                }
                proStr = proStr + "[" + ____655.____659.____688.darkGoldStr + "]{0}： [-][" + ____655.____659.____688.itemColorStrList[0] + "]{1}[-][" + ____655.____659.____688.itemColorStrList[1] + "]{2}[-]\n";
                proStr = proStr.format(proName, proValue + ____654.____674.getPlaceStr(proValue, 7), pluProValue)
            }
            var label = ____654.____673.newRichLabel(320, proStr);
            label.setScale(0.9);
            this._layer.addChild(label, 1);
            this.____1311.push(label);
            var line = ____654.____673.newKYSprite();
            line.setFrame("bar/ui_bar5.png");
            line.setScaleX(0.65);
            line.setAnchorPoint(____654.____673.anchorPoints[0]);
            line.setPosition(____654.____673.____159(148, -35));
            this._layer.addChild(line, 1);
            this._createList.push(line);
            var rollPropertyList = this._itemInfo.rollProperty;
            var rollProStr = "";
            for (var i = 1; i <= 5; i++) {
                var rollProInfo = rollPropertyList[i];
                if (rollProInfo != null) {
                    rollProStr += ____655.____659.____688.getColorStrByQuality(____655.____659.propertyType.getNameByType(rollProInfo.id) + "+" + rollProInfo.value, rollProInfo.quality) + ____654.____674.getPlaceStr(parseInt(rollProInfo.value), 10) + ____655.____659.____688.getColorStrByQuality(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text1", rollProInfo.star), rollProInfo.quality) + "\n"
                }
            }
            var label = ____654.____673.newRichLabel(320, rollProStr, ____655.____659.____688.itemColorList[3]);
            label.setScale(0.9);
            label.setPositionY(-66);
            this._layer.addChild(label, 1);
            this.____1311.push(label);
            var equipInfo = ____655.itemInfoList.getBodyEquipByType(this._itemInfo.template.categoryId);
            if (equipInfo == null || equipInfo.____57() < this._itemInfo.____57()) {
                this._btnTitle1.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel1"));
                this.____1778.setTouchEnabled(false);
                this.____1778.setFrame("btn/ui_btn1_4.png")
            } else {
                this._btnTitle1.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel6"));
                if (equipInfo.____57() > this._itemInfo.____57()) {
                    this.____1777.setTouchEnabled(false);
                    this.____1777.setFrame("btn/ui_btn1_4.png")
                }
            }
            this._btnTitle2.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel3"));
            if (equipInfo != null) {
                this._compareTip = new FlashTip();
                this._compareTip.setItemInfo(equipInfo);
                this._compareTip.setPosition(____654.____673.____159(-360, 40));
                this.addChild(this._compareTip);
                this.setPositionX((____655.____656 - this.getContentSize().width + 360) / 2)
            }
        } else if (this._itemInfo.bagType == 4) {
            this._btnTitle1.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel8"));
            this._btnTitle2.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel2"))
        } else {
            this._btnTitle1.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel7"));
            var label = ____654.____673.newRichLabel(320, this._itemInfo.template.description, ____655.____659.____688.system);
            label.setScale(0.9);
            this._layer.addChild(label, 1);
            this.____1311.push(label);
            var addHeight = label.getHeight() * 0.9 - 160;
            if (addHeight > 0) {
                this.setPositionY(this.getPositionY() + addHeight / 2);
                var size = this.____869.getSize();
                this.____869.setSize(____654.____673.____160(size.width, size.height + addHeight));
                this.setContentSize(____654.____673.____160(size.width, size.height + addHeight));
                this.____1777.setPositionY(this.____1777.getPositionY() - addHeight);
                this._btnTitle1.setPositionY(this._btnTitle1.getPositionY() - addHeight);
                this.____1778.setPositionY(this.____1778.getPositionY() - addHeight);
                this._btnTitle2.setPositionY(this._btnTitle2.getPositionY() - addHeight)
            }
            if (this._itemInfo.template.sellPrice > 0) {
                this._btnTitle2.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel4"))
            } else {
                this._btnTitle2.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel5"))
            }
        }
    },
    hideFormContainer: function() {
        ____654.tipsManager.hide()
    },
    dispose: function() {
        this.____17();
        this._super();
        if (this._compareTip != null) {
            this._compareTip.dispose();
            this._compareTip = null
        }
        this._itemInfo = null;
        for (var i = 0; i < this.____1311.length; i++) {
            this.____1311[i].dispose()
        }
        this.____1311 = null;
        for (var i = 0; i < this._createList.length; i++) {
            this._createList[i].dispose()
        }
        this._createList = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._closeBtn = null;
        this.____1777 = null;
        this._btnTitle1 = null;
        this.____1778 = null;
        this._btnTitle2 = null;
        this._nameLabel = null;
        this.____1823 = null;
        this._layer = null;
        this.____869 = null
    },
});
var PlayerMenuTip = KYPanel.extend({
    _type: null,
    ____1251: null,
    ____856: null,
    _itemList: null,
    ____1040: 0,
    ____1073: 0,
    ____1607: 0,
    ctor: function(type, info) {
        this._super();
        this._type = type;
        this._info = info;
        this.____1251 = [];
        this._itemList = [];
        this.____856 = ____654.____673.newKYImageView();
        this.____856.setFrame("board/ui_board6.png");
        this.____856.setScale9Enabled(true);
        this.____856.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____856.setCapInsets(____654.____673.____161(40, 40, 1, 1));
        this.addChild(this.____856);
        this.____1040 = 200;
        this.____1073 = 200;
        this.____5()
    },
    ____5: function() {
        if (this._type == 1) {
            this.____1251 = [
                [1, "icon/ui_menuIcon4.png", 1, this._info],
                [2, "icon/ui_menuIcon7.png", 1, this._info],
                [3, "icon/ui_menuIcon6.png", ____655.____659.levelType.shejiaoLevel, this._info]
            ];
            if (____655.____668.getFriend(this._info.userId) != null) {
                this.____1251.push([4, "icon/ui_menuIcon8.png", ____655.____659.levelType.shejiaoLevel, this._info])
            } else {
                this.____1251.push([5, "icon/ui_menuIcon10.png", ____655.____659.levelType.shejiaoLevel, this._info])
            }
            this.____1607 = 2
        } else if (this._type == 2) {
            this.____1251 = [
                [1, "icon/ui_menuIcon4.png", 1, this._info],
                [2, "icon/ui_menuIcon7.png", 1, this._info]
            ];
            if (____655.____668.getFriend(this._info.userId) != null) {
                this.____1251.push([4, "icon/ui_menuIcon8.png", ____655.____659.levelType.shejiaoLevel, this._info])
            } else {
                this.____1251.push([5, "icon/ui_menuIcon10.png", ____655.____659.levelType.shejiaoLevel, this._info])
            }
            this.____1607 = 2
        } else if (this._type == 3) {
            var myJob = ____655.____667.clubJob;
            if (myJob == 1) {
                if (this._info.job == 0) {
                    this.____1251 = [
                        [11, "icon/ui_menuIcon1.png", 1, this._info],
                        [13, "icon/ui_menuIcon3.png", 1, this._info],
                        [14, "icon/ui_menuIcon4.png", 1, this._info]
                    ]
                } else if (this._info.job == 2) {
                    this.____1251 = [
                        [12, "icon/ui_menuIcon2.png", 1, this._info],
                        [13, "icon/ui_menuIcon3.png", 1, this._info],
                        [14, "icon/ui_menuIcon4.png", 1, this._info]
                    ]
                }
            } else if (myJob == 2) {
                if (this._info.job == 0) {
                    this.____1251 = [
                        [13, "icon/ui_menuIcon3.png", 1, this._info],
                        [14, "icon/ui_menuIcon4.png", 1, this._info]
                    ]
                }
            }
            this.____1607 = 3
        }
        for (var i = 0; i < this.____1251.length; i++) {
            var item = new ____2088();
            item.____18(this.____1251[i]);
            this._itemList.push(item);
            this.addChild(item);
            var posX = i % this.____1607 * 90 + 67;
            var posY = Math.ceil((Math.ceil(this.____1251.length / this.____1607) * this.____1607 - i) / this.____1607) * 90 - 20;
            item.setPosition(____654.____673.____159(posX, posY))
        }
        if (this.____1251.length > 0) {
            this.____1040 = Math.ceil(this.____1251.length / this.____1607) * 90 + 40;
            this.____1073 = Math.min(this.____1607, this.____1251.length) * 90 + 40
        }
        this.____856.setSize(____654.____673.____160(this.____1073, this.____1040))
    },
    setPos: function(pos) {
        if (pos == null) return;
        if (this.____1040 + pos.y > ____655.____657) {
            pos.y = ____655.____657 - this.____1040
        }
        if (pos.x < 0) {
            pos.x = 0
        } else if (pos.x > (____655.____656 - this.____1073)) {
            pos.x = ____655.____656 - this.____1073
        }
        this.setPosition(pos)
    },
    hideFormContainer: function() {
        ____654.tipsManager.hide()
    },
    dispose: function() {
        this._type = null;
        this.____1251 = null;
        this.____856.dispose();
        this.____856 = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this._itemList = null;
        this.____1040 = null;
        this.____1073 = null;
        this._super()
    },
});
var PlayerNoticeManager = cc.Class.extend({
    advacneNotice: function(type, starCount, nick) {
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(starCount);
        var value = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(starCount);
        var stageStr = "[" + ____655.____659.____688.purpleStr + "]" + ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", value, star) + "[-]";
        var typeName = "[" + ____655.____659.____688.yellowStr + "]" + ____655.____659.nameType.getAdvanceName(type) + "[-]";
        var name = "[" + ____655.____659.____688.yellowStr + "]" + nick + "[-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text1", name, typeName, stageStr);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    warKillCount: function(nick, count) {
        var str = "";
        if (count == 5) {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text3", nick, count)
        } else if (count == 10) {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text4", nick, count)
        } else if (count > 10) {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text5", nick, count)
        }
        ____654.tipsManager.quickTip.showScene(str)
    },
    warShutdown: function(nick1, nick2, count) {
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text6", nick1, nick2, count);
        ____654.tipsManager.quickTip.showScene(str)
    },
    worldBossNotice: function(time) {
        var str = "";
        if (time > 0) {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text7", time)
        } else {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text8")
        }
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    worldBossBeSkill: function(nick, bossId, awardList) {
        var nickStr = "[" + ____655.____659.____688.yellowStr + "]" + nick + "[-]";
        var monsterTemplate = ____655.allTemplates.monsterTemplateList.getMonster(bossId);
        var bossNameStr = "[" + ____655.____659.____688.yellowStr + "][" + monsterTemplate.name + "][-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text9", nickStr, bossNameStr);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    tanbaoOpenBoxNotice: function(nick) {
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text10", nick);
        ____654.tipsManager.quickTip.showScene(str)
    },
    playerRenameNotice: function(oldName, newName) {
        var oldNickStr = "[" + ____655.____659.____688.yellowStr + "]" + oldName + "[-]";
        var newNickStr = "[" + ____655.____659.____688.yellowStr + "]" + newName + "[-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text11").format(oldNickStr, newNickStr);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    createClubNotice: function(playerName, clubName) {
        var playerNameStr = "[" + ____655.____659.____688.yellowStr + "]" + playerName + "[-]";
        var clubNameStr = "[" + ____655.____659.____688.lightGreenStr + "]" + clubName + "[-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text12", playerNameStr, clubNameStr);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    zhuoYaoKillBossNotice: function(nick) {
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text13", nick);
        ____654.tipsManager.quickTip.showScene(str)
    },
    luckyChouJiangNotice: function(nick, itemList) {
        var nickStr = "[" + ____655.____659.____688.yellowStr + "]" + nick + "[-]";
        var count = 0;
        var appendStr = "";
        for (var i = 0; i < itemList.length; i++) {
            var itemTemplate = ____655.allTemplates.____794.getItem(itemList[i][0]);
            appendStr = appendStr + "[" + ____655.____659.____688.itemColorStrList[itemTemplate.quality] + "]" + itemTemplate.name + " x" + itemList[i][1] + "[-]"
        }
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text14", nickStr, appendStr);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    luckyGetJiangNotice: function(nick, itemList, condition) {
        var nickStr = "[" + ____655.____659.____688.yellowStr + "]" + nick + "[-]";
        var count = 0;
        var appendStr = "";
        for (var i = 0; i < itemList.length; i++) {
            var itemTemplate = ____655.allTemplates.____794.getItem(itemList[i][0]);
            appendStr = appendStr + "[" + ____655.____659.____688.itemColorStrList[itemTemplate.quality] + "]" + itemTemplate.name + " x" + itemList[i][1] + "[-]"
        }
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text15", nickStr, condition, appendStr);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    familyFightGuWuNotice: function(nick, clubName, propertyId, propertyValue) {
        var nickStr = nick;
        var clubNameStr = "[" + ____655.____659.____688.redStr + "]" + clubName + "[-]";
        var proPertyName = ____655.____659.propertyType.getNameByType(propertyId);
        var proStr = "[" + proPertyName + "]+" + propertyValue + "%";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text16", nick, clubName, proStr);
        ____654.tipsManager.quickTip.showScene(str)
    },
    marryNotice: function(nick1, nick2, marryType) {
        var nick1Str = "[" + ____655.____659.____688.yellowStr + "]" + nick1 + "[-]";
        var nick2Str = "[" + ____655.____659.____688.yellowStr + "]" + nick2 + "[-]";
        var template = ____655.allTemplates.marryOathTemplateList.____55(____655.____659.commonStaticType.sheJiao_marry, marryType);
        var ringStr = "[" + ____655.____659.____688.purpleStr + "]" + template.name + "[-]";
        var fight = "[" + ____655.____659.____688.yellowStr + "]" + template.getFight() + "[-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text17", nick1Str, nick2Str, ringStr, fight);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info);
        var tmpInfo = ____655.particleInfoList.list["floower"];
        var p = new tmpInfo.cls(____654.____676.____802, tmpInfo);
        p.play()
    },
    oathNotice: function(nick1, nick2, nick3, type) {
        var nick1Str = "[" + ____655.____659.____688.yellowStr + "]" + nick1 + "[-]";
        var nick2Str = "[" + ____655.____659.____688.yellowStr + "]" + nick2 + "[-]";
        var nick3Str = "[" + ____655.____659.____688.yellowStr + "]" + nick3 + "[-]";
        var template = ____655.allTemplates.marryOathTemplateList.____55(____655.____659.commonStaticType.sheJiao_oath, type);
        var fight = "[" + ____655.____659.____688.yellowStr + "]" + template.getFight() + "[-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text19", nick1Str, nick2Str, nick3Str, fight);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info);
        var tmpInfo = ____655.particleInfoList.list["floower2"];
        var p = new tmpInfo.cls(____654.____676.____802, tmpInfo);
        p.play()
    },
    getZhanQiNotice: function(type, clubName, monsterId) {
        var monsterTemplate = ____655.allTemplates.monsterTemplateList.getMonster(monsterId);
        var bossNameStr = monsterTemplate.name;
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text18", clubName, bossNameStr);
        ____654.tipsManager.quickTip.showScene(str)
    },
    zhanShenLoginNotice: function(nick) {
        var nickStr = "[" + ____655.____659.____688.yellowStr + "]" + nick + "[-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text20", nickStr);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    titleNotice: function(templateId, nick) {
        var template = ____655.allTemplates.titleTemplateList.getTitle(templateId);
        var nickName = "[" + ____655.____659.____688.yellowStr + "]" + nick + "[-]";
        var titleName = "[" + ____655.____659.____688.purpleStr + "]" + template.name + "[-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text21", nickName, titleName);
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    dailyFirstRechargeNotice: function(nick, condition) {
        var nickStr = "[" + ____655.____659.____688.yellowStr + "]" + nick + "[-]";
        var conditionList = ____655.allTemplates.dailyFirstRechargeTemplateList.conditionList;
        var index = conditionList.indexOf(condition);
        var str = "";
        if (index == 0) {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text22", nickStr)
        } else if (index == 1) {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text24", nickStr, condition / 10)
        } else if (index == 2) {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text25", nickStr, condition / 10)
        } else if (index == 3) {
            str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text26", nickStr, condition / 10)
        }
        var info = new ____481();
        info.channel = ____655.____659.____693.worldNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
    familyTreasureNotice: function(nick, boxId) {
        var boxInfo = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(boxId);
        var ____993 = ____655.allTemplates.familyTreasuresBoxTemplateList.getNoticeBoxColor(boxId);
        var nickColor = ____655.____659.____688.yellowStr;
        var nickStr = "[" + nickColor + "]" + nick + "[-]";
        var boxStr = "[" + ____993 + "]" + boxInfo.name + "[-]";
        var str = ____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text23", nickStr, boxStr);
        var info = new ____481();
        info.channel = ____655.____659.____693.clubNotice;
        info.message = str;
        ____655.____669.____36(info)
    },
});
var ____2084 = cc.Class.extend({
    _itemList: null,
    _sceneTipItem: null,
    _sceneTipTime: 0,
    _noticeItem: null,
    _noticeTime: 0,
    maxCount: 3,
    ctor: function() {
        this._itemList = []
    },
    show: function(content) {
        if (content == null || content == "") {
            return
        }
        if (this._itemList.length >= this.maxCount) {
            return
        }
        var itemView = new ____2089(content);
        itemView.setPosition(____654.____673.____159(____655.____656 - 390, 283 + 38 * (this._itemList.length)));
        ____654.____676.____802.addChild(itemView, 99);
        this._itemList.push(itemView);
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        var len = this._itemList.length;
        var del = [];
        for (var i = 0; i < len; i++) {
            var item = this._itemList[i];
            item.count++;
            if (item.count < 90) {
                item.setPositionY(item.getPositionY() + 0.5)
            } else {
                item.dispose();
                del.unshift(i)
            }
        }
        if (del.length > 0) {
            for (var j = 0; j < del.length; j++) {
                this._itemList.splice(del[j], 1)
            }
        }
        if (this._itemList.length == 0) {
            ____654.____678.____299(this.tick, this)
        }
    },
    showScene: function(content) {
        if (content == null || content == "") {
            return
        }
        if (this._sceneTipItem == null) {
            this._sceneTipItem = new SceneTipItemView();
            this._sceneTipItem.setPosition(____655.____656 * 0.5, 147);
            ____654.____676.____802.addChild(this._sceneTipItem, 98)
        }
        this._sceneTipItem.setString(content);
        this._sceneTipTime = 180;
        ____654.____678.____298(this.sceneTipTick, this)
    },
    sceneTipTick: function(delta, count) {
        this._sceneTipTime--;
        if (this._sceneTipTime <= 0) {
            if (this._sceneTipItem != null) {
                this._sceneTipItem.dispose();
                this._sceneTipItem = null
            }
            ____654.____678.____299(this.sceneTipTick, this)
        }
    },
    showNotice: function(content) {
        if (content == null || content == "") {
            return
        }
        if (this._noticeItem != null) {
            this._noticeItem.dispose()
        }
        this._noticeItem = new NoticeItem(content);
        this._noticeItem.setPosition(____655.____656 * 0.5, ____655.____657 - 110);
        ____654.____676.____802.addChild(this._noticeItem, 98);
        this._noticeTime = 300;
        ____654.____678.____298(this.noticeTick, this)
    },
    noticeTick: function(delta, count) {
        this._noticeTime--;
        if (this._noticeTime <= 0) {
            if (this._noticeItem != null) {
                this._noticeItem.dispose();
                this._noticeItem = null
            }
            ____654.____678.____299(this.noticeTick, this)
        }
    },
});
var ShenBingFlashTip = KYPanel.extend({
    ____1157: null,
    _nameLabel: null,
    _markImg: null,
    _weaponIcon: null,
    ____1706: null,
    _proValueLabelList: null,
    _proNameLabelList: null,
    ____1869: null,
    ctor: function() {
        this._super("flashTip2.ExportJson");
        this.____1157 = this.getChildByName("fightLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this._markImg = this.getChildByName("markImg");
        this._weaponIcon = this.getChildByName("weaponIcon");
        this.____1706 = [];
        for (var i = 1; i <= 5; i++) {
            this.____1706.push(this.getChildByName("starIcon" + i))
        }
        this._proValueLabelList = [];
        this._proNameLabelList = [];
        for (var i = 1; i <= 4; i++) {
            this._proValueLabelList.push(this.getChildByName("proValue" + i));
            this._proNameLabelList.push(this.getChildByName("proName" + i))
        }
        this.getChildByName("fightDesLabel").setString("战力：")
    },
    ____363: function(tempInfo, level) {
        if (level > 0) {
            this._markImg.setVisible(false)
        } else {
            this._markImg.setVisible(true)
        }
        this._nameLabel.setString(tempInfo.name);
        this.____1869 = ____654.____675.____139("outPic/role_weaponIcon" + tempInfo.type + ".png");
        ____654.____677.____146(this._weaponIcon, this.____1869);
        ____654.____674.setKYStarListColor(this.____1706, level);
        if (tempInfo.stars[level] != null) {
            this.____1157.setString(tempInfo.stars[level].fightValue);
            for (var i = 0; i < tempInfo.stars[level].attrStr.length; i++) {
                var name = ____655.____659.propertyType.getNameByType(tempInfo.stars[level].attrStr[i].id);
                this._proNameLabelList[i].setString(name + "：");
                this._proValueLabelList[i].setString(tempInfo.stars[level].attrStr[i].value)
            }
        } else {
            this.____1157.setString(0);
            for (var i = 0; i < tempInfo.stars[1].attrStr.length; i++) {
                var name = ____655.____659.propertyType.getNameByType(tempInfo.stars[1].attrStr[i].id);
                this._proNameLabelList[i].setString(name + "：");
                this._proValueLabelList[i].setString(0)
            }
        }
    },
    getTipHeight: function() {
        return 372
    },
    dispose: function() {
        this.____1157 = null;
        this._nameLabel = null;
        this._markImg = null;
        this.____1706 = null;
        this._proValueLabelList = null;
        this._proNameLabelList = null;
        if (this.____1869 != null) {
            ____654.____677.removeImageQuote(this.____1869, this._weaponIcon);
            this._weaponIcon = null;
            this.____1869 = null
        }
        this._super()
    },
});
var StringTip = KYPanel.extend({
    _label: null,
    ____856: null,
    _closeBtn: null,
    _stringWidth: 500,
    ctor: function(width) {
        this._super();
        this.modeValue = 100;
        this.____856 = ____654.____673.newKYImageView();
        this.____856.setFrame("board/ui_board6.png");
        this.____856.setScale9Enabled(true);
        this.____856.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____856.setCapInsets(____654.____673.____161(40, 40, 1, 1));
        this.addChild(this.____856);
        if (width != null) {
            this._stringWidth = width
        }
        this._closeBtn = ____654.____673.newKYSprite();
        this._closeBtn.setFrame("btn/ui_closeBtn2.png", 1);
        this.____6()
    },
    setString: function(content) {
        if (this._label != null) {
            return
        }
        this._label = ____654.____673.newRichLabel(this._stringWidth, content);
        this.addChild(this._label);
        this.addChild(this._closeBtn);
        var bgWidth = this._stringWidth + 40;
        var bgHeight = this._label.getHeight() + 26;
        this.____856.setSize(____654.____673.____160(bgWidth, bgHeight));
        this.____856.setPosition(____654.____673.____159(-bgWidth * 0.5, -bgHeight * 0.5));
        this._label.setPosition(____654.____673.____159(20 - bgWidth * 0.5, this._label.getHeight() - 15 - bgHeight * 0.5));
        this._closeBtn.setPosition(____654.____673.____159(this._stringWidth + 16 - bgWidth * 0.5, this._label.getHeight() - 1 - bgHeight * 0.5))
    },
    hideFormContainer: function() {
        ____654.tipsManager.hide()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._closeBtn) {
                ____654.tipsManager.hide()
            }
        }
    },
    dispose: function() {
        this.____17();
        this._super();
        if (this._label != null) {
            this._label.dispose();
            this._label = null
        }
        if (this.____856 != null) {
            this.____856.dispose();
            this.____856 = null
        }
        if (this._closeBtn != null) {
            this._closeBtn.dispose();
            this._closeBtn = null
        }
    },
});
var ____2086 = cc.Class.extend({
    quickTip: null,
    ____1167: null,
    ____1070: null,
    ctor: function() {
        this.quickTip = new ____2084()
    },
    showBagItemTip: function(itemInfo) {
        if (itemInfo == null) {
            return
        }
        this.hide();
        if (____655.____659.categoryType.isWaiXingEquip(itemInfo.template.categoryId)) {
            this.showAdvanceEquipTip(itemInfo, 2);
            return
        }
        this.____1070 = new ItemTip();
        this.____1070.____363(itemInfo);
        ____654.____676.____125(this.____1070, false)
    },
    showStringTip: function(content, width) {
        if (content == null || content == "") {
            return
        }
        this.hide();
        this.____1070 = new StringTip(width);
        this.____1070.setString(content);
        ____654.____676.____125(this.____1070, true)
    },
    showPlayerMenuTip: function(type, info, pos) {
        if (info == null) {
            return
        }
        this.hide();
        this.____1070 = new PlayerMenuTip(type, info);
        this.____1070.setPos(pos);
        ____654.____676.____125(this.____1070, false)
    },
    showAdvanceEquipTip: function(info, type) {
        if (info == null) {
            return
        }
        var itemTempInfo = null;
        var star = 0;
        var quality = 0;
        var itemInfo = null;
        if (info instanceof ItemInfo) {
            itemTempInfo = info.template;
            star = info.quality;
            quality = info.qhLevel;
            itemInfo = info
        } else if (info instanceof ____1972) {
            itemTempInfo = info.template;
            star = info.star;
            quality = info.quality
        }
        if (itemTempInfo == null) {
            return
        }
        this.hide();
        this.____1070 = new AdvanceEquipTip();
        this.____1070.____363(itemTempInfo, star, quality, type, itemInfo);
        ____654.____676.____125(this.____1070, true)
    },
    showFlashAdvanceEquipTip: function(info, type, pos) {
        this.hideFlashTip();
        if (info == null) {
            return
        }
        var itemTempInfo = null;
        var star = 0;
        var quality = 0;
        if (info instanceof ItemInfo) {
            itemTempInfo = info.template;
            star = info.quality;
            quality = info.qhLevel;
            itemInfo = info
        } else if (info instanceof ____1972) {
            itemTempInfo = info.template;
            star = info.star;
            quality = info.quality
        }
        if (itemTempInfo == null) {
            return
        }
        this.____1167 = new AdvanceEquipTip();
        this.____1167.____363(itemTempInfo, star, quality, type);
        this.____1167.setPosition(this.getFlashPos(pos, this.____1167.getTipHeight()));
        ____654.____676.____802.addChild(this.____1167, 98)
    },
    showFlashShenBingTip: function(tempInfo, level, pos) {
        this.hideFlashTip();
        if (tempInfo == null) {
            return
        }
        this.____1167 = new ShenBingFlashTip();
        this.____1167.____363(tempInfo, level);
        this.____1167.setPosition(this.getFlashPos(pos, this.____1167.getTipHeight()));
        ____654.____676.____802.addChild(this.____1167, 98)
    },
    showItemFlashTip: function(itemInfo, pos, stoneInfo) {
        this.hideFlashTip();
        if (____655.____659.categoryType.isWaiXingEquip(itemInfo.template.categoryId)) {
            this.showFlashAdvanceEquipTip(itemInfo, 3, pos);
            return
        }
        this.____1167 = new FlashTip();
        this.____1167.setItemInfo(itemInfo, stoneInfo);
        this.____1167.setPosition(this.getFlashPos(pos, this.____1167.getTipHeight()));
        ____654.____676.____802.addChild(this.____1167, 98)
    },
    showItemTempFlashTip: function(itemTemplateInfo, pos) {
        this.hideFlashTip();
        this.____1167 = new FlashTip();
        this.____1167.setItemTemplateInfo(itemTemplateInfo);
        this.____1167.setPosition(this.getFlashPos(pos, this.____1167.getTipHeight()));
        ____654.____676.____802.addChild(this.____1167, 98)
    },
    showDanTempFlashTip: function(itemTemplateInfo, type, count, maxCount, pos, lookType) {
        this.hideFlashTip();
        this.____1167 = new DanFlashTip();
        this.____1167.setItemTemplateInfo(itemTemplateInfo, type, count, maxCount, lookType);
        this.____1167.setPos(pos);
        ____654.____676.____802.addChild(this.____1167, 98)
    },
    showSkillFlashTip: function(skillInfo, pos, godType) {
        this.hideFlashTip();
        this.____1167 = new FlashTip();
        this.____1167.setSkillInfo(skillInfo, godType);
        this.____1167.setPosition(this.getFlashPos(pos, this.____1167.getTipHeight()));
        ____654.____676.____802.addChild(this.____1167, 98)
    },
    showSkillTempFlashTip: function(skillTemplateInfo, pos, godType, level) {
        this.hideFlashTip();
        this.____1167 = new FlashTip();
        this.____1167.setSkillTemplateInfo(skillTemplateInfo, godType, level);
        this.____1167.setPosition(this.getFlashPos(pos, this.____1167.getTipHeight()));
        ____654.____676.____802.addChild(this.____1167, 98)
    },
    getFlashPos: function(pos, height) {
        var result = ____654.____673.____159(0, 0);
        if (pos.x > ____655.____656 * 0.5) {
            result.x = pos.x - 45 - 352
        } else {
            result.x = pos.x + 45
        }
        if (pos.y > ____655.____657 * 0.5) {
            result.y = pos.y - 45 + (height - 372)
        } else {
            result.y = pos.y + 45 - 372
        }
        if (result.y > ____655.____657 - height) {
            result.y = ____655.____657 - height
        } else if (result.y < height - 372) {
            result.y = height - 372
        }
        return result
    },
    hideFlashTip: function() {
        if (this.____1167 != null) {
            var tip = this.____1167;
            this.____1167 = null;
            tip.dispose()
        }
    },
    showFaceTip: function(pos, callback, executor) {
        this.hide();
        this.____1070 = new FaceTip(callback, executor);
        this.____1070.setPosition(pos);
        ____654.____676.____125(this.____1070, false)
    },
    hide: function() {
        if (this.____1070 != null) {
            ____654.____676.____127(this.____1070);
            this.____1070.dispose();
            this.____1070 = null
        }
    },
});
var ____2090 = cc.Class.extend({
    type: 0,
    ctor: function() {
        this.type = ____655.____659.triggerEventType.guide
    },
    handler: function(info) {
        if (info.action == ____655.____659.triggerEventType.newlyNpcTalk) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.guide_npcTalkView, ____654.____672, info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.newlyRiderTip) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.open_guideRiderPanel, ____654.____672, null))
        } else if (info.action == ____655.____659.triggerEventType.newlyGuideClick) {
            ____654.guideShow(info.params[0])
        }
    },
});
var ____2091 = cc.Class.extend({
    type: 0,
    ctor: function() {
        this.type = ____655.____659.triggerEventType.moduleEvent
    },
    handler: function(info, param) {
        if (info.action == ____655.____659.triggerEventType.enterCopy) {
            ____654.copyTester.enterCopy(info.params[0], info.params[1])
        } else if (info.action == ____655.____659.triggerEventType.____129) {
            ____654.____676.uiPanelContainer.close();
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_closeOtherPanel, ____654.____672));
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_hideChatPanel, ____654.____672))
        }
    },
});
var ____2092 = cc.Class.extend({
    type: 0,
    ctor: function() {
        this.type = ____655.____659.triggerEventType.popup
    },
    handler: function(info) {
        var num = 0;
        if (info.action == ____655.____659.triggerEventType.popupChatPanel) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_showChatPanel, ____654.____672, null))
        } else if (info.action == ____655.____659.triggerEventType.popupClubPanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_club, parseInt(info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.popupActivePanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.llTab, ____655.____659.panelTabType.active)
        } else if (info.action == ____655.____659.triggerEventType.popupWarPanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.warPlaceTab, ____655.____659.panelTabType.warPlace, parseInt(info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.popupShenjiangBossPanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.bossTab, ____655.____659.panelTabType.boss_shenJiang)
        } else if (info.action == ____655.____659.triggerEventType.popupShejiaoPanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_friend)
        } else if (info.action == ____655.____659.triggerEventType.popupLilianPanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.llTab, ____655.____659.panelTabType.ll)
        } else if (info.action == ____655.____659.triggerEventType.popupWuhunPanel) {
            if (this.checkLevel(____655.____659.levelType.wuhunLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponSoul)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupBaoshiPanel) {
            if (this.checkLevel(____655.____659.levelType.baoshiLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponStone)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupJinjiePanel) {} else if (info.action == ____655.____659.triggerEventType.popupQianghuaPanel) {
            if (this.checkLevel(____655.____659.levelType.strengthLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponStrength)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupShenbingPanel) {
            if (this.checkLevel(____655.____659.levelType.godLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponGod)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupWaiguanPanel) {
            if ((info.params[0] == null || info.params[0] == 0 || info.params[0] == 1) && !this.checkLevel(____655.____659.levelType.riderLevel)) {
                return
            } else if (info.params[0] == 2 && !this.checkLevel(____655.____659.levelType.petLevel)) {
                return
            } else if (info.params[0] == 3 && !this.checkLevel(____655.____659.levelType.wingLevel)) {
                return
            } else if (info.params[0] == 4 && !this.checkLevel(____655.____659.levelType.footLevel)) {
                return
            } else if (info.params[0] == 5 && !this.checkLevel(____655.____659.levelType.fabaoLevel)) {
                return
            } else if (info.params[0] == 6 && !this.checkLevel(____655.____659.levelType.zhenlingLevel)) {
                return
            } else if (info.params[0] == 7 && !this.checkLevel(____655.____659.levelType.shenjianLevel)) {
                return
            }
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, parseInt(info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.popupHunPoPanel) {
            if ((info.params[0] == null || info.params[0] == 0 || info.params[0] == 1) && !this.checkLevel(____655.____659.levelType.riderLevel)) {
                return
            } else if (info.params[0] == 2 && !this.checkLevel(____655.____659.levelType.petLevel)) {
                return
            } else if (info.params[0] == 3 && !this.checkLevel(____655.____659.levelType.wingLevel)) {
                return
            } else if (info.params[0] == 4 && !this.checkLevel(____655.____659.levelType.footLevel)) {
                return
            } else if (info.params[0] == 5 && !this.checkLevel(____655.____659.levelType.fabaoLevel)) {
                return
            } else if (info.params[0] == 6 && !this.checkLevel(____655.____659.levelType.zhenlingLevel)) {
                return
            } else if (info.params[0] == 7 && !this.checkLevel(____655.____659.levelType.shenjianLevel)) {
                return
            }
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.waiGuan_soul, parseInt(info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.popupHuanRiderPanel) {
            if (this.checkLevel(____655.____659.levelType.riderLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.huaXing_rider)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupHuanWingPanel) {
            if (this.checkLevel(____655.____659.levelType.wingLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.huaXing_wing)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupHuanPetPanel) {
            if (this.checkLevel(____655.____659.levelType.petLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.huaXing_pet)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupFashionPanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tabGroup1, ____655.____659.panelTabType.fashion)
        } else if (info.action == ____655.____659.triggerEventType.popupShopPanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tabGroup2, ____655.____659.panelTabType.shop)
        } else if (info.action == ____655.____659.triggerEventType.popupVipPanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.vipTab, ____655.____659.panelTabType.vip)
        } else if (info.action == ____655.____659.triggerEventType.popupCopyPanel) {
            if ((info.params[0] == null || info.params[0] == 0 || info.params[0] == 1) && !this.checkLevel(____655.____659.levelType.copyLevel)) {
                return
            } else if (info.params[0] == 2 && !this.checkLevel(____655.____659.levelType.waiguanCopyLevel)) {
                return
            } else if (info.params[0] == 3 && !this.checkLevel(____655.____659.levelType.cailiaoCopyLevel)) {
                return
            } else if (info.params[0] == 4 && !this.checkLevel(____655.____659.levelType.yaotaCopyLevel)) {
                return
            } else if (info.params[0] == 5 && !this.checkLevel(____655.____659.levelType.tongtianLevel)) {
                return
            } else if (info.params[0] == 6 && !this.checkLevel(____655.____659.levelType.shouhuLevel)) {
                return
            }
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy, parseInt(info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.popupRankPanel) {
            if (!this.checkLevel(____655.____659.levelType.rankLevel)) {
                return
            }
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab, ____655.____659.panelTabType.rank, parseInt(info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.popupWuShenMatchPanel) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.war_showWushenMatchPanel, ____654.____672, 0))
        } else if (info.action == ____655.____659.triggerEventType.popupXunBaoMatchPanel) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.war_showXunBaoMatchPanel, ____654.____672, 0))
        } else if (info.action == ____655.____659.triggerEventType.popupZhuoYaoMatchPanel) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.war_showZhuoYaoMatchPanel, ____654.____672, 0))
        } else if (info.action == ____655.____659.triggerEventType.popupTGHJMatchPanel) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.war_showTGHJMatchPanel, ____654.____672, null))
        } else if (info.action == ____655.____659.triggerEventType.popupTujianPanel) {
            if (this.checkLevel(____655.____659.levelType.tujianLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tuJianTab)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupHuanZhuangPanel) {
            if (this.checkLevel(____655.____659.levelType.tujianLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tuJianTab, ____655.____659.panelTabType.huanZhuang)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupTitlePanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tabGroup1, ____655.____659.panelTabType.title)
        } else if (info.action == ____655.____659.triggerEventType.popupOnlineAwardPanel) {
            if (____655.statInfo.onlineAward_time != -1) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.open_onlineAwardPanel, ____654.____672))
            }
        } else if (info.action == ____655.____659.triggerEventType.popupRongLuPanel) {
            if (this.checkLevel(____655.____659.levelType.ronglianLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup, ____655.____659.panelTabType.weaponPot)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupPersonBossPanel) {
            if (this.checkLevel(____655.____659.levelType.bossLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.bossTab, ____655.____659.panelTabType.boss_person)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupWorldBossPanel) {
            if (this.checkLevel(____655.____659.levelType.bossLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.bossTab, ____655.____659.panelTabType.boss_world)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupWelfarePanel) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.welfareTab, ____655.____659.panelTabType.welfare, parseInt(info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.popupPayPanel) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
        } else if (info.action == ____655.____659.triggerEventType.popupTGXSPanel) {
            if (____655.activityIconList.timingIcons[6] != null && ____655.activityIconList.timingIcons[6].timeType == 1 && ____655.activityIconList.timingIcons[6].endTime > ____655.____662.getZeroPassTime()) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.xuanshangTab)
            } else {
                ____654.tipsManager.quickTip.show("活动尚未开启")
            }
        } else if (info.action == ____655.____659.triggerEventType.popupXianYuanPanel) {
            if (this.checkLevel(____655.____659.levelType.marryLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_xianYuan)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupOathPanel) {
            if (this.checkLevel(____655.____659.levelType.jieYiLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_jieYi)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupLuckyTresurePanel) {
            if (____655.activityIconList.activityIcons[39] != null) {
                if (____655.activityIconList.activityIcons[39].isShow) {
                    var weeksDay = ____655.____662.getClientDate().getDay();
                    if (weeksDay == 0) {
                        weeksDay = 7
                    }
                    var type = 0;
                    if (weeksDay >= 1 && weeksDay <= 3) {
                        type = 1
                    } else if (weeksDay >= 4 && weeksDay <= 7) {
                        type = 2
                    }
                    ____654.____672.dispatchEvent(new ____590(____655.____661.open_luckyTreasurePanel, ____654.____672, type))
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2092.text1"))
                }
            }
        } else if (info.action == ____655.____659.triggerEventType.popupHomeLiandan) {
            if (this.checkLevel(____655.____659.levelType.homeLevel)) {
                ____654.____679.____155(____655.____659.____690.home, ____655.____659.panelTabType.homeLianDan)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupHome) {
            if (this.checkLevel(____655.____659.levelType.homeLevel)) {
                ____654.____679.____155(____655.____659.____690.home)
            }
        } else if (info.action == ____655.____659.triggerEventType.popupYaoJing) {
            var openDay = ____655.____662.getOpenDayByCurrentTime();
            if (openDay > 1 && this.checkLevel(____655.____659.levelType.dailyFirstRechargeLevel)) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tuJianTab, ____655.____659.panelTabType.tuJianYaoJing)
            }
        }
    },
    checkLevel: function(level) {
        if (____655.____667.level >= level) {
            return true
        } else {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2340.text1", level));
            return false
        }
    },
});
var TaskTriggerHandler = cc.Class.extend({
    type: 0,
    ctor: function() {
        this.type = ____655.____659.triggerEventType.task
    },
    handler: function(info, param) {
        if (info.action == ____655.____659.triggerEventType.taskAccept) {
            ____654.selfDataMessageSender.sendTaskAccept(parseInt(info.params[0]))
        }
    },
});
var ____539 = cc.Class.extend({
    type: 0,
    action: 0,
    group: 0,
    params: null,
    descript: "",
    ctor: function() {
        this.params = []
    },
    init: function(data) {
        this.type = data.readByte();
        this.action = data.readShort();
        this.group = data.readByte();
        this.descript = data.readString();
        this.params = [];
        for (var i = 0; i < 4; i++) {
            this.params.push(data.readInt())
        }
    },
    initWithString: function(str) {
        var list = str.split("$");
        if (list.length < 8) {
            throw new Error("____539 param error:" + str)
        }
        this.type = parseInt(list[0]);
        this.action = parseInt(list[1]);
        this.group = parseInt(list[2]);
        this.descript = list[3];
        this.params = [];
        this.params.push(list[4]);
        this.params.push(list[5]);
        this.params.push(list[6]);
        this.params.push(list[7])
    },
});
var ____2094 = cc.Class.extend({
    ____1214: null,
    ____1853: null,
    ____1852: 0,
    ____1854: -1,
    ctor: function() {
        this.____1214 = {};
        this.____1853 = [];
        var handler = null;
        handler = new ____2090();
        this.____1214[handler.type] = handler;
        handler = new ____2092();
        this.____1214[handler.type] = handler;
        handler = new ____2095();
        this.____1214[handler.type] = handler;
        handler = new ____2091();
        this.____1214[handler.type] = handler;
        handler = new TaskTriggerHandler();
        this.____1214[handler.type] = handler;
        ____654.____672.addEventListener(____655.____661.global_triggerNext, this.triggerNextHandler, this)
    },
    setWaitingActionType: function(type) {
        this.____1854 = type
    },
    triggerNextHandler: function(evt) {
        if (evt.data != this.____1854) return;
        this.____1854 = -1;
        this.____1852 = this.____1852 + 1;
        this.doHandlerList(this.____1852)
    },
    doHandlerList: function(index) {
        var list = this.____1853[index];
        if (list != null) {
            var len = list.length;
            for (var i = len - 1; i >= 0; i--) {
                if (list[i] != null) {
                    this.handler(list[i])
                }
            }
        }
        if (index >= this.____1853.length) {
            this.____1853 = [];
            this.____1852 = 0;
            this.____1854 = -1
        }
    },
    handler: function(info) {
        if (info.action == ____655.____659.triggerEventType.waitToNext) {
            this.setWaitingActionType(info.action);
            return
        }
        var trigger = this.____1214[info.type];
        if (trigger != null) {
            trigger.handler(info)
        }
    },
    handlerList: function(list) {
        var t = [];
        var len = list.length;
        for (var i = 0; i < len; i++) {
            var info = list[i];
            var group = info.group;
            if (t[group] == null) {
                t[group] = []
            }
            if (info.action == ____655.____659.triggerEventType.waitToNext) {
                t[group].splice(0, 1, info)
            } else {
                t[group].push(info)
            }
        }
        this.____1853 = t;
        this.____1852 = 0;
        this.doHandlerList(this.____1852)
    },
});
var ____2095 = cc.Class.extend({
    type: 0,
    ctor: function() {
        this.type = ____655.____659.triggerEventType.walk
    },
    handler: function(info, param) {
        if (info.action == ____655.____659.triggerEventType.walkToNpc) {
            if (____655.copyInfo.currentId > 0) {
                var triggerInfo = new ____539();
                triggerInfo.type = ____655.____659.triggerEventType.walk;
                triggerInfo.action = ____655.____659.triggerEventType.walkToNpc;
                triggerInfo.params = info.params;
                ____655.____667.outCopyTrigger = triggerInfo
            } else {
                ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkToNpc, ____654.____672, info.params[0]))
            }
        } else if (info.action == ____655.____659.triggerEventType.walkToMonster) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkToMonster, ____654.____672, info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.walkToCollect) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkToCollect, ____654.____672, info.params[0]))
        } else if (info.action == ____655.____659.triggerEventType.walkToPoint) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkToPoint, ____654.____672, [info.params[0], info.params[1], info.params[2]]));
            ____654.____676.uiPanelContainer.close()
        }
    },
});
var Yuyanbao = cc.Class.extend({
    list: null,
    weekList: null,
    ctor: function() {
        ____655.____659.nameType.xianweiList = ["无仙位", "散仙", "游仙", "上仙", "星君", "灵君", "真君", "大帝", "圣祖", "天尊"];
        ____655.____659.nameType.weekList = ["星期一", "星期二", "星期三", "星期四", "星期五", "星期六", "星期天"];
        ____655.____659.nameType.numberList = ["", "一", "二", "三", "四", "五", "六", "七", "八", "九", "十"];
        ____655.____659.nameType.advanceName = ["坐骑", "仙宠", "飞羽", "足迹", "法宝", "阵灵", "神剑"];
        ____655.____659.nameType.careerName = ["逍遥", "玄女"];
        ____655.____659.nameType.baoshiName = ["", "攻击宝石", "暴击宝石", "命中宝石", "防御宝石", "闪避宝石", "坚韧宝石"];
        ____655.____659.nameType.compareNameList = [
            ["外观", "坐骑", "仙宠", "飞羽", "足迹", "法宝", "阵灵", "神剑"],
            ["魂魄", "坐骑", "仙宠", "飞羽", "足迹", "法宝", "阵灵", "神剑"],
            ["幻装", "幻骑", "幻宠", "幻羽", "时装"],
            ["神兵", "神兵", "强化", "宝石", "武魂", "熔炼"],
            ["图鉴", "图鉴", "幻装"],
            ["其他", "VIP", "历练", "心法"]
        ];
        this.list = {
            "start.loginTips1": "请输入账号",
            "start.loginTips2": "请输入昵称",
            "start.loginTips3": "角色名称长度为2-5个字",
            "start.loginTips4": "抵制不良游戏，拒绝盗版游戏。注意自我保护，谨防受骗上当。适度游戏益脑，沉迷游戏伤身。合理安排时间，享受健康生活。",
            "start.loginTips5": "角色删除后不可再寻回，请谨慎操作！\n请输入\"{0}\"文字：",
            "start.loginTips6": "删除",
            "start.loginTips7": "请输入\"{0}\"文字",
            "start.loginTips8": "名称含有非法字符",
            "start.loginTips9": "版本号：{0}",
            "alert.btnTips1": "是",
            "alert.btnTips2": "否",
            "alert.btnTips3": "确定",
            "alert.btnTips4": "取消",
            "alert.btnTips5": "退出 {0}",
            "alert.btnTips6": "确定 {0}",
            "alert.btnTips7": "领取 {0}",
            "alert.btnTips8": "单人挑战",
            "alert.btnTips9": "组队挑战",
            "alert.btnTips10": "再打一次 {0}",
            "alert.btnTips11": "前往历练",
            "alert.btnTips12": "特惠商店",
            "alert.btnTips13": "前往",
            "alert.btnTips14": "放弃",
            "common.timeTips1": "{0}天",
            "common.timeTips2": "{0}分{1}秒",
            "common.timeTips3": "{0}秒",
            "common.timeTips4": "{0}小时",
            "common.timeTips5": "{0}分钟",
            "common.gridTips1": "{0}万",
            "common.inputDefalut": "请输入内容",
            "common.propertyName1": "攻击",
            "common.propertyName2": "防御",
            "common.propertyName3": "PVE伤害",
            "common.propertyName4": "PVP伤害",
            "common.propertyName5": "经验加成",
            "common.propertyName6": "生命恢复",
            "common.propertyName7": "移动速度",
            "common.propertyName8": "生命",
            "common.propertyName9": "暴击",
            "common.propertyName10": "坚韧",
            "common.propertyName11": "命中",
            "common.propertyName12": "闪避",
            "common.propertyName19": "移动速度",
            "common.propertyName20": "生命上限",
            "common.propertyName25": "伤害加成",
            "common.propertyName26": "伤害减免",
            "common.propertyName27": "伤害",
            "common.propertyName28": "绝对防御",
            "common.personEquipName1": "武器",
            "common.personEquipName2": "戒指",
            "common.personEquipName3": "项链",
            "common.personEquipName4": "护符",
            "common.personEquipName5": "衣服",
            "common.personEquipName6": "护手",
            "common.personEquipName7": "护腿",
            "common.personEquipName8": "鞋子",
            "common.tabGroupTips1": "{0}级开启",
            "common.fightTip": "战力：{0}",
            "common.fightTip2": "战力：",
            "common.tips1": "无",
            "worldmap.text1": "达到{0}级可进入该地图。",
            "uiPanel.typeTitle1": "背包",
            "uiPanel.typeTitle2": "属性",
            "uiPanel.typeTitle3": "时装",
            "uiPanel.typeTitle4": "称号",
            "uiPanel.typeTitle5": "变强",
            "uiPanel.typeTitle6": "商城",
            "uiPanel.typeTitle7": "邮件",
            "uiPanel.typeTitle8": "神兵",
            "uiPanel.typeTitle10": "强化",
            "uiPanel.typeTitle11": "宝石",
            "uiPanel.typeTitle12": "武魂",
            "uiPanel.typeTitle13": "熔炉",
            "uiPanel.typeTitle14": "副本",
            "uiPanel.typeTitle15": "世界",
            "uiPanel.typeTitle16": "个人",
            "uiPanel.typeTitle17": "图鉴",
            "uiPanel.typeTitle18": "跨服",
            "uiPanel.typeTitle19": "外观",
            "uiPanel.typeTitle20": "魂魄",
            "uiPanel.typeTitle21": "幻骑",
            "uiPanel.typeTitle22": "幻宠",
            "uiPanel.typeTitle23": "幻羽",
            "uiPanel.typeTitle25": "家族",
            "uiPanel.typeTitle26": "仙缘",
            "uiPanel.typeTitle27": "结义",
            "uiPanel.typeTitle28": "好友",
            "uiPanel.typeTitle29": "历练",
            "uiPanel.typeTitle30": "活动",
            "uiPanel.typeTitle31": "专属福利",
            "uiPanel.typeTitle32": "战场",
            "uiPanel.typeTitle33": "排行榜",
            "uiPanel.typeTitle34": "VIP特权",
            "uiPanel.typeTitle35": "人物",
            "uiPanel.typeTitle36": "外观",
            "uiPanel.typeTitle37": "魂魄",
            "uiPanel.typeTitle38": "幻装",
            "uiPanel.typeTitle39": "对比",
            "uiPanel.typeTitle40": "冲榜活动",
            "uiPanel.typeTitle41": "飞仙成尊",
            "uiPanel.typeTitle42": "图鉴",
            "uiPanel.typeTitle43": "幻装",
            "uiPanel.typeTitle44": "登录有礼",
            "uiPanel.typeTitle45": "齐天大圣",
            "uiPanel.typeTitle46": "仙侣",
            "uiPanel.typeTitle47": "天宫悬赏",
            "uiPanel.typeTitle48": "妖精",
            "mail.panelTips1": "剩余时间：{0}天",
            "mail.panelTips2": "剩余时间：少于1天",
            "mail.btnLabel1": "领  取",
            "mail.btnLabel2": "删  除",
            "itemTip.btnLabel1": "装备",
            "itemTip.btnLabel2": "卸下",
            "itemTip.btnLabel3": "熔炼",
            "itemTip.btnLabel4": "出售",
            "itemTip.btnLabel5": "丢弃",
            "itemTip.btnLabel6": "洗炼",
            "itemTip.btnLabel7": "使用",
            "itemTip.btnLabel8": "强化",
            "itemTip.categoryType1": "未知",
            "itemTip.categoryType2": "人物装备",
            "itemTip.categoryType3": "坐骑装备",
            "itemTip.categoryType4": "仙宠装备",
            "itemTip.categoryType5": "飞羽装备",
            "itemTip.categoryType6": "足迹装备",
            "itemTip.categoryType7": "法宝装备",
            "itemTip.categoryType8": "阵灵装备",
            "itemTip.categoryType9": "神剑装备",
            "itemTip.categoryType10": "物品",
            "itemTip.categoryType11": "材料",
            "itemTip.showTip1": "该物品不可丢弃",
            "itemTip.showTip2": "是否确定{0}稀有道具{1}",
            "chatPanel.sendTip1": "输入内容为空",
            "chatPanel.sendTip2": "输入内容含有非法字符",
            "chatPanel.sendTip3": "[0xff0000]发言需要达到{0}级,请加油升级[-]",
            "chatPanel.sendTip4": "[0xff0000]请先加入家族[-]",
            "chatPanel.sendTip5": "[0xff0000]发言间隔为{0}秒,请休息一下[-]",
            "equipTabButton.tipText": "未装备{0}",
            "____2199.text1": "时间：{0}-{1}",
            "____2235.text2": "参与活动可获得时装饰件",
            "____2235.text3": "激活",
            "____2235.text4": "升星",
            "____2235.text5": "已满星",
            "____2340.text1": "{0}级开放",
            "____2338.text1": "1、熔炼掉比穿戴中更低阶“外观”和“人物”装备",
            "____2338.text2": "2、更高阶“外观”装备会各保留1件，其余被熔炼掉",
            "____2338.text3": "可直接熔炼装备：{0}",
            "____2338.text4": "同品质人物装备：{0}",
            "____2338.text5": "本次熔炼装备将增加{0}点熔炼值\n[0xFFFFFF] [-]\n可直接熔炼装备：{1}件\n同品质人物装备：{2}件",
            "____2338.text6": "没有可熔炼装备",
            "____2338.text7": "熔炼装备成功",
            "bagPanel.text1": "物品",
            "bagPanel.text2": "材料",
            "bagPanel.text3": "装备",
            "bagPanel.text4": "暂时未获得任何{0}",
            "____2182.text1": "次数:{0}",
            "____2182.text2": "({0}恢复1次)",
            "____2182.text3": "仙位达到{0}可挑战",
            "____2182.text4": "成功通过{0}波",
            "____2182.text5": "今日主掉落：{0}",
            "____2182.text6": "{0}星奖励",
            "____2182.text7": "仙位达到{0}可挑战",
            "____2182.text8": "今日剩余挑战：{0}次",
            "____2182.text9": "第{0}层",
            "____2182.text10": "第{0}层奖励",
            "____2182.text11": "{0}层{1}波",
            "____2182.text12": "第{0}关",
            "____2182.text13": "挑战第{0}关",
            "____2182.text14": "第{0}波",
            "____2182.text15": "确认花费{0}钻石进行扫荡？",
            "____2182.text16": "今日剩余重置：{0}次",
            "____2182.text17": "确认花费{0}钻石进行挑战？",
            "____2107.text1": "当前场景不能传送",
            "____2107.text2": "等级不足",
            "____2107.text3": "仙位未达到{0}",
            "____2107.text4": "所需物品不足",
            "____2107.text5": "副本次数不足",
            "____2107.text6": "请{0}秒后再次进入",
            "____2107.text7": "邀请成功",
            "____2107.text8": "对方不是你的好友或家族成员",
            "____2107.text9": "该好友已下线",
            "____2107.text10": "该好友在副本中",
            "____2107.text11": "该好友已被邀请",
            "____2107.text12": "对方副本次数不够",
            "____2107.text13": "队伍已经解散",
            "____2107.text14": "队伍人数已满",
            "____2107.text15": "[0x00ff00]{0}[-]邀请你一起参加{1}，是否与TA并肩作战？",
            "____2107.text16": "关闭界面将会退出队伍，是否关闭？",
            "____2107.text17": "是否确定将[0x00ff00]{0}[-]踢出队伍？",
            "____2107.text18": "组队请求被对方拒绝",
            "____2107.text19": "恭喜你达到了{0}分，将自动进入下一层",
            "____2336.text1": "金箍棒达到蓝5星自动激活",
            "____2336.text2": "火云刀达到蓝5星自动激活",
            "____2336.text3": "充   值",
            "____2336.text4": "升   星",
            "____2336.text5": "满   星",
            "____2336.text6": "神兵升星成功",
            "____2336.text7": "升星所需神铁不足",
            "____2336.text8": "该神兵已经满级",
            "____2336.text9": "该神兵未激活，不能升星",
            "____2336.text10": "成功卸下神兵",
            "____2336.text11": "成功装上神兵",
            "____2336.text12": "该神兵未激活",
            "____2105.text1": "{0}神兵激活成功",
            "____2105.godType1": "金箍棒",
            "____2105.godType2": "火云刀",
            "____2105.godType3": "开天斧",
            "____2243.text1": "个性",
            "____2243.text2": "活动",
            "____2243.text3": "成长",
            "____2243.text4": "仙位",
            "____2243.text5": "探索",
            "____2134.text1": "接受任务",
            "____2134.text2": "提交任务",
            "____2134.text3": "{0}秒后关闭",
            "____2088.text1": "请先添加对方为好友",
            "____2088.text2": "对方未达到{0}级",
            "____2088.text3": "不能删除仙侣",
            "____2242.text1": "佩戴",
            "____2242.text2": "卸下",
            "____2242.text3": "有效期：永久",
            "____2242.text4": "天",
            "____2278.text1": "(已完成)",
            "____2278.text2": "({0}级)",
            "____2278.text3": "(可领取)",
            "____2278.typeName1": "[主]",
            "____2278.typeName2": "[支]",
            "____2278.typeName3": "[环]",
            "____2278.typeName4": "[族]",
            "____2278.typeName5": "[引]",
            "____2272.text1": "¥ {0}",
            "____561.text1": "暂无好友",
            "____561.text2": "添加家族好友一起战斗吧！",
            "____561.text3": "好友数量已达上限",
            "____561.text4": "好友数：",
            "____561.text5": "推荐好友",
            "____2196.text1": "注：每天有1次添加推荐好友机会",
            "____2196.text2": "请勾选一个推荐好友",
            "____2196.text3": "一键添加",
            "____2261.text1": "以下玩家邀请你添加好友",
            "____2261.text2": "全部拒绝",
            "____2261.text3": "全部同意",
            "____2260.text1": "拒绝",
            "____2260.text2": "同意",
            "____2192.text1": "发送",
            "scene.nameWord1": "[族]",
            "scene.nameWord2": "❤%s的仙侣❤",
            "scene.nameWord3": "[义]",
            "____2088.tips1": "确定要删除好友[0xEA6E00]{0}[-]吗?",
            "shop.title1": "钻石",
            "shop.title2": "绑钻",
            "shop.title3": "荣誉",
            "shopItemView.text1": "{0}不足",
            "shopItemView.text2": "该物品已售罄",
            "ActiveCodeMessageHandler.text1": "领取奖励成功",
            "ActiveCodeMessageHandler.text2": "激活码不存在",
            "ActiveCodeMessageHandler.text3": "激活码已经领取过",
            "ActiveCodeMessageHandler.text5": "你已经领取过该奖励",
            "money.name1": "钻石",
            "money.name2": "绑钻",
            "money.name3": "铜币",
            "money.name4": "贡献",
            "money.name5": "荣誉",
            "money.name6": "声望",
            "____2201.text1": "{0}活跃度奖励{1}",
            "statMessageSender.tip1": "购买成功！",
            "moneyInfo.tips1": "钻石不足",
            "moneyInfo.tips2": "绑钻不足",
            "moneyInfo.tips3": "铜币不足",
            "moneyInfo.tips4": "帮贡不足",
            "moneyInfo.tips5": "荣誉不足",
            "moneyInfo.tips6": "声望不足",
            "moneyInfo.canBindGold": "\n[0x00FF00]温馨提示：优先扣除绑定钻石[-]",
            "____2131.tips1": "未激活",
            "____2257.text1": "立即参与",
            "____2257.text2": "战场说明",
            "____2257.text3": "每天21:00开启家族战",
            "____2257.text4": "虚位以待",
            "____2257.text5": "家族",
            "____2257.text6": "人数",
            "____2257.text7": "实力",
            "____2257.text8": "总积分",
            "____2257.text9": "族长：",
            "____2257.text10": "报名参战",
            "____2257.text11": "您还未加入家族",
            "____2257.text12": "家族尚未报名",
            "____2257.text13": "尚未有排名信息",
            "____2257.text14": "尚未上榜",
            "VipItemView.text1": "获得铜币增加",
            "VipItemView.text2": "获得经验增加",
            "VipItemView.text3": "获得荣誉增加",
            "VipItemView.text4": "人物生命提升",
            "VipItemView.text5": "人物防御提升",
            "VipItemView.text6": "人物攻击提升",
            "VipItemView.text7": "仙宠攻击提升",
            "____2345.text1": "亲爱的仙尊，请在下方输入您获取到的礼包兑换码，并点击“领取礼包”",
            "____2345.text2": "即可获得相应的礼品哦~礼品直接到背包，请注意查收。",
            "____2345.text3": "礼品兑换码",
            "____2345.text4": "领取礼包",
            "welfareResGetBackView.tips1": "月度好礼剩余{0}天",
            "welfareResGetBackView.btn1": "已领取",
            "welfareResGetBackView.btn2": "领取",
            "____2351.tip1": "周一至周六全部领完才能领取周日大礼",
            "____2351.tip2": "补签",
            "____2351.tip3": "不可领取",
            "____2351.tip4": "确定支付[0x009800]{0}钻石[-]补签领取奖励吗？",
            "____2350.text1": "温馨提示：只能选择其中一种方式找回资源",
            "____2353.text1": "仙位达到{0}才能找回",
            "____2353.text2": "确定支付[0x009800]{0}钻石[-]领取资源吗？",
            "____2353.text3": "确定支付[0x009800]{0}铜币[-]领取资源吗？",
            "____2353.text4": "经验：",
            "____2353.text5": "找回",
            "WelfareZhuanShuGiftItemView.text1": "剩余时间：",
            "WelfareZhuanShuGiftItemView.text2": "送{0}",
            "____2352.text1": "限购",
            "____2349.text1": "专属礼包",
            "____2349.text2": "特惠限购",
            "____2349.text3": "至尊好礼",
            "____2349.text4": "每周签到",
            "____2349.text5": "资源找回",
            "____2349.text6": "礼包兑换",
            "____2349.text7": "更新公告",
            "____2349.text8": "中秋集福",
            "____2202.text1": "确认花费{0}钻石完成全部任务？",
            "DoushenDianPanel.text1": "{0}(可钻石挑战)",
            "DoushendianItem.text1": "战:",
            "ReturnGiftPanel.text1": "领取奖励",
            "ReturnGiftPanel.text2": "充值领奖",
            "AdvanceEquipTip.text1": "（{0}阶{1}星可用）",
            "AdvanceEquipTip.text2": "请先提升{0}品阶",
            "AdvanceEquipTip.text3": "装备品阶较低，只能熔炼掉!",
            "AdvanceEquipTip.text4": "（可使用）",
            "AdvanceEquipGrid.text1": "可装备",
            "AdvanceEquipGrid.text2": "新装备",
            "AdvanceEquipGrid.text3": "在线奖励已领完",
            "____2203.text1": "历练值不足",
            "____2203.text2": "历练已满级",
            "TuJianPanel.text1": "全{0}星激活下条属性",
            "TuJianPanel.text2": "图鉴总星数奖励（{0}）",
            "TuJianPanel.text3": "※图鉴升星增加基础属性，全部达到指定星级激活星级属性",
            "TuJianPanel.text4": "基础属性",
            "TuJianPanel.text5": "星级属性",
            "TuJianPanel.text6": "总星数",
            "TuJianItemView.text1": "升 星",
            "HuanZhuangItemView.text1": "敬请期待",
            "HuanZhuangItemView.text2": "未获得",
            "HuanZhuangPanel.text1": "获得{0}个形象激活新属性",
            "HuanZhuangPanel.text2": "幻装总收录奖励（{0}）",
            "HuanZhuangPanel.text3": "※收录幻骑、幻宠、幻羽、时装可以激活幻化属性",
            "HuanZhuangPanel.text4": "幻化属性",
            "HuanZhuangPanel.text5": "收录数",
            "HuanZhuangPanel.text6": "可领取",
            "____2274.text1": "修仙之路副本挑战满次数通知",
            "____2274.text2": "个人BOSS全部可免费挑战通知",
            "____2274.text3": "仙园农作物可摘取通知",
            "____2274.text4": "家族大战赛事开启通知（每天21:00-21:15开启）",
            "____2274.text5": "全民系列精彩活动通知（每天10:30-12:00开启）",
            "____2274.text6": "天宫系列精彩活动通知（每天14:30-16:00开启）",
            "____2274.text7": "音乐音效",
            "____2274.text8": "附近玩家",
            "____2326.text1": "是否花费[0x009800]{0}钻石[-]补足材料直接{1}？",
            "____2326.text2": "进阶",
            "____2326.text3": "飞升",
            "____2326.text4": "使用成功",
            "____2326.text5": "钻石补足材料直接飞升",
            "____2326.text6": "钻石补足材料直接进阶",
            "____2326.text7": "骑乘中",
            "____2326.text8": "出战中",
            "____2326.text9": "使用中",
            "____2326.text10": "骑乘",
            "____2326.text11": "出战",
            "____2326.text12": "更高阶数敬请期待",
            "DanFlashTip.text1": "说明：{0}品阶高可用更多{1}",
            "DanFlashTip.text2": "说明：提升{0}品阶可继续使用{1}",
            "WeaponXiLianPanel.text1": "（{0}星）",
            "WeaponXiLianPanel.text2": "空",
            "WeaponXiLianPanel.text3": "原：{0}",
            "WeaponXiLianPanel.text4": "新：{0}",
            "WeaponXiLianPanel.text5": "洗炼获得新属性",
            "WeaponXiLianPanel.text6": "洗炼成功，新属性生效",
            "WeaponXiLianPanel.text7": "恢复成功，原属性不变",
            "WeaponXiLianPanel.text8": "确定支付10钻石恢复装备的原洗炼属性吗？",
            "____2162.text1": "※亲爱的友友，请加入家族与小伙伴一起战斗吧！",
            "____2162.text2": "自动加入",
            "____2162.text3": "创建家族",
            "____2162.text4": "申 请",
            "____2162.text5": "已满人",
            "____2162.text6": "已申请",
            "____2162.text7": "今日已达申请上限!",
            "____2159.text1": "你确定支付",
            "____2159.text2": "创建家族吗?",
            "____2159.text3": "请输入家族名称",
            "____2159.text4": "确 定",
            "____2159.text5": "取 消",
            "____2159.text6": "最多五个字",
            "____2159.text7": "您是尊贵的VIP用户,创建家族免费!",
            "____2159.text8": "{0}钻石",
            "____2159.text9": "名字不能为空!",
            "____2159.text10": "名字不能超过5个字!",
            "____2159.text11": "名字不能少于2个字!",
            "____2160.text1": "家族说明",
            "____2160.text2": "信息",
            "____2160.text3": "成员",
            "____2160.text4": "心法",
            "____2160.text5": "降妖",
            "____2160.text6": "伏魔",
            "____2160.text7": "神树",
            "____2178.text1": "攻击：",
            "____2178.text2": "防御：",
            "____2178.text3": "暴击：",
            "____2178.text4": "坚韧：",
            "____2178.text5": "命中：",
            "____2178.text6": "闪避：",
            "____2178.text7": "消耗贡献：",
            "____2178.text8": "修 炼",
            "____2178.text9": "家族贡献值不足!",
            "____2178.text10": "拥有贡献：",
            "____2176.text1": "申请信息",
            "____2176.text2": "全部拒绝",
            "____2176.text3": "全部同意",
            "____2176.text4": "名称",
            "____2176.text5": "等级",
            "____2176.text6": "战力",
            "____2176.text7": "操作",
            "____2174.text1": "不可自动加入",
            "____2174.text2": "65级自动加入",
            "____2174.text3": "VIP自动加入",
            "____2174.text6": "在线",
            "____2174.text7": "{0}天前",
            "____2174.text8": "离线",
            "____2174.text9": "玩家查看功能暂未开放!",
            "____2172.text1": "家族 :",
            "____2172.text2": "成员 :",
            "____2172.text3": "实力 :",
            "____2172.text4": "族长 :",
            "____2172.text5": "维护 :",
            "____2172.text6": "财富 :",
            "____2172.text7": "公告 :",
            "____2172.text8": "保存",
            "____2172.text9": "捐献钻石 :",
            "____2172.text10": "捐献次数 :",
            "____2172.text11": "获得贡献 :",
            "____2172.text12": "获得贡献 :",
            "____2172.text13": "增加财富 :",
            "____2172.text14": "{0}万",
            "____2172.text15": "欢迎各位新朋友加入本家族（点击文字可更改）",
            "____2172.text16": "温馨提示：家族财富值低于-10000时家族自动解散",
            "____2172.text17": "（家族{0}次）",
            "____2172.text18": "{0}财富/天",
            "____2172.text19": "不限",
            "____2172.text20": "{0}次",
            "____2172.text21": "（VIP{0}可捐献）",
            "____2172.text22": "没有达到VIP{0}!",
            "____2172.text23": "已达今日最高捐献次数!",
            "____2172.text24": "内容不能为空!",
            "____2172.text25": "65级及以上的玩家退出家族后，[0x009700]24小时后[-]才可以加入新家族，你确定要退出吗？\n[0x009700]注：退出家族，心法和贡献值会保留[-]",
            "____2172.text26": "（VIP3及以上族长和副族长可更改公告）",
            "____2172.text27": "公告内容包含非法字符",
            "____2172.text28": "保存成功!",
            "____2172.text29": "你确定要退出吗？\n[0x009700]注：退出家族，心法和贡献值会保留[-]",
            "____2172.text30": "退出",
            "____2171.text1": "※可以用仙露给神树浇水增加其成长值",
            "____2171.text2": "※神树达到相应成长值时可以领取奖励",
            "____2171.text3": "神树当前成长值：{0}%（每天0点重置）",
            "____2171.text4": "{0}个",
            "____2171.text5": "可领取",
            "____2171.text6": "神树{0}%成长奖励!",
            "____2171.text7": "拥有仙露数量不足!",
            "____2171.text8": "神树满成长无需浇水!",
            "____2170.text1": "挑 战: ",
            "____2170.text2": "重 置",
            "____2170.text3": "降妖·普通",
            "____2170.text4": "降妖·精英",
            "____2170.text5": "降妖·地狱",
            "____2170.text6": "降妖·传说",
            "____2170.text7": "降妖·史诗",
            "____2170.text8": "挑战次数 : {0}",
            "____2170.text9": "降妖通关奖励",
            "____2170.text10": "说明: 通关后奖励发放到个人邮箱",
            "____2170.text11": "重置降妖",
            "____2170.text12": "今日剩余重置机会：{0}次",
            "____2166.text1": "※族长或长老可以开启挑战（家族创建满24小时）",
            "____2166.text2": "※每战胜一个BOSS参与者获得一份奖励",
            "____2166.text3": "开 启",
            "____2166.text4": "排名奖励",
            "____2166.text5": "挑 战",
            "____2166.text6": "已结束",
            "____2166.text7": "家族财富不足!",
            "____2166.text8": "开启伏魔活动全体一起挑战牛魔王,每战胜一个BOSS获得一份奖励,活动只有[0x009700]15分钟[-]挑战时间.\n[0x009700]注:开启活动需要消耗2000家族财富.[-]",
            "____2166.text9": "族长或者长老可开启!",
            "ClubInfo.text1": "族长",
            "ClubInfo.text2": "长老",
            "ClubInfo.text3": "成员",
            "ClubInfo.text4": "家族财富不够!",
            "ClubInfo.text5": "有玩家正在副本中!",
            "ClubInfo.text6": "重置成功!",
            "ClubInfo.text7": "家族创建成功!",
            "ClubInfo.text8": "家族创建失败",
            "ClubInfo.text9": "获得[0xfffc1f]2000财富[-]",
            "ClubInfo.text10": "获得[0xfffc1f]100财富[-]",
            "ClubInfo.text11": "家族伏魔活动已开启,活动只有[0x009700]15分钟[-]挑战时间,请及时进入活动地图?",
            "ClubInfo.text12": "申请超过5个",
            "ClubInfo.text13": "24小时内无法加入家族",
            "ClubInfo.text14": "{0}加入成功",
            "ClubInfo.text15": "家族名已存在!",
            "ClubInfo.text16": "创建家族24小时后开启!",
            "ClubInfo.text17": "家族名存在非法字符!",
            "ClubInfo.text18": "玩家已加入其他家族!",
            "ClubInfo.text19": "同意玩家加入家族",
            "ClubInfo.text20": "没有可加入的家族",
            "____2156.text1": "BOSS说明",
            "____2156.text2": "{0}刷新",
            "____2156.text3": "次日{0}刷新",
            "____2156.text4": "已刷新",
            "____2156.text5": "剩余刷新：",
            "____2156.text6": "挑战",
            "____2156.text7": "难度：",
            "____2156.text8": "推荐：",
            "____2156.text9": "{0}万战力",
            "____2156.text10": "确认支付[0x009700]{0}[-]钻石进行刷新?",
            "____2156.text11": "今日剩余付费挑战：",
            "____2156.text12": "仙位要求：",
            "____2156.text13": "免费挑战：",
            "____2156.text14": "付费挑战：",
            "____2156.text15": "免费挑战",
            "____2156.text16": "是否花费[0x009700]{0}[-]钻石直接挑战BOSS?",
            "____2156.text17": "前5名奖装备宝箱",
            "____2156.text18": "BOSS下次刷新",
            "OpenPanel.text1": "活动剩余时间：",
            "OpenPanel.text2": "邮件发奖",
            "OpenPanel.text3": "第{0}名",
            "OpenPanel.text4": "第{0}-{1}名",
            "OpenPanel.text5": "(第一阶段)",
            "OpenPanel.text6": "(第二阶段)",
            "OpenPanel.text7": "原价：",
            "OpenPanel.text8": "特价：",
            "OpenPanel.text9": "购 买",
            "OpenPanel.text10": "可购数量：{0}",
            "OpenPanel.text11": "请输入购买数量!",
            "OpenPanel.text12": "{0}阶{1}星",
            "OpenLeiChongPanel.text1": "金箍棒",
            "OpenLeiChongPanel.text2": "赤血丹心",
            "OpenLeiChongPanel.text3": "齐天大圣",
            "OpenLeiChongPanel.text4": "再充值",
            "OpenLeiChongPanel.text5": "即可获得",
            "OpenLeiChongPanel.text6": "活动剩余时间",
            "OpenLeiChongPanel.text7": "累充{0}",
            "OpenLeiChongPanel.text8": "金箍棒(神兵)",
            "OpenLeiChongPanel.text9": "赤血丹心(时装)",
            "OpenLeiChongPanel.text10": "齐天大圣(幻宠)",
            "LoginGiftPanel.text1": "第{0}天",
            "LoginGiftPanel.text2": "你确定支付[0x009700]20钻石[-]补领登录奖励吗?",
            "XianWeiUpLevelPanel.text1": "恭喜你获得参与更高难度PVE挑战和PVP对抗活动资格",
            "XianWeiUpLevelPanel.text2": "恭喜你完成了所有的环任务",
            "XianWeiUpLevelPanel.text3": "恭喜你完成了所有的家族任务",
            "WelcomePanel.text1": "亲爱的仙友，小仙为你准备了一份",
            "WelcomePanel.text2": "小礼，收下它开始你的修仙之旅吧！",
            "WelcomePanel.text3": "收下礼物 {0}",
            "____2252.text1": "伤害排名越高奖励越好",
            "____2252.text2": "下个BOSS10秒后刷新",
            "____2252.text3": "BOSS即将刷新:",
            "AwardZhanChangPanel.text1": "关 闭",
            "AwardZhanChangPanel.text2": "斗神坛奖励",
            "AwardZhanChangPanel.text3": "武神争霸奖励",
            "AwardZhanChangPanel.text4": "家族战奖励",
            "AwardZhanChangPanel.text5": "领 取",
            "AwardZhanChangPanel.text6": "前 往",
            "AwardZhanChangPanel.text7": "前往",
            "AwardZhanChangPanel.text8": "领取",
            "FeiXianPanel.text1": "初入仙途",
            "FeiXianPanel.text2": "渐入佳境",
            "FeiXianPanel.text3": "锋芒初露",
            "FeiXianPanel.text4": "大显神通",
            "FeiXianPanel.text5": "登峰造极",
            "FeiXianPanel.text6": "出神入化",
            "FeiXianPanel.text7": "飞仙成尊",
            "FeiXianPanel.text8": "第{0}天开放!",
            "FeiXianPanel.text9": "活动结束后邮件发放奖励",
            "FeiXianPanel.text10": "第{0}天总奖励",
            "FeiXianPanel.text11": "（完成上面{0}个目标可领取）",
            "____2259.text1": "斗神坛",
            "____2259.text2": "家族战",
            "____2259.text3": "大乱斗",
            "____2259.text4": "武神争霸",
            "____2256.text1": "不能挑战自己",
            "____2256.text2": "当前挑战次数不够，您可以支付[0x009700]{0}钻石[-]立即挑战",
            "____2256.text3": "是否挑战{0}?其战力",
            "____2256.text4": "达到前{0}名才可挑战",
            "____2256.text5": "换一批",
            "DaluandouPanel.text1": "每天19:00开启大乱斗",
            "DaluandouPanel.text2": "大乱斗奖励（{0}）",
            "WushenzhengbaPanel.text1": "每天19:30开启武神争霸",
            "WushenzhengbaPanel.text2": "已达今日进入最高次数!",
            "FlashTip.text1": "{0}阶{1}星{2}自动激活该技能",
            "FlashTip.text2": "角色升到{0}自动激活该技能",
            "FlashTip.text3": "{0}阶{1}星{2}技能自动提升到Lv{3}",
            "FlashTip.text4": "角色升到{0}级技能自动提升到Lv{1}",
            "FlashTip.text5": "该技能已满级",
            "PlayerNoticeManager.text1": "恭喜{0}成功将{1}进阶到{2}，战力又大大提升了！",
            "PlayerNoticeManager.text2": "{0}阶{1}星",
            "PlayerNoticeManager.text3": "[{0}]已经连续战胜{1}人，无可匹敌！",
            "PlayerNoticeManager.text4": "[{0}]已经连续战胜{1}人，所向披靡！",
            "PlayerNoticeManager.text5": "[{0}]已经连续战胜{1}人，问鼎群雄！",
            "PlayerNoticeManager.text6": "[{0}]终结了[{1}]的{2}连胜！",
            "PlayerNoticeManager.text7": "世界BOSS将于{0}分钟后降临，请仙友们提前准备前往挑战！",
            "PlayerNoticeManager.text8": "世界BOSS携带大量宝物出现啦，请仙友们快去挑战拿大奖！",
            "PlayerNoticeManager.text9": "{0}带领大家一起战胜了世界BOSS{1}",
            "PlayerNoticeManager.text10": "{0} 成功开启了中心的传奇大宝箱，获得大量积分！",
            "PlayerNoticeManager.text11": "{0}将昵称更改为{1}！",
            "PlayerNoticeManager.text12": "{0}创建了{1}（家族），正在征集小伙伴一起战斗！",
            "PlayerNoticeManager.text13": "{0} 一举击杀捉妖BOSS琵琶精！",
            "PlayerNoticeManager.text14": "恭喜{0}在幸运寻宝中获得了{1}！",
            "PlayerNoticeManager.text15": "{0}今日累计寻宝达到{1}次,获得了{2}！",
            "PlayerNoticeManager.text16": "玩家[{0}]一郑千金使用了战争鼓舞，[{1}]所有成员获得了{2}",
            "PlayerNoticeManager.text17": "恭喜{0}和{1}以{2}为信物共谐连理，双方同时获得{3}战力加成！实力暴涨！",
            "PlayerNoticeManager.text18": "[{0}]成功抢夺了{1}！！",
            "PlayerNoticeManager.text19": "{0}、{1}、{2}三人桃园结义祸福同享，同时获得{3}战力加成！共闯天下。",
            "PlayerNoticeManager.text20": "本服战神{0}上线啦，膜拜战神可获得奖励！",
            "PlayerNoticeManager.text21": "恭喜{0}喜从天降巧获探索称号{1}!",
            "PlayerNoticeManager.text22": "哇，{0}完成了今日首充，领取了魅力非凡的[0xFFF885]妖精卡[-]以及海量的材料！",
            "PlayerNoticeManager.text23": "{0}在家族宝藏中挖到了【{1}】！小伙伴们快来助我一臂之力！",
            "PlayerNoticeManager.text24": "{0}完成了{1}元今日首充，获得了绝世珍品[0xFFF885]魂魄丹[-]，战力更上一层楼了！",
            "PlayerNoticeManager.text25": "富豪{0}完成了{1}元今日首充，获得了大量外观进阶材料，速来围观！",
            "PlayerNoticeManager.text26": "江湖传闻，{0}完成了所有今日首充，领取了全部奖励。神壕，请接受我的膝盖！",
            "____2327.text1": "参与活动可获得外观魂石",
            "renameView.text1": "昵称最多5个字",
            "____2330.text1": "{0}达到{1}阶{2}星可继续炼魂",
            "____2330.text2": "{0} x{1}次",
            "____2238.text1": "加为好友",
            "____2238.text2": "对方已是您的好友",
            "____2238.text3": "{0}级可加好友",
            "____2100.text1": "战场人数已满",
            "____2100.text2": "所在战场已经结束",
            "____2100.text3": "由于没有对手已直接获胜",
            "____2100.text4": "今天你已参与过该活动",
            "____2092.text1": "活动暂未开放!",
            "AdvancePanel.text1": "先完成主线任务才能激活形象!",
            "LookInfo.text1": "不能查看离线玩家!",
            "____2103.text1": "玩家当前不在线",
            "____2103.text2": "成功发送好友邀请",
            "____2103.text3": "不能添加自己",
            "____2103.text4": "没有此角色名称",
            "HomePanel.text1": "土地：{0}",
            "HomePanel.text2": "昵称：{0}",
            "HomePanel.text3": "今日播种次数已用完",
            "HomePanel.text4": "今日偷菜次数用完",
            "HomePanel.text5": "浇水成功！",
            "HomePanel.text6": "浇水成功！今日可帮助浇水{0}次",
            "HomePanel.text7": "今日帮助好友浇水次数用完",
            "HomePanel.text8": "是否花费{0}钻石加速庄稼。",
            "HomePanel.text9": "加速成功",
            "HomePanel.text11": "可播种：{0}次",
            "HomePanel.text12": "可收获",
            "HomeMessageSender.text1": "炼丹失败",
            "HomeMessageSender.text2": "他快破产了，放过他吧！",
            "HomeMessageSender.text3": "采摘成功！今日可采摘{0}次",
            "HomeLianDanBtn.type0": "装备宝石",
            "HomeLianDanBtn.type1": "装备强化",
            "HomeLianDanBtn.type2": "外观仙丹",
            "HomeLianDanView.desc0": "注：消耗宝石碎片随机获得1~2级宝石",
            "HomeLianDanView.desc1": "注：消耗强化石碎片随机获得初级和中级强化石",
            "HomeLianDanView.desc2": "注：消耗丹药精华随机获得各种成长丹和潜能丹",
            "____543.text1": "不能查看自己",
            "HomeSeedItemView.text1": "生长期：{0}",
            "HomeSeedItemView.text2": "总产量：{0}",
            "HomeSeedItemView.text3": "副奖励：{0}",
            "MarryAcceptPanel.text1": "{0}战力：",
            "____2168.text1": "重置条件：",
            "____2168.text2": "消耗{0}财富",
            "____2168.text3": "家族实力{0}万",
            "____2168.text4": "难度：普通",
            "____2168.text5": "奖励：{0}%",
            "____2168.text6": "难度：精英",
            "____2168.text7": "难度：地狱",
            "____2168.text8": "难度：传说",
            "____2168.text9": "难度：史诗",
            "____2168.text10": "今日进入次数已用完!",
            "____2168.text11": "确定支付[0x009700]{0}财富[-]重置{1}副本吗?",
            "____2168.text12": "消耗{0}仙露增加{1}神树成长!",
            "____2220.text1": "玩家名称",
            "____2220.text2": "职业",
            "____2220.text3": "图鉴战力",
            "____2220.text4": "暂无排行榜数据",
            "____2220.text5": "家族",
            "____2220.text6": "法宝名称",
            "____2220.text7": "法宝品阶",
            "____2220.text8": "法宝战力",
            "____2220.text9": "你当前未有排名信息",
            "____2220.text10": "足迹名称",
            "____2220.text11": "足迹品阶",
            "____2220.text12": "足迹战力",
            "____2220.text13": "仙宠名称",
            "____2220.text14": "仙宠品阶",
            "____2220.text15": "仙宠战力",
            "____2220.text16": "坐骑名称",
            "____2220.text17": "坐骑品阶",
            "____2220.text18": "坐骑战力",
            "____2220.text19": "无",
            "____2220.text20": "神剑名称",
            "____2220.text21": "神剑品阶",
            "____2220.text22": "神剑战力",
            "____2220.text23": "飞羽名称",
            "____2220.text24": "飞羽品阶",
            "____2220.text25": "飞羽战力",
            "____2220.text26": "阵灵名称",
            "____2220.text27": "阵灵品阶",
            "____2220.text28": "阵灵战力",
            "LuckyTreasurePanel.text1": "十抽",
            "LuckyTreasurePanel.text2": "寻宝",
            "LuckyTreasurePanel.text3": "幸运寻宝",
            "LuckyTreasurePanel.text4": "(第一轮)",
            "LuckyTreasurePanel.text5": "(第二轮)",
            "LuckyTreasurePanel.text6": "拥有寻宝密令：{0}",
            "LuckyTreasurePanel.text7": "第一轮寻宝: {0}次",
            "LuckyTreasurePanel.text8": "第二轮寻宝: {0}次",
            "LuckyTreasurePanel.text9": "你拥有的寻宝密令不足，购买专属礼包可以快速获得！点击确认前往专属礼包界面。",
            "LuckyTreasurePanel.text10": "获取密令",
            "RoleXianWeiTipView.text1": "角色等级达到{0}级",
            "RoleXianWeiTipView.text2": "战力达到{0}",
            "RoleXianWeiTipView.text3": "满足上面双条件即可提升仙位",
            "VipPanel.text1": "您当前的VIP已经满级",
            "WushenzhengbaPanel.text3": "立刻参与",
            "____2253.text1": "铜币：",
            "____2253.text2": "贡献：",
            "____2253.text3": "获得挑战奖励：",
            "____2253.text4": "恭喜你获得100%优胜奖",
            "____2253.text5": "很遗憾仅获得50%鼓励奖",
            "____2253.text6": "荣誉：",
            "____2253.text7": "(仙位越高奖励越好)",
            "____2253.text8": "扫荡成功获得奖励：",
            "____2253.text9": "再扫一次",
            "____2253.text10": "获得扫荡奖励：",
            "____2253.text11": "紫霞",
            "____2253.text12": "副本已通关，是否退出?",
            "____2253.text13": "战胜BOSS",
            "____2253.text14": "当前波次：",
            "____2253.text15": "提升仙位后可以继续挑战",
            "MarryAcceptPanel.text1": "{0}战力：",
            "MarryAcceptPanel.text2": "不愿意",
            "MarryAcceptPanel.text3": "我愿意",
            "MarryAcceptPanel.text4": "你本人需要支付：",
            "MarryAcceptPanel.text5": "仙侣情缘",
            "MarryApplyPanel.text1": "AA支付",
            "MarryApplyPanel.text2": "个人支付",
            "MarryApplyPanel.text3": "每人支付：",
            "MarryApplyPanel.text4": "请先选择一个好友",
            "MarryApplyPanel.text5": "无在线异性好友",
            "MarryApplyPanel.text6": "是否支付[0x009700]{0}[-]钻石请求结缘？",
            "MarryFriendListPanel.text1": "对方等级不足{0}级",
            "MarryPanel.text1": "结缘二人可获得婚戒的属性加成",
            "MarryPanel.text2": "升级",
            "MarryPanel.text3": "我要结缘",
            "MarryPanel.text4": "升为神之戒后继续强化",
            "MarryPanel.text5": "仙侣：",
            "MarryPanel.text6": "已强化到最高级",
            "MarryPanel.text7": "{0}属性预览",
            "MarryRingAdvancePanel.text1": "本次婚戒提升将支付",
            "MarryRingAdvancePanel.text2": "可强化等级：",
            "MarryRingAdvancePanel.text3": "提示",
            "MarryRingAdvancePanel.text4": "本次婚戒提升将支付",
            "MarryRingAdvancePanel.text5": "本次婚戒提升将支付",
            "OathAcceptPanel.text1": "{0}邀请你结义",
            "OathAcceptPanel.text2": "本次结义费用：",
            "OathApplyPanel.text1": "人数不足，请先选择好友",
            "OathApplyPanel.text2": "结义的其他两位成员不能为同一个人",
            "OathApplyPanel.text3": "是否支付[0x009700]{0}[-]钻石请求结义？",
            "OathApplyPanel.text4": "无在线好友",
            "OathPanel.text1": "结义三人都获得信物属性加成",
            "OathPanel.text2": "我要结义",
            "OathPanel.text3": "升为神之信物后继续强化",
            "OathXinWuAdvancePanel.text1": "本次信物提升将支付",
            "OathXinWuAdvancePanel.text2": "升为神之信物后继续强化",
            "OathXinWuAdvancePanel.text3": "升为神之信物后继续强化",
            "FamilyTreasuresOnePanel.text1": "今日剩余挖宝次数：{0}",
            "FamilyTreasuresOnePanel.text2": "{0} 刷新",
            "FamilyTreasuresOnePanel.text3": "是否花费{0}钻石刷新？",
            "FamilyTreasuresOnePanel.text4": "自动刷新宝藏：",
            "FamilyTreasuresOnePanel.text5": "免费刷新",
            "familyTreasuresItemOne.text1": "{0}小时",
            "familyTreasuresItemOne.text2": " {0} 挖宝",
            "familyTreasuresItemOne.text3": " 是否花费{0}钻石挖宝？",
            "familyTreasuresItemOne.text4": "免费挖宝",
            "familyTreasuresItemOne.text5": "今日挖宝次数已用完",
            "familyTreasuresItemOne.text6": "挖宝成功！",
            "familyTreasuresItemTwo.text1": "协助：{0}（奖励+50%）",
            "familyTreasuresItemTwo.text2": "再过{0}秒可再次邀请协助",
            "familyTreasuresItemTwo.text3": "拥有者：{0}",
            "familyTreasuresItemTwo.text4": " {0} 挖宝",
            "familyTreasuresItemTwo.text5": "是否花费{0}钻石快速领取奖励？",
            "familyTreasuresItemTwo.text6": "领取奖励",
            "familyTreasuresItemTwo.text7": "协助：无",
            "familyTreasuresItemTwo.text8": "邀请协助",
            "familyTreasuresItemTwo.text9": "协助挖宝",
            "FamilyTreasuresPanel.text1": "家族宝藏",
            "FamilyTreasuresPanel.text2": "活动剩余时间",
            "FamilyTreasuresPanel.text3": "宝藏列表",
            "FamilyTreasuresPanel.text4": "我的宝藏",
            "FamilyTreasuresPanel.text5": "协助列表",
            "FamilyTreasuresPanel.text6": "加入家族后即可以与小伙伴一起快乐寻宝了，点击“前往”去加入家族吧！",
            "FamilyTreasuresThreePanel.text1": "剩余协助次数：{0}次（协助开启宝藏可获得奖励）",
            "FamilyTreasuresThreePanel.text2": "  协助挖宝同样可以获得宝藏奖励！\n      赶快邀请小伙伴挖宝吧！~",
            "FamilyTreasuresTwoPanel.text1": "获得家族成员协助可额外增加50%奖励哦！",
            "FamilyTreasuresTwoPanel.text2": "您的宝藏列表空空如也哦！~",
            "CityKingChatPop.text0": "你们可曾听过我的大名？",
            "CityKingChatPop.text1": "那个谁，可敢与我一战？",
            "CityKingChatPop.text2": "膜拜我，便给你点好处",
            "CityKingChatPop.text3": "战神降世，神威在天！",
            "CityKingChatPop.text4": "战力第一，不服来战！",
            "CityKingChatPop.text5": "高处不胜寒，寂寞谁人懂…",
            "DailyFirstRechargePanel.text1": "累充{0}元奖励",
            "WaiXingChongJiePanel.text1": "{0}进阶到{1}阶{2}星即可领取奖励",
        }
    },
});
var ____2097 = cc.Class.extend({
    list: null,
    ctor: function() {
        var temp = new Yuyanbao();
        this.list = temp.list
    },
    getYuyanbao: function(id) {
        if (id == null) return "";
        var value = this.list[id];
        if (value == null) {
            print("------语言包中未找到" + id + "对应信息-------");
            return ""
        }
        if (arguments.length == 1) return value;
        var arr = Array.prototype.slice.call(arguments, 1);
        return value.format(arr)
    },
});
var ____2098 = cc.Class.extend({
    add: function() {
        var this_ = this;

        function clubInfoReturn(bytes) {
            ____655.clubInfo.init(bytes)
        }

        function clubListReturn(bytes) {
            ____655.clubItemList.init(bytes)
        }

        function clubCreateReturn(bytes) {
            var isSucc = bytes.readBoolean();
            if (isSucc) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text7"));
            } else {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text8"));
            }
        }

        function clubMemberListReturn(bytes) {
            ____655.clubInfo.initMember(bytes)
        }

        function clubMyDataReturn(bytes) {
            ____655.clubInfo.initMyData(bytes)
        }

        function clubApplyListReturn(bytes) {
            ____655.clubInfo.initApplyList(bytes)
        }

        function clubRequteInfoReturn(bytes) {
            ____655.clubInfo.requteClubInfo(bytes)
        }

        function clubPlayerApplyDealReturn(bytes) {
            ____655.clubInfo.clubPlayerApplyDeal(bytes)
        }

        function clubPlayerXinFaReturn(bytes) {
            ____655.clubInfo.clubXinFaInfo(bytes)
        }

        function clubPlayerGodTreeInfoReturn(bytes) {
            ____655.clubInfo.clubPlayerGodTreeInfo(bytes)
        }

        function clubPlayerDevoteInfoReturn(bytes) {
            var type = bytes.readByte();
            if (type == 1) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text9"))
            } else if (type == 2) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text10"))
            }
        }

        function clubExpeditionBossHPReturn(bytes) {
            ____655.clubInfo.clubExpeditionBossHPInfo(bytes)
        }

        function clubExpeditionHurtReturn(bytes) {
            ____655.clubInfo.clubExpeditionHurtInfo(bytes)
        }

        function clubExpeditionResetReturn(bytes) {
            ____655.clubInfo.clubExpeditionResetInfo(bytes)
        }

        function okClick() {
            ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID, 0)
        }

        function clubBossStartInfoReturn(bytes) {
            var value = bytes.readByte();
            if (value == 0) {
                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("ClubInfo.text11"), null, 0, this, okClick, null, null)
            } else if (value == 1) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text16"))
            }
        }

        function clubBossCopyInfoReturn(bytes) {
            ____655.clubInfo.clubBossCopyInfo(bytes)
        }

        function clubBossRankInfoReturn(bytes) {
            ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID).setDamageRankInfo(bytes)
        }

        function clubJobUpdateReturn(bytes) {
            ____655.clubInfo.clubJobUpdate(bytes)
        }

        function clubMemberKickReturn(bytes) {
            ____655.clubInfo.ClubMemberkick(bytes)
        }

        function clubJoinTipReturn(bytes) {
            var type = bytes.readByte();
            var clubName = bytes.readString();
            if (type == 1) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text12"))
            } else if (type == 2) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text13"))
            } else if (type == 3) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text14", clubName))
            } else if (type == 4) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text15", clubName))
            } else if (type == 5) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text17"))
            } else if (type == 6) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text18"))
            } else if (type == 7) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text19"))
            } else if (type == 8) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text20"))
            }
        }
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_INFO, clubInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_LIST, clubListReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_CREATE, clubCreateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_MEMBER_LIST, clubMemberListReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_MYDATA, clubMyDataReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_APPLY_LIST, clubApplyListReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_REQUTENUM, clubRequteInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_APPLY_DEAL, clubPlayerApplyDealReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_XINFA_INFO, clubPlayerXinFaReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_GODTREE_INFO, clubPlayerGodTreeInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_DEVOTE, clubPlayerDevoteInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_EXPEDITION_BOSS_HP, clubExpeditionBossHPReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_EXPEDITION_HURT, clubExpeditionHurtReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_EXPEDITION_RESET, clubExpeditionResetReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_BOSS_STARTCOPY, clubBossStartInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_BOSS_COPYINFO, clubBossCopyInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_BOSS_RANKINFO, clubBossRankInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_JOB_UPDATE, clubJobUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_MEMBER_KICK, clubMemberKickReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CLUB_JOIN_TIP, clubJoinTipReturn)
    },
    sendClubList: function(pageIndex, pageCount) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_LIST);
        messOut.writeShort(pageIndex);
        messOut.writeByte(pageCount);
        ____654.____680.send(messOut)
    },
    sendClubCreate: function(name) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_CREATE);
        messOut.writeString(name);
        ____654.____680.send(messOut)
    },
    sendClubInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_INFO);
        ____654.____680.send(messOut)
    },
    sendClubAutoJoin: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_AUTO_JOIN);
        ____654.____680.send(messOut)
    },
    sendClubMember: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_MEMBER_LIST);
        ____654.____680.send(messOut)
    },
    sendApplyList: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_APPLY_LIST);
        ____654.____680.send(messOut)
    },
    sendApplyClub: function(clubId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_APPLY);
        messOut.writeNumber(clubId);
        ____654.____680.send(messOut)
    },
    sendRequteClubInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_REQUTENUM);
        ____654.____680.send(messOut)
    },
    sendClubNoticeSave: function(content) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_NOTICE_SAVE);
        messOut.writeString(content);
        ____654.____680.send(messOut)
    },
    sendClubDevote: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_DEVOTE);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendAutoJoinLevel: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_AUTO_JOIN_LEVEL);
        messOut.writeShort(type);
        ____654.____680.send(messOut)
    },
    sendClubMemberDeal: function(type, userId, value) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_APPLY_DEAL);
        messOut.writeByte(type);
        messOut.writeNumber(userId);
        messOut.writeByte(value);
        ____654.____680.send(messOut)
    },
    sendClubXinFaUp: function(count) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_XINFA_UP);
        messOut.writeByte(count);
        ____654.____680.send(messOut)
    },
    sendClubGodTreeUp: function(num) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_GODTREE_UP);
        messOut.writeInt(num);
        ____654.____680.send(messOut)
    },
    sendClubGodTreeGetAward: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_GODTREE_GETAWARD);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendClubLeave: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_LEAVE);
        ____654.____680.send(messOut)
    },
    sendGetClubExpeditionBossInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_EXPEDITION_BOSS_HP);
        ____654.____680.send(messOut)
    },
    sendClubExpeditionRest: function(copyId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_EXPEDITION_RESET);
        messOut.writeInt(copyId);
        ____654.____680.send(messOut)
    },
    sendClubBossStartCopy: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_BOSS_STARTCOPY);
        ____654.____680.send(messOut)
    },
    sendClubJobChange: function(userId, job) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_JOB_UPDATE);
        messOut.writeNumber(userId);
        messOut.writeByte(job);
        ____654.____680.send(messOut)
    },
    sendClubMasterChange: function(userId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_MASTER_UPDATE);
        messOut.writeNumber(userId);
        ____654.____680.send(messOut)
    },
    sendClubMemberCick: function(userId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_MEMBER_KICK);
        messOut.writeNumber(userId);
        ____654.____680.send(messOut)
    },
    sendXinFaDataGet: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CLUB_XINFA_INFO);
        ____654.____680.send(messOut)
    }
});
var ____543 = cc.Class.extend({
    ____1321: 0,
    ____1225: 0,
    add: function() {
        var this_ = this;

        function restartHandler() {
            print("+++++执行重启客户端指令，如果PC端运行可能崩溃+++++");
            cc.director.restart()
        };

        function accountCreateReturn(bytes) {
            var result = bytes.readBoolean();
            var resultStr = bytes.readString();
            var id = bytes.readNumber();
            if (result) {
                ____655.createRole = true;
                this_.____195(id)
            } else {
                ____654.tipsManager.quickTip.show(resultStr)
            }
            ____654.panelQuote.hideLoading("createRole")
        };

        function accountUserReturn(bytes) {
            var ____658 = bytes.readShort();
            if (____655.____658 != ____658) {
                ____654.panelQuote.hideLoading("loginServer");
                ____655.getAlert().show(1, "游戏版本有更新,请重启游戏(" + ____655.____658 + "-" + ____658 + ")", null, 0, this, restartHandler, null, null);
                return
            }
            var len = bytes.readShort();
            var list = [];
            for (var i = 0; i < len; i++) {
                var role = new ____494();
                role.userId = bytes.readNumber();
                role.level = bytes.readInt();
                role.userName = bytes.readString();
                role.nickName = bytes.readString();
                role.serverId = bytes.readShort();
                role.career = bytes.readByte();
                role.xianwei = bytes.readByte();
                list.push(role);
                print("==========收到角色数据", role.userId, role.nickName)
            }
            ____655.____663.____62(list)
        };

        function accountLoginReturn(bytes) {
            var ____658 = bytes.readShort();
            if (____655.____658 != ____658) {
                ____655.getAlert().show(1, "游戏版本有更新,请重启游戏(" + ____655.____658 + "-" + ____658 + ")", null, 0, this, restartHandler, null, null);
                return
            }
            ____655.____665 = bytes.readInt();
            ____655.____662.____43(bytes.readByte());
            var len = bytes.readShort();
            for (var i = 0; i < len; i++) {
                bytes.readShort()
            }
            var userId = bytes.readNumber();
            if (____655.____667 == null) {
                ____655.____667 = new ____504()
            } else {
                ____655.____667.____76()
            }
            ____655.____667.userId = userId;
            ____654.____685.____191(____655.____667, bytes);
            ____654.selfPlayerInit();
            var map = bytes.readInt();
            ____655.____663.clearAllView();
            ____654.____679.____155(____655.____659.____690.sceneModule, null);
            ____655.____667.createRoleTime = bytes.readInt() * 1000;
            ____655.____667.levelUpTime = bytes.readInt() * 1000;
            ____655.____667.hefuTime = bytes.readInt() * 1000;
            ____655.____667.changeInfo();
            ____654.selfDataMessageSender.____196();
            ____655.____667.setShortAccount();
            ____654.sdk.setPlayerInfo();
            ____654.sdk.enterGameServer();
            if (____655.createRole == true) {
                ____655.createRole = false;
                ____654.sdk.createRole()
            }
        };

        function logoutReturn(bytes) {
            var type = bytes.readUByte();
            ____655.logoutType = type
        };

        function sysDateReturn(bytes) {
            var time = bytes.readInt();
            var timeZone = bytes.readShort();
            ____655.____662.____43(timeZone);
            ____655.____662.____42(time)
        };

        function activityInfoReturn(bytes) {
            ____655.activityInfo.initInfo(bytes)
        };

        function activityAwardReturn(bytes) {
            ____655.activityInfo.initAward(bytes)
        };

        function activityTotalReturn(bytes) {
            ____655.activityInfo.initTotalActivity(bytes)
        };

        function quickComplateErrorReturn(bytes) {
            ____654.tipsManager.quickTip.show("未加入家族,无法快速完成家族任务")
        };

        function chatMessageReturn(bytes) {
            var serverId = bytes.readShort();
            var channel = bytes.readUByte();
            var level = bytes.readShort();
            var vipLevel = bytes.readUByte();
            var gm = bytes.readUByte();
            var nick = bytes.readString();
            var career = bytes.readUByte();
            var userId = bytes.readNumber();
            var toUserId = bytes.readNumber();
            var message = bytes.readString();
            if (userId == ____655.____667.userId) {
                return
            }
            var info = new ____481();
            info.playerInfo.serverId = serverId;
            info.playerInfo.level = level;
            info.playerInfo.vipLevel = vipLevel;
            info.playerInfo.gm = gm;
            info.playerInfo.nick = nick;
            info.playerInfo.career = career;
            info.playerInfo.userId = userId;
            info.toUserId = toUserId;
            info.channel = channel;
            info.message = message;
            info.time = ____655.____662.secondsToDateString(____655.____662.getSystemTimeSec());
            ____655.____669.____36(info)
        };

        function activityIconConfigReturn(bytes) {
            ____655.activityIconList.initActivityIcon(bytes)
        };

        function timingIconUpdateReturn(bytes) {
            ____655.activityIconList.initTimingIcon(bytes)
        };

        function vipInfoReturn(bytes) {
            ____655.statInfo.getVipAwardInfo(bytes)
        };

        function returnGiftInfo(bytes) {
            ____655.statInfo.getReturnGiftInfo(bytes)
        };

        function systemMessageReturn(bytes) {
            var mType = bytes.readShort();
            var code = bytes.readInt();
            var color = bytes.readByte();
            var message = bytes.readString();
            if (mType == 3) {
                ____654.tipsManager.quickTip.show(message)
            } else if (mType == 1 || mType == 2 || mType == 5 || mType == 7 || mType == 10) {
                ____655.____669.appendSystemItem(message, true)
            } else {
                print("-----------------------------------");
                print("还未处理的系统消息:" + message);
                print("mType:" + mType + ",code:" + code);
                print("-----------------------------------")
            }
        };

        function updateVipLevel(bytes) {
            var vipLevel = bytes.readShort();
            ____655.____667.____65(vipLevel)
        };

        function lookInfoReturn(bytes) {
            ____655.lookInfo.initData(bytes);
            ____654.____672.dispatchEvent(new ____590(____655.____661.look_InfoReturn, ____654.____672))
        };

        function lookAdvanceFashionReturn(bytes) {
            ____655.lookInfo.advanceFashionInitData(bytes);
            ____654.____672.dispatchEvent(new ____590(____655.____661.look_InfoReturn, ____654.____672))
        };

        function lookCompareReturn(bytes) {
            ____655.lookInfo.compareInitData(bytes);
            ____654.____672.dispatchEvent(new ____590(____655.____661.look_InfoReturn, ____654.____672))
        };

        function lookErrorReturn(bytes) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("LookInfo.text1"))
        };

        function dailyRechargeInfoReturn(bytes) {
            ____655.dailyFirstRechargeInfo.infoUpdate(bytes)
        };

        function taskClubAndDailyInfoReturn(bytes) {
            var taskType = bytes.readByte();
            var len = bytes.readByte();
            var itemList = [];
            for (var i = 0; i < len; i++) {
                var templateId = bytes.readInt();
                var count = bytes.readInt();
                itemList.push([templateId, count])
            }
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_taskClubAndDailyUpdate, ____654.____672, [taskType, itemList]))
        };

        function waiXingChongJieInfoReturn(bytes) {
            ____655.openInfo.updateWaiXingChongJieInfo(bytes)
        };
        ____654.____680.addSocketHandler(____655.____659.____691.SYS_MESS, systemMessageReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.____765, accountCreateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.____763, accountUserReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.LOGIN, accountLoginReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.LOGOUT, logoutReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.SYS_DATE, sysDateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ACTIVITY_INFO, activityInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ACTIVITY_AWARD, activityAwardReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ACTIVITY_ICON_CONFIG, activityIconConfigReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ACTIVITY_TOTAL, activityTotalReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TASK_QUICKFINISH, quickComplateErrorReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TIMING_ICON_UPDATE, timingIconUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CHAT_MESSAGE, chatMessageReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.VIP_INFO, vipInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.RETURNGIFT_INFO, returnGiftInfo);
        ____654.____680.addSocketHandler(____655.____659.____691.VIP_LEVEL, updateVipLevel);
        ____654.____680.addSocketHandler(____655.____659.____691.LOOK_PLAYER, lookInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.LOOK_PLAYER_FASHION, lookAdvanceFashionReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.LOOK_PLAYER_COMPARE, lookCompareReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.LOOK_PLAYER_ERROR, lookErrorReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.DAILY_FIRST_RECHARGE_INFO, dailyRechargeInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TASK_CLUB_DAILY_COMPLETE, taskClubAndDailyInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.WAI_XING_CHONG_JIE_INFO, waiXingChongJieInfoReturn)
    },
    ____192: function() {
        ____654.____678.____298(this.____193, this)
    },
    ____193: function(delta) {
        this.____1225 += 1;
        if (this.____1225 > 10) {
            var currentTime = ____655.____662.getSystemTime();
            var offsetTime = currentTime - this.____1321;
            if (offsetTime > 30000 || offsetTime < 0) {
                ____654.____680.sendCode(____655.____659.____691.____766);
                this.____1321 = currentTime
            }
            this.____1225 = 0
        }
    },
    ____194: function(userId) {
        if (userId == null) userId = 0;
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.____762);
        messOut.writeShort(____655.____663.serverId);
        messOut.writeInt(____655.____663.time);
        messOut.writeByte(____655.____663.cm);
        messOut.writeNumber(userId);
        messOut.writeByte(____655.____663.isImei);
        messOut.writeByte(____655.____663.orderMD5Type);
        messOut.writeString(____655.____663.userName);
        messOut.writeString(____655.____663.sign);
        messOut.writeShort(____655.____663.agentId);
        ____654.____680.send(messOut);
        this.____192()
    },
    sendLogout: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.LOGOUT);
        ____654.____680.send(messOut)
    },
    sendAccountRoleCreate: function(serverId, nickName, career) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.____765);
        messOut.writeByte(career);
        messOut.writeInt(serverId);
        messOut.writeString(nickName);
        ____654.____680.send(messOut)
    },
    ____195: function(id) {
        print("-------------选择角色", id);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.____764);
        messOut.writeNumber(id);
        ____654.____680.send(messOut)
    },
    sendAccountDeleteMessage: function(id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ACCOUNT_DELETE);
        messOut.writeNumber(id);
        ____654.____680.send(messOut)
    },
    sendChat: function(chatType, content, userNick, userId) {
        if (userNick == null) {
            userNick = ""
        }
        if (userId == null) {
            userId = 0
        }
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CHAT_MESSAGE);
        messOut.writeByte(chatType);
        messOut.writeByte(0);
        messOut.writeString(userNick);
        messOut.writeNumber(userId);
        messOut.writeString(content);
        ____654.____680.send(messOut)
    },
    sendActivityUpgrade: function(type) {
        print("发送历练升级", type);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ACTIVITY_UPGRADE);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    getActivityBox: function(act) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ACTIVITY_BOX);
        messOut.writeShort(act);
        ____654.____680.send(messOut)
    },
    sendGetVipAward: function(level) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.VIP_GETAWARD);
        messOut.writeByte(level);
        ____654.____680.send(messOut)
    },
    sendGetReturnGift: function(id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.RETURNGIFT_INFO);
        messOut.writeByte(id);
        ____654.____680.send(messOut)
    },
    sendXiLianMaterial: function(itemId, index) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ITEM_XILIAN);
        messOut.writeNumber(itemId);
        messOut.writeByte(index);
        ____654.____680.send(messOut)
    },
    sendChooseXilian: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ITEM_XILIAN_CHOOSE);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendGMBug: function(type, content) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.GM_MESSAGE);
        messOut.writeByte(type);
        messOut.writeString(content);
        ____654.____680.send(messOut)
    },
    sendLook: function(userId, serverId) {
        if (userId == ____655.____667.userId) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____543.text1"));
            return
        }
        if (____655.lookInfo == null) {
            ____655.lookInfo = new LookInfo()
        }
        ____655.lookInfo.initDataFinish1 = false;
        ____655.lookInfo.initDataFinish2 = false;
        ____655.lookInfo.initDataFinish3 = false;
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.LOOK_PLAYER);
        messOut.writeNumber(userId);
        messOut.writeShort(serverId);
        ____654.____680.send(messOut)
    },
    sendGetFirstRechargeAward: function(condition) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.DAILY_FIRST_RECHARGE_GET);
        messOut.writeShort(condition);
        ____654.____680.send(messOut)
    },
    sendWaiXingChongJieAward: function(tempId) {
        print("发送外形冲阶奖励协议：", tempId);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WAI_XING_CHONG_JIE_INFO);
        messOut.writeShort(tempId);
        ____654.____680.send(messOut)
    },
});
var ____2100 = cc.Class.extend({
    add: function() {
        var this_ = this;

        function copyFinishReturn(bytes) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.copy_finish, ____654.____672, null))
        };

        function copyEnterReturn(bytes) {
            var copyId = bytes.readInt();
            print("进入副本协议", copyId);
            var addCount = bytes.readByte();
            if (copyId < 1) {
                return
            } else if (copyId == 1) {
                var time = bytes.readInt();
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text6", time))
            } else if (copyId == 2) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2100.text1"))
            } else if (copyId == 3) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2100.text2"))
            } else if (copyId == 4) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2100.text3"))
            } else if (copyId == 5) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2100.text4"))
            } else {
                var missionId = bytes.readInt();
                ____655.copyInfo.setCopyId(copyId, missionId);
                ____655.warDatas.setCopyIdComplete();
                if (____655.allTemplates.copyTemplateList.clubExpeditionCopyList.indexOf(copyId) != -1) {
                    if (addCount > 0) {
                        ____655.statInfo.addCopyEnterCount(____655.allTemplates.copyTemplateList.clubExpeditionCopyList[0], addCount)
                    }
                } else {
                    if (addCount > 0) {
                        ____655.statInfo.addCopyEnterCount(copyId, addCount)
                    }
                }
            }
        };

        function copyExitReturn(bytes) {
            var copyId = bytes.readInt();
            ____655.copyInfo.lastId = copyId;
            ____655.copyInfo.clearCopyId();
            ____655.warDatas.clearCopyId();
            ____654.____672.dispatchEvent(new ____590(____655.____661.copy_exit, ____654.____672, copyId))
        };

        function copyExitPanelReturn(bytes) {
            var copyId = bytes.readInt();
            if (____655.allTemplates.copyTemplateList.NEWLY_COPYIDLIST.indexOf(copyId) >= 0 || copyId == ____655.allTemplates.copyTemplateList.ZUOYAO_COPYID) {
                return
            }
            if (____655.guideCopyId == 99 || ____655.guideCopyId == copyId) {
                ____655.guideCopyId = 0
            } else {
                ____654.____672.dispatchEvent(new ____590(____655.____661.copy_showComplatePanel, ____654.____672, [copyId, bytes]))
            }
        };

        function copyShouhuUpdateReturn(bytes) {
            var copyId = bytes.readInt();
            var currentMission = bytes.readShort();
            var totalMission = bytes.readShort();
            var monsterCount = bytes.readInt();
            var totalMonster = bytes.readInt();
            var time = bytes.readInt();
            var exp = bytes.readInt();
            var copper = bytes.readInt();
            var info = ____655.copyInfo.currentCopyInfo;
            if (info != null && info.copyId == copyId) {
                info.updateWave(currentMission, totalMission);
                info.updateTime(time, 0);
                info.exp = exp;
                info.copper = copper
            }
        };

        function copyInfoReturn(bytes) {
            ____655.statInfo.initCopyList(bytes)
        };

        function copyWorldBossInfoReturn(bytes) {
            ____655.copyInfo.worldBossInfo.setDamageRankInfo(bytes)
        };

        function bossSelfUpdateReturn(bytes) {
            ____655.copyInfo.worldBossInfo.setSelfDamageInfo(bytes)
        };

        function copyEnterCountReturn(bytes) {
            var copyId = bytes.readInt();
            var count = bytes.readUByte();
            var time = bytes.readInt();
            ____655.statInfo.setCopyEnterCount(copyId, count, time)
        };

        function copyStarCountReturn(bytes) {
            var len = bytes.readUByte();
            for (var i = 0; i < len; i++) {
                var copyId = bytes.readInt();
                ____655.copyInfo.setCopyAwardState(copyId, bytes)
            }
        };

        function yaoqingPlayerReturn(bytes) {
            var type = bytes.readByte();
            if (type == 0) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text7"))
            } else if (type == 2) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text9"))
            } else if (type == 3) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text8"))
            } else if (type == 12) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text11"))
            } else if (type == 13) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text12"))
            } else if (type == 14) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text10"))
            } else if (type == 15) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text13"))
            } else if (type == 16) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text14"))
            }
        };

        function yaoqingNoticeReturn(type, bytes) {
            if (____655.isYaoqing == true) {
                return
            }
            var playerId = bytes.readNumber();
            var nick = bytes.readString();
            print("#收到组队邀请", nick);

            function okHandler() {
                ____655.isYaoqing = false;
                ____654.copyMessageSender.sendTeamBack(type, playerId, 1)
            };

            function cancelHandler() {
                ____655.isYaoqing = false;
                ____654.copyMessageSender.sendTeamBack(type, playerId, 2)
            };
            var copyName = "";
            if (type == 1) {
                copyName = "守护副本"
            } else if (type == 2) {
                copyName = "天宫悬赏"
            }
            ____655.isYaoqing = true;
            ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2107.text15", nick, copyName), null, -10, this, okHandler, cancelHandler, null)
        };

        function yaoqingNoticeReturn1(bytes) {
            yaoqingNoticeReturn(1, bytes)
        };

        function yaoqingNoticeReturn2(bytes) {
            yaoqingNoticeReturn(2, bytes)
        };

        function yaoqingBackReturn(type, bytes) {
            var backType = bytes.readByte();
            if (backType == 0) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.common_showTeamPanel, ____654.____672, [type, false, 0]))
            } else if (backType == 15) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text13"))
            } else if (backType == 19) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text14"))
            } else if (backType == 9) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text18"))
            }
        };

        function yaoqingBackReturn1(bytes) {
            yaoqingBackReturn(1, bytes)
        };

        function yaoqingBackReturn2(bytes) {
            yaoqingBackReturn(2, bytes)
        };

        function quitTeamReturn(bytes) {
            var index = bytes.readByte();
            if (index == 1) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.common_hideTeamPanel, ____654.____672, null));
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text13"))
            } else {
                ____654.____672.dispatchEvent(new ____590(____655.____661.team_quit, ____654.____672, index - 1))
            }
        };

        function kickoutTeamReturn(bytes) {
            var index = bytes.readByte();
            ____654.____672.dispatchEvent(new ____590(____655.____661.team_quit, ____654.____672, index - 1))
        };

        function teamInfoReturn(bytes) {
            var infoList = [null, null, null];
            var len = bytes.readByte();
            for (var i = 0; i < len; i++) {
                var playerInfo = new ____499();
                playerInfo.userId = bytes.readNumber();
                var index = bytes.readByte();
                playerInfo.career = bytes.readByte();
                playerInfo.combat = bytes.readInt();
                playerInfo.nick = bytes.readString();
                ____654.____685.____187(playerInfo, bytes);
                infoList[index - 1] = playerInfo
            }
            ____654.____672.dispatchEvent(new ____590(____655.____661.team_update, ____654.____672, infoList))
        };

        function shouhuInfoReturn(bytes) {
            var copyInfo = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.SHOUHU_COPYID);
            copyInfo.setNpcHp(bytes.readShort());
            copyInfo.setTeamInfo(bytes)
        };

        function copyMaxMissionReturn(bytes) {
            var copyId = bytes.readInt();
            var maxMission = bytes.readInt();
            var dayMission = bytes.readInt();
            ____655.statInfo.setCopyMission(copyId, maxMission, dayMission)
        };

        function monsterInfoReturn(bytes) {
            var leftMonster = bytes.readInt();
            var totalMonster = bytes.readInt();
            var info = ____655.copyInfo.currentCopyInfo;
            if (info != null) {
                info.updateMonster(leftMonster, totalMonster)
            }
        };

        function timeUpdateReturn(bytes) {
            var info = ____655.copyInfo.currentCopyInfo;
            var leftTime = bytes.readInt();
            var totalTime = bytes.readInt();
            if (info != null) {
                info.updateTime(leftTime, totalTime)
            }
        };

        function starComplateReturn(bytes) {
            var info = ____655.copyInfo.currentCopyInfo;
            var starNum = bytes.readUByte();
            print("---临时星星数量---", starNum);
            if (info != null) {
                info.currentStar = starNum
            }
        };

        function sweepComplateReturn(bytes) {
            var copySweepInfo = new CopySweepInfo();
            copySweepInfo.init(bytes);
            ____655.statInfo.addCopyEnterCount(copySweepInfo.copyId, 1);
            ____655.copyInfo.sweepComplate(copySweepInfo)
        };

        function bossUpdateReturn(bytes) {
            ____655.bossItemList.init(bytes)
        };

        function copyRestInfoReturn(bytes) {
            var len = bytes.readInt();
            for (var i = 0; i < len; i++) {
                var type = bytes.readInt();
                var resetNum = bytes.readUByte();
                if (type == ____655.allTemplates.copyTemplateList.SHENJIANG_TYPE) {
                    ____655.bossItemList.godBossRestNum = resetNum;
                    var l = bytes.readUByte();
                    for (var j = 0; j < l; j++) {
                        var copyId = bytes.readInt();
                        var monsterId = bytes.readInt();
                        var remainTime = bytes.readInt();
                        ____655.bossItemList.godBossList[copyId] = [monsterId, remainTime]
                    }
                } else if (type == ____655.allTemplates.copyTemplateList.TONGTIAN_TYPE) {
                    ____655.statInfo.setCopyReset(____655.allTemplates.copyTemplateList.TONGTIAN_COPYID, resetNum)
                }
            }
            ____654.____672.dispatchEvent(new ____590(____655.____661.copy_reset, ____654.____672, null))
        };

        function copyRestReturn(bytes) {
            var len = bytes.readUByte();
            for (var i = 0; i < len; i++) {
                var copyId = bytes.readInt();
                var num = bytes.readUByte();
                if (copyId == ____655.allTemplates.copyTemplateList.TONGTIAN_COPYID) {} else {
                    ____655.bossItemList.godBossRestNumList[copyId] = num;
                    ____655.bossItemList.infoReset()
                }
            }
        };

        function personBossUpdateReturn(bytes) {
            ____655.bossItemList.setPersonBossInfo(bytes)
        };

        function xuanshangUpdateReturn(bytes) {
            ____655.bossItemList.setXuanshangInfo(bytes)
        };
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_FINISH, copyFinishReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_ENTER, copyEnterReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_EXIT, copyExitReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_EXIT_PANEL, copyExitPanelReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_SHOWHU_UPDATE, copyShouhuUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_INFO_UPDATE, copyInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.BOSS_HURT_UPFATE, copyWorldBossInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.BOSS_SELFDAMAGE_UPDATE, bossSelfUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_ENTERCOUNT, copyEnterCountReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_STARCOUNT, copyStarCountReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_YAOQINGPLAYER, yaoqingPlayerReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.XUANSHANG_YAOQINGPLAYER, yaoqingPlayerReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_YAOQINGNOTICE, yaoqingNoticeReturn1);
        ____654.____680.addSocketHandler(____655.____659.____691.XUANSHANG_YAOQINGNOTICE, yaoqingNoticeReturn2);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_YAOQINGBACK, yaoqingBackReturn1);
        ____654.____680.addSocketHandler(____655.____659.____691.XUANSHANG_YAOQINGBACK, yaoqingBackReturn2);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_QUITTEAM, quitTeamReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.XUANSHANG_QUITTEAM, quitTeamReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_KICKOUTTEAM, kickoutTeamReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.XUANSHANG_KICKOUTTEAM, kickoutTeamReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_TEAMINFO, teamInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.XUANSHANG_TEAMINFO, teamInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.SHOUHU_INFO_UPDATE, shouhuInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_MAXMISSION, copyMaxMissionReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_MONSTERUPDATE, monsterInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_TIMEUPDATE, timeUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_STARCOMPLATE, starComplateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_SWEEP_COMPLATE, sweepComplateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_RESTINFO, copyRestInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_REST, copyRestReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.BOSS_UPDATE, bossUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_PERSONBOSS_INFO, personBossUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.XUANSHANG_INFO, xuanshangUpdateReturn)
    },
    sendEnterCopy: function(copyId, mission) {
        print("个人进入副本", copyId, mission);
        if (mission == null) {
            mission = 0
        }
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_ENTER);
        messOut.writeInt(copyId);
        messOut.writeShort(mission + 1);
        ____654.____680.send(messOut)
    },
    sendExitCopy: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_EXIT);
        ____654.____680.send(messOut)
    },
    sendStarAward: function(copyId, awardId) {
        print("#发送领奖", copyId, awardId);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_STARACCEPT);
        messOut.writeInt(copyId);
        messOut.writeInt(awardId);
        ____654.____680.send(messOut)
    },
    sendCopyAwardUpdate: function(copyId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_AWARDUPDATE);
        messOut.writeInt(copyId);
        ____654.____680.send(messOut)
    },
    sendTeamCreat: function(type, index) {
        var messOut = null;
        if (type == 1) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_CREATETEAM)
        } else if (type == 2) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.XUANSHANG_CREATETEAM);
            messOut.writeByte(index)
        }
        ____654.____680.send(messOut)
    },
    sendTeamPlayer: function(type, userId, index) {
        print("#邀请玩家", type, userId, index);
        var messOut = null;
        if (type == 1) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_YAOQINGPLAYER)
        } else if (type == 2) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.XUANSHANG_YAOQINGPLAYER)
        }
        messOut.writeNumber(userId);
        messOut.writeByte(index);
        ____654.____680.send(messOut)
    },
    sendTeamBack: function(type, userId, result) {
        print("#回应邀请", type, userId, result);
        var messOut = null;
        if (type == 1) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_YAOQINGBACK)
        } else if (type == 2) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.XUANSHANG_YAOQINGBACK)
        }
        messOut.writeNumber(userId);
        messOut.writeByte(result);
        ____654.____680.send(messOut)
    },
    sendTeamQuit: function(type) {
        print("#退出队伍", type);
        var messOut = null;
        if (type == 1) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_QUITTEAM)
        } else if (type == 2) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.XUANSHANG_QUITTEAM)
        }
        ____654.____680.send(messOut)
    },
    sendTeamKickout: function(type, index) {
        print("#踢出队伍", type, index);
        var messOut = null;
        if (type == 1) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_KICKOUTTEAM)
        } else if (type == 2) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.XUANSHANG_KICKOUTTEAM)
        }
        messOut.writeByte(index + 1);
        ____654.____680.send(messOut)
    },
    sendTeamInfo: function(type) {
        var messOut = null;
        if (type == 1) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_TEAMINFO)
        } else if (type == 2) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.XUANSHANG_TEAMINFO)
        }
        ____654.____680.send(messOut)
    },
    sendTeamEnterCopy: function(type, pos, teamType) {
        print("#队伍进入副本", type, pos, teamType);
        var messOut = null;
        if (type == 1) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_TEAMENTER)
        } else if (type == 2) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.XUANSHANG_TEAMENTER);
            messOut.writeByte(pos);
            messOut.writeByte(teamType)
        }
        ____654.____680.send(messOut)
    },
    sendStartMatch: function(copyId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_STARTMATCH);
        messOut.writeInt(copyId);
        ____654.____680.send(messOut)
    },
    sendEndMatch: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_ENDMATCH);
        ____654.____680.send(messOut)
    },
    sendMonsterUpdate: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_MONSTERUPDATE);
        ____654.____680.send(messOut)
    },
    sendTimeUpdate: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_TIMEUPDATE);
        ____654.____680.send(messOut)
    },
    sendShouhuUpdate: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_SHOWHU_UPDATE);
        ____654.____680.send(messOut)
    },
    sendSweepCopy: function(copyId, mission) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_SWEEP_COMPLATE);
        messOut.writeInt(copyId);
        messOut.writeInt(mission + 1);
        ____654.____680.send(messOut)
    },
    sendGetWorldBossInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.BOSS_UPDATE);
        ____654.____680.send(messOut)
    },
    sendCopyReset: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_REST);
        messOut.writeInt(type);
        ____654.____680.send(messOut)
    },
    sendCopyResetInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_RESTINFO);
        ____654.____680.send(messOut)
    },
    sendGetCopyInfo: function(list) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_INFO_UPDATE);
        messOut.writeByte(list.length);
        for (var i = 0; i < list.length; i++) {
            messOut.writeInt(list[i])
        }
        ____654.____680.send(messOut)
    },
    sendXuanshangFresh: function(index) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.XUANSHANG_FRESH);
        messOut.writeByte(index);
        ____654.____680.send(messOut)
    },
});
var FamilyTreasuresMessageSender = cc.Class.extend({
    add: function() {
        var this_ = this;

        function returnMessage1(bytes) {
            ____655.familyTreasuresInfo.updateBaseInfo(bytes)
        };

        function returnMessage2(bytes) {
            ____655.familyTreasuresInfo.updateMyTreasures(bytes)
        };

        function returnMessage3(bytes) {
            ____655.familyTreasuresInfo.updateHelpList(bytes)
        };
        ____654.____680.addSocketHandler(____655.____659.____691.FAMILY_TREASURES_BASE_INFO, returnMessage1);
        ____654.____680.addSocketHandler(____655.____659.____691.FAMILY_TREASURES_MY_TRE, returnMessage2);
        ____654.____680.addSocketHandler(____655.____659.____691.FAMILY_TREASURES_HELP_LIST, returnMessage3)
    },
    getBaseInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FAMILY_TREASURES_BASE_INFO);
        ____654.____680.send(messOut)
    },
    familyTreasuresFresh: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FAMILY_TREASURES_FRESH);
        ____654.____680.send(messOut)
    },
    openTreasures: function(index) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FAMILY_TREASURES_OPEN_TRE);
        messOut.writeByte(index);
        ____654.____680.send(messOut)
    },
    forHelp: function(id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FAMILY_TREASURES_FOR_HELP);
        messOut.writeShort(id);
        ____654.____680.send(messOut)
    },
    getAward: function(id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FAMILY_TREASURES_GET_AWARD);
        messOut.writeShort(id);
        ____654.____680.send(messOut)
    },
    getHelpAward: function() {
        print("协助奖励---");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FAMILY_TREASURES_GET_HELP_AWARD);
        ____654.____680.send(messOut)
    },
    helpWabao: function(userId, id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FAMILY_TREASURES_HELP_WABAO);
        messOut.writeNumber(userId);
        messOut.writeShort(id);
        ____654.____680.send(messOut)
    },
});
var ____2101 = cc.Class.extend({
    add: function() {
        var this_ = this;

        function fashionInfoReturn(bytes) {
            ____655.fashionInfo.init(bytes)
        };

        function fashionInfoReturn2(bytes) {
            ____655.fashionInfo.updateInfo(bytes)
        };

        function advanceUpdateReturn(bytes) {
            ____655.advanceItemList.init(bytes)
        };

        function useStarUpdateReturn(bytes) {
            var type = bytes.readShort();
            var currentHuaxing = bytes.readInt();
            ____655.fashionInfo.setHuaXing(type, currentHuaxing)
        };

        function petUpdateReturn(bytes) {
            ____655.advanceItemList.petInit(bytes)
        };

        function equipUpdateReturn(bytes) {
            ____655.advanceItemList.addEquipList(bytes)
        };

        function tuJianAwardRecordReturn(bytes) {
            ____655.fashionInfo.tuJianAwardRecordUpdate(bytes)
        };

        function soulInfoReturn(bytes) {
            ____655.advanceItemList.soulLevelUpdate(bytes)
        };
        ____654.____680.addSocketHandler(____655.____659.____691.ADVANCE_SOUL_UPDATE, soulInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TU_JIAN_GET_AWARD, tuJianAwardRecordReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ADVANCE_EQUIP_UPDATE, equipUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.FASHION_MOVEEQUIP, useStarUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.FASHION_INFO_LIST, fashionInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.FASHION_INFO, fashionInfoReturn2);
        ____654.____680.addSocketHandler(____655.____659.____691.ADVANCE_UPDATE, advanceUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PET_INFO_UPDATE, petUpdateReturn)
    },
    sendActive: function(type, templateId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FASHION_ACTIVE);
        messOut.writeInt(templateId);
        messOut.writeShort(type);
        ____654.____680.send(messOut)
    },
    sendUpStar: function(type, templateId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FASHION_UPSTAR);
        messOut.writeInt(templateId);
        messOut.writeShort(type);
        ____654.____680.send(messOut)
    },
    sendMoveEquip: function(templateId, starCount, advanceType, fashionType, operator) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FASHION_MOVEEQUIP);
        messOut.writeInt(templateId);
        messOut.writeShort(starCount);
        messOut.writeByte(advanceType);
        messOut.writeByte(fashionType);
        messOut.writeByte(operator);
        print(templateId, starCount, advanceType, fashionType, operator, "||||");
        ____654.____680.send(messOut)
    },
    sendAdvanceUp: function(type, isBuy) {
        var messOut;
        if (type == ____655.____659.commonStaticType.style_Pet) {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.PET_ADVANCE);
            messOut.writeBoolean(isBuy)
        } else {
            messOut = ____654.____680.getMessageOut(____655.____659.____691.ADVANCE_UPDATE);
            messOut.writeByte(type);
            messOut.writeBoolean(isBuy)
        }
        ____654.____680.send(messOut)
    },
    sendUseQnWx: function(type1, type2, count) {
        if (type1 == ____655.____659.commonStaticType.style_Pet) {
            var messOut = ____654.____680.getMessageOut(____655.____659.____691.PET_QN_WX);
            messOut.writeByte(type2);
            messOut.writeShort(count);
            ____654.____680.send(messOut)
        } else {
            var messOut = ____654.____680.getMessageOut(____655.____659.____691.ADVANCE_QN_WX);
            messOut.writeByte(type1);
            messOut.writeByte(type2);
            messOut.writeShort(count);
            ____654.____680.send(messOut)
        }
    },
    sendJihuo: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ADVANCE_JIHUO);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendJihuoPet: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PET_INFO_UPDATE);
        ____654.____680.send(messOut)
    },
    sendTuJianAward: function(type, templateId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TU_JIAN_GET_AWARD);
        messOut.writeInt(templateId);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendSoulLevelUp: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ADVANCE_SOUL_UPDATE);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
});
var HomeMessageSender = cc.Class.extend({
    add: function() {
        var this_ = this;

        function homeInfoHander(bytes) {
            ____655.homeInfo.updateHomeInfo(bytes);
            print("仙园信息！！！！！！！")
        };

        function homePersonInfoHander(bytes) {
            print("仙园单人信息！！！！！！！");
            ____655.homeInfo.updatePersonHomeInfo(bytes)
        };

        function homeLianDanRewardHander(bytes) {
            print("炼丹返回");
            var type = bytes.readByte();
            if (type == 0) {
                ____655.homeInfo.updateLianDanReward(bytes)
            } else {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomeMessageSender.text1"))
            }
        };

        function homeMessTipHandler(bytes) {
            var type = bytes.readByte();
            if (type == 1) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomeMessageSender.text2"))
            } else if (type == 2) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomeMessageSender.text3", ____655.allTemplates.homeTemplateList.MAX_STEAL - ____655.homeInfo.stealCount))
            }
        };

        function homeFriendDeletd(bytes) {
            ____655.homeInfo.friendDelete(bytes);
            print("仙园好友删除")
        };
        ____654.____680.addSocketHandler(____655.____659.____691.HOME_FRIEND_DELETE, homeFriendDeletd);
        ____654.____680.addSocketHandler(____655.____659.____691.HOME_TIP_FLAG, homeMessTipHandler);
        ____654.____680.addSocketHandler(____655.____659.____691.HOME_INFO, homeInfoHander);
        ____654.____680.addSocketHandler(____655.____659.____691.HOME_PERSON_INFO, homePersonInfoHander);
        ____654.____680.addSocketHandler(____655.____659.____691.HOME_LIANDAN_REWARD, homeLianDanRewardHander)
    },
    sendPlant: function(type, seedId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.HOME_SEED);
        messOut.writeByte(type);
        messOut.writeNumber(seedId);
        ____654.____680.send(messOut);
        print("sendPlant : function(type,seedId)", type, seedId)
    },
    sendLiandan: function(id, times) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.HOME_LIANDAN);
        messOut.writeInt(id);
        messOut.writeShort(times);
        ____654.____680.send(messOut);
        print("!!仙园炼丹", id, times)
    }
});
var LuckyTreasureMessageSender = cc.Class.extend({
    add: function() {
        function luckyTreasureReturn(bytes) {
            ____655.welfareInfo.setLuckyTreasureInfo(bytes)
        };

        function luckyTreasurePickReturn(bytes) {
            ____655.welfareInfo.setLuckyTreasurePickInfo(bytes)
        };
        ____654.____680.addSocketHandler(____655.____659.____691.LUKCY_TREASURE_INFO, luckyTreasureReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.LUKCY_TREASURE_PICK, luckyTreasurePickReturn)
    },
    sendPickAward: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.LUKCY_TREASURE_PICK);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendGetLuckyAward: function(index) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.LUKCY_TREASURE_GETAWARD);
        messOut.writeByte(index);
        ____654.____680.send(messOut)
    },
});
var MarryOathMessageSender = cc.Class.extend({
    add: function() {
        function marryInfoReturn(bytes) {
            ____655.marryOathInfo.marryInfoUpate(bytes)
        };

        function marryRequestReturn(bytes) {
            var type = bytes.readByte();
            if (type == 0) {
                ____654.tipsManager.quickTip.show("结缘请求已发出")
            } else if (type == 1) {
                ____654.tipsManager.quickTip.show("等级不够")
            } else if (type == 2) {
                ____654.tipsManager.quickTip.show("对方不在线")
            } else if (type == 3) {
                ____654.tipsManager.quickTip.show("对方不是好友")
            } else if (type == 4) {
                ____654.tipsManager.quickTip.show("不存在该戒指信息")
            } else if (type == 5) {
                ____654.tipsManager.quickTip.show("对方等级不足")
            } else if (type == 6) {
                ____654.tipsManager.quickTip.show("对方钻石不足")
            } else if (type == 7) {
                ____654.tipsManager.quickTip.show("当前已经结缘")
            } else if (type == 8) {
                ____654.tipsManager.quickTip.show("对方已经结缘")
            } else if (type == 9) {
                ____654.tipsManager.quickTip.show("对方拒绝结缘")
            } else if (type == 17) {
                ____654.tipsManager.quickTip.show("操作中,请稍后")
            }
        };

        function repleyReturn(bytes) {
            var userId = bytes.readNumber();
            var type = bytes.readByte();
            var name = bytes.readString();
            var isAA = bytes.readBoolean();
            ____654.____679.____155(____655.____659.____690.marryOath, [____655.____659.panelTabType.sheJiao_marryAccept, [userId, type, name, isAA]])
        };

        function marryBreakReturn(bytes) {
            var type = bytes.readByte();
            if (type == 1) {
                ____654.tipsManager.quickTip.show("铜币不足，解缘失败")
            }
        };

        function oathInfoReturn(bytes) {
            ____655.marryOathInfo.oathInfoUpdate(bytes)
        };

        function oathBrotherInfoReturn(bytes) {
            ____655.marryOathInfo.brotherInfoUpdate(bytes)
        };

        function oathRepleyReturn(bytes) {
            var info = {};
            info["firstId"] = bytes.readNumber();
            info["firstName"] = bytes.readString();
            info["firstCareer"] = bytes.readByte();
            info["otherId"] = bytes.readNumber();
            info["otherName"] = bytes.readString();
            info["otherCareer"] = bytes.readByte();
            info["type"] = bytes.readByte();
            info["pos"] = bytes.readByte();
            info["isAA"] = bytes.readByte();
            ____654.____679.____155(____655.____659.____690.marryOath, [____655.____659.panelTabType.sheJiao_oathAccept, info])
        };

        function oathRequestReturn(bytes) {
            var type = bytes.readByte();
            if (type == 0) {
                ____654.tipsManager.quickTip.show("结义请求已发出")
            } else if (type == 1) {
                ____654.tipsManager.quickTip.show("等级不够")
            } else if (type == 2) {
                ____654.tipsManager.quickTip.show("结义成员有人不在线")
            } else if (type == 3) {
                ____654.tipsManager.quickTip.show("结义成员不是好友")
            } else if (type == 4) {
                ____654.tipsManager.quickTip.show("不存在信物信息")
            } else if (type == 5) {
                ____654.tipsManager.quickTip.show("对方等级不足")
            } else if (type == 6) {
                ____654.tipsManager.quickTip.show("结义成员中有人钻石不足")
            } else if (type == 7) {
                ____654.tipsManager.quickTip.show("您当前已结义")
            } else if (type == 8) {
                ____654.tipsManager.quickTip.show("成员中有人已结义")
            } else if (type == 9) {
                ____654.tipsManager.quickTip.show("结义成员中有人拒绝结义")
            } else if (type == 10) {
                ____654.tipsManager.quickTip.show("结义称号超出五个字")
            } else if (type == 11) {
                ____654.tipsManager.quickTip.show("结义称号已存在")
            } else if (type == 12) {
                ____654.tipsManager.quickTip.show("结义的其他两位成员不能为同一个人")
            }
        };

        function oathBreakReturn(bytes) {
            var type = bytes.readByte();
            if (type == 1) {
                ____654.tipsManager.quickTip.show("铜币不足，解义失败")
            }
        };

        function oathSuccessReturn(bytes) {
            var type = bytes.readByte();
            ____654.tipsManager.quickTip.show("结义成功")
        };
        ____654.____680.addSocketHandler(____655.____659.____691.OATH_TIPS, oathSuccessReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.OATH_BROTHER_INFO, oathBrotherInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.OATH_REQUEST, oathRequestReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.OATH_REPLAY, oathRepleyReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.OATH_INFO, oathInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.OATH_DEVOICE, oathBreakReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MARRY_DIVORCE, marryBreakReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MARRY_REPLEY, repleyReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MARRY_REQUEST, marryRequestReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MARRY_INFOUPDATE, marryInfoReturn)
    },
    sendStrengthLevelUp: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MARRY_UP_LEVEL);
        ____654.____680.send(messOut)
    },
    sendMarryApply: function(userId, type, isAA) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MARRY_REQUEST);
        messOut.writeNumber(userId);
        messOut.writeByte(type);
        messOut.writeBoolean(isAA);
        ____654.____680.send(messOut)
    },
    sendIsAccept: function(isAccept, userId, type, needPrice) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MARRY_REPLEY);
        messOut.writeBoolean(isAccept);
        messOut.writeByte(type);
        messOut.writeNumber(userId);
        messOut.writeShort(needPrice);
        ____654.____680.send(messOut)
    },
    sendBreakMarry: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MARRY_DIVORCE);
        ____654.____680.send(messOut)
    },
    sendAdvanceRing: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MARRY_ADVANCED);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendOathApply: function(SecondId, ThridId, type, isAA) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.OATH_REQUEST);
        messOut.writeNumber(SecondId);
        messOut.writeNumber(ThridId);
        messOut.writeByte(type);
        messOut.writeBoolean(isAA);
        ____654.____680.send(messOut)
    },
    sendOathRepley: function(userId, isAccept, pos, needPrice) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.OATH_REPLAY);
        messOut.writeNumber(userId);
        messOut.writeBoolean(isAccept);
        messOut.writeByte(pos);
        messOut.writeInt(needPrice);
        ____654.____680.send(messOut)
    },
    sendBreakOath: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.OATH_DEVOICE);
        ____654.____680.send(messOut)
    },
    sendAdvanceXinWu: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.OATH_ADVANCE);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendGetBrotherInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.OATH_BROTHER_INFO);
        ____654.____680.send(messOut)
    },
});
var PlayerNoticeMessageSender = cc.Class.extend({
    add: function() {
        function PlayerNoticeReturn(bytes) {
            var noticeType = bytes.readShort();
            if (noticeType == 11) {
                var type = bytes.readByte();
                var starCount = bytes.readShort();
                var nick = bytes.readString();
                ____654.playerNoticeManager.advacneNotice(type, starCount, nick)
            } else if (noticeType == 42) {
                var bossId = bytes.readInt();
                var nick = bytes.readString();
                var len = bytes.readByte();
                var awardList = [];
                for (var i = 0; i < len; i++) {
                    var itemId = bytes.readInt();
                    var count = bytes.readShort();
                    var streng = bytes.readShort();
                    var starCount = bytes.readShort();
                    awardList.push([itemId, count, streng, starCount])
                }
                ____654.playerNoticeManager.worldBossBeSkill(nick, bossId, awardList)
            } else if (noticeType == 45) {
                ____654.playerNoticeManager.worldBossNotice(5)
            } else if (noticeType == 46) {
                ____654.playerNoticeManager.worldBossNotice(0)
            } else if (noticeType == 49) {
                var deadNick = bytes.readString();
                var attakNick = bytes.readString();
                var count = bytes.readShort();
                ____654.playerNoticeManager.warShutdown(attakNick, deadNick, count)
            } else if (noticeType == 50) {
                var nick = bytes.readString();
                var count = bytes.readShort();
                ____654.playerNoticeManager.warKillCount(nick, count)
            } else if (noticeType == 56) {
                var nick = bytes.readString();
                ____654.playerNoticeManager.tanbaoOpenBoxNotice(nick)
            } else if (noticeType == 57) {
                var nick = bytes.readString();
                ____654.playerNoticeManager.zhuoYaoKillBossNotice(nick)
            } else if (noticeType == 61) {
                var type = bytes.readByte();
                var clubName = bytes.readString();
                var monsterId = bytes.readInt();
                ____654.playerNoticeManager.getZhanQiNotice(type, clubName, monsterId)
            } else if (noticeType == 65) {
                var clubName = bytes.readString();
                var nick = bytes.readString();
                var propertyId = bytes.readByte();
                var propertyValue = bytes.readByte();
                ____654.playerNoticeManager.familyFightGuWuNotice(nick, clubName, propertyId, propertyValue)
            } else if (noticeType == 67) {
                var nick1 = bytes.readString();
                var nick2 = bytes.readString();
                var marryType = bytes.readByte();
                ____654.playerNoticeManager.marryNotice(nick1, nick2, marryType)
            } else if (noticeType == 80) {
                var nick1 = bytes.readString();
                var nick2 = bytes.readString();
                var nick3 = bytes.readString();
                var oathType = bytes.readByte();
                ____654.playerNoticeManager.oathNotice(nick1, nick2, nick3, oathType)
            } else if (noticeType == 94) {
                var nick = bytes.readString();
                var len = bytes.readByte();
                var itemList = [];
                for (var i = 0; i < len; i++) {
                    var itemId = bytes.readInt();
                    var count = bytes.readInt();
                    itemList.push([itemId, count])
                }
                ____654.playerNoticeManager.luckyChouJiangNotice(nick, itemList)
            } else if (noticeType == 95) {
                var nick = bytes.readString();
                var len = bytes.readByte();
                var itemList = [];
                for (var i = 0; i < len; i++) {
                    var itemId = bytes.readInt();
                    var count = bytes.readInt();
                    itemList.push([itemId, count])
                }
                var condition = bytes.readShort();
                ____654.playerNoticeManager.luckyGetJiangNotice(nick, itemList, condition)
            } else if (noticeType == 96) {
                var oldName = bytes.readString();
                var newName = bytes.readString();
                ____654.playerNoticeManager.playerRenameNotice(oldName, newName)
            } else if (noticeType == 97) {
                var nick = bytes.readString();
                var clubName = bytes.readString();
                ____654.playerNoticeManager.createClubNotice(nick, clubName)
            } else if (noticeType == 100) {
                var nick = bytes.readString();
                ____654.playerNoticeManager.zhanShenLoginNotice(nick)
            } else if (noticeType == 101) {
                var templateId = bytes.readInt();
                var nick = bytes.readString();
                ____654.playerNoticeManager.titleNotice(templateId, nick)
            } else if (noticeType == 102) {
                var nick = bytes.readString();
                var condition = bytes.readShort();
                ____654.playerNoticeManager.dailyFirstRechargeNotice(nick, condition)
            } else if (noticeType == 103) {
                var boxId = bytes.readInt();
                var name = bytes.readString();
                ____654.playerNoticeManager.familyTreasureNotice(name, boxId)
            } else {
                print("++++++++未处理公告类型：" + noticeType + "+++++++++")
            }
        };
        ____654.____680.addSocketHandler(____655.____659.____691.NOTICE_MESSAGE, PlayerNoticeReturn)
    },
});
var ____2102 = cc.Class.extend({
    add: function() {
        function jiaZuWarRankReturn(bytes) {
            ____655.rankInfo.initJiazuWarInfo(bytes)
        };

        function commonRankInfoReturn(bytes) {
            ____655.rankInfo.initRankInfo(bytes)
        };

        function copyRankInfoReturn(bytes) {
            ____655.rankInfo.initCopyYaotaRankInfo(bytes)
        };

        function douShenRankReturn(bytes) {
            ____655.rankInfo.initDoushenRank(bytes)
        };

        function douShenInfoReturn(bytes) {
            ____655.rankInfo.initDoushenInfo(bytes)
        };

        function wuShenRankReturn(bytes) {
            ____655.rankInfo.initWushenRank(bytes)
        };
        ____654.____680.addSocketHandler(____655.____659.____691.WUSHEN_RANK, wuShenRankReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.JIAZU_WAR_SIGNRANK, jiaZuWarRankReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COMMONRANK_INFO, commonRankInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPYRANK_BAZHU, copyRankInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.DOUSHEN_RANK, douShenRankReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.DOUSHEN_INFO, douShenInfoReturn)
    },
    sendGetWuShenRank: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WUSHEN_RANK);
        ____654.____680.send(messOut)
    },
    sendGetJiazuWarRank: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.JIAZU_WAR_SIGNRANK);
        messOut.writeByte(1);
        messOut.writeByte(5);
        ____654.____680.send(messOut)
    },
    sendGetDouShenWarRank: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.DOUSHEN_RANK);
        ____654.____680.send(messOut)
    },
    sendGetDouShenWarInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.DOUSHEN_INFO);
        ____654.____680.send(messOut)
    },
    sendGetRankInfo: function(type, page, count) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COMMONRANK_INFO);
        messOut.writeByte(type);
        messOut.writeByte(page);
        messOut.writeByte(count);
        ____654.____680.send(messOut)
    },
    sendCopyRankInfo: function(page, len) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPYRANK_BAZHU);
        messOut.writeByte(page);
        messOut.writeByte(len);
        ____654.____680.send(messOut)
    },
});
var ____2103 = cc.Class.extend({
    isFirstUpdateTask: true,
    add: function() {
        var this_ = this;

        function skillInitReturn(bytes) {
            var len = bytes.readInt();
            for (var mm = 0; mm < len; mm++) {
                var skillId = bytes.readInt();
                if (bytes.readBoolean()) {
                    var skill = ____655.skillItemList.getSkill(skillId);
                    var add = false;
                    if (skill == null) {
                        skill = new ____2050();
                        add = true;
                        skill.____54(skillId)
                    }
                    var lastUseTime = bytes.readNumber();
                    skill.level = bytes.readShort();
                    skill.setLastUseTime(lastUseTime);
                    if (add) {
                        ____655.skillItemList.addSkill(skill)
                    } else {
                        ____655.skillItemList.updateSkill(skill)
                    }
                } else {
                    ____655.skillItemList.removeSkill(skillId)
                }
            }
            ____655.skillItemList.skillListUpdate()
        };

        function taskUpdateReturn(bytes) {
            var len = bytes.readInt();
            for (var mm = 0; mm < len; mm++) {
                var groupId = bytes.readInt();
                var taskId = bytes.readInt();
                var isSubmit = bytes.readBoolean();
                var task = ____655.____670.____121(taskId);
                if (isSubmit) {
                    var completeInfo = new ____1958();
                    completeInfo.setTaskId(taskId);
                    completeInfo.isNewSubmit = bytes.readByte() == 2;
                    completeInfo.finishDate = bytes.readInt();
                    ____655.____670.removeTaskByGroupId(completeInfo.____55().groupId);
                    ____655.____670.removeCompleteTaskByGroupId(completeInfo.____55().groupId);
                    ____655.____670.addCompleteTask(completeInfo);
                    if (completeInfo.isNewSubmit) {
                        ____654.____672.dispatchEvent(new ____590(____655.____661.common_taskSubmit, ____654.____672, taskId));
                        if (completeInfo.____55().isAuto) {
                            ____655.allTemplates.taskTemplateList.handleSubmitTrigger(taskId)
                        }
                        if (completeInfo.____55().isAutoAccept()) {
                            ____655.____670.checkAutoAccept()
                        }
                    }
                } else {
                    if (task == null) {
                        task = new ____528();
                        task.setTaskId(taskId);
                        ____655.____670.removeTaskByGroupId(task.____55().groupId);
                        ____655.____670.removeCompleteTaskByGroupId(task.____55().groupId);
                        ____655.____670.____120(task)
                    }
                    task.isNewAccept = bytes.readByte() == 1;
                    task.____115(bytes.readString(), !this_.isFirstUpdateTask);
                    task.____117(this_.isFirstUpdateTask);
                    if (task.isNewAccept) {
                        ____654.____672.dispatchEvent(new ____590(____655.____661.common_taskAccept, ____654.____672, task))
                    }
                }
            }
            if (this_.isFirstUpdateTask == true) {
                ____655.____670.checkAutoAccept();
                ____654.____672.dispatchEvent(new ____590(____655.____661.common_taskSubmit, ____654.____672, null));
                this_.isFirstUpdateTask = false
            }
        };

        function taskResetReturn(bytes) {
            var len = bytes.readInt();
            for (var i = 0; i < len; i++) {
                var groupId = bytes.readInt();
                var taskId = bytes.readInt();
                ____655.____670.removeTaskByGroupId(groupId);
                ____655.____670.removeCompleteTaskByGroupId(groupId)
            }
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_taskSubmit, ____654.____672, null))
        };

        function itemPlaceUpdateReturn(bytes) {
            var len = bytes.readInt();
            var list = [];
            var doSortDispatch = false;
            for (var mm = 0; mm < len; mm++) {
                var itemId = bytes.readNumber();
                var exist = bytes.readBoolean();
                if (exist) {
                    var item = ____655.itemInfoList.getItemById(itemId);
                    var getType = bytes.readByte();
                    if (item == null) {
                        item = new ItemInfo();
                        item.id = itemId;
                        ____654.____685.setItem(item, bytes);
                        ____655.itemInfoList.____367(item);
                        doSortDispatch = true
                    } else {
                        var doSort = ____654.____685.setItem(item, bytes);
                        if (doSortDispatch == false) {
                            doSortDispatch = doSort
                        }
                    }
                    if (getType > 0) {
                        ____654.commonTick.addGetItemEffect(item.templateId, getType)
                    }
                } else {
                    doSortDispatch = true;
                    ____655.itemInfoList.removeItem(itemId)
                }
            }
            if (doSortDispatch) {
                ____655.itemInfoList.sortAndDispatch()
            }
            ____655.itemInfoList.countChangeDispatch()
        };

        function mailUpdateReturn(bytes) {
            var len = bytes.readUShort();
            for (var mm = 0; mm < len; mm++) {
                var id = bytes.readNumber();
                var mail = ____655.mailItemList.getMail(id);
                var exist = bytes.readBoolean();
                if (exist == true) {
                    if (mail == null) {
                        mail = new ____492();
                        mail.id = id;
                        ____655.mailItemList.addMail(mail)
                    }
                    mail.init(bytes)
                } else {
                    if (mail != null) {
                        ____655.mailItemList.____59(id)
                    }
                }
            }
            if (len > 0) {
                ____655.mailItemList.sortAndDispatch()
            }
        };

        function mailRemoveReturn(bytes) {
            var len = bytes.readUShort();
            for (var mm = 0; mm < len; mm++) {
                var id = bytes.readNumber();
                var mail = ____655.mailItemList.getMail(id);
                var isDel = bytes.readBoolean();
                if (mail != null && !isDel) {
                    ____655.mailItemList.____59(id)
                }
            }
            if (len > 0) {
                ____655.mailItemList.sortAndDispatch()
            }
        };

        function mailAttachReturn(bytes) {
            var len = bytes.readUShort();
            for (var mm = 0; mm < len; mm++) {
                var id = bytes.readNumber();
                var mail = ____655.mailItemList.getMail(id);
                var fetchState = bytes.readUByte();
                if (mail != null) {
                    mail.setFetchFlag(fetchState);
                    if (fetchState != 0) {
                        mail.setRead(true)
                    }
                }
            }
        };

        function friendListUpdateReturn(bytes) {
            var len = bytes.readUShort();
            for (var mm = 0; mm < len; mm++) {
                var id = bytes.readNumber();
                var friend = ____655.____668.getFriend(id);
                var friendState = bytes.readUByte();
                if (friendState == 1) {
                    if (friend == null) {
                        friend = new FriendInfo();
                        ____655.____668.addFriend(friend)
                    }
                    friend.setId(id);
                    friend.init(bytes);
                    if (len == 1) {
                        ____655.____668.addFriendDispatch(id)
                    }
                } else {
                    if (friend != null) {
                        ____655.____668.removeFriend(id);
                        ____655.____669.deleteChatById(id)
                    }
                    if (len == 1) {
                        ____655.____668.removeFriendDispatch(id)
                    }
                }
            }
            if (len > 0) {
                ____655.____668.sortAndDispatch()
            }
        };

        function friendStateUpdateReturn(bytes) {
            var friend = ____655.____668.getFriend(bytes.readNumber());
            friend.updateFriendState(bytes)
        };

        function friendOffLineMessageReturn(bytes) {
            var len = bytes.readByte();
            var list = [];
            for (var mm = 0; mm < len; mm++) {
                var userId = bytes.readNumber();
                var time = bytes.readNumber();
                var message = bytes.readString();
                list.push([userId, time, message])
            }
            ____655.____669.setOffLineMessage(list)
        };

        function friendRecommendListReturn(bytes) {
            var infoList = [];
            var len = bytes.readByte();
            for (var mm = 0; mm < len; mm++) {
                var userId = bytes.readNumber();
                var nick = bytes.readString();
                var level = bytes.readShort();
                var vipLevel = bytes.readShort();
                var combat = bytes.readInt();
                var serverId = bytes.readShort();
                var career = bytes.readByte();
                infoList.push([userId, nick, level, vipLevel, combat, serverId, career])
            }
            ____655.____668.setTuiJianList(infoList)
        };

        function friendResponseReturn(bytes) {
            var serverId = bytes.readShort();
            var userId = bytes.readNumber();
            var nick = bytes.readString();
            var vipLevel = bytes.readByte();
            var combat = bytes.readInt();
            var career = bytes.readByte();
            var isHandler = false;
            var info = [userId, nick, vipLevel, combat, serverId, career, isHandler];
            ____655.____668.addResponseInfo(info)
        };

        function friendRecommendCountReturn(bytes) {
            var count = bytes.readByte();
            ____655.____668.setTuiJianCount(count)
        };

        function titleListUpdateReturn(bytes) {
            var len = bytes.readInt();
            for (var mm = 0; mm < len; mm++) {
                var titleId = bytes.readInt();
                var isCurrent = bytes.readBoolean();
                var title = ____655.titleList.getTitle(titleId);
                if (title == null) {
                    title = new ____2058();
                    title.init(titleId, bytes.readInt());
                    ____655.titleList.addTitle(title)
                }
                if (isCurrent) {
                    ____655.titleList.setCurrentTitleId(titleId)
                }
            }
        };

        function moneyUpdateReturn(bytes) {
            ____655.____667.moneyInfo.____77(bytes)
        };

        function expUpdateReturn(bytes) {
            ____655.____667.setExp(bytes.readNumber())
        };

        function userUpdateReturn(bytes) {
            var selfPlayer = ____655.____667;
            if (selfPlayer == null) {
                return
            }
            ____654.____685.setPlyerPropertys(selfPlayer, bytes);
            selfPlayer.____75(bytes.readInt());
            selfPlayer.setXianwei(bytes.readUShort())
        };

        function titleChooseRetuen(bytes) {
            var titleTemplateId = bytes.readInt();
            ____655.titleList.setCurrentTitleId(titleTemplateId)
        };

        function feiXianInfoReturn(bytes) {
            ____655.feiXianInfo.____363(bytes)
        };

        function loginGiftInfoReturn(bytes) {
            ____655.openInfo.setLoginGiftInfo(bytes)
        };

        function openSelfInfoReturn(bytes) {
            ____655.openInfo.setOpenSelfInfo(bytes)
        };

        function welcomeAwardState(bytes) {
            ____655.statInfo.setWelcomeState(bytes)
        };

        function itemGetReturn(bytes) {
            var tempId = bytes.readInt();
            var count = bytes.readInt();
            var quality = bytes.readUByte();
            var qhLevel = bytes.readUByte();
            var item = ____655.allTemplates.____794.getItem(tempId);
            if (item == null || item.categoryId == ____655.____659.categoryType.DIAOLUOCOPPER) {
                return
            }
            var name = item.name;
            var colorQ = item.quality;
            if (____655.____659.categoryType.isWaiXingEquip(item.categoryId)) {
                name = ____654.yuyanbaoManager.getYuyanbao("OpenPanel.text12", ____655.____659.nameType.getChineseNumber2(____655.allTemplates.advanceTemplateList.getStageByStar(quality)), ____655.allTemplates.advanceTemplateList.getCurrentStar(quality)) + name;
                colorQ = item.quality + qhLevel;
                if (count > 1) {
                    name += (" x" + count.toString())
                }
            } else if (____655.____659.categoryType.isEquip(item.categoryId)) {
                if (qhLevel > 0) {
                    name += (" +" + qhLevel.toString())
                }
                colorQ = quality;
                if (count > 1) {
                    name += (" x" + count.toString())
                }
            } else {
                name += (" x" + count.toString())
            }
            ____655.____669.appendSystemItem("获得" + ____655.____659.____688.getColorStrByQuality(name, colorQ))
        };

        function renameReturn(bytes) {
            var type = bytes.readByte();
            var msg = bytes.readString();
            ____654.tipsManager.quickTip.show(msg)
        };

        function addFriendTipsReturn(bytes) {
            var type = bytes.readByte();
            if (type == 1) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2103.text1"))
            } else if (type == 2) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2103.text2"))
            } else if (type == 3) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2103.text3"))
            } else if (type == 4) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2103.text4"))
            }
        };
        ____654.____680.addSocketHandler(____655.____659.____691.ADD_FRIEND_TIPS, addFriendTipsReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.FRIEND_RECOMMEND_COUNT, friendRecommendCountReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.FRIEND_RESPONSE, friendResponseReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.RECOMMEND_FRIEND_LIST, friendRecommendListReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.FRIEND_OFF_LINE_MESSAGE, friendOffLineMessageReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.SKILL_INIT, skillInitReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.____777, taskUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TASK_RESET, taskResetReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ITEM_PLACE_UPDATE, itemPlaceUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.____769, mailUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.____770, mailRemoveReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MAIL_ATTACH, mailAttachReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.FRIEND_LIST_UPDATE, friendListUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.FRIEND_ONLINE_UPDATE, friendStateUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TITLE_LIST_UPDATE, titleListUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MONEY_UPDATE, moneyUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.EXP_UPDATE, expUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.UPDATE_USER_INFO, userUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TITLE_CHOOSE, titleChooseRetuen);
        ____654.____680.addSocketHandler(____655.____659.____691.FEIXIAN_INFO_UPDATE, feiXianInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.LOGINGIFT_INFO_UPDATE, loginGiftInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.OPEN_SELFINFO_UPDATE, openSelfInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.WELCOME_AWARD, welcomeAwardState);
        ____654.____680.addSocketHandler(____655.____659.____691.ITEM_GET_MSG, itemGetReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_RENAMW, renameReturn)
    },
    ____61: function() {
        this.isFirstUpdateTask = true
    },
    ____196: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.____775);
        messOut.writeInt(2147483647);
        ____654.____680.send(messOut)
    },
    sendMailRemove: function(list) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.____770);
        var len = list.length;
        messOut.writeShort(len);
        for (var i = 0; i < len; i++) {
            messOut.writeNumber(list[i])
        }
        ____654.____680.send(messOut)
    },
    sendMailAttach: function(list) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MAIL_ATTACH);
        var len = list.length;
        messOut.writeShort(len);
        for (var i = 0; i < len; i++) {
            messOut.writeNumber(list[i])
        }
        ____654.____680.send(messOut)
    },
    sendMailRed: function(id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MAIL_READ);
        messOut.writeNumber(id);
        ____654.____680.send(messOut)
    },
    sendMoveEquip: function(bagType, itemId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ITEM_MOVEEQUIP);
        messOut.writeByte(bagType);
        messOut.writeNumber(itemId);
        ____654.____680.send(messOut)
    },
    sendEquipFusion: function(itemId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ITEM_EQUIP_FUSION);
        messOut.writeNumber(itemId);
        ____654.____680.send(messOut)
    },
    sendUseItem: function(itemId, bagType, count) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ITEM_USE);
        messOut.writeNumber(itemId);
        messOut.writeByte(bagType);
        messOut.writeInt(count);
        ____654.____680.send(messOut)
    },
    sendSellItem: function(itemId, bagType, count) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ITEM_SELL);
        messOut.writeNumber(itemId);
        messOut.writeByte(bagType);
        messOut.writeInt(count);
        ____654.____680.send(messOut)
    },
    sendTaskAccept: function(taskId) {
        print("#接受任务", taskId);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TASK_ACCEPT);
        messOut.writeInt(taskId);
        ____654.____680.send(messOut)
    },
    sendTaskCancel: function(taskId) {
        print("#取消任务", taskId);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TASK_CANCEL);
        messOut.writeInt(taskId);
        ____654.____680.send(messOut)
    },
    sendTaskSubmit: function(taskId) {
        print("#提交任务", taskId);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TASK_SUBMIT);
        messOut.writeInt(taskId);
        ____654.____680.send(messOut)
    },
    sendTaskClientCount: function(taskId, count) {
        print("#客户端控制数量", taskId, count);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TASK_CLIENT);
        messOut.writeInt(taskId);
        messOut.writeByte(count);
        ____654.____680.send(messOut)
    },
    sendTaskQuick: function(taskId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TASK_QUICKFINISH);
        messOut.writeInt(taskId);
        ____654.____680.send(messOut)
    },
    sendDeleteFriend: function(userId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FRIEND_DELETE);
        messOut.writeNumber(userId);
        ____654.____680.send(messOut)
    },
    sendAddFriend: function(serverId, nick, flag) {
        var isFromTuiJian = 0;
        if (flag != null) {
            isFromTuiJian = flag
        }
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FRIEND_UPDATE);
        messOut.writeShort(serverId);
        messOut.writeByte(isFromTuiJian);
        messOut.writeString(nick);
        ____654.____680.send(messOut)
    },
    sendAcceptFriend: function(userId, isAgree) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.____779);
        messOut.writeNumber(userId);
        messOut.writeBoolean(isAgree);
        ____654.____680.send(messOut)
    },
    sendBatchAddFriend: function(isAgree, list) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.BATCH_FRIEND_ACCPET);
        messOut.writeByte(isAgree);
        var len = list.length;
        messOut.writeShort(len);
        for (var i = 0; i < len; i++) {
            var id = list[i];
            messOut.writeNumber(id)
        }
        ____654.____680.send(messOut)
    },
    sendGetTuiJianList: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.RECOMMEND_FRIEND_LIST);
        ____654.____680.send(messOut)
    },
    sendGetTuiJianCount: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FRIEND_RECOMMEND_COUNT);
        ____654.____680.send(messOut)
    },
    sendTitleChange: function(type, title) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TITLE_CHOOSE);
        messOut.writeByte(type);
        messOut.writeInt(title);
        ____654.____680.send(messOut)
    },
    sendFeiXianGetAward: function(type, day) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.FEIXIAN_GETAWARD);
        messOut.writeByte(type);
        messOut.writeByte(day);
        ____654.____680.send(messOut)
    },
    sendLoginGiftGetAward: function(openId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.LOGINGIFT_INFO_UPDATE);
        messOut.writeInt(openId);
        ____654.____680.send(messOut)
    },
    sendWelcomeAwardGet: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WELCOME_AWARD);
        ____654.____680.send(messOut)
    },
    sendRename: function(name) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PLAYER_RENAMW);
        messOut.writeString(name);
        ____654.____680.send(messOut)
    },
    sendOpenAwardGet: function(id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.OPENACTIVITY_GET_AWARD);
        messOut.writeInt(id);
        ____654.____680.send(messOut)
    },
});
var ____2104 = cc.Class.extend({
    add: function() {
        function onlineAwardInfoReturn(bytes) {
            ____655.statInfo.onlineAwardUpdate(bytes)
        }

        function shopInfoReturn(bytes) {
            var len = bytes.readInt();
            var idList = [];
            for (var i = 0; i < len; i++) {
                var shopItemId = bytes.readInt();
                var isAdd = ____655.statInfo.addShopItem(shopItemId, bytes.readInt());
                if (isAdd) {
                    idList.push(shopItemId)
                }
            }
            if (idList.length > 0) {
                ____655.statInfo.shopItemListUpdate(idList)
            }
        }

        function shopBuyReturn(bytes) {
            var success = bytes.readByte();
            if (success) {
                var shopItemId = bytes.readInt();
                var count = bytes.readInt();
                var shopItemTemplate = ____655.allTemplates.shopTemplateList.getShopItem(shopItemId);
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("statMessageSender.tip1"))
            }
        }
        ____654.____680.addSocketHandler(____655.____659.____691.ONLINE_AWARD_INFO, onlineAwardInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.SHOP_INFOS, shopInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.SHOP_BUY, shopBuyReturn)
    },
    sendOnlineAwardGet: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ONLINE_AWARD_GET);
        ____654.____680.send(messOut)
    },
    sendShopBuy: function(shopItemId, count) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.SHOP_BUY);
        messOut.writeInt(shopItemId);
        messOut.writeInt(count);
        ____654.____680.send(messOut)
    },
});
var ____2105 = cc.Class.extend({
    add: function() {
        var this_ = this;

        function strengthEquipResult(bytes) {
            ____655.itemInfoList.strengthResult(bytes)
        }

        function weaponInfoHandler(bytes) {
            ____655.furnaceInfo.updateWeaponSoul(bytes)
        }

        function weaponGodInfoHandler(bytes) {
            ____655.furnaceInfo.updateGodWeaponInfo(bytes)
        }

        function stoneInfoUpdateHandler(bytes) {
            ____655.furnaceInfo.updateStoneInfo(bytes)
        }

        function xilianResult(bytes) {
            ____655.furnaceInfo.xilianResult(bytes.readByte())
        }

        function potInfoResult(bytes) {
            var exp = bytes.readInt();
            var level = bytes.readShort();
            ____655.furnaceInfo.updatePotInfo(level, exp)
        }

        function godLiveResult(bytes) {
            var type = bytes.readByte();
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2105.text1", ____654.yuyanbaoManager.getYuyanbao("____2105.godType" + type)))
        }
        ____654.____680.addSocketHandler(____655.____659.____691.WEAPON_STONE_INFO, stoneInfoUpdateHandler);
        ____654.____680.addSocketHandler(____655.____659.____691.WEAPON_GOD_INFO, weaponGodInfoHandler);
        ____654.____680.addSocketHandler(____655.____659.____691.WEAPON_SOUL_INFO, weaponInfoHandler);
        ____654.____680.addSocketHandler(____655.____659.____691.ITEM_STRENGTH, strengthEquipResult);
        ____654.____680.addSocketHandler(____655.____659.____691.ITEM_XILIAN, xilianResult);
        ____654.____680.addSocketHandler(____655.____659.____691.WEAPON_POT_UPDATE, potInfoResult);
        ____654.____680.addSocketHandler(____655.____659.____691.WEAPON_GOD_LIVE, godLiveResult)
    },
    sendEquipStrength: function(itemId, stoneId, perfectId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ITEM_STRENGTH);
        messOut.writeNumber(itemId);
        messOut.writeNumber(stoneId);
        messOut.writeNumber(perfectId);
        ____654.____680.send(messOut)
    },
    sendWeaponSoulUp: function(level) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WEAPON_SOUL_UP);
        messOut.writeByte(level);
        ____654.____680.send(messOut)
    },
    sendWeaponGodUse: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WEAPON_GOD_USE);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendWeaponGadUp: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WEAPON_GOD_UP);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendStoneUp: function(equipType, stoneType, materialList) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WEAPON_STONE_UP);
        messOut.writeByte(equipType);
        messOut.writeByte(stoneType);
        var len = materialList.length;
        messOut.writeShort(len);
        for (var i = 0; i < len; i++) {
            messOut.writeNumber(materialList[i][0]);
            messOut.writeShort(materialList[i][1])
        }
        ____654.____680.send(messOut)
    },
    sendPotUpdate: function(list1, list2) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WEAPON_POT_UPDATE);
        var len1 = list1.length;
        var len2 = list2.length;
        messOut.writeShort(len1 + len2);
        print("熔炼装备数量：", len1 + len2);
        for (var i = 0; i < len1; i++) {
            messOut.writeNumber(list1[i][0]);
            messOut.writeShort(list1[i][1]);
            print("熔炼装备", list1[i][0], list1[i][1])
        }
        for (var i = 0; i < len2; i++) {
            messOut.writeNumber(list2[i][0]);
            messOut.writeShort(list2[i][1]);
            print("熔炼装备", list2[i][0], list2[i][1])
        }
        ____654.____680.send(messOut)
    },
});
var ____2106 = cc.Class.extend({
    add: function() {
        function activeCodeReturn(bytes) {
            var type = bytes.readUByte();
            ____655.welfareInfo.showActiveCodeTips(type)
        };

        function weekSignInfoReturn(bytes) {
            ____655.welfareInfo.weekSignInfoUpdate(bytes)
        };

        function monthCardInfoReturn(bytes) {
            ____655.welfareInfo.monthCardInfoUpdate(bytes)
        };

        function resRecoverInfoReturn(bytes) {
            var activityValue = bytes.readShort();
            var resHasBuy = bytes.readByte();
            ____655.welfareInfo.resRecoverInfoUpdate(activityValue, resHasBuy)
        };

        function kuozhanInfoReturn(bytes) {
            ____655.statInfo.setKuozhanGiftInfo(bytes.readByte())
        };

        function zhuanShuGiftInfoReturn(bytes) {
            var len = bytes.readByte();
            var infoList = [];
            for (var i = 0; i < len; i++) {
                var id = bytes.readInt();
                var count = bytes.readByte();
                infoList.push([id, count])
            }
            ____655.welfareInfo.zhuanShuGiftInfoUpdate(infoList)
        };
        ____654.____680.addSocketHandler(____655.____659.____691.ZHUANSHU_GIFT_INFO, zhuanShuGiftInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.RES_RECOVER_INFO, resRecoverInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.KUOZHAN_AWARD, kuozhanInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MONTH_CARD_INFO, monthCardInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.WEEK_SIGN_GET_AWARD, weekSignInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ACTIVE_CODE, activeCodeReturn)
    },
    sendGetSignAward: function(day) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WEEK_SIGN_GET_AWARD);
        messOut.writeByte(day);
        ____654.____680.send(messOut)
    },
    sendActiveCode: function(code) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ACTIVE_CODE);
        messOut.writeString(code);
        ____654.____680.send(messOut)
    },
    sendMonthCardAward: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MONTH_CARD_GET_AWARD);
        ____654.____680.send(messOut)
    },
    sendGetResRecoverAward: function(moneyType) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.RES_RECOVER_INFO);
        messOut.writeByte(moneyType);
        ____654.____680.send(messOut)
    },
    sendKuozhanAward: function(state) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.KUOZHAN_AWARD);
        messOut.writeByte(state);
        ____654.____680.send(messOut)
    },
});
var ____2107 = cc.Class.extend({
    ctor: function() {},
    checkCopy: function(copyId, missionIndex) {
        if (____655.copyInfo.currentId > 0 || ____655.allTemplates.mapTemplateList.canToCopy(____655.currentMapId) == false) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text1"));
            return false
        }
        var copyTemplateInfo = ____655.allTemplates.copyTemplateList.getCopy(copyId);
        if (copyTemplateInfo == null) {
            return false
        }
        var missionTemplateInfo = copyTemplateInfo.missions[missionIndex];
        if (missionTemplateInfo == null) {
            return false
        }
        if (____655.____667.level < missionTemplateInfo.needLevel) {
            ____654.tipsManager.quickTip.show(missionTemplateInfo.needLevel + "级可进入");
            return false
        }
        if (____655.____667.xianwei < missionTemplateInfo.needXianwei) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text3", ____655.____659.nameType.getXianweiName(missionTemplateInfo.needXianwei)));
            return false
        }
        if (missionTemplateInfo.needItems.length > 0) {
            for (var i = 0; i < missionTemplateInfo.needItems; i++) {
                var count = ____655.itemInfoList.getCountByTempId(missionTemplateInfo.needItems[0]);
                if (count < missionTemplateInfo.needItems[1]) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text4"));
                    return false
                }
            }
        }
        if (copyId != ____655.allTemplates.copyTemplateList.TONGTIAN_COPYID) {
            var statInfo = ____655.statInfo.statCopyList[copyId];
            if (statInfo != null && statInfo.currentEnterCount >= copyTemplateInfo.dayTimes) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text5"));
                return false
            }
        }
        if (!this.checkTime(copyId)) {
            ____654.tipsManager.quickTip.show("活动尚未开启");
            return false
        }
        return true
    },
    enterCopy: function(copyId, missionIndex) {
        if (this.checkCopy(copyId, missionIndex) == false) {
            return
        }
        print("发送进入副本", copyId, missionIndex);
        ____654.copyMessageSender.sendEnterCopy(copyId, missionIndex)
    },
    sweepCopy: function(copyId, missionIndex) {
        if (this.checkCopy(copyId, missionIndex) == false) {
            return
        }
        print("发送扫荡副本", copyId, missionIndex);
        ____654.copyMessageSender.sendSweepCopy(copyId, missionIndex)
    },
    exitCopy: function() {
        print("发送退出副本");
        ____654.copyMessageSender.sendExitCopy()
    },
    checkTime: function(copyId) {
        var timingInfo1 = this.getActivityInfo(copyId);
        if (timingInfo1 == null) {
            return true
        }
        var day = ____655.____662.getClientDate().getDay();
        if (day == 0) {
            day = 7
        }
        if (timingInfo1.day.indexOf(day) == -1) {
            return false
        }
        var passTime = ____655.____662.getZeroPassTime();
        if (passTime < timingInfo1.startTime || passTime > timingInfo1.endTime) {
            return false
        }
        return true
    },
    getActivityInfo: function(copyId) {
        if (copyId == ____655.allTemplates.copyTemplateList.ZUOYAO_COPYID) {
            return ____655.allTemplates.timingActivityTemplateList.____238(2)
        } else if (copyId == ____655.allTemplates.copyTemplateList.XUNBAO_COPYID) {
            return ____655.allTemplates.timingActivityTemplateList.____238(3)
        } else if (copyId == ____655.allTemplates.copyTemplateList.TGHJ_COPYID) {
            return ____655.allTemplates.timingActivityTemplateList.____238(5)
        } else if (copyId == ____655.allTemplates.copyTemplateList.DALUANDOU_COPYID) {
            return ____655.allTemplates.timingActivityTemplateList.____238(7)
        } else if (copyId == ____655.allTemplates.copyTemplateList.WUSHEN_COPYID) {
            return ____655.allTemplates.timingActivityTemplateList.____238(8)
        } else if (copyId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID) {
            return ____655.allTemplates.timingActivityTemplateList.____238(9)
        } else if (copyId == ____655.allTemplates.copyTemplateList.WANGZHE_COPYID) {
            return ____655.allTemplates.timingActivityTemplateList.____238(10)
        }
        return null
    },
});
var ____2108 = cc.Class.extend({
    ctor: function() {},
    useItem: function(itemInfo) {
        if (itemInfo.getCanUse(true) == false) {
            return
        }
        if (itemInfo.template.categoryId == ____655.____659.categoryType.BANGGONG && ____655.____667.clubId == 0) {
            ____654.tipsManager.quickTip.show("加入家族才能使用");
            return
        }
        if (itemInfo.template.triggers.length > 0) {
            ____654.triggerManager.handlerList(itemInfo.template.triggers);
            return
        }

        function sendUse(num) {
            ____654.selfDataMessageSender.sendUseItem(itemInfo.id, itemInfo.bagType, num)
        }
        if (itemInfo.template.canBatchUse && itemInfo.count > 1) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_showNumberPanel, ____654.____672, [2, itemInfo.template, itemInfo.template.sellPrice, itemInfo.template.sellType, itemInfo.count, itemInfo.count, this, sendUse]))
        } else {
            sendUse(1)
        }
    },
    useAdvanceEquip: function(itemInfo) {
        if (itemInfo == null) return;
        if (____655.____659.categoryType.isWaiXingEquip(itemInfo.template.categoryId)) {
            ____654.selfDataMessageSender.sendUseItem(itemInfo.id, itemInfo.bagType, 1)
        }
    },
    sellItem: function(itemInfo) {
        if (itemInfo == null) {
            return
        }

        function sendSell() {
            ____654.selfDataMessageSender.sendSellItem(itemInfo.id, itemInfo.bagType, itemInfo.count)
        }
        if (itemInfo.template.sellType == 0) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("itemTip.showTip1"));
            return
        }
        if (itemInfo.____57 > 2) {
            var str = "";
            if (itemInfo.template.sellPrice == 0) {
                str = ____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel5")
            } else {
                str = ____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel4")
            }
            ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("itemTip.showTip2", str, ____655.____659.____688.getColorStrByQuality(itemInfo.getName(), itemInfo.____57())), ____654.noAlertUtils.ITEMSELL, 0, this, sendSell, null, null)
        } else {
            sendSell()
        }
    },
});
var PlayerInfoTester = cc.Class.extend({
    getDataTime: 0,
    dispatchTime: 0,
    itemUpdateTime: 0,
    moneyUpdateTime: 0,
    dayUpdateTime: 0,
    shopUpdateTime: 0,
    advanceEquipList: null,
    roleEquipList: null,
    hunshiList: null,
    hunpoList: null,
    xianluCount: 0,
    danList: null,
    qianghuashiList: null,
    familyTreasuresList: null,
    baoshiList: null,
    tongXinJieCount: 0,
    jinLanPuCount: 0,
    _isShowPrint: false,
    openDay: 0,
    createDay: 0,
    day: 0,
    returnGiftNum: 0,
    loginGiftNum: 0,
    feixianGift1Num: 0,
    feixianGift2Num: 0,
    feixianGift3Num: 0,
    feixianGift4Num: 0,
    feixianGift5Num: 0,
    feixianGift6Num: 0,
    feixianGift7Num: 0,
    fudaiNum: 0,
    monthCardNum: 0,
    weekSignNum: 0,
    recoverNum: 0,
    vipGiftNum: 0,
    fasionNum: 0,
    weaponGodNum: 0,
    weaponStrengthNum: 0,
    weaponBaoshiNum: 0,
    wuhunNum: 0,
    rongluNum: 0,
    clubShenqingNum: 0,
    clubXinfaNum: 0,
    clubExpeditionNum: 0,
    clubTreeNum: 0,
    tujianSJNum: 0,
    tujianMWNum: 0,
    tujianSXNum: 0,
    tujianSBNum: 0,
    tujianBWNum: 0,
    tujianAwardNum: 0,
    huanZhuangAwardNum: 0,
    bagItemNum: 0,
    bagEquipNum: 0,
    riderNum: 0,
    petNum: 0,
    wingNum: 0,
    footNum: 0,
    fabaoNum: 0,
    zhenlingNum: 0,
    shenjianNum: 0,
    fashionRiderNum: 0,
    fashingPetNum: 0,
    fashingWingNum: 0,
    personBossNum: 0,
    shenjiangNum: 0,
    doushentanNum: 0,
    lilianNum: 0,
    copyXiuxianNum: 0,
    copyWaiguanNum: 0,
    copyCailiaoNum: 0,
    copyYaotaNum: 0,
    copyTongtianNum: 0,
    copyShouhuNum: 0,
    onlineNum: 0,
    hunpoRiderNum: 0,
    hunpoWindNum: 0,
    hunpoFaBaoNum: 0,
    hunpoZhenLingNum: 0,
    hunpoShenJianNum: 0,
    hunpoFootNum: 0,
    hunpoPetNum: 0,
    luckyTreasureNum: 0,
    marryNum: 0,
    oathNum: 0,
    homeNum: 0,
    copyXianJieNum: 0,
    tujianYaoJingNum: 0,
    familyTreasuresNum: 0,
    bossMaxTime: 0,
    xiuxianMaxTime: 0,
    jiazuzhanTime: 0,
    homeSeedTime: 0,
    quanminTime: 0,
    tiangongTime: 0,
    openChongBangNum: 0,
    ctor: function() {
        this.advanceEquipList = {};
        this.roleEquipList = [];
        this.hunshiList = {};
        this.hunpoList = {};
        this.xianluCount = 0;
        this.danList = {};
        this.qianghuashiList = {};
        this.familyTreasuresList = {};
        this.baoshiList = {};
        this.getData();
        this.openDay = ____655.____662.getOpenDayByCurrentTime();
        this.createDay = ____655.____662.getDayByCreatRoleTime();
        this.day = ____655.____662.getClientDate().getDay();
        if (this.day == 0) {
            this.day = 7
        }
        this.____6()
    },
    getData: function() {
        this.getDataTime = 0;
        ____654.____678.____298(this.getDataTick, this)
    },
    getDataTick: function(delta, count) {
        this.getDataTime++;
        if (this.getDataTime == 60) {
            ____654.rankMessageSender.sendGetDouShenWarInfo()
        } else if (this.getDataTime == 61) {
            ____655.allTemplates.openActivityTemplateList.updateList()
        } else if (this.getDataTime == 62) {
            ____654.copyMessageSender.sendCopyResetInfo()
        } else if (this.getDataTime == 63) {
            ____654.welfareMessageSender.sendKuozhanAward(1)
        } else if (this.getDataTime == 300) {
            this.checkAll()
        } else if (this.getDataTime > 300) {
            if (this.getDataTime % 1800 == 0) {
                this.checkTick()
            }
        }
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.____698, this.reconnectHandler, this);
        ____654.____672.addEventListener(____655.____661.playerInfo_selfInfo, this.playerInfoUpdate, this);
        ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.dayUpdate, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.itemsUpdate, this);
        ____655.____667.moneyInfo.addEventListener(____655.____661.____701, this.moneyUpdate, this);
        ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.dayUpdate, this);
        ____655.statInfo.addEventListener(____655.____661.stat_copyStat_update, this.copyStatUpdate, this);
        ____655.statInfo.addEventListener(____655.____661.stat_copyEnter_update, this.copyEnterUpdate, this);
        ____655.statInfo.addEventListener(____655.____661.stat_copyReset_update, this.copyResetUpdate, this);
        ____655.statInfo.addEventListener(____655.____661.stat_copyMission_update, this.copyMissionUpdate, this);
        ____655.copyInfo.addEventListener(____655.____661.copy_awardStateUpdate, this.copyAwardUpdate, this);
        ____655.statInfo.addEventListener(____655.____661.stat_shopList_update, this.shopListUpdate, this);
        ____655.statInfo.addEventListener(____655.____661.returnGiftInfo, this.checkReturnGift, this);
        ____655.openInfo.addEventListener(____655.____661.playerInfo_loginGiftInfo_Update, this.checkLoginGift, this);
        ____655.feiXianInfo.addEventListener(____655.____661.playerInfo_feiXianInfo_Update, this.checkFeixian, this);
        ____655.welfareInfo.addEventListener(____655.____661.welfare_MonthCardUpdate, this.checkMonthCard, this);
        ____655.welfareInfo.addEventListener(____655.____661.welfare_weekSignUpdate, this.checkWeekSign, this);
        ____655.welfareInfo.addEventListener(____655.____661.welfare_ResRecoverUpdate, this.checkRecover, this);
        ____655.____667.addEventListener(____655.____661.____704, this.checkVipGift, this);
        ____655.____667.addEventListener(____655.____661.playerInfo_club, this.updateClubInfo, this);
        ____655.statInfo.addEventListener(____655.____661.vip_awardUpdate, this.checkVipGift, this);
        ____655.rankInfo.addEventListener(____655.____661.common_rankDoushenInfoUpdate, this.checkDoushen, this);
        ____655.rankInfo.addEventListener(____655.____661.common_doushenCountUpdate, this.checkDoushen, this);
        ____655.activityInfo.addEventListener(____655.____661.activity_totalActivityUpdate, this.checkLilian, this);
        ____655.activityInfo.addEventListener(____655.____661.activity_awardUpdate, this.checkLilian, this);
        ____655.activityInfo.addEventListener(____655.____661.activity_infoUpdate, this.checkLilian, this);
        ____654.____672.addEventListener(____655.____661.copy_reset, this.checkShenjiangBoss, this);
        ____655.statInfo.addEventListener(____655.____661.stat_online_update, this.checkOnline, this);
        ____655.welfareInfo.addEventListener(____655.____661.luckyTreasure_infoUpdate, this.checkLuckyTreasure, this);
        ____655.marryOathInfo.addEventListener(____655.____661.marry_infoUpdate, this.checkCopyXianJie, this);
        ____655.marryOathInfo.addEventListener(____655.____661.oath_infoUpdate, this.checkCopyXianJie, this);
        ____655.clubInfo.addEventListener(____655.____661.club_info_update, this.checkClubTree, this);
        ____655.familyTreasuresInfo.addEventListener(____655.____661.familyTreasuresPopUpdate, this.familyTreasuresPopUpdate, this);
        ____655.openInfo.addEventListener(____655.____661.playerInfo_selfInfo_Update, this.checkOpenChongBang, this);
        ____654.____672.addEventListener(____655.____661.advance_infoUpdate, this.checkOpenChongBang, this)
    },
    reconnectHandler: function() {
        this.resetAllData()
    },
    playerInfoUpdate: function() {
        this.getData();
        this.openDay = ____655.____662.getOpenDayByCurrentTime();
        this.createDay = ____655.____662.getDayByCreatRoleTime();
        this.day = ____655.____662.getClientDate().getDay();
        if (this.day == 0) {
            this.day = 7
        }
    },
    familyTreasuresPopUpdate: function(evt) {
        var _num = 0;
        if (____655.____667.clubId != 0) {
            this.familyTreasuresList[evt.data[0]] = evt.data[1];
            for (var i in this.familyTreasuresList) {
                if (this.familyTreasuresList[i]) {
                    _num++
                }
            }
        }
        var isDifferentState = (this.familyTreasuresNum == 0 && _num != 0) || (this.familyTreasuresNum != 0 && _num == 0);
        if (isDifferentState) {
            this.familyTreasuresNum = _num;
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 68))
        }
    },
    updateClubInfo: function() {
        this.checkClubShenqing();
        this.checkClubXinfa();
        this.checkClubExpedition();
        this.checkClubTree()
    },
    checkAll: function() {
        this.itemsUpdate();
        this.checkReturnGift();
        this.checkLoginGift();
        this.checkFeixian();
        this.checkFudai();
        this.checkOpenChongBang();
        this.checkWeekSign();
        this.checkRecover();
        this.checkVipGift();
        this.checkClubXinfa();
        this.checkClubExpedition();
        this.checkCopyXianJie()
    },
    checkTick: function() {
        this.checkPersonBoss();
        this.checkTongzhi();
        this.checkHomeTip()
    },
    itemsUpdate: function(evt) {
        this.itemUpdateTime = 60;
        ____654.____678.____298(this.itemUpdateTick, this)
    },
    itemUpdateTick: function(delta, count) {
        this.itemUpdateTime--;
        if (this.itemUpdateTime > 0) {
            return
        }
        ____654.____678.____299(this.itemUpdateTick, this);
        this.advanceEquipList = {};
        this.roleEquipList = [];
        this.hunshiList = {};
        this.hunpoList = {};
        this.xianluCount = 0;
        this.danList = {};
        this.qianghuashiList = {};
        this.baoshiList = {};
        this.tongXinJieCount = 0;
        this.jinLanPuCount = 0;
        var list = ____655.itemInfoList.list;
        var autoEquipList = [];
        var autoCategoryIdList = [];
        var itemNum = 0;
        var equipNum = 0;
        for (var k in list) {
            var info = list[k];
            if (info == null) {
                continue
            }
            if (info.bagType == 4) {
                continue
            }
            var categoryId = info.template.categoryId;
            if (categoryId == ____655.____659.categoryType.HUNSHI) {
                if (this.hunshiList[info.templateId] == null) {
                    this.hunshiList[info.templateId] = 0
                }
                this.hunshiList[info.templateId] += info.count
            }
            if (categoryId == ____655.____659.categoryType.HUNPODAN) {
                if (this.hunpoList[info.templateId] == null) {
                    this.hunpoList[info.templateId] = 0
                }
                this.hunpoList[info.templateId] += info.count
            } else if (categoryId == ____655.____659.categoryType.QIANGHUASHI) {
                if (this.qianghuashiList[info.templateId] == null) {
                    this.qianghuashiList[info.templateId] = 0
                }
                this.qianghuashiList[info.templateId] += info.count
            } else if (categoryId == ____655.____659.categoryType.XIANLU) {
                this.xianluCount += info.count
            } else if (____655.____659.categoryType.isBaoshi(categoryId)) {
                if (this.baoshiList[categoryId] == null) {
                    this.baoshiList[categoryId] = 0
                }
                this.baoshiList[categoryId] += (info.count * info.template.propertys[3])
            } else if (____655.____659.categoryType.isWaiXingEquip(categoryId)) {
                if (this.advanceEquipList[categoryId] == null) {
                    this.advanceEquipList[categoryId] = []
                }
                this.advanceEquipList[categoryId].push(info)
            } else if (____655.____659.categoryType.isEquip(categoryId)) {
                this.roleEquipList.push(info);
                var curEquipInfo = ____655.itemInfoList.getBodyEquipByType(categoryId);
                if (curEquipInfo == null) {
                    if (autoCategoryIdList.indexOf(categoryId) < 0) {
                        autoEquipList.push(info);
                        autoCategoryIdList.push(categoryId)
                    }
                } else {
                    if (equipNum == 0) {
                        if (curEquipInfo.quality <= info.quality) {
                            equipNum = 1
                        }
                    }
                }
            } else if (categoryId >= ____655.____659.categoryType.JINJIEDAN[0] && categoryId <= ____655.____659.categoryType.FEISHENG[7]) {
                if (this.danList[categoryId] == null) {
                    this.danList[categoryId] = 0
                }
                this.danList[categoryId] += info.count
            } else if (categoryId == ____655.____659.categoryType.TONGXINJIE) {
                this.tongXinJieCount += info.count
            } else if (categoryId == ____655.____659.categoryType.JINLANPU) {
                this.jinLanPuCount += info.count
            }
            if (info.bagType == 1) {
                itemNum = 1
            }
        }
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_testerItemUpdate, ____654.____672, null));
        for (var z = 0; z < autoEquipList.length; z++) {
            ____654.selfDataMessageSender.sendMoveEquip(autoEquipList[z].bagType, autoEquipList[z].id)
        }
        this.checkStrength();
        this.checkBaoshi();
        this.checkFashion();
        this.checkClubTree();
        this.checkRider();
        this.checkPet();
        this.checkWing();
        this.checkFoot();
        this.checkFabao();
        this.checkZhenling();
        this.checkShenjian();
        this.checkHunPo();
        this.checkTujianAward();
        this.checkHuanZhuangAward();
        this.checkRonglu();
        this.checkLuckyTreasure();
        this.checkMarryLevelUp();
        this.checkOathLevelUp();
        if (itemNum != this.bagItemNum) {
            this.bagItemNum = itemNum;
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 32))
        }
        if (equipNum != this.bagEquipNum) {
            this.bagEquipNum = equipNum;
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 33))
        }
    },
    moneyUpdate: function(evt) {
        this.moneyUpdateTime = 60;
        ____654.____678.____298(this.moneyUpdateTick, this)
    },
    moneyUpdateTick: function(delta, count) {
        this.moneyUpdateTime--;
        if (this.moneyUpdateTime > 0) {
            return
        }
        ____654.____678.____299(this.moneyUpdateTick, this);
        this.checkReturnGift();
        this.checkClubXinfa();
        this.checkWuhun()
    },
    dayUpdate: function(evt) {
        this.dayUpdateTime = 60;
        ____654.____678.____298(this.dayUpdateTick, this)
    },
    dayUpdateTick: function(delta, count) {
        this.dayUpdateTime--;
        if (this.dayUpdateTime > 0) {
            return
        }
        ____654.____678.____299(this.dayUpdateTick, this);
        this.openDay = ____655.____662.getOpenDayByCurrentTime();
        this.createDay = ____655.____662.getDayByCreatRoleTime();
        this.day = ____655.____662.getClientDate().getDay();
        if (this.day == 0) {
            this.day = 7
        }
        this.checkLoginGift();
        this.checkFeixian();
        this.checkFudai();
        this.checkOpenChongBang();
        this.checkWeekSign()
    },
    copyStatUpdate: function(evt) {
        this.checkClubExpedition();
        this.checkCopyXiuxian();
        this.checkCopyWaiguan();
        this.checkCopyCailiao();
        this.checkCopyYatao();
        this.checkCopyTongtian();
        this.checkCopyShouhu();
        this.checkCopyXianJie();
        this.checkPersonBoss()
    },
    copyEnterUpdate: function(evt) {
        var copyId = evt.data;
        if (copyId == ____655.allTemplates.copyTemplateList.clubExpeditionCopyList[0]) {
            this.checkClubExpedition()
        } else if (copyId == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
            this.checkCopyXiuxian()
        } else if (copyId == ____655.allTemplates.copyTemplateList.WAIGUAN_COPYID) {
            this.checkCopyWaiguan()
        } else if (copyId == ____655.allTemplates.copyTemplateList.CAILIAO_COPYID) {
            this.checkCopyCailiao()
        } else if (copyId == ____655.allTemplates.copyTemplateList.SHOUHU_COPYID) {
            this.checkCopyShouhu()
        } else if (copyId == ____655.allTemplates.copyTemplateList.XIANYUAN_COPYID || copyId == ____655.allTemplates.copyTemplateList.JIEYI_COPYID) {
            this.checkCopyXianJie()
        }
    },
    copyResetUpdate: function(evt) {
        var copyId = evt.data;
        if (copyId == ____655.allTemplates.copyTemplateList.TONGTIAN_COPYID) {
            this.checkCopyTongtian()
        }
    },
    copyMissionUpdate: function(evt) {
        var copyId = evt.data;
        if (copyId == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
            this.checkCopyXiuxian()
        } else if (copyId == ____655.allTemplates.copyTemplateList.TONGTIAN_COPYID) {
            this.checkCopyTongtian()
        } else if (copyId == ____655.allTemplates.copyTemplateList.YAOTA_COPYID) {
            this.checkCopyYatao()
        }
    },
    copyAwardUpdate: function(evt) {
        var copyId = evt.data;
        if (copyId == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
            this.checkCopyXiuxian()
        } else if (copyId == ____655.allTemplates.copyTemplateList.YAOTA_COPYID) {
            this.checkCopyYatao()
        }
    },
    shopListUpdate: function(evt) {
        this.shopUpdateTime = 60;
        ____654.____678.____298(this.shopUpdateTick, this)
    },
    shopUpdateTick: function(delta, count) {
        this.shopUpdateTime--;
        if (this.shopUpdateTime > 0) {
            return
        }
        ____654.____678.____299(this.shopUpdateTick, this);
        this.checkFudai()
    },
    checkReturnGift: function() {
        var num = 0;
        if (____655.statInfo.returnGiftInfo.isLeftGetAward == 0 || (____655.statInfo.returnGiftInfo.isRightGetAward == 0 && ____655.____667.moneyInfo.getTodayRecharge() > 0)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<回归礼包检测>", num)
        }
        if (this.returnGiftNum == num) {
            return
        }
        this.returnGiftNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 1))
    },
    checkLoginGift: function() {
        var num = 0;
        if (this.openDay < 8) {
            num = 1;
            for (var i = 0; i < ____655.openInfo.loginGiftAwardList.length; i++) {
                if (____655.openInfo.loginGiftAwardList[i] == this.openDay) {
                    num = 0;
                    break
                }
            }
        }
        if (this._isShowPrint) {
            print("<七天登录检测>", num)
        }
        if (this.loginGiftNum == num) {
            return
        }
        this.loginGiftNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 2))
    },
    checkFeixian: function() {
        var numList = [0, 0, 0, 0, 0, 0, 0];
        if (this.createDay < 8) {
            var itemGetAward = ____655.feiXianInfo.itemGetAward;
            var viewGetAward = ____655.feiXianInfo.viewGetAward;
            var conditionList = ____655.feiXianInfo.conditionList;
            for (var i = 0; i < this.createDay; i++) {
                if (viewGetAward.indexOf(i + 1) != -1) {
                    continue
                }
                var info = [];
                var tempInfo = ____655.allTemplates.feiXianTemplateList.infoList[i + 1];
                var weekDay = ____655.____662.getDate(____655.____667.createRoleTime).getDay();
                weekDay = (weekDay + i) % 7;
                if (weekDay == 0) {
                    weekDay = 7
                }
                for (var k = 0; k < tempInfo.length; k++) {
                    if (tempInfo[k].weeks == 0 || (tempInfo[k].weeks > 0 && tempInfo[k].weeks == weekDay)) {
                        info.push(tempInfo[k])
                    }
                }
                var hasGetAwardNum = 0;
                var hasNums = 0;
                for (var j = 0; j < info.length; j++) {
                    if (conditionList[info[j].type] != null) {
                        hasNums = conditionList[info[j].type];
                        if (hasNums >= info[j].condition && itemGetAward.indexOf(info[j].type) == -1) {
                            numList[i] = 1
                        }
                    }
                    if (itemGetAward.indexOf(info[j].type) != -1) {
                        hasGetAwardNum = hasGetAwardNum + 1
                    }
                }
                if (hasGetAwardNum >= 4) {
                    numList[i] = 1
                }
            }
        }
        if (numList[0] != this.feixianGift1Num) {
            this.feixianGift1Num = numList[0];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 3))
        }
        if (numList[1] != this.feixianGift2Num) {
            this.feixianGift2Num = numList[1];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 4))
        }
        if (numList[2] != this.feixianGift3Num) {
            this.feixianGift3Num = numList[2];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 5))
        }
        if (numList[3] != this.feixianGift4Num) {
            this.feixianGift4Num = numList[3];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 6))
        }
        if (numList[4] != this.feixianGift5Num) {
            this.feixianGift5Num = numList[4];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 7))
        }
        if (numList[5] != this.feixianGift6Num) {
            this.feixianGift6Num = numList[5];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 8))
        }
        if (numList[6] != this.feixianGift7Num) {
            this.feixianGift7Num = numList[6];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 9))
        }
        if (this._isShowPrint) {
            print("<飞仙成尊检测>", numList[0], numList[1], numList[2], numList[3], numList[4], numList[5], numList[6])
        }
    },
    checkOpenChongBang: function(evt) {
        if (____655.____667.level < ____655.____659.levelType.openLevel) {
            return
        }
        var num = 0;
        if (this.openDay < 8) {
            var openDayList = [____655.____659.commonStaticType.style_Horse, ____655.____659.commonStaticType.style_Pet, ____655.____659.commonStaticType.style_Wind, ____655.____659.commonStaticType.style_Foot, ____655.____659.commonStaticType.style_FaBao, ____655.____659.commonStaticType.style_ZhengLing, ____655.____659.commonStaticType.style_ShenJian];
            var day = ____655.____662.getClientDate().getDay();
            if (day == 0) {
                day = 7
            }
            if (evt != null && evt.data != null && (openDayList.indexOf(evt.data.type) + 1) != day) {
                return
            }
            var tabList = ____655.allTemplates.openActivityTemplateList.typeList;
            if (tabList != null) {
                var chgTypeList = [];
                var infoList = [];
                var stage = 0;
                for (var i = 0; i < tabList.length; i++) {
                    if (tabList[i] >= 3 && tabList[i] <= 9) {
                        if (tabList[i] == 3) {
                            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Horse) != null) {
                                stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Horse).starCount
                            } else {
                                stage = 0
                            }
                        } else if (tabList[i] == 4) {
                            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Pet) != null) {
                                stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Pet).starCount
                            } else {
                                stage = 0
                            }
                        } else if (tabList[i] == 5) {
                            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Wind) != null) {
                                stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Wind).starCount
                            } else {
                                stage = 0
                            }
                        } else if (tabList[i] == 6) {
                            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Foot) != null) {
                                stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Foot).starCount
                            } else {
                                stage = 0
                            }
                        } else if (tabList[i] == 7) {
                            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_FaBao) != null) {
                                stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_FaBao).starCount
                            } else {
                                stage = 0
                            }
                        } else if (tabList[i] == 8) {
                            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ZhengLing) != null) {
                                stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ZhengLing).starCount
                            } else {
                                stage = 0
                            }
                        } else if (tabList[i] == 9) {
                            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ShenJian) != null) {
                                stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ShenJian).starCount
                            } else {
                                stage = 0
                            }
                        }
                        infoList = ____655.openInfo.getInfoByShowType(tabList[i]);
                        for (var i = 0; i < infoList.length; i++) {
                            var selfInfo = ____655.openInfo.getSelfInfoById(infoList[i].id);
                            if (selfInfo == null) {
                                if (stage >= parseInt(infoList[i].conditionList)) {
                                    num = 1;
                                    break
                                }
                            }
                        }
                    }
                }
                if (this.openChongBangNum != num) {
                    this.openChongBangNum = num;
                    ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 70))
                }
            }
        }
    },
    checkFudai: function() {
        if (____655.____667.level < ____655.____659.levelType.openLevel) {
            return
        }
        var num = 0;
        if (this.openDay < 8) {
            var systemTime = ____655.____662.getSystemTimeSec();
            var infoList = ____655.allTemplates.shopTemplateList.getShopTempListByType(____655.allTemplates.shopTemplateList.shopType_10);
            for (var i = 0; i < infoList.length; i++) {
                var info = infoList[i];
                var beginSecond = ____655.____662.getTimesByDay(info.beginDay);
                var finishSecond = ____655.____662.getTimesByDay(info.endDay);
                if ((((this.openDay - 1) % 7) + 1) == info.weekDay && finishSecond > systemTime && beginSecond <= systemTime && info.endDate > systemTime && info.beginDate <= systemTime) {
                    var limitInfo = ____655.statInfo.statShopItemList[info.id];
                    if (limitInfo == null || info.limitBuyCount > limitInfo.hasBuyCount) {
                        this.fudaiNum = 1;
                        break
                    }
                }
            }
        }
        if (this._isShowPrint) {
            print("<福袋购买检测>", num)
        }
        if (this.fudaiNum == num) {
            return
        }
        this.fudaiNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 10))
    },
    checkMonthCard: function() {
        var num = 0;
        var day = ____655.welfareInfo.monthCardDays;
        if (day > 0) {
            if (____655.welfareInfo.monthCardIsHasGot == 1) {
                num = 1
            }
        }
        if (this._isShowPrint) {
            print("<至尊月卡检测>", num)
        }
        if (this.monthCardNum == num) {
            return
        }
        this.monthCardNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 11))
    },
    checkWeekSign: function() {
        var num = 0;
        if (____655.welfareInfo.weekSignHasGotList.indexOf(this.day) == -1) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<每周签到检测>", num)
        }
        if (this.weekSignNum == num) {
            return
        }
        this.weekSignNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 12))
    },
    checkRecover: function() {
        if (____655.____667.xianwei <= 1) {
            return
        }
        var num = 0;
        if (____655.welfareInfo.resHasBuy == 0) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<资源找回检测>", num)
        }
        if (this.recoverNum == num) {
            return
        }
        this.recoverNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 13))
    },
    checkVipGift: function() {
        var num = 0;
        var vipLevel = ____655.____667.vipLevel;
        for (var i = 1; i <= vipLevel; i++) {
            if (____655.statInfo.vipGetAwardList[i] == null) {
                num = 1;
                break
            }
        }
        if (this._isShowPrint) {
            print("<VIP礼包检测>", num)
        }
        if (this.vipGiftNum == num) {
            return
        }
        this.vipGiftNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 14))
    },
    checkFashion: function() {
        if (____655.____667.level < ____655.____659.levelType.waiguanLevel) {
            return
        }
        var numList = {};
        var list = ____655.allTemplates.fashionTemplateList.list;
        for (var k in list) {
            var info = list[k];
            var starLevel = 0;
            var selfInfo = null;
            if (info.carrer != 0 && info.carrer != ____655.____667.career) {
                continue
            }
            if (info.type == 1 || info.type == 2 || info.type == 3) {
                if (numList[1] != null) {
                    continue
                }
                selfInfo = ____655.furnaceInfo.getGodWeaponInfoByType(info.type);
                if (selfInfo == null) {
                    continue
                }
                starLevel = selfInfo.level
            } else {
                if (numList[info.type] != null) {
                    continue
                }
                selfInfo = ____655.fashionInfo.getFashionInfo(info.type, info.templateId);
                if (selfInfo != null) {
                    starLevel = selfInfo.star
                }
            }
            if (starLevel >= info.maxStars) {
                continue
            }
            var needItem = info.stars[starLevel + 1].needItems[0];
            if (needItem != null) {
                if (this.hunshiList[needItem[0]] >= needItem[1]) {
                    if (info.type == 1 || info.type == 2 || info.type == 3) {
                        numList[1] = 1
                    } else {
                        numList[info.type] = 1
                    }
                }
            }
        }
        if (numList[1] == null) {
            numList[1] = 0
        }
        if (numList[1] != this.weaponGodNum) {
            this.weaponGodNum = numList[1];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 16))
        }
        if (numList[20] == null) {
            numList[20] = 0
        }
        if (numList[20] != this.fasionNum) {
            this.fasionNum = numList[20];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 15))
        }
        if (numList[21] == null) {
            numList[21] = 0
        }
        if (numList[21] != this.fashionRiderNum) {
            this.fashionRiderNum = numList[21];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 41))
        }
        if (numList[23] == null) {
            numList[23] = 0
        }
        if (numList[23] != this.fashingPetNum) {
            this.fashingPetNum = numList[23];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 42))
        }
        if (numList[22] == null) {
            numList[22] = 0
        }
        if (numList[22] != this.fashingWingNum) {
            this.fashingWingNum = numList[22];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 43))
        }
        if (numList[10001] == null) {
            numList[10001] = 0
        }
        if (numList[10001] != this.tujianSJNum) {
            this.tujianSJNum = numList[10001];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 25))
        }
        if (numList[10002] == null) {
            numList[10002] = 0
        }
        if (numList[10002] != this.tujianMWNum) {
            this.tujianMWNum = numList[10002];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 26))
        }
        if (numList[10003] == null) {
            numList[10003] = 0
        }
        if (numList[10003] != this.tujianSXNum) {
            this.tujianSXNum = numList[10003];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 27))
        }
        if (numList[10004] == null) {
            numList[10004] = 0
        }
        if (numList[10004] != this.tujianSBNum) {
            this.tujianSBNum = numList[10004];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 28))
        }
        if (numList[10005] == null) {
            numList[10005] = 0
        }
        if (numList[10005] != this.tujianBWNum) {
            this.tujianBWNum = numList[10005];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 29))
        }
        if (numList[11001] == null) {
            numList[11001] = 0
        }
        if (numList[11001] != this.tujianYaoJingNum) {
            this.tujianYaoJingNum = numList[11001];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 67))
        }
        if (this._isShowPrint) {
            print("<时装幻骑幻宠幻羽升星检测>", numList[1], numList[20], numList[21], numList[22], numList[23], numList[10001], numList[10002], numList[10003], numList[10004], numList[10005])
        }
    },
    checkStrength: function() {
        if (____655.____667.level < ____655.____659.levelType.strengthLevel) {
            return
        }
        var num = 0;
        var passCount = 0;
        var list = ____655.itemInfoList.bagTypeList[4];
        for (var i = 0; i < list.length; i++) {
            var itemInfo = list[i];
            if (itemInfo == null) {
                continue
            }
            var costTemplateInfo = ____655.allTemplates.strengthCostTemplateList.getCost(itemInfo.qhLevel + 1);
            if (costTemplateInfo != null) {
                if (!____655.____667.moneyInfo.moneyEnoughByType(3, costTemplateInfo.needCopper)) {
                    continue
                }
                for (var j = 0; j < costTemplateInfo.items.length; j++) {
                    var count = this.qianghuashiList[costTemplateInfo.items[j][0]];
                    if (count == null) {
                        count = 0
                    }
                    if (count < costTemplateInfo.items[j][1]) {
                        break
                    } else {
                        passCount = passCount + 1
                    }
                }
                if (passCount == costTemplateInfo.items.length) {
                    num = 1;
                    break
                }
            }
        }
        if (this._isShowPrint) {
            print("<装备强化检测>", num)
        }
        if (this.weaponStrengthNum == num) {
            return
        }
        this.weaponStrengthNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 17))
    },
    checkBaoshi: function() {
        if (____655.____667.level < ____655.____659.levelType.baoshiLevel) {
            return
        }
        var num = 0;
        var list = ____655.itemInfoList.bagTypeList[4];
        for (var i = 0; i < list.length; i++) {
            var itemInfo = list[i];
            if (itemInfo == null) {
                continue
            }
            var baoshiEquipTemplate = ____655.allTemplates.baoShiEquipTemplateList.getTemplateInfoByType(itemInfo.template.categoryId);
            if (baoshiEquipTemplate == null) {
                continue
            }
            for (var j = 0; j < baoshiEquipTemplate.baoshiList.length; j++) {
                var stoneType = baoshiEquipTemplate.baoshiList[j][0];
                var openLevel = baoshiEquipTemplate.baoshiList[j][1];
                if (____655.____667.level >= openLevel) {
                    var exp = ____655.furnaceInfo.getStoneExpByType(itemInfo.template.categoryId, stoneType);
                    var nextTemplate = ____655.allTemplates.baoShiTemplateList.getNextTemplateByTypeAndExp(stoneType, exp);
                    if (nextTemplate != null) {
                        var needExp = nextTemplate.needExp - exp;
                        var itemType = ____655.allTemplates.____794.getItem(nextTemplate.itemList[0]).categoryId;
                        if (needExp <= this.baoshiList[itemType]) {
                            num = 1;
                            break
                        }
                    }
                }
            }
        }
        if (this._isShowPrint) {
            print("<宝石升级检测>", num)
        }
        if (this.weaponBaoshiNum == num) {
            return
        }
        this.weaponBaoshiNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 18))
    },
    checkWuhun: function() {
        if (____655.____667.level < ____655.____659.levelType.wuhunLevel) {
            return
        }
        var num = 0;
        var copper = ____655.____667.moneyInfo.list[2];
        var needCopper = ____655.allTemplates.wuhunTemplateList.getNeedCopperByLevel(____655.furnaceInfo.weaponSoulLevel + 1);
        if (copper >= needCopper * 20) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<武魂升级检测>", num)
        }
        if (this.wuhunNum == num) {
            return
        }
        this.wuhunNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 19))
    },
    checkRonglu: function() {
        if (____655.____667.level < ____655.____659.levelType.ronglianLevel) {
            return
        }
        var num = 0;
        outerloop: for (var categoryId in this.advanceEquipList) {
            var list = this.advanceEquipList[categoryId];
            for (var i = 0; i < list.length; i++) {
                var itemInfo = list[i];
                var placeInfo = ____655.____659.categoryType.getAdvanceEquipPlace(categoryId);
                var acvanceInfo = ____655.advanceItemList.getItemByType(placeInfo[0]);
                if (acvanceInfo != null) {
                    var acvanceEquipInfo = acvanceInfo.equipList[placeInfo[1]];
                    if ((acvanceEquipInfo != null && itemInfo.quality <= acvanceEquipInfo.star) || itemInfo.count > 1) {
                        num = 1;
                        break outerloop
                    }
                }
            }
        }
        if (num == 0) {
            for (var i = 0; i < this.roleEquipList.length; i++) {
                var itemInfo = this.roleEquipList[i];
                var categoryId = itemInfo.template.categoryId;
                var bodyEquip = ____655.itemInfoList.getBodyEquipByType(categoryId);
                if (bodyEquip != null) {
                    var equiQuality = itemInfo.____57();
                    var bodyQuality = bodyEquip.____57();
                    if (equiQuality < bodyQuality) {
                        num = 1;
                        break
                    }
                }
            }
        }
        if (this._isShowPrint) {
            print("<熔炉检测>", num)
        }
        if (this.rongluNum == num) {
            return
        }
        this.rongluNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 20))
    },
    checkClubShenqing: function() {
        if (____655.____667.level < ____655.____659.levelType.shejiaoLevel) {
            return
        }
        if (this._isShowPrint) {
            print("<家族申请检测>", 0)
        }
    },
    checkClubXinfa: function() {
        if (____655.____667.level < ____655.____659.levelType.shejiaoLevel) {
            return
        }
        var num = 0;
        if (____655.____667.clubId > 0) {
            var gongxian = ____655.____667.moneyInfo.banggong;
            var currentLevel = Math.floor(____655.clubInfo.xinFaLevel / 6);
            var currentIndex = ____655.clubInfo.xinFaLevel % 6;
            var count = Math.floor(gongxian / this.calNeedMaterial(currentIndex));
            if (count >= 6) {
                num = 1
            }
        }
        if (this._isShowPrint) {
            print("<家族心法检测>", num)
        }
        if (this.clubXinfaNum == num) {
            return
        }
        this.clubXinfaNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 22))
    },
    calNeedMaterial: function(index) {
        var currentLevel = Math.floor(____655.clubInfo.xinFaLevel / 6);
        var remainIndex = ____655.clubInfo.xinFaLevel % 6;
        var nextLevel = 0;
        if (remainIndex >= index) {
            nextLevel = currentLevel + 1
        } else {
            nextLevel = currentLevel
        }
        var num = nextLevel * 200;
        return num
    },
    checkClubExpedition: function() {
        if (____655.____667.level < ____655.____659.levelType.shejiaoLevel) {
            return
        }
        var num = 0;
        if (____655.____667.clubId > 0) {
            if (!this.isCopyEnterCountFull(____655.allTemplates.copyTemplateList.clubExpeditionCopyList[0])) {
                num = 1
            }
        }
        if (this._isShowPrint) {
            print("<家族降妖检测>", num)
        }
        if (this.clubExpeditionNum == num) {
            return
        }
        this.clubExpeditionNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 23))
    },
    checkClubTree: function() {
        return;
        if (____655.____667.level < ____655.____659.levelType.shejiaoLevel) {
            return
        }
        var num = 0;
        var templateList = ____655.allTemplates.clubTreeAwardTemplateList.list;
        var totalNum = templateList[4].value;
        if (____655.____667.clubId > 0) {
            if (this.xianluCount > 0 && totalNum > ____655.clubInfo.godTreeNum) {
                num = 1
            }
        }
        if (this._isShowPrint) {
            print("<家族神树检测>", num)
        }
        if (this.clubTreeNum == num) {
            return
        }
        this.clubTreeNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 24))
    },
    checkTujianAward: function() {
        if (____655.____667.level < ____655.____659.levelType.tujianLevel) {
            return
        }
        var num = 0;
        var myTotalStarCount = 0;
        var tuJiantemplateList = ____655.allTemplates.tuJianTemplateList.tuJianList;
        for (var i = 0; i < tuJiantemplateList.length; i++) {
            var type = tuJiantemplateList[i].id;
            var fashionTempInfoList = ____655.allTemplates.fashionTemplateList.getList(type);
            if (fashionTempInfoList != null && fashionTempInfoList.length > 0) {
                for (var j = 0; j < fashionTempInfoList.length; j++) {
                    var id = fashionTempInfoList[j].templateId;
                    var info = ____655.fashionInfo.getFashionInfo(type, id);
                    if (info != null) {
                        myTotalStarCount += info.star
                    }
                }
            }
        }
        var list = ____655.allTemplates.awardTemplateList.getTypeList(22);
        for (var i = 0; i < list.length; i++) {
            var hasGot = ____655.fashionInfo.tuJianAwardRecord.indexOf(parseInt(list[i].condition));
            if (myTotalStarCount >= parseInt(list[i].condition) && hasGot == -1) {
                num = 1;
                break
            }
        }
        if (this._isShowPrint) {
            print("<检测图鉴领奖>", num)
        }
        if (this.tujianAwardNum == num) {
            return
        }
        this.tujianAwardNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 30))
    },
    checkHuanZhuangAward: function() {
        if (____655.____667.level < ____655.____659.levelType.tujianLevel) {
            return
        }
        var num = 0;
        var myTotalCount = 0;
        var huanZhuangTemplateList = ____655.allTemplates.tuJianTemplateList.huanZhuangList;
        for (var i = 0; i < huanZhuangTemplateList.length; i++) {
            var fashionIdList = huanZhuangTemplateList[i].fashionIdList;
            if (fashionIdList != null && fashionIdList.length > 0) {
                for (var j = 0; j < fashionIdList.length; j++) {
                    var type = fashionIdList[j][0];
                    var id = 0;
                    if (type == ____655.____659.commonStaticType.style_fashion_cloth && !____655.____667.getSex()) {
                        id = fashionIdList[j][2]
                    } else {
                        id = fashionIdList[j][1]
                    }
                    var info = ____655.fashionInfo.getFashionInfo(type, id);
                    if (info != null) {
                        myTotalCount++
                    }
                }
            }
        }
        var list = ____655.allTemplates.awardTemplateList.getTypeList(23);
        for (var i = 0; i < list.length; i++) {
            var hasGot = ____655.fashionInfo.huanZhuangAwardRecord.indexOf(parseInt(list[i].condition));
            if (myTotalCount >= parseInt(list[i].condition) && hasGot == -1) {
                num = 1;
                break
            }
        }
        if (this._isShowPrint) {
            print("<检测图鉴领奖>", num)
        }
        if (this.huanZhuangAwardNum == num) {
            return
        }
        this.huanZhuangAwardNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 31))
    },
    checkRider: function() {
        if (____655.____667.level < ____655.____659.levelType.riderLevel) {
            return
        }
        var num = 0;
        var info = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Horse);
        if (info == null) {
            return
        }
        if (this.isAdvance(____655.____659.commonStaticType.style_Horse, 1)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测坐骑>", num)
        }
        if (this.riderNum == num) {
            return
        }
        this.riderNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 34))
    },
    checkPet: function() {
        if (____655.____667.level < ____655.____659.levelType.petLevel) {
            return
        }
        var num = 0;
        var info = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Pet);
        if (info == null) {
            return
        }
        if (this.isAdvance(____655.____659.commonStaticType.style_Pet, 0)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测宠物>", num)
        }
        if (this.petNum == num) {
            return
        }
        this.petNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 35))
    },
    checkWing: function() {
        if (____655.____667.level < ____655.____659.levelType.wingLevel) {
            return
        }
        var num = 0;
        var info = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Wind);
        if (info == null) {
            return
        }
        if (this.isAdvance(____655.____659.commonStaticType.style_Wind, 3)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测羽翼>", num)
        }
        if (this.wingNum == num) {
            return
        }
        this.wingNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 36))
    },
    checkFoot: function() {
        if (____655.____667.level < ____655.____659.levelType.footLevel) {
            return
        }
        var num = 0;
        var info = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Foot);
        if (info == null) {
            return
        }
        if (this.isAdvance(____655.____659.commonStaticType.style_Foot, 2)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测足迹>", num)
        }
        if (this.footNum == num) {
            return
        }
        this.footNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 37))
    },
    checkFabao: function() {
        if (____655.____667.level < ____655.____659.levelType.fabaoLevel) {
            return
        }
        var num = 0;
        var info = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_FaBao);
        if (info == null) {
            return
        }
        if (this.isAdvance(____655.____659.commonStaticType.style_FaBao, 4)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测法宝>", num)
        }
        if (this.fabaoNum == num) {
            return
        }
        this.fabaoNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 38))
    },
    checkZhenling: function() {
        if (____655.____667.level < ____655.____659.levelType.zhenlingLevel) {
            return
        }
        var num = 0;
        var info = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ZhengLing);
        if (info == null) {
            return
        }
        if (this.isAdvance(____655.____659.commonStaticType.style_ZhengLing, 5)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测阵灵>", num)
        }
        if (this.zhenlingNum == num) {
            return
        }
        this.zhenlingNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 39))
    },
    checkShenjian: function() {
        if (____655.____667.level < ____655.____659.levelType.shenjianLevel) {
            return
        }
        var num = 0;
        var info = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ShenJian);
        if (info == null) {
            return
        }
        if (this.isAdvance(____655.____659.commonStaticType.style_ShenJian, 6)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测神剑>", num)
        }
        if (this.shenjianNum == num) {
            return
        }
        this.shenjianNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 40))
    },
    checkHunPo: function() {
        var typeList = ____655.____659.commonStaticType.advanceTypeList;
        var needItemId = 0;
        var needCount = 0;
        var curLevel = 0;
        var tempInfo = null;
        var numList = [];
        for (var i = 0; i < typeList.length; i++) {
            curLevel = ____655.advanceItemList.getSoulLevelByType(typeList[i]);
            tempInfo = ____655.allTemplates.hunPoTemplateList.getInfoByLevel(typeList[i], curLevel + 1);
            if (tempInfo == null) {
                numList[i] = 0;
                continue
            }
            needItemId = tempInfo.needItem[0];
            needCount = ____655.allTemplates.hunPoTemplateList.getNeedCountByLevel(typeList[i], curLevel + 1);
            if (this.hunpoList[needItemId] != null && this.hunpoList[needItemId] >= needCount) {
                numList[i] = 1
            } else {
                numList[i] = 0
            }
        }
        if (____655.____667.level >= ____655.____659.levelType.riderLevel && numList[0] != this.hunpoRiderNum) {
            this.hunpoRiderNum = numList[0];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 55))
        }
        if (____655.____667.level >= ____655.____659.levelType.wingLevel && numList[1] != this.hunpoWindNum) {
            this.hunpoWindNum = numList[1];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 56))
        }
        if (____655.____667.level >= ____655.____659.levelType.fabaoLevel && numList[2] != this.hunpoFaBaoNum) {
            this.hunpoFaBaoNum = numList[2];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 57))
        }
        if (____655.____667.level >= ____655.____659.levelType.zhenlingLevel && numList[3] != this.hunpoZhenLingNum) {
            this.hunpoZhenLingNum = numList[3];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 58))
        }
        if (____655.____667.level >= ____655.____659.levelType.shenjianLevel && numList[4] != this.hunpoShenJianNum) {
            this.hunpoShenJianNum = numList[4];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 59))
        }
        if (____655.____667.level >= ____655.____659.levelType.footLevel && numList[5] != this.hunpoFootNum) {
            this.hunpoFootNum = numList[5];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 60))
        }
        if (____655.____667.level >= ____655.____659.levelType.petLevel && numList[6] != this.hunpoPetNum) {
            this.hunpoPetNum = numList[6];
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 61))
        }
    },
    checkPersonBoss: function() {
        if (____655.____667.level < ____655.____659.levelType.bossLevel) {
            return
        }
        var num = 0;
        this.bossMaxTime = 0;
        var idList = ____655.allTemplates.copyTemplateList.WORLDBOSSPERSON_IDLIST;
        var personBossCopyList = ____655.bossItemList.personBossCopyList;
        var systime = ____655.____662.getSystemTimeSec();
        var count = 0;
        for (var i = 0; i < idList.length; i++) {
            var index = personBossCopyList.indexOf(idList[i]);
            if (index < 0) {
                continue
            }
            var info = ____655.statInfo.statCopyList[idList[i]];
            if (info != null) {
                var resetTime = info.lastRevertTime;
                if (this.bossMaxTime < resetTime) {
                    this.bossMaxTime = resetTime
                }
                if (resetTime <= systime) {
                    num = 1
                }
                count++
            }
        }
        if (count < 3) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测个人BOSS>", num)
        }
        if (this.personBossNum == num) {
            return
        }
        this.personBossNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 44))
    },
    checkShenjiangBoss: function() {
        if (____655.____667.level < ____655.____659.levelType.bossLevel) {
            return
        }
        var num = 0;
        var godBossList = ____655.bossItemList.godBossList;
        var deltaList = [0, 0, 0];
        for (var i = 0; i < 3; i++) {
            var copyIdList = ____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST;
            var remainTimes = godBossList[copyIdList[i]][1];
            var currentTimes = ____655.____662.getSystemTimeSec();
            deltaList[i] = remainTimes - currentTimes;
            if (deltaList[i] <= 0) {
                num = 1;
                break
            }
        }
        if (this._isShowPrint) {
            print("<检测神将BOSS>", num)
        }
        if (this.shenjiangNum == num) {
            return
        }
        this.shenjiangNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 45))
    },
    checkDoushen: function() {
        if (____655.____667.level < ____655.____659.levelType.warLevel) {
            return
        }
        var num = 0;
        if (____655.rankInfo.doushenAwardState == 1) {
            num = 1
        } else if (____655.rankInfo.doushenCount >= 5) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测斗神坛>", num)
        }
        if (this.doushentanNum == num) {
            return
        }
        this.doushentanNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 46))
    },
    checkLilian: function() {
        if (____655.____667.level < ____655.____659.levelType.lilianLevel) {
            return
        }
        var num = 0;
        var list = ____655.allTemplates.rankAwardTemplateList.getTypeList(20);
        var awardList = ____655.activityInfo.awardList;
        for (var i = 0; i < list.length; i++) {
            if (awardList[list[i].minLevel] == null && ____655.activityInfo.activity >= list[i].minLevel) {
                num = 1;
                break
            }
        }
        if (num <= 0) {
            var tempInfo = ____655.allTemplates.lilianTemplateList.getInfoByLevel(____655.activityInfo.lilianLevel);
            if (tempInfo.needLilian * 6 <= ____655.activityInfo.totalActivity) {
                num = 1
            }
        }
        if (this._isShowPrint) {
            print("<检测历练升级>", num)
        }
        if (this.lilianNum == num) {
            return
        }
        this.lilianNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 47))
    },
    checkCopyXiuxian: function() {
        if (____655.____667.level < ____655.____659.levelType.xiuxianCopyLevel) {
            return
        }
        var num = 0;
        var copyId = ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID;
        if (!this.isCopyEnterCountFull(copyId)) {
            num = 1
        } else {
            var copyInfo = ____655.copyInfo.getCopyInfo(copyId);
            var list = ____655.allTemplates.awardTemplateList.getTypeList(1);
            for (var i = 0; i < list.length; i++) {
                var info = list[i];
                if (info.condition > copyInfo.starCount) {
                    break
                }
                if (copyInfo.awardStarList[info.id] != true) {
                    num = 1;
                    break
                }
            }
        }
        var enterTimes = 0;
        var info = ____655.statInfo.statCopyList[copyId];
        if (info != null) {
            enterTimes = info.currentEnterCount
        }
        this.xiuxianMaxTime = ____655.____662.getSystemTimeSec() + enterTimes * ____655.allTemplates.copyTemplateList.COPYXIUXIANRESET_CD;
        if (this._isShowPrint) {
            print("<检测修仙之路>", num)
        }
        if (this.copyXiuxianNum == num) {
            return
        }
        this.copyXiuxianNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 48))
    },
    checkCopyWaiguan: function() {
        if (____655.____667.level < ____655.____659.levelType.waiguanCopyLevel) {
            return
        }
        var num = 0;
        if (!this.isCopyEnterCountFull(____655.allTemplates.copyTemplateList.WAIGUAN_COPYID)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测外观副本>", num)
        }
        if (this.copyWaiguanNum == num) {
            return
        }
        this.copyWaiguanNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 49))
    },
    checkCopyCailiao: function() {
        if (____655.____667.level < ____655.____659.levelType.cailiaoCopyLevel) {
            return
        }
        var num = 0;
        var enterTimes = 0;
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.CAILIAO_COPYID];
        if (info != null) {
            enterTimes = info.currentEnterCount
        }
        if (enterTimes < 2) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测材料副本>", num)
        }
        if (this.copyCailiaoNum == num) {
            return
        }
        this.copyCailiaoNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 50))
    },
    checkCopyYatao: function() {
        if (____655.____667.level < ____655.____659.levelType.yaotaCopyLevel) {
            return
        }
        var num = 0;
        var copyId = ____655.allTemplates.copyTemplateList.YAOTA_COPYID;
        var info = ____655.statInfo.statCopyList[copyId];
        if (info != null) {
            if (info.maxMission > info.todayMaxMission) {
                num = 1
            } else {
                var copyInfo = ____655.copyInfo.getCopyInfo(copyId);
                var copyTempInfo = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.YAOTA_COPYID);
                var index = copyTempInfo.missionIds.indexOf(info.todayMaxMission);
                var list = ____655.allTemplates.awardTemplateList.getTypeList(2);
                for (var i = 0; i < list.length; i++) {
                    var info = list[i];
                    if (info.condition > index) {
                        break
                    }
                    if (copyInfo.boxAcceptState[info.id] != true) {
                        num = 1;
                        break
                    }
                }
            }
        } else {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测九层妖塔>", num)
        }
        if (this.copyYaotaNum == num) {
            return
        }
        this.copyYaotaNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 51))
    },
    checkCopyTongtian: function() {
        if (____655.____667.level < ____655.____659.levelType.tongtianLevel) {
            return
        }
        var num = 0;
        var copyId = ____655.allTemplates.copyTemplateList.TONGTIAN_COPYID;
        var info = ____655.statInfo.statCopyList[copyId];
        if (info == null || info.maxMission == 0 || info.maxMission > info.todayMaxMission) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测通天试炼>", num)
        }
        if (this.copyTongtianNum == num) {
            return
        }
        this.copyTongtianNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 52))
    },
    checkCopyShouhu: function() {
        if (____655.____667.level < ____655.____659.levelType.shouhuLevel) {
            return
        }
        var num = 0;
        if (!this.isCopyEnterCountFull(____655.allTemplates.copyTemplateList.SHOUHU_COPYID)) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测守护紫霞>", num)
        }
        if (this.copyShouhuNum == num) {
            return
        }
        this.copyShouhuNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 53))
    },
    checkCopyXianJie: function() {
        if (____655.____667.level < ____655.____659.levelType.xianjieLevel) {
            return
        }
        var num = 0;
        var enterTimes = 1;
        var info = null;
        if (____655.____667.marryType > 0) {
            info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.XIANYUAN_COPYID];
            if (info != null) {
                enterTimes = info.currentEnterCount
            } else {
                enterTimes = 0
            }
        }
        if (enterTimes > 0 && ____655.____667.oathType > 0) {
            info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.JIEYI_COPYID];
            if (info != null) {
                enterTimes = info.currentEnterCount
            } else {
                enterTimes = 0
            }
        }
        if (enterTimes == 0) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<检测仙缘结义副本>", num)
        }
        if (this.copyXianJieNum == num) {
            return
        }
        this.copyXianJieNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 66))
    },
    checkOnline: function() {
        var num = 0;
        var leftTime = ____655.statInfo.onlineAward_time - ____655.____662.getSystemTimeSec();
        if (leftTime <= 0) {
            num = 1
        }
        if (this._isShowPrint) {
            print("<在线奖励检测>", num)
        }
        if (this.onlineNum == num) {
            return
        }
        this.onlineNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 54))
    },
    checkLuckyTreasure: function() {
        var num = 0;
        var weeksDay = ____655.____662.getClientDate().getDay();
        if (weeksDay == 0) {
            weeksDay = 7
        }
        var type = 0;
        if (weeksDay >= 1 && weeksDay <= 3) {
            type = 1
        } else if (weeksDay >= 4 && weeksDay <= 7) {
            type = 2
        }
        var templateInfo = ____655.allTemplates.luckyTreasureTemplateList.getInfoById(type);
        var hasNum = ____655.itemInfoList.getCountByTempId(templateInfo.needItemId);
        if (hasNum > 0) {
            num = 1
        }
        var getAwardList = ____655.welfareInfo.getAwardList;
        var luckyTotalNum = ____655.welfareInfo.luckyTotalNum;
        for (var i = 0; i < 4; i++) {
            var index = getAwardList.indexOf((i + 1));
            if (luckyTotalNum >= templateInfo.itemList[i][2] && index == -1) {
                num = 1;
                break
            }
        }
        if (this.luckyTreasureNum == num) {
            return
        }
        this.luckyTreasureNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 62))
    },
    checkMarryLevelUp: function() {
        return;
        var num = 0;
        var type = ____655.____659.commonStaticType.sheJiao_marry;
        var needCount = ____655.allTemplates.hunPoTemplateList.getXinWuNeedCount(type, ____655.marryOathInfo.marryLevel + 1);
        var maxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(type, ____655.marryOathInfo.marryType);
        if (this.tongXinJieCount >= needCount && ____655.marryOathInfo.marryLevel < maxLevel) {
            num = 1
        }
        if (this.marryNum == num) {
            return
        }
        this.marryNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 63))
    },
    checkOathLevelUp: function() {
        return;
        var num = 0;
        var type = ____655.____659.commonStaticType.sheJiao_oath;
        var needCount = ____655.allTemplates.hunPoTemplateList.getXinWuNeedCount(type, ____655.marryOathInfo.oathLevel + 1);
        var maxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(type, ____655.marryOathInfo.oathType);
        if (this.jinLanPuCount >= needCount && ____655.marryOathInfo.oathLevel < maxLevel) {
            num = 1
        }
        if (this.oathNum == num) {
            return
        }
        this.oathNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 64))
    },
    isCopyEnterCountFull: function(copyId) {
        var dayTimes = ____655.allTemplates.copyTemplateList.getCopy(copyId).dayTimes;
        var enterTimes = 0;
        var info = ____655.statInfo.statCopyList[copyId];
        if (info != null) {
            enterTimes = info.currentEnterCount
        }
        return dayTimes <= enterTimes
    },
    isAdvance: function(type, index) {
        var info = ____655.advanceItemList.getItemByType(type);
        var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(type, info.starCount);
        if (info.wuxing < stageTempInfo.wuxingMax && this.getDanNum([____655.____659.categoryType.CHENGZHANGDAN[index]]) + this.getDanNum([____655.____659.categoryType.CHENGZHANGDAN[7]]) > 0) {
            return true
        }
        if (info.qiangNeng < stageTempInfo.qianNengMax && this.getDanNum([____655.____659.categoryType.QIANNENG[index]]) + this.getDanNum([____655.____659.categoryType.QIANNENG[7]]) > 0) {
            return true
        }
        var maxStage = ____655.allTemplates.advanceTemplateList.getMaxStage(type);
        if (info.starCount < ____655.allTemplates.advanceTemplateList.getTotalStarByStage(maxStage)) {
            var starTempInfo = ____655.allTemplates.advanceTemplateList.getStarInfo(type, info.starCount);
            if (this.getDanNum([____655.____659.categoryType.JINJIEDAN[index]]) >= starTempInfo.needItems[0][1] && (starTempInfo.needItems[1] == null || this.getDanNum([____655.____659.categoryType.FEISHENG[index]]) >= starTempInfo.needItems[1][1])) {
                return true
            }
        }
        var list = null;
        var categoryType = ____655.____659.categoryType.getAdvanceEquipCategoryId(type, 1);
        for (var i = 0; i < 4; i++) {
            list = this.advanceEquipList[categoryType + i];
            if (list == null) {
                continue
            }
            for (var j = 0; j < list.length; j++) {
                if (info.starCount >= list[j].quality) {
                    if (info.equipList[i + 1] == null) {
                        return true
                    } else {
                        var oldFight = ____655.____659.categoryType.getWaiXingFight(info.equipList[i + 1].star, info.equipList[i + 1].quality);
                        var newFight = ____655.____659.categoryType.getWaiXingFight(list[j].quality, list[j].qhLevel);
                        if (oldFight < newFight) {
                            return true
                        }
                    }
                }
            }
        }
        return false
    },
    getDanNum: function(categoryType) {
        var num = this.danList[categoryType];
        if (num == null) {
            return 0
        }
        return num
    },
    resetAllData: function() {
        ____654.____678.____299(this.getDataTick, this);
        this.dispatchTime = 0;
        this.itemUpdateTime = 0;
        this.moneyUpdateTime = 0;
        this.dayUpdateTime = 0;
        this.shopUpdateTime = 0;
        this.tongXinJieCount = 0;
        this.jinLanPuCount = 0;
        this.advanceEquipList = {};
        this.roleEquipList = [];
        this.hunshiList = {};
        this.hunpoList = {};
        this.xianluCount = 0;
        this.danList = {};
        this.qianghuashiList = {};
        this.baoshiList = {};
        this.openDay = 0;
        this.createDay = 0;
        this.day = 0;
        this.returnGiftNum = 0;
        this.loginGiftNum = 0;
        this.feixianGift1Num = 0;
        this.feixianGift2Num = 0;
        this.feixianGift3Num = 0;
        this.feixianGift4Num = 0;
        this.feixianGift5Num = 0;
        this.feixianGift6Num = 0;
        this.feixianGift7Num = 0;
        this.fudaiNum = 0;
        this.monthCardNum = 0;
        this.weekSignNum = 0;
        this.recoverNum = 0;
        this.vipGiftNum = 0;
        this.fasionNum = 0;
        this.weaponGodNum = 0;
        this.weaponStrengthNum = 0;
        this.weaponBaoshiNum = 0;
        this.wuhunNum = 0;
        this.rongluNum = 0;
        this.clubShenqingNum = 0;
        this.clubXinfaNum = 0;
        this.clubExpeditionNum = 0;
        this.clubTreeNum = 0;
        this.tujianSJNum = 0;
        this.tujianMWNum = 0;
        this.tujianSXNum = 0;
        this.tujianSBNum = 0;
        this.tujianBWNum = 0;
        this.tujianAwardNum = 0;
        this.huanZhuangAwardNum = 0;
        this.bagItemNum = 0;
        this.bagEquipNum = 0;
        this.riderNum = 0;
        this.petNum = 0;
        this.wingNum = 0;
        this.footNum = 0;
        this.fabaoNum = 0;
        this.zhenlingNum = 0;
        this.shenjianNum = 0;
        this.fashionRiderNum = 0;
        this.fashingPetNum = 0;
        this.fashingWingNum = 0;
        this.personBossNum = 0;
        this.shenjiangNum = 0;
        this.doushentanNum = 0;
        this.lilianNum = 0;
        this.copyXiuxianNum = 0;
        this.copyWaiguanNum = 0;
        this.copyCailiaoNum = 0;
        this.copyYaotaNum = 0;
        this.copyTongtianNum = 0;
        this.copyShouhuNum = 0;
        this.onlineNum = 0;
        this.hunpoRiderNum = 0;
        this.hunpoWindNum = 0;
        this.hunpoFaBaoNum = 0;
        this.hunpoZhenLingNum = 0;
        this.hunpoShenJianNum = 0;
        this.hunpoFootNum = 0;
        this.hunpoPetNum = 0;
        this.luckyTreasureNum = 0;
        this.marryNum = 0;
        this.oathNum = 0;
        this.homeNum = 0;
        this.copyXianJieNum = 0;
        this.familyTreasuresNum = 0;
        this.tujianYaoJingNum = 0;
        this.openChongBangNum = 0
    },
    checkHomeTip: function() {
        var res = ____655.homeInfo.getHomeTip();
        var num = 0;
        if (!!res) {
            num++
        }
        if (this.homeNum == num) {
            return
        }
        this.homeNum = num;
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_popData, ____654.____672, 65))
    },
    checkTongzhi: function() {
        var now = ____655.____662.getSystemTimeSec();
        var isTenClock = false;
        var passTime = 0;
        var date = null;
        ____654.sdk.cleanNotify();
        if (____655.____667.level >= 45) {
            passTime = ____655.____662.getZeroPassTime(now);
            this.jiazuzhanTime = now + 75300 - passTime;
            if (passTime >= 75300) {
                this.jiazuzhanTime += ____655.____662.secondsOfDay
            }
            this.quanminTime = now + 37500 - passTime;
            if (passTime >= 37500) {
                this.quanminTime += ____655.____662.secondsOfDay
            }
            this.tiangongTime = now + 51900 - passTime;
            if (passTime >= 51900) {
                this.tiangongTime += ____655.____662.secondsOfDay
            }
        }
        if (____655.gameSetting.tongzhiList[0]) {
            if (this.xiuxianMaxTime - now > 60) {
                passTime = ____655.____662.getZeroPassTime(this.xiuxianMaxTime);
                if (isTenClock == false || passTime > 36000) {
                    if (passTime <= 36000) {
                        this.xiuxianMaxTime += (36000 - passTime);
                        isTenClock = true
                    }
                    date = ____655.____662.getDate(this.xiuxianMaxTime * 1000);
                    ____654.sdk.setNotify("修仙之路挑战", "您有20次副本挑战机会啦，快来赢取海量奖励！", ____655.____662.dateToString(date), ____655.____662.singleToDouble(date.getHours()), ____655.____662.singleToDouble(date.getMinutes()))
                }
            }
        }
        if (____655.gameSetting.tongzhiList[1]) {
            if (this.bossMaxTime - now > 60) {
                passTime = ____655.____662.getZeroPassTime(this.bossMaxTime);
                if (isTenClock == false || passTime > 36000) {
                    if (passTime <= 36000) {
                        this.bossMaxTime += (36000 - passTime);
                        isTenClock = true
                    }
                    date = ____655.____662.getDate(this.bossMaxTime * 1000);
                    ____654.sdk.setNotify("挑战BOSS", "快来推倒BOSS，爆七大外观装备！", ____655.____662.dateToString(date), ____655.____662.singleToDouble(date.getHours()), ____655.____662.singleToDouble(date.getMinutes()))
                }
            }
        }
        if (____655.gameSetting.tongzhiList[2]) {
            if (this.homeSeedTime - now > 60) {
                date = ____655.____662.getDate(this.homeSeedTime * 1000);
                ____654.sdk.setNotify("收获种植奖励", "仙园作物成熟啦，赶紧上来收获吧！", ____655.____662.dateToString(date), ____655.____662.singleToDouble(date.getHours()), ____655.____662.singleToDouble(date.getMinutes()))
            }
        }
        if (____655.gameSetting.tongzhiList[3]) {
            if (this.jiazuzhanTime - now > 60) {
                date = ____655.____662.getDate(this.jiazuzhanTime * 1000);
                ____654.sdk.setNotify("家族大战", "家族荣誉之战，等你来守护！", ____655.____662.dateToString(date), ____655.____662.singleToDouble(date.getHours()), ____655.____662.singleToDouble(date.getMinutes()))
            }
        }
        if (____655.gameSetting.tongzhiList[4]) {
            if (this.quanminTime - now > 60) {
                date = ____655.____662.getDate(this.quanminTime * 1000);
                ____654.sdk.setNotify("全民精彩活动", "全民捉妖、全民寻宝活动开启啦，快来捉妖抢宝物！", ____655.____662.dateToString(date), ____655.____662.singleToDouble(date.getHours()), ____655.____662.singleToDouble(date.getMinutes()))
            }
        }
        if (____655.gameSetting.tongzhiList[5]) {
            if (this.tiangongTime - now > 60) {
                date = ____655.____662.getDate(this.tiangongTime * 1000);
                ____654.sdk.setNotify("天宫精彩活动", "天宫幻境、天宫悬赏活动开启啦，快来悬赏拿大奖！", ____655.____662.dateToString(date), ____655.____662.singleToDouble(date.getHours()), ____655.____662.singleToDouble(date.getMinutes()))
            }
        }
    },
});
var TaskTester = cc.Class.extend({
    CLUBJOIN: 1001,
    CLUBXINFA: 1002,
    taskList: null,
    ctor: function() {
        this.taskList = {}
    },
    addCheck: function(taskId) {
        var taskInfo = ____655.____670.____121(taskId);
        if (taskInfo == null) {
            return
        }
        if (taskInfo.____55().termList.length == 0) {
            return
        }
        this.addListener(taskInfo);
        this.sendCheckCount(taskInfo)
    },
    removeCheck: function(taskInfo) {
        if (taskInfo.____55().termList.length == 0) {
            return
        }
        var type = parseInt(taskInfo.____55().termList[0][0]);
        this.removeListener(type)
    },
    checkTask: function(taskInfo) {
        var type = parseInt(taskInfo.____55().termList[0][0]);
        if (type == this.CLUBJOIN) {
            if (____655.clubInfo.id > 0) {
                return 1
            }
            return 0
        } else if (type == this.CLUBXINFA) {
            return ____655.clubInfo.xinFaLevel
        }
        return 0
    },
    addListener: function(taskInfo) {
        var type = parseInt(taskInfo.____55().termList[0][0]);
        if (type == this.CLUBJOIN) {
            ____655.clubInfo.addEventListener(____655.____661.club_info_update, this.updateClubHandler, this)
        } else if (type == this.CLUBXINFA) {
            ____655.clubInfo.addEventListener(____655.____661.club_xinfaInfo_update, this.updateXinfaHandler, this)
        }
        this.taskList[type] = taskInfo
    },
    removeListener: function(type) {
        if (type == this.CLUBJOIN) {
            ____655.clubInfo.removeEventListener(____655.____661.club_info_update, this.updateClubHandler, this)
        } else if (type == this.CLUBXINFA) {
            ____655.clubInfo.removeEventListener(____655.____661.club_xinfaInfo_update, this.updateXinfaHandler, this)
        }
        this.taskList[type] = null
    },
    updateClubHandler: function(evt) {
        this.sendCheckCount(this.taskList[this.CLUBJOIN])
    },
    updateXinfaHandler: function(evt) {
        this.sendCheckCount(this.taskList[this.CLUBXINFA])
    },
    sendCheckCount: function(info) {
        if (info != null) {
            var needCount = parseInt(info.____55().termList[0][1]) - this.checkTask(info);
            print(parseInt(info.____55().termList[0][1]), this.checkTask(info));
            if (needCount < 0) {
                needCount = 0
            }
            ____654.selfDataMessageSender.sendTaskClientCount(info.taskId, needCount)
        }
    },
});
var AddNumberUtils = cc.Class.extend({
    _target: null,
    _currentNumber: 0,
    _targetNumber: 0,
    _dn: 0,
    ctor: function(target, defaultNumber) {
        this._target = target;
        if (defaultNumber == null) {
            this._currentNumber = 0
        } else {
            this._currentNumber = defaultNumber
        }
        this._target.setString(this._currentNumber)
    },
    setValue: function(value, isChange) {
        this._targetNumber = value;
        if (this._targetNumber == this._currentNumber) return;
        if (isChange == false || this._targetNumber < this._currentNumber) {
            this._currentNumber = this._targetNumber;
            this._target.setString(this._targetNumber);
            this.stop();
            return
        }
        this._dn = Math.ceil((this._targetNumber - this._currentNumber) / 40);
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._currentNumber += this._dn;
        if (this._currentNumber >= this._targetNumber) {
            this._currentNumber = this._targetNumber;
            this._target.setString(this._currentNumber);
            this.stop()
        } else {
            this._target.setString(this._currentNumber)
        }
    },
    stop: function() {
        ____654.____678.____299(this.tick, this)
    },
    dispose: function() {
        this.stop();
        this._target = null
    },
});
var ____540 = cc.Class.extend({
    director: null,
    textureCache: null,
    spriteFrameCache: null,
    animationCache: null,
    anchorPoints: null,
    zeroSize: null,
    ctor: function() {
        this.director = cc.director;
        this.textureCache = cc.textureCache;
        this.spriteFrameCache = cc.spriteFrameCache;
        this.animationCache = cc.animationCache;
        this.zeroSize = cc.size(0, 0);
        this.anchorPoints = [cc.p(0.5, 0.5), cc.p(0, 1), cc.p(0.5, 1), cc.p(1, 1), cc.p(0, 0.5), cc.p(1, 0.5), cc.p(0, 0), cc.p(1, 0), cc.p(0.5, 0)]
    },
    release: function(node) {
        if (node == null) {
            return
        }
        if (node.getParent != null && node.getParent() != null) {
            node.removeFromParent()
        }
        if (node.dispose != null) {
            node.dispose = null
        }
        node["___release"] = true;
        if (!!node.release) {
            node.release()
        }
    },
    releaseTexture: function(path) {
        this.textureCache.removeTextureForKey(path)
    },
    releasePlist: function(plistPath) {
        this.spriteFrameCache.removeSpriteFramesFromFile(plistPath)
    },
    ____159: function(x, y) {
        if (x == null) x = 0;
        if (y == null) y = 0;
        return cc.p(x, y)
    },
    ____160: function(width, height) {
        if (width == null) width = 0;
        if (height == null) height = 0;
        return cc.size(width, height)
    },
    ____161: function(x, y, width, height) {
        if (x == null) x = 0;
        if (y == null) y = 0;
        if (width == null) width = 0;
        if (height == null) height = 0;
        return cc.rect(x, y, width, height)
    },
    newClippingNode: function() {
        var n = cc.ClippingNode.create();
        n.retain();
        return n
    },
    newDrawNode: function() {
        var n = new cc.DrawNode();
        n.retain();
        return n
    },
    newRichLabel: function(width, text, color, align) {
        var rl = new RichLabel(width, align);
        if (color != null) {
            rl.setTextColor(color)
        } else {
            rl.setTextColor(____655.____659.____688.system)
        }
        if (text != null) {
            rl.setString(text)
        }
        return rl
    },
    newAnima: function(fileName, callback, callTarget) {
        if (!____655.gameConfig.isNative()) return null;
        if (callback == null || callTarget == null) return null;
        return new ____2358(fileName, callback, callTarget)
    },
    newArmature: function(name) {
        if (!____655.gameConfig.isNative()) return null;
        var node = ccs.Armature.create(name);
        node.retain();
        return node
    },
    ____177: function(image, progresssType) {
        var progress = new cc.ProgressTimer(image);
        if (!!progresssType) progress.setType(progresssType);
        progress.retain();
        return progress
    },
    newSkin: function(picPath) {
        if (!____655.gameConfig.isNative()) return null;
        var node = ccs.Skin.create(picPath);
        node.retain();
        return node
    },
    isFileExist: function(path) {
        return jsb.fileUtils.isFileExist(path)
    },
    newKYSprite: function() {
        var node = new KYSprite();
        return node
    },
    newKYImageView: function() {
        var node = new KYImageView();
        return node
    },
    newKYListView: function() {
        var node = new KYListView();
        return node
    },
    newKYNode: function() {
        var node = new KYNode();
        return node
    },
    newKYProgressBar: function(path, width) {
        var node = new KYProgressBar();
        node.initUI(path, 1, width);
        return node
    },
    newKYClippingNode: function() {
        var node = new KYClippingNode();
        return node
    },
    newKYDrawNode: function() {
        var node = new KYDrawNode();
        return node
    },
    newKYLabel: function(fontSize, isShadow, size) {
        if (fontSize == null) fontSize = 20;
        if (size == null) size = cc.size(0, 0);
        var node = new KYLabel();
        node.setFontName(____655.defaultFontName);
        node.setColor(____655.____659.____688.system);
        node.setFontSize(fontSize);
        node.setDimensions(size);
        if (isShadow == true) {
            node.enableShadow(cc.color(0, 0, 0, 1), cc.size(1, -1), 0)
        }
        return node
    },
    newKYTextField: function(size, maxLength, fontSize, isPassword, color, placeHolder) {
        if (fontSize == null) fontSize = 22;
        if (isPassword == null) isPassword = false;
        if (color == null) color = ____655.____659.____688.white;
        if (placeHolder == null) placeHolder = ____654.yuyanbaoManager.getYuyanbao("common.inputDefalut");
        var text = new KYTextField();
        text.setAnchorPoint(this.anchorPoints[4]);
        text.setContentSize(size);
        text.setTouchAreaEnabled(true);
        text.setTextAreaSize(size);
        text.setTouchSize(size);
        text.setMaxLength(maxLength);
        text.setFontSize(fontSize);
        text.setFontName(____655.defaultFontName);
        text.setPlaceHolder(placeHolder);
        text.setColor(color);
        return text
    },
});
var ____541 = cc.Class.extend({
    ____1242: null,
    astar: null,
    md5Utils: null,
    ctor: function() {
        this.____1242 = new ____593();
        this.astar = new AStar();
        this.md5Utils = new MD5()
    },
    md5: function(strSrc, key, raw) {
        return this.md5Utils.md5(strSrc, key, raw)
    },
    ____179: function(p1, p2) {
        var dx = p2.x - p1.x;
        var dy = p2.y - p1.y;
        return Math.sqrt(dx * dx + dy * dy)
    },
    ____180: function(p1, p2) {
        return !!p1 && !!p2 ? (p1.x == p2.x && p1.y == p2.y) : false
    },
    sizeEquals: function(size1, size2) {
        return !!size1 && !!size2 ? (size1.width == size2.width && size1.height == size2.height) : false
    },
    ____181: function(array, item) {
        if (item == null || array == null) return -1;
        return array.indexOf(item)
    },
    arrayEquote: function(arr1, arr2) {
        if (arr1 == null || arr2 == null || arr1.length != arr2.length) return false;
        for (var i = 0; i < arr1.length; i++) {
            if (arr1[i] != arr2[i]) return false
        }
        return true
    },
    dicEquote: function(dic1, dic2) {
        if (dic1 == null || dic2 == null) return;
        for (var i in dic1) {
            if (dic1[i] != dic2[i]) return false
        }
        for (var i in dic2) {
            if (dic1[i] == null) return false
        }
        return true
    },
    removeItemInArray: function(arr, item) {
        for (var i = 0; i < arr.length; i++) {
            if (arr[i] == item) {
                arr.splice(i, 1);
                break
            }
        }
    },
    ____182: function(byteArray) {
        return this.____1242.____182(byteArray)
    },
    ____183: function(str, token) {
        if (str == "" || str == null) return [];
        var list = str.split(token);
        var len = list.length;
        for (var i = 0; i < len; i++) {
            list[i] = parseInt(list[i])
        }
        return list
    },
    strItemSplitToInts: function(str) {
        if (str == "" || str == null || str.length == 0) return [];
        var listbig = str.split("|");
        var len = listbig.length;
        var ret = [];
        for (var i = 0; i < len; i++) {
            var listsmall = listbig[i].split(",");
            for (var j = 0; j < listsmall.length; j++) {
                listsmall[j] = parseInt(listsmall[j])
            }
            ret.push(listsmall)
        }
        return ret
    },
    strItemSplitToStrs: function(str) {
        if (str == "" || str == null || str.length == 0) return [];
        var listbig = str.split("|");
        var len = listbig.length;
        var ret = [];
        for (var i = 0; i < len; i++) {
            var listsmall = listbig[i].split(",");
            ret.push(listsmall)
        }
        return ret
    },
    strSplitToPoints: function(str) {
        if (str == "" || str == null) return [____654.____673.____159(0, 0)];
        var result = [];
        var tmp = str.split("|");
        for (var i = 0; i < tmp.length; i++) {
            var ps = tmp[i].split(",");
            result.push(____654.____673.____159(parseInt(ps[0]), parseInt(ps[1])))
        }
        return result
    },
    ____184: function(str) {
        var result = [];
        if (str == "") return result;
        var tmpList1 = str.split("|");
        for (var i = 0; i < tmpList1.length; i++) {
            var tmpList2 = tmpList1[i].split(",");
            if (tmpList2.length >= 2) {
                var tmpInfo = new ____484();
                tmpInfo.id = parseInt(tmpList2[0]);
                tmpInfo.value = parseInt(tmpList2[1]);
                if (tmpList2.length > 2) {
                    tmpInfo.percent = parseInt(tmpList2[2])
                }
                result.push(tmpInfo)
            }
        }
        return result
    },
    setKYBtnEnabled: function(btn, value, type) {
        if (type == null) {
            type = 0
        }
        btn.setTouchEnabled(value);
        if (type == 0) {
            if (value) {
                btn.setFrame("btn/ui_btn1_1.png")
            } else {
                btn.setFrame("btn/ui_btn1_4.png")
            }
        } else if (type == 1) {
            if (value) {
                btn.setFrame("btn/ui_btn1_2.png")
            } else {
                btn.setFrame("btn/ui_btn1_4.png")
            }
        } else if (type == 2) {
            if (value) {
                btn.setFrame("btn/ui_btn1_3.png")
            } else {
                btn.setFrame("btn/ui_btn1_4.png")
            }
        }
    },
    setStarListColor: function(starList, level) {
        var count = starList.length;
        var type = Math.max(Math.floor(level / count), 0);
        var curCount = level % count;
        if (curCount == 0) {
            var path = "icon/ui_startIcon" + Math.min(type, 6) + ".png";
            for (var i = 0; i < count; i++) {
                starList[i].loadTexture(path, 1)
            }
        } else {
            var path = "icon/ui_startIcon" + Math.min((type + 1), 6) + ".png";
            for (var i = 0; i < count; i++) {
                if (i < curCount) {
                    starList[i].loadTexture(path, 1)
                } else {
                    starList[i].loadTexture("icon/ui_startIcon0.png", 1)
                }
            }
        }
    },
    setKYStarListColor: function(starList, level) {
        var count = starList.length;
        var type = Math.max(Math.floor(level / count), 0);
        var curCount = level % count;
        if (curCount == 0) {
            var path = "icon/ui_startIcon" + Math.min(type, 6) + ".png";
            for (var i = 0; i < count; i++) {
                starList[i].setFrame(path, 1)
            }
        } else {
            var path = "icon/ui_startIcon" + Math.min((type + 1), 6) + ".png";
            for (var i = 0; i < count; i++) {
                if (i < curCount) {
                    starList[i].setFrame(path, 1)
                } else {
                    starList[i].setFrame("icon/ui_startIcon0.png", 1)
                }
            }
        }
    },
    getWanCount: function(count) {
        if (count >= 10000) {
            var w = Math.floor(count * 0.0001);
            return ____654.yuyanbaoManager.getYuyanbao("common.gridTips1", w.toString())
        } else {
            return count.toString()
        }
    },
    clone: function(obj) {
        return JSON.parse(JSON.stringify(obj))
    },
    getPlaceStr: function(number, count) {
        var str = "";
        for (var i = count; i > 0; i--) {
            if (number < Math.pow(10, i)) {
                str += " "
            }
        }
        return str
    },
    loadKuozhan: function(list, isShow) {
        if (list == null || list.length == 0) {
            return
        }
        var this_ = this;

        function complate(type) {
            if (type == null) {
                if (isShow) {
                    ____654.gameScene.clearUpdateView()
                }
                ____654.____672.dispatchEvent(new ____590(____655.____661.kuozhanUpdate, ____654.____672, null))
            }
        };
        var isUpdate = ____654.gameScene.startDownBPackage(complate, list);
        if (isShow && isUpdate) {
            ____654.gameScene.showUpdateView()
        }
    },
});

function assert(cond, msg) {
    if (!cond) {
        var errMsg = "error.";
        if (!!msg) {
            var args = [];
            for (var i = 1; i < arguments.length; i++) args.push(arguments[i]);
            errMsg = "Error: " + cc.formatStr.apply(cc, args)
        }
        if (____654.useTry()) {
            try {
                throw new Error(errMsg)
            } catch (e) {
                ____654.doPrintError(e)
            }
        }
    }
    return cond
}
var ccui_Widget_addTouchEventListener = ccui.Widget.prototype.addTouchEventListener;
ccui.Widget.prototype.addTouchEventListener = function(selector, target) {
    function touch(sender, eventType) {
        if (____654.useTry()) {
            try {
                selector.call(target, sender, eventType)
            } catch (e) {
                ____654.doPrintError(e)
            }
        } else {
            selector.call(target, sender, eventType)
        }
    }
    ccui_Widget_addTouchEventListener.call(this, touch, target)
};
var cc_Node_prototype_addChild_Camera = cc.Node.prototype.addChild;
cc.Node.prototype.addChild = function(child, localZOrder, tag) {
    var mask = this.getCameraMask();
    if (!!child && !!child.removeFromParent) child.removeFromParent(false);
    if (!assert(child, "addChild方法，子对象为空")) return;
    if (localZOrder == null) cc_Node_prototype_addChild_Camera.call(this, child);
    else if (tag == null) cc_Node_prototype_addChild_Camera.call(this, child, localZOrder);
    else cc_Node_prototype_addChild_Camera.call(this, child, localZOrder, tag)
};
var cc_SpriteBatchNode_prototype_addChild = cc.SpriteBatchNode.prototype.addChild;
cc.SpriteBatchNode.prototype.addChild = function(child, localZOrder, tag) {
    if (this.getTexture().getName() != child.getTexture().getName()) {
        print("batchNode addChild error", this.getTexture().getName(), child.getTexture().getName());
        return
    }
    cc_SpriteBatchNode_prototype_addChild.call(this, child, localZOrder, tag)
};
var ccui_Button_prototype_loadTextureNormal = ccui.Button.prototype.loadTextureNormal;
ccui.Button.prototype.loadTextureNormal = function(fileName, tex) {
    if (tex == null) ccui_Button_prototype_loadTextureNormal.call(this, fileName);
    else {
        if (tex == 1) {
            var frame = ____654.____673.spriteFrameCache.getSpriteFrame(fileName);
            if (!assert(frame, "#empty frame：" + fileName)) return
        }
        ccui_Button_prototype_loadTextureNormal.call(this, fileName, tex)
    }
};
var cc_Sprite_prototype_setSpriteFrame = cc.Sprite.prototype.setSpriteFrame;
cc.Sprite.prototype.setSpriteFrame = function(frame) {
    if (typeof(frame) == "string") {
        var f = ____654.____673.spriteFrameCache.getSpriteFrame(frame);
        if (assert(f, "frame为空" + frame)) {
            cc_Sprite_prototype_setSpriteFrame.call(this, frame)
        }
    } else {
        if (assert(frame, "frame为空")) {
            cc_Sprite_prototype_setSpriteFrame.call(this, frame)
        }
    }
};
ccui.Scale9Sprite.prototype.getScale = function() {
    return this.getScaleX()
};
ccui.Widget.prototype.getScale = function() {
    return this.getScaleX()
};
var ccui_ScrollView_prototype_setScrollBarWidth = ccui.ScrollView.prototype.setScrollBarWidth;
ccui.ScrollView.prototype.setScrollBarWidth = function(width) {
    if (!this.isScrollBarEnabled()) return;
    ccui_ScrollView_prototype_setScrollBarWidth.call(this, width)
};
var ccui_ScrollView_prototype_getScrollBarWidth = ccui.ScrollView.prototype.getScrollBarWidth;
ccui.ScrollView.prototype.getScrollBarWidth = function() {
    if (!this.isScrollBarEnabled()) return 0;
    return ccui_ScrollView_prototype_getScrollBarWidth.call(this)
};
var ccui_ScrollView_prototype_setScrollBarColor = ccui.ScrollView.prototype.setScrollBarColor;
ccui.ScrollView.prototype.setScrollBarColor = function(color) {
    if (!this.isScrollBarEnabled()) return;
    ccui_ScrollView_prototype_setScrollBarColor.call(this, color)
};
var ccui_ScrollView_prototype_getScrollBarColor = ccui.ScrollView.prototype.getScrollBarColor;
ccui.ScrollView.prototype.getScrollBarColor = function() {
    if (!this.isScrollBarEnabled()) return ____655.____659.____688.white;
    return ccui_ScrollView_prototype_getScrollBarColor.call(this)
};
var ccui_ScrollView_prototype_setScrollBarOpacity = ccui.ScrollView.prototype.setScrollBarOpacity;
ccui.ScrollView.prototype.setScrollBarOpacity = function(opacity) {
    if (!this.isScrollBarEnabled()) return;
    ccui_ScrollView_prototype_setScrollBarOpacity.call(this, opacity)
};
var ccui_ScrollView_prototype_getScrollBarOpacity = ccui.ScrollView.prototype.getScrollBarOpacity;
ccui.ScrollView.prototype.getScrollBarOpacity = function() {
    if (!this.isScrollBarEnabled()) return -1;
    return ccui_ScrollView_prototype_getScrollBarOpacity.call(this)
};
var ccui_Text_prototype_setString = ccui.Text.prototype.setString;
ccui.Text.prototype.setString = function(value) {
    if (value == null) value = "null";
    ccui_Text_prototype_setString.call(this, value)
};
var ccui_TextField_prototype_setString = ccui.TextField.prototype.setString;
ccui.TextField.prototype.setString = function(value) {
    if (value == null) value = "null";
    ccui_TextField_prototype_setString.call(this, value)
};
var cc_LabelTTF_prototype_setString = cc.LabelTTF.prototype.setString;
cc.LabelTTF.prototype.setString = function(value) {
    if (value == null) value = "null";
    cc_LabelTTF_prototype_setString.call(this, value)
};
if (!!ccui.ImageView.prototype.loadTexture) {
    var ccui_ImageView_prototype_loadTexture = ccui.ImageView.prototype.loadTexture;
    ccui.ImageView.prototype.loadTexture = function(fileName, texType) {
        if (texType == undefined) {
            ccui_ImageView_prototype_loadTexture.call(this, fileName)
        } else {
            if (texType == 1) {
                var frame = ____654.____673.spriteFrameCache.getSpriteFrame(fileName);
                if (!assert(frame, "#empty frame：" + fileName)) return
            }
            ccui_ImageView_prototype_loadTexture.call(this, fileName, texType)
        }
    }
}
var showNodeCount = 0;
if (cc.sys.os === cc.sys.OS_WINDOWS || cc.sys.os === cc.sys.OS_WP8 || cc.sys.os === cc.sys.OS_WINRT) {
    var cc_Node_prototype_retain_showMemory = cc.Node.prototype.retain;
    cc.Node.prototype.retain = function() {
        showNodeCount++;
        cc_Node_prototype_retain_showMemory.call(this)
    };
    var cc_Node_prototype_release_showMemory = cc.Node.prototype.release;
    cc.Node.prototype.release = function() {
        showNodeCount--;
        cc_Node_prototype_release_showMemory.call(this)
    }
};
var ____2111 = cc.Class.extend({
    ____1712: 0,
    ____1626: 0,
    ____1337: 0,
    ____1325: 0,
    ____1769: null,
    ____1131: null,
    ____930: null,
    _label: null,
    _type: 0,
    ____994: 0,
    ____1172: null,
    ctor: function() {},
    setLabel: function(label, type, colorSeconds, formatYuyan) {
        this._label = label;
        if (type == null) {
            type = 0
        }
        if (colorSeconds == null) {
            colorSeconds = 0
        }
        this._type = type;
        this.____994 = colorSeconds;
        this.____1172 = formatYuyan
    },
    updateLabel: function() {
        if (this._label == null) {
            return
        }
        var result = null;
        if (this._type == 0 || this._type == 4) {
            if (this.getLeftTime() > ____655.____662.secondsOfDay) {
                if (this._type == 0) {
                    result = ____654.yuyanbaoManager.getYuyanbao("common.timeTips1", Math.floor(this.getLeftTime() / ____655.____662.secondsOfDay).toString())
                } else {
                    result = Math.floor(this.getLeftTime() / ____655.____662.secondsOfDay).toString() + "d"
                }
            } else {
                result = ____655.____662.secondsToDateString(this.getLeftTime())
            }
        } else if (this._type == 1) {
            result = ____655.____662.secondsToDateString2(this.getLeftTime())
        } else if (this._type == 2) {
            result = this.getLeftTime().toString()
        } else if (this._type == 3) {
            result = ____655.____662.secondsToDateString4(this.getLeftTime())
        }
        if (result == null) {
            return
        }
        if (this.____1172 != null) {
            this._label.setString(____654.yuyanbaoManager.getYuyanbao(this.____1172, result))
        } else {
            this._label.setString(result)
        }
        if (this.____994 > 0 && this.getLeftTime() < this.____994) {
            this._label.setColor(____655.____659.____688.red)
        }
    },
    start: function(seconds, tickCb, endCb, cbParams) {
        if (seconds < 0) {
            seconds = 0
        }
        this.____1626 = Math.ceil(seconds);
        this.____1712 = ____655.____662.getSystemTime();
        this.____1325 = this.____1712;
        this.____1769 = tickCb;
        this.____1131 = endCb;
        this.____930 = cbParams;
        this.____1337 = this.____1626;
        if (this.____1626 == 0) {
            this.stop()
        } else {
            if (this.____1769 != null) {
                this.____1769(this.____930)
            }
            this.updateLabel();
            ____654.____678.____298(this.tick, this)
        }
    },
    tick: function(delta, tickCount) {
        if (this.____1325 == null) {
            this.____1325 = ____655.____662.getSystemTime();
            return
        }
        if (____655.____662.getSystemTime() - this.____1325 >= 1000) {
            this.____1325 = ____655.____662.getSystemTime();
            this.____1337 = this.____1626 - Math.floor((this.____1325 - this.____1712) / 1000);
            if (this.____1337 <= 0) {
                this.____1337 = 0;
                this.stop()
            } else {
                if (this.____1769 != null) {
                    this.____1769(this.____930)
                }
                this.updateLabel()
            }
        }
    },
    stop: function() {
        ____654.____678.____299(this.tick, this);
        this.updateLabel();
        if (this.____1769 != null) {
            this.____1769(this.____930)
        }
        if (this.____1131 != null) {
            this.____1131(this.____930)
        }
    },
    getLeftTime: function() {
        return this.____1337
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____1769 = null;
        this.____1131 = null;
        this.____930 = null;
        this._label = null;
        this.____1172 = null
    },
});
var MD5 = cc.Class.extend({
    ctor: function() {},
    raw_md5: function(s) {
        return this.rstr_md5(this.str2rstr_utf8(s))
    },
    hex_md5: function(s) {
        return this.rstr2hex(this.raw_md5(s))
    },
    raw_hmac_md5: function(k, d) {
        return this.rstr_hmac_md5(this.str2rstr_utf8(k), this.str2rstr_utf8(d))
    },
    hex_hmac_md5: function(k, d) {
        return this.rstr2hex(this.raw_hmac_md5(k, d))
    },
    str2rstr_utf8: function(input) {
        return unescape(encodeURIComponent(input))
    },
    rstr2hex: function(input) {
        var hex_tab = '0123456789abcdef',
            output = '',
            x, i;
        for (i = 0; i < input.length; i += 1) {
            x = input.charCodeAt(i);
            output += hex_tab.charAt((x >>> 4) & 0x0F) + hex_tab.charAt(x & 0x0F)
        }
        return output
    },
    rstr_hmac_md5: function(key, data) {
        var i, bkey = this.rstr2binl(key),
            ipad = [],
            opad = [],
            hash;
        ipad[15] = opad[15] = undefined;
        if (bkey.length > 16) {
            bkey = this.binl_md5(bkey, key.length * 8)
        }
        for (i = 0; i < 16; i += 1) {
            ipad[i] = bkey[i] ^ 0x36363636;
            opad[i] = bkey[i] ^ 0x5C5C5C5C
        }
        hash = this.binl_md5(ipad.concat(this.rstr2binl(data)), 512 + data.length * 8);
        return this.binl2rstr(this.binl_md5(opad.concat(hash), 512 + 128))
    },
    rstr_md5: function(s) {
        return this.binl2rstr(this.binl_md5(this.rstr2binl(s), s.length * 8))
    },
    rstr2binl: function(input) {
        var i, output = [];
        output[(input.length >> 2) - 1] = undefined;
        for (i = 0; i < output.length; i += 1) {
            output[i] = 0
        }
        for (i = 0; i < input.length * 8; i += 8) {
            output[i >> 5] |= (input.charCodeAt(i / 8) & 0xFF) << (i % 32)
        }
        return output
    },
    binl2rstr: function(input) {
        var i, output = '';
        for (i = 0; i < input.length * 32; i += 8) {
            output += String.fromCharCode((input[i >> 5] >>> (i % 32)) & 0xFF)
        }
        return output
    },
    binl_md5: function(x, len) {
        x[len >> 5] |= 0x80 << (len % 32);
        x[(((len + 64) >>> 9) << 4) + 14] = len;
        var i, olda, oldb, oldc, oldd, a = 1732584193,
            b = -271733879,
            c = -1732584194,
            d = 271733878;
        for (i = 0; i < x.length; i += 16) {
            olda = a;
            oldb = b;
            oldc = c;
            oldd = d;
            a = this.md5_ff(a, b, c, d, x[i], 7, -680876936);
            d = this.md5_ff(d, a, b, c, x[i + 1], 12, -389564586);
            c = this.md5_ff(c, d, a, b, x[i + 2], 17, 606105819);
            b = this.md5_ff(b, c, d, a, x[i + 3], 22, -1044525330);
            a = this.md5_ff(a, b, c, d, x[i + 4], 7, -176418897);
            d = this.md5_ff(d, a, b, c, x[i + 5], 12, 1200080426);
            c = this.md5_ff(c, d, a, b, x[i + 6], 17, -1473231341);
            b = this.md5_ff(b, c, d, a, x[i + 7], 22, -45705983);
            a = this.md5_ff(a, b, c, d, x[i + 8], 7, 1770035416);
            d = this.md5_ff(d, a, b, c, x[i + 9], 12, -1958414417);
            c = this.md5_ff(c, d, a, b, x[i + 10], 17, -42063);
            b = this.md5_ff(b, c, d, a, x[i + 11], 22, -1990404162);
            a = this.md5_ff(a, b, c, d, x[i + 12], 7, 1804603682);
            d = this.md5_ff(d, a, b, c, x[i + 13], 12, -40341101);
            c = this.md5_ff(c, d, a, b, x[i + 14], 17, -1502002290);
            b = this.md5_ff(b, c, d, a, x[i + 15], 22, 1236535329);
            a = this.md5_gg(a, b, c, d, x[i + 1], 5, -165796510);
            d = this.md5_gg(d, a, b, c, x[i + 6], 9, -1069501632);
            c = this.md5_gg(c, d, a, b, x[i + 11], 14, 643717713);
            b = this.md5_gg(b, c, d, a, x[i], 20, -373897302);
            a = this.md5_gg(a, b, c, d, x[i + 5], 5, -701558691);
            d = this.md5_gg(d, a, b, c, x[i + 10], 9, 38016083);
            c = this.md5_gg(c, d, a, b, x[i + 15], 14, -660478335);
            b = this.md5_gg(b, c, d, a, x[i + 4], 20, -405537848);
            a = this.md5_gg(a, b, c, d, x[i + 9], 5, 568446438);
            d = this.md5_gg(d, a, b, c, x[i + 14], 9, -1019803690);
            c = this.md5_gg(c, d, a, b, x[i + 3], 14, -187363961);
            b = this.md5_gg(b, c, d, a, x[i + 8], 20, 1163531501);
            a = this.md5_gg(a, b, c, d, x[i + 13], 5, -1444681467);
            d = this.md5_gg(d, a, b, c, x[i + 2], 9, -51403784);
            c = this.md5_gg(c, d, a, b, x[i + 7], 14, 1735328473);
            b = this.md5_gg(b, c, d, a, x[i + 12], 20, -1926607734);
            a = this.md5_hh(a, b, c, d, x[i + 5], 4, -378558);
            d = this.md5_hh(d, a, b, c, x[i + 8], 11, -2022574463);
            c = this.md5_hh(c, d, a, b, x[i + 11], 16, 1839030562);
            b = this.md5_hh(b, c, d, a, x[i + 14], 23, -35309556);
            a = this.md5_hh(a, b, c, d, x[i + 1], 4, -1530992060);
            d = this.md5_hh(d, a, b, c, x[i + 4], 11, 1272893353);
            c = this.md5_hh(c, d, a, b, x[i + 7], 16, -155497632);
            b = this.md5_hh(b, c, d, a, x[i + 10], 23, -1094730640);
            a = this.md5_hh(a, b, c, d, x[i + 13], 4, 681279174);
            d = this.md5_hh(d, a, b, c, x[i], 11, -358537222);
            c = this.md5_hh(c, d, a, b, x[i + 3], 16, -722521979);
            b = this.md5_hh(b, c, d, a, x[i + 6], 23, 76029189);
            a = this.md5_hh(a, b, c, d, x[i + 9], 4, -640364487);
            d = this.md5_hh(d, a, b, c, x[i + 12], 11, -421815835);
            c = this.md5_hh(c, d, a, b, x[i + 15], 16, 530742520);
            b = this.md5_hh(b, c, d, a, x[i + 2], 23, -995338651);
            a = this.md5_ii(a, b, c, d, x[i], 6, -198630844);
            d = this.md5_ii(d, a, b, c, x[i + 7], 10, 1126891415);
            c = this.md5_ii(c, d, a, b, x[i + 14], 15, -1416354905);
            b = this.md5_ii(b, c, d, a, x[i + 5], 21, -57434055);
            a = this.md5_ii(a, b, c, d, x[i + 12], 6, 1700485571);
            d = this.md5_ii(d, a, b, c, x[i + 3], 10, -1894986606);
            c = this.md5_ii(c, d, a, b, x[i + 10], 15, -1051523);
            b = this.md5_ii(b, c, d, a, x[i + 1], 21, -2054922799);
            a = this.md5_ii(a, b, c, d, x[i + 8], 6, 1873313359);
            d = this.md5_ii(d, a, b, c, x[i + 15], 10, -30611744);
            c = this.md5_ii(c, d, a, b, x[i + 6], 15, -1560198380);
            b = this.md5_ii(b, c, d, a, x[i + 13], 21, 1309151649);
            a = this.md5_ii(a, b, c, d, x[i + 4], 6, -145523070);
            d = this.md5_ii(d, a, b, c, x[i + 11], 10, -1120210379);
            c = this.md5_ii(c, d, a, b, x[i + 2], 15, 718787259);
            b = this.md5_ii(b, c, d, a, x[i + 9], 21, -343485551);
            a = this.safe_add(a, olda);
            b = this.safe_add(b, oldb);
            c = this.safe_add(c, oldc);
            d = this.safe_add(d, oldd)
        }
        return [a, b, c, d]
    },
    md5_cmn: function(q, a, b, x, s, t) {
        return this.safe_add(this.bit_rol(this.safe_add(this.safe_add(a, q), this.safe_add(x, t)), s), b)
    },
    md5_ff: function(a, b, c, d, x, s, t) {
        return this.md5_cmn((b & c) | ((~b) & d), a, b, x, s, t)
    },
    md5_gg: function(a, b, c, d, x, s, t) {
        return this.md5_cmn((b & d) | (c & (~d)), a, b, x, s, t)
    },
    md5_hh: function(a, b, c, d, x, s, t) {
        return this.md5_cmn(b ^ c ^ d, a, b, x, s, t)
    },
    md5_ii: function(a, b, c, d, x, s, t) {
        return this.md5_cmn(c ^ (b | (~d)), a, b, x, s, t)
    },
    safe_add: function(x, y) {
        var lsw = (x & 0xFFFF) + (y & 0xFFFF);
        var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
        return (msw << 16) | (lsw & 0xFFFF)
    },
    bit_rol: function(num, cnt) {
        return (num << cnt) | (num >>> (32 - cnt))
    },
    md5: function(string, key, raw) {
        if (!key) {
            if (!raw) {
                return this.hex_md5(string)
            }
            return this.raw_md5(string)
        }
        if (!raw) {
            return this.hex_hmac_md5(key, string)
        }
        return this.raw_hmac_md5(key, string)
    }
});
var ____542 = cc.Class.extend({
    getPlayerStyleBin: function(data, warState, nick) {
        var styleBin = {};
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var id = data.readByte();
            styleBin[id] = data.readInt()
        }
        styleBin[____655.____659.commonStaticType.style_isHorse] = data.readBoolean();
        if (warState == null) warState = 0;
        if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.XUNBAO_COPYID || ____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.ZUOYAO_COPYID) {
            styleBin[____655.____659.commonStaticType.style_Buff] = ____655.allTemplates.copyTemplateList.getBuffIdByWarState(____655.copyInfo.currentId, warState)
        } else if (warState > 0) {
            var buffId = ____655.allTemplates.copyTemplateList.getBuffIdByWarState(____655.copyInfo.currentId, warState);
            if (buffId > 0) {
                styleBin[____655.____659.commonStaticType.style_Buff] = buffId
            }
        }
        return styleBin
    },
    ____187: function(player, data, warState) {
        player.characterInfo.updateStyle(this.getPlayerStyleBin(data, warState, player.nick))
    },
    ____186: function(player, data) {
        player.nick = data.readString();
        player.____64(data.readShort());
        player.setCareer(data.readByte());
        player.serverId = data.readShort();
        player.____65(data.readByte())
    },
    ____188: function(player, data, warState) {
        this.____186(player, data);
        this.____187(player, data, warState);
        player.clubId = data.readNumber();
        player.clubName = data.readString();
        player.clubJob = data.readByte();
        player.clubLevel = data.readShort();
        player.setPKmode(data.readByte());
        player.____75(data.readInt());
        player.teamId = data.readInt();
        player.characterInfo.reflesh()
    },
    ____190: function(player, data) {
        this.____188(player, data);
        player.setXianwei(data.readShort());
        this.setPlyerPropertys(player, data)
    },
    setPlyerPropertys: function(player, data) {
        player.maxHP = data.readNumber();
        player.currentHP = data.readNumber();
        player.attack = data.readInt();
        player.defense = data.readInt();
        player.propertys = [];
        for (var i = 0; i < 10; i++) {
            player.propertys.push(data.readInt())
        }
    },
    ____191: function(player, data) {
        this.____190(player, data);
        player.account = data.readString();
        var strList = player.account.split("_");
        player.shortAccount = strList[0];
        player.exp = data.readNumber();
        player.moneyInfo.____77(data);
        player.updateBagMaxCount(data.readShort());
        player.pvpChangeDate = data.readInt()
    },
    setItem: function(itemInfo, data) {
        itemInfo.____107(data.readInt());
        var bagTypeChange = false;
        var lastBagType = itemInfo.bagType;
        itemInfo.bagType = data.readUByte();
        if (itemInfo.bagType != lastBagType) {
            bagTypeChange = true
        }
        itemInfo.isBind = data.readBoolean();
        itemInfo.count = data.readShort();
        itemInfo.qhLevel = data.readShort();
        itemInfo.quality = data.readShort();
        itemInfo.vaildDate = data.readInt() * 1000;
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var place = data.readByte();
            var proInfo = itemInfo.rollProperty[place];
            if (proInfo == null) {
                proInfo = new RollPropertyInfo();
                itemInfo.rollProperty[place] = proInfo
            }
            proInfo.star = data.readByte();
            proInfo.id = data.readShort();
            proInfo.value = data.readInt();
            proInfo.quality = data.readByte()
        }
        itemInfo.updateInfo();
        return bagTypeChange
    },
    setStoneInfo: function(stoneInfoList, data) {
        var len = data.readByte();
        for (var i = 0; i < len; i++) {
            var categoryId = data.readByte();
            var info = stoneInfoList[categoryId];
            if (info == null) {
                info = {};
                stoneInfoList[categoryId] = info
            }
            var len2 = data.readByte();
            for (var j = 0; j < len2; j++) {
                info[data.readByte()] = data.readNumber()
            }
        }
    },
    setGodWeaponInfo: function(godWeaponlist, data) {
        var currentShenBin = null;
        var len = data.readByte();
        for (i = 0; i < len; i++) {
            var type = data.readByte();
            var info = godWeaponlist[type];
            if (info == null) {
                info = new WeaponGodInfo();
                info.type = type;
                godWeaponlist[type] = info
            }
            info.level = data.readShort();
            info.isUse = data.readBoolean();
            if (info.isUse) {
                currentShenBin = info
            }
        }
        return currentShenBin
    },
});
var ____2113 = cc.Class.extend({
    SPEAKER: "alert_speaker",
    ITEMSELL: "alert_itemSell",
    PERSONBOSS: "alert_personBoss",
    JIAZUWARGUWU: "alert_jiazuWarGuwu",
    DOUSHENFIGHT: "alert_doushenFight",
    COPLATETASK: "alert_complatetask",
    DOUSHENADDTIME: "alert_doushenAddTime",
    TGHJ_OPENTIME: "alert_tghjOpenTime",
    ADVANCE_UP: "alert_advanceUp",
    LUCKYTREASURE1: "alert_luckytreasure1",
    LUCKYTREASURE10: "alert_luckytreasure10",
    TGXS_OPENTIME: "alert_tgxsOpenTime",
    HOME_PLANT: "home_plant_seed",
    HOME_PLANT_SPEED: "home_plant_speed",
    HOME_HUNT: "home_hunt",
    HOME_HUNT_SPEED: "home_hunt_speed",
    SHENJIANG_BOSS: "shenjiang_boss",
    getIsShow: function(type) {
        var showTime = ____654.sdk.readKV(type);
        if (showTime == "" || showTime == null) {
            return true
        }
        showTime = parseInt(showTime);
        if (showTime == 0 || showTime == null) {
            return true
        }
        return ____655.____662.getBetweenTimeDay(showTime, ____655.____662.getSystemTimeSec()) > 0
    },
    setNotShow: function(type) {
        var time = ____655.____662.getSystemTimeSec();
        ____654.sdk.writeKV(type, time)
    },
});
var ____2114 = cc.Class.extend({
    jsc: null,
    showLoginCallbackSuccess: null,
    showLoginCallbackError: null,
    showLoginCallbackCancel: null,
    logoutCallbackSuccess: null,
    logoutCallbackFailed: null,
    logoutCallbackNoAPI: null,
    payCallbackSuccess: null,
    payCallbackFailed: null,
    payCallbackCancel: null,
    uploadCallback: null,
    downloadCallback: null,
    voiceCompletionCallback: null,
    billNOType: 0,
    recordTime: 0,
    restartDiff: 60000,
    SAVELOGINNAME: "SAVELOGINNAME",
    SAVELOCALSERVER: "SAVELOCALSERVER",
    ctor: function(jsc) {
        this.jsc = jsc;
        jsc.JS_VERSION_NAME = 1;
        jsc.JS_APP_NAME = 2;
        jsc.JS_PACKAGE_NAME = 3;
        jsc.JS_SHOW_TIP = 4;
        jsc.JS_SET_CALLBACK = 5;
        jsc.JS_GET_SDK_ID = 6;
        jsc.JS_CHGHOSTTOIP = 7;
        jsc.JS_SHOWCONFIRM = 8;
        jsc.JS_EXIT = 9;
        jsc.JS_PRESSBACK = 10;
        jsc.JS_SETRESTARTTIME = 11;
        jsc.JS_GETNETWORKSTATE = 12;
        jsc.JS_STARTLOCK = 13;
        jsc.JS_RELEASELOCK = 14;
        jsc.JS_SET_PROCESSFILTERS = 15;
        jsc.JS_CHECKGAMESPEED = 16;
        jsc.JS_INITSDK = 21;
        jsc.JS_SHOWSDKLOGINPAGE = 22;
        jsc.JS_ENTERSNSCENTER = 23;
        jsc.JS_SHOWPAYPAGE = 24;
        jsc.JS_SENDDATA = 25;
        jsc.JS_LOGINOUT = 26;
        jsc.JS_HASUSERCENTER = 27;
        jsc.JS_HASLOGINOUT = 28;
        jsc.JS_GETCHILDCHANNEL = 29;
        jsc.JS_CONFIRMUSERNAME = 30;
        jsc.JS_GETSDKSUFFIX = 31;
        jsc.JS_REGNOTIFY = 41;
        jsc.JS_UNREGNOTIFY = 42;
        jsc.JS_NOTIFYTOKEN = 43;
        jsc.JS_SETNOTIFY = 44;
        jsc.JS_CLEANNOTIFY = 45;
        jsc.JS_SETTAG = 46;
        jsc.JS_DELTAG = 47;
        jsc.JS_STARTVOICE = 50;
        jsc.JS_STOPVOICE = 51;
        jsc.JS_PLAYVOICE = 52;
        jsc.JS_DELFILE = 53;
        jsc.JS_UPLOADFILE = 54;
        jsc.JS_DOWNLOADFILE = 55;
        jsc.CALL_ONRESUME = 101;
        jsc.CALL_ONDESTROY = 102;
        jsc.CALL_ONPAUSE = 103;
        jsc.CALL_ONSTART = 104;
        jsc.CALL_ONSTOP = 105;
        jsc.CALL_ONNEWINTENT = 106;
        jsc.CALL_ONACTIVITYRESULT = 107;
        jsc.CALL_ONRESTART = 108;
        jsc.CALL_ONCREATE = 109;
        jsc.CALL_ONFOCUS = 110;
        jsc.CALL_PRESSBACK = 121;
        jsc.CALL_DIALOGOK = 122;
        jsc.CALL_DIALOGCANCEL = 123;
        jsc.CALL_APP_TIP = 124;
        jsc.CALL_USERSPEED = 125;
        jsc.CALL_INITCOMPLETE = 141;
        jsc.CALL_SDKINITFAILED = 142;
        jsc.CALL_SDKLOGINSUCCESS = 143;
        jsc.CALL_SDKLOGINERROR = 144;
        jsc.CALL_SDKLOGCANCEL = 145;
        jsc.CALL_SDKPAYSUCCESS = 146;
        jsc.CALL_SDKPAYFAILED = 147;
        jsc.CALL_SDKPAYCANCEL = 148;
        jsc.CALL_SDKLOGOUT_SUCCESS = 149;
        jsc.CALL_SDKLOGOUT_FAILED = 150;
        jsc.CALL_SDKLOGOUT_NOAPI = 151;
        jsc.CALL_SDKPRESWITCH_ACCOUNT = 152;
        jsc.CALL_SDKAFTERSWITCH_ACCOUNT = 153;
        jsc.CALL_SDKBINDACCOUNT = 154;
        jsc.CALL_SDKEXIT_NOUI = 155;
        jsc.CALL_SDKEXIT_UI_CONTINUE = 156;
        jsc.CALL_SDKEXIT_UI_CANCEL = 157;
        jsc.CALL_SDKEXIT_ERROR = 158;
        jsc.CALL_UPLOADFILE = 171;
        jsc.CALL_DOWNLOADFILE = 172;
        jsc.CALL_VOICECOMPLETION = 173;
        this.____6()
    },
    writeKV: function(key, value) {
        this.jsc.writeKV(key, value)
    },
    readKV: function(key) {
        return this.jsc.readKV(key)
    },
    setLocalUserId: function(userId) {
        this.writeKV(this.SAVELOGINNAME, userId)
    },
    getLocalUserId: function() {
        return this.readKV(this.SAVELOGINNAME)
    },
    setLocalServer: function(areaId, serverId) {
        this.writeKV(this.SAVELOCALSERVER, JSON.stringify([areaId, serverId]))
    },
    getLocalServer: function() {
        var str = this.readKV(this.SAVELOCALSERVER);
        if (!str || str.length == 0) return [];
        return JSON.parse(str)
    },
    ____6: function() {
        var this_ = this;
        this.jsc.addCallback(this.jsc.CALL_PRESSBACK, function(vals) {
            this_.pressBack()
        });
        this.jsc.addCallback(this.jsc.CALL_DIALOGOK, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_DIALOGCANCEL, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_APP_TIP, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_USERSPEED, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_SDKPAYSUCCESS, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_SDKPAYFAILED, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_SDKPAYCANCEL, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_SDKPRESWITCH_ACCOUNT, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_SDKAFTERSWITCH_ACCOUNT, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_SDKBINDACCOUNT, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_SDKEXIT_UI_CONTINUE, function(vals) {
            this_.exit()
        });
        this.jsc.addCallback(this.jsc.CALL_SDKEXIT_NOUI, function(vals) {
            this_.showConfirm("是否确定退出游戏？", "exit")
        });
        this.jsc.addCallback(this.jsc.CALL_DIALOGOK, function(vals) {
            this_.dialogOk(vals)
        });
        this.jsc.addCallback(this.jsc.CALL_DIALOGCANCEL, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_ONRESUME, function(vals) {
            print("#this_.startLock");
            this_.startLock();
            var currentTime = new Date().getTime();
            print("#need restart", currentTime, this_.recordTime);
            if (currentTime - this_.recordTime > this_.restartDiff) {
                cc.director.restart()
            }
            this_.recordTime = currentTime
        });
        this.jsc.addCallback(this.jsc.CALL_ONPAUSE, function(vals) {
            print("#this_.releaseLock");
            this_.releaseLock();
            this_.recordTime = new Date().getTime()
        });
        this.jsc.addCallback(this.jsc.CALL_SDKLOGOUT_SUCCESS, function(vals) {
            this_.clearAndClose()
        });
        this.jsc.addCallback(this.jsc.CALL_SDKLOGOUT_FAILED, function(vals) {});
        this.jsc.addCallback(this.jsc.CALL_SDKLOGOUT_NOAPI, function(vals) {})
    },
    showLogin: function(callback) {
        var this_ = this;

        function doCallback(retCode, vals) {
            this_.jsc.removeCallback(this_.jsc.CALL_SDKLOGINSUCCESS, this_.showLoginCallbackSuccess);
            this_.jsc.removeCallback(this_.jsc.CALL_SDKLOGINERROR, this_.showLoginCallbackError);
            this_.jsc.removeCallback(this_.jsc.CALL_SDKLOGCANCEL, this_.showLoginCallbackCancel);
            this_.showLoginCallbackSuccess = null;
            this_.showLoginCallbackError = null;
            this_.showLoginCallbackCancel = null;
            if (!!callback) callback(retCode == 0, vals)
        }
        this_.showLoginCallbackSuccess = function(vals) {
            doCallback(0, vals)
        };
        this_.showLoginCallbackError = function(vals) {
            doCallback(1, vals)
        };
        this_.showLoginCallbackCancel = function(vals) {
            doCallback(2, vals)
        };
        this.jsc.addCallback(this.jsc.CALL_SDKLOGINSUCCESS, this.showLoginCallbackSuccess);
        this.jsc.addCallback(this.jsc.CALL_SDKLOGINERROR, this.showLoginCallbackError);
        this.jsc.addCallback(this.jsc.CALL_SDKLOGCANCEL, this.showLoginCallbackCancel);
        this.jsc.jsCall([this_.jsc.JS_SHOWSDKLOGINPAGE])
    },
    clearAndClose: function() {
        if (____654.____680.isConnect()) {
            ____654.clearAll();
            ____655.____61();
            ____655.isLogout = true;
            ____654.____680.close()
        } else {
            ____654.____672.dispatchEvent(new ____590(____655.____661.start_restart, ____654.____672, null))
        }
    },
    logout: function() {
        if (____655.gameConfig.isNoSdkOrTestSdk()) {
            this.clearAndClose();
            return
        }
        this.jsc.jsCall([this.jsc.JS_LOGINOUT])
    },
    chgHostToIp: function(host) {
        if (____655.gameConfig.isWin()) {
            return ____654.____680.chgHost2Ip(host)
        }
        return this.jsc.jsCall([this.jsc.JS_CHGHOSTTOIP, host])
    },
    showConfirm: function(tips, tag) {
        this.jsc.jsCall([this.jsc.JS_SHOWCONFIRM, tips, tag])
    },
    dialogOk: function(vals) {
        if (vals == "exit") {
            this.exit()
        }
    },
    exit: function() {
        this.jsc.jsCall([this.jsc.JS_EXIT])
    },
    pressBack: function() {
        this.jsc.jsCall([this.jsc.JS_PRESSBACK])
    },
    setRestartTime: function(time) {
        this.jsc.jsCall([this.jsc.JS_SETRESTARTTIME, time])
    },
    getNetWorkState: function() {
        return this.jsc.jsCall([this.jsc.JS_GETNETWORKSTATE])
    },
    startLock: function() {
        this.jsc.jsCall([this.jsc.JS_STARTLOCK])
    },
    releaseLock: function() {
        this.jsc.jsCall([this.jsc.JS_RELEASELOCK])
    },
    setProcessFilters: function(processes) {
        this.jsc.jsCall([this.jsc.JS_SET_PROCESSFILTERS, processes])
    },
    checkGameSpeed: function() {
        this.jsc.jsCall([this.jsc.JS_CHECKGAMESPEED])
    },
    hasLogout: function() {
        return this.jsc.jsCall([this.jsc.JS_HASLOGINOUT]) == "true"
    },
    hasUserCenter: function() {
        return this.jsc.jsCall([this.jsc.JS_HASUSERCENTER]) == "true"
    },
    userCenter: function() {
        if (this.hasUserCenter) {
            this.jsc.jsCall([this.jsc.JS_ENTERSNSCENTER])
        }
    },
    setPlayerInfo: function() {
        return this.sendData("setPlayerInfo", ____655.____667.userId, ____655.____667.nick, ____655.____667.level, ____655.____667.moneyInfo.getMoneyCountByType(1), ____655.____667.serverId, ____655.____663.serverName, ____655.____667.uniteName, ____655.____667.vipLevel, ____655.____667.shortAccount, ____655.____667.createRoleTime * 0.001, ____655.____667.levelUpTime * 0.001)
    },
    createRole: function() {
        return this.sendData("createRole", ____655.____667.nick, ____655.____667.createRoleTime * 0.001, ____655.____667.levelUpTime * 0.001)
    },
    enterGameServer: function() {
        return this.sendData("enterGameServer", ____655.____667.serverId, ____655.____667.userId, ____655.____667.nick, ____655.____667.createRoleTime * 0.001, ____655.____667.levelUpTime * 0.001)
    },
    levelUp: function() {
        return this.sendData("levelChange", ____655.____667.nick, ____655.____667.level, ____655.____667.moneyInfo.getMoneyCountByType(1), ____655.____667.createRoleTime * 0.001, ____655.____667.levelUpTime * 0.001)
    },
    sendAccessToken: function() {
        this.sendData("setPlayerInfo", "0", "0", "0", "0", "0", "0", "0", "0", ____655.____663.getShortAccount(), "0", "0");
        return this.sendData("setAccessToken", ____655.____663.accessToken)
    },
    sendData: function(cmd) {
        if (____655.gameConfig.isNoSdkOrTestSdk()) return;
        var data = [this.jsc.JS_SENDDATA, cmd];
        for (var i = 1; i < arguments.length; i++) {
            data.push(arguments[i])
        }
        return this.jsc.jsCall(data)
    },
    pay: function(template, callback) {
        if (____655.gameConfig.isNoSdkOrTestSdk()) return;
        var timespan = ____655.____662.getSystemTime(),
            payNum = template.price,
            payName = template.unit,
            payCount = template.count,
            billNO = timespan + "_" + ____655.____667.serverId + "_" + template.payType + "_" + ____655.____667.shortAccount,
            produceId = ____655.allTemplates.payTemplateList.getProduceIdForTemplateInfo(template);
        if (____655.____663.orderMD5Type == 1) {
            billNO = ____654.____674.md5(billNO)
        }
        var list = [this.jsc.JS_SHOWPAYPAGE, ____655.____667.serverId, ____655.____667.userId, ____655.____667.shortAccount, ____655.____667.nick, ____655.____667.level, ____655.____667.vipLevel, payNum, payName, payCount, billNO, ____655.gameConfig.payUrl, ____655.____667.moneyInfo.getMoneyCountByType(1), ____655.____667.clubName, ____655.____663.serverName, produceId, "kuyouendflag"];
        var this_ = this;

        function doCallback(retCode, vals) {
            this.jsc.removeCallback(this.jsc.CALL_SDKPAYSUCCESS, this.payCallbackSuccess);
            this.jsc.removeCallback(this.jsc.CALL_SDKPAYFAILED, this.payCallbackFailed);
            this.jsc.removeCallback(this.jsc.CALL_SDKPAYCANCEL, this.payCallbackCancel);
            this_.payCallbackSuccess = null;
            this_.payCallbackFailed = null;
            this_.payCallbackCancel = null;
            if (!!callback) callback(retCode, vals)
        }
        this_.payCallbackSuccess = function(vals) {
            doCallback(0, vals)
        };
        this_.payCallbackFailed = function(vals) {
            doCallback(1, vals)
        };
        this_.payCallbackCancel = function(vals) {
            doCallback(2, vals)
        };
        this.jsc.addCallback(this.jsc.CALL_SDKPAYSUCCESS, this.payCallbackSuccess);
        this.jsc.addCallback(this.jsc.CALL_SDKPAYFAILED, this.payCallbackFailed);
        this.jsc.addCallback(this.jsc.CALL_SDKPAYCANCEL, this.payCallbackCancel);
        this.jsc.jsCall(list);
        var url = ____655.gameConfig.billUrl + "?a=" + ____655.gameConfig.agentId + "&s=" + ____655.____667.serverId + "&u=" + ____655.____667.shortAccount + "&t=" + timespan + "&m=" + payNum + "&o=" + billNO + "&tp=" + template.payType;
        print("#pay url", url);
        ____654.____677.loadRemoteTxt(url, function() {
            print("#充值上报回调")
        })
    },
    getChildChannel: function() {
        return this.jsc.jsCall([this.jsc.JS_GETCHILDCHANNEL]) || 0
    },
    confirmUserName: function(username) {
        return this.jsc.jsCall([this.jsc.JS_CONFIRMUSERNAME, username])
    },
    getSdkSuffix: function() {
        return this.jsc.jsCall([this.jsc.JS_GETSDKSUFFIX])
    },
    delFile: function(filepath) {
        print("#delFile", filepath, ____654.____673.isFileExist(filepath));
        if (____654.____673.isFileExist(filepath)) {
            return jsb.fileUtils.removeFile(filepath)
        }
        return true
    },
    getVoiceFullPath: function(filename) {
        return verpath + "/voice/" + filename + ".amr"
    },
    startVoice: function(filename) {
        var fullpath = this.getVoiceFullPath(filename);
        return this.jsc.jsCall([this.jsc.JS_STARTVOICE, fullpath])
    },
    stopVoice: function(callback) {
        return this.jsc.jsCall([this.jsc.JS_STOPVOICE])
    },
    playVoice: function(filename, callback) {
        var fullpath = this.getVoiceFullPath(filename),
            this_ = this;
        if (!!callback) {
            function doCallback(vals) {
                this_.jsc.removeCallback(this_.jsc.CALL_VOICECOMPLETION, this_.voiceCompletionCallback);
                this_.voiceCompletionCallback = null;
                callback(filename)
            }
            this_.voiceCompletionCallback = function(vals) {
                doCallback(vals)
            };
            this.jsc.addCallback(this.jsc.CALL_VOICECOMPLETION, this.voiceCompletionCallback)
        }
        return this.jsc.jsCall([this.jsc.JS_PLAYVOICE, fullpath])
    },
    delVoice: function(filename) {
        var fullpath = this.getVoiceFullPath(filename);
        return this.jsc.jsCall([this.jsc.JS_DELFILE, fullpath])
    },
    getUploadServerUrl: function() {
        return ____655.gameConfig.uploadVoiceUrl.format(____655.____663.serverId)
    },
    getDownloadServerUrl: function(filename) {
        return ____655.gameConfig.downloadVoiceUrl.format(____655.____663.serverId, filename)
    },
    uploadVoice: function(filename, callback, msgDict) {
        var msg = "",
            uploadServerPath = this.getUploadServerUrl(),
            fullpath = this.getVoiceFullPath(filename),
            this_ = this;
        if (!!msgDict) {
            for (var key in msgDict) {
                msg += "|" + key + "," + msgDict[key]
            }
            if (msg.length > 0) msg = msg.substring(1)
        }
        if (!!callback) {
            function doCallback(vals) {
                var cbParams = vals.split(","),
                    retCode = parseInt(cbParams[0]),
                    cbVals = cbParams[1];
                this_.jsc.removeCallback(this_.jsc.CALL_UPLOADFILE, this_.uploadCallback);
                this_.uploadCallback = null;
                callback(retCode == 0, cbVals)
            }
            this_.uploadCallback = function(vals) {
                doCallback(vals)
            };
            this.jsc.addCallback(this.jsc.CALL_UPLOADFILE, this.uploadCallback)
        }
        return this.jsc.jsCall([this.jsc.JS_UPLOADFILE, uploadServerPath, fullpath, msg])
    },
    downloadVoice: function(filename, callback) {
        var fullpath = this.getVoiceFullPath(filename),
            downServerPath = this.getDownloadServerUrl(filename),
            this_ = this;
        if (!!callback) {
            function doCallback(vals) {
                var cbParams = vals.split(","),
                    retCode = parseInt(cbParams[0]),
                    cbVals = filename;
                this_.jsc.removeCallback(this_.jsc.CALL_DOWNLOADFILE, this_.downloadCallback);
                this_.downloadCallback = null;
                callback(retCode == 0, cbVals)
            }
            this_.downloadCallback = function(vals) {
                doCallback(vals)
            };
            this.jsc.addCallback(this.jsc.CALL_DOWNLOADFILE, this.downloadCallback)
        }
        return this.jsc.jsCall([this.jsc.JS_DOWNLOADFILE, downServerPath, fullpath])
    },
    regNotify: function() {
        this.jsc.jsCall([this.jsc.JS_REGNOTIFY])
    },
    unregNotify: function() {
        this.jsc.jsCall([this.jsc.JS_UNREGNOTIFY])
    },
    notifyToken: function() {
        return this.jsc.jsCall([this.jsc.JS_NOTIFYTOKEN])
    },
    setNotify: function(title, content, date, HH, mm) {
        this.jsc.jsCall([this.jsc.JS_SETNOTIFY, title, content, date, HH, mm])
    },
    cleanNotify: function() {
        this.jsc.jsCall([this.jsc.JS_CLEANNOTIFY])
    },
    setNotifyTag: function(tag) {
        this.jsc.jsCall([this.jsc.JS_SETTAG, tag])
    },
    delNotifyTag: function(tag) {
        this.jsc.jsCall([this.jsc.JS_DELTAG, tag])
    },
    feedback: function(fbtype, label, text) {
        var url = ____655.gameConfig.feedbackUrl;
        if (!url) return;
        var data = {
            game_id: 63,
            game_channel_id: this.getChildChannel(),
            user_id: ____655.____663.getShortAccount(),
            server_id: ____655.____667.serverId,
            label: label,
            type: fbtype,
            role_id: ____655.____667.userId,
            role_name: ____655.____667.nick,
            comment_content: text,
            phone_model: "none",
            client_servion: ____654.sdk.jsc.getVerionCode(),
            level: ____655.____667.level,
            pay_sum: ____655.____667.moneyInfo.list[2]
        };
        ____654.____677.post(url, function(errorInfo, response) {
            if (!!errorInfo) {
                print("#feedback error", errorInfo)
            } else {
                print("#response", response)
            }
        }, data)
    }
});
var ____2115 = cc.Class.extend({
    colorShaderList: null,
    colorList: null,
    colorInfoWaitList: null,
    timeCount: 0,
    ctor: function() {
        this.colorShaderList = [];
        this.colorList = [
            ["1.0", "0.0", "0.0", "0.0", "1.0", "0.0", "0.0", "0.0", "1.0"],
            ["0.3", "0.6", "0.1", "0.3", "0.6", "0.1", "0.3", "0.6", "0.1"]
        ];
        this.colorInfoWaitList = []
    },
    setColor: function(node, ____688) {
        if (node == null) {
            return
        }
        var tempShader = this.colorShaderList[____688];
        if (tempShader == null) {
            tempShader = cc.GLProgram.createWithByteArrays(this.getColorVSH(), this.getColorFSH(this.colorList[____688]));
            tempShader.retain();
            tempShader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
            tempShader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
            tempShader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
            tempShader.link();
            tempShader.updateUniforms();
            this.colorShaderList[____688] = tempShader
        }
        gl.useProgram(tempShader.getProgram());
        this.colorInfoWaitList.push([node, ____688]);
        this.timeCount = 3;
        ____654.____678.____298(this.setColorTick, this)
    },
    removeColor: function(node) {
        for (var i = 0; i < this.colorInfoWaitList.length; i++) {
            if (this.colorInfoWaitList[i][0] == node) {
                this.colorInfoWaitList[i][0] = null
            }
        }
    },
    setColorTick: function(delta, count) {
        this.timeCount--;
        if (this.timeCount <= 0) {
            for (var i = 0; i < this.colorInfoWaitList.length; i++) {
                var node = this.colorInfoWaitList[i][0];
                if (node == null) {
                    continue
                }
                var tempNode = node;
                if (tempNode.getVirtualRenderer != null) {
                    tempNode = tempNode.getVirtualRenderer()
                }
                if (tempNode.getSprite != null) {
                    tempNode = tempNode.getSprite()
                }
                if (tempNode == null) {
                    continue
                }
                tempNode.setShaderProgram(this.colorShaderList[this.colorInfoWaitList[i][1]])
            }
            this.colorInfoWaitList = [];
            ____654.____678.____299(this.setColorTick, this)
        }
    },
    getColorFSH: function(list) {
        var str = "varying vec4 v_fragmentColor; \n" + "varying vec2 v_texCoord; \n" + "void main() \n" + "{ \n" + "	vec4 texColor = texture2D(CC_Texture0, v_texCoord); \n" + "	float r = texColor.r * " + list[0] + " + texColor.g * " + list[1] + " + texColor.b * " + list[2] + "; \n" + "	float g = texColor.r * " + list[3] + " + texColor.g * " + list[4] + " + texColor.b * " + list[5] + "; \n" + "	float b = texColor.r * " + list[6] + " + texColor.g * " + list[7] + " + texColor.b * " + list[8] + "; \n" + "	gl_FragColor = vec4(r, g, b, texColor.a); \n" + "} \n";
        return str
    },
    getColorVSH: function() {
        var str = "attribute vec4 a_position; \n" + "attribute vec2 a_texCoord; \n" + "attribute vec4 a_color; \n" + "varying vec4 v_fragmentColor; \n" + "varying vec2 v_texCoord; \n" + "void main() \n" + "{ \n" + "	gl_Position = CC_PMatrix * a_position; \n" + "	v_fragmentColor = a_color; \n" + "	v_texCoord = a_texCoord; \n" + "} \n";
        return str
    },
});
var ____594 = cc.Class.extend({
    ____1083: null,
    ____922: null,
    ____1161: 0,
    ____1503: 0,
    ____1057: 0,
    _currentTemp: null,
    ____1804: null,
    ____1326: 0,
    start: function(data, callback) {
        this.____1083 = new ByteArray();
        this.____1083.____284(data);
        this.____1083 = ____654.____674.____182(this.____1083);
        this.____922 = callback;
        this.____1083.readInt();
        this.____1161 = this.____1083.readUByte();
        this.____1804 = new ____514();
        this.____1804.parseComplete = true;
        this.____1326 = 5;
        ____654.____678.____298(this.tryTick, this)
    },
    tryTick: function(delta, tickCount) {
        this.tick(delta, tickCount)
    },
    tick: function(delta, tickCount) {
        if (this.____1503 >= this.____1161) return;
        var tmpBytes = this.____1083.getPosition();
        for (var i = 0; i < 10000000000; i++) {
            if (this._currentTemp == null) {
                this.____1083.setPosition(this.____1326);
                var type = this.____1083.readUByte();
                var fileLen = this.____1083.readUInt();
                this.____1326 = this.____1083.getPosition() + fileLen;
                switch (type) {
                    case 1:
                        this._currentTemp = this.____1804;
                        if (____655.wordFiltersInfo == null) {
                            ____655.wordFiltersInfo = new ____1920();
                            ____655.wordFiltersInfo.initData(this.____1083)
                        }
                        break;
                    case 2:
                        this._currentTemp = ____655.allTemplates.npcTemplateList;
                        break;
                    case 3:
                        this._currentTemp = ____655.allTemplates.monsterTemplateList;
                        break;
                    case 4:
                        this._currentTemp = ____655.allTemplates.advanceTemplateList;
                        break;
                    case 5:
                        this._currentTemp = this.____1804;
                        if (____655.randomNameInfo == null) {
                            ____655.randomNameInfo = new RandomNameInfo();
                            ____655.randomNameInfo.initData(this.____1083)
                        }
                        break;
                    case 6:
                    case 7:
                        this._currentTemp = ____655.allTemplates.____794;
                        break;
                    case 8:
                        this._currentTemp = ____655.allTemplates.payTemplateList;
                        break;
                    case 9:
                        this._currentTemp = ____655.allTemplates.mapTemplateList;
                        break;
                    case 10:
                        this._currentTemp = ____655.allTemplates.gateTemplateList;
                        break;
                    case 11:
                        this._currentTemp = ____655.allTemplates.____790;
                        break;
                    case 13:
                        this._currentTemp = ____655.allTemplates.collectTemplateList;
                        break;
                    case 14:
                        this._currentTemp = ____655.allTemplates.skillTemplateList;
                        break;
                    case 15:
                        this._currentTemp = ____655.allTemplates.copyTemplateList;
                        break;
                    case 16:
                        this._currentTemp = ____655.allTemplates.____789;
                        break;
                    case 17:
                        this._currentTemp = ____655.allTemplates.shopTemplateList;
                        break;
                    case 18:
                        this._currentTemp = ____655.allTemplates.titleTemplateList;
                        break;
                    case 19:
                        this._currentTemp = ____655.allTemplates.taskTemplateList;
                        break;
                    case 20:
                        this._currentTemp = ____655.allTemplates.fashionTemplateList;
                        break;
                    case 22:
                        this._currentTemp = ____655.allTemplates.advanceTemplateList;
                        break;
                    case 24:
                        this._currentTemp = ____655.allTemplates.shopTemplateList;
                        break;
                    case 26:
                        this._currentTemp = ____655.allTemplates.rongluTemplateList;
                        break;
                    case 27:
                        this._currentTemp = ____655.allTemplates.wuhunTemplateList;
                        break;
                    case 28:
                        this._currentTemp = ____655.allTemplates.strengthPropertyTemplateList;
                        break;
                    case 29:
                        this._currentTemp = ____655.allTemplates.strengthCostTemplateList;
                        break;
                    case 31:
                        this._currentTemp = ____655.allTemplates.dailyActivityTemplateList;
                        break;
                    case 32:
                        this._currentTemp = ____655.allTemplates.timingActivityTemplateList;
                        break;
                    case 33:
                        this._currentTemp = ____655.allTemplates.vipTemplateList;
                        break;
                    case 34:
                        this._currentTemp = ____655.allTemplates.bossTemplateList;
                        break;
                    case 35:
                        this._currentTemp = ____655.allTemplates.lilianTemplateList;
                        break;
                    case 36:
                        this._currentTemp = ____655.allTemplates.clubTreeAwardTemplateList;
                        break;
                    case 37:
                        this._currentTemp = ____655.allTemplates.baoShiTemplateList;
                        break;
                    case 38:
                        this._currentTemp = ____655.allTemplates.baoShiEquipTemplateList;
                        break;
                    case 39:
                        this._currentTemp = ____655.allTemplates.rankAwardTemplateList;
                        break;
                    case 40:
                        this._currentTemp = ____655.allTemplates.awardTemplateList;
                        break;
                    case 41:
                        this._currentTemp = ____655.allTemplates.expTemplateList;
                        break;
                    case 42:
                        this._currentTemp = ____655.allTemplates.weekSignTemplateList;
                        break;
                    case 43:
                        this._currentTemp = ____655.allTemplates.resRecoverTemplateList;
                        break;
                    case 44:
                        this._currentTemp = ____655.allTemplates.fashionTemplateList;
                        break;
                    case 45:
                        this._currentTemp = ____655.allTemplates.douShenTemplateList;
                        break;
                    case 46:
                        this._currentTemp = ____655.allTemplates.payTemplateList;
                        break;
                    case 47:
                        this._currentTemp = ____655.allTemplates.openActivityTemplateList;
                        break;
                    case 48:
                        this._currentTemp = ____655.allTemplates.awardTemplateList;
                        break;
                    case 49:
                        this._currentTemp = ____655.allTemplates.feiXianTemplateList;
                        break;
                    case 50:
                        this._currentTemp = ____655.allTemplates.figureTemplateList;
                        break;
                    case 51:
                        this._currentTemp = ____655.allTemplates.tuJianTemplateList;
                        break;
                    case 52:
                        this._currentTemp = ____655.allTemplates.xianWeiTemplateList;
                        break;
                    case 53:
                        this._currentTemp = ____655.allTemplates.newlyGuideTemplateList;
                        break;
                    case 54:
                        this._currentTemp = ____655.allTemplates.hunPoTemplateList;
                        break;
                    case 55:
                        this._currentTemp = ____655.allTemplates.luckyTreasureTemplateList;
                        break;
                    case 56:
                        this._currentTemp = ____655.allTemplates.homeTemplateList;
                        break;
                    case 57:
                        this._currentTemp = ____655.allTemplates.marryOathTemplateList;
                        break;
                    case 58:
                        this._currentTemp = ____655.allTemplates.seedTemplateList;
                        break;
                    case 59:
                        this._currentTemp = ____655.allTemplates.dailyFirstRechargeTemplateList;
                        break;
                    case 60:
                        this._currentTemp = ____655.allTemplates.familyTreasuresBaseTemplateList;
                        break;
                    case 61:
                        this._currentTemp = ____655.allTemplates.familyTreasuresBoxTemplateList;
                        break;
                    case 62:
                        this._currentTemp = ____655.allTemplates.homePetTemplateList;
                        break;
                    case 63:
                        this._currentTemp = ____655.allTemplates.homeJinjieTemplateList;
                        break;
                    default:
                        this._currentTemp = this.____1804;
                        break
                }
                if (!!this._currentTemp && this._currentTemp != this.____1804) {
                    this._currentTemp.init(this.____1083)
                }
            } else {
                if (this._currentTemp.parseComplete) {
                    this._currentTemp = null;
                    this.____1503++;
                    if (this.____1503 >= this.____1161) {
                        this.____307();
                        break
                    }
                } else {
                    this._currentTemp.parse();
                    if (this.____1083.getPosition() - tmpBytes > 60000) {
                        break
                    }
                }
            }
        }
    },
    ____307: function() {
        ____654.____678.____299(this.tryTick, this);
        this.____1083 = null;
        this._currentTemp = null;
        this.____1804 = null;
        if (this.____922 != null) {
            this.____922()
        }
        this.____922 = null;
        ____655.templateComplete()
    }
});
var Alert = KYPanel.extend({
    ____869: null,
    ____870: null,
    _titleLabel: null,
    ____886: null,
    ____887: null,
    ____893: null,
    ____894: null,
    ____963: null,
    _closeBtn: null,
    ____1592: null,
    _executor: null,
    ____923: null,
    ____924: null,
    ____1676: null,
    _text1: "",
    _text2: "",
    _countType: 0,
    ____1485: 0,
    _count: 0,
    _type: 1,
    ctor: function() {
        this._super("alertPanel.ExportJson");
        this.modeValue = 100;
        this.____869 = this.getChildByName("bg1__3");
        this.____870 = this.getChildByName("bg2__3");
        this._titleLabel = this.getChildByName("titleLabel");
        this.____886 = this.getChildByName("btn1__1");
        this.____887 = this.getChildByName("btn2__1");
        this.____893 = this.getChildByName("btnLabel1");
        this.____894 = this.getChildByName("btnLabel2");
        this.____963 = this.getChildByName("checkBox");
        this.____963.setString("今日不再提示");
        this._closeBtn = this.getChildByName("closeBtn");
        this._closeBtn.setVisible(false);
        this.____6()
    },
    show: function(type, content, showType, count, executor, callback1, callback2, title) {
        this.____1676 = showType;
        if (showType != null) {
            this.setType(1);
            this.____963.setSelected(false);
            if (____654.noAlertUtils.getIsShow(showType) == false) {
                if (executor != null && callback1 != null) {
                    callback1.call(executor)
                }
                this.dispose();
                return
            }
        } else {
            this.setType(0)
        }
        if (title != null) {
            this._titleLabel.setString(title)
        }
        this._executor = executor;
        this.____923 = callback1;
        this.____924 = callback2;
        this.____1592 = ____654.____673.newRichLabel(400);
        this.____1592.setString(content);
        this.____1592.setPosition(____654.____673.____159(26 + (400 - this.____1592.getTextWidth()) * 0.5, 248));
        this.addChild(this.____1592, 9);
        if (type == 1) {
            this._text1 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips3");
            this.____893.setString(this._text1);
            this.____886.setPositionX(226);
            this.____893.setPositionX(226);
            this.____887.setVisible(false);
            this._closeBtn.setVisible(false)
        } else if (type == 2) {
            this._text1 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips3");
            this.____893.setString(this._text1);
            this._text2 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips4");
            this.____894.setString(this._text2);
            this._closeBtn.setVisible(false)
        } else if (type == 3) {
            this._text1 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips1");
            this.____893.setString(this._text1);
            this._text2 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips2");
            this.____894.setString(this._text2);
            this._closeBtn.setVisible(false)
        } else if (type == 4) {
            this._text1 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips9");
            this.____893.setString(this._text1);
            this._text2 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips8");
            this.____894.setString(this._text2);
            this._closeBtn.setVisible(true)
        } else if (type == 5) {
            this._text1 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips12");
            this.____893.setString(this._text1);
            this._text2 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips11");
            this.____894.setString(this._text2);
            this._closeBtn.setVisible(true)
        } else if (type == 6) {
            this._text1 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips13");
            this.____893.setString(this._text1);
            this._text2 = ____654.yuyanbaoManager.getYuyanbao("alert.btnTips14");
            this.____894.setString(this._text2);
            this._closeBtn.setVisible(false)
        }
        if (count != null) {
            if (count > 0) {
                this._countType = 1;
                this.____1485 = count;
                this.____893.setString(this._text1 + " " + this.____1485);
                this._count = 0;
                ____654.____678.____298(this.tick, this)
            } else if (count < 0) {
                this._countType = 2;
                this.____1485 = -count;
                this.____894.setString(this._text2 + " " + this.____1485);
                this._count = 0;
                ____654.____678.____298(this.tick, this)
            } else {
                this._countType = 0
            }
        }
        ____654.____676.____125(this)
    },
    tick: function(delta, tickCount) {
        if (this._countType == 0) {
            ____654.____678.____299(this.tick, this);
            return
        }
        this._count++;
        if (this._count < 60) return;
        this._count = 0;
        this.____1485--;
        if (this.____1485 > 0) {
            if (this._countType == 1) {
                this.____893.setString(this._text1 + " " + this.____1485.toString())
            } else if (this._countType == 2) {
                this.____894.setString(this._text2 + " " + this.____1485.toString())
            }
        } else {
            if (this._countType == 1) {
                this.____16(this.____886, ccui.Widget.TOUCH_ENDED)
            } else if (this._countType == 2) {
                this.____16(this.____887, ccui.Widget.TOUCH_ENDED)
            }
        }
    },
    ____6: function() {
        this.____886.addListener(this, this.____16);
        this.____887.addListener(this, this.____16);
        this._closeBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____886) {
                if (this.____1676 != null) {
                    if (this.____963.getSelected()) {
                        ____654.noAlertUtils.setNotShow(this.____1676)
                    }
                }
                if (this.____923 != null) {
                    if (this._executor != null) {
                        this.____923.call(this._executor)
                    } else {
                        this.____923()
                    }
                }
                this.dispose()
            } else if (sender == this.____887) {
                if (this.____924 != null) {
                    if (this._executor != null) {
                        this.____924.call(this._executor)
                    } else {
                        this.____924()
                    }
                }
                this.dispose()
            } else if (sender == this._closeBtn) {
                this.dispose()
            }
        }
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    setType: function(type) {
        if (this._type == type) return;
        this._type = type;
        if (type == 0) {
            this.____869.setContentSize(____654.____673.____160(452, 312));
            this.____869.setPosition(226, 185);
            this.____963.setVisible(false);
            this.____886.setPositionY(80);
            this.____893.setPositionY(80);
            this.____887.setPositionY(80);
            this.____894.setPositionY(80)
        } else if (type == 1) {}
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        if (this.____1592 != null) {
            this.____1592.dispose();
            this.____1592 = null
        }
        this.____1763 = null;
        this.____869 = null;
        this.____870 = null;
        this._titleLabel = null;
        this.____886 = null;
        this.____887 = null;
        this.____893 = null;
        this.____894 = null;
        this.____963 = null;
        this._closeBtn = null;
        this._executor = null;
        this.____923 = null;
        this.____924 = null;
        this._super();
        ____655.isYaoqing = false
    },
});
var ____2125 = KYNode.extend({
    _itemInfo: null,
    _grid: null,
    ____936: null,
    _nameLabel: null,
    _numLabel: null,
    ctor: function(itemInfo) {
        this._super("welfareZhuanShuGiftTipItemView.ExportJson");
        this._itemInfo = itemInfo;
        this.____936 = this.getChildByName("cell");
        this._nameLabel = this.getChildByName("nameLabel");
        this._numLabel = this.getChildByName("numLabel");
        this._grid = new ____2129();
        this._grid.setMouseEnabled(false);
        this._grid.setIsShowCount(false);
        this.____936.addChild(this._grid);
        this.____5()
    },
    ____5: function() {
        var itemId = 0;
        var itemCount = 0;
        if (this._itemInfo[0] == null) {
            itemId = this._itemInfo.templateId;
            itemCount = this._itemInfo.count
        } else {
            itemId = this._itemInfo[0];
            itemCount = this._itemInfo[1]
        }
        var itemTempInfo = ____655.allTemplates.____794.getItem(itemId);
        this._nameLabel.setString(itemTempInfo.name);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTempInfo.quality));
        this._grid.setItemTemplateInfo(itemTempInfo);
        this._numLabel.setString("x " + ____654.____674.getWanCount(itemCount))
    },
    dispose: function() {
        this._super();
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._itemInfo = null;
        this.____936 = null;
        this._nameLabel = null;
        this._numLabel = null
    },
});
var ____2126 = KYPanel.extend({
    _titleLabel: null,
    _closeBtn: null,
    _listView: null,
    ____1185: null,
    ____1186: null,
    _itemList: null,
    _tipsLabel: null,
    _callBack: null,
    _executor: null,
    ____877: null,
    ctor: function(title, list, tips, canAccept, callBack, executor) {
        this._super("clubGodTreeResultView.ExportJson");
        this._titleLabel = this.getChildByName("delLabel");
        this._titleLabel.setString(title);
        this._closeBtn = this.getChildByName("closeBtn");
        this._listView = this.getChildByName("listView");
        this.____1185 = this.getChildByName("getBtn");
        this.____1186 = this.getChildByName("titleLabel");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____877 = this.getChildByName("borad");
        if (tips == null) {
            if (canAccept == 2) {
                this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text7"));
                ____654.____674.setKYBtnEnabled(this.____1185, true, 2)
            } else if (canAccept == true) {
                this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text8"));
                ____654.____674.setKYBtnEnabled(this.____1185, true, 2)
            } else {
                this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip3"));
                ____654.____674.setKYBtnEnabled(this.____1185, false, 2)
            }
        } else {
            this._tipsLabel.setString(tips);
            this.____1185.setVisible(false)
        }
        this._callBack = callBack;
        this._executor = executor;
        this.____5(list);
        this.____6()
    },
    ____5: function(list) {
        this._itemList = [];
        for (var i = 0; i < list.length; i++) {
            var item = new ____2125(list[i]);
            this._listView.pushBackCustomItem(item);
            this._itemList.push(item)
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1185.addListener(this, this.____16);
        this.____877.addListener(this, this.____16)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1185) {
                if (this._callBack != null && this._executor != null) {
                    this._callBack.call(this._executor)
                }
                this.dispose()
            } else if (sender == this._closeBtn) {
                this.dispose()
            }
        }
    },
    hideFormContainer: function() {
        this.dispose()
    },
    dispose: function() {
        this.____17();
        this._titleLabel = null;
        this._closeBtn = null;
        this._listView = null;
        this.____1185 = null;
        this.____1186 = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this._itemList = null;
        this._tipsLabel = null;
        this._callBack = null;
        this._executor = null;
        this.____877 = null;
        this._super()
    },
});
var AwardZhanChangItem = KYNode.extend({
    _itemInfo: null,
    _itemList: null,
    _gridList: null,
    _rankIcon: null,
    ____1579: null,
    ____1241: null,
    ctor: function(index, itemInfo) {
        this._super("zhanChangAwardItem.ExportJson");
        this._itemInfo = itemInfo;
        this._itemList = [];
        this._gridList = [];
        this.____1241 = index;
        for (var i = 0; i < 5; i++) {
            this._itemList.push(this.getChildByName("cellLayer" + (i + 1)))
        }
        for (var i = 0; i < itemInfo.awardList.length; i++) {
            var grid = new ____2129();
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(itemInfo.awardList[i][0]);
            grid.setItemTemplateInfo(itemTemplateInfo);
            grid.setCount(itemInfo.awardList[i][1]);
            this._itemList[i].addChild(grid);
            this._gridList.push(grid)
        }
        this._rankIcon = this.getChildByName("rankIcon");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1579.setString("");
        this.____5()
    },
    ____5: function() {
        if (parseInt(this._itemInfo.minLevel) == parseInt(this._itemInfo.maxLevel)) {
            if (this._itemInfo.minLevel == 1) {
                this._rankIcon.setFrame("flag/zhangChangRankIcon1.png")
            } else if (this._itemInfo.minLevel == 2) {
                this._rankIcon.setFrame("flag/zhangChangRankIcon2.png")
            } else if (this._itemInfo.minLevel == 3) {
                this._rankIcon.setFrame("flag/zhangChangRankIcon3.png")
            }
        } else {
            if (this.____1241 == 3) {
                this._rankIcon.setFrame("flag/zhangChangRankIcon4.png")
            } else if (this.____1241 == 4) {
                this._rankIcon.setFrame("flag/zhangChangRankIcon5.png")
            } else if (this.____1241 >= 5) {
                this._rankIcon.setFrame("flag/zhangChangRankIcon6.png")
            }
            this.____1579.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text4", this._itemInfo.minLevel, this._itemInfo.maxLevel))
        }
    },
    dispose: function() {
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        this._itemInfo = null;
        this._itemList = null;
        this._rankIcon = null;
        this.____1579 = null;
        this.____1241 = null;
        this._super()
    },
});
var AwardZhanChangPanel = KYPanel.extend({
    _titleLabel: null,
    _closeBtn: null,
    ____1479: null,
    ____892: null,
    _listView: null,
    _itemList: null,
    _callBack: null,
    _executor: null,
    _controller: null,
    _type: null,
    _tipsLabel: null,
    ctor: function(controller, type, title, list, callBack, executor) {
        this._super("zhanChangAwardView.ExportJson");
        this._controller = controller;
        this._titleLabel = this.getChildByName("tittleLabel");
        this._titleLabel.setString(title);
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1479 = this.getChildByName("okBtn"), this.____892 = this.getChildByName("btnLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text5"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._listView = this.getChildByName("listView");
        this._type = type;
        if (this._type == 12 || this._type == 21) {
            this.____1479.setVisible(false);
            this.____892.setVisible(false);
            this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text9"))
        }
        this._callBack = callBack;
        this._executor = executor;
        this.____5(list);
        this.infoUpdateHandler();
        this.____6()
    },
    ____5: function(list) {
        this._itemList = [];
        for (var i = 0; i < list.length; i++) {
            var item = new AwardZhanChangItem(i, list[i]);
            this._listView.pushBackCustomItem(item);
            this._itemList.push(item)
        }
    },
    infoUpdateHandler: function() {
        print("____655.rankInfo.doushenAwardState", ____655.rankInfo.doushenAwardState);
        if (this._type == 10) {
            var state = ____655.rankInfo.doushenAwardState;
            if (state == 0) {
                ____654.____674.setKYBtnEnabled(this.____1479, false, 0)
            } else if (state == 1) {
                ____654.____674.setKYBtnEnabled(this.____1479, true, 2)
            }
        }
    },
    ____6: function() {
        ____655.rankInfo.addEventListener(____655.____661.common_rankDoushenInfoUpdate, this.infoUpdateHandler, this);
        this._closeBtn.addListener(this, this.____16);
        this.____1479.addListener(this, this.____16)
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankDoushenInfoUpdate, this.infoUpdateHandler, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1479) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                this._callBack.call(this._executor)
            } else if (sender == this._closeBtn) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                this._controller.hideAwardZhanChangPanel()
            }
        }
    },
    hideFormContainer: function() {
        this._controller.hideAwardZhanChangPanel()
    },
    dispose: function() {
        this.____17();
        this._titleLabel = null;
        this._closeBtn = null;
        this._listView = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this._itemList = null;
        this._callBack = null;
        this._executor = null;
        this.____1479 = null;
        this.____892 = null;
        this._controller = null;
        this._tipsLabel = null;
        this._super()
    },
});
var ____2120 = KYNode.extend({
    ____890: null,
    _equipCell: null,
    _nameLabel: null,
    ____1779: null,
    ____1283: null,
    ____928: -1,
    ____1764: "",
    ____1139: null,
    ctor: function(categoryType) {
        this._super("weaponEquipBtn.ExportJson");
        this.____890 = this.getChildByName("btnImg");
        this._equipCell = this.getChildByName("equipCell");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1779 = this.getChildByName("tipIcon");
        this.____1779.setVisible(false);
        this.____1283 = new ____2129();
        this.____1283.setAllTouchEnabledFlase();
        this.____1283.setMouseEnabled(false);
        this.____1283.setIsShowCount(false);
        this._equipCell.addChild(this.____1283, 1);
        this.____928 = categoryType;
        this.____1764 = ____655.____659.categoryType.getNameByCategoryType(this.____928);
        var itemInfo = ____655.itemInfoList.getBodyEquipByType(this.____928);
        this.setItemInfo(itemInfo)
    },
    setItemInfo: function(itemInfo) {
        if (this.____1139 != null) {
            this.____1139.removeEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this)
        }
        this.____1139 = itemInfo;
        if (this.____1139 != null) {
            this.____1139.addEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this)
        }
        this.____1283.setItemInfo(this.____1139);
        this.itemInfoUpdate()
    },
    getItemInfo: function(tipFlag) {
        if (tipFlag && this.____1139 == null) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("equipTabButton.tipText", this.____1764))
        }
        return this.____1139
    },
    itemInfoUpdate: function(evt) {
        var strengtStr = " +{0}";
        if (this.____1139 != null && this.____1139.qhLevel > 0) {
            strengtStr = strengtStr.format(this.____1139.qhLevel)
        } else {
            strengtStr = ""
        }
        this._nameLabel.setString(this.____1764 + strengtStr)
    },
    setTipIocnVisible: function(flag) {
        this.____1779.setVisible(flag)
    },
    ____239: function(flag) {
        if (flag) {
            this.____890.setFrame("board/ui_board8.png", 1)
        } else {
            this.____890.setFrame("board/ui_board7.png", 1)
        }
    },
    dispose: function() {
        if (this.____1139 != null) {
            this.____1139.removeEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this);
            this.____1139 = null
        }
        this._super();
        this.____890 = null;
        this._equipCell = null;
        this._nameLabel = null;
        this.____1779 = null;
        this.____1283.dispose();
        this.____1283 = null;
        this.____928 = null;
        this.____1764 = null
    },
});
var GetItemEffect = cc.Class.extend({
    id: 0,
    type: 0,
    ____1239: null,
    _path: "",
    _currentTick: 0,
    _addTick: 0,
    ____1180: 0,
    ____1181: 0,
    ctor: function(data) {
        this.id = data[0];
        this.type = data[1];
        this._path = ____654.____675.getIconPath(____655.allTemplates.____794.getItem(this.id).iconPath, ____655.____659.iconPathType.item);
        this.____1239 = ____654.____673.newKYSprite();
        ____654.____677.____146(this.____1239, this._path);
        this.____1239.setScale(0.6);
        if (this.type == 53 || this.type == 56) {
            this._addTick = 180
        } else {
            ____654.____676.____802.addChild(this.____1239)
        }
        ____654.____678.____298(this.tick, this);
        this.____1074 = ____655.____656 * 0.5 + Math.random() * 100 - 50;
        this.____1075 = ____655.____657 * 0.5 + Math.random() * 140 - 70;
        this.____1239.setPosition(-100, -100);
        this.____1180 = Math.random() * 20 + 10;
        this.____1181 = ____655.____657 / 30 + Math.random() * 3 - 1.5
    },
    tick: function(delta, count) {
        if (this._addTick > 0) {
            this._addTick--;
            if (this._addTick <= 0) {
                ____654.____676.____802.addChild(this.____1239)
            }
            return
        }
        this._currentTick++;
        if (this._currentTick >= 100 || this.____1075 <= 50 || this.____1074 <= 50) {
            this.dispose();
            return
        }
        var dt = 0.15;
        this.____1180 -= dt * 24;
        this.____1074 += this.____1180 * dt;
        this.____1181 -= dt * 15;
        this.____1075 += this.____1181 * dt;
        this.____1239.setPosition(this.____1074, ____655.____657 - this.____1075)
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        if (this._path != "") {
            ____654.____677.removeImageQuote(this._path, this.____1239);
            this._path = null
        }
        if (this.____1239 != null) {
            this.____1239.dispose();
            this.____1239 = null
        }
    },
});
var AdvanceEquipGrid = ____2128.extend({
    _panelType: 0,
    _place: 0,
    _equipInfo: null,
    _tipsLabel: null,
    ____1533: null,
    _addIcon: null,
    _isMyEquip: false,
    _canUseEquip: null,
    _nextUseEquip: null,
    _tickCount: 0,
    _isNew: true,
    _countBg: null,
    _stageLabel: null,
    _starLabel: null,
    _equipFlag: null,
    ctor: function(isGround, offsetX, offsetY) {
        if (offsetX == null) {
            offsetX = 41
        }
        if (offsetY == null) {
            offsetY = 41
        }
        this._super(isGround, offsetX, offsetY);
        this._isNew = true;
        this._tipsLabel = ____654.____673.newKYLabel(18);
        this._tipsLabel.setPosition(____654.____673.____159(40, 15));
        this._tipsLabel.setVisible(false);
        this.addChild(this._tipsLabel, 3)
    },
    ____6: function() {
        this._super();
        ____654.____672.addEventListener(____655.____661.common_testerItemUpdate, this.updateView, this);
        ____654.____672.addEventListener(____655.____661.guide_openRiderEquip, this.guideHandler, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_testerItemUpdate, this.updateView, this);
        ____654.____672.removeEventListener(____655.____661.guide_openRiderEquip, this.guideHandler, this)
    },
    guideHandler: function() {
        if (this._panelType == ____655.____659.commonStaticType.style_Horse && this._place == 1 && this._isMyEquip) {
            if (this._canUseEquip != null) {
                ____654.tipsManager.showAdvanceEquipTip(this._canUseEquip, 2)
            }
        }
    },
    setShowPop: function(value) {
        if (value) {
            if (this.____1533 == null) {
                this.____1533 = ____654.____673.newKYSprite();
                this.____1533.setFrame("icon/ui_numTipIcon.png");
                this.____1533.setPosition(____654.____673.____159(76, 76));
                this.addChild(this.____1533, 4)
            }
        } else {
            if (this.____1533 != null) {
                this.____1533.dispose();
                this.____1533 = null
            }
        }
    },
    setShowAddIcon: function(value) {
        if (value) {
            if (this._addIcon == null) {
                this._addIcon = ____654.____673.newKYSprite();
                this._addIcon.setFrame("icon/ui_plusIcon2.png");
                this._addIcon.setPosition(____654.____673.____159(60, 60));
                this.addChild(this._addIcon, 5)
            }
        } else {
            if (this._addIcon != null) {
                this._addIcon.dispose();
                this._addIcon = null
            }
        }
    },
    initSize: function() {
        this.____1677 = ____654.____673.____160(72, 72);
        this._scale = 1.2
    },
    setEquipInfo: function(equipInfo, paneType, place, isMyEquip) {
        this._equipInfo = equipInfo;
        if (this._equipInfo != null) {
            this.setBaseItemInfo(this._equipInfo.template);
            this.setStageFlag(this._equipInfo.star)
        } else {
            this.____1512.setFrame("icon/ui_defaultEquipIcon.png")
        }
        if (this._panelType != null && this._panelType != paneType) {
            this._panelType = paneType
        }
        if (this._place != null) {
            this._place = place
        }
        if (isMyEquip != null) {
            this._isMyEquip = isMyEquip
        }
        if (this._isNew) {
            this.updateView();
            this.____6();
            this._isNew = false
        }
    },
    updateView: function() {
        if (this._isMyEquip) {
            var categoryId = ____655.____659.categoryType.getAdvanceEquipCategoryId(this._panelType, this._place);
            var equipList = ____654.playerInfoTester.advanceEquipList[categoryId];
            var canUseEquip = null;
            var nextUseEquip = null;
            if (equipList != null) {
                var myStarCount = ____655.advanceItemList.getItemByType(this._panelType).starCount;
                for (var i = 0; i < equipList.length; i++) {
                    if (this._equipInfo != null && this._equipInfo.getWaiXingFight() >= equipList[i].getWaiXingFight()) {} else if (myStarCount >= equipList[i].quality) {
                        if (canUseEquip == null || canUseEquip.getWaiXingFight() < equipList[i].getWaiXingFight()) {
                            canUseEquip = equipList[i]
                        }
                    } else {
                        if (nextUseEquip == null || nextUseEquip.getWaiXingFight() > equipList[i].getWaiXingFight()) {
                            nextUseEquip = equipList[i]
                        }
                    }
                }
            }
            this._canUseEquip = canUseEquip;
            this._nextUseEquip = nextUseEquip;
            if (this._canUseEquip != null) {
                this._tipsLabel.setVisible(true);
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("AdvanceEquipGrid.text1"));
                this._tipsLabel.setColor(____655.____659.____688.lightGreen);
                this.setShowPop(true);
                if (this._countBg == null) {
                    this._countBg = ____654.____673.newKYSprite();
                    this._countBg.setFrame("countBg.png");
                    this._countBg.setAnchorPoint(____654.____673.anchorPoints[5]);
                    this._countBg.setPosition(____654.____673.____159(this.____1477 + 36, this.____1478 - 25));
                    this.addChild(this._countBg, 2)
                }
            } else if (this._nextUseEquip != null) {
                this._tipsLabel.setVisible(true);
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("AdvanceEquipGrid.text2"));
                this._tipsLabel.setColor(____655.____659.____688.system);
                this.setShowPop(false);
                if (this._countBg == null) {
                    this._countBg = ____654.____673.newKYSprite();
                    this._countBg.setFrame("countBg.png");
                    this._countBg.setAnchorPoint(____654.____673.anchorPoints[5]);
                    this._countBg.setPosition(____654.____673.____159(this.____1477 + 36, this.____1478 - 25));
                    this.addChild(this._countBg, 2)
                }
            } else {
                this._tipsLabel.setVisible(false);
                if (this._countBg != null) {
                    this._countBg.dispose();
                    this._countBg = null
                }
                this.setShowPop(false);
                if (this._equipInfo == null) {
                    this.setShowAddIcon(true)
                } else {
                    this.setShowAddIcon(false)
                }
            }
        }
    },
    setStageFlag: function(starCount) {
        if (this._equipFlag == null) {
            this._equipFlag = ____654.____673.newKYSprite();
            this._equipFlag.setFrame("flag/ui_advanceEquipFlag.png");
            this._equipFlag.setPosition(____654.____673.____159(62, 56));
            this.addChild(this._equipFlag, 4)
        }
        if (this._stageLabel == null) {
            this._stageLabel = new NumberView();
            this._stageLabel.setType(7, null, 0.9);
            this._stageLabel.setAnchorPoint(____654.____673.anchorPoints[5]);
            this._stageLabel.setRotation(45);
            this._stageLabel.setPosition(____654.____673.____159(24, 42));
            this._equipFlag.addChild(this._stageLabel, 4)
        }
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(starCount);
        var value = ____655.____659.nameType.getChineseNumber(stage);
        this._stageLabel.setString(value);
        if (this._starLabel == null) {
            this._starLabel = new NumberView();
            this._starLabel.setType(1, null, 0.5);
            this._starLabel.setRotation(45);
            this._starLabel.setPosition(____654.____673.____159(40, 25));
            this._equipFlag.addChild(this._starLabel)
        }
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(starCount);
        this._starLabel.setString(star)
    },
    clearStageFlag: function() {
        if (this._starLabel != null) {
            this._starLabel.dispose();
            this._starLabel = null
        }
        if (this._stageLabel != null) {
            this._stageLabel.dispose();
            this._stageLabel = null
        }
        if (this._equipFlag != null) {
            this._equipFlag.dispose();
            this._equipFlag = null
        }
    },
    getBgPath: function() {
        return "cell/ui_cell1.png"
    },
    getPath: function() {
        if (this.____867 == null) {
            return null
        }
        if (this._equipInfo.quality > 0) {
            return ____654.____675.getIconPath(this.____867.iconPath + this._equipInfo.quality.toString(), ____655.____659.iconPathType.item)
        } else {
            return ____654.____675.getIconPath(this.____867.iconPath, ____655.____659.iconPathType.item)
        }
    },
    clickHandler: function(sender, eventType, pos) {
        if (this._isMyEquip) {
            if (this._canUseEquip != null) {
                ____654.tipsManager.showAdvanceEquipTip(this._canUseEquip, 2)
            } else if (this._nextUseEquip != null) {
                ____654.tipsManager.showAdvanceEquipTip(this._nextUseEquip, 2)
            } else {
                if (this._equipInfo == null) {
                    if (____655.____667.level >= ____655.____659.levelType.waiguanCopyLevel) {
                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy, 2)
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2340.text1", ____655.____659.levelType.waiguanCopyLevel))
                    }
                }
            }
        }
    },
    downHandler: function(sender, eventType, pos) {
        if (this._canUseEquip != null || this._nextUseEquip != null || this._equipInfo == null) {
            return
        }
        this._super(sender, eventType, pos)
    },
    upHandler: function(sender, eventType, pos) {
        if (this._canUseEquip != null || this._nextUseEquip != null || this._equipInfo == null) {
            return
        }
        this._super(sender, eventType, pos)
    },
    ____358: function(sender, eventType, pos) {
        if (this._canUseEquip != null || this._nextUseEquip != null || this._equipInfo == null) {
            return
        }
        this._super(sender, eventType, pos)
    },
    showTip: function() {
        if (this._equipInfo != null) {
            var pos = this.convertToWorldSpace(____654.____673.____159(this.____1477, this.____1478));
            ____654.tipsManager.showFlashAdvanceEquipTip(this._equipInfo, 1, pos)
        }
    },
    hideTip: function() {
        ____654.tipsManager.hideFlashTip()
    },
    dispose: function() {
        this.____17();
        if (this._countBg != null) {
            this._countBg.dispose();
            this._countBg = null
        }
        if (this._tipsLabel != null) {
            this._tipsLabel.dispose();
            this._tipsLabel = null
        }
        this.clearStageFlag();
        this.setShowPop(false);
        this.setShowAddIcon(false);
        this._panelType = null;
        this._place = null;
        this._equipInfo = null;
        this._isMyEquip = null;
        this._canUseEquip = null;
        this._nextUseEquip = null;
        ____654.tipsManager.hideFlashTip();
        this._super()
    },
});
var ____2129 = ____2128.extend({
    _itemInfo: null,
    _countBg: null,
    _countLabel: null,
    ____1570: null,
    ____1569: null,
    ____1280: true,
    ____1281: false,
    ____1140: 0,
    _equipFlag: null,
    _stageLabel: null,
    _starLabel: null,
    ctor: function(isGround, offsetX, offsetY, isSwallow, isListener) {
        if (offsetX == null) {
            offsetX = 41
        }
        if (offsetY == null) {
            offsetY = 41
        }
        this._super(isGround, offsetX, offsetY, isSwallow, isListener)
    },
    initSize: function() {
        this.____1677 = ____654.____673.____160(72, 72);
        this._scale = 1.2
    },
    setItemInfo: function(itemInfo) {
        if (this._itemInfo != null) {
            this._itemInfo.removeEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this)
        }
        this._itemInfo = itemInfo;
        if (this._itemInfo != null) {
            this._itemInfo.addEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this)
        }
        this.updateView()
    },
    updateView: function() {
        if (this._itemInfo == null) {
            this.setItemTemplateInfo(null);
            this.clearStageFlag();
            this.setQHLevel(-1);
            this.setCount(-1)
        } else {
            this.setItemTemplateInfo(this._itemInfo.template);
            if (this.____1280) {
                this.setCount(this._itemInfo.count)
            }
            if (____655.____659.categoryType.isWaiXingEquip(this.____867.categoryId)) {
                this.setQHLevel(-1);
                this.setStageFlag(this._itemInfo.quality)
            } else {
                this.clearStageFlag();
                if (this.____1281) {
                    this.setQHLevel(this._itemInfo.qhLevel)
                }
            }
        }
    },
    setItemTemplateInfo: function(tempInfo) {
        this.setBaseItemInfo(tempInfo)
    },
    setAllTouchEnabledFlase: function() {
        this.____1512.setTouchEnabled(false)
    },
    setCount: function(count) {
        if (count > -1) {
            if (this._countLabel == null) {
                this._countLabel = ____654.____673.newKYLabel();
                this._countLabel.setAnchorPoint(____654.____673.anchorPoints[5]);
                this._countLabel.setPosition(____654.____673.____159(this.____1477 + 34, this.____1478 - 26));
                this.addChild(this._countLabel, 3)
            }
            this._countLabel.setString(____654.____674.getWanCount(count));
            if (this._countBg == null) {
                this._countBg = ____654.____673.newKYSprite();
                this._countBg.setFrame("countBg.png");
                this._countBg.setAnchorPoint(____654.____673.anchorPoints[5]);
                this._countBg.setPosition(____654.____673.____159(this.____1477 + 36, this.____1478 - 26));
                this.addChild(this._countBg, 2)
            }
        } else {
            if (this._countLabel != null) {
                this._countLabel.dispose();
                this._countLabel = null
            }
            if (this._countBg != null) {
                this._countBg.dispose();
                this._countBg = null
            }
        }
    },
    setNeedCount: function(count, needCount) {
        if (this._countLabel == null) {
            this._countLabel = ____654.____673.newKYLabel();
            this._countLabel.setAnchorPoint(____654.____673.anchorPoints[5]);
            this._countLabel.setPosition(____654.____673.____159(this.____1477 + 34, this.____1478 - 25));
            this.addChild(this._countLabel, 3)
        }
        if (count >= needCount) {
            this._countLabel.setColor(____655.____659.____688.white)
        } else {
            this._countLabel.setColor(____655.____659.____688.red)
        }
        this._countLabel.setString(____654.____674.getWanCount(count) + "/" + ____654.____674.getWanCount(needCount));
        if (this._countBg == null) {
            this._countBg = ____654.____673.newKYSprite();
            this._countBg.setFrame("countBg.png");
            this._countBg.setPosition(____654.____673.____159(43, 16));
            this.addChild(this._countBg, 2)
        }
    },
    setQHLevel: function(level) {
        if (level > 0) {
            if (this.____1569 == null) {
                this.____1569 = ____654.____673.newKYSprite();
                this.____1569.setFrame("flag/ui_plusIcon3.png");
                this.____1569.setAnchorPoint(____654.____673.anchorPoints[4]);
                this.____1569.setPosition(____654.____673.____159(this.____1477 - 34, this.____1478 + 25));
                this.addChild(this.____1569, 3)
            }
            if (this.____1570 == null) {
                this.____1570 = new NumberView();
                this.____1570.setType(3);
                this.____1570.setAnchorPoint(____654.____673.anchorPoints[4]);
                this.____1570.setPosition(____654.____673.____159(this.____1477 - 12, this.____1478 + 25));
                this.addChild(this.____1570, 2)
            }
            this.____1570.setString(level)
        } else {
            if (this.____1570 != null) {
                this.____1570.dispose();
                this.____1570 = null
            }
            if (this.____1569 != null) {
                this.____1569.dispose();
                this.____1569 = null
            }
        }
    },
    itemInfoUpdate: function(evt) {
        this.updateView()
    },
    getBgPath: function() {
        return "cell/ui_cell1.png"
    },
    getPath: function() {
        if (this.____867 == null) {
            return null
        }
        if (____655.____659.categoryType.isWaiXingEquip(this.____867.categoryId) && this._itemInfo != null && this._itemInfo.qhLevel > 0) {
            return ____654.____675.getIconPath(this.____867.iconPath + this._itemInfo.qhLevel.toString(), ____655.____659.iconPathType.item)
        } else {
            return ____654.____675.getIconPath(this.____867.iconPath, ____655.____659.iconPathType.item)
        }
    },
    getItemInfo: function() {
        return this._itemInfo
    },
    setIsShowQHLevel: function(value) {
        this.____1281 = value;
        if (value) {
            if (this._itemInfo != null) {
                this.setQHLevel(this._itemInfo.qhLevel)
            }
        } else {
            this.setQHLevel(-1)
        }
    },
    setIsShowCount: function(value) {
        this.____1280 = value;
        if (value) {
            if (this._itemInfo != null) {
                this.setCount(this._itemInfo.count)
            }
        } else {
            this.setCount(-1)
        }
    },
    getIsShowCount: function() {
        return this.____1280
    },
    setEquipFlagType: function(type) {
        if (this.____1140 == type) {
            return
        }
        this.____1140 = type;
        if (this.____1140 == 0) {
            if (this._equipFlag != null) {
                this._equipFlag.dispose();
                this._equipFlag = null
            }
        } else {
            if (this._equipFlag == null) {
                this._equipFlag = ____654.____673.newKYSprite();
                this._equipFlag.setPosition(____654.____673.____159(this.____1477 - 19, this.____1478 + 19));
                this.addChild(this._equipFlag, 9)
            }
            if (this.____1140 == 1) {
                this._equipFlag.setFrame("flag/ui_canEquipFlag.png")
            } else if (this.____1140 == 2) {
                this._equipFlag.setFrame("flag/ui_canWashFlag.png")
            }
        }
    },
    setStageFlag: function(starCount) {
        if (this._equipFlag == null) {
            this._equipFlag = ____654.____673.newKYSprite();
            this._equipFlag.setFrame("flag/ui_advanceEquipFlag.png");
            this._equipFlag.setPosition(____654.____673.____159(this.____1477 + 21, this.____1478 + 15));
            this.addChild(this._equipFlag, 4)
        }
        if (this._stageLabel == null) {
            this._stageLabel = new NumberView();
            this._stageLabel.setType(7, null, 0.9);
            this._stageLabel.setAnchorPoint(____654.____673.anchorPoints[5]);
            this._stageLabel.setRotation(45);
            this._stageLabel.setPosition(____654.____673.____159(24, 42));
            this._equipFlag.addChild(this._stageLabel, 4)
        }
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(starCount);
        var value = ____655.____659.nameType.getChineseNumber(stage);
        this._stageLabel.setString(value);
        if (this._starLabel == null) {
            this._starLabel = new NumberView();
            this._starLabel.setType(1, null, 0.5);
            this._starLabel.setRotation(45);
            this._starLabel.setPosition(____654.____673.____159(40, 25));
            this._equipFlag.addChild(this._starLabel)
        }
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(starCount);
        this._starLabel.setString(star)
    },
    clearStageFlag: function() {
        if (this._starLabel != null) {
            this._starLabel.dispose();
            this._starLabel = null
        }
        if (this._stageLabel != null) {
            this._stageLabel.dispose();
            this._stageLabel = null
        }
        if (this._equipFlag != null) {
            this._equipFlag.dispose();
            this._equipFlag = null
        }
    },
    showTip: function() {
        var pos = this.convertToWorldSpace(____654.____673.____159(this.____1477, this.____1478));
        if (this._itemInfo != null) {
            ____654.tipsManager.showItemFlashTip(this._itemInfo, pos)
        } else if (this.____867 != null) {
            ____654.tipsManager.showItemTempFlashTip(this.____867, pos)
        }
    },
    hideTip: function() {
        ____654.tipsManager.hideFlashTip()
    },
    dispose: function() {
        this.setCount(-1);
        this.setQHLevel(-1);
        this.clearStageFlag();
        this._super();
        if (this._itemInfo != null) {
            this._itemInfo.removeEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this);
            this._itemInfo = null
        }
        ____654.tipsManager.hideFlashTip()
    }
});
var ____2130 = KYNode.extend({
    ____1199: null,
    ____1361: null,
    _lockImg: null,
    _proValueLabel: null,
    _proName: null,
    ____1830: null,
    ____1694: null,
    ____1693: null,
    ____1457: null,
    ____999: null,
    ____1237: null,
    ctor: function() {
        this._super("goodsProgressCell.ExportJson");
        this.____1199 = this.getChildByName("goodsCell");
        this.____1361 = this.getChildByName("lockIcon");
        this._lockImg = this.getChildByName("lockImg");
        this.____1361.setVisible(false);
        this._lockImg.setVisible(false);
        this._proValueLabel = this.getChildByName("proValue");
        this._proName = this.getChildByName("proName");
        this.____1830 = this.getChildByName("upgradeIcon");
        this.____1830.setVisible(false);
        this.____1694 = this.getChildByName("speedBg");
        this.____1693 = this.getChildByName("speedBar");
        this.____1693.setPercent(0);
        this.____1457 = this.getChildByName("nextSpeedBar");
        this.____1457.setPercent(0);
        this.____1237 = this.getChildByName("iconImg");
        this.____999 = this.getChildByName("conditionLabel")
    },
    dispose: function() {
        this._super();
        this.____1199 = null;
        this.____1361 = null;
        this._lockImg = null;
        this._proValueLabel = null;
        this._proName = null;
        this.____1830 = null;
        this.____1694 = null;
        this.____1693 = null;
        this.____999 = null;
        this.____1237 = null;
        this.____1457 = null
    },
});
var ____2131 = ____2128.extend({
    ____1680: null,
    _levelLabel: null,
    _godType: null,
    _isShowLevel: true,
    ____1340: null,
    _skillLevel: 0,
    ctor: function(isGround, offsetX, offsetY) {
        this._super(isGround, offsetX, offsetY)
    },
    initSize: function() {
        this.____1677 = ____654.____673.____160(74, 74);
        this._scale = 1.03
    },
    setSkillInfo: function(skillInfo, godType) {
        this.____1680 = skillInfo;
        if (this.____1680 == null) {
            this.setSkillTemplateInfo(null)
        } else {
            this.setSkillTemplateInfo(skillInfo.template, godType);
            this.____64(skillInfo.level)
        }
    },
    setSkillTemplateInfo: function(tempInfo, godType) {
        this._godType = godType;
        this.setBaseItemInfo(tempInfo)
    },
    setIsShowCount: function(flag) {
        this._isShowLevel = flag;
        if (!this._isShowLevel) {
            this.____64(-1)
        }
    },
    ____64: function(level) {
        this._skillLevel = 0;
        if (level > -1 && this._isShowLevel) {
            if (this._levelLabel == null) {
                this._levelLabel = ____654.____673.newKYLabel();
                this._levelLabel.setPosition(____654.____673.____159(this.____1477, this.____1478 - 25));
                this.addChild(this._levelLabel, 20)
            }
            if (level == 0) {
                this._levelLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2131.tips1"));
                this.setGray(true);
                this._levelLabel.setFontSize(18)
            } else {
                this.setGray(false);
                this._levelLabel.setString("Lv." + level.toString());
                this._levelLabel.setFontSize(20);
                this._skillLevel = level
            }
            if (this.____1340 == null) {
                this.____1340 = ____654.____673.newKYSprite();
                this.____1340.setFrame("ui_levelBg.png");
                this.____1340.setPosition(____654.____673.____159(this.____1477, this.____1478 - 27));
                this.addChild(this.____1340, 19)
            }
        } else {
            if (this._levelLabel != null) {
                this._levelLabel.dispose();
                this._levelLabel = null
            }
            if (this.____1340 != null) {
                this.____1340.dispose();
                this.____1340 = null
            }
        }
    },
    getPath: function() {
        if (this.____867 == null) {
            return null
        }
        return ____655.allTemplates.skillTemplateList.getSkillFullPath(this.____867.templateId, this._godType)
    },
    getBgPath: function() {
        return "cell/ui_cell2.png"
    },
    showTip: function() {
        var pos = this.convertToWorldSpace(____654.____673.____159(this.____1477, this.____1478));
        if (this.____1680 != null) {
            ____654.tipsManager.showSkillFlashTip(this.____1680, pos, this._godType)
        } else if (this.____867 != null) {
            ____654.tipsManager.showSkillTempFlashTip(this.____867, pos, this._godType, this._skillLevel)
        }
    },
    hideTip: function() {
        ____654.tipsManager.hideFlashTip()
    },
    dispose: function() {
        this.____64(-1);
        this.____1680 = null;
        ____654.tipsManager.hideFlashTip();
        this._super()
    }
});
var LoadingPanel = KYNode.extend({
    _bg: null,
    _bgPath: "",
    ____1239: null,
    ____1240: "",
    _tipsLabel: null,
    ____1356: null,
    _barRight: null,
    _logo: null,
    ____1363: "",
    _currentIndex: 1,
    _maskBg: null,
    _percent: 0,
    ctor: function() {
        this._super("loadingPanel.ExportJson");
        this._bgPath = ____654.____675.____139("outPic/loadingBg.png");
        this._bg = this.getChildByName("bg");
        this.____1239 = this.getChildByName("img");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____1356 = this.getChildByName("loadingBar");
        this._barRight = this.getChildByName("barRight");
        this._logo = this.getChildByName("logo");
        this.____1363 = ____654.____675.getPlatFromPath(____655.sources, "logo.png");
        this._maskBg = this.getChildByName("maskBg");
        this._maskBg.setSize(____654.____673.____160(____655.____656, ____655.____657));
        this._maskBg.setTouchEnabled(true);
        ____654.____677.____146(this._bg, this._bgPath);
        ____654.____677.____146(this._logo, this.____1363)
    },
    show: function() {
        if (this.getParent() == null) {
            ____654.____676.____802.addChild(this, 1000)
        }
        var des = ____654.____682.____108("loading_descript").split("##");
        var index = Math.floor(Math.random() * des.length);
        this._tipsLabel.setString(des[index]);
        this.____1240 = ____654.____675.____139("outPic/advertImg_" + this._currentIndex + ".png");
        ____654.____677.____146(this.____1239, this.____1240);
        this._currentIndex++;
        if (this._currentIndex > 5) {
            this._currentIndex = 1
        }
        this.setPosition(____654.____673.____159((____655.____656 - this.getContentSize().width) / 2, (____655.____657 - this.getContentSize().height) / 2));
        ____654.____676.hideBack()
    },
    hide: function() {
        if (this.getParent() != null) {
            this.removeFromParent(false)
        }
        if (this.____1240 != "") {
            ____654.____677.removeImageQuote(this.____1240, this.____1239);
            this.____1240 = null
        }
        ____654.____676.showBack()
    },
    setValue: function(value) {
        this._percent = value;
        this.____1356.setPercent(value);
        this._barRight.setPositionX(160 + 872 * value / 100)
    },
    getPercent: function() {
        return this._percent
    },
    dispose: function() {
        this._tipsLabel = null;
        this.____1356 = null;
        this._barRight = null;
        this._maskBg = null;
        if (this.____1240 != "") {
            ____654.____677.removeImageQuote(this.____1240, this.____1239);
            this.____1240 = null
        }
        this.____1239 = null;
        if (this._bgPath != "") {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this.____1363 != "") {
            ____654.____677.removeImageQuote(this.____1363, this._logo);
            this.____1363 = null
        }
        this._logo = null
    },
});
var ____2121 = KYNode.extend({
    _type: null,
    _bg: null,
    ____1126: null,
    _tickCount: 0,
    _maxTickCount: 600,
    ctor: function() {
        this._super();
        this._type = [];
        this._bg = ____654.____673.newKYImageView();
        this._bg.setFrame("board/ui_blackBoard.png");
        this._bg.setScale9Enabled(true);
        this._bg.setCapInsets(cc.rect(4, 4, 1, 1));
        this._bg.setOpacity(150);
        this._bg.setAnchorPoint(____654.____673.anchorPoints[6]);
        this._bg.setTouchEnabled(true);
        this._bg.setContentSize(____655.____656, ____655.____657);
        this.addChild(this._bg);
        this.____1126 = new RotationEffect("effect/effect_loading.png", 10);
        this.____1126.setPosition(____654.____673.____159(____655.____656 / 2, ____655.____657 / 2));
        this.addChild(this.____1126)
    },
    isTypeShow: function(type) {
        var index = this._type.indexOf(type);
        return index >= 0
    },
    setType: function(type) {
        this._type.push(type);
        if (this.getParent() == null) {
            ____654.____676.____802.addChild(this, 100)
        }
        ____654.____678.____298(this.tick, this);
        this._tickCount = this._maxTickCount
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount < 0) {
            this.hideType();
            ____654.____678.____299(this.tick, this)
        }
    },
    hideType: function(type) {
        if (type != null) {
            var index = this._type.indexOf(type);
            if (index >= 0) {
                this._type.splice(index, 1)
            }
        } else {
            this._type = []
        }
        if (this._type.length == 0 && this.getParent() != null) {
            this.removeFromParent(false)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this._type = null;
        this._bg.dispose();
        this._bg = null;
        this.____1126.dispose();
        this.____1126 = null;
        this._super()
    }
});
var ____2122 = cc.GLNode.extend({
    ____1665: null,
    tex1Location: null,
    tex2Location: null,
    uniformOffset: null,
    tex1: null,
    tex2: null,
    squareVertexPositionBuffer: null,
    squareVertexTextureBuffer: null,
    ____1836: 0,
    ____1851: 0,
    ____1826: 0,
    ____1838: 0,
    ctor: function(texture1, texture2, size, uSpeed, vSpeed) {
        this.____1836 = uSpeed || 0;
        this.____1851 = vSpeed || 0;
        this._super();
        this.____1665 = cc.GLProgram.createWithByteArrays(this.getVSH(), this.getFSH());
        this.____1665.retain();
        this.____1665.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
        this.____1665.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
        this.____1665.link();
        this.____1665.updateUniforms();
        this.initGL(texture1, texture2, size);
        var program = this.____1665.getProgram();
        this.tex1Location = gl.getUniformLocation(program, "texture0");
        this.tex2Location = gl.getUniformLocation(program, "texture1");
        this.uniformOffset = gl.getUniformLocation(program, "texOffset");
        if (this.____1836 != 0 || this.____1851 != 0) {
            ____654.____678.____298(this.tick, this)
        }
    },
    tick: function(delta, count) {
        this.____1826 += this.____1836 * delta;
        this.____1838 += this.____1851 * delta;
        if (this.____1826 > 1 || this.____1826 < -1) {
            this.____1826 = 0
        }
        if (this.____1838 > 1 || this.____1838 < -1) {
            this.____1838 = 0
        }
    },
    draw: function() {
        this.____1665.use();
        this.____1665.setUniformsForBuiltins();
        this.____1665.setUniformLocationF32(this.uniformOffset, this.____1826, this.____1838);
        gl.activeTexture(gl.TEXTURE0);
        gl.bindTexture(gl.TEXTURE_2D, this.tex1.getName());
        gl.uniform1i(this.tex1Location, 0);
        gl.activeTexture(gl.TEXTURE1);
        gl.bindTexture(gl.TEXTURE_2D, this.tex2.getName());
        gl.uniform1i(this.tex2Location, 1);
        gl.bindBuffer(gl.ARRAY_BUFFER, this.squareVertexPositionBuffer);
        gl.vertexAttribPointer(cc.VERTEX_ATTRIB_POSITION, 2, gl.FLOAT, false, 0, 0);
        gl.bindBuffer(gl.ARRAY_BUFFER, this.squareVertexTextureBuffer);
        gl.vertexAttribPointer(cc.VERTEX_ATTRIB_TEX_COORDS, 2, gl.FLOAT, false, 0, 0);
        gl.drawArrays(gl.TRIANGLE_STRIP, 0, 4);
        gl.activeTexture(gl.TEXTURE1);
        gl.bindTexture(gl.TEXTURE_2D, null);
        gl.activeTexture(gl.TEXTURE0);
        gl.bindTexture(gl.TEXTURE_2D, null);
        gl.bindBuffer(gl.ARRAY_BUFFER, null)
    },
    initGL: function(texture1, texture2, size) {
        this.tex1 = cc.textureCache.addImage(texture1);
        this.tex2 = cc.textureCache.addImage(texture2);
        this.squareVertexPositionBuffer = gl.createBuffer();
        gl.bindBuffer(gl.ARRAY_BUFFER, this.squareVertexPositionBuffer);
        var vertices = [size, size, 0, size, size, 0, 0, 0];
        gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertices), gl.STATIC_DRAW);
        this.squareVertexTextureBuffer = gl.createBuffer();
        gl.bindBuffer(gl.ARRAY_BUFFER, this.squareVertexTextureBuffer);
        var texcoords = [0, 0, 1, 0, 0, 1, 1, 1];
        gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(texcoords), gl.STATIC_DRAW);
        gl.bindBuffer(gl.ARRAY_BUFFER, null)
    },
    getFSH: function() {
        var str = "varying vec4 v_fragmentColor; \n" + "varying vec2 v_texCoord; \n" + "uniform sampler2D texture0; \n" + "uniform sampler2D texture1; \n" + "uniform vec2 texOffset; \n" + "void main() \n" + "{ \n" + " vec2 texcoord = mod(texOffset + v_texCoord,1.0); \n" + " vec4 color1 =  v_fragmentColor * texture2D(texture0, texcoord); \n" + " vec4 color2 =  texture2D(texture1, v_texCoord); \n" + " gl_FragColor = vec4(color1.r*color2.r, color1.g*color2.g, color1.b*color2.b, color1.a*color2.a); \n" + "} \n";
        return str
    },
    getVSH: function() {
        var str = "attribute vec4 a_position; \n" + "attribute vec2 a_texCoord; \n" + "attribute vec4 a_color; \n" + "varying vec4 v_fragmentColor; \n" + "varying vec2 v_texCoord; \n" + "void main() \n" + "{ \n" + " gl_Position = (CC_PMatrix * CC_MVMatrix) * a_position; \n" + " v_fragmentColor = a_color; \n" + " v_texCoord = a_texCoord; \n" + "} \n";
        return str
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____1665.release();
        this.____1665 = null;
        this.tex1Location = null;
        this.tex2Location = null;
        this.uniformOffset = null;
        cc.textureCache.removeTexture(this.tex1);
        this.tex1 = null;
        cc.textureCache.removeTexture(this.tex2);
        this.tex2 = null;
        gl.deleteBuffer(this.squareVertexPositionBuffer);
        this.squareVertexPositionBuffer = null;
        gl.deleteBuffer(this.squareVertexTextureBuffer);
        this.squareVertexTextureBuffer = null
    },
});
var NewlyCopyTalkView = KYPanel.extend({
    _controller: null,
    _bg: null,
    ____1221: null,
    ____1224: null,
    _upBg: null,
    _downBg: null,
    _nameBg: null,
    _nameLabel: null,
    _jumpBtn: null,
    ____1001: null,
    ____1384: null,
    ____1251: null,
    _currentIndex: -1,
    _maskTime: 0,
    _isMask: false,
    _touchEffect: null,
    _id: null,
    ctor: function(controller) {
        this._super();
        this._controller = controller;
        this._bg = ____654.____673.newKYImageView();
        this._bg.setFrame("board/ui_alphaBoard.png");
        this._bg.setScale9Enabled(true);
        this._bg.setCapInsets(____654.____673.____161(4, 4, 1, 1));
        this._bg.setOpacity(0);
        this._bg.setTouchEnabled(true);
        this._bg.setContentSize(____654.____673.____160(____655.____656, ____655.____657));
        this._bg.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.addChild(this._bg);
        this._upBg = ____654.____673.newKYImageView();
        this._upBg.setFrame("bar/ui_newlyBar1.png");
        this._upBg.setScale9Enabled(true);
        this._upBg.setCapInsets(____654.____673.____161(10, 43, 1, 1));
        this._upBg.setContentSize(____654.____673.____160(____655.____656, 88));
        this._upBg.setAnchorPoint(____654.____673.anchorPoints[1]);
        this._upBg.setPositionY(____655.____657);
        this.addChild(this._upBg);
        this._downBg = ____654.____673.newKYImageView();
        this._downBg.setFrame("bar/ui_newlyBar1.png");
        this._downBg.setScale9Enabled(true);
        this._downBg.setCapInsets(____654.____673.____161(10, 43, 1, 1));
        this._downBg.setContentSize(____654.____673.____160(____655.____656, 126));
        this._downBg.setAnchorPoint(____654.____673.anchorPoints[1]);
        this._downBg.setScaleY(-1);
        this.addChild(this._downBg);
        this._nameBg = ____654.____673.newKYImageView();
        this._nameBg.setFrame("bar/ui_newlyBar2.png");
        this._nameBg.setScale9Enabled(true);
        this._nameBg.setCapInsets(____654.____673.____161(30, 16, 1, 1));
        this._nameBg.setContentSize(____654.____673.____160(165, 33));
        this._nameBg.setAnchorPoint(____654.____673.anchorPoints[6]);
        this._nameBg.setPosition(____654.____673.____159(268, 125));
        this.addChild(this._nameBg);
        this._nameLabel = ____654.____673.newKYLabel();
        this._nameLabel.setPosition(____654.____673.____159(340, 142));
        this.addChild(this._nameLabel);
        this.____1221 = ____654.____673.newKYSprite();
        this.____1221.setPosition(____654.____673.____159(130, 132));
        this.addChild(this.____1221);
        this._jumpBtn = ____654.____673.newKYSprite();
        this._jumpBtn.setFrame("icon/ui_jumpBtn.png");
        this._jumpBtn.setPosition(____654.____673.____159(____655.____656 - 80, ____655.____657 - 45));
        this.addChild(this._jumpBtn);
        this.____1001 = ____654.____673.newKYLabel();
        this.____1001.setAnchorPoint(____654.____673.anchorPoints[1]);
        this.____1001.setContentSize(____654.____673.____160(675, 115));
        this.____1001.setPosition(____654.____673.____159(270, 100));
        this.addChild(this.____1001);
        this.____1384 = [];
        for (var i = 0; i < 3; i++) {
            var mask = ____654.____673.newKYImageView();
            mask.setFrame("bar/ui_newlyBar3.jpg");
            mask.setScale9Enabled(true);
            mask.setCapInsets(____654.____673.____161(20, 20, 1, 1));
            mask.setContentSize(____654.____673.____160(675, 40));
            mask.setScaleY(0.875);
            mask.setAnchorPoint(____654.____673.anchorPoints[6]);
            mask.setPosition(____654.____673.____159(270, 14 + 28 * i));
            this.____1384.push(mask);
            this.addChild(mask)
        }
        this.____6()
    },
    ____6: function() {
        this._bg.addListener(this, this.____16);
        this._jumpBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._bg) {
                if (this._isMask) {
                    this.stopMask()
                } else {
                    this.nextPage()
                }
            } else if (sender == this._jumpBtn) {
                this._controller.hideNpcTalkView()
            }
        }
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this)
    },
    ____363: function(desId) {
        this._id = desId;
        var content = ____654.____682.____108(desId.toString());
        if (content == null || content == "") {
            this.closeHandler();
            return
        }
        this._currentIndex = -1;
        this.____1251 = ____654.____674.strItemSplitToStrs(content);
        this.nextPage()
    },
    closeHandler: function() {
        this._controller.hideNpcTalkView()
    },
    nextPage: function() {
        ____654.____678.____299(this.maskTick, this);
        if (this._touchEffect != null) {
            this._touchEffect.dispose();
            this._touchEffect = null
        }
        this._currentIndex++;
        if (this._currentIndex >= this.____1251.length) {
            this._controller.hideNpcTalkView();
            return
        }
        var info = this.____1251[this._currentIndex];
        var path = null;
        if (info[1] == "0") {
            this._nameLabel.setString(____655.____667.nick);
            path = ____654.____675.____139("outPic/roleImg" + ____655.____667.career + ".png");
            this.____1221.setScale(0.6)
        } else {
            this._nameLabel.setString(info[1]);
            if (info[0] != "0") {
                path = ____654.____675.getMonsterHead("big" + info[0])
            }
            this.____1221.setScale(1)
        }
        this.____1001.setString(____654.____682.____108(info[2]));
        this.startMask();
        if (this.____1224 == path) {
            return
        }
        if (path != null) {
            ____654.____677.removeImageQuote(this.____1224, this.____1221)
        }
        this.____1224 = path;
        if (this.____1224 != null) {
            ____654.____677.____146(this.____1221, this.____1224)
        } else {
            this.____1221.setFrame("board/ui_alphaBoard.png")
        }
    },
    startMask: function() {
        if (this._isMask == true) {
            return
        }
        this._maskTime = 0;
        for (var i = 0; i < 3; i++) {
            this.____1384[i].setPositionX(270)
        }
        ____654.____678.____298(this.maskTick, this);
        this._isMask = true
    },
    maskTick: function(delta, count) {
        this._maskTime++;
        if (this._maskTime < 60) {
            this.____1384[2].setPositionX(270 + this._maskTime * 12)
        } else if (this._maskTime == 60) {
            this.stopMask();
            if (this._touchEffect == null) {
                this._touchEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.FINGER_EFFECT, false, ____654.____673.____159(900, 60), this, false, 1)
            }
        } else if (this._maskTime < 300) {} else {
            this.nextPage()
        }
    },
    stopMask: function() {
        if (this._isMask == false) {
            return
        }
        for (var i = 0; i < 3; i++) {
            this.____1384[i].setPositionX(990)
        }
        this._isMask = false
    },
    dispose: function() {
        ____654.____678.____299(this.maskTick, this);
        this.____17();
        if (this._id == "50100") {
            ____654.guideShow(53)
        } else {
            ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, true))
        }
        this.stopMask();
        this._controller = null;
        if (this._bg != null) {
            this._bg.dispose();
            this._bg = null
        }
        if (this.____1224 != null) {
            ____654.____677.removeImageQuote(this.____1224, this.____1221);
            this.____1224 = null
        }
        if (this.____1221 != null) {
            this.____1221.dispose();
            this.____1221 = null
        }
        if (this._upBg != null) {
            this._upBg.dispose();
            this._upBg = null
        }
        if (this._downBg != null) {
            this._downBg.dispose();
            this._downBg = null
        }
        if (this._nameBg != null) {
            this._nameBg.dispose();
            this._nameBg = null
        }
        if (this._nameLabel != null) {
            this._nameLabel.dispose();
            this._nameLabel = null
        }
        if (this._jumpBtn != null) {
            this._jumpBtn.dispose();
            this._jumpBtn = null
        }
        if (this.____1001 != null) {
            this.____1001.dispose();
            this.____1001 = null
        }
        if (this.____1384 != null) {
            for (var i = 0; i < this.____1384.length; i++) {
                this.____1384[i].dispose()
            }
            this.____1384 = null
        }
        this.____1251 = null;
        this._super()
    },
});
var ____2132 = KYNode.extend({
    _icon: null,
    _titleLabel: null,
    ____1731: null,
    ____1817: null,
    ____1745: null,
    ____1748: null,
    ctor: function() {
        this._super("npcDialogItemView.ExportJson");
        this._icon = this.getChildByName("icon");
        this._titleLabel = this.getChildByName("titleLabel");
        this.____1731 = this.getChildByName("styleLabel")
    },
    setTaskInfo: function(taskInfo) {
        this.____1745 = taskInfo;
        this.____1817 = null;
        this.____1748 = null;
        this._titleLabel.setString(this.____1745.____55().getTaskTypeName() + this.____1745.____55().title);
        if (this.____1745.____55().type == 1) {
            this._titleLabel.setColor(____655.____659.____688.lightGreen)
        } else {
            this._titleLabel.setColor(____655.____659.____688.yellow)
        }
        if (this.____1745.state == ____655.____659.commonStaticType.task_finishNotSubmit) {
            this._icon.setFrame("icon/ui_npcTaskIcon3.png", 1);
            this.____1731.setString("已完成")
        } else if (this.____1745.state == ____655.____659.commonStaticType.task_acceptNotFinish) {
            this._icon.setFrame("icon/ui_npcTaskIcon1.png", 1);
            this.____1731.setString("未完成")
        }
        this.____1731.setPositionX(this._titleLabel.getContentSize().width + 75)
    },
    setTaskTemplateInfo: function(taskTemplateInfo) {
        this.____1748 = taskTemplateInfo;
        this.____1745 = null;
        this.____1817 = null;
        this._titleLabel.setString(this.____1748.getTaskTypeName() + this.____1748.title);
        this._icon.setFrame("icon/ui_npcTaskIcon2.png", 1);
        var level = this.____1748.minLv;
        if (level > ____655.____667.level) {
            this.____1731.setColor(____655.____659.____688.red);
            this.____1731.setString(____654.yuyanbaoManager.getYuyanbao("____2278.text2", level))
        } else {
            this.____1731.setColor(____655.____659.____688.lightGreen);
            this.____1731.setString(____654.yuyanbaoManager.getYuyanbao("____2278.text3"))
        }
        this.____1731.setPositionX(this._titleLabel.getContentSize().width + 75)
    },
    setTriggerInfo: function(trigger) {
        this.____1817 = trigger;
        this.____1748 = null;
        this.____1745 = null;
        this._titleLabel.setString(trigger.descript);
        this._icon.setFrame("icon/ui_npcFuncIcon.png", 1)
    },
    clickHandler: function() {
        if (this.____1745 != null) {
            ____654.____676.____1466.setTaskId(this.____1745.taskId)
        } else if (this.____1748 != null) {
            ____654.____676.____1466.setTaskId(this.____1748.id)
        } else if (this.____1817 != null) {
            ____654.triggerManager.handlerList([this.____1817]);
            ____654.____676.hideNpcPanel()
        }
    },
    dispose: function() {
        this._super();
        this._icon = null;
        this._titleLabel = null;
        this.____1731 = null;
        this.____1817 = null;
        this.____1745 = null;
        this.____1748 = null
    },
});
var ____2133 = KYNode.extend({
    ____1109: null,
    ____1285: null,
    _timeLabel: null,
    ____1383: null,
    _itemList: null,
    _countDownUtils: null,
    ctor: function() {
        this._super("npcDialogView.ExportJson");
        this.____1109 = this.getChildByName("dialogLabel");
        this.____1285 = this.getChildByName("itemLayer");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1285.setItemsMargin(5);
        this.____1285.setLocalZOrder(11);
        this._itemList = [];
        this.____1383 = this.getChildByName("maskBtn");
        this.____1383.setPosition(____654.____673.____159(-39, -112));
        this.____1383.setScaleX(____655.____656 / 8);
        this.____1383.setScaleY(____655.____657 / 8);
        this.____6()
    },
    ____6: function() {
        this.____1383.addListener(this, this.____16)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1383) {
                ____654.____676.hideNpcPanel()
            }
        }
    },
    ____17: function() {},
    setDialog: function(dialog) {
        this.____1109.setString(dialog)
    },
    setList: function(canSubmitList, canAcceptList, cantSubmitList, triggers) {
        this.clearItems();
        var len = 0;
        var i = 0;
        var item = null;
        for (i = 0; i < canSubmitList.length; i++) {
            item = new ____2132();
            item.setTaskInfo(canSubmitList[i]);
            this._itemList.push(item);
            this.____1285.pushBackCustomItem(item);
            item.addListener(this, this.itemClickHandler);
            len++
        }
        for (i = 0; i < canAcceptList.length; i++) {
            item = new ____2132();
            item.setTaskTemplateInfo(canAcceptList[i]);
            this._itemList.push(item);
            this.____1285.pushBackCustomItem(item);
            item.addListener(this, this.itemClickHandler);
            len++
        }
        for (i = 0; i < cantSubmitList.length; i++) {
            item = new ____2132();
            item.setTaskInfo(cantSubmitList[i]);
            this._itemList.push(item);
            this.____1285.pushBackCustomItem(item);
            item.addListener(this, this.itemClickHandler);
            len++
        }
        for (i = 0; i < triggers.length; i++) {
            item = new ____2132();
            item.setTriggerInfo(triggers[i]);
            this._itemList.push(item);
            this.____1285.pushBackCustomItem(item);
            item.addListener(this, this.itemClickHandler);
            len++
        }

        function countDownComplete() {
            ____654.____676.hideNpcPanel()
        };
        if (len == 0) {
            if (this._countDownUtils == null) {
                this._countDownUtils = new ____2111();
                this._countDownUtils.setLabel(this._timeLabel, 2, 0, "____2134.text3")
            }
            this._countDownUtils.start(10, null, countDownComplete);
            this.____1383.setTouchEnabled(true)
        } else {
            this._timeLabel.setString("");
            this.____1383.setTouchEnabled(false)
        }
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            sender.clickHandler()
        }
    },
    clearItems: function() {
        this.____1285.removeAllItems();
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this._itemList = []
    },
    hide: function() {
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this.removeFromParent(false)
    },
});
var ____2134 = KYPanel.extend({
    _bg: null,
    _bgPath: null,
    _nameLabel: null,
    ____1839: null,
    _closeBtn: null,
    ____1464: null,
    ____1463: null,
    ____1110: null,
    ____1749: null,
    _isShow: false,
    currentTimesNums: null,
    nextTimeNums: 0,
    ctor: function() {
        this._super("npcPanel.ExportJson");
        this._bg = this.getChildByName("bg");
        this._nameLabel = this.getChildByName("nameLabel");
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1839 = this.getChildByName("viewLayer");
        this._bgPath = ____654.____675.____139("outPic/ui_npcPanelBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.currentTimesNums = {};
        this.nextTimeNums = 0;
        this.____6()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        ____655.____667.addEventListener(____655.____661.____703, this.levelUpHandler, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._closeBtn) {
                ____654.____676.hideNpcPanel()
            }
        }
    },
    ____17: function() {
        ____655.____667.removeEventListener(____655.____661.____703, this.levelUpHandler, this)
    },
    setNpcId: function(npcId) {
        this._isShow = true;
        if (this.____1463 != npcId) {
            this.____1463 = npcId;
            this.____1464 = ____655.allTemplates.npcTemplateList.getNpc(npcId);
            this._nameLabel.setString(this.____1464.name);
            this.nextTimeNums = ____655.____662.getSystemTimeSec();
            if (this.currentTimesNums[npcId] == null || this.nextTimeNums - this.currentTimesNums[npcId] > Math.random() * 60 + 90) {
                ____654.soundManager.playSound(this.____1464.sound, false, true);
                this.currentTimesNums[npcId] = this.nextTimeNums
            }
        }
        var notSubmitList = ____655.____670.getNotSumbitByNpcId(npcId);
        var canSubmitList = notSubmitList[0];
        var cantSubmitList = notSubmitList[1];
        var canAcceptList = ____655.____670.getCanAcceptByNpcId(npcId);
        var triggers = this.____1464.triggers;
        var canSubmitLen = canSubmitList.length;
        var cantSubmitLen = cantSubmitList.length;
        var canAcceptLen = canAcceptList.length;
        var triggerLen = triggers.length;
        if (canSubmitLen > 0) {
            if (this.____1110 != null) {
                this.____1110.removeFromParent(false)
            }
            this.setTaskId(canSubmitList[0].taskId)
        } else if (triggerLen == 0 && (canSubmitLen + cantSubmitLen + canAcceptLen) == 1) {
            if (this.____1110 != null) {
                this.____1110.removeFromParent(false)
            }
            if (canSubmitLen == 1) {
                this.setTaskId(canSubmitList[0].taskId)
            } else if (cantSubmitLen == 1) {
                this.setTaskId(cantSubmitList[0].taskId)
            } else if (canAcceptLen == 1) {
                this.setTaskId(canAcceptList[0].id)
            }
        } else if (triggerLen == 1 && (canSubmitLen + cantSubmitLen + canAcceptLen) == 0) {
            ____654.triggerManager.handlerList(triggers);
            ____654.____676.hideNpcPanel();
            return
        } else {
            if (this.____1749 != null) {
                this.____1749.hide()
            }
            if (this.____1110 == null) {
                this.____1110 = new ____2133()
            }
            this.____1110.setDialog(this.____1464.getDialog());
            this.____1110.setList(canSubmitList, canAcceptList, cantSubmitList, triggers);
            if (this.____1110.getParent() == null) {
                this.____1839.addChild(this.____1110)
            }
        }
    },
    levelUpHandler: function(evt) {
        if (this._isShow == true) {
            var npcId = this.____1463;
            this.setNpcId(npcId)
        }
    },
    setTaskId: function(taskId) {
        if (this.____1110 != null) {
            this.____1110.hide()
        }
        if (this.____1749 == null) {
            this.____1749 = new ____2135()
        }
        this.____1749.setTaskId(taskId);
        if (this.____1749.getParent() == null) {
            this.____1839.addChild(this.____1749)
        }
    },
    hide: function() {
        this._isShow = false;
        if (this.____1749 != null) {
            this.____1749.hide()
        }
        if (this.____1110 != null) {
            this.____1110.hide()
        }
        this.removeFromParent(false)
    },
});
var ____2135 = KYNode.extend({
    _titleLabel: null,
    _infoLabel: null,
    ____849: null,
    ____852: null,
    ____850: null,
    ____853: null,
    ____936: null,
    ____1743: null,
    ____892: null,
    ____1383: null,
    ____1744: 0,
    ____1745: null,
    ____1756: null,
    ____911: 0,
    _itemList: null,
    _itemInfoList: null,
    ctor: function() {
        this._super("npcTaskView.ExportJson");
        this._titleLabel = this.getChildByName("titleLabel");
        this._infoLabel = this.getChildByName("infoLabel");
        this.____849 = this.getChildByName("awardIcon1");
        this.____849.setVisible(false);
        this.____852 = this.getChildByName("awardLabel1");
        this.____852.setString("");
        this.____850 = this.getChildByName("awardIcon2");
        this.____850.setVisible(false);
        this.____853 = this.getChildByName("awardLabel2");
        this.____853.setString("");
        this.____936 = this.getChildByName("cellLayer");
        this.____1743 = this.getChildByName("taskBtn");
        this.____892 = this.getChildByName("btnLabel");
        this.____1383 = this.getChildByName("maskBtn");
        this.____1383.setPosition(____654.____673.____159(-39, -112));
        this.____1383.setSize(____654.____673.____160(____655.____656, ____655.____657));
        this.____6()
    },
    ____6: function() {
        this.____1743.addListener(this, this.____16);
        this.____1383.addListener(this, this.____16)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1743 || sender == this.____1383) {
                if (this.____911 == 0) {}
                if (this.____911 == 1) {
                    ____654.selfDataMessageSender.sendTaskAccept(this.____1744)
                } else if (this.____911 == 2) {
                    ____654.selfDataMessageSender.sendTaskSubmit(this.____1744)
                }
                ____654.____676.hideNpcPanel()
            }
        }
    },
    ____17: function() {},
    setTaskId: function(taskId) {
        this.____1744 = taskId;
        this.____1756 = ____655.allTemplates.taskTemplateList.____121(taskId);
        this.____1745 = ____655.____670.____121(taskId);
        this._titleLabel.setString(this.____1756.title);
        if (this.____1745 == null) {
            this.____911 = 1;
            ____654.____674.setKYBtnEnabled(this.____1743, true, 1);
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2134.text1"));
            this._infoLabel.setString(this.____1756.getAcceptContent())
        } else {
            if (this.____1745.state == ____655.____659.commonStaticType.task_finishNotSubmit) {
                this.____911 = 2;
                ____654.____674.setKYBtnEnabled(this.____1743, true, 1)
            } else {
                this.____911 = 0;
                ____654.____674.setKYBtnEnabled(this.____1743, false, 1)
            }
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2134.text2"));
            this._infoLabel.setString(this.____1756.getFinishContent())
        }
        var list = this.____1756.awardList;
        this.clearItems();
        this._itemList = [];
        this._itemInfoList = [];
        var len = 0;
        for (var i = 0; i < list.length; i++) {
            var tempInfo = ____655.allTemplates.____794.getItem(list[i].templateId);
            if (tempInfo == null) {
                continue
            }
            if (tempInfo.categoryId == ____655.____659.categoryType.EXP) {
                this.____849.setVisible(true);
                this.____852.setString(list[i].count.toString())
            } else if (tempInfo.categoryId == ____655.____659.categoryType.COPPER) {
                this.____850.setVisible(true);
                this.____853.setString(list[i].count.toString())
            } else {
                if (list[i].needCareer == 0 || list[i].needCareer == ____655.____667.career) {
                    var item = new ____2129(true, 0, 0);
                    var itemInfo = new ItemInfo();
                    itemInfo.____107(list[i].templateId);
                    itemInfo.count = list[i].count;
                    itemInfo.qhLevel = list[i].qhLevel;
                    itemInfo.quality = list[i].quality;
                    item.setItemInfo(itemInfo);
                    this._itemInfoList.push(itemInfo);
                    this._itemList.push(item);
                    item.setPositionX(-18 + 90 * len);
                    this.____936.addChild(item);
                    len++
                }
            }
        }
    },
    clearItems: function() {
        if (this._itemList == null) {
            return
        }
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this._itemList = null;
        for (var i = 0; i < this._itemInfoList.length; i++) {
            this._itemInfoList[i].dispose()
        }
        this._itemInfoList = null
    },
    hide: function() {
        this.____1744 = 0;
        this.____1756 = null;
        this.____1745 = null;
        this.clearItems();
        this.removeFromParent(false)
    },
});
var NumberPanel = KYPanel.extend({
    ____1791: null,
    _nameLabel: null,
    _closeBtn: null,
    ____1024: null,
    _countLabel: null,
    ____1404: null,
    ____1397: null,
    ____1471: null,
    ____1510: null,
    ____1418: null,
    ____1421: null,
    ____919: null,
    ____855: null,
    _grid: null,
    _tipsLabel: null,
    _type: 0,
    _max: 0,
    _price: 0,
    ____1422: 0,
    ____1052: "0",
    _executor: null,
    ____922: null,
    ____1265: true,
    _perGroupCount: 0,
    ____892: null,
    ctor: function(type, itemTemplateInfo, price, moneyType, count, max, executor, callback, perGroupCount) {
        this._super("numberPanel.ExportJson");
        this.____1791 = this.getChildByName("textScrollView");
        this._nameLabel = this.getChildByName("nameLabel");
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1024 = this.getChildByName("buyCount");
        this._countLabel = this.getChildByName("countLabel");
        this.____855 = this.getChildByName("backBtn");
        this.____1404 = this.getChildByName("maxLabel");
        this.____1397 = this.getChildByName("maxCount");
        this.____892 = this.getChildByName("titleLabel");
        this.____1471 = [];
        for (var i = 0; i < 10; i++) {
            this.____1471.push(this.getChildByName("numBtn" + i))
        }
        this.____1510 = this.getChildByName("payLabel");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____1421 = this.getChildByName("moneyLabel");
        this.____919 = this.getChildByName("buyBtn");
        this.____1052 = count.toString();
        this._price = price;
        this.____1422 = moneyType;
        this._max = max;
        this._executor = executor;
        this.____922 = callback;
        this._perGroupCount = perGroupCount;
        this.____5(type, itemTemplateInfo);
        this.____6()
    },
    ____5: function(type, itemTemplateInfo) {
        this._grid = new ____2129();
        this._grid.setMouseEnabled(false);
        this._grid.setIsShowCount(false);
        this._grid.setItemTemplateInfo(itemTemplateInfo);
        if (this._perGroupCount != null && this._perGroupCount > 1) {
            this._grid.setCount(this._perGroupCount)
        }
        this.getChildByName("cellBg").addChild(this._grid);
        this._nameLabel.setString(itemTemplateInfo.name);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTemplateInfo.quality));
        this._tipsLabel = ____654.____673.newRichLabel(220, itemTemplateInfo.description);
        this._tipsLabel.setScale(0.9);
        var labelHeight = this._tipsLabel.getHeight() * 0.9;
        if (labelHeight < 220) {
            labelHeight = 220
        }
        this._tipsLabel.setPositionY(labelHeight - 30);
        this.____1791.setInnerSize(____654.____673.____160(200, labelHeight));
        this.____1791.addContent(this._tipsLabel);
        this.setType(type);
        this.updateView()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____855.addListener(this, this.____16);
        this.____919.addListener(this, this.____16);
        for (var i = 0; i < 10; i++) {
            this.____1471[i].addListener(this, this.____16)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____855) {
                if (this.____1052 == "" || this.____1052 == "0") {
                    return
                }
                this.____1265 = false;
                this.____1052 = this.____1052.slice(0, this.____1052.length - 1);
                this.updateView()
            } else if (sender == this.____919) {
                if (this.____1052 != "" && this.____1052 != "0" && this._executor != null && this.____922 != null) {
                    this.____922.call(this._executor, parseInt(this.____1052))
                }
                this.dispose()
            } else {
                var index = this.____1471.indexOf(sender);
                if (index < 0) {
                    return
                }
                if (this.____1265) {
                    this.____1052 = "";
                    this.____1265 = false
                }
                this.____1052 += index.toString();
                this.updateView()
            }
        }
    },
    ____17: function() {},
    setType: function(type) {
        this._type = type;
        if (type == 1) {
            if (this._max == 0) {
                this.____1404.setString("限购数量：");
                this.____1397.setString("无限");
                this._max = 999
            } else {
                this.____1404.setString("限购数量：");
                this.____1397.setString(this._max)
            }
            this.____1024.setString("购买个数：");
            this.____1510.setString("支付");
            this.____892.setString("购 买");
            this.____1418.setFrame(____654.____675.getMoneyPathByType(this.____1422), 1)
        } else if (type == 2) {
            this.____1404.setString("拥有数量：");
            this.____1397.setString(this._max);
            this.____1024.setString("使用个数：");
            this.____919.setFrame("btn/ui_btn1_2.png", 1);
            this.____892.setString("使 用");
            this.____1510.setString("");
            this.____1418.setVisible(false)
        } else if (type == 3 || type == 4) {
            this.____1404.setString("拥有数量：");
            this.____1397.setString(this._max);
            if (type == 3) {
                this.____1024.setString("出售个数：");
                this.____892.setString("出 售")
            } else {
                this.____1024.setString("丢弃个数：");
                this.____892.setString("丢 弃")
            }
            this.____1510.setString("获得");
            this.____1418.setFrame(____654.____675.getMoneyPathByType(this.____1422), 1)
        }
    },
    updateView: function() {
        if (this.____1052 == "") {
            this.____1052 = "0"
        }
        var currentNum = parseInt(this.____1052);
        if (currentNum < 0) {
            currentNum = 0
        }
        if (currentNum > this._max) {
            currentNum = this._max
        }
        this.____1052 = currentNum.toString();
        this._countLabel.setString(this.____1052);
        if (this._type == 1 || this._type == 3 || this._type == 4) {
            this.____1421.setString(____654.____674.getWanCount(currentNum * this._price))
        } else {
            this.____1421.setString("")
        }
    },
    dispose: function() {
        this.____17();
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this.____892 = null;
        this.____1791 = null;
        this._nameLabel = null;
        this._closeBtn = null;
        this.____1024 = null;
        this._countLabel = null;
        this.____1404 = null;
        this.____1397 = null;
        this.____1471 = null;
        this.____1510 = null;
        this.____1418 = null;
        this.____1421 = null;
        this.____919 = null;
        this.____855 = null;
        this._tipsLabel.dispose();
        this._tipsLabel = null;
        this._type = null;
        this._max = null;
        this._price = null;
        this.____1422 = null;
        this.____1052 = null;
        this._executor = null;
        this.____922 = null;
        this.____1265 = null;
        this._perGroupCount = null;
        this._super()
    },
});
var RichLabel = KYNode.extend({
    _content: null,
    infoList: null,
    itemList: null,
    ____1762: null,
    ____993: null,
    ____1815: 100,
    ____1073: 0,
    _align: 0,
    ctor: function(totalWidth, align) {
        this._super();
        if (align != null) {
            this._align = align
        }
        if (totalWidth != null) {
            this.____1815 = totalWidth
        }
        this.____993 = ____655.____659.____688.system
    },
    setTextColor: function(color) {
        this.____993 = color
    },
    setString: function(content) {
        if (this._content != null) {
            print("RichLabel暂不支持重设文本，请删掉重新创建");
            return
        }
        if (content == "") {
            print("RichLabel不支持空文本内容");
            return
        }

        function sortHandler(a, b) {
            return a[0] - b[0]
        }
        this._content = content;
        this.infoList = [];
        this.itemList = [];
        var tempContent = content;
        var index = 0;
        var list = null;
        while (true) {
            list = tempContent.match(____655.____659.commonStaticType.triggerPattern);
            if (list == null) {
                break
            }
            var startIndex = list.index;
            var endIndex = startIndex + list[0].length;
            this.infoList.push([startIndex + index, endIndex + index, 2, list[0]]);
            tempContent = tempContent.slice(endIndex);
            index += endIndex
        }
        tempContent = content;
        index = 0;
        while (true) {
            list = tempContent.match(____655.____659.commonStaticType.colorPattern);
            if (list == null) {
                break
            }
            var startIndex = list.index;
            var endIndex = startIndex + list[0].length;
            this.infoList.push([startIndex + index, endIndex + index, 3, list[0]]);
            tempContent = tempContent.slice(endIndex);
            index += endIndex
        }
        tempContent = content;
        index = 0;
        while (true) {
            list = tempContent.match(____655.____659.commonStaticType.facePattern);
            if (list == null) {
                break
            }
            var startIndex = list.index;
            var endIndex = startIndex + list[0].length;
            this.infoList.push([startIndex + index, endIndex + index, 4, list[0]]);
            tempContent = tempContent.slice(endIndex);
            index += endIndex
        }
        tempContent = content;
        index = 0;
        while (true) {
            list = tempContent.match(____655.____659.commonStaticType.enterPattern);
            if (list == null) {
                break
            }
            var startIndex = list.index;
            var endIndex = startIndex + list[0].length;
            this.infoList.push([startIndex + index, endIndex + index, 5, list[0]]);
            tempContent = tempContent.slice(endIndex);
            index += endIndex
        }
        this.infoList.sort(sortHandler);
        var leftWidth = this.____1815;
        var index = 0;
        var len = this.infoList.length;
        for (var i = 0; i < len; i++) {
            var info = this.infoList[i];
            if (info[0] > index) {
                leftWidth = this.createItem(1, content.slice(index, info[0]), leftWidth);
                index = info[1]
            }
            leftWidth = this.createItem(info[2], info[3], leftWidth);
            index = info[1]
        }
        var strLen = content.length;
        if (index < strLen) {
            leftWidth = this.createItem(1, content.slice(index), leftWidth)
        }
        this.reSize()
    },
    createItem: function(type, content, leftWidth) {
        var leftResult = 0;
        if (type == 5) {
            var item = new ____2139(type, "");
            item.create();
            item.setItemWidth(leftWidth);
            leftResult = 0;
            this.itemList.push(item)
        } else if (type == 4) {
            var faceId = content.slice(1);
            var item = new ____2139(type, faceId);
            item.create();
            if (item.getItemWidth() > leftWidth) {
                leftResult = this.____1815 - item.getItemWidth()
            } else {
                leftResult = leftWidth - item.getItemWidth()
            }
            this.itemList.push(item)
        } else {
            var showContent = "";
            var fontColor = this.____993;
            var triggerInfo = null;
            var isImage = false;
            if (type == 3) {
                fontColor = ____655.____659.____688.stringToColor3b(content.slice(3, 9));
                showContent = content.slice(10, -3)
            } else if (type == 2) {
                triggerInfo = new ____539();
                triggerInfo.initWithString(content.slice(1, -1));
                if (triggerInfo.type == 9) {
                    isImage = true
                } else {
                    showContent = triggerInfo.descript
                }
            } else {
                showContent = content
            }
            if (isImage) {
                var item = new ____2139(type, "", 0, triggerInfo);
                item.setColor(fontColor);
                item.create();
                this.itemList.push(item);
                leftResult = leftWidth - item.getItemWidth();
                if (leftResult < 0) {
                    leftResult = this.____1815 - item.getItemWidth()
                }
                return leftResult
            }
            var showContentLen = showContent.length;
            var startIndex = 0;
            var endIndex = 0;
            var currentWidth = 0;
            var tmpLeftWidth = leftWidth;
            var tmpStr = "";
            for (var i = 0; i < showContentLen; i++) {
                var tmpChar = showContent.charAt(i);
                ____654.testRichText.setString(tmpChar);
                var strWidth = ____654.testRichText.getContentSize().width;
                if (strWidth < 12) {
                    strWidth = 12
                }
                var tmpWidth = currentWidth + strWidth;
                if (tmpWidth <= tmpLeftWidth) {
                    tmpStr += tmpChar;
                    currentWidth = tmpWidth;
                    if (i == showContentLen - 1) {
                        var item = new ____2139(type, tmpStr, currentWidth, triggerInfo);
                        item.setColor(fontColor);
                        item.create();
                        this.itemList.push(item);
                        leftResult = tmpLeftWidth - item.getItemWidth();
                        break
                    }
                } else {
                    var item = new ____2139(type, tmpStr, currentWidth, triggerInfo);
                    item.setColor(fontColor);
                    item.create();
                    this.itemList.push(item);
                    if (i == showContentLen - 1) {
                        var item = new ____2139(type, tmpChar, strWidth, triggerInfo);
                        item.setColor(fontColor);
                        item.create();
                        this.itemList.push(item);
                        leftResult = this.____1815 - item.getItemWidth()
                    } else {
                        tmpStr = tmpChar;
                        tmpLeftWidth = this.____1815 - strWidth;
                        currentWidth = strWidth
                    }
                }
            }
        }
        return leftResult
    },
    setCharInfo: function(chatInfo) {
        var element = "";
        if (chatInfo.playerInfo != null && chatInfo.playerInfo.userId != 0) {
            if (chatInfo.playerInfo.career > 0) {
                var careerIconPath = "icon/ui_careerIcon" + chatInfo.playerInfo.career + ".png";
                element += "{9$901$0$" + careerIconPath + "$0$0$0$0}"
            }
            if (chatInfo.playerInfo.gm == 1) {
                element += "[0xEA6E00]指导员[-]"
            } else if (chatInfo.playerInfo.gm == 2) {
                element += "[0xEA6E00]GM[-]"
            } else if (chatInfo.playerInfo.vipLevel > 0) {
                element += "[0xEA6E00]VIP" + chatInfo.playerInfo.vipLevel + "[-]"
            }
            element += "[0xFFF100]" + chatInfo.playerInfo.nick + "[-]: "
        }
        if (chatInfo.channel == ____655.____659.____693.systemNotice) {
            this.setTextColor(____655.____659.____688.red)
        }
        element += chatInfo.message;
        this.setString(element)
    },
    reSize: function() {
        if (this.itemList == null || this.itemList.length == 0) {
            return
        }
        var currentX = 0;
        var currentY = 0;
        var len = this.itemList.length;
        var lastLabelList = [];
        for (var i = 0; i < len; i++) {
            var item = this.itemList[i];
            this.addChild(item);
            if (currentX + item.getItemWidth() > this.____1815) {
                currentY = currentY - 30;
                item.setPosition(____654.____673.____159(0, currentY));
                currentX = item.getItemWidth();
                this.____1073 = this.____1815;
                lastLabelList = [item]
            } else {
                item.setPosition(____654.____673.____159(currentX, currentY));
                currentX = currentX + item.getItemWidth();
                if (currentX > this.____1073) {
                    this.____1073 = currentX
                }
                lastLabelList.push(item)
            }
        }
        this.____1762 = 0 - currentY + 30;
        if (this._align == 0) {
            return
        }
        if (currentY < 0) {
            var offsetX = 0;
            if (this._align == 1) {
                offsetX = (this.____1815 - currentX) * 0.5
            } else if (this._align == 2) {
                offsetX = this.____1815 - currentX
            }
            for (var j = 0; j < lastLabelList.length; j++) {
                var tempX = lastLabelList[j].getPosition().x + offsetX;
                lastLabelList[j].setPositionX(tempX)
            }
        }
    },
    getTextWidth: function() {
        return this.____1073
    },
    getHeight: function() {
        return this.____1762
    },
    dispose: function() {
        this._content = null;
        if (this.itemList != null) {
            var len = this.itemList.length;
            for (var i = 0; i < len; i++) {
                this.itemList[i].dispose()
            }
            this.itemList = null
        }
        this.____993 = null;
        this.infoList = null;
        this._super()
    },
});
var ____2137 = KYNode.extend({
    _bg: null,
    ____1221: null,
    ____927: null,
    ____1846: null,
    _nameLabel: null,
    ____1523: null,
    ctor: function() {
        this._super()
    },
    setPlayerInfo: function(playerInfo) {
        this.____1523 = playerInfo;
        if (this.____1523 == null || this.____1523.nick == "") {
            this.setSystemInfo();
            return
        }
        var isSelf = (this.____1523.userId == ____655.____667.userId);
        this._bg = ____654.____673.newKYSprite();
        this._bg.setFrame("cell/ui_cell2.png");
        this._bg.setScale(0.85);
        this.addChild(this._bg);
        this.____1221 = ____654.____673.newKYSprite();
        this.____1221.setFrame("sceneIcon/PlayerHeadIcon2_" + this.____1523.career + ".png");
        this.____1221.setScale(0.85);
        this.addChild(this.____1221);
        if (!isSelf) {
            this.____927 = ____654.____673.newKYSprite();
            this.____927.setFrame("icon/ui_careerIcon" + this.____1523.career + ".png");
            this.addChild(this.____927);
            var vipWidth = 0;
            if (this.____1523.vipLevel > 0 || this.____1523.gm > 0) {
                this.____1846 = ____654.____673.newKYLabel(18);
                this.____1846.setAnchorPoint(____654.____673.anchorPoints[4]);
                this.____1846.setColor(____655.____659.____688.orange);
                if (this.____1523.gm == 1) {
                    this.____1846.setString("指导员")
                } else if (this.____1523.gm == 2) {
                    this.____1846.setString("GM")
                } else {
                    this.____1846.setString("VIP" + this.____1523.vipLevel)
                }
                this.____1846.setPosition(____654.____673.____159(90, -13));
                this.addChild(this.____1846);
                vipWidth = this.____1846.getContentSize().width
            }
            this._nameLabel = ____654.____673.newKYLabel(18);
            this._nameLabel.setColor(____655.____659.____688.green);
            this._nameLabel.setString(this.____1523.nick);
            this.addChild(this._nameLabel);
            this._bg.setPosition(____654.____673.____159(37, -37));
            this.____1221.setPosition(____654.____673.____159(35, -27));
            this.____927.setPosition(____654.____673.____159(80, -13));
            this._nameLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
            this._nameLabel.setPosition(____654.____673.____159(90 + vipWidth, -13));
            this._bg.addListener(this, this.headClickHandler)
        } else {
            this._bg.setPosition(____654.____673.____159(-37, -37));
            this.____1221.setPosition(____654.____673.____159(-39, -27))
        }
    },
    setSystemInfo: function() {
        this.____1221 = ____654.____673.newKYSprite();
        this.____1221.setFrame("icon/ui_welfareIcon7.png");
        this.addChild(this.____1221);
        this._nameLabel = ____654.____673.newKYLabel(18);
        this._nameLabel.setColor(____655.____659.____688.green);
        this._nameLabel.setString("系统");
        this.addChild(this._nameLabel);
        this.____1221.setPosition(____654.____673.____159(36, -37));
        this._nameLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this._nameLabel.setPosition(____654.____673.____159(90, -13))
    },
    headClickHandler: function(sender, eventType, pos) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.tipsManager.showPlayerMenuTip(1, this.____1523, pos)
        }
    },
    dispose: function() {
        this._super();
        if (this._bg != null) {
            this._bg.dispose();
            this._bg = null
        }
        if (this.____1221 != null) {
            this.____1221.dispose();
            this.____1221 = null
        }
        if (this.____927 != null) {
            this.____927.dispose();
            this.____927 = null
        }
        if (this.____1846 != null) {
            this.____1846.dispose();
            this.____1846 = null
        }
        if (this._nameLabel != null) {
            this._nameLabel.dispose();
            this._nameLabel = null
        }
        this.____1523 = null
    },
});
var ____2138 = KYNode.extend({
    ____1292: 0,
    _bg: null,
    ____1592: null,
    ____959: null,
    ____1827: null,
    ____1651: null,
    ____1850: null,
    _timeLabel: null,
    _newIcon: null,
    _chatInfo: null,
    _isFail: false,
    ctor: function(itemWidth) {
        this._super();
        this.____1292 = itemWidth;
        this.____959 = new ____2137();
        this.addChild(this.____959)
    },
    setCharInfo: function(chatInfo) {
        this._chatInfo = chatInfo;
        this.____959.setPlayerInfo(chatInfo.playerInfo);
        var isSelf = (chatInfo.playerInfo != null && chatInfo.playerInfo.userId == ____655.____667.userId);
        var message = chatInfo.message;
        if (message.charAt(0) == " ") {
            var strList = message.split("|");
            if (strList[0] == " voice") {
                this.createVoiceView(isSelf, strList, chatInfo.isDownLoad);
                return
            }
        }
        this.createChatView(isSelf, message)
    },
    createVoiceView: function(isSelf, data, isDownLoad) {
        this.____1850 = ____654.____673.newKYSprite();
        this.____1850.setFrame("icon/ui_voiceFlag.png");
        this._timeLabel = ____654.____673.newKYLabel();
        this._timeLabel.setColor(____655.____659.____688.white);
        this._bg = ____654.____673.newKYImageView();
        this._bg.setScale9Enabled(true);
        this._timeLabel.setString(data[2] + "\"");
        var textWidth = parseInt(data[2]) * 10 + 60;
        if (textWidth > this.____1292 - 130) {
            textWidth = this.____1292 - 130
        }
        this._bg.setSize(____654.____673.____160(textWidth + 24, 44));
        this._bg.setTouchEnabled(true);
        this._bg.addListener(this, this.bgClickHandler);
        this.addChild(this._bg);
        this.addChild(this.____1850);
        this.addChild(this._timeLabel);
        if (!isSelf) {
            if (this._chatInfo.playerInfo != null && this._chatInfo.playerInfo.vipLevel >= 5) {
                this._bg.setFrame("board/ui_chatBoard2.png")
            } else {
                this._bg.setFrame("board/ui_voiceBoard1.png")
            }
            this._bg.setAnchorPoint(____654.____673.anchorPoints[1]);
            this._bg.setCapInsets(____654.____673.____161(30, 22, 1, 1));
            this._bg.setPosition(____654.____673.____159(72, -27));
            this.____1850.setPosition(____654.____673.____159(100, -49));
            this._timeLabel.setPosition(____654.____673.____159(textWidth + 73, -49));
            if (!isDownLoad) {
                this._newIcon = ____654.____673.newKYSprite();
                this._newIcon.setFrame("icon/ui_numTipIcon2.png");
                this._newIcon.setScale(0.5);
                this.addChild(this._newIcon);
                this._newIcon.setPosition(____654.____673.____159(textWidth + 105, -35))
            }
        } else {
            if (this._chatInfo.playerInfo != null && this._chatInfo.playerInfo.vipLevel >= 5) {
                this._bg.setFrame("board/ui_chatBoard2.png");
                this._bg.setAnchorPoint(____654.____673.anchorPoints[1]);
                this._bg.setCapInsets(____654.____673.____161(30, 22, 1, 1));
                this._bg.setScaleX(-1)
            } else {
                this._bg.setFrame("board/ui_voiceBoard2.png");
                this._bg.setAnchorPoint(____654.____673.anchorPoints[3]);
                this._bg.setCapInsets(____654.____673.____161(10, 22, 1, 1))
            }
            this._bg.setPosition(____654.____673.____159(this.____1292 - 72, -27));
            this.____959.setPositionX(this.____1292);
            this.____1850.setScaleX(-1);
            this.____1850.setPosition(____654.____673.____159(this.____1292 - 100, -49));
            this._timeLabel.setPosition(____654.____673.____159(this.____1292 - textWidth - 73, -49));
            if (data[1] == "0") {
                this._isFail = true;
                this._newIcon = ____654.____673.newKYSprite("icon/ui_messageError.png", 1);
                this._newIcon.setFrame("icon/ui_messageError.png");
                this.addChild(this._newIcon);
                this._newIcon.setPosition(____654.____673.____159(this.____1292 - textWidth - 112, -49))
            }
        }
    },
    createChatView: function(isSelf, message) {
        this.____1592 = ____654.____673.newRichLabel(this.____1292 - 130);
        this.____1592.setString(message);
        this._bg = ____654.____673.newKYImageView();
        this._bg.setScale9Enabled(true);
        var textWidth = this.____1592.getTextWidth();
        var textHeight = this.____1592.getHeight();
        this._bg.setSize(____654.____673.____160(textWidth + 24, textHeight + 14));
        this.addChild(this._bg);
        this.addChild(this.____1592);
        if (!isSelf) {
            if (this._chatInfo.playerInfo != null && this._chatInfo.playerInfo.vipLevel >= 5) {
                this._bg.setFrame("board/ui_chatBoard2.png")
            } else {
                this._bg.setFrame("board/ui_chatBoard1.png")
            }
            this._bg.setAnchorPoint(____654.____673.anchorPoints[1]);
            this._bg.setCapInsets(____654.____673.____161(30, 38, 1, 1));
            this._bg.setPosition(____654.____673.____159(72, -27));
            this.____1592.setPosition(____654.____673.____159(92, -63))
        } else {
            if (this._chatInfo.playerInfo != null && this._chatInfo.playerInfo.vipLevel >= 5) {
                this._bg.setFrame("board/ui_chatBoard2.png");
                this._bg.setAnchorPoint(____654.____673.anchorPoints[1]);
                this._bg.setCapInsets(____654.____673.____161(30, 22, 1, 1));
                this._bg.setScaleX(-1)
            } else {
                this._bg.setFrame("board/ui_chatBoard.png");
                this._bg.setAnchorPoint(____654.____673.anchorPoints[3]);
                this._bg.setCapInsets(____654.____673.____161(10, 38, 1, 1))
            }
            this._bg.setPosition(____654.____673.____159(this.____1292 - 72, -27));
            this.____959.setPositionX(this.____1292);
            this.____1592.setPosition(____654.____673.____159(this.____1292 - textWidth - 89, -63))
        }
    },
    bgClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._bg) {
                print("dinaji------------", this._isFail);
                if (this._isFail) {
                    ____655.____669.updateVoice(this._chatInfo, this.updateVoiceHandler, this);
                    this._bg.setTouchEnabled(false)
                } else {
                    ____655.____669.playVoice(this._chatInfo);
                    if (this._newIcon != null) {
                        this._newIcon.dispose();
                        this._newIcon = null
                    }
                }
            }
        }
    },
    updateVoiceHandler: function(result) {
        this._bg.setTouchEnabled(true);
        if (result) {
            if (this._newIcon != null) {
                this._newIcon.dispose();
                this._newIcon = null
            }
            this._isFail = false
        }
    },
    getHeight: function() {
        if (this.____1592 != null) {
            return this.____1592.getHeight() + 48
        }
        return 78
    },
    dispose: function() {
        this._super();
        if (this._bg != null) {
            this._bg.dispose();
            this._bg = null
        }
        if (this.____959 != null) {
            this.____959.dispose();
            this.____959 = null
        }
        if (this.____1592 != null) {
            this.____1592.dispose();
            this.____1592 = null
        }
        if (this.____1827 != null) {
            this.____1827.dispose();
            this.____1827 = null
        }
        if (this.____1651 != null) {
            this.____1651.dispose();
            this.____1651 = null
        }
        if (this.____1850 != null) {
            this.____1850.dispose();
            this.____1850 = null
        }
        if (this._timeLabel != null) {
            this._timeLabel.dispose();
            this._timeLabel = null
        }
        if (this._newIcon != null) {
            this._newIcon.dispose();
            this._newIcon = null
        }
        this._chatInfo = null
    },
});
var ____2139 = KYNode.extend({
    _type: 0,
    _content: "",
    ____1765: 0,
    ____1818: null,
    _face: null,
    _label: null,
    ____993: null,
    _image: null,
    ctor: function(type, content, textWidth, triggerInfo) {
        this._super();
        this._type = type;
        this._content = content;
        this.____1765 = textWidth;
        this.____1818 = triggerInfo;
        if (type == 4) {
            this.____1765 = 30
        }
    },
    setColor: function(color) {
        if (this.____993 == null) {
            this.____993 = color
        }
    },
    create: function(fontSize) {
        if (this._type == 5) {} else if (this._type == 4) {
            var num = parseInt(this._content);
            if (num < 35 && num >= 0) {
                this._face = new ____2087(1.2);
                this._face.setFaceData(____655.faceInfo.faceList[num]);
                this._face.setPosition(____654.____673.____159(0, 0));
                this.addChild(this._face)
            }
        } else if (this._type == 2 && this.____1818.type == 9) {
            this._image = ____654.____673.newKYSprite();
            this._image.setFrame(this.____1818.descript);
            this._image.setAnchorPoint(____654.____673.anchorPoints[6]);
            this.addChild(this._image);
            this.____1765 = this._image.getContentSize().width
        } else {
            if (this._content != null) {
                this._label = ____654.____673.newKYLabel();
                this._label.setAnchorPoint(____654.____673.anchorPoints[6]);
                if (fontSize != null) {
                    this._label.setFontSize(fontSize)
                }
                this._label.setColor(this.____993);
                this._label.setString(this._content);
                this.addChild(this._label)
            }
        }
    },
    getItemWidth: function() {
        return this.____1765
    },
    setItemWidth: function(value) {
        this.____1765 = value
    },
    dispose: function() {
        if (this._label != null) {
            this._label.dispose();
            this._label = null
        }
        if (this._image != null) {
            this._image.dispose();
            this._image = null
        }
        this.____1818 = null;
        if (this._face != null) {
            this._face.dispose();
            this._face = null
        }
        this.____993 = null;
        this._super()
    },
});
var StarView = KYNode.extend({
    ____1840: null,
    ____1255: 0,
    _totalCount: 0,
    _currentCount: 0,
    ctor: function(intervalX) {
        this._super();
        if (intervalX == null) {
            this.____1255 = 40
        } else {
            this.____1255 = intervalX
        }
        this.____1840 = []
    },
    ____363: function(totalCount, currentCount, colorIndex) {
        this.setCount(totalCount);
        this.setCurrentCount(currentCount);
        this.setColor(colorIndex)
    },
    setCount: function(count) {
        if (this._totalCount == count) return;
        this._totalCount = count;
        var len = Math.max(this.____1840.length, count);
        for (var i = 0; i < len; i++) {
            if (i < count) {
                if (this.____1840[i] == null) {
                    var view = ____654.____673.newKYSprite();
                    view.setFrame("icon/ui_startIcon0.png");
                    this.addChild(view);
                    this.____1840.push(view)
                } else {
                    this.____1840[i].setVisible(true)
                }
                this.____1840[i].setPositionX((1 - count) * 0.5 * this.____1255 + this.____1255 * i)
            } else {
                if (this.____1840[i] != null) {
                    this.____1840[i].setVisible(false)
                }
            }
        }
    },
    setCurrentCount: function(count) {
        this._currentCount = Math.min(this._totalCount, count)
    },
    setColor: function(colorIndex) {
        for (var i = 0; i < this._totalCount; i++) {
            if (i < this._currentCount) {
                this.____1840[i].setFrame("icon/ui_startIcon" + Math.min(colorIndex, 6) + ".png")
            } else {
                this.____1840[i].setFrame("icon/ui_startIcon0.png")
            }
        }
    },
    dispose: function() {
        this._super();
        for (var i = 0; i < this.____1840.length; i++) {
            this.____1840[i].dispose()
        }
        this.____1840 = null;
        this.____1255 = null;
        this._totalCount = null;
        this._currentCount = null
    },
});
var TabButton = KYNode.extend({
    ____1241: -1,
    ____1630: false,
    _type: 0,
    ____1236: null,
    _bg: null,
    _titleLabel: null,
    ____864: null,
    _levelLabel: null,
    ____1166: null,
    ____1533: null,
    _path: null,
    _iconType: false,
    ctor: function(type, index) {
        if (index == null) {
            print("+++++切卡索引值不能为空+++++")
        }
        this._type = type;
        if (this._type == 1) {
            this._super("tabBtn.ExportJson");
            this.____1236 = this.getChildByName("iconImage");
            this._bg = this.getChildByName(" bg");
            this._titleLabel = this.getChildByName("titleLabel");
            this.____864 = this.getChildByName("barTip");
            this._levelLabel = this.____864.getChildByName("levelLabel");
            this.____864.setVisible(false)
        }
        this.____1241 = index
    },
    setTitle: function(title, color) {
        if (this._titleLabel != null && title != null) {
            this._titleLabel.setString(title)
        }
        if (color != null) {
            this._titleLabel.setColor(color)
        }
    },
    ____64: function(level) {
        this.____864.setVisible(true);
        this._levelLabel.setString(____654.yuyanbaoManager.getYuyanbao("common.tabGroupTips1", level.toString()))
    },
    setIconPath: function(path, type) {
        if (type != null) {
            this._iconType = type
        }
        if (this._iconType) {
            if (this._path != null) {
                ____654.____677.removeImageQuote(this.____1236, this._path);
                this._path = null
            }
            if (this.____1236 != null && path != null) {
                ____654.____677.____146(this.____1236, path);
                this._path = path
            }
        } else {
            if (this.____1236 != null && path != null) {
                this.____1236.setFrame(path)
            }
        }
    },
    setSelected: function(value) {
        if (value == this.____1630) {
            return
        }
        this.____1630 = value;
        if (this.____1630) {
            if (this._type == 1) {
                this._bg.setFrame("board/ui_board8.png")
            }
            this.setTouchEnabled(false)
        } else {
            if (this._type == 1) {
                this._bg.setFrame("board/ui_board7.png")
            }
            this.setTouchEnabled(true)
        }
    },
    setFlagImg: function(flagPath, type) {
        if (flagPath != null) {
            if (this.____1166 == null) {
                this.____1166 = ____654.____673.newKYSprite();
                this.addChild(this.____1166, 8)
            }
            if (type == null || type == 1) {
                this.____1166.setPosition(____654.____673.____159(15, 58));
                this.____1166.setRotation(-30)
            } else if (type == 2) {
                this.____1166.setPosition(____654.____673.____159(15, 48))
            }
            this.____1166.setFrame(flagPath)
        } else {
            if (this.____1166 != null) {
                this.____1166.dispose();
                this.____1166 = null
            }
        }
    },
    getIndex: function() {
        return this.____1241
    },
    setShowPop: function(isShow) {
        if (isShow && this.____1533 == null) {
            this.____1533 = ____654.____673.newKYSprite();
            this.____1533.setFrame("icon/ui_numTipIcon.png");
            this.addChild(this.____1533, 9);
            if (this._type == 1) {
                this.____1533.setPosition(____654.____673.____159(173, 58))
            }
        } else if (!isShow && this.____1533 != null) {
            this.____1533.dispose();
            this.____1533 = null
        }
    },
    dispose: function() {
        this._bg = null;
        this._titleLabel = null;
        this.____864 = null;
        this._levelLabel = null;
        if (this.____1533 != null) {
            this.____1533.dispose();
            this.____1533 = null
        }
        if (this.____1166 != null) {
            this.____1166.dispose();
            this.____1166 = null
        }
        if (this._path != null) {
            ____654.____677.removeImageQuote(this.____1236, this._path)
        }
        this.____1236 = null;
        this._super()
    },
});
var TabGroup = KYNode.extend({
    _type: 0,
    ____1251: null,
    ____1741: null,
    _currentIndex: -1,
    _callBack: null,
    _executor: null,
    ctor: function(type, infoList, callBack, executor) {
        this._super();
        this._type = type;
        this.____1251 = infoList;
        this._callBack = callBack;
        this._executor = executor;
        this.refreshView()
    },
    refreshView: function() {
        this.clearBtns();
        this.____1741 = [];
        var len = this.____1251.length;
        if (len == 0) {
            return
        }
        var i = 0;
        var tabBtn = null;
        var index = 1;
        if (this._type == 1) {
            for (i = 0; i < len; i++) {
                var level = this.____1251[i][4];
                if (level == null) {
                    level = 0
                }
                tabBtn = new TabButton(1, this.____1251[i][0]);
                this.____1741.push(tabBtn);
                if (this.____1251[i][3] == true) {
                    tabBtn.setIconPath(this.____1251[i][2], this.____1251[i][5]);
                    tabBtn.setTitle(this.____1251[i][1]);
                    tabBtn.setPositionY(-index * 75);
                    this.addChild(tabBtn);
                    if (level > ____655.____667.level) {
                        tabBtn.____64(level)
                    } else {
                        tabBtn.addListener(this, this.tabClickHandler)
                    }
                    index++
                }
            }
        }
    },
    clearBtns: function() {
        if (this.____1741 != null) {
            for (var i = 0; i < this.____1741.length; i++) {
                this.____1741[i].dispose()
            }
            this.____1741 = null
        }
    },
    tabClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var index = this.____1741.indexOf(sender);
            if (index > -1) {
                this.setTabIndex(index)
            }
        }
    },
    setTabIndex: function(index) {
        if (this.____1741 == null) {
            return
        }
        if (this._currentIndex != -1 && this.____1741[this._currentIndex] != null) {
            this.____1741[this._currentIndex].setSelected(false)
        }
        this._currentIndex = index;
        this.____1741[this._currentIndex].setSelected(true);
        if (this._executor != null && this._callBack != null) {
            this._callBack.call(this._executor, this.____1741[this._currentIndex].getIndex())
        }
    },
    getCurrentIndex: function() {
        return this._currentIndex
    },
    getCurrentTab: function() {
        return this.____1741[this._currentIndex].getIndex()
    },
    setShowPop: function(index, value) {
        for (var i = 0; i < this.____1741.length; i++) {
            if (this.____1741[i].getIndex() == index) {
                this.____1741[i].setShowPop(value);
                return
            }
        }
    },
    setBtnFlagImg: function(tab, path, type) {
        for (var i = 0; i < this.____1741.length; i++) {
            if (this.____1741[i] != null && this.____1741[i].getIndex() == tab) {
                this.____1741[i].setFlagImg(path, type)
            }
        }
    },
    dispose: function() {
        this.clearBtns();
        this.____1251 = null;
        this._callBack = null;
        this._executor = null;
        this._super()
    },
});
var ____2142 = cc.Class.extend({
    _type: 0,
    ____1251: null,
    ____1741: null,
    _currentIndex: -1,
    _callBack: null,
    _container: null,
    _executor: null,
    ctor: function(type, infoList, callBack, container, executor) {
        this._type = type;
        this.____1251 = infoList;
        this._callBack = callBack;
        this._container = container;
        this._executor = executor;
        this.refreshView()
    },
    refreshView: function() {
        this.clearBtns();
        this.____1741 = [];
        var len = this.____1251.length;
        if (len == 0) {
            return
        }
        var i = 0;
        var tabBtn = null;
        var index = 1;
        if (this._type == 1) {
            for (i = 0; i < len; i++) {
                if (this.____1251[i][3] == false) {
                    continue
                }
                var level = this.____1251[i][4];
                if (level == null) {
                    level = 0
                }
                tabBtn = new TabButton(1, this.____1251[i][0]);
                tabBtn.setIconPath(this.____1251[i][2]);
                this.____1741.push(tabBtn);
                if (level > ____655.____667.level) {
                    tabBtn.____64(level)
                } else {
                    tabBtn.addListener(this, this.tabClickHandler, null, null, null, false, true)
                }
                tabBtn.setTitle(this.____1251[i][1]);
                index++;
                this._container.pushBackCustomItem(tabBtn)
            }
        }
    },
    clearBtns: function() {
        if (this._container != null) {
            this._container.removeAllItems()
        }
        if (this.____1741 != null) {
            for (var i = 0; i < this.____1741.length; i++) {
                this.____1741[i].dispose()
            }
            this.____1741 = null
        }
    },
    tabClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var index = this.____1741.indexOf(sender);
            if (index > -1) {
                this.setTabIndex(index)
            }
        }
    },
    setTabIndex: function(index) {
        if (this.____1741 == null) {
            return
        }
        if (this._currentIndex != -1 && this.____1741[this._currentIndex] != null) {
            this.____1741[this._currentIndex].setSelected(false)
        }
        this._currentIndex = index;
        this.____1741[this._currentIndex].setSelected(true);
        if (this._executor != null && this._callBack != null) {
            this._callBack.call(this._executor, this.____1741[this._currentIndex].getIndex())
        }
    },
    getCurrentIndex: function() {
        return this._currentIndex
    },
    getCurrentTab: function() {
        return this.____1741[this._currentIndex].getIndex()
    },
    setBtnFlagImg: function(tab, path) {
        for (var i = 0; i < this.____1741.length; i++) {
            if (this.____1741[i] != null && this.____1741[i].getIndex() == tab) {
                this.____1741[i].setFlagImg(path)
            }
        }
    },
    dispose: function() {
        this.clearBtns();
        this.____1251 = null;
        this._callBack = null;
        this._container = null;
        this._executor = null
    },
});
var ____2143 = KYImageView.extend({
    _label: null,
    ____1304: null,
    ____1630: null,
    ____1533: null,
    ____1166: null,
    _flagLabel: null,
    _countDownUtils: null,
    _type: 1,
    ctor: function(type) {
        this._super();
        if (type != null) {
            this._type = type
        }
        if (this._type == 1) {
            this._label = ____654.____673.newKYLabel(24, true, ____654.____673.____160(26, 64));
            this._label.setPosition(____654.____673.____159(31, 63));
            this.addChild(this._label, 1);
            this.setAnchorPoint(____654.____673.anchorPoints[0])
        } else if (this._type == 2) {
            this._label = ____654.____673.newKYLabel(24);
            this._label.setPosition(____654.____673.____159(60, 27));
            this.setScale9Enabled(true);
            this.setCapInsets(____654.____673.____161(20, 27, 1, 1));
            this.setSize(____654.____673.____160(120, 55));
            this.addChild(this._label);
            this.setAnchorPoint(____654.____673.anchorPoints[6])
        } else if (this._type == 3) {
            this._label = ____654.____673.newKYLabel(24, true, ____654.____673.____160(26, 64));
            this._label.setPosition(____654.____673.____159(34, 47));
            this.addChild(this._label, 1);
            this.setAnchorPoint(____654.____673.anchorPoints[6])
        } else if (this._type == 4) {
            this._label = ____654.____673.newKYLabel(30);
            this._label.setAnchorPoint(____654.____673.anchorPoints[4]);
            this._label.setPosition(____654.____673.____159(30, 53));
            this.____1304 = ____654.____673.newKYLabel(30);
            this.____1304.setAnchorPoint(____654.____673.anchorPoints[4]);
            this.____1304.setPosition(____654.____673.____159(200, 53));
            this.setScale9Enabled(true);
            this.setCapInsets(____654.____673.____161(20, 27, 1, 1));
            this.setSize(____654.____673.____160(273, 98));
            this.addChild(this._label);
            this.addChild(this.____1304);
            this.setAnchorPoint(____654.____673.anchorPoints[4])
        } else if (this._type == 5) {
            this._label = ____654.____673.newKYLabel(26);
            this._label.setPosition(____654.____673.____159(90, 38));
            this.setScale9Enabled(true);
            this.setCapInsets(____654.____673.____161(20, 27, 1, 1));
            this.setSize(____654.____673.____160(185, 70));
            this.addChild(this._label);
            this.setAnchorPoint(____654.____673.anchorPoints[6])
        }
        this.setSelected(false)
    },
    setSelected: function(value) {
        if (value == this.____1630) {
            return
        }
        this.____1630 = value;
        if (value) {
            if (this._type == 1) {
                this.setFrame("btn/ui_tabBtn1_2.png")
            } else if (this._type == 2 || this._type == 4 || this._type == 5) {
                this.setFrame("btn/ui_btn1_2.png")
            } else if (this._type == 3) {
                this.setFrame("btn/ui_tabBtn2_2.png")
            }
        } else {
            if (this._type == 1) {
                this.setFrame("btn/ui_tabBtn1_1.png")
            } else if (this._type == 2 || this._type == 4 || this._type == 5) {
                this.setFrame("btn/ui_btn1_1.png")
            } else if (this._type == 3) {
                this.setFrame("btn/ui_tabBtn2_1.png")
            }
        }
    },
    getSelected: function() {
        return this.____1630
    },
    setLabel: function(str) {
        if (this._label != null) {
            this._label.setString(str)
        }
    },
    setLabel2: function(str) {
        if (this.____1304 != null) {
            this.____1304.setString(str)
        }
    },
    setLabelOffsetX: function(x) {
        if (this._label != null) {
            this._label.setPositionX(x)
        }
    },
    setLabel2OffsetX: function(x) {
        if (this.____1304 != null) {
            this.____1304.setPositionX(x)
        }
    },
    setLabelColor: function(color) {
        if (this._label != null) {
            this._label.setColor(color)
        }
    },
    setShowPop: function(isShow) {
        if (isShow && this.____1533 == null) {
            this.____1533 = ____654.____673.newKYSprite();
            this.____1533.setFrame("icon/ui_numTipIcon.png");
            this.addChild(this.____1533, 9);
            if (this._type == 1) {
                this.____1533.setPosition(____654.____673.____159(48, 102))
            } else if (this._type == 5) {
                this.____1533.setPosition(____654.____673.____159(174, 49))
            }
        } else if (!isShow && this.____1533 != null) {
            this.____1533.dispose();
            this.____1533 = null
        }
    },
    setFlagImg: function() {
        if (this.____1166 == null) {
            this.____1166 = ____654.____673.newKYSprite();
            this.____1166.setPosition(____654.____673.____159(18, 62));
            this.addChild(this.____1166, 8)
        }
        this.____1166.setFrame("bar/ui_tabBtnBar.png");
        if (this._flagLabel == null) {
            this._flagLabel = ____654.____673.newKYLabel(14);
            this._flagLabel.setPosition(____654.____673.____159(28, 62));
            this.addChild(this._flagLabel, 9)
        }
        var remainTime = ____655.____662.secondsOfDay - ____655.____662.getZeroPassTime();
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._flagLabel, 0, 0);
        this._countDownUtils.start(remainTime)
    },
    setOpenDayFlag: function(days) {
        if (this.____1166 == null) {
            this.____1166 = ____654.____673.newKYSprite();
            this.____1166.setPosition(____654.____673.____159(18, 62));
            this.addChild(this.____1166, 8)
        }
        this.____1166.setFrame("bar/ui_tabBtnBar.png");
        if (this._flagLabel == null) {
            this._flagLabel = ____654.____673.newKYLabel(16);
            this._flagLabel.setPosition(____654.____673.____159(28, 62));
            this.addChild(this._flagLabel, 9)
        }
        this._flagLabel.setString("第" + days + "天")
    },
    dispose: function() {
        if (this._label != null) {
            this._label.dispose();
            this._label = null
        }
        if (this.____1304 != null) {
            this.____1304.dispose();
            this.____1304 = null
        }
        if (this.____1533 != null) {
            this.____1533.dispose();
            this.____1533 = null
        }
        if (this.____1166 != null) {
            this.____1166.dispose();
            this.____1166 = null
        }
        if (this._flagLabel != null) {
            this._flagLabel.dispose();
            this._flagLabel = null
        }
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    },
});
var ____2145 = KYNode.extend({
    ____1053: -1,
    ____1498: 0,
    ____1840: null,
    ____1255: 0,
    ctor: function(pageCount, intervalX) {
        this._super();
        if (intervalX == null) {
            this.____1255 = 40
        } else {
            this.____1255 = intervalX
        }
        if (pageCount != null) {
            this.resetCount(pageCount)
        }
    },
    resetCount: function(count, currentPage) {
        if (this.____1498 == count) {
            return
        }
        this.clearView();
        this.____1498 = count;
        this.____1840 = [];
        for (var i = 0; i < count; i++) {
            var view = ____654.____673.newKYSprite();
            view.setFrame("btn/ui_checkBox2_1.png");
            view.setPositionX((1 - count) * 0.5 * this.____1255 + this.____1255 * i);
            this.addChild(view);
            this.____1840.push(view)
        }
        if (currentPage == null) {
            currentPage = this.____1053
        }
        this.____1053 = -1;
        this.setPage(currentPage);
        if (count == 1) {
            this.____1840[0].setVisible(false)
        } else if (this.____1840[0] != null) {
            this.____1840[0].setVisible(true)
        }
    },
    clearView: function() {
        if (this.____1840 != null) {
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = null
        }
    },
    setPage: function(page) {
        if (page >= this.____1498) {
            page = this.____1498 - 1
        }
        if (page == this.____1053) {
            return
        }
        if (this.____1053 > -1) {
            if (this.____1840[this.____1053] != null) {
                this.____1840[this.____1053].setFrame("btn/ui_checkBox2_1.png")
            }
        }
        this.____1053 = page;
        if (this.____1053 > -1) {
            if (this.____1840[this.____1053] != null) {
                this.____1840[this.____1053].setFrame("btn/ui_checkBox2_2.png")
            }
        }
    },
    getCurrentPage: function() {
        return this.____1053
    },
    dispose: function() {
        this.clearView();
        this._super()
    },
});
var ____2147 = cc.Class.extend({
    _container: null,
    _titleId: null,
    _template: null,
    ____1239: null,
    ____1126: null,
    ____1690: "",
    ____1539: -1,
    ____1540: -1,
    ctor: function(id, container) {
        this._container = container;
        this.setTitileId(id)
    },
    setTitileId: function(id) {
        if (this._titleId == id) {
            return
        }
        this._titleId = id;
        this._template = ____655.allTemplates.titleTemplateList.getTitle(id);
        if (this._template.resouceType == 1) {
            if (this.____1126 != null) {
                this.____1126.dispose();
                this.____1126 = null
            }
            if (this.____1239 == null) {
                this.____1239 = ____654.____673.newKYSprite();
                this._container.addChild(this.____1239)
            } else {
                if (this.____1690 != "") {
                    ____654.____677.removeImageQuote(this.____1690, this.____1239)
                }
            }
            this.____1690 = ____654.____675.getTilteImgPath(this._template.picPath);
            ____654.____677.____146(this.____1239, this.____1690)
        } else if (this._template.resouceType == 2) {
            if (this.____1239 != null) {
                if (this.____1690 != "") {
                    ____654.____677.removeImageQuote(this.____1690, this.____1239);
                    this.____1690 = ""
                }
                this.____1239.dispose();
                this.____1239 = null
            }
            this.____1126 = ____654.effectManager.create(parseInt(this._template.picPath), false, null, false);
            this.____1126.play();
            this.____1126.addTo(this)
        }
    },
    ____344: function() {
        if (this.____1239 != null && this.____1239.getParent() != null) {
            this.____1239.setPosition(this.____1539, this.____1540)
        }
    },
    move: function(x, y) {
        this.____1539 = x;
        this.____1540 = y;
        this.____344()
    },
    show: function() {
        if (this.____1239 != null && this.____1239.getParent() == null) {
            this._container.addChild(this.____1239)
        }
        this.____344()
    },
    hide: function() {
        if (this.____1239 != null) {
            this.____1239.removeFromParent(false)
        }
    },
    setOpacity: function(value) {
        if (this.____1239 != null) {
            this.____1239.setOpacity(value)
        }
    },
    dispose: function() {
        this._container = null;
        if (this.____1239 != null && this.____1690 != "") {
            ____654.____677.removeImageQuote(this.____1690, this.____1239);
            this.____1239.dispose();
            this.____1239 = null;
            this.____1690 = ""
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
    },
});
var ____2124 = cc.Layer.extend({
    ____857: null,
    ____1739: null,
    ____1067: null,
    _currentGroup: null,
    _container: null,
    _closeBtn: null,
    _titleLabel: null,
    ctor: function() {
        this._super();
        this.setPosition(____654.____673.____159(____655.____656 * 0.5 - 480, ____655.____657 * 0.5 - 320));
        this.____857 = ____654.____673.newKYImageView();
        this.____857.setFrame("board/ui_blackBoard.png");
        this.____857.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____857.setScale9Enabled(true);
        this.____857.setCapInsets(____654.____673.____161(4, 4, 1, 1));
        this.____857.setOpacity(200);
        this.____857.setSize(____654.____673.____160(____655.____656, ____655.____657));
        this.____857.setPosition(____654.____673.____159(480 - ____655.____656 * 0.5, 320 - ____655.____657 * 0.5));
        this.addChild(this.____857);
        this.____1739 = [];
        this._container = null;
        this._container = new KYNode("uiPanelContainer.ExportJson");
        this.addChild(this._container);
        this._closeBtn = this._container.getChildByName("closeBtn");
        this._titleLabel = ____654.____673.newKYLabel(30, true);
        this._titleLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this._titleLabel.setPosition(____654.____673.____159(40, 600));
        this._container.addChild(this._titleLabel);
        this.____6()
    },
    ____6: function() {
        this.____857.addListener(this, this.bgClickHandler);
        this._closeBtn.addListener(this, this.clickHandler);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.addEventListener(____655.____661.look_InfoReturn, this.showLookPanel, this)
    },
    bgClickHandler: function() {},
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._closeBtn) {
                if (this._currentGroup == ____655.____659.panelTabType.lookTab && ____655.lookInfo.panelType > 0) {
                    ____655.lookInfo.openLastPanel()
                } else {
                    this.close()
                }
            }
        }
    },
    initTabs: function(tabGroup, tab, data) {
        if (this._currentGroup == tabGroup) {
            if (this.____1067 == null || tab != this.____1067.tab) {
                for (var j = 0; j < this.____1739.length; j++) {
                    if (tab == this.____1739[j].tab) {
                        this.____239(this.____1739[j], data);
                        break
                    }
                }
            }
            return
        }
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_hideChatPanel, ____654.____672));
        this.clear();
        this._currentGroup = tabGroup;
        var len = tabGroup.length;
        if (len == 0) {
            return
        }
        var selelctIndex = 0;
        this.____1739 = [];
        var count = 0;
        var info;
        if (len > 1) {
            for (var i = 0; i < len; i++) {
                info = {};
                info.tab = tabGroup[i];
                info.btn = new ____2143();
                info.btn.setLabel(____655.____659.panelTabType.getTabTitle(tabGroup[i]));
                info.btn.addListener(this, this.tabClickHandler);
                if (____655.____659.panelTabType.isCanShow(tabGroup[i])) {
                    info.btn.setPosition(____654.____673.____159(939, 496 - 102 * count));
                    this._container.addChild(info.btn, 90 + count);
                    count++
                }
                this.____1739.push(info);
                if (tab == tabGroup[i]) {
                    selelctIndex = i
                }
            }
        } else {
            info = {};
            info.tab = tabGroup[0];
            this.____1739.push(info)
        }
        if (this.getParent() == null) {
            this.hideBack();
            ____654.____676.fixPanelContainer.addChild(this, 99)
        }
        this.____239(this.____1739[selelctIndex], data);
        this.popUpdate()
    },
    showBack: function() {
        ____654.____676.showBack()
    },
    hideBack: function() {
        ____654.____676.hideBack()
    },
    tabClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var len = this.____1739.length;
            for (var i = 0; i < len; i++) {
                if (this.____1739[i].btn == sender) {
                    this.____239(this.____1739[i]);
                    return
                }
            }
        }
    },
    ____225: function(index) {
        this.____239(this.____1739[index])
    },
    ____239: function(info, data) {
        if (this.____1067 == info) {
            return
        }
        if (this.____1067 != null) {
            this.____1067.btn.setSelected(false);
            if (this.____1067.panel != null) {
                this.____1067.panel.removeFromParent(false)
            }
        }
        this.____1067 = info;
        this._titleLabel.setString(____655.____659.panelTabType.getTabTitle(this.____1067.tab));
        if (this.____1067 != null) {
            if (this.____1067.btn != null) {
                this.____1067.btn.setSelected(true)
            }
            if (this.____1067.panel != null) {
                if (this.____1067.panel.getParent() == null) {
                    this.addChild(this.____1067.panel)
                }
            } else {
                ____655.____659.panelTabType.handleByTab(this.____1067.tab, data)
            }
        }
    },
    ____125: function(panel, tabType) {
        if (this.____1067 == null || this.____1067.tab != tabType) {
            print("+++++检测到非常规打开，开始自动创建新切卡+++++");
            var list = ____655.____659.panelTabType.allTabs;
            for (var i = 0; i < list.length; i++) {
                if (list[i].indexOf(tabType) >= 0) {
                    this.initTabs(list[i], tabType);
                    return
                }
            }
        }
        this.____1067.panel = panel;
        if (panel.getParent() == null) {
            this.addChild(panel)
        }
    },
    getCurrentPanel: function() {
        if (this.____1067 == null) {
            return null
        }
        return this.____1067.panel
    },
    popUpdate: function(evt) {
        if (this._currentGroup == null) {
            return
        }
        var type = 0;
        var index = -1;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 15) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.fashion);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.fasionNum > 0)
            }
        }
        if (type == 0 || type == 16) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.weaponGod);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.weaponGodNum > 0)
            }
        }
        if (type == 0 || type == 17) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.weaponStrength);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.weaponStrengthNum > 0)
            }
        }
        if (type == 0 || type == 18) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.weaponStone);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.weaponBaoshiNum > 0)
            }
        }
        if (type == 0 || type == 19) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.weaponSoul);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.wuhunNum > 0)
            }
        }
        if (type == 0 || type == 20) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.weaponPot);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.rongluNum > 0)
            }
        }
        if (type == 0 || type == 25 || type == 26 || type == 27 || type == 28 || type == 29 || type == 30) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.tuJian);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop((____654.playerInfoTester.tujianSJNum + ____654.playerInfoTester.tujianMWNum + ____654.playerInfoTester.tujianSXNum + ____654.playerInfoTester.tujianSBNum + ____654.playerInfoTester.tujianBWNum + ____654.playerInfoTester.tujianAwardNum) > 0)
            }
        }
        if (type == 0 || type == 31) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.huanZhuang);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.huanZhuangAwardNum > 0)
            }
        }
        if (type == 0 || type == 32) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.bag);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.bagItemNum + ____654.playerInfoTester.bagEquipNum > 0)
            }
        }
        if (type == 0 || type == 34 || type == 35 || type == 36 || type == 37 || type == 38 || type == 39 || type == 40) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.advance);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop((____654.playerInfoTester.riderNum + ____654.playerInfoTester.petNum + ____654.playerInfoTester.wingNum + ____654.playerInfoTester.footNum + ____654.playerInfoTester.fabaoNum + ____654.playerInfoTester.zhenlingNum + ____654.playerInfoTester.shenjianNum) > 0)
            }
        }
        if (type == 0 || type == 41) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.huaXing_rider);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.fashionRiderNum > 0)
            }
        }
        if (type == 0 || type == 42) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.huaXing_pet);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.fashingPetNum > 0)
            }
        }
        if (type == 0 || type == 43) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.huaXing_wing);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.fashingWingNum > 0)
            }
        }
        if (type == 0 || type == 44) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.boss_person);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.personBossNum > 0)
            }
        }
        if (type == 0 || type == 45) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.boss_shenJiang);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.shenjiangNum > 0)
            }
        }
        if (type == 0 || type == 47) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.ll);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.lilianNum > 0)
            }
        }
        if (type == 0 || type == 55 || type == 56 || type == 57 || type == 58 || type == 59 || type == 60 || type == 61) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.waiGuan_soul);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop((____654.playerInfoTester.hunpoRiderNum + ____654.playerInfoTester.hunpoWindNum + ____654.playerInfoTester.hunpoFaBaoNum + ____654.playerInfoTester.hunpoZhenLingNum + ____654.playerInfoTester.hunpoShenJianNum + ____654.playerInfoTester.hunpoFootNum + ____654.playerInfoTester.hunpoPetNum) > 0)
            }
        }
        if (type == 0 || type == 63) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.sheJiao_xianYuan);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.marryNum > 0)
            }
        }
        if (type == 0 || type == 64) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.sheJiao_jieYi);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.oathNum > 0)
            }
        }
        if (type == 0 || type == 67) {
            index = this._currentGroup.indexOf(____655.____659.panelTabType.tuJianYaoJing);
            if (index >= 0) {
                this.____1739[index].btn.setShowPop(____654.playerInfoTester.tujianYaoJingNum > 0)
            }
        }
    },
    showLookPanel: function(evt) {
        if (____655.lookInfo.initDataFinish1 && ____655.lookInfo.initDataFinish2 && ____655.lookInfo.initDataFinish3) {
            if (____655.lookInfo.lookType == 1) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.lookTab, ____655.____659.panelTabType.lookCompare)
            } else {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.lookTab)
            }
            ____655.lookInfo.lookType = 0
        }
    },
    clear: function() {
        if (this.____1739 != null) {
            var len = this.____1739.length;
            for (var i = 0; i < len; i++) {
                if (this.____1739[i].btn != null) {
                    this.____1739[i].btn.dispose()
                }
                if (this.____1739[i].panel != null && this.____1739[i].panel.dispose != null) {
                    this.____1739[i].panel.dispose()
                }
            }
        }
        this.____1739 = null;
        this.____1067 = null;
        this._currentGroup = null
    },
    close: function() {
        this.clear();
        if (this.getParent() != null) {
            this.removeFromParent(false)
        }
        this.showBack()
    },
});
var ____2148 = cc.Class.extend({
    bossModule: null,
    ctor: function(module) {
        this.bossModule = module;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showWorldBossPanel: function(type) {
        if (this.bossModule.worldBossPanel == null) {
            this.bossModule.worldBossPanel = new ____2156(this)
        }
        ____654.____676.uiPanelContainer.____125(this.bossModule.worldBossPanel, type)
    },
    showWorldBossAwardPanel: function(monsterId) {
        if (this.bossModule.worldBossAwardPanel == null) {
            this.bossModule.worldBossAwardPanel = new ____2154(this, monsterId)
        }
        ____654.____676.____125(this.bossModule.worldBossAwardPanel)
    },
    showPersonBossPanel: function(type) {
        if (this.bossModule.personalPanel == null) {
            this.bossModule.personalPanel = new PersonBossPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.bossModule.personalPanel, type)
    },
    showGodBossPanel: function(type) {
        if (this.bossModule.shenJiangPanel == null) {
            this.bossModule.shenJiangPanel = new ShenJiangBossPanel1(this)
        }
        ____654.____676.uiPanelContainer.____125(this.bossModule.shenJiangPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.bossModule.worldBossPanel) {
            this.bossModule.worldBossPanel = null
        } else if (p == this.bossModule.worldBossAwardPanel) {
            this.bossModule.worldBossAwardPanel = null
        } else if (p == this.bossModule.shenJiangPanel) {
            this.bossModule.shenJiangPanel = null
        } else if (p == this.bossModule.personalPanel) {
            this.bossModule.personalPanel = null
        }
    },
});
var ____2149 = ____537.extend({
    bossController: null,
    worldBossPanel: null,
    personalPanel: null,
    shenJiangPanel: null,
    kuaFuPanel: null,
    worldBossAwardPanel: null,
    setup: function(data) {
        this.bossController = new ____2148(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.boss_world) {
            this.bossController.showWorldBossPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.boss_person) {
            this.bossController.showPersonBossPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.boss_shenJiang) {
            this.bossController.showGodBossPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.boss_kuaFu) {}
    },
    clear: function() {},
});
var ____2150 = KYPanel.extend({});
var ____2151 = KYNode.extend({
    _controller: null,
    ____1241: 0,
    ____1008: 0,
    _remainNum: 0,
    ____935: null,
    _gridList: null,
    _timeLabel: null,
    ____999: null,
    ____1102: null,
    ____1103: null,
    ____1176: null,
    ____1177: null,
    ____1508: null,
    ____1509: null,
    ____944: null,
    _characterInfo: null,
    _countDownUtils: null,
    _itemIndex: -1,
    lastRevertTime: 0,
    price: 0,
    ____1126: null,
    _oldNums: 0,
    _tipImgList: null,
    _tuiJianFlag: null,
    ctor: function(controller, itemIndex) {
        this._super("bossPersonItemView.ExportJson");
        this._controller = controller;
        this._itemIndex = itemIndex;
        this._bg = this.getChildByName("itemBg");
        this._path = ____654.____675.____139("outPic/strength_bg4.png");
        ____654.____677.____146(this._bg, this._path);
        this.____1102 = this.getChildByName("desLabel1");
        this.____1102.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text12"));
        this.____1103 = this.getChildByName("desLabel2");
        this.____1103.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text13"));
        this.____999 = this.getChildByName("conditionLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this._tuiJianFlag = this.getChildByName("tuiJianFlag");
        this.____935 = [];
        this._gridList = [];
        this._tipImgList = [];
        for (var i = 0; i < 3; i++) {
            this._tipImgList.push(this.getChildByName("tipImg" + (i + 1)));
            this.____935.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            grid.setIsShowCount(false);
            this.____935[i].addChild(grid);
            this._gridList.push(grid)
        }
        this.lastRevertTime = 0;
        this.____1176 = this.getChildByName("freeBtn__1");
        this.____1177 = this.____1176.getChildByName("btnLabel");
        this.____1177.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text15"));
        this.____1508 = this.getChildByName("payBtn__1");
        this.____1509 = this.____1508.getChildByName("priceLabel2");
        this.____1509.setString("?");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        this.____6()
    },
    setFlagInfo: function(index) {
        var openDay = ____655.____662.getClientDate().getDay();
        if (openDay == 0) {
            openDay = 7
        }
        if (index == 0) {
            if (openDay >= 1 && openDay <= 3) {
                this._tuiJianFlag.setVisible(true)
            } else {
                this._tuiJianFlag.setVisible(false)
            }
            this._tipImgList[0].setFrame(this.setFlagImgPath(6));
            this._tipImgList[1].setFrame(this.setFlagImgPath(5));
            this._tipImgList[2].setFrame(this.setFlagImgPath(0));
            this._tipImgList[2].setVisible(true)
        } else if (index == 1) {
            if (openDay >= 4 && openDay <= 5) {
                this._tuiJianFlag.setVisible(true)
            } else {
                this._tuiJianFlag.setVisible(false)
            }
            this._tipImgList[0].setFrame(this.setFlagImgPath(1));
            this._tipImgList[1].setFrame(this.setFlagImgPath(4));
            this._tipImgList[2].setVisible(false)
        } else if (index == 2) {
            if (openDay >= 6 && openDay <= 7) {
                this._tuiJianFlag.setVisible(true)
            } else {
                this._tuiJianFlag.setVisible(false)
            }
            this._tipImgList[0].setFrame(this.setFlagImgPath(2));
            this._tipImgList[1].setFrame(this.setFlagImgPath(3));
            this._tipImgList[2].setVisible(false)
        }
    },
    ____18: function(index, copyId, remainNum) {
        this.____1241 = index;
        this.____1008 = copyId;
        this._remainNum = remainNum;
        this.setFlagInfo(this.____1241);
        var missionsTempList = ____655.allTemplates.copyTemplateList.getCopy(this.____1008).missions;
        var bossId = missionsTempList[____655.____667.xianwei - 1].bossId;
        var awardList = missionsTempList[____655.____667.xianwei - 1].awards[0];
        var monsterTemplate = ____655.allTemplates.monsterTemplateList.getMonster(bossId);
        this.setCharacter(bossId, monsterTemplate);
        this.____999.setString(____655.____659.nameType.getXianweiName(____655.____667.xianwei));
        var info = ____655.statInfo.statCopyList[copyId];
        if (info != null) {
            var systemTime = ____655.____662.getSystemTimeSec();
            if (info.lastRevertTime - systemTime > 0) {
                this.lastRevertTime = info.lastRevertTime - systemTime
            } else {
                this.lastRevertTime = 0
            }
        }
        var this_ = this;

        function cdTick() {
            if (this_.lastRevertTime > 0) {
                this_.lastRevertTime--;
                this_.price = Math.ceil(this_.lastRevertTime / 180);
                if (this_._oldNums != this_.price) {
                    this_._oldNums = this_.price;
                    this_.____1176.setVisible(false);
                    this_.____1508.setVisible(true);
                    this_.____1509.setString(this_.price)
                }
            } else {
                if (this_.____1126 != null) {
                    this_.____1126.dispose();
                    this_.____1126 = null
                }
                this_.____1176.setVisible(true);
                this_.____1508.setVisible(false);
                this_.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(71, 28), this_.____1176);
                this_.____1126.setScaleX(1.23)
            }
        }

        function endTime() {
            this_._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text4"));
            this_.____1176.setVisible(true);
            this_.____1508.setVisible(false);
            if (this_.____1126 != null) {
                this_.____1126.dispose();
                this_.____1126 = null
            }
            this_.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(71, 28), this_.____1176);
            this_.____1126.setScaleX(1.23)
        }
        this._countDownUtils.start(this.lastRevertTime, cdTick, endTime);
        for (var i = 0; i < 3; i++) {
            var info = ____655.allTemplates.____794.getItem(awardList[i][0]);
            this._gridList[i].setItemTemplateInfo(info)
        }
    },
    setCharacter: function(bossId, monsterTemplate) {
        if (this.____944 != null) {
            this.____944.dispose();
            this._characterInfo.dispose();
            this.____944 = null;
            this._characterInfo = null
        }
        if (monsterTemplate != null) {
            this._characterInfo = ____654.getCharacterInfo(monsterTemplate.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.bottom, this, 10);
            var figureTempLate = ____655.allTemplates.figureTemplateList.getFigure(monsterTemplate.figureId);
            this.____944.move(figureTempLate.getOffsetX() + 152, figureTempLate.getOffsetY() + 284)
        }
    },
    setFlagImgPath: function(index) {
        var str = "";
        if (index == 5) {
            str = "flag/ui_bossTip9.png"
        } else if (index == 0) {
            str = "flag/ui_bossTip4.png"
        } else if (index == 4) {
            str = "flag/ui_bossTip8.png"
        } else if (index == 1) {
            str = "flag/ui_bossTip5.png"
        } else if (index == 2) {
            str = "flag/ui_bossTip6.png"
        } else if (index == 3) {
            str = "flag/ui_bossTip7.png"
        } else if (index == 6) {
            str = "flag/ui_bossTip3.png"
        }
        return str
    },
    ____16: function(sender, eventType) {
        function okClick() {
            ____654.copyMessageSender.sendEnterCopy(this.____1008, 0)
        }
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1176) {
                ____654.copyMessageSender.sendEnterCopy(this.____1008, 0)
            } else if (sender == this.____1508) {
                if (!____655.____667.moneyInfo.money1Enough(this.price)) {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                } else {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2156.text16", this.price) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.PERSONBOSS, 0, this, okClick, null, null)
                }
            }
        }
    },
    ____6: function() {
        this.____1176.addListener(this, this.____16);
        this.____1508.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.guide_challengePersonBoss, this.guideChallenge, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.guide_challengePersonBoss, this.guideChallenge, this)
    },
    guideChallenge: function() {
        if (this._itemIndex == 0 && this.____1176.isVisible()) {
            ____654.copyMessageSender.sendEnterCopy(this.____1008, 0)
        }
    },
    dispose: function() {
        this.____17();
        if (this._path != null) {
            ____654.____677.removeImageQuote(this._bg, this._path);
            this._path = null
        }
        this._bg = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        if (this.____944 != null) {
            this.____944.dispose();
            this._characterInfo.dispose();
            this.____944 = null;
            this._characterInfo = null
        }
        this._controller = null;
        this.____1241 = null;
        this._itemIndex = null;
        this.____1008 = null;
        this._remainNum = null;
        this.____935 = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._timeLabel = null;
        this.____999 = null;
        this.____1102 = null;
        this.____1103 = null;
        this.____1104 = null;
        this.____1176 = null;
        this.____1177 = null;
        this.____1508 = null;
        this.____1509 = null;
        this.lastRevertTime = null;
        this.price = null;
        this._tuiJianFlag = null;
        this._tipImgList = null;
        this._super()
    },
});
var PersonBossPanel = KYPanel.extend({
    _controller: null,
    ____1243: null,
    ____1227: null,
    _listView: null,
    _itemList: null,
    ____1101: null,
    ____1775: null,
    _moneyView: null,
    ctor: function(controller) {
        this._super("bossPersonPanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(3);
        moneyLayer.addChild(this._moneyView);
        this.____1243 = this.getChildByName("click_btn");
        this.____1227 = this.getChildByName("helpLabel");
        this.____1227.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text1"));
        this._itemList = [];
        this._listView = this.getChildByName("listView");
        this._listView.setItemsMargin(5);
        this._listView.setScrollBarEnabled(false);
        this.____1101 = this.getChildByName("desLabel");
        this.____1101.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text11"));
        this.____1775 = this.getChildByName("timesLabel");
        var copyIdList = ____655.allTemplates.copyTemplateList.WORLDBOSSPERSON_IDLIST;
        ____654.copyMessageSender.sendGetCopyInfo(copyIdList);
        this.____5();
        this.____6()
    },
    ____5: function() {
        for (var i = 0; i < 3; i++) {
            var item = new ____2151(this._controller, i);
            this._listView.pushBackItem(item);
            this._itemList.push(item)
        }
        this.refreshWorldBossPerson()
    },
    refreshWorldBossPerson: function() {
        var personBossRemainNum = ____655.bossItemList.personBossRemainNum;
        var personBossCopyList = ____655.bossItemList.personBossCopyList;
        var copyIdList = ____655.allTemplates.copyTemplateList.WORLDBOSSPERSON_IDLIST;
        for (var i = 0; i < 3; i++) {
            this._itemList[i].____18(i, personBossCopyList[i], personBossRemainNum)
        }
        this.____1775.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text20", personBossRemainNum))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1243) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                ____654.tipsManager.showStringTip(____654.____682.____108("10090"), 500)
            }
        }
    },
    ____6: function() {
        this.____1243.addListener(this, this.____16);
        ____655.bossItemList.addEventListener(____655.____661.personBoss_infoUpdate, this.refreshWorldBossPerson, this);
        ____655.statInfo.addEventListener(____655.____661.stat_copyStat_update, this.refreshWorldBossPerson, this)
    },
    ____17: function() {
        ____655.bossItemList.removeEventListener(____655.____661.personBoss_infoUpdate, this.refreshWorldBossPerson, this);
        ____655.statInfo.removeEventListener(____655.____661.stat_copyStat_update, this.refreshWorldBossPerson, this)
    },
    dispose: function() {
        this.____17();
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this._controller = null;
        this.____1243 = null;
        this.____1227 = null;
        this._listView = null;
        if (this._itemList != null) {
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose()
            }
            this._itemList = null
        }
        this.____1101 = null;
        this.____1775 = null;
        this._super()
    },
});
var ShenJiangBossPanel = KYPanel.extend({
    _controller: null,
    _bg: null,
    _path: null,
    ____1101: null,
    _numLabel: null,
    ____1582: null,
    ____1544: null,
    ____892: null,
    ____1227: null,
    ____1243: null,
    _itemList: null,
    ____1217: null,
    ____941: null,
    ____895: null,
    ____935: null,
    _gridList: null,
    ____1547: null,
    ____955: null,
    ____949: null,
    _moneyView: null,
    _effectList: null,
    ____1158: null,
    _fightValesList: null,
    ctor: function(controller) {
        this._super("bossGodPanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(3);
        moneyLayer.addChild(this._moneyView);
        this._bg = this.getChildByName("bg");
        this._path = ____654.____675.____139("outPic/ui_bossBg1.png");
        ____654.____677.____146(this._bg, this._path);
        this.____1101 = this.getChildByName("desLabel");
        this.____1101.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text5"));
        this._numLabel = this.getChildByName("timesLabel");
        this.____1582 = this.getChildByName("refleshBtn__1");
        this.____1544 = this.____1582.getChildByName("priceLabel");
        this.____892 = this.____1582.getChildByName("btnLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text2", ""));
        this.____1227 = this.getChildByName("helpLabel");
        this.____1227.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text1"));
        this.____1243 = this.getChildByName("click_btn");
        this._itemList = [];
        this.____1217 = [];
        this.____941 = [];
        this.____895 = [];
        this.____1158 = [];
        this._fightValesList = [];
        this.____935 = [];
        this._gridList = [];
        this.____955 = [];
        this.____949 = [];
        for (var i = 0; i < 3; i++) {
            this._itemList.push(this.getChildByName("item" + (i + 1)));
            this.____1217.push(this.getChildByName("flag" + (i + 1)));
            this.____1217[i].setVisible(false);
            this.____941.push(this.getChildByName("challengeBtn" + (i + 1) + "__1"));
            this.____895.push(this.____941[i].getChildByName("btnLabel"));
            this.____895[i].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text6"));
            this.getChildByName("desLabel" + (i + 1) + "1").setString(____654.yuyanbaoManager.getYuyanbao("____2156.text7"));
            this.getChildByName("desLabel" + (i + 1) + "2").setString(____654.yuyanbaoManager.getYuyanbao("____2156.text8"));
            this.____1158.push(this.getChildByName("tuiJianLabel" + (i + 1)));
            for (var j = 0; j < 3; j++) {
                if (this.____935[i] == null) {
                    this.____935[i] = []
                }
                this.____935[i].push(this.getChildByName("cell" + (i + 1).toString() + (j + 1)));
                var grid = new ____2129();
                grid.setIsShowCount(false);
                this.____935[i][j].addChild(grid);
                if (this._gridList[i] == null) {
                    this._gridList[i] = []
                }
                this._gridList[i].push(grid)
            }
        }
        this._effectList = [];
        this.____1547 = [80, 50, 30];
        ____654.copyMessageSender.sendCopyResetInfo();
        this.refreshWorldBossGodBtn();
        this.____6()
    },
    refreshWorldBossGod: function() {
        var godBossType = ____655.bossItemList.godBossType;
        var godBossRestNum = ____655.bossItemList.godBossRestNum;
        var godBossList = ____655.bossItemList.godBossList;
        this._numLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text20", godBossRestNum));
        if (godBossRestNum > 0) {
            this.____1544.setString(this.____1547[godBossRestNum - 1])
        } else {
            ____654.____674.setKYBtnEnabled(this.____1582, false, 0);
            this.____1544.setString(this.____1547[0])
        }
        var copyIdList = ____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST;
        for (var i = 0; i < 3; i++) {
            var bossId = godBossList[copyIdList[i]];
            this.setCharacterInfo(bossId, i);
            var awardTemplateList = ____655.allTemplates.awardTemplateList.getTypeList(3);
            var currentAward = [];
            for (var j = 0; j < awardTemplateList.length; j++) {
                if (parseInt(awardTemplateList[j].condition) == bossId) {
                    currentAward = awardTemplateList[j].awardList;
                    break
                }
            }
            var index = copyIdList.indexOf(copyIdList[i]);
            for (var k = 0; k < 3; k++) {
                var itemTempInfo = ____655.allTemplates.____794.getItem(currentAward[k][0]);
                this._gridList[index][k].setItemTemplateInfo(itemTempInfo);
                if (currentAward[k][1] > 0) {
                    this._gridList[index][k].setCount(currentAward[k][1])
                }
            }
        }
    },
    refreshWorldBossGodBtn: function() {
        for (var i = 0; i < 3; i++) {
            var copyIdList = ____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST;
            var info = ____655.statInfo.statCopyList[copyIdList[i]];
            var copyNum = 0;
            if (info != null) {
                copyNum = info.currentEnterCount
            }
            if (this._effectList[i] != null) {
                this._effectList[i].dispose();
                this._effectList[i] = null
            }
            if (copyNum > 0) {
                this.____941[i].setVisible(false);
                this.____1217[i].setVisible(true)
            } else {
                this._effectList[i] = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(71, 28), this.____941[i]);
                this._effectList[i].setScaleX(1.23);
                this.____941[i].setVisible(true);
                this.____1217[i].setVisible(false)
            }
        }
    },
    setCharacterInfo: function(bossId, index) {
        if (this.____955[index] != null) {
            this.____955[index].dispose();
            this.____949[index].dispose();
            this.____955[index] = null;
            this.____949[index] = null
        }
        var monsterTemplate = ____655.allTemplates.monsterTemplateList.getMonster(bossId);
        if (monsterTemplate != null) {
            this.____949[index] = ____654.getCharacterInfo(monsterTemplate.figureId, ____655.____659.____687.stand);
            this.____955[index] = new ____545(this.____949[index]);
            this.____955[index].init(____655.____659.____686.bottom, this._itemList[index], 10);
            var figureTempLate = ____655.allTemplates.figureTemplateList.getFigure(monsterTemplate.figureId);
            this.____955[index].move(figureTempLate.getOffsetX() + 120, figureTempLate.getOffsetY() + 220)
        }
        var fightValue = monsterTemplate.fightValue * 0.0001;
        this._fightValesList[index] = monsterTemplate.fightValue;
        if (index == 0) {
            this.____1158[index].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text9", fightValue))
        } else if (index == 1) {
            this.____1158[index].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text9", fightValue))
        } else if (index == 2) {
            this.____1158[index].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text9", fightValue))
        }
    },
    ____16: function(sender, eventType) {
        function okClick() {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.copyMessageSender.sendCopyReset(____655.allTemplates.copyTemplateList.SHENJIANG_TYPE)
        }

        function ok1Click() {
            ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[0], 0)
        }

        function ok2Click() {
            ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[1], 0)
        }

        function ok3Click() {
            ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[2], 0)
        }
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var selfFight = ____655.____667.combat;
            if (sender == this.____1243) {
                ____654.tipsManager.showStringTip(____654.____682.____108("10090"), 500)
            } else if (sender == this.____1582) {
                var godBossRestNum = ____655.bossItemList.godBossRestNum;
                if (____655.____667.moneyInfo.money1Enough(this.____1547[godBossRestNum - 1])) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2156.text10", this.____1547[godBossRestNum - 1]) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.SHENJIANG_BOSS, 0, this, okClick, null, null)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
            } else if (sender == this.____941[0]) {
                if (selfFight >= this._fightValesList[0] * 0.8) {
                    ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[0], 0)
                } else {
                    ____655.getAlert().show(2, "你当前战力远低于副本的参考战力，是否继续进入？", null, 0, this, ok1Click, null, null)
                }
            } else if (sender == this.____941[1]) {
                if (selfFight >= this._fightValesList[1] * 0.8) {
                    ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[1], 0)
                } else {
                    ____655.getAlert().show(2, "你当前战力远低于副本的参考战力，是否继续进入？", null, 0, this, ok2Click, null, null)
                }
            } else if (sender == this.____941[2]) {
                if (selfFight >= this._fightValesList[2] * 0.8) {
                    ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[2], 0)
                } else {
                    ____655.getAlert().show(2, "你当前战力远低于副本的参考战力，是否继续进入？", null, 0, this, ok3Click, null, null)
                }
            }
        }
    },
    ____6: function() {
        this.____1243.addListener(this, this.____16);
        this.____1582.addListener(this, this.____16);
        for (var i = 0; i < 3; i++) {
            this.____941[i].addListener(this, this.____16)
        }
        ____655.statInfo.addEventListener(____655.____661.stat_copyStat_update, this.refreshWorldBossGodBtn, this);
        ____654.____672.addEventListener(____655.____661.copy_reset, this.refreshWorldBossGod, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.stat_copyStat_update, this.refreshWorldBossGodBtn, this);
        ____654.____672.removeEventListener(____655.____661.copy_reset, this.refreshWorldBossGod, this)
    },
    dispose: function() {
        this.____17();
        if (this._path != null) {
            ____654.____677.removeImageQuote(this._bg, this._path);
            this._path = null
        }
        this._bg = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this.____1101 = null;
        this._controller = null;
        this._numLabel = null;
        this.____1582 = null;
        this.____1544 = null;
        this.____892 = null;
        this.____1227 = null;
        this.____1243 = null;
        this._itemList = null;
        this.____1217 = null;
        this.____941 = null;
        this.____895 = null;
        this.____1158 = null;
        this.____935 = null;
        if (this._gridList != null) {
            for (var index = 0; index < this._gridList.length; index++) {
                if (this._gridList[index] != null) {
                    for (var i = 0; i < this._gridList[index].length; i++) {
                        this._gridList[index][i].dispose()
                    }
                    this._gridList[index] = null
                }
            }
            this._gridList = null
        }
        if (this.____955 != null) {
            for (var i = 0; i < this.____955.length; i++) {
                this.____955[i].dispose()
            }
            this.____955 = null
        }
        if (this.____949 != null) {
            for (var i = 0; i < this.____949.length; i++) {
                this.____949[i].dispose()
            }
            this.____949 = null
        }
        if (this._effectList != null) {
            for (var index in this._effectList) {
                this._effectList[index].dispose()
            }
            this._effectList = null
        }
        this._fightValesList = null;
        this.____1547 = null;
        this._super()
    },
});
var ShenJiangBossPanel1 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _path: null,
    _remainNums: null,
    ____1101: null,
    ____941: null,
    _chanllengeBtnLabelList: null,
    _goldIconList: null,
    _priceLabelList: null,
    _remainTimesList: null,
    _tuiJianLabelList: null,
    _effectList: null,
    _moneyView: null,
    ____1227: null,
    ____1243: null,
    _characterItemList: null,
    ____935: null,
    _gridList: null,
    ____955: null,
    ____949: null,
    _fightValesList: null,
    _countDownUtilsList: null,
    _deltaList: null,
    _goldNumList: null,
    _oldNumsList: null,
    _godBossRestNum: null,
    ctor: function(controller) {
        this._super("bossGodPanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(3);
        moneyLayer.addChild(this._moneyView);
        this.____1227 = this.getChildByName("helpLabel");
        this.____1227.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text1"));
        this.____1243 = this.getChildByName("click_btn");
        this._bg = this.getChildByName("bg");
        this._path = ____654.____675.____139("outPic/ui_bossBg1.png");
        ____654.____677.____146(this._bg, this._path);
        this._remainNums = this.getChildByName("timesLabel");
        this.____1101 = this.getChildByName("desLabel");
        this.____941 = [];
        this._goldIconList = [];
        this._priceLabelList = [];
        this._remainTimesList = [];
        this._tuiJianLabelList = [];
        this._characterItemList = [];
        this.____935 = [];
        this._gridList = [];
        this.____955 = [];
        this.____949 = [];
        this._fightValesList = [];
        this._countDownUtilsList = [];
        this._chanllengeBtnLabelList = [];
        this._deltaList = [];
        this._goldNumList = [0, 0, 0];
        this._oldNumsList = [0, 0, 0];
        for (var i = 0; i < 3; i++) {
            this.____941.push(this.getChildByName("challengeBtn" + (i + 1) + "__1"));
            this._chanllengeBtnLabelList.push(this.____941[i].getChildByName("btnLabel"));
            this._chanllengeBtnLabelList[i].setString("免费挑战");
            this._goldIconList.push(this.getChildByName("goldIcon" + (i + 1)));
            this._priceLabelList.push(this.getChildByName("priceLabel" + (i + 1)));
            this._remainTimesList.push(this.getChildByName("timesLabel" + (i + 1)));
            this._tuiJianLabelList.push(this.getChildByName("tuiJianLabel" + (i + 1)));
            this._characterItemList.push(this.getChildByName("item" + (i + 1)));
            var countDownUtils = new ____2111();
            countDownUtils.setLabel(this._remainTimesList[i], 0, 0);
            this._countDownUtilsList.push(countDownUtils);
            for (var j = 0; j < 3; j++) {
                if (this.____935[i] == null) {
                    this.____935[i] = []
                }
                this.____935[i].push(this.getChildByName("cell" + (i + 1).toString() + (j + 1)));
                var grid = new ____2129();
                grid.setIsShowCount(false);
                this.____935[i][j].addChild(grid);
                if (this._gridList[i] == null) {
                    this._gridList[i] = []
                }
                this._gridList[i].push(grid)
            }
        }
        this._effectList = [];
        ____654.copyMessageSender.sendCopyResetInfo();
        this.____6()
    },
    refreshWorldBossGod: function() {
        this._godBossRestNum = ____655.bossItemList.godBossRestNum;
        var godBossList = ____655.bossItemList.godBossList;
        this.____1101.setString("今日剩余付费挑战：");
        this._remainNums.setString(this._godBossRestNum + "次");
        var this_ = this;
        var cbList = [function endTime1() {
            this_.tickTime(0)
        }, function endTime2() {
            this_.tickTime(1)
        }, function endTime3() {
            this_.tickTime(2)
        }];
        var tickList = [function tickTime1() {
            this_.tickTime(0)
        }, function tickTime1() {
            this_.tickTime(1)
        }, function tickTime1() {
            this_.tickTime(2)
        }];
        var copyIdList = ____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST;
        for (var i = 0; i < 3; i++) {
            var bossId = godBossList[copyIdList[i]][0];
            var remainTimes = godBossList[copyIdList[i]][1];
            var currentTimes = ____655.____662.getSystemTimeSec();
            this._deltaList[i] = remainTimes - currentTimes;
            this._countDownUtilsList[i].start(this._deltaList[i], tickList[i], cbList[i]);
            this.setCharacterInfo(bossId, i);
            var awardTemplateList = ____655.allTemplates.awardTemplateList.getTypeList(3);
            var currentAward = [];
            for (var j = 0; j < awardTemplateList.length; j++) {
                if (parseInt(awardTemplateList[j].condition) == bossId) {
                    currentAward = awardTemplateList[j].awardList;
                    break
                }
            }
            var index = copyIdList.indexOf(copyIdList[i]);
            for (var k = 0; k < 3; k++) {
                var itemTempInfo = ____655.allTemplates.____794.getItem(currentAward[k][0]);
                this._gridList[index][k].setItemTemplateInfo(itemTempInfo);
                if (currentAward[k][1] > 0) {
                    this._gridList[index][k].setCount(currentAward[k][1])
                }
            }
        }
    },
    endTime: function(index) {
        this._remainTimesList[index].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text4"));
        this._chanllengeBtnLabelList[index].setVisible(true);
        this._goldIconList[index].setVisible(false);
        this._priceLabelList[index].setVisible(false);
        if (this._effectList[index] != null) {
            this._effectList[index].dispose();
            this._effectList[index] = null
        }
        this._effectList[index] = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(71, 28), this.____941[index]);
        this._effectList[index].setScaleX(1.23)
    },
    tickTime: function(index) {
        if (this._deltaList[index] > 0) {
            this._deltaList[index]--;
            if (index == 0) {
                this._goldNumList[index] = Math.ceil(this._deltaList[index] / (6 * 60))
            } else if (index == 1) {
                this._goldNumList[index] = Math.ceil(this._deltaList[index] / (3 * 60))
            } else if (index == 2) {
                this._goldNumList[index] = Math.ceil(this._deltaList[index] / (2 * 60))
            }
            if (this._oldNumsList[index] != this._goldNumList[index]) {
                this._oldNumsList[index] = this._goldNumList[index];
                this._chanllengeBtnLabelList[index].setVisible(false);
                this._goldIconList[index].setVisible(true);
                this._priceLabelList[index].setVisible(true);
                this._priceLabelList[index].setString(this._goldNumList[index])
            }
        } else {
            this._remainTimesList[index].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text4"));
            this._chanllengeBtnLabelList[index].setVisible(true);
            this._goldIconList[index].setVisible(false);
            this._priceLabelList[index].setVisible(false);
            if (this._effectList[index] != null) {
                this._effectList[index].dispose();
                this._effectList[index] = null
            }
            this._effectList[index] = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(71, 28), this.____941[index]);
            this._effectList[index].setScaleX(1.23)
        }
    },
    setCharacterInfo: function(bossId, index) {
        if (this.____955[index] != null) {
            this.____955[index].dispose();
            this.____949[index].dispose();
            this.____955[index] = null;
            this.____949[index] = null
        }
        var monsterTemplate = ____655.allTemplates.monsterTemplateList.getMonster(bossId);
        if (monsterTemplate != null) {
            this.____949[index] = ____654.getCharacterInfo(monsterTemplate.figureId, ____655.____659.____687.stand);
            this.____955[index] = new ____545(this.____949[index]);
            this.____955[index].init(____655.____659.____686.bottom, this._characterItemList[index], 10);
            var figureTempLate = ____655.allTemplates.figureTemplateList.getFigure(monsterTemplate.figureId);
            this.____955[index].move(figureTempLate.getOffsetX(), figureTempLate.getOffsetY())
        }
        var fightValue = monsterTemplate.fightValue * 0.0001;
        this._fightValesList[index] = monsterTemplate.fightValue;
        if (index == 0) {
            this._tuiJianLabelList[index].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text9", fightValue))
        } else if (index == 1) {
            this._tuiJianLabelList[index].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text9", fightValue))
        } else if (index == 2) {
            this._tuiJianLabelList[index].setString(____654.yuyanbaoManager.getYuyanbao("____2156.text9", fightValue))
        }
    },
    ____16: function(sender, eventType) {
        function okClick() {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.copyMessageSender.sendCopyReset(____655.allTemplates.copyTemplateList.SHENJIANG_TYPE)
        }

        function ok1Click() {
            ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[0], 0)
        }

        function ok11Click() {
            if (this._goldNumList[0] <= 0) {
                ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[0], 0)
            } else {
                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2156.text16", this._goldNumList[0]), null, 0, this, ok1Click, null, null)
            }
        }

        function ok2Click() {
            ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[1], 0)
        }

        function ok22Click() {
            if (this._goldNumList[1] <= 0) {
                ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[1], 0)
            } else {
                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2156.text16", this._goldNumList[1]), null, 0, this, ok2Click, null, null)
            }
        }

        function ok3Click() {
            ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[2], 0)
        }

        function ok33Click() {
            if (this._goldNumList[2] <= 0) {
                ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[2], 0)
            } else {
                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2156.text16", this._goldNumList[2]), null, 0, this, ok3Click, null, null)
            }
        }
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var selfFight = ____655.____667.combat;
            if (sender == this.____1243) {
                ____654.tipsManager.showStringTip(____654.____682.____108("10090"), 500)
            } else if (sender == this.____941[0]) {
                if (this._godBossRestNum > 0 || this._goldNumList[0] <= 0) {
                    if (____655.____667.moneyInfo.money1Enough(this._goldNumList[0])) {
                        if (selfFight >= this._fightValesList[0] * 0.8) {
                            if (this._goldNumList[0] <= 0) {
                                ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[0], 0)
                            } else {
                                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2156.text16", this._goldNumList[0]) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.SHENJIANG_BOSS, 0, this, ok1Click, null, null)
                            }
                        } else {
                            ____655.getAlert().show(2, "你当前战力远低于副本的参考战力，是否继续进入？", null, 0, this, ok11Click, null, null)
                        }
                    } else {
                        ____655.____667.moneyInfo.showNotEnoughTip(1)
                    }
                } else {
                    ____654.tipsManager.quickTip.show("付费次数已用完")
                }
            } else if (sender == this.____941[1]) {
                if (this._godBossRestNum > 0 || this._goldNumList[1] <= 0) {
                    if (____655.____667.moneyInfo.money1Enough(this._goldNumList[1])) {
                        if (selfFight >= this._fightValesList[1] * 0.8) {
                            if (this._goldNumList[1] <= 0) {
                                ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[1], 0)
                            } else {
                                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2156.text16", this._goldNumList[1]) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.SHENJIANG_BOSS, 0, this, ok2Click, null, null)
                            }
                        } else {
                            ____655.getAlert().show(2, "你当前战力远低于副本的参考战力，是否继续进入？", null, 0, this, ok22Click, null, null)
                        }
                    } else {
                        ____655.____667.moneyInfo.showNotEnoughTip(1)
                    }
                } else {
                    ____654.tipsManager.quickTip.show("付费次数已用完")
                }
            } else if (sender == this.____941[2]) {
                if (this._godBossRestNum > 0 || this._goldNumList[2] <= 0) {
                    if (____655.____667.moneyInfo.money1Enough(this._goldNumList[2])) {
                        if (selfFight >= this._fightValesList[2] * 0.8) {
                            if (this._goldNumList[2] <= 0) {
                                ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST[2], 0)
                            } else {
                                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2156.text16", this._goldNumList[2]) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.SHENJIANG_BOSS, 0, this, ok3Click, null, null)
                            }
                        } else {
                            ____655.getAlert().show(2, "你当前战力远低于副本的参考战力，是否继续进入？", null, 0, this, ok33Click, null, null)
                        }
                    } else {
                        ____655.____667.moneyInfo.showNotEnoughTip(1)
                    }
                } else {
                    ____654.tipsManager.quickTip.show("付费次数已用完")
                }
            }
        }
    },
    ____6: function() {
        this.____1243.addListener(this, this.____16);
        for (var i = 0; i < 3; i++) {
            this.____941[i].addListener(this, this.____16)
        }
        ____654.____672.addEventListener(____655.____661.copy_reset, this.refreshWorldBossGod, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.copy_reset, this.refreshWorldBossGod, this)
    },
    dispose: function() {
        this.____17();
        if (this._path != null) {
            ____654.____677.removeImageQuote(this._bg, this._path);
            this._path = null
        }
        this._bg = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this.____1101 = null;
        this._controller = null;
        this._remainNums = null;
        this.____1227 = null;
        this.____1243 = null;
        this.____941 = null;
        this._chanllengeBtnLabelList = null;
        this._goldIconList = null;
        this._priceLabelList = null;
        this._remainTimesList = null;
        this._tuiJianLabelList = null;
        this.____1158 = null;
        this.____935 = null;
        if (this._gridList != null) {
            for (var index = 0; index < this._gridList.length; index++) {
                if (this._gridList[index] != null) {
                    for (var i = 0; i < this._gridList[index].length; i++) {
                        this._gridList[index][i].dispose()
                    }
                    this._gridList[index] = null
                }
            }
            this._gridList = null
        }
        if (this.____955 != null) {
            for (var i = 0; i < this.____955.length; i++) {
                this.____955[i].dispose()
            }
            this.____955 = null
        }
        if (this.____949 != null) {
            for (var i = 0; i < this.____949.length; i++) {
                this.____949[i].dispose()
            }
            this.____949 = null
        }
        if (this._effectList != null) {
            for (var index in this._effectList) {
                this._effectList[index].dispose()
            }
            this._effectList = null
        }
        this._deltaList = null;
        this._goldNumList = null;
        if (this._countDownUtilsList != null) {
            for (var i = 0; i < this._countDownUtilsList.length; i++) {
                this._countDownUtilsList[i].dispose()
            }
            this._countDownUtilsList = null
        }
        this._characterItemList = null;
        this._super()
    },
});
var ____2154 = KYPanel.extend({
    _controller: null,
    ____880: null,
    _titleLabel: null,
    ____934: null,
    ____1193: null,
    _closeBtn: null,
    ____938: null,
    ____883: null,
    ____1428: null,
    ____1550: null,
    ctor: function(bossController, bossId) {
        this._controller = bossController;
        this.____880 = bossId;
        this._super("bossWorldAwardPanel.ExportJson");
        this._titleLabel = this.getChildByName("titleLabel");
        this.____1550 = this.getChildByName("produceLabel");
        this.____934 = [this.getChildByName("cell1"), this.getChildByName("cell2"), this.getChildByName("cell3"), this.getChildByName("cell4"), this.getChildByName("cell5"), this.getChildByName("cell6"), this.getChildByName("cell7"), this.getChildByName("cell8")];
        this.____1193 = this.getChildByName("goBtn__1");
        this._closeBtn = this.getChildByName("closeBtn");
        this.____883 = ____655.allTemplates.bossTemplateList.____55(this.____880);
        this.____1428 = ____655.allTemplates.monsterTemplateList.getMonster(this.____880);
        this.____1550.setString(this.____883.description);
        this._titleLabel.setString(this.____1428.name);
        this.____938 = [];
        var itemList = this.____883.items;
        for (var i = 0; i < itemList.length; i++) {
            var cell = new ____2129();
            cell.setItemTemplateInfo(____655.allTemplates.____794.getItem(itemList[i][0]));
            if (itemList[i][1] > 0) {
                cell.setCount(itemList[i][1])
            }
            this.____938.push(cell);
            this.____934[i].addChild(cell)
        }
        this.____1193.addListener(this, this.goClickHandler);
        this._closeBtn.addListener(this, this.closeClickHandler)
    },
    goClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_flyToMap, ____654.____672, this.____1428.sceneId));
            this.dispose()
        }
    },
    closeClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this.dispose()
        }
    },
    dispose: function() {
        this._super();
        this._controller = null;
        this._titleLabel = null;
        this.____934 = null;
        this.____1193 = null;
        this._closeBtn = null;
        if (this.____938 != null) {
            for (var i = 0; i < this.____938.length; i++) {
                this.____938[i].dispose()
            }
            this.____938 = null
        }
        this.____883 = null;
        this.____1428 = null;
        this.____1550 = null
    },
});
var ____2155 = KYNode.extend({
    _bg: null,
    ____1340: null,
    _levelLabel: null,
    _nameLabel: null,
    _tipsLabel: null,
    ____1302: null,
    ____1781: null,
    ____1782: null,
    _tipImg3: null,
    _template: null,
    _bossInfo: null,
    ____1428: null,
    _bgPath: null,
    ____1168: null,
    ____944: null,
    _characterInfo: null,
    ctor: function(template) {
        this._super("bossWorldItemView.ExportJson");
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/ui_bossItemBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1340 = this.getChildByName("levelBg");
        this._levelLabel = this.getChildByName("levelLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____1781 = this.getChildByName("tipImg1");
        this.____1782 = this.getChildByName("tipImg2");
        this._tipImg3 = this.getChildByName("tipImg3");
        this.____1302 = this.getChildByName("hasChallengeFlag");
        this.____1302.setLocalZOrder(12);
        this._template = template;
        this._bossInfo = ____655.bossItemList.getBossInfo(this._template.monsterId);
        this.____1428 = ____655.allTemplates.monsterTemplateList.getMonster(this._template.monsterId);
        this.____1168 = [____654.yuyanbaoManager.getYuyanbao("____2156.text2", "10:00"), ____654.yuyanbaoManager.getYuyanbao("____2156.text2", "14:00"), ____654.yuyanbaoManager.getYuyanbao("____2156.text2", "18:00"), ____654.yuyanbaoManager.getYuyanbao("____2156.text2", "22:00"), ____654.yuyanbaoManager.getYuyanbao("____2156.text3", "10:00")];
        this.____5()
    },
    ____5: function() {
        this.____1781.setFrame(this.setFlagImgPath(this._template.flagShow[0]));
        this.____1782.setFrame(this.setFlagImgPath(this._template.flagShow[1]));
        if (this._template.flagShow[2] != null) {
            this._tipImg3.setFrame(this.setFlagImgPath(this._template.flagShow[2]));
            this._tipImg3.setVisible(true)
        } else {
            this._tipImg3.setVisible(false)
        }
        var stage = this.getStageByLevel(this.____1428.level);
        this._levelLabel.setString(stage);
        this.____1340.setFrame(this.setLevelBgPath(stage));
        this._nameLabel.setString(this.____1428.name);
        if (this._bossInfo != null) {
            this.isWorldBossTime(this._bossInfo.fleshState)
        } else {
            this.isWorldBossTime(1)
        }
        this.setCharacter()
    },
    setCharacter: function() {
        if (this.____944 != null) {
            this.____944.dispose();
            this._characterInfo.dispose();
            this.____944 = null;
            this._characterInfo = null
        }
        if (this.____1428 != null) {
            this._characterInfo = ____654.getCharacterInfo(this.____1428.figureId, ____655.____659.____687.stand);
            var figureTempLate = ____655.allTemplates.figureTemplateList.getFigure(this.____1428.figureId);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.bottom, this, 10);
            this.____944.setScale(0.9, 0.9);
            this.____944.move(figureTempLate.getOffsetX() + 142, figureTempLate.getOffsetY() + 76)
        }
    },
    isWorldBossTime: function(bossState) {
        var systemTime = ____655.____662.getZeroPassTime();
        var time1 = 10 * 3600;
        var time2 = 14 * 3600;
        var time3 = 18 * 3600;
        var time4 = 22 * 3600;
        if (systemTime < time1) {
            if (bossState == 0) {
                this._tipsLabel.setString(this.____1168[0]);
                this._tipsLabel.setColor(____655.____659.____688.system);
                this.____1302.setVisible(true)
            } else if (bossState == 1) {
                this.____1302.setVisible(false);
                this._tipsLabel.setColor(____655.____659.____688.green);
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text4"))
            }
        } else if (time1 <= systemTime && systemTime < time2) {
            if (bossState == 0) {
                this._tipsLabel.setString(this.____1168[1]);
                this._tipsLabel.setColor(____655.____659.____688.system);
                this.____1302.setVisible(true)
            } else if (bossState == 1) {
                this.____1302.setVisible(false);
                this._tipsLabel.setColor(____655.____659.____688.green);
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text4"))
            }
        } else if (time2 <= systemTime && systemTime < time3) {
            if (bossState == 0) {
                this._tipsLabel.setString(this.____1168[2]);
                this._tipsLabel.setColor(____655.____659.____688.system);
                this.____1302.setVisible(true)
            } else if (bossState == 1) {
                this.____1302.setVisible(false);
                this._tipsLabel.setColor(____655.____659.____688.green);
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text4"))
            }
        } else if (time3 <= systemTime && systemTime < time4) {
            if (bossState == 0) {
                this._tipsLabel.setString(this.____1168[3]);
                this._tipsLabel.setColor(____655.____659.____688.system);
                this.____1302.setVisible(true)
            } else if (bossState == 1) {
                this.____1302.setVisible(false);
                this._tipsLabel.setColor(____655.____659.____688.green);
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text4"))
            }
        } else if (systemTime > time4) {
            if (bossState == 0) {
                this._tipsLabel.setString(this.____1168[4]);
                this._tipsLabel.setColor(____655.____659.____688.system);
                this.____1302.setVisible(true)
            } else if (bossState == 1) {
                this.____1302.setVisible(false);
                this._tipsLabel.setColor(____655.____659.____688.green);
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text4"))
            }
        }
    },
    getStageByLevel: function(level) {
        var stage = level / 10 - 2;
        return stage
    },
    setLevelBgPath: function(stage) {
        var str = "";
        if (stage == 3 || stage == 4) {
            str = "icon/ui_bossLevelBg1.png"
        } else if (stage == 5 || stage == 6) {
            str = "icon/ui_bossLevelBg2.png"
        } else if (stage == 7 || stage == 8) {
            str = "icon/ui_bossLevelBg3.png"
        } else if (stage == 9 || stage == 10) {
            str = "icon/ui_bossLevelBg4.png"
        } else if (stage == 11 || stage == 12) {
            str = "icon/ui_bossLevelBg5.png"
        } else if (stage == 13 || stage == 14) {
            str = "icon/ui_bossLevelBg6.png"
        } else {
            str = "icon/ui_bossLevelBg6.png"
        }
        return str
    },
    setFlagImgPath: function(index) {
        var str = "";
        if (index == 2) {
            str = "flag/ui_bossTip9.png"
        } else if (index == 3) {
            str = "flag/ui_bossTip4.png"
        } else if (index == 4) {
            str = "flag/ui_bossTip8.png"
        } else if (index == 5) {
            str = "flag/ui_bossTip5.png"
        } else if (index == 6) {
            str = "flag/ui_bossTip6.png"
        } else if (index == 7) {
            str = "flag/ui_bossTip7.png"
        } else if (index == 1) {
            str = "flag/ui_bossTip3.png"
        }
        return str
    },
    dispose: function() {
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        this.____1340 = null;
        this._levelLabel = null;
        this._nameLabel = null;
        this._tipsLabel = null;
        this.____1302 = null;
        this.____1781 = null;
        this.____1782 = null;
        this._tipImg3 = null;
        this._template = null;
        this._bossInfo = null;
        this.____1428 = null;
        this.____1168 = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this._characterInfo.dispose();
            this.____944 = null;
            this._characterInfo = null
        }
        this._super()
    }
});
var ____2156 = KYPanel.extend({
    _controller: null,
    _tileContainer: null,
    ____1773: null,
    ____1783: null,
    ____1776: null,
    _moneyView: null,
    _pageController: null,
    ctor: function(controller) {
        this._super("bossWorldPanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(3);
        moneyLayer.addChild(this._moneyView);
        ____654.copyMessageSender.sendGetWorldBossInfo();
        this._tileContainer = this.getChildByName("itemLayer__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._pageController = new KYScrollPageController(this._tileContainer);
        this._pageController.setPageLong(this._tileContainer.getShowWidth() + 9);
        this._tileContainer.setMoveController(this._pageController);
        this._tileContainer.setFormat(2, 0, ____654.____673.____160(287, 240), 4, 5);
        this.____1776 = this.getChildByName("click_btn");
        this.____1783 = this.getChildByName("helpLabel");
        this.____1783.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text1"));
        this.____6()
    },
    refreshWorldBoss: function() {
        this._tileContainer.clearAllItems();
        var count = ____655.allTemplates.bossTemplateList.sortList.length;
        this._tileContainer.setFormat(2, count, ____654.____673.____160(287, 240), 4, 5, false);
        if (this.____1773 == null) {
            this.____1773 = new ____2145();
            this.____1773.setPosition(98, 14);
            this.getChildByName("pageView").addChild(this.____1773);
            this._pageController.setPageView(this.____1773)
        }
        this.____1773.resetCount(Math.ceil(count / 6));
        this.____1773.setPage(0)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1776) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                ____654.tipsManager.showStringTip(____654.____682.____108("10090"), 500)
            }
        }
    },
    ____6: function() {
        this.____1776.addListener(this, this.____16);
        ____655.bossItemList.addEventListener(____655.____661.worldBoss_stateUpdate, this.refreshWorldBoss, this)
    },
    getItemByIndex: function(index) {
        var bossInfo = ____655.allTemplates.bossTemplateList.sortList[index];
        if (bossInfo == null) return null;
        var item = new ____2155(bossInfo);
        item.addListener(this, this.gridClickHandler, null, null, null, false, true);
        return item
    },
    getIdByIndex: function(index) {
        var bossInfo = ____655.allTemplates.bossTemplateList.sortList[index];
        if (bossInfo == null) return -1;
        return bossInfo.monsterId
    },
    gridClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            this._controller.showWorldBossAwardPanel(sender._template.monsterId)
        }
    },
    ____17: function() {
        ____655.bossItemList.removeEventListener(____655.____661.worldBoss_stateUpdate, this.refreshWorldBoss, this)
    },
    dispose: function() {
        this.____17();
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this.____1773 != null) {
            this.____1773.dispose();
            this.____1773 = null
        }
        if (this._pageController != null) {
            this._pageController.dispose();
            this._pageController = null
        }
        this._tileContainer = null;
        this.____1783 = null;
        this.____1776 = null;
        this._super();
        this._controller = null
    },
});
var ____2157 = cc.Class.extend({
    clubModule: null,
    ctor: function(clubModule) {
        this.clubModule = clubModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this);
        ____655.____667.addEventListener(____655.____661.playerInfo_club, this.updateClubInfo, this)
    },
    updateClubInfo: function() {
        if (____655.____667.clubId > 0) {
            this.joinClubCondition()
        } else {
            this.leaveClubCondition()
        }
    },
    joinClubCondition: function() {
        this.hideClubRequtePanel(____655.____659.panelTabType.sheJiao_club);
        this.showClubPanel(____655.____659.panelTabType.sheJiao_club)
    },
    leaveClubCondition: function() {
        this.hideClubPanel(____655.____659.panelTabType.sheJiao_club);
        this.showClubRequtePanel(____655.____659.panelTabType.sheJiao_club)
    },
    showClubPanel: function(type, index) {
        if (this.clubModule.clubPanel == null) {
            this.clubModule.clubPanel = new ____2160(this, index)
        }
        ____654.____676.uiPanelContainer.____125(this.clubModule.clubPanel, type)
    },
    hideClubPanel: function() {
        if (this.clubModule.clubPanel != null) {
            this.clubModule.clubPanel.dispose();
            this.clubModule.clubPanel = null
        }
    },
    showClubRequtePanel: function(type) {
        if (this.clubModule.clubRequtePanel == null) {
            this.clubModule.clubRequtePanel = new ____2162(this)
        }
        ____654.____676.uiPanelContainer.____125(this.clubModule.clubRequtePanel, type)
    },
    hideClubRequtePanel: function() {
        if (this.clubModule.clubRequtePanel != null) {
            this.clubModule.clubRequtePanel.dispose();
            this.clubModule.clubRequtePanel = null
        }
    },
    showCreationView: function() {
        if (this.clubModule.clubCreationView == null) {
            this.clubModule.clubCreationView = new ____2159(this)
        }
        ____654.____676.____125(this.clubModule.clubCreationView, true)
    },
    hideCreationView: function() {
        if (this.clubModule.clubCreationView != null) {
            this.clubModule.clubCreationView.dispose();
            this.clubModule.clubCreationView = null
        }
    },
    showRequteInfoView: function() {
        if (this.clubModule.clubRequteInfoView == null) {
            this.clubModule.clubRequteInfoView = new ____2176(this)
        }
        ____654.____676.____125(this.clubModule.clubRequteInfoView, true)
    },
    hideRequteInfoView: function() {
        if (this.clubModule.clubRequteInfoView != null) {
            this.clubModule.clubRequteInfoView.dispose();
            this.clubModule.clubRequteInfoView = null
        }
    },
    showClubExpeditionRestView: function(copyId) {
        if (this.clubModule.clubExpeditionResetView == null) {
            this.clubModule.clubExpeditionResetView = new ClubExpeditionRestView(this, copyId)
        }
        ____654.____676.____125(this.clubModule.clubExpeditionResetView, true)
    },
    hideClubExpeditionRestView: function() {
        if (this.clubModule.clubExpeditionResetView != null) {
            this.clubModule.clubExpeditionResetView.dispose();
            this.clubModule.clubExpeditionResetView = null
        }
    },
    showClubBossRankView: function() {
        if (this.clubModule.clubBossRankView == null) {
            this.clubModule.clubBossRankView = new ClubBossRankView(this)
        }
        ____654.____676.____125(this.clubModule.clubBossRankView, true)
    },
    hideClubBossRankView: function() {
        if (this.clubModule.clubBossRankView != null) {
            this.clubModule.clubBossRankView.dispose();
            this.clubModule.clubBossRankView = null
        }
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.clubModule.clubPanel) {
            this.clubModule.clubPanel = null
        } else if (p == this.clubModule.clubRequtePanel) {
            this.clubModule.clubRequtePanel = null
        } else if (p == this.clubModule.clubCreationView) {
            this.clubModule.clubCreationView = null
        }
    },
});
var ____2158 = ____537.extend({
    clubController: null,
    clubRequtePanel: null,
    clubPanel: null,
    clubCreationView: null,
    clubRequteInfoView: null,
    clubBossRankView: null,
    clubExpeditionResetView: null,
    setup: function(data) {
        this.clubController = new ____2157(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (____655.____667.clubId == 0) {
            this.clubController.showClubRequtePanel(data[0])
        } else {
            this.clubController.showClubPanel(data[0], data[1])
        }
    },
    clear: function() {},
});
var ____2159 = KYPanel.extend({
    ____1803: null,
    ____1102: null,
    ____1103: null,
    ____1104: null,
    ____1105: null,
    _inputController: null,
    ____1479: null,
    ____1481: null,
    ____920: null,
    ____921: null,
    ____1398: 12,
    _controller: null,
    ctor: function(controller) {
        this._super("clubCreationView.ExportJson");
        this._controller = controller;
        this.____1803 = this.getChildByName("tittleLabel");
        this.____1102 = this.getChildByName("desLabel1_Copy0");
        this.____1102.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text1"));
        this.____1103 = this.getChildByName("desLabel2");
        this.____1104 = this.getChildByName("desLabel3");
        this.____1104.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text2"));
        this.____1105 = this.getChildByName("desLabel4");
        this.____1105.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text3"));
        this.____1479 = this.getChildByName("okBtn__1");
        this.____1481 = this.____1479.getChildByName("btnLabel");
        this.____1481.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text4"));
        this.____920 = this.getChildByName("calBtn__1");
        this.____921 = this.____920.getChildByName("btnLabel");
        this.____921.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text5"));
        var layer = this.getChildByName("labelLayer");
        this._inputController = new InputLabelController(____654.____673.____159(0, 15), layer.getContentSize(), layer, this.____1398, 20, ____654.yuyanbaoManager.getYuyanbao("____2159.text6"));
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.____1103.setVisible(true);
        this.____1104.setVisible(true);
        this.____1103.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text8", 200))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1479) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                var playerVipLevel = ____655.____667.vipLevel;
                if (____655.____667.moneyInfo.money1Enough(200)) {
                    this.creatClub()
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
            } else if (sender == this.____920) {
                this._controller.hideCreationView()
            }
        }
    },
    creatClub: function() {
        var clubName = this._inputController.getString();
        if (clubName == null || clubName == "") {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2159.text9"));
            return
        }
        var nameLen = ____655.wordFiltersInfo.getStringLen(clubName);
        if (nameLen > 10) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2159.text10"));
            return
        } else if (nameLen < 4) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2159.text11"));
            return
        }
        if (____655.wordFiltersInfo.checkName(clubName)) {
            ____654.clubMessageSender.sendClubCreate(this._inputController.getString())
        } else {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("start.loginTips8"))
        }
    },
    ____6: function() {
        this.____1479.addListener(this, this.____16);
        this.____920.addListener(this, this.____16)
    },
    removewEvent: function() {},
    dispose: function() {
        this.removewEvent();
        this._super();
        this._controller = null;
        this.____1803 = null;
        this.____1102 = null;
        this.____1103 = null;
        this.____1104 = null;
        this.____1105 = null;
        this.____1479 = null;
        this.____1481 = null;
        this.____920 = null;
        this.____921 = null;
        if (this._inputController != null) {
            this._inputController.dispose();
            this._inputController = null
        }
    },
});
var ____2160 = KYPanel.extend({
    _controller: null,
    ____1776: null,
    ____1740: null,
    ____1737: null,
    ____1738: null,
    _panelList: null,
    ____1054: null,
    ____1783: null,
    ctor: function(controller, index) {
        this._super("clubPanel.ExportJson");
        this._controller = controller;
        this.____1776 = this.getChildByName("tipBtn");
        this.____1740 = this.getChildByName("tabLayer");
        this.____1783 = this.getChildByName("tipLabel");
        this.____1783.setString(____654.yuyanbaoManager.getYuyanbao("____2160.text1"));
        this._panelList = {};
        this.____5(index);
        this.____6();
        this.popUpdate()
    },
    ____5: function(index) {
        this.____1738 = [
            [1, ____654.yuyanbaoManager.getYuyanbao("____2160.text2"), "icon/ui_leagueIcon1.png", true],
            [2, ____654.yuyanbaoManager.getYuyanbao("____2160.text3"), "icon/ui_leagueIcon2.png", true],
            [3, ____654.yuyanbaoManager.getYuyanbao("____2160.text4"), "icon/ui_leagueIcon3.png", true],
            [4, ____654.yuyanbaoManager.getYuyanbao("____2160.text5"), "icon/ui_leagueIcon4.png", true],
            [5, ____654.yuyanbaoManager.getYuyanbao("____2160.text6"), "icon/ui_leagueIcon5.png", true],
            [6, ____654.yuyanbaoManager.getYuyanbao("____2160.text7"), "icon/ui_leagueIcon6.png", true],
        ];
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(540);
        this.____1740.addChild(this.____1737);
        if (index == null || index == 0) {
            index = 1
        }
        this.____1737.setTabIndex(index - 1)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1776) {
                ____654.tipsManager.showStringTip(____654.____682.____108("10075"), 500)
            }
        }
    },
    ____6: function() {
        this.____1776.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 22) {
            this.____1737.setShowPop(3, ____654.playerInfoTester.clubXinfaNum > 0)
        }
        if (type == 0 || type == 23) {
            this.____1737.setShowPop(4, ____654.playerInfoTester.clubExpeditionNum > 0)
        }
        if (type == 0 || type == 24) {
            this.____1737.setShowPop(6, ____654.playerInfoTester.clubTreeNum > 0)
        }
    },
    changeTabIndexHandler: function(evt) {
        if (this.getParent() != null) {
            var index = evt.data;
            this.____1737.setTabIndex(index)
        }
    },
    setTab: function(tab) {
        if (this.____1054 != null) {
            this.____1054.removeFromParent(false)
        }
        this.____1054 = this.getPanel(tab);
        if (this.____1054 != null && this.____1054.getParent() == null) {
            this.addChild(this.____1054)
        }
    },
    getPanel: function(tab) {
        var panel = this._panelList[tab];
        if (panel == null) {
            if (tab == 1) {
                panel = new ____2172(this._controller)
            } else if (tab == 2) {
                panel = new ____2174(this._controller)
            } else if (tab == 3) {
                panel = new ____2178(this._controller)
            } else if (tab == 4) {
                panel = new ____2170(this._controller)
            } else if (tab == 5) {
                panel = new ____2166(this._controller)
            } else if (tab == 6) {
                panel = new ____2171(this._controller)
            }
            this._panelList[tab] = panel
        }
        return panel
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1776 = null;
        this.____1740 = null;
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        this.____1738 = null;
        if (this._panelList != null) {
            for (var i in this._panelList) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        this.____1054 = null;
        this._super()
    },
});
var ____2161 = KYNode.extend({
    ____1579: null,
    ____984: null,
    ____1296: null,
    ____1729: null,
    _numLabel: null,
    _tipsLabel: null,
    ____1586: null,
    ____892: null,
    ____1044: null,
    ctor: function() {
        this._super("clubRequteItem.ExportJson");
        this.____1579 = this.getChildByName("rankLabel");
        this.____984 = this.getChildByName("clubName");
        this.____1296 = this.getChildByName("joyerName");
        this.____1729 = this.getChildByName("strengthLabel");
        this._numLabel = this.getChildByName("numLabel");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text6"));
        this._tipsLabel.setColor(____655.____659.____688.green);
        this.____1586 = this.getChildByName("requteBtn__1");
        this.____1586.setVisible(false);
        this.____892 = this.____1586.getChildByName("btnLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text4"));
        this.____6()
    },
    ____18: function(info, index) {
        if (info == null) {
            this.____1579.setString("");
            this.____984.setString("");
            this.____1296.setString("");
            this.____1729.setString("");
            this._numLabel.setString("");
            this._tipsLabel.setString("");
            this.____1586.setVisible(false)
        } else {
            this.____1044 = info;
            this.____1579.setString(index);
            this.____984.setString(info.clubName);
            this.____1296.setString(info.masterName);
            this.____1729.setString(info.totalFight);
            this._numLabel.setString(info.memberCount + "/" + ____655.clubItemList.clubMemberNums);
            if (info.memberCount >= ____655.clubItemList.clubMemberNums) {
                this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text5"));
                this._tipsLabel.setColor(____655.____659.____688.red);
                this.____1586.setVisible(false)
            } else {
                if (____655.clubInfo.selfRequteList.indexOf(info.clubId) == -1) {
                    this.____1586.setVisible(true)
                } else {
                    this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text6"));
                    this._tipsLabel.setColor(____655.____659.____688.green);
                    this.____1586.setVisible(false)
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1586) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                if (____655.clubInfo.selfRequteNum < 5) {
                    this.____1586.setVisible(false);
                    ____654.clubMessageSender.sendApplyClub(this.____1044.clubId)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2162.text7"))
                }
            }
        }
    },
    ____6: function() {
        this.____1586.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._super();
        this.____1579 = null;
        this.____984 = null;
        this.____1296 = null;
        this.____1729 = null;
        this._numLabel = null;
        this._tipsLabel = null;
        this.____1586 = null;
        this.____892 = null
    },
});
var ____2162 = KYPanel.extend({
    _controller: null,
    ____1094: null,
    ____1351: null,
    ____1336: null,
    ____1593: null,
    ____1551: null,
    ____1294: null,
    ____1025: null,
    ____1295: null,
    ____1026: null,
    currentPage: 1,
    totalPage: 0,
    itemList: null,
    createPanel: null,
    ____1789: null,
    ____1790: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("clubRequteView.ExportJson");
        this._controller = controller;
        this.____1094 = this.getChildByName("delLabel");
        this.____1094.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text1"));
        this.____1351 = this.getChildByName("listLayer");
        this.____1336 = this.getChildByName("leftBtn");
        this.____1593 = this.getChildByName("rightBtn");
        this.____1551 = this.getChildByName("progressLabel");
        this.____1294 = this.getChildByName("joinBtn__1");
        this.____1295 = this.____1294.getChildByName("btnLabel");
        this.____1295.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text2"));
        this.____1789 = this.getChildByName("tipsLabel1");
        this.____1790 = this.getChildByName("tipsLabel2");
        this.____1789.setVisible(false);
        this.____1790.setVisible(false);
        this.____1025 = this.getChildByName("createBtn__1");
        this.____1026 = this.____1025.getChildByName("btnLabel");
        this.____1026.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text3"));
        ____654.clubMessageSender.sendClubList(this.currentPage, ____655.clubItemList.pageCount);
        ____654.clubMessageSender.sendRequteClubInfo();
        this.itemList = [];
        this.____6();
        this.____5()
    },
    ____5: function() {
        var selfLevel = ____655.____667.level;
        if (selfLevel >= 65) {
            this.____1294.setVisible(true)
        } else {
            this.____1294.setVisible(false)
        }
        for (var i = 0; i < ____655.clubItemList.pageCount; i++) {
            var item = new ____2161();
            item.setPosition(2, 380 - i * 76);
            this.____1351.addChild(item);
            this.itemList.push(item)
        }
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1294) {
                ____654.clubMessageSender.sendClubAutoJoin()
            } else if (sender == this.____1025) {
                if (this.createPanel == null) {
                    this._controller.showCreationView()
                }
            } else if (sender == this.____1336) {
                if (this.currentPage >= 2) {
                    ____654.clubMessageSender.sendClubList(this.currentPage - 1, ____655.clubItemList.pageCount)
                }
            } else if (sender == this.____1593) {
                if (this.currentPage < this.totalPage) {
                    ____654.clubMessageSender.sendClubList(this.currentPage + 1, ____655.clubItemList.pageCount)
                }
            }
        }
    },
    ____6: function() {
        this.____1294.addListener(this, this.____16);
        this.____1025.addListener(this, this.____16);
        this.____1336.addListener(this, this.____16);
        this.____1593.addListener(this, this.____16);
        ____655.clubItemList.addEventListener(____655.____661.club_list_update, this.setClubListInfo, this);
        ____655.clubInfo.addEventListener(____655.____661.club_RequteInfo, this.setClubListInfo, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this.____1789.setVisible(true);
            this.____1790.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    setClubListInfo: function(evt) {
        this.____1789.setVisible(false);
        this.____1790.setVisible(false);
        ____654.____678.____299(this.showTick, this);
        if (evt.data != null) {
            this.currentPage = Math.ceil(evt.data / 6)
        } else {
            this.currentPage = 1
        }
        this.totalPage = Math.ceil(____655.clubItemList.totalClubCount / ____655.clubItemList.pageCount);
        this.____1551.setString(this.currentPage + "/" + this.totalPage);
        var num = 0;
        if (this.currentPage < this.totalPage) {
            num = 6
        } else {
            num = (____655.clubItemList.totalClubCount - 1) % ____655.clubItemList.pageCount + 1
        }
        for (var i = 1; i <= 6; i++) {
            if (num < i) {
                this.itemList[i - 1].____18()
            } else {
                var index = (this.currentPage - 1) * 6 + i;
                this.itemList[i - 1].____18(____655.clubItemList.clubList[index], index)
            }
        }
    },
    ____17: function() {
        ____655.clubItemList.removeEventListener(____655.____661.club_list_update, this.setClubListInfo, this);
        ____655.clubInfo.removeEventListener(____655.____661.club_RequteInfo, this.setClubListInfo, this)
    },
    dispose: function() {
        ____654.____678.____299(this.showTick, this);
        this._controller.hideCreationView();
        this._controller = null;
        this.____17();
        this.____1094 = null;
        this.____1351 = null;
        this.____1336 = null;
        this.____1593 = null;
        this.____1551 = null;
        this.____1294 = null;
        this.____1295 = null;
        this.____1025 = null;
        this.____1026 = null;
        this.____1789 = null;
        this.____1790 = null;
        for (var i = 0; i < this.itemList.length; i++) {
            if (this.itemList[i] != null) {
                this.itemList[i].dispose()
            }
        }
        this.itemList = null;
        this._super()
    },
});
var ____2163 = KYNode.extend({
    _bg: null,
    ____1427: null,
    _bgPath: null,
    ____1413: null,
    ____944: null,
    _characterInfo: null,
    ctor: function(missionTemplateInfo) {
        this._super("clubBossItemView.ExportJson");
        this.____1413 = missionTemplateInfo;
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/league_bossBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1427 = this.getChildByName("monsterName");
        this.____5()
    },
    ____5: function() {
        var monsterInfo = ____655.allTemplates.monsterTemplateList.getMonster(this.____1413.bossId);
        if (this.____944 != null) {
            this.____944.dispose();
            this._characterInfo.dispose();
            this.____944 = null;
            this._characterInfo = null
        }
        if (monsterInfo != null) {
            this._characterInfo = ____654.getCharacterInfo(monsterInfo.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.bottom, this);
            if (this.____1413.bossId == 901401) {
                this.____944.move(105, 82)
            } else if (this.____1413.bossId == 901402) {
                this.____944.move(105, 108)
            } else if (this.____1413.bossId == 901403) {
                this.____944.move(105, 112)
            }
            this.____1427.setString(monsterInfo.name)
        }
    },
    ____6: function() {},
    ____17: function() {},
    dispose: function() {
        this.____17();
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg)
        }
        this._bg = null;
        this._bgPath = null;
        this.____1427 = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this._characterInfo.dispose();
            this.____944 = null;
            this._characterInfo = null
        }
        this.____1413 = null;
        this._super()
    },
});
var ____2164 = KYNode.extend({
    _itemInfo: null,
    _grid: null,
    _numLabel: null,
    ____1472: null,
    ____937: null,
    _gridList: null,
    ____1241: null,
    ctor: function(index, itemInfo) {
        this._super("clubBossRankItem.ExportJson");
        this._itemInfo = itemInfo;
        this.____1241 = index;
        this.____937 = [];
        this._gridList = [];
        for (var i = 0; i < 5; i++) {
            this.____937.push(this.getChildByName("cellLayer" + (i + 1)));
            var grid = new ____2129();
            this.____937[i].addChild(grid);
            this._gridList.push(grid)
        }
        this.____1472 = this.getChildByName("numIcon");
        this._numLabel = this.getChildByName("numLabel");
        this.____5()
    },
    ____5: function() {
        if (this.____1241 == 0) {
            this.____1472.setFrame("flag/ui_rankNo1.png");
            this.____1472.setVisible(true)
        } else if (this.____1241 == 1) {
            this.____1472.setFrame("flag/ui_rankNo2.png");
            this.____1472.setVisible(true)
        } else if (this.____1241 == 2) {
            this.____1472.setFrame("flag/ui_rankNo3.png");
            this.____1472.setVisible(true)
        } else {
            this.____1472.setVisible(false);
            if (this._itemInfo.minLevel == this._itemInfo.maxLevel) {
                this._numLabel.setString(this._itemInfo.minLevel)
            } else {
                this._numLabel.setString(this._itemInfo.minLevel + "-" + this._itemInfo.maxLevel)
            }
        }
        for (var i = 0; i < this._itemInfo.awardList.length; i++) {
            var itemTempInfo = ____655.allTemplates.____794.getItem(this._itemInfo.awardList[i][0]);
            this._gridList[i].setItemTemplateInfo(itemTempInfo);
            this._gridList[i].setCount(this._itemInfo.awardList[i][1])
        }
    },
    dispose: function() {
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        this._itemInfo = null;
        this.____1472 = null;
        this._numLabel = null;
        this.____937 = null;
        this._super()
    },
});
var ClubBossRankView = KYPanel.extend({
    _controller: null,
    ____1803: null,
    _closeBtn: null,
    _listView: null,
    _itemList: null,
    _line2: null,
    ctor: function(controller) {
        this._super("clubBossRankView.ExportJson");
        this._controller = controller;
        this.____1803 = this.getChildByName("tittleLabel");
        this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text4"));
        this._closeBtn = this.getChildByName("closeBtn");
        this._listView = this.getChildByName("listView");
        this._line2 = this.getChildByName("line2");
        this._itemList = [];
        this.____5();
        this.____6()
    },
    ____5: function() {
        var templateList = ____655.allTemplates.rankAwardTemplateList.getTypeList(17);
        if (templateList != null && templateList.length > 0) {
            for (var i = 0; i < templateList.length; i++) {
                if (templateList[i].stage <= 0) {
                    var item = new ____2164(i, templateList[i]);
                    this._listView.pushBackItem(item);
                    this._itemList.push(item)
                }
            }
            this._listView.setScrollBarEnabled(false)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this._controller.hideClubBossRankView()
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16)
    },
    ____17: function() {},
    hideFormContainer: function() {
        this._controller.hideClubBossRankView()
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1803 = null;
        this._closeBtn = null;
        this._listView = null;
        if (this._itemList != null && this._itemList.length > 0) {
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose()
            }
            this._itemList = null
        }
        this._line2 = null;
        this._super()
    },
});
var ____2166 = KYPanel.extend({
    _controller: null,
    ____937: null,
    ____1789: null,
    ____1790: null,
    ____1480: null,
    ____892: null,
    _listView: null,
    _gridList: null,
    _itemList: null,
    ____1776: null,
    ctor: function(controller) {
        this._super("clubBossView.ExportJson");
        this._controller = controller;
        this.____937 = [];
        this._gridList = [];
        for (var i = 0; i < 5; i++) {
            this.____937.push(this.getChildByName("cellLayer" + (i + 1)));
            var grid = new ____2129();
            grid.setIsShowCount(false);
            this.____937[i].addChild(grid);
            this._gridList.push(grid)
        }
        this.____1789 = this.getChildByName("tipsLabel1");
        this.____1789.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text1"));
        this.____1790 = this.getChildByName("tipsLabel2");
        this.____1790.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text2"));
        this.____1480 = this.getChildByName("OKBtn__1");
        this.____892 = this.____1480.getChildByName("btnLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text3"));
        this._listView = this.getChildByName("cellList");
        this.____1776 = this.getChildByName("tipBtn");
        this.____1783 = this.getChildByName("tipLabel");
        this.____1783.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text4"));
        this._itemList = [];
        this.____6();
        this.____5();
        this.updateView()
    },
    ____5: function() {
        var awardlist = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID).missions[0].awards[0];
        var len = awardlist.length;
        if (len > 5) {
            len = 5
        }
        for (i = 0; i < len; i++) {
            var info = ____655.allTemplates.____794.getItem(awardlist[i][0]);
            this._gridList[i].setItemTemplateInfo(info)
        }
        var missionTemplateInfoList = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID).missions;
        for (var i = 0; i < 3; i++) {
            var item = new ____2163(missionTemplateInfoList[i]);
            this._listView.addChild(item);
            item.setPosition(____654.____673.____159(2 + (i * 220), 2));
            this._itemList.push(item)
        }
    },
    updateView: function() {
        var clubBossState = ____655.clubInfo.clubBossState;
        if (clubBossState == 0) {
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text3"));
            ____654.____674.setKYBtnEnabled(this.____1480, true, 1)
        } else if (clubBossState == 1) {
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text5"));
            ____654.____674.setKYBtnEnabled(this.____1480, true, 2)
        } else if (clubBossState == 2) {
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text5"));
            ____654.____674.setKYBtnEnabled(this.____1480, true, 2)
        } else if (clubBossState == 3) {
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text6"));
            ____654.____674.setKYBtnEnabled(this.____1480, false, 0)
        }
    },
    ____16: function(sender, eventType) {
        function okClick() {
            var wealth = ____655.clubInfo.wealth;
            if (wealth >= 2000) {
                ____654.clubMessageSender.sendClubBossStartCopy()
            } else {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2166.text7"))
            }
        }
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var clubBossState = ____655.clubInfo.clubBossState;
            var clubJob = ____655.____667.clubJob;
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1480) {
                if (clubBossState == 0) {
                    if (clubJob > 0) {
                        ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2166.text8"), null, 0, this, okClick, null, null)
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2166.text9"))
                    }
                } else if (clubBossState == 1 || clubBossState == 2) {
                    ____654.copyMessageSender.sendEnterCopy(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID, 0)
                }
            } else if (sender == this.____1776) {
                this._controller.showClubBossRankView()
            }
        }
    },
    ____6: function() {
        this.____1480.addListener(this, this.____16);
        this.____1776.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_bossInfoUpdate, this.updateView, this)
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_bossInfoUpdate, this.updateView, this)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____937 = null;
        this.____1789 = null;
        this.____1790 = null;
        this.____1480 = null;
        this.____892 = null;
        this._listView = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        this._itemList = null;
        this.____1776 = null;
        this._super()
    },
});
var ____2167 = KYNode.extend({
    ____1643: null,
    ____1356: null,
    _numLabel: null,
    ____1218: null,
    ____879: null,
    ____1357: null,
    ____1504: null,
    ctor: function() {
        this._super("clubExpeditionItem.ExportJson");
        this.____1643 = this.getChildByName("selectView");
        this.____1357 = this.getChildByName("progressBg__1");
        this.____1356 = this.getChildByName("loadingBar");
        this._numLabel = this.getChildByName("numLabel");
        this.____1218 = this.getChildByName("haskillImg");
        this.____879 = this.getChildByName("bossIcon")
    },
    ____6: function() {},
    ____18: function(info) {
        if (info == null) {
            this.____1356.setVisible(false);
            this._numLabel.setVisible(false);
            this.____1357.setVisible(false);
            this.____1218.setVisible(false);
            this.____879.setVisible(false)
        } else {
            if (this.____1504 != null) {
                ____654.____677.removeImageQuote(this.____1504, this.____879);
                this.____1504 = null
            }
            this.____1356.setVisible(true);
            this._numLabel.setVisible(true);
            this.____879.setVisible(true);
            this.____1357.setVisible(true);
            var monsterTemplateInfo = ____655.allTemplates.monsterTemplateList.getMonster(info.bossId);
            this.____1504 = ____654.____675.getMonsterHead(monsterTemplateInfo.headPath);
            ____654.____677.____146(this.____879, this.____1504)
        }
    },
    setLoadingBg: function(isShow) {
        this.____1356.setVisible(isShow);
        this._numLabel.setVisible(isShow);
        this.____1357.setVisible(isShow)
    },
    setLodingPrecent: function(pre) {
        this._numLabel.setString(pre + "%");
        this.____1356.setPercent(pre)
    },
    setSelectItem: function(isShow) {
        this.____1643.setVisible(isShow)
    },
    hasKilledItem: function(isKill) {
        this.____1218.setVisible(isKill)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this.____1643 = null;
        this.____1356 = null;
        this._numLabel = null;
        this.____1218 = null;
        this.____1357 = null;
        if (this.____1504 != null) {
            ____654.____677.removeImageQuote(this.____1504, this.____879);
            this.____1504 = null
        }
        this.____879 = null;
        this._super()
    },
});
var ____2168 = KYNode.extend({
    ____1822: null,
    ____1240: null,
    ____1820: null,
    ____851: null,
    ____1699: null,
    ____1480: null,
    ____892: null,
    ____1784: null,
    ____1785: null,
    ____1786: null,
    ____1215: 0,
    ____1653: null,
    ____1730: null,
    ____1787: null,
    _controller: null,
    ctor: function(hardId, controller) {
        this._super("clubExpeditionRestItem.ExportJson");
        this._controller = controller;
        this.____1822 = this.getChildByName("typeImg");
        this.____1215 = hardId;
        if (this.____1215 == 0) {
            this.____1240 = ____654.____675.____139("outPic/clubExpeditionBgHard1.png")
        } else if (this.____1215 == 1) {
            this.____1240 = ____654.____675.____139("outPic/clubExpeditionBgHard2.png")
        } else if (this.____1215 == 2) {
            this.____1240 = ____654.____675.____139("outPic/clubExpeditionBgHard3.png")
        } else if (this.____1215 == 3) {
            this.____1240 = ____654.____675.____139("outPic/clubExpeditionBgHard4.png")
        } else if (this.____1215 == 4) {
            this.____1240 = ____654.____675.____139("outPic/clubExpeditionBgHard5.png")
        }
        ____654.____677.____146(this.____1822, this.____1240);
        this.____1820 = this.getChildByName("typeDel");
        this.____851 = this.getChildByName("awardLabel");
        this.____896 = this.getChildByName("btnLayer");
        this.____1699 = this.getChildByName("btnLayer").getChildByName("spentNum");
        this.____1480 = this.getChildByName("btnLayer").getChildByName("OKBtn__1");
        this.____892 = this.getChildByName("btnLayer").getChildByName("btnLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text2"));
        this.____1787 = this.getChildByName("tipLayer");
        this.____1784 = this.getChildByName("tipLayer").getChildByName("label1");
        this.____1784.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text1"));
        this.____1785 = this.getChildByName("tipLayer").getChildByName("label2");
        this.____1785.setString("");
        this.____1786 = this.getChildByName("tipLayer").getChildByName("label3");
        this.____1653 = [4000, 6000, 8000, 10000, 12000];
        this.____1730 = [350000, 1750000, 3500000, 7000000, 17500000];
        this.____5();
        this.____6()
    },
    ____5: function() {
        var clubExpeditionCopyId = ____655.allTemplates.copyTemplateList.clubExpeditionCopyList[this.____1215];
        var copyTempLateInfo = ____655.allTemplates.copyTemplateList.copyList[clubExpeditionCopyId];
        var clubStrength = ____655.clubInfo.fight;
        if (clubStrength >= copyTempLateInfo.clubFight) {
            this.____896.setVisible(true);
            this.____1787.setVisible(false);
            this.____1699.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text2", this.____1653[this.____1215]));
            if (____655.clubInfo.wealth >= this.____1653[this.____1215]) {
                this.____1699.setColor(____655.____659.____688.itemColorList[0])
            } else {
                this.____1699.setColor(____655.____659.____688.red)
            }
        } else {
            this.____896.setVisible(false);
            this.____1787.setVisible(true);
            this.____1786.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text3", this.____1730[this.____1215] * 0.0001))
        }
        if (this.____1215 == 0) {
            this.____1820.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text4"));
            this.____851.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text5", 100))
        } else if (this.____1215 == 1) {
            this.____1820.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text6"));
            this.____851.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text5", 150))
        } else if (this.____1215 == 2) {
            this.____1820.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text7"));
            this.____851.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text5", 200))
        } else if (this.____1215 == 3) {
            this.____1820.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text8"));
            this.____851.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text5", 250))
        } else if (this.____1215 == 4) {
            this.____1820.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text9"));
            this.____851.setString(____654.yuyanbaoManager.getYuyanbao("____2168.text5", 300))
        }
    },
    ____16: function(sender, eventType) {
        function okClick() {
            ____654.clubMessageSender.sendClubExpeditionRest(____655.allTemplates.copyTemplateList.clubExpeditionCopyList[this.____1215]);
            this._controller.hideClubExpeditionRestView()
        }
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1480) {
                var clubExpeditionCopyId = ____655.allTemplates.copyTemplateList.clubExpeditionCopyList[this.____1215];
                var copyTempLateInfo = ____655.allTemplates.copyTemplateList.getCopy(clubExpeditionCopyId);
                if (____655.clubInfo.bossExpeditionRestNum > 0) {
                    if (____655.clubInfo.wealth >= this.____1653[this.____1215]) {
                        ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2168.text11", this.____1653[this.____1215], copyTempLateInfo.name), null, 0, this, okClick, null, null)
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2166.text7"))
                    }
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2168.text10"))
                }
            }
        }
    },
    ____6: function() {
        this.____1480.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        ____654.____677.removeImageQuote(this.____1240, this.____1822);
        this.____1240 = null;
        this.____1822 = null;
        this.____1820 = null;
        this.____851 = null;
        this.____1699 = null;
        this.____1480 = null;
        this.____892 = null;
        this.____1784 = null;
        this.____1785 = null;
        this.____1786 = null;
        this.____1215 = null;
        this.____1215 = null;
        this.____1653 = null;
        this.____1730 = null;
        this.____1787 = null;
        this.____896 = null;
        this._super()
    },
});
var ClubExpeditionRestView = KYPanel.extend({
    _controller: null,
    _titleLabel: null,
    _numLabel: null,
    _closeBtn: null,
    _listView: null,
    ____1350: null,
    ____1008: 0,
    ctor: function(controller, copyId) {
        this._super("clubExpeditionRestView.ExportJson");
        this._controller = controller;
        this._titleLabel = this.getChildByName("titleLabel");
        this._titleLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text11"));
        this._numLabel = this.getChildByName("numLabel");
        this._closeBtn = this.getChildByName("closeBtn");
        this._listView = this.getChildByName("listView");
        this.____1350 = [];
        this.____1008 = copyId;
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (this.____1350 != null) {
            this._listView.removeAllItems()
        }
        for (var i = 0; i < this.____1350.length; i++) {
            this.____1350[i].dispose()
        }
        this.____1350 = [];
        for (var i = 0; i < 5; i++) {
            var item = new ____2168(i, this._controller);
            this._listView.pushBackItem(item);
            this.____1350.push(item)
        }
        this._listView.setScrollBarEnabled(false);
        this._numLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text12", ____655.clubInfo.bossExpeditionRestNum))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this._controller.hideClubExpeditionRestView()
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_expeditionBossHp, this.____5, this)
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_expeditionBossHp, this.____5, this)
    },
    dispose: function() {
        this._controller = null;
        this.____17();
        this._titleLabel = null;
        this._numLabel = null;
        this._closeBtn = null;
        this._listView = null;
        for (var i = 0; i < this.____1350.length; i++) {
            this.____1350[i].dispose()
        }
        this.____1350 = null;
        this.____1215 = null;
        this.____1008 = null;
        this._super()
    },
});
var ____2170 = KYPanel.extend({
    ____1480: null,
    ____892: null,
    _numLabel: null,
    ____935: null,
    _bg: null,
    _bgPath: null,
    _itemList: null,
    ____1288: null,
    _gridList: null,
    ____884: null,
    ____1588: null,
    ____1589: null,
    _controller: null,
    ____854: null,
    delta: 0,
    ctor: function(controller) {
        this._super("clubExpeditionView.ExportJson");
        this._controller = controller;
        this.____1480 = this.getChildByName("OKBtn__1");
        this.____892 = this.____1480.getChildByName("btnLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2166.text5"));
        this._numLabel = this.getChildByName("numLabel");
        this.____935 = [];
        this._gridList = [];
        for (var i = 0; i < 4; i++) {
            this.____935.push(this.getChildByName("cellLayer" + (i + 1)));
            var grid = new ____2129();
            grid.setIsShowCount(false);
            this.____935[i].addChild(grid);
            this._gridList.push(grid)
        }
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/clubExpeditionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._itemList = [];
        this.____1288 = [];
        for (var i = 0; i < 9; i++) {
            this._itemList.push(this.getChildByName("bossItem" + (i + 1)));
            var item = new ____2167();
            this._itemList[i].addChild(item);
            this.____1288.push(item)
        }
        this.____884 = this.getChildByName("boxIcon");
        this.____1588 = this.getChildByName("resetBtn__1");
        this.____1588.setVisible(false);
        this.____1589 = this.____1588.getChildByName("titleLabel");
        this.____1589.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text2"));
        this.____1803 = this.getChildByName("tittleLabel");
        ____654.clubMessageSender.sendGetClubExpeditionBossInfo();
        this.____6();
        this.currentCopyId = 0;
        this.currentCopyIndex = 0;
        this.currentMissionIndex = 0;
        this.currentMissionId = 0;
        this.delta = 0;
        this.____854 = [];
        this.____5()
    },
    ____5: function() {
        var bossMissionList = ____655.clubInfo.bossMissionList;
        var currentCopyTempInfo = null;
        var currentMissionTempInfo = null;
        var missionList = [];
        for (var copyId in bossMissionList) {
            this.currentCopyId = copyId
        }
        if (this.currentCopyId == 0) {
            this.currentCopyId = ____655.allTemplates.copyTemplateList.clubExpeditionCopyList[0];
            this.currentCopyIndex = 0;
            this.currentMissionIndex = 0;
            currentCopyTempInfo = ____655.allTemplates.copyTemplateList.getCopy(this.currentCopyId);
            missionList = currentCopyTempInfo.missions;
            this.currentMissionId = missionList[0];
            for (var i = 0; i < 9; i++) {
                var missionTemplateInfo = missionList[i];
                this.____1288[i].____18(missionTemplateInfo);
                this.____1288[i].setLodingPrecent(100);
                if (i == this.currentMissionIndex) {
                    this.____1288[i].setSelectItem(true);
                    currentMissionTempInfo = missionList[i]
                } else {
                    this.____1288[i].setSelectItem(false)
                }
                if (this.currentMissionIndex < i) {
                    this.____1288[i].hasKilledItem(false);
                    this.____1288[i].setLoadingBg(false)
                } else if (this.currentMissionIndex == i) {
                    this.____1288[i].hasKilledItem(false);
                    this.____1288[i].setLoadingBg(true)
                } else {
                    this.____1288[i].hasKilledItem(true);
                    this.____1288[i].setLoadingBg(false)
                }
            }
        } else {
            currentCopyTempInfo = ____655.allTemplates.copyTemplateList.getCopy(this.currentCopyId);
            missionList = currentCopyTempInfo.missions;
            this.currentCopyIndex = ____655.allTemplates.copyTemplateList.clubExpeditionCopyList.indexOf(parseInt(this.currentCopyId));
            this.currentMissionId = bossMissionList[this.currentCopyId][0];
            for (var i = 0; i < 9; i++) {
                var missionTemplateInfo = missionList[i];
                this.____1288[i].____18(missionTemplateInfo);
                if (missionList[i].id == bossMissionList[this.currentCopyId][0]) {
                    this.currentMissionIndex = i;
                    this.____1288[i].setSelectItem(true);
                    currentMissionTempInfo = missionList[i]
                } else {
                    this.____1288[i].setSelectItem(false)
                }
                if (this.currentMissionId > missionList[i].id) {
                    this.____1288[i].hasKilledItem(true);
                    this.____1288[i].setLoadingBg(false)
                } else {
                    this.____1288[i].hasKilledItem(false);
                    if (this.currentMissionId == missionList[i].id) {
                        var totalBloor = missionList[i].recommendCombat;
                        var preBloor = 0;
                        if (i > 0) {
                            preBloor = missionList[i - 1].recommendCombat
                        }
                        var currentBoss = (totalBloor - preBloor);
                        var pre = Math.floor((currentBoss - Math.ceil(bossMissionList[this.currentCopyId][1] - preBloor)) / (totalBloor - preBloor) * 100);
                        if (pre > 100) {
                            pre = 100
                        } else if (pre <= 1) {
                            pre = 1
                        }
                        this.____1288[i].setLodingPrecent(pre);
                        this.____1288[i].setLoadingBg(true)
                    } else {
                        this.____1288[i].setLoadingBg(false);
                        this.____1288[i].setLodingPrecent(100)
                    }
                }
            }
        }
        this.____854 = missionList[8].awards[0];
        if (this.currentCopyIndex == 0) {
            this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text3"))
        } else if (this.currentCopyIndex == 1) {
            this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text4"))
        } else if (this.currentCopyIndex == 2) {
            this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text5"))
        } else if (this.currentCopyIndex == 3) {
            this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text6"))
        } else if (this.currentCopyIndex == 4) {
            this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text7"))
        }
        if (currentMissionTempInfo == null) {
            currentMissionTempInfo = missionList[8]
        }
        for (var i = 0; i < currentMissionTempInfo.firstAwards.length; i++) {
            var info = ____655.allTemplates.____794.getItem(currentMissionTempInfo.firstAwards[i][0]);
            this._gridList[i].setItemTemplateInfo(info)
        }
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.clubExpeditionCopyList[0]];
        var copyNum = 0;
        if (info != null) {
            copyNum = info.currentEnterCount
        }
        this.delta = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.clubExpeditionCopyList[0]).dayTimes - copyNum;
        this._numLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2170.text8", this.delta));
        if (this.currentMissionId > missionList[8].id) {
            if (____655.clubInfo.myJob > 0) {
                this.____1480.setVisible(false);
                this.____1588.setVisible(true)
            } else {
                this.____1480.setVisible(true);
                this.____1480.setFrame("btn/ui_btn1_4.png");
                this.____1480.setTouchEnabled(false);
                this.____1588.setVisible(false)
            }
        } else {
            this.____1588.setVisible(false);
            this.____1480.setVisible(true);
            this.____1480.setFrame("btn/ui_btn1_2.png");
            this.____1480.setTouchEnabled(true)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____884) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [____654.yuyanbaoManager.getYuyanbao("____2170.text9"), this.____854, ____654.yuyanbaoManager.getYuyanbao("____2170.text10"), false, null, null]))
            } else if (sender == this.____1480) {
                if (this.delta > 0) {
                    ____654.copyMessageSender.sendEnterCopy(this.currentCopyId, this.currentMissionIndex)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("WushenzhengbaPanel.text2"))
                }
            } else if (sender == this.____1588) {
                this._controller.showClubExpeditionRestView(this.currentCopyId)
            }
        }
    },
    ____6: function() {
        this.____884.addListener(this, this.____16);
        this.____1480.addListener(this, this.____16);
        this.____1588.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_expeditionBossHp, this.____5, this)
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_expeditionBossHp, this.____5, this)
    },
    dispose: function() {
        this.____17();
        this.____1480 = null;
        this.____892 = null;
        this._numLabel = null;
        this.____935 = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this._itemList = null;
        if (this.____1288 != null) {
            for (var i = 0; i < this.____1288.length; i++) {
                this.____1288[i].dispose()
            }
            this.____1288 = null
        }
        this.____1288 = null;
        this.____884 = null;
        this.____1588 = null;
        this.____1589 = null;
        this._controller = null;
        this.delta = 0;
        this._super()
    },
});
var ____2171 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    ____1094: null,
    ____885: null,
    ____1581: null,
    ____1356: null,
    ____1789: null,
    ____1790: null,
    _numLabel: null,
    _upBtn: null,
    ____1829: null,
    ____1195: 0,
    ____1194: null,
    ____1811: 0,
    ____1219: 0,
    _currentIndex: 0,
    _effectList: null,
    _effect1: null,
    _effect2: null,
    _effect3: null,
    _effect4: null,
    ctor: function(controller) {
        this._super("clubGodTreeView.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/league_tree.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1094 = this.getChildByName("delLabel");
        this.____885 = [];
        this.____1581 = [];
        for (var i = 1; i < 5; i++) {
            this.____885.push(this.getChildByName("box" + i));
            this.____1581.push(this.getChildByName("rate" + i))
        }
        this.____1356 = this.getChildByName("loadingBar");
        this.____1789 = this.getChildByName("tipsLabel1");
        this.____1789.setString(____654.yuyanbaoManager.getYuyanbao("____2171.text1"));
        this.____1790 = this.getChildByName("tipsLabel2");
        this.____1790.setString(____654.yuyanbaoManager.getYuyanbao("____2171.text2"));
        this._numLabel = this.getChildByName("numLabel");
        this._upBtn = this.getChildByName("upBtn__1");
        this.____1829 = this.getChildByName("titleLabel");
        this._effect1 = null;
        this._effect2 = null;
        this._effect3 = null;
        this._effect4 = null;
        this.____1194 = [];
        this.____5();
        this.____6();
        this.updateCountView()
    },
    updateCountView: function() {
        this.____1219 = ____655.itemInfoList.getCountByCategoryId(____655.____659.categoryType.XIANLU);
        this._numLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2171.text4", this.____1219))
    },
    ____5: function() {
        this.____1195 = ____655.clubInfo.godTreeNum;
        this.____1194 = ____655.clubInfo.godTreeAwardList;
        this.____1758 = ____655.allTemplates.clubTreeAwardTemplateList.list;
        this.____1811 = this.____1758[4].value;
        var per = Math.floor(this.____1195 / this.____1811 * 100);
        if (per > 100) {
            per = 100
        } else if (per <= 0) {
            per = 0
        }
        this.____1094.setString(____654.yuyanbaoManager.getYuyanbao("____2171.text3", per));
        this.____1356.setPercent(per);
        for (var i = 1; i <= 4; i++) {
            if (this.____1194[i] != null) {
                this.____1581[i - 1].setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn1"));
                this.____1581[i - 1].setColor(____655.____659.____688.gray);
                this.____885[i - 1].setFrame("icon/ui_boxIcon0.png");
                if (i == 1) {
                    if (this._effect1 != null) {
                        this._effect1.dispose();
                        this._effect1 = null
                    }
                } else if (i == 2) {
                    if (this._effect2 != null) {
                        this._effect2.dispose();
                        this._effect2 = null
                    }
                } else if (i == 3) {
                    if (this._effect3 != null) {
                        this._effect3.dispose();
                        this._effect3 = null
                    }
                } else if (i == 4) {
                    if (this._effect4 != null) {
                        this._effect4.dispose();
                        this._effect4 = null
                    }
                }
            } else {
                if (per >= 25 && i == 1) {
                    this.____1581[0].setString(____654.yuyanbaoManager.getYuyanbao("____2171.text5"));
                    this.____1581[0].setColor(____655.____659.____688.green);
                    if (this._effect1 == null) {
                        this._effect1 = new RotationEffect("effect/effect_10.png", 5);
                        this._effect1.move(this.____1356.getPositionX() + 78, this.____1356.getPositionY());
                        this.addChild(this._effect1, 6)
                    }
                } else if (per >= 50 && i == 2) {
                    this.____1581[1].setString(____654.yuyanbaoManager.getYuyanbao("____2171.text5"));
                    this.____1581[1].setColor(____655.____659.____688.green);
                    if (this._effect2 == null) {
                        this._effect2 = new RotationEffect("effect/effect_10.png", 5);
                        this._effect2.move(this.____1356.getPositionX() + 174, this.____1356.getPositionY());
                        this.addChild(this._effect2, 6)
                    }
                } else if (per >= 75 && i == 3) {
                    this.____1581[2].setString(____654.yuyanbaoManager.getYuyanbao("____2171.text5"));
                    this.____1581[2].setColor(____655.____659.____688.green);
                    if (this._effect3 == null) {
                        this._effect3 = new RotationEffect("effect/effect_10.png", 5);
                        this._effect3.move(this.____1356.getPositionX() + 269, this.____1356.getPositionY());
                        this.addChild(this._effect3, 6)
                    }
                } else if (per >= 100 && i == 4) {
                    this.____1581[3].setString(____654.yuyanbaoManager.getYuyanbao("____2171.text5"));
                    this.____1581[3].setColor(____655.____659.____688.green);
                    if (this._effect4 == null) {
                        this._effect4 = new RotationEffect("effect/effect_10.png", 5);
                        this._effect4.move(this.____1356.getPositionX() + 367, this.____1356.getPositionY());
                        this.addChild(this._effect4, 6)
                    }
                }
            }
        }
        for (var i = 0; i < 4; i++) {
            this.____885[i].setTouchEnabled(true);
            this.____885[i].addListener(this, this.boxClickHandler)
        }
    },
    boxClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            this._currentIndex = ____654.____674.____181(this.____885, sender);
            if (this._currentIndex != -1) {
                var info = this.____1758[this._currentIndex + 1];
                var title = "";
                if (this._currentIndex == 0) {
                    title = ____654.yuyanbaoManager.getYuyanbao("____2171.text6", 25)
                } else if (this._currentIndex == 1) {
                    title = ____654.yuyanbaoManager.getYuyanbao("____2171.text6", 50)
                } else if (this._currentIndex == 2) {
                    title = ____654.yuyanbaoManager.getYuyanbao("____2171.text6", 75)
                } else if (this._currentIndex == 3) {
                    title = ____654.yuyanbaoManager.getYuyanbao("____2171.text6", 100)
                }
                var canAccept = false;
                if (____655.clubInfo.godTreeAwardList[this._currentIndex + 1] == null) {
                    if (____655.clubInfo.godTreeNum >= info.value) {
                        canAccept = true
                    }
                }
                ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [title, info.items, null, canAccept, this.acceptHandler, this]))
            }
        }
    },
    acceptHandler: function() {
        if (this._currentIndex != -1) {
            var info = this.____1758[this._currentIndex + 1];
            if (____655.clubInfo.godTreeAwardList[this._currentIndex + 1] == null && ____655.clubInfo.godTreeNum >= info.value) {
                ____654.clubMessageSender.sendClubGodTreeGetAward(info.id)
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._upBtn) {
                var per = (this.____1195 / this.____1811 * 100);
                var delta = this.____1811 - this.____1195;
                var count = 0;
                if (per < 100) {
                    if (this.____1219 > 0) {
                        if (this.____1219 > delta) {
                            count = delta
                        } else {
                            count = this.____1219
                        }
                        ____654.clubMessageSender.sendClubGodTreeUp(count);
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2168.text12", count, count * 10))
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2171.text7"))
                    }
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2171.text8"))
                }
            }
        }
    },
    ____6: function() {
        this._upBtn.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_info_update, this.____5, this);
        ____655.clubInfo.addEventListener(____655.____661.club_myData_update, this.____5, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.updateCountView, this)
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_info_update, this.____5, this);
        ____655.clubInfo.removeEventListener(____655.____661.club_myData_update, this.____5, this);
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.updateCountView, this)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        if (this._effectList != null) {
            for (var i = 0; i < this._effectList.length; i++) {
                if (this._effectList[i] != null) {
                    this._effectList[i].dispose()
                }
            }
            this._effectList = null
        }
        this._bg = null;
        this.____1094 = null;
        this.____885 = null;
        this.____1581 = null;
        this.____1356 = null;
        this.____1789 = null;
        this.____1790 = null;
        this._numLabel = null;
        this._upBtn = null;
        this.____1829 = null;
        this.____1195 = null;
        this.____1194 = null, this.____1811 = null;
        this.____1219 = null;
        if (this._effect1 != null) {
            this._effect1.dispose();
            this._effect1 = null
        }
        if (this._effect2 != null) {
            this._effect2.dispose();
            this._effect2 = null
        }
        if (this._effect3 != null) {
            this._effect3.dispose();
            this._effect3 = null
        }
        if (this._effect4 != null) {
            this._effect4.dispose();
            this._effect4 = null
        }
        this._super()
    },
});
var ____2172 = KYPanel.extend({
    _controller: null,
    ____984: null,
    ____982: null,
    ____987: null,
    ____978: null,
    ____980: null,
    ____975: null,
    ____1860: null,
    ____986: null,
    ____859: null,
    ____860: null,
    ____1303: null,
    ____1304: null,
    ____1305: null,
    ____1306: null,
    ____1307: null,
    ____1308: null,
    ____1245: null,
    ____1246: null,
    ____1247: null,
    ____1248: null,
    ____1249: null,
    ____1250: null,
    ____1789: null,
    ____1790: null,
    ____1196: null,
    ____1197: null,
    ____1005: null,
    ____1006: null,
    _inputController: null,
    ____985: null,
    ____983: null,
    ____979: null,
    ____988: null,
    ____981: null,
    ____976: null,
    ____1192: null,
    detailLabel: null,
    ctor: function(controller) {
        this._super("clubInfoView.ExportJson");
        this._controller = controller;
        this.____984 = this.getChildByName("clubName");
        this.____984.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text1"));
        this.____982 = this.getChildByName("clubMemNums");
        this.____982.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text2"));
        this.____987 = this.getChildByName("clubStrength");
        this.____987.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text3"));
        this.____978 = this.getChildByName("clubLeader");
        this.____978.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text4"));
        this.____980 = this.getChildByName("clubMaintenance");
        this.____980.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text5"));
        this.____975 = this.getChildByName("clubFortune");
        this.____975.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text6"));
        this.____1860 = this.getChildByName("warmTipLabel");
        this.____986 = this.getChildByName("clubNotice");
        this.____986.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text7"));
        this.____859 = this.getChildByName("baocunBtn__1");
        this.____860 = this.getChildByName("btnLabel");
        this.____860.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text8"));
        this.____1303 = this.getChildByName("label1");
        this.____1303.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text9"));
        this.____1304 = this.getChildByName("label2");
        this.____1304.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text10"));
        this.____1305 = this.getChildByName("label3");
        this.____1305.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text11"));
        this.____1306 = this.getChildByName("label4");
        this.____1306.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text12"));
        this.____1307 = this.getChildByName("label5");
        this.____1307.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text13"));
        this.____1308 = this.getChildByName("label6");
        this.____1308.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text13"));
        this.____1245 = this.getChildByName("infoLabel1");
        this.____1246 = this.getChildByName("infoLabel2");
        this.____1247 = this.getChildByName("infoLabel3");
        this.____1248 = this.getChildByName("infoLabel4");
        this.____1249 = this.getChildByName("infoLabel5");
        this.____1250 = this.getChildByName("infoLabel6");
        this.____1789 = this.getChildByName("tipsLabel1");
        this.____1790 = this.getChildByName("tipsLabel2");
        this.____1196 = this.getChildByName("goldBtn__1");
        this.____1197 = this.____1196.getChildByName("btnLabel");
        this.____1197.setString("200");
        this.____1005 = this.getChildByName("coppeyBtn__1");
        this.____1006 = this.____1005.getChildByName("btnLabel");
        this.____1006.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text14", 10));
        this.detailLabel = this.getChildByName("clubDelLabel");
        this.____985 = this.getChildByName("clubNameLabel");
        this.____983 = this.getChildByName("clubMemNumsLabel");
        this.____979 = this.getChildByName("clubLeaderLabel");
        this.____988 = this.getChildByName("clubStrengthLabel");
        this.____981 = this.getChildByName("clubMaintenanceLabel");
        this.____976 = this.getChildByName("clubFortuneLabel");
        this.____1192 = this.getChildByName("giveUpIcon");
        this.getChildByName("tipsLabel11").setString(____654.yuyanbaoManager.getYuyanbao("____2172.text26"));
        this.getChildByName("btnLabel2").setString(____654.yuyanbaoManager.getYuyanbao("____2172.text30"));
        var layer = this.getChildByName("noticeLayer");
        this._inputController = new InputLabelController(____654.____673.____159(4, 89), this.getChildByName("clubDelLabel").getDimensions(), layer, 50, 18, "");
        this._inputController.setCallBack(this.attachHandler, this.detachHandler, this);
        this._inputController.setOpacity(0);
        ____654.clubMessageSender.sendClubInfo();
        this.____6()
    },
    ____5: function() {
        this.____1860.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text16"));
        this.____1790.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text17", (200 - ____655.clubInfo.totalCopperCount)));
        this.____985.setString(____655.clubInfo.name);
        this.____983.setString(____655.clubInfo.memberCount + "/" + ____655.clubItemList.clubMemberNums);
        this.____979.setString(____655.clubInfo.masterName);
        this.____988.setString(____655.clubInfo.fight);
        this.____981.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text18", 1000));
        this.____976.setString(____655.clubInfo.wealth);
        if (____655.clubInfo.descript != "" && ____655.clubInfo.descript != null) {
            this.detailLabel.setString(____655.clubInfo.descript);
            this._inputController.setString(____655.clubInfo.descript)
        } else {
            this.detailLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text15"));
            this._inputController.setString("")
        }
        if (____655.clubInfo.wealth <= 0) {
            this.____1860.setVisible(true)
        } else {
            this.____1860.setVisible(false)
        }
        if (____655.____667.clubJob <= 0 || (____655.____667.clubJob > 0 && ____655.____667.vipLevel < 3)) {
            this.____859.setVisible(false);
            this.____860.setVisible(false);
            this._inputController.setTouchEnabled(false)
        } else {
            this.____859.setVisible(true);
            this.____860.setVisible(true);
            this._inputController.setTouchEnabled(true)
        }
    },
    initBottomView: function() {
        this.____1245.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text19"));
        this.____1246.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text20", (5 - ____655.clubInfo.myCopperCount)));
        this.____1247.setString("2000");
        this.____1248.setString("100");
        this.____1249.setString("2000");
        this.____1250.setString("100");
        this.____1789.setString(____654.yuyanbaoManager.getYuyanbao("____2172.text21", 3))
    },
    ____16: function(sender, eventType) {
        function okClick() {
            ____654.clubMessageSender.sendClubLeave()
        }
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1196) {
                var playerVipLevel = ____655.____667.vipLevel;
                if (playerVipLevel >= 3) {
                    if (____655.____667.moneyInfo.money1Enough(200)) {
                        ____654.clubMessageSender.sendClubDevote(1)
                    } else {
                        ____655.____667.moneyInfo.showNotEnoughTip(1)
                    }
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2172.text22", 3))
                }
            } else if (sender == this.____1005) {
                var playerCoppey = ____655.____667.moneyInfo.list[2];
                if (5 - ____655.clubInfo.myCopperCount > 0) {
                    if (playerCoppey >= 10 * 10000) {
                        ____654.clubMessageSender.sendClubDevote(2)
                    } else {
                        ____654.tipsManager.quickTip.show(____655.____667.moneyInfo.showNotEnoughTip(3))
                    }
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2172.text23"))
                }
            } else if (sender == this.____859) {
                var clubName = this.detailLabel.getString();
                if (clubName == null || clubName == "") {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2172.text24"));
                    return
                }
                clubName = ____655.wordFiltersInfo.filtChat(clubName);
                if (clubName == null) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2172.text27"));
                    return
                }
                ____654.clubMessageSender.sendClubNoticeSave(clubName);
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2172.text28"))
            } else if (sender == this.____1192) {
                var selfLevel = ____655.____667.level;
                var str = "";
                if (selfLevel < 65) {
                    str = ____654.yuyanbaoManager.getYuyanbao("____2172.text29")
                } else {
                    str = ____654.yuyanbaoManager.getYuyanbao("____2172.text25")
                }
                ____655.getAlert().show(2, str, null, 0, this, okClick, null, null)
            }
        }
    },
    attachHandler: function() {
        this._inputController.setOpacity(255)
    },
    detachHandler: function() {
        this._inputController.setOpacity(0);
        var detail = this._inputController.getString();
        if (detail == "") {
            detail = ____654.yuyanbaoManager.getYuyanbao("____2172.text15")
        }
        this.detailLabel.setString(detail)
    },
    ____6: function() {
        this.____859.addListener(this, this.____16);
        this.____1196.addListener(this, this.____16);
        this.____1005.addListener(this, this.____16);
        this.____1192.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_info_update, this.____5, this);
        ____655.clubInfo.addEventListener(____655.____661.club_myData_update, this.initBottomView, this)
    },
    removewEvent: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_info_update, this.____5, this);
        ____655.clubInfo.removeEventListener(____655.____661.club_myData_update, this.initBottomView, this)
    },
    dispose: function() {
        this.removewEvent();
        this._super();
        this._controller = null;
        this.____984 = null;
        this.____982 = null;
        this.____987 = null;
        this.____978 = null;
        this.____980 = null;
        this.____975 = null;
        this.____1860 = null;
        this.____986 = null;
        this.____859 = null;
        this.____860 = null;
        this.____1303 = null;
        this.____1304 = null;
        this.____1305 = null;
        this.____1306 = null;
        this.____1307 = null;
        this.____1308 = null;
        this.____1245 = null;
        this.____1246 = null;
        this.____1247 = null;
        this.____1248 = null;
        this.____1249 = null;
        this.____1250 = null;
        this.____1789 = null;
        this.____1790 = null;
        this.____1196 = null;
        this.____1197 = null;
        this.____1005 = null;
        this.____1006 = null;
        this.____985 = null;
        this.____983 = null;
        this.____979 = null;
        this.____988 = null;
        this.____981 = null;
        this.____976 = null;
        this.____1192 = null;
        this.detailLabel = null;
        if (this._inputController != null) {
            this._inputController.dispose();
            this._inputController = null
        }
    },
});
var ____2173 = KYNode.extend({
    ____1472: null,
    ____1526: null,
    _vipLevel: null,
    ____1524: null,
    ____1519: null,
    ____1520: null,
    ____1528: null,
    ____1213: null,
    ____1046: -1,
    ctor: function() {
        this._super("clubMemberItemView.ExportJson");
        this.____1472 = this.getChildByName("numIcon");
        this.____1526 = this.getChildByName("playerName");
        this._vipLevel = this.getChildByName("vipLevel");
        this.____1524 = this.getChildByName("playerLevel");
        this.____1519 = this.getChildByName("playerDevote");
        this.____1520 = this.getChildByName("playerFight");
        this.____1528 = this.getChildByName("playerState");
        this.____1213 = this.getChildByName("handleBtn");
        this.____1213.setTouchEnabled(true);
        this.____6()
    },
    ____18: function(info) {
        if (info == null) {
            this.____1472.setVisible(false);
            this.____1526.setString("");
            this._vipLevel.setString("");
            this.____1524.setString("");
            this.____1519.setString("");
            this.____1520.setString("");
            this.____1528.setString("")
        } else {
            this.____1044 = info;
            if (____655.____667.userId == this.____1044.userId) {
                this.____1213.setVisible(false)
            }
            if (info.job > 0) {
                this.____1472.setVisible(true);
                if (info.job == 1) {
                    this.____1472.setFrame("icon/ui_leagueJob1.png")
                } else if (info.job == 2) {
                    this.____1472.setFrame("icon/ui_leagueJob2.png")
                }
            } else {
                this.____1472.setVisible(false)
            }
            this.____1526.setString(info.name);
            if (info.vipLevel <= 0) {
                this._vipLevel.setVisible(false)
            } else {
                this._vipLevel.setVisible(true)
            }
            this._vipLevel.setString("VIP" + info.vipLevel);
            this.____1524.setString(info.level);
            this.____1519.setString(info.gongxian);
            this.____1520.setString(info.fight);
            if (info.onlineState) {
                this.____1528.setString(____654.yuyanbaoManager.getYuyanbao("____2174.text6"));
                this.____1526.setColor(____655.____659.____688.itemColorList[0]);
                this._vipLevel.setColor(____655.____659.____688.itemColorList[4]);
                this.____1524.setColor(____655.____659.____688.itemColorList[0]);
                this.____1519.setColor(____655.____659.____688.itemColorList[0]);
                this.____1520.setColor(____655.____659.____688.itemColorList[0]);
                this.____1528.setColor(____655.____659.____688.itemColorList[0])
            } else {
                var delta = Math.floor(____655.____662.getSystemTime() / 1000 - info.lastOnlineTime);
                var dayTime = 24 * 3600;
                for (var i = 6; i > 0; i--) {
                    if (delta >= i * dayTime) {
                        this.____1528.setString(____654.yuyanbaoManager.getYuyanbao("____2174.text7", i));
                        break
                    }
                    if (delta < dayTime) {
                        this.____1528.setString(____654.yuyanbaoManager.getYuyanbao("____2174.text8"))
                    }
                }
                this.____1526.setColor(____655.____659.____688.gray);
                this._vipLevel.setColor(____655.____659.____688.gray);
                this.____1524.setColor(____655.____659.____688.gray);
                this.____1519.setColor(____655.____659.____688.gray);
                this.____1520.setColor(____655.____659.____688.gray);
                this.____1528.setColor(____655.____659.____688.gray)
            }
        }
    },
    ____16: function(sender, eventType, pos) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1213) {
                var myJob = ____655.____667.clubJob;
                if (myJob == 1) {
                    ____654.tipsManager.showPlayerMenuTip(3, this.____1044, pos)
                } else if (myJob == 2) {
                    if (this.____1044.job == 2) {
                        ____654.____683.sendLook(this.____1044.userId, this.____1044.serverId);
                        ____655.lookInfo.panelType = 13
                    } else if (this.____1044.job == 0) {
                        ____654.tipsManager.showPlayerMenuTip(3, this.____1044, pos)
                    } else if (this.____1044.job == 1) {
                        ____654.____683.sendLook(this.____1044.userId, this.____1044.serverId);
                        ____655.lookInfo.panelType = 13
                    }
                } else if (myJob == 0) {
                    ____654.____683.sendLook(this.____1044.userId, this.____1044.serverId);
                    ____655.lookInfo.panelType = 13
                }
            }
        }
    },
    ____6: function() {
        this.____1213.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._super();
        this.____1472 = null;
        this.____1526 = null;
        this._vipLevel = null;
        this.____1524 = null;
        this.____1519 = null;
        this.____1520 = null;
        this.____1528 = null;
        this.____1213 = null
    },
});
var ____2174 = KYPanel.extend({
    _controller: null,
    _borad1: null,
    _imgBtn: null,
    _listView: null,
    ____1587: null,
    ____1788: null,
    _numLabel: null,
    ____998: null,
    ____1344: null,
    ____1405: null,
    _itemList: null,
    ____996: null,
    conditionList: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("clubMemberView.ExportJson");
        this._controller = controller;
        this._listView = this.getChildByName("listView");
        this.____1587 = this.getChildByName("requteImg");
        this.____1788 = this.getChildByName("tipPop");
        this._numLabel = this.getChildByName("numLabel");
        this.____998 = this.getChildByName("conditionBtn");
        this.____1344 = this.getChildByName("limitLabel");
        this.____6();
        ____654.clubMessageSender.sendClubMember();
        this.____1405 = [];
        this._itemList = [];
        this.conditionList = [____654.yuyanbaoManager.getYuyanbao("____2174.text1"), ____654.yuyanbaoManager.getYuyanbao("____2174.text2"), ____654.yuyanbaoManager.getYuyanbao("____2174.text3"), ];
        this._borad1 = this.getChildByName("borad1__3");
        this._imgBtn = this.getChildByName("imgBtn");
        if (____655.____667.clubJob > 0) {
            ____654.clubMessageSender.sendApplyList();
            this.____1788.setVisible(true);
            this._numLabel.setVisible(true);
            this.____1587.setTouchEnabled(true);
            condition = ____655.clubInfo.autoInFightLevel;
            this.____1344.setString(this.conditionList[condition]);
            this.____998.setTouchEnabled(true)
        } else {
            this.____1788.setVisible(false);
            this._numLabel.setVisible(false);
            this.____1587.setTouchEnabled(false);
            this.____998.setTouchEnabled(false);
            this._borad1.setVisible(false);
            this.____1344.setVisible(false);
            this._imgBtn.setVisible(false)
        }
        this.applyListView()
    },
    ____5: function() {
        this.clearItemList();
        this.____1405 = ____655.clubInfo.members;
        ____654.____678.____298(this.tick, this)
    },
    clubMemberkick: function(evt) {
        var index = evt.data;
        if (index != null) {
            this._listView.removeItem(index)
        }
    },
    clubMemberJobUpdate: function(evt) {
        var index = evt.data;
        if (index != null) {
            this._itemList[index].____18(this.____1405[index])
        }
    },
    tick: function(delta, count) {
        var item = new ____2173();
        item.____18(this.____1405[this._tickCount]);
        this._listView.pushBackItem(item);
        this._itemList.push(item);
        this._tickCount++;
        if (this._tickCount >= this.____1405.length) {
            this._tickCount = 0;
            this._listView.resetPos();
            ____654.____678.____299(this.tick, this)
        }
    },
    applyListView: function() {
        this._numLabel.setString(____655.clubInfo.applys.length);
        if (____655.clubInfo.applys.length <= 0) {
            this.____1788.setVisible(false);
            this._numLabel.setVisible(false);
            this.____1587.setTouchEnabled(false);
            this.____1587.setVisible(false)
        } else {
            this.____1788.setVisible(true);
            this._numLabel.setVisible(true);
            this.____1587.setTouchEnabled(true);
            this.____1587.setVisible(true)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1587) {
                this._controller.showRequteInfoView()
            } else if (sender == this.____998) {
                var pos = ____654.____673.____159(-38, ____655.____657 * 0.5 - 320 + 160);
                this.____996 = new ____1894(this.conditionList, 180, pos)
            }
        }
    },
    ____6: function() {
        this.____1587.addListener(this, this.____16);
        this.____998.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_memberList_update_jobUpdate, this.clubMemberJobUpdate, this);
        ____655.clubInfo.addEventListener(____655.____661.club_memberList_update_Kick, this.clubMemberkick, this);
        ____655.clubInfo.addEventListener(____655.____661.club_applyList_update, this.applyListView, this);
        ____654.____672.addEventListener(____655.____661.global_comboBox, this.comboBoxSelectHandler, this);
        ____655.clubInfo.addEventListener(____655.____661.club_memberList_update, this.____5, this)
    },
    comboBoxSelectHandler: function(evt) {
        if (this.____996 != null) {
            if (evt.data == 1) {
                ____654.clubMessageSender.sendAutoJoinLevel(0);
                this.____1344.setString(this.conditionList[0])
            } else if (evt.data == 2) {
                ____654.clubMessageSender.sendAutoJoinLevel(1);
                this.____1344.setString(this.conditionList[1])
            } else if (evt.data == 3) {
                ____654.clubMessageSender.sendAutoJoinLevel(2);
                this.____1344.setString(this.conditionList[2])
            }
            this.____996.dispose();
            ____654.____676.____127(this.____996);
            this.____996 = null
        }
    },
    clearItemList: function() {
        if (this._itemList != null) {
            this._listView.removeAllItems()
        }
        if (this._itemList.length > 0) {
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose();
                this._itemList[i] = null
            }
        }
        this._itemList = []
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_memberList_update, this.____5, this);
        ____655.clubInfo.removeEventListener(____655.____661.club_applyList_update, this.applyListView, this);
        ____654.____672.removeEventListener(____655.____661.global_comboBox, this.comboBoxSelectHandler, this);
        ____655.clubInfo.removeEventListener(____655.____661.club_memberList_update_jobUpdate, this.clubMemberJobUpdate, this);
        ____655.clubInfo.removeEventListener(____655.____661.club_memberList_update_Kick, this.clubMemberkick, this)
    },
    dispose: function() {
        this.____17();
        this.clearItemList();
        this._super();
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._listView = null;
        this.____1587 = null;
        this.____1788 = null;
        this._numLabel = null;
        this.____998 = null;
        this.____1344 = null;
        this._borad1 = null;
        this._imgBtn = null;
        this._tickCount = null;
        if (this.____996 != null) {
            this.____996.dispose();
            ____654.____676.____127(this.____996);
            this.____996 = null
        }
    },
});
var ____2175 = KYNode.extend({
    ____1526: null,
    ____1524: null,
    ____1520: null,
    ____1495: null,
    ____1297: null,
    ____1496: null,
    ____1298: null,
    ____1835: 0,
    ____1846: null,
    ctor: function() {
        this._super("clubRequteInfoItem.ExportJson");
        this.____1526 = this.getChildByName("playerName");
        this.____1524 = this.getChildByName("playerLevel");
        this.____1520 = this.getChildByName("playerFight");
        this.____1495 = this.getChildByName("outBtn__1");
        this.____1297 = this.getChildByName("jujueBtn__1");
        this.____1496 = this.getChildByName("titleLabel1");
        this.____1496.setString(____654.yuyanbaoManager.getYuyanbao("____2260.text1"));
        this.____1298 = this.getChildByName("titleLabel2");
        this.____1298.setString(____654.yuyanbaoManager.getYuyanbao("____2260.text2"));
        this.____1846 = this.getChildByName("vipLevel");
        this.____6()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1495) {
                ____654.clubMessageSender.sendClubMemberDeal(1, this.____1835, 1)
            } else if (sender == this.____1297) {
                ____654.clubMessageSender.sendClubMemberDeal(0, this.____1835, 1);
                ____654.tipsManager.quickTip.show("拒绝玩家加入家族")
            }
        }
    },
    ____6: function() {
        this.____1495.addListener(this, this.____16);
        this.____1297.addListener(this, this.____16)
    },
    ____18: function(info) {
        if (info == null) {
            this.____1526.setString("");
            this.____1524.setString("");
            this.____1520.setString("");
            this.____1495.setVisible(false);
            this.____1297.setVisible(false)
        } else {
            this.____1495.setVisible(true);
            this.____1297.setVisible(true);
            if (info.vipLevel > 0) {
                this.____1526.setString(info.name);
                this.____1846.setString("VIP" + info.vipLevel)
            } else {
                this.____1526.setString(info.name);
                this.____1846.setString("")
            }
            this.____1524.setString(info.level);
            this.____1520.setString(info.fight);
            this.____1835 = info.userId
        }
    },
    dispose: function() {
        this.____1526 = null;
        this.____1524 = null;
        this.____1520 = null;
        this.____1495 = null;
        this.____1297 = null;
        this.____1496 = null;
        this.____1298 = null;
        this.____1846 = null;
        this._super()
    },
});
var ____2176 = KYPanel.extend({
    _titleLabel: null,
    _closeBtn: null,
    ____1297: null,
    ____1298: null,
    ____1479: null,
    ____1483: null,
    _listView: null,
    ____1016: null,
    ____1017: null,
    ____1018: null,
    ____1019: null,
    _controller: null,
    _itemList: null,
    ____1774: 0,
    ____835: 0,
    ____911: 0,
    ctor: function(controller) {
        this._super("clubRequteInfoView.ExportJson");
        this._controller = controller;
        this._titleLabel = this.getChildByName("titleLabel");
        this._titleLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text1"));
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1297 = this.getChildByName("jujueBtn__1");
        this.____1298 = this.getChildByName("btnLabel1");
        this.____1298.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text2"));
        this.____1479 = this.getChildByName("outBtn__1");
        this.____1483 = this.getChildByName("btnLabel2");
        this.____1483.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text3"));
        this._listView = this.getChildByName("listView");
        this.____1016 = this.getChildByName("cotent1");
        this.____1016.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text4"));
        this.____1017 = this.getChildByName("cotent2");
        this.____1017.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text5"));
        this.____1018 = this.getChildByName("cotent3");
        this.____1018.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text6"));
        this.____1019 = this.getChildByName("cotent4");
        this.____1019.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text7"));
        this._itemList = [];
        this.____6();
        this.____5()
    },
    ____5: function() {
        if (this._itemList != null) {
            this._listView.removeAllItems();
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose();
                this._itemList[i] = null
            }
            this._itemList = []
        }

        function sortHandler(info1, info2) {
            if (info1.vipLevel != info2.vipLevel) {
                return info2.vipLevel - info1.vipLevel
            } else {
                return info2.level - info1.level
            }
        }
        ____655.clubInfo.applys.sort(sortHandler);
        this.____835 = ____655.clubInfo.applys.length;
        for (var i = 0; i < this.____835; i++) {
            var item = new ____2175();
            item.____18(____655.clubInfo.applys[i]);
            this._itemList.push(item);
            this._listView.pushBackItem(item)
        }
    },
    tick: function(delta, tickCount) {
        this.____1774 = this.____1774 + 1;
        if (this.____1774 > 5) {
            this.____1774 = 0;
            this.____835 = this.____835 - 1;
            if (this.____835 < 0) {
                ____654.____678.____299(this.tick, this);
                this._controller.hideRequteInfoView()
            } else {
                if (this.____911 == 1) {
                    ____654.clubMessageSender.sendClubMemberDeal(1, ____655.clubInfo.applys[this.____835].userId, 2)
                } else if (this.____911 == 0) {
                    ____654.clubMessageSender.sendClubMemberDeal(0, ____655.clubInfo.applys[this.____835].userId, 2)
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this._controller.hideRequteInfoView()
            } else if (sender == this.____1297) {
                ____654.tipsManager.quickTip.show("拒绝玩家加入家族");
                ____654.____678.____298(this.tick, this);
                this.____911 = 0
            } else if (sender == this.____1479) {
                ____654.tipsManager.quickTip.show("同意玩家加入家族");
                ____654.____678.____298(this.tick, this);
                this.____911 = 1
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1297.addListener(this, this.____16);
        this.____1479.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_applyList_update, this.____5, this)
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_applyList_update, this.____5, this)
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____17();
        this._super();
        this._titleLabel = null;
        this._closeBtn = null;
        this.____1297 = null;
        this.____1298 = null;
        this.____1479 = null;
        this.____1483 = null;
        this._listView = null;
        this.____1016 = null;
        this.____1017 = null;
        this.____1018 = null;
        this.____1019 = null;
        this._controller = null;
        if (this._itemList != null) {
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose();
                this._itemList[i] = null
            }
            this._itemList = null
        }
        this.____1774 = null;
        this.____835 = null;
        this.____911 = null
    },
});
var ____2177 = KYNode.extend({
    ____1635: null,
    ____1774: 0,
    _plusNum: 0,
    ctor: function() {
        this._super("clubXinFaItem.ExportJson");
        this.____1635 = this.getChildByName("selectIcon");
        this.____1774 = 82;
        this._plusNum = 2;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        if (this.____1774 == 80 || this.____1774 == 120) {
            this._plusNum = -this._plusNum
        }
        this.____1774 = this.____1774 + this._plusNum;
        this.____1635.setScale(this.____1774 / 100)
    },
    isShowIcon: function(isShow) {
        this.____1635.setVisible(isShow)
    },
    isShowEffect: function() {},
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____1635 = null;
        this.____1774 = null;
        this._plusNum = null;
        this._super()
    },
});
var ____2178 = KYPanel.extend({
    _controller: null,
    ____1159: null,
    _bg: null,
    _bgPath: null,
    ____839: null,
    ____844: null,
    ____843: null,
    ____842: null,
    ____841: null,
    ____840: null,
    ____1885: 0,
    ____1883: null,
    ____1884: 0,
    ____1635: null,
    ____1219: 0,
    ____845: null,
    ____1532: null,
    _itemList: null,
    ____1783: null,
    _gongXianValue: null,
    _tipLabel1: null,
    _gongXianValue1: null,
    ____1480: null,
    ____1482: null,
    ____1542: null,
    ____1288: null,
    _oldXinFaLevel: 0,
    _count: 0,
    _addNumberUtils: null,
    ____1774: 0,
    _plusNum: 0,
    _flagTime: false,
    ____1165: true,
    ctor: function(controller) {
        this._super("clubXinFaView.ExportJson");
        this._controller = controller;
        this.____1159 = this.getChildByName("fightValue");
        this.____1159.setString("0");
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/star_bg1.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____839 = this.getChildByName("atrrName1");
        this.____839.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text1"));
        this.____840 = this.getChildByName("atrrName2");
        this.____840.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text2"));
        this.____841 = this.getChildByName("atrrName3");
        this.____841.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text3"));
        this.____842 = this.getChildByName("atrrName4");
        this.____842.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text4"));
        this.____843 = this.getChildByName("atrrName5");
        this.____843.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text5"));
        this.____844 = this.getChildByName("atrrName6");
        this.____844.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text6"));
        this.____845 = [];
        for (var i = 1; i <= 6; i++) {
            this.____845.push(this.getChildByName("atrrValue" + i));
            this.____845[i - 1].setString("0")
        }
        this.____1532 = [];
        for (var i = 1; i <= 6; i++) {
            this.____1532.push(this.getChildByName("plusValue" + i));
            this.____1532[i - 1].setString("")
        }
        this._itemList = [];
        for (var i = 1; i <= 6; i++) {
            this._itemList.push(this.getChildByName("item" + i))
        }
        this.____1783 = this.getChildByName("tipLabel");
        this.____1783.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text10"));
        this._gongXianValue = this.getChildByName("gongXianValue");
        this.____1480 = this.getChildByName("OKBtn__1");
        this.____1482 = this.getChildByName("btnLabel");
        this.____1482.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text8"));
        this.____1542 = [____655.____659.propertyType.PU_GONG_par, ____655.____659.propertyType.PU_FANG_par, ____655.____659.propertyType.BAO_JI_par, ____655.____659.propertyType.JIAN_REN_par, ____655.____659.propertyType.MING_ZHONG_par, ____655.____659.propertyType.SHAN_BI_par];
        this.____1883 = {};
        this.____1635 = this.getChildByName("selectIcon");
        this._tipLabel1 = this.getChildByName("tipLabel1");
        this._tipLabel1.setString(____654.yuyanbaoManager.getYuyanbao("____2178.text7"));
        this._gongXianValue1 = this.getChildByName("gongXianValue1");
        this.____1774 = 82;
        this._plusNum = 2;
        ____654.clubMessageSender.sendXinFaDataGet();
        ____654.____678.____298(this.tickRoller, this);
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.____1885 = ____655.clubInfo.xinFaLevel;
        if (this._oldXinFaLevel == 0 && this.____1165) {
            this._oldXinFaLevel = this.____1885;
            this.____239(this._oldXinFaLevel);
            var currentIndex = this._oldXinFaLevel % 6;
            this.calAttrValue(currentIndex);
            this.____1165 = false
        } else {
            ____654.____678.____298(this.tick, this)
        }
        this.____1884 = ____655.clubInfo.xinFaFight;
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____1159, this.____1884)
        } else {
            this._addNumberUtils.setValue(this.____1884)
        }
        this.____1883 = ____655.clubInfo.xinFaAttrList;
        for (var index in this.____1883) {
            if (index == ____655.____659.propertyType.PU_GONG) {
                this.____845[0].setString(this.____1883[index])
            } else if (index == ____655.____659.propertyType.PU_FANG) {
                this.____845[1].setString(this.____1883[index])
            } else if (index == ____655.____659.propertyType.BAO_JI) {
                this.____845[2].setString(this.____1883[index])
            } else if (index == ____655.____659.propertyType.JIAN_REN) {
                this.____845[3].setString(this.____1883[index])
            } else if (index == ____655.____659.propertyType.MING_ZHONG) {
                this.____845[4].setString(this.____1883[index])
            } else if (index == ____655.____659.propertyType.SHAN_BI) {
                this.____845[5].setString(this.____1883[index])
            }
        }
        this.moneyUpdate()
    },
    tickRoller: function(delta, count) {
        if (this.____1774 == 80 || this.____1774 == 120) {
            this._plusNum = -this._plusNum
        }
        this.____1774 = this.____1774 + this._plusNum;
        this.____1635.setScale(this.____1774 / 100)
    },
    tick: function(delta, count) {
        this._count++;
        if (this._count >= 18) {
            this._count = 0;
            this._oldXinFaLevel++;
            if (this._oldXinFaLevel > this.____1885) {
                this._oldXinFaLevel = this.____1885;
                if (this._flagTime) {
                    ____654.____674.setKYBtnEnabled(this.____1480, true, 1)
                }
                ____654.____678.____299(this.tick, this)
            } else {
                if (!this._flagTime) {
                    ____654.____674.setKYBtnEnabled(this.____1480, false, 0)
                }
                this._flagTime = true;
                this.____239(this._oldXinFaLevel);
                var currentIndex = this._oldXinFaLevel % 6;
                this.calAttrValue(currentIndex)
            }
        }
    },
    ____239: function(xinFaLevel) {
        var currentIndex = xinFaLevel % 6;
        for (var i = 0; i < 6; i++) {
            if (currentIndex == i) {
                var x = this._itemList[i].getPositionX() + 33;
                var y = this._itemList[i].getPositionY() + 33;
                this.____1635.setPosition(x, y)
            }
        }
    },
    moneyUpdate: function() {
        var currentIndex = this.____1885 % 6;
        this.____1219 = ____655.____667.moneyInfo.banggong;
        var needMatrial = this.calNeedMaterial(currentIndex);
        this._gongXianValue.setString(this.____1219);
        var currentLevel = Math.floor(this.____1885 / 6);
        var index = 6 - (this.____1885 % 6);
        if (currentLevel == 0) {
            currentLevel = 1
        }
        var count = Math.floor(this.____1219 / needMatrial);
        if (count >= index) {
            count = index
        }
        if (count >= 1) {
            this._gongXianValue1.setColor(____655.____659.____688.itemColorList[0])
        } else {
            this._gongXianValue1.setColor(____655.____659.____688.red)
        }
        if (count > 0) {
            this._gongXianValue1.setString(needMatrial + " x" + ____654.yuyanbaoManager.getYuyanbao("____2172.text20", count))
        } else {
            this._gongXianValue1.setString(needMatrial)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1480) {
                var currentLevel = Math.floor(this.____1885 / 6);
                var index = 6 - (this.____1885 % 6);
                var currentIndex = this.____1885 % 6;
                var needMatrial = this.calNeedMaterial(currentIndex);
                if (currentLevel == 0) {
                    currentLevel = 1
                }
                var count = Math.floor(this.____1219 / needMatrial);
                if (count >= index) {
                    count = index
                }
                if (count >= 1) {
                    this._flagTime = false;
                    ____654.clubMessageSender.sendClubXinFaUp(count)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2178.text9"))
                }
            }
        }
    },
    ____6: function() {
        this.____1480.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_xinfaInfo_update, this.____5, this);
        ____655.____667.moneyInfo.addEventListener(____655.____661.____701, this.moneyUpdate, this)
    },
    calAttrValue: function(index) {
        var currentLevel = Math.floor(this.____1885 / 6);
        var remainIndex = this.____1885 % 6;
        var nextLevel = 0;
        if (remainIndex >= index) {
            nextLevel = currentLevel + 1
        } else {
            nextLevel = currentLevel
        }
        var attrValue = nextLevel * 20 / this.____1542[index];
        for (var i = 0; i < 6; i++) {
            if (i == index) {
                this.____1532[i].setString("+" + attrValue);
                this.____1532[i].setVisible(true)
            } else {
                this.____1532[i].setVisible(false)
            }
        }
    },
    calNeedMaterial: function(index) {
        var currentLevel = Math.floor(this.____1885 / 6);
        var remainIndex = this.____1885 % 6;
        var nextLevel = 0;
        if (remainIndex >= index) {
            nextLevel = currentLevel + 1
        } else {
            nextLevel = currentLevel
        }
        var num = nextLevel * 200;
        return num
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_xinfaInfo_update, this.____5, this);
        ____655.____667.moneyInfo.removeEventListener(____655.____661.____701, this.moneyUpdate, this)
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        ____654.____678.____299(this.tickRoller, this);
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        this._controller = null;
        this.____1159 = null;
        this.____839 = null;
        this.____844 = null;
        this.____843 = null;
        this.____842 = null;
        this.____841 = null;
        this.____840 = null;
        this.____1885 = null;
        this.____1883 = null;
        this.____1884 = null;
        this.____1635 = null;
        this.____1219 = null;
        this.____845 = null;
        this.____1532 = null;
        this._itemList = null;
        this.____1783 = null;
        this._gongXianValue = null;
        this.____1480 = null;
        this.____1482 = null;
        this.____1542 = null;
        this._oldXinFaLevel = null;
        this._count = null;
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this.____1774 = null;
        this._plusNum = null;
        this.____1635 = null;
        this._tipLabel1 = null;
        this._flagTime = null;
        this._gongXianValue1 = null;
        this._super()
    },
});
var ____2181 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _nameLabel: null,
    ____1245: null,
    ____1246: null,
    _timeLabel: null,
    ____1152: null,
    ____1421: null,
    ____1418: null,
    ____851: null,
    ____950: null,
    ____944: null,
    _characterInfo: null,
    _richLabel1: null,
    _richLabel2: null,
    _gridList: null,
    ____1009: null,
    ____1012: null,
    ____1050: 0,
    _cost: 0,
    ctor: function(controller) {
        this._super("copyCaiLiaoView.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1245 = this.getChildByName("infoLabel1");
        this.____1246 = this.getChildByName("infoLabel2");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1152 = this.getChildByName("fightBtn");
        this.____1421 = this.getChildByName("btnLabel");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____851 = this.getChildByName("awardLabel");
        this.____950 = this.getChildByName("characterLayer");
        this._richLabel1 = ____654.____673.newRichLabel(this.____1245.getDimensions().width, ____654.____682.____108("10021"));
        this._richLabel1.setPosition(____654.____673.____159(this.____1245.getPosition().x, this.____1245.getPosition().y - 30));
        this.addChild(this._richLabel1, 4);
        this._richLabel2 = ____654.____673.newRichLabel(this.____1246.getDimensions().width, ____654.____682.____108("10022"));
        this._richLabel2.setPosition(____654.____673.____159(this.____1246.getPosition().x, this.____1246.getPosition().y - 30));
        this.addChild(this._richLabel2, 4);
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.CAILIAO_COPYID);
        this.____1012 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.CAILIAO_COPYID);
        this._gridList = [];
        var gridLayer = this.getChildByName("cellLayer");
        for (var j = 0; j < 4; j++) {
            var grid = new ____2129(true, 0, 0);
            grid.setPositionX(91 * j);
            gridLayer.addChild(grid);
            this._gridList.push(grid)
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.____1050 = ____655.____662.getClientDate().getDay();
        if (this.____1050 == 0) {
            this.____1050 = 7
        }
        this.____1050--;
        var count = 0;
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.CAILIAO_COPYID];
        if (info == null) {
            count = this.____1012.dayTimes
        } else {
            count = this.____1012.dayTimes - info.currentEnterCount
        }
        this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text8", count));
        var missionInfo = this.____1012.missions[this.____1050];
        this.____851.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text5", missionInfo.name));
        var xianwei = ____655.____667.xianwei;
        for (var i = 0; i < 4; i++) {
            var itemInfo = missionInfo.awards[xianwei - 1][i];
            if (itemInfo == null) {
                this._gridList[i].setItemTemplateInfo(null)
            } else {
                this._gridList[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo[0]));
                if (itemInfo[1] > 0) {
                    this._gridList[i].setCount(itemInfo[1])
                }
            }
        }
        var monsterInfo = ____655.allTemplates.monsterTemplateList.getMonster(missionInfo.bossId);
        if (monsterInfo == null) {
            return
        }
        var xianwei = "";
        if (____655.____667.xianwei > 0) {
            xianwei = "(" + ____655.____659.nameType.getXianweiName(____655.____667.xianwei) + ")"
        }
        this._nameLabel.setString(monsterInfo.name + xianwei);
        this._characterInfo = ____654.getCharacterInfo(monsterInfo.figureId, ____655.____659.____687.stand);
        this.____944 = new ____545(this._characterInfo);
        this.____944.init(____655.____659.____686.rightBottom, this.____950);
        var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(monsterInfo.figureId);
        this.____944.setScale(figureTemplate.getScale() * 0.8, figureTemplate.getScale() * 0.8);
        this.____944.move(0, 50);
        this._cost = ____655.allTemplates.copyTemplateList.CAILIAO_COSTLIST[count];
        if (this._cost < 0) {
            ____654.____674.setKYBtnEnabled(this.____1152, false, 1);
            this.____1418.setVisible(false)
        } else if (this._cost > 0) {
            this.____1421.setPositionX(610);
            this.____1421.setString(this._cost.toString())
        } else {
            this.____1418.setVisible(false)
        }
    },
    ____6: function() {
        this.____1152.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.guide_enterCaiLiaoCopy, this.guideHandler, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.guide_enterCaiLiaoCopy, this.guideHandler, this)
    },
    guideHandler: function() {
        if (this.____1152.isTouchEnabled()) {
            ____654.copyTester.enterCopy(this.____1012.id, this.____1050)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1152) {
                if (this._cost < 0) {
                    return
                }
                var taskId = 0;
                var taskInfo = ____655.____670.getComplateTaskByType(1);
                if (taskInfo != null) {
                    taskId = taskInfo.taskId
                }
                if (taskId < 104110) {
                    taskInfo = ____655.____670.getTaskByType(1);
                    if (taskInfo != null) {
                        taskId = taskInfo.taskId
                    }
                    if (taskId < 104110) {
                        ____654.tipsManager.quickTip.show("请先完成主线任务后再来挑战");
                        return
                    }
                }
                if (this._cost == 0) {
                    this.enterHandler()
                } else if (____655.____667.moneyInfo.money1Enough(this._cost)) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2182.text17", this._cost) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, this.enterHandler, null, null)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips1"))
                }
            }
        }
    },
    enterHandler: function() {
        ____654.copyTester.enterCopy(this.____1012.id, this.____1050)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this._characterInfo.dispose();
            this.____944 = null;
            this._characterInfo = null
        }
        this._nameLabel = null;
        this.____1245 = null;
        this.____1246 = null;
        this._timeLabel = null;
        this.____1152 = null;
        this.____1421 = null;
        this.____1418 = null;
        this.____851 = null;
        this.____950 = null;
        this.____1009 = null;
        this.____1012 = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this._richLabel1 != null) {
            this._richLabel1.dispose();
            this._richLabel1 = null
        }
        if (this._richLabel2 != null) {
            this._richLabel2.dispose();
            this._richLabel2 = null
        }
        this._super()
    },
});
var ____2182 = KYPanel.extend({
    _controller: null,
    ____1776: null,
    ____1740: null,
    ____1502: null,
    ____1737: null,
    ____1738: null,
    _panelList: null,
    ____1054: null,
    _moneyView: null,
    ctor: function(controller, index) {
        this._super("copyPanel.ExportJson");
        this._controller = controller;
        this.____1776 = this.getChildByName("tipBtn");
        this.____1740 = this.getChildByName("tabLayer");
        this.____1502 = this.getChildByName("panelLayer");
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(3);
        moneyLayer.addChild(this._moneyView);
        this._panelList = {};
        this.____5(index);
        this.____6();
        this.popUpdate()
    },
    ____5: function(index) {
        this.____1738 = [
            [1, "修仙之路", "icon/ui_copyIcon1.png", true, ____655.____659.levelType.xiuxianCopyLevel],
            [2, "外观装备", "icon/ui_copyIcon2.png", true, ____655.____659.levelType.waiguanCopyLevel],
            [3, "外观进阶", "icon/ui_copyIcon3.png", true, ____655.____659.levelType.cailiaoCopyLevel],
            [4, "赚取铜币", "icon/ui_copyIcon4.png", true, ____655.____659.levelType.yaotaCopyLevel],
            [5, "强化材料", "icon/ui_copyIcon5.png", true, ____655.____659.levelType.tongtianLevel],
            [6, "守护紫霞", "icon/ui_copyIcon6.png", true, ____655.____659.levelType.shouhuLevel],
            [7, "仙缘结义", "icon/ui_copyIcon7.png", false, ____655.____659.levelType.xianjieLevel]
        ];
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(540);
        this.____1740.addChild(this.____1737);
        if (index == null || index == 0) {
            index = 1
        }
        this.____1737.setTabIndex(index - 1)
    },
    ____6: function() {
        this.____1776.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 48) {
            this.____1737.setShowPop(1, ____654.playerInfoTester.copyXiuxianNum > 0)
        }
        if (type == 0 || type == 49) {
            this.____1737.setShowPop(2, ____654.playerInfoTester.copyWaiguanNum > 0)
        }
        if (type == 0 || type == 50) {
            this.____1737.setShowPop(3, ____654.playerInfoTester.copyCailiaoNum > 0)
        }
        if (type == 0 || type == 51) {
            this.____1737.setShowPop(4, ____654.playerInfoTester.copyYaotaNum > 0)
        }
        if (type == 0 || type == 52) {
            this.____1737.setShowPop(5, ____654.playerInfoTester.copyTongtianNum > 0)
        }
        if (type == 0 || type == 53) {
            this.____1737.setShowPop(6, ____654.playerInfoTester.copyShouhuNum > 0)
        }
        if (type == 0 || type == 66) {
            this.____1737.setShowPop(7, ____654.playerInfoTester.copyXianJieNum > 0)
        }
    },
    jumpToTab: function(index) {
        if (index < this.____1738.length) {
            this.____1737.setTabIndex(index)
        }
    },
    changeTabIndexHandler: function(evt) {
        if (this.getParent() != null) {
            var index = evt.data;
            this.____1737.setTabIndex(index)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1776) {
                var currentTab = this.____1737.getCurrentTab();
                ____654.tipsManager.showStringTip(____654.____682.____108("10020"), 500)
            }
        }
    },
    setTab: function(tab) {
        if (this.____1054 != null) {
            this.____1054.removeFromParent(false)
        }
        this.____1054 = this.getPanel(tab);
        if (this.____1054 != null && this.____1054.getParent() == null) {
            this.____1502.addChild(this.____1054)
        }
    },
    getPanel: function(tab) {
        var panel = this._panelList[tab];
        if (panel == null) {
            if (tab == 1) {
                panel = new ____2187(this._controller)
            } else if (tab == 2) {
                panel = new ____2185(this._controller)
            } else if (tab == 3) {
                panel = new ____2181(this._controller)
            } else if (tab == 4) {
                panel = new ____2188(this._controller)
            } else if (tab == 5) {
                panel = new ____2184(this._controller)
            } else if (tab == 6) {
                panel = new ____2183(this._controller)
            } else if (tab == 7) {
                panel = new ____2186(this._controller)
            }
            this._panelList[tab] = panel
        }
        return panel
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1776 = null;
        this.____1740 = null;
        this.____1502 = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        this.____1738 = null;
        if (this._panelList != null) {
            for (var i in this._panelList) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        this.____1054 = null;
        this._super()
    },
});
var CopyShopPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _itemContainer: null,
    _titleLabel: null,
    _tipsLabel: null,
    ____1251: null,
    _itemList: null,
    ctor: function(controller, type) {
        this._super("copyShopPanel.ExportJson");
        this._controller = controller;
        this._closeBtn = this.getChildByName("closeBtn");
        this._titleLabel = this.getChildByName("titleLabel");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._itemContainer = this.getChildByName("itemLayer__1");
        this._itemContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____1251 = ____655.allTemplates.shopTemplateList.getShopTempListByType(type);
        this._itemList = [];
        var systemTime = ____655.____662.getSystemTimeSec();
        for (var i = 0; i < this.____1251.length; i++) {
            var info = this.____1251[i];
            var beginSecond = ____655.____662.getTimesByDay(info.beginDay);
            var finishSecond = ____655.____662.getTimesByDay(info.endDay);
            var weekDay = ____655.____662.getClientDate().getDay();
            if (weekDay == 0) {
                weekDay = 7
            }
            if ((info.weekDay == 0 || weekDay == info.weekDay) && (finishSecond > systemTime) && (beginSecond <= systemTime) && (info.endDate > systemTime) && (info.beginDate <= systemTime)) {
                this._itemList.push(this.____1251[i])
            }
        }
        this._itemContainer.setFormat(2, this._itemList.length, ____654.____673.____160(279, 243), 8, 8, true);
        if (type == ____655.allTemplates.shopTemplateList.shopType_101) {
            this._titleLabel.setString("黑市商店")
        } else if (type == ____655.allTemplates.shopTemplateList.shopType_102) {
            this._titleLabel.setString("异域商店")
        }
        this._tipsLabel.setString("每天0点刷新商品和限购次数");
        this.____6()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            }
        }
    },
    getItemByIndex: function(index) {
        var tempInfo = this._itemList[index];
        if (tempInfo != null) {
            return new ____2310(tempInfo)
        }
        return null
    },
    getIdByIndex: function(index) {
        if (this._itemList[index] == null) {
            return -1
        }
        return this._itemList[index].id
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._closeBtn = null;
        this._titleLabel = null;
        this._tipsLabel = null;
        this._itemContainer = null;
        this._super()
    },
});
var CopyShouHuMatchPanel = KYPanel.extend({
    _controller: null,
    _timeLabel: null,
    _cancelBtn: null,
    _sureBtn: null,
    _tickCount: 0,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._super("copySingleWaitView.ExportJson");
        this._timeLabel = this.getChildByName("timeLabel");
        this._cancelBtn = this.getChildByName("cancelBtn");
        this._sureBtn = this.getChildByName("sureBtn");
        ____654.copyMessageSender.sendStartMatch();
        this._tickCount = 3600;
        this._timeLabel.setString(60);
        ____654.____678.____298(this.tick, this);
        this.____6();
        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, false));
        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkStop, ____654.____672))
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        this._sureBtn.addListener(this, this.____16);
        this._cancelBtn.addListener(this, this.____16)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._sureBtn) {
                ____654.copyMessageSender.sendEndMatch();
                ____654.copyTester.enterCopy(____655.allTemplates.copyTemplateList.SHOUHU_COPYID, 0)
            } else if (sender == this._cancelBtn) {
                ____654.copyMessageSender.sendEndMatch();
                this.dispose()
            }
        }
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            this._tickCount = 3600
        }
        if (this._tickCount % 60 == 0) {
            this._timeLabel.setString(Math.ceil(this._tickCount / 60))
        }
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____17();
        this._controller = null;
        this._timeLabel = null;
        this._cancelBtn = null;
        this._sureBtn = null;
        this._super()
    },
});
var ____2183 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _timeLabel: null,
    ____1245: null,
    ____1246: null,
    _nameLabel: null,
    ____950: null,
    ____1750: null,
    ____1178: null,
    _richLabel1: null,
    _richLabel2: null,
    _gridList: null,
    ____944: null,
    _characterInfo: null,
    ____1009: null,
    ____1012: null,
    ctor: function(controller) {
        this._super("copyShouHuView.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this.____1245 = this.getChildByName("infoLabel1");
        this.____1246 = this.getChildByName("infoLabel2");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____950 = this.getChildByName("characterLayer");
        this.____1750 = this.getChildByName("teamBtn");
        this.____1178 = this.getChildByName("friendBtn");
        this._timeLabel = this.getChildByName("timeLabel");
        this._richLabel1 = ____654.____673.newRichLabel(this.____1245.getDimensions().width, ____654.____682.____108("10023"));
        this._richLabel1.setPosition(____654.____673.____159(this.____1245.getPosition().x, this.____1245.getPosition().y - 30));
        this.addChild(this._richLabel1, 4);
        this._richLabel2 = ____654.____673.newRichLabel(this.____1246.getDimensions().width, ____654.____682.____108("10024"));
        this._richLabel2.setPosition(____654.____673.____159(this.____1246.getPosition().x, this.____1246.getPosition().y - 30));
        this.addChild(this._richLabel2, 4);
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.SHOUHU_COPYID);
        this.____1012 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.SHOUHU_COPYID);
        var xianwei = "";
        if (____655.____667.xianwei > 0) {
            xianwei = "(" + ____655.____659.nameType.getXianweiName(____655.____667.xianwei) + ")"
        }
        this._nameLabel.setString("紫霞仙子" + xianwei);
        this._gridList = [];
        var gridLayer = this.getChildByName("cellLayer");
        for (var j = 0; j < 4; j++) {
            var grid = new ____2129(true, 0, 0);
            grid.setPositionX(91 * j);
            gridLayer.addChild(grid);
            this._gridList.push(grid)
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        this._characterInfo = ____654.getCharacterInfo(____655.allTemplates.monsterTemplateList.getMonster(300201).figureId, ____655.____659.____687.stand);
        this.____944 = new ____545(this._characterInfo);
        this.____944.init(____655.____659.____686.rightBottom, this.____950);
        this.____944.setScale(1, 1);
        this.____944.move(0, 30);
        var missionInfo = this.____1012.missions[0];
        var xianwei = ____655.____667.xianwei;
        for (var i = 0; i < 4; i++) {
            var itemInfo = missionInfo.awards[xianwei - 1][i];
            if (itemInfo == null) {
                this._gridList[i].setItemTemplateInfo(null)
            } else {
                this._gridList[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo[0]));
                if (itemInfo[1] > 0) {
                    this._gridList[i].setCount(itemInfo[1])
                }
            }
        }
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.SHOUHU_COPYID];
        var lastCount = this.____1012.dayTimes;
        if (info != null) {
            lastCount = lastCount - info.currentEnterCount
        }
        this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text8", lastCount));
        if (lastCount <= 0) {
            ____654.____674.setKYBtnEnabled(this.____1178, false, 1);
            ____654.____674.setKYBtnEnabled(this.____1750, false, 2)
        }
    },
    ____6: function() {
        this.____1178.addListener(this, this.____16);
        this.____1750.addListener(this, this.____16)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1178) {
                if (____654.copyTester.checkCopy(this.____1012.id, 0)) {
                    ____654.____672.dispatchEvent(new ____590(____655.____661.common_showTeamPanel, ____654.____672, [1, true, 0]))
                }
            } else if (sender == this.____1750) {
                if (____654.copyTester.checkCopy(this.____1012.id, 0)) {
                    this._controller.showMatchPanel()
                }
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this._timeLabel = null;
        this.____1245 = null;
        this.____1246 = null;
        this._nameLabel = null;
        this.____950 = null;
        this.____1750 = null;
        this.____1178 = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null;
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        this.____1009 = null;
        this.____1012 = null;
        if (this._richLabel1 != null) {
            this._richLabel1.dispose();
            this._richLabel1 = null
        }
        if (this._richLabel2 != null) {
            this._richLabel2.dispose();
            this._richLabel2 = null
        }
        this._super()
    },
});
var ____2184 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _nameLabel: null,
    ____1735: null,
    ____1152: null,
    ____950: null,
    ____1246: null,
    ____1248: null,
    _titleLabel: null,
    ____953: null,
    ____955: null,
    ____949: null,
    _flagList: null,
    ____1342: null,
    ____1670: null,
    ____1671: null,
    ____1345: null,
    ____1346: null,
    _timeLabel: null,
    _gridList: null,
    ____1009: null,
    ____1012: null,
    ____1050: 0,
    _flagPath: null,
    _maxIndex: 0,
    _selectEffect: null,
    _resetCount: 0,
    ctor: function(controller) {
        this._super("copyTongTianView.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1735 = this.getChildByName("sweepBtn");
        this.getChildByName("btnLabel2").setString("重置");
        this.____1152 = this.getChildByName("fightBtn");
        this.____1246 = this.getChildByName("infoLabel2");
        this.____1248 = this.getChildByName("infoLabel4");
        this._titleLabel = this.getChildByName("nameLabel_Copy1");
        this.____1345 = this.getChildByName("limitLabel1");
        this.____1346 = this.getChildByName("limitLabel2");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____953 = [this.getChildByName("characterLayer1"), this.getChildByName("characterLayer2"), this.getChildByName("characterLayer3")];
        this.____1342 = [this.getChildByName("levelLabel1"), this.getChildByName("levelLabel2"), this.getChildByName("levelLabel3")];
        this.____1670 = this.getChildByName("shopBtn1");
        this.____1671 = this.getChildByName("shopBtn2");
        this._bgPath = ____654.____675.____139("outPic/ui_copyBg2.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._flagPath = ____654.____675.____139("outPic/ui_copyFlag.png");
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.TONGTIAN_COPYID);
        this.____1012 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.TONGTIAN_COPYID);
        this._gridList = [];
        var gridLayer = this.getChildByName("cellLayer");
        for (var j = 0; j < 4; j++) {
            var grid = new ____2129(true, 0, 0);
            grid.setPositionX(91 * j);
            gridLayer.addChild(grid);
            this._gridList.push(grid)
        }
        this.____5();
        this.initShop();
        this.____6()
    },
    ____5: function() {
        this.clear();
        this.____955 = [];
        this.____949 = [];
        this._flagList = [];
        var currentIndex = -1;
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.TONGTIAN_COPYID];
        var isAllPass = false;
        if (info != null) {
            if (info.todayMaxMission != 0) {
                currentIndex = this.____1012.missionIds.indexOf(info.todayMaxMission);
                if (currentIndex == -1) {
                    isAllPass = true;
                    ____654.____674.setKYBtnEnabled(this.____1152, false, 1);
                    currentIndex = this.____1012.missionIds.length - 1
                } else {
                    ____654.____674.setKYBtnEnabled(this.____1152, true, 1)
                }
            } else {
                ____654.____674.setKYBtnEnabled(this.____1152, true, 1)
            }
            if (info.maxMission != 0) {
                this._maxIndex = this.____1012.missionIds.indexOf(info.maxMission);
                if (this._maxIndex == -1) {
                    this._maxIndex = 50
                }
            }
        } else {
            ____654.____674.setKYBtnEnabled(this.____1152, true, 1)
        }
        var startIndex = currentIndex - 1;
        if (startIndex < 0) {
            startIndex = 0
        } else if (startIndex > this.____1012.missionIds.length - 3) {
            startIndex = this.____1012.missionIds.length - 3
        }
        var isFirstMonster = true;
        for (var i = 0; i < 3; i++) {
            this.____1342[i].setString(____654.yuyanbaoManager.getYuyanbao("____2182.text12", startIndex + i + 1));
            if (currentIndex > startIndex + i || (currentIndex == this.____1012.missionIds.length - 1 && isAllPass == true)) {
                var flag = ____654.____673.newKYSprite();
                ____654.____677.____146(flag, this._flagPath);
                flag.setPositionY(35);
                this.____953[i].addChild(flag);
                this._flagList.push(flag)
            } else {
                var missionInfo = this.____1012.missions[startIndex + i];
                var bossInfo = ____655.allTemplates.monsterTemplateList.getMonster(missionInfo.bossId);
                if (bossInfo != null) {
                    var characterInfo = ____654.getCharacterInfo(bossInfo.figureId, ____655.____659.____687.stand);
                    var character = new ____545(characterInfo);
                    if (i == 1) {
                        character.init(____655.____659.____686.leftBottom, this.____953[i], 1)
                    } else {
                        character.init(____655.____659.____686.rightBottom, this.____953[i], 1)
                    }
                    var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(bossInfo.figureId);
                    if ((startIndex + i + 1) % 5 == 0) {
                        character.setScale(figureTemplate.getScale() * 0.4, figureTemplate.getScale() * 0.4)
                    } else {
                        character.setScale(figureTemplate.getScale(), figureTemplate.getScale())
                    }
                    character.move(0, 15);
                    this.____955.push(character);
                    this.____949.push(characterInfo)
                }
                if (isFirstMonster) {
                    this._selectEffect = ____654.____673.newKYSprite();
                    this._selectEffect.setFrame("ui_redBottom.png");
                    this.____953[i].addChild(this._selectEffect, 0);
                    isFirstMonster = false
                }
            }
        }
        if (currentIndex >= this.____1012.missionIds.length) {
            currentIndex--
        } else if (currentIndex < 0) {
            currentIndex = 0
        }
        var currentMissionInfo = this.____1012.missions[currentIndex];
        var xianwei = ____655.____667.xianwei;
        for (var i = 0; i < 4; i++) {
            var itemInfo = currentMissionInfo.awards[xianwei - 1][i];
            if (itemInfo == null) {
                this._gridList[i].setItemTemplateInfo(null)
            } else {
                this._gridList[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo[0]));
                if (itemInfo[1] > 0) {
                    this._gridList[i].setCount(itemInfo[1])
                }
            }
        }
        this._nameLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text13", currentIndex + 1));
        this.____1248.setString(____655.____659.nameType.getXianweiName(____655.____667.xianwei));
        if (info == null || info.maxMission == 0) {
            this.____1246.setString("无")
        } else {
            var maxIndex = this.____1012.missionIds.indexOf(info.maxMission);
            if (maxIndex < 0) {
                maxIndex = 49
            }
            this.____1246.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text12", maxIndex + 1))
        }
        this._resetCount = -1;
        if (info != null) {
            this._resetCount = info.resetNum
        }
        if (this._resetCount < 0) {
            this._resetCount = this.____1012.resetNum
        }
        this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text16", this._resetCount));
        if (this._resetCount <= 0 || currentIndex == 0) {
            ____654.____674.setKYBtnEnabled(this.____1735, false, 2)
        } else {
            ____654.____674.setKYBtnEnabled(this.____1735, true, 2)
        }
    },
    initShop: function() {
        if (____655.____667.xianwei < 4 || (this._maxIndex < 49 && ____655.____667.xianwei == 4)) {
            this.____1670.setTouchEnabled(false);
            this.____1345.setString(____655.____659.nameType.getXianweiName(4) + "50关开放")
        }
        if (____655.____667.xianwei < 7 || (this._maxIndex < 49 && ____655.____667.xianwei == 7)) {
            this.____1671.setTouchEnabled(false);
            this.____1346.setString(____655.____659.nameType.getXianweiName(7) + "50关开放")
        }
    },
    ____6: function() {
        this.____1152.addListener(this, this.____16);
        this.____1735.addListener(this, this.____16);
        this.____1670.addListener(this, this.____16);
        this.____1671.addListener(this, this.____16);
        ____655.statInfo.addEventListener(____655.____661.stat_copyStat_update, this.____5, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.stat_copyStat_update, this.____5, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1670) {
                this._controller.____265(101)
            } else if (sender == this.____1671) {
                this._controller.____265(102)
            } else if (sender == this.____1152) {
                ____654.copyTester.enterCopy(this.____1012.id, this.____1050)
            } else if (sender == this.____1735) {
                var cost = ____655.allTemplates.copyTemplateList.TONGTIAN_RESETCOST[this._resetCount];
                if (____655.____667.moneyInfo.money1Enough(cost)) {
                    ____655.getAlert().show(2, "确定要花费[0x009700]" + cost + "[-]钻石重置副本回1层吗？" + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, this.resetHandler, null, null)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips1"))
                }
            }
        }
    },
    resetHandler: function() {
        ____654.copyMessageSender.sendCopyReset(____655.allTemplates.copyTemplateList.TONGTIAN_TYPE)
    },
    clear: function() {
        if (this._flagList != null) {
            for (var j = 0; j < this._flagList.length; j++) {
                this._flagList[j].dispose()
            }
            this._flagList = null
        }
        if (this.____955 != null) {
            for (var i = 0; i < this.____955.length; i++) {
                this.____955[i].dispose();
                this.____949[i].dispose()
            }
            this.____955 = null;
            this.____949 = null
        }
        if (this._selectEffect != null) {
            this._selectEffect.dispose();
            this._selectEffect = null
        }
    },
    dispose: function() {
        this.____17();
        this.clear();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this.____1597 != null) {
            ____654.____677.removeImageQuote(this.____1597, this._roleBg);
            this.____1597 = null
        }
        this._roleBg = null;
        this._nameLabel = null;
        this.____1735 = null;
        this.____1152 = null;
        this.____950 = null;
        this.____1246 = null;
        this.____1248 = null;
        this._titleLabel = null;
        this.____953 = null;
        this.____1342 = null;
        this.____1670 = null;
        this.____1671 = null;
        this.____1345 = null;
        this.____1346 = null;
        this._timeLabel = null;
        this.____1009 = null;
        this.____1012 = null;
        if (this._gridList != null) {
            for (var k = 0; k < this._gridList.length; k++) {
                this._gridList[k].dispose()
            }
            this._gridList = null
        }
        this._super()
    },
});
var ____2185 = KYPanel.extend({
    _controller: null,
    ____869: null,
    ____870: null,
    _bgPath: null,
    ____1443: null,
    ____1444: null,
    ____1202: null,
    ____1203: null,
    ____951: null,
    ____952: null,
    ____1499: null,
    ____1153: null,
    ____1154: null,
    ____893: null,
    ____894: null,
    _timeLabel: null,
    ____1345: null,
    ____1346: null,
    ____970: null,
    ____945: null,
    ____946: null,
    ____947: null,
    ____948: null,
    ____1053: -1,
    ____1400: 0,
    ____1009: null,
    ____1012: null,
    ____1711: null,
    ctor: function(controller) {
        this._super("copyWaiGuanView.ExportJson");
        this._controller = controller;
        this.____869 = this.getChildByName("bg1");
        this.____870 = this.getChildByName("bg2");
        this.____1443 = this.getChildByName("nameLabel1");
        this.____1444 = this.getChildByName("nameLabel2");
        this.____951 = this.getChildByName("characterLayer1");
        this.____952 = this.getChildByName("characterLayer2");
        this.____1153 = this.getChildByName("fightBtn1");
        this.____1154 = this.getChildByName("fightBtn2");
        this.____893 = this.getChildByName("btnLabel1");
        this.____894 = this.getChildByName("btnLabel2");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1345 = this.getChildByName("limitLabel1");
        this.____1346 = this.getChildByName("limitLabel2");
        this.____970 = this.getChildByName("clickLayer");
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this.____869, this._bgPath);
        ____654.____677.____146(this.____870, this._bgPath);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.WAIGUAN_COPYID);
        this.____1012 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.WAIGUAN_COPYID);
        this.____1400 = Math.ceil(this.____1012.missions.length / 2) - 1;
        this.____1499 = new ____2145(this.____1400 + 1);
        this.getChildByName("pageViewLayer").addChild(this.____1499);
        var gridLayer1 = this.getChildByName("itemLayer1");
        var gridLayer2 = this.getChildByName("itemLayer2");
        this.____1202 = [];
        this.____1203 = [];
        for (var i = 0; i < 3; i++) {
            var item1 = new ____2129(true, 0, 0);
            item1.setPositionX(91 * i);
            gridLayer1.addChild(item1);
            this.____1202.push(item1);
            var item2 = new ____2129(true, 0, 0);
            item2.setPositionX(91 * i);
            gridLayer2.addChild(item2);
            this.____1203.push(item2)
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (this.____1400 == -1) {
            return
        }
        var list = this.____1012.missions;
        var len = list.length;
        var index = len - 1;
        for (var i = 0; i < len; i++) {
            if (____655.____667.xianwei < list[i].needXianwei) {
                index = i;
                break
            }
        }
        index--;
        if (index < 0) {
            index = 0
        }
        this.setPage(Math.ceil((index + 1) / 2) - 1)
    },
    setPage: function(page) {
        if (page < 0) {
            page = 0
        }
        if (page > this.____1400) {
            page = this.____1400
        }
        if (this.____1053 == page) {
            return
        }
        this.____1499.setPage(page);
        this.____1053 = page;
        var missionInfo1 = this.____1012.missions[this.____1053 * 2];
        var missionInfo2 = this.____1012.missions[this.____1053 * 2 + 1];
        this.____1443.setString(missionInfo1.name);
        this.____1444.setString(missionInfo2.name);
        for (var i = 0; i < 3; i++) {
            var itemInfo = missionInfo1.awards[0][i];
            if (itemInfo == null) {
                this.____1202[i].setItemTemplateInfo(null)
            } else {
                this.____1202[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo[0]))
            }
            itemInfo = missionInfo2.awards[0][i];
            if (itemInfo == null) {
                this.____1203[i].setItemTemplateInfo(null)
            } else {
                this.____1203[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo[0]))
            }
        }
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.WAIGUAN_COPYID];
        var lastCount = this.____1012.dayTimes;
        if (info != null) {
            lastCount = lastCount - info.currentEnterCount
        }
        this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text8", lastCount));
        if (lastCount <= 0) {
            ____654.____674.setKYBtnEnabled(this.____1153, false, 1);
            ____654.____674.setKYBtnEnabled(this.____1154, false, 1)
        }
        var bossInfo1 = ____655.allTemplates.monsterTemplateList.getMonster(missionInfo1.bossId);
        var bossInfo2 = ____655.allTemplates.monsterTemplateList.getMonster(missionInfo2.bossId);
        if (this.____945 != null) {
            this.____945.dispose();
            this.____947.dispose()
        }
        if (bossInfo1 != null) {
            this.____947 = ____654.getCharacterInfo(bossInfo1.figureId, ____655.____659.____687.stand);
            this.____945 = new ____545(this.____947);
            this.____945.init(____655.____659.____686.rightBottom, this.____951);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(bossInfo1.figureId);
            this.____945.setScale(figureTemplate.getScale() * 0.8, figureTemplate.getScale() * 0.8);
            if (this.____1053 == 0) {
                this.____945.move(0, 50)
            } else {
                this.____945.move(0, 30)
            }
        }
        if (this.____946 != null) {
            this.____946.dispose();
            this.____948.dispose()
        }
        if (bossInfo2 != null) {
            this.____948 = ____654.getCharacterInfo(bossInfo2.figureId, ____655.____659.____687.stand);
            this.____946 = new ____545(this.____948);
            this.____946.init(____655.____659.____686.rightBottom, this.____952);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(bossInfo2.figureId);
            this.____946.setScale(figureTemplate.getScale() * 0.8, figureTemplate.getScale() * 0.8);
            this.____946.move(0, 30)
        }
        if (missionInfo1.needXianwei > ____655.____667.xianwei) {
            this.____1153.setVisible(false);
            this.____893.setVisible(false);
            this.____1345.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text7", ____655.____659.nameType.getXianweiName(missionInfo1.needXianwei)))
        } else {
            this.____1153.setVisible(true);
            this.____893.setVisible(true);
            this.____1345.setString("")
        }
        if (missionInfo2.needXianwei > ____655.____667.xianwei) {
            this.____1154.setVisible(false);
            this.____894.setVisible(false);
            this.____1346.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text7", ____655.____659.nameType.getXianweiName(missionInfo2.needXianwei)))
        } else {
            this.____1154.setVisible(true);
            this.____894.setVisible(true);
            this.____1346.setString("")
        }
    },
    ____6: function() {
        this.____1153.addListener(this, this.____16);
        this.____1154.addListener(this, this.____16);
        this.____970.addListener(this, null, this.downHandler, this.upHandler, null, false)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1153) {
                ____654.copyTester.enterCopy(this.____1012.id, this.____1053 * 2)
            } else if (sender == this.____1154) {
                ____654.copyTester.enterCopy(this.____1012.id, this.____1053 * 2 + 1)
            }
        }
    },
    downHandler: function(sender, eventType, pos) {
        this.____1711 = pos
    },
    upHandler: function(sender, eventType, pos) {
        if (sender == this.____970) {
            if (this.____1711 == null) {
                return
            }
            var startPos = this.____1711;
            var endPos = pos;
            if (startPos.x - endPos.x > 50) {
                this.setPage(this.____1053 + 1)
            } else if (startPos.x - endPos.x < -50) {
                this.setPage(this.____1053 - 1)
            }
            this.____1711 = null
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this.____869);
            ____654.____677.removeImageQuote(this._bgPath, this.____870);
            this._bgPath = null
        }
        this.____869 = null;
        this.____870 = null;
        if (this.____945 != null) {
            this.____945.dispose();
            this.____947.dispose();
            this.____945 = null;
            this.____947 = null
        }
        if (this.____946 != null) {
            this.____946.dispose();
            this.____948.dispose();
            this.____946 = null;
            this.____948 = null
        }
        this.____1443 = null;
        this.____1444 = null;
        this.____951 = null;
        this.____952 = null;
        this.____1153 = null;
        this.____1154 = null;
        this.____893 = null;
        this.____894 = null;
        this._timeLabel = null;
        this.____1345 = null;
        this.____1346 = null;
        this.____970 = null;
        if (this.____1202 != null) {
            for (var i = 0; i < this.____1202.length; i++) {
                this.____1202[i].dispose()
            }
            this.____1202 = null
        }
        if (this.____1203 != null) {
            for (var j = 0; j < this.____1203.length; j++) {
                this.____1203[j].dispose()
            }
            this.____1203 = null
        }
        if (this.____1499 != null) {
            this.____1499.dispose();
            this.____1499 = null
        }
        this.____1711 = null;
        this._super()
    },
});
var ____2186 = KYNode.extend({
    _controller: null,
    ____869: null,
    ____870: null,
    ____872: null,
    ____873: null,
    ____1202: null,
    ____1203: null,
    ____1153: null,
    ____1154: null,
    _timeLabel1: null,
    _timeLabel2: null,
    ____1443: null,
    ____1444: null,
    ____1419: null,
    ____1420: null,
    ____893: null,
    ____894: null,
    ____1010: null,
    ____1013: null,
    ____1011: null,
    ____1014: null,
    _cost1: 0,
    _cost2: 0,
    ctor: function(controller) {
        this._super("copyXianJieView.ExportJson");
        this._controller = controller;
        this.____869 = this.getChildByName("bg1");
        this.____870 = this.getChildByName("bg2");
        this.____1153 = this.getChildByName("fightBtn1");
        this.____1154 = this.getChildByName("fightBtn2");
        this._timeLabel1 = this.getChildByName("timeLabel1");
        this._timeLabel2 = this.getChildByName("timeLabel2");
        this.____1443 = this.getChildByName("nameLabel1");
        this.____1444 = this.getChildByName("nameLabel2");
        this.____1419 = this.getChildByName("moneyIcon2");
        this.____1420 = this.getChildByName("moneyIcon1");
        this.____893 = this.getChildByName("btnLabel2");
        this.____894 = this.getChildByName("btnLabel1");
        this.____872 = ____654.____675.____139("outPic/ui_copyBg3_1.png");
        ____654.____677.____146(this.____869, this.____872);
        this.____873 = ____654.____675.____139("outPic/ui_copyBg3_2.png");
        ____654.____677.____146(this.____870, this.____873);
        this.____1010 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.XIANYUAN_COPYID);
        this.____1013 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.XIANYUAN_COPYID);
        this.____1011 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.JIEYI_COPYID);
        this.____1014 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.JIEYI_COPYID);
        var gridLayer1 = this.getChildByName("cellLayer1");
        var gridLayer2 = this.getChildByName("cellLayer2");
        this.____1202 = [];
        this.____1203 = [];
        for (var i = 0; i < 3; i++) {
            var item1 = new ____2129(true, 0, 0);
            item1.setPositionX(91 * i);
            gridLayer1.addChild(item1);
            this.____1202.push(item1);
            var item2 = new ____2129(true, 0, 0);
            item2.setPositionX(91 * i);
            gridLayer2.addChild(item2);
            this.____1203.push(item2)
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        var missionInfo1 = this.____1013.missions[0];
        var missionInfo2 = this.____1014.missions[0];
        this.____1443.setString(missionInfo1.name + "(" + ____655.____659.nameType.getSelfXianweiName() + ")");
        this.____1444.setString(missionInfo2.name + "(" + ____655.____659.nameType.getSelfXianweiName() + ")");
        for (var i = 0; i < 3; i++) {
            var itemInfo1 = missionInfo1.awards[____655.____667.xianwei - 1][i];
            if (itemInfo1 == null) {
                this.____1202[i].setItemTemplateInfo(null)
            } else {
                this.____1202[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo1[0]));
                if (itemInfo1[1] > 0) {
                    this.____1202[i].setCount(itemInfo1[1])
                }
            }
            var itemInfo2 = missionInfo2.awards[____655.____667.xianwei - 1][i];
            if (itemInfo2 == null) {
                this.____1203[i].setItemTemplateInfo(null)
            } else {
                this.____1203[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo2[0]));
                if (itemInfo2[1] > 0) {
                    this.____1203[i].setCount(itemInfo2[1])
                }
            }
        }
        var count1 = 0;
        var info1 = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.XIANYUAN_COPYID];
        if (info1 == null) {
            count1 = this.____1013.dayTimes
        } else {
            count1 = this.____1013.dayTimes - info1.currentEnterCount
        }
        var count2 = 0;
        var info2 = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.JIEYI_COPYID];
        if (info2 == null) {
            count2 = this.____1014.dayTimes
        } else {
            count2 = this.____1014.dayTimes - info2.currentEnterCount
        }
        this._timeLabel1.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text8", count1));
        this._timeLabel2.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text8", count2));
        this._cost1 = ____655.allTemplates.copyTemplateList.XIANJIE_COSTLIST[count1];
        if (this._cost1 < 0) {
            ____654.____674.setKYBtnEnabled(this.____1153, false, 1);
            this.____1419.setVisible(false)
        } else if (this._cost1 > 0) {
            this.____893.setPositionX(202);
            this.____893.setString(this._cost1.toString())
        } else {
            this.____1419.setVisible(false)
        }
        this._cost2 = ____655.allTemplates.copyTemplateList.XIANJIE_COSTLIST[count2];
        if (this._cost2 < 0) {
            ____654.____674.setKYBtnEnabled(this.____1154, false, 1);
            this.____1420.setVisible(false)
        } else if (this._cost2 > 0) {
            this.____894.setPositionX(561);
            this.____894.setString(this._cost2.toString())
        } else {
            this.____1420.setVisible(false)
        }
    },
    ____6: function() {
        this.____1153.addListener(this, this.____16);
        this.____1154.addListener(this, this.____16)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1153) {
                if (____655.marryOathInfo.marryType == 0) {
                    ____654.tipsManager.quickTip.show("未结缘无法进入该副本");
                    return
                }
                if (this._cost1 == 0) {
                    this.enterHandler1()
                } else if (____655.____667.moneyInfo.money1Enough(this._cost1)) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2182.text17", this._cost1) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, this.enterHandler1, null, null)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips1"))
                }
            } else if (sender == this.____1154) {
                if (____655.marryOathInfo.oathType == 0) {
                    ____654.tipsManager.quickTip.show("未结义无法进入该副本");
                    return
                }
                if (this._cost2 == 0) {
                    this.enterHandler2()
                } else if (____655.____667.moneyInfo.money1Enough(this._cost2)) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2182.text17", this._cost2) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, this.enterHandler2, null, null)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips1"))
                }
            }
        }
    },
    enterHandler1: function() {
        ____654.copyTester.enterCopy(this.____1013.id, 0)
    },
    enterHandler2: function() {
        ____654.copyTester.enterCopy(this.____1014.id, 0)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        if (this.____872 != null) {
            ____654.____677.removeImageQuote(this.____872, this.____869);
            this.____872 = null
        }
        this.____869 = null;
        if (this.____873 != null) {
            ____654.____677.removeImageQuote(this.____873, this.____870);
            this.____873 = null
        }
        this.____870 = null;
        this.____1153 = null;
        this.____1154 = null;
        this._timeLabel1 = null;
        this._timeLabel2 = null;
        this.____1010 = null;
        this.____1013 = null;
        this.____1011 = null;
        this.____1014 = null;
        if (this.____1202 != null) {
            for (var i = 0; i < this.____1202.length; i++) {
                this.____1202[i].dispose()
            }
            this.____1202 = null
        }
        if (this.____1203 != null) {
            for (var j = 0; j < this.____1203.length; j++) {
                this.____1203[j].dispose()
            }
            this.____1203 = null
        }
        this.____1443 = null;
        this.____1444 = null;
        this.____1419 = null;
        this.____1420 = null;
        this.____893 = null;
        this.____894 = null;
        this._super()
    },
});
var ____2187 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _countLabel: null,
    ____884: null,
    _titleLabel: null,
    ____1499: null,
    ____1152: null,
    ____1735: null,
    ____1591: null,
    ____1590: null,
    _timeLabel: null,
    ____1344: null,
    ____970: null,
    _itemList: null,
    _gridList: null,
    ____1632: -1,
    ____1053: -1,
    ____1400: 0,
    ____1009: null,
    ____1012: null,
    ____1399: 0,
    ____926: null,
    _canAcceptEffect: null,
    ____1711: null,
    ctor: function(controller) {
        this._super("copyXiuXianView.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this.____884 = this.getChildByName("boxIcon");
        this._countLabel = this.getChildByName("countLabel");
        this._titleLabel = this.getChildByName("titleLabel");
        this.____1152 = this.getChildByName("fightBtn");
        this.____1735 = this.getChildByName("sweepBtn");
        this.____1591 = this.getChildByName("resetLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1344 = this.getChildByName("limitLabel");
        this.____970 = this.getChildByName("clickLayer");
        this.____1590 = new ____2111();
        this.____1590.setLabel(this.____1591, 3, 0, "____2182.text2");
        this._bgPath = ____654.____675.____139("outPic/ui_copyBg4.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.XIUXIAN_COPYID);
        this.____1012 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.XIUXIAN_COPYID);
        this.____1400 = Math.ceil(this.____1012.missions.length / 9) - 1;
        this._itemList = [];
        for (var i = 1; i < 10; i++) {
            var item = new ____2189();
            this.getChildByName("cell" + i).addChild(item);
            item.addListener(this, this.itemClickHandler, null, null, null, false);
            this._itemList.push(item)
        }
        this._gridList = [];
        var gridLayer = this.getChildByName("cellLayer");
        for (var j = 0; j < 4; j++) {
            var grid = new ____2129(true, 0, 0);
            grid.setPositionX(91 * j);
            gridLayer.addChild(grid);
            this._gridList.push(grid)
        }
        this.____1499 = new ____2145(this.____1400 + 1);
        this.getChildByName("pageViewLayer").addChild(this.____1499);
        this.____5();
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.XIUXIAN_COPYID];
        var currentIndex = 0;
        if (info != null) {
            currentIndex = this.____1012.missionIds.indexOf(info.maxMission)
        }
        if (currentIndex < 0) {
            currentIndex = 80
        }
        var missTempInfo = this.____1012.missions[currentIndex]
        if (missTempInfo.needXianwei > ____655.____667.xianwei || missTempInfo.needLevel > ____655.____667.level) {
            currentIndex--
        }
        this.setPage(Math.floor(currentIndex / 9));
        this.____6();
        ____654.copyMessageSender.sendCopyAwardUpdate(____655.allTemplates.copyTemplateList.XIUXIAN_COPYID)
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var index = this._itemList.indexOf(sender);
            this.setSelected(index)
        }
    },
    ____5: function() {
        if (this.____1400 == -1) {
            return
        }
        this.updateStar();
        this.updateInfo()
    },
    setPage: function(page) {
        if (page < 0) {
            page = 0
        }
        if (page > this.____1400) {
            page = this.____1400
        }
        if (this.____1053 == page) {
            return
        }
        this.____1499.setPage(page);
        this.____1053 = page;
        var list = this.____1012.missions;
        var select = 0;
        for (var i = 0; i < 9; i++) {
            var index = this.____1053 * 9 + i;
            if ((index != 0 && list[index].id > this.____1399) || list[index].needXianwei > ____655.____667.xianwei || list[index].needLevel > ____655.____667.level) {
                this._itemList[i].setGray(true)
            } else {
                this._itemList[i].setGray(false);
                select = i
            }
            this._itemList[i].____363(list[index]);
            this._itemList[i].setStarCount(this.____1009.missionStarList[list[index].id])
        }
        this.setSelected(select)
    },
    updateStar: function() {
        var list = ____655.allTemplates.awardTemplateList.getTypeList(1);
        this.____926 = null;
        for (var i = 0; i < list.length; i++) {
            var info = list[i];
            if (this.____1009.awardStarList[info.id] != true) {
                this.____926 = info;
                break
            }
        }
        if (this.____926 == null) {
            this.____884.setVisible(false);
            this._countLabel.setString(this.____1009.starCount + "/" + (this.____1012.missions.length * 3))
        } else {
            this._countLabel.setString(this.____1009.starCount + "/" + this.____926.condition);
            if (this.____1009.starCount >= parseInt(this.____926.condition)) {
                ____654.shaderCache.setColor(this.____884, 0);
                if (this._canAcceptEffect == null) {
                    this._canAcceptEffect = new RotationEffect("effect/effect_10.png", 5);
                    this._canAcceptEffect.move(661, 491);
                    this.addChild(this._canAcceptEffect, 2)
                }
            } else {
                ____654.shaderCache.setColor(this.____884, 1);
                if (this._canAcceptEffect != null) {
                    this._canAcceptEffect.dispose();
                    this._canAcceptEffect = null
                }
            }
        }
    },
    updateInfo: function() {
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.XIUXIAN_COPYID];
        if (info == null) {
            this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text1", this.____1012.dayTimes));
            this.____1590.stop();
            this.____1591.setString("")
        } else {
            this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text1", this.____1012.dayTimes - info.currentEnterCount));
            if (info.currentEnterCount > 0) {
                this.____1590.start(info.lastRevertTime - ____655.____662.getSystemTimeSec())
            } else {
                this.____1590.stop();
                this.____1591.setString("")
            }
            this.____1399 = info.maxMission
        }
    },
    setSelected: function(index) {
        if (this.____1632 > -1) {
            this._itemList[this.____1632].setSelected(false)
        }
        this.____1632 = index;
        this._itemList[this.____1632].setSelected(true);
        var missionInfo = this.____1012.missions[this.____1053 * 9 + this.____1632];
        this._titleLabel.setString(missionInfo.name);
        var offset = 0;
        for (var i = 0; i < 4; i++) {
            var itemInfo = missionInfo.awards[0][i + offset];
            if (itemInfo == null) {
                this._gridList[i].setItemTemplateInfo(null)
            } else {
                if (itemInfo[2] != null && itemInfo[2] != 0 && itemInfo[2] != ____655.____667.career) {
                    i--;
                    offset++
                } else {
                    this._gridList[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo[0]))
                }
            }
        }
        if (missionInfo.needXianwei > ____655.____667.xianwei) {
            this.____1344.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text3", ____655.____659.nameType.getXianweiName(missionInfo.needXianwei)))
        } else {
            this.____1344.setString("")
        }
        if ((this.____1399 > 0 && this.____1399 > missionInfo.id) || (this.____1399 == 0 && this.____1053 + this.____1632 == 0) || (this.____1399 > 0 && this.____1399 == missionInfo.id)) {
            ____654.____674.setKYBtnEnabled(this.____1152, true, 1)
        } else {
            ____654.____674.setKYBtnEnabled(this.____1152, false, 1)
        }
        if (this.____1009.missionStarList[missionInfo.id] == null || this.____1009.missionStarList[missionInfo.id] < 3) {
            ____654.____674.setKYBtnEnabled(this.____1735, false, 2)
        } else {
            ____654.____674.setKYBtnEnabled(this.____1735, true, 2)
        }
    },
    ____6: function() {
        this.____884.addListener(this, this.____16);
        this.____1152.addListener(this, this.____16);
        this.____1735.addListener(this, this.____16);
        this.____970.addListener(this, null, this.downHandler, this.upHandler);
        ____655.copyInfo.addEventListener(____655.____661.copy_awardStateUpdate, this.awardStateUpdateHandler, this);
        ____654.____672.addEventListener(____655.____661.guide_enterXiuXianCopy, this.guideHandler, this);
        ____655.statInfo.addEventListener(____655.____661.stat_copyStat_update, this.updateInfo, this);
        ____655.statInfo.addEventListener(____655.____661.stat_copyEnter_update, this.updateInfo, this)
    },
    ____17: function() {
        ____655.copyInfo.removeEventListener(____655.____661.copy_awardStateUpdate, this.awardStateUpdateHandler, this);
        ____654.____672.removeEventListener(____655.____661.guide_enterXiuXianCopy, this.guideHandler, this);
        ____655.statInfo.removeEventListener(____655.____661.stat_copyStat_update, this.updateInfo, this);
        ____655.statInfo.removeEventListener(____655.____661.stat_copyEnter_update, this.updateInfo, this)
    },
    awardStateUpdateHandler: function(evt) {
        if (evt.data == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
            this.____5()
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____884) {
                if (this.____926 == null) {
                    return
                }
                ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [____654.yuyanbaoManager.getYuyanbao("____2182.text6", this.____926.condition), this.____926.awardList, null, this.____1009.starCount >= this.____926.condition, this.acceptHandler, this]))
            } else if (sender == this.____1152) {
                ____654.copyTester.enterCopy(this.____1012.id, this.____1053 * 9 + this.____1632)
            } else if (sender == this.____1735) {
                var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.XIUXIAN_COPYID];
                if (info == null || info.maxMission < this.____1012.missionIds[this.____1053 * 9 + this.____1632]) {
                    ____654.tipsManager.quickTip.show("只能扫荡已通关关卡");
                    return
                }
                ____654.copyTester.sweepCopy(this.____1012.id, this.____1053 * 9 + this.____1632)
            }
        }
    },
    downHandler: function(sender, eventType, pos) {
        this.____1711 = pos
    },
    upHandler: function(sender, eventType, pos) {
        if (sender == this.____970) {
            if (this.____1711 == null) {
                return
            }
            var startPos = this.____1711;
            var endPos = pos;
            if (startPos.x - endPos.x > 50) {
                this.setPage(this.____1053 + 1)
            } else if (startPos.x - endPos.x < -50) {
                this.setPage(this.____1053 - 1)
            }
            this.____1711 = null
        }
    },
    guideHandler: function() {
        if (this.____1152.isTouchEnabled()) {
            ____654.copyTester.enterCopy(this.____1012.id, this.____1053 * 9 + this.____1632)
        }
    },
    acceptHandler: function() {
        ____654.copyMessageSender.sendStarAward(____655.allTemplates.copyTemplateList.XIUXIAN_COPYID, this.____926.id);
        this.____1009.awardStarList[this.____926.id] = true;
        this.updateStar()
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1012 = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this._countLabel = null;
        ____654.shaderCache.removeColor(this.____884);
        this.____884 = null;
        this._titleLabel = null;
        if (this.____1499 != null) {
            this.____1499.dispose();
            this.____1499 = null
        }
        this.____1152 = null;
        this.____1735 = null;
        if (this.____1590 != null) {
            this.____1590.dispose();
            this.____1590 = null
        }
        this.____1591 = null;
        this._timeLabel = null;
        this.____1344 = null;
        this.____970 = null;
        if (this._itemList != null) {
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose()
            }
            this._itemList = null
        }
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        this.____926 = null;
        if (this._canAcceptEffect != null) {
            this._canAcceptEffect.dispose();
            this._canAcceptEffect = null
        }
        this.____1711 = null;
        this._super()
    },
});
var ____2188 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _nameLabel: null,
    ____1735: null,
    ____1152: null,
    _roleBg: null,
    ____1597: null,
    ____950: null,
    ____944: null,
    ____1245: null,
    ____1246: null,
    ____1247: null,
    ____1248: null,
    ____1249: null,
    ____885: null,
    ____1311: null,
    ____1339: null,
    ____1156: null,
    _gridList: null,
    _effectList: null,
    ____1009: null,
    ____1012: null,
    _curMissionIndex: 0,
    _nextMissionIndex: 0,
    _canAcceptIndex: -1,
    ____854: null,
    _startIndex: 0,
    _canAcceptIndexList: null,
    _sweepCost: 20,
    ctor: function(controller) {
        this._super("copyYaoTaView.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this._roleBg = this.getChildByName("roleBg");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1735 = this.getChildByName("sweepBtn");
        this.____1152 = this.getChildByName("fightBtn");
        this.____950 = this.getChildByName("characterLayer");
        this.____1245 = this.getChildByName("infoLabel1");
        this.____1246 = this.getChildByName("infoLabel2");
        this.____1247 = this.getChildByName("infoLabel3");
        this.____1248 = this.getChildByName("infoLabel4");
        this.____1249 = this.getChildByName("infoLabel5");
        this.____885 = [this.getChildByName("boxBtn1"), this.getChildByName("boxBtn2"), this.getChildByName("boxBtn3")];
        this.____1311 = [this.getChildByName("levelLabel1"), this.getChildByName("levelLabel2"), this.getChildByName("levelLabel3")];
        this.____1339 = this.getChildByName("LoadingBar_742308");
        this.____1156 = this.getChildByName("fightInfoLabel2");
        this._bgPath = ____654.____675.____139("outPic/ui_copyBg1.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1597 = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._roleBg, this.____1597);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.YAOTA_COPYID);
        this.____1012 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.YAOTA_COPYID);
        this._gridList = [];
        this._effectList = {};
        var gridLayer = this.getChildByName("cellLayer");
        for (var j = 0; j < 4; j++) {
            var grid = new ____2129(true, 0, 0);
            grid.setPositionX(91 * j);
            gridLayer.addChild(grid);
            this._gridList.push(grid)
        }
        this.____854 = ____655.allTemplates.awardTemplateList.getTypeList(2);
        this._canAcceptIndexList = [];
        this.____5();
        this.____6();
        ____654.rankMessageSender.sendCopyRankInfo(1, 1);
        ____654.copyMessageSender.sendCopyAwardUpdate(____655.allTemplates.copyTemplateList.YAOTA_COPYID)
    },
    ____5: function() {
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.YAOTA_COPYID];
        this._curMissionIndex = 0;
        this._nextMissionIndex = 1;
        if (info != null && info.todayMaxMission != 0) {
            var currentMissionIndex = this.____1012.missionIds.indexOf(info.todayMaxMission);
            if (currentMissionIndex == -1) {
                this._curMissionIndex = this.____1012.missionIds.length;
                this._nextMissionIndex = this._curMissionIndex
            } else {
                this._curMissionIndex = currentMissionIndex;
                this._nextMissionIndex = currentMissionIndex + 1
            }
        }
        if (this._nextMissionIndex == this._curMissionIndex) {
            ____654.____674.setKYBtnEnabled(this.____1735, false, 2);
            ____654.____674.setKYBtnEnabled(this.____1152, false, 1)
        } else if (info == null || info.todayMaxMission >= info.maxMission) {
            ____654.____674.setKYBtnEnabled(this.____1735, false, 2)
        }
        var nextMissionInfo = this.____1012.missions[this._nextMissionIndex - 1];
        var xianwei = ____655.____667.xianwei;
        for (var i = 0; i < 4; i++) {
            var itemInfo = nextMissionInfo.awards[xianwei - 1][i];
            if (itemInfo == null) {
                this._gridList[i].setItemTemplateInfo(null)
            } else {
                this._gridList[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemInfo[0]));
                if (itemInfo[1] > 0) {
                    this._gridList[i].setCount(itemInfo[1])
                }
            }
        }
        if (____655.____667.xianwei >= nextMissionInfo.needXianwei) {
            this._nameLabel.setString(nextMissionInfo.name);
            this._nameLabel.setColor(____655.____659.____688.system)
        } else {
            this._nameLabel.setString(nextMissionInfo.name + "(" + ____655.____659.nameType.getXianweiName(nextMissionInfo.needXianwei) + ")");
            this._nameLabel.setColor(____655.____659.____688.red)
        }
        this.____1156.setString(____655.____667.combat);
        this.updateAward();
        if (info == null || info.maxMission == 0) {
            this.____1249.setString("无")
        } else {
            var maxIndex = this.____1012.missionIds.indexOf(info.maxMission);
            var levelList = ____655.allTemplates.copyTemplateList.getYaoTaLevel(maxIndex);
            this.____1249.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text11", levelList[0], levelList[1]))
        }
    },
    updateBazhu: function(evt) {
        if (____655.rankInfo.copyYaotaSelfRank == 0) {
            this.____1248.setString("30+")
        } else {
            this.____1248.setString(____655.rankInfo.copyYaotaSelfRank.toString())
        }
        var bazhuInfo = ____655.rankInfo.copyYaotaBazhuInfo;
        if (bazhuInfo == null) {
            this.____1245.setString("无");
            this.____1246.setString("无");
            this.____1247.setString(0)
        } else {
            this.____944 = new ____545(bazhuInfo.playerInfo.characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____950, 1);
            this.____944.move(0, 20);
            this.____1245.setString(bazhuInfo.playerInfo.nick);
            this.____1247.setString(bazhuInfo.playerInfo.combat);
            var maxIndex = this.____1012.missionIds.indexOf(bazhuInfo.record);
            if (bazhuInfo.record == 0) {
                maxIndex = 1
            } else if (maxIndex == -1) {
                maxIndex = this.____1012.missionIds.length
            } else {
                maxIndex++
            }
            var levelList = ____655.allTemplates.copyTemplateList.getYaoTaLevel(maxIndex);
            this.____1246.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text11", levelList[0], levelList[1]))
        }
    },
    updateAward: function() {
        this._canAcceptIndex = -1;
        for (var i = 0; i < this.____854.length; i++) {
            if (this.____1009.boxAcceptState[this.____854[i].id] != true) {
                this._canAcceptIndex = i;
                break
            }
        }
        this._startIndex = 0;
        if (this._canAcceptIndex == -1) {
            this._startIndex = this.____854.length - 3
        } else if (this._canAcceptIndex == this.____854.length - 1) {
            this._startIndex = this._canAcceptIndex - 2
        } else {
            this._startIndex = this._canAcceptIndex - 1
        }
        if (this._startIndex < 0) {
            this._startIndex = 0
        }
        this._canAcceptIndexList = [];
        var pre = 0;
        for (var j = 0; j < 3; j++) {
            if (this.____1009.boxAcceptState[this.____854[this._startIndex + j].id] != true) {
                this.____885[j].setFrame("icon/ui_boxIcon.png");
                if (parseInt(this.____854[this._startIndex + j].condition) <= this._curMissionIndex) {
                    if (this._effectList[j] == null) {
                        this._effectList[j] = new RotationEffect("effect/effect_10.png", 5);
                        this._effectList[j].move(69 + 138 * j, 194);
                        this.addChild(this._effectList[j], 14)
                    }
                    this._canAcceptIndexList.push(j);
                    pre++
                } else {
                    if (this._effectList[j] != null) {
                        this._effectList[j].dispose();
                        this._effectList[j] = null
                    }
                }
            } else {
                if (this._effectList[j] != null) {
                    this._effectList[j].dispose();
                    this._effectList[j] = null
                }
                this.____885[j].setFrame("icon/ui_boxIcon0.png");
                pre++
            }
            this.____1311[j].setString(____654.yuyanbaoManager.getYuyanbao("____2182.text9", this._startIndex + j + 1));
            if (pre == 0) {
                this.____1339.setPercent(0)
            } else if (pre == 1) {
                this.____1339.setPercent(25)
            } else if (pre == 2) {
                this.____1339.setPercent(75)
            } else {
                this.____1339.setPercent(100)
            }
        }
    },
    ____6: function() {
        this.____1152.addListener(this, this.____16);
        this.____1735.addListener(this, this.____16);
        for (var i = 0; i < 3; i++) {
            this.____885[i].addListener(this, this.____16)
        }
        ____655.copyInfo.addEventListener(____655.____661.copy_awardStateUpdate, this.awardStateUpdateHandler, this);
        ____655.rankInfo.addEventListener(____655.____661.common_rankCopyUpdate, this.updateBazhu, this);
        ____655.statInfo.addEventListener(____655.____661.stat_copyStat_update, this.missionUpdateHandler, this)
    },
    ____17: function() {
        ____655.copyInfo.removeEventListener(____655.____661.copy_awardStateUpdate, this.awardStateUpdateHandler, this);
        ____655.rankInfo.removeEventListener(____655.____661.common_rankCopyUpdate, this.updateBazhu, this);
        ____655.statInfo.removeEventListener(____655.____661.stat_copyStat_update, this.missionUpdateHandler, this)
    },
    awardStateUpdateHandler: function(evt) {
        if (evt.data == ____655.allTemplates.copyTemplateList.YAOTA_COPYID) {
            this.updateAward()
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1152) {
                ____654.copyTester.enterCopy(this.____1012.id, this._nextMissionIndex - 1)
            } else if (sender == this.____1735) {
                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2182.text15", this._sweepCost) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, this.sweepHandler, null, null)
            } else {
                var index = this.____885.indexOf(sender);
                if (index == -1) {
                    return
                }
                if (this._canAcceptIndexList.indexOf(index) == -1) {
                    ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [____654.yuyanbaoManager.getYuyanbao("____2182.text10", index + this._startIndex + 1), this.____854[index + this._startIndex].awardList, null, false, null, null]))
                } else {
                    ____654.copyMessageSender.sendStarAward(____655.allTemplates.copyTemplateList.YAOTA_COPYID, this.____854[index + this._startIndex].id);
                    if (this._effectList[index] != null) {
                        this._effectList[index].dispose();
                        this._effectList[index] = null
                    }
                    this.____885[index].setFrame("icon/ui_boxIcon0.png")
                }
            }
        }
    },
    sweepHandler: function() {
        if (____655.____667.moneyInfo.money1Enough(this._sweepCost)) {
            ____654.copyTester.sweepCopy(this.____1012.id, 0)
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    missionUpdateHandler: function(evt) {
        this.____5()
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this.____1597 != null) {
            ____654.____677.removeImageQuote(this.____1597, this._roleBg);
            this.____1597 = null
        }
        this._roleBg = null;
        this._nameLabel = null;
        this.____1735 = null;
        this.____1152 = null;
        this.____950 = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        this.____1245 = null;
        this.____1246 = null;
        this.____1247 = null;
        this.____1248 = null;
        this.____1249 = null;
        this.____885 = null;
        this.____1311 = null;
        this.____1339 = null;
        this.____1156 = null;
        this.____1009 = null;
        this.____1012 = null;
        this.____854 = null;
        this._canAcceptIndexList = null;
        this._sweepCost = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this._effectList != null) {
            for (var k in this._effectList) {
                if (this._effectList[k] != null) {
                    this._effectList[k].dispose()
                }
            }
            this._effectList = null
        }
        this._super()
    },
});
var ____2189 = KYNode.extend({
    ____1707: null,
    ____1221: null,
    ____1636: null,
    ____1224: null,
    ____1412: null,
    ____1267: false,
    ctor: function() {
        this._super("copyXiuXianItemView.ExportJson");
        this.____1707 = [this.getChildByName("star1"), this.getChildByName("star2"), this.getChildByName("star3")];
        this.____1221 = this.getChildByName("headIcon");
        this.____1221.setScale(1.15);
        this.____1636 = this.getChildByName("selectImg");
        this.____1636.setVisible(false)
    },
    ____363: function(missionInfo) {
        this.____1412 = missionInfo;
        var boss = ____655.allTemplates.monsterTemplateList.getMonster(missionInfo.bossId);
        this.setPath(____654.____675.getMonsterHead(boss.headPath))
    },
    setPath: function(path) {
        var this_ = this;

        function complateHandler() {
            if (this_.____1267) {
                ____654.shaderCache.setColor(this_.____1221, 1)
            } else {
                ____654.shaderCache.setColor(this_.____1221, 0)
            }
        };
        this.clearIcon();
        this.____1224 = path;
        if (this.____1224 == null) {
            return
        }
        ____654.____677.____146(this.____1221, this.____1224, complateHandler)
    },
    setStarCount: function(count) {
        if (count == null) {
            count = 0
        }
        for (var i = 0; i < 3; i++) {
            if (i < count) {
                this.____1707[i].setFrame("icon/ui_startIcon5.png")
            } else {
                this.____1707[i].setFrame("icon/ui_startIcon0.png")
            }
        }
    },
    setSelected: function(value) {
        this.____1636.setVisible(value);
        this.setTouchEnabled(!value)
    },
    clearIcon: function() {
        if (this.____1224 != null) {
            ____654.____677.removeImageQuote(this.____1224, this.____1221);
            this.____1224 = null
        }
    },
    setGray: function(value) {
        this.____1267 = value
    },
    dispose: function() {
        this._super();
        this.clearIcon();
        this.____1707 = null;
        ____654.shaderCache.removeColor(this.____1221);
        this.____1221 = null;
        this.____1636 = null;
        this.____1412 = null
    },
});
var XuanshangItemView = KYNode.extend({
    _bg: null,
    _bgPath: null,
    ____1241: null,
    ____1707: null,
    ____937: null,
    _complateIcon: null,
    ____950: null,
    _freshBtn: null,
    ____1152: null,
    _titleLabel: null,
    ____1418: null,
    ____1799: null,
    ____944: null,
    _characterInfo: null,
    _monsterId: null,
    _star: 0,
    _count: null,
    _isKill: null,
    ctor: function(index) {
        this._super("xuanshangItemView.ExportJson");
        this.____1241 = index;
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/strength_bg4.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1707 = [this.getChildByName("starIcon1"), this.getChildByName("starIcon2"), this.getChildByName("starIcon3"), this.getChildByName("starIcon4"), this.getChildByName("starIcon5")];
        this._complateIcon = this.getChildByName("complateIcon");
        this.____950 = this.getChildByName("characterLayer");
        this._freshBtn = this.getChildByName("freshBtn");
        this.____1152 = this.getChildByName("fightBtn");
        this._titleLabel = this.getChildByName("titleLabel1");
        this.____1799 = this.getChildByName("titleLabel2");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____937 = [];
        for (var i = 1; i < 4; i++) {
            var itemGrid = new ____2129();
            this.getChildByName("cellBg" + i).addChild(itemGrid);
            this.____937.push(itemGrid)
        }
        this.____6()
    },
    ____6: function() {
        this._freshBtn.addListener(this, this.____16);
        this.____1152.addListener(this, this.____16)
    },
    ____17: function() {},
    setMonster: function(monsterId, star) {
        if (this._monsterId != monsterId) {
            this.clearCharacter();
            this._monsterId = monsterId;
            var monsterInfo = ____655.allTemplates.monsterTemplateList.getMonster(monsterId);
            if (monsterInfo == null) {
                return
            }
            this._characterInfo = ____654.getCharacterInfo(monsterInfo.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____950);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(monsterInfo.figureId);
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue, scaleValue);
            this.____944.move(0, (40 + figureTemplate.windowOffsetY) * scaleValue);
            var list = ____655.allTemplates.awardTemplateList.getTypeList(25);
            var len = list.length;
            for (var i = 0; i < len; i++) {
                if (list[i].condition == this._monsterId) {
                    this.setAward(list[i].awardList);
                    break
                }
            }
        }
        if (this._star != star) {
            this._star = star;
            for (var i = 0; i < 5; i++) {
                if (star > i) {
                    this.____1707[i].setFrame("icon/ui_startIcon5.png")
                } else {
                    this.____1707[i].setFrame("icon/ui_startIcon0.png")
                }
            }
        }
    },
    setKill: function(isKill) {
        if (this._isKill == isKill) {
            return
        }
        this._isKill = isKill;
        this._freshBtn.setVisible(!this._isKill);
        this._titleLabel.setVisible(!this._isKill);
        this.____1418.setVisible(!this._isKill);
        this.____1152.setVisible(!this._isKill);
        this.____1799.setVisible(!this._isKill);
        this._complateIcon.setVisible(this._isKill)
    },
    setFreshCount: function(count) {
        if (this._isKill) {
            return
        }
        if (this._count == count) {
            return
        }
        this._count = count;
        if (count > 0) {
            this._titleLabel.setString("免费刷新 " + count);
            this._titleLabel.setPositionX(70);
            this.____1418.setVisible(false)
        } else {
            this._titleLabel.setString("5刷新");
            this._titleLabel.setPositionX(90);
            this.____1418.setVisible(true)
        }
    },
    setAward: function(list) {
        var len = list.length;
        for (var i = 0; i < 3; i++) {
            if (i < len && list[i] != null) {
                this.____937[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(list[i][0]));
                if (list[i][1] > 0) {
                    this.____937[i].setCount(list[i][1])
                } else {
                    this.____937[i].setCount(-1)
                }
            } else {
                this.____937[i].setItemTemplateInfo(null)
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._freshBtn) {
                if (this._count > 0) {
                    this.freshHandler()
                } else {
                    if (____655.____667.moneyInfo.money1Enough(5)) {
                        ____655.getAlert().show(2, "是否花费[0x009700]5[-]钻石，刷新BOSS形象和星级？" + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.TGXS_OPENTIME, 0, this, this.freshHandler, null, null)
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips1"))
                    }
                }
            } else if (sender == this.____1152) {
                ____655.getAlert().show(4, "是否邀请好友一起挑战？", null, 0, this, this.yaoqingHandler, this.enterCopyHandler, null)
            }
        }
    },
    freshHandler: function() {
        ____654.copyMessageSender.sendXuanshangFresh(this.____1241)
    },
    yaoqingHandler: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_showTeamPanel, ____654.____672, [2, true, this.____1241]))
    },
    enterCopyHandler: function() {
        ____654.copyMessageSender.sendTeamEnterCopy(2, this.____1241, 0)
    },
    clearCharacter: function() {
        if (this.____944 != null) {
            this.____944.dispose();
            this._characterInfo.dispose();
            this.____944 = null;
            this._characterInfo = null
        }
    },
    dispose: function() {
        this.____17();
        this.clearCharacter();
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bg = null;
        this.____1707 = null;
        this._complateIcon = null;
        this.____950 = null;
        this._freshBtn = null;
        this.____1152 = null;
        this._titleLabel = null;
        this.____1799 = null;
        this.____1418 = null;
        if (this.____937 != null) {
            for (var i = 0; i < this.____937.length; i++) {
                this.____937[i].dispose()
            }
            this.____937 = null
        }
        this._super()
    },
});
var XuanshangPanel = KYPanel.extend({
    _controller: null,
    _countLabel: null,
    _itemViewList: null,
    ctor: function(controller, index) {
        this._super("xuanshangPanel.ExportJson");
        this._controller = controller;
        this._countLabel = this.getChildByName("countLabel");
        this._itemViewList = [];
        for (var i = 0; i < 3; i++) {
            var itemView = new XuanshangItemView(i + 1);
            this.getChildByName("itemLayer" + (i + 1).toString()).addChild(itemView);
            this._itemViewList.push(itemView)
        }
        this.infoUpdate();
        this.____6()
    },
    ____6: function() {
        ____655.bossItemList.addEventListener(____655.____661.xuanshang_infoUpdate, this.infoUpdate, this)
    },
    ____17: function() {
        ____655.bossItemList.removeEventListener(____655.____661.xuanshang_infoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        this._countLabel.setString("剩余协助次数：" + ____655.bossItemList.xuanshangTeamCount + "次");
        var list = ____655.bossItemList.xuanshangList;
        for (var i = 0; i < 3; i++) {
            if (list[i + 1] != null) {
                this._itemViewList[i].setMonster(list[i + 1].bossId, list[i + 1].star);
                this._itemViewList[i].setKill(list[i + 1].isKill);
                this._itemViewList[i].setFreshCount(____655.bossItemList.xuanshangFreshCount)
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._countLabel = null;
        if (this._itemViewList != null) {
            for (var i = 0; i < 3; i++) {
                this._itemViewList[i].dispose()
            }
            this._itemViewList = null
        }
        this._super()
    },
});
var ____2179 = cc.Class.extend({
    copyModule: null,
    ctor: function(copyModule) {
        this.copyModule = copyModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showCopyPanel: function(type, index) {
        if (this.copyModule.copyPanel == null) {
            this.copyModule.copyPanel = new ____2182(this, index)
        }
        ____654.____676.uiPanelContainer.____125(this.copyModule.copyPanel, type)
    },
    showXuanShang: function(type, index) {
        if (this.copyModule.xuanshangPanel == null) {
            this.copyModule.xuanshangPanel = new XuanshangPanel(this, index)
        }
        ____654.____676.uiPanelContainer.____125(this.copyModule.xuanshangPanel, type)
    },
    showMatchPanel: function() {
        if (this.copyModule.copyMatchPanel == null) {
            this.copyModule.copyMatchPanel = new CopyShouHuMatchPanel(this)
        }
        ____654.____676.____125(this.copyModule.copyMatchPanel, true)
    },
    ____265: function(type) {
        if (this.copyModule.copyShopPanel == null) {
            this.copyModule.copyShopPanel = new CopyShopPanel(this, type)
        }
        ____654.____676.____125(this.copyModule.copyShopPanel, true)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.copyModule.copyPanel) {
            this.copyModule.copyPanel = null
        } else if (p == this.copyModule.copyMatchPanel) {
            this.copyModule.copyMatchPanel = null
        } else if (p == this.copyModule.copyShopPanel) {
            this.copyModule.copyShopPanel = null
        } else if (p == this.copyModule.xuanshangPanel) {
            this.copyModule.xuanshangPanel = null
        }
    },
});
var ____2180 = ____537.extend({
    copyController: null,
    copyPanel: null,
    xuanshangPanel: null,
    copyMatchPanel: null,
    copyShopPanel: null,
    setup: function(data) {
        this.copyController = new ____2179(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.xuanshang) {
            this.copyController.showXuanShang(data[0], data[1])
        } else {
            this.copyController.showCopyPanel(data[0], data[1])
        }
    },
    clear: function() {},
});
var FeiXianCommonItem = KYPanel.extend({
    ____1821: null,
    ____1001: null,
    ____1021: null,
    _numLabel: null,
    _itemList: null,
    _gridList: null,
    _hasGetFlag: null,
    ____1185: null,
    ____1186: null,
    ____1165: false,
    _info: null,
    ____1126: null,
    _hasFlag: false,
    ctor: function() {
        this._super("feiYuCommonItem.ExportJson");
        this.____1821 = this.getChildByName("typeIcon");
        this.____1001 = this.getChildByName("contentLabel");
        this.____1021 = this.getChildByName("countBar");
        this._numLabel = this.getChildByName("numLabel");
        this._itemList = [];
        this._gridList = [];
        for (var i = 0; i < 2; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            this._itemList[i].addChild(grid);
            this._gridList.push(grid)
        }
        this._hasGetFlag = this.getChildByName("hasGetFlag");
        this._hasGetFlag.setVisible(false);
        this.____1185 = this.getChildByName("getBtn__1");
        this.____1186 = this.____1185.getChildByName("btnLabel");
        this.____6()
    },
    ____18: function(info) {
        if (info == null) return;
        this._info = info;
        var conditionList = ____655.feiXianInfo.conditionList;
        var itemGetAward = ____655.feiXianInfo.itemGetAward;
        var awardList = info.typeAwardList;
        var len = awardList.length;
        if (len > 2) len = 2;
        for (var i = 0; i < len; i++) {
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(awardList[i][0]);
            this._gridList[i].setItemTemplateInfo(itemTemplateInfo);
            this._gridList[i].setCount(awardList[i][1])
        }
        this.____1001.setString(info.content);
        this.____1821.setFrame(info.picPath);
        var hasNums = 0;
        if (conditionList[info.type] != null) {
            hasNums = conditionList[info.type]
        }
        this._numLabel.setString(hasNums + "/" + info.condition);
        var pre = Math.floor(hasNums * 100 / parseInt(info.condition));
        if (pre >= 100) {
            pre = 100;
            if (itemGetAward.length > 0) {
                if (itemGetAward.indexOf(info.type) == -1) {
                    ____654.____674.setKYBtnEnabled(this.____1185, true, 1);
                    this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text5"));
                    this.____1165 = true
                } else {
                    this.____1185.setVisible(false);
                    this._hasGetFlag.setVisible(true);
                    this.____1165 = false;
                    this._hasFlag = true
                }
            } else {
                ____654.____674.setKYBtnEnabled(this.____1185, true, 1);
                this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text5"));
                this.____1165 = true
            }
        } else {
            ____654.____674.setKYBtnEnabled(this.____1185, true, 2);
            this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text6"));
            this.____1165 = false
        }
        if (this.____1165) {
            if (this.____1126 == null) {
                this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(57, 28), this.____1185)
            }
        }
        this.____1021.setPercent(pre)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1185) {
                if (this.____1165) {
                    ____654.selfDataMessageSender.sendFeiXianGetAward(2, this._info.type)
                } else {
                    ____654.triggerManager.handlerList(this._info.deploy)
                }
            }
        }
    },
    getFlagState: function() {
        return this.____1165
    },
    getAwardState: function() {
        return this._hasFlag
    },
    ____6: function() {
        this.____1185.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this.____1821 = null;
        this.____1001 = null;
        this.____1021 = null;
        this._numLabel = null;
        this._hasGetFlag = null;
        this._itemList = null;
        this.____1185 = null;
        this.____1186 = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._info = null;
        this._hasFlag = null;
        this._super()
    },
});
var FeiXianCommonView = KYPanel.extend({
    _content1: null,
    _days: 0,
    _timeLabel: null,
    _countDownUtils: null,
    _listView: null,
    ____1840: null,
    _timeTips: null,
    _tipsLabel: null,
    _itemList: null,
    _gridList: null,
    ____1251: null,
    ____1165: false,
    ____1185: null,
    _hasGetFlag: null,
    ____1186: null,
    ____862: null,
    _barBgPath: null,
    ____1126: null,
    ctor: function(days) {
        this._super("feiYuCommonView.ExportJson");
        this._content1 = this.getChildByName("content1");
        this._content1.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text1"));
        this._days = days;
        this._timeLabel = this.getChildByName("timeLabel");
        this._timeLabel.setString("00:00:00");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        this.____1251 = [];
        this.____1840 = [];
        this._listView = this.getChildByName("listView");
        this._listView.setItemsMargin(5);
        this._listView.setScrollBarEnabled(false);
        this._timeTips = this.getChildByName("timeTips");
        this._timeTips.setString("");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setString("");
        this._itemList = [];
        this._gridList = [];
        for (var i = 0; i < 5; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            this._itemList[i].addChild(grid);
            this._gridList.push(grid)
        }
        this._hasGetFlag = this.getChildByName("hasGetFlag");
        this._hasGetFlag.setVisible(false);
        this.____1185 = this.getChildByName("getBtn__1");
        this.____1186 = this.____1185.getChildByName("btnLabel");
        this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text5"));
        this.____862 = this.getChildByName("barBg_Copy0");
        this._barBgPath = ____654.____675.____139("outPic/commonBarBg.png");
        ____654.____677.____146(this.____862, this._barBgPath);
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.setCountDownTime();
        var tempLateInfoList = ____655.allTemplates.feiXianTemplateList.infoList[this._days];
        var weekDay = ____655.____662.getDate(____655.____667.createRoleTime).getDay();
        weekDay = (weekDay + this._days - 1) % 7;
        if (weekDay == 0) {
            weekDay = 7
        }
        for (var i = 0; i < tempLateInfoList.length; i++) {
            if (tempLateInfoList[i].weeks == 0 || (tempLateInfoList[i].weeks > 0 && tempLateInfoList[i].weeks == weekDay)) {
                this.____1251.push(tempLateInfoList[i])
            }
        }
        this._timeTips.setString(____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text10", this._days));
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text11", this.____1251.length));
        var len1 = this.____1251[3].awardList.length;
        if (len1 >= 5) len1 = 5;
        for (var i = 0; i < len1; i++) {
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(this.____1251[3].awardList[i][0]);
            this._gridList[i].setItemTemplateInfo(itemTemplateInfo);
            this._gridList[i].setCount(this.____1251[3].awardList[i][1])
        }
        this.updateView()
    },
    setCountDownTime: function() {
        var lastRevertTime = 0;
        var createZoreTime = ____655.____667.createRoleTime * 0.001 - ((____655.____667.createRoleTime * 0.001 + ____655.____662.____1888) % ____655.____662.secondsOfDay);
        lastRevertTime = (7 * ____655.____662.secondsOfDay) + createZoreTime - ____655.____662.getSystemTimeSec();
        this._countDownUtils.start(lastRevertTime)
    },
    updateView: function() {
        if (this.____1840 != null) {
            this._listView.removeAllItems();
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = []
        }
        var len = this.____1251.length;
        var list1 = [];
        var list2 = [];
        var list3 = [];
        for (var i = 0; i < len; i++) {
            var item = new FeiXianCommonItem();
            item.____18(this.____1251[i]);
            if (item.getFlagState()) {
                list1.push(item)
            } else {
                if (item.getAwardState()) {
                    list3.push(item)
                } else {
                    list2.push(item)
                }
            }
            this.____1840.push(item)
        }
        for (var i = 0; i < list1.length; i++) {
            this._listView.pushBackItem(list1[i])
        }
        for (var i = 0; i < list2.length; i++) {
            this._listView.pushBackItem(list2[i])
        }
        for (var i = 0; i < list3.length; i++) {
            this._listView.pushBackItem(list3[i])
        }
        var list1 = null;
        var list2 = null;
        var list3 = null;
        var itemGetAward = ____655.feiXianInfo.itemGetAward;
        var viewGetAward = ____655.feiXianInfo.viewGetAward;
        var hasGetAwardNum = 0;
        if (viewGetAward.length > 0) {
            if (viewGetAward.indexOf(this._days) == -1) {
                for (var i = 0; i < this.____1251.length; i++) {
                    if (itemGetAward.length > 0) {
                        if (itemGetAward.indexOf(this.____1251[i].type) != -1) {
                            hasGetAwardNum = hasGetAwardNum + 1
                        }
                    }
                }
                if (hasGetAwardNum >= 4) {
                    ____654.____674.setKYBtnEnabled(this.____1185, true, 1);
                    this.____1165 = true
                } else {
                    ____654.____674.setKYBtnEnabled(this.____1185, false, 0);
                    this.____1165 = false
                }
            } else {
                this.____1185.setVisible(false);
                this._hasGetFlag.setVisible(true);
                this.____1165 = true
            }
        } else {
            for (var i = 0; i < this.____1251.length; i++) {
                if (itemGetAward.length > 0) {
                    if (itemGetAward.indexOf(this.____1251[i].type) != -1) {
                        hasGetAwardNum = hasGetAwardNum + 1
                    }
                }
            }
            if (hasGetAwardNum >= 4) {
                ____654.____674.setKYBtnEnabled(this.____1185, true, 1);
                this.____1165 = true
            } else {
                ____654.____674.setKYBtnEnabled(this.____1185, false, 0);
                this.____1165 = false
            }
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        if (this.____1165) {
            this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(59, 28), this.____1185)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1185) {
                if (this.____1165) {
                    ____654.selfDataMessageSender.sendFeiXianGetAward(1, this._days)
                }
            }
        }
    },
    ____6: function() {
        this.____1185.addListener(this, this.____16);
        ____655.feiXianInfo.addEventListener(____655.____661.playerInfo_feiXianInfo_Update, this.updateView, this)
    },
    ____17: function() {
        ____655.feiXianInfo.removeEventListener(____655.____661.playerInfo_feiXianInfo_Update, this.updateView, this)
    },
    dispose: function() {
        this.____17();
        this._content1 = null;
        this._days = null;
        this._timeLabel = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._listView = null;
        this._timeTips = null;
        this._tipsLabel = null;
        if (this.____1840 != null) {
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = null
        }
        this._itemList = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this._barBgPath != null) {
            ____654.____677.removeImageQuote(this._barBgPath, this.____862);
            this._barBgPath = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this.____862 = null;
        this.____1185 = null;
        this._hasGetFlag = null;
        this.____1186 = null;
        this._super()
    },
});
var FeiXianPanel = KYPanel.extend({
    _controller: null,
    ____1740: null,
    ____1502: null,
    _panelList: null,
    ____1736: null,
    _chgTypeList: null,
    ____1062: -1,
    ctor: function(controller) {
        this._super("feiYuPanel.ExportJson");
        this._controller = controller;
        this.____1740 = this.getChildByName("tabLayer");
        this.____1502 = this.getChildByName("panelLayer");
        this._panelList = {};
        this.____1736 = [];
        this._chgTypeList = [];
        this.____5();
        this.____6()
    },
    ____5: function() {
        var tabNameList = [____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text1"), ____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text2"), ____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text3"), ____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text4"), ____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text5"), ____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text6"), ____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text7")];
        var tabList = ____655.allTemplates.feiXianTemplateList.typeList;
        for (var i = 0; i < tabList.length; i++) {
            this._chgTypeList.push(tabList[i]);
            var tabBtn = new ____2143(5);
            var tabName = tabNameList[tabList[i] - 1];
            if (____655.allTemplates.feiXianTemplateList.getCountDownTypeList().indexOf(tabList[i]) == -1) {
                tabBtn.setOpenDayFlag(tabList[i])
            }
            tabBtn.setLabel(tabName);
            this.____1740.pushBackItem(tabBtn);
            this.____1736.push(tabBtn);
            this.____1736[i].addListener(this, this.btnTabClickHandler, null, null, null, false, true)
        }
        this.____1740.setItemsMargin(5);
        this.setIndexPanel(0);
        this.popUpdate()
    },
    btnTabClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this.____1736.indexOf(sender);
            var curDays = this._chgTypeList[index];
            if (____655.allTemplates.feiXianTemplateList.getCountDownTypeList().indexOf(curDays) == -1) {
                var content = ____654.yuyanbaoManager.getYuyanbao("FeiXianPanel.text8", curDays);
                ____654.tipsManager.quickTip.show(content);
                return
            }
            if (index == this.____1062) {
                return
            } else {
                this.setIndexPanel(index)
            }
        }
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.closePanel, this);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    setIndexPanel: function(index) {
        if (this.____1062 != -1) {
            this.____1736[this.____1062].setSelected(false);
            this._panelList[this.____1062].removeFromParent(false)
        }
        var curDays = this._chgTypeList[index];
        this.____1062 = index;
        this.____1736[this.____1062].setSelected(true);
        if (this._panelList[this.____1062] == null) {
            this._panelList[this.____1062] = this.getPanel(curDays)
        }
        this.____1502.addChild(this._panelList[this.____1062])
    },
    getPanel: function(days) {
        var panel = null;
        if (panel == null) {
            panel = new FeiXianCommonView(days)
        }
        return panel
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.global_dayUpdate, this.closePanel, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 3) {
            this.____1736[0].setShowPop(____654.playerInfoTester.feixianGift1Num > 0)
        }
        if (type == 0 || type == 4) {
            this.____1736[1].setShowPop(____654.playerInfoTester.feixianGift2Num > 0)
        }
        if (type == 0 || type == 5) {
            this.____1736[2].setShowPop(____654.playerInfoTester.feixianGift3Num > 0)
        }
        if (type == 0 || type == 6) {
            this.____1736[3].setShowPop(____654.playerInfoTester.feixianGift4Num > 0)
        }
        if (type == 0 || type == 7) {
            this.____1736[4].setShowPop(____654.playerInfoTester.feixianGift5Num > 0)
        }
        if (type == 0 || type == 8) {
            this.____1736[5].setShowPop(____654.playerInfoTester.feixianGift6Num > 0)
        }
        if (type == 0 || type == 9) {
            this.____1736[6].setShowPop(____654.playerInfoTester.feixianGift7Num > 0)
        }
    },
    closePanel: function() {
        ____654.____676.uiPanelContainer.close()
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1740 = null;
        this.____1502 = null;
        if (this.____1736 != null) {
            for (var i = 0; i < this.____1736.length; i++) {
                this.____1736[i].dispose()
            }
            this.____1736 = null
        }
        if (this._panelList != null) {
            for (var i in this._panelList) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        this._chgTypeList = null;
        this.____1062 = null;
        this._super()
    },
});
var FeiXianController = cc.Class.extend({
    feiXianModule: null,
    ctor: function(module) {
        this.feiXianModule = module;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showFeiXianPanel: function(type) {
        if (this.feiXianModule.feiXianPanel == null) {
            this.feiXianModule.feiXianPanel = new FeiXianPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.feiXianModule.feiXianPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.feiXianModule.feiXianPanel) {
            this.feiXianModule.feiXianPanel = null
        }
    },
});
var FeiXianModule = ____537.extend({
    feiXianController: null,
    feiXianPanel: null,
    setup: function(data) {
        this.feiXianController = new FeiXianController(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.feiXian) {
            this.feiXianController.showFeiXianPanel(data[0], data[1])
        }
    },
    clear: function() {},
});
var ____2192 = KYNode.extend({
    ____962: null,
    ____1148: null,
    ____1650: null,
    ____1310: null,
    _inputController: null,
    ____1309: null,
    ____1311: null,
    ____960: null,
    ____1226: 0,
    ____1774: 0,
    ____1241: 0,
    ____1398: 30,
    _info: 0,
    ctor: function() {
        this._super("sjChatView.ExportJson");
        this.____962 = this.getChildByName("scrollView");
        this.____962.setScrollBarEnabled(false);
        this.____1148 = this.getChildByName("faceBtn");
        this.____1650 = this.getChildByName("sendBtn");
        var labelLayer = this.getChildByName("labelLayer");
        this._inputController = new InputLabelController(____654.____673.____159(0, 20), labelLayer.getContentSize(), labelLayer, this.____1398, 20);
        this.____1309 = ____654.____673.newKYNode();
        this.____1309.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____962.addContent(this.____1309);
        this.____1311 = [];
        this.____960 = [];
        this.____6();
        this.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2192.text1"))
    },
    ____6: function() {
        this.____1650.addListener(this, this.____16);
        this.____1148.addListener(this, this.____16);
        ____655.____669.addEventListener(____655.____661.____761, this.addChatItemInfoHandler, this)
    },
    ____17: function() {
        ____655.____669.removeEventListener(____655.____661.____761, this.addChatItemInfoHandler, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1148) {
                ____654.tipsManager.showFaceTip(____654.____673.____159(____655.____656 - 380, 82), this.faceTipHandler, this)
            } else if (sender == this.____1650) {
                var content = this._inputController.getString();
                if (content == null || content == "") {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("chatPanel.sendTip1"));
                    return
                }
                this.sendMessage(content, true)
            }
        }
    },
    ____243: function(info) {
        this.clearLabels();
        this._info = info;
        var list = ____655.____669.getPrivatChatList(this._info.userId);
        if (list == null) return;
        for (var i = 0; i < list.length; i++) {
            this.____960.push(list[i])
        }
        ____654.____678.____298(this.tick, this)
    },
    addChatItemInfoHandler: function(evt) {
        var info = evt.data;
        if (info != null) {
            if (info.channel == ____655.____659.____693.privat && (info.toUserId == this._info.userId || info.playerInfo.userId == this._info.userId)) {
                this.____960.push(info);
                ____654.____678.____298(this.tick, this)
            }
        }
    },
    tick: function(delta, count) {
        this.____1774++;
        if (this.____1774 > 3) {
            this.____1774 = 0;
            var info = null;
            var label = null;
            if (this.____1241 < this.____960.length) {
                info = this.____960[this.____1241];
                this.____1241++;
                label = new ____2138(542);
                label.setCharInfo(info);
                info.____34(false);
                label.setPosition(____654.____673.____159(5, -this.____1226));
                this.____1226 += label.getHeight();
                this.____1309.addChild(label)
            }
            if (label != null) {
                this.____1309.setPositionY(Math.max(this.____1226, 450));
                this.____1311.push(label);
                this.____962.setInnerSize(____654.____673.____160(583, this.____1226));
                this.____962.jumpToBottom()
            }
            if (this.____1241 == this.____960.length) {
                ____654.____678.____299(this.tick, this)
            }
        }
    },
    sendMessage: function(message) {
        var info = new ____481();
        info.playerInfo.serverId = ____655.____667.serverId;
        info.playerInfo.vipLevel = ____655.____667.vipLevel;
        info.playerInfo.gm = ____655.____667.gm;
        info.playerInfo.nick = ____655.____667.nick;
        info.playerInfo.userId = ____655.____667.userId;
        info.toUserId = this._info.userId;
        info.playerInfo.career = ____655.____667.career;
        info.channel = ____655.____659.____693.privat;
        info.message = message;
        info.time = ____655.____662.secondsToDateString(____655.____662.getSystemTimeSec());
        ____655.____669.____36(info);
        ____654.____683.sendChat(____655.____659.____693.privat, message, this._info.nick, this._info.userId);
        this._inputController.setString("")
    },
    faceTipHandler: function(index) {
        var faceMsg = "";
        var content = this._inputController.getString();
        if (content.length >= this.____1398) {
            return
        }
        if (index < 10) {
            faceMsg = "#0" + index
        } else {
            faceMsg = "#" + index
        }
        this._inputController.setString(content + faceMsg)
    },
    clearLabels: function() {
        ____654.____678.____299(this.tick, this);
        for (var i = 0; i < this.____1311.length; i++) {
            this.____1311[i].dispose()
        }
        this.____1311 = [];
        this.____960 = [];
        this.____1241 = 0;
        this.____1226 = 0;
        this._info = null
    },
    dispose: function() {
        ____654.tipsManager.hide();
        this.____17();
        this.clearLabels();
        this.____1311 = null;
        this.____962 = null;
        this.____1148 = null;
        this.____1650 = null;
        this.____1310 = null;
        this.____960 = null;
        this.____1226 = null;
        this.____1774 = null;
        this.____1241 = null;
        this.____1398 = null;
        this._info = null;
        if (this._inputController != null) {
            this._inputController.dispose();
            this._inputController = null
        }
        if (this.____1309 != null) {
            this.____1309.dispose();
            this.____1309 = null
        }
        this._super()
    },
});
var ____2193 = KYNode.extend({
    _info: null,
    ____927: null,
    ____1849: null,
    ____1848: null,
    _nameLabel: null,
    ____995: null,
    _bg: null,
    ____1779: null,
    _downPos: null,
    ctor: function(info) {
        this._super("sjFriendItemView.ExportJson");
        this._info = info;
        this.____927 = this.getChildByName("careerIcon");
        this.____927.setTouchEnabled(true);
        this.____1849 = this.getChildByName("vipImg");
        this.____1848 = this.getChildByName("vipLevelLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____995 = this.getChildByName("combatLabel");
        this._bg = this.getChildByName("bg");
        this.____1779 = this.getChildByName("tipIcon");
        this.____6();
        this.____5()
    },
    ____6: function() {
        this.____927.addListener(this, this.iconClickHandler, this.downHandler, null, null, false, true);
        this._info.addEventListener(____655.____661.common_friendStateUpdate, this.onlineUpdate, this)
    },
    ____17: function() {
        if (this._info != null && this._info.info != null) {
            this._info.removeEventListener(____655.____661.common_friendStateUpdate, this.onlineUpdate, this)
        }
    },
    downHandler: function(sender, eventType, pos) {
        this._downPos = pos
    },
    iconClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this._info != null) {
                ____654.tipsManager.showPlayerMenuTip(2, this._info.info, this._downPos);
                if (this._callBack != null) {
                    this._callBack.call(this._executor, this, eventType)
                }
            }
        }
    },
    ____5: function() {
        if (this._info == null) return;
        this._nameLabel.setString(this._info.info.nick);
        this.____995.setString(____654.____674.getWanCount(this._info.combat));
        this.____927.setFrame("sceneIcon/PlayerHeadIcon2_" + this._info.info.career.toString() + ".png");
        if (this._info.info.vipLevel > 0) {
            this.____1849.setVisible(true);
            this.____1848.setVisible(true);
            this.____1848.setString(this._info.info.vipLevel)
        } else {
            this.____1849.setVisible(false);
            this.____1848.setVisible(false)
        }
        var count = ____655.____669.getUnreadCountByUserId(this._info.info.userId);
        this.showPopIcon(count > 0);
        this.onlineUpdate()
    },
    ____239: function(isSelect) {
        if (isSelect) {
            this._bg.setFrame("board/ui_board8.png")
        } else {
            this._bg.setFrame("board/ui_board7.png")
        }
    },
    onlineUpdate: function(evt) {
        if (this._info.online > 0) {
            ____654.shaderCache.setColor(this.____927, 0);
            this._nameLabel.setColor(____655.____659.____688.yellow)
        } else {
            ____654.shaderCache.setColor(this.____927, 1);
            this._nameLabel.setColor(____655.____659.____688.smoke)
        }
    },
    ____238: function() {
        return this._info
    },
    showPopIcon: function(flag) {
        this.____1779.setVisible(flag)
    },
    dispose: function() {
        this.____17();
        this._info = null;
        ____654.shaderCache.removeColor(this.____927);
        this.____927 = null;
        this._downPos = null;
        this.____1849 = null;
        this.____1848 = null;
        this._nameLabel = null;
        this.____995 = null;
        this._bg = null;
        this._super()
    },
});
var ____561 = KYPanel.extend({
    _controller: null,
    ____1734: null,
    ____1286: null,
    ____962: null,
    _tipsLabel: null,
    ____1790: null,
    _tileContainer: null,
    ____1259: false,
    ____1039: -1,
    ____1038: 0,
    ____961: null,
    ____1819: null,
    ____1282: false,
    ____1759: null,
    _tickCount: 5,
    _countLabel: null,
    ctor: function(controller) {
        this._controller = controller;
        this._super("sjPanel.ExportJson");
        this.____1734 = this.getChildByName("btn1");
        this.____962 = this.getChildByName("chatView");
        this.____962.setScrollBarEnabled(false);
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____1790 = this.getChildByName("tipsLabel2");
        this._countLabel = this.getChildByName("countLabel");
        this.____961 = new ____2192();
        this.____1819 = new ____2196();
        this._tileContainer = this.getChildByName("itemListView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____561.text1"));
        this.____1790.setString(____654.yuyanbaoManager.getYuyanbao("____561.text2"));
        this.getChildByName("desLabel").setString(____654.yuyanbaoManager.getYuyanbao("____561.text4"));
        this.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("____561.text5"));
        ____654.selfDataMessageSender.sendGetTuiJianCount();
        this.____6();
        this.updateListView(true)
    },
    ____6: function() {
        this.____1734.addListener(this, this.tuiJianBtnHandler);
        ____655.____668.addEventListener(____655.____661.common_friendListUpdate, this.friendUpdateHandler, this);
        ____655.____668.addEventListener(____655.____661.common_friendTJCountUpdate, this.tuiJianViewUpdate, this);
        ____655.____668.addEventListener(____655.____661.common_addFriend, this.friendUpdateHandler, this);
        ____655.____668.addEventListener(____655.____661.common_deleteFriend, this.friendDeleteHandler, this);
        ____654.____672.addEventListener(____655.____661.common_friendSelectItem, this.selectItemHandler, this)
    },
    ____17: function() {
        ____655.____668.removeEventListener(____655.____661.common_friendListUpdate, this.friendUpdateHandler, this);
        ____655.____668.removeEventListener(____655.____661.common_friendTJCountUpdate, this.tuiJianViewUpdate, this);
        ____655.____668.removeEventListener(____655.____661.common_addFriend, this.friendUpdateHandler, this);
        ____655.____668.removeEventListener(____655.____661.common_deleteFriend, this.friendDeleteHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_friendSelectItem, this.selectItemHandler, this)
    },
    friendUpdateHandler: function() {
        this.updateListView(false)
    },
    friendDeleteHandler: function(evt) {
        var userId = 0;
        if (evt != null) {
            userId = evt.data
        }
        if (userId > 0) {
            this._tileContainer.removeItemById(userId);
            if (this.____1038 == userId) {
                var index = this.____1039;
                this.____1038 = 0;
                this.____1039 = -1;
                if (____655.____668.list.length > 0) {
                    index--;
                    if (index < 0) {
                        index = 0
                    }
                    this.setSelectedItem(index)
                }
            }
        }
        this.updateListView(false)
    },
    tuiJianViewUpdate: function() {
        if (____655.____668.tuiJianCount <= 0) {
            this.showTuiJianView(false);
            ____654.____674.setKYBtnEnabled(this.____1734, false, 1)
        } else {
            if (____655.____668.list.length <= 0) {
                this.showTuiJianView(true)
            }
            ____654.____674.setKYBtnEnabled(this.____1734, true, 1)
        }
    },
    getItemByIndex: function(index) {
        var info = ____655.____668.list[index];
        if (info == null) return null;
        var item = new ____2193(info);
        item.addListener(this, this.itemClickHandler, null, null, null, false, true);
        if (index == this.____1039) {
            item.____239(true);
            item.showPopIcon(false)
        }
        return item
    },
    getIdByIndex: function(index) {
        var info = ____655.____668.list[index];
        if (info == null) return -1;
        return info.info.userId
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var info = sender.____238();
            if (info != null) {
                var index = ____655.____668.list.indexOf(info);
                if (index != -1) {
                    this.setSelectedItem(index)
                }
            }
        }
    },
    updateListView: function(isChangeSelect) {
        if (isChangeSelect != null) {
            this.____1259 = isChangeSelect
        } else {
            this.____1259 = false
        }

        function friendSort(info1, info2) {
            var count1 = ____655.____669.getUnreadCountByUserId(info1.info.userId);
            var count2 = ____655.____669.getUnreadCountByUserId(info2.info.userId);
            if (count1 > 0 && count2 > 0) {
                if (info2.online == info1.online) {
                    return info2.combat - info1.combat
                }
                return info1.online - 0.5
            } else if ((count1 + count2) > 0) {
                return count2 - count1
            } else {
                if (info2.online == info1.online) {
                    return info2.combat - info1.combat
                }
                return info2.online - 0.5
            }
        }
        ____655.____668.list.sort(friendSort);
        var length = ____655.____668.list.length;
        if (length > 0) {
            this._tipsLabel.setVisible(false);
            this.____1790.setVisible(false);
            if (!this.____1259 && this.____1038 > 0) {
                this.setSelectedItemById(this.____1038)
            }
        } else {
            this.____1790.setVisible(true);
            this._tipsLabel.setVisible(true)
        }
        this._countLabel.setString(length + "/" + ____655.____668.maxCount);
        this._tileContainer.setFormat(1, length, ____654.____673.____160(271, 96), 4, 7, this.____1259)
    },
    selectItemHandler: function(evt) {
        if (evt != null) {
            this.____1759 = evt.data
        }
        this._tickCount = 5;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount == 0) {
            if (____655.____668.list.length <= 0) return;
            if (this.____1759 == null) {
                this.setSelectedItem(0)
            } else {
                this.setSelectedItemById(this.____1759)
            }
            ____654.____678.____299(this.tick, this)
        }
    },
    setSelectedItem: function(index) {
        if (this.____1039 == index) {
            if (this.____1282) {
                this.showChatView()
            }
            return
        }
        if (this.____1039 >= 0) {
            var item = this._tileContainer.getItemByIndex(this.____1039);
            if (item != null) {
                item.____239(false)
            }
        }
        this.____1039 = index;
        var id = this.getIdByIndex(this.____1039);
        this.____1038 = id;
        var item = this._tileContainer.getItemByIndex(this.____1039);
        if (item != null) {
            item.____239(true);
            item.showPopIcon(false)
        }
        this.showChatView();
        var info = ____655.____668.list[index];
        if (info != null) {
            this.____961.____243(info.info)
        }
    },
    setSelectedItemById: function(id) {
        if (id == null) return;
        var index = 0;
        for (var i = 0; i < ____655.____668.list.length; i++) {
            if (____655.____668.list[i].getId() == id) {
                index = i;
                break
            }
        }
        var count = 526 / 96;
        var percent = Math.floor(index / (____655.____668.list.length - count) * 100);
        if (percent > 100) {
            percent = 100
        }
        this._tileContainer.jumpToPercent(percent);
        this.setSelectedItem(index)
    },
    showTuiJianView: function(isShow) {
        this.____1282 = isShow;
        if (isShow) {
            if (this.____1819.getParent() == null) {
                this.____962.addChild(this.____1819)
            }
            if (this.____961.getParent() != null) {
                this.____961.removeFromParent(false)
            }
            this.____1790.setVisible(false)
        } else {
            if (this.____1039 >= 0) {
                this.showChatView()
            } else if (this.____1819.getParent() != null) {
                this.____1819.removeFromParent(false)
            }
            var length = ____655.____668.list.length;
            if (length > 0) {
                this.____1790.setVisible(false)
            } else {
                this.____1790.setVisible(true)
            }
        }
    },
    showChatView: function() {
        this.____1282 = false;
        if (this.____961.getParent() == null) {
            this.____962.addChild(this.____961)
        }
        if (this.____1819.getParent() != null) {
            this.____1819.removeFromParent(false)
        }
    },
    tuiJianBtnHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (____655.____668.list.length < ____655.____668.maxCount) {
                if (____655.____668.tuiJianCount > 0) {
                    this.showTuiJianView(!this.____1282)
                }
            } else {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____561.text3"))
            }
        }
    },
    tuiJianBtnUpdate: function() {
        if (____655.____668.tuiJianCount > 0) {
            ____654.____674.setKYBtnEnabled(this.____1734, true, 1)
        } else {
            ____654.____674.setKYBtnEnabled(this.____1734, false, 0)
        }
    },
    dispose: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.chat_unreadCountReset, ____654.____672));
        this.____17();
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this.____1734 = null;
        this.____1286 = null;
        this.____962 = null;
        this._tipsLabel = null;
        this.____1790 = null;
        this._tileContainer = null;
        this.____1259 = null;
        this.____1039 = null;
        this.____1038 = null;
        if (this.____961 != null) {
            this.____961.dispose();
            this.____961 = null
        }
        if (this.____1819 != null) {
            this.____1819.dispose();
            this.____1819 = null
        }
        this.____1282 = null;
        this.____1759 = null;
        this._tickCount = null;
        this._countLabel = null;
        this._super()
    },
});
var ____2195 = KYNode.extend({
    _info: null,
    ____927: null,
    ____1848: null,
    _nameLabel: null,
    ____995: null,
    ____963: null,
    ____1849: null,
    ctor: function(info) {
        this._super("sjTuiJianItemView.ExportJson");
        this._info = info;
        this.____927 = this.getChildByName("careerIcon");
        this.____1849 = this.getChildByName("vipImg");
        this.____1848 = this.getChildByName("vipLevelLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____995 = this.getChildByName("combatLabel");
        this.____963 = this.getChildByName("checkBox");
        this.____5()
    },
    ____5: function() {
        if (this._info != null) {
            this.____963.setSelected(true);
            this._nameLabel.setString(this._info[1]);
            this.____995.setString(____654.____674.getWanCount(this._info[4]));
            if (this._info[3] > 0) {
                this.____1849.setVisible(true);
                this.____1848.setVisible(true);
                this.____1848.setString(this._info[3])
            } else {
                this.____1849.setVisible(false);
                this.____1848.setVisible(false)
            }
            this.____927.setFrame("sceneIcon/PlayerHeadIcon2_" + this._info[6] + ".png")
        }
    },
    ____238: function() {
        return this._info
    },
    dispose: function() {
        this._info = null;
        this.____927 = null;
        this.____1848 = null;
        this._nameLabel = null;
        this.____995 = null;
        this.____963 = null;
        this.____1849 = null;
        this._super()
    },
});
var ____2196 = KYNode.extend({
    ____824: null,
    _tipsLabel: null,
    _tileContainer: null,
    ctor: function() {
        this._super("sjTuiJianView.ExportJson");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____824 = this.getChildByName("addBtn");
        this.getChildByName("tipsLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2196.text1"));
        this.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2196.text3"));
        this.____6();
        ____654.selfDataMessageSender.sendGetTuiJianList()
    },
    ____6: function() {
        this.____824.addListener(this, this.____16);
        ____655.____668.addEventListener(____655.____661.commom_friendTJListUpdate, this.updateView, this)
    },
    ____17: function() {
        ____655.____668.removeEventListener(____655.____661.commom_friendTJListUpdate, this.updateView, this)
    },
    getItemByIndex: function(index) {
        var info = ____655.____668.tuiJianList[index];
        if (info == null) return null;
        var item = new ____2195(info);
        item.setClickCallBack(this.itemClickHandler, this);
        return item
    },
    getIdByIndex: function(index) {
        var info = ____655.____668.tuiJianList[index];
        if (info == null) return -1;
        return info[0]
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender.____963.getSelected()) {
                sender.____963.setSelected(false)
            } else {
                sender.____963.setSelected(true)
            }
        }
    },
    updateView: function() {
        if (this._tileContainer == null) {
            this._tileContainer = this.getChildByName("scrollView__1");
            this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this)
        }
        this._tileContainer.setFormat(2, ____655.____668.tuiJianList.length, ____654.____673.____160(273, 109), 11, 10, true)
    },
    getItemByIndex: function(index) {
        var info = ____655.____668.tuiJianList[index];
        if (info == null) return null;
        var item = new ____2195(info);
        item.addListener(this, this.itemClickHandler, null, null, null, false, true);
        return item
    },
    getIdByIndex: function(index) {
        var info = ____655.____668.tuiJianList[index];
        if (info == null) return -1;
        return info[0]
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var count = 0;
            for (var i = 0; i < ____655.____668.tuiJianList.length; i++) {
                var item = this._tileContainer.getItemByIndex(i);
                if (item != null && item.____963.getSelected()) {
                    var info = item.____238();
                    if (info != null) {
                        count++;
                        ____654.selfDataMessageSender.sendAddFriend(info[5], info[1], 1);
                        ____654.____674.setKYBtnEnabled(this.____824, false)
                    }
                }
            }
            if (count == 0) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2196.text2"))
            }
        }
    },
    dispose: function() {
        this.____17();
        this.____824 = null;
        this._tipsLabel = null;
        this._tileContainer = null;
        this._super()
    },
});
var ____2190 = cc.Class.extend({
    friendModule: null,
    ctor: function(friendModule) {
        this.friendModule = friendModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    ____227: function(type) {
        if (this.friendModule.friendPanel == null) {
            this.friendModule.friendPanel = new ____561(this)
        }
        ____654.____676.uiPanelContainer.____125(this.friendModule.friendPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.friendModule.friendPanel) {
            this.friendModule.friendPanel = null
        }
    },
});
var ____2191 = ____537.extend({
    friendController: null,
    friendPanel: null,
    setup: function(data) {
        this.friendController = new ____2190(this);
        this.____151(data)
    },
    ____151: function(data) {
        this.friendController.____227(data[0])
    },
    clear: function() {},
});
var HomeDescView = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____871: null,
    ____1096: null,
    ctor: function(controller) {
        this._controller = controller;
        this._super("homeDescView.ExportJson");
        this.modeValue = 150;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____871 = this.getChildByName("bgImg");
        this.____1096 = this.getChildByName("descLabel");
        this._bgPath = ____654.____675.____139("outPic/homeDescBg.png");
        ____654.____677.____146(this.____871, this._bgPath);
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.____1096.setString(____654.____682.____108(10100))
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            }
        }
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    dispose: function() {
        this.____17();
        ____654.____677.removeImageQuote(this._bgPath, this.____871);
        this._bgPath = null;
        this.____871 = null;
        this._closeBtn = null;
        this.____1096 = null;
        this._super()
    },
});
var HomeFriendItemView = KYNode.extend({
    ____1579: null,
    ____1459: null,
    ____927: null,
    _flagImg1: null,
    _flagImg2: null,
    _flagImg3: null,
    _homeFriendInfo: null,
    ctor: function(info) {
        this._super("homeFriendItem.ExportJson");
        this._homeFriendInfo = info;
        this.____1579 = this.getChildByName("rankLabel");
        this.____1459 = this.getChildByName("nickLabel");
        this.____927 = this.getChildByName("careerIcon");
        this._flagImg1 = this.getChildByName("flagImg1");
        this._flagImg2 = this.getChildByName("flagImg2");
        this._flagImg3 = this.getChildByName("flagImg3");
        this._flagImg1.setVisible(false);
        this._flagImg2.setVisible(false);
        this._flagImg3.setVisible(false);
        this.____1579.setString(this._homeFriendInfo.homeLevel);
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (this._homeFriendInfo == null) {
            return
        }
        this._flagImg1.setVisible(this._homeFriendInfo.getCanSteal());
        this._flagImg2.setVisible(this._homeFriendInfo.getCanWater());
        this._flagImg3.setVisible(this._homeFriendInfo.getCanFeed());
        this.____1459.setString(this._homeFriendInfo.nick);
        this.____927.setFrame("sceneIcon/PlayerHeadIcon2_" + this._homeFriendInfo.career + ".png", 1)
    },
    ____6: function() {},
    getFriendHomeInfo: function() {
        return this._homeFriendInfo
    },
    dispose: function() {
        this._super();
        this.____1579 = null;
        this.____1459 = null;
        this.____927 = null;
        this._flagImg1 = null;
        this._flagImg2 = null;
        this._flagImg3 = null;
        this._homeFriendInfo = null
    },
});
var HomeHuntView = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _titleImg1: null,
    _titleImg2: null,
    _huntBtn1: null,
    _huntBtn2: null,
    _huntTime1: null,
    _huntTime2: null,
    _btnTitle1: null,
    _btnTitle2: null,
    ____1418: null,
    ____1544: null,
    _awardTitile1_1: null,
    _awardTitile1_2: null,
    _awardTitile2_1: null,
    _awardTitile2_2: null,
    _cellList1: null,
    _cellList2: null,
    _titleImgPath1: null,
    _titleImgPath2: null,
    _petInfo: null,
    ctor: function(controller) {
        this._controller = controller;
        this._super("homeHuntView.ExportJson");
        this.modeValue = 150;
        this._closeBtn = this.getChildByName("closeBtn");
        this._titleImg1 = this.getChildByName("titleImg1");
        this._titleImg2 = this.getChildByName("titleImg2");
        this._huntBtn1 = this.getChildByName("huntBtn1");
        this._huntBtn2 = this.getChildByName("huntBtn2");
        this._huntTime1 = this.getChildByName("huntTime1");
        this._huntTime2 = this.getChildByName("huntTime2");
        this._btnTitle1 = this.getChildByName("btnTitle1");
        this._btnTitle2 = this.getChildByName("btnTitle2");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____1544 = this.getChildByName("priceLabel");
        this._awardTitile1_1 = this.getChildByName("awardTitile1_1");
        this._awardTitile1_2 = this.getChildByName("awardTitile1_2");
        this._awardTitile2_1 = this.getChildByName("awardTitile2_1");
        this._awardTitile2_2 = this.getChildByName("awardTitile2_2");
        this._cellList1 = [];
        this._cellList2 = [];
        for (var i = 1; i <= 12; i++) {
            var item1 = new ____2129();
            var item2 = new ____2129();
            this.getChildByName("cell1_" + i).addChild(item1);
            this.getChildByName("cell2_" + i).addChild(item2);
            this._cellList1.push(item1);
            this._cellList2.push(item2)
        }
        this._titleImgPath1 = ____654.____675.____139("outPic/homeHuntTitle1.png");
        ____654.____677.____146(this._titleImg1, this._titleImgPath1);
        this._titleImgPath2 = ____654.____675.____139("outPic/homeHuntTitle2.png");
        ____654.____677.____146(this._titleImg2, this._titleImgPath2);
        this.____5();
        this.____6()
    },
    ____5: function() {
        var petInfo = ____655.allTemplates.homePetTemplateList.getInfoByLevel(____655.homeInfo.homePet);
        this._petInfo = petInfo;
        for (var i = 0; i < this._cellList1.length; i++) {
            var freeAward = petInfo.freeAwardList[i];
            if (!!freeAward && freeAward[0] > 0) {
                var itemTemplateInfo = ____655.allTemplates.____794.getItem(freeAward[0]);
                this._cellList1[i].setItemTemplateInfo(itemTemplateInfo);
                if (freeAward[1] > 0) {
                    this._cellList1[i].setCount(freeAward[1])
                } else {
                    this._cellList1[i].setCount(-1)
                }
            } else {
                this._cellList1[i].setItemTemplateInfo(null);
                this._cellList1[i].setCount(-1)
            }
            var ybAward = petInfo.ybAwardList[i];
            if (!!ybAward && ybAward[0] > 0) {
                var itemTemplateInfo = ____655.allTemplates.____794.getItem(ybAward[0]);
                this._cellList2[i].setItemTemplateInfo(itemTemplateInfo);
                if (ybAward[1] > 0) {
                    this._cellList2[i].setCount(ybAward[1])
                } else {
                    this._cellList2[i].setCount(-1)
                }
            } else {
                this._cellList2[i].setItemTemplateInfo(null);
                this._cellList2[i].setCount(-1)
            }
        }
        this._huntTime1.setString("狩猎时间：" + (____655.____662.secondsToDateString5(petInfo.freeHuntInfo[1])));
        this._huntTime2.setString("狩猎时间：" + (____655.____662.secondsToDateString5(petInfo.ybHuntInfo[1])));
        this.____1544.setString(petInfo.ybHuntInfo[2])
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this._huntBtn1.addListener(this, this.____16);
        this._huntBtn2.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this._huntBtn1) {
                print("初级狩猎", this._petInfo.freeHuntInfo[0]);
                var count = ____655.allTemplates.homeTemplateList.MAX_HUNT - ____655.homeInfo.huntCount;
                if (count > 0) {
                    ____654.homeMessageSender.sendPlant(12, 1);
                    this.dispose()
                } else {
                    ____654.tipsManager.quickTip.show("狩猎次数已用完")
                }
            } else if (sender == this._huntBtn2) {
                var count = ____655.allTemplates.homeTemplateList.MAX_HUNT - ____655.homeInfo.huntCount;
                if (count > 0) {
                    ____655.getAlert().show(2, "是否花费{0}钻石狩猎。".format(this._petInfo.ybHuntInfo[2]) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.HOME_HUNT, 0, this, this.huntHandler, null, null)
                } else {
                    ____654.tipsManager.quickTip.show("狩猎次数已用完")
                }
                print("高级狩猎", this._petInfo.ybHuntInfo[0])
            }
        }
    },
    huntHandler: function() {
        if (____655.____667.moneyInfo.moneyEnoughByType(5, this._petInfo.ybHuntInfo[2])) {
            ____654.homeMessageSender.sendPlant(12, 2);
            this.dispose()
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    dispose: function() {
        this.____17();
        for (var i = 0; i < this._cellList1.length; i++) {
            this._cellList1[i].dispose();
            this._cellList2[i].dispose()
        }
        this._cellList1 = null;
        this._cellList2 = null;
        ____654.____677.removeImageQuote(this._titleImgPath1, this._titleImg1);
        this._titleImgPath1 = null;
        this._titleImg1 = null;
        ____654.____677.removeImageQuote(this._titleImgPath2, this._titleImg2);
        this._titleImgPath2 = null;
        this._titleImg2 = null;
        this._closeBtn = null;
        this._huntBtn1 = null;
        this._huntBtn2 = null;
        this._huntTime1 = null;
        this._huntTime2 = null;
        this._btnTitle1 = null;
        this._btnTitle2 = null;
        this.____1418 = null;
        this.____1544 = null;
        this._awardTitile1_1 = null;
        this._awardTitile1_2 = null;
        this._awardTitile2_1 = null;
        this._awardTitile2_2 = null;
        this._petInfo = null;
        this._super()
    },
});
var HomeJinjieView = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____871: null,
    _upcountLabel: null,
    ____1443: null,
    ____1444: null,
    ____1096: null,
    _jinjieBtn: null,
    _btn_countLabel: null,
    _btn_titleLabel: null,
    _btn_moneyIcon: null,
    _bgPath: null,
    ____937: null,
    _materialList: null,
    _needMoney: 0,
    ctor: function(controller) {
        this._controller = controller;
        this._super("homeJinJieView.ExportJson");
        this.modeValue = 150;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____871 = this.getChildByName("bgImg");
        this._upcountLabel = this.getChildByName("upcountLabel");
        this.____1443 = this.getChildByName("nameLabel1");
        this.____1444 = this.getChildByName("nameLabel2");
        this.____1096 = this.getChildByName("descLabel");
        this._jinjieBtn = this.getChildByName("jinjieBtn");
        this._btn_countLabel = this.getChildByName("countLabel");
        this._btn_titleLabel = this.getChildByName("btnTitleLabel");
        this._btn_moneyIcon = this.getChildByName("moneyIcon");
        this.____937 = [];
        for (var i = 1; i <= 3; i++) {
            var item = new ____2129();
            this.getChildByName("materialCell" + i).addChild(item);
            this.____937.push(item)
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        this._bgPath = ____654.____675.____139("outPic/home_jinjie_" + ____655.homeInfo.landQuality + ".png");
        ____654.____677.____146(this.____871, this._bgPath);
        var curTemplate = ____655.allTemplates.homeJinjieTemplateList.getInfoByQuality(____655.homeInfo.landQuality);
        var nexTemplate = ____655.allTemplates.homeJinjieTemplateList.getInfoByQuality(____655.homeInfo.landQuality + 1);
        var needMoney = 0;
        if (!!curTemplate) {
            this.____1443.setString(curTemplate.name);
            this._materialList = curTemplate.metarialList;
            for (var i = 0; i < this.____937.length; i++) {
                var info = this._materialList[i];
                if (!!info) {
                    var itemTemplateInfo = ____655.allTemplates.____794.getItem(info[0]);
                    this.____937[i].setItemTemplateInfo(itemTemplateInfo);
                    var count = ____655.homeInfo.itemList[info[0]] || 0;
                    this.____937[i].setNeedCount(count, info[1]);
                    if (info[1] > count) {
                        needMoney += (info[1] - count) * info[2]
                    }
                } else {
                    this.____937[i].setItemTemplateInfo(null);
                    this.____937[i].setCount(-1)
                }
            }
        }
        if (!!nexTemplate) {
            this.____1444.setString(nexTemplate.name);
            var addVal = nexTemplate.mulriple - 100;
            this._upcountLabel.setString("+" + addVal + "%");
            if (____655.homeInfo.homeLevel >= nexTemplate.needHomeLevel) {
                this._jinjieBtn.setFrame("btn/ui_btn1_2.png");
                this.____1096.setString("");
                if (needMoney > 0) {
                    this._btn_moneyIcon.setVisible(true);
                    this._btn_countLabel.setString(needMoney);
                    this._btn_titleLabel.setPositionX(381)
                } else {
                    this._btn_moneyIcon.setVisible(false);
                    this._btn_countLabel.setString("");
                    this._btn_titleLabel.setPositionX(332)
                }
            } else {
                this._jinjieBtn.setFrame("btn/ui_btn1_4.png");
                this._btn_moneyIcon.setVisible(false);
                this._btn_countLabel.setString("");
                this._btn_titleLabel.setPositionX(332);
                this.____1096.setString("仙园达到{0}级可进阶".format(nexTemplate.needHomeLevel))
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this._jinjieBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this._jinjieBtn) {
                var nexTemplate = ____655.allTemplates.homeJinjieTemplateList.getInfoByQuality(____655.homeInfo.landQuality + 1);
                if (____655.homeInfo.homeLevel >= nexTemplate.needHomeLevel) {
                    var needMoney = 0;
                    if (!!this._materialList) {
                        for (var i = 0; i < this._materialList.length; i++) {
                            var info = this._materialList[i];
                            var count = ____655.homeInfo.itemList[info[0]] || 0;
                            if (info[1] > count) {
                                needMoney += (info[1] - count) * info[2]
                            }
                        }
                    }
                    if (needMoney > 0) {
                        this._needMoney = needMoney;
                        ____655.getAlert().show(2, "是否花费{0}钻石购买材料进阶仙园？".format(needMoney) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, this.jinjieHandler, null, null)
                    } else {
                        ____654.homeMessageSender.sendPlant(6, 0);
                        this.dispose()
                    }
                } else {
                    ____654.tipsManager.quickTip.show("仙园等级不够!")
                }
            }
        }
    },
    jinjieHandler: function() {
        if (____655.____667.moneyInfo.moneyEnoughByType(5, this._needMoney)) {
            ____654.homeMessageSender.sendPlant(6, 1);
            this.dispose()
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    dispose: function() {
        this.____17();
        if (!!this._bgPath) {
            ____654.____677.removeImageQuote(this._bgPath, this.____871);
            this._bgPath = null
        }
        for (var i = 0; i < this.____937.length; i++) {
            this.____937[i].dispose()
        }
        this.____937 = null;
        this._controller = null;
        this._closeBtn = null;
        this.____871 = null;
        this._upcountLabel = null;
        this.____1443 = null;
        this.____1444 = null;
        this.____1096 = null;
        this._jinjieBtn = null;
        this._btn_countLabel = null;
        this._btn_titleLabel = null;
        this._btn_moneyIcon = null;
        this._needMoney = null;
        this._super()
    },
});
var HomeLand = cc.Class.extend({
    land: null,
    landFlag: null,
    crop: null,
    ____1126: null,
    _effectId: -1,
    ctor: function(land) {
        this.land = land
    },
    setVisible: function(flag) {
        this.land.setVisible(flag);
        if (flag) {
            this.setFlantEffect()
        }
    },
    setLandFlag: function(flag) {
        if (!!flag) {
            if (this.landFlag == null) {
                this.landFlag = ____654.____673.newKYSprite();
                this.landFlag.setFrame("icon/home_landMark.png");
                this.landFlag.setPosition(____654.____673.____159(55, 55));
                this.land.addChild(this.landFlag, 1)
            }
        } else {
            if (this.landFlag != null) {
                this.landFlag.dispose();
                this.landFlag = null
            }
        }
    },
    setLandIsOpen: function(flag) {
        if (!!flag) {
            this.land.setFrame("icon/home_land1.png", 1)
        } else {
            this.land.setFrame("icon/home_land2.png", 1)
        }
    },
    setFlantEffect: function(effectInfo) {
        if (!!effectInfo) {
            if (this._effectId == effectInfo[1]) {
                return
            }
            if (this.____1126 != null) {
                this.____1126.dispose();
                this.____1126 = null;
                this._effectId = -1
            }
            this._effectId = effectInfo[1];
            this.____1126 = ____654.effectManager.setEffect(effectInfo[1], false, ____654.____673.____159(effectInfo[2], effectInfo[3]), this.land);
            this.____1126.setScale(effectInfo[4] / 100)
        } else {
            if (this.____1126 != null) {
                this.____1126.dispose();
                this.____1126 = null;
                this._effectId = -1
            }
        }
    },
    dispose: function() {
        this.setFlantEffect();
        this.setLandFlag(false);
        this.land = null
    },
});
var HomeLianDanBtn = KYNode.extend({
    ____890: null,
    _titleLabel: null,
    ____1779: null,
    _type: -1,
    ctor: function(type) {
        this._super("homeLianDanBtn.ExportJson");
        this._type = type;
        this.____890 = this.getChildByName("btnImg");
        this._titleLabel = this.getChildByName("titleLabel");
        this.____1779 = this.getChildByName("tipIcon");
        this._titleLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomeLianDanBtn.type" + type))
    },
    ____239: function(flag) {
        if (flag) {
            this.____890.setFrame("btn/ui_btn1_2.png", 1)
        } else {
            this.____890.setFrame("btn/ui_btn1_1.png", 1)
        }
    },
    getSelectIndex: function() {
        return this._type
    },
    reflashTip: function() {
        var templatId = ____655.allTemplates.homeTemplateList.LIANDAN_MATERAL_LIST[this._type];
        if (!!templatId) {
            if (____655.itemInfoList.getCountByTempId(templatId) >= ____655.allTemplates.homeTemplateList.LIANDAN_MATERAL_COUNT) {
                this.____1779.setVisible(true)
            } else {
                this.____1779.setVisible(false)
            }
        } else {
            this.____1779.setVisible(false)
        }
    },
    dispose: function() {
        this._super();
        this.____890 = null;
        this._titleLabel = null;
        this._type = null
    },
});
var HomeLianDanRewardView = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____1495: null,
    ____1798: null,
    ____1144: null,
    ____1096: null,
    ____1145: null,
    ____937: null,
    ctor: function(controller) {
        this._super("settlementPanel.ExportJson");
        this._controller = controller;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1495 = this.getChildByName("outBtn");
        this.____1798 = this.getChildByName("titleLabel1");
        this.getChildByName("againBtn").setVisible(false);
        this.getChildByName("titleLabel2").setVisible(false);
        this.____1144 = this.getChildByName("expLabel");
        this.____1096 = this.getChildByName("descLabel");
        this.____1145 = this.getChildByName("expValue");
        this.getChildByName("moneyValue").setString("");
        this.getChildByName("moneyLabel").setString("");
        for (var i = 1; i <= 3; i++) {
            this.getChildByName("starIcon" + i).setVisible(false)
        }
        this.____937 = [];
        for (var j = 1; j <= 10; j++) {
            var item = new ____2129();
            this.getChildByName("cell" + j).addChild(item);
            this.____937.push(item)
        }
        this.____1495.setPositionX(268);
        this.____1798.setPositionX(268);
        this.____1798.setString("朕知道了");
        this.____1145.setPositionX(140);
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (____655.homeInfo.awardType == 1) {
            this.____1096.setString("仙园种植收获：");
            this.____1144.setString("仙园经验:");
            this.____1145.setString(____655.homeInfo.addExp)
        } else if (____655.homeInfo.awardType == 2) {
            this.____1096.setString("仙园炼丹收获：");
            this.____1144.setString("");
            this.____1145.setString("")
        } else if (____655.homeInfo.awardType == 3) {
            this.____1096.setString("仙园狩猎收获：");
            this.____1144.setString("仙园经验:");
            this.____1145.setString(____655.homeInfo.addExp)
        }
        var info = ____655.homeInfo.liandanRewardList;
        if (!!info) {
            var len = info.length;
            if (len > 10) {
                len = 10
            }
            for (var i = 0; i < len; i++) {
                var tempInfo = ____655.allTemplates.____794.getItem(info[i].templateId);
                this.____937[i].setItemTemplateInfo(tempInfo);
                this.____937[i].setCount(info[i].count)
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1495.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____1495) {
                this.dispose()
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._closeBtn = null;
        this.____1495 = null;
        this.____1798 = null;
        this.____1144 = null;
        this.____1096 = null;
        this.____1145 = null;
        if (this.____937 != null) {
            for (var i = 0; i < this.____937.length; i++) {
                this.____937[i].dispose()
            }
            this.____937 = null
        }
        this._super()
    },
});
var HomeLianDanView = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____908: null,
    ____871: null,
    ____1388: null,
    _itemCell: null,
    _liandanBtn: null,
    ____1096: null,
    _btnList: null,
    _itemList: null,
    ____1629: null,
    ____1637: -1,
    _templateIdList: null,
    _materialItem: null,
    _descStrList: null,
    ctor: function(controller) {
        this._controller = controller;
        this._super("homeLianDanView.ExportJson");
        this.modeValue = 150;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____908 = this.getChildByName("btnListView");
        this.____908.setScrollBarEnabled(false);
        this.____908.setItemsMargin(10);
        this.____871 = this.getChildByName("bgImg");
        this.____1388 = this.getChildByName("materialCell");
        this._itemCell = this.getChildByName("itemCell");
        this._liandanBtn = this.getChildByName("liandanBtn");
        this.____1096 = this.getChildByName("descLabel");
        this._bgPath = ____654.____675.____139("outPic/homePotBg.png");
        ____654.____677.____146(this.____871, this._bgPath);
        this._materialItem = new ____2129();
        this.____1388.addChild(this._materialItem, 1);
        this._templateIdList = ____655.allTemplates.homeTemplateList.LIANDAN_MATERAL_LIST;
        this._btnList = [];
        this._descStrList = [____654.yuyanbaoManager.getYuyanbao("HomeLianDanView.desc0"), ____654.yuyanbaoManager.getYuyanbao("HomeLianDanView.desc1"), ____654.yuyanbaoManager.getYuyanbao("HomeLianDanView.desc2")];
        this.____5();
        this.____6()
    },
    ____5: function() {
        for (var i = 0; i < this._templateIdList.length; i++) {
            var btn = new HomeLianDanBtn(i);
            btn.addListener(this, this.____16, null, null, null, false, true);
            this.____908.pushBackItem(btn);
            this._btnList.push(btn)
        }
        this.btnSelect(this._btnList[0])
    },
    btnSelect: function(btn) {
        if (this.____1629 == btn) {
            return
        }
        if (this.____1629 != null) {
            this.____1629.____239(false)
        }
        this.____1629 = btn;
        if (this.____1629 != null) {
            this.____1629.____239(true);
            this.____1637 = this.____1629.getSelectIndex();
            this.setSelectView()
        }
    },
    setSelectView: function(evt) {
        this._materialItem.setItemTemplateInfo(null);
        this._materialItem.setCount(-1);
        if (this.____1637 >= 0) {
            var str = this._descStrList[this.____1637] || "";
            this.____1096.setString(str);
            var templateInfo = ____655.allTemplates.____794.getItem(this._templateIdList[this.____1637]);
            if (!!templateInfo) {
                var count = ____655.itemInfoList.getCountByTempId(this._templateIdList[this.____1637]);
                this._materialItem.setItemTemplateInfo(templateInfo);
                this._materialItem.setNeedCount(count, ____655.allTemplates.homeTemplateList.LIANDAN_MATERAL_COUNT)
            }
        }
        for (var i = 0; i < this._btnList.length; i++) {
            this._btnList[i].reflashTip()
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this._liandanBtn.addListener(this, this.____16);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.setSelectView, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.setSelectView, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this._liandanBtn) {
                if (this.____1637 >= 0) {
                    var count = ____655.itemInfoList.getCountByTempId(this._templateIdList[this.____1637]);
                    var times = Math.floor(count / ____655.allTemplates.homeTemplateList.LIANDAN_MATERAL_COUNT);
                    if (times > 0) {
                        ____654.homeMessageSender.sendLiandan(this._templateIdList[this.____1637], times);
                        ____654.tipsManager.quickTip.show("炼丹成功");
                        return
                    }
                }
                ____654.tipsManager.quickTip.show("材料不足")
            } else {
                for (var i = 0; i < this._btnList.length; i++) {
                    if (sender == this._btnList[i]) {
                        this.btnSelect(this._btnList[i]);
                        return
                    }
                }
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        ____654.____677.removeImageQuote(this._bgPath, this.____871);
        this._bgPath = null;
        if (this._materialItem != null) {
            this._materialItem.dispose();
            this._materialItem = null
        }
        this._closeBtn = null;
        this.____908 = null;
        this.____871 = null;
        this.____1388 = null;
        this._itemCell = null;
        this._liandanBtn = null;
        this.____1096 = null;
        this.____1629 = null;
        if (this._btnList != null) {
            var len = this._btnList.length;
            for (var i = 0; i < len; i++) {
                this._btnList[i].dispose()
            }
            this._btnList = null
        }
        this.____1637 = null;
        this._descStrList = null;
        this._super()
    },
});
var HomePanel = KYPanel.extend({
    _controller: null,
    _bg: null,
    _spring: null,
    _shuomingBtn: null,
    _liandanBtn: null,
    _liandanTip: null,
    _jinjieBtn: null,
    _jinJieTip: null,
    _closeBtn: null,
    ____1178: null,
    _friendTip: null,
    _friend_leftBtn: null,
    _friend_rigthBtn: null,
    ____927: null,
    _levelLabel: null,
    _nameLabel: null,
    _countLabel: null,
    _homeLevelLabel: null,
    _homeLevelImg: null,
    ____1142: null,
    _expCount: null,
    _landBtn: null,
    _land_timeBg: null,
    _land_timeLabel: null,
    _nestImg: null,
    _landList: null,
    _feedBtn: null,
    _feedTimeBg: null,
    _feedTimeLabel: null,
    _huntBtn: null,
    _huntTimeBg: null,
    _huntTimeLabel: null,
    _petChatBg: null,
    _petChatLabel: null,
    _petLevelLabel: null,
    _petLevelBar: null,
    _petLevelBarBg: null,
    _foodTipBg: null,
    _foodCount: null,
    _curHomeInfo: null,
    _bgPath: null,
    _friendShowPsY: 240,
    _friendHidePsY: 45,
    _friendIsShow: false,
    _friendShowPropController: null,
    _friendHidePropController: null,
    _tileContainer: null,
    _friendList: null,
    _friendUpdateTime: -1,
    _eggImgPath: null,
    _eggImg: null,
    _pickEffect: null,
    _petInfo: null,
    _petEffect: null,
    _huntEffect: null,
    _feedEffect: null,
    _chattickCount: 0,
    _intervalTime: 0,
    ____1770: 0,
    ____1771: 0,
    _tickCount3: 0,
    ____1165: 1,
    ____1478: 370,
    ctor: function(controller) {
        this._controller = controller;
        ____654.____676.hideBack();
        this._super("homePanel.ExportJson");
        this._bg = this.getChildByName("bg");
        this._spring = this.getChildByName("spring");
        this._shuomingBtn = this.getChildByName("shuomingBtn");
        this._liandanBtn = this.getChildByName("liandanBtn");
        this._liandanTip = this.getChildByName("lianDanTipIcon");
        this._jinjieBtn = this.getChildByName("jinjieBtn");
        this._jinJieTip = this.getChildByName("jinJieTipIcon");
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1178 = this.getChildByName("friendBtn");
        this._friendTip = this.____1178.getChildByName("friendTipIcon");
        this._friend_leftBtn = this.____1178.getChildByName("leftBtn");
        this._friend_rigthBtn = this.____1178.getChildByName("rightBtn");
        this.____927 = this.getChildByName("careerIcon");
        this._levelLabel = this.getChildByName("levelLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this._countLabel = this.getChildByName("countLabel");
        this._homeLevelLabel = this.getChildByName("homeLevelLabel");
        this._homeLevelImg = this.getChildByName("homeLevelImg");
        this.____1142 = this.getChildByName("expBar");
        this._expCount = this.getChildByName("expCount");
        this._landBtn = this.getChildByName("landBtn");
        this._land_timeBg = this.getChildByName("timeBg");
        this._land_timeLabel = this.getChildByName("timeLabel");
        this._nestImg = this.getChildByName("nestImg");
        this._feedBtn = this.getChildByName("feedBtn");
        this._feedTimeBg = this.getChildByName("feedTimeBg");
        this._feedTimeLabel = this.getChildByName("feedTimeLabel");
        this._huntBtn = this.getChildByName("huntBtn");
        this._huntTimeBg = this.getChildByName("huntTimeBg");
        this._huntTimeLabel = this.getChildByName("huntTimeLabel");
        this._petChatBg = this.getChildByName("petChatBg");
        this._petChatLabel = this.getChildByName("petChatLabel");
        this._petLevelLabel = this.getChildByName("petLevelLabel");
        this._petLevelBar = this.getChildByName("petLevelBar");
        this._petLevelBarBg = this.getChildByName("petLevelBarBg");
        this._foodTipBg = this.getChildByName("foodTipBg");
        this._foodCount = this.getChildByName("foodCount");
        this._petChatBg.setVisible(false);
        this._petChatLabel.setString("");
        this._landList = [];
        for (var i = 1; i <= 20; i++) {
            var land = this.getChildByName("land" + i);
            this._landList.push(new HomeLand(land))
        }
        this._bgPath = ____654.____675.____139("outPic/homeBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._nestPath = ____654.____675.____139("outPic/home_nest.png");
        ____654.____677.____146(this._nestImg, this._nestPath);
        this._friendShowPropController = new PropController();
        this._friendShowPropController.addInfo(new PropInfo(this.____1178, 2, 0, this._friendHidePsY, this._friendShowPsY, 10, 5));
        this._friendHidePropController = new PropController();
        this._friendHidePropController.addInfo(new PropInfo(this.____1178, 2, 0, this._friendShowPsY, this._friendHidePsY, -10, -5));
        this._friendList = ____655.homeInfo.friendInfoList;
        this._tileContainer = this.____1178.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getFriendItemByIndex, this.getIdByIndex, this);
        this.____1178.setPositionY(this._friendHidePsY);
        this.____5();
        this.____6();
        this.reflashFriendTip()
    },
    ____5: function() {
        if (this._curHomeInfo == null) {
            this._curHomeInfo = ____655.homeInfo
        }
        if (this._curHomeInfo == ____655.homeInfo) {
            this._nameLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomePanel.text2", ____655.____667.nick));
            this.____927.setFrame("sceneIcon/PlayerHeadIcon2_" + ____655.____667.career + ".png", 1);
            this._shuomingBtn.setVisible(true);
            this._liandanBtn.setVisible(true);
            this._liandanTip.setVisible(this._curHomeInfo.getLianDanTip());
            this._jinjieBtn.setVisible(this._curHomeInfo.landQuality < ____655.allTemplates.homeJinjieTemplateList.MAX_QUALITY);
            this._jinJieTip.setVisible(____655.homeInfo.getCanJinjie());
            this._closeBtn.setFrame("icon/ui_backIcon.png")
        } else {
            this._nameLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomePanel.text2", this._curHomeInfo.nick));
            this.____927.setFrame("sceneIcon/PlayerHeadIcon2_" + this._curHomeInfo.career + ".png", 1);
            this._shuomingBtn.setVisible(false);
            this._liandanBtn.setVisible(false);
            this._liandanTip.setVisible(false);
            this._jinjieBtn.setVisible(false);
            this._jinJieTip.setVisible(false);
            this._closeBtn.setFrame("icon/home_back.png")
        }
        this._countLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomePanel.text1", this._curHomeInfo.landAmount));
        this._levelLabel.setString(this._curHomeInfo.homeLevel);
        var curQualityTemplate = ____655.allTemplates.homeJinjieTemplateList.getInfoByQuality(this._curHomeInfo.landQuality);
        if (!!curQualityTemplate && curQualityTemplate.mulriple > 100) {
            var addVal = curQualityTemplate.mulriple - 100;
            this._homeLevelLabel.setString("+" + addVal + "%");
            this._homeLevelImg.setVisible(true)
        } else {
            this._homeLevelLabel.setString("");
            this._homeLevelImg.setVisible(false)
        }
        var exp = this._curHomeInfo.homeExp;
        var maxExp = ____655.allTemplates.homeTemplateList.getInfoByLevel(this._curHomeInfo.homeLevel).maxExp;
        var temp = ____655.allTemplates.homeTemplateList.getInfoByLevel(this._curHomeInfo.homeLevel - 1);
        if (!!temp) {
            exp -= temp.maxExp;
            maxExp -= temp.maxExp
        }
        this._expCount.setString(exp + "/" + maxExp);
        var percent = Math.min(100, Math.max(0, Math.floor(exp / maxExp * 100)));
        this.____1142.setPercent(percent);
        this.setLandCount();
        this.setLandBtnState();
        this.setPetState()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this._shuomingBtn.addListener(this, this.____16);
        this._liandanBtn.addListener(this, this.____16);
        this._jinjieBtn.addListener(this, this.____16);
        this.____1178.addListener(this, this.____16);
        this._landBtn.addListener(this, this.____16);
        this._feedBtn.addListener(this, this.____16);
        this._huntBtn.addListener(this, this.____16);
        ____655.homeInfo.addEventListener(____655.____661.home_infoUpdate, this.infoUpdate, this);
        ____655.homeInfo.addEventListener(____655.____661.home_friendInfoUpdate, this.friendInfoUpdate, this);
        ____655.homeInfo.addEventListener(____655.____661.home_LianDanReward, this.lianDanReward, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.itemCountUpdate, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____655.homeInfo.removeEventListener(____655.____661.home_infoUpdate, this.infoUpdate, this);
        ____655.homeInfo.removeEventListener(____655.____661.home_friendInfoUpdate, this.friendInfoUpdate, this);
        ____655.homeInfo.removeEventListener(____655.____661.home_LianDanReward, this.lianDanReward, this);
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.itemCountUpdate, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    itemCountUpdate: function(evt) {
        if (this._curHomeInfo == ____655.homeInfo) {
            this._liandanTip.setVisible(this._curHomeInfo.getLianDanTip())
        }
        this.setFoodCount()
    },
    lianDanReward: function(evt) {
        this._controller.showHomeLianDanRewardView()
    },
    getFriendItemByIndex: function(index) {
        var userId = this._friendList[index];
        if (userId != null) {
            var item = new HomeFriendItemView(____655.homeInfo.friendInfoTab[userId]);
            item.addListener(this, this.friendItemClickHandler, null, null, null, false, true);
            return item
        }
        return null
    },
    getIdByIndex: function(index) {
        if (this._friendList[index] == null) {
            return -1
        }
        return this._friendList[index]
    },
    friendItemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var info = sender.getFriendHomeInfo();
            if (!!info) {
                if (info == this._curHomeInfo) {
                    return
                }
                this._curHomeInfo = info;
                this.____5()
            }
        }
    },
    infoUpdate: function(evt) {
        this.____5()
    },
    friendInfoUpdate: function(evt) {
        this._friendList = ____655.homeInfo.friendInfoList;
        this._tileContainer.clearAllItems();
        this._tileContainer.setFormat(1, this._friendList.length, ____654.____673.____160(172, 183), 0, 0, true);
        this.reflashFriendTip()
    },
    reflashFriendTip: function() {
        this._friendTip.setVisible(____655.homeInfo.getFriendTip())
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                if (this._curHomeInfo == ____655.homeInfo) {
                    this.dispose()
                } else {
                    this._curHomeInfo = ____655.homeInfo;
                    this.____5()
                }
            } else if (sender == this._shuomingBtn) {
                print("##this._shuomingBtn");
                this._controller.showHomeDescView()
            } else if (sender == this._liandanBtn) {
                print("##this._liandanBtn");
                this._controller.showHomeLianDanView()
            } else if (sender == this._jinjieBtn) {
                print("##this._jinjieBtn");
                this._controller.showHomeJinjieView()
            } else if (sender == this.____1178) {
                if (this._friendIsShow) {
                    this._friendShowPropController.pEnd();
                    this._friendHidePropController.pStart()
                } else {
                    this._friendShowPropController.pStart();
                    this._friendHidePropController.pEnd();
                    this.friendUpdateTime()
                }
                this._friendIsShow = !this._friendIsShow
            } else if (sender == this._landBtn) {
                if (this._curHomeInfo.seedId == 0) {
                    var count = ____655.allTemplates.homeTemplateList.MAX_FLANT - this._curHomeInfo.plantCount;
                    if (count > 0) {
                        this._controller.showHomeSeedView()
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomePanel.text3"))
                    }
                } else {
                    var time = ____655.____662.getSystemTimeSec();
                    var tempInfo = ____655.allTemplates.seedTemplateList.getInfoById(this._curHomeInfo.seedId);
                    if (this._curHomeInfo.seedTime + tempInfo.ripeTime < time) {
                        if (this._curHomeInfo == ____655.homeInfo) {
                            ____654.homeMessageSender.sendPlant(4, 0)
                        } else {
                            if (____655.homeInfo.stealCount < ____655.allTemplates.homeTemplateList.MAX_STEAL) {
                                ____654.homeMessageSender.sendPlant(7, this._curHomeInfo.userId)
                            } else {
                                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomePanel.text4"))
                            }
                        }
                    } else {
                        if (this._curHomeInfo.waterTime + tempInfo.target.waterTime < time) {
                            if (this._curHomeInfo == ____655.homeInfo) {
                                ____654.homeMessageSender.sendPlant(2, 0);
                                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomePanel.text5"))
                            } else {
                                if (____655.homeInfo.helpCount < ____655.allTemplates.homeTemplateList.MAX_WATER) {
                                    ____654.homeMessageSender.sendPlant(5, this._curHomeInfo.userId);
                                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomePanel.text6", ____655.allTemplates.homeTemplateList.MAX_WATER - ____655.homeInfo.helpCount - 1))
                                } else {
                                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomePanel.text7"))
                                }
                            }
                        } else {
                            var speedTime = this._curHomeInfo.seedTime + tempInfo.ripeTime - time;
                            ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("HomePanel.text8", Math.ceil(speedTime / tempInfo.target.accPrice) * this._curHomeInfo.landAmount) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.HOME_PLANT_SPEED, 0, this, this.speedHandler, null, null)
                        }
                    }
                }
            } else if (sender == this._feedBtn) {
                if (this._curHomeInfo.caressNum >= ____655.allTemplates.homeTemplateList.MAX_CARESS_COUNT) {
                    if (this._curHomeInfo == ____655.homeInfo) {
                        var foodCount = ____655.itemInfoList.getCountByTempId(____655.allTemplates.homePetTemplateList.FOOD_TEMPLATE_ID);
                        if (foodCount > 0) {
                            ____654.homeMessageSender.sendPlant(10, 0);
                            this._petChatLabel.setString("好好吃~~~");
                            ____654.tipsManager.quickTip.show("喂养成功")
                        } else {
                            this._petChatLabel.setString("饿死朕了，快来喂我！");
                            ____654.tipsManager.quickTip.show("没有口粮了哦")
                        }
                    } else {
                        ____654.homeMessageSender.sendPlant(11, this._curHomeInfo.userId);
                        ____654.tipsManager.quickTip.show("帮助喂养成功");
                        this._petChatLabel.setString("明天再来喂我哟~~")
                    }
                } else {
                    if (this._curHomeInfo == ____655.homeInfo) {
                        if (Math.floor((____655.____662.getSystemTimeSec() - ____655.____665) / ____655.____662.secondsOfDay) > Math.floor((this._curHomeInfo.caressTime - ____655.____665) / ____655.____662.secondsOfDay)) {
                            ____654.homeMessageSender.sendPlant(8, 0);
                            var count = ____655.allTemplates.homeTemplateList.MAX_CARESS_COUNT - this._curHomeInfo.caressNum - 1;
                            if (count > 0) {
                                ____654.tipsManager.quickTip.show("抚摸成功，还需{0}次唤醒灵宠".format(count))
                            } else {
                                ____654.tipsManager.quickTip.show("抚摸成功，灵宠醒了哦~")
                            }
                        } else {
                            ____654.tipsManager.quickTip.show("邀请好友帮你抚摸宝宝吧！")
                        }
                        this._petChatLabel.setString("主人主人，快邀请好友一起抚摸我吧！")
                    } else {
                        ____654.homeMessageSender.sendPlant(9, this._curHomeInfo.userId);
                        this._petChatLabel.setString("我主人不在家，别动手动脚");
                        ____654.tipsManager.quickTip.show("你调戏了别人家的灵宠蛋")
                    }
                }
                ____654.____678.____298(this.____244, this);
                this._chattickCount = 100;
                this._petChatBg.setVisible(true)
            } else if (sender == this._huntBtn) {
                if (this._curHomeInfo.huntType > 0) {
                    var time = ____655.____662.getSystemTimeSec();
                    var needTime = this._curHomeInfo.huntTime - time;
                    if (needTime > 0) {
                        print("狩猎没完成，加速判断");
                        var price = Math.ceil(needTime / this._petInfo.timePrice[0]) * this._petInfo.timePrice[1];
                        ____655.getAlert().show(2, "是否花费{0}钻石立刻完成狩猎。".format(price) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.HOME_HUNT_SPEED, 0, this, this.speedHuntHandler, null, null)
                    } else {
                        print("狩猎完成，领取奖励");
                        ____654.homeMessageSender.sendPlant(13, 0)
                    }
                } else {
                    var count = ____655.allTemplates.homeTemplateList.MAX_HUNT - this._curHomeInfo.huntCount;
                    if (count > 0) {
                        this._controller.showHomeHuntView()
                    } else {
                        ____654.tipsManager.quickTip.show("狩猎次数已用完");
                        return
                    }
                }
            } else if (sender == this._eggImg) {
                this._petChatLabel.setString("再动手我就出来打你哟！");
                ____654.____678.____298(this.____244, this);
                this._chattickCount = 100;
                this._petChatBg.setVisible(true)
            }
        }
    },
    friendUpdateTime: function() {
        var time = ____655.____662.getSystemTimeSec();
        if (time > this._friendUpdateTime + 10) {
            this._friendUpdateTime = time;
            ____655.homeInfo.friendInfoSort(true)
        }
    },
    speedHuntHandler: function() {
        var time = ____655.____662.getSystemTimeSec();
        var needTime = this._curHomeInfo.huntTime - time;
        var price = Math.ceil(needTime / this._petInfo.timePrice[0]) * this._petInfo.timePrice[1];
        if (____655.____667.moneyInfo.moneyEnoughByType(5, Math.ceil(price))) {
            ____654.homeMessageSender.sendPlant(14, 0);
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomePanel.text9"))
        } else {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("moneyInfo.tips1"))
        }
    },
    speedHandler: function() {
        var time = ____655.____662.getSystemTimeSec();
        var tempInfo = ____655.allTemplates.seedTemplateList.getInfoById(this._curHomeInfo.seedId);
        var speedTime = this._curHomeInfo.seedTime + tempInfo.ripeTime - time;
        if (____655.____667.moneyInfo.moneyEnoughByType(5, Math.ceil(speedTime / tempInfo.target.accPrice) * this._curHomeInfo.landAmount)) {
            ____654.homeMessageSender.sendPlant(3, 0);
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomePanel.text9"))
        } else {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("HomePanel.text10"))
        }
    },
    setLandBtnState: function() {
        if (this._curHomeInfo.seedId <= 0) {
            ____654.____678.____299(this.tick, this);
            if (this._curHomeInfo == ____655.homeInfo) {
                this._landBtn.setFrame("icon/home_bozhong.png", 1);
                this._landBtn.setVisible(true);
                this._land_timeBg.setVisible(true);
                this._land_timeLabel.setVisible(true);
                var count = ____655.allTemplates.homeTemplateList.MAX_FLANT - this._curHomeInfo.plantCount;
                this.setPickEffect(count > 0);
                this._land_timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomePanel.text11", count))
            } else {
                this._landBtn.setVisible(false);
                this.setPickEffect(false);
                this._land_timeBg.setVisible(false);
                this._land_timeLabel.setVisible(false)
            }
            for (var i = 0; i < this._curHomeInfo.landAmount; i++) {
                this._landList[i].setFlantEffect(null)
            }
        } else {
            ____654.____678.____298(this.tick, this)
        }
    },
    setPetState: function() {
        if (this._curHomeInfo == ____655.homeInfo && this._curHomeInfo.homeLevel >= 2 && this._curHomeInfo.caressNum >= ____655.allTemplates.homeTemplateList.MAX_CARESS_COUNT) {
            this._huntBtn.setVisible(true);
            this._huntTimeLabel.setVisible(true);
            this._huntTimeBg.setVisible(true);
            this.setFeedBtnCenter(false)
        } else {
            this._huntBtn.setVisible(false);
            this._huntTimeLabel.setVisible(false);
            this._huntTimeBg.setVisible(false);
            this.setFeedBtnCenter(true)
        }
        this.setHuntEffect(false);
        this.setFeedEffect(false);
        ____654.____678.____299(this.huntTimeTick, this);
        if (this._curHomeInfo.caressNum >= ____655.allTemplates.homeTemplateList.MAX_CARESS_COUNT) {
            this._feedBtn.setFrame("icon/home_weiyang.png", 1);
            this.setFoodCount();
            if (this._curHomeInfo == ____655.homeInfo) {
                this._feedBtn.setVisible(true);
                this._feedTimeBg.setVisible(true);
                this._feedTimeLabel.setVisible(true);
                this._feedTimeLabel.setString("可喂养{0}次".format(____655.allTemplates.homeTemplateList.MAX_OTHER_HELP_FEED - ____655.homeInfo.ohterHelpFeedCount));
                if (this._curHomeInfo.huntType > 0) {
                    ____654.____678.____298(this.huntTimeTick, this)
                } else {
                    this._huntBtn.setFrame("icon/home_shoulie.png", 1);
                    var huntCount = ____655.allTemplates.homeTemplateList.MAX_FLANT - this._curHomeInfo.huntCount;
                    this._huntTimeLabel.setString("可狩猎{0}次".format(huntCount));
                    this.setHuntEffect(this._curHomeInfo.homeLevel >= 2 && huntCount > 0)
                }
            } else {
                var flag = this._curHomeInfo.getCanFeed();
                this._feedBtn.setVisible(flag);
                this._feedTimeBg.setVisible(flag);
                this._feedTimeLabel.setVisible(flag);
                this.setFeedEffect(flag);
                this._feedTimeLabel.setString("可喂养{0}次".format(____655.allTemplates.homeTemplateList.MAX_OTHER_HELP_FEED - this._curHomeInfo.ohterHelpFeedCount))
            }
            if (this._eggImg != null && this._eggImg.getParent() != null) {
                this._eggImg.removeFromParent(false)
            }
            var petInfo = ____655.allTemplates.homePetTemplateList.getInfoByLevel(this._curHomeInfo.homePet);
            this.setPetInfo(petInfo);
            if (!!petInfo) {
                this._petLevelLabel.setVisible(true);
                this._petLevelLabel.setString("Lv." + petInfo.level);
                if (petInfo.level < ____655.allTemplates.homePetTemplateList.MAX_LEVEL) {
                    var percent = Math.min(100, Math.max(0, Math.floor((this._curHomeInfo.feedNum - petInfo.minExp) / (petInfo.maxExp - petInfo.minExp) * 100)));
                    this._petLevelBar.setPercent(percent);
                    this._petLevelLabel.setPositionX(80);
                    this._petLevelBar.setVisible(true);
                    this._petLevelBarBg.setVisible(true)
                } else {
                    this._petLevelLabel.setPositionX(138);
                    this._petLevelBar.setVisible(false);
                    this._petLevelBarBg.setVisible(false)
                }
            }
        } else {
            this.setPetInfo(null);
            this._petLevelLabel.setVisible(false);
            this._petLevelBar.setVisible(false);
            this._petLevelBarBg.setVisible(false);
            this._foodTipBg.setVisible(false);
            this._foodCount.setVisible(false);
            if (this._curHomeInfo != ____655.homeInfo && (____655.homeInfo.caressList[this._curHomeInfo.userId] || ____655.homeInfo.helpCaressNum >= ____655.allTemplates.homePetTemplateList.MAX_HELP_CARESS)) {
                this._feedBtn.setVisible(false);
                this._feedTimeBg.setVisible(false);
                this._feedTimeLabel.setVisible(false)
            } else {
                this._feedBtn.setFrame("icon/home_fumo.png", 1);
                this._feedBtn.setVisible(true);
                this._feedTimeBg.setVisible(true);
                this._feedTimeLabel.setVisible(true);
                var count = ____655.allTemplates.homeTemplateList.MAX_CARESS_COUNT - this._curHomeInfo.caressNum;
                this._feedTimeLabel.setString("还需抚摸{0}次".format(count));
                if (this._curHomeInfo == ____655.homeInfo) {
                    var flag = Math.floor((____655.____662.getSystemTimeSec() - ____655.____665) / ____655.____662.secondsOfDay) > Math.floor((this._curHomeInfo.caressTime - ____655.____665) / ____655.____662.secondsOfDay);
                    this.setFeedEffect(flag)
                } else {
                    this.setFeedEffect(true)
                }
            }
            if (this._eggImg == null) {
                this._eggImg = ____654.____673.newKYSprite();
                this._eggImg.addListener(this, this.____16);
                this._eggImgPath = ____654.____675.____139("outPic/home_egg.png");
                ____654.____677.____146(this._eggImg, this._eggImgPath);
                this._eggImg.setPositionX(135);
                this._eggImg.setPositionY(370);
                this.setEggFloat(true, 3)
            }
            if (this._eggImg.getParent() == null) {
                this.addChild(this._eggImg, 2)
            }
        }
    },
    setFoodCount: function() {
        var foodCount = ____655.itemInfoList.getCountByTempId(____655.allTemplates.homePetTemplateList.FOOD_TEMPLATE_ID);
        if (foodCount > 0 && this._curHomeInfo == ____655.homeInfo) {
            this._foodCount.setString(foodCount);
            this._foodTipBg.setVisible(true);
            this._foodCount.setVisible(true);
            this.setFeedEffect(true)
        } else {
            this._foodTipBg.setVisible(false);
            this._foodCount.setVisible(false);
            this.setFeedEffect(false)
        }
    },
    huntTimeTick: function() {
        var time = ____655.____662.getSystemTimeSec();
        var needTime = this._curHomeInfo.huntTime - time;
        if (needTime > 0) {
            this._huntTimeLabel.setString(____655.____662.secondsToDateString(needTime))
        } else {
            this._huntBtn.setFrame("icon/home_shouhuo.png", 1);
            this._huntTimeLabel.setString("狩猎完成");
            this.setHuntEffect(true);
            ____654.____678.____299(this.huntTimeTick, this)
        }
    },
    setEggFloat: function(isOn, intervalTime) {
        this._intervalTime = intervalTime * 60;
        if (!!isOn) {
            ____654.____678.____298(this.eggTick, this)
        } else {
            ____654.____678.____299(this.eggTick, this)
        }
    },
    eggTick: function(delta, count) {
        this.____1770++;
        if (this.____1770 >= this._intervalTime) {
            this.____1771++;
            if (this.____1771 > 1) {
                this.____1771 = 0;
                this.____1478 += this.____1165;
                if (this.____1478 < 370 || this.____1478 > 376) {
                    this.____1165 = -this.____1165;
                    this._tickCount3++;
                    if (this.____1165 > 0 && this._tickCount3 > 3) {
                        this._tickCount3 = 0;
                        this.____1770 = 0
                    }
                }
                this._eggImg.setPositionY(this.____1478)
            }
        }
    },
    setFeedBtnCenter: function(isCenter) {
        if (isCenter) {
            this._feedBtn.setPositionX(130);
            this._feedTimeBg.setPositionX(130);
            this._feedTimeLabel.setPositionX(130);
            this._foodTipBg.setPositionX(110);
            this._foodCount.setPositionX(110)
        } else {
            this._feedBtn.setPositionX(75);
            this._feedTimeBg.setPositionX(75);
            this._feedTimeLabel.setPositionX(75);
            this._foodTipBg.setPositionX(55);
            this._foodCount.setPositionX(55)
        }
    },
    setPetInfo: function(petInfo) {
        if (petInfo == null) {
            this._petInfo = null;
            if (this._petEffect != null) {
                this._petEffect.dispose();
                this._petEffect = null;
                return
            }
        }
        if (this._petInfo == petInfo) {
            return
        }
        if (this._petEffect != null) {
            this._petEffect.dispose();
            this._petEffect = null
        }
        this._petInfo = petInfo;
        if (this._petInfo.effectId > 0) {
            this._petEffect = ____654.effectManager.setEffect(this._petInfo.effectId, false, this._petInfo.pos, this._nestImg);
            this._petEffect.setScale(this._petInfo.scale);
            this._petEffect.setLocalZOrder(3)
        }
    },
    ____244: function() {
        this._chattickCount--;
        if (this._chattickCount > 0) {
            return
        }
        this._petChatBg.setVisible(false);
        this._petChatLabel.setString("");
        ____654.____678.____299(this.____244, this)
    },
    setPickEffect: function(flag) {
        if (flag) {
            if (this._pickEffect == null) {
                this._pickEffect = new RotationEffect("effect/effect_10.png", 5);
                this._pickEffect.setPosition(this._landBtn.getPosition());
                this.addChild(this._pickEffect, 5)
            }
        } else {
            if (this._pickEffect != null) {
                this._pickEffect.dispose();
                this._pickEffect = null
            }
        }
    },
    setHuntEffect: function(flag) {
        if (flag) {
            if (this._huntEffect == null) {
                this._huntEffect = new RotationEffect("effect/effect_10.png", 5);
                this._huntEffect.setPosition(this._huntBtn.getPosition());
                this.addChild(this._huntEffect, 5)
            }
        } else {
            if (this._huntEffect != null) {
                this._huntEffect.dispose();
                this._huntEffect = null
            }
        }
    },
    setFeedEffect: function(flag) {
        if (flag) {
            if (this._feedEffect == null) {
                this._feedEffect = new RotationEffect("effect/effect_10.png", 5);
                this.addChild(this._feedEffect, 5)
            }
            this._feedEffect.setPosition(this._feedBtn.getPosition())
        } else {
            if (this._feedEffect != null) {
                this._feedEffect.dispose();
                this._feedEffect = null
            }
        }
    },
    tick: function() {
        var time = ____655.____662.getSystemTimeSec();
        var tempInfo = ____655.allTemplates.seedTemplateList.getInfoById(this._curHomeInfo.seedId);
        if (this._curHomeInfo.seedTime + tempInfo.ripeTime <= time) {
            this._landBtn.setFrame("icon/home_caiji.png", 1);
            if (this._curHomeInfo == ____655.homeInfo) {
                this._landBtn.setVisible(true);
                this.setPickEffect(true);
                this._land_timeBg.setVisible(true);
                this._land_timeLabel.setVisible(true)
            } else {
                var flag = this._curHomeInfo.getCanSteal();
                this._landBtn.setVisible(flag);
                this.setPickEffect(flag);
                this._land_timeBg.setVisible(flag);
                this._land_timeLabel.setVisible(flag)
            }
            this._land_timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomePanel.text12"));
            ____654.____678.____299(this.tick, this)
        } else {
            if (this._curHomeInfo.waterTime + tempInfo.target.waterTime < time) {
                this._landBtn.setFrame("icon/home_jiaoshui.png", 1);
                this._landBtn.setVisible(true);
                this.setPickEffect(true);
                this._land_timeBg.setVisible(true);
                this._land_timeLabel.setVisible(true)
            } else {
                if (this._curHomeInfo == ____655.homeInfo) {
                    this._landBtn.setFrame("icon/home_jiasu.png", 1);
                    this._landBtn.setVisible(true);
                    this._land_timeBg.setVisible(true);
                    this._land_timeLabel.setVisible(true)
                } else {
                    this._landBtn.setVisible(false);
                    this._land_timeBg.setVisible(false);
                    this._land_timeLabel.setVisible(false)
                }
                this.setPickEffect(false)
            }
            this._land_timeLabel.setString(____655.____662.secondsToDateString(this._curHomeInfo.seedTime + tempInfo.ripeTime - time))
        }
        var stateTime = time - this._curHomeInfo.seedTime;
        for (var i = tempInfo.style.length - 1; i >= 0; i--) {
            if (stateTime >= tempInfo.style[i][0]) {
                for (var j = 0; j < this._curHomeInfo.landAmount; j++) {
                    this._landList[j].setFlantEffect(tempInfo.style[i])
                }
                break
            }
        }
    },
    setLandCount: function() {
        var landCount = this._curHomeInfo.landAmount;
        var nexLandCount = 0;
        var temp = ____655.allTemplates.homeTemplateList.getInfoByLevel(this._curHomeInfo.homeLevel + 1);
        if (!!temp) {
            nexLandCount = temp.landAmount
        }
        for (var i = 0; i < this._landList.length; i++) {
            if (i < landCount) {
                this._landList[i].setVisible(true);
                this._landList[i].setLandFlag(false);
                this._landList[i].setLandIsOpen(true)
            } else if (i >= landCount && i < nexLandCount && this._curHomeInfo == ____655.homeInfo) {
                this._landList[i].setVisible(true);
                this._landList[i].setLandFlag(true);
                this._landList[i].setLandIsOpen(false)
            } else {
                this._landList[i].setVisible(false)
            }
        }
    },
    dispose: function() {
        ____654.____678.____299(this.huntTimeTick, this);
        ____654.____678.____299(this.tick, this);
        ____654.____678.____299(this.____244, this);
        this.setEggFloat(false, 0);
        this.setPickEffect(false);
        this.setHuntEffect(false);
        this.setFeedEffect(false);
        this.____17();
        this.setPetInfo(null);
        this._tileContainer = null;
        this._friendShowPropController.dispose();
        this._friendShowPropController = null;
        this._friendHidePropController.dispose();
        this._friendHidePropController = null;
        this._controller = null;
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        ____654.____677.removeImageQuote(this._nestPath, this._nestImg);
        this._bgPath = null;
        this._bg = null;
        if (this._landList != null) {
            for (var i = 0; i < this._landList.length; i++) {
                this._landList[i].dispose()
            }
            this._landList = null
        }
        this._spring = null;
        this._shuomingBtn = null;
        this._liandanBtn = null;
        this._liandanTip = null;
        this._jinjieBtn = null;
        this._jinJieTip = null;
        this._closeBtn = null;
        this.____1178 = null;
        this._friendTip = null;
        this._friend_leftBtn = null;
        this._friend_rigthBtn = null;
        this.____927 = null;
        this._levelLabel = null;
        this._nameLabel = null;
        this._countLabel = null;
        this._homeLevelLabel = null;
        this._homeLevelImg = null;
        this.____1142 = null;
        this._expCount = null;
        this._landBtn = null;
        this._land_timeBg = null;
        this._land_timeLabel = null;
        this._nestImg = null;
        this._curHomeInfo = null;
        this._friendList = null;
        this._friendShowPsY = null;
        this._friendHidePsY = null;
        this._friendIsShow = null;
        this._feedBtn = null;
        this._feedTimeBg = null;
        this._feedTimeLabel = null;
        this._huntBtn = null;
        this._huntTimeBg = null;
        this._huntTimeLabel = null;
        this._petChatBg = null;
        this._petChatLabel = null;
        this._petLevelLabel = null;
        this._petLevelBar = null;
        this._petLevelBarBg = null;
        this._foodTipBg = null;
        this._foodCount = null;
        if (this._eggImg != null) {
            ____654.____677.removeImageQuote(this._eggImgPath, this._eggImg);
            this._eggImgPath = null;
            this._eggImg.dispose();
            this._eggImg = null
        }
        this._chattickCount = null;
        this._friendUpdateTime = null;
        this._intervalTime = null;
        this.____1770 = null;
        this.____1771 = null;
        this._tickCount3 = null;
        this.____1165 = null;
        this.____1478 = null;
        ____654.____676.showBack();
        this._super()
    },
});
var HomeSeedBtn = KYNode.extend({
    ____890: null,
    ____1237: null,
    _titleLabel: null,
    _type: 0,
    ctor: function(type) {
        this._super("homeSeedBtn.ExportJson");
        this.____890 = this.getChildByName("btnImg");
        this.____1237 = this.getChildByName("iconImg");
        this._titleLabel = this.getChildByName("titleLabel");
        this._type = type;
        this.____1237.setFrame("icon/ui_seedIcon_" + type + ".png", 1);
        this._titleLabel.setString(____655.allTemplates.seedTemplateList.getInfoByType(type).name)
    },
    ____239: function(flag) {
        if (flag) {
            this.____890.setFrame("btn/ui_btn1_2.png", 1)
        } else {
            this.____890.setFrame("btn/ui_btn1_1.png", 1)
        }
    },
    getType: function() {
        return this._type
    },
    dispose: function() {
        this._super();
        this.____890 = null;
        this.____1237 = null;
        this._titleLabel = null
    },
});
var HomeSeedItemView = KYNode.extend({
    _seedImg: null,
    _titleImg: null,
    _timeLabel: null,
    _mainCropsLabel: null,
    _viceCropsLabel: null,
    _seedBtn: null,
    _btn_titleLabel: null,
    _btn_moneyIcon: null,
    _lineImg: null,
    ____1756: null,
    _quality: 0,
    ____1126: null,
    _target: null,
    ctor: function(target, tempInfo, quality) {
        this._super("homeSeedItemView.ExportJson");
        this._target = target;
        this.____1756 = tempInfo;
        this._quality = quality;
        this._seedImg = this.getChildByName("seedImg");
        this._titleImg = this.getChildByName("titleImg");
        this._timeLabel = this.getChildByName("timeLabel");
        this._mainCropsLabel = this.getChildByName("mainCropsLabel");
        this._viceCropsLabel = this.getChildByName("viceCropsLabel");
        this._seedBtn = this.getChildByName("seedBtn");
        this._btn_titleLabel = this.getChildByName("btnTitleLabel");
        this._btn_moneyIcon = this.getChildByName("moneyIcon");
        this._lineImg = this.getChildByName("lineImg");
        this._titleImg.setFrame("flag/colorWord_" + quality + ".png", 1);
        this._bgPath = ____654.____675.____139("outPic/seedBgImg_" + quality + ".png");
        ____654.____677.____146(this._seedImg, this._bgPath);
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (!!this.____1756) {
            var info = this.____1756.qualityList[this._quality];
            if (!!info) {
                var effectId = info.style[2][1];
                if (this.____1126 != null) {
                    this.____1126.dispose();
                    this.____1126 = null
                }
                this.____1126 = ____654.effectManager.setEffect(effectId, false, this._seedImg.getPosition(), this);
                this.____1126.setScale(info.scale);
                if (info.price <= 0) {
                    this._btn_titleLabel.setString("种植");
                    this._btn_titleLabel.setPositionX(83);
                    this._btn_moneyIcon.setVisible(false)
                } else {
                    this._btn_titleLabel.setString("{0} 种植".format(info.price * ____655.homeInfo.landAmount));
                    this._btn_titleLabel.setPositionX(74);
                    this._btn_moneyIcon.setVisible(true)
                }
                this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomeSeedItemView.text1", ____655.____662.secondsToDateString5(info.ripeTime)));
                this._mainCropsLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomeSeedItemView.text2", info.awardList[0][0] + "x" + (parseInt(info.awardList[0][1]) * ____655.homeInfo.landAmount)));
                this._viceCropsLabel.setString(____654.yuyanbaoManager.getYuyanbao("HomeSeedItemView.text3", info.awardList[1][0]))
            }
        }
    },
    ____6: function() {
        this._seedBtn.addListener(this, this.____16)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._seedBtn) {
                if (!!this.____1756) {
                    var info = this.____1756.qualityList[this._quality];
                    if (!!info) {
                        if (info.price <= 0) {
                            this.plantHandler()
                        } else {
                            ____655.getAlert().show(2, "是否花费{0}钻石种植{1}。".format(info.price * ____655.homeInfo.landAmount, this.____1756.name) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.HOME_PLANT, 0, this, this.plantHandler, null, null)
                        }
                    }
                }
            }
        }
    },
    plantHandler: function() {
        var info = this.____1756.qualityList[this._quality];
        if (____655.____667.moneyInfo.moneyEnoughByType(5, info.price * ____655.homeInfo.landAmount)) {
            ____654.homeMessageSender.sendPlant(1, info.id);
            if (!!this._target && !!this._target.dispose) {
                this._target.dispose()
            }
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    setLineVisible: function(flag) {
        this._lineImg.setVisible(flag)
    },
    dispose: function() {
        this._super();
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        ____654.____677.removeImageQuote(this._bgPath, this._seedImg);
        this._bgPath = null;
        this._seedImg = null;
        this._titleImg = null;
        this._timeLabel = null;
        this._mainCropsLabel = null;
        this._viceCropsLabel = null;
        this._seedBtn = null;
        this._btn_titleLabel = null;
        this._btn_moneyIcon = null;
        this._lineImg = null;
        this.____1756 = null;
        this._quality = null;
        this._target = null
    },
});
var HomeSeedView = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____908: null,
    ____1286: null,
    _btnList: null,
    _itemList: null,
    ____1629: null,
    ctor: function(controller) {
        this._controller = controller;
        this._super("homeSeedView.ExportJson");
        this.modeValue = 150;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____908 = this.getChildByName("btnListView");
        this.____908.setScrollBarEnabled(false);
        this.____908.setItemsMargin(10);
        this.____1286 = this.getChildByName("itemListView");
        this.____1286.setScrollBarEnabled(false);
        this._btnList = [];
        this.____5();
        this.____6()
    },
    ____5: function() {
        var list = ____655.allTemplates.seedTemplateList.seedList;
        for (var i in list) {
            var btn = new HomeSeedBtn(i);
            btn.addListener(this, this.____16);
            this.____908.pushBackItem(btn);
            this._btnList.push(btn)
        }
        this.btnSelect(this._btnList[0])
    },
    btnSelect: function(btn) {
        if (this.____1629 == btn) {
            return
        }
        if (this.____1629 != null) {
            this.____1629.____239(false)
        }
        this.____1629 = btn;
        if (this.____1629 != null) {
            this.____1629.____239(true);
            this.setSelectItemView(this.____1629.getType())
        }
    },
    setSelectItemView: function(type) {
        this.clearItemView();
        this._itemList = [];
        var info = ____655.allTemplates.seedTemplateList.getInfoByType(type);
        if (!!info) {
            for (var i in info.qualityList) {
                var item = new HomeSeedItemView(this, info, i);
                if (i == 1) {
                    item.setLineVisible(false)
                }
                item.addListener(this, this.____16);
                this.____1286.pushBackItem(item);
                this._itemList.push(item)
            }
        }
    },
    clearItemView: function() {
        this.____1286.removeAllItems();
        if (this._itemList != null) {
            var len = this._itemList.length;
            for (var i = 0; i < len; i++) {
                this._itemList[i].dispose()
            }
            this._itemList = null
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else {
                for (var i = 0; i < this._btnList.length; i++) {
                    if (sender == this._btnList[i]) {
                        this.btnSelect(this._btnList[i]);
                        return
                    }
                }
            }
        }
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    dispose: function() {
        this.____17();
        this.clearItemView();
        this._controller = null;
        this._closeBtn = null;
        this.____908 = null;
        this.____1286 = null;
        this.____1629 = null;
        if (this._btnList != null) {
            var len = this._btnList.length;
            for (var i = 0; i < len; i++) {
                this._btnList[i].dispose()
            }
            this._btnList = null
        }
        this._super()
    },
});
var HomeController = cc.Class.extend({
    homeModule: null,
    ctor: function(homeModule) {
        this.homeModule = homeModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showHomePanel: function(type) {
        if (this.homeModule.homePanel == null) {
            this.homeModule.homePanel = new HomePanel(this)
        }
        ____654.____676.____125(this.homeModule.homePanel, true);
        if (type == ____655.____659.panelTabType.homeLianDan) {
            this.showHomeLianDanView()
        }
    },
    showHomeSeedView: function() {
        if (this.homeModule.homeSeedView == null) {
            this.homeModule.homeSeedView = new HomeSeedView(this)
        }
        ____654.____676.____125(this.homeModule.homeSeedView, true)
    },
    showHomeLianDanView: function() {
        if (this.homeModule.homeLianDanView == null) {
            this.homeModule.homeLianDanView = new HomeLianDanView(this)
        }
        ____654.____676.____125(this.homeModule.homeLianDanView, true)
    },
    showHomeJinjieView: function() {
        if (this.homeModule.homeJinjieView == null) {
            this.homeModule.homeJinjieView = new HomeJinjieView(this)
        }
        ____654.____676.____125(this.homeModule.homeJinjieView, true)
    },
    showHomeDescView: function() {
        if (this.homeModule.homeDescView == null) {
            this.homeModule.homeDescView = new HomeDescView(this)
        }
        ____654.____676.____125(this.homeModule.homeDescView, true)
    },
    showHomeHuntView: function() {
        if (this.homeModule.homeHuntView == null) {
            this.homeModule.homeHuntView = new HomeHuntView(this)
        }
        ____654.____676.____125(this.homeModule.homeHuntView, true)
    },
    showHomeLianDanRewardView: function() {
        if (this.homeModule.homeLianDanRewardView == null) {
            this.homeModule.homeLianDanRewardView = new HomeLianDanRewardView(this)
        }
        ____654.____676.____125(this.homeModule.homeLianDanRewardView, true)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.homeModule.homePanel) {
            this.homeModule.homePanel = null
        } else if (p == this.homeModule.homeSeedView) {
            this.homeModule.homeSeedView = null
        } else if (p == this.homeModule.homeLianDanView) {
            this.homeModule.homeLianDanView = null
        } else if (p == this.homeModule.homeJinjieView) {
            this.homeModule.homeJinjieView = null
        } else if (p == this.homeModule.homeDescView) {
            this.homeModule.homeDescView = null
        } else if (p == this.homeModule.homeLianDanRewardView) {
            this.homeModule.homeLianDanRewardView = null
        } else if (p == this.homeModule.homeHuntView) {
            this.homeModule.homeHuntView = null
        }
    },
});
var HomeModule = ____537.extend({
    homeController: null,
    homePanel: null,
    homeSeedView: null,
    homeLianDanView: null,
    homeJinjieView: null,
    homeDescView: null,
    homeLianDanRewardView: null,
    homeHuntView: null,
    setup: function(data) {
        this.homeController = new HomeController(this);
        this.____151(data)
    },
    ____151: function(data) {
        this.homeController.showHomePanel(data)
    },
    clear: function() {},
});
var MarryAcceptPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _sayNoBtn: null,
    ____892: null,
    ____819: null,
    ____1102: null,
    ____1544: null,
    ____1418: null,
    _bg: null,
    _bgPath: null,
    _ringPriceLabel: null,
    ____1157: null,
    _ringIcon: null,
    _ringPath: null,
    _headIcon1: null,
    _headIcon2: null,
    ____1443: null,
    ____1444: null,
    _info: null,
    _friendInfo: null,
    _price: 0,
    _tickCount: 600,
    _desFightLabel: null,
    ctor: function(controller, info) {
        this._super("marryAcceptPanel.ExportJson");
        this._controller = controller;
        this._info = info;
        this._closeBtn = this.getChildByName("closeBtn");
        this._closeBtn.setVisible(false);
        this._sayNoBtn = this.getChildByName("sayNoBtn");
        this.____892 = this.getChildByName("btnLabel1");
        this.____819 = this.getChildByName("acceptBtn");
        this.____1102 = this.getChildByName("desLabel1");
        this.____1544 = this.getChildByName("priceLabel");
        this.____1418 = this.getChildByName("moneyIcon");
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/marry_bg1.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._ringPriceLabel = this.getChildByName("ringNameLabel");
        this.____1157 = this.getChildByName("fightLabel");
        this._ringIcon = this.getChildByName("ringIcon");
        this._headIcon1 = this.getChildByName("headIcon1");
        this._headIcon2 = this.getChildByName("headIcon2");
        this.____1443 = this.getChildByName("nameLabel1");
        this.____1444 = this.getChildByName("nameLabel2");
        this._desFightLabel = this.getChildByName("desFightLabel");
        this.getChildByName("btnLabel1").setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text2"));
        this.getChildByName("btnLabel2").setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text3"));
        this.____1102.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text4"));
        this.getChildByName("titleLabel").setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text5"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____819.addListener(this, this.____16);
        this._sayNoBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                ____654.marryOathMessageSender.sendIsAccept(false, this._info[0], this._info[1], 0);
                this.dispose()
            } else if (sender == this.____819) {
                if (____655.____667.moneyInfo.money0Enough(this._price)) {
                    ____654.marryOathMessageSender.sendIsAccept(true, this._info[0], this._info[1], this._price)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
                this.dispose()
            } else if (sender == this._sayNoBtn) {
                ____654.marryOathMessageSender.sendIsAccept(false, this._info[0], this._info[1], 0);
                this.dispose()
            }
        }
    },
    ____5: function() {
        this._friendInfo = ____655.____668.getFriend(this._info[0]);
        if (this._friendInfo == null) return;
        this.____1443.setString(____655.____667.nick);
        this._headIcon1.setFrame("sceneIcon/PlayerHeadIcon2_" + ____655.____667.career.toString() + ".png", 1);
        this.____1444.setString(this._friendInfo.info.nick);
        this._headIcon2.setFrame("sceneIcon/PlayerHeadIcon2_" + this._friendInfo.info.career.toString() + ".png", 1);
        var ringTempInfo = ____655.allTemplates.marryOathTemplateList.____55(____655.____659.commonStaticType.sheJiao_marry, this._info[1]);
        this._ringPath = ____654.____675.____139("outPic/" + ringTempInfo.iconPath);
        ____654.____677.____146(this._ringIcon, this._ringPath);
        this.____1157.setString(ringTempInfo.getFight());
        this._ringPriceLabel.setString(ringTempInfo.fee);
        this._desFightLabel.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", ringTempInfo.name));
        if (this._info[3] == 1) {
            this.____1102.setVisible(true);
            this._price = Math.ceil(ringTempInfo.fee / 2);
            this.____1544.setString(this._price);
            this.____1418.setVisible(true)
        } else {
            this.____1102.setVisible(false);
            this.____1544.setString("");
            this.____1418.setVisible(false)
        }
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        if (this._tickCount % 60 == 0) {
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text2") + (this._tickCount / 60).toString())
        }
        this._tickCount--;
        if (this._tickCount <= 0) {
            ____654.____678.____299(this.tick, this);
            ____654.marryOathMessageSender.sendIsAccept(false, this._info[0], this._info[1], 0);
            this.dispose()
        }
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._closeBtn = null;
        this._sayNoBtn = null;
        this.____819 = null;
        this.____1102 = null;
        this.____1544 = null;
        this.____1418 = null;
        this.____892 = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this._ringPriceLabel = null;
        this.____1157 = null;
        if (this._ringPath != null) {
            ____654.____677.removeImageQuote(this._ringPath, this._ringIcon);
            this._ringPath = null
        }
        this._ringIcon = null;
        this._headIcon1 = null;
        this._headIcon2 = null;
        this.____1443 = null;
        this.____1444 = null;
        this._info = null;
        this._friendInfo = null;
        this._desFightLabel = null;
        this._super()
    },
});
var MarryApplyPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _AABtn: null,
    _personalPayBtn: null,
    ____1544: null,
    _bg: null,
    _bgPath: null,
    _ringPriceLabel1: null,
    _ringPriceLabel2: null,
    _desFightLabel1: null,
    _desFightLabel2: null,
    _fightLabel1: null,
    _fightLabel2: null,
    _ringIcon1: null,
    _ringIconPath1: null,
    _ringIcon2: null,
    _ringIconPath2: null,
    _headIcon1: null,
    _headIcon2: null,
    ____1443: null,
    ____1444: null,
    _titleLabel: null,
    _ringTemplateList: null,
    ____1637: -1,
    ____1636: null,
    _friendListBtn: null,
    _isAA: false,
    ____1835: 0,
    ctor: function(controller) {
        this._controller = controller;
        this._super("marryApplyPanel.ExportJson");
        this._closeBtn = this.getChildByName("closeBtn");
        this._AABtn = this.getChildByName("AABtn");
        this._personalPayBtn = this.getChildByName("personalPayBtn");
        this.____1544 = this.getChildByName("priceLabel");
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/marry_bg1.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._ringPriceLabel1 = this.getChildByName("ringPriceLabel1");
        this._ringPriceLabel2 = this.getChildByName("ringPriceLabel2");
        this._desFightLabel1 = this.getChildByName("desFightLabel1");
        this._desFightLabel2 = this.getChildByName("desFightLabel2");
        this._fightLabel1 = this.getChildByName("fightLabel1");
        this._fightLabel2 = this.getChildByName("fightLabel2");
        this._ringIcon1 = this.getChildByName("ringIcon1");
        this._ringIconPath1 = null;
        this._ringIcon2 = this.getChildByName("ringIcon2");
        this._ringIconPath2 = null;
        this._headIcon1 = this.getChildByName("headIcon1");
        this._headIcon2 = this.getChildByName("headIcon2");
        this.____1443 = this.getChildByName("nameLabel1");
        this.____1444 = this.getChildByName("nameLabel2");
        this._friendListBtn = this.getChildByName("friendListBtn");
        this.____1636 = this.getChildByName("selectImg");
        this._titleLabel = this.getChildByName("titleLabel");
        this._titleLabel.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text5"));
        this.getChildByName("btnLabel1").setString(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text1"));
        this.getChildByName("btnLabel2").setString(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text2"));
        this.getChildByName("desLabel1").setString(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text3"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._AABtn.addListener(this, this.____16);
        this._friendListBtn.addListener(this, this.____16);
        this._ringIcon1.addListener(this, this.____16);
        this._ringIcon2.addListener(this, this.____16);
        this._personalPayBtn.addListener(this, this.____16);
        this._closeBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.marry_chooseFriend, this.chooseFriendHandler, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this);
        ____655.marryOathInfo.addEventListener(____655.____661.marry_infoUpdate, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.marry_chooseFriend, this.chooseFriendHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this);
        ____655.marryOathInfo.removeEventListener(____655.____661.marry_infoUpdate, this.dispose, this)
    },
    chooseFriendHandler: function(evt) {
        var data = evt.data;
        if (data == null) return;
        this.____1835 = data.id;
        this.setFriendView(this.____1835)
    },
    ____5: function() {
        this._ringTemplateList = ____655.allTemplates.marryOathTemplateList.getTemplateList(____655.____659.commonStaticType.sheJiao_marry);
        this.____1443.setString(____655.____667.nick);
        this._headIcon1.setFrame("sceneIcon/PlayerHeadIcon2_" + ____655.____667.career.toString() + ".png", 1);
        this.setFriendView();
        this._ringPriceLabel1.setString(this._ringTemplateList[0].fee);
        this._ringIconPath1 = ____654.____675.____139("outPic/" + this._ringTemplateList[0].iconPath);
        ____654.____677.____146(this._ringIcon1, this._ringIconPath1);
        this._desFightLabel1.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", this._ringTemplateList[0].name));
        this._fightLabel1.setString(this._ringTemplateList[0].getFight());
        this._ringPriceLabel2.setString(this._ringTemplateList[1].fee);
        this._ringIconPath2 = ____654.____675.____139("outPic/" + this._ringTemplateList[1].iconPath);
        ____654.____677.____146(this._ringIcon2, this._ringIconPath2);
        this._desFightLabel2.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", this._ringTemplateList[1].name));
        this._fightLabel2.setString(this._ringTemplateList[1].getFight());
        this.____239(0)
    },
    ____239: function(index) {
        if (this.____1637 == index) return;
        this.____1637 = index;
        this.____1636.setPositionX(190 + 315 * index);
        this.____1544.setString(Math.ceil(this._ringTemplateList[index].fee / 2))
    },
    setFriendView: function(id) {
        if (id == null) {
            this._headIcon2.setVisible(false);
            this.____1444.setString("")
        } else {
            var info = ____655.____668.getFriend(id);
            if (info == null) {
                this._headIcon2.setVisible(false);
                this.____1444.setString("")
            } else {
                this._headIcon2.setVisible(true);
                this.____1444.setString(info.info.nick);
                this._headIcon2.setFrame("sceneIcon/PlayerHeadIcon2_" + info.info.career.toString() + ".png", 1)
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._AABtn) {
                if (this.____1835 == null || this.____1835 <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text4"));
                    return
                }
                var price = Math.ceil(this._ringTemplateList[this.____1637].fee / 2);
                if (____655.____667.moneyInfo.money0Enough(price)) {
                    this._isAA = true;
                    ____655.getAlert().show(2, "是否支付[0x009700]" + price + "[-]钻石请求结缘？", null, 0, this, this.applytHandler, null, null)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
            } else if (sender == this._personalPayBtn) {
                if (this.____1835 == null || this.____1835 <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text4"));
                    return
                }
                var price = this._ringTemplateList[this.____1637].fee;
                if (____655.____667.moneyInfo.money0Enough(price)) {
                    this._isAA = false;
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text6", price), null, 0, this, this.applytHandler, null, null)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
            } else if (sender == this._friendListBtn) {
                var list = [];
                if (____655.____667.getSex()) {
                    list = ____655.____668.getOnlineList(2)
                } else {
                    list = ____655.____668.getOnlineList(1)
                }
                if (list.length <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text5"));
                    return
                }
                this._controller.showMarryFreindListPanel(1, 1)
            } else if (sender == this._ringIcon1) {
                this.____239(0)
            } else if (sender == this._ringIcon2) {
                this.____239(1)
            } else if (sender == this._closeBtn) {
                this.dispose()
            }
        }
    },
    applytHandler: function() {
        ____654.marryOathMessageSender.sendMarryApply(this.____1835, this._ringTemplateList[this.____1637].id, this._isAA)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._closeBtn = null;
        this._AABtn = null;
        this._personalPayBtn = null;
        this.____1544 = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this._ringPriceLabel1 = null;
        this._ringPriceLabel2 = null;
        this._desFightLabel1 = null;
        this._desFightLabel2 = null;
        this._fightLabel1 = null;
        this._fightLabel2 = null;
        if (this._ringIconPath1 != null) {
            ____654.____677.removeImageQuote(this._ringIconPath1, this._ringIcon1);
            this._ringIconPath1 = null
        }
        this._ringIcon1 = null;
        if (this._ringIconPath2 != null) {
            ____654.____677.removeImageQuote(this._ringIconPath2, this._ringIcon2);
            this._ringIconPath2 = null
        }
        this._ringIcon2 = null;
        this._headIcon1 = null;
        this._headIcon2 = null;
        this.____1443 = null;
        this.____1444 = null;
        this._titleLabel = null;
        this._ringTemplateList = null;
        this.____1637 = null;
        this.____1636 = null;
        this._friendListBtn = null;
        this._isAA = null;
        this.____1835 = null;
        this._super()
    },
});
var MarryFriendListItem = KYNode.extend({
    _nameLabel: null,
    _info: null,
    ctor: function(info) {
        this._super("marryFriendListItem.ExportJson");
        this._info = info;
        this._nameLabel = this.getChildByName("Label_756638");
        this.____5()
    },
    ____5: function() {
        this._nameLabel.setString(this._info.info.nick)
    },
    ____238: function() {
        return this._info
    },
    dispose: function() {
        this._nameLabel = null;
        this._info = null;
        this._super()
    },
});
var MarryFriendListPanel = KYPanel.extend({
    _closeBtn: null,
    _tileContainer: null,
    _list: null,
    _pos: 0,
    _type: 0,
    ctor: function(controller, type, pos) {
        this._super("marryFriendListView.ExportJson");
        this._type = type;
        this._pos = pos;
        this._closeBtn = this.getChildByName("closeBtn");
        this._list = [];
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this.dispose()
        }
    },
    ____5: function() {
        if (this._type == 1) {
            if (____655.____667.getSex()) {
                this._list = ____655.____668.getOnlineList(2)
            } else {
                this._list = ____655.____668.getOnlineList(1)
            }
        } else {
            this._list = ____655.____668.getOnlineList()
        }
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, this._list.length, ____654.____673.____160(228, 47), 0, 10, true)
    },
    getItemByIndex: function(index) {
        var info = this._list[index];
        if (info == null) return null;
        var item = new MarryFriendListItem(info);
        item.addListener(this, this.itemClickHandler, null, null, null, false, true);
        return item
    },
    getIdByIndex: function(index) {
        var info = this._list[index];
        if (info == null) return -1;
        return info.info.userId
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var info = sender.____238();
            if (info == null) return;
            if (this._type == 1 && info.info.level < ____655.____659.levelType.marryLevel) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("MarryFriendListPanel.text1", ____655.____659.levelType.marryLevel))
            } else if (this._type == 2 && info.info.level < ____655.____659.levelType.jieYiLevel) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("MarryFriendListPanel.text1", ____655.____659.levelType.jieYiLevel))
            } else {
                var data = {};
                data["id"] = info.info.userId;
                data["pos"] = this._pos;
                ____654.____672.dispatchEvent(new ____590(____655.____661.marry_chooseFriend, ____654.____672, data));
                this.dispose()
            }
        }
    },
    hideFormContainer: function() {
        this.dispose()
    },
    dispose: function() {
        this.____17();
        this._closeBtn = null;
        this._tileContainer = null;
        this._list = null;
        this._super()
    },
});
var MarryPanel = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _marryTitleLabel: null,
    _strengthBtn: null,
    _breakBtn: null,
    _marryApplyBtn: null,
    _everMarryView: null,
    _levelLabel: null,
    _ringNameLabel: null,
    _stageUpBtn: null,
    _ringIcon: null,
    _ringIconPath: null,
    _neverMarryView: null,
    _proValueLabelList: null,
    _proNameLabelList: null,
    _plusValueLabelList: null,
    ____995: null,
    _grid: null,
    _needItemId: 0,
    _maxLevel: 0,
    _type: 0,
    ____1566: null,
    _addNumberUtils: null,
    _upBtnCanClick: true,
    _ringTempInfo: null,
    ____1790: null,
    _breakMoney: 5000000,
    _marryApplyBtnLabel: null,
    _stageUpBtnLabel: null,
    ctor: function(controller) {
        this._controller = controller;
        this._super("marryPanel.ExportJson");
        this.setPosition(____654.____673.____159(13, 11));
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/marry_bg2.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._marryTitleLabel = this.getChildByName("marryTitleLabel");
        this._strengthBtn = this.getChildByName("strengthBtn");
        this._breakBtn = this.getChildByName("breakBtn");
        this._marryApplyBtn = this.getChildByName("marryApplyBtn");
        this._everMarryView = this.getChildByName("everMarryView");
        this._levelLabel = this._everMarryView.getChildByName("levelLabel");
        this._ringNameLabel = this._everMarryView.getChildByName("ringNameLabel");
        this._stageUpBtn = this._everMarryView.getChildByName("levelUpBtn");
        this._tipsLabel = this._everMarryView.getChildByName("tipsLabel1");
        this._ringIcon = this._everMarryView.getChildByName("ringIcon");
        this._stageUpBtnLabel = this._everMarryView.getChildByName("levelUpBtnLabel");
        this._marryApplyBtnLabel = this.getChildByName("marryApplyBtnLabel");
        this._ringIconPath = null;
        this._neverMarryView = this.getChildByName("neverMarryView");
        this.____1790 = this._neverMarryView.getChildByName("tipsLabel2");
        this._proValueLabelList = [];
        this._proNameLabelList = [];
        this._plusValueLabelList = [];
        for (var i = 1; i < 8; i++) {
            this._proValueLabelList.push(this.getChildByName("proValue" + i));
            this._proNameLabelList.push(this.getChildByName("proName" + i));
            this._plusValueLabelList.push(this.getChildByName("plusValue" + i))
        }
        this.____995 = this.getChildByName("combatLabel");
        this._grid = new ____2129();
        this.getChildByName("cell").addChild(this._grid);
        this._neverMarryView.getChildByName("tipsLabel3").setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text1"));
        this._stageUpBtnLabel.setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text2"));
        this._marryApplyBtnLabel.setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text3"));
        this.getChildByName("strengthBtnLabel").setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle10"));
        this.getChildByName("desLabel").setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text5"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._stageUpBtn.addListener(this, this.____16);
        this._marryApplyBtn.addListener(this, this.____16);
        this._breakBtn.addListener(this, this.____16);
        this._strengthBtn.addListener(this, this.____16);
        ____655.marryOathInfo.addEventListener(____655.____661.marry_infoUpdate, this.infoUpdate, this)
    },
    ____17: function() {
        ____655.marryOathInfo.removeEventListener(____655.____661.marry_infoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function() {
        this._upBtnCanClick = true;
        this.updateView()
    },
    ____5: function() {
        this._type = ____655.____659.commonStaticType.sheJiao_marry;
        var tempInfo = ____655.allTemplates.hunPoTemplateList.getInfoByLevel(this._type, 1);
        if (tempInfo != null) {
            this._needItemId = tempInfo.needItem[0]
        }
        var itemTempInfo = ____655.allTemplates.____794.getItem(this._needItemId);
        this._grid.setItemTemplateInfo(itemTempInfo);
        this.____1566 = ____655.allTemplates.hunPoTemplateList.getProTypeList(this._type);
        for (var i = 0; i < this.____1566.length; i++) {
            var propertyId = this.____1566[i];
            var name = ____655.____659.propertyType.getNameByType(propertyId);
            this._proNameLabelList[i].setString(name + "：")
        }
        this.updateView()
    },
    updateView: function() {
        if (____655.marryOathInfo.marryType <= 0) {
            this._marryTitleLabel.setString(____654.yuyanbaoManager.getYuyanbao("common.tips1"));
            this._ringIcon.setVisible(false);
            this._neverMarryView.setVisible(true);
            this._everMarryView.setVisible(false);
            this._marryApplyBtn.setVisible(true);
            this._marryApplyBtnLabel.setVisible(true);
            this._breakBtn.setVisible(false);
            ____654.____674.setKYBtnEnabled(this._strengthBtn, false, 1);
            var needCount = ____655.allTemplates.hunPoTemplateList.getNeedCountByLevel(this._type, 1);
            var hasCount = ____655.itemInfoList.getCountByTempId(this._needItemId);
            this._grid.setNeedCount(hasCount, needCount);
            this._tipsLabel.setVisible(false)
        } else {
            if (____655.marryOathInfo.marryId > 0) {
                this._marryTitleLabel.setString(____655.marryOathInfo.marryName);
                this._neverMarryView.setVisible(false);
                this._everMarryView.setVisible(true);
                this._marryApplyBtn.setVisible(false);
                this._marryApplyBtnLabel.setVisible(false);
                this._breakBtn.setVisible(true)
            } else {
                this._marryTitleLabel.setString(____654.yuyanbaoManager.getYuyanbao("common.tips1"));
                this._neverMarryView.setVisible(false);
                this._everMarryView.setVisible(true);
                this._marryApplyBtn.setVisible(true);
                this._marryApplyBtnLabel.setVisible(true);
                this._breakBtn.setVisible(false)
            }
            this._maxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(this._type, ____655.marryOathInfo.marryType);
            this._ringTempInfo = ____655.allTemplates.marryOathTemplateList.____55(this._type, ____655.marryOathInfo.marryType);
            this._ringIcon.setVisible(true);
            this._ringIconPath = ____654.____675.____139("outPic/" + this._ringTempInfo.iconPath);
            ____654.____677.____146(this._ringIcon, this._ringIconPath);
            this._ringNameLabel.setString(this._ringTempInfo.name);
            this._levelLabel.setString("Lv." + ____655.marryOathInfo.marryLevel);
            if (____655.allTemplates.marryOathTemplateList.isCanAdvance(this._type, ____655.marryOathInfo.marryType)) {
                ____654.____674.setKYBtnEnabled(this._stageUpBtn, true, 1);
                if (____655.marryOathInfo.marryLevel >= this._maxLevel) {
                    this._tipsLabel.setVisible(true);
                    this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text4"))
                } else {
                    this._tipsLabel.setVisible(false)
                }
            } else {
                this._stageUpBtn.setVisible(false);
                this._stageUpBtnLabel.setVisible(false);
                if (____655.marryOathInfo.marryLevel >= this._maxLevel) {
                    this._tipsLabel.setVisible(true);
                    this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text6"))
                } else {
                    this._tipsLabel.setVisible(false)
                }
            }
            this.setMaterialView()
        }
        this.setPropertyView()
    },
    setMaterialView: function() {
        var maxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(this._type);
        if (____655.marryOathInfo.marryLevel >= maxLevel) {
            this._grid.setCount(-1);
            ____654.____674.setKYBtnEnabled(this._strengthBtn, false, 1)
        } else {
            var needCount = ____655.allTemplates.hunPoTemplateList.getXinWuNeedCount(this._type, ____655.marryOathInfo.marryLevel + 1);
            var hasCount = ____655.itemInfoList.getCountByTempId(this._needItemId);
            this._grid.setNeedCount(hasCount, needCount);
            if (hasCount >= needCount && ____655.marryOathInfo.marryLevel < this._maxLevel) {
                ____654.____674.setKYBtnEnabled(this._strengthBtn, true, 1)
            } else {
                ____654.____674.setKYBtnEnabled(this._strengthBtn, false, 1)
            }
        }
    },
    setPropertyView: function() {
        if (____655.marryOathInfo.marryType <= 0) {
            var bestTempInfo = ____655.allTemplates.marryOathTemplateList.getBestTempInfo(this._type);
            var proValueList = bestTempInfo.attList;
            for (var i = 0; i < this.____1566.length; i++) {
                var propertyId = this.____1566[i];
                this._plusValueLabelList[i].setString("");
                this._proValueLabelList[i].setString(proValueList[i].value)
            }
            if (this._addNumberUtils == null) {
                this._addNumberUtils = new AddNumberUtils(this.____995, 0)
            } else {
                this._addNumberUtils.setValue(0, true)
            }
            this.____1790.setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text7", bestTempInfo.name))
        } else {
            var ringProList = this._ringTempInfo.attList;
            var proValueList = ____655.allTemplates.hunPoTemplateList.getXinWuTotalProperty(this._type, ____655.marryOathInfo.marryLevel);
            var plusValueList = ____655.allTemplates.hunPoTemplateList.getXinWuAddProperty(this._type, ____655.marryOathInfo.marryLevel + 1);
            var fight = 0;
            for (var i = 0; i < this.____1566.length; i++) {
                var propertyId = this.____1566[i];
                var value = ringProList[i].value + proValueList[propertyId];
                this._proValueLabelList[i].setString(value);
                fight += ____655.____659.propertyType.getFight(propertyId, value);
                if (plusValueList != null) {
                    this._plusValueLabelList[i].setString("+" + plusValueList[propertyId])
                } else {
                    this._plusValueLabelList[i].setString("")
                }
            }
            if (this._addNumberUtils == null) {
                this._addNumberUtils = new AddNumberUtils(this.____995, fight)
            } else {
                this._addNumberUtils.setValue(fight, true)
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._stageUpBtn) {
                this._controller.showMarryRingAdvancePanel()
            } else if (sender == this._marryApplyBtn) {
                this._controller.showMarryApplyPanel()
            } else if (sender == this._breakBtn) {
                var str = ____654.____682.____108(10098);
                ____655.getAlert().show(2, str, null, 0, this, this.okClick)
            } else if (sender == this._strengthBtn) {
                if (this._upBtnCanClick) {
                    ____654.marryOathMessageSender.sendStrengthLevelUp();
                    this._upBtnCanClick = false
                } else {
                    print("---协议没返回,不能点---")
                }
            }
        }
    },
    okClick: function() {
        if (____655.____667.moneyInfo.money2Enough(this._breakMoney)) {
            ____654.marryOathMessageSender.sendBreakMarry()
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(3)
        }
    },
    dispose: function() {
        this.____17();
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this._ringIconPath != null) {
            ____654.____677.removeImageQuote(this._ringIconPath, this._ringIcon);
            this._ringIconPath = null
        }
        this._ringIcon = null;
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this._controller = null;
        this.____1790 = null;
        this._ringTempInfo = null;
        this._marryTitleLabel = null;
        this._strengthBtn = null;
        this._breakBtn = null;
        this._marryApplyBtn = null;
        this._marryApplyBtnLabel = null;
        this._everMarryView = null;
        this._levelLabel = null;
        this._ringNameLabel = null;
        this._stageUpBtn = null;
        this._stageUpBtnLabel = null;
        this._neverMarryView = null;
        this._proValueLabelList = null;
        this._proNameLabelList = null;
        this._plusValueLabelList = null;
        this.____995 = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._needItemId = null;
        this._maxLevel = null;
        this._type = null;
        this.____1566 = null;
        this._upBtnCanClick = null;
        this._super()
    },
});
var MarryRingAdvancePanel = KYPanel.extend({
    _closeBtn: null,
    _sayNoBtn: null,
    ____819: null,
    ____1544: null,
    _fightLabel1: null,
    _fightLabel2: null,
    _desFightLabel1: null,
    _xinWuIcon1: null,
    _xinWuIconPath1: null,
    _xinWuIcon2: null,
    _xinWuIconPath2: null,
    _desFightLabel2: null,
    _levelLabel1: null,
    _levelLabel2: null,
    _price: 0,
    ____1076: null,
    _nextTempInfo: null,
    ctor: function() {
        this._super("oathXinWuUpPanel.ExportJson");
        this._closeBtn = this.getChildByName("closeBtn");
        this._sayNoBtn = this.getChildByName("sayNoBtn");
        this.____819 = this.getChildByName("acceptBtn");
        this.____1544 = this.getChildByName("priceLabel");
        this._fightLabel1 = this.getChildByName("fightLabel1");
        this._fightLabel2 = this.getChildByName("fightLabel2");
        this._desFightLabel1 = this.getChildByName("desFightLabel1");
        this._desFightLabel2 = this.getChildByName("desFightLabel2");
        this._xinWuIcon1 = this.getChildByName("xinWuIcon1");
        this._xinWuIconPath1 = null;
        this._xinWuIcon2 = this.getChildByName("xinWuIcon2");
        this._xinWuIconPath2 = null;
        this._levelLabel1 = this.getChildByName("levelLabel1");
        this._levelLabel2 = this.getChildByName("levelLabel2");
        this.getChildByName("desLabel1").setString(____654.yuyanbaoManager.getYuyanbao("MarryRingAdvancePanel.text1"));
        this.getChildByName("btnLabel1").setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips4"));
        this.getChildByName("btnLabel2").setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips3"));
        this.getChildByName("xinWuPriceLabel1").setString(____654.yuyanbaoManager.getYuyanbao("MarryRingAdvancePanel.text2"));
        this.getChildByName("xinWuPriceLabel2").setString(____654.yuyanbaoManager.getYuyanbao("MarryRingAdvancePanel.text2"));
        this.getChildByName("titleLabel").setString(____654.yuyanbaoManager.getYuyanbao("MarryRingAdvancePanel.text3"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this._sayNoBtn.addListener(this, this.____16);
        this.____819.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____5: function() {
        this.____1076 = ____655.allTemplates.marryOathTemplateList.____55(____655.____659.commonStaticType.sheJiao_marry, ____655.marryOathInfo.marryType);
        this._nextTempInfo = ____655.allTemplates.marryOathTemplateList.____55(____655.____659.commonStaticType.sheJiao_marry, ____655.marryOathInfo.marryType + 1);
        if (this._nextTempInfo == null) return;
        this._price = Math.ceil((this._nextTempInfo.fee - this.____1076.fee) / 2);
        this.____1544.setString(this._price);
        this._xinWuIconPath1 = ____654.____675.____139("outPic/" + this.____1076.iconPath);
        ____654.____677.____146(this._xinWuIcon1, this._xinWuIconPath1);
        this._desFightLabel1.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", this.____1076.name));
        this._fightLabel1.setString(this.____1076.getFight());
        this._xinWuIconPath2 = ____654.____675.____139("outPic/" + this._nextTempInfo.iconPath);
        ____654.____677.____146(this._xinWuIcon2, this._xinWuIconPath2);
        this._desFightLabel2.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", this._nextTempInfo.name));
        this._fightLabel2.setString(this._nextTempInfo.getFight());
        var curMaxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(____655.____659.commonStaticType.sheJiao_marry, this.____1076.id);
        this._levelLabel1.setString("Lv." + curMaxLevel);
        var nextMaxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(____655.____659.commonStaticType.sheJiao_marry, this._nextTempInfo.id);
        this._levelLabel2.setString("Lv." + nextMaxLevel)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._sayNoBtn) {
                this.dispose()
            } else if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____819) {
                if (____655.____667.moneyInfo.money0Enough(this._price)) {
                    ____654.marryOathMessageSender.sendAdvanceRing(this._nextTempInfo.id)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
                this.dispose()
            }
        }
    },
    dispose: function() {
        this.____17();
        this._closeBtn = null;
        this._sayNoBtn = null;
        this.____819 = null;
        this.____1544 = null;
        this._fightLabel1 = null;
        this._fightLabel2 = null;
        this._desFightLabel1 = null;
        if (this._xinWuIconPath1 != null) {
            ____654.____677.removeImageQuote(this._xinWuIconPath1, this._xinWuIcon1);
            this._xinWuIconPath1 = null
        }
        this._xinWuIcon1 = null;
        if (this._xinWuIconPath2 != null) {
            ____654.____677.removeImageQuote(this._xinWuIconPath2, this._xinWuIcon2);
            this._xinWuIconPath2 = null
        }
        this._xinWuIcon2 = null;
        this._desFightLabel2 = null;
        this._levelLabel1 = null;
        this._levelLabel2 = null;
        this._price = null;
        this.____1076 = null;
        this._nextTempInfo = null;
        this._super()
    },
});
var OathAcceptPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _sayNoBtn: null,
    ____892: null,
    ____819: null,
    ____1102: null,
    ____1510: null,
    _xinWuPriceLabel: null,
    ____1418: null,
    _bg: null,
    _bgPath: null,
    ____1157: null,
    _xinWuIcon: null,
    _xinWuIconPath: null,
    _brotherLabelList: null,
    _nameLabelList: null,
    ____1222: null,
    _titleTipsLabel: null,
    _desFightLabel: null,
    _info: null,
    _price: 0,
    _tickCount: 600,
    ctor: function(controller, info) {
        this._super("oathAcceptPanel.ExportJson");
        this._controller = controller;
        this._info = info;
        if (info == null) return;
        this._closeBtn = this.getChildByName("closeBtn");
        this._closeBtn.setVisible(false);
        this._sayNoBtn = this.getChildByName("sayNoBtn");
        this.____892 = this._sayNoBtn.getChildByName("btnLabel");
        this.____819 = this.getChildByName("acceptBtn");
        this.____1102 = this.getChildByName("desLabel1");
        this._xinWuPriceLabel = this.getChildByName("xinWuPriceLabel");
        this.____1510 = this.getChildByName("jieYiPriceLabel");
        this.____1418 = this.getChildByName("moneyIcon1");
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/oath_bg1.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._titleTipsLabel = this.getChildByName("titleTipsLabel");
        this._desFightLabel = this.getChildByName("desLabel2");
        this.____1157 = this.getChildByName("fightLabel");
        this._xinWuIcon = this.getChildByName("xinWuIcon");
        this._brotherLabelList = [];
        this._nameLabelList = [];
        this.____1222 = [];
        for (var i = 1; i < 4; i++) {
            this._brotherLabelList.push(this.getChildByName("brotherLabel" + i));
            this._nameLabelList.push(this.getChildByName("nameLabel" + i));
            this.____1222.push(this.getChildByName("headIcon" + i))
        }
        this._sayNoBtn.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2260.text1"));
        this.____819.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2260.text2"));
        this.____1102.setString(____654.yuyanbaoManager.getYuyanbao("OathAcceptPanel.text2"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____819.addListener(this, this.____16);
        this._sayNoBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                ____654.marryOathMessageSender.sendOathRepley(this._info.firstId, false, this._info.pos, 0);
                this.dispose()
            } else if (sender == this.____819) {
                if (____655.____667.moneyInfo.money0Enough(this._price)) {
                    ____654.marryOathMessageSender.sendOathRepley(this._info.firstId, true, this._info.pos, this._price)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
                this.dispose()
            } else if (sender == this._sayNoBtn) {
                ____654.marryOathMessageSender.sendOathRepley(this._info.firstId, false, this._info.pos, 0);
                this.dispose()
            }
        }
    },
    ____5: function() {
        this._nameLabelList[0].setString(this._info.firstName);
        this.____1222[0].setFrame("sceneIcon/PlayerHeadIcon2_" + this._info.firstCareer.toString() + ".png", 1);
        this._brotherLabelList[0].setString(____655.marryOathInfo.getBrotherTitle(this._info.firstCareer, 1));
        if (this._info.pos == 2) {
            this._nameLabelList[1].setString(____655.____667.nick);
            this.____1222[1].setFrame("sceneIcon/PlayerHeadIcon2_" + ____655.____667.career.toString() + ".png", 1);
            this._brotherLabelList[1].setString(____655.marryOathInfo.getBrotherTitle(____655.____667.career, 2));
            this._nameLabelList[2].setString(this._info.otherName);
            this.____1222[2].setFrame("sceneIcon/PlayerHeadIcon2_" + this._info.otherCareer.toString() + ".png", 1);
            this._brotherLabelList[2].setString(____655.marryOathInfo.getBrotherTitle(this._info.otherCareer, 3))
        } else {
            this._nameLabelList[1].setString(this._info.otherName);
            this.____1222[1].setFrame("sceneIcon/PlayerHeadIcon2_" + this._info.otherCareer.toString() + ".png", 1);
            this._brotherLabelList[1].setString(____655.marryOathInfo.getBrotherTitle(this._info.otherCareer, 2));
            this._nameLabelList[2].setString(____655.____667.nick);
            this.____1222[2].setFrame("sceneIcon/PlayerHeadIcon2_" + ____655.____667.career.toString() + ".png", 1);
            this._brotherLabelList[2].setString(____655.marryOathInfo.getBrotherTitle(____655.____667.career, 3))
        }
        this._titleTipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("OathAcceptPanel.text1", this._info.firstName));
        var xinWuTempInfo = ____655.allTemplates.marryOathTemplateList.____55(____655.____659.commonStaticType.sheJiao_oath, this._info.type);
        this._xinWuIconPath = ____654.____675.____139("outPic/" + xinWuTempInfo.iconPath);
        ____654.____677.____146(this._xinWuIcon, this._xinWuIconPath);
        this.____1157.setString(xinWuTempInfo.getFight());
        this._xinWuPriceLabel.setString(xinWuTempInfo.fee);
        if (this._info.isAA == 1) {
            this.____1102.setVisible(true);
            this._price = Math.ceil(xinWuTempInfo.fee / 3);
            this.____1510.setString(this._price);
            this.____1418.setVisible(true)
        } else {
            this.____1102.setVisible(false);
            this.____1510.setString("");
            this.____1418.setVisible(false)
        }
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        if (this._tickCount % 60 == 0) {
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2260.text1") + (this._tickCount / 60).toString())
        }
        this._tickCount--;
        if (this._tickCount <= 0) {
            ____654.____678.____299(this.tick, this);
            ____654.marryOathMessageSender.sendOathRepley(this._info.firstId, false, this._info.pos, 0);
            this.dispose()
        }
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._closeBtn = null;
        this._sayNoBtn = null;
        this.____819 = null;
        this.____1102 = null;
        this.____1510 = null;
        this._xinWuPriceLabel = null;
        this.____1418 = null;
        this.____892 = null;
        this._titleTipsLabel = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this.____1157 = null;
        if (this._xinWuIconPath != null) {
            ____654.____677.removeImageQuote(this._xinWuIconPath, this._xinWuIcon);
            this._xinWuIconPath = null
        }
        this._xinWuIcon = null;
        this._info = null;
        this._brotherLabelList = null;
        this._nameLabelList = null;
        this.____1222 = null;
        this._desFightLabel = null;
        this._price = null;
        this._tickCount = null;
        this._super()
    },
});
var OathApplyPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _AABtn: null,
    _personalPayBtn: null,
    ____1544: null,
    _bg: null,
    _bgPath: null,
    _xinWuPriceLabel1: null,
    _xinWuPriceLabel2: null,
    _desFightLabel1: null,
    _desFightLabel2: null,
    _fightLabel1: null,
    _fightLabel2: null,
    _xinWuIcon1: null,
    _xinWuIconPath1: null,
    _xinWuIcon2: null,
    _xinWuIconPath2: null,
    ____1636: null,
    _drowDownBtn2: null,
    _drowDownBtn3: null,
    _brotherLabelList: null,
    _nameLabelList: null,
    ____1222: null,
    ____1309: null,
    _xinWuTempList: null,
    ____1637: -1,
    _isAA: false,
    _userId1: 0,
    _userId2: 0,
    ____1398: 30,
    ctor: function(controller) {
        this._controller = controller;
        this._super("oathApplyPanel.ExportJson");
        this._closeBtn = this.getChildByName("closeBtn");
        this._AABtn = this.getChildByName("AABtn");
        this._personalPayBtn = this.getChildByName("personalPayBtn");
        this.____1544 = this.getChildByName("jieYiPriceLabel");
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/oath_bg1.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._xinWuPriceLabel1 = this.getChildByName("xinWuPriceLabel1");
        this._xinWuPriceLabel2 = this.getChildByName("xinWuPriceLabel2");
        this._desFightLabel1 = this.getChildByName("desFightLabel1");
        this._desFightLabel2 = this.getChildByName("desFightLabel2");
        this._fightLabel1 = this.getChildByName("fightLabel1");
        this._fightLabel2 = this.getChildByName("fightLabel2");
        this._xinWuIcon1 = this.getChildByName("xinWuIcon1");
        this._xinWuIconPath1 = null;
        this._xinWuIcon2 = this.getChildByName("xinWuIcon2");
        this._xinWuIconPath2 = null;
        this.____1636 = this.getChildByName("selectImg");
        this._drowDownBtn2 = this.getChildByName("drowDownBtn2");
        this._drowDownBtn3 = this.getChildByName("drowDownBtn3");
        this._brotherLabelList = [];
        this._nameLabelList = [];
        this.____1222 = [];
        for (var i = 1; i < 4; i++) {
            this._brotherLabelList.push(this.getChildByName("brotherLabel" + i));
            this._nameLabelList.push(this.getChildByName("nameLabel" + i));
            this.____1222.push(this.getChildByName("headIcon" + i))
        }
        this.getChildByName("btnLabel1").setString(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text1"));
        this.getChildByName("btnLabel2").setString(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text2"));
        this.getChildByName("desLabel1").setString(____654.yuyanbaoManager.getYuyanbao("MarryApplyPanel.text3"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._AABtn.addListener(this, this.____16);
        this._drowDownBtn2.addListener(this, this.____16);
        this._drowDownBtn3.addListener(this, this.____16);
        this._xinWuIcon1.addListener(this, this.____16);
        this._xinWuIcon2.addListener(this, this.____16);
        this._personalPayBtn.addListener(this, this.____16);
        this._closeBtn.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.marry_chooseFriend, this.chooseFriendHandler, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this);
        ____655.marryOathInfo.addEventListener(____655.____661.oath_infoUpdate, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.marry_chooseFriend, this.chooseFriendHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this);
        ____655.marryOathInfo.removeEventListener(____655.____661.oath_infoUpdate, this.dispose, this)
    },
    chooseFriendHandler: function(evt) {
        var data = evt.data;
        if (data == null) return;
        var userId = data.id;
        var pos = data.pos;
        if (pos == 1) {
            this._userId1 = userId
        } else if (pos == 2) {
            this._userId2 = userId
        }
        this.setFriendView(pos, userId)
    },
    ____5: function() {
        this.initFriendView();
        this._xinWuTempList = ____655.allTemplates.marryOathTemplateList.getTemplateList(____655.____659.commonStaticType.sheJiao_oath);
        this._nameLabelList[0].setString(____655.____667.nick);
        this.____1222[0].setFrame("sceneIcon/PlayerHeadIcon2_" + ____655.____667.career.toString() + ".png", 1);
        this._brotherLabelList[0].setString(____655.marryOathInfo.getBrotherTitle(____655.____667.career, 1));
        this._xinWuPriceLabel1.setString(this._xinWuTempList[0].fee);
        this._xinWuIconPath1 = ____654.____675.____139("outPic/" + this._xinWuTempList[0].iconPath);
        ____654.____677.____146(this._xinWuIcon1, this._xinWuIconPath1);
        this._desFightLabel1.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", this._xinWuTempList[0].name));
        this._fightLabel1.setString(this._xinWuTempList[0].getFight());
        this._xinWuPriceLabel2.setString(this._xinWuTempList[1].fee);
        this._xinWuIconPath2 = ____654.____675.____139("outPic/" + this._xinWuTempList[1].iconPath);
        ____654.____677.____146(this._xinWuIcon2, this._xinWuIconPath2);
        this._desFightLabel2.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", this._xinWuTempList[1].name));
        this._fightLabel2.setString(this._xinWuTempList[1].getFight());
        this.____239(0)
    },
    ____239: function(index) {
        if (this.____1637 == index) return;
        this.____1637 = index;
        this.____1636.setPositionX(203 + 295 * index);
        this.____1544.setString(Math.ceil(this._xinWuTempList[index].fee / 3))
    },
    initFriendView: function() {
        this.____1222[1].setVisible(false);
        this._nameLabelList[1].setString("");
        this.____1222[2].setVisible(false);
        this._nameLabelList[2].setString("")
    },
    setFriendView: function(pos, id) {
        if (id != null && this.____1222[pos] != null && this._nameLabelList[pos] != null) {
            var info = ____655.____668.getFriend(id);
            if (info == null) {
                this.____1222[pos].setVisible(false);
                this._nameLabelList[pos].setString("");
                this._brotherLabelList[pos].setString("")
            } else {
                this.____1222[pos].setVisible(true);
                this._nameLabelList[pos].setString(info.info.nick);
                this.____1222[pos].setFrame("sceneIcon/PlayerHeadIcon2_" + info.info.career.toString() + ".png", 1);
                this._brotherLabelList[pos].setString(____655.marryOathInfo.getBrotherTitle(info.info.career, pos + 1))
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._AABtn) {
                if (this._userId1 == null || this._userId1 <= 0 || this._userId2 == null || this._userId2 <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("OathApplyPanel.text1"));
                    return
                }
                if (this._userId1 == this._userId2) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("OathApplyPanel.text2"));
                    return
                }
                var price = Math.ceil(this._xinWuTempList[this.____1637].fee / 3);
                if (____655.____667.moneyInfo.money0Enough(price)) {
                    this._isAA = true;
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("OathApplyPanel.text3", price), null, 0, this, this.applytHandler, null, null)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
            } else if (sender == this._personalPayBtn) {
                if (this._userId1 == null || this._userId1 <= 0 || this._userId2 == null || this._userId2 <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("OathApplyPanel.text1"));
                    return
                }
                if (this._userId1 == this._userId2) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("OathApplyPanel.text2"));
                    return
                }
                var price = this._xinWuTempList[this.____1637].fee;
                if (____655.____667.moneyInfo.money0Enough(price)) {
                    this._isAA = false;
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("OathApplyPanel.text3", price), null, 0, this, this.applytHandler, null, null)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
            } else if (sender == this._drowDownBtn2) {
                var list = ____655.____668.getOnlineList();
                if (list.length <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("OathApplyPanel.text4"));
                    return
                }
                this._controller.showMarryFreindListPanel(2, 1)
            } else if (sender == this._drowDownBtn3) {
                var list = ____655.____668.getOnlineList();
                if (list.length <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("OathApplyPanel.text4"));
                    return
                }
                this._controller.showMarryFreindListPanel(2, 2)
            } else if (sender == this._xinWuIcon1) {
                this.____239(0)
            } else if (sender == this._xinWuIcon2) {
                this.____239(1)
            } else if (sender == this._closeBtn) {
                this.dispose()
            }
        }
    },
    applytHandler: function() {
        var title = "";
        ____654.marryOathMessageSender.sendOathApply(this._userId1, this._userId2, this._xinWuTempList[this.____1637].id, this._isAA)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._closeBtn = null;
        this._AABtn = null;
        this._personalPayBtn = null;
        this.____1544 = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this._xinWuPriceLabel1 = null;
        this._xinWuPriceLabel2 = null;
        this._desFightLabel1 = null;
        this._desFightLabel2 = null;
        this._fightLabel1 = null;
        this._fightLabel2 = null;
        if (this._xinWuIconPath1 != null) {
            ____654.____677.removeImageQuote(this._xinWuIconPath1, this._xinWuIcon1);
            this._xinWuIconPath1 = null
        }
        this._xinWuIcon1 = null;
        if (this._xinWuIconPath2 != null) {
            ____654.____677.removeImageQuote(this._xinWuIconPath2, this._xinWuIcon2);
            this._xinWuIconPath2 = null
        }
        this._xinWuIcon2 = null;
        this._xinWuTempList = null;
        this.____1637 = null;
        this.____1636 = null;
        this._friendListBtn = null;
        this._isAA = null;
        this._userId1 = null;
        this._userId2 = null;
        this._drowDownBtn2 = null;
        this._drowDownBtn3 = null;
        this._brotherLabelList = null;
        this._nameLabelList = null;
        this.____1222 = null;
        this.____1398 = null;
        this._super()
    },
});
var OathPanel = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _strengthBtn: null,
    _breakBtn: null,
    _oathApplyBtn: null,
    _everMarryView: null,
    _levelLabel: null,
    _stageUpBtn: null,
    _tipsLabel: null,
    _xinWuIcon: null,
    _xinWuIconPath: null,
    _broNameLabelList: null,
    _borTypeLabelList: null,
    _neverMarryView: null,
    _proValueLabelList: null,
    _proNameLabelList: null,
    _plusValueLabelList: null,
    ____995: null,
    _grid: null,
    ____1790: null,
    _xinWuNameLabel: null,
    _applyBtnLabel: null,
    _stageUpBtnLabel: null,
    _type: null,
    _maxLevel: null,
    _needItemId: null,
    ____1566: null,
    _xinWuTempInfo: null,
    _upBtnCanClick: true,
    _addNumberUtils: null,
    _breakMoney: 5000000,
    ctor: function(controller) {
        this._controller = controller;
        this._super("oathPanel.ExportJson");
        this.setPosition(____654.____673.____159(13, 11));
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/oath_bg2.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._strengthBtn = this.getChildByName("strengthBtn");
        this._breakBtn = this.getChildByName("breakBtn");
        this._oathApplyBtn = this.getChildByName("oathApplyBtn");
        this._applyBtnLabel = this.getChildByName("applyBtnLabel");
        this._everMarryView = this.getChildByName("everOathView");
        this._levelLabel = this._everMarryView.getChildByName("levelLabel");
        this._stageUpBtn = this._everMarryView.getChildByName("levelUpBtn");
        this._stageUpBtnLabel = this._everMarryView.getChildByName("levelUpBtnLabel");
        this._tipsLabel = this._everMarryView.getChildByName("tipsLabel1");
        this._xinWuIcon = this._everMarryView.getChildByName("xinWuIcon");
        this._xinWuIconPath = null;
        this._xinWuNameLabel = this._everMarryView.getChildByName("xinWuNameLabel");
        this._broNameLabelList = [];
        this._borTypeLabelList = [];
        for (var i = 1; i < 4; i++) {
            this._borTypeLabelList.push(this._everMarryView.getChildByName("brotherLabel" + i));
            this._broNameLabelList.push(this._everMarryView.getChildByName("nameLabel" + i))
        }
        this._neverMarryView = this.getChildByName("neverOathView");
        this.____1790 = this._neverMarryView.getChildByName("tipsLabel2");
        this._proValueLabelList = [];
        this._proNameLabelList = [];
        this._plusValueLabelList = [];
        for (var i = 1; i < 8; i++) {
            this._proValueLabelList.push(this.getChildByName("proValue" + i));
            this._proNameLabelList.push(this.getChildByName("proName" + i));
            this._plusValueLabelList.push(this.getChildByName("plusValue" + i))
        }
        this.____995 = this.getChildByName("combatLabel");
        this._grid = new ____2129();
        this.getChildByName("cell").addChild(this._grid);
        this._neverMarryView.getChildByName("tipsLabel3").setString(____654.yuyanbaoManager.getYuyanbao("OathPanel.text1"));
        this._stageUpBtnLabel.setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text2"));
        this._applyBtnLabel.setString(____654.yuyanbaoManager.getYuyanbao("OathPanel.text2"));
        this.getChildByName("strengthBtnLabel").setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle10"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._stageUpBtn.addListener(this, this.____16);
        this._oathApplyBtn.addListener(this, this.____16);
        this._breakBtn.addListener(this, this.____16);
        this._strengthBtn.addListener(this, this.____16);
        ____655.marryOathInfo.addEventListener(____655.____661.oath_infoUpdate, this.infoUpdate, this);
        ____655.marryOathInfo.addEventListener(____655.____661.oath_brotherInfoUpdate, this.setBrotherInfo, this)
    },
    ____17: function() {
        ____655.marryOathInfo.removeEventListener(____655.____661.oath_infoUpdate, this.infoUpdate, this);
        ____655.marryOathInfo.removeEventListener(____655.____661.oath_brotherInfoUpdate, this.setBrotherInfo, this)
    },
    infoUpdate: function() {
        this._upBtnCanClick = true;
        this.updateView()
    },
    ____5: function() {
        if (____655.marryOathInfo.oathPos > 0) {
            ____654.marryOathMessageSender.sendGetBrotherInfo()
        }
        this._type = ____655.____659.commonStaticType.sheJiao_oath;
        var tempInfo = ____655.allTemplates.hunPoTemplateList.getInfoByLevel(this._type, 1);
        if (tempInfo != null) {
            this._needItemId = tempInfo.needItem[0]
        }
        var itemTempInfo = ____655.allTemplates.____794.getItem(this._needItemId);
        this._grid.setItemTemplateInfo(itemTempInfo);
        this.____1566 = ____655.allTemplates.hunPoTemplateList.getProTypeList(this._type);
        for (var i = 0; i < this.____1566.length; i++) {
            var propertyId = this.____1566[i];
            var name = ____655.____659.propertyType.getNameByType(propertyId);
            this._proNameLabelList[i].setString(name + "：")
        }
        this.updateView()
    },
    updateView: function() {
        if (____655.marryOathInfo.oathType <= 0) {
            this._neverMarryView.setVisible(true);
            this._everMarryView.setVisible(false);
            this._oathApplyBtn.setVisible(true);
            this._applyBtnLabel.setVisible(true);
            this._breakBtn.setVisible(false);
            ____654.____674.setKYBtnEnabled(this._strengthBtn, false, 1);
            var needCount = ____655.allTemplates.hunPoTemplateList.getNeedCountByLevel(this._type, 1);
            var hasCount = ____655.itemInfoList.getCountByTempId(this._needItemId);
            this._grid.setNeedCount(hasCount, needCount);
            this._tipsLabel.setVisible(false)
        } else {
            if (____655.marryOathInfo.oathPos > 0) {
                this._neverMarryView.setVisible(false);
                this._everMarryView.setVisible(true);
                this._oathApplyBtn.setVisible(false);
                this._applyBtnLabel.setVisible(false);
                this._breakBtn.setVisible(true)
            } else {
                this._neverMarryView.setVisible(false);
                this._everMarryView.setVisible(true);
                this._oathApplyBtn.setVisible(true);
                this._applyBtnLabel.setVisible(true);
                this._breakBtn.setVisible(false)
            }
            this._maxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(this._type, ____655.marryOathInfo.oathType);
            this._xinWuTempInfo = ____655.allTemplates.marryOathTemplateList.____55(this._type, ____655.marryOathInfo.oathType);
            this._xinWuIcon.setVisible(true);
            this._xinWuIconPath = ____654.____675.____139("outPic/" + this._xinWuTempInfo.iconPath);
            ____654.____677.____146(this._xinWuIcon, this._xinWuIconPath);
            this._xinWuNameLabel.setString(this._xinWuTempInfo.name);
            this._levelLabel.setString("Lv." + ____655.marryOathInfo.oathLevel);
            if (____655.allTemplates.marryOathTemplateList.isCanAdvance(this._type, ____655.marryOathInfo.oathType)) {
                ____654.____674.setKYBtnEnabled(this._stageUpBtn, true, 1);
                if (____655.marryOathInfo.oathLevel >= this._maxLevel) {
                    this._tipsLabel.setVisible(true);
                    this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("OathPanel.text3"))
                } else {
                    this._tipsLabel.setVisible(false)
                }
            } else {
                this._stageUpBtn.setVisible(false);
                this._stageUpBtnLabel.setVisible(false);
                if (____655.marryOathInfo.oathLevel >= this._maxLevel) {
                    this._tipsLabel.setVisible(true);
                    this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text6"))
                } else {
                    this._tipsLabel.setVisible(false)
                }
            }
            this.setBrotherInfo();
            this.setMaterialView()
        }
        this.setPropertyView()
    },
    setBrotherInfo: function() {
        var brotherInfoList = ____655.marryOathInfo.oathBrotherList;
        for (var i = 0; i < 3; i++) {
            if (____655.marryOathInfo.oathPos > 0) {
                var info = brotherInfoList[i + 1];
                if (info != null) {
                    this._broNameLabelList[i].setString(info.nick);
                    this._borTypeLabelList[i].setString(info.brotherTitle + "：")
                } else {
                    this._borTypeLabelList[i].setString(____655.marryOathInfo.getBrotherTitle(1, i + 1) + "：");
                    this._broNameLabelList[i].setString(____654.yuyanbaoManager.getYuyanbao("common.tips1"))
                }
            } else {
                this._borTypeLabelList[i].setString("");
                this._broNameLabelList[i].setString("")
            }
        }
    },
    setMaterialView: function() {
        var maxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(this._type);
        if (____655.marryOathInfo.oathLevel >= maxLevel) {
            this._grid.setCount(-1);
            ____654.____674.setKYBtnEnabled(this._strengthBtn, false, 1)
        } else {
            var needCount = ____655.allTemplates.hunPoTemplateList.getXinWuNeedCount(this._type, ____655.marryOathInfo.oathLevel + 1);
            var hasCount = ____655.itemInfoList.getCountByTempId(this._needItemId);
            this._grid.setNeedCount(hasCount, needCount);
            if (hasCount >= needCount && ____655.marryOathInfo.oathLevel < this._maxLevel) {
                ____654.____674.setKYBtnEnabled(this._strengthBtn, true, 1)
            } else {
                ____654.____674.setKYBtnEnabled(this._strengthBtn, false, 1)
            }
        }
    },
    setPropertyView: function() {
        if (____655.marryOathInfo.oathType <= 0) {
            var bestTempInfo = ____655.allTemplates.marryOathTemplateList.getBestTempInfo(this._type);
            var proValueList = bestTempInfo.attList;
            for (var i = 0; i < this.____1566.length; i++) {
                var propertyId = this.____1566[i];
                this._plusValueLabelList[i].setString("");
                this._proValueLabelList[i].setString(proValueList[i].value)
            }
            if (this._addNumberUtils == null) {
                this._addNumberUtils = new AddNumberUtils(this.____995, 0)
            } else {
                this._addNumberUtils.setValue(0, true)
            }
            this.____1790.setString(____654.yuyanbaoManager.getYuyanbao("MarryPanel.text7", bestTempInfo.name))
        } else {
            var xinWuProList = this._xinWuTempInfo.attList;
            var proValueList = ____655.allTemplates.hunPoTemplateList.getXinWuTotalProperty(this._type, ____655.marryOathInfo.oathLevel);
            var plusValueList = ____655.allTemplates.hunPoTemplateList.getXinWuAddProperty(this._type, ____655.marryOathInfo.oathLevel + 1);
            var fight = 0;
            for (var i = 0; i < this.____1566.length; i++) {
                var propertyId = this.____1566[i];
                var value = xinWuProList[i].value + proValueList[propertyId];
                this._proValueLabelList[i].setString(value);
                fight += ____655.____659.propertyType.getFight(propertyId, value);
                if (plusValueList != null) {
                    this._plusValueLabelList[i].setString("+" + plusValueList[propertyId])
                } else {
                    this._plusValueLabelList[i].setString("")
                }
            }
            if (this._addNumberUtils == null) {
                this._addNumberUtils = new AddNumberUtils(this.____995, fight)
            } else {
                this._addNumberUtils.setValue(fight, true)
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._stageUpBtn) {
                this._controller.showOathXinWuAdvancePanel()
            } else if (sender == this._oathApplyBtn) {
                this._controller.showOathApplyPanel()
            } else if (sender == this._breakBtn) {
                var str = ____654.____682.____108(10099);
                ____655.getAlert().show(2, str, null, 0, this, this.okClick)
            } else if (sender == this._strengthBtn) {
                if (this._upBtnCanClick) {
                    ____654.marryOathMessageSender.sendAdvanceXinWu(2);
                    this._upBtnCanClick = false
                } else {
                    print("---协议没返回,不能点---")
                }
            }
        }
    },
    okClick: function() {
        if (____655.____667.moneyInfo.money2Enough(this._breakMoney)) {
            ____654.marryOathMessageSender.sendBreakOath()
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(3)
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this._xinWuIconPath != null) {
            ____654.____677.removeImageQuote(this._xinWuIconPath, this._xinWuIcon);
            this._xinWuIconPath = null
        }
        this._xinWuIcon = null;
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this._strengthBtn = null;
        this._breakBtn = null;
        this._oathApplyBtn = null;
        this._applyBtnLabel = null;
        this._everMarryView = null;
        this._levelLabel = null;
        this._stageUpBtn = null;
        this._tipsLabel = null;
        this._broNameLabelList = null;
        this._borTypeLabelList = null;
        this._neverMarryView = null;
        this._proValueLabelList = null;
        this._proNameLabelList = null;
        this._plusValueLabelList = null;
        this._xinWuNameLabel = null;
        this.____995 = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this.____1790 = null;
        this._type = null;
        this._maxLevel = null;
        this._needItemId = null;
        this.____1566 = null;
        this._xinWuTempInfo = null;
        this._upBtnCanClick = null;
        this._breakMoney = null;
        this._super()
    },
});
var OathXinWuAdvancePanel = KYPanel.extend({
    _closeBtn: null,
    _sayNoBtn: null,
    ____819: null,
    ____1544: null,
    _fightLabel1: null,
    _fightLabel2: null,
    _desFightLabel1: null,
    _xinWuIcon1: null,
    _xinWuIconPath1: null,
    _xinWuIcon2: null,
    _xinWuIconPath2: null,
    _desFightLabel2: null,
    _levelLabel1: null,
    _levelLabel2: null,
    _price: 0,
    ____1076: null,
    _nextTempInfo: null,
    ctor: function() {
        this._super("oathXinWuUpPanel.ExportJson");
        this._closeBtn = this.getChildByName("closeBtn");
        this._sayNoBtn = this.getChildByName("sayNoBtn");
        this.____819 = this.getChildByName("acceptBtn");
        this.____1544 = this.getChildByName("priceLabel");
        this._fightLabel1 = this.getChildByName("fightLabel1");
        this._fightLabel2 = this.getChildByName("fightLabel2");
        this._desFightLabel1 = this.getChildByName("desFightLabel1");
        this._desFightLabel2 = this.getChildByName("desFightLabel2");
        this._xinWuIcon1 = this.getChildByName("xinWuIcon1");
        this._xinWuIconPath1 = null;
        this._xinWuIcon2 = this.getChildByName("xinWuIcon2");
        this._xinWuIconPath2 = null;
        this._levelLabel1 = this.getChildByName("levelLabel1");
        this._levelLabel2 = this.getChildByName("levelLabel2");
        this.getChildByName("desLabel1").setString(____654.yuyanbaoManager.getYuyanbao("OathXinWuAdvancePanel.text1"));
        this.getChildByName("btnLabel1").setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips4"));
        this.getChildByName("btnLabel2").setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips3"));
        this.getChildByName("xinWuPriceLabel1").setString(____654.yuyanbaoManager.getYuyanbao("MarryRingAdvancePanel.text2"));
        this.getChildByName("xinWuPriceLabel2").setString(____654.yuyanbaoManager.getYuyanbao("MarryRingAdvancePanel.text2"));
        this.getChildByName("titleLabel").setString(____654.yuyanbaoManager.getYuyanbao("MarryRingAdvancePanel.text3"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this._sayNoBtn.addListener(this, this.____16);
        this.____819.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____5: function() {
        this.____1076 = ____655.allTemplates.marryOathTemplateList.____55(____655.____659.commonStaticType.sheJiao_oath, ____655.marryOathInfo.oathType);
        this._nextTempInfo = ____655.allTemplates.marryOathTemplateList.____55(____655.____659.commonStaticType.sheJiao_oath, ____655.marryOathInfo.oathType + 1);
        if (this._nextTempInfo == null) return;
        this._price = Math.ceil((this._nextTempInfo.fee - this.____1076.fee) / 3);
        this.____1544.setString(this._price);
        this._xinWuIconPath1 = ____654.____675.____139("outPic/" + this.____1076.iconPath);
        ____654.____677.____146(this._xinWuIcon1, this._xinWuIconPath1);
        this._desFightLabel1.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", this.____1076.name));
        this._fightLabel1.setString(this.____1076.getFight());
        this._xinWuIconPath2 = ____654.____675.____139("outPic/" + this._nextTempInfo.iconPath);
        ____654.____677.____146(this._xinWuIcon2, this._xinWuIconPath2);
        this._desFightLabel2.setString(____654.yuyanbaoManager.getYuyanbao("MarryAcceptPanel.text1", this._nextTempInfo.name));
        this._fightLabel2.setString(this._nextTempInfo.getFight());
        var curMaxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(____655.____659.commonStaticType.sheJiao_oath, this.____1076.id);
        this._levelLabel1.setString("Lv." + curMaxLevel);
        var nextMaxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(____655.____659.commonStaticType.sheJiao_oath, this._nextTempInfo.id);
        this._levelLabel2.setString("Lv." + nextMaxLevel)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._sayNoBtn) {
                this.dispose()
            } else if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____819) {
                if (____655.____667.moneyInfo.money0Enough(this._price)) {
                    ____654.marryOathMessageSender.sendAdvanceXinWu(1)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
                this.dispose()
            }
        }
    },
    dispose: function() {
        this.____17();
        this._closeBtn = null;
        this._sayNoBtn = null;
        this.____819 = null;
        this.____1544 = null;
        this._fightLabel1 = null;
        this._fightLabel2 = null;
        this._desFightLabel1 = null;
        if (this._xinWuIconPath1 != null) {
            ____654.____677.removeImageQuote(this._xinWuIconPath1, this._xinWuIcon1);
            this._xinWuIconPath1 = null
        }
        this._xinWuIcon1 = null;
        if (this._xinWuIconPath2 != null) {
            ____654.____677.removeImageQuote(this._xinWuIconPath2, this._xinWuIcon2);
            this._xinWuIconPath2 = null
        }
        this._xinWuIcon2 = null;
        this._desFightLabel2 = null;
        this._levelLabel1 = null;
        this._levelLabel2 = null;
        this._price = null;
        this.____1076 = null;
        this._nextTempInfo = null;
        this._super()
    },
});
var MarryOathController = cc.Class.extend({
    module: null,
    ctor: function(marryOathModule) {
        this.module = marryOathModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showMarryPanel: function(type) {
        if (this.module.marryPanel == null) {
            this.module.marryPanel = new MarryPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.module.marryPanel, type)
    },
    showMarryApplyPanel: function() {
        if (this.module.marryApplyPanel == null) {
            this.module.marryApplyPanel = new MarryApplyPanel(this)
        }
        ____654.____676.____125(this.module.marryApplyPanel)
    },
    showMarryFreindListPanel: function(type, pos) {
        if (this.module.marryFriendPanel == null) {
            this.module.marryFriendPanel = new MarryFriendListPanel(this, type, pos)
        }
        ____654.____676.____125(this.module.marryFriendPanel)
    },
    showMarryAcceptPanel: function(info) {
        if (this.module.marryAcceptPanel == null) {
            this.module.marryAcceptPanel = new MarryAcceptPanel(this, info)
        }
        ____654.____676.____125(this.module.marryAcceptPanel)
    },
    showMarryRingAdvancePanel: function() {
        if (this.module.marryRingAdvancePanel == null) {
            this.module.marryRingAdvancePanel = new MarryRingAdvancePanel(this)
        }
        ____654.____676.____125(this.module.marryRingAdvancePanel)
    },
    showOathPanel: function(type) {
        if (this.module.oathPanel == null) {
            this.module.oathPanel = new OathPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.module.oathPanel, type)
    },
    showOathApplyPanel: function() {
        if (this.module.oathApplyPanel == null) {
            this.module.oathApplyPanel = new OathApplyPanel(this)
        }
        ____654.____676.____125(this.module.oathApplyPanel)
    },
    showOathAcceptPanel: function(info) {
        if (this.module.oathAcceptPanel == null) {
            this.module.oathAcceptPanel = new OathAcceptPanel(this, info)
        }
        ____654.____676.____125(this.module.oathAcceptPanel)
    },
    showOathXinWuAdvancePanel: function() {
        if (this.module.oathXinWuAdvancePanel == null) {
            this.module.oathXinWuAdvancePanel = new OathXinWuAdvancePanel(this)
        }
        ____654.____676.____125(this.module.oathXinWuAdvancePanel)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.module.marryPanel) {
            this.module.marryPanel = null
        } else if (p == this.module.marryApplyPanel) {
            this.module.marryApplyPanel = null
        } else if (p == this.module.marryAcceptPanel) {
            this.module.marryAcceptPanel = null
        } else if (p == this.module.marryRingAdvancePanel) {
            this.module.marryRingAdvancePanel = null
        } else if (p == this.module.marryFriendPanel) {
            this.module.marryFriendPanel = null
        } else if (p == this.module.oathPanel) {
            this.module.oathPanel = null
        } else if (p == this.module.oathApplyPanel) {
            this.module.oathApplyPanel = null
        } else if (p == this.module.oathAcceptPanel) {
            this.module.oathAcceptPanel = null
        } else if (p == this.module.oathXinWuAdvancePanel) {
            this.module.oathXinWuAdvancePanel = null
        }
    },
});
var MarryOathModule = ____537.extend({
    marryController: null,
    marryPanel: null,
    marryApplyPanel: null,
    marryAcceptPanel: null,
    marryFriendPanel: null,
    marryRingAdvancePanel: null,
    oathPanel: null,
    oathApplyPanel: null,
    oathAcceptPanel: null,
    oathXinWuAdvancePanel: null,
    setup: function(data) {
        this.marryOathController = new MarryOathController(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.sheJiao_xianYuan) {
            this.marryOathController.showMarryPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.sheJiao_jieYi) {
            this.marryOathController.showOathPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.sheJiao_marryAccept) {
            this.marryOathController.showMarryAcceptPanel(data[1])
        } else if (data[0] == ____655.____659.panelTabType.sheJiao_oathAccept) {
            this.marryOathController.showOathAcceptPanel(data[1])
        }
    },
    clear: function() {},
});
var ActiveItemView = KYNode.extend({
    info: null,
    _timeLabel: null,
    ____1722: null,
    bg: null,
    imgIcon: null,
    ctor: function(info) {
        this._super("activityItem.ExportJson");
        this.info = info;
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1722 = this.getChildByName("stateLabel");
        this.bg = this.getChildByName("bg");
        this.imgIcon = this.getChildByName("imgIcon");
        this.____5()
    },
    ____5: function() {
        this.imgIcon.setFrame("activity/" + this.info.path + ".png");
        var startTime = ____655.____662.secondsToDateString3(this.info.startTime);
        var endTime = ____655.____662.secondsToDateString3(this.info.endTime);
        this._timeLabel.setString("时间：" + startTime + "-" + endTime);
        var nowTime = ____655.____662.getZeroPassTime();
        if (this.info.level <= ____655.____667.level) {
            if (nowTime < this.info.startTime) {
                this.____1722.setString("未开启");
                this.____1722.setColor(____655.____659.____688.yellow)
            } else if (this.info.startTime <= nowTime && nowTime <= this.info.endTime) {
                this.____1722.setString("进行中");
                this.____1722.setColor(____655.____659.____688.lightGreen)
            } else if (nowTime > this.info.endTime) {
                this.____1722.setString("已结束")
            }
        } else {
            this.____1722.setString(this.info.level + "级可参与");
            this.____1722.setColor(____655.____659.____688.red)
        }
    },
    ____239: function(flag) {
        if (flag) {
            this.bg.setFrame("board/ui_board8.png")
        } else {
            this.bg.setFrame("board/ui_board7.png")
        }
    },
    dispose: function() {
        this.info = null;
        this._timeLabel = null;
        this.____1722 = null;
        this.bg = null;
        this.imgIcon = null;
        this._super();
        this._controller = null
    },
});
var ActivePanel = KYPanel.extend({
    _controller: null,
    _currentIndex: -1,
    ____1001: null,
    ____1200: null,
    tempInfoList: null,
    depoly: null,
    sendBtn: null,
    ____1002: null,
    ctor: function(controller) {
        this._super("activityPanel.ExportJson");
        this._controller = controller;
        this.____1001 = this.getChildByName("contentLabel");
        this.sendBtn = this.getChildByName("sendBtn_Copy0");
        this.____1200 = [];
        this.depoly = [];
        for (var i = 0; i < 8; i++) {
            var _grid = new ____2129();
            this.getChildByName("cellLayer" + (i + 1)).addChild(_grid);
            this.____1200.push(_grid)
        }
        this.____1002 = this.getChildByName("listView__1");
        this.____1002.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        ____655.allTemplates.timingActivityTemplateList.updateList();
        this.tempInfoList = ____655.allTemplates.timingActivityTemplateList.todayList;
        this.____5();
        this.____6()
    },
    ____5: function() {
        var len = this.tempInfoList.length;
        this.____1002.setFormat(1, len, ____654.____673.____160(475, 75), 0, 7, false);
        var index = this.getNextActivingActive();
        this.____225(index);
        this.____1002.jumpToPercent(index / len * 100)
    },
    jumpToItem: function(evt) {
        var id = evt.data;
        for (var i in this.tempInfoList) {
            if (this.tempInfoList[i].templateId == id) {
                this.____225(i);
                return
            }
        }
        this.____225(0)
    },
    getNextActivingActive: function() {
        var nowTime = ____655.____662.getZeroPassTime();
        for (var i in this.tempInfoList) {
            if (this.tempInfoList[i].startTime <= nowTime && nowTime <= this.tempInfoList[i].endTime) {
                return i
            }
        }
        return 0
    },
    getItemByIndex: function(index) {
        var templateInfo = this.tempInfoList[index];
        if (templateInfo == null) {
            return null
        }
        var grid = new ActiveItemView(templateInfo);
        grid.addListener(this, this.____16, null, null, null, false, true);
        if (this._currentIndex == index) {
            grid.____239(true)
        }
        return grid
    },
    getIdByIndex: function(index) {
        var itemInfo = this.tempInfoList[index];
        if (itemInfo == null) {
            return -1
        }
        return itemInfo.templateId
    },
    ____6: function() {
        this.sendBtn.addListener(this, this.btnClickHandler2);
        ____654.____672.addEventListener(____655.____661.timing_active_jumpTo, this.jumpToItem, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.timing_active_jumpTo, this.jumpToItem, this)
    },
    btnClickHandler2: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.sendBtn) {
                var info = this.tempInfoList[this._currentIndex];
                if (info == null) return;
                if (info.level <= ____655.____667.level) {
                    var nowTime = ____655.____662.getZeroPassTime();
                    if (nowTime < info.startTime) {
                        ____654.tipsManager.quickTip.show("未开启")
                    } else if (info.startTime <= nowTime && nowTime <= info.endTime) {
                        if (this.depoly.length > 0) {
                            ____654.triggerManager.handlerList(this.depoly)
                        }
                    } else if (nowTime > info.endTime) {
                        ____654.tipsManager.quickTip.show("该活动已结束")
                    }
                } else {
                    ____654.tipsManager.quickTip.show(info.level + "级可参与")
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this.tempInfoList.indexOf(sender.info);
            if (index >= 0) {
                this.____225(index)
            }
        }
    },
    ____225: function(index) {
        this.depoly = this.tempInfoList[index].triggers;
        this.____1001.setString(this.tempInfoList[index].dec);
        var goodsList = this.tempInfoList[index].award;
        for (var i = 0; i < this.____1200.length; i++) {
            if (goodsList[i] == null) {
                this.____1200[i].setItemTemplateInfo(null)
            } else {
                this.____1200[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(goodsList[i]))
            }
        }
        var oldItem = null;
        if (this._currentIndex >= 0) {
            oldItem = this.____1002.getItemByIndex(this._currentIndex)
        }
        if (oldItem != null) {
            oldItem.____239(false)
        }
        this._currentIndex = index;
        if (this._currentIndex >= 0) {
            oldItem = this.____1002.getItemByIndex(this._currentIndex)
        }
        if (oldItem != null) {
            oldItem.____239(true)
        }
    },
    dispose: function() {
        this.____17();
        this.____1002 = null;
        for (var i = 0; i < this.____1200.length; i++) {
            if (this.____1200[i] != null) {
                this.____1200[i].dispose();
                this.____1200[i] = null
            }
        }
        this.____1001 = null;
        this.depoly = null;
        this._currentIndex = null;
        this.sendBtn = null;
        this.tempInfoList = null;
        this._super();
        this._controller = null
    },
});
var LlItem2View = KYNode.extend({
    loadingBar: null,
    boxList: null,
    list: null,
    index: null,
    _selectEffect: null,
    progressLabelList: null,
    ctor: function() {
        this._super("activityPercentItem.ExportJson");
        this.loadingBar = this.getChildByName("progressBg").getChildByName("loadingBar");
        this.boxList = [];
        this.progressLabelList = [];
        this.index = 1;
        for (var i = 1; i <= 4; i++) {
            this.boxList.push(this.getChildByName("box" + i));
            this.progressLabelList.push(this.getChildByName("progressLabel" + i))
        }
        this._selectEffect = {};
        this.list = [];
        var list = ____655.allTemplates.rankAwardTemplateList.getTypeList(20);
        for (var i in list) {
            if (list[i].stage == ____655.____667.xianwei) {
                this.list.push(list[i])
            }
        }
        this.____5();
        this.____6()
    },
    ____6: function() {
        var x = this.loadingBar.getPositionX();
        var sizeX = this.loadingBar.getContentSize().width;
        var startX = x - sizeX / 2;
        for (var i = 0; i <= 3; i++) {
            this.boxList[i].addListener(this, this.____16);
            this.progressLabelList[i].setString(this.list[i].minLevel)
        }
        ____655.activityInfo.addEventListener(____655.____661.activity_awardUpdate, this.updateInfo, this)
    },
    ____17: function() {
        ____655.activityInfo.removeEventListener(____655.____661.activity_awardUpdate, this.updateInfo, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this.index = this.boxList.indexOf(sender);
            var xianwei = "";
            if (____655.____667.xianwei != 1) {
                xianwei = "(" + ____655.____659.nameType.getXianweiName(____655.____667.xianwei) + ")"
            }
            var awardList = ____655.activityInfo.awardList;
            ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [____654.yuyanbaoManager.getYuyanbao("____2201.text1", this.list[this.index].minLevel, xianwei), this.list[this.index].awardList, null, ____655.activityInfo.activity >= this.list[this.index].minLevel && !awardList[this.list[this.index].minLevel], this.acceptHandler, this]))
        }
    },
    acceptHandler: function() {
        ____654.____683.getActivityBox(this.list[this.index].minLevel)
    },
    ____5: function() {
        this.updateInfo()
    },
    updateInfo: function() {
        var todayActNum = ____655.activityInfo.activity;
        var awardList = ____655.activityInfo.awardList;
        this.loadingBar.setPercent(todayActNum / 120 * 100);
        for (var i = 0; i <= 3; i++) {
            if (awardList[this.list[i].minLevel]) {
                this.progressLabelList[i].setString("已领取");
                this.canGetEffect(false, i);
                this.progressLabelList[i].setColor(____655.____659.____688.green);
                this.boxList[i].setFrame("icon/ui_boxIcon0.png")
            } else {
                if (todayActNum >= this.list[i].minLevel) {
                    this.progressLabelList[i].setString("可领取");
                    this.canGetEffect(true, i)
                }
            }
        }
    },
    canGetEffect: function(flag, index) {
        if (flag) {
            if (this._selectEffect[index] == null) {
                this._selectEffect[index] = new RotationEffect("effect/effect_10.png", 5);
                var pos = this.boxList[index].getPosition();
                this._selectEffect[index].move(pos.x, pos.y);
                this.addChild(this._selectEffect[index], 2)
            }
        } else {
            if (this._selectEffect[index] != null) {
                this._selectEffect[index].dispose();
                this._selectEffect[index] = null
            }
        }
    },
    dispose: function() {
        this.____17();
        this.loadingBar = null;
        if (this._selectEffect != null) {
            for (var k in this._selectEffect) {
                if (this._selectEffect[k] != null) {
                    this._selectEffect[k].dispose()
                }
            }
            this._selectEffect = null
        }
        this.boxList = null;
        this.list = null;
        this._super();
        this._controller = null
    },
});
var LlItemView = KYNode.extend({
    info: null,
    isComplate: null,
    typeNameLabel: null,
    ____822: null,
    _infoLabel: null,
    sendBtn: null,
    stateLabel: null,
    ctor: function(info) {
        this._super("activityCommonItem.ExportJson");
        this.typeNameLabel = this.getChildByName("typeNameLabel");
        this.____822 = this.getChildByName("numLabel");
        this._infoLabel = this.getChildByName("infoLabel");
        this.sendBtn = this.getChildByName("sendBtn_Copy0");
        this.stateLabel = this.getChildByName("stateLabel");
        this.stateLabel.setVisible(false);
        this.info = info;
        this.____5();
        this.____6()
    },
    ____6: function() {
        this.sendBtn.addListener(this, this.btnClickHandler2);
        ____655.activityInfo.addEventListener(____655.____661.activity_infoUpdate, this.____5, this)
    },
    ____17: function() {
        ____655.activityInfo.removeEventListener(____655.____661.activity_infoUpdate, this.____5, this)
    },
    btnClickHandler2: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.sendBtn) {
                if (this.info.templateId == 18 || this.info.templateId == 19) {
                    var cost = 0;

                    function sendCell() {
                        if (____655.____667.moneyInfo.money1Enough(cost)) {
                            var type = 0;
                            if (this.info.templateId == 18) {
                                type = 3;
                            } else {
                                type = 4;
                            }
                            var taskInfo = ____655.____670.getTaskByType(type);
                            if (taskInfo == null) {
                                if (this.info.templateId == 18) {
                                    ____654.tipsManager.quickTip.show("无法完成环任务")
                                } else {
                                    ____654.tipsManager.quickTip.show("无法完成家族任务")
                                }
                            } else {
                                ____654.selfDataMessageSender.sendTaskQuick(taskInfo.taskId)
                            }
                        } else {
                            ____654.tipsManager.quickTip.show("钻石不足")
                        }
                    }
                    if (this.isComplate == null) {
                        cost = this.info.count * 2
                    } else {
                        cost = this.isComplate * 2
                    }
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2202.text1", cost) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.COPLATETASK, 0, this, sendCell, null, null)
                } else {
                    if (this.info.triggers.length > 0) {
                        ____654.triggerManager.handlerList(this.info.triggers)
                    }
                }
            }
        }
    },
    ____5: function() {
        this.isComplate = ____655.activityInfo.infoList[this.info.templateId];
        this.typeNameLabel.setString(this.info.name);
        this.____822.setString("x" + this.info.activity);
        this._infoLabel.setString(this.info.count);
        if (this.info.level > ____655.____667.level) {
            this.stateLabel.setString(this.info.level + "级开放");
            this.stateLabel.setColor(____655.____659.____688.red);
            this.sendBtn.setVisible(false);
            this.getChildByName("btnLabel").setVisible(false);
            this.stateLabel.setVisible(true)
        } else {
            if (this.isComplate != null) {
                if (this.isComplate == 0) {
                    this.sendBtn.setVisible(false);
                    this.getChildByName("btnLabel").setVisible(false);
                    this.stateLabel.setVisible(true);
                    this._infoLabel.setString(this.isComplate);
                    this.stateLabel.setColor(____655.____659.____688.green);
                    this.stateLabel.setString("已完成")
                } else {
                    this.sendBtn.setVisible(true);
                    this.getChildByName("btnLabel").setVisible(true);
                    this.stateLabel.setVisible(false);
                    this._infoLabel.setString(this.isComplate)
                }
            }
            if (this.info.templateId == 18 || this.info.templateId == 19) {
                this.getChildByName("btnLabel").setString("完 成");
                this.sendBtn.setFrame("btn/ui_btn1_3.png")
            }
        }
    },
    dispose: function() {
        this.____17();
        this.info = null;
        this.isComplate = null;
        this.typeNameLabel = null;
        this.____822 = null;
        this._infoLabel = null;
        this.sendBtn = null;
        this.stateLabel = null;
        this._super();
        this._controller = null
    },
});
var ____2203 = KYPanel.extend({
    _controller: null,
    ____1235: null,
    _bgPath: null,
    currentNum: null,
    numLabel: null,
    posIcon: null,
    listView: null,
    postionList: null,
    lilianBtn: null,
    fightValue: null,
    atrrValueList: null,
    propertyIdList: null,
    atrrNameList: null,
    plusValueList: null,
    tempInfo: null,
    totaleNumLabel: null,
    listView_2: null,
    ____1774: null,
    item_2: null,
    ____1002: null,
    _timeCount2: null,
    plusNum: null,
    _oldLevel: null,
    _addNumberUtils: null,
    ____1126: null,
    ctor: function(controller) {
        this._super("activityCommonPanel.ExportJson");
        this._controller = controller;
        this.____1235 = this.getChildByName("bg");
        this.currentNum = this.getChildByName("currentNum");
        this.numLabel = this.getChildByName("numLabel");
        this.totaleNumLabel = this.getChildByName("money2Label");
        this.listView = this.getChildByName("listView__1");
        this.____1002 = this.listView;
        this.____1002.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.posIcon = this.getChildByName("point_Icon");
        this.lilianBtn = this.getChildByName("sendBtn");
        this.fightValue = this.getChildByName("fightValue");
        this.listView_2 = this.getChildByName("listView_2");
        this.____1774 = 0;
        this._timeCount2 = 82;
        this._oldLevel = ____655.activityInfo.lilianLevel;
        this.plusNum = 2;
        this._bgPath = ____654.____675.____139("outPic/ui_lilianBg.png");
        this.postionList = [
            [221, 524],
            [319, 445],
            [359, 348],
            [221, 301],
            [89, 348],
            [127, 445]
        ];
        this.propertyIdList = [1, 2, 9, 10, 11, 12];
        this.atrrValueList = [];
        this.atrrNameList = [];
        this.plusValueList = [];
        for (var i = 0; i <= 5; i++) {
            this.atrrValueList.push(this.getChildByName("atrrValue" + (i + 1)));
            this.atrrNameList.push(this.getChildByName("atrrName" + (i + 1)));
            this.plusValueList.push(this.getChildByName("plusValue" + (i + 1)))
        }
        ____655.allTemplates.dailyActivityTemplateList.sortFunc();
        this.item_2 = new LlItem2View();
        this.listView_2.addChild(this.item_2);
        this.____5();
        this.updateBtnState()
    },
    ____5: function() {
        ____654.____678.____298(this.tick2, this);
        ____654.____677.____146(this.____1235, this._bgPath);
        this.updateView();
        this.setNumLabel();
        this.____6()
    },
    ____6: function() {
        this.lilianBtn.addListener(this, this.____16);
        ____655.activityInfo.addEventListener(____655.____661.activity_totalActivityUpdate, this.lilianLevelUpdate, this)
    },
    ____17: function() {
        ____655.activityInfo.removeEventListener(____655.____661.activity_totalActivityUpdate, this.lilianLevelUpdate, this)
    },
    lilianLevelUpdate: function() {
        this.____5();
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        ____654.____678.____298(this.tick, this);
        ____654.____674.setKYBtnEnabled(this.lilianBtn, false, 1)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.lilianBtn) {
                if (this.tempInfo != null) {
                    if (this.tempInfo.needLilian <= ____655.activityInfo.totalActivity) {
                        var num = Math.floor(____655.activityInfo.totalActivity / this.tempInfo.needLilian);
                        var maxNum = 6 - this._oldLevel % 6;
                        if (num > maxNum) {
                            num = maxNum
                        }
                        ____654.____683.sendActivityUpgrade(num)
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2203.text1"))
                    }
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2203.text2"))
                }
            }
        }
    },
    updateView: function() {
        this.updateRightPanel();
        this.updateLeftPanel()
    },
    tick: function(delta, count) {
        this.____1774 = this.____1774 + 1;
        if (this.____1774 > 18) {
            this.____1774 = 0;
            if (this._oldLevel >= ____655.activityInfo.lilianLevel) {
                ____654.____678.____299(this.tick, this);
                this.setNumLabel();
                ____654.____674.setKYBtnEnabled(this.lilianBtn, true, 1);
                this.updateBtnState()
            } else {
                this._oldLevel = this._oldLevel + 1;
                this.updateView()
            }
        }
    },
    updateBtnState: function() {
        if (____655.activityInfo.totalActivity >= this.tempInfo.needLilian) {
            if (this.____1126 == null) {
                this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(57, 28), this.lilianBtn)
            }
        } else {
            if (this.____1126 != null) {
                this.____1126.dispose();
                this.____1126 = null
            }
        }
    },
    tick2: function(delta, count) {
        if (this._timeCount2 == 80 || this._timeCount2 == 120) {
            this.plusNum = -this.plusNum
        }
        this._timeCount2 = this._timeCount2 + this.plusNum;
        this.posIcon.setScale(this._timeCount2 / 100)
    },
    getItemByIndex: function(index) {
        var itemInfo = ____655.allTemplates.dailyActivityTemplateList.____1824[index];
        if (itemInfo == null) {
            return null
        }
        var grid = new LlItemView(itemInfo);
        return grid
    },
    getIdByIndex: function(index) {
        var itemInfo = ____655.allTemplates.dailyActivityTemplateList.____1824[index];
        if (itemInfo == null) {
            return -1
        }
        return itemInfo.templateId
    },
    updateRightPanel: function() {
        var todayActNum = ____655.activityInfo.activity;
        var templatedInfo = ____655.allTemplates.dailyActivityTemplateList.____1824;
        this.currentNum.setString(todayActNum);
        this.____1002.setFormat(1, templatedInfo.length, ____654.____673.____160(435, 80), 0, 7, true);
        this.item_2.updateInfo()
    },
    updateLeftPanel: function() {
        var totalActNum = ____655.activityInfo.totalActivity;
        this.totaleNumLabel.setString(totalActNum);
        var lilianLevel = this._oldLevel;
        var currentAtts = ____655.allTemplates.lilianTemplateList.getTotalPropertyByLevel(lilianLevel);
        this.tempInfo = ____655.allTemplates.lilianTemplateList.getInfoByLevel(lilianLevel);
        var nextAddProperty = ____655.allTemplates.lilianTemplateList.getAddPropertyByLevel(lilianLevel + 1);
        var postion = lilianLevel % 6;
        this.posIcon.setPosition(____654.____673.____159(this.postionList[postion][0], this.postionList[postion][1]));
        var fightNum = 0;
        for (var i = 0; i <= 5; i++) {
            this.atrrValueList[i].setString(currentAtts[i]);
            this.atrrNameList[i].setString(____655.____659.propertyType.getNameByType(this.propertyIdList[i]) + " :");
            fightNum = fightNum + ____655.____659.propertyType.getFight(this.propertyIdList[i], currentAtts[i]);
            if (postion == i) {
                this.plusValueList[i].setVisible(true);
                this.plusValueList[i].setString("+" + nextAddProperty)
            } else {
                this.plusValueList[i].setVisible(false)
            }
        }
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.fightValue, fightNum)
        } else {
            this._addNumberUtils.setValue(fightNum)
        }
    },
    setNumLabel: function() {
        if (this.tempInfo == null) {
            this.numLabel.setVisible(false)
        } else {
            var num = Math.floor(____655.activityInfo.totalActivity / this.tempInfo.needLilian);
            var maxNum = 6 - this._oldLevel % 6;
            if (num > maxNum) {
                num = maxNum
            }
            if (num > 0) {
                this.numLabel.setString(this.tempInfo.needLilian + " x" + num + "次")
            } else {
                this.numLabel.setString(this.tempInfo.needLilian)
            }
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        ____654.____678.____299(this.tick2, this);
        this.____17();
        ____654.____677.removeImageQuote(this.____1235, this._bgPath);
        this.____1235 = null;
        this._bgPath = null;
        this.currentNum = null;
        this.numLabel = null;
        this.posIcon = null;
        this.____1002 = null;
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this.listView = null;
        this.plusNum = null;
        this.postionList = null;
        this.lilianBtn = null;
        this.fightValue = null;
        this.atrrValueList = null;
        this.propertyIdList = null;
        this.atrrNameList = null;
        this.plusValueList = null;
        this.tempInfo = null;
        this.totaleNumLabel = null;
        this.listView_2 = null;
        this.____1774 = null;
        this._timeCount2 = null;
        if (this.item_2 != null) {
            this.item_2.dispose();
            this.item_2 = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._super();
        this._controller = null
    },
});
var ____2197 = cc.Class.extend({
    llModule: null,
    ctor: function(module) {
        this.llModule = module;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showLlPanel: function(type) {
        if (this.llModule.llPanel == null) {
            this.llModule.llPanel = new ____2203(this)
        }
        ____654.____676.uiPanelContainer.____125(this.llModule.llPanel, type)
    },
    showActivePanel: function(type) {
        if (this.llModule.activePanel == null) {
            this.llModule.activePanel = new ActivePanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.llModule.activePanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.llModule.llPanel) {
            this.llModule.llPanel = null
        }
        if (p == this.llModule.activePanel) {
            this.llModule.activePanel = null
        }
    },
});
var ____2198 = ____537.extend({
    llController: null,
    llPanel: null,
    activePanel: null,
    setup: function(data) {
        this.llController = new ____2197(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.ll) {
            this.llController.showLlPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.active) {
            this.llController.showActivePanel(data[0])
        }
    },
    clear: function() {},
});
var LoginGiftItem1 = KYNode.extend({
    _cell: null,
    _daysLabel: null,
    _grid: null,
    ____1185: null,
    ____1186: null,
    ____1722: 0,
    _info: null,
    ____1165: 0,
    _getImg: null,
    ____1126: null,
    ctor: function() {
        this._super("loginGiftItem1.ExportJson");
        this._cell = this.getChildByName("cell");
        this._grid = new ____2129();
        this._cell.addChild(this._grid);
        this._daysLabel = this.getChildByName("daysLabel");
        this.____1185 = this.getChildByName("OKBtn");
        this.____1186 = this.getChildByName("btnLabel");
        this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn2"));
        this.____1722 = this.getChildByName("stateLabel");
        this.____1722.setString("");
        this._getImg = this.getChildByName("getImg");
        this._getImg.setVisible(false);
        this.____6()
    },
    ____18: function(index, info) {
        if (info == null) return;
        this._info = info;
        var itemTemplateInfo = ____655.allTemplates.____794.getItem(info.awardList[0][0]);
        this._grid.setItemTemplateInfo(itemTemplateInfo);
        this._grid.setCount(info.awardList[0][1]);
        this._daysLabel.setString(____654.yuyanbaoManager.getYuyanbao("LoginGiftPanel.text1", index));
        var loginGiftAwardList = ____655.openInfo.loginGiftAwardList;
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        if (loginGiftAwardList.length > 0) {
            if (loginGiftAwardList.indexOf(index) != -1) {
                this.____1185.setVisible(false);
                this.____1186.setVisible(false);
                this._getImg.setVisible(true);
                this.____1722.setString("")
            } else {
                if (index < openDay) {
                    ____654.____674.setKYBtnEnabled(this.____1185, true, 2);
                    this.____1186.setVisible(true);
                    this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip2"));
                    this.____1722.setString("");
                    this.____1165 = 1;
                    if (this.____1126 != null) {
                        this.____1126.dispose();
                        this.____1126 = null
                    }
                } else if (index == openDay) {
                    ____654.____674.setKYBtnEnabled(this.____1185, true, 1);
                    this.____1186.setVisible(true);
                    this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn2"));
                    this.____1165 = 2;
                    if (this.____1126 == null) {
                        this.____1126 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                        this.____1126.move(38, 22);
                        this.____1126.setScaleX(0.65);
                        this.____1126.setScaleY(0.8);
                        this.____1126.play();
                        this.____1126.addTo(this.____1185, 1)
                    }
                } else if (index > openDay) {
                    this.____1185.setVisible(false);
                    this.____1186.setVisible(false);
                    this.____1722.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip3"));
                    this.____1722.setColor(____655.____659.____688.itemColorList[0]);
                    if (this.____1126 != null) {
                        this.____1126.dispose();
                        this.____1126 = null
                    }
                }
            }
        } else {
            if (index < openDay) {
                ____654.____674.setKYBtnEnabled(this.____1185, true, 2);
                this.____1186.setVisible(true);
                this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip2"));
                this.____1722.setString("");
                this.____1165 = 1;
                if (this.____1126 != null) {
                    this.____1126.dispose();
                    this.____1126 = null
                }
            } else if (index == openDay) {
                ____654.____674.setKYBtnEnabled(this.____1185, true, 1);
                this.____1186.setVisible(true);
                this.____1186.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn2"));
                this.____1165 = 2;
                if (this.____1126 == null) {
                    this.____1126 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                    this.____1126.play();
                    this.____1126.move(38, 22);
                    this.____1126.setScaleX(0.65);
                    this.____1126.setScaleY(0.8);
                    this.____1126.addTo(this.____1185, 1)
                }
            } else if (index > openDay) {
                this.____1185.setVisible(false);
                this.____1186.setVisible(false);
                this.____1722.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip3"));
                this.____1722.setColor(____655.____659.____688.itemColorList[0]);
                if (this.____1126 != null) {
                    this.____1126.dispose();
                    this.____1126 = null
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            function okClick() {
                if (____655.____667.moneyInfo.money1Enough(20)) {
                    ____654.selfDataMessageSender.sendLoginGiftGetAward(this._info.id)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
            }
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1185) {
                if (this.____1165 == 1) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("LoginGiftPanel.text2") + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, okClick, null, null)
                } else if (this.____1165 == 2) {
                    ____654.selfDataMessageSender.sendLoginGiftGetAward(this._info.id)
                }
            }
        }
    },
    ____6: function() {
        this.____1185.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._cell = null;
        this.____1344 = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._nameLabel = null;
        this.____1016 = null;
        this.____1017 = null;
        this._oriPrice = null;
        this._price = null;
        this.____1185 = null;
        this.____1186 = null;
        this._outFlag = null;
        this._limitInfo = null;
        this._info = null;
        this._count = null;
        this._getImg = null;
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._super()
    },
});
var LoginGiftItem2 = KYNode.extend({
    ____937: null,
    _gridList: null,
    _daysLabel: null,
    ____1480: null,
    ____1482: null,
    ____1722: 0,
    _info: null,
    _riderBg: null,
    _riderBgPath: null,
    _riderLayer: null,
    ____944: null,
    _characterInfo: null,
    _getImg: null,
    ____1126: null,
    ctor: function() {
        this._super("loginGiftItem2.ExportJson");
        this.____937 = [];
        this._gridList = [];
        for (var i = 0; i < 3; i++) {
            this.____937.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            this.____937[i].addChild(grid);
            this._gridList.push(grid)
        }
        this._daysLabel = this.getChildByName("daysLabel");
        this.____1480 = this.getChildByName("OKBtn");
        this.____1482 = this.getChildByName("btnLabel");
        this.____1482.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn2"));
        this.____1722 = this.getChildByName("stateLabel");
        this.____1722.setString("");
        this._getImg = this.getChildByName("getImg");
        this._getImg.setVisible(false);
        this._riderBg = this.getChildByName("riderBg");
        this._riderBgPath = ____654.____675.____139("outPic/loginGiftCharacterBg.png");
        ____654.____677.____146(this._riderBg, this._riderBgPath);
        this._riderLayer = this.getChildByName("riderLayer");
        this.____6();
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        var styleList = {};
        styleList[____655.____659.commonStaticType.style_Horse] = 3012;
        this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Horse, ____655.____659.____687.playerStand2);
        this._characterInfo.updateStyle(styleList);
        this.____944 = new ____545(this._characterInfo);
        this.____944.init(____655.____659.____686.rightBottom, this._riderLayer);
        this.____944.move(56, 0)
    },
    ____18: function(index, info) {
        if (info == null) return;
        this._info = info;
        var len = info.awardList.length;
        if (len > 3) len = 3;
        for (var i = 0; i < len; i++) {
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(info.awardList[i][0]);
            this._gridList[i].setItemTemplateInfo(itemTemplateInfo);
            this._gridList[i].setCount(info.awardList[i][1])
        }
        this._daysLabel.setString(____654.yuyanbaoManager.getYuyanbao("LoginGiftPanel.text1", 7));
        var loginGiftAwardList = ____655.openInfo.loginGiftAwardList;
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        if (loginGiftAwardList.length > 0) {
            if (loginGiftAwardList.indexOf(index) != -1) {
                this.____1480.setVisible(false);
                this.____1482.setVisible(false);
                this._getImg.setVisible(true);
                this.____1722.setString("")
            } else {
                if (index < openDay) {
                    ____654.____674.setKYBtnEnabled(this.____1480, true, 2);
                    this.____1482.setVisible(true);
                    this.____1482.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip2"));
                    this.____1722.setString("");
                    this.____1165 = 1;
                    if (this.____1126 != null) {
                        this.____1126.dispose();
                        this.____1126 = null
                    }
                } else if (index == openDay) {
                    ____654.____674.setKYBtnEnabled(this.____1480, true, 1);
                    this.____1482.setVisible(true);
                    this.____1482.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn2"));
                    this.____1165 = 2;
                    if (this.____1126 == null) {
                        this.____1126 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                        this.____1126.play();
                        this.____1126.move(60, 27);
                        this.____1126.addTo(this.____1480, 1)
                    }
                } else if (index > openDay) {
                    this.____1480.setVisible(false);
                    this.____1482.setVisible(false);
                    this.____1722.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip3"));
                    this.____1722.setColor(____655.____659.____688.itemColorList[0]);
                    if (this.____1126 != null) {
                        this.____1126.dispose();
                        this.____1126 = null
                    }
                }
            }
        } else {
            if (index < openDay) {
                ____654.____674.setKYBtnEnabled(this.____1480, true, 2);
                this.____1482.setVisible(true);
                this.____1482.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip2"));
                this.____1722.setString("");
                this.____1165 = 1;
                if (this.____1126 != null) {
                    this.____1126.dispose();
                    this.____1126 = null
                }
            } else if (index == openDay) {
                ____654.____674.setKYBtnEnabled(this.____1480, true, 1);
                this.____1482.setVisible(true);
                this.____1482.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn2"));
                this.____1165 = 2;
                if (this.____1126 == null) {
                    this.____1126 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                    this.____1126.play();
                    this.____1126.move(60, 27);
                    this.____1126.addTo(this.____1480, 1)
                }
            } else if (index > openDay) {
                this.____1480.setVisible(false);
                this.____1482.setVisible(false);
                this.____1722.setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip3"));
                this.____1722.setColor(____655.____659.____688.itemColorList[0]);
                if (this.____1126 != null) {
                    this.____1126.dispose();
                    this.____1126 = null
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1480) {
                function okClick() {
                    if (____655.____667.moneyInfo.money1Enough(20)) {
                        ____654.selfDataMessageSender.sendLoginGiftGetAward(this._info.id)
                    } else {
                        ____655.____667.moneyInfo.showNotEnoughTip(1)
                    }
                }
                if (this.____1165 == 1) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("LoginGiftPanel.text2") + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, okClick, null, null)
                } else if (this.____1165 == 2) {
                    ____654.selfDataMessageSender.sendLoginGiftGetAward(this._info.id)
                }
            }
        }
    },
    ____6: function() {
        this.____1480.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        if (this._riderBgPath != null) {
            ____654.____677.removeImageQuote(this._riderBgPath, this._riderBg);
            this._riderBgPath = null
        }
        this._riderBg = null;
        this.____937 = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        this._daysLabel = null;
        this.____1480 = null;
        this.____1482 = null;
        this.____1722 = null;
        this._info = null;
        this._riderLayer = null;
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._getImg = null;
        this._super()
    },
});
var LoginGiftPanel = KYPanel.extend({
    _controller: null,
    ____862: null,
    _barBgPath: null,
    _content1: null,
    ____1285: null,
    ____1840: null,
    ____1251: null,
    _timeLabel: null,
    _item1: null,
    _moneyView: null,
    ctor: function(controller) {
        this._super("loginGiftPanel.ExportJson");
        this._controller = controller;
        this.____862 = this.getChildByName("barBg");
        this._barBgPath = ____654.____675.____139("outPic/commonBarBg.png");
        ____654.____677.____146(this.____862, this._barBgPath);
        this._content1 = this.getChildByName("content1");
        this._content1.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text1"));
        this.____1285 = this.getChildByName("itemLayer");
        this._timeLabel = this.getChildByName("timeLabel");
        this._timeLabel.setString("00:00:00");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this.____1840 = [];
        this.____1251 = [];
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.setCountDownTime();
        this.____1251 = ____655.allTemplates.openActivityTemplateList.loginGiftList;
        for (var i = 0; i < 6; i++) {
            var item = new LoginGiftItem1();
            item.____18((i + 1), this.____1251[i]);
            item.setPosition(4 + (i % 3) * 212, 5 + 228 - Math.floor(i / 3) * 228);
            this.____1285.addChild(item);
            this.____1840.push(item)
        }
        this._item1 = new LoginGiftItem2();
        this._item1.____18(7, this.____1251[6]);
        this.____1285.addChild(this._item1);
        this._item1.setPosition(644, 5)
    },
    setCountDownTime: function() {
        var lastRevertTime = 0;
        lastRevertTime = (7 * ____655.____662.secondsOfDay) + ____655.____665 - ____655.____662.getSystemTimeSec();
        this._countDownUtils.start(lastRevertTime)
    },
    updateView: function() {
        for (var i = 0; i < 6; i++) {
            this.____1840[i].____18((i + 1), this.____1251[i])
        }
        this._item1.____18(7, this.____1251[6])
    },
    ____6: function() {
        ____655.openInfo.addEventListener(____655.____661.playerInfo_openTemplate, this.closePanel, this);
        ____655.openInfo.addEventListener(____655.____661.playerInfo_loginGiftInfo_Update, this.updateView, this)
    },
    ____17: function() {
        ____655.openInfo.removeEventListener(____655.____661.playerInfo_openTemplate, this.closePanel, this);
        ____655.openInfo.removeEventListener(____655.____661.playerInfo_loginGiftInfo_Update, this.updateView, this)
    },
    closePanel: function() {
        ____654.____676.uiPanelContainer.close()
    },
    dispose: function() {
        this.____17();
        if (this._barBgPath != null) {
            ____654.____677.removeImageQuote(this._barBgPath, this.____862);
            this._barBgPath = null
        }
        this.____862 = null;
        this._controller = null;
        this._timeLabel = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this.____1251 = null;
        if (this.____1840 != null) {
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = null
        }
        if (this._item1 != null) {
            this._item1.dispose();
            this._item1 = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this._super()
    },
});
var LoginGiftController = cc.Class.extend({
    loginGiftModule: null,
    ctor: function(module) {
        this.loginGiftModule = module;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showLoginGiftPanel: function(type) {
        if (this.loginGiftModule.loginGiftPanel == null) {
            this.loginGiftModule.loginGiftPanel = new LoginGiftPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.loginGiftModule.loginGiftPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.loginGiftModule.loginGiftPanel) {
            this.loginGiftModule.loginGiftPanel = null
        }
    },
});
var LoginGiftModule = ____537.extend({
    loginGiftController: null,
    loginGiftPanel: null,
    setup: function(data) {
        this.loginGiftController = new LoginGiftController(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.loginGift) {
            this.loginGiftController.showLoginGiftPanel(data[0])
        }
    },
    clear: function() {},
});
var LookCompareItem = KYNode.extend({
    _imgIcon: null,
    _nameLabel: null,
    _numLabel1: null,
    _numLabel2: null,
    ____1266: true,
    ctor: function() {
        this._super("lookCompareItem.ExportJson");
        this._imgIcon = this.getChildByName("imgIcon");
        this._nameLabel = this.getChildByName("name");
        this._numLabel1 = this.getChildByName("num1");
        this._numLabel2 = this.getChildByName("num2")
    },
    ____18: function(name, num1, num2) {
        this._nameLabel.setString(name);
        this._numLabel1.setString(num1);
        var offset = num2 - num1;
        if (offset >= 0) {
            this._numLabel2.setString("+" + offset.toString());
            this._numLabel2.setColor(____655.____659.____688.lightGreen)
        } else {
            this._numLabel2.setString(offset);
            this._numLabel2.setColor(____655.____659.____688.red)
        }
    },
    setFold: function(value) {
        if (this.____1266 == value) {
            return
        }
        this.____1266 = value;
        if (this.____1266) {
            this._imgIcon.setScaleY(1)
        } else {
            this._imgIcon.setScaleY(-1)
        }
    },
    getFold: function() {
        return this.____1266
    },
    dispose: function() {
        this._imgIcon = null;
        this._nameLabel = null;
        this._numLabel1 = null;
        this._numLabel2 = null;
        this._super()
    },
});
var LookCompareItem2 = KYNode.extend({
    _nameLabel: null,
    _numLabel1: null,
    _numLabel2: null,
    ctor: function() {
        this._super("lookCompareItem2.ExportJson");
        this._nameLabel = this.getChildByName("name_Copy0");
        this._numLabel1 = this.getChildByName("num1_Copy0");
        this._numLabel2 = this.getChildByName("num2_Copy0")
    },
    ____18: function(name, num1, num2) {
        this._nameLabel.setString(name);
        this._numLabel1.setString(num1);
        var offset = num2 - num1;
        if (offset >= 0) {
            this._numLabel2.setString("+" + offset.toString());
            this._numLabel2.setColor(____655.____659.____688.lightGreen)
        } else {
            this._numLabel2.setString(offset);
            this._numLabel2.setColor(____655.____659.____688.red)
        }
    },
    dispose: function() {
        this._nameLabel = null;
        this._numLabel1 = null;
        this._numLabel2 = null;
        this._super()
    },
});
var LookFashionItem = KYNode.extend({
    _bg: null,
    ____1707: null,
    _nameLabel: null,
    ____995: null,
    _noGetImg: null,
    _imgMestry: null,
    ____1674: null,
    _waitLabel: null,
    ____1752: null,
    _bgPath: null,
    _imgMestryPath: null,
    ____1716: null,
    ____944: null,
    _characterInfo: null,
    _type: null,
    _labFightLabel: null,
    ctor: function() {
        this._super("lookFantacyClothItem.ExportJson");
        this._bg = this.getChildByName("imgBg");
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._nameLabel = this.getChildByName("labName");
        this.____995 = this.getChildByName("combatNum");
        this._noGetImg = this.getChildByName("imgNoGet");
        this._imgMestry = this.getChildByName("imgMestry");
        this.____1674 = this.getChildByName("layer");
        this._waitLabel = this.getChildByName("waitLabel");
        this.____1716 = this.getChildByName("starView");
        this.____1707 = [];
        for (var i = 1; i <= 5; i++) {
            this.____1707.push(this.____1716.getChildByName("start" + i))
        }
        this._labFightLabel = this.getChildByName("labFight");
        this.____5()
    },
    ____5: function() {},
    ____18: function(type, tempInfo) {
        this.____1752 = tempInfo;
        this._type = type;
        if (this.____1752 != null) {
            var info = ____655.lookInfo.getFashionInfo(type, tempInfo.templateId);
            if (info == null) {
                this._noGetImg.setVisible(true);
                this.____995.setString(tempInfo.stars[1].fightValue);
                this.setStar(0)
            } else {
                this._noGetImg.setVisible(false);
                this.____995.setString(tempInfo.stars[info.star].fightValue);
                this.setStar(info.star)
            }
            this.____995.setVisible(true);
            this._waitLabel.setString("");
            this._nameLabel.setString(tempInfo.name);
            this._nameLabel.setVisible(true);
            this.____1716.setVisible(true);
            this._labFightLabel.setString(____654.yuyanbaoManager.getYuyanbao("common.fightTip2"));
            this._imgMestry.setVisible(false);
            this.showCharacter(tempInfo)
        } else {
            if (this.____944 != null) {
                this.____944.dispose();
                this.____944 = null
            }
            if (this._characterInfo != null) {
                this._characterInfo.dispose();
                this._characterInfo = null
            }
            this.____995.setVisible(false);
            this._nameLabel.setVisible(false);
            this._labFightLabel.setString("");
            this._waitLabel.setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangItemView.text1"));
            this._noGetImg.setVisible(false);
            this.____1716.setVisible(false);
            this._imgMestryPath = ____654.____675.____139("outPic/ui_wenHaoIcon.png");
            ____654.____677.____146(this._imgMestry, this._imgMestryPath);
            this._imgMestry.setVisible(true)
        }
    },
    setStar: function(count) {
        for (var i = 0; i < this.____1707.length; i++) {
            if (i < count) {
                this.____1707[i].setFrame("icon/ui_startIcon1.png")
            } else {
                this.____1707[i].setFrame("icon/ui_startIcon0.png")
            }
        }
    },
    showCharacter: function(tempInfo) {
        if (tempInfo == null) return;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._type == ____655.____659.commonStaticType.style_fashion_horse) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Horse] = tempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Horse, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale * 0.7;
            this.____944.setScale(scaleValue, scaleValue);
            var y = (0 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(20, y)
        } else if (this._type == ____655.____659.commonStaticType.style_fashion_wing) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Wind] = tempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Wind, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue, scaleValue);
            var y = (-78 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(10, y)
        } else if (this._type == ____655.____659.commonStaticType.style_fashion_pet) {
            this._characterInfo = ____654.getCharacterInfo(tempInfo.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale * 0.8;
            this.____944.setScale(scaleValue, scaleValue);
            var y = (-20 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(10, y)
        } else if (this._type == ____655.____659.commonStaticType.style_fashion_cloth) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Cloth] = tempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Cloth, ____655.____659.____687.playerStand1);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue, scaleValue);
            var x = 12 * scaleValue;
            var y = 8 * scaleValue;
            this.____944.move(x, y)
        }
    },
    dispose: function() {
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        this._nameLabel = null;
        this.____995 = null;
        this._noGetImg = null;
        this.____1674 = null;
        this.____1707 = null;
        this._waitLabel = null;
        this.____1752 = null;
        this._labFightLabel = null;
        ____654.____677.removeImageQuote(this._imgMestryPath, this._imgMestry);
        this._imgMestryPath = null;
        this._imgMestry = null;
        this.____1716 = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        this._type = null;
        this._super()
    },
});
var LookComparePanel = KYPanel.extend({
    _controller: null,
    _bgPath: null,
    _titlePath: null,
    _title: null,
    ____869: null,
    ____870: null,
    _scrollLayer: null,
    ____1285: null,
    _itemList: null,
    _itemList2: null,
    _nameList: null,
    _currentIndex: -1,
    ____1824: null,
    _playerView1: null,
    _playerView2: null,
    _combatLabel1: null,
    _combatLabel2: null,
    ____1443: null,
    ____1444: null,
    _myCharacter: null,
    _hisCharacter: null,
    _fightList: null,
    _addFriendBtn: null,
    ____1889: null,
    _zhengLingEffect2: null,
    ctor: function(controller) {
        this._super("lookComparePanel.ExportJson");
        this._controller = controller;
        this._title = this.getChildByName("imgTitle");
        this.____869 = this.getChildByName("leftBackGround");
        this.____870 = this.getChildByName("rightBackGround");
        this._scrollLayer = this.getChildByName("scrollowView");
        this._titlePath = ____654.____675.____139("outPic/commonBarBg.png");
        ____654.____677.____146(this._title, this._titlePath);
        this._bgPath = ____654.____675.____139("outPic/role_bg.png");
        ____654.____677.____146(this.____869, this._bgPath);
        ____654.____677.____146(this.____870, this._bgPath);
        this._playerView1 = this.getChildByName("playerView1");
        this._playerView2 = this.getChildByName("playerView2");
        this._combatLabel1 = this.getChildByName("combatNum1");
        this._combatLabel2 = this.getChildByName("combatNum2");
        this.____1443 = this.getChildByName("name1");
        this.____1444 = this.getChildByName("name2");
        this._addFriendBtn = this.getChildByName("addFriendBtn");
        this.getChildByName("tipLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2238.text1"));
        this.____1824 = [____655.____659.commonStaticType.style_Horse, ____655.____659.commonStaticType.style_Pet, ____655.____659.commonStaticType.style_Wind, ____655.____659.commonStaticType.style_Foot, ____655.____659.commonStaticType.style_FaBao, ____655.____659.commonStaticType.style_ZhengLing, ____655.____659.commonStaticType.style_ShenJian];
        this.____1285 = ____654.____673.newKYSprite();
        this._scrollLayer.addContent(this.____1285);
        this.updateFight();
        this._itemList = [];
        this._itemList2 = [];
        this._nameList = ____655.____659.nameType.compareNameList;
        for (var i = 0; i < this._nameList.length; i++) {
            var compareItem = new LookCompareItem();
            compareItem.____18(this._nameList[i][0], this._fightList[i][0][1], this._fightList[i][0][0]);
            compareItem.addListener(this, this.itemClickHandler, null, null, null, false, true);
            this._itemList.push(compareItem);
            compareItem.setPositionX(2);
            this.____1285.addChild(compareItem)
        }
        this.updateItemList();
        this.updatePlayerInfo();
        this.____6()
    },
    ____6: function() {
        this._addFriendBtn.addListener(this, this.addFriendHandler)
    },
    updatePlayerInfo: function() {
        this._combatLabel1.setString(____655.____667.combat);
        this._combatLabel2.setString(____655.lookInfo.playerInfo.combat);
        if (____655.____667.xianwei > 1) {
            this.____1443.setString(____655.____667.nick + "（" + ____655.____659.nameType.getXianweiName(____655.____667.xianwei) + "）")
        } else {
            this.____1443.setString(____655.____667.nick)
        }
        if (____655.lookInfo.playerInfo.xianwei > 1) {
            this.____1444.setString(____655.lookInfo.playerInfo.nick + "（" + ____655.____659.nameType.getXianweiName(____655.lookInfo.playerInfo.xianwei) + "）")
        } else {
            this.____1444.setString(____655.lookInfo.playerInfo.nick)
        }
        this._myCharacter = new ____545(____655.____667.characterInfo);
        this._myCharacter.init(____655.____659.____686.rightBottom, this._playerView1, 30);
        this._myCharacter.move(40, (-12 + ____655.____667.characterInfo.getYOffset()) * 1.1);
        this._myCharacter.setScale(1.1, 1.1);
        this._myCharacter.____203(____655.____659.____687.stand);
        this._hisCharacter = new ____545(____655.lookInfo.playerInfo.characterInfo);
        this._hisCharacter.init(____655.____659.____686.rightBottom, this._playerView2, 30);
        this._hisCharacter.move(40, (-12 + ____655.lookInfo.playerInfo.characterInfo.getYOffset()) * 1.1);
        this._hisCharacter.setScale(1.1, 1.1);
        this._hisCharacter.____203(____655.____659.____687.stand)
    },
    createZhengLing: function() {
        var fazhenId = ____655.____667.characterInfo.getStyleList()[____655.____659.commonStaticType.style_ZhengLing];
        if (fazhenId == null || fazhenId == 0) {
            if (this.____1889 != null) {
                this.____1889.dispose();
                this.____1889 = null
            }
        } else {
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ZhengLing, fazhenId).figureId);
            this.____1889 = ____654.effectManager.setEffect(effectId, false, ____654.____673.____159(40, -35), this._playerView1)
        }
        var fazhenId2 = ____655.lookInfo.playerInfo.characterInfo.getStyleList()[____655.____659.commonStaticType.style_ZhengLing];
        if (fazhenId2 == null || fazhenId2 == 0) {
            if (this._zhengLingEffect2 != null) {
                this._zhengLingEffect2.dispose();
                this._zhengLingEffect2 = null
            }
        } else {
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ZhengLing, fazhenId2).figureId);
            this._zhengLingEffect2 = ____654.effectManager.setEffect(effectId, false, ____654.____673.____159(40, -35), this._playerView2)
        }
    },
    updateFight: function() {
        this._fightList = [];
        this._fightList.push(this.getWaiGuanFight());
        this._fightList.push(this.getHunPoFight());
        this._fightList.push(this.getFashionFight());
        this._fightList.push(this.getShenBingFight());
        this._fightList.push(this.getTuJianFight());
        this._fightList.push(this.getOtherFight())
    },
    getWaiGuanFight: function() {
        var myTotalFight = 0;
        var hisTotalFight = 0;
        var fightList = [];
        var info = null;
        for (var i = 0; i < this.____1824.length; i++) {
            var myFight = 0;
            var hisFight = 0;
            info = ____655.advanceItemList.getItemByType(this.____1824[i]);
            if (info != null) {
                myFight = info.fight
            } else {
                myFight = 0
            }
            info = ____655.lookInfo.advanceItemList.getItemByType(this.____1824[i]);
            if (info != null) {
                hisFight = info.fight
            } else {
                hisFight = 0
            }
            myTotalFight += myFight;
            hisTotalFight += hisFight;
            fightList.push([myFight, hisFight])
        }
        fightList.splice(0, 0, [myTotalFight, hisTotalFight]);
        return fightList
    },
    getHunPoFight: function() {
        var myTotalFight = 0;
        var hisTotalFight = 0;
        var fightList = [];
        for (var mm = 0; mm < this.____1824.length; mm++) {
            var myHunPoLevel = ____655.advanceItemList.getSoulLevelByType(this.____1824[mm]);
            var myFight = 0;
            var propertyList = ____655.allTemplates.hunPoTemplateList.getTotalPropertyByLevel(this.____1824[mm], myHunPoLevel);
            var proTypeList = ____655.allTemplates.hunPoTemplateList.getProTypeList(this.____1824[mm]);
            if (proTypeList != null) {
                for (var i = 0; i < proTypeList.length; i++) {
                    var propertyId = proTypeList[i];
                    if (propertyId != null) {
                        var value = 0;
                        if (propertyList[propertyId] != null) {
                            value = propertyList[propertyId]
                        }
                        myFight += ____655.____659.propertyType.getFight(propertyId, value)
                    }
                }
            }
            var hisHunPoLevel = ____655.lookInfo.advanceItemList.getSoulLevelByType(this.____1824[mm]);
            var hisFight = 0;
            var propertyList2 = ____655.allTemplates.hunPoTemplateList.getTotalPropertyByLevel(this.____1824[mm], hisHunPoLevel);
            var proTypeList2 = ____655.allTemplates.hunPoTemplateList.getProTypeList(this.____1824[mm]);
            if (proTypeList2 != null) {
                for (var i = 0; i < proTypeList2.length; i++) {
                    var propertyId = proTypeList2[i];
                    if (propertyId != null) {
                        var value = 0;
                        if (propertyList2[propertyId] != null) {
                            value = propertyList2[propertyId]
                        }
                        hisFight += ____655.____659.propertyType.getFight(propertyId, value)
                    }
                }
            }
            myTotalFight += myFight;
            hisTotalFight += hisFight;
            fightList.push([myFight, hisFight])
        }
        fightList.splice(0, 0, [myTotalFight, hisTotalFight]);
        return fightList
    },
    getFashionFight: function() {
        var typeList = [____655.____659.commonStaticType.style_fashion_horse, ____655.____659.commonStaticType.style_fashion_pet, ____655.____659.commonStaticType.style_fashion_wing, ____655.____659.commonStaticType.style_fashion_cloth];
        var myTotalFight = 0;
        var hisTotalFight = 0;
        var fightList = [];
        var fashionInfo = null;
        for (var i = 0; i < typeList.length; i++) {
            var myFight = 0;
            var hisFight = 0;
            fashionInfo = ____655.fashionInfo.getFashion(typeList[i]);
            if (fashionInfo != null) {
                for (var k in fashionInfo.huaxingList) {
                    var info = fashionInfo.huaxingList[k];
                    if (info != null) {
                        myFight += info.template.fightValue
                    }
                }
            }
            fashionInfo = ____655.lookInfo.getFashion(typeList[i]);
            if (fashionInfo != null) {
                for (var k in fashionInfo.huaxingList) {
                    var info = fashionInfo.huaxingList[k];
                    if (info != null) {
                        hisFight += info.template.fightValue
                    }
                }
            }
            myTotalFight += myFight;
            hisTotalFight += hisFight;
            fightList.push([myFight, hisFight])
        }
        fightList.splice(0, 0, [myTotalFight, hisTotalFight]);
        return fightList
    },
    getShenBingFight: function() {
        var myTotalFight = 0;
        var hisTotalFight = 0;
        var fightList = [];
        var myFight = 0;
        var hisFight = 0;
        var weaponGodList = ____655.furnaceInfo.GOD_WEAPON_TYPE;
        var info = null;
        for (var i = 0; i < weaponGodList.length; i++) {
            info = ____655.furnaceInfo.getGodWeaponInfoByType(weaponGodList[i]);
            if (info != null) {
                var templateInfoList = ____655.allTemplates.fashionTemplateList.getList(weaponGodList[i]);
                var templateInfo = null;
                if (templateInfoList != null) {
                    templateInfo = templateInfoList[0]
                }
                if (templateInfo != null) {
                    myFight += templateInfo.stars[info.level].fightValue
                }
            }
            info = ____655.lookInfo.getGodWeaponInfoByType(weaponGodList[i]);
            if (info != null) {
                var templateInfoList = ____655.allTemplates.fashionTemplateList.getList(weaponGodList[i]);
                var templateInfo = null;
                if (templateInfoList != null) {
                    templateInfo = templateInfoList[0]
                }
                if (templateInfo != null) {
                    hisFight += templateInfo.stars[info.level].fightValue
                }
            }
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        myFight = 0;
        hisFight = 0;
        var equipItemList = ____655.____659.categoryType.equipList;
        for (var mm = 0; mm < equipItemList.length; mm++) {
            var info = ____655.itemInfoList.getBodyEquipByType(equipItemList[mm]);
            if (info != null) {
                var proTemplate = ____655.allTemplates.strengthPropertyTemplateList.____238(info.template.categoryId, info.qhLevel);
                if (proTemplate != null) {
                    var proList = proTemplate.propertyAdd;
                    for (var i = 0; i < proList.length; i++) {
                        if (proList[i] != null) {
                            myFight += ____655.____659.propertyType.getFight(proList[i].id, proList[i].value)
                        }
                    }
                }
            }
            info = ____655.lookInfo.getBodyEquipByType(equipItemList[mm]);
            if (info != null) {
                var proTemplate = ____655.allTemplates.strengthPropertyTemplateList.____238(info.template.categoryId, info.qhLevel);
                if (proTemplate != null) {
                    var proList = proTemplate.propertyAdd;
                    for (var i = 0; i < proList.length; i++) {
                        if (proList[i] != null) {
                            hisFight += ____655.____659.propertyType.getFight(proList[i].id, proList[i].value)
                        }
                    }
                }
            }
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        myFight = 0;
        hisFight = ____655.lookInfo.baoShiFight;
        var equipItemList = ____655.____659.categoryType.equipList;
        for (var i = 0; i < equipItemList.length; i++) {
            var equipType = equipItemList[i];
            var baoshiEquipTemplate = ____655.allTemplates.baoShiEquipTemplateList.getTemplateInfoByType(equipType);
            for (var j = 0; j < baoshiEquipTemplate.baoshiList.length; j++) {
                var stoneType = baoshiEquipTemplate.baoshiList[j][0];
                var exp = ____655.furnaceInfo.getStoneExpByType(equipType, stoneType);
                var template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndExp(stoneType, exp);
                if (template != null) {
                    var proType = template.atrrList[0].id;
                    var proValue = template.atrrList[0].value;
                    var openLevel = baoshiEquipTemplate.baoshiList[j][1];
                    if (openLevel != -1 && ____655.____667.level >= openLevel && proType != -1 && proValue != -1) {
                        myFight += ____655.____659.propertyType.getFight(proType, proValue)
                    }
                }
            }
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        myFight = 0;
        hisFight = 0;
        var myProList = ____655.allTemplates.wuhunTemplateList.getTotalPropertyByLevel(____655.furnaceInfo.weaponSoulLevel);
        var hisProList = ____655.allTemplates.wuhunTemplateList.getTotalPropertyByLevel(____655.lookInfo.wuHunLevel);
        var proTypeList = ____655.allTemplates.wuhunTemplateList.____1566;
        for (var i = 0; i < proTypeList.length; i++) {
            var num = myProList[i] || 0;
            myFight += ____655.____659.propertyType.getFight(proTypeList[i], num);
            var num2 = hisProList[i] || 0;
            hisFight += ____655.____659.propertyType.getFight(proTypeList[i], num2)
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        myFight = 0;
        hisFight = 0;
        var myTemplate = ____655.allTemplates.rongluTemplateList.____238(____655.furnaceInfo.weaponPotLevel);
        var hisTemplate = ____655.allTemplates.rongluTemplateList.____238(____655.lookInfo.rongLuLevel);
        var proList = ____655.allTemplates.rongluTemplateList.____1566;
        for (var i = 0; i < proList.length; i++) {
            var myPro = 0;
            if (myTemplate != null) {
                myPro = myTemplate.getProByType(proList[i])
            }
            var hisPro = 0;
            if (hisTemplate != null) {
                hisPro = hisTemplate.getProByType(proList[i])
            }
            myFight += ____655.____659.propertyType.getFight(proList[i], myPro);
            hisFight += ____655.____659.propertyType.getFight(proList[i], hisPro)
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        fightList.splice(0, 0, [myTotalFight, hisTotalFight]);
        return fightList
    },
    getTuJianFight: function() {
        var myTotalFight = 0;
        var hisTotalFight = 0;
        var fightList = [];
        var myFight = 0;
        var hisFight = ____655.lookInfo.tujianFight;
        var tuJianTempList = ____655.allTemplates.tuJianTemplateList.tuJianList;
        for (var i = 0; i < tuJianTempList.length; i++) {
            var type = tuJianTempList[i].id;
            var tempInfoList = ____655.allTemplates.fashionTemplateList.getList(type);
            if (tempInfoList != null && tempInfoList.length > 0) {
                var star = 99;
                for (var j = 0; j < tempInfoList.length; j++) {
                    var id = tempInfoList[j].templateId;
                    var info = ____655.fashionInfo.getFashionInfo(type, id);
                    if (info != null) {
                        myFight += tempInfoList[j].stars[info.star].fightValue;
                        if (star > info.star) {
                            star = info.star
                        }
                    } else {
                        star = 0
                    }
                }
                var propertyList = tuJianTempList[i].propertyList;
                var propertyId = tempInfoList[0].stars[1].attrStr[0].id;
                var propertyValue = 0;
                for (var j = 0; j < propertyList.length; j++) {
                    if (propertyList[j][0] <= star) {
                        propertyValue += propertyList[j][2]
                    }
                }
                myFight += ____655.____659.propertyType.getFight(propertyId, propertyValue)
            }
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        var huanZhuangTempList = ____655.allTemplates.tuJianTemplateList.huanZhuangList;
        myFight = 0;
        hisFight = ____655.lookInfo.huanZhuangFight;
        for (var i = 0; i < huanZhuangTempList.length; i++) {
            var fashionIdList = huanZhuangTempList[i].fashionIdList;
            var count = 0;
            for (var j = 0; j < fashionIdList.length; j++) {
                var type = fashionIdList[j][0];
                var id = 0;
                if (type == ____655.____659.commonStaticType.style_fashion_cloth && !____655.____667.getSex()) {
                    id = fashionIdList[j][2]
                } else {
                    id = fashionIdList[j][1]
                }
                var info = ____655.fashionInfo.getFashionInfo(type, id);
                if (info != null) {
                    count++
                }
            }
            var propertyList = huanZhuangTempList[i].propertyList;
            var propertyId = propertyList[i][1];
            var propertyValue = 0;
            for (var j = 0; j < propertyList.length; j++) {
                if (propertyList[j][0] <= count) {
                    propertyValue += propertyList[j][2]
                }
            }
            myFight += ____655.____659.propertyType.getFight(propertyId, propertyValue)
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        fightList.splice(0, 0, [myTotalFight, hisTotalFight]);
        return fightList
    },
    getOtherFight: function() {
        var myTotalFight = 0;
        var hisTotalFight = 0;
        var fightList = [];
        var myFight = 0;
        var hisFight = 0;
        var myTemplate = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(____655.____667.vipLevel);
        var hisTemplate = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(____655.lookInfo.playerInfo.vipLevel);
        if (myTemplate != null) {
            var proList = myTemplate.propAdd;
            for (var i = 0; i < proList.length; i++) {
                if (proList[i] != null) {
                    myFight += ____655.____659.propertyType.getFight(proList[i].id, proList[i].value)
                }
            }
        }
        if (hisTemplate != null) {
            var proList = hisTemplate.propAdd;
            for (var i = 0; i < proList.length; i++) {
                if (proList[i] != null) {
                    hisFight += ____655.____659.propertyType.getFight(proList[i].id, proList[i].value)
                }
            }
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        myFight = 0;
        hisFight = 0;
        var propertyIdList = ____655.allTemplates.lilianTemplateList.proTypeList;
        var myAtts = ____655.allTemplates.lilianTemplateList.getTotalPropertyByLevel(____655.activityInfo.lilianLevel);
        var hisAtts = ____655.allTemplates.lilianTemplateList.getTotalPropertyByLevel(____655.lookInfo.liLianLevel);
        for (var i = 0; i <= 5; i++) {
            myFight += ____655.____659.propertyType.getFight(propertyIdList[i], myAtts[i]);
            hisFight += ____655.____659.propertyType.getFight(propertyIdList[i], hisAtts[i])
        }
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        myFight = ____655.clubInfo.xinFaFight;
        hisFight = ____655.lookInfo.xinFaFight;
        myTotalFight += myFight;
        hisTotalFight += hisFight;
        fightList.push([myFight, hisFight]);
        fightList.splice(0, 0, [myTotalFight, hisTotalFight]);
        return fightList
    },
    addFriendHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____655.lookInfo.addFriend()
        }
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this._itemList.indexOf(sender);
            if (this._currentIndex >= 0) {
                this.clearItems2();
                this._itemList[this._currentIndex].setFold(true)
            }
            if (this._currentIndex == index) {
                this._currentIndex = -1
            } else {
                this._currentIndex = index;
                this._itemList[this._currentIndex].setFold(false);
                this.createItems2(this._currentIndex)
            }
            this.updateItemList()
        }
    },
    updateItemList: function() {
        var offsetY = 0;
        for (var i = 0; i < this._itemList.length; i++) {
            offsetY += -55;
            this._itemList[i].setPositionY(offsetY);
            if (!this._itemList[i].getFold()) {
                for (var j = 0; j < this._itemList2.length; j++) {
                    offsetY += -40;
                    this._itemList2[j].setPositionY(offsetY)
                }
            }
        }
        if (offsetY > -434) {
            this.____1285.setPositionY(434);
            this._scrollLayer.setInnerSize(____654.____673.____160(310, 434));
            this._scrollLayer.jumpToTop()
        } else {
            this.____1285.setPositionY(-offsetY);
            this._scrollLayer.setInnerSize(____654.____673.____160(310, -offsetY));
            this._scrollLayer.jumpToTop()
        }
    },
    createItems2: function(index) {
        var list = this._nameList[index];
        for (var i = 1; i < list.length; i++) {
            var item = new LookCompareItem2();
            item.____18(list[i], this._fightList[index][i][1], this._fightList[index][i][0]);
            this._itemList2.push(item);
            this.____1285.addChild(item)
        }
    },
    clearItems2: function() {
        for (var i = 0; i < this._itemList2.length; i++) {
            this._itemList2[i].dispose()
        }
        this._itemList2 = []
    },
    dispose: function() {
        this._controller = null;
        this._addFriendBtn = null;
        this._super();
        ____654.____677.removeImageQuote(this._titlePath, this._title);
        ____654.____677.removeImageQuote(this._bgPath, this.____869);
        ____654.____677.removeImageQuote(this._bgPath, this.____870);
        this._title = null;
        this.____869 = null;
        this.____870 = null;
        this._titlePath = null;
        this._bgPath = null;
        this._scrollLayer = null;
        if (this.____1285 != null) {
            this.____1285.dispose();
            this.____1285 = null
        }
        this._nameList = null;
        this._fightList = null;
        this._playerView1 = null;
        this._playerView2 = null;
        this._combatLabel1 = null;
        this._combatLabel2 = null;
        this.____1443 = null;
        this.____1444 = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this._itemList = null;
        if (this._myCharacter != null) {
            this._myCharacter.dispose();
            this._myCharacter = null
        }
        if (this._hisCharacter != null) {
            this._hisCharacter.dispose();
            this._hisCharacter = null
        }
        if (this.____1889 != null) {
            this.____1889.dispose();
            this.____1889 = null
        }
        if (this._zhengLingEffect2 != null) {
            this._zhengLingEffect2.dispose();
            this._zhengLingEffect2 = null
        }
        this.clearItems2();
        this.____1824 = null;
        this._itemList2 = null
    },
});
var LookFashionPanel = KYPanel.extend({
    _controller: null,
    ____1499: null,
    ____1291: null,
    ____1737: null,
    ____1738: null,
    ____1054: null,
    _type: null,
    ____1758: null,
    ____1400: 0,
    ____1053: -1,
    _itemList: null,
    _addFriendBtn: null,
    ____1889: null,
    _beginPos: null,
    _clickView: null,
    ctor: function(controller) {
        this._super("lookFantacyClothPanel.ExportJson");
        this._controller = controller;
        this.____1291 = this.getChildByName("ScrollViewBorad");
        this._clickView = this.getChildByName("itemView");
        this._addFriendBtn = this.getChildByName("addFriendBtn");
        this.getChildByName("tipLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2238.text1"));
        this._itemList = [];
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._addFriendBtn.addListener(this, this.addFriendHandler);
        this._clickView.addListener(this, null, this.itemViewTouchBegin, this.itemViewTouchUp)
    },
    ____5: function() {
        for (var i = 0; i < 6; i++) {
            var item = new LookFashionItem();
            item.setPosition(____654.____673.____159((i % 3) * 224, 260 - Math.floor(i / 3) * 255));
            this.____1291.addChild(item);
            this._itemList.push(item)
        }
        this.____1738 = [
            [1, ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle21"), "icon/ui_waixingIcon1.png", true],
            [2, ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle22"), "icon/ui_waixingIcon2.png", true],
            [3, ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle23"), "icon/ui_waixingIcon3.png", true],
            [4, ____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle3"), "icon/ui_waixingIcon4.png", true]
        ];
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(515);
        var tabLayer = this.getChildByName("scrollView");
        tabLayer.setScrollBarEnabled(false);
        tabLayer.addChild(this.____1737);
        this.____1737.setTabIndex(0)
    },
    setTab: function(tab) {
        if (tab == 1) {
            this._type = ____655.____659.commonStaticType.style_fashion_horse;
            this.____1758 = ____655.allTemplates.fashionTemplateList.getList(this._type)
        } else if (tab == 2) {
            this._type = ____655.____659.commonStaticType.style_fashion_pet;
            this.____1758 = ____655.allTemplates.fashionTemplateList.getList(this._type)
        } else if (tab == 3) {
            this._type = ____655.____659.commonStaticType.style_fashion_wing;
            this.____1758 = ____655.allTemplates.fashionTemplateList.getList(this._type)
        } else if (tab == 4) {
            this._type = ____655.____659.commonStaticType.style_fashion_cloth;
            var career = ____655.lookInfo.playerInfo.career;
            this.____1758 = ____655.allTemplates.fashionTemplateList.getListByTypeAndCarrer(this._type, career)
        }
        this.____1053 = -1;
        this.updateView()
    },
    updateView: function() {
        var this_ = this;

        function sortFunc(item1, item2) {
            var info1 = ____655.fashionInfo.getFashionInfo(this_._type, item1.templateId);
            var info2 = ____655.fashionInfo.getFashionInfo(this_._type, item2.templateId);
            if (info1 != null && info2 != null) {
                if (info2.star == info1.star) {
                    return item2.stars[1].fightValue - item1.stars[1].fightValue
                }
                return info2.star - info1.star
            } else if (info1 != null) {
                return -1
            } else if (info2 != null) {
                return 1
            }
            return item2.stars[1].fightValue - item1.stars[1].fightValue
        };
        this.____1758.sort(sortFunc);
        this.____1400 = Math.ceil(this.____1758.length / 6);
        if (this.____1499 == null) {
            this.____1499 = new ____2145(this.____1400, 30);
            this.____1499.setPosition(____654.____673.____159(558, 25));
            this.addChild(this.____1499)
        } else {
            this.____1499.resetCount(this.____1400)
        }
        this.setPage(1)
    },
    setPage: function(page) {
        if (page < 1) {
            page = 1
        }
        if (page > this.____1400) {
            page = this.____1400
        }
        if (this.____1053 == page) {
            return
        }
        this.____1499.setPage(page - 1);
        this.____1053 = page;
        var index = 0;
        for (var i = (page - 1) * 6; i < page * 6; i++) {
            var info = this.____1758[i];
            this._itemList[index].____18(this._type, info);
            index++
        }
    },
    addFriendHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____655.lookInfo.addFriend()
        }
    },
    itemViewTouchBegin: function(sender, eventType, pos) {
        this._beginPos = pos
    },
    itemViewTouchUp: function(sender, eventType, pos) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var startPos = this._beginPos;
            var endPos = pos;
            if (startPos.x - endPos.x > 50) {
                this.setPage(this.____1053 + 1)
            } else if (startPos.x - endPos.x < -50) {
                this.setPage(this.____1053 - 1)
            }
        }
    },
    dispose: function() {
        this._controller = null;
        this._addFriendBtn = null;
        if (this.____1499 != null) {
            this.____1499.dispose();
            this.____1499 = null
        }
        this.____1291 = null;
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        if (this._itemList != null) {
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose();
                this._itemList[i] = null
            }
            this._itemList = null
        }
        if (this.____1889 != null) {
            this.____1889.dispose();
            this.____1889 = null
        }
        this.____1738 = null;
        this.____1054 = null;
        this._clickView = null;
        this._type = null;
        this.____1758 = null;
        this.____1400 = null;
        this.____1053 = null;
        this._super()
    },
});
var LookController = cc.Class.extend({
    lookModule: null,
    ctor: function(lookModule) {
        this.lookModule = lookModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showLookRolePanel: function(type) {
        if (this.lookModule.lookRolePanel == null) {
            this.lookModule.lookRolePanel = new ____2238(this, 1)
        }
        ____654.____676.uiPanelContainer.____125(this.lookModule.lookRolePanel, type)
    },
    showLookWaiguanPanel: function(type) {
        if (this.lookModule.lookAdvancePanel == null) {
            this.lookModule.lookAdvancePanel = new AdvancePanel(this, null, 1)
        }
        ____654.____676.uiPanelContainer.____125(this.lookModule.lookAdvancePanel, type)
    },
    showLookSoulPanel: function(type) {
        if (this.lookModule.lookSoulPanel == null) {
            this.lookModule.lookSoulPanel = new ____2330(this, null, 1)
        }
        ____654.____676.uiPanelContainer.____125(this.lookModule.lookSoulPanel, type)
    },
    showLookFashionPanel: function(type) {
        if (this.lookModule.lookFashionPanel == null) {
            this.lookModule.lookFashionPanel = new LookFashionPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.lookModule.lookFashionPanel, type)
    },
    showLookComparePanel: function(type) {
        if (this.lookModule.lookComparePanel == null) {
            this.lookModule.lookComparePanel = new LookComparePanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.lookModule.lookComparePanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.lookModule.lookRolePanel) {
            this.lookModule.lookRolePanel = null
        } else if (p == this.lookModule.lookAdvancePanel) {
            this.lookModule.lookAdvancePanel = null
        } else if (p == this.lookModule.lookSoulPanel) {
            this.lookModule.lookSoulPanel = null
        } else if (p == this.lookModule.lookFashionPanel) {
            this.lookModule.lookFashionPanel = null
        } else if (p == this.lookModule.lookComparePanel) {
            this.lookModule.lookComparePanel = null
        }
    },
});
var LookModule = ____537.extend({
    lookController: null,
    lookRolePanel: null,
    lookAdvancePanel: null,
    lookSoulPanel: null,
    lookFashionPanel: null,
    lookComparePanel: null,
    setup: function(data) {
        this.lookController = new LookController(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.lookRole) {
            this.lookController.showLookRolePanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.lookWaiguan) {
            this.lookController.showLookWaiguanPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.lookSoul) {
            this.lookController.showLookSoulPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.lookFashion) {
            this.lookController.showLookFashionPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.lookCompare) {
            this.lookController.showLookComparePanel(data[0])
        }
    },
    clear: function() {},
});
var OpenFreeGoldView = KYPanel.extend({
    _tittleBg: null,
    _tittleBgPath: null,
    _contentBg: null,
    _contentPath: null,
    _content: null,
    _type: null,
    _timeLabel: null,
    ____919: null,
    _countDownUtils: null,
    ctor: function(type) {
        this._super("openFreeGoldView.ExportJson");
        this._tittleBg = this.getChildByName("tittleBg");
        this._tittleBgPath = ____654.____675.____139("outPic/openFreeGoldTabImg.png");
        ____654.____677.____146(this._tittleBg, this._tittleBgPath);
        this._contentBg = this.getChildByName("bg");
        this._contentPath = ____654.____675.____139("outPic/openFreeGoldView.png");
        ____654.____677.____146(this._contentBg, this._contentPath);
        this._content = this.getChildByName("content");
        this._content.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text1"));
        this._type = type;
        this._timeLabel = this.getChildByName("timeLabel");
        this.____919 = this.getChildByName("buyBtn");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        this.____5();
        this.____6()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____919) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
            }
        }
    },
    ____5: function() {
        var lastRevertTime = (7 * ____655.____662.secondsOfDay) + ____655.____665 - ____655.____662.getSystemTimeSec();
        this._countDownUtils.start(lastRevertTime)
    },
    ____6: function() {
        this.____919.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        if (this._tittleBgPath != null) {
            ____654.____677.removeImageQuote(this._tittleBgPath, this._tittleBg);
            this._tittleBgPath = null
        }
        this._tittleBg = null;
        if (this._contentPath != null) {
            ____654.____677.removeImageQuote(this._contentPath, this._contentBg);
            this._contentPath = null
        }
        this._contentBg = null;
        this._content = null;
        this._type = null;
        this._timeLabel = null;
        this.____919 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    },
});
var OpenLuckyBagItem = KYNode.extend({
    _cell: null,
    ____1344: null,
    _nameLabel: null,
    ____1016: null,
    ____1017: null,
    _oriPrice: null,
    _price: null,
    ____919: null,
    _buyBtnLabel: null,
    _outFlag: null,
    _grid: null,
    _count: 0,
    _info: null,
    _limitInfo: null,
    _flagIcon: null,
    ctor: function() {
        this._super("openLuckyBagItem.ExportJson");
        this._cell = this.getChildByName("cell");
        this._grid = new ____2129();
        this._grid.setIsShowCount(false);
        this._cell.addChild(this._grid);
        this.____1344 = this.getChildByName("limitLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1016 = this.getChildByName("cotent1");
        this.____1016.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text7"));
        this.____1017 = this.getChildByName("cotent2");
        this.____1017.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text8"));
        this._oriPrice = this.getChildByName("oriPrice");
        this._price = this.getChildByName("price");
        this.____919 = this.getChildByName("buyBtn");
        this._buyBtnLabel = this.getChildByName("btnLabel");
        this._buyBtnLabel.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text9"));
        this._outFlag = this.getChildByName("outFlag");
        this._outFlag.setVisible(false);
        this._flagIcon = this.getChildByName("flagIcon");
        this._flagIcon.setVisible(false);
        this.____6()
    },
    ____18: function(info) {
        if (info == null) return;
        this._info = info;
        if (info.tagType == 2) {
            this._flagIcon.setVisible(true)
        }
        var itemTemplateInfo = ____655.allTemplates.____794.getItem(info.templateId);
        this._grid.setItemTemplateInfo(itemTemplateInfo);
        var limitInfo = ____655.statInfo.statShopItemList[info.id];
        this._count = 0;
        if (this._limitInfo != null) {
            this._limitInfo.removeEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
        }
        if (limitInfo == null) {
            this._count = info.limitBuyCount
        } else {
            this._limitInfo = limitInfo;
            this._count = info.limitBuyCount - limitInfo.hasBuyCount
        }
        if (this._limitInfo != null) {
            this._limitInfo.addEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
        }
        this.____1344.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text10", this._count));
        this._nameLabel.setString(itemTemplateInfo.name);
        this._nameLabel.setColor(____655.____659.____688.itemColorList[itemTemplateInfo.quality]);
        this._oriPrice.setString(info.oldPrice);
        this._price.setString(info.price);
        if (this._count <= 0) {
            this._outFlag.setVisible(true);
            ____654.____674.setKYBtnEnabled(this.____919, false, 0)
        } else {
            this._outFlag.setVisible(false);
            ____654.____674.setKYBtnEnabled(this.____919, true, 1)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____919) {
                var count = 1;
                count = this._info.limitBuyCount;
                var limitInfo = ____655.statInfo.statShopItemList[this._info.id];
                if (limitInfo != null) {
                    count -= limitInfo.hasBuyCount
                }
                if (count <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("shopItemView.text2"));
                    return
                }
                count = Math.min(count, Math.floor(____655.____667.moneyInfo.getMoneyCountByType(this._info.payType) / this._info.price));
                ____654.____672.dispatchEvent(new ____590(____655.____661.common_showNumberPanel, ____654.____672, [1, this._info.itemTemplateInfo, this._info.price, this._info.payType, count, this._info.limitBuyCount, this, this.sendBuy]))
            }
        }
    },
    sendBuy: function(count) {
        if (count == 0) {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text11"));
            return
        }
        if (____655.____667.moneyInfo.moneyEnoughByType(this._info.payType, this._info.price * count)) {
            ____654.statMessageSender.sendShopBuy(this._info.id, count)
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(this._info.payType)
        }
    },
    setLimitInfoView: function() {
        var limitInfo = ____655.statInfo.statShopItemList[this._info.id];
        this._count = 0;
        if (this._limitInfo != null) {
            this._limitInfo.removeEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
        }
        if (limitInfo == null) {
            this._count = this._info.limitBuyCount
        } else {
            this._limitInfo = limitInfo;
            this._count = this._info.limitBuyCount - limitInfo.hasBuyCount
        }
        if (this._limitInfo != null) {
            this._limitInfo.addEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
        }
        if (this._count <= 0) {
            this._outFlag.setVisible(true);
            ____654.____674.setKYBtnEnabled(this.____919, false, 0)
        } else {
            this._outFlag.setVisible(false);
            ____654.____674.setKYBtnEnabled(this.____919, true, 1)
        }
        this.____1344.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text10", this._count))
    },
    ____6: function() {
        this.____919.addListener(this, this.____16)
    },
    ____17: function() {
        if (this._limitInfo != null) {
            this._limitInfo.removeEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
        }
    },
    dispose: function() {
        this.____17();
        this._cell = null;
        this.____1344 = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._nameLabel = null;
        this.____1016 = null;
        this.____1017 = null;
        this._oriPrice = null;
        this._price = null;
        this.____919 = null;
        this._buyBtnLabel = null;
        this._outFlag = null;
        this._limitInfo = null;
        this._info = null;
        this._count = null;
        this._flagIcon = null;
        this._super()
    },
});
var OpenLuckyBagView = KYPanel.extend({
    _tittleBg: null,
    _tittleBgPath: null,
    _itemList: null,
    _type: null,
    ____1840: null,
    ____1251: null,
    ctor: function(type) {
        this._super("openLuckyBagView.ExportJson");
        this._tittleBg = this.getChildByName("tittleBg");
        this._tittleBgPath = ____654.____675.____139("outPic/openLuckyBagTabImg.png");
        ____654.____677.____146(this._tittleBg, this._tittleBgPath);
        this._itemList = this.getChildByName("itemList");
        this._type = type;
        this.____1840 = [];
        this.____1251 = [];
        this.____5();
        this.____6()
    },
    ____5: function() {
        var infoList = ____655.allTemplates.shopTemplateList.getShopTempListByType(____655.allTemplates.shopTemplateList.shopType_10);
        var itemList = [];
        var systemTime = ____655.____662.getSystemTimeSec();
        for (var i = 0; i < infoList.length; i++) {
            var info = infoList[i];
            var beginSecond = ____655.____662.getTimesByDay(info.beginDay);
            var finishSecond = ____655.____662.getTimesByDay(info.endDay);
            var weekDay = ____655.____662.getClientDate().getDay();
            if (weekDay == 0) {
                weekDay = 7
            }
            if ((weekDay == info.weekDay) && (finishSecond > systemTime) && (beginSecond <= systemTime) && (info.endDate > systemTime) && (info.beginDate <= systemTime)) {
                itemList.push(info)
            }
        }
        for (var i = 0; i < itemList.length; i++) {
            var info = itemList[i];
            var item = new OpenLuckyBagItem();
            item.____18(info);
            item.setPosition(3 + (i % 2) * 358, 5 + Math.floor(i / 2) * 200);
            this._itemList.addChild(item, 10);
            this.____1840.push(item);
            this.____1251.push(info)
        }
    },
    setLimitInfoView: function() {
        for (var i = 0; i < this.____1840.length; i++) {
            this.____1840[i].____18(this.____1251[i])
        }
    },
    ____6: function() {
        ____655.statInfo.addEventListener(____655.____661.stat_shopList_update, this.setLimitInfoView, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.stat_shopList_update, this.setLimitInfoView, this)
    },
    dispose: function() {
        this.____17();
        if (this._tittleBgPath != null) {
            ____654.____677.removeImageQuote(this._tittleBgPath, this._tittleBg);
            this._tittleBgPath = null
        }
        this._tittleBg = null;
        this._itemList = null;
        if (this.____1840 != null) {
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = null
        }
        this._super()
    },
});
var OpenOtherRankItem = KYNode.extend({
    ____1579: null,
    ____1783: null,
    _itemList: null,
    ____1840: null,
    ____1185: null,
    _hasFlag: null,
    _type: null,
    _worldLabel: null,
    ctor: function(type) {
        this._super("openRankItem.ExportJson");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1783 = this.getChildByName("tipLabel");
        this.____1783.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text2"));
        this._itemList = [];
        this.____1840 = [];
        for (var i = 0; i < 5; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            this._itemList[i].addChild(grid);
            this.____1840.push(grid)
        }
        this._type = type;
        this.____1185 = this.getChildByName("getBtn");
        this._hasFlag = this.getChildByName("hasFlag");
        this._worldLabel = this.getChildByName("wordLabel");
        this._worldLabel.setVisible(false);
        this.____1185.setVisible(false);
        this._hasFlag.setVisible(false)
    },
    ____18: function(conditionInfo, awardList) {
        if (conditionInfo == null) return;
        if (conditionInfo[0] == conditionInfo[1]) {
            this.____1579.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text3", conditionInfo[0]))
        } else {
            this.____1579.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text4", conditionInfo[0], conditionInfo[1]))
        }
        this.____1579.setPositionY(this.____1579.getPositionY() - 5);
        var len = 0;
        if (awardList.length > 5) {
            len = 5
        } else {
            len = awardList.length
        }
        for (var i = 0; i < len; i++) {
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(awardList[i][0]);
            this.____1840[i].setItemTemplateInfo(itemTemplateInfo);
            this.____1840[i].setCount(awardList[i][1])
        }
    },
    dispose: function() {
        this.____1579 = null;
        this.____1783 = null;
        this._itemList = null;
        if (this.____1840 != null) {
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = null
        }
        this.____1185 = null;
        this._hasFlag = null;
        this._type = null;
        this._worldLabel = null;
        this._super()
    },
});
var OpenOtherRankView = KYPanel.extend({
    _contentBg: null,
    _contentPath: null,
    _content1: null,
    _type: null,
    _timeLabel: null,
    _countDownUtils: null,
    _playerLayerList: null,
    _playerNameList: null,
    _fightValueList: null,
    _listView: null,
    ____1840: null,
    _tipsLabel: null,
    _fightImgList: null,
    ____955: null,
    _currentRankType: 0,
    ctor: function(type) {
        this._super("openRankView.ExportJson");
        this._contentBg = this.getChildByName("bg");
        this._contentPath = ____654.____675.____139("outPic/ui_fightPlaceBg1.png");
        ____654.____677.____146(this._contentBg, this._contentPath);
        this._content1 = this.getChildByName("content1");
        this._content1.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text1"));
        this._type = type;
        this._timeLabel = this.getChildByName("timeLabel");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        this._playerLayerList = [];
        this._playerNameList = [];
        this._fightValueList = [];
        this._fightImgList = [];
        for (var i = 0; i < 3; i++) {
            this._playerLayerList.push(this.getChildByName("playerLayer" + (i + 1)));
            this._playerNameList.push(this.getChildByName("playerName" + (i + 1)));
            this._playerNameList[i].setString("");
            this._fightValueList.push(this.getChildByName("fightValue" + (i + 1)));
            this._fightValueList[i].setString("");
            this._fightImgList.push(this.getChildByName("fightImg" + (i + 1)));
            this._playerNameList[i].setString(____654.yuyanbaoManager.getYuyanbao("____2257.text4"));
            this._fightImgList[i].setVisible(false)
        }
        this.____1840 = [];
        this._listView = this.getChildByName("listView");
        this._tipsLabel = this.getChildByName("tipsLabel");
        var typeList = [1, 2, 3];
        if (this._type == 10) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[0], 1, 3);
            this._currentRankType = typeList[0];
            for (var i = 0; i < 3; i++) {
                this._fightImgList[i].setFrame("flag/ui_strengthFlag.png");
                this._fightImgList[i].setScale(1.25)
            }
        } else if (this._type == 11) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[1], 1, 3);
            this._currentRankType = typeList[1]
        } else if (this._type == 12) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[2], 1, 3);
            this._currentRankType = typeList[2]
        }
        this.____862 = this.getChildByName("barBg");
        this._barBgPath = ____654.____675.____139("outPic/commonBarBg.png");
        ____654.____677.____146(this.____862, this._barBgPath);
        this.____955 = [];
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.setCountDownTime();
        var infoList = ____655.openInfo.getInfoByShowType(this._type);
        var len = infoList[0].conditionList.length;
        for (var i = 0; i < len; i++) {
            var conditionInfo = infoList[0].conditionList[i];
            var awardList = infoList[0].awardList[i];
            var item = new OpenOtherRankItem(this._type);
            item.____18(conditionInfo, awardList);
            this._listView.pushBackItem(item);
            this.____1840.push(item)
        }
        this._listView.setItemsMargin(5)
    },
    setCountDownTime: function() {
        var lastRevertTime = 0;
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        if (openDay <= 3) {
            lastRevertTime = (3 * ____655.____662.secondsOfDay) + ____655.____665 - ____655.____662.getSystemTimeSec();
            this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text5"))
        } else {
            lastRevertTime = (7 * ____655.____662.secondsOfDay) + ____655.____665 - ____655.____662.getSystemTimeSec();
            this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text6"))
        }
        this._countDownUtils.start(lastRevertTime)
    },
    setRankInfo: function(evt) {
        var type = evt.data;
        if (this._currentRankType != type) {
            return
        }
        var infoList = null;
        if (this._type == 10) {
            infoList = ____655.rankInfo.clubRankList
        } else if (this._type == 11) {
            infoList = ____655.rankInfo.xianWeiRankList
        } else if (this._type == 12) {
            infoList = ____655.rankInfo.checkRankList
        }
        for (var i = 0; i < 3; i++) {
            if (infoList[i + 1] != null) {
                if (this._type == 10) {
                    this._playerNameList[i].setString(infoList[i + 1].clubName);
                    this._fightValueList[i].setString(infoList[i + 1].otherFight)
                } else {
                    this._playerNameList[i].setString(infoList[i + 1].userName);
                    this._fightValueList[i].setString(infoList[i + 1].fightValue)
                }
                var character = new ____545(infoList[i + 1].playerInfo.characterInfo);
                character.init(____655.____659.____686.rightBottom, this._playerLayerList[i]);
                character.move(-5, 20);
                this.____955.push(character);
                this._fightImgList[i].setVisible(true)
            }
        }
    },
    ____6: function() {
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.setRankInfo, this)
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.setRankInfo, this)
    },
    dispose: function() {
        this.____17();
        if (this._contentPath != null) {
            ____654.____677.removeImageQuote(this._contentPath, this._contentBg);
            this._contentPath = null
        }
        this._contentBg = null;
        this._content1 = null;
        this._type = null;
        this._timeLabel = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._playerLayerList = null;
        this._playerNameList = null;
        this._fightValueList = null;
        this._listView = null;
        if (this.____1840 != null) {
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = null
        }
        this._tipsLabel = null;
        if (this._barBgPath != null) {
            ____654.____677.removeImageQuote(this._barBgPath, this.____862);
            this._barBgPath = null
        }
        if (this.____955 != null) {
            for (var i = 0; i < this.____955.length; i++) {
                this.____955[i].dispose()
            }
            this.____955 = null
        }
        this.____862 = null;
        this._fightImgList = null;
        this._currentRankType = null;
        this._super()
    },
});
var OpenPanel = KYPanel.extend({
    _controller: null,
    ____1740: null,
    ____1502: null,
    _panelList: null,
    ____1736: null,
    _chgTypeList: null,
    ____1062: -1,
    _moneyView: null,
    ctor: function(controller) {
        this._super("openPanel.ExportJson");
        this._controller = controller;
        this.____1740 = this.getChildByName("tabLayer");
        this.____1502 = this.getChildByName("panelLayer");
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this._panelList = {};
        this.____1736 = [];
        this._chgTypeList = [];
        this.____5()
    },
    ____5: function() {
        var tabList = ____655.allTemplates.openActivityTemplateList.typeList;
        for (var i = 0; i < tabList.length; i++) {
            this._chgTypeList.push(tabList[i]);
            var tabBtn = new ____2143(5);
            var tabName = ____655.openInfo.getInfoByShowType(tabList[i])[0].title;
            if (____655.allTemplates.openActivityTemplateList.countDownTypeList.indexOf(tabList[i]) != -1) {
                tabBtn.setFlagImg()
            }
            tabBtn.setLabel(tabName);
            this.____1740.pushBackItem(tabBtn);
            this.____1736.push(tabBtn);
            this.____1736[i].addListener(this, this.btnTabClickHandler)
        }
        this.____1740.setItemsMargin(5);
        this.setIndexPanel(0);
        this.popUpdate()
    },
    btnTabClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this.____1736.indexOf(sender);
            if (index == this.____1062) {
                return
            } else {
                this.setIndexPanel(index)
            }
        }
    },
    ____6: function() {
        ____655.openInfo.addEventListener(____655.____661.playerInfo_openTemplate, this.closePanel, this);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 70) {
            this.____1736[0].setShowPop(____654.playerInfoTester.openChongBangNum > 0)
        }
    },
    setIndexPanel: function(index) {
        if (this.____1062 != -1) {
            this.____1736[this.____1062].setSelected(false);
            this._panelList[this.____1062].removeFromParent(false)
        }
        this.____1062 = index;
        var curType = this._chgTypeList[this.____1062];
        this.____1736[this.____1062].setSelected(true);
        if (this._panelList[this.____1062] == null) {
            this._panelList[this.____1062] = this.getPanel(curType)
        }
        this.____1502.addChild(this._panelList[this.____1062])
    },
    getPanel: function(type) {
        var panel = null;
        if (panel == null) {
            if (type == 1) {
                panel = new OpenLuckyBagView(type)
            } else if (type == 2) {
                panel = new OpenFreeGoldView(type)
            } else if (type >= 3 && type <= 9) {
                panel = new OpenRankView(type)
            } else if (type >= 10 && type <= 12) {
                panel = new OpenOtherRankView(type)
            }
        }
        return panel
    },
    ____17: function() {
        ____655.openInfo.removeEventListener(____655.____661.playerInfo_openTemplate, this.closePanel, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    closePanel: function() {
        ____654.____676.uiPanelContainer.close()
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1740 = null;
        this.____1502 = null;
        if (this._panelList != null) {
            for (var i in this._panelList) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        if (this.____1736 != null) {
            for (var i = 0; i < this.____1736.length; i++) {
                this.____1736[i].dispose()
            }
            this.____1736 = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this._chgTypeList = null;
        this.____1062 = null;
        this._super()
    },
});
var OpenRankItem = KYNode.extend({
    ____1579: null,
    ____1783: null,
    _itemList: null,
    ____1840: null,
    ____1185: null,
    _hasFlag: null,
    _type: null,
    _stage: 0,
    _selfInfo: null,
    _itemInfo: null,
    ____1126: null,
    ____1165: null,
    ____1241: 0,
    _worldLabel: null,
    _itemInfoList: null,
    ctor: function(type) {
        this._super("openRankItem.ExportJson");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1783 = this.getChildByName("tipLabel");
        this.____1783.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text2"));
        this._itemList = [];
        this.____1840 = [];
        this._itemInfoList = [];
        for (var i = 0; i < 5; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            this._itemInfoList[i] = new ItemInfo();
            this._itemList[i].addChild(grid);
            this.____1840.push(grid)
        }
        this._type = type;
        this.____1185 = this.getChildByName("getBtn");
        this._hasFlag = this.getChildByName("hasFlag");
        this._worldLabel = this.getChildByName("wordLabel");
        this._worldLabel.setString("奖励");
        this.____1185.setVisible(false);
        this._hasFlag.setVisible(false);
        this.____1783.setVisible(false);
        this.____6()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____1185) {
                if (this.____1165 == 0) {
                    this.triggerHandler(this.____1241)
                } else if (this.____1165 == 1) {
                    ____654.selfDataMessageSender.sendOpenAwardGet(this._itemInfo.id)
                }
            }
        }
    },
    ____6: function() {
        this.____1185.addListener(this, this.____16)
    },
    ____17: function() {},
    ____18: function(itemInfo) {
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(parseInt(itemInfo.conditionList));
        var value = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(parseInt(itemInfo.conditionList));
        this.____1579.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text12", value, star));
        this._itemInfo = itemInfo;
        var len = 0;
        if (itemInfo.awardList.length > 5) {
            len = 5
        } else {
            len = itemInfo.awardList.length
        }
        for (var i = 0; i < len; i++) {
            this._itemInfoList[i].____107(itemInfo.awardList[i][0]);
            this._itemInfoList[i].count = itemInfo.awardList[i][1];
            if (itemInfo.awardList[i][2] != null) {
                this._itemInfoList[i].qhLevel = itemInfo.awardList[i][2]
            }
            if (itemInfo.awardList[i][3] != null) {
                this._itemInfoList[i].quality = itemInfo.awardList[i][3]
            }
            this.____1840[i].setItemInfo(this._itemInfoList[i])
        }
        if (this._type == 3) {
            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Horse) != null) {
                this._stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Horse).starCount
            } else {
                this._stage = 0
            }
            this.____1241 = 1
        } else if (this._type == 4) {
            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Pet) != null) {
                this._stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Pet).starCount
            } else {
                this._stage = 0
            }
            this.____1241 = 2
        } else if (this._type == 5) {
            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Wind) != null) {
                this._stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Wind).starCount
            } else {
                this._stage = 0
            }
            this.____1241 = 3
        } else if (this._type == 6) {
            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Foot) != null) {
                this._stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Foot).starCount
            } else {
                this._stage = 0
            }
            this.____1241 = 4
        } else if (this._type == 7) {
            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_FaBao) != null) {
                this._stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_FaBao).starCount
            } else {
                this._stage = 0
            }
            this.____1241 = 5
        } else if (this._type == 8) {
            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ZhengLing) != null) {
                this._stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ZhengLing).starCount
            } else {
                this._stage = 0
            }
            this.____1241 = 6
        } else if (this._type == 9) {
            if (____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ShenJian) != null) {
                this._stage = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ShenJian).starCount
            } else {
                this._stage = 0
            }
            this.____1241 = 7
        }
        this._selfInfo = ____655.openInfo.getSelfInfoById(itemInfo.id);
        if (this._selfInfo != null) {
            if (this.____1126 != null) {
                this.____1126.dispose();
                this.____1126 = null
            }
            this.____1185.setVisible(false);
            this.____1783.setVisible(false);
            this._hasFlag.setVisible(true);
            this.____1165 = 2
        } else {
            this.____1185.setVisible(true);
            this.____1783.setVisible(true);
            this._hasFlag.setVisible(false);
            if (this._stage >= parseInt(itemInfo.conditionList)) {
                this.____1783.setString("领 取");
                if (this.____1126 != null) {
                    this.____1126.dispose();
                    this.____1126 = null
                }
                this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(58, 28), this.____1185);
                this.____1165 = 1
            } else {
                this.____1783.setString("前 往");
                this.____1165 = 0
            }
        }
    },
    getFlagState: function() {
        return this.____1165
    },
    triggerHandler: function(index) {
        if ((index == 1) && !this.checkLevel(____655.____659.levelType.riderLevel)) {
            return
        } else if (index == 2 && !this.checkLevel(____655.____659.levelType.petLevel)) {
            return
        } else if (index == 3 && !this.checkLevel(____655.____659.levelType.wingLevel)) {
            return
        } else if (index == 4 && !this.checkLevel(____655.____659.levelType.footLevel)) {
            return
        } else if (index == 5 && !this.checkLevel(____655.____659.levelType.fabaoLevel)) {
            return
        } else if (index == 6 && !this.checkLevel(____655.____659.levelType.zhenlingLevel)) {
            return
        } else if (index == 7 && !this.checkLevel(____655.____659.levelType.shenjianLevel)) {
            return
        }
        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, index)
    },
    checkLevel: function(level) {
        if (____655.____667.level >= level) {
            return true
        } else {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2340.text1", level));
            return false
        }
    },
    dispose: function() {
        this.____17();
        this.____1579 = null;
        this.____1783 = null;
        this._itemList = null;
        if (this.____1840 != null) {
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = null
        }
        this.____1185 = null;
        this._hasFlag = null;
        this._type = null;
        this._stage = null;
        this._selfInfo = null;
        this._itemInfo = null;
        this.____1165 = null;
        this.____1241 = null;
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._worldLabel = null;
        if (this._itemInfoList != null) {
            for (var i = 0; i < this._itemInfoList.length; i++) {
                this._itemInfoList[i].dispose()
            }
            this._itemInfoList = null
        }
        this._super()
    },
});
var OpenRankView = KYPanel.extend({
    _contentBg: null,
    _contentPath: null,
    _content1: null,
    _type: null,
    _timeLabel: null,
    _countDownUtils: null,
    _playerLayerList: null,
    _playerNameList: null,
    _fightValueList: null,
    _listView: null,
    ____1840: null,
    ____955: null,
    _fightImgList: null,
    _currentRankType: 0,
    ____1251: null,
    ctor: function(type) {
        this._super("openRankView.ExportJson");
        this._contentBg = this.getChildByName("bg");
        this._contentPath = ____654.____675.____139("outPic/ui_fightPlaceBg1.png");
        ____654.____677.____146(this._contentBg, this._contentPath);
        this._content1 = this.getChildByName("content1");
        this._content1.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text1"));
        this._type = type;
        this._timeLabel = this.getChildByName("timeLabel");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        this._playerLayerList = [];
        this._playerNameList = [];
        this._fightValueList = [];
        this._fightImgList = [];
        for (var i = 0; i < 3; i++) {
            this._playerLayerList.push(this.getChildByName("playerLayer" + (i + 1)));
            this._playerNameList.push(this.getChildByName("playerName" + (i + 1)));
            this._playerNameList[i].setString("");
            this._fightValueList.push(this.getChildByName("fightValue" + (i + 1)));
            this._fightValueList[i].setString("");
            this._fightImgList.push(this.getChildByName("fightImg" + (i + 1)));
            this._playerNameList[i].setString(____654.yuyanbaoManager.getYuyanbao("____2257.text4"));
            this._fightImgList[i].setVisible(false)
        }
        this.____1840 = [];
        this._listView = this.getChildByName("listView");
        var typeList = [5, 6, 7, 8, 9, 10, 11];
        if (this._type == 3) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[0], 1, 3);
            this._currentRankType = typeList[0]
        } else if (this._type == 4) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[1], 1, 3);
            this._currentRankType = typeList[1]
        } else if (this._type == 5) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[2], 1, 3);
            this._currentRankType = typeList[2]
        } else if (this._type == 6) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[3], 1, 3);
            this._currentRankType = typeList[3]
        } else if (this._type == 7) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[4], 1, 3);
            this._currentRankType = typeList[4]
        } else if (this._type == 8) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[5], 1, 3);
            this._currentRankType = typeList[5]
        } else if (this._type == 9) {
            ____654.rankMessageSender.sendGetRankInfo(typeList[6], 1, 3);
            this._currentRankType = typeList[6]
        }
        this.____862 = this.getChildByName("barBg");
        this._barBgPath = ____654.____675.____139("outPic/commonBarBg.png");
        ____654.____677.____146(this.____862, this._barBgPath);
        this.____955 = [];
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.setCountDownTime();
        if (this.____1840 != null) {
            this._listView.removeAllItems();
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = []
        }
        this.____1251 = ____655.openInfo.getInfoByShowType(this._type);
        var len = this.____1251.length;
        var list1 = [];
        var list2 = [];
        var list3 = [];
        for (var i = 0; i < len; i++) {
            var item = new OpenRankItem(this._type);
            item.____18(this.____1251[i]);
            if (item.getFlagState() == 0) {
                list2.push(item)
            } else if (item.getFlagState() == 1) {
                list1.push(item)
            } else if (item.getFlagState() == 2) {
                list3.push(item)
            }
        }
        for (var i = 0; i < list1.length; i++) {
            this._listView.pushBackItem(list1[i]);
            this.____1840.push(list1[i])
        }
        for (var i = 0; i < list2.length; i++) {
            this._listView.pushBackItem(list2[i]);
            this.____1840.push(list2[i])
        }
        for (var i = 0; i < list3.length; i++) {
            this._listView.pushBackItem(list3[i]);
            this.____1840.push(list3[i])
        }
        var list1 = null;
        var list2 = null;
        var list3 = null;
        this._listView.setItemsMargin(5)
    },
    setCountDownTime: function() {
        var lastRevertTime = 0;
        lastRevertTime = ____655.____662.secondsOfDay - ____655.____662.getZeroPassTime();
        this._countDownUtils.start(lastRevertTime)
    },
    setRankInfo: function(evt) {
        var type = evt.data;
        if (this._currentRankType != type) {
            return
        }
        var infoList = null;
        if (this._type == 3) {
            infoList = ____655.rankInfo.riderRankList
        } else if (this._type == 4) {
            infoList = ____655.rankInfo.petRankList
        } else if (this._type == 5) {
            infoList = ____655.rankInfo.wingRankList
        } else if (this._type == 6) {
            infoList = ____655.rankInfo.footPrintRankList
        } else if (this._type == 7) {
            infoList = ____655.rankInfo.fabaoRankList
        } else if (this._type == 8) {
            infoList = ____655.rankInfo.zhenLingRankList
        } else if (this._type == 9) {
            infoList = ____655.rankInfo.shenJiangRankList
        }
        for (var i = 0; i < 3; i++) {
            if (infoList[i + 1] != null) {
                this._playerNameList[i].setString(infoList[i + 1].userName);
                this._fightValueList[i].setString(infoList[i + 1].otherFight);
                var character = new ____545(infoList[i + 1].playerInfo.characterInfo);
                character.init(____655.____659.____686.rightBottom, this._playerLayerList[i], 3);
                character.move(-6, 20);
                this.____955.push(character);
                this._fightImgList[i].setVisible(true)
            }
        }
    },
    reflashItem: function(evt) {
        var id = evt.data;
        if (id == null) {
            return
        }
        for (var i = 0; i < this.____1251.length; i++) {
            if (this.____1251[i].id == id) {
                this.____5();
                break
            }
        }
    },
    ____6: function() {
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.setRankInfo, this);
        ____655.openInfo.addEventListener(____655.____661.playerInfo_selfInfo_Update, this.reflashItem, this)
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.setRankInfo, this);
        ____655.openInfo.removeEventListener(____655.____661.playerInfo_selfInfo_Update, this.reflashItem, this)
    },
    dispose: function() {
        this.____17();
        if (this._contentPath != null) {
            ____654.____677.removeImageQuote(this._contentPath, this._contentBg);
            this._contentPath = null
        }
        this._contentBg = null;
        this._content1 = null;
        this._type = null;
        this._timeLabel = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._playerLayerList = null;
        this._playerNameList = null;
        this._fightValueList = null;
        this._listView = null;
        if (this.____1840 != null) {
            for (var i = 0; i < this.____1840.length; i++) {
                this.____1840[i].dispose()
            }
            this.____1840 = null
        }
        if (this._barBgPath != null) {
            ____654.____677.removeImageQuote(this._barBgPath, this.____862);
            this._barBgPath = null
        }
        if (this.____955 != null) {
            for (var i = 0; i < this.____955.length; i++) {
                this.____955[i].dispose()
            }
            this.____955 = null
        }
        this.____862 = null;
        this._fightImgList = null;
        this._currentRankType = null;
        this._super()
    },
});
var OpenController = cc.Class.extend({
    openModule: null,
    ctor: function(module) {
        this.openModule = module;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showOpenPanel: function(type) {
        if (this.openModule.openPanel == null) {
            this.openModule.openPanel = new OpenPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.openModule.openPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.openModule.openPanel) {
            this.openModule.openPanel = null
        }
    },
});
var OpenModule = ____537.extend({
    openController: null,
    openPanel: null,
    setup: function(data) {
        this.openController = new OpenController(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.open) {
            this.openController.showOpenPanel(data[0])
        }
    },
    clear: function() {},
});
var OpenLeiChongPanel = KYPanel.extend({
    _controller: null,
    ____877: null,
    _boradPath: null,
    _layerList: null,
    _hadGetFlagList: null,
    _gridList: null,
    _itemList: null,
    ____1021: null,
    ____1568: null,
    _content1: null,
    _content2: null,
    _timeTips: null,
    _goldValueLabel: null,
    _goodsNameLabel: null,
    _timeLabel: null,
    _countDownUtils: null,
    ____1508: null,
    ____1509: null,
    ____1251: null,
    _characterInfo: null,
    ____944: null,
    ____947: null,
    ____945: null,
    _nameList: null,
    _nameLabelList: null,
    _godWeaponEffect: null,
    _effectList: null,
    ctor: function(controller) {
        this._super("openLeiChongPanel.ExportJson");
        this._controller = controller;
        this.____877 = this.getChildByName("borad");
        this._boradPath = ____654.____675.____139("outPic/openLeiChongBg.png");
        ____654.____677.____146(this.____877, this._boradPath);
        this._layerList = [];
        this._hadGetFlagList = [];
        this._gridList = [];
        this._itemList = [];
        this._effectList = [];
        for (var i = 0; i < 3; i++) {
            this._layerList.push(this.getChildByName("layer" + (i + 1)));
            this._hadGetFlagList.push(this.getChildByName("hadGetFlag" + (i + 1)));
            this._hadGetFlagList[i].setVisible(false);
            for (var j = 0; j < 3; j++) {
                if (this._gridList[i] == null) {
                    this._gridList[i] = []
                }
                if (this._itemList[i] == null) {
                    this._itemList[i] = []
                }
                this._itemList[i].push(this.getChildByName("cell" + (i + 1) + (j + 1)));
                var grid = new ____2129();
                this._itemList[i][j].addChild(grid);
                this._gridList[i].push(grid)
            }
        }
        this.____1021 = this.getChildByName("countBar");
        this._nameList = [____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text1"), ____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text2"), ____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text3")];
        this._nameLabelList = [];
        this.____1568 = [];
        for (var i = 0; i < 3; i++) {
            this.____1568.push(this.getChildByName("proValue" + (i + 1)));
            this._nameLabelList.push(this.getChildByName("goodsLabel" + (i + 1)));
            this._nameLabelList[i].setString(this._nameList[i])
        }
        this._content1 = this.getChildByName("content1");
        this._content1.setString(____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text4"));
        this._content2 = this.getChildByName("content2");
        this._content2.setString(____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text5"));
        this._timeTips = this.getChildByName("timeTips");
        this._timeTips.setString(____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text6"));
        this._goldValueLabel = this.getChildByName("goldValueLabel");
        this._goodsNameLabel = this.getChildByName("goodsNameLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        this.____1508 = this.getChildByName("buyBtn_Copy0");
        var sexType = ____655.____667.career;
        for (var i = 0; i < 3; i++) {
            if (i == 0) {
                this._godWeaponEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.SHENBING_EFFECT1, false, ____654.____673.____159(20, 25), this._layerList[i]);
                this._godWeaponEffect.setLocalZOrder(15)
            } else if (i == 1) {
                var styleList = {};
                var figureId = 0;
                if (sexType == 1) {
                    figureId = 110801
                } else if (sexType == 2) {
                    figureId = 120801
                }
                styleList[____655.____659.commonStaticType.style_Cloth] = figureId;
                this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Cloth, ____655.____659.____687.playerStand1);
                this._characterInfo.updateStyle(styleList);
                this.____944 = new ____545(this._characterInfo);
                this.____944.init(____655.____659.____686.rightBottom, this._layerList[i], 10);
                this.____944.move(10, 40);
                this.____944.setScale(1.2)
            } else if (i == 2) {
                this.____947 = ____654.getCharacterInfo(8065, ____655.____659.____687.stand);
                this.____945 = new ____545(this.____947);
                this.____945.init(____655.____659.____686.rightBottom, this._layerList[i], 10);
                this.____945.move(10, 60)
            }
            this._effectList[i] = ____654.effectManager.setEffect(____655.allTemplates.____789.CHARACTER_BG_EFFECT, false, ____654.____673.____159(15, 8), this._layerList[i]);
            this._effectList[i].setLocalZOrder(8)
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.setCountDownTime();
        this.____1251 = ____655.allTemplates.openActivityTemplateList.openLeiChongList;
        for (var i = 0; i < 3; i++) {
            var info = this.____1251[i];
            if (info != null) {
                var len = info.awardList.length;
                if (len > 3) len = 3;
                for (var j = 0; j < len; j++) {
                    var itemTemplateInfo = ____655.allTemplates.____794.getItem(info.awardList[j][0]);
                    this._gridList[i][j].setItemTemplateInfo(itemTemplateInfo);
                    this._gridList[i][j].setCount(info.awardList[j][1])
                }
            }
            this.____1568[i].setString(____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text7", info.conditionList))
        }
        this.updateView();
        this.updateView1()
    },
    setCountDownTime: function() {
        var lastRevertTime = 0;
        lastRevertTime = (____655.____662.secondsOfDay) + ____655.____665 - ____655.____662.getSystemTimeSec();
        this._countDownUtils.start(lastRevertTime)
    },
    updateView: function() {
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        if (openDay > 2) return;
        var chongZhiScore = ____655.____667.moneyInfo.getChongZhiScore(____655.____665);
        if (chongZhiScore < parseInt(this.____1251[0].conditionList)) {
            this._goldValueLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text8", (parseInt(this.____1251[0].conditionList) - chongZhiScore)));
            this._goodsNameLabel.setString(____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text8"));
            this.____1021.setPercent(chongZhiScore * 0.25)
        } else if (chongZhiScore < parseInt(this.____1251[1].conditionList)) {
            this._goldValueLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text8", (parseInt(this.____1251[1].conditionList) - chongZhiScore)));
            this._goodsNameLabel.setString(____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text9"));
            this.____1021.setPercent((chongZhiScore - parseInt(this.____1251[0].conditionList)) * 0.0565 + 15)
        } else if (chongZhiScore < parseInt(this.____1251[2].conditionList)) {
            this._goldValueLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text8", (parseInt(this.____1251[2].conditionList) - chongZhiScore)));
            this._goodsNameLabel.setString(____654.yuyanbaoManager.getYuyanbao("OpenLeiChongPanel.text10"));
            this.____1021.setPercent((chongZhiScore - parseInt(this.____1251[1].conditionList)) * 0.0833 + 50)
        } else if (chongZhiScore >= parseInt(this.____1251[2].conditionList)) {
            this.____1021.setPercent(100)
        }
    },
    updateView1: function() {
        for (var i = 0; i < 3; i++) {
            var selfInfo = ____655.openInfo.getSelfInfoById(this.____1251[i].id);
            if (selfInfo == null) {
                this._hadGetFlagList[i].setVisible(false)
            } else {
                if (selfInfo.count > 0) {
                    this._hadGetFlagList[i].setVisible(true)
                } else {
                    this._hadGetFlagList[i].setVisible(false)
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1508) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672));
                this.closePanel()
            }
        }
    },
    ____6: function() {
        this.____1508.addListener(this, this.____16);
        ____655.openInfo.addEventListener(____655.____661.playerInfo_openTemplate, this.closePanel, this);
        ____655.____667.moneyInfo.addEventListener(____655.____661.____701, this.updateView, this);
        ____655.openInfo.addEventListener(____655.____661.playerInfo_selfInfo_Update, this.updateView1, this)
    },
    ____17: function() {
        ____655.openInfo.removeEventListener(____655.____661.playerInfo_openTemplate, this.closePanel, this);
        ____655.____667.moneyInfo.removeEventListener(____655.____661.____701, this.updateView, this);
        ____655.openInfo.removeEventListener(____655.____661.playerInfo_selfInfo_Update, this.updateView1, this)
    },
    closePanel: function() {
        ____654.____676.uiPanelContainer.close()
    },
    dispose: function() {
        this.____17();
        if (this._boradPath != null) {
            ____654.____677.removeImageQuote(this._boradPath, this.____877);
            this._boradPath = null
        }
        this.____877 = null;
        this._controller = null;
        this._layerList = null;
        this._hadGetFlagList = null;
        this._itemList = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                for (var j = 0; j < this._gridList[i].length; j++) {
                    this._gridList[i][j].dispose()
                }
            }
            this._gridList = null
        }
        this.____1021 = null;
        this.____1568 = null;
        this._content1 = null;
        this._content2 = null;
        this._timeTips = null;
        this._goldValueLabel = null;
        this._goodsNameLabel = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._timeLabel = null;
        this.____1508 = null;
        this.____1509 = null;
        this.____1251 = null;
        if (this.____945 != null) {
            this.____945.dispose();
            this.____945 = null
        }
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this.____947 != null) {
            this.____947.dispose();
            this.____947 = null
        }
        if (this._godWeaponEffect != null) {
            this._godWeaponEffect.dispose();
            this._godWeaponEffect = null
        }
        if (this._effectList != null) {
            for (var i = 0; i < this._effectList.length; i++) {
                this._effectList[i].dispose()
            }
            this._effectList = null
        }
        this._nameList = null;
        this._nameLabelList = null;
        this._super()
    },
});
var OpenLeiChongController = cc.Class.extend({
    openLeiChongModule: null,
    ctor: function(module) {
        this.openLeiChongModule = module;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showOpenLeiChongPanel: function(type) {
        if (this.openLeiChongModule.openLeiChongPanel == null) {
            this.openLeiChongModule.openLeiChongPanel = new OpenLeiChongPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.openLeiChongModule.openLeiChongPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.openLeiChongModule.openLeiChongPanel) {
            this.openLeiChongModule.openLeiChongPanel = null
        }
    },
});
var OpenLeiChongModule = ____537.extend({
    openLeiChongController: null,
    openLeiChongPanel: null,
    setup: function(data) {
        this.openLeiChongController = new OpenLeiChongController(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.openLeiChong) {
            this.openLeiChongController.showOpenLeiChongPanel(data[0])
        }
    },
    clear: function() {},
});
var PrePayPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _titleLabel: null,
    _bgPic: null,
    _bgPath: null,
    _describeLabel: null,
    _leftTimeLabel: null,
    _time: null,
    ____1510: null,
    _payNum: null,
    _getJewelLabel: null,
    _getJewelNum: null,
    _btnPay: null,
    _moneyLayer: null,
    _moneyView: null,
    _countDownUtils: null,
    ctor: function(scenePanelController) {
        this._super("prePayPanel.ExportJson");
        this.modeValue = 200;
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this._bgPic = this.getChildByName("bgPic");
        this._bgPath = ____654.____675.____139("outPic/ui_prePay.png");
        ____654.____677.____146(this._bgPic, this._bgPath);
        this._describeLabel = this.getChildByName("describeLabel");
        this._leftTimeLabel = this.getChildByName("leftTimeLabel");
        this._time = this.getChildByName("time");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._time, 0, 0, null);
        this.____1510 = this.getChildByName("payLabel");
        this._payNum = this.getChildByName("payNum");
        this._getJewelLabel = this.getChildByName("getJewelLabel");
        this._getJewelNum = this.getChildByName("getJewelNum");
        this._btnPay = this.getChildByName("btnPay");
        this._moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        this._moneyLayer.addChild(this._moneyView);
        this._titleLabel = ____654.____673.newKYLabel(30, true);
        this._titleLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this._titleLabel.setPosition(____654.____673.____159(29, 604));
        this._titleLabel.setString("预充送钻");
        this.addChild(this._titleLabel, 1);
        this.____5();
        this.____6();
        ____654.____676.hideBack()
    },
    ____5: function() {
        this._describeLabel.setString(____654.____682.____108(10074));
        if (____655.activityIconList.activityIcons[15] != null) {
            var leftTime = ____655.activityIconList.activityIcons[15].endTime - ____655.____662.getSystemTimeSec();
            this._countDownUtils.start(leftTime)
        }
        var score = Math.floor(____655.____667.moneyInfo.getMoneyCountByType(9) * 0.1);
        this._payNum.setString(score + "元");
        this._getJewelNum.setString(score * 15 + "钻石")
    },
    ____6: function() {
        this._btnPay.addListener(this, this.clickHandler);
        this._closeBtn.addListener(this, this.clickHandler);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this._btnPay) {
                this.dispose();
                ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
            }
        }
    },
    dispose: function() {
        ____654.____676.showBack();
        this.____17();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bgPic);
            this._bgPath = null
        }
        this._bgPic = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this._titleLabel != null) {
            this._titleLabel.dispose();
            this._titleLabel = null
        }
        this._closeBtn = null;
        this._describeLabel = null;
        this._leftTimeLabel = null;
        this._time = null;
        this.____1510 = null;
        this._payNum = null;
        this._getJewelLabel = null;
        this._getJewelNum = null;
        this._btnPay = null;
        this._moneyLayer = null;
        this._super()
    },
});
var ____2206 = KYNode.extend({
    _controller: null,
    _checkRankInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _fightValue1: null,
    _fightValue2: null,
    _fightValue3: null,
    _fightValue4: null,
    ____1237: null,
    ctor: function() {
        this._super("rankFashionItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._fightValue1 = this.getChildByName("fightValue1");
        this._fightValue2 = this.getChildByName("fightValue2");
        this._fightValue3 = this.getChildByName("fightValue3");
        this._fightValue4 = this.getChildByName("fightValue4");
        this.____1237 = this.getChildByName("iconImg");
        this.____6()
    },
    ____18: function(checkRankInfo) {
        this._checkRankInfo = checkRankInfo;
        if (checkRankInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + checkRankInfo.rank + ".png", 1)
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(checkRankInfo.rank)
        }
        this.____1526.setString(checkRankInfo.userName);
        this._fightValue1.setString(checkRankInfo.clubName);
        this._fightValue2.setString(____655.____659.nameType.getXianweiName(checkRankInfo.xianWei));
        this._fightValue3.setString(checkRankInfo.otherStage);
        this._fightValue4.setString(checkRankInfo.fightValue)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._checkRankInfo.userId, this._checkRankInfo.serverId);
                ____655.lookInfo.panelType = 3
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this.checkRankInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._fightValue1 = null;
        this._fightValue2 = null;
        this._fightValue3 = null;
        this._fightValue4 = null;
        this.____1237 = null;
        this._super()
    },
});
var ____2207 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    _title5: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankFashionPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString("家族");
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2243.text4"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("TuJianPanel.text6"));
        this._title5 = this.getChildByName("title5");
        this._title5.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text3"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2206();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(3, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 3) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function(evt) {
        var len = ____655.rankInfo.lengthList[3];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[3];
        if (len == null) {
            len = 0
        }
        for (var i = 1; i <= len; i++) {
            var checkRankInfo = ____655.rankInfo.checkRankList[i];
            if (checkRankInfo == null) {
                break
            }
            if (____655.____667.userId == checkRankInfo.userId) {
                this.____1646.____18(checkRankInfo);
                return
            }
        }
        this.____1646.____1579.setString("20+");
        this.____1646.____1526.setString(____655.____667.nick);
        var careerName = ____655.____659.nameType.getCareerName(____655.____667.career);
        if (____655.____667.clubName != "") {
            this.____1646._fightValue1.setString(____655.____667.clubName)
        } else {
            this.____1646._fightValue1.setString("无")
        }
        this.____1646._fightValue2.setString(____655.____659.nameType.getSelfXianweiName());
        var starCount = 0;
        var myFight = 0;
        var tuJianTempList = ____655.allTemplates.tuJianTemplateList.tuJianList;
        for (var i = 0; i < tuJianTempList.length; i++) {
            var type = tuJianTempList[i].id;
            var tempInfoList = ____655.allTemplates.fashionTemplateList.getList(type);
            if (tempInfoList != null && tempInfoList.length > 0) {
                var star = 99;
                for (var j = 0; j < tempInfoList.length; j++) {
                    var id = tempInfoList[j].templateId;
                    var info = ____655.fashionInfo.getFashionInfo(type, id);
                    if (info != null) {
                        myFight += tempInfoList[j].stars[info.star].fightValue;
                        starCount += info.star;
                        if (star > info.star) {
                            star = info.star
                        }
                    } else {
                        star = 0
                    }
                }
                var propertyList = tuJianTempList[i].propertyList;
                var propertyId = tempInfoList[0].stars[1].attrStr[0].id;
                var propertyValue = 0;
                for (var j = 0; j < propertyList.length; j++) {
                    if (propertyList[j][0] <= star) {
                        propertyValue += propertyList[j][2]
                    }
                }
                myFight += ____655.____659.propertyType.getFight(propertyId, propertyValue)
            }
        }
        this.____1646._fightValue3.setString(starCount);
        this.____1646._fightValue4.setString(myFight)
    },
    getItemByIndex: function(index) {
        var checkRankInfo = ____655.rankInfo.checkRankList[index + 1];
        if (checkRankInfo == null) return;
        var item = new ____2206();
        item.____18(checkRankInfo);
        return item
    },
    getIdByIndex: function(index) {
        var checkRankInfo = ____655.rankInfo.checkRankList[index + 1];
        if (checkRankInfo == null) - 1;
        return checkRankInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        this._title5 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2208 = KYNode.extend({
    _controller: null,
    _clubInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _riderName: null,
    _starName: null,
    ____1159: null,
    ____1237: null,
    ____1586: null,
    ____909: null,
    ctor: function() {
        this._super("rankRiderItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._riderName = this.getChildByName("riderName");
        this._starName = this.getChildByName("starName");
        this.____1159 = this.getChildByName("fightValue");
        this.____1237 = this.getChildByName("iconImg");
        this.____1237.setVisible(false);
        this.____1586 = this.getChildByName("upBtn_Copy0");
        this.____909 = this.getChildByName("titleLabel");
        if (____655.____667.clubId > 0) {
            this.____1586.setVisible(false);
            this.____909.setVisible(false)
        }
        this.____6()
    },
    ____18: function(clubInfo) {
        this._clubInfo = clubInfo;
        if (clubInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + clubInfo.rank + ".png")
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(clubInfo.rank)
        }
        this.____1526.setString(clubInfo.clubName);
        this._riderName.setString(clubInfo.userName);
        this._starName.setString(clubInfo.otherStage + "/" + ____655.clubItemList.clubMemberNums);
        this.____1159.setString(clubInfo.otherFight)
    },
    updateBtnState: function() {
        if (this._clubInfo == null) {
            return
        }
        var index = ____654.____674.____181(____655.clubInfo.selfRequteList, this._clubInfo.userId);
        if (index > -1) {
            this.____1586.setFrame("btn/ui_btn1_4.png");
            this.____909.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text6"));
            this.____1586.setTouchEnabled(false)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1586) {
                if (____655.clubInfo.selfRequteNum < 5) {
                    this.____1586.setFrame("btn/ui_btn1_4.png");
                    this.____1586.setTouchEnabled(false);
                    this.____909.setString(____654.yuyanbaoManager.getYuyanbao("____2162.text6"));
                    ____654.clubMessageSender.sendApplyClub(this._clubInfo.userId)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2162.text7"))
                }
            }
        }
    },
    ____6: function() {
        ____654.clubMessageSender.sendRequteClubInfo();
        this.____1586.addListener(this, this.____16, null, null, null, false, true);
        ____655.clubInfo.addEventListener(____655.____661.club_RequteInfo, this.updateBtnState, this)
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_RequteInfo, this.updateBtnState, this)
    },
    dispose: function() {
        this.____17();
        this._clubInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._riderName = null;
        this._starName = null;
        this.____1159 = null;
        this.____1237 = null;
        this.____1586 = null;
        this._super()
    },
});
var ____2209 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankRiderPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text5"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("ClubInfo.text1"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text6"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text7"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2208();
        this.____1646.____1586.setVisible(false);
        this.____1646.____909.setVisible(false);
        this.____1646.setPositionY(0);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(1, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    infoUpdate: function(evt) {
        if (evt.data == 1) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function() {
        var len = ____655.rankInfo.lengthList[1];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[1];
        if (len == null) {
            len = 0
        }
        for (var i = 1; i <= len; i++) {
            var clubRankInfo = ____655.rankInfo.clubRankList[i];
            if (clubRankInfo == null) {
                break
            }
            if (____655.____667.clubId == clubRankInfo.userId) {
                this.____1646.____18(clubRankInfo);
                return
            }
        }
        if (____655.clubInfo.id > 0) {
            this.____1646.____1579.setString("20+");
            this.____1646.____1526.setString(____655.____667.clubName);
            this.____1646._riderName.setString(____655.clubInfo.masterName);
            this.____1646._starName.setString(____655.clubInfo.memberCount + "/" + ____655.clubItemList.clubMemberNums);
            this.____1646.____1159.setString(____655.clubInfo.fight)
        } else {
            this.____1646.____1579.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text9"))
        }
    },
    getItemByIndex: function(index) {
        var clubRankInfo = ____655.rankInfo.clubRankList[index + 1];
        if (clubRankInfo == null) return null;
        var item = new ____2208();
        item.____18(clubRankInfo);
        return item
    },
    getIdByIndex: function(index) {
        var clubRankInfo = ____655.rankInfo.clubRankList[index + 1];
        if (clubRankInfo == null) return -1;
        return clubRankInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2210 = KYNode.extend({
    _controller: null,
    _fabaoInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _riderName: null,
    _starName: null,
    ____1159: null,
    ____1237: null,
    ____1586: null,
    ____909: null,
    ctor: function() {
        this._super("rankRiderItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._riderName = this.getChildByName("riderName");
        this._starName = this.getChildByName("starName");
        this.____1159 = this.getChildByName("fightValue");
        this.____1237 = this.getChildByName("iconImg");
        this.____1586 = this.getChildByName("upBtn_Copy0");
        this.____909 = this.getChildByName("titleLabel");
        this.____909.setVisible(false);
        this.____1586.setVisible(false);
        this.____6()
    },
    ____18: function(fabaoInfo) {
        this._fabaoInfo = fabaoInfo;
        if (fabaoInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + fabaoInfo.rank + ".png", 1)
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(fabaoInfo.rank)
        }
        this.____1526.setString(fabaoInfo.userName);
        this._riderName.setString(fabaoInfo.petName);
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(fabaoInfo.otherStage);
        var stageName = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(fabaoInfo.otherStage);
        this._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
        this.____1159.setString(fabaoInfo.otherFight)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._fabaoInfo.userId, this._fabaoInfo.serverId);
                ____655.lookInfo.panelType = 9
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._fabaoInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._riderName = null;
        this._starName = null;
        this.____1159 = null;
        this.____1237 = null;
        this.____1586 = null;
        this.____909 = null;
        this._super()
    },
});
var ____2211 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankRiderPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text6"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text7"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text8"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2210();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(9, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 9) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function(evt) {
        var len = ____655.rankInfo.lengthList[9];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[9];
        for (var i = 1; i <= len; i++) {
            var fabaoRankInfo = ____655.rankInfo.fabaoRankList[i];
            if (fabaoRankInfo == null) {
                break
            }
            if (____655.____667.userId == fabaoRankInfo.userId) {
                this.____1646.____18(fabaoRankInfo);
                return
            }
        }
        var fabaoInfo = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_FaBao);
        if (fabaoInfo != null) {
            this.____1646.____1579.setString("20+");
            this.____1646.____1526.setString(____655.____667.nick);
            var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(fabaoInfo.type, fabaoInfo.starCount);
            this.____1646._riderName.setString(stageTempInfo.name);
            var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(fabaoInfo.starCount);
            var stageName = ____655.____659.nameType.getChineseNumber2(stage);
            var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(fabaoInfo.starCount);
            this.____1646._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
            this.____1646.____1159.setString(fabaoInfo.fight)
        } else {
            this.____1646.____1579.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text9"))
        }
    },
    getItemByIndex: function(index) {
        var fabaoRankInfo = ____655.rankInfo.fabaoRankList[index + 1];
        if (fabaoRankInfo == null) return null;
        var item = new ____2210();
        item.____18(fabaoRankInfo);
        return item
    },
    getIdByIndex: function(index) {
        var fabaoRankInfo = ____655.rankInfo.fabaoRankList[index + 1];
        if (fabaoRankInfo == null) return -1;
        return fabaoRankInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2212 = KYNode.extend({
    _controller: null,
    _xianWeiInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _fightValue1: null,
    _fightValue2: null,
    _fightValue3: null,
    _fightValue4: null,
    ____1237: null,
    ctor: function() {
        this._super("rankFashionItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._fightValue1 = this.getChildByName("fightValue1");
        this._fightValue2 = this.getChildByName("fightValue2");
        this._fightValue3 = this.getChildByName("fightValue3");
        this._fightValue4 = this.getChildByName("fightValue4");
        this.____1237 = this.getChildByName("iconImg");
        this.____6()
    },
    ____18: function(fashionInfo) {
        this._fashionInfo = fashionInfo;
        if (fashionInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + fashionInfo.rank + ".png", 1)
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(fashionInfo.rank)
        }
        this.____1526.setString(fashionInfo.userName);
        this._fightValue1.setString(fashionInfo.riderValue);
        this._fightValue2.setString(fashionInfo.petValue);
        this._fightValue3.setString(fashionInfo.wingValue);
        this._fightValue4.setString(fashionInfo.fashionValue)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._fashionInfo.userId, this._fashionInfo.serverId);
                ____655.lookInfo.panelType = 4
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._clubInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._fightValue1 = null;
        this._fightValue2 = null;
        this._fightValue3 = null;
        this._fightValue4 = null;
        this.____1237 = null;
        this._super()
    },
});
var ____2213 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    _title5: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankFashionPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle21"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle22"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle23"));
        this._title5 = this.getChildByName("title5");
        this._title5.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle3"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2212();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(4, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 4) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function() {
        var len = ____655.rankInfo.lengthList[4];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[4];
        for (var i = 1; i <= len; i++) {
            var fashionRankInfo = ____655.rankInfo.fashionRankList[i];
            if (fashionRankInfo == null) {
                break
            }
            if (____655.____667.userId == fashionRankInfo.userId) {
                this.____1646.____18(fashionRankInfo);
                return
            }
        }
        this.____1646.____1579.setString("20+");
        this.____1646.____1526.setString(____655.____667.nick);
        var typeList = [____655.____659.commonStaticType.style_fashion_horse, ____655.____659.commonStaticType.style_fashion_pet, ____655.____659.commonStaticType.style_fashion_wing, ____655.____659.commonStaticType.style_fashion_cloth];
        var fightList = [];
        var fashionInfo = null;
        for (var i = 0; i < typeList.length; i++) {
            fightList[i] = 0;
            fashionInfo = ____655.fashionInfo.getFashion(typeList[i]);
            if (fashionInfo != null) {
                for (var k in fashionInfo.huaxingList) {
                    var info = fashionInfo.huaxingList[k];
                    if (info != null) {
                        fightList[i] += info.template.fightValue
                    }
                }
            }
        }
        this.____1646._fightValue1.setString(fightList[0]);
        this.____1646._fightValue2.setString(fightList[1]);
        this.____1646._fightValue3.setString(fightList[2]);
        this.____1646._fightValue4.setString(fightList[3])
    },
    getItemByIndex: function(index) {
        var fashionRankInfo = ____655.rankInfo.fashionRankList[index + 1];
        if (fashionRankInfo == null) return null;
        var item = new ____2212();
        item.____18(fashionRankInfo);
        return item
    },
    getIdByIndex: function(index) {
        var fashionRankInfo = ____655.rankInfo.fashionRankList[index + 1];
        if (fashionRankInfo == null) return -1;
        return fashionRankInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        this._title5 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2214 = KYNode.extend({
    _controller: null,
    _footPrintInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _riderName: null,
    _starName: null,
    ____1159: null,
    ____1237: null,
    ____1586: null,
    ____909: null,
    ctor: function() {
        this._super("rankRiderItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._riderName = this.getChildByName("riderName");
        this._starName = this.getChildByName("starName");
        this.____1159 = this.getChildByName("fightValue");
        this.____1237 = this.getChildByName("iconImg");
        this.____1586 = this.getChildByName("upBtn_Copy0");
        this.____909 = this.getChildByName("titleLabel");
        this.____909.setVisible(false);
        this.____1586.setVisible(false);
        this.____6()
    },
    ____18: function(footPrintInfo) {
        this._footPrintInfo = footPrintInfo;
        if (footPrintInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + footPrintInfo.rank + ".png")
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(footPrintInfo.rank)
        }
        this.____1526.setString(footPrintInfo.userName);
        this._riderName.setString(footPrintInfo.petName);
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(footPrintInfo.otherStage);
        var stageName = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(footPrintInfo.otherStage);
        this._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
        this.____1159.setString(footPrintInfo.otherFight)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._footPrintInfo.userId, this._footPrintInfo.serverId);
                ____655.lookInfo.panelType = 8
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._footPrintInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._riderName = null;
        this._starName = null;
        this.____1159 = null;
        this.____1237 = null;
        this.____1586 = null;
        this.____909 = null;
        this._super()
    },
});
var ____2215 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankRiderPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text10"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text11"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text12"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2214();
        this.____1646.____1237.setVisible(false);
        this.____1646.setPositionY(0);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(8, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 8) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function() {
        var len = ____655.rankInfo.lengthList[8];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[8];
        for (var i = 1; i <= len; i++) {
            var footPrintRankInfo = ____655.rankInfo.footPrintRankList[i];
            if (footPrintRankInfo == null) {
                break
            }
            if (____655.____667.userId == footPrintRankInfo.userId) {
                this.____1646.____18(footPrintRankInfo);
                return
            }
        }
        var footInfo = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Foot);
        if (footInfo != null) {
            this.____1646.____1579.setString("20+");
            this.____1646.____1526.setString(____655.____667.nick);
            var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(footInfo.type, footInfo.starCount);
            this.____1646._riderName.setString(stageTempInfo.name);
            var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(footInfo.starCount);
            var stageName = ____655.____659.nameType.getChineseNumber2(stage);
            var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(footInfo.starCount);
            this.____1646._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
            this.____1646.____1159.setString(footInfo.fight)
        } else {
            this.____1646.____1579.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text9"))
        }
    },
    getItemByIndex: function(index) {
        var footPrintRankInfo = ____655.rankInfo.footPrintRankList[index + 1];
        if (footPrintRankInfo == null) return null;
        var item = new ____2214();
        item.____18(footPrintRankInfo);
        return item
    },
    getIdByIndex: function(index) {
        var footPrintRankInfo = ____655.rankInfo.footPrintRankList[index + 1];
        if (footPrintRankInfo == null) return -1;
        return footPrintRankInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2216 = KYNode.extend({
    _controller: null,
    _xianWeiInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _fightValue1: null,
    _fightValue2: null,
    _fightValue3: null,
    _fightValue4: null,
    _fightValue5: null,
    ____1237: null,
    ctor: function() {
        this._super("rankGodItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._fightValue1 = this.getChildByName("fightValue1");
        this._fightValue2 = this.getChildByName("fightValue2");
        this._fightValue3 = this.getChildByName("fightValue3");
        this._fightValue4 = this.getChildByName("fightValue4");
        this._fightValue5 = this.getChildByName("fightValue5");
        this.____1237 = this.getChildByName("iconImg");
        this.____6()
    },
    ____18: function(godInfo) {
        this._godInfo = godInfo
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {}
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._clubInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._fightValue1 = null;
        this._fightValue2 = null;
        this._fightValue3 = null;
        this._fightValue4 = null;
        this._fightValue5 = null;
        this.____1237 = null;
        this._super()
    },
});
var ____2217 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    _title5: null,
    _title6: null,
    ____1646: null,
    _tileContainer: null,
    ctor: function(controller) {
        this._super("rankGodPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle8"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle10"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle11"));
        this._title5 = this.getChildByName("title5");
        this._title5.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle12"));
        this._title6 = this.getChildByName("title6");
        this._title6.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel3"));
        this.____1646 = new ____2216();
        this.____1646.setPositionY(0);
        this.addChild(this.____1646, 10);
        this.____5()
    },
    ____5: function() {
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 20, ____654.____673.____160(731, 70), 0, 3)
    },
    getItemByIndex: function(index) {
        var item = new ____2216();
        item.____18();
        return item
    },
    getIdByIndex: function(index) {},
    dispose: function() {
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        this._title5 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._super()
    }
});
var ____2218 = KYNode.extend({
    _controller: null,
    _petInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _riderName: null,
    _starName: null,
    ____1159: null,
    ____1237: null,
    ____1586: null,
    ____909: null,
    ctor: function() {
        this._super("rankRiderItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._riderName = this.getChildByName("riderName");
        this._starName = this.getChildByName("starName");
        this.____1159 = this.getChildByName("fightValue");
        this.____1237 = this.getChildByName("iconImg");
        this.____1586 = this.getChildByName("upBtn_Copy0");
        this.____909 = this.getChildByName("titleLabel");
        this.____909.setVisible(false);
        this.____1586.setVisible(false);
        this.____6()
    },
    ____18: function(petInfo) {
        this._petInfo = petInfo;
        if (petInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + petInfo.rank + ".png")
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(petInfo.rank)
        }
        this.____1526.setString(petInfo.userName);
        this._riderName.setString(petInfo.petName);
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(petInfo.otherStage);
        var stageName = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(petInfo.otherStage);
        this._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
        this.____1159.setString(petInfo.otherFight)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._petInfo.userId, this._petInfo.serverId);
                ____655.lookInfo.panelType = 6
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._petInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._riderName = null;
        this._starName = null;
        this.____1159 = null;
        this.____1237 = null;
        this.____1586 = null;
        this.____909 = null;
        this._super()
    },
});
var ____2219 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankRiderPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text13"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text14"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text15"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2218();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(6, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 6) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function() {
        var len = ____655.rankInfo.lengthList[6];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, ____655.rankInfo.lengthList[6], ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[6];
        for (var i = 1; i <= len; i++) {
            var petRankInfo = ____655.rankInfo.petRankList[i];
            if (petRankInfo == null) {
                break
            }
            if (____655.____667.userId == petRankInfo.userId) {
                this.____1646.____18(petRankInfo);
                return
            }
        }
        var petInfo = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Pet);
        if (petInfo != null) {
            this.____1646.____1579.setString("20+");
            this.____1646.____1526.setString(____655.____667.nick);
            var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(petInfo.type, petInfo.starCount);
            this.____1646._riderName.setString(stageTempInfo.name);
            var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(petInfo.starCount);
            var stageName = ____655.____659.nameType.getChineseNumber2(stage);
            var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(petInfo.starCount);
            this.____1646._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
            this.____1646.____1159.setString(petInfo.fight)
        } else {
            this.____1646.____1579.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text9"))
        }
    },
    getItemByIndex: function(index) {
        var petRankInfo = ____655.rankInfo.petRankList[index + 1];
        if (petRankInfo == null) return null;
        var item = new ____2218();
        item.____18(petRankInfo);
        return item
    },
    getIdByIndex: function(index) {
        var petRankInfo = ____655.rankInfo.petRankList[index + 1];
        if (petRankInfo == null) return -1;
        return petRankInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2220 = KYPanel.extend({
    _controller: null,
    ____1740: null,
    ____1502: null,
    ____1737: null,
    ____1738: null,
    _panelList: null,
    ____1054: null,
    ____1783: null,
    ctor: function(controller, index) {
        this._super("rankPanel.ExportJson");
        this._controller = controller;
        this.____1740 = this.getChildByName("tabLayer");
        this.____1740.setScrollBarEnabled(false);
        this.____1502 = this.getChildByName("panelLayer");
        this.____1783 = this.getChildByName("tipLabel");
        this.____1783.setString("※排行榜信息在每个整点的50分自动刷新，向上滑动显示更多排名");
        this._panelList = {};
        this.____5(index)
    },
    ____5: function(index) {
        this.____1738 = [
            [1, "战力榜", "icon/ui_rankIcon2.png", true],
            [2, "家族榜", "icon/ui_rankIcon1.png", true],
            [3, "图鉴榜", "icon/ui_rankIcon5.png", true],
            [4, "幻装榜", "icon/ui_rankIcon4.png", true],
            [5, "坐骑榜", "icon/ui_waixingIcon1.png", true],
            [6, "仙宠榜", "icon/ui_waixingIcon2.png", true],
            [7, "飞羽榜", "icon/ui_waixingIcon3.png", true],
            [8, "足迹榜", "icon/ui_waixingIcon4.png", true],
            [9, "法宝榜", "icon/ui_waixingIcon5.png", true],
            [10, "阵灵榜", "icon/ui_waixingIcon6.png", true],
            [11, "神剑榜", "icon/ui_waixingIcon7.png", true],
        ];
        this.____1737 = new ____2142(1, this.____1738, this.setTab, this.____1740, this);
        this.____1740.setItemsMargin(5);
        if (index == null || index == 0) {
            index = 1
        }
        this.____1737.setTabIndex(index - 1)
    },
    ____6: function() {},
    setTab: function(tab) {
        if (this.____1054 != null) {
            this.____1054.removeFromParent(false)
        }
        this.____1054 = this.getPanel(tab);
        if (this.____1054 != null && this.____1054.getParent() == null) {
            this.____1502.addChild(this.____1054)
        }
    },
    getPanel: function(tab) {
        var panel = this._panelList[tab];
        if (panel == null) {
            if (tab == 1) {
                panel = new ____2228(this._controller)
            } else if (tab == 2) {
                panel = new ____2209(this._controller)
            } else if (tab == 3) {
                panel = new ____2207(this._controller)
            } else if (tab == 4) {
                panel = new ____2213(this._controller)
            } else if (tab == 5) {
                panel = new ____2222(this._controller)
            } else if (tab == 6) {
                panel = new ____2219(this._controller)
            } else if (tab == 7) {
                panel = new ____2226(this._controller)
            } else if (tab == 8) {
                panel = new ____2215(this._controller)
            } else if (tab == 9) {
                panel = new ____2211(this._controller)
            } else if (tab == 10) {
                panel = new ____2230(this._controller)
            } else if (tab == 11) {
                panel = new ____2224(this._controller)
            }
            this._panelList[tab] = panel
        }
        return panel
    },
    dispose: function() {
        this._controller = null;
        this.____1776 = null;
        this.____1740 = null;
        this.____1502 = null;
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        this.____1738 = null;
        if (this._panelList != null) {
            for (var i in this._panelList) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        this.____1054 = null;
        this._super()
    },
});
var ____2221 = KYNode.extend({
    _controller: null,
    _riderInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _riderName: null,
    _starName: null,
    ____1159: null,
    ____1237: null,
    ____1586: null,
    ____909: null,
    ctor: function() {
        this._super("rankRiderItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._riderName = this.getChildByName("riderName");
        this._starName = this.getChildByName("starName");
        this.____1159 = this.getChildByName("fightValue");
        this.____1237 = this.getChildByName("iconImg");
        this.____1586 = this.getChildByName("upBtn_Copy0");
        this.____909 = this.getChildByName("titleLabel");
        this.____909.setVisible(false);
        this.____1586.setVisible(false);
        this.____6()
    },
    ____18: function(riderInfo) {
        this._riderInfo = riderInfo;
        if (riderInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + riderInfo.rank + ".png")
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(riderInfo.rank)
        }
        this.____1526.setString(riderInfo.userName);
        this._riderName.setString(riderInfo.petName);
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(riderInfo.otherStage);
        var stageName = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(riderInfo.otherStage);
        this._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
        this.____1159.setString(riderInfo.otherFight)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._riderInfo.userId, this._riderInfo.serverId);
                ____655.lookInfo.panelType = 5
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._riderInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._riderName = null;
        this._starName = null;
        this.____1159 = null;
        this.____1237 = null;
        this.____1586 = null;
        this.____909 = null;
        this._super()
    },
});
var ____2222 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankRiderPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text16"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text17"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text18"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2221();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(5, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 5) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function(evt) {
        var len = ____655.rankInfo.lengthList[5];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[5];
        if (len == null) {
            len = 0
        }
        for (var i = 1; i <= len; i++) {
            var riderRankInfo = ____655.rankInfo.riderRankList[i];
            if (riderRankInfo == null) {
                break
            }
            if (____655.____667.userId == riderRankInfo.userId) {
                this.____1646.____18(riderRankInfo);
                return
            }
        }
        var riderInfo = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Horse);
        if (riderInfo != null) {
            this.____1646.____1579.setString("20+");
            this.____1646.____1526.setString(____655.____667.nick);
            var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(riderInfo.type, riderInfo.starCount);
            if (stageTempInfo != null) {
                this.____1646._riderName.setString(stageTempInfo.name)
            } else {
                this.____1646._riderName.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text19"))
            }
            var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(riderInfo.starCount);
            var stageName = ____655.____659.nameType.getChineseNumber2(stage);
            var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(riderInfo.starCount);
            this.____1646._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
            this.____1646.____1159.setString(riderInfo.fight)
        } else {
            this.____1646.____1579.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text9"))
        }
    },
    getItemByIndex: function(index) {
        var riderRankInfo = ____655.rankInfo.riderRankList[index + 1];
        if (riderRankInfo == null) return null;
        var item = new ____2221();
        item.____18(riderRankInfo);
        return item
    },
    getIdByIndex: function(index) {
        var riderRankInfo = ____655.rankInfo.riderRankList[index + 1];
        if (riderRankInfo == null) return -1;
        return riderRankInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2223 = KYNode.extend({
    _controller: null,
    _shenJianInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _riderName: null,
    _starName: null,
    ____1159: null,
    ____1237: null,
    ____1586: null,
    ____909: null,
    ctor: function() {
        this._super("rankRiderItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._riderName = this.getChildByName("riderName");
        this._starName = this.getChildByName("starName");
        this.____1159 = this.getChildByName("fightValue");
        this.____1237 = this.getChildByName("iconImg");
        this.____1586 = this.getChildByName("upBtn_Copy0");
        this.____909 = this.getChildByName("titleLabel");
        this.____909.setVisible(false);
        this.____1586.setVisible(false);
        this.____6()
    },
    ____18: function(shenJianInfo) {
        this._shenJianInfo = shenJianInfo;
        if (shenJianInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + shenJianInfo.rank + ".png", 1)
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(shenJianInfo.rank)
        }
        this.____1526.setString(shenJianInfo.userName);
        this._riderName.setString(shenJianInfo.petName);
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(shenJianInfo.otherStage);
        var stageName = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(shenJianInfo.otherStage);
        this._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
        this.____1159.setString(shenJianInfo.otherFight)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._shenJianInfo.userId, this._shenJianInfo.serverId);
                ____655.lookInfo.panelType = 11
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._riderInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._riderName = null;
        this._starName = null;
        this.____1159 = null;
        this.____1237 = null;
        this.____1586 = null;
        this.____909 = null;
        this._super()
    },
});
var ____2224 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankRiderPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text20"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text21"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text22"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2223();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(11, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 11) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function(evt) {
        var len = ____655.rankInfo.lengthList[11];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[11];
        for (var i = 1; i <= len; i++) {
            var shenJiangRankInfo = ____655.rankInfo.shenJiangRankList[i];
            if (shenJiangRankInfo == null) {
                break
            }
            if (____655.____667.userId == shenJiangRankInfo.userId) {
                this.____1646.____18(shenJiangRankInfo);
                return
            }
        }
        var shenJiangInfo = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ShenJian);
        if (shenJiangInfo != null) {
            this.____1646.____1579.setString("20+");
            this.____1646.____1526.setString(____655.____667.nick);
            var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(shenJiangInfo.type, shenJiangInfo.starCount);
            this.____1646._riderName.setString(stageTempInfo.name);
            var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(shenJiangInfo.starCount);
            var stageName = ____655.____659.nameType.getChineseNumber2(stage);
            var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(shenJiangInfo.starCount);
            this.____1646._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
            this.____1646.____1159.setString(shenJiangInfo.fight)
        } else {
            this.____1646.____1579.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"))
        }
    },
    getItemByIndex: function(index) {
        var shenJiangInfo = ____655.rankInfo.shenJiangRankList[index + 1];
        if (shenJiangInfo == null) return null;
        var item = new ____2223();
        item.____18(shenJiangInfo);
        return item
    },
    getIdByIndex: function(index) {
        var shenJiangInfo = ____655.rankInfo.shenJiangRankList[index + 1];
        if (shenJiangInfo == null) return -1;
        return shenJiangInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2225 = KYNode.extend({
    _controller: null,
    _wingInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _riderName: null,
    _starName: null,
    ____1159: null,
    ____1237: null,
    ____1586: null,
    ____909: null,
    ctor: function() {
        this._super("rankRiderItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._riderName = this.getChildByName("riderName");
        this._starName = this.getChildByName("starName");
        this.____1159 = this.getChildByName("fightValue");
        this.____1237 = this.getChildByName("iconImg");
        this.____1586 = this.getChildByName("upBtn_Copy0");
        this.____909 = this.getChildByName("titleLabel");
        this.____909.setVisible(false);
        this.____1586.setVisible(false);
        this.____6()
    },
    ____18: function(wingInfo) {
        this._wingInfo = wingInfo;
        if (wingInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + wingInfo.rank + ".png")
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(wingInfo.rank)
        }
        this.____1526.setString(wingInfo.userName);
        this._riderName.setString(wingInfo.petName);
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(wingInfo.otherStage);
        var stageName = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(wingInfo.otherStage);
        this._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
        this.____1159.setString(wingInfo.otherFight)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._wingInfo.userId, this._wingInfo.serverId);
                ____655.lookInfo.panelType = 7
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._riderInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._riderName = null;
        this._starName = null;
        this.____1159 = null;
        this.____1237 = null;
        this.____1586 = null;
        this.____909 = null;
        this._super()
    },
});
var ____2226 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankRiderPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text23"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text24"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text25"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2225();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(7, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 7) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function(evt) {
        var len = ____655.rankInfo.lengthList[7];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, ____655.rankInfo.lengthList[7], ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[7];
        for (var i = 1; i <= len; i++) {
            var wingRankInfo = ____655.rankInfo.wingRankList[i];
            if (wingRankInfo == null) {
                break
            }
            if (____655.____667.userId == wingRankInfo.userId) {
                this.____1646.____18(wingRankInfo);
                return
            }
        }
        this.____1646._rankImg.setVisible(false);
        var wingInfo = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Wind);
        if (wingInfo != null) {
            this.____1646.____1579.setString("20+");
            this.____1646.____1526.setString(____655.____667.nick);
            var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(wingInfo.type, wingInfo.starCount);
            this.____1646._riderName.setString(stageTempInfo.name);
            var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(wingInfo.starCount);
            var stageName = ____655.____659.nameType.getChineseNumber2(stage);
            var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(wingInfo.starCount);
            this.____1646._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
            this.____1646.____1159.setString(wingInfo.fight)
        } else {
            this.____1646.____1579.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text9"))
        }
    },
    getItemByIndex: function(index) {
        var wingInfo = ____655.rankInfo.wingRankList[index + 1];
        if (wingInfo == null) return null;
        var item = new ____2225();
        item.____18(wingInfo);
        return item
    },
    getIdByIndex: function(index) {
        var wingInfo = ____655.rankInfo.wingRankList[index + 1];
        if (wingInfo == null) return -1;
        return wingInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2227 = KYNode.extend({
    _controller: null,
    _xianWeiInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _fightValue1: null,
    _fightValue2: null,
    _fightValue3: null,
    _fightValue4: null,
    ____1237: null,
    ctor: function() {
        this._super("rankFashionItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._fightValue1 = this.getChildByName("fightValue1");
        this._fightValue2 = this.getChildByName("fightValue2");
        this._fightValue3 = this.getChildByName("fightValue3");
        this._fightValue4 = this.getChildByName("fightValue4");
        this.____1237 = this.getChildByName("iconImg");
        this.____1237.setFrame("icon/ui_infoIcon.png", 1);
        this.____6()
    },
    ____18: function(xianWeiInfo) {
        this._xianWeiInfo = xianWeiInfo;
        if (xianWeiInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + xianWeiInfo.rank + ".png", 1)
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(xianWeiInfo.rank)
        }
        this.____1526.setString(xianWeiInfo.userName);
        this._fightValue1.setString(xianWeiInfo.clubName);
        this._fightValue2.setString(____655.____659.nameType.getXianweiName(xianWeiInfo.xianWei));
        this._fightValue3.setString(xianWeiInfo.level);
        this._fightValue4.setString(xianWeiInfo.fightValue)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._xianWeiInfo.userId, this._xianWeiInfo.serverId);
                ____655.lookInfo.panelType = 2
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._clubInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._fightValue1 = null;
        this._fightValue2 = null;
        this._fightValue3 = null;
        this._fightValue4 = null;
        this.____1237 = null;
        this._super()
    },
});
var ____2228 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    _title5: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankFashionPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString("家族");
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2243.text4"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text5"));
        this._title5 = this.getChildByName("title5");
        this._title5.setString(____654.yuyanbaoManager.getYuyanbao("____2176.text6"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2227();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(2, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 2) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function() {
        var len = ____655.rankInfo.lengthList[2];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[2];
        if (len == null) {
            len = 0
        }
        for (var i = 1; i <= len; i++) {
            var xianweiInfo = ____655.rankInfo.xianWeiRankList[i];
            if (xianweiInfo == null) {
                break
            }
            if (____655.____667.userId == xianweiInfo.userId) {
                this.____1646.____18(xianweiInfo);
                return
            }
        }
        this.____1646.____1579.setString("20+");
        this.____1646.____1526.setString(____655.____667.nick);
        var careerName = ____655.____659.nameType.getCareerName(____655.____667.career);
        if (____655.____667.clubName != "") {
            this.____1646._fightValue1.setString(____655.____667.clubName)
        } else {
            this.____1646._fightValue1.setString("无")
        }
        this.____1646._fightValue2.setString(____655.____659.nameType.getSelfXianweiName());
        this.____1646._fightValue3.setString(____655.____667.level);
        this.____1646._fightValue4.setString(____655.____667.combat)
    },
    getItemByIndex: function(index) {
        var xianweiInfo = ____655.rankInfo.xianWeiRankList[index + 1];
        if (xianweiInfo == null) return;
        var item = new ____2227();
        item.____18(xianweiInfo);
        return item
    },
    getIdByIndex: function(index) {
        var xianweiInfo = ____655.rankInfo.xianWeiRankList[index + 1];
        if (xianweiInfo == null) return -1;
        return xianweiInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        this._title5 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2229 = KYNode.extend({
    _controller: null,
    _zhenlingInfo: null,
    _rankImg: null,
    ____1579: null,
    ____1526: null,
    _riderName: null,
    _starName: null,
    ____1159: null,
    ____1237: null,
    ____1586: null,
    ____909: null,
    ctor: function() {
        this._super("rankRiderItem.ExportJson");
        this._rankImg = this.getChildByName("rankImg");
        this.____1579 = this.getChildByName("rankLabel");
        this.____1526 = this.getChildByName("playerName");
        this._riderName = this.getChildByName("riderName");
        this._starName = this.getChildByName("starName");
        this.____1159 = this.getChildByName("fightValue");
        this.____1237 = this.getChildByName("iconImg");
        this.____1586 = this.getChildByName("upBtn_Copy0");
        this.____909 = this.getChildByName("titleLabel");
        this.____909.setVisible(false);
        this.____1586.setVisible(false);
        this.____6()
    },
    ____18: function(zhenlingInfo) {
        this._zhenlingInfo = zhenlingInfo;
        if (zhenlingInfo.rank <= 3) {
            this._rankImg.setFrame("flag/ui_rankNo" + zhenlingInfo.rank + ".png")
        } else {
            this._rankImg.setVisible(false);
            this.____1579.setString(zhenlingInfo.rank)
        }
        this.____1526.setString(zhenlingInfo.userName);
        this._riderName.setString(zhenlingInfo.petName);
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(zhenlingInfo.otherStage);
        var stageName = ____655.____659.nameType.getChineseNumber2(stage);
        var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(zhenlingInfo.otherStage);
        this._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
        this.____1159.setString(zhenlingInfo.otherFight)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1237) {
                ____654.____683.sendLook(this._zhenlingInfo.userId, this._zhenlingInfo.serverId);
                ____655.lookInfo.panelType = 10
            }
        }
    },
    ____6: function() {
        this.____1237.addListener(this, this.____16, null, null, null, false, true)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._riderInfo = null;
        this._rankImg = null;
        this.____1579 = null;
        this.____1526 = null;
        this._riderName = null;
        this._starName = null;
        this.____1159 = null;
        this.____1237 = null;
        this.____1586 = null;
        this.____909 = null;
        this._super()
    },
});
var ____2230 = KYPanel.extend({
    _controller: null,
    _title1: null,
    _title2: null,
    _title3: null,
    _title4: null,
    ____1646: null,
    _tileContainer: null,
    _tipsLabel: null,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("rankRiderPanel.ExportJson");
        this._controller = controller;
        this._title1 = this.getChildByName("title1");
        this._title1.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text1"));
        this._title2 = this.getChildByName("title2");
        this._title2.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text26"));
        this._title3 = this.getChildByName("title3");
        this._title3.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text27"));
        this._title4 = this.getChildByName("title4");
        this._title4.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text28"));
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setVisible(false);
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text4"));
        this.____1646 = new ____2229();
        this.____1646.setPositionY(0);
        this.____1646.____1237.setVisible(false);
        this.addChild(this.____1646, 10);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, 0, ____654.____673.____160(731, 70), 0, 3, true);
        this._tickCount = 0;
        ____654.____678.____298(this.showTick, this);
        this.____6()
    },
    ____6: function() {
        ____654.rankMessageSender.sendGetRankInfo(10, 1, 20);
        ____655.rankInfo.addEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    showTick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tipsLabel.setVisible(true);
            ____654.____678.____299(this.showTick, this)
        }
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankInfoUpdate, this.infoUpdate, this)
    },
    infoUpdate: function(evt) {
        if (evt.data == 10) {
            this.updateView();
            this.updatePlayerInfo()
        }
    },
    updateView: function(evt) {
        var len = ____655.rankInfo.lengthList[10];
        if (len == null) {
            len = 0
        }
        if (len == 0) {
            this._tipsLabel.setVisible(true)
        } else {
            this._tipsLabel.setVisible(false);
            ____654.____678.____299(this.showTick, this)
        }
        this._tileContainer.setFormat(1, len, ____654.____673.____160(731, 70), 0, 3, true)
    },
    updatePlayerInfo: function() {
        var len = ____655.rankInfo.lengthList[10];
        for (var i = 1; i <= len; i++) {
            var zhenLingRankInfo = ____655.rankInfo.zhenLingRankList[i];
            if (zhenLingRankInfo == null) {
                break
            }
            if (____655.____667.userId == zhenLingRankInfo.userId) {
                this.____1646.____18(zhenLingRankInfo);
                return
            }
        }
        var zhenLingInfo = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_ZhengLing);
        if (zhenLingInfo != null) {
            this.____1646.____1579.setString("20+");
            this.____1646.____1526.setString(____655.____667.nick);
            var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(zhenLingInfo.type, zhenLingInfo.starCount);
            this.____1646._riderName.setString(stageTempInfo.name);
            var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(zhenLingInfo.starCount);
            var stageName = ____655.____659.nameType.getChineseNumber2(stage);
            var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(zhenLingInfo.starCount);
            this.____1646._starName.setString(____654.yuyanbaoManager.getYuyanbao("PlayerNoticeManager.text2", stageName, star));
            this.____1646.____1159.setString(zhenLingInfo.fight)
        } else {
            this.____1646.____1579.setString(____654.yuyanbaoManager.getYuyanbao("____2220.text9"))
        }
    },
    getItemByIndex: function(index) {
        var zhenLingRankInfo = ____655.rankInfo.zhenLingRankList[index + 1];
        if (zhenLingRankInfo == null) return null;
        var item = new ____2229();
        item.____18(zhenLingRankInfo);
        return item
    },
    getIdByIndex: function(index) {
        var zhenLingRankInfo = ____655.rankInfo.zhenLingRankList[index + 1];
        if (zhenLingRankInfo == null) return -1;
        return zhenLingRankInfo.userId
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.showTick, this);
        this._controller = null;
        this._title1 = null;
        this._title2 = null;
        this._title3 = null;
        this._title4 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._tileContainer = null;
        this._tipsLabel = null;
        this._tickCount = 0;
        this._super()
    }
});
var ____2204 = cc.Class.extend({
    rankModule: null,
    ctor: function(module) {
        this.rankModule = module;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showRankPanel: function(type, index) {
        if (this.rankModule.rankPanel == null) {
            this.rankModule.rankPanel = new ____2220(this, index)
        }
        ____654.____676.uiPanelContainer.____125(this.rankModule.rankPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.rankModule.rankPanel) {
            this.rankModule.rankPanel = null
        }
    },
});
var ____2205 = ____537.extend({
    rankController: null,
    rankPanel: null,
    clubPanel: null,
    xianWeiPanel: null,
    godPanel: null,
    fashionPanel: null,
    riderPanel: null,
    petPanel: null,
    wingPanel: null,
    setup: function(data) {
        this.rankController = new ____2204(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.rank) {
            this.rankController.showRankPanel(data[0], data[1])
        }
    },
    clear: function() {},
});
var ReturnGiftPanel = KYPanel.extend({
    _imgTitle: null,
    _titlePath: null,
    _imgLeftAward: null,
    _leftAwardPath: null,
    _imgRightAward: null,
    _rightAwardPath: null,
    _labLeftExp: null,
    _leftExpNum: null,
    _labRightExp: null,
    _rightExpNum: null,
    _leftTime: null,
    _rightTime: null,
    _imgLeftGet: null,
    _imgRightGet: null,
    _closeBtn: null,
    ____1336: null,
    _leftBtnName: null,
    ____1593: null,
    _rightBtnName: null,
    _awardTemplate: null,
    _leftGridList: null,
    _rightGridList: null,
    _leftCountDownUtils: null,
    _rightCountDownUtils: null,
    _leftBtnEffect: null,
    _rightBtnEffect: null,
    ctor: function() {
        this._super("returnGiftPanel.ExportJson");
        this._imgTitle = this.getChildByName("imgTitle");
        this._titlePath = ____654.____675.____139("outPic/ui_comeBack.png");
        ____654.____677.____146(this._imgTitle, this._titlePath);
        this._imgLeftAward = this.getChildByName("imgAward1");
        this._leftAwardPath = ____654.____675.____139("outPic/ui_award100.png");
        ____654.____677.____146(this._imgLeftAward, this._leftAwardPath);
        this._imgRightAward = this.getChildByName("imgAward2");
        this._rightAwardPath = ____654.____675.____139("outPic/ui_award200.png");
        ____654.____677.____146(this._imgRightAward, this._rightAwardPath);
        this._labLeftExp = this.getChildByName("labExp1");
        this._leftExpNum = this.getChildByName("expNum1");
        this._labRightExp = this.getChildByName("labExp2");
        this._rightExpNum = this.getChildByName("expNum2");
        this._leftTime = this.getChildByName("time1");
        this._leftCountDownUtils = new ____2111();
        this._leftCountDownUtils.setLabel(this._leftTime, 0, 0, null);
        this._rightTime = this.getChildByName("time2");
        this._rightCountDownUtils = new ____2111();
        this._rightCountDownUtils.setLabel(this._rightTime, 0, 0, null);
        this._imgLeftGet = this.getChildByName("imgGet1");
        this._imgRightGet = this.getChildByName("imgGet2");
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1336 = this.getChildByName("leftBtn");
        this._leftBtnName = this.getChildByName("btnName1");
        this.____1593 = this.getChildByName("rightBtn");
        this._rightBtnName = this.getChildByName("btnName2");
        this._leftGridList = [];
        this._rightGridList = [];
        for (var i = 1; i <= 8; i++) {
            var leftGrid = new ____2129(true, 0, 0);
            leftGrid.setScale(0.66);
            var leftAwardCell = this.getChildByName("cell" + i);
            leftGrid.setPosition(27, 27);
            leftAwardCell.addChild(leftGrid);
            this._leftGridList.push(leftGrid);
            var rightGrid = new ____2129(true, 0, 0);
            rightGrid.setScale(0.66);
            var rightAwardCell = this.getChildByName("tCell" + i);
            rightGrid.setPosition(27, 27);
            rightAwardCell.addChild(rightGrid);
            this._rightGridList.push(rightGrid)
        }
        this.____5();
        this.updateView();
        this.____6()
    },
    ____5: function() {
        var index = ____655.____667.xianwei - 2;
        this._awardTemplate = ____655.allTemplates.awardTemplateList.typeList[6][index];
        this._leftExpNum.setString(this._awardTemplate.condition);
        this._rightExpNum.setString(parseInt(this._awardTemplate.condition) * 2);
        var awardList = this._awardTemplate.awardList;
        for (var index = 0; index < awardList.length; index++) {
            if (awardList[index] != null) {
                this._leftGridList[index].setItemTemplateInfo(____655.allTemplates.____794.getItem(awardList[index][0]));
                this._leftGridList[index].setCount(awardList[index][1]);
                this._rightGridList[index].setItemTemplateInfo(____655.allTemplates.____794.getItem(awardList[index][0]));
                this._rightGridList[index].setCount(awardList[index][1] * 2)
            }
        }
        var passTime = ____655.____662.getZeroPassTime();
        print(____655.____662.____971);
        var times = ____655.____662.getZeroPassTime(____655.____662.____971);
        var leftTime = ____655.____662.secondsOfDay - passTime;
        if (leftTime > 0) {
            this._leftCountDownUtils.start(leftTime);
            this._rightCountDownUtils.start(leftTime)
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.clickHandler);
        this.____1336.addListener(this, this.clickHandler);
        this.____1593.addListener(this, this.clickHandler);
        ____655.statInfo.addEventListener(____655.____661.returnGiftInfo, this.updateView, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.returnGiftInfo, this.updateView, this)
    },
    updateView: function() {
        if (____655.statInfo.returnGiftInfo.isLeftGetAward == 0) {
            this._imgLeftGet.setVisible(false);
            if (this._leftBtnEffect == null) {
                this._leftBtnEffect = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                this._leftBtnEffect.setScaleX(1.2);
                this._leftBtnEffect.move(70, 27);
                this._leftBtnEffect.play();
                this._leftBtnEffect.addTo(this.____1336, 10)
            }
        } else {
            this._imgLeftGet.setVisible(true);
            ____654.____674.setKYBtnEnabled(this.____1336, false, 1);
            if (this._leftBtnEffect != null) {
                this._leftBtnEffect.dispose();
                this._leftBtnEffect = null
            }
        }
        if (____655.statInfo.returnGiftInfo.isRightGetAward == 0) {
            this._imgRightGet.setVisible(false);
            if (____655.____667.moneyInfo.getTodayRecharge() > 0) {
                this._rightBtnName.setString(____654.yuyanbaoManager.getYuyanbao("ReturnGiftPanel.text1"));
                if (this._rightBtnEffect == null) {
                    this._rightBtnEffect = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                    this._rightBtnEffect.setScaleX(1.2);
                    this._rightBtnEffect.move(70, 27);
                    this._rightBtnEffect.play();
                    this._rightBtnEffect.addTo(this.____1593, 10)
                }
            } else {
                this._rightBtnName.setString(____654.yuyanbaoManager.getYuyanbao("ReturnGiftPanel.text2"));
                if (this._rightBtnEffect != null) {
                    this._rightBtnEffect.dispose();
                    this._rightBtnEffect = null
                }
            }
        } else {
            this._imgRightGet.setVisible(true);
            ____654.____674.setKYBtnEnabled(this.____1593, false, 1);
            if (this._rightBtnEffect != null) {
                this._rightBtnEffect.dispose();
                this._rightBtnEffect = null
            }
        }
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____1336) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                ____654.____683.sendGetReturnGift(1)
            } else if (sender == this.____1593) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                if (____655.____667.moneyInfo.getTodayRecharge() > 0) {
                    ____654.____683.sendGetReturnGift(2)
                } else {
                    this.dispose();
                    ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
                }
            }
        }
    },
    dispose: function() {
        this.____17();
        if (this._leftGridList != null) {
            for (var i = 0; i < this._leftGridList.length; i++) {
                this._leftGridList[i].dispose();
                this._leftGridList[i] = null
            }
        }
        if (this._rightGridList != null) {
            for (var i = 0; i < this._rightGridList.length; i++) {
                this._rightGridList[i].dispose();
                this._rightGridList[i] = null
            }
        }
        if (this._leftCountDownUtils != null) {
            this._leftCountDownUtils.dispose();
            this._leftCountDownUtils = null
        }
        this._leftTime = null;
        if (this._rightCountDownUtils != null) {
            this._rightCountDownUtils.dispose();
            this._rightCountDownUtils = null
        }
        this._rightTime = null;
        if (this._titlePath != null) {
            ____654.____677.removeImageQuote(this._imgTitle, this._titlePath);
            this._titlePath = null
        }
        this._imgTitle = null;
        if (this._leftAwardPath != null) {
            ____654.____677.removeImageQuote(this._imgLeftAward, this._leftAwardPath);
            this._leftAwardPath = null
        }
        this._imgLeftAward = null;
        if (this._rightAwardPath != null) {
            ____654.____677.removeImageQuote(this._imgRightAward, this._rightAwardPath);
            this._rightAwardPath = null
        }
        this._imgRightAward = null;
        this._labLeftExp = null;
        this._leftExpNum = null;
        this._labRightExp = null;
        this._rightExpNum = null;
        this._imgLeftGet = null;
        this._imgRightGet = null;
        this._closeBtn = null;
        this.____1336 = null;
        this._leftBtnName = null;
        this.____1593 = null;
        this._rightBtnName = null;
        this._awardTemplate = null;
        if (this._rightBtnEffect != null) {
            this._rightBtnEffect.dispose();
            this._rightBtnEffect = null
        }
        if (this._leftBtnEffect != null) {
            this._leftBtnEffect.dispose();
            this._leftBtnEffect = null
        }
        this._super()
    },
});
var ____552 = KYPanel.extend({
    _controller: null,
    ____1606: null,
    ____858: null,
    _moneyView: null,
    ctor: function(controller) {
        this._super("rolePanel.ExportJson");
        this._controller = controller;
        var roleLayer = this.getChildByName("roleLayer");
        var bagLayer = this.getChildByName("bagLayer");
        var moneyLayer = this.getChildByName("moneyLayer");
        this.____1606 = new ____2240(this._controller);
        this.____858 = new ____2234();
        this._moneyView = new ____2237();
        roleLayer.addChild(this.____1606);
        bagLayer.addChild(this.____858);
        moneyLayer.addChild(this._moneyView);
        this.getChildByName("addFriendBtn").setVisible(false);
        this.getChildByName("tipLabel").setVisible(false);
        this.getChildByName("addIcon").setVisible(false)
    },
    dispose: function() {
        this._controller = null;
        if (this.____1606 != null) {
            this.____1606.dispose();
            this.____1606 = null
        }
        if (this.____858 != null) {
            this.____858.dispose();
            this.____858 = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this._super()
    },
});
var ____2234 = KYNode.extend({
    ____1736: null,
    _tipList: null,
    ____1002: null,
    ____1071: -1,
    _tipsLabel: null,
    _bg: null,
    _bgPath: null,
    ____1824: null,
    _popIcon1: null,
    _popIcon2: null,
    ctor: function() {
        this._super("bagView.ExportJson");
        this._tipsLabel = this.getChildByName("tipLabel");
        this.____1736 = [this.getChildByName("tabBtn1"), this.getChildByName("tabBtn2"), this.getChildByName("tabBtn3")];
        this._tipList = [____654.yuyanbaoManager.getYuyanbao("bagPanel.text2"), ____654.yuyanbaoManager.getYuyanbao("bagPanel.text1"), ____654.yuyanbaoManager.getYuyanbao("bagPanel.text3")];
        this.____1824 = [3, 1, 2];
        for (var i = 0; i < 3; i++) {
            this.getChildByName("btnLabel" + (i + 1)).setString(this._tipList[i])
        }
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/ui_bagBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1002 = this.getChildByName("cellPanel__1");
        this.____1002.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.setType(0);
        this.____6();
        this.popUpdate()
    },
    ____6: function() {
        for (var i = 0; i < this.____1736.length; i++) {
            this.____1736[i].addListener(this, this.____16)
        }
        ____655.itemInfoList.addEventListener(____655.____661.common_itemListUpdate, this.itemUpdate, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemInfoDelete, this.itemInfoDelete, this);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.addEventListener(____655.____661.common_equipQualityUp, this.equipQualityUp, this);
        ____654.____672.addEventListener(____655.____661.guide_openEquipBag, this.guideHandler, this)
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemListUpdate, this.itemUpdate, this);
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemInfoDelete, this.itemInfoDelete, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.removeEventListener(____655.____661.common_equipQualityUp, this.equipQualityUp, this);
        ____654.____672.removeEventListener(____655.____661.guide_openEquipBag, this.guideHandler, this)
    },
    guideHandler: function() {
        this.setType(2)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 32) {
            if (____654.playerInfoTester.bagItemNum > 0 && this._popIcon1 == null) {
                this._popIcon1 = ____654.____673.newKYSprite();
                this._popIcon1.setFrame("icon/ui_numTipIcon.png");
                this.____1736[1].addChild(this._popIcon1, 9);
                this._popIcon1.setPosition(____654.____673.____159(110, 45))
            } else if (____654.playerInfoTester.bagItemNum <= 0 && this._popIcon1 != null) {
                this._popIcon1.dispose();
                this._popIcon1 = null
            }
        }
        if (type == 0 || type == 33) {
            if (____654.playerInfoTester.bagEquipNum > 0 && this._popIcon2 == null) {
                this._popIcon2 = ____654.____673.newKYSprite();
                this._popIcon2.setFrame("icon/ui_numTipIcon.png");
                this.____1736[2].addChild(this._popIcon2, 9);
                this._popIcon2.setPosition(____654.____673.____159(110, 45))
            } else if (____654.playerInfoTester.bagEquipNum <= 0 && this._popIcon2 != null) {
                this._popIcon2.dispose();
                this._popIcon2 = null
            }
        }
    },
    itemUpdate: function(evt) {
        this.____18(false)
    },
    ____18: function(isSetPos) {
        var len = ____655.itemInfoList.bagTypeList[this.____1824[this.____1071]].length;
        if (len <= 0) {
            this._tipsLabel.setVisible(true);
            this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("bagPanel.text4", this._tipList[this.____1071]))
        } else {
            this._tipsLabel.setVisible(false)
        }
        this.____1002.setFormat(4, len, ____654.____673.____160(82, 82), 13, 7, isSetPos)
    },
    itemInfoDelete: function(evt) {
        var dataList = evt.data;
        if (dataList[0] == this.____1824[this.____1071]) {
            this.____1002.removeItemById(dataList[1])
        }
    },
    equipQualityUp: function(evt) {
        if (this.____1824[this.____1071] == 2) {
            this.____1002.clearAllItems();
            this.____18(true)
        }
    },
    getItemByIndex: function(index) {
        var itemInfo = ____655.itemInfoList.bagTypeList[this.____1824[this.____1071]][index];
        if (itemInfo == null) {
            return null
        }
        var grid = new ____2129(true, null, null, null, false);
        grid.setIsShowQHLevel(true);
        grid.____1512.addListener(this, this.gridClickHandler, null, null, null, false, true);
        grid.setItemInfo(itemInfo);
        var categoryId = itemInfo.template.categoryId;
        if (____655.____659.categoryType.isEquip(categoryId)) {
            var curEquipInfo = ____655.itemInfoList.getBodyEquipByType(categoryId);
            if (curEquipInfo != null) {
                if (curEquipInfo.quality < itemInfo.quality) {
                    grid.setEquipFlagType(1)
                } else if (curEquipInfo.quality == itemInfo.quality) {
                    grid.setEquipFlagType(2)
                } else {
                    grid.setEquipFlagType(0)
                }
            }
        }
        return grid
    },
    getIdByIndex: function(index) {
        var itemInfo = ____655.itemInfoList.bagTypeList[this.____1824[this.____1071]][index];
        if (itemInfo == null) {
            return -1
        }
        return itemInfo.id
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this.____1736.indexOf(sender);
            this.setType(index)
        }
    },
    gridClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.tipsManager.showBagItemTip(sender.getParent().getItemInfo())
        }
    },
    setType: function(type) {
        if (this.____1071 == type) {
            return
        }
        if (this.____1071 >= 0) {
            this.____1736[this.____1071].setFrame("btn/ui_btn1_1.png");
            this.____1736[this.____1071].setTouchEnabled(true)
        }
        this.____1071 = type;
        if (this.____1071 >= 0) {
            this.____1736[this.____1071].setFrame("btn/ui_btn1_2.png");
            this.____1736[this.____1071].setTouchEnabled(false)
        }
        this.____1002.clearAllItems();
        this.____18(true)
    },
    dispose: function() {
        this.____17();
        this._super();
        if (this._popIcon1 != null) {
            this._popIcon1.dispose();
            this._popIcon1 = null
        }
        if (this._popIcon2 != null) {
            this._popIcon2.dispose();
            this._popIcon2 = null
        }
        this.____1736 = null;
        this._tipList = null;
        this._tipsLabel = null;
        this.____1002 = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this.____1824 = null
    },
});
var ____2235 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    ____995: null,
    _upBtn: null,
    ____1706: null,
    ____1555: null,
    ____1568: null,
    _proPlusValueList: null,
    ____865: null,
    ____861: null,
    ____1185: null,
    ____1829: null,
    ____1674: null,
    ____1637: -1,
    ____1252: null,
    ____1076: null,
    ____1031: null,
    ____1151: null,
    ____1042: 0,
    ____1043: 0,
    _panelType: 0,
    _tileContainer: null,
    ____944: null,
    _characterInfo: null,
    _characterEffect: null,
    _moneyView: null,
    _addNumberUtils: null,
    ____1828: null,
    ____1834: true,
    ctor: function(controller) {
        this._super("roleFashionPanel.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____995 = this.getChildByName("combatLabel");
        this._upBtn = this.getChildByName("upBtn");
        this.____865 = this.getChildByName("moneyLabel");
        this.____861 = this.getChildByName("countBar");
        this.____1185 = this.getChildByName("addBtn");
        this.____1829 = this.getChildByName("btnLabel");
        this.____1674 = this.getChildByName("show_panel");
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this.____1706 = [];
        this.____1555 = [];
        this.____1568 = [];
        this._proPlusValueList = [];
        for (var i = 1; i <= 5; i++) {
            this.____1706.push(this.getChildByName("starIcon" + i))
        }
        for (var i = 1; i <= 4; i++) {
            this.____1555.push(this.getChildByName("proName" + i));
            this.____1568.push(this.getChildByName("proValue" + i));
            this._proPlusValueList.push(this.getChildByName("proPlusValue" + i))
        }
        this._tileContainer = this.getChildByName("btnListView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____5();
        this.____6()
    },
    ____6: function() {
        this.____1185.addListener(this, this.____16);
        this._upBtn.addListener(this, this.____16);
        ____655.fashionInfo.addEventListener(____655.____661.fashion_infoUpdate, this.updateInfoHandler, this);
        ____655.fashionInfo.addEventListener(____655.____661.fashion_hauxingUpdate, this.huaxingUpdate, this);
        ____654.____672.addEventListener(____655.____661.common_testerItemUpdate, this.updateCount, this)
    },
    ____17: function() {
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_infoUpdate, this.updateInfoHandler, this);
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_hauxingUpdate, this.huaxingUpdate, this);
        ____654.____672.removeEventListener(____655.____661.common_testerItemUpdate, this.updateCount, this)
    },
    updateCount: function() {
        for (var i = 0; i < this.____1252.length; i++) {
            var tabBtn = this._tileContainer.getItemByIndex(i);
            if (tabBtn != null) {
                var tempInfo = tabBtn.getTempInfo();
                if (tabBtn != null && tempInfo != null) {
                    this.tabBtnSetCount(tabBtn, tempInfo)
                }
            }
        }
    },
    tabBtnSetCount: function(tabBtn, tempInfo) {
        var starLevel = 0;
        var selfInfo = ____655.fashionInfo.getFashionInfo(tempInfo.type, tempInfo.templateId);
        if (selfInfo != null) {
            starLevel = selfInfo.star
        }
        if (starLevel < tempInfo.maxStars) {
            var needItemId = tabBtn.getTempInfo().stars[starLevel + 1].needItems[0][0];
            var hasCount = ____654.playerInfoTester.hunshiList[needItemId];
            if (hasCount == null) {
                hasCount = 0
            }
            var needCount = tempInfo.stars[starLevel + 1].needItems[0][1];
            if (needCount > hasCount) {
                tabBtn.setShowPop(false)
            } else {
                tabBtn.setShowPop(true)
            }
            if (selfInfo == null) {
                tabBtn.updateCount(hasCount, needCount)
            }
        } else {
            tabBtn.setShowPop(false)
        }
    },
    huaxingUpdate: function(evt) {
        var data = evt.data;
        if (data == null) return;
        var type = data[0];
        var currentHuaxing = data[1];
        if (currentHuaxing != null && currentHuaxing != this.____1042) {
            var tabBtn = this._tileContainer.getItemByIndex(this.____1043);
            if (tabBtn != null) {
                tabBtn.setUse(false)
            }
            this.____1042 = currentHuaxing;
            if (currentHuaxing > 0) {
                for (var i = 0; i < this.____1252.length; i++) {
                    var tabBtn2 = this._tileContainer.getItemByIndex(i);
                    if (tabBtn2 != null && tabBtn2.getTempInfoId() != null && tabBtn2.getTempInfoId() == currentHuaxing) {
                        this.____1043 = i;
                        tabBtn2.setUse(true);
                        break
                    }
                }
            }
        }
        this.____1834 = true
    },
    updateInfoHandler: function(evt) {
        var data = evt.data;
        if (data == null) return;
        var type = data[0];
        if (type != null && type == this._panelType) {
            var index = this.____1637;
            this.____1637 = -1;
            this.____225(index, true)
        }
    },
    ____5: function() {
        this._panelType = ____655.____659.commonStaticType.style_fashion_cloth;
        var this_ = this;

        function sortFunc(item1, item2) {
            var info1 = ____655.fashionInfo.getFashionInfo(this_._panelType, item1.templateId);
            var info2 = ____655.fashionInfo.getFashionInfo(this_._panelType, item2.templateId);
            if (info1 != null && info2 != null) {
                if (info2.star == info1.star) {
                    return item2.stars[1].fightValue - item1.stars[1].fightValue
                }
                return info2.star - info1.star
            } else if (info1 != null) {
                return -1
            } else if (info2 != null) {
                return 1
            }
            return item2.stars[1].fightValue - item1.stars[1].fightValue
        };
        this.____1151 = ____655.fashionInfo.getFashion(this._panelType);
        if (this.____1151 != null) {
            this.____1042 = this.____1151.currentHuaxing
        }
        var career = ____655.____667.career;
        this.____1252 = ____655.allTemplates.fashionTemplateList.getListByTypeAndCarrer(this._panelType, career);
        this.____1252.sort(sortFunc);
        this._tileContainer.setFormat(1, this.____1252.length, ____654.____673.____160(314, 110), 0, 0, true);
        this.____225(0)
    },
    getItemByIndex: function(index) {
        var tabBtn = new ____2236(index);
        tabBtn.____18(this._panelType, this.____1252[index]);
        tabBtn.addListener(this, this.tabBtnClickHandler, null, null, null, false, true);
        tabBtn.setClickCallBack(this.checkBoxClickHandler, this);
        if (this.____1042 == this.____1252[index].templateId) {
            this.____1043 = index;
            tabBtn.setUse(true)
        }
        if (this.____1637 == index) {
            tabBtn.____239(true)
        }
        this.tabBtnSetCount(tabBtn, this.____1252[index]);
        return tabBtn
    },
    getIdByIndex: function(index) {
        var info = this.____1252[index];
        if (info == null) return -1;
        return this.____1252[index].templateId
    },
    checkItemSelect: function() {
        if (this.____1252 != null) {
            for (var i = 0; i < this.____1252.length; i++) {
                var tempInfo = this.____1252[i];
                if (this.checkIsCanUp(tempInfo)) {
                    this.____225(i);
                    return
                }
            }
            this.____225(0)
        }
    },
    checkIsCanUp: function(tempInfo, isShowTip) {
        if (tempInfo == null) return false;
        var info = ____655.fashionInfo.getFashionInfo(this._panelType, tempInfo.templateId);
        var starLevel = 0;
        if (info != null) {
            starLevel = info.star
        }
        if (tempInfo.stars[starLevel + 1] == null) {
            return false
        } else {
            var hasCount = ____655.itemInfoList.getCountByTempId(tempInfo.stars[starLevel + 1].needItems[0][0]);
            var needCount = tempInfo.stars[starLevel + 1].needItems[0][1];
            if (hasCount >= needCount) {
                return true
            } else {
                if (isShowTip != null && isShowTip) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2235.text2"))
                }
                return false
            }
        }
        return false
    },
    tabBtnClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = sender.getIndex();
            this.____225(index)
        }
    },
    checkBoxClickHandler: function(tabBtn) {
        if (this.____1834 == false) return;
        var index = tabBtn.getIndex();
        this.____225(index);
        var tempInfo = tabBtn.getTempInfo();
        if (tempInfo == null) return;
        var info = ____655.fashionInfo.getFashionInfo(this._panelType, tempInfo.templateId);
        if (info != null) {
            if (tempInfo.templateId == this.____1042) {
                ____654.fashionMessageSender.sendMoveEquip(this.____1076.templateId, 0, 0, this._panelType, 2);
                tabBtn.setUse(false)
            } else {
                ____654.fashionMessageSender.sendMoveEquip(this.____1076.templateId, 0, 0, this._panelType, 1);
                var btn = this._tileContainer.getItemByIndex(this.____1043);
                if (btn != null) {
                    btn.setUse(false)
                }
                this.____1043 = index;
                this.____1042 = tempInfo.templateId;
                tabBtn.setUse(true)
            }
            this.____1834 = false
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1185) {
                if (this.____1076 == null || this.____1076.deploy.length <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2235.text2"));
                    return
                }
                if (this.____1076.deploy.length > 0) {
                    ____654.triggerManager.handlerList(this.____1076.deploy)
                }
            } else if (sender == this._upBtn) {
                if (this.checkIsCanUp(this.____1076, true)) {
                    if (this.____1031 != null) {
                        ____654.fashionMessageSender.sendUpStar(this._panelType, this.____1076.templateId)
                    } else {
                        ____654.fashionMessageSender.sendActive(this._panelType, this.____1076.templateId)
                    }
                }
            }
        }
    },
    ____225: function(index, isInfoUpdate) {
        if (index == this.____1637) return;
        var tempInfo = this.____1252[index];
        if (tempInfo == null) {
            return
        }
        this.____1076 = tempInfo;
        var tabBtn = this._tileContainer.getItemByIndex(this.____1637);
        if (tabBtn != null) {
            tabBtn.____239(false)
        }
        this.____1637 = index;
        var curTabBtn = this._tileContainer.getItemByIndex(this.____1637);
        if (curTabBtn != null) {
            curTabBtn.____239(true)
        }
        var starLevel = 1;
        this.____1031 = ____655.fashionInfo.getFashionInfo(this._panelType, tempInfo.templateId);
        if (this.____1031 == null) {
            this.setStar(0);
            this.____1829.setString(____654.yuyanbaoManager.getYuyanbao("____2235.text3"))
        } else {
            starLevel = this.____1031.star;
            this.setStar(starLevel);
            this.____1829.setString(____654.yuyanbaoManager.getYuyanbao("____2235.text4"))
        }
        var starTempInfo = tempInfo.stars[starLevel];
        var nextStarTempInfo = tempInfo.stars[starLevel + 1];
        if (starTempInfo != null) {
            if (this._addNumberUtils == null) {
                this._addNumberUtils = new AddNumberUtils(this.____995, starTempInfo.fightValue)
            }
            if (isInfoUpdate != null && isInfoUpdate) {
                this._addNumberUtils.setValue(starTempInfo.fightValue, true)
            } else {
                this._addNumberUtils.setValue(starTempInfo.fightValue, false)
            }
            for (var i = 0; i < starTempInfo.attrStr.length; i++) {
                if (this.____1555[i] != null) {
                    var name = ____655.____659.propertyType.getNameByType(starTempInfo.attrStr[i].id);
                    this.____1555[i].setString(name + "：");
                    this.____1568[i].setString(starTempInfo.attrStr[i].value)
                }
            }
        }
        if (nextStarTempInfo != null) {
            var hasCount = 0;
            var needCount = 0;
            if (this.____1031 != null) {
                for (var i = 0; i < nextStarTempInfo.attrStr.length; i++) {
                    if (this._proPlusValueList[i] != null) {
                        var value = nextStarTempInfo.attrStr[i].value - starTempInfo.attrStr[i].value;
                        this._proPlusValueList[i].setString("+" + value)
                    }
                }
                hasCount = ____655.itemInfoList.getCountByTempId(nextStarTempInfo.needItems[0][0]);
                needCount = nextStarTempInfo.needItems[0][1]
            } else {
                for (var i = 0; i < nextStarTempInfo.attrStr.length; i++) {
                    if (this._proPlusValueList[i] != null) {
                        this._proPlusValueList[i].setString("")
                    }
                }
                hasCount = ____655.itemInfoList.getCountByTempId(starTempInfo.needItems[0][0]);
                needCount = starTempInfo.needItems[0][1]
            }
            var percent = Math.floor(hasCount / needCount * 100);
            if (percent > 100) percent = 100;
            this.____861.setPercent(percent);
            this.____865.setString(hasCount + "/" + needCount);
            this._upBtn.setFrame("btn/ui_btn1_2.png");
            this._upBtn.setTouchEnabled(true);
            if (hasCount >= needCount) {
                if (this.____1828 == null) {
                    this.____1828 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                    this.____1828.setScaleX(1.2);
                    this.____1828.move(774, 66);
                    this.____1828.play();
                    this.____1828.addTo(this, 10)
                }
            } else {
                if (this.____1828 != null) {
                    this.____1828.dispose();
                    this.____1828 = null
                }
            }
        } else {
            for (var i = 0; i < this._proPlusValueList.length; i++) {
                if (this._proPlusValueList[i] != null) {
                    this._proPlusValueList[i].setString("")
                }
            }
            this.____861.setPercent(100);
            this.____865.setString("MAX");
            this.____1829.setString(____654.yuyanbaoManager.getYuyanbao("____2235.text5"));
            this._upBtn.setFrame("btn/ui_btn1_4.png");
            this._upBtn.setTouchEnabled(false);
            if (this.____1828 != null) {
                this.____1828.dispose();
                this.____1828 = null
            }
        }
        this.showCharacter(tempInfo)
    },
    showCharacter: function(tempInfo) {
        if (tempInfo == null) return;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._characterEffect == null) {
            this._characterEffect = ____654.effectManager.create(____655.allTemplates.____789.CHARACTER_BG_EFFECT, false, null, false);
            this._characterEffect.move(167, 45);
            this._characterEffect.play();
            this._characterEffect.addTo(this.____1674)
        }
        var styleList = {};
        styleList[____655.____659.commonStaticType.style_Cloth] = tempInfo.figureId;
        this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Cloth, ____655.____659.____687.playerStand1);
        this._characterInfo.updateStyle(styleList);
        this.____944 = new ____545(this._characterInfo);
        this.____944.init(____655.____659.____686.rightBottom, this.____1674);
        var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId);
        var scaleValue = figureTemplate.windowScale * 1.2;
        this.____944.setScale(scaleValue);
        var x = 138 * scaleValue;
        var y = 54 * scaleValue;
        this.____944.move(x, y)
    },
    setStar: function(count) {
        for (var i = 0; i < this.____1706.length; i++) {
            if (i < count) {
                this.____1706[i].setFrame("icon/ui_startIcon1.png")
            } else {
                this.____1706[i].setFrame("icon/ui_startIcon0.png")
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1151 = null;
        this._tileContainer = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this._characterEffect != null) {
            this._characterEffect.dispose();
            this._characterEffect = null
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        if (this.____1828 != null) {
            this.____1828.dispose();
            this.____1828 = null
        }
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        this.____995 = null;
        this._upBtn = null;
        this.____1706 = null;
        this.____1555 = null;
        this.____1568 = null;
        this._proPlusValueList = null;
        this.____865 = null;
        this.____861 = null;
        this.____1185 = null;
        this.____1829 = null;
        this.____1637 = null;
        this.____1252 = null;
        this.____1076 = null;
        this.____1031 = null;
        this._panelType = null;
        this.____1834 = null;
        this.____1674 = null;
        this._super()
    },
});
var ____2236 = KYNode.extend({
    _bg: null,
    _tipImg: null,
    _nameLabel: null,
    ____866: null,
    ____1716: null,
    ____1706: null,
    ____963: null,
    ____964: null,
    ____1461: null,
    ____1821: null,
    ____865: null,
    ____1021: null,
    _panelType: 0,
    _info: null,
    ____1752: null,
    ____1241: 0,
    _path: null,
    ____1512: null,
    ____1533: null,
    _callBack: null,
    _executor: null,
    ctor: function(index) {
        this.____1241 = index;
        this._super("itemTabBtn.ExportJson");
        this._bg = this.getChildByName("btnImg");
        this._tipImg = this.getChildByName("tipImg");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____964 = this.getChildByName("checkBoxBtn");
        this.____963 = this.getChildByName("checkBox");
        this.____963.setTouchEnabled(false);
        this.____1461 = this.getChildByName("notGetFlag");
        this.____866 = this.getChildByName("livePanel");
        this.____1821 = this.____866.getChildByName("moneyIcon");
        this.____865 = this.____866.getChildByName("moneyLabel");
        this.____1021 = this.____866.getChildByName("countBar");
        this.____1716 = this.getChildByName("starPanel");
        this.____1706 = [];
        for (var i = 1; i <= 5; i++) {
            this.____1706.push(this.____1716.getChildByName("starIcon" + i))
        }
        var itemCell = this.getChildByName("itemCell");
        this.____1512 = ____654.____673.newKYSprite();
        this.____1512.setPosition(____654.____673.____159(41, 41));
        this.____1512.setScale(1.2);
        itemCell.addChild(this.____1512, 1);
        this.____963.setSelected(false);
        this._tipImg.setVisible(false);
        this.____1461.setVisible(false);
        this.____6()
    },
    ____6: function() {
        ____655.fashionInfo.addEventListener(____655.____661.fashion_infoUpdate, this.updateInfoHandler, this)
    },
    ____17: function() {
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_infoUpdate, this.updateInfoHandler, this)
    },
    updateInfoHandler: function(evt) {
        var data = evt.data;
        if (data == null) return;
        var type = data[0];
        if (type != null && type == this._panelType) {
            this.updateInfo()
        }
    },
    ____18: function(panelType, template) {
        this._panelType = panelType;
        this.____1752 = template;
        if (panelType != null) {
            if (panelType == ____655.____659.commonStaticType.style_fashion_cloth) {
                this.____1821.setFrame("icon/ui_moneyIcon4.png")
            }
            if (panelType == ____655.____659.commonStaticType.style_fashion_horse) {
                this._tipImg.setFrame("flag/ui_riderFlag.png")
            } else {
                this._tipImg.setFrame("flag/ui_usingFlag.png")
            }
        }
        var this_ = this;

        function complateHandler() {
            if (this_._info == null) {
                ____654.shaderCache.setColor(this_.____1512, 1)
            } else {
                ____654.shaderCache.setColor(this_.____1512, 0)
            }
        };
        if (this.____1752 != null) {
            this._path = ____654.____675.getIconPath(this.____1752.iconPath, ____655.____659.iconPathType.item);
            if (this._path != null) {
                ____654.____677.____146(this.____1512, this._path, complateHandler)
            }
            this._nameLabel.setString(this.____1752.name);
            this.updateInfo()
        }
    },
    updateInfo: function() {
        if (this.____1752 != null) {
            this._info = ____655.fashionInfo.getFashionInfo(this._panelType, this.____1752.templateId)
        }
        if (this._info != null) {
            this.____866.setVisible(false);
            this.____1716.setVisible(true);
            this.setStarCount(this._info.star);
            this.____1461.setVisible(false);
            ____654.shaderCache.setColor(this.____1512, 0)
        } else {
            this.____866.setVisible(true);
            this.____1716.setVisible(false);
            this.____1461.setVisible(true);
            ____654.shaderCache.setColor(this.____1512, 1)
        }
    },
    setShowPop: function(value) {
        if (value) {
            if (this.____1533 == null) {
                this.____1533 = ____654.____673.newKYSprite();
                this.____1533.setFrame("icon/ui_numTipIcon.png");
                this.____1533.setPosition(____654.____673.____159(306, 100));
                this.addChild(this.____1533, 99)
            }
        } else {
            if (this.____1533 != null) {
                this.____1533.dispose();
                this.____1533 = null
            }
        }
    },
    setClickCallBack: function(callBack, executor) {
        this._callBack = callBack;
        this._executor = executor;
        if (this._executor != null) {
            this.____964.addListener(this, this.checkBoxClickHandler, null, null, null, false)
        }
    },
    checkBoxClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this._callBack != null) {
                this._callBack.call(this._executor, this)
            }
        }
    },
    setStarCount: function(count) {
        for (var i = 0; i < this.____1706.length; i++) {
            if (i < count) {
                this.____1706[i].setFrame("icon/ui_startIcon1.png")
            } else {
                this.____1706[i].setFrame("icon/ui_startIcon0.png")
            }
        }
    },
    ____239: function(isSelect) {
        if (isSelect == true) {
            this._bg.setFrame("board/ui_board8.png")
        } else {
            this._bg.setFrame("board/ui_board7.png")
        }
    },
    setUse: function(isUse) {
        this.____963.setSelected(isUse);
        this._tipImg.setVisible(isUse)
    },
    updateCount: function(count, needCount) {
        if (this._info != null) return;
        if (count != null && needCount != null) {
            var percent = Math.floor(count / needCount * 100);
            if (percent > 100) percent = 100;
            this.____1021.setPercent(percent);
            this.____865.setString(count + "/" + needCount)
        } else {
            this.____865.setString("");
            this.____1021.setPercent(0)
        }
    },
    getIndex: function() {
        return this.____1241
    },
    getTempInfo: function() {
        return this.____1752
    },
    getTempInfoId: function() {
        if (this.____1752 != null) {
            return this.____1752.templateId
        }
        return null
    },
    dispose: function() {
        this.____17();
        this.setShowPop(false);
        this._tipImg = null;
        ____654.shaderCache.removeColor(this.____1512);
        this.____1512.dispose();
        this.____1512 = null;
        this._nameLabel = null;
        this.____866 = null;
        this.____1716 = null;
        this.____1706 = null;
        this.____963 = null;
        this.____964 = null;
        this.____1461 = null;
        this.____1821 = null;
        this.____865 = null;
        this.____1021 = null;
        this._panelType = 0;
        this._info = null;
        this.____1752 = null;
        this._super()
    },
});
var ____2237 = KYNode.extend({
    _type: -1,
    _moneyIcons: null,
    _moneyLabels: null,
    _bgs: null,
    ____1530: null,
    ctor: function(type) {
        this._super("moneyView.ExportJson");
        this._moneyIcons = [this.getChildByName("moneyIcon1"), this.getChildByName("moneyIcon2"), this.getChildByName("moneyIcon3")];
        this._moneyLabels = [this.getChildByName("money1Label"), this.getChildByName("money2Label"), this.getChildByName("money3Label")];
        this._bgs = [this.getChildByName("bg1__1"), this.getChildByName("bg2__1"), this.getChildByName("bg3__1")];
        this.____1530 = this.getChildByName("plusBtn");
        if (type != null) {
            this.setType(type)
        } else {
            this.setType(0)
        }
        this.____6()
    },
    ____6: function() {
        ____655.____667.moneyInfo.addEventListener(____655.____661.____701, this.moneyUpdateHandler, this);
        this.____1530.addListener(this, this.____16)
    },
    ____17: function() {
        ____655.____667.moneyInfo.removeEventListener(____655.____661.____701, this.moneyUpdateHandler, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1530) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
            }
        }
    },
    moneyUpdateHandler: function(evt) {
        if (this._type == 0) {
            this._moneyLabels[0].setString(____655.____667.moneyInfo.list[0]);
            this._moneyLabels[1].setString(____655.____667.moneyInfo.list[1]);
            this._moneyLabels[2].setString(____654.____674.getWanCount(____655.____667.moneyInfo.list[2]))
        } else if (this._type == 1) {
            this._moneyLabels[0].setString(____655.____667.moneyInfo.list[0]);
            this._moneyLabels[1].setString(____655.____667.moneyInfo.list[1]);
            this._moneyLabels[2].setString(____654.____674.getWanCount(____655.____667.moneyInfo.list[5]))
        } else if (this._type == 2) {
            this._moneyLabels[0].setString(____654.____674.getWanCount(____655.____667.moneyInfo.list[5]))
        } else if (this._type == 3) {
            this._moneyLabels[0].setString(____655.____667.moneyInfo.list[0]);
            this._moneyLabels[1].setString(____655.____667.moneyInfo.list[1])
        }
    },
    setType: function(value) {
        if (this._type == value) {
            return
        }
        this._type = value;
        if (this._type == 0) {
            this._moneyIcons[0].setFrame(____654.____675.getMoneyPathByType(1));
            this._moneyIcons[1].setFrame(____654.____675.getMoneyPathByType(2));
            this._moneyIcons[1].setVisible(true);
            this._moneyLabels[1].setVisible(true);
            this._bgs[1].setVisible(true);
            this._moneyIcons[2].setFrame(____654.____675.getMoneyPathByType(3));
            this._moneyIcons[2].setVisible(true);
            this._moneyLabels[2].setVisible(true);
            this._bgs[2].setVisible(true);
            this.____1530.setVisible(true)
        } else if (this._type == 1) {
            this._moneyIcons[0].setFrame(____654.____675.getMoneyPathByType(1));
            this._moneyIcons[1].setFrame(____654.____675.getMoneyPathByType(2));
            this._moneyIcons[1].setVisible(true);
            this._moneyLabels[1].setVisible(true);
            this._bgs[1].setVisible(true);
            this._moneyIcons[2].setFrame(____654.____675.getMoneyPathByType(6));
            this._moneyIcons[2].setVisible(true);
            this._moneyLabels[2].setVisible(true);
            this._bgs[2].setVisible(true);
            this.____1530.setVisible(true)
        } else if (this._type == 2) {
            this._moneyIcons[0].setFrame(____654.____675.getMoneyPathByType(6));
            this._moneyIcons[1].setVisible(false);
            this._moneyLabels[1].setVisible(false);
            this._bgs[1].setVisible(false);
            this._moneyIcons[2].setVisible(false);
            this._moneyLabels[2].setVisible(false);
            this._bgs[2].setVisible(false);
            this.____1530.setVisible(false)
        } else if (this._type == 3) {
            this._moneyIcons[0].setFrame(____654.____675.getMoneyPathByType(1));
            this._moneyIcons[1].setFrame(____654.____675.getMoneyPathByType(2));
            this._moneyIcons[1].setVisible(true);
            this._moneyLabels[1].setVisible(true);
            this._bgs[1].setVisible(true);
            this._moneyIcons[2].setVisible(false);
            this._moneyLabels[2].setVisible(false);
            this._bgs[2].setVisible(false);
            this.____1530.setVisible(true)
        }
        this.moneyUpdateHandler()
    },
    dispose: function() {
        this.____17();
        this._super();
        this._moneyIcons = null;
        this._moneyLabels = null;
        this._bgs = null;
        this.____1530 = null
    },
});
var ____2238 = KYPanel.extend({
    _controller: null,
    ____1606: null,
    ____1563: null,
    _moneyView: null,
    _addFriendBtn: null,
    ctor: function(controller, type) {
        this._super("rolePanel.ExportJson");
        this._controller = controller;
        var roleLayer = this.getChildByName("roleLayer");
        var propertyLayer = this.getChildByName("bagLayer");
        var moneyLayer = this.getChildByName("moneyLayer");
        this.____1606 = new ____2240(this._controller, type);
        roleLayer.addChild(this.____1606);
        this.____1563 = new PropertyView(type);
        propertyLayer.addChild(this.____1563);
        this._moneyView = new ____2237();
        moneyLayer.addChild(this._moneyView);
        this._addFriendBtn = this.getChildByName("addFriendBtn");
        if (type == 1) {
            this._moneyView.setVisible(false);
            this._addFriendBtn.addListener(this, this.addFriendHandler);
            this.getChildByName("tipLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2238.text1"))
        } else {
            this._addFriendBtn.setVisible(false);
            this.getChildByName("tipLabel").setVisible(false);
            this.getChildByName("addIcon").setVisible(false)
        }
    },
    addFriendHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____655.lookInfo.addFriend()
        }
    },
    dispose: function() {
        this._controller = null;
        if (this.____1606 != null) {
            this.____1606.dispose();
            this.____1606 = null
        }
        if (this.____1563 != null) {
            this.____1563.dispose();
            this.____1563 = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this._addFriendBtn = null;
        this._super()
    },
});
var PropertyView = KYNode.extend({
    ____977: null,
    ____1382: null,
    ____1293: null,
    ____1553: null,
    ____1142: null,
    ____1144: null,
    _skillGirdList: null,
    _nameList: null,
    _tickCount: 0,
    _type: 0,
    ____1523: null,
    ctor: function(type) {
        this._super("rolePropertyView.ExportJson");
        this.____977 = this.getChildByName("clubLabel");
        this.____1382 = this.getChildByName("marryLabel");
        this.____1293 = this.getChildByName("jieyiLabel");
        this.____1142 = this.getChildByName("expBar");
        this.____1144 = this.getChildByName("expLabel");
        this.getChildByName("clubTitle").setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle25") + "：");
        this.getChildByName("marryTitle").setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle46") + " : ");
        this.getChildByName("jieyiTitle").setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle27") + " : ");
        this._nameList = [____654.yuyanbaoManager.getYuyanbao("common.propertyName8") + " : ", ____654.yuyanbaoManager.getYuyanbao("____2178.text1"), ____654.yuyanbaoManager.getYuyanbao("____2178.text2"), ____654.yuyanbaoManager.getYuyanbao("____2178.text5"), ____654.yuyanbaoManager.getYuyanbao("____2178.text6"), ____654.yuyanbaoManager.getYuyanbao("____2178.text3"), ____654.yuyanbaoManager.getYuyanbao("____2178.text4"), ____654.yuyanbaoManager.getYuyanbao("common.propertyName4") + " : ", ____654.yuyanbaoManager.getYuyanbao("common.propertyName3") + " : ", ____654.yuyanbaoManager.getYuyanbao("common.propertyName26") + " : ", ____654.yuyanbaoManager.getYuyanbao("common.propertyName5") + " : ", ____654.yuyanbaoManager.getYuyanbao("common.propertyName7") + " : ", ____654.yuyanbaoManager.getYuyanbao("common.propertyName6") + " : ", ];
        this.____1553 = [];
        this._skillGirdList = [];
        for (var i = 1; i <= 13; i++) {
            var proLabel = this.getChildByName("proValue" + i);
            this.____1553.push(proLabel);
            var nameLabel = this.getChildByName("proName" + i);
            nameLabel.setString(this._nameList[i - 1])
        }
        for (var i = 1; i <= 4; i++) {
            var gird = new ____2131(false, 43, 43);
            this.getChildByName("skillCell" + i).addChild(gird);
            this._skillGirdList.push(gird)
        }
        this._type = type;
        if (this._type == 1) {
            this.____1142.setVisible(false);
            this.____1144.setVisible(false);
            this.getChildByName("expTitel").setVisible(false);
            this.getChildByName("ImageView_736612_Copy0").setVisible(false);
            this.____1523 = ____655.lookInfo.playerInfo
        } else {
            this.____6();
            this.____1523 = ____655.____667
        }
        this.initData()
    },
    ____6: function() {
        ____655.fashionInfo.addEventListener(____655.____661.fashion_infoUpdate, this.fashionUpdateHandler, this)
    },
    ____17: function() {
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_infoUpdate, this.fashionUpdateHandler, this)
    },
    fashionUpdateHandler: function() {
        this._tickCount = 0;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this.initData();
            ____654.____678.____299(this.tick, this)
        }
    },
    initData: function() {
        if (this._type == 1) {
            if (____655.lookInfo.marryName != "") {
                this.____1382.setString(____655.lookInfo.marryName)
            }
            if (this.____1523.clubName != "") {
                this.____977.setString(this.____1523.clubName)
            }
            var brotherNameList = ____655.lookInfo.oathNamelist;
            if (brotherNameList.length <= 0) {
                this.____1293.setString("无")
            } else if (brotherNameList.length == 1) {
                this.____1293.setString(brotherNameList[0])
            } else if (brotherNameList.length == 2) {
                this.____1293.setString(brotherNameList[0] + "、" + brotherNameList[1])
            }
        } else {
            if (____655.marryOathInfo.marryId > 0) {
                this.____1382.setString(____655.marryOathInfo.marryName)
            }
            if (____655.marryOathInfo.oathPos > 0) {
                var str = "";
                for (var pos in ____655.marryOathInfo.oathBrotherList) {
                    var info = ____655.marryOathInfo.oathBrotherList[pos];
                    if (info != null && info.userId != ____655.____667.userId) {
                        if (str == "") {
                            str = info.nick
                        } else {
                            str = str + "、" + info.nick
                        }
                    }
                }
                this.____1293.setString(str)
            }
            if (____655.clubInfo.id > 0) {
                this.____977.setString(____655.clubInfo.name)
            }
            var exp;
            var total;
            var nowTemp = ____655.allTemplates.expTemplateList.____238(this.____1523.level);
            if (this.____1523.level >= ____655.allTemplates.expTemplateList.maxLevel) {
                exp = this.____1523.exp;
                total = this.____1523.exp
            } else {
                var nextTemp = ____655.allTemplates.expTemplateList.____238(this.____1523.level + 1);
                if (nowTemp == null) {
                    exp = this.____1523.exp;
                    total = nextTemp.totalExp
                } else {
                    exp = this.____1523.exp - nowTemp.totalExp;
                    total = nextTemp.totalExp - nowTemp.totalExp
                }
            }
            this.____1142.setPercent(Math.floor(exp / total * 100));
            this.____1144.setString(exp + "/" + total)
        }
        this.____1553[0].setString(this.____1523.maxHP);
        this.____1553[1].setString(this.____1523.attack);
        this.____1553[2].setString(this.____1523.defense);
        for (var i = 3; i < 7; i++) {
            if (this.____1523.propertys[i - 3] != null) {
                this.____1553[i].setString(this.____1523.propertys[i - 3])
            }
        }
        for (var i = 7; i < 13; i++) {
            if (this.____1523.propertys[i - 3] != null) {
                var value = this.____1523.propertys[i - 3] / 100;
                if (i == 10) {
                    value = Math.max(0, (this.____1523.propertys[i - 3] - 10000)) / 100
                }
                this.____1553[i].setString(value + "%")
            }
        }
        var skillList = ____655.allTemplates.skillTemplateList.getSkillListByCareer(this.____1523.career);
        var godType = 0;
        if (this._type == 1) {
            godType = ____655.lookInfo.getUseGodWeaponType()
        } else {
            godType = ____655.furnaceInfo.getUseGodWeaponType()
        }
        if (godType < 0) {
            godType = null
        }
        var skillInfo = ____655.skillItemList;
        for (var i = 0; i < this._skillGirdList.length; i++) {
            var id = skillList[i + 1];
            if (id != null) {
                var skillLevel = 0;
                if (this._type == 1) {
                    if (____655.lookInfo.skillList[id] != null) {
                        skillLevel = ____655.lookInfo.skillList[id]
                    }
                } else {
                    skillLevel = skillInfo.getSkillLevel(id)
                }
                var templateInfo = ____655.allTemplates.skillTemplateList.getSkill(id);
                this._skillGirdList[i].setSkillTemplateInfo(templateInfo, godType);
                this._skillGirdList[i].____64(skillLevel)
            }
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        if (this._type == 1) {} else {
            this.____17()
        }
        this.____977 = null;
        this.____1382 = null;
        this.____1293 = null;
        this.____1553 = null;
        this.____1142 = null;
        this.____1144 = null;
        if (this._skillGirdList != null) {
            for (var i = 0; i < this._skillGirdList.length; i++) {
                this._skillGirdList[i].dispose();
                this._skillGirdList[i] = null
            }
        }
        this._skillGirdList = null;
        this._nameList = null;
        this.____1523 = null;
        this._super()
    },
});
var RenameView = KYPanel.extend({
    _controller: null,
    _titleLabel: null,
    _renameBtn: null,
    _cancelBtn: null,
    _nameLabel: null,
    _inputNameController: null,
    ctor: function(controller) {
        this._super("reNamePanel.ExportJson");
        this._controller = controller;
        this.modeValue = 100;
        this.setTouchEnabled(true);
        this._titleLabel = this.getChildByName("titleLabel");
        this._renameBtn = this.getChildByName("btn1");
        this._cancelBtn = this.getChildByName("btn2");
        this._nameLabel = this.getChildByName("nameLabel");
        this._inputNameController = new InputLabelController(this._nameLabel.getPosition(), this._nameLabel.getDimensions(), this, 15, 20, ____654.yuyanbaoManager.getYuyanbao("renameView.text1"));
        this.____6();
        this.____5()
    },
    ____5: function() {},
    ____6: function() {
        this._renameBtn.addListener(this, this.____16);
        this._cancelBtn.addListener(this, this.____16)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._renameBtn) {
                var name = this._inputNameController.getString();
                if (name == null || name == "") {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("start.loginTips3"));
                    return
                }
                var nameLen = ____655.wordFiltersInfo.getStringLen(name);
                if (nameLen < 4 || nameLen > 10) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("start.loginTips3"));
                    return
                }
                if (!____655.____667.moneyInfo.moneyEnoughByType(5, 500)) {
                    ____655.____667.moneyInfo.showNotEnoughTip(1);
                    return
                }
                if (____655.wordFiltersInfo.checkName(name)) {
                    ____654.selfDataMessageSender.sendRename(name);
                    this._controller.hideRenameView()
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("start.loginTips8"))
                }
            } else if (sender == this._cancelBtn) {
                this._controller.hideRenameView()
            }
        }
    },
    hideFormContainer: function() {},
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._controller = null;
        this._titleLabel = null;
        this._renameBtn = null;
        this._cancelBtn = null;
        this._nameLabel = null;
        if (this._inputNameController != null) {
            this._inputNameController.dispose();
            this._inputNameController = null
        }
        this._super()
    },
});
var ____2240 = KYNode.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    ____1864: null,
    ____1865: null,
    ____1866: null,
    ____1870: null,
    ____1871: null,
    ____1872: null,
    ____1861: null,
    ____1862: null,
    ____1863: null,
    _weaponTipList: null,
    _weaponWordList: null,
    _renameBtn: null,
    _renameIcon: null,
    _gridList: null,
    ____950: null,
    _nameLabel: null,
    ____1846: null,
    _xianWeiLayer: null,
    _xianWeiLabel: null,
    _xianWeiImg: null,
    ____944: null,
    ____1889: null,
    _addNumberUtils: null,
    ____1706: null,
    _type: 0,
    ____1523: null,
    _touchBeginPos: null,
    ____1711: null,
    ctor: function(controller, type) {
        this._super("roleDisplayView.ExportJson");
        this._controller = controller;
        this._type = type;
        this._bg = this.getChildByName("bg");
        this._weaponTipList = [];
        this._weaponWordList = [];
        this.____1861 = this.getChildByName("weaponBtn1");
        this._weaponTipList.push(this.getChildByName("tipImg1"));
        this._weaponWordList.push(this.getChildByName("markImg1"));
        this.____1862 = this.getChildByName("weaponBtn2");
        this._weaponTipList.push(this.getChildByName("tipImg2"));
        this._weaponWordList.push(this.getChildByName("markImg2"));
        this.____1863 = this.getChildByName("weaponBtn3");
        this._weaponTipList.push(this.getChildByName("tipImg3"));
        this._weaponWordList.push(this.getChildByName("markImg3"));
        this.____1706 = [];
        this.____1706[0] = [];
        for (var i = 1; i < 6; i++) {
            this.____1706[0].push(this.getChildByName("starIcon1" + i))
        }
        this.____1706[1] = [];
        for (var i = 1; i < 6; i++) {
            this.____1706[1].push(this.getChildByName("starIcon2" + i))
        }
        this.____1706[2] = [];
        for (var i = 1; i < 6; i++) {
            this.____1706[2].push(this.getChildByName("starIcon3" + i))
        }
        this._bgPath = ____654.____675.____139("outPic/role_bg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1864 = this.getChildByName("weaponIcon1");
        this.____1870 = ____654.____675.____139("outPic/role_weaponIcon1.png");
        ____654.____677.____146(this.____1864, this.____1870);
        this.____1865 = this.getChildByName("weaponIcon2");
        this.____1871 = ____654.____675.____139("outPic/role_weaponIcon2.png");
        ____654.____677.____146(this.____1865, this.____1871);
        this.____1866 = this.getChildByName("weaponIcon3");
        this.____1872 = ____654.____675.____139("outPic/role_weaponIcon3.png");
        ____654.____677.____146(this.____1866, this.____1872);
        this.____950 = this.getChildByName("characterLayer");
        this.____1846 = this.getChildByName("vipLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1157 = this.getChildByName("fightLabel");
        this._xianWeiLabel = this.getChildByName("xianWeiLabel");
        this._xianWeiImg = this.getChildByName("tipImg");
        this._renameBtn = this.getChildByName("renameBtn");
        this._renameIcon = this.getChildByName("renameIcon");
        this._gridList = [];
        for (var i = 1; i < 9; i++) {
            var cell = new ____2129(null, null, null, null, false);
            cell.setIsShowCount(false);
            cell.setIsShowQHLevel(true);
            this.getChildByName("cell" + i).addChild(cell);
            cell.____1512.addListener(this, null, this.downHandler, this.upHandler, this.____358);
            this._gridList.push(cell)
        }
        if (this._type == 1) {
            this._xianWeiImg.setVisible(false);
            this._renameBtn.setTouchEnabled(false);
            this._renameIcon.setVisible(false);
            this.____1523 = ____655.lookInfo.playerInfo
        } else {
            this._xianWeiImg.setTouchEnabled(true);
            this._renameBtn.setTouchEnabled(true);
            this._renameIcon.setVisible(true);
            this.____1523 = ____655.____667
        }
        if (this.____1523.xianwei >= ____655.allTemplates.xianWeiTemplateList.totalXianWeiNum) {
            this._xianWeiImg.setVisible(false)
        }
        this._xianWeiLabel.setString(____655.____659.nameType.getXianweiName(this.____1523.xianwei));
        this._xianWeiImg.setPositionX(this._xianWeiLabel.getPositionX() + this._xianWeiLabel.getContentSize().width + 21);
        this.____1157.setString(this.____1523.combat);
        this.____944 = new ____545(this.____1523.characterInfo);
        this.____944.init(____655.____659.____686.rightBottom, this.____950, 30);
        this.____944.move(0, 20 + this.____1523.characterInfo.getYOffset());
        this.____944.setScale(1.1);
        this.____944.____203(____655.____659.____687.stand);
        this.levelUpdate();
        this.vipLevelUpdate();
        this.itemsUpdate();
        if (this._type == 1) {
            this._xianWeiLabel.setPositionX(210)
        }
        this.____6();
        this.updateGodInfo()
    },
    createZhengLing: function() {
        var fazhenId = this.____1523.characterInfo.getStyleList()[____655.____659.commonStaticType.style_ZhengLing];
        if (fazhenId == null || fazhenId == 0) {
            if (this.____1889 != null) {
                this.____1889.dispose();
                this.____1889 = null
            }
        } else {
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ZhengLing, fazhenId).figureId);
            this.____1889 = ____654.effectManager.setEffect(effectId, false, ____654.____673.____159(0, 0), this.____950)
        }
    },
    xianWeiUpdateHandler: function() {
        this._xianWeiLabel.setString(____655.____659.nameType.getXianweiName(this.____1523.xianwei))
    },
    levelUpdate: function() {
        this._nameLabel.setString(this.____1523.nick + "(Lv" + this.____1523.level + ")")
    },
    vipLevelUpdate: function() {
        if (this.____1523.vipLevel > 0) {
            this.____1846.setString("VIP" + this.____1523.vipLevel)
        } else {
            this.____1846.setString("")
        }
    },
    ____6: function() {
        if (this._type == 1) {
            this.____1861.addListener(this, null, this.weaponBtnTouchBegin, this.weaponBtnTouchUp, this.weaponBtnTouchMove);
            this.____1862.addListener(this, null, this.weaponBtnTouchBegin, this.weaponBtnTouchUp, this.weaponBtnTouchMove);
            this.____1863.addListener(this, null, this.weaponBtnTouchBegin, this.weaponBtnTouchUp, this.weaponBtnTouchMove)
        } else {
            ____655.itemInfoList.addEventListener(____655.____661.common_itemListUpdate, this.itemsUpdate, this);
            ____655.____667.addEventListener(____655.____661.playerInfo_combatUpdate, this.fightUpdateHandler, this);
            ____655.furnaceInfo.addEventListener(____655.____661.weapon_godInfoUpdate, this.updateGodInfo, this);
            ____655.____667.addEventListener(____655.____661.____703, this.levelUpdate, this);
            ____655.____667.addEventListener(____655.____661.playerInfo_nick, this.levelUpdate, this);
            ____655.____667.addEventListener(____655.____661.____704, this.vipLevelUpdate, this);
            ____655.____667.addEventListener(____655.____661.playerInfo_xianweiUpdate, this.xianWeiUpdateHandler, this);
            this._xianWeiImg.addListener(this, this.____16);
            this._renameBtn.addListener(this, this.____16);
            this.____1861.addListener(this, this.____16);
            this.____1862.addListener(this, this.____16);
            this.____1863.addListener(this, this.____16)
        }
    },
    fightUpdateHandler: function() {
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____1157, this.____1523.combat)
        } else {
            this._addNumberUtils.setValue(this.____1523.combat)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1861) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup)
            } else if (sender == this.____1862) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup)
            } else if (sender == this.____1863) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup)
            } else if (sender == this._xianWeiImg) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.open_xianweiTipsPanel, ____654.____672))
            } else if (sender == this._renameBtn) {
                this._controller.showRenameView()
            }
        }
    },
    weaponBtnTouchBegin: function(sender, eventType, pos) {
        this._touchBeginPos = pos;
        if (sender == this.____1861) {
            var pos = this.convertToWorldSpace(this.____1861.getPosition());
            this.showShenBingFlashTip(____655.furnaceInfo.GOD_WEAPON_TYPE[0], pos)
        } else if (sender == this.____1862) {
            var pos = this.convertToWorldSpace(this.____1862.getPosition());
            this.showShenBingFlashTip(____655.furnaceInfo.GOD_WEAPON_TYPE[1], pos)
        } else if (sender == this.____1863) {
            var pos = this.convertToWorldSpace(this.____1863.getPosition());
            this.showShenBingFlashTip(____655.furnaceInfo.GOD_WEAPON_TYPE[2], pos)
        }
    },
    weaponBtnTouchUp: function(sender, eventType) {
        if (sender == this.____1861 || sender == this.____1862 || sender == this.____1863) {
            ____654.tipsManager.hideFlashTip()
        }
    },
    weaponBtnTouchMove: function(sender, eventType, pos) {
        if (sender == this.____1861 || sender == this.____1862 || sender == this.____1863) {
            if (this._touchBeginPos.x - pos.x > 15 || this._touchBeginPos.y - pos.y > 15) {
                ____654.tipsManager.hideFlashTip()
            }
        }
    },
    showShenBingFlashTip: function(type, pos) {
        var info = ____655.lookInfo.getGodWeaponInfoByType(type);
        var level = 0;
        if (info != null) {
            level = info.level
        }
        var templateInfoList = ____655.allTemplates.fashionTemplateList.getList(type);
        if (templateInfoList != null) {
            var templateInfo = templateInfoList[0];
            ____654.tipsManager.showFlashShenBingTip(templateInfo, level, pos)
        }
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemListUpdate, this.itemsUpdate, this);
        ____655.____667.removeEventListener(____655.____661.playerInfo_combatUpdate, this.fightUpdateHandler, this);
        ____655.furnaceInfo.removeEventListener(____655.____661.weapon_godInfoUpdate, this.updateGodInfo, this);
        ____655.____667.removeEventListener(____655.____661.____703, this.levelUpdate, this);
        ____655.____667.removeEventListener(____655.____661.playerInfo_nick, this.levelUpdate, this);
        ____655.____667.removeEventListener(____655.____661.____704, this.vipLevelUpdate, this);
        ____655.____667.removeEventListener(____655.____661.playerInfo_xianweiUpdate, this.xianWeiUpdateHandler, this)
    },
    updateGodInfo: function(evt) {
        if (this._type == 1) {
            for (var i = 0; i < this._weaponWordList.length; i++) {
                this._weaponWordList[i].setVisible(false);
                this._weaponTipList[i].setVisible(false)
            }
            var weaponGodList = ____655.furnaceInfo.GOD_WEAPON_TYPE;
            for (var i = 0; i < weaponGodList.length; i++) {
                var info = ____655.lookInfo.getGodWeaponInfoByType(weaponGodList[i]);
                if (info != null) {
                    ____654.____674.setKYStarListColor(this.____1706[i], info.level)
                } else {
                    for (var j = 0; j < this.____1706[i].length; j++) {
                        this.____1706[i][j].setVisible(false)
                    }
                }
            }
        } else {
            for (var i = 0; i < this.____1706.length; i++) {
                for (var j = 0; j < this.____1706[i].length; j++) {
                    this.____1706[i][j].setVisible(false)
                }
            }
            var weaponGodList = ____655.furnaceInfo.GOD_WEAPON_TYPE;
            for (var i = 0; i < weaponGodList.length; i++) {
                var info = ____655.furnaceInfo.getGodWeaponInfoByType(weaponGodList[i]);
                if (info == null) {
                    this._weaponTipList[i].setVisible(false);
                    this._weaponWordList[i].setVisible(true);
                    this._weaponWordList[i].setFrame("flag/word_jihuo.png")
                } else {
                    if (info.isUse) {
                        this._weaponWordList[i].setVisible(true);
                        this._weaponWordList[i].setFrame("flag/word_shiyong.png")
                    } else {
                        this._weaponWordList[i].setVisible(false)
                    }
                }
            }
            this.updateGodTip()
        }
    },
    updateGodTip: function() {
        var weaponGodList = ____655.furnaceInfo.GOD_WEAPON_TYPE;
        for (var i = 0; i < weaponGodList.length; i++) {
            var info = ____655.furnaceInfo.getGodWeaponInfoByType(weaponGodList[i]);
            if (info != null) {
                var template = ____655.allTemplates.fashionTemplateList.getList(weaponGodList[i]);
                if (template != null) {
                    template = template[0]
                }
                if (template != null) {
                    var nextStartTempInfo = template.stars[info.level + 1];
                    if (nextStartTempInfo != null) {
                        var count = ____655.itemInfoList.getCountByTempId(nextStartTempInfo.needItems[0][0]);
                        if (count >= nextStartTempInfo.needItems[0][1]) {
                            this._weaponTipList[i].setVisible(true)
                        } else {
                            this._weaponTipList[i].setVisible(false)
                        }
                    } else {
                        this._weaponTipList[i].setVisible(false)
                    }
                } else {
                    this._weaponTipList[i].setVisible(false)
                }
            } else {
                this._weaponTipList[i].setVisible(false)
            }
        }
    },
    itemsUpdate: function(evt) {
        var list = null;
        if (this._type == 1) {
            list = ____655.lookInfo.equipList
        } else {
            list = ____655.itemInfoList.bagTypeList[4];
            this.updateGodTip()
        }
        var haveEquipIndexList = [];
        for (var i = 0; i < list.length; i++) {
            var index = list[i].template.categoryId - 1;
            this._gridList[index].setItemInfo(list[i]);
            haveEquipIndexList.push(index)
        }
        for (var j = 0; j < 8; j++) {
            if (haveEquipIndexList.indexOf(j) == -1) {
                this._gridList[j].setItemInfo(null)
            }
        }
    },
    downHandler: function(sender, eventType, pos) {
        this.showTip(sender);
        this.____1711 = pos
    },
    upHandler: function(sender, eventType, pos) {
        this.hideTip()
    },
    ____358: function(sender, eventType, pos) {
        if (this.____1711 != null) {
            if (this.____1711.x - pos.x > 15 || this.____1711.y - pos.y > 15) {
                this.hideTip()
            }
            this.____1711 = null
        }
    },
    showTip: function(sender) {
        var pos = sender.getParent().convertToWorldSpace(____654.____673.____159(sender.getParent().____1477, sender.getParent().____1478));
        if (sender.getParent().getItemInfo() != null) {
            var stoneList = new TipStoneInfoList(this.____1523.level);
            var equipType = sender.getParent().getItemInfo().template.categoryId;
            var baoshiEquipTemplate = ____655.allTemplates.baoShiEquipTemplateList.getTemplateInfoByType(equipType);
            for (var i = 0; i < baoshiEquipTemplate.baoshiList.length; i++) {
                var stoneInfo = new TipStoneInfo();
                var type = baoshiEquipTemplate.baoshiList[i][0];
                stoneInfo.stoneType = type;
                stoneInfo.openLevel = baoshiEquipTemplate.baoshiList[i][1];
                var template = null;
                if (baoshiEquipTemplate.baoshiList[i][1] >= this.____1523.level) {
                    exp = 0;
                    if (this._type == 1) {
                        exp = ____655.lookInfo.getStoneExpByType(equipType, type)
                    } else {
                        exp = ____655.furnaceInfo.getStoneExpByType(equipType, type)
                    }
                    template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndExp(type, exp)
                }
                if (template == null) {
                    template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndLv(type, 1)
                }
                stoneInfo.stoneLevel = template.level;
                stoneInfo.template = template;
                stoneList.stoneList.push(stoneInfo)
            }
            ____654.tipsManager.showItemFlashTip(sender.getParent().getItemInfo(), pos, stoneList)
        }
    },
    hideTip: function() {
        ____654.tipsManager.hideFlashTip()
    },
    dispose: function() {
        if (this._type == 1) {} else {
            this.____17()
        }
        this._controller = null;
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bg = null;
        ____654.____677.removeImageQuote(this.____1870, this.____1864);
        this.____1864 = null;
        ____654.____677.removeImageQuote(this.____1871, this.____1865);
        this.____1865 = null;
        ____654.____677.removeImageQuote(this.____1872, this.____1866);
        this.____1866 = null;
        this.____950 = null;
        this._nameLabel = null;
        this.____1846 = null;
        this._xianWeiLabel = null;
        this._xianWeiImg = null;
        this.____1861 = null;
        this.____1862 = null;
        this.____1863 = null;
        this._weaponTipList = null;
        this._weaponWordList = null;
        this._renameBtn = null;
        this._renameIcon = null;
        this._touchBeginPos = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this.____1889 != null) {
            this.____1889.dispose();
            this.____1889 = null
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this.____1523 = null;
        this.____1706 = [];
        this.____1711 = null;
        ____654.tipsManager.hideFlashTip();
        this._super()
    },
});
var ____2241 = KYNode.extend({
    ____1445: null,
    ____1473: null,
    ____1157: null,
    ____1800: null,
    titleTemplateId: -1,
    ____1628: null,
    _titleItemView: null,
    ctor: function(controller) {
        this._super("titleItemView.ExportJson");
        this._title = this.getChildByName("titleLayer");
        this.____1445 = [];
        this.____1473 = [];
        for (var i = 1; i <= 5; i++) {
            var nameLab = this.getChildByName("nameLabel" + i);
            this.____1445.push(nameLab);
            var numLab = this.getChildByName("numLabel" + i);
            this.____1473.push(numLab)
        }
        this.____1157 = this.getChildByName("fightLabel");
        this.____1800 = this.getChildByName("titleLayer");
        this.____1628 = this.getChildByName("selectBorad")
    },
    ____239: function(isShow) {
        if (this.____1628 != null) {
            this.____1628.setVisible(isShow)
        }
    },
    setTitleId: function(titleTemplateId) {
        this.titleTemplateId = titleTemplateId;
        var titleTemplate = ____655.allTemplates.titleTemplateList.getTitle(titleTemplateId);
        if (titleTemplate == null) {
            return
        }
        if (titleTemplate.id >= 1000) {
            this.____1157.setString(0)
        } else {
            this.____1157.setString(titleTemplate.fight)
        }
        this._titleItemView = new ____2147(titleTemplateId, this.____1800);
        var len = this.____1445.length;
        for (var i = 0; i < len; i++) {
            if (titleTemplate.propertys[i] != null) {
                this.____1445[i].setString(____655.____659.propertyType.getNameByType(titleTemplate.propertys[i].id));
                this.____1473[i].setString(titleTemplate.propertys[i].value)
            } else {
                this.____1445[i].setString("");
                this.____1473[i].setString("")
            }
        }
    },
    getTitleTemplate: function() {
        return ____655.allTemplates.titleTemplateList.getTitle(this.titleTemplateId)
    },
    dispose: function() {
        this.____1445 = null;
        this.____1473 = null;
        this.____1157 = null;
        this.____1800 = null;
        this.titleTemplateId = null;
        this.____1628 = null;
        if (this._titleItemView != null) {
            this._titleItemView.dispose();
            this._titleItemView = null
        }
        this._super()
    },
});
var ____2242 = KYPanel.extend({
    _controller: null,
    ____1627: null,
    ____896: null,
    ____1460: null,
    _infoLabel: null,
    _timeLabel: null,
    ____889: null,
    ____909: null,
    ____911: false,
    ____1795: null,
    ____1801: null,
    ____1062: -1,
    ____1063: null,
    ____1797: null,
    _countDownUtils: null,
    _currentSelectTitleItem: null,
    _moneyView: null,
    ctor: function(controller) {
        this._super("titlePanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this.____1627 = this.getChildByName("selectBoard");
        this.____896 = this.getChildByName("btnLayer");
        this.____1460 = this.getChildByName("noGetIcon");
        this._infoLabel = this.getChildByName("infoLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____889 = this.getChildByName("Btn_get");
        this.____909 = this.getChildByName("btnName");
        this._btnScrollView = this.getChildByName("btn_ScrollView");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0, null);
        this.____1801 = [____654.yuyanbaoManager.getYuyanbao("____2243.text1"), ____654.yuyanbaoManager.getYuyanbao("____2243.text2"), ____654.yuyanbaoManager.getYuyanbao("____2243.text4"), ____654.yuyanbaoManager.getYuyanbao("____2243.text5")];
        this.____1795 = [];
        this.____1797 = [];
        this._currentSelectTitleIndex = 0;
        this._tileContainer = this.getChildByName("titleLayer__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._btnContainer = this.getChildByName("btn_ScrollView__1");
        this._btnContainer.setCallbacks(this.getBtnByIndex, this.getBtnIdByIndex, this);
        this._btnContainer.setPadding(2, 48);
        this._btnContainer.setFormat(1, this.____1801.length, ____654.____673.____160(275, 96), 5, 5);
        this.____6()
    },
    ____6: function() {
        this.____889.addListener(this, this.____16);
        ____655.titleList.addEventListener(____655.____661.playerInfo_addTitle, this.addTitle, this);
        ____655.titleList.addEventListener(____655.____661.playerInfo_removeTitle, this.removeTitle, this);
        ____655.titleList.addEventListener(____655.____661.playerInfo_updateTitle, this.changeTitle, this)
    },
    getItemByIndex: function(index) {
        var itemInfo = this._list[index];
        if (itemInfo == null) return null;
        var item = new ____2241();
        item.setTitleId(itemInfo.id);
        item.addListener(this, this.itemClickHandler, null, null, null, false, true);
        item.____239(false);
        return item
    },
    getIdByIndex: function(index) {
        var itemInfo = this._list[index];
        if (itemInfo == null) return -1;
        return itemInfo.id
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._currentSelectTitleItem == sender) {
                return
            }
            sender.____239(true);
            if (this._currentSelectTitleItem != null) {
                this._currentSelectTitleItem.____239(false)
            }
            this._currentSelectTitleItem = sender;
            this.____1063 = sender.getTitleTemplate();
            this.showTitleDiscribe(sender.titleTemplateId)
        }
    },
    getBtnByIndex: function(index) {
        var btn = this.____1795[index];
        if (btn == null && this.____1801[index] != null) {
            btn = new ____2143(4);
            btn.setLabel(this.____1801[index]);
            btn.addListener(this, this.btnTabClickHandler);
            btn.setLabel2(this.getTitleCountLabel(index));
            this.____1795[index] = btn
        }
        if (btn != null && index == 0 && this.____1062 < 0) {
            this.____1062 = index;
            this.____1795[0].setSelected(true);
            this.updateTitleLayer()
        }
        return btn
    },
    getBtnIdByIndex: function(index) {
        return index
    },
    btnTabClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this.____1795.indexOf(sender);
            if (index == this.____1062) {
                return
            } else {
                for (var i = 0; i < this.____1795.length; i++) {
                    if (index == i) {
                        this.____1795[index].setSelected(true)
                    } else {
                        this.____1795[i].setSelected(false)
                    }
                }
                this.____1062 = index;
                this._currentSelectTitleItem = null;
                this.____1063 = null;
                this.updateTitleLayer()
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____889) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                if (this.____911 == true) {
                    ____654.selfDataMessageSender.sendTitleChange(this.____1063.type, this.____1063.id)
                } else {
                    ____654.selfDataMessageSender.sendTitleChange(this.____1063.type, 0)
                }
            }
        }
    },
    addTitle: function() {
        this.updateTitleLayer()
    },
    removeTitle: function() {
        this.updateTitleLayer()
    },
    changeTitle: function() {
        this.updateTitleLayer()
    },
    updateTitleLayer: function() {
        this._list = [];
        this._tileContainer.clearAllItems();
        this.updateBtnTitle();
        if (this.____1062 == 0) {
            this._list = ____655.allTemplates.titleTemplateList.getTitlesByType(7)
        } else if (this.____1062 == 1) {
            this._list = ____655.allTemplates.titleTemplateList.getTitlesByType(4)
        } else if (this.____1062 == 2) {
            this._list = ____655.allTemplates.titleTemplateList.getTitlesByType(8)
        } else if (this.____1062 == 3) {
            this._list = ____655.allTemplates.titleTemplateList.getTitlesByType(9)
        }
        if (this._list == null || this._list.length == 0) {
            return
        }
        this._tileContainer.setFormat(1, this._list.length, ____654.____673.____160(316, 366), 0, 12, true);
        if (this.____1063 == null) {
            this.____1063 = this._list[0]
        }
        this.showTitleDiscribe(this.____1063.id)
    },
    updateBtnTitle: function() {
        for (var i = 0; i < this.____1795.length; i++) {
            if (this.____1795[i] != null) {
                this.____1795[i].setLabel2(this.getTitleCountLabel(i))
            }
        }
    },
    getTitleCountLabel: function(index) {
        var title = "";
        if (index == 0) {
            title = ____655.titleList.getTitleCount(7) + "/" + ____655.allTemplates.titleTemplateList.getTitlesByType(7).length
        } else if (index == 1) {
            title = ____655.titleList.getTitleCount(4) + "/" + ____655.allTemplates.titleTemplateList.getTitlesByType(4).length
        } else if (index == 2) {
            title = ____655.titleList.getTitleCount(8) + "/" + ____655.allTemplates.titleTemplateList.getTitlesByType(8).length
        } else if (index == 3) {
            title = ____655.titleList.getTitleCount(9) + "/" + ____655.allTemplates.titleTemplateList.getTitlesByType(9).length
        }
        return title
    },
    showTitleDiscribe: function(titleTemplateId) {
        var titleTemplate = ____655.allTemplates.titleTemplateList.getTitle(titleTemplateId);
        this._infoLabel.setString(titleTemplate.descript);
        var titleInfo = ____655.titleList.getTitle(titleTemplateId);
        if (titleInfo == null) {
            if (titleTemplate.time == 0) {
                this._countDownUtils.stop();
                this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2242.text3"))
            } else {
                this._countDownUtils.stop();
                if (titleTemplate.time >= 86400) {
                    this._timeLabel.setString(Math.floor(titleTemplate.time / 86400) + ____654.yuyanbaoManager.getYuyanbao("____2242.text4"))
                } else {}
            }
        } else {
            if (titleInfo.endTime == 0) {
                this._countDownUtils.stop();
                this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2242.text3"))
            } else {
                var leftTime = titleInfo.endTime - Math.floor(____655.____662.getSystemTime() / 1000);
                this._countDownUtils.start(leftTime)
            }
        }
        this.updateTitleBtnState()
    },
    updateTitleBtnState: function() {
        if (this.____1063 != null) {
            if (____655.titleList.getTitle(this.____1063.id) == null) {
                this.____1460.setVisible(true);
                this.____889.setVisible(false);
                this.____909.setVisible(false)
            } else if (____655.titleList.currentTitleId == this.____1063.id) {
                this.____1460.setVisible(false);
                this.____889.setVisible(true);
                this.____909.setVisible(true);
                this.____909.setString(____654.yuyanbaoManager.getYuyanbao("____2242.text2"));
                this.____911 = false
            } else {
                this.____1460.setVisible(false);
                this.____889.setVisible(true);
                this.____909.setVisible(true);
                this.____909.setString(____654.yuyanbaoManager.getYuyanbao("____2242.text1"));
                this.____911 = true
            }
        } else {
            this.____1460.setVisible(true);
            this.____889.setVisible(false);
            this.____889.setTouchEnabled(false);
            this.____909.setVisible(false)
        }
    },
    ____17: function() {
        ____655.titleList.removeEventListener(____655.____661.playerInfo_addTitle, this.addTitle, this);
        ____655.titleList.removeEventListener(____655.____661.playerInfo_removeTitle, this.removeTitle, this);
        ____655.titleList.removeEventListener(____655.____661.playerInfo_updateTitle, this.changeTitle, this)
    },
    dispose: function() {
        this.____17();
        this.____1627 = null;
        this.____1460 = null;
        this.____896 = null;
        this._infoLabel = null;
        this._timeLabel = null;
        this.____889 = null;
        this.____909 = null;
        this.____911 = false;
        this.____1795 = null;
        this.____1801 = null;
        this.____1062 = null;
        this.____1063 = null;
        this._currentSelectTitleItem = null;
        this.____1797 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._tileContainer = null;
        this._btnContainer = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this._super()
    },
});
var ____2231 = cc.Class.extend({
    roleModule: null,
    ctor: function(roleModule) {
        this.roleModule = roleModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    ____214: function(type) {
        if (this.roleModule.bagPanel == null) {
            this.roleModule.bagPanel = new ____552(this)
        }
        ____654.____676.uiPanelContainer.____125(this.roleModule.bagPanel, type)
    },
    showFashionPanel: function(type) {
        if (this.roleModule.fasionPanel == null) {
            this.roleModule.fasionPanel = new ____2235(this)
        }
        ____654.____676.uiPanelContainer.____125(this.roleModule.fasionPanel, type)
    },
    showPropertyPanel: function(type) {
        if (this.roleModule.propertyPanel == null) {
            this.roleModule.propertyPanel = new ____2238(this)
        }
        ____654.____676.uiPanelContainer.____125(this.roleModule.propertyPanel, type)
    },
    showTitlePanel: function(type) {
        if (this.roleModule.titlePanel == null) {
            this.roleModule.titlePanel = new ____2242(this)
        }
        ____654.____676.uiPanelContainer.____125(this.roleModule.titlePanel, type)
    },
    showRenameView: function() {
        if (this.roleModule.renameView == null) {
            this.roleModule.renameView = new RenameView(this)
        }
        ____654.____676.____125(this.roleModule.renameView, true)
    },
    hideRenameView: function() {
        if (this.roleModule.renameView != null) {
            this.roleModule.renameView.dispose();
            this.roleModule.renameView = null
        }
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.roleModule.bagPanel) {
            this.roleModule.bagPanel = null
        }
        if (p == this.roleModule.fasionPanel) {
            this.roleModule.fasionPanel = null
        }
        if (p == this.roleModule.propertyPanel) {
            this.roleModule.propertyPanel = null
        }
        if (p == this.roleModule.titlePanel) {
            this.roleModule.titlePanel = null
        }
    },
});
var ____2232 = ____537.extend({
    roleController: null,
    bagPanel: null,
    titlePanel: null,
    propertyPanel: null,
    fasionPanel: null,
    scorePanel: null,
    renameView: null,
    setup: function(data) {
        this.roleController = new ____2231(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.bag) {
            this.roleController.____214(data[0])
        } else if (data[0] == ____655.____659.panelTabType.property) {
            this.roleController.showPropertyPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.fashion) {
            this.roleController.showFashionPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.title) {
            this.roleController.showTitlePanel(data[0])
        }
    },
    clear: function() {},
});
var ChatPanel = KYPanel.extend({
    ____1398: 30,
    _controller: null,
    _closeBtn: null,
    ____942: null,
    ____1650: null,
    _vioceBtn: null,
    _vioceFlag: null,
    ____1148: null,
    ____962: null,
    _inputController: null,
    _voiceView: null,
    ____1850: null,
    _voiceLabel: null,
    ____963: null,
    ____893: null,
    ____1824: null,
    ____1311: null,
    _currentIndex: -1,
    ____1071: 0,
    ____1774: 0,
    ____1484: null,
    ____1486: 0,
    ____1309: null,
    ____1448: null,
    ____1449: 0,
    _delHeight: 0,
    ____1075: 0,
    _vioceAreaX: 0,
    _vioceAreaY: 0,
    _vioceAreaW: 0,
    _vioceAreaH: 0,
    _isVioce: false,
    _isSay: true,
    ctor: function(scenePanelController, channel) {
        this._super("chatPanel.ExportJson");
        ____655.chatPanelFlag = true;
        this.modeValue = -1;
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this._voiceView = this.getChildByName("voiceView");
        this._voiceView.setVisible(false);
        this._voiceView.setPosition(____654.____673.____159(480 - ____655.____656 * 0.5, 320));
        this.____1850 = this._voiceView.getChildByName("voiceIcon");
        this._voiceLabel = this._voiceView.getChildByName("tipsLabel");
        this.____963 = this.getChildByName("checkBox");
        this.____942 = [this.getChildByName("channelBtn1"), this.getChildByName("channelBtn2"), this.getChildByName("channelBtn3")];
        this.____1650 = this.getChildByName("sendBtn");
        this.____893 = this.getChildByName("btnLabel");
        this._vioceBtn = this.getChildByName("vioceBtn");
        this._vioceFlag = this.getChildByName("ImageView_1117041");
        this._vioceAreaX = 352 + ____655.____656 - 480;
        this._vioceAreaY = 0;
        this._vioceAreaW = 130;
        this._vioceAreaH = 80;
        this.____1148 = this.getChildByName("faceBtn");
        this.____962 = this.getChildByName("chatView");
        this.____1309 = ____654.____673.newKYNode();
        this.____1309.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____962.addContent(this.____1309);
        this._inputController = new InputLabelController(____654.____673.____159(0, 20), this.getChildByName("labelLayer").getContentSize(), this.getChildByName("labelLayer"), this.____1398, 20);
        this._inputController.setCallBack(this.attachHandler, this.updateBtnState, this);
        this.getChildByName("ImageView_735160").addListener(this, this.clickHandler);
        this.____1484 = [];
        this.____1448 = [];
        this.____1311 = [];
        this.____1824 = [____655.____659.____693.world, ____655.____659.____693.club, ____655.____659.____693.system];
        this.____6();
        var index = 0;
        if (channel != null) {
            var index = ____655.____659.____693.channelList.indexOf(channel);
            if (index < 0) {
                index = 0
            }
        }
        this.setChannelType(index);
        this.updateBtnState()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1650.addListener(this, this.____16);
        this.____1148.addListener(this, this.____16);
        if (____655.isCanVoice) {
            this._vioceBtn.addListener(this, this.____16, this.vioceDownHandler, this.vioceUpHandler, this.vioceMoveHandler)
        }
        this.____963.setStateCB(this, this.checkBoxClickHandler);
        this.____962.addEventListener(____655.____661.UI_scrollView_scroll, this.____358, this);
        for (var i = 0; i < this.____942.length; i++) {
            this.____942[i].addListener(this, this.____16)
        }
        ____655.____669.addEventListener(____655.____661.____761, this.addChatItemInfoHandler, this);
        ____654.____672.removeEventListener(____655.____661.____698, this.reconnectHandler, this)
    },
    ____17: function() {
        ____655.____669.removeEventListener(____655.____661.____761, this.addChatItemInfoHandler, this);
        ____654.____672.removeEventListener(____655.____661.____698, this.reconnectHandler, this)
    },
    clickHandler: function() {},
    vioceDownHandler: function(sender, eventType, pos) {
        if (!this.isCanSend()) {
            return
        }
        this._isVioce = true;
        ____655.____669.startVioce();
        this._voiceView.setVisible(true);
        this._isSay = true;
        this.____1850.setFrame("icon/ui_voiceIcon1.png");
        this._voiceLabel.setString("手指上滑，取消发送");
        ____654.____678.____298(this.voiceTick, this)
    },
    vioceUpHandler: function(sender, eventType, pos) {
        if (eventType == ccui.Widget.TOUCH_CANCELED) {
            if (sender == this._vioceBtn) {
                if (!this._isVioce) {
                    return
                }
                this._isVioce = false;
                ____655.____669.endVioce();
                this._voiceView.setVisible(false);
                ____654.____678.____299(this.voiceTick, this)
            }
        }
    },
    vioceMoveHandler: function(sender, eventType, pos) {
        if (sender == this._vioceBtn) {
            if (!this._isVioce) {
                return
            }
            if (pos.x < this._vioceAreaX || pos.x > this._vioceAreaX + this._vioceAreaW || pos.y < this._vioceAreaY || pos.y > this._vioceAreaY + this._vioceAreaH) {
                if (this._isSay == false) {
                    return
                }
                this._isSay = false;
                this.____1850.setFrame("icon/ui_voiceIcon2.png");
                this._voiceLabel.setString("松开手指，取消发送")
            } else {
                if (this._isSay == true) {
                    return
                }
                this._isSay = true;
                this.____1850.setFrame("icon/ui_voiceIcon1.png");
                this._voiceLabel.setString("手指上滑，取消发送")
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____1148) {
                ____654.tipsManager.showFaceTip(____654.____673.____159(____655.____656 - 380, 82), this.faceTipHandler, this)
            } else if (sender == this.____1650) {
                if (!this.isCanSend()) {
                    return
                }
                var content = this._inputController.getString();
                if (content == null || content == "") {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("chatPanel.sendTip1"));
                    return
                }
                content = ____655.wordFiltersInfo.filtChat(content);
                if (content == null) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("chatPanel.sendTip2"));
                    return
                }
                if (this.____1071 == ____655.____659.____693.system) {
                    this.setChannelType(0)
                }
                this.sendMessage(content, true)
            } else if (sender == this._vioceBtn) {
                if (!this._isVioce) {
                    return
                }
                this._isVioce = false;
                if (____655.____669.getVoiceTime() >= 1) {
                    var sendType = this.____1071;
                    if (sendType == ____655.____659.____693.system) {
                        this.setChannelType(0);
                        sendType = ____655.____659.____693.world
                    }
                    ____655.____669.sendVioce(sendType, ____655.____667.userId)
                } else {
                    ____654.tipsManager.quickTip.show("说话时间太短！");
                    ____655.____669.endVioce()
                }
                this._voiceView.setVisible(false);
                ____654.____678.____299(this.voiceTick, this)
            } else {
                var index = this.____942.indexOf(sender);
                if (index > -1) {
                    this.setChannelType(index)
                }
            }
        }
    },
    checkBoxClickHandler: function() {
        var isCheck = this.____963.getSelected();
        var channel = ____655.____659.____693.channelList[this._currentIndex];
        if (channel == ____655.____659.____693.world || channel == ____655.____659.____693.system) {
            ____655.____669.isAutoVoice1 = isCheck
        } else if (channel == ____655.____659.____693.club) {
            ____655.____669.isAutoVoice2 = isCheck
        }
    },
    ____358: function(sender, eventType) {
        this.checkShow()
    },
    attachHandler: function() {
        this.____1650.setVisible(true);
        this.____893.setVisible(true);
        this._vioceBtn.setVisible(false);
        this._vioceFlag.setVisible(false)
    },
    updateBtnState: function() {
        var content = this._inputController.getString();
        if (____655.isCanVoice && (content == null || content == "")) {
            this.____1650.setVisible(false);
            this.____893.setVisible(false);
            this._vioceBtn.setVisible(true);
            this._vioceFlag.setVisible(true)
        } else {
            this.____1650.setVisible(true);
            this.____893.setVisible(true);
            this._vioceBtn.setVisible(false);
            this._vioceFlag.setVisible(false)
        }
    },
    checkShow: function() {
        var currentY = this.____962.getContentSp().getPosition().y;
        if (Math.abs(this.____1075 - currentY) < 40) {
            return
        }
        this.____1075 = currentY;
        var ch = this.____962.getInnerSize().height;
        for (var i = 0; i < this.____1311.length; i++) {
            var label = this.____1311[i];
            if (label == null) {
                continue
            }
            if (ch + label.getPosition().y - this.____1486 + this._delHeight - label.getHeight() < 490 - this.____1075 && ch + label.getPosition().y - this.____1486 + this._delHeight > -this.____1075) {
                label.setVisible(true)
            } else {
                label.setVisible(false)
            }
        }
    },
    faceTipHandler: function(index) {
        var faceMsg = "";
        var content = this._inputController.getString();
        if (content.length >= this.____1398) {
            return
        }
        if (index < 10) {
            faceMsg = "#0" + index
        } else {
            faceMsg = "#" + index
        }
        this._inputController.setString(content + faceMsg);
        this.updateBtnState()
    },
    addChatItemInfoHandler: function(evt) {
        var info = evt.data;
        var index = ____655.____659.____693.channelShowType[this._currentIndex].indexOf(info.channel);
        if (index > -1) {
            this.____1448.push(info);
            ____654.____678.____298(this.tick, this)
        }
    },
    reconnectHandler: function(evt) {
        this.dispose()
    },
    isCanSend: function() {
        var sendType = this.____1071;
        if (sendType == ____655.____659.____693.system) {
            sendType = ____655.____659.____693.world
        }
        return ____655.____669.checkCanSendChat(sendType)
    },
    sendMessage: function(message) {
        var sendType = this.____1071;
        ____655.____669.sendTime[sendType] = ____655.____662.getSystemTimeSec();
        var info = new ____481();
        info.playerInfo.serverId = ____655.____667.serverId;
        info.playerInfo.vipLevel = ____655.____667.vipLevel;
        info.playerInfo.gm = ____655.____667.gm;
        info.playerInfo.nick = ____655.____667.nick;
        info.playerInfo.userId = ____655.____667.userId;
        info.toUserId = ____655.____667.userId;
        info.playerInfo.career = ____655.____667.career;
        info.channel = sendType;
        info.message = message;
        info.time = ____655.____662.secondsToDateString(____655.____662.getSystemTimeSec());
        ____655.____669.____36(info);
        if (message.charAt(0) == " " || ____655.____667.vipLevel >= 3 || ____655.wordFiltersInfo.checkNumber(message)) {
            ____654.____683.sendChat(sendType, message, ____655.____667.nick, ____655.____667.userId)
        }
        this._inputController.setString("");
        this.updateBtnState()
    },
    setChannelType: function(index) {
        if (this._currentIndex == index) {
            return
        }
        if (this._currentIndex > -1) {
            this.____942[this._currentIndex].setFrame("btn/ui_tabBtn2_1.png")
        }
        this._currentIndex = index;
        this.____942[this._currentIndex].setFrame("btn/ui_tabBtn2_2.png");
        this.____1071 = this.____1824[index];
        this.updateShow();
        var channel = ____655.____659.____693.channelList[this._currentIndex];
        if (channel == ____655.____659.____693.world || channel == ____655.____659.____693.system) {
            this.____963.setSelected(____655.____669.isAutoVoice1);
            this.____963.setString("自动播放世界语音")
        } else if (channel == ____655.____659.____693.club) {
            this.____963.setSelected(____655.____669.isAutoVoice2);
            this.____963.setString("自动播放家族语音")
        }
    },
    updateShow: function() {
        this.clearLabels();
        var list = ____655.____669.itemList[this.____1071];
        for (var i = 0; i < list.length; i++) {
            this.____1484.push(list[i])
        }
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this.____1774++;
        if (this.____1774 > 3) {
            this.____1774 = 0;
            var info = null;
            var label = null;
            if (this.____1484.length > 0) {
                info = this.____1484.pop();
                label = new ____2138(390);
                label.setCharInfo(info);
                this.____1486 += label.getHeight();
                label.setPosition(____654.____673.____159(5, this.____1486));
                this.____1309.addChild(label);
                this.____1311.unshift(label)
            } else if (this.____1448.length > 0) {
                info = this.____1448.pop();
                label = new ____2138(390);
                label.setCharInfo(info);
                label.setPosition(____654.____673.____159(5, -this.____1449));
                this.____1449 += label.getHeight();
                this.____1309.addChild(label);
                this.____1311.push(label)
            }
            if (label != null) {
                if (this.____1311.length > ____655.____669.maxCount) {
                    var delLabel = this.____1311.shift();
                    this._delHeight += delLabel.getHeight();
                    delLabel.dispose()
                }
                this.____1309.setPositionY(this.____1449);
                this.____962.setInnerSize(____654.____673.____160(400, this.____1486 + this.____1449 - this._delHeight));
                this.____962.jumpToBottom()
            }
            if (this.____1484.length == 0 && this.____1448.length == 0) {
                ____654.____678.____299(this.tick, this)
            }
        }
        this.checkShow()
    },
    voiceTick: function(delta, count) {
        if (____655.____669.getVoiceTime() >= 10) {
            this._isVioce = false;
            var sendType = this.____1071;
            if (sendType == ____655.____659.____693.system) {
                this.setChannelType(0);
                sendType = ____655.____659.____693.world
            }
            ____655.____669.sendVioce(sendType, ____655.____667.userId);
            this._voiceView.setVisible(false);
            ____654.____678.____299(this.voiceTick, this)
        }
    },
    clearLabels: function() {
        ____654.____678.____299(this.tick, this);
        for (var i = 0; i < this.____1311.length; i++) {
            this.____1311[i].dispose()
        }
        this.____1311 = [];
        this.____1484 = [];
        this.____1448 = [];
        this.____1486 = 0;
        this.____1449 = 0
    },
    dispose: function() {
        ____654.____678.____299(this.voiceTick, this);
        ____654.tipsManager.hide();
        this.____17();
        this.clearLabels();
        this._super();
        if (this._inputController != null) {
            this._inputController.dispose();
            this._inputController = null
        }
        if (this.____1309 != null) {
            this.____1309.dispose();
            this.____1309 = null
        }
        this.____1824 = null;
        this._controller = null;
        this._closeBtn = null;
        this.____942 = null;
        this.____1650 = null;
        this._vioceBtn = null;
        this._vioceFlag = null;
        this.____1148 = null;
        this.____962 = null;
        this.____1311 = null;
        this.____1484 = null;
        this.____1448 = null;
        this._voiceView = null;
        this.____1850 = null;
        this._voiceLabel = null;
        this.____963 = null;
        this.____893 = null;
        ____655.chatPanelFlag = false
    },
});
var SceneChatView = KYPanel.extend({
    _controller: null,
    ____857: null,
    _chatLabel: null,
    _count: 0,
    ____1165: true,
    ctor: function(controller) {
        this._super();
        this._controller = controller;
        this.____857 = ____654.____673.newKYImageView();
        this.____857.setPosition(204, 48);
        this.____857.setScale9Enabled(true);
        this.____857.setCapInsets(cc.rect(4, 4, 2, 2));
        this.____857.setSize(cc.size(408, 96));
        this.____857.setFrame("board/ui_blackBoard.png");
        this.____857.setOpacity(200);
        this.____6()
    },
    show: function(info) {
        var chatInfo = info;
        if (chatInfo != null) {
            if (this.____857 != null) {
                this.addChild(this.____857)
            }
            this._count = 180;
            if (this.____1165) {
                ____654.____678.____298(this.tickChatView, this)
            }
            this.____1165 = false;
            if (this._chatLabel != null) {
                this._chatLabel.dispose();
                this._chatLabel = null
            }
            if (this._chatLabel == null) {
                this._chatLabel = ____654.____673.newRichLabel(388);
                this.____857.addChild(this._chatLabel);
                this._chatLabel.setCharInfo(chatInfo);
                var chatWordH = this._chatLabel.getHeight();
                var height = 16 + chatWordH * 0.5;
                this._chatLabel.setPosition(10, height)
            }
        }
    },
    tickChatView: function() {
        this._count--;
        if (this._count <= 0) {
            this._count = 0;
            this.____1165 = true;
            this.hideSceneChatView();
            ____654.____678.____299(this.tickChatView, this)
        }
    },
    hideSceneChatView: function() {
        if (this.____857 != null) {
            this.____857.removeFromParent(false)
        }
        if (this._chatLabel != null) {
            this._chatLabel.dispose();
            this._chatLabel = null
        }
    },
    ____6: function() {},
    ____17: function() {},
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tickChatView, this);
        this._controller = null;
        if (this.____857 != null) {
            this.____857.dispose();
            this.____857 = null
        }
        if (this._chatLabel != null) {
            this._chatLabel.dispose();
            this._chatLabel = null
        }
        this._count = null;
        this.____1165 = null;
        this._super()
    },
});
var CifuController = cc.Class.extend({
    ____1617: null,
    _cifuItems: null,
    ctor: function(controller) {
        this.____1617 = controller;
        this._cifuItems = [];
        ____655.warDatas.cifuInfo.addEventListener(____655.____661.war_cifu_state, this.cifuStateUpdate, this)
    },
    cifuStateUpdate: function(evt) {
        this.clear();
        var result = evt.data;
        if (result == 1) {
            for (var i = 0; i < 3; i++) {
                var item = new CifuItem();
                item.move(Math.random() * (____655.____656 * 0.6) + 200, Math.random() * -100);
                item.start();
                this._cifuItems.push(item);
                item.____1239.addListener(this, this.itemClickHandler)
            }
        }
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var item = sender.getParent();
            if (item == null) {
                return
            }
            var index = this._cifuItems.indexOf(item);
            if (index > -1) {
                this._cifuItems.splice(index, 1);
                this.____1617.warMessageSender.sendCifuGet()
            }
            ____654.effectManager.setEffect(____655.allTemplates.____789.CIFU_BAG_EFFECT, false, item.getPosition(), ____654.____676.____802);
            item.dispose()
        }
    },
    clear: function() {
        for (var i = 0; i < this._cifuItems.length; i++) {
            if (this._cifuItems[i] != null) {
                this._cifuItems[i].dispose()
            }
        }
        this._cifuItems = []
    },
});
var CifuItem = KYNode.extend({
    ____1239: null,
    _path: null,
    ____1074: 0,
    ____1075: 0,
    ____1692: 0,
    _tickCount: 0,
    start: function() {
        this.____1239 = ____654.____673.newKYSprite();
        this.____1239.setPosition(____654.____673.____159(87, 51));
        this._path = ____654.____675.____139("outPic/hongbao.png");
        ____654.____677.____146(this.____1239, this._path);
        this.addChild(this.____1239);
        this.____1692 = (Math.random() * 200 + 200) / 100;
        ____654.____678.____298(this.tick, this);
        ____654.____676.____802.addChild(this)
    },
    move: function(x, y) {
        this.____1074 = x;
        this.____1075 = y;
        this.setToPos()
    },
    setToPos: function() {
        this.setPosition(this.____1074, this.____1075)
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 100) {
            this.stop()
        } else {
            this.____1075 += this.____1692;
            this.setToPos()
        }
    },
    stop: function() {
        ____654.____678.____299(this.tick, this)
    },
    dispose: function() {
        this.stop();
        if (this._path != null) {
            ____654.____677.removeImageQuote(this._path, this.____1239)
        }
        this._path = "";
        if (this.____1239 != null) {
            this.____1239.dispose();
            this.____1239 = null
        }
        this._super()
    },
});
var CitykingPanel = KYPanel.extend({
    _controller: null,
    _bg: null,
    _clickBg: null,
    ____886: null,
    ____887: null,
    ____1157: null,
    _nameLabel: null,
    ____1846: null,
    ____1881: null,
    ____892: null,
    ____944: null,
    _bgPath: null,
    ____1835: null,
    ____1657: null,
    ctor: function(scenePanelController) {
        this._super("cityKingPanel.ExportJson");
        this._controller = scenePanelController;
        this._bg = this.getChildByName("bg");
        this._clickBg = this.getChildByName("ImageView_1167066");
        this.____886 = this.getChildByName("chakanBtn");
        this.____887 = this.getChildByName("mobaiBtn");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1846 = this.getChildByName("vipLabel");
        this.____1881 = this.getChildByName("xianweiLabel");
        this.____1157 = this.getChildByName("fightLabel");
        this.____892 = this.getChildByName("titleLabel2_Copy0");
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        var playerInfo = this._controller.sceneInfo.scenePlayerList.chenZhuPlayer.figureInfo;
        this.____944 = new ____545(playerInfo.characterInfo);
        this.____944.init(____655.____659.____686.rightBottom, this, 12);
        this.____944.move(235, 227 + playerInfo.characterInfo.getYOffset());
        this.____944.____203(____655.____659.____687.stand);
        this._nameLabel.setString(playerInfo.nick + "(Lv." + playerInfo.level + ")");
        if (playerInfo.vipLevel > 0) {
            this.____1846.setString("VIP" + playerInfo.vipLevel)
        }
        this.____1881.setString(____655.____659.nameType.getXianweiName(playerInfo.xianwei));
        this.____1157.setString(playerInfo.combat);
        this.____1835 = playerInfo.userId;
        this.____1657 = playerInfo.serverId;
        if (____655.statInfo.mobaiCount > 0) {
            ____654.____674.setKYBtnEnabled(this.____887, false, 1);
            this.____892.setString("已膜拜")
        }
        this.____6()
    },
    ____6: function() {
        this.____886.addListener(this, this.____16);
        this.____887.addListener(this, this.____16);
        this._clickBg.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____16: function(sender, eventType) {
        ____654.soundManager.playSound(____654.soundManager.BTN);
        if (sender == this.____886) {
            ____654.____683.sendLook(this.____1835, this.____1657);
            this.dispose()
        } else if (sender == this.____887) {
            this._controller.sceneModule.sceneMessageSender.sendCitykingMobai();
            ____654.____674.setKYBtnEnabled(this.____887, false, 1);
            this.____892.setString("已膜拜")
        }
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    hideFormContainer: function() {
        this.dispose()
    },
    dispose: function() {
        this.____17();
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._controller = null;
        this._bg = null;
        this._clickBg = null;
        this.____886 = null;
        this.____887 = null;
        this.____1157 = null;
        this._nameLabel = null;
        this.____1846 = null;
        this.____1881 = null;
        this.____892 = null;
        this._super()
    },
});
var ____2247 = KYNode.extend({
    ____939: null,
    ____1574: 300,
    _container: null,
    ____857: null,
    ____1497: null,
    ____939: null,
    ____1618: null,
    ctor: function() {
        this._super();
        this.____939 = ____654.____673.____159(0, 0);
        this.____857 = ____654.____673.newKYSprite();
        this.____857.setFrame("ui_controllPadSmall.png");
        this.addChild(this.____857);
        this.____1497 = ____654.____673.newKYSprite();
        this.____1497.setFrame("ui_padBtn.png");
        this.addChild(this.____1497);
        this.____6()
    },
    ____6: function() {
        this.____857.addListener(this, null, this.downHandler, this.upHandler, this.____358)
    },
    move: function(pos) {
        this.____1618 = pos;
        this.setPosition(pos)
    },
    downHandler: function(sender, eventType, pos) {
        this.____857.setFrame("ui_controllPad.png");
        this.updateDirectionForTouchLocation(pos)
    },
    upHandler: function(sender, eventType, pos) {
        this.updateDirectionForTouchLocation(null)
    },
    ____358: function(sender, eventType, pos) {
        this.updateDirectionForTouchLocation(pos)
    },
    updateDirectionForTouchLocation: function(pos) {
        if (pos == null) {
            this.____857.setFrame("ui_controllPadSmall.png");
            ____654.____672.dispatchEvent(new ____590(____655.____661.global_controllPadReset, ____654.____672));
            pos = this.____939
        }
        if ((pos == this.____939) || (Math.pow(this.____1618.x - pos.x, 2) + Math.pow(this.____1618.y - pos.y, 2) <= this.____1574)) {
            ____655.touchWalkValue = 1000;
            this.____1497.setPosition(this.____939)
        } else {
            ____655.touchWalkValue = ____655.____659.____686.____97(this.____1618, pos);
            var tmp = ____655.____659.____686.____98(this.____1618, pos);
            this.____1497.setPosition(____654.____673.____159(Math.cos(tmp) * 90, Math.sin(tmp) * 90))
        }
    },
    dispose: function() {},
});
var ____2251 = KYNode.extend({
    ____1579: null,
    _nameLabel: null,
    ____1233: null,
    ctor: function() {
        this._super("followClubBossItem.ExportJson");
        this.____1579 = this.getChildByName("rank_label");
        this._nameLabel = this.getChildByName("name_label");
        this.____1233 = this.getChildByName("attack_label")
    },
    ____18: function(rank, itemInfo) {
        if (itemInfo != null) {
            this.____1579.setString(rank);
            this._nameLabel.setString(itemInfo[2]);
            this.____1233.setString(____654.____674.getWanCount(itemInfo[3]))
        } else {
            this.____1579.setString("");
            this._nameLabel.setString("");
            this.____1233.setString("")
        }
    },
    setTextColor: function(color) {
        this.____1579.setColor(color);
        this._nameLabel.setColor(color);
        this.____1233.setColor(color)
    },
    dispose: function() {
        this.____1579 = null;
        this._nameLabel = null;
        this.____1233 = null;
        this._super()
    },
});
var ____2252 = KYPanel.extend({
    _controller: null,
    ____882: null,
    _listView: null,
    ____1223: null,
    ____1111: null,
    ____1222: null,
    ____1506: null,
    ____1078: null,
    ____1646: null,
    ____1028: 0,
    _countDownUtils: null,
    _timeLabel: null,
    ____1722: null,
    _statesLabel: null,
    ____1789: null,
    ____1790: null,
    _timeLayer: null,
    _playerCount: 0,
    ctor: function(scenePanelController) {
        this._super("followClubBossPanel.ExportJson");
        this._controller = scenePanelController;
        this.____882 = this.getChildByName("bossNameLabel");
        this.____882.setString(____654.yuyanbaoManager.getYuyanbao("____2252.text1"));
        this._listView = this.getChildByName("rankPanel");
        this.____1223 = this.getChildByName("headView");
        this.____1223.setPosition(____654.____673.____159(____655.____656 - 300, ____655.____657 - 390));
        this.____1111 = [];
        this.____1222 = [];
        this.____1506 = [];
        this.____1078 = [];
        for (var i = 0; i < 3; i++) {
            this.____1111.push(this.____1223.getChildByName("dieFlag" + (i + 1)));
            this.____1111[i].setVisible(false);
            this.____1222.push(this.____1223.getChildByName("headIcon" + (i + 1)));
            this.____1506.push(____654.____675.____139("outPic/clubBossIcon" + (i + 1) + ".png"))
        }
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1722 = this.getChildByName("stateLabel");
        this._timeLabel.setString("");
        this.____1722.setString("");
        this.____1789 = this.getChildByName("tipsLabel1");
        this.____1789.setVisible(false);
        this.____1790 = this.getChildByName("tipsLabel2");
        this.____1790.setVisible(false);
        this.____1646 = new ____2251();
        this.____1646.setPositionY(3);
        this.addChild(this.____1646);
        this._timeLayer = this.getChildByName("timeLayer");
        this._timeLayer.setPosition(____655.____656 / 2 - 150, -160);
        this._countDownLabel = this._timeLayer.getChildByName("timeLabel");
        this._statesLabel = this._timeLayer.getChildByName("bossNameLabel");
        this._timeLayer.setVisible(false);
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._countDownLabel, 2, 0, "common.timeTips3");
        this.____5();
        this.____6()
    },
    ____5: function() {
        for (var i = 0; i < 3; i++) {
            ____654.____677.____146(this.____1222[i], this.____1506[i]);
            this.____1222[i].setScale(1.2)
        }
        this.updateView();
        this.updateTime()
    },
    updateView: function() {
        this.clearItem();
        var damageRankList = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID).damageRankList;
        var currentInfo = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID);

        function sortHandler(info1, info2) {
            if (info2.hurt == info1.hurt) {
                return -1
            } else {
                return info2.hurt - info1.hurt
            }
        }
        damageRankList.sort(sortHandler);
        var isShowSelf = false;
        for (var i = 0; i < damageRankList.length; i++) {
            var item = new ____2251();
            item.____18((i + 1).toString(), damageRankList[i]);
            this._listView.pushBackItem(item);
            this.____1078.push(item);
            if (!isShowSelf) {
                if (____655.____667.userId == damageRankList[i][1]) {
                    isShowSelf = true;
                    if (i < 10) {
                        this.____1646.____18((i + 1).toString(), damageRankList[i])
                    } else {
                        this.____1646.____18("10+", damageRankList[i]);
                        return
                    }
                }
            }
        }
        if (this._playerCount != damageRankList.length) {
            this._listView.resetPos();
            this._playerCount = damageRankList.length
        }
        var index = ____654.____674.____181(currentInfo.bossIdList, currentInfo.monsterId);
        if (index == 0 && currentInfo.monsterCurHp <= 0) {
            this._timeLayer.setVisible(true);
            this._countDownLabel.setVisible(false);
            this._statesLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2252.text2"));
            this._statesLabel.setPositionX(290)
        } else if (index == 1 && currentInfo.monsterCurHp <= 0) {
            this._timeLayer.setVisible(true);
            this._countDownLabel.setVisible(false);
            this._statesLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2252.text2"));
            this._statesLabel.setPositionX(290)
        } else {
            this._timeLayer.setVisible(false)
        }
        if (this.____1028 != currentInfo.monsterId || (index == 2 && currentInfo.monsterCurHp <= 0)) {
            this.____1028 = currentInfo.monsterId;
            this.headIconUpdate(currentInfo, index)
        }
    },
    headIconUpdate: function(currentInfo, index) {
        for (var i = 0; i < 3; i++) {
            if (i < index || (i == index && currentInfo.monsterCurHp <= 0)) {
                ____654.shaderCache.setColor(this.____1222[i], 1);
                this.____1111[i].setVisible(true)
            } else {
                ____654.shaderCache.setColor(this.____1222[i], 0);
                this.____1111[i].setVisible(false)
            }
        }
    },
    ____6: function() {
        var currentInfo = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID);
        if (currentInfo != null) {
            currentInfo.addEventListener(____655.____661.club_bossRankDamageUpdate, this.updateView, this)
        }
        ____655.clubInfo.addEventListener(____655.____661.club_bossInfoUpdate, this.updateTime, this);
        ____654.____672.addEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    copyFinishHandler: function() {
        this._controller.showOverCountDownView(10, null, this.countDownCallBack, this)
    },
    countDownCallBack: function() {
        ____654.copyTester.exitCopy()
    },
    updateTime: function() {
        var clubBossState = ____655.clubInfo.clubBossState;
        var clubBossTime = ____655.clubInfo.clubBossTime;
        if (clubBossState == 1) {
            var remainTime = 60 + clubBossTime - ____655.____662.getSystemTimeSec();
            this._countDownUtils.start(remainTime);
            this._statesLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2252.text3"));
            this._timeLayer.setVisible(true)
        } else if (clubBossState == 2) {
            this._timeLayer.setVisible(false);
            var remainTime = 15 * 60 + clubBossTime - ____655.____662.getSystemTimeSec();
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_exitTimeUpdate, ____654.____672, remainTime))
        }
    },
    clearItem: function() {
        this._listView.removeAllItems();
        var currentInfo = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID);
        if (this.____1078.length > 0) {
            for (var i = 0; i < this.____1078.length; i++) {
                this.____1078[i].dispose()
            }
            this.____1078 = []
        }
    },
    ____17: function() {
        var currentInfo = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID);
        if (currentInfo != null) {
            currentInfo.removeEventListener(____655.____661.club_bossRankDamageUpdate, this.updateView, this)
        }
        ____655.clubInfo.removeEventListener(____655.____661.club_bossInfoUpdate, this.updateTime, this);
        ____654.____672.removeEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    dispose: function() {
        this.____17();
        this.clearItem();
        this._controller = null;
        this.____882 = null;
        this._listView = null;
        this.____1223 = null;
        this.____1111 = null;
        if (this.____1222 != null) {
            for (var i = 0; i < 3; i++) {
                ____654.shaderCache.removeColor(this.____1222[i]);
                ____654.____677.removeImageQuote(this.____1222[i], this.____1506[i])
            }
            this.____1506 = null;
            this.____1222 = null
        }
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this.____1789 = null;
        this.____1790 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._timeLabel = null;
        this.____1722 = null;
        this._statesLabel = null;
        this._timeLayer = null;
        this._super()
    },
});
var CopyBaseFollowPanel = KYPanel.extend({
    _controller: null,
    _monsterLabel: null,
    ____1009: null,
    _countDownUtils: null,
    _tickCount: 0,
    ____1008: 0,
    ctor: function(scenePanelController, copyId) {
        this._super("copyBaseFollowPanel.ExportJson");
        this._controller = scenePanelController;
        this.____1008 = copyId;
        this._monsterLabel = this.getChildByName("infoLabel2");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("infoLabel1"), 1, 30, null);
        this.____1009 = ____655.copyInfo.getCopyInfo(this.____1008);
        this.____5();
        this.____6()
    },
    ____5: function() {
        ____654.copyMessageSender.sendMonsterUpdate();
        ____654.copyMessageSender.sendTimeUpdate();
        var copyTime = ____655.allTemplates.copyTemplateList.getCopy(this.____1008).copyTime;
        this._countDownUtils.start(copyTime, null, null)
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    updateTime: function(evt) {
        this._countDownUtils.start(this.____1009.leftTime, null, null)
    },
    updateMonster: function(evt) {
        this._monsterLabel.setString((this.____1009.totalMonster - this.____1009.leftMonster) + "/" + this.____1009.totalMonster);
        if (this.____1009.leftMonster == 0) {
            this._tickCount = 120;
            ____654.____678.____298(this.exitTick, this)
        }
    },
    exitTick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            ____654.copyTester.exitCopy();
            ____654.____678.____299(this.exitTick, this)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.exitTick, this);
        this.____17();
        this._controller = null;
        this._monsterLabel = null;
        this.____1009 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    },
});
var ____2253 = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____1495: null,
    ____1798: null,
    ____829: null,
    ____1799: null,
    ____1096: null,
    ____1145: null,
    ____1423: null,
    ____1707: null,
    ____937: null,
    _countDownUtils: null,
    ____1008: 0,
    ____1411: 0,
    ____1101: null,
    _sweepInfo: null,
    _isAgain: false,
    _flagIcon: null,
    ctor: function(scenePanelController) {
        this._super("settlementPanel.ExportJson");
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1495 = this.getChildByName("outBtn");
        this.____1798 = this.getChildByName("titleLabel1");
        this.____829 = this.getChildByName("againBtn");
        this.____1799 = this.getChildByName("titleLabel2");
        this.____1096 = this.getChildByName("descLabel");
        this.____1145 = this.getChildByName("expValue");
        this.____1423 = this.getChildByName("moneyValue");
        this.____1421 = this.getChildByName("moneyLabel");
        this.____1421.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text1"));
        this._flagIcon = this.getChildByName("flagIcon");
        this.____1707 = [this.getChildByName("starIcon1"), this.getChildByName("starIcon2"), this.getChildByName("starIcon3")];
        for (var i = 0; i < 3; i++) {
            this.____1707[i].setVisible(false)
        }
        this.____937 = [];
        for (var j = 1; j <= 10; j++) {
            var item = new ____2129();
            this.getChildByName("cell" + j).addChild(item);
            this.____937.push(item)
        }
        this.____1101 = this.getChildByName("desLabel");
        this.____6()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1495.addListener(this, this.____16);
        this.____829.addListener(this, this.____16)
    },
    ____17: function() {},
    initData: function(copyId, bytes) {
        this.____1008 = copyId;
        var money2 = 0;
        this.____1423.setString("0");
        if (this.____1008 >= ____655.allTemplates.copyTemplateList.clubExpeditionCopyList[0] && this.____1008 <= ____655.allTemplates.copyTemplateList.clubExpeditionCopyList[4]) {
            var wealth = bytes.readInt();
            var hurt = bytes.readNumber();
            this.____1421.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text2"));
            this.____1423.setString(wealth.toString());
            var w = Math.floor(hurt * 0.01);
            var q = Math.floor(hurt * 0.001) % 10;
            this.____1101.setString("对BOSS造成" + w.toString() + "." + q.toString() + "%伤害");
            this.____1096.setVisible(____654.yuyanbaoManager.getYuyanbao("____2253.text3"));
            this.____829.setVisible(false);
            this.____1799.setVisible(false);
            this.____1495.setPositionX(266);
            this.____1798.setPositionX(266)
        } else if (this.____1008 == ____655.allTemplates.copyTemplateList.DALUANDOU_COPYID) {
            this.____1411 = bytes.readInt() - 1;
            var campRank = bytes.readNumber();
            this.____1096.setString("你所在阵营获得第" + campRank.toString() + "名;个人积分排名第" + ____655.warDatas.daLuanDouInfo.selfRank.toString() + "名");
            this.setNoAgain()
        } else if (this.____1008 == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID) {
            this.____1411 = bytes.readInt() - 1;
            var jiazuRank = bytes.readNumber();
            if (jiazuRank == 1) {
                this.____1096.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text4"))
            } else {
                this.____1096.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text5"))
            }
            this.setNoAgain()
        } else if (this.____1008 == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
            var starNum = ____655.copyInfo.getCopyInfo(this.____1008).currentStar;
            this.____1411 = bytes.readInt() - 1;
            money2 = bytes.readNumber();
            for (var i = 0; i < 3; i++) {
                this.____1707[i].setVisible(true);
                if (i < starNum) {
                    this.____1707[i].setFrame("icon/ui_startIcon5.png")
                }
            }
        } else {
            this.____1411 = bytes.readInt() - 1;
            money2 = bytes.readNumber();
            this.____1096.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text3"));
            if (this.____1008 == ____655.allTemplates.copyTemplateList.WAIGUAN_COPYID) {} else if (this.____1008 == ____655.allTemplates.copyTemplateList.CAILIAO_COPYID) {
                if (____655.allTemplates.copyTemplateList.CAILIAO_COSTLIST[____655.allTemplates.copyTemplateList.getCopy(this.____1008).dayTimes - ____655.statInfo.statCopyList[this.____1008].currentEnterCount] != 0) {
                    this.setNoAgain()
                }
            } else {
                this.setNoAgain()
            }
        }
        var exp = bytes.readInt();
        var len = bytes.readByte();
        var index = 0;
        for (var i = 0; i < len; i++) {
            var id = bytes.readInt();
            var count = bytes.readInt();
            var tempInfo = ____655.allTemplates.____794.getItem(id);
            if (tempInfo == null) {
                continue
            }
            if (tempInfo.categoryId == ____655.____659.categoryType.COPPER) {
                money2 += count
            } else if (tempInfo.categoryId == ____655.____659.categoryType.DIAOLUOCOPPER) {
                money2 += tempInfo.propertys[0] * count
            } else {
                if (index < 10) {
                    this.____937[index].setItemTemplateInfo(tempInfo);
                    this.____937[index].setCount(count);
                    index++
                }
            }
        }
        if (money2 > 0) {
            this.____1423.setString(money2.toString())
        }
        this.____1145.setString(exp.toString());
        var this_ = this;

        function countDownComplete1() {
            this_.dispose()
        };

        function countDownComplete2() {
            ____654.copyTester.enterCopy(this_.____1008, this_.____1411);
            this_._isAgain = true;
            this_.dispose()
        };
        this._countDownUtils = new ____2111();
        if (this.____1008 == ____655.allTemplates.copyTemplateList.WAIGUAN_COPYID) {
            this.____1798.setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips3"));
            this._countDownUtils.setLabel(this.____1799, 2, 0, "alert.btnTips10");
            this._countDownUtils.start(10, null, countDownComplete2, null)
        } else {
            this._countDownUtils.setLabel(this.____1798, 2, 0, "alert.btnTips6");
            this._countDownUtils.start(10, null, countDownComplete1, null)
        }
    },
    initDouShen: function(dataList) {
        this.____1008 = -99;
        var isWin = dataList[0];
        var rank = dataList[1];
        var exp = dataList[2];
        var honor = dataList[3];
        var itemList = dataList[4];
        this.setNoAgain();
        if (isWin) {
            this.____1096.setString("挑战胜利新排名：第" + rank + "名");
            this._flagIcon.setFrame("flag/ui_copyWinFlag.png")
        } else {
            this.____1096.setString("挑战失败保持排名：第" + rank + "名");
            this._flagIcon.setFrame("flag/ui_copyFailFlag.png")
        }
        this.____1421.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text6"));
        this.____1423.setString(honor.toString());
        this.____1145.setString(exp.toString());
        this.____1101.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text7"));
        this.____1101.setColor(____655.____659.____688.green);
        this.____1101.setPositionX(40 + this.____1096.getContentSize().width);
        var len = itemList.length;
        for (var i = 0; i < len; i++) {
            if (i < 10) {
                this.____937[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(itemList[i][0]));
                this.____937[i].setCount(itemList[i][1])
            }
        }
        var this_ = this;

        function countDownComplete() {
            this_.dispose()
        };
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.____1798, 2, 0, "alert.btnTips6");
        this._countDownUtils.start(10, null, countDownComplete, null)
    },
    initSweep: function(sweepInfo) {
        this._sweepInfo = sweepInfo;
        if (this._sweepInfo.copyId == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
            this.____1096.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text8"));
            this.____1799.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text9"));
            for (var i = 0; i < 3; i++) {
                this.____1707[i].setVisible(true);
                this.____1707[i].setFrame("icon/ui_startIcon5.png")
            }
        } else if (this._sweepInfo.copyId == ____655.allTemplates.copyTemplateList.YAOTA_COPYID) {
            this.setNoAgain();
            this.____1096.setString(____654.yuyanbaoManager.getYuyanbao("____2253.text10"))
        }
        var list = this._sweepInfo.itemList;
        var index = 0;
        var copper = 0;
        var exp = 0;
        for (var i = 0; i < list.length; i++) {
            var tempInfo = ____655.allTemplates.____794.getItem(list[i][0]);
            if (tempInfo == null) {
                continue
            }
            if (tempInfo.categoryId == ____655.____659.categoryType.COPPER) {
                copper += list[i][1]
            } else if (tempInfo.categoryId == ____655.____659.categoryType.DIAOLUOCOPPER) {
                copper += tempInfo.propertys[0] * list[i][1]
            } else {
                if (index < 10) {
                    this.____937[index].setItemTemplateInfo(tempInfo);
                    this.____937[index].setCount(list[i][1]);
                    index++
                }
            }
        }
        this.____1423.setString(copper.toString());
        this.____1145.setString(exp.toString());
        var this_ = this;

        function countDownComplete() {
            this_.dispose()
        };
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.____1798, 2, 0, "alert.btnTips6");
        this._countDownUtils.start(10, null, countDownComplete, null)
    },
    setNoAgain: function() {
        this.____829.setVisible(false);
        this.____1799.setVisible(false);
        this.____1495.setPositionX(268);
        this.____1798.setPositionX(268)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____1495) {
                this.dispose()
            } else if (sender == this.____829) {
                if (this._sweepInfo != null) {
                    var missionIndex = ____655.allTemplates.copyTemplateList.getCopy(this._sweepInfo.copyId).missionIds.indexOf(this._sweepInfo.missionId);
                    if (missionIndex >= 0) {
                        ____654.copyTester.sweepCopy(this._sweepInfo.copyId, missionIndex)
                    }
                } else {
                    ____654.copyTester.enterCopy(this.____1008, this.____1411)
                }
                this._isAgain = true;
                this.dispose()
            }
        }
    },
    dispose: function() {
        if (this._isAgain == false && this._sweepInfo == null) {
            if (this.____1008 == -99) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.warPlaceTab, ____655.____659.panelTabType.warPlace)
            } else if (this.____1008 == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy)
            } else if (this.____1008 >= ____655.allTemplates.copyTemplateList.clubExpeditionCopyList[0] && this.____1008 <= ____655.allTemplates.copyTemplateList.clubExpeditionCopyList[4]) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_club, 4)
            } else if (this.____1008 == ____655.allTemplates.copyTemplateList.WAIGUAN_COPYID) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy, 2)
            } else if (this.____1008 == ____655.allTemplates.copyTemplateList.CAILIAO_COPYID) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy, 3)
            } else if (this.____1008 == ____655.allTemplates.copyTemplateList.YAOTA_COPYID) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy, 4)
            } else if (this.____1008 == ____655.allTemplates.copyTemplateList.TONGTIAN_COPYID) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy, 5)
            } else if (this.____1008 == ____655.allTemplates.copyTemplateList.SHOUHU_COPYID) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy, 6)
            } else if (this.____1008 == ____655.allTemplates.copyTemplateList.XIANYUAN_COPYID || this.____1008 == ____655.allTemplates.copyTemplateList.JIEYI_COPYID) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab, ____655.____659.panelTabType.copy, 7)
            } else if (this.____1008 == ____655.allTemplates.copyTemplateList.TGXS_COPYID) {
                if (____655.activityIconList.timingIcons[6] != null && ____655.activityIconList.timingIcons[6].endTime > ____655.____662.getZeroPassTime()) {
                    ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.xuanshangTab)
                }
            } else if (____655.allTemplates.copyTemplateList.WORLDBOSSPERSON_IDLIST.indexOf(this.____1008) != -1) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.bossTab, ____655.____659.panelTabType.boss_person)
            } else if (____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST.indexOf(this.____1008) != -1) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.bossTab, ____655.____659.panelTabType.boss_shenJiang)
            }
        }
        this.____17();
        this._super();
        this._controller = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._closeBtn = null;
        this.____1495 = null;
        this.____829 = null;
        this.____1096 = null;
        this.____1145 = null;
        this.____1423 = null;
        this.____1707 = null;
        this.____1798 = null;
        this.____1799 = null;
        this.____1101 = null;
        this.____1421 = null;
        this._flagIcon = null;
        if (this._sweepInfo != null) {
            this._sweepInfo.dispose();
            this._sweepInfo = null
        }
        if (this.____937 != null) {
            for (var i = 0; i < this.____937.length; i++) {
                this.____937[i].dispose()
            }
            this.____937 = null
        }
    },
});
var CopyJumpLevelView = KYPanel.extend({
    _levelLabel: null,
    _timeLabel: null,
    _countDownUtils: null,
    _callBack: null,
    _executor: null,
    ctor: function() {
        this._super("copyJumpLevelView.ExportJson");
        this._levelLabel = this.getChildByName("levelLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 2, 0)
    },
    setOverCallBack: function(callBack, executor) {
        this._callBack = callBack;
        this._executor = executor
    },
    initData: function(time, level, cb) {
        var this_ = this;

        function timeOverHandler() {
            if (this_._callBack != null && this_._executor) {
                this_._callBack.call(this_._executor)
            }
        };
        this._countDownUtils.start(time, null, timeOverHandler);
        this._levelLabel.setString(level)
    },
    dispose: function() {
        this._levelLabel = null;
        this._timeLabel = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    },
});
var CopyNewlyComplatePanel = KYPanel.extend({
    _bgEffect: null,
    ____1479: null,
    _nameLabel: null,
    ____944: null,
    ____1127: null,
    ____892: null,
    _characterInfo: null,
    _newlyIndex: 0,
    _countDownUtils: null,
    ctor: function(controller, index) {
        this._super();
        this.modeValue = 200;
        this._newlyIndex = index;
        this._bgEffect = ____654.effectManager.create(____655.allTemplates.____789.CHARACTER_BG_EFFECT, false, null, false);
        this._bgEffect.move(0, -35);
        this._bgEffect.play();
        this._bgEffect.addTo(this, 0);
        this._nameLabel = ____654.____673.newKYLabel(24);
        this._nameLabel.setPositionY(156);
        this._nameLabel.setColor(____655.____659.____688.yellow);
        this.addChild(this._nameLabel);
        this.____1479 = ____654.____673.newKYImageView();
        this.____1479.setFrame("btn/ui_btn1_2.png");
        this.____1479.setScale9Enabled(true);
        this.____1479.setCapInsets(____654.____673.____161(20, 27, 1, 1));
        this.____1479.setSize(____654.____673.____160(140, 55));
        this.____1479.setPositionY(-160);
        this.addChild(this.____1479);
        this.____892 = ____654.____673.newKYLabel(24, true);
        this.____892.setPosition(____654.____673.____159(75, 30));
        this.____1479.addChild(this.____892);
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.____892, 2, 0, "alert.btnTips7");
        this.____5();
        this.____6()
    },
    ____5: function() {
        var this_ = this;

        function complateHandler() {
            ____654.copyTester.exitCopy();
            this_.dispose()
        };
        this._countDownUtils.start(5, null, complateHandler);
        this.createCharacter()
    },
    ____6: function() {
        this.____1479.addListener(this, this.clickHandler)
    },
    ____17: function() {},
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1479) {
                ____654.copyTester.exitCopy();
                this.dispose()
            }
        }
    },
    createCharacter: function() {
        if (this._newlyIndex == 0) {
            var styleList = {};
            var figureTemplate = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Horse, 1);
            this._nameLabel.setString(figureTemplate.name);
            styleList[____655.____659.commonStaticType.style_Horse] = figureTemplate.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Horse, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this)
        } else if (this._newlyIndex == 1) {
            var figureTemplate = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Pet, 1);
            this._nameLabel.setString(figureTemplate.name);
            this._characterInfo = ____654.getCharacterInfo(figureTemplate.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.setScale(1.5);
            this.____944.init(____655.____659.____686.rightBottom, this)
        } else if (this._newlyIndex == 2) {
            var styleList = {};
            var figureTemplate = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Wind, 1);
            this._nameLabel.setString(figureTemplate.name);
            styleList[____655.____659.commonStaticType.style_Wind] = figureTemplate.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Wind, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.move(0, -75);
            this.____944.init(____655.____659.____686.rightBottom, this)
        } else if (this._newlyIndex == 3) {
            this.____944 = new FootShowEffect(1, 4);
            var effectId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Foot, 1).figureId;
            var effectTemplate = ____655.allTemplates.____789.getEffect(effectId);
            var scaleValue = effectTemplate.scale;
            this.____944.setScale(scaleValue);
            this.____944.setPosition(____654.____673.____159(-110, 0));
            this.addChild(this.____944, 9)
        } else if (this._newlyIndex == 4) {
            var effectId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_FaBao, 1).figureId;
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.play()
        } else if (this._newlyIndex == 5) {
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ZhengLing, 1).figureId);
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.play()
        } else if (this._newlyIndex == 6) {
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ShenJian, 1).figureId);
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.play()
        }
        if (!!this.____1127) {
            this.____1127.addTo(this, 9)
        }
    },
    dispose: function() {
        this.____17();
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (!!this.____1127) {
            this.____1127.dispose();
            this.____1127 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._bgEffect != null) {
            this._bgEffect.dispose();
            this._bgEffect = null
        }
        if (this.____1479 != null) {
            this.____1479.dispose();
            this.____1479 = null
        }
        if (this._nameLabel != null) {
            this._nameLabel.dispose();
            this._nameLabel = null
        }
        if (this.____892 != null) {
            this.____892.dispose();
            this.____892 = null
        }
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    }
});
var CopyNewlyFollowPanel = KYPanel.extend({
    _controller: null,
    _monsterLabel: null,
    _characterBg: null,
    _characterBg2: null,
    ____944: null,
    ____1127: null,
    _characterInfo: null,
    _bg: null,
    _bgPath: null,
    _bgPath_2: null,
    ____1009: null,
    _copyTempInfo: null,
    _newlyIndex: 0,
    _countDownUtils: null,
    _tickCount: 0,
    _currentCollectId: 0,
    _touchEffect: null,
    ctor: function(scenePanelController) {
        this._super("copyNewlyFollowPanel.ExportJson");
        this._controller = scenePanelController;
        this._monsterLabel = this.getChildByName("infoLabel2_Copy0");
        this._characterBg = this.getChildByName("characterBg");
        this._characterBg2 = this.getChildByName("characterBg_2");
        this._bg = this.getChildByName("ImageView_974199__3");
        this._bgPath = ____654.____675.____139("outPic/ui_newlyFollowBg.png");
        this._bgPath_2 = ____654.____675.____139("outPic/pass_award.png");
        ____654.____677.____146(this._characterBg, this._bgPath);
        ____654.____677.____146(this._characterBg2, this._bgPath_2);
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("infoLabel1_Copy0"), 1, 30, null);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.copyInfo.currentId);
        this._copyTempInfo = ____655.allTemplates.copyTemplateList.getCopy(____655.copyInfo.currentId);
        this._newlyIndex = ____655.allTemplates.copyTemplateList.NEWLY_COPYIDLIST.indexOf(____655.copyInfo.currentId);
        this._controller.sceneModule.getNewlyBehavior().reset(this._newlyIndex);
        this.____5();
        this.____6()
    },
    ____5: function() {
        ____654.copyMessageSender.sendShouhuUpdate();
        var copyTime = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.CAILIAO_COPYID).copyTime;
        this._countDownUtils.start(copyTime, null, null);
        this.createCharacter()
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_waveUpdate, this.updateWave, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this);
        ____654.____672.addEventListener(____655.____661.copy_finish, this.copyFinishHandler, this);
        this._bg.addListener(this, this.____16)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_waveUpdate, this.updateWave, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this);
        ____654.____672.removeEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._bg) {
                if (this._currentCollectId == 0) {
                    return
                }
                this._controller.sceneModule.walkTester.walkToCollectByTemplateId(this._currentCollectId)
            }
        }
    },
    updateTime: function(evt) {
        this._countDownUtils.start(this.____1009.leftTime, null, null)
    },
    updateWave: function(evt) {
        var missionTempInfo = this._copyTempInfo.missions[this.____1009.currentWave - 1];
        if (missionTempInfo != null) {
            this._monsterLabel.setString(missionTempInfo.name)
        } else {
            this._monsterLabel.setString("无")
        }
        this._currentCollectId = 0;
        if (this._newlyIndex == 0) {
            if (this.____1009.currentWave == 2) {
                this._currentCollectId = 1101
            }
        } else if (this._newlyIndex == 4) {
            if (this.____1009.currentWave == 2) {
                this._currentCollectId = 1100
            } else if (this.____1009.currentWave == 4) {
                this._currentCollectId = 1103
            }
        }
        if (this._currentCollectId > 0) {
            this._bg.setTouchEnabled(true);
            if (this._touchEffect == null) {
                this._touchEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.FINGER_EFFECT, false, ____654.____673.____159(200, 60), this, false, 1)
            }
        } else {
            this._bg.setTouchEnabled(false);
            if (this._touchEffect != null) {
                this._touchEffect.dispose();
                this._touchEffect = null
            }
        }
    },
    createCharacter: function() {
        if (this._newlyIndex == 0) {
            var styleList = {};
            var figureId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Horse, 1).figureId;
            styleList[____655.____659.commonStaticType.style_Horse] = figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Horse, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this, 22);
            this.____944.move(116, -60)
        } else if (this._newlyIndex == 1) {
            var figureTemplate = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Pet, 1);
            this._characterInfo = ____654.getCharacterInfo(figureTemplate.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this, 22);
            this.____944.move(108, -77)
        } else if (this._newlyIndex == 2) {
            var styleList = {};
            var figureId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Wind, 1).figureId;
            styleList[____655.____659.commonStaticType.style_Wind] = figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Wind, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this, 22);
            this.____944.move(126, -159)
        } else if (this._newlyIndex == 3) {
            this.____944 = new FootShowEffect(1, 4);
            var effectId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Foot, 1).figureId;
            var effectTemplate = ____655.allTemplates.____789.getEffect(effectId);
            var scaleValue = effectTemplate.scale;
            this.____944.setScale(scaleValue);
            this.____944.setPosition(____654.____673.____159(-30, 100));
            this._characterBg.addChild(this.____944)
        } else if (this._newlyIndex == 4) {
            var effectId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_FaBao, 1).figureId;
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.move(70, 104);
            this.____1127.play()
        } else if (this._newlyIndex == 5) {
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ZhengLing, 1).figureId);
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.move(69, 110);
            this.____1127.play()
        } else if (this._newlyIndex == 6) {
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ShenJian, 1).figureId);
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.move(70, 100);
            this.____1127.play()
        }
        if (this.____1127 != null) {
            this.____1127.addTo(this._characterBg)
        }
    },
    copyFinishHandler: function(evt) {
        this._tickCount = 30;
        ____654.____678.____298(this.exitTick, this)
    },
    exitTick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            this._controller.showNewlyCopyComplatePanel(this._newlyIndex);
            ____654.____678.____299(this.exitTick, this)
        }
    },
    acceptAward: function() {
        if (this._newlyIndex == 0) {
            ____654.fashionMessageSender.sendJihuo(____655.____659.commonStaticType.style_Horse)
        } else if (this._newlyIndex == 1) {
            ____654.fashionMessageSender.sendJihuoPet()
        } else if (this._newlyIndex == 2) {
            ____654.fashionMessageSender.sendJihuo(____655.____659.commonStaticType.style_Wind)
        } else if (this._newlyIndex == 3) {
            ____654.fashionMessageSender.sendJihuo(____655.____659.commonStaticType.style_Foot)
        } else if (this._newlyIndex == 4) {
            ____654.fashionMessageSender.sendJihuo(____655.____659.commonStaticType.style_FaBao)
        } else if (this._newlyIndex == 5) {
            ____654.fashionMessageSender.sendJihuo(____655.____659.commonStaticType.style_ZhengLing)
        } else if (this._newlyIndex == 6) {
            ____654.fashionMessageSender.sendJihuo(____655.____659.commonStaticType.style_ShenJian)
        }
    },
    dispose: function() {
        this.acceptAward();
        this._controller.sceneModule.getNewlyBehavior().clear();
        ____654.____678.____299(this.exitTick, this);
        this.____17();
        this._controller = null;
        this._monsterLabel = null;
        this._bg = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this.____1127 != null) {
            this.____1127.dispose();
            this.____1127 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._characterBg);
            this._bgPath = null
        }
        this._characterBg = null;
        if (this._bgPath_2 != null) {
            ____654.____677.removeImageQuote(this._bgPath_2, this._characterBg2);
            this._bgPath_2 = null
        }
        this._characterBg2 = null;
        if (this._touchEffect != null) {
            this._touchEffect.dispose();
            this._touchEffect = null
        }
        this.____1009 = null;
        this._copyTempInfo = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    },
});
var CopyShouHuFollowPanel = KYPanel.extend({
    _controller: null,
    _waveLabel: null,
    _iconList: null,
    _levelList: null,
    _nickList: null,
    ____1231: null,
    ____1009: null,
    _countDownUtils: null,
    ctor: function(scenePanelController) {
        this._super("copyShowHuFollowPanel.ExportJson");
        this._controller = scenePanelController;
        this._waveLabel = this.getChildByName("infoLabel1");
        this._iconList = [];
        this._levelList = [];
        this._nickList = [];
        for (var i = 0; i < 3; i++) {
            this._iconList.push(this.getChildByName("headIcon" + (i + 1)));
            this._levelList.push(this.getChildByName("levelLabel" + (i + 1)));
            this._nickList.push(this.getChildByName("nameLabel" + (i + 1)))
        }
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("infoLabel2"), 1, 30, null);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.SHOUHU_COPYID);
        var npcLayer = this.getChildByName("Panel_974260");
        npcLayer.getChildByName("nameLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2253.text11"));
        npcLayer.getChildByName("levelLabel").setString("99");
        npcLayer.setPosition(____654.____673.____159(____655.____656 - 10, 300));
        this.____1231 = npcLayer.getChildByName("hpBar");
        this.____5();
        this.____6()
    },
    ____5: function() {
        ____654.copyMessageSender.sendShouhuUpdate();
        var copyTime = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.SHOUHU_COPYID).copyTime;
        this._countDownUtils.start(copyTime, null, null);
        this.updateTeam()
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this);
        this.____1009.addEventListener(____655.____661.copy_waveUpdate, this.updateWave, this);
        this.____1009.addEventListener(____655.____661.copy_teamUpdate, this.updateTeam, this);
        this.____1009.addEventListener(____655.____661.copy_npcHpUpdate, this.updateHp, this);
        ____654.____672.addEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this);
        this.____1009.removeEventListener(____655.____661.copy_waveUpdate, this.updateWave, this);
        this.____1009.removeEventListener(____655.____661.copy_teamUpdate, this.updateTeam, this);
        this.____1009.removeEventListener(____655.____661.copy_npcHpUpdate, this.updateHp, this);
        ____654.____672.removeEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    updateTime: function(evt) {
        if (this.____1009.currentWave == this.____1009.totalWave) {
            return
        }
        this._countDownUtils.start(this.____1009.leftTime, null, null)
    },
    updateWave: function(evt) {
        this._waveLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text14", this.____1009.currentWave + "/" + this.____1009.totalWave));
        if (this.____1009.currentWave == this.____1009.totalWave) {
            this._countDownUtils.stop();
            this.getChildByName("infoLabel2").setString("----")
        }
    },
    updateTeam: function(evt) {
        for (var i = 0; i < 3; i++) {
            if (this.____1009.teamList[i] != null) {
                this._iconList[i].setVisible(true);
                this._iconList[i].setFrame("sceneIcon/PlayerHeadIcon2_" + this.____1009.teamList[i][0] + ".png");
                this._levelList[i].setString(this.____1009.teamList[i][1]);
                this._nickList[i].setString(this.____1009.teamList[i][2])
            } else {
                this._iconList[i].setVisible(false);
                this._levelList[i].setString("");
                this._nickList[i].setString("")
            }
        }
    },
    updateHp: function(evt) {
        this.____1231.setPercent(this.____1009.npcHp)
    },
    copyFinishHandler: function(evt) {
        function okClick() {
            ____654.copyTester.exitCopy()
        };
        ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2253.text12"), null, 10, this, okClick)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._waveLabel = null;
        this._iconList = null;
        this._levelList = null;
        this._nickList = null;
        this.____1009 = null;
        this.____1231 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    },
});
var CopyTongTianFollowPanel = KYPanel.extend({
    _controller: null,
    _monsterLabel: null,
    _waveLabel: null,
    ____1009: null,
    ____1012: null,
    _countDownUtils: null,
    _copyJumpLevelView: null,
    ctor: function(scenePanelController) {
        this._super("copyLevelFollowPanel.ExportJson");
        this._controller = scenePanelController;
        this._waveLabel = this.getChildByName("infoLabel3");
        this._monsterLabel = this.getChildByName("infoLabel2");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("infoLabel1"), 1, 0, null);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.TONGTIAN_COPYID);
        this.____1012 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.TONGTIAN_COPYID);
        this.____5();
        this.____6()
    },
    ____5: function() {
        ____654.copyMessageSender.sendShouhuUpdate();
        var index = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.TONGTIAN_COPYID).missionIds.indexOf(this.____1009.missionId);
        this._waveLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text12", (index + 1)));
        var copyTime = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.TONGTIAN_COPYID).copyTime;
        this._countDownUtils.start(copyTime, null, null)
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this);
        this.____1009.addEventListener(____655.____661.copy_waveUpdate, this.updateWave, this);
        ____654.____672.addEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this);
        this.____1009.removeEventListener(____655.____661.copy_waveUpdate, this.updateWave, this);
        ____654.____672.removeEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    updateTime: function(evt) {
        this._countDownUtils.start(this.____1009.leftTime, null, null);
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.TONGTIAN_COPYID];
        var maxLevel = 0;
        if (info != null && info.maxMission > 0) {
            var maxLevel = this.____1012.missionIds.indexOf(info.maxMission);
            if (maxLevel < 0) {
                maxLevel = 50
            }
        }
        var curLevel = this.____1009.currentWave;
        if (curLevel > 0 && curLevel < 50 && curLevel % 5 == 0 && maxLevel >= curLevel + 5) {
            var time = this.____1012.missions[curLevel - 1].copyTime;
            this.showJumpTip(Math.ceil(time / 2 - 0.5), ____654.yuyanbaoManager.getYuyanbao("____2182.text12", curLevel + 5))
        } else {
            this.hideJumpTip()
        }
    },
    showJumpTip: function(time, level) {
        if (this._copyJumpLevelView == null) {
            this._copyJumpLevelView = new CopyJumpLevelView();
            ____654.____676.____799.addChild(this._copyJumpLevelView);
            this._copyJumpLevelView.setPosition(____654.____673.____159(____655.____656 * 0.5 - 250, 110));
            this._copyJumpLevelView.setOverCallBack(this.hideJumpTip, this)
        }
        this._copyJumpLevelView.initData(time, level)
    },
    hideJumpTip: function() {
        if (this._copyJumpLevelView != null) {
            this._copyJumpLevelView.dispose();
            this._copyJumpLevelView = null
        }
    },
    updateMonster: function(evt) {
        this._monsterLabel.setString((this.____1009.totalMonster - this.____1009.leftMonster) + "/" + this.____1009.totalMonster)
    },
    updateWave: function(evt) {
        this._waveLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text12", this.____1009.currentWave));
        ____654.copyMessageSender.sendMonsterUpdate()
    },
    copyFinishHandler: function(evt) {
        function okClick() {
            ____654.copyTester.exitCopy()
        };
        ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2253.text12"), null, 10, this, okClick)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._monsterLabel = null;
        this._waveLabel = null;
        this.____1009 = null;
        this.____1012 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this.hideJumpTip();
        this._super()
    },
});
var CopyWaiGuanFollowPanel = KYPanel.extend({
    _controller: null,
    _monsterLabel: null,
    ____1009: null,
    _countDownUtils: null,
    _tickCount: 0,
    ctor: function(scenePanelController) {
        this._super("copyBaseFollowPanel.ExportJson");
        this._controller = scenePanelController;
        this._monsterLabel = this.getChildByName("infoLabel2");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("infoLabel1"), 1, 30, null);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.WAIGUAN_COPYID);
        this.____5();
        this.____6()
    },
    ____5: function() {
        ____654.copyMessageSender.sendMonsterUpdate();
        ____654.copyMessageSender.sendTimeUpdate();
        var copyTime = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.WAIGUAN_COPYID).copyTime;
        this._countDownUtils.start(copyTime, null, null)
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    updateTime: function(evt) {
        this._countDownUtils.start(this.____1009.leftTime, null, null)
    },
    updateMonster: function(evt) {
        this._monsterLabel.setString((this.____1009.totalMonster - this.____1009.leftMonster) + "/" + this.____1009.totalMonster);
        if (this.____1009.leftMonster == 0) {
            this._tickCount = 120;
            ____654.____678.____298(this.exitTick, this)
        }
    },
    exitTick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            ____654.copyTester.exitCopy();
            ____654.____678.____299(this.exitTick, this)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.exitTick, this);
        this.____17();
        this._controller = null;
        this._monsterLabel = null;
        this.____1009 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    },
});
var CopyXiuXianFollowPanel = KYPanel.extend({
    _controller: null,
    _monsterLabel: null,
    _totalTimeLabel: null,
    ____1707: null,
    ____1009: null,
    _countDownUtils: null,
    _tickCount: 0,
    ____1712: 0,
    _fightTime: 0,
    ctor: function(scenePanelController) {
        this._super("copyStarFollowPanel.ExportJson");
        this._controller = scenePanelController;
        this._monsterLabel = this.getChildByName("infoLabel4");
        this.getChildByName("tipsLabel4").setString(____654.yuyanbaoManager.getYuyanbao("____2253.text13"));
        this._totalTimeLabel = this.getChildByName("infoLabel2");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("infoLabel3"), 1, 30, null);
        this.____1707 = [this.getChildByName("star1"), this.getChildByName("star2"), this.getChildByName("star3")];
        this.____1707[0].setFrame("icon/ui_startIcon5.png");
        this.____1707[1].setFrame("icon/ui_startIcon5.png");
        this.____1707[2].setFrame("icon/ui_startIcon5.png");
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.XIUXIAN_COPYID);
        this.____5();
        this.____6()
    },
    ____5: function() {
        ____654.copyMessageSender.sendMonsterUpdate();
        ____654.copyMessageSender.sendTimeUpdate();
        this.____1712 = ____655.____662.getSystemTimeSec();
        this._fightTime = 0;
        ____654.____678.____298(this.fightTick, this)
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    updateTime: function(evt) {
        this._countDownUtils.start(this.____1009.leftTime);
        var nowTime = ____655.____662.getSystemTimeSec();
        this.____1712 = nowTime - (180 - this.____1009.leftTime)
    },
    updateMonster: function(evt) {
        this._monsterLabel.setString((this.____1009.totalMonster - this.____1009.leftMonster) + "/" + this.____1009.totalMonster);
        if (this.____1009.leftMonster == 0) {
            this._tickCount = 120;
            this._countDownUtils.stop();
            ____654.____678.____298(this.exitTick, this);
            ____654.____678.____299(this.fightTick, this)
        }
    },
    exitTick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            ____654.copyTester.exitCopy();
            ____654.____678.____299(this.exitTick, this)
        }
    },
    fightTick: function(delta, count) {
        var fightTime = ____655.____662.getSystemTimeSec() - this.____1712;
        if (this._fightTime == fightTime) {
            return
        }
        this._fightTime = fightTime;
        if (fightTime >= 90) {
            this.____1707[1].setFrame("icon/ui_startIcon0.png")
        }
        if (fightTime >= 60) {
            this.____1707[2].setFrame("icon/ui_startIcon0.png")
        }
        this._totalTimeLabel.setString(____655.____662.secondsToDateString(fightTime))
    },
    dispose: function() {
        ____654.____678.____299(this.exitTick, this);
        ____654.____678.____299(this.fightTick, this);
        this.____17();
        this._controller = null;
        this._monsterLabel = null;
        this._totalTimeLabel = null;
        this.____1707 = null;
        this.____1009 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._super()
    },
});
var CopyYaoTaFollowPanel = KYPanel.extend({
    _controller: null,
    _monsterLabel: null,
    _waveLabel: null,
    ____1009: null,
    ____1012: null,
    _countDownUtils: null,
    _copyJumpLevelView: null,
    ctor: function(scenePanelController) {
        this._super("copyLevelFollowPanel.ExportJson");
        this._controller = scenePanelController;
        this._waveLabel = this.getChildByName("infoLabel3");
        this.getChildByName("tipsLabel3").setString(____654.yuyanbaoManager.getYuyanbao("____2253.text14"));
        this._monsterLabel = this.getChildByName("infoLabel2");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("infoLabel1"), 1, 0, null);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.YAOTA_COPYID);
        this.____1012 = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.YAOTA_COPYID);
        this.____5();
        this.____6()
    },
    ____5: function() {
        ____654.copyMessageSender.sendShouhuUpdate();
        var copyTime = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.YAOTA_COPYID).copyTime;
        this._countDownUtils.start(copyTime, null, null);
        this.updateMonster();
        this.updateWave()
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this);
        this.____1009.addEventListener(____655.____661.copy_waveUpdate, this.updateWave, this);
        ____654.____672.addEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this);
        this.____1009.removeEventListener(____655.____661.copy_waveUpdate, this.updateWave, this);
        ____654.____672.removeEventListener(____655.____661.copy_finish, this.copyFinishHandler, this)
    },
    updateTime: function(evt) {
        this._countDownUtils.start(this.____1009.leftTime, null, null);
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.YAOTA_COPYID];
        var maxLevel = 0;
        if (info != null && info.maxMission > 0) {
            var maxLevel = this.____1012.missionIds.indexOf(info.maxMission);
            if (maxLevel < 0) {
                maxLevel = 135
            }
        }
        var curLevel = this.____1009.currentWave;
        if (curLevel > 0 && curLevel < 135 && curLevel % 5 == 0 && maxLevel >= curLevel + 5) {
            var levelList = ____655.allTemplates.copyTemplateList.getYaoTaLevel(curLevel + 5);
            var time = this.____1012.missions[curLevel - 1].copyTime;
            this.showJumpTip(Math.ceil(time / 4 - 0.5), ____654.yuyanbaoManager.getYuyanbao("____2182.text11", levelList[0], levelList[1]))
        } else {
            this.hideJumpTip()
        }
    },
    showJumpTip: function(time, level) {
        if (this._copyJumpLevelView == null) {
            this._copyJumpLevelView = new CopyJumpLevelView();
            ____654.____676.____799.addChild(this._copyJumpLevelView);
            this._copyJumpLevelView.setPosition(____654.____673.____159(____655.____656 * 0.5 - 250, 110));
            this._copyJumpLevelView.setOverCallBack(this.hideJumpTip, this)
        }
        this._copyJumpLevelView.initData(time, level)
    },
    hideJumpTip: function() {
        if (this._copyJumpLevelView != null) {
            this._copyJumpLevelView.dispose();
            this._copyJumpLevelView = null
        }
    },
    updateMonster: function(evt) {
        this._monsterLabel.setString((this.____1009.totalMonster - this.____1009.leftMonster) + "/" + this.____1009.totalMonster)
    },
    updateWave: function(evt) {
        var levelList = ____655.allTemplates.copyTemplateList.getYaoTaLevel(this.____1009.currentWave);
        this._waveLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2182.text11", levelList[0], levelList[1]));
        ____654.copyMessageSender.sendMonsterUpdate()
    },
    copyFinishHandler: function(evt) {
        function okClick() {
            ____654.copyTester.exitCopy()
        };
        var str = "";
        var info = ____655.statInfo.statCopyList[____655.allTemplates.copyTemplateList.YAOTA_COPYID];
        if (info != null && info.todayMaxMission != 0) {
            var copyTemplateInfo = ____655.allTemplates.copyTemplateList.getCopy(____655.allTemplates.copyTemplateList.YAOTA_COPYID);
            var currentMissionIndex = copyTemplateInfo.missionIds.indexOf(info.todayMaxMission);
            if (currentMissionIndex == -1) {
                str = ____654.yuyanbaoManager.getYuyanbao("____2253.text12")
            } else {
                str = ____654.yuyanbaoManager.getYuyanbao("____2253.text15")
            }
        } else {
            str = ____654.yuyanbaoManager.getYuyanbao("____2253.text15")
        }
        ____655.getAlert().show(2, str, null, 10, this, okClick)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._monsterLabel = null;
        this._waveLabel = null;
        this.____1009 = null;
        this.____1012 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this.hideJumpTip();
        this._super()
    },
});
var PersonBossFollowPanel = KYPanel.extend({
    _controller: null,
    _monsterLabel: null,
    ____1009: null,
    _countDownUtils: null,
    _tickCount: 0,
    ____1008: 0,
    ctor: function(scenePanelController, copyId) {
        this._super("copyBaseFollowPanel.ExportJson");
        this._controller = scenePanelController;
        this._monsterLabel = this.getChildByName("infoLabel2");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("infoLabel1"), 1, 30, null);
        this.____1008 = copyId;
        this.____1009 = ____655.copyInfo.getCopyInfo(copyId);
        this.____5();
        this.____6()
    },
    ____5: function() {
        ____654.copyMessageSender.sendMonsterUpdate();
        ____654.copyMessageSender.sendTimeUpdate();
        var copyTime = ____655.allTemplates.copyTemplateList.getCopy(this.____1008).copyTime;
        this._countDownUtils.start(copyTime, null, null)
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_monsterUpdate, this.updateMonster, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    updateTime: function(evt) {
        this._countDownUtils.start(this.____1009.leftTime, null, null)
    },
    updateMonster: function(evt) {
        this._monsterLabel.setString((this.____1009.totalMonster - this.____1009.leftMonster) + "/" + this.____1009.totalMonster);
        if (this.____1009.leftMonster == 0) {
            this._tickCount = 120;
            ____654.____678.____298(this.exitTick, this)
        }
    },
    exitTick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            ____654.copyTester.exitCopy();
            ____654.____678.____299(this.exitTick, this)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.exitTick, this);
        this.____17();
        this._controller = null;
        this._monsterLabel = null;
        this.____1009 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this.____1008 = null;
        this._super()
    },
});
var ____2254 = KYPanel.extend({
    _controller: null,
    ____882: null,
    _listView: null,
    ____1223: null,
    ____1111: null,
    ____1222: null,
    ____1506: null,
    ____1078: null,
    ____1646: null,
    _mapId: null,
    ____1673: true,
    ____1241: 0,
    ____1789: null,
    ____1790: null,
    _playerCount: 0,
    ctor: function(scenePanelController, mapId) {
        this._super("followClubBossPanel.ExportJson");
        this._controller = scenePanelController;
        this._mapId = mapId;
        this.____882 = this.getChildByName("bossNameLabel");
        this.____882.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text17"));
        this._listView = this.getChildByName("rankPanel");
        this.____1223 = this.getChildByName("headView");
        this.____1223.setVisible(false);
        this.____1078 = [];
        this.____1789 = this.getChildByName("tipsLabel1");
        this.____1789.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text18"));
        this.____1790 = this.getChildByName("tipsLabel2");
        this.____1789.setVisible(false);
        this.____1790.setVisible(false);
        this.____1646 = new ____2251();
        this.____1646.setPositionY(3);
        this.addChild(this.____1646);
        this.getChildByName("timeLabel").setVisible(false);
        this.getChildByName("stateLabel").setVisible(false);
        this.getChildByName("timeLayer").setVisible(false);
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.checkBossState();
        this.updateView();
        this.updateSelfView()
    },
    updateSelfView: function() {
        var damageRankList = ____655.copyInfo.worldBossInfo.damageRankList;
        var selfInfo = ____655.copyInfo.worldBossInfo.selfInfo;
        var rank = "10+";
        if (damageRankList.length > 0) {
            for (var i = 0; i < damageRankList.length; i++) {
                if (____655.____667.userId == damageRankList[i][1]) {
                    rank = (i + 1).toString();
                    break
                }
            }
        } else {
            rank = "1"
        }
        this.____1646.____18(rank, selfInfo[0])
    },
    updateView: function() {
        var damageRankList = ____655.copyInfo.worldBossInfo.damageRankList;
        if (this.____1673) {
            if (damageRankList.length > 0 || this.checkBossState()) {
                this.____1789.setVisible(false);
                this.____1790.setVisible(false);
                this.____1673 = false
            } else {
                this.____1789.setVisible(true);
                this.____1790.setVisible(true);
                if (this.____1241 == 1) {
                    this.____1790.setString("10:00")
                } else if (this.____1241 == 2) {
                    this.____1790.setString("14:00")
                } else if (this.____1241 == 3) {
                    this.____1790.setString("18:00")
                } else if (this.____1241 == 4) {
                    this.____1790.setString("22:00")
                } else if (this.____1241 == 5) {
                    this.____1790.setString(____654.yuyanbaoManager.getYuyanbao("____2156.text3", "10:00"))
                }
            }
        }
        this.clearItem();
        for (var i = 0; i < damageRankList.length; i++) {
            var item = new ____2251();
            if (i == 0) {
                item.setTextColor(____655.____659.____688.orange)
            } else if (i == 1) {
                item.setTextColor(____655.____659.____688.green)
            }
            item.____18((i + 1).toString(), damageRankList[i]);
            this._listView.pushBackItem(item);
            this.____1078.push(item)
        }
        if (this._playerCount != damageRankList.length) {
            this._listView.resetPos();
            this._playerCount = damageRankList.length
        }
    },
    ____6: function() {
        ____655.copyInfo.worldBossInfo.addEventListener(____655.____661.worldBoss_hurtUpdate, this.updateView, this);
        ____655.copyInfo.worldBossInfo.addEventListener(____655.____661.worldBossSelf_hurtUpdate, this.updateSelfView, this)
    },
    clearItem: function() {
        this._listView.removeAllItems();
        if (this.____1078.length > 0) {
            for (var i = 0; i < this.____1078.length; i++) {
                this.____1078[i].dispose()
            }
            this.____1078 = []
        }
    },
    checkBossState: function() {
        var bossState = 0;
        var systemTime = ____655.____662.getZeroPassTime();
        var time1 = 10 * 3600;
        var time2 = 14 * 3600;
        var time3 = 18 * 3600;
        var time4 = 22 * 3600;
        var templateInfo = ____655.allTemplates.monsterTemplateList.mapMonsterList[this._mapId];
        var info = ____655.bossItemList.getBossInfo(templateInfo[0].id);
        if (info != null) {
            bossState = info.fleshState
        } else {
            bossState = 0
        }
        if (systemTime < time1) {
            if (bossState == 0) {
                this.____1241 = 1;
                return false
            } else if (bossState == 1) {
                this.____1241 = 1;
                return true
            }
        } else if (time1 <= systemTime && systemTime < time2) {
            if (bossState == 0) {
                this.____1241 = 2;
                return false
            } else if (bossState == 1) {
                this.____1241 = 2;
                return true
            }
        } else if (time2 <= systemTime && systemTime < time3) {
            if (bossState == 0) {
                this.____1241 = 3;
                return false
            } else if (bossState == 1) {
                this.____1241 = 3;
                return true
            }
        } else if (time3 <= systemTime && systemTime < time4) {
            if (bossState == 0) {
                this.____1241 = 4;
                return false
            } else if (bossState == 1) {
                this.____1241 = 4;
                return true
            }
        } else if (systemTime >= time4) {
            if (bossState == 0) {
                this.____1241 = 5;
                return false
            } else if (bossState == 1) {
                this.____1241 = 5;
                return true
            }
        }
    },
    ____17: function() {
        ____655.copyInfo.worldBossInfo.removeEventListener(____655.____661.worldBoss_hurtUpdate, this.updateView, this);
        ____655.copyInfo.worldBossInfo.removeEventListener(____655.____661.worldBossSelf_hurtUpdate, this.updateSelfView, this)
    },
    dispose: function() {
        this.____17();
        this.clearItem();
        this._controller = null;
        this.____882 = null;
        this._listView = null;
        this.____1223 = null;
        if (this.____1646 != null) {
            this.____1646.dispose();
            this.____1646 = null
        }
        this._mapId = null;
        this.____1673 = null;
        this.____1789 = null;
        this.____1790 = null;
        ____655.copyInfo.worldBossInfo.____61();
        this._super()
    },
});
var familyTreasuresItemOne = KYNode.extend({
    _boxTemplateInfo: null,
    _itemList: null,
    _boxName: null,
    _openBtn: null,
    ____1241: null,
    _openWastTime: null,
    _boxIdList: null,
    ____1512: null,
    path: null,
    _goldIcon: null,
    _gold: null,
    ____1126: null,
    ctor: function(index) {
        this._super("familyTreasuresItem1.ExportJson");
        this._itemList = [];
        for (var i = 1; i <= 5; i++) {
            var _grid = new ____2129();
            this.getChildByName("cell" + i).addChild(_grid);
            this._itemList.push(_grid)
        }
        this._boxName = this.getChildByName("nameLabel");
        this._openBtn = this.getChildByName("messagebtn");
        this._goldIcon = this.getChildByName("moneyIcon");
        this._openWastTime = this.getChildByName("time_label");
        this.____1241 = index;
        this._gold = 0;
        this._boxIdList = [];
        this._boxIdList = ____655.familyTreasuresInfo.____885;
        this.____1512 = ____654.____673.newKYSprite();
        this.____1512.setPosition(____654.____673.____159(73, 52));
        this.____1512.setScale(1.2);
        this.addChild(this.____1512, 1);
        this.____6()
    },
    updateInfo: function() {
        var _boxId = this._boxIdList[this.____1241][0];
        this._boxTemplateInfo = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(_boxId);
        this._boxName.setString(this._boxTemplateInfo.name);
        var ____993 = ____655.allTemplates.familyTreasuresBoxTemplateList.getStageColor(_boxId);
        this._boxName.setColor(____993);
        var goodsList = this._boxTemplateInfo.common_award;
        for (var i = 0; i < goodsList.length; i++) {
            this._itemList[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(goodsList[i][0]));
            this._itemList[i].setCount(goodsList[i][1])
        }
        this._openWastTime.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemOne.text1", (this._boxTemplateInfo.need_time / 3600)));
        this.path = ____654.____675.getIconPath(this._boxTemplateInfo.icon, ____655.____659.iconPathType.item);
        ____654.____677.____146(this.____1512, this.path);
        var freeCdTime = ____655.familyTreasuresInfo._wabaoNextTimes - ____655.____662.getSystemTimeSec();
        if (freeCdTime > 0) {
            this._goldIcon.setVisible(true);
            this.getChildByName("btnLabel").setPosition(563, 38);
            this.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemOne.text2", this._boxTemplateInfo.wabao_cost));
            this._gold = this._boxTemplateInfo.wabao_cost;
            if (this.____1126 != null) {
                this.____1126.dispose();
                this.____1126 = null
            }
        } else {
            this._goldIcon.setVisible(false);
            this.getChildByName("btnLabel").setPosition(555, 38);
            this.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemOne.text4"));
            if (this.____1126 == null) {
                this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(75, 28), this._openBtn);
                this.____1126.setScaleX(1.3)
            }
        }
    },
    ____6: function() {
        this._openBtn.addListener(this, this.clickHandler)
    },
    ____17: function() {},
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (____655.familyTreasuresInfo.isNoClubButHasTask()) {
                ____655.getAlert().show(6, ____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text6"), null, 5, this, this.noClubCallBack, null, null)
            } else {
                var totaleTime = ____655.allTemplates.familyTreasuresBaseTemplateList.list[1].wabao_times;
                var hadTimes = ____655.familyTreasuresInfo._wabaoTimes;
                if (totaleTime - hadTimes > 0) {
                    if (this._gold > 0) {
                        ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemOne.text3", this._gold) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), "familyTreasuresItemOne", 0, this, this.costHandler, null, null)
                    } else {
                        var pos = this._boxIdList[this.____1241][1];
                        ____654.familyTreasuresMessageSender.openTreasures(pos);
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemOne.text6"))
                    }
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemOne.text5"))
                }
            }
        }
    },
    noClubCallBack: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.closeFamilyTreasuresPanel, this));
        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_club, 2)
    },
    costHandler: function() {
        if (____655.____667.moneyInfo.money1Enough(this._gold)) {
            var pos = this._boxIdList[this.____1241][1];
            ____654.familyTreasuresMessageSender.openTreasures(pos);
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemOne.text6"))
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    dispose: function() {
        this.____17();
        this._boxTemplateInfo = null;
        for (var i = 0; i < this._itemList.length; i++) {
            if (this._itemList[i] != null) {
                this._itemList[i].dispose();
                this._itemList[i] = null
            }
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._boxName = null;
        this._openBtn = null;
        this.____1241 = null;
        this._openWastTime = null;
        this._boxIdList = null;
        this.____1512.dispose();
        this.____1512 = null;
        this._gold = null;
        this.path = null;
        this._goldIcon = null;
        this._super()
    },
});
var familyTreasuresItemTwo = KYNode.extend({
    ____1002: null,
    _itemList: null,
    _boxName: null,
    ____1185: null,
    ____1241: null,
    _myBoxList: null,
    _countDownUtils: null,
    _helpNameLabel: null,
    ____892: null,
    ____911: 0,
    _boxInfo: null,
    ____1165: 0,
    ____1512: null,
    path: null,
    _goldIcon: null,
    _gold: null,
    _countDownUtils2: null,
    _timeLabel: null,
    ____1126: null,
    ctor: function(index, flag) {
        this._super("familyTreasuresItem2.ExportJson");
        this._itemList = [];
        for (var i = 1; i <= 5; i++) {
            var _grid = new ____2129();
            this.getChildByName("cell" + i).addChild(_grid);
            this._itemList.push(_grid)
        }
        this._boxName = this.getChildByName("nameLabel");
        this.____1185 = this.getChildByName("messagebtn");
        this._goldIcon = this.getChildByName("moneyIcon");
        this._helpNameLabel = this.getChildByName("nameLabel_Copy0");
        this.____892 = this.getChildByName("btnLabel");
        this._timeLabel = this.getChildByName("time_label");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("time_label"), 0, 0);
        this._countDownUtils2 = new ____2111();
        this._countDownUtils2.setLabel(this.getChildByName("btnLabel"), 0, 0);
        this.____1241 = index;
        this._gold = 0;
        this.____1165 = flag;
        this.____1512 = ____654.____673.newKYSprite();
        this.____1512.setPosition(____654.____673.____159(71, 62));
        this.____1512.setScale(1.2);
        this.addChild(this.____1512, 1);
        this._myBoxList = [];
        if (this.____1165 == 2) {
            this._myBoxList = ____655.familyTreasuresInfo._myBoxList;
            this._goldIcon.setVisible(false)
        } else {
            this._myBoxList = ____655.familyTreasuresInfo._helpBoxList
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        var _boxInfo = this._myBoxList[this.____1241];
        this._boxInfo = _boxInfo;
        var _boxId = _boxInfo[1];
        this._boxTemplateInfo = ____655.allTemplates.familyTreasuresBoxTemplateList.getBoxInfoById(_boxId);
        this._boxName.setString(this._boxTemplateInfo.name);
        var ____993 = ____655.allTemplates.familyTreasuresBoxTemplateList.getStageColor(_boxId);
        this._boxName.setColor(____993);
        var goodsList = this._boxTemplateInfo.common_award;
        for (var i = 0; i < goodsList.length; i++) {
            this._itemList[i].setItemTemplateInfo(____655.allTemplates.____794.getItem(goodsList[i][0]));
            var num = goodsList[i][1];
            if (this.____1165 == 2) {
                if (_boxInfo[4] != "") {
                    num = goodsList[i][1] * 1.5
                }
            }
            this._itemList[i].setCount(num)
        }
        this.path = ____654.____675.getIconPath(this._boxTemplateInfo.icon, ____655.____659.iconPathType.item);
        ____654.____677.____146(this.____1512, this.path);

        function endTimeCallback() {
            _this._timeLabel.setString("挖宝成功");
            var needTime1 = endTime - ____655.____662.getSystemTimeSec();
            _this.updateBtnState(needTime1, _boxInfo)
        };
        var endTime = _boxInfo[2];
        var _this = this;
        var needTime1 = endTime - ____655.____662.getSystemTimeSec() - 2;
        if (this.____1165 == 3) {
            if (_boxInfo[3] == 0) {
                _this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemOne.text1", (this._boxTemplateInfo.need_time / 3600)))
            } else {
                this._countDownUtils.start(needTime1, null, endTimeCallback)
            }
        } else {
            this._countDownUtils.start(needTime1, null, endTimeCallback)
        }
        this.updateBtnState(needTime1, _boxInfo)
    },
    updateBtnState: function(needTime1, _boxInfo) {
        if (this.____1165 == 2) {
            this.____892.setPosition(550, 49);
            if (_boxInfo[4] != "") {
                this._helpNameLabel.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text1", _boxInfo[4]));
                this.____892.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text6"));
                if (needTime1 > 0) {
                    this.____1185.setTouchEnabled(false);
                    this.____1185.setFrame("btn/ui_btn1_4.png")
                } else {
                    if (this.____1126 == null) {
                        this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(75, 28), this.____1185);
                        this.____1126.setScaleX(1.3)
                    }
                    this.____1185.setTouchEnabled(true);
                    this.____1185.setFrame("btn/ui_btn1_2.png");
                    this.____911 = 1
                }
            } else {
                this._helpNameLabel.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text7"));
                if (needTime1 > 0) {
                    this.____911 = 2;
                    var cdTime = this._boxInfo[3] - ____655.____662.getSystemTimeSec();
                    if (cdTime > 0) {
                        function endTimeCallback() {
                            _this.____1185.setTouchEnabled(true);
                            _this.____1185.setFrame("btn/ui_btn1_2.png");
                            _this.____892.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text8"))
                        };
                        var _this = this;
                        this._countDownUtils2.start(cdTime, null, endTimeCallback);
                        this.____1185.setTouchEnabled(false);
                        this.____1185.setFrame("btn/ui_btn1_4.png")
                    } else {
                        if (this.____1126 == null) {
                            this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(75, 28), this.____1185);
                            this.____1126.setScaleX(1.3)
                        }
                        this.____1185.setTouchEnabled(true);
                        this.____1185.setFrame("btn/ui_btn1_2.png");
                        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text8"))
                    }
                } else {
                    if (this.____1126 == null) {
                        this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(75, 28), this.____1185);
                        this.____1126.setScaleX(1.3)
                    }
                    this.____892.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text6"));
                    this.____911 = 1
                }
            }
        } else if (this.____1165 == 3) {
            this._helpNameLabel.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text3", _boxInfo[4]));
            this.____1185.setTouchEnabled(true);
            this.____1185.setFrame("btn/ui_btn1_2.png");
            if (_boxInfo[3] > 0) {
                this.____911 = 4;
                if (needTime1 > 0) {
                    this._goldIcon.setVisible(true);
                    var cost = Math.ceil(needTime1 / 600) * this._boxTemplateInfo.cost_per_10;
                    cost = Math.ceil(cost / 100);
                    this.____892.setPosition(558, 49);
                    this.____892.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text4", cost));
                    this._gold = cost
                } else {
                    this._goldIcon.setVisible(false);
                    this.____892.setPosition(550, 49);
                    this.____1185.setFrame("btn/ui_btn1_2.png");
                    this.____892.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text6"));
                    this._gold = 0;
                    if (this.____1126 == null) {
                        this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(75, 28), this.____1185);
                        this.____1126.setScaleX(1.3)
                    }
                }
            } else {
                this.____911 = 3;
                this._goldIcon.setVisible(false);
                this.____892.setPosition(550, 49);
                this.____892.setString(____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text9"));
                if (!____655.familyTreasuresInfo._isCanHelpOthers) {
                    this.____1185.setFrame("btn/ui_btn1_4.png")
                }
            }
        }
    },
    ____6: function() {
        this.____1185.addListener(this, this.clickHandler)
    },
    ____17: function() {},
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var id = this._myBoxList[this.____1241][0];
            if (this.____911 == 1) {
                ____654.familyTreasuresMessageSender.getAward(id)
            } else if (this.____911 == 2) {
                if (____655.familyTreasuresInfo.isNoClubButHasTask()) {
                    ____655.getAlert().show(6, ____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text6"), null, 5, this, this.noClubCallBack, null, null)
                } else {
                    var cdTime = this._boxInfo[3] - ____655.____662.getSystemTimeSec();
                    if (cdTime <= 0) {
                        ____654.familyTreasuresMessageSender.forHelp(id);
                        ____654.tipsManager.quickTip.show("发送邀请成功！")
                    } else {
                        ____654.tipsManager.quickTip.show("邀请协助冷却中！")
                    }
                }
            } else if (this.____911 == 3) {
                if (!____655.familyTreasuresInfo._isCanHelpOthers) {
                    ____654.tipsManager.quickTip.show("同时仅可协助一人！")
                } else {
                    var canHelpTime = ____655.allTemplates.familyTreasuresBaseTemplateList.list[1].help_times - ____655.familyTreasuresInfo._helpTime;
                    if (canHelpTime > 0) {
                        var userId = this._myBoxList[this.____1241][5];
                        var id = this._myBoxList[this.____1241][0];
                        ____654.familyTreasuresMessageSender.helpWabao(userId, id);
                        ____654.tipsManager.quickTip.show("协助挖宝成功！")
                    } else {
                        ____654.tipsManager.quickTip.show("协助挖宝次数已用完！")
                    }
                }
            } else if (this.____911 == 4) {
                if (this._gold > 0) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("familyTreasuresItemTwo.text5", this._gold) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), "familyTreasuresItemTwo", 0, this, this.costHandler, null, null)
                } else {
                    ____654.familyTreasuresMessageSender.getHelpAward()
                }
            }
        }
    },
    noClubCallBack: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.closeFamilyTreasuresPanel, this));
        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_club, 2)
    },
    costHandler: function() {
        if (____655.____667.moneyInfo.money1Enough(this._gold)) {
            ____654.familyTreasuresMessageSender.getHelpAward()
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    dispose: function() {
        this.____17();
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        if (this._countDownUtils2 != null) {
            this._countDownUtils2.dispose();
            this._countDownUtils2 = null
        }
        this.____1002 = null;
        for (var i = 0; i < this._itemList.length; i++) {
            if (this._itemList[i] != null) {
                this._itemList[i].dispose();
                this._itemList[i] = null
            }
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._boxName = null;
        this.____1185 = null;
        this._gold = null;
        this.____1241 = null;
        this._myBoxList = null;
        this._helpNameLabel = null;
        this._timeLabel = null;
        this.____892 = null;
        this.____911 = null;
        this._boxInfo = null;
        this.____1165 = null;
        this.____1512 = null;
        this.path = null;
        this._goldIcon = null;
        this._super()
    },
});
var FamilyTreasuresOnePanel = KYNode.extend({
    _parent: null,
    ____1002: null,
    _boxIdList: null,
    _wabaoTimesLabel: null,
    _freshCountDownUtils: null,
    _nextFreeCountDownUtils: null,
    familyTreasuresBaseInfo: null,
    ____1021: null,
    _freshBtn: null,
    _gold: null,
    _isFristOpen: null,
    _nextFreeLabel: null,
    ctor: function(parent) {
        this._super("familyTreasuresOne.ExportJson");
        this._parent = parent;
        this.____1002 = this.getChildByName("scrollView__1");
        this.____1002.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._boxIdList = [];
        this._wabaoTimesLabel = this.getChildByName("Label_1184606");
        this._freshBtn = this.getChildByName("refreshBtn");
        this._nextFreeLabel = this.getChildByName("countLabel");
        this._freshCountDownUtils = new ____2111();
        this._freshCountDownUtils.setLabel(this.getChildByName("timeLabel"), 0, 0);
        this._nextFreeCountDownUtils = new ____2111();
        this._nextFreeCountDownUtils.setLabel(this.getChildByName("countLabel"), 0, 0);
        this.____1021 = this.getChildByName("countBar");
        this.getChildByName("tips_1").setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresOnePanel.text4"));
        this._gold = 0;
        this._isFristOpen = true;
        this.familyTreasuresBaseInfo = ____655.allTemplates.familyTreasuresBaseTemplateList.list[1];
        this.____6()
    },
    ____5: function() {
        var _info = ____655.familyTreasuresInfo;
        this._boxIdList = ____655.familyTreasuresInfo.____885;
        if (this.____1002 != null) {
            this.____1002.clearAllItems()
        }
        var len = this._boxIdList.length;
        if (this._isFristOpen) {
            this.____1002.setFormat(1, len, ____654.____673.____160(700, 115), 0, 0, true);
            this._isFristOpen = false
        } else {
            this.____1002.setFormat(1, len, ____654.____673.____160(700, 115), 0, 0, false)
        }
        var totaleTime = this.familyTreasuresBaseInfo.wabao_times;
        var hadTimes = ____655.familyTreasuresInfo._wabaoTimes;
        this._wabaoTimesLabel.setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresOnePanel.text1", totaleTime - hadTimes));

        function endTime1() {};
        var needTime1 = _info._boxFreshTimes - ____655.____662.getSystemTimeSec();
        this._freshCountDownUtils.start(needTime1, null, endTime1);
        var _this = this;

        function endTime2() {
            _this._nextFreeLabel.setString("免费挖宝")
        };
        var needTime2 = _info._wabaoNextTimes - ____655.____662.getSystemTimeSec();
        this._nextFreeCountDownUtils.start(needTime2, null, endTime2);
        var fenmu = _info._wabaoNextTimes - _info._wabaoBeginTimes;
        var fenzi = needTime2;
        this.____1021.setPercent(needTime2 * 100 / (_info._wabaoNextTimes - _info._wabaoBeginTimes));
        if (_info._freshTimes < 2) {
            this.getChildByName("refreshLabel").setPosition(565, 49);
            this.getChildByName("refreshLabel").setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresOnePanel.text5"));
            this.getChildByName("moneyIcon").setVisible(false)
        } else {
            var _gold = (_info._freshTimes - 1) * 10;
            if (_gold > 50) {
                _gold = 50
            }
            this._gold = _gold;
            this.getChildByName("refreshLabel").setPosition(580, 49);
            this.getChildByName("refreshLabel").setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresOnePanel.text2", _gold));
            this.getChildByName("moneyIcon").setVisible(true)
        }
    },
    ____6: function() {
        this._freshBtn.addListener(this, this.clickHandler);
        ____655.familyTreasuresInfo.addEventListener(____655.____661.familyTreasuresListUpdate, this.____5, this)
    },
    ____17: function() {
        ____655.familyTreasuresInfo.removeEventListener(____655.____661.familyTreasuresListUpdate, this.____5, this)
    },
    getItemByIndex: function(index) {
        var grid = new familyTreasuresItemOne(index);
        grid.updateInfo();
        return grid
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (____655.familyTreasuresInfo.isNoClubButHasTask()) {
                ____655.getAlert().show(6, ____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text6"), null, 5, this, this.noClubCallBack, null, null)
            } else {
                if (this._gold > 0) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresOnePanel.text3", this._gold) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), "FamilyTreasuresOnePanel", 0, this, this.costHandler, null, null)
                } else {
                    ____654.familyTreasuresMessageSender.familyTreasuresFresh()
                }
            }
        }
    },
    noClubCallBack: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.closeFamilyTreasuresPanel, this));
        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_club, 2)
    },
    costHandler: function() {
        if (____655.____667.moneyInfo.money1Enough(this._gold)) {
            ____654.familyTreasuresMessageSender.familyTreasuresFresh()
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    getIdByIndex: function(index) {
        return index
    },
    dispose: function() {
        this.____17();
        if (this._freshCountDownUtils != null) {
            this._freshCountDownUtils.dispose();
            this._freshCountDownUtils = null
        }
        if (this._nextFreeCountDownUtils != null) {
            this._nextFreeCountDownUtils.dispose();
            this._nextFreeCountDownUtils = null
        }
        this.____1002 = null;
        this._boxIdList = null;
        this._wabaoTimesLabel = null;
        this.familyTreasuresBaseInfo = null;
        this.____1021 = null;
        this._gold = null;
        this._isFristOpen = null;
        this._freshBtn = null;
        this._parent = null;
        this._super()
    },
});
var FamilyTreasuresPanel = KYPanel.extend({
    _controller: null,
    ____1738: null,
    ____1740: null,
    ____1737: null,
    ____1054: null,
    _panelList: null,
    _moneyView: null,
    _titleLabel: null,
    _tips_image: null,
    _bgPath: null,
    _closeBtn: null,
    _countDownUtils: null,
    ____1776: null,
    ctor: function(controller, index) {
        this._super("familyTreasuresPanel.ExportJson");
        this._controller = controller;
        this.____1776 = this.getChildByName("tipBtn");
        this.____1740 = this.getChildByName("tabLayer");
        this._tips_image = this.getChildByName("tips_image");
        this._closeBtn = this.getChildByName("closeBtn");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("time"), 0, 0);
        this._bgPath = ____654.____675.____139("outPic/familyTreasureLogo.png");
        ____654.____677.____146(this._tips_image, this._bgPath);
        this._moneyView = new ____2237(3);
        this.getChildByName("moneyLayer").addChild(this._moneyView);
        this._titleLabel = ____654.____673.newKYLabel(30, true);
        this._titleLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this._titleLabel.setPosition(____654.____673.____159(29, 604));
        this._titleLabel.setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text1"));
        this.addChild(this._titleLabel, 1);
        this.getChildByName("tips_1").setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text2"));
        this._panelList = [null, null, null, null, null, null];
        ____654.familyTreasuresMessageSender.getBaseInfo();
        if (index == null) index = 0;
        this.____5(index);
        this.____6()
    },
    ____5: function(index) {
        var leftTime = ____655.activityIconList.activityIcons[40].endTime - ____655.____662.getSystemTimeSec();

        function endTime() {
            this.dispose()
        }
        this._countDownUtils.start(leftTime, null, endTime);
        this.____1738 = [
            [1, ____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text3"), "icon/ui_familyTreasures1.png", true, 5],
            [2, ____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text4"), "icon/ui_familyTreasures2.png", true, 10],
            [3, ____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text5"), "icon/ui_familyTreasures3.png", true, 15],
        ];
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(340);
        this.____1740.addChild(this.____1737);
        if (index == null || index == 0) {
            index = 1
        }
        this.____1737.setTabIndex(index - 1)
    },
    setTab: function(tab) {
        if (this.____1054 != null) {
            this.____1054.removeFromParent(false)
        }
        this.____1054 = this.getPanel(tab);
        if (this.____1054 != null && this.____1054.getParent() == null) {
            this.addChild(this.____1054, 99);
            this.____1054.setPositionX(215)
        }
    },
    getPanel: function(tab) {
        var panel = this._panelList[tab];
        if (panel == null) {
            if (tab == 1) {
                panel = new FamilyTreasuresOnePanel(this)
            } else if (tab == 2) {
                panel = new FamilyTreasuresTwoPanel(this)
            } else if (tab == 3) {
                panel = new FamilyTreasuresThreePanel(this)
            }
            this._panelList[tab] = panel
        }
        return panel
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.clickHandler);
        this.____1776.addListener(this, this.clickHandler);
        ____654.____672.addEventListener(____655.____661.closeFamilyTreasuresPanel, this.dispose, this);
        ____654.____672.addEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____655.familyTreasuresInfo.addEventListener(____655.____661.familyTreasuresPopUpdate, this.popUpdate, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.closeFamilyTreasuresPanel, this.dispose, this);
        ____654.____672.removeEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____655.familyTreasuresInfo.removeEventListener(____655.____661.familyTreasuresPopUpdate, this.popUpdate, this)
    },
    popUpdate: function(evt) {
        var list = evt.data;
        this.____1737.setShowPop(list[0], list[1])
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____1776) {
                ____654.tipsManager.showStringTip(____654.____682.____108("10102"), 500)
            }
        }
    },
    changeTabIndexHandler: function(evt) {
        if (this.getParent() != null) {
            var index = evt.data;
            this.____1737.setTabIndex(index)
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._closeBtn = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this.____1740 = null;
        this.____1054 = null;
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        if (this._panelList != null) {
            for (var i = 0; i < this._panelList.length; i++) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this.____1738 = null;
        this.____1776 = null;
        this._titleLabel.dispose();
        this._titleLabel = null;
        this._tips_image = null;
        this._bgPath = null;
        this._super()
    },
});
var FamilyTreasuresThreePanel = KYNode.extend({
    _controller: null,
    ____1002: null,
    ____885: null,
    _tipsLabel: null,
    ____1790: null,
    _isFristOpen: null,
    ____892: null,
    _jumpbtn: null,
    ctor: function(controller) {
        this._super("familyTreasuresTwo.ExportJson");
        this._controller = controller;
        this.____1002 = this.getChildByName("scrollView__1");
        this._tipsLabel = this.getChildByName("Label_1184606");
        this.____1790 = this.getChildByName("tipsLabel");
        this.____1002.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____885 = [];
        this.____892 = this.getChildByName("btnLabel");
        this.____892.setString("获得宝藏");
        this._jumpbtn = this.getChildByName("jumpbtn");
        this._isFristOpen = true;
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (this.____1002 != null) {
            this.____1002.clearAllItems()
        }
        this.____885 = ____655.familyTreasuresInfo._helpBoxList;
        var len = this.____885.length;
        if (this._isFristOpen) {
            this.____1002.setFormat(1, len, ____654.____673.____160(716, 138), 0, 3, true);
            this._isFristOpen = false
        } else {
            this.____1002.setFormat(1, len, ____654.____673.____160(716, 138), 0, 3, false)
        }
        if (len != 0) {
            this.____1790.setVisible(false);
            this.____892.setVisible(false);
            this._jumpbtn.setVisible(false)
        } else {
            this.____1790.setVisible(true);
            this.____892.setVisible(true);
            this._jumpbtn.setVisible(true);
            this.____1790.setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresThreePanel.text2"))
        }
        var canHelpTime = ____655.allTemplates.familyTreasuresBaseTemplateList.list[1].help_times - ____655.familyTreasuresInfo._helpTime;
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresThreePanel.text1", canHelpTime))
    },
    ____6: function() {
        this.____892.addListener(this, this.clickHandler);
        ____655.familyTreasuresInfo.addEventListener(____655.____661.familyTreasuresHelpListUpdate, this.____5, this)
    },
    ____17: function() {
        ____655.familyTreasuresInfo.removeEventListener(____655.____661.familyTreasuresHelpListUpdate, this.____5, this)
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_changeTabIndex, ____654.____672, 0))
        }
    },
    getItemByIndex: function(index) {
        var grid = new familyTreasuresItemTwo(index, 3);
        return grid
    },
    getIdByIndex: function(index) {
        return index
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1002 = null;
        this.____885 = null;
        this._isFristOpen = null;
        this._tipsLabel = null;
        this.____1790 = null;
        this._jumpbtn = null;
        this.____892 = null;
        this._super()
    },
});
var FamilyTreasuresTwoPanel = KYNode.extend({
    _parent: null,
    ____1002: null,
    ____885: null,
    _tipsLabel: null,
    _isFristOpen: null,
    ____892: null,
    _jumpbtn: null,
    ctor: function(parent) {
        this._super("familyTreasuresTwo.ExportJson");
        this._parent = parent;
        this.____1002 = this.getChildByName("scrollView__1");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____892 = this.getChildByName("btnLabel");
        this.____892.setString("获得宝藏");
        this._jumpbtn = this.getChildByName("jumpbtn");
        this.getChildByName("Label_1184606").setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresTwoPanel.text1"));
        this.____1002.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____885 = [];
        this._isFristOpen = true;
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (this.____1002 != null) {
            this.____1002.clearAllItems()
        }
        this.____885 = ____655.familyTreasuresInfo._myBoxList;
        var len = this.____885.length;
        if (this._isFristOpen) {
            this.____1002.setFormat(1, len, ____654.____673.____160(716, 138), 0, 3, true);
            this._isFristOpen = false
        } else {
            this.____1002.setFormat(1, len, ____654.____673.____160(716, 138), 0, 3, false)
        }
        if (len != 0) {
            this._tipsLabel.setVisible(false);
            this.____892.setVisible(false);
            this._jumpbtn.setVisible(false)
        } else {
            this._tipsLabel.setVisible(true);
            this.____892.setVisible(true);
            this._jumpbtn.setVisible(true);
            this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresTwoPanel.text2"))
        }
    },
    ____6: function() {
        this.____892.addListener(this, this.clickHandler);
        ____655.familyTreasuresInfo.addEventListener(____655.____661.myFamilyTreasuresListUpdate, this.____5, this)
    },
    ____17: function() {
        ____655.familyTreasuresInfo.removeEventListener(____655.____661.myFamilyTreasuresListUpdate, this.____5, this)
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_changeTabIndex, ____654.____672, 0))
        }
    },
    getItemByIndex: function(index) {
        var grid = new familyTreasuresItemTwo(index, 2);
        return grid
    },
    getIdByIndex: function(index) {
        return index
    },
    dispose: function() {
        this.____17();
        this._parent = null;
        this.____1002 = null;
        this._isFristOpen = null;
        this._jumpbtn = null;
        this.____892 = null;
        this.____885 = null;
        this._tipsLabel = null;
        this._super()
    },
});
var DaluandouPanel = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _xianwei_Label: null,
    ____1480: null,
    _tips_label: null,
    _cell1s: null,
    _cell2s: null,
    _cell3s: null,
    _gridList: null,
    _nameLabel: null,
    ctor: function(controller) {
        this._super("daluandouPanel.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("ImageView_953123");
        this._bgPath = ____654.____675.____139("outPic/daluandou.png");
        this._xianwei_Label = this.getChildByName("xianwei_Label");
        this._xianwei_Label.setString(____655.____659.nameType.getSelfXianweiName());
        this.____1480 = this.getChildByName("OKBtn");
        this.____1480.addListener(this, this.okClickHandler);
        this._cell1s = [this.getChildByName("cell1_1"), this.getChildByName("cell1_2"), this.getChildByName("cell1_3"), this.getChildByName("cell1_4")];
        this._cell2s = [this.getChildByName("cell2_1"), this.getChildByName("cell2_2"), this.getChildByName("cell2_3"), this.getChildByName("cell2_4")];
        this._cell3s = [this.getChildByName("cell3_1"), this.getChildByName("cell3_2"), this.getChildByName("cell3_3"), this.getChildByName("cell3_4 ")];
        this._tips_label = this.getChildByName("tips_label");
        this._nameLabel = this.getChildByName("Name");
        this._tips_label.setString(____654.yuyanbaoManager.getYuyanbao("DaluandouPanel.text1"));
        this.____5()
    },
    ____5: function() {
        ____654.____677.____146(this._bg, this._bgPath);
        var xianWei = ____655.____667.xianwei;
        this._nameLabel.setString(____654.yuyanbaoManager.getYuyanbao("DaluandouPanel.text2", ____655.____659.nameType.getXianweiName(____655.____667.xianwei)));
        var tmplist = ____655.allTemplates.rankAwardTemplateList.getTypeList(18);
        var list = {};
        for (var i = 0; i < tmplist.length; i++) {
            var info = tmplist[i];
            if (info.stage == ____655.____667.xianwei) {
                list[info.minLevel] = info
            }
        }
        this._gridList = [];
        var awards = list[1].awardList;
        for (var i = 0; i < this._cell1s.length; i++) {
            if (awards[i] != null) {
                var grid = new ____2129(false);
                grid.setItemTemplateInfo(____655.allTemplates.____794.getItem(parseInt(awards[i][0])));
                grid.setCount(awards[i][1]);
                this._cell1s[i].addChild(grid);
                this._gridList.push(grid)
            }
        }
        awards = list[2].awardList;
        for (var i = 0; i < this._cell2s.length; i++) {
            if (awards[i] != null) {
                var grid = new ____2129(false);
                grid.setItemTemplateInfo(____655.allTemplates.____794.getItem(parseInt(awards[i][0])));
                grid.setCount(awards[i][1]);
                this._cell2s[i].addChild(grid);
                this._gridList.push(grid)
            }
        }
        awards = list[3].awardList;
        for (var i = 0; i < this._cell3s.length; i++) {
            if (awards[i] != null) {
                var grid = new ____2129(false);
                grid.setItemTemplateInfo(____655.allTemplates.____794.getItem(parseInt(awards[i][0])));
                grid.setCount(awards[i][1]);
                this._cell3s[i].addChild(grid);
                this._gridList.push(grid)
            }
        }
    },
    okClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.copyTester.enterCopy(____655.allTemplates.copyTemplateList.DALUANDOU_COPYID, 0)
        }
    },
    dispose: function() {
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._controller = null;
        this._bg = null;
        this._bgPath = null;
        this._xianwei_Label = null;
        this.____1480 = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                if (this._gridList[i] != null) {
                    this._gridList[i].dispose()
                }
            }
            this._gridList = null
        }
        this._tips_label = null;
        this._cell1s = null;
        this._cell2s = null;
        this._cell3s = null;
        this._nameLabel = null;
        this._super()
    },
});
var DoushendianItem = KYNode.extend({
    _info: null,
    ____927: null,
    ____1579: null,
    _nameLabel: null,
    ____1157: null,
    ctor: function() {
        this._super("doushendianItemView.ExportJson");
        this.____927 = this.getChildByName("careerIcon");
        this.____1579 = this.getChildByName("nameLabel");
        this._nameLabel = this.getChildByName("descLabel");
        this.____1157 = this.getChildByName("combatLabel");
        this.setContentSize(____654.____673.____160(135, 137));
        this.setTouchEnabled(true)
    },
    ____18: function(info) {
        if (this._info == info) return;
        this._info = info;
        this.____927.setFrame("sceneIcon/PlayerHeadIcon2_" + this._info.playerInfo.career + ".png");
        this.____1579.setString(this._info.rank);
        this._nameLabel.setString(this._info.playerInfo.nick);
        this.____1157.setString(____654.yuyanbaoManager.getYuyanbao("DoushendianItem.text1") + this._info.playerInfo.combat)
    },
    ____238: function() {
        return this._info
    },
    dispose: function() {
        this.____927 = null;
        this.____1579 = null;
        this._nameLabel = null;
        this.____1157 = null;
        this._info = null;
        this._super()
    },
});
var ____2256 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _replaceBtn: null,
    _timeList: null,
    ____1625: null,
    _familyLabel: null,
    ____892: null,
    ____1288: null,
    ____884: null,
    _details: null,
    _characters: null,
    _countDownLabel: null,
    _countDownUtils: null,
    ____1126: null,
    COST: 10,
    _tickCount: 600,
    ctor: function(controller) {
        this._super("doushendianPanel.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("ImageView_953123");
        this._bgPath = ____654.____675.____139("outPic/ui_fightPlaceBg1.png");
        this._replaceBtn = this.getChildByName("replaceBtn");
        this.____892 = this.getChildByName("btnLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2256.text5"));
        this._timeList = [this.getChildByName("time_1"), this.getChildByName("time_2"), this.getChildByName("time_3"), this.getChildByName("time_4"), this.getChildByName("time_5")];
        this._familyLabel = this.getChildByName("familyLabel");
        this.____1625 = this.getChildByName("scrollView");
        this.____1625.setScrollBarEnabled(false);
        this.____884 = this.getChildByName("boxIcon");
        this.____884.setTouchEnabled(true);
        this._countDownLabel = this.getChildByName("countDownLabel");
        this._details = [this.getChildByName("detail_1"), this.getChildByName("detail_2"), this.getChildByName("detail_3")];
        for (var i = 0; i < this._details.length; i++) {
            this._details[i].addListener(this, this.topClickHandler)
        }
        this.____1288 = [];
        this._characters = [];
        this.____5();
        this.____6();
        this.infoUpdateHandler(null);
        this._replaceBtn.addListener(this, this.replaceClickHandler);
        ____654.rankMessageSender.sendGetDouShenWarRank();
        ____654.rankMessageSender.sendGetDouShenWarInfo()
    },
    ____5: function() {
        ____654.____677.____146(this._bg, this._bgPath)
    },
    ____6: function() {
        this.____884.addListener(this, this.boxClickHandler);
        ____655.rankInfo.addEventListener(____655.____661.common_rankDoushenRankUpdate, this.rankUpdateHandler, this);
        ____655.rankInfo.addEventListener(____655.____661.common_rankDoushenInfoUpdate, this.infoUpdateHandler, this)
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankDoushenRankUpdate, this.rankUpdateHandler, this);
        ____655.rankInfo.removeEventListener(____655.____661.common_rankDoushenInfoUpdate, this.infoUpdateHandler, this)
    },
    replaceClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.rankMessageSender.sendGetDouShenWarRank();
            ____654.____674.setKYBtnEnabled(this._replaceBtn, false, 1);
            this._tickCount = 600;
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2256.text5") + " " + (this._tickCount / 60));
            ____654.____678.____298(this.tick, this)
        }
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            ____654.____674.setKYBtnEnabled(this._replaceBtn, true, 1);
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2256.text5"));
            ____654.____678.____299(this.tick, this)
        } else if (this._tickCount % 60 == 0) {
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2256.text5") + " " + (this._tickCount / 60))
        }
    },
    boxClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.____884) {
                var title = ____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text2");
                var lists = ____655.allTemplates.rankAwardTemplateList.getTypeList(10);
                var xianWei = ____655.____667.xianwei;
                var list = [];
                for (var i = 0; i < lists.length; i++) {
                    if (lists[i].stage == xianWei) {
                        list.push(lists[i])
                    }
                }
                if (sender == this.____884) {
                    this._controller.showAwardZhanChangPanel(10, title, list, this.acceptHandler, this)
                }
            }
        }
    },
    acceptHandler: function() {
        this._controller.warMessageSender.sendDoushenAward();
        ____655.rankInfo.doushenAwardState = 0
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var info = sender.____238();
            this.clickInfo(info)
        }
    },
    topClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (____655.rankInfo.doushenSelfRank > 50) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2256.text4", 50));
                return
            }
            var index = this._details.indexOf(sender);
            if (index > -1) {
                var info = ____655.rankInfo.doushenTopList[index + 1];
                this.clickInfo(info)
            }
        }
    },
    clickInfo: function(info) {
        var this_ = this;

        function fightHandler() {
            if (info != null && info.playerInfo != null) {
                this_._controller.warMessageSender.sendDoushenFight(info.playerInfo.userId, info.rank)
            }
            ____654.____676.uiPanelContainer.close()
        }

        function addTime() {
            if (____655.____667.moneyInfo.money1Enough(this.COST)) {
                fightHandler()
            } else {
                ____655.____667.moneyInfo.showNotEnoughTip(1)
            }
        }
        if (info != null && info.playerInfo != null) {
            if (info.playerInfo.userId == ____655.____667.userId) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2256.text1"))
            } else if (____655.rankInfo.doushenCount <= 0) {
                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2256.text2", this.COST) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.DOUSHENADDTIME, 0, this, addTime, null, null)
            } else {
                ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2256.text3", info.playerInfo.nick) + info.playerInfo.combat, ____654.noAlertUtils.DOUSHENFIGHT, 0, this, fightHandler, null, null)
            }
        } else {
            print("ERROR:____2256 ItemClick", info)
        }
    },
    clearItems: function() {
        if (this.____1288 != null) {
            for (var i = 0; i < this.____1288.length; i++) {
                this.____1288[i].dispose()
            }
            this.____1288 = []
        }
    },
    clearCharacters: function() {
        if (this._characters != null) {
            for (var i = 0; i < this._characters.length; i++) {
                if (this._characters[i] != null) {
                    this._characters[i].dispose()
                }
            }
            this._characters = []
        }
    },
    rankUpdateHandler: function(evt) {
        this.clearItems();
        this.clearCharacters();
        var list = ____655.rankInfo.doushenRanks;
        for (var i = 0; i < list.length; i++) {
            var item = this.____1288[i];
            if (item == null) {
                item = new DoushendianItem();
                this.____1625.addChild(item);
                this.____1288.push(item);
                item.setPosition(____654.____673.____159(i * 135, 0));
                item.addListener(this, this.itemClickHandler)
            }
            item.____18(list[i])
        }
        for (var i = 0; i < this._details.length; i++) {
            var info = ____655.rankInfo.doushenTopList[i + 1];
            var view = this._details[i];
            if (info != null) {
                this.getChildByName("nameLabel" + (i + 1)).setString(info.playerInfo.nick);
                this.getChildByName("fight_num" + (i + 1)).setString(info.playerInfo.combat);
                var character = this._characters[i];
                if (character != null) {
                    character.dispose()
                }
                character = new ____545(info.playerInfo.characterInfo, null, null);
                character.init(____655.____659.____686.rightBottom, this.getChildByName("characterLayer" + (i + 1)));
                this._characters[i] = character
            }
        }
    },
    infoUpdateHandler: function(evt) {
        var c = ____655.rankInfo.doushenCount;
        if (c < 0) c = 0;
        else if (c > 5) c = 5;
        for (var i = 0; i < c; i++) {
            this._timeList[i].setVisible(true)
        }
        for (var i = c; i < 5; i++) {
            this._timeList[i].setVisible(false)
        }
        if (____655.rankInfo.doushenCount <= 0) {
            var dt = ____655.rankInfo.doushenCD - ____655.____662.getSystemTimeSec();
            if (dt > 0) {
                this._countDownLabel.setVisible(true);
                if (this._countDownUtils == null) {
                    this._countDownUtils = new ____2111();
                    this._countDownUtils.setLabel(this._countDownLabel, 0, 0, "DoushenDianPanel.text1")
                }
                this._countDownUtils.start(dt, null, null)
            }
        } else {
            this._countDownLabel.setVisible(false)
        }
        this._familyLabel.setString(____655.rankInfo.doushenSelfRank > 1000 ? "1000+" : ____655.rankInfo.doushenSelfRank);
        var doushenAwardState = ____655.rankInfo.doushenAwardState;
        if (doushenAwardState == 1) {
            if (this.____1126 == null) {
                this.____1126 = new RotationEffect("effect/effect_10.png", 5);
                this.____1126.move(695, 54);
                this.addChild(this.____1126, 2)
            }
        } else {
            if (this.____1126 != null) {
                this.____1126.dispose();
                this.____1126 = null
            }
        }
    },
    dispose: function() {
        if (this._bgPath != "" && this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg)
        }
        this.____17();
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._bg = null;
        this._bgPath = null;
        this.____892 = null;
        this.____1625 = null;
        this._replaceBtn = null;
        this._timeList = null;
        this._familyLabel = null;
        this.____884 = null;
        this.clearItems();
        this.clearCharacters();
        this._details = null;
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._countDownLabel = null;
        this._super()
    },
});
var ____2257 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    ____1480: null,
    ____892: null,
    scrollView: null,
    _detail: null,
    familyLabel: null,
    jifenLabel: null,
    ____911: 0,
    _characters: null,
    _tileContainer: null,
    ____884: null,
    ____1101: null,
    ____1126: null,
    ctor: function(controller) {
        this._super("familyFightPanel.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("ImageView_953123");
        this._bgPath = ____654.____675.____139("outPic/ui_fightPlaceBg1.png");
        this.____1480 = this.getChildByName("OKBtn");
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.familyLabel = this.getChildByName("familyLabel");
        this.jifenLabel = this.getChildByName("jifenLabel");
        this.____1480.addListener(this, this.okClickHandler);
        this.____892 = this.getChildByName("btnLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text1"));
        this.getChildByName("tips_label").setString(____654.yuyanbaoManager.getYuyanbao("____2257.text3"));
        this.signUpdateHandler(null);
        this.____884 = this.getChildByName("boxIcon");
        this.____5();
        this.____6();
        this._detail = [];
        for (var i = 1; i <= 3; i++) {
            this._detail.push(this.getChildByName("detail_" + i))
        }
        this.getChildByName("Name").setString(____654.yuyanbaoManager.getYuyanbao("____2257.text5"));
        this.getChildByName("num").setString(____654.yuyanbaoManager.getYuyanbao("____2257.text6"));
        this.getChildByName("shili").setString(____654.yuyanbaoManager.getYuyanbao("____2257.text7"));
        this.getChildByName("totalScore").setString(____654.yuyanbaoManager.getYuyanbao("____2257.text8"));
        this.____1101 = this.getChildByName("desLabel");
        this.____1101.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text13"));
        this._characters = [];
        ____654.rankMessageSender.sendGetJiazuWarRank();
        this._controller.warMessageSender.sendJiazuSignNum()
    },
    ____5: function() {
        ____654.____677.____146(this._bg, this._bgPath)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var title = ____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text4");
            var list = ____655.allTemplates.rankAwardTemplateList.getTypeList(12);
            if (sender == this.____884) {
                this._controller.showAwardZhanChangPanel(12, title, list)
            }
        }
    },
    ____6: function() {
        this.____884.addListener(this, this.____16);
        ____655.warDatas.jiazuWarInfo.addEventListener(____655.____661.war_jiazu_signUpdate, this.signUpdateHandler, this);
        ____655.rankInfo.addEventListener(____655.____661.common_rankJiazuWarUpdate, this.setRankInfo, this)
    },
    ____17: function() {
        ____655.warDatas.jiazuWarInfo.removeEventListener(____655.____661.war_jiazu_signUpdate, this.signUpdateHandler, this);
        ____655.rankInfo.removeEventListener(____655.____661.common_rankJiazuWarUpdate, this.setRankInfo, this)
    },
    clearCharacters: function() {
        for (var i = 0; i < this._characters.length; i++) {
            if (this._characters[i] != null) {
                this._characters[i].dispose()
            }
        }
        this._characters = []
    },
    setRankInfo: function() {
        var rankListInfo = ____655.rankInfo.jiazuWarRanks;
        var c = rankListInfo.length;
        if (c <= 0) {
            c = 0;
            this.____1101.setVisible(true)
        } else if (c > 3) {
            c = 3;
            this.____1101.setVisible(false)
        } else {
            this.____1101.setVisible(false)
        }
        this.clearCharacters();
        for (var i = 0; i < c; i++) {
            var info = rankListInfo[i];
            var view = this._detail[i];
            if (info != null) {
                this.getChildByName("leader" + (i + 1)).setString(____654.yuyanbaoManager.getYuyanbao("____2257.text9") + info.playerNick);
                this.getChildByName("nameLabel" + (i + 1)).setString(info.clubName);
                if (info.playerInfo != null) {
                    var character = new ____545(info.playerInfo.characterInfo, null, null);
                    character.init(____655.____659.____686.rightBottom, this.getChildByName("characterLayer" + (i + 1)));
                    this._characters[i] = character
                }
            }
        }
        for (var i = c; i < 3; i++) {
            this.getChildByName("leader" + (i + 1)).setString("");
            this.getChildByName("nameLabel" + (i + 1)).setString(____654.yuyanbaoManager.getYuyanbao("____2257.text4"))
        }
        this._tileContainer.clearAllItems();
        this._tileContainer.setFormat(1, rankListInfo.length, ____654.____673.____160(590, 28), 0, 3, true);
        if (____655.rankInfo.jiazuWarSelfRank > 100) {
            this.familyLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text14"))
        } else {
            this.familyLabel.setString(____655.rankInfo.jiazuWarSelfRank)
        }
        this.jifenLabel.setString(____655.rankInfo.jiazuWarSelfScore)
    },
    getIdByIndex: function(index) {
        return ____655.rankInfo.jiazuWarRanks[index].rank
    },
    getItemByIndex: function(index) {
        var item = new FamilyFightRankItem(____655.rankInfo.jiazuWarRanks[index]);
        return item
    },
    signUpdateHandler: function(evt) {
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        if (____655.____667.clubId == 0) {
            this.____911 = 0;
            return
        }
        if (____655.warDatas.jiazuWarInfo.hasSign) {
            this.____911 = 1;
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text1"))
        } else {
            if (____655.____667.clubJob > 0 && !this.isBegin()) {
                this.____911 = 2;
                this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text10"));
                this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(71, 28), this.____1480);
                this.____1126.setScaleX(1.23)
            } else {
                this.____911 = 3;
                this.____892.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text1"))
            }
        }
    },
    isBegin: function() {
        var timingInfo1 = ____654.copyTester.getActivityInfo(____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID);
        if (timingInfo1 == null) {
            return true
        }
        var day = ____655.____662.getClientDate().getDay();
        if (day == 0) {
            day = 7
        }
        if (timingInfo1.day.indexOf(day) == -1) {
            return false
        }
        var passTime = ____655.____662.getZeroPassTime();
        if (passTime < timingInfo1.startTime || passTime > timingInfo1.endTime + 300) {
            return false
        }
        return true
    },
    okClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this.____911 == 0) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2257.text11"))
            } else if (this.____911 == 1) {
                ____654.copyTester.enterCopy(____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID, 0)
            } else if (this.____911 == 2) {
                this._controller.warMessageSender.sendJiazuSign()
            } else if (this.____911 == 3) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2257.text12"))
            }
        }
    },
    dispose: function() {
        this.____17();
        this.clearCharacters();
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bg = null;
        this._bgPath = null;
        this.____1480 = null;
        this.____892 = null;
        this.scrollView = null;
        this._detail = null;
        this.familyLabel = null;
        this.jifenLabel = null;
        this.____911 = 0, this._controller = null;
        if (this._tileContainer != null) {
            this._tileContainer.dispose();
            this._tileContainer = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this.____1101 = null;
        this.____884 = null;
        this._super()
    },
});
var FamilyFightRankItem = KYNode.extend({
    rankLabel: null,
    name_label: null,
    personNum_label: null,
    fight_label: null,
    totale_score_label: null,
    rankIcon: null,
    ctor: function(info) {
        this._super("familyFightRankItem.ExportJson");
        this.rankLabel = this.getChildByName("rank_label");
        this.rankIcon = this.getChildByName("rankIcon");
        this.rankIcon.setVisible(false);
        this.name_label = this.getChildByName("name_label");
        this.personNum_label = this.getChildByName("personNum_label");
        this.fight_label = this.getChildByName("fight_label");
        this.totale_score_label = this.getChildByName("totale_score_label");
        this.info = info;
        if (this.info.rank == 1) {
            this.rankIcon.setFrame("flag/ui_rankNo1.png");
            this.rankIcon.setVisible(true);
            this.rankLabel.setVisible(false)
        } else if (this.info.rank == 2) {
            this.rankIcon.setFrame("flag/ui_rankNo2.png");
            this.rankIcon.setVisible(true);
            this.rankLabel.setVisible(false)
        } else if (this.info.rank == 3) {
            this.rankIcon.setFrame("flag/ui_rankNo3.png");
            this.rankIcon.setVisible(true);
            this.rankLabel.setVisible(false)
        } else {
            this.rankLabel.setString(this.info.rank);
            this.rankLabel.setVisible(true);
            this.rankIcon.setVisible(false)
        }
        this.name_label.setString(this.info.clubName);
        this.personNum_label.setString(this.info.playerNum);
        this.fight_label.setString(this.info.fight);
        this.totale_score_label.setString(this.info.score)
    },
    dispose: function() {
        this.rankLabel = null;
        this.name_label = null;
        this.personNum_label = null;
        this.fight_label = null;
        this.totale_score_label = null;
        this.rankIcon = null;
        this._super()
    },
});
var ____2259 = KYPanel.extend({
    _controller: null,
    ____1738: null,
    ____1740: null,
    ____1737: null,
    ____1054: null,
    _panelList: null,
    _moneyView: null,
    ____1776: null,
    ctor: function(controller, index) {
        this._super("fightPlaceBasePanel.ExportJson");
        this._controller = controller;
        this.____1740 = this.getChildByName("tabLayer");
        this._moneyView = new ____2237(2);
        this.getChildByName("moneyLayer").addChild(this._moneyView);
        this.____1776 = this.getChildByName("tipBtn");
        this._panelList = [null, null, null, null, null, null];
        if (index == null) index = 0;
        this.____5(index);
        this.____6();
        this.popUpdate()
    },
    ____5: function(index) {
        this.____1738 = [
            [1, ____654.yuyanbaoManager.getYuyanbao("____2259.text1"), "icon/ui_warIcon1.png", true, 5],
            [2, ____654.yuyanbaoManager.getYuyanbao("____2259.text2"), "icon/ui_warIcon2.png", true, 10],
            [3, ____654.yuyanbaoManager.getYuyanbao("____2259.text3"), "icon/ui_warIcon3.png", true, 15],
            [4, ____654.yuyanbaoManager.getYuyanbao("____2259.text4"), "icon/ui_warIcon4.png", true, 20],
        ];
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(540);
        this.____1740.addChild(this.____1737);
        if (index == null || index == 0) {
            index = 1
        }
        this.____1737.setTabIndex(index - 1)
    },
    setTab: function(tab) {
        if (this.____1054 != null) {
            this.____1054.removeFromParent(false)
        }
        this.____1054 = this.getPanel(tab);
        if (this.____1054 != null && this.____1054.getParent() == null) {
            this.addChild(this.____1054)
        }
    },
    getPanel: function(tab) {
        var panel = this._panelList[tab];
        if (panel == null) {
            if (tab == 1) {
                panel = new ____2256(this._controller)
            } else if (tab == 2) {
                panel = new ____2257(this._controller)
            } else if (tab == 3) {
                panel = new DaluandouPanel(this._controller)
            } else if (tab == 4) {
                panel = new WushenzhengbaPanel(this._controller)
            }
            this._panelList[tab] = panel
        }
        return panel
    },
    ____6: function() {
        this.____1776.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 46) {
            this.____1737.setShowPop(1, ____654.playerInfoTester.doushentanNum > 0)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1776) {
                ____654.tipsManager.showStringTip(____654.____682.____108("10073"), 500)
            }
        }
    },
    changeTabIndexHandler: function(evt) {
        if (this.getParent() != null) {
            var index = evt.data;
            this.____1737.setTabIndex(index)
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1776 = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this.____1740 = null;
        this.____1054 = null;
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        if (this._panelList != null) {
            for (var i = 0; i < this._panelList.length; i++) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        this._super()
    },
});
var WuShenRankItem = KYNode.extend({
    rank_label: null,
    name_label: null,
    xianwei_label: null,
    fight_label: null,
    score_label: null,
    info: null,
    rankIcon: null,
    ctor: function(info) {
        this._super("familyFightRankItem.ExportJson");
        this.info = info;
        this.rank_label = this.getChildByName("rank_label");
        this.name_label = this.getChildByName("name_label");
        this.rankIcon = this.getChildByName("rankIcon");
        this.rankIcon.setVisible(false);
        this.xianwei_label = this.getChildByName("personNum_label");
        this.fight_label = this.getChildByName("fight_label");
        this.score_label = this.getChildByName("totale_score_label");
        if (this.info.rank == 1) {
            this.rankIcon.setFrame("flag/ui_rankNo1.png");
            this.rankIcon.setVisible(true);
            this.rank_label.setVisible(false)
        } else if (this.info.rank == 2) {
            this.rankIcon.setFrame("flag/ui_rankNo2.png");
            this.rankIcon.setVisible(true);
            this.rank_label.setVisible(false)
        } else if (this.info.rank == 3) {
            this.rankIcon.setFrame("flag/ui_rankNo3.png");
            this.rankIcon.setVisible(true);
            this.rank_label.setVisible(false)
        } else {
            this.rank_label.setString(this.info.rank);
            this.rank_label.setVisible(true);
            this.rankIcon.setVisible(false)
        }
        this.rank_label.setString(this.info.rank);
        this.name_label.setString(this.info.playerInfo.nick);
        this.xianwei_label.setString(____655.____659.nameType.getXianweiName(this.info.xianwei));
        this.fight_label.setString(this.info.playerInfo.combat);
        this.score_label.setString(this.info.score)
    },
    dispose: function() {
        this.info = null;
        this.name_label = null;
        this.rank_label = null;
        this.xianwei_label = null;
        this.fight_label = null;
        this.score_label = null;
        this.rankIcon = null;
        this._super()
    },
});
var WushenzhengbaPanel = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _details: null,
    ____1625: null,
    _xianwei_Label: null,
    _person_rank: null,
    _jifenLabel: null,
    ____884: null,
    ____1480: null,
    _tileContainer: null,
    _characters: null,
    _tipsLabel: null,
    ____1094: null,
    ctor: function(controller) {
        this._super("wushenzhengbaPanel.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("ImageView_953123");
        this._bgPath = ____654.____675.____139("outPic/ui_fightPlaceBg1.png");
        this._details = [];
        for (var i = 1; i <= 3; i++) {
            this._details.push(this.getChildByName("detail_" + i))
        }
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._xianwei_Label = this.getChildByName("xianwei_Label");
        this._xianwei_Label.setString(____655.____659.nameType.getSelfXianweiName());
        this._person_rank = this.getChildByName("person_rank");
        this._jifenLabel = this.getChildByName("jifenLabel");
        this.____884 = this.getChildByName("boxIcon");
        this.____1480 = this.getChildByName("OKBtn");
        this.____1480.addListener(this, this.okClickHandler);
        this._tipsLabel = this.getChildByName("tips_label");
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("WushenzhengbaPanel.text1"));
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1094 = this.getChildByName("delLabel");
        this.____1094.setString(____654.yuyanbaoManager.getYuyanbao("____2257.text13"));
        this.getChildByName("OKBtnLabel").setString(____654.yuyanbaoManager.getYuyanbao("WushenzhengbaPanel.text3"));
        ____655.rankInfo.clearWushenRanks();
        ____655.rankInfo.initWushenTimes();
        this.setRankInfo(null);
        ____654.rankMessageSender.sendGetWuShenRank();
        this.____6()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var title = ____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text3");
            var lists = ____655.allTemplates.rankAwardTemplateList.getTypeList(21);
            var xianWei = ____655.____667.xianwei;
            var list = [];
            for (var i = 0; i < lists.length; i++) {
                if (lists[i].stage == xianWei) {
                    list.push(lists[i])
                }
            }
            if (sender == this.____884) {
                this._controller.showAwardZhanChangPanel(21, title, list)
            }
        }
    },
    ____6: function() {
        this.____884.addListener(this, this.____16);
        ____655.rankInfo.addEventListener(____655.____661.common_rankWushenRankUpdate, this.setRankInfo, this)
    },
    ____17: function() {
        ____655.rankInfo.removeEventListener(____655.____661.common_rankWushenRankUpdate, this.setRankInfo, this)
    },
    getItemByIndex: function(index) {
        var item = new WuShenRankItem(____655.rankInfo.wushenRanks[index]);
        return item
    },
    getIdByIndex: function(index) {
        return ____655.rankInfo.wushenRanks[index].rank
    },
    okClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (____655.rankInfo.wushenJoinTimes > 0) {
                this._controller.showWuShenMatchPanel(null)
            } else {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("WushenzhengbaPanel.text2"))
            }
        }
    },
    boxClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {}
    },
    clearCharacters: function() {
        if (this._characters != null) {
            for (var i = 0; i < this._characters.length; i++) {
                if (this._characters[i] != null) {
                    this._characters[i].dispose()
                }
            }
        }
        this._characters = []
    },
    setRankInfo: function(evt) {
        var list = ____655.rankInfo.wushenRanks;
        this._tileContainer.clearAllItems();
        this._tileContainer.setFormat(1, list.length, ____654.____673.____160(590, 28), 0, 3, true);
        this.clearCharacters();
        if (list.length > 0) {
            this.____1094.setVisible(false)
        } else {
            this.____1094.setVisible(true)
        }
        for (var i = 0; i < 3; i++) {
            var info = list[i];
            var view = this._details[i];
            if (info != null) {
                view.getChildByName("nameLabel").setString(info.playerInfo.nick);
                view.getChildByName("fight_num").setString(info.playerInfo.combat);
                view.getChildByName("fight_num").setVisible(true);
                view.getChildByName("fight_name").setVisible(true);
                var character = this._characters[i];
                if (character != null) {
                    character.dispose()
                }
                character = new ____545(info.playerInfo.characterInfo, null, null);
                character.init(____655.____659.____686.rightBottom, view.getChildByName("characterLayer"));
                this._characters[i] = character
            } else {
                view.getChildByName("nameLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2257.text4"));
                view.getChildByName("fight_num").setVisible(false);
                view.getChildByName("fight_name").setVisible(false)
            }
        }
        this._person_rank.setString(____655.rankInfo.wushenSelfRank);
        this._jifenLabel.setString(____655.rankInfo.wushenSelfScore)
    },
    dispose: function() {
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this.____17();
        this.clearCharacters();
        this._controller = null;
        this._bg = null;
        this._bgPath = null;
        this._details = null;
        this.____1625 = null;
        this._xianwei_Label = null;
        this._person_rank = null;
        this._jifenLabel = null;
        this.____884 = null;
        this.____1480 = null;
        if (this._tileContainer != null) {
            this._tileContainer.dispose();
            this._tileContainer = null
        }
        this.____1094 = null;
        this._tipsLabel = null;
        this._super()
    },
});
var FootShowEffect = KYNode.extend({
    ____1241: 0,
    _tickCount: 0,
    _effectId: 0,
    _count: 6,
    ctor: function(star, count) {
        this._super();
        if (count != null) {
            this._count = count
        }
        this._effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Foot, star).figureId);
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 16) {
            this._tickCount = 0;
            this.____1241++;
            var p = ____654.____673.____159(40 * this.____1241, 0);
            var zujiEffect = ____654.effectManager.create(this._effectId, false, p, true);
            zujiEffect.addTo(this);
            zujiEffect.play();
            if (this.____1241 > (this._count - 1)) {
                this.____1241 = 0
            }
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this._super()
    },
});
var ____2260 = KYNode.extend({
    _info: null,
    ____927: null,
    ____1849: null,
    ____1848: null,
    _nameLabel: null,
    ____995: null,
    ____1583: null,
    ____830: null,
    _callBack: null,
    _executor: null,
    ctor: function(info) {
        this._super("sjAddItemView.ExportJson");
        this._info = info;
        this.____927 = this.getChildByName("careerIcon");
        this.____1849 = this.getChildByName("vipImg");
        this.____1848 = this.getChildByName("vipLevelLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____995 = this.getChildByName("combatLabel");
        this.____1583 = this.getChildByName("btn2");
        this.____830 = this.getChildByName("btn1");
        this.getChildByName("btnLabel2").setString(____654.yuyanbaoManager.getYuyanbao("____2260.text1"));
        this.getChildByName("btnLabel1").setString(____654.yuyanbaoManager.getYuyanbao("____2260.text2"));
        this.____5();
        this.____6()
    },
    ____6: function() {
        this.____830.addListener(this, this.____16);
        this.____1583.addListener(this, this.____16)
    },
    ____5: function() {
        if (this._info == null) return;
        this._nameLabel.setString(this._info[1]);
        this.____995.setString(this._info[3]);
        this.____927.setFrame("sceneIcon/PlayerHeadIcon2_" + this._info[5] + ".png");
        if (this._info[2] > 0) {
            this.____1849.setVisible(true);
            this.____1848.setVisible(true);
            this.____1848.setString(this._info[2])
        } else {
            this.____1849.setVisible(false);
            this.____1848.setVisible(false)
        }
    },
    setClickCallBack: function(callBack, executor) {
        this._callBack = callBack;
        this._executor = executor
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._info == null) return;
            if (sender == this.____830) {
                if (this._callBack != null) {
                    this._callBack.call(this._executor, this._info[0], 1)
                }
            } else if (sender == this.____1583) {
                if (this._callBack != null) {
                    this._callBack.call(this._executor, this._info[0], 0)
                }
            }
        }
    },
    dispose: function() {
        this._info = null;
        this.____927 = null;
        this.____1849 = null;
        this.____1848 = null;
        this._nameLabel = null;
        this.____995 = null;
        this.____1583 = null;
        this.____830 = null;
        this._callBack = null;
        this._executor = null;
        this._super()
    },
});
var ____2261 = KYPanel.extend({
    ____1583: null,
    ____830: null,
    ____1286: null,
    _itemList: null,
    _controller: null,
    ____1241: 0,
    _itemCanClick: true,
    ctor: function(controller) {
        this._super("sjAddPanel.ExportJson");
        this._controller = controller;
        this.____1583 = this.getChildByName("btn2");
        this.____830 = this.getChildByName("btn1");
        this.____1286 = this.getChildByName("itemListView");
        this.____1286.setScrollBarEnabled(false);
        this.getChildByName("titleLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2261.text1"));
        this.getChildByName("btnLabel2").setString(____654.yuyanbaoManager.getYuyanbao("____2261.text2"));
        this.getChildByName("btnLabel1").setString(____654.yuyanbaoManager.getYuyanbao("____2261.text3"));
        this._itemList = [];
        this.____6();
        this.____5()
    },
    ____6: function() {
        this.____1583.addListener(this, this.____16);
        this.____830.addListener(this, this.____16);
        ____655.____668.addEventListener(____655.____661.common_friendResponseUpdate, this.updateView, this)
    },
    ____17: function() {
        ____655.____668.removeEventListener(____655.____661.common_friendResponseUpdate, this.updateView, this)
    },
    ____5: function() {
        this._itemCanClick = false;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        var info = ____655.____668.responseList[this.____1241];
        if (info != null && info[6] == false) {
            var item = new ____2260(info);
            this.____1286.pushBackItem(item);
            item.setClickCallBack(this.itemClickHandler, this);
            this._itemList.push(item)
        }
        if (this.____1241 < ____655.____668.responseList.length) {
            this.____1241++
        } else {
            this._itemCanClick = true;
            ____654.____678.____299(this.tick, this)
        }
    },
    itemClickHandler: function(userId, isAdd) {
        if (!this._itemCanClick) return;
        ____654.selfDataMessageSender.sendAcceptFriend(userId, isAdd);
        var index = 0;
        for (var i = 0; i < ____655.____668.responseList.length; i++) {
            if (____655.____668.responseList[i][6] == false) {
                if (____655.____668.responseList[i][0] == userId) {
                    ____655.____668.responseList[i][6] = true;
                    this.____1286.removeItem(index)
                } else {
                    index++
                }
            }
        }
        if (index == 0) {
            this.dispose()
        }
    },
    updateView: function(evt) {
        if (!this._itemCanClick || evt == null) return;
        var info = evt.data;
        if (info != null) {
            var item = new ____2260(info);
            this.____1286.pushBackItem(item);
            item.setClickCallBack(this.itemClickHandler, this);
            this._itemList.push(item)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____830) {
                var list = [];
                for (var i = 0; i < ____655.____668.responseList.length; i++) {
                    if (____655.____668.responseList[i][6] == false) {
                        list.push(____655.____668.responseList[i][0])
                    }
                }
                if (list.length <= 0) return;
                ____654.selfDataMessageSender.sendBatchAddFriend(1, list);
                this.dispose()
            } else if (sender == this.____1583) {
                var list = [];
                for (var i = 0; i < ____655.____668.responseList.length; i++) {
                    if (____655.____668.responseList[i][6] == false) {
                        list.push(____655.____668.responseList[i][0])
                    }
                }
                if (list.length <= 0) return;
                ____654.selfDataMessageSender.sendBatchAddFriend(0, list);
                this.dispose()
            }
        }
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        this.____1583 = null;
        this.____830 = null;
        this.____1286 = null;
        if (this._itemList != null) {
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose()
            }
        }
        this._itemList = null;
        this._controller = null;
        ____655.____668.clearResponseList();
        this._super()
    },
});
var GuideRiderView = KYPanel.extend({
    _controller: null,
    ____857: null,
    _Img: null,
    _ImgPath: null,
    _ImgBg: null,
    ____1783: null,
    ____1126: null,
    _count: 0,
    ____1478: 0,
    _maxY: 0,
    ____1711: null,
    ctor: function(controller) {
        this._super();
        this._controller = controller;
        this.____857 = ____654.____673.newKYImageView();
        this.____857.setFrame("board/ui_blackBoard.png");
        this.____857.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.____857.setScale9Enabled(true);
        this.____857.setCapInsets(____654.____673.____161(4, 4, 1, 1));
        this.____857.setOpacity(180);
        this.____857.setSize(____654.____673.____160(____655.____656, ____655.____657));
        this.____857.setPosition(____654.____673.____159(-____655.____656 * 0.5, -____655.____657 * 0.5));
        this.____857.setTouchEnabled(true);
        this.addChild(this.____857);
        this._Img = ____654.____673.newKYSprite();
        this._ImgPath = ____654.____675.____139("outPic/guideRiderArrow.png");
        ____654.____677.____146(this._Img, this._ImgPath);
        this.addChild(this._Img, 2);
        this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.FINGER_EFFECT, false, ____654.____673.____159(0, -48), this, false, 1);
        this.____1126.setLocalZOrder(5);
        this._ImgBg = ____654.____673.newKYSprite();
        this._ImgBg.setFrame("bar/ui_bar22.png");
        this._ImgBg.setScaleX(1.85);
        this._ImgBg.setScaleY(1.88);
        this._ImgBg.setPositionY(-110);
        this.addChild(this._ImgBg, 1);
        this.____1783 = ____654.____673.newKYLabel(26);
        this.____1783.setString("向上滑动上坐骑");
        this.____1783.setPosition(-5, -107);
        this.addChild(this.____1783, 21);
        this.____1478 = -48;
        this._maxY = 42;
        this.____6();
        ____654.____678.____298(this.tick, this)
    },
    downHandler: function(sender, eventType, pos) {
        this.____1711 = pos
    },
    upHandler: function(sender, eventType, pos) {
        if (this.____1711 == null) {
            return
        }
        var offsetY = pos.y - this.____1711.y;
        if (offsetY > 50) {
            this._controller.hideGuideRiderPanel()
        }
    },
    ____6: function() {
        this.____857.addListener(this, null, this.downHandler, this.upHandler)
    },
    tick: function(delta, count) {
        if (this.____1126) {
            this.____1478 = this.____1478 + delta * 65;
            if (this.____1478 >= this._maxY) {
                this.____1478 = this._maxY - 90
            }
            this.____1126.move(0, this.____1478)
        }
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        this._controller.sceneModule.walkTester.doRider(true, true);
        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkToNpc, ____654.____672, 100117));
        this._controller = null;
        if (this._ImgPath != null) {
            ____654.____677.removeImageQuote(this._Img, this._ImgPath)
        }
        if (this.____857 != null) {
            this.____857.dispose();
            this.____857 = null
        }
        if (this._Img != null) {
            this._Img.dispose();
            this._Img = null
        }
        if (this._ImgBg != null) {
            this._ImgBg.dispose();
            this._ImgBg = null
        }
        if (this.____1783 != null) {
            this.____1783.dispose();
            this.____1783 = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._count = null;
        this.____1478 = null;
        this._maxY = null;
        this.____1711 = null;
        this._super()
    },
});
var ____2262 = cc.Class.extend({
    _controller: null,
    _headBg: null,
    ____1340: null,
    ____862: null,
    ____1221: null,
    _levelLabel: null,
    _nameLabel: null,
    ____1231: null,
    ____1616: null,
    _container: null,
    ____1539: 0,
    ____1540: 0,
    ctor: function(controller, container) {
        this._controller = controller;
        this._container = container;
        this.createView();
        this.____6()
    },
    createView: function() {
        this.____862 = ____654.____673.newKYSprite();
        this.____862.setFrame("sceneIcon/ui_hpBar.png");
        this._headBg = ____654.____673.newKYSprite();
        this._headBg.setFrame("cell/ui_cell5.png");
        this.____1221 = ____654.____673.newKYSprite();
        this.____1221.setFrame(this.getIconPath());
        this.____1340 = ____654.____673.newKYSprite();
        this.____1340.setFrame("sceneIcon/ui_levelBg.png");
        this._levelLabel = new NumberView();
        this._levelLabel.setType(0, null, 0.9);
        ____654.____676.mainMenuContainer.addChild(this._levelLabel, 6);
        this._nameLabel = ____654.____673.newKYLabel(18, true);
        this._nameLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this.createHpBar()
    },
    createHpBar: function() {
        this.____1231 = ____654.____673.newKYProgressBar("bar/ui_bar20.png", 130);
        this.____1231.setColor(____655.____659.____688.bossHpColorList[____655.____659.____688.bossHpColorList.length - 1])
    },
    setToPos: function() {
        if (this.____862 != null) this.____862.setPosition(____654.____673.____159(this.____1539 + 143, this.____1540 + 43));
        if (this._headBg != null) this._headBg.setPosition(____654.____673.____159(this.____1539 + 43, this.____1540 + 43));
        if (this.____1340 != null) this.____1340.setPosition(____654.____673.____159(this.____1539 + 68, this.____1540 + 22));
        if (this.____1221 != null) this.____1221.setPosition(____654.____673.____159(this.____1539 + 42, this.____1540 + 51));
        if (this._levelLabel != null) this._levelLabel.setPosition(this.____1539 + 77, this.____1540 + 22);
        if (this._nameLabel != null) this._nameLabel.setPosition(____654.____673.____159(this.____1539 + 87, this.____1540 + 59));
        if (this.____1231 != null) this.____1231.setPosition(____654.____673.____159(this.____1539 + 83, this.____1540 + 28))
    },
    getIconPath: function() {
        return "sceneIcon/PlayerHeadIcon2_1.png"
    },
    ____363: function(sceneObjInfo) {
        if (this.____1616 == sceneObjInfo) return;
        this.removeSceneObjEvent();
        this.____1616 = sceneObjInfo;
        if (this.____1616 == null) {
            this.hide()
        } else {
            this.addSceneObjEvent();
            this.updateView()
        }
    },
    addSceneObjEvent: function() {
        if (this.____1616 != null) {
            this.____1616.addEventListener(____655.____661.playerInfo_hpUpdate, this.hpUpdateHandler, this)
        }
    },
    removeSceneObjEvent: function() {
        if (this.____1616 != null) {
            this.____1616.removeEventListener(____655.____661.playerInfo_hpUpdate, this.hpUpdateHandler, this)
        }
    },
    updateView: function() {
        if (this.____862 != null && this.____862.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____862, this.getHpBarOrder())
        }
        if (this._headBg != null && this._headBg.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._headBg, 3)
        }
        if (this.____1221 != null && this.____1221.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1221, 4)
        }
        if (this.____1340 != null && this.____1340.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1340, 5)
        }
        if (this.____1231 != null && this.____1231.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1231, this.getHpBarOrder() - 1)
        }
        if (this._levelLabel != null && this._levelLabel.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._levelLabel, 6)
        }
        if (this._nameLabel != null && this._nameLabel.getParent() == null) {
            ____654.____676.____799.addChild(this._nameLabel, 2)
        }
        this.setToPos();
        this.hpUpdateHandler();
        this.addClickZone()
    },
    getHpBarOrder: function() {
        return 2
    },
    hide: function() {
        if (this._headBg != null && this._headBg.getParent() != null) {
            this._headBg.removeFromParent(false)
        }
        if (this.____1340 != null && this.____1340.getParent() != null) {
            this.____1340.removeFromParent(false)
        }
        if (this.____862 != null && this.____862.getParent() != null) {
            this.____862.removeFromParent(false)
        }
        if (this.____1221 != null && this.____1221.getParent() != null) {
            this.____1221.removeFromParent(false)
        }
        if (this._nameLabel != null && this._nameLabel.getParent() != null) {
            this._nameLabel.removeFromParent(false)
        }
        if (this.____1231 != null && this.____1231.getParent() != null) {
            this.____1231.removeFromParent(false)
        }
        if (this._levelLabel != null) {
            this._levelLabel.removeFromParent(false)
        }
        this.removeClickZone()
    },
    addClickZone: function() {},
    removeClickZone: function() {},
    ____6: function() {},
    ____17: function() {},
    move: function(x, y) {
        if (this.____1539 == x && this.____1540 == y) return;
        this.____1539 = x;
        this.____1540 = y;
        this.setToPos()
    },
    headClickHandler: function() {},
    hpUpdateHandler: function() {
        this.____1231.setPercent(Math.floor(this.____1616.____386() / this.____1616.____384() * 100))
    },
    dispose: function() {
        this.removeClickZone();
        this.____17();
        this.removeSceneObjEvent();
        this.____1616 = null;
        this._controller = null;
        if (this._headBg != null) {
            this._headBg.dispose();
            this._headBg = null
        }
        if (this.____1340 != null) {
            this.____1340.dispose();
            this.____1340 = null
        }
        if (this.____862 != null) {
            this.____862.dispose();
            this.____862 = null
        }
        if (this.____1221 != null) {
            this.____1221.dispose();
            this.____1221 = null
        }
        if (this._nameLabel != null) {
            this._nameLabel.dispose();
            this._nameLabel = null
        }
        if (this.____1231 != null) {
            this.____1231.dispose();
            this.____1231 = null
        }
        if (this._levelLabel != null) {
            this._levelLabel.dispose();
            this._levelLabel = null
        }
    },
});
var ____2263 = cc.Class.extend({
    _controller: null,
    _sceneInfo: null,
    ____1645: null,
    ____1424: null,
    ____1521: null,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._sceneInfo = scenePanelController.sceneInfo;
        this.____1645 = new ____2266();
        this.____1645.move(0, ____655.____657 - 100);
        this.____1645.____363(this._sceneInfo.scenePlayerList.selfPlayer);
        this.____1424 = new MonsterHeadView(this._controller);
        this.____1424.move(345, ____655.____657 - 100);
        this.____1521 = new ____2265(this._controller);
        this.____1521.move(345, ____655.____657 - 100);
        this.____6()
    },
    ____6: function() {
        this._sceneInfo.scenePlayerList.addEventListener(____655.____661.sceneInfo_selfInfo, this.setSelfComplete, this);
        this._sceneInfo.addEventListener(____655.____661.sceneInfo_selectChange, this.changeTargetInfo, this)
    },
    ____17: function() {
        this._sceneInfo.scenePlayerList.removeEventListener(____655.____661.sceneInfo_selfInfo, this.setSelfComplete, this);
        this._sceneInfo.removeEventListener(____655.____661.sceneInfo_selectChange, this.changeTargetInfo, this)
    },
    changeTargetInfo: function() {
        var info = this._sceneInfo.getCurrentSelectObjInfo();
        if (info != null && info.____402() == ____655.____659.commonStaticType.soType_monster && info.template.isBoss()) {
            this.____1424.____363(info);
            this.____1521.____363(null)
        } else if (info != null && info.____402() == ____655.____659.commonStaticType.soType_player) {
            this.____1424.____363(null);
            this.____1521.____363(info)
        } else {
            this.____1424.____363(null);
            this.____1521.____363(null)
        }
    },
    addMonsterHeadView: function() {},
    addPlayerHeadView: function() {},
    setSelfComplete: function(evt) {
        this.____1645.____363(this._sceneInfo.scenePlayerList.selfPlayer)
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._sceneInfo = null;
        if (this.____1645 != null) {
            this.____1645.dispose()
        }
        this.____1645 = null;
        if (this.____1424 != null) {
            this.____1424.dispose()
        }
        this.____1424 = null;
        if (this.____1521 != null) {
            this.____1521.dispose()
        }
        this.____1521 = null
    },
});
var MonsterHeadView = ____2262.extend({
    ____1232: null,
    _numLabel: null,
    ctor: function(controller, container) {
        this._super(controller, container)
    },
    createView: function() {
        this._super();
        this._numLabel = new NumberView();
        this._numLabel.setType(0, null, 0.9);
        ____654.____676.mainMenuContainer.addChild(this._numLabel)
    },
    createHpBar: function() {
        this._super();
        this.____1232 = ____654.____673.newKYProgressBar("bar/ui_bar20.png", 130)
    },
    setToPos: function() {
        this._super();
        if (this.____1221 != null) this.____1221.setPosition(____654.____673.____159(this.____1539 + 42, this.____1540 + 43));
        if (this._numLabel != null) this._numLabel.setPosition(this.____1539 + 200, this.____1540 + 58);
        if (this.____1232 != null) this.____1232.setPosition(____654.____673.____159(this.____1539 + 83, this.____1540 + 28))
    },
    updateView: function() {
        this._super();
        if (this._numLabel != null && this._numLabel.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._numLabel)
        }
        if (this.____1232 != null && this.____1232.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1232, 0)
        }
        this.levelUpdateHandler();
        this.nameUpdateHandler()
    },
    hide: function() {
        this._super();
        if (this._numLabel != null) {
            this._numLabel.removeFromParent(false)
        }
        if (this.____1232 != null && this.____1232.getParent() != null) {
            this.____1232.removeFromParent(false)
        }
    },
    getIconPath: function() {
        return "sceneIcon/BossHeadIcon.png"
    },
    levelUpdateHandler: function() {
        this._levelLabel.setString(this.____1616.template.level)
    },
    nameUpdateHandler: function() {
        this._nameLabel.setString(this.____1616.template.name)
    },
    hpUpdateHandler: function() {
        var hpBarCount = ____655.allTemplates.monsterTemplateList.getMonsterHpBarCount(this.____1616.____384());
        var oneBarPre = 100 / hpBarCount;
        var pre = this.____1616.____386() / this.____1616.____384() * 100;
        var curHasCount = Math.min(Math.ceil(pre / oneBarPre), hpBarCount);
        var colorIndex = (hpBarCount - curHasCount) % ____655.____659.____688.bossHpColorList.length;
        var nextColorIndex = (colorIndex + 1) % ____655.____659.____688.bossHpColorList.length;
        if (curHasCount > 1) {
            this.____1232.setColor(____655.____659.____688.bossHpColorList[nextColorIndex]);
            this.____1232.setPercent(100)
        } else {
            this.____1232.setPercent(0)
        }
        this.____1231.setColor(____655.____659.____688.bossHpColorList[colorIndex]);
        var showPre = pre;
        for (var i = 1; i <= hpBarCount; i++) {
            if (showPre > oneBarPre) {
                showPre = showPre - oneBarPre
            } else {
                break
            }
        }
        this.____1231.setPercent(showPre * hpBarCount);
        this._numLabel.setString("X" + curHasCount)
    },
    dispose: function() {
        if (this.____1232 != null) {}
        if (this._numLabel != null) {
            this._numLabel.dispose();
            this._numLabel = null
        }
        this._super()
    },
});
var ____2265 = ____2262.extend({
    ctor: function(controller, container) {
        this._super(controller, container)
    },
    createView: function() {
        this._super();
        this._nameLabel.setAnchorPoint(____654.____673.anchorPoints[0]);
        this._nameLabel.setColor(____655.____659.____688.yellow);
        this.____862.setFrame("sceneIcon/ui_playerHpBg.png")
    },
    createHpBar: function() {
        this.____1231 = ccui.LoadingBar.create();
        this.____1231.loadTexture("sceneIcon/ui_playerHpBar.png", 1);
        this.____1231.retain();
        this.____1231.setRotation(270)
    },
    addSceneObjEvent: function() {
        this._super();
        if (this.____1616 != null && this.____1616.figureInfo != null) {
            this.____1616.figureInfo.addEventListener(____655.____661.____703, this.levelUpdateHandler, this)
        }
    },
    removeSceneObjEvent: function() {
        this._super();
        if (this.____1616 != null && this.____1616.figureInfo != null) {
            this.____1616.figureInfo.removeEventListener(____655.____661.____703, this.levelUpdateHandler, this)
        }
    },
    headClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this.____1616 != null && this.____1616.figureInfo != null) {
                ____654.tipsManager.showPlayerMenuTip(1, this.____1616.figureInfo, sender.getTouchEndPosition())
            }
        }
    },
    updateView: function() {
        this._super();
        this.setHeadIcon();
        this.levelUpdateHandler();
        this.nameUpdateHandler()
    },
    addClickZone: function() {
        var this_ = this;

        function doClick() {
            if (this_.____1616 != null && this_.____1616.figureInfo != null) {
                ____654.tipsManager.showPlayerMenuTip(1, this_.____1616.figureInfo, ____654.____673.____159(422, ____655.____657 - 55))
            }
        };
        ____654.setClickZone(2, 387, ____655.____657 - 55, 100, 100, doClick)
    },
    removeClickZone: function() {
        ____654.clearClickZone(2)
    },
    setHeadIcon: function() {
        var frameName = "sceneIcon/PlayerHeadIcon2_" + this.____1616.getCareer() + ".png";
        if (this.____1221 != null) {
            this.____1221.setFrame(frameName)
        }
    },
    setToPos: function() {
        if (this.____862 != null) this.____862.setPosition(____654.____673.____159(this.____1539, this.____1540 + 48));
        if (this._nameLabel != null) this._nameLabel.setPosition(____654.____673.____159(this.____1539 + 45, this.____1540 - 10));
        if (this.____1231 != null) this.____1231.setPosition(____654.____673.____159(this.____1539 - 2, this.____1540 + 49));
        if (this._headBg != null) this._headBg.setPosition(____654.____673.____159(this.____1539 + 43, this.____1540 + 43));
        if (this.____1340 != null) this.____1340.setPosition(____654.____673.____159(this.____1539 + 68, this.____1540 + 22));
        if (this.____1221 != null) this.____1221.setPosition(____654.____673.____159(this.____1539 + 42, this.____1540 + 51));
        if (this._levelLabel != null) this._levelLabel.setPosition(this.____1539 + 77, this.____1540 + 22)
    },
    getHpBarOrder: function() {
        return 7
    },
    levelUpdateHandler: function() {
        if (this.____1616.figureInfo == null) {
            return
        }
        this._levelLabel.setString(this.____1616.figureInfo.level)
    },
    nameUpdateHandler: function() {
        if (this.____1616.figureInfo == null) {
            return
        }
        this._nameLabel.setString(this.____1616.figureInfo.nick)
    },
    hpUpdateHandler: function() {
        if (this.____1231 != null) {
            if (this.____1616.____384() == 0) {
                print("+++++++++++++最大生命值为0！+++++++++++++");
                return
            }
            this.____1231.setPercent(Math.floor(this.____1616.____386() / this.____1616.____384() * 100))
        }
    },
    dispose: function() {
        ____654.clearClickZone(2);
        this._super()
    },
});
var ____2266 = ____2265.extend({
    _money1Icon: null,
    _money2Icon: null,
    ____1416: null,
    ____1417: null,
    ____1157: null,
    _addNumberUtils: null,
    ____1533: null,
    ctor: function(controller, container) {
        this._super(controller, container)
    },
    createView: function() {
        this._super();
        this.____862.setFrame("sceneIcon/ui_selfHeadBg.png");
        this.____862.setAnchorPoint(____654.____673.anchorPoints[6]);
        if (this._headBg != null) {
            this._headBg.dispose();
            this._headBg = null
        }
        this.____1340.setFrame("sceneIcon/ui_selfLevelBg.png");
        this._money1Icon = ____654.____673.newKYSprite();
        this._money1Icon.setFrame("icon/ui_moneyIcon1.png");
        this._money1Icon.setScale(0.8);
        this._money2Icon = ____654.____673.newKYSprite();
        this._money2Icon.setFrame("icon/ui_moneyIcon10.png");
        this._money2Icon.setScale(0.8);
        this.____1416 = new NumberView();
        this.____1416.setType(0, null, 0.9);
        this.____1416.setAnchorPoint(____654.____673.anchorPoints[4]);
        ____654.____676.mainMenuContainer.addChild(this.____1416, 6);
        this.____1417 = new NumberView();
        this.____1417.setType(0, null, 0.9);
        this.____1417.setAnchorPoint(____654.____673.anchorPoints[4]);
        ____654.____676.mainMenuContainer.addChild(this.____1417, 6);
        this.____1157 = new NumberView();
        this.____1157.setType(2, null, 0.9);
        ____654.____676.mainMenuContainer.addChild(this.____1157, 6);
        this._addNumberUtils = new AddNumberUtils(this.____1157, ____655.____667.combat);
        if (this._nameLabel != null && this._nameLabel.getParent() != null) {
            this._nameLabel.removeFromParent(false)
        }
    },
    setShowPop: function(value) {
        if (value) {
            if (this.____1533 == null) {
                this.____1533 = ____654.____673.newKYSprite();
                this.____1533.setFrame("icon/ui_numTipIcon.png");
                ____654.____676.mainMenuContainer.addChild(this.____1533, 10);
                this.____1533.setPosition(____654.____673.____159(this.____1539 + 93, this.____1540 + 89))
            }
        } else {
            if (this.____1533 != null) {
                this.____1533.dispose();
                this.____1533 = null
            }
        }
    },
    createHpBar: function() {
        this.____1231 = ____654.____673.newKYProgressBar("bar/ui_bar8.png", 130)
    },
    updateView: function() {
        this._super();
        if (this._money1Icon != null && this._money1Icon.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._money1Icon, 5)
        }
        if (this._money2Icon != null && this._money2Icon.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._money2Icon, 5)
        }
        if (this.____1416 != null && this.____1416.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1416, 6)
        }
        if (this.____1417 != null && this.____1417.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1417, 6)
        }
        if (this.____1157 != null && this.____1157.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1157, 6)
        }
        this.moneyUpdateHandler();
        this.fightUpdateHandler()
    },
    getHpBarOrder: function() {
        return 2
    },
    hide: function() {
        this._super();
        if (this._money1Icon != null && this._money1Icon.getParent() != null) {
            this._money1Icon.removeFromParent(false)
        }
        if (this._money2Icon != null && this._money2Icon.getParent() != null) {
            this._money2Icon.removeFromParent(false)
        }
        if (this.____1416 != null) {
            this.____1416.removeFromParent(false)
        }
        if (this.____1417 != null) {
            this.____1417.removeFromParent(false)
        }
        if (this.____1157 != null) {
            this.____1157.removeFromParent(false)
        }
    },
    addClickZone: function() {
        function doClick() {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_headClick, ____654.____672, null))
        };
        ____654.setClickZone(1, 120, ____655.____657 - 50, 240, 100, doClick)
    },
    removeClickZone: function() {
        ____654.clearClickZone(1)
    },
    setHeadIcon: function() {
        if (this.____1221 != null) {
            this.____1221.setFrame("sceneIcon/PlayerHeadIcon" + this.____1616.getCareer() + ".png")
        }
    },
    setToPos: function() {
        if (this.____862 != null) this.____862.setPosition(____654.____673.____159(this.____1539 + 2, this.____1540));
        if (this.____1340 != null) this.____1340.setPosition(____654.____673.____159(this.____1539 + 63, this.____1540 + 11));
        if (this.____1221 != null) this.____1221.setPosition(____654.____673.____159(this.____1539 + 32, this.____1540 + 61));
        if (this._money1Icon != null) this._money1Icon.setPosition(this.____1539 + 126, this.____1540 + 72);
        if (this._money2Icon != null) this._money2Icon.setPosition(this.____1539 + 222, this.____1540 + 71);
        if (this._levelLabel != null) this._levelLabel.setPosition(this.____1539 + 63, this.____1540 + 10);
        if (this.____1416 != null) this.____1416.setPosition(this.____1539 + 147, this.____1540 + 71);
        if (this.____1417 != null) this.____1417.setPosition(this.____1539 + 240, this.____1540 + 71);
        if (this.____1157 != null) this.____1157.setPosition(this.____1539 + 174, this.____1540 + 17);
        if (this.____1231 != null) this.____1231.setPosition(____654.____673.____159(this.____1539 + 102, this.____1540 + 45))
    },
    ____6: function() {
        this._super();
        ____655.____667.moneyInfo.addEventListener(____655.____661.____701, this.moneyUpdateHandler, this);
        ____655.____667.addEventListener(____655.____661.playerInfo_combatUpdate, this.fightUpdateHandler, this)
    },
    ____17: function() {
        this._super();
        ____655.____667.moneyInfo.removeEventListener(____655.____661.____701, this.moneyUpdateHandler, this);
        ____655.____667.removeEventListener(____655.____661.playerInfo_combatUpdate, this.fightUpdateHandler, this)
    },
    moneyUpdateHandler: function(evt) {
        this.____1416.setString(____655.____667.moneyInfo.list[0]);
        this.____1417.setString(____655.____667.moneyInfo.list[1])
    },
    fightUpdateHandler: function(evt) {
        this._addNumberUtils.setValue(____655.____667.combat)
    },
    nameUpdateHandler: function() {},
    dispose: function() {
        if (this.____1416 != null) {
            this.____1416.dispose();
            this.____1416 = null
        }
        if (this.____1417 != null) {
            this.____1417.dispose();
            this.____1417 = null
        }
        if (this.____1157 != null) {
            this.____1157.dispose();
            this.____1157 = null
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        if (this._money1Icon != null) {
            this._money1Icon.dispose();
            this._money1Icon = null
        }
        if (this._money2Icon != null) {
            this._money2Icon.dispose();
            this._money2Icon = null
        }
        this.setShowPop(false);
        this._super()
    },
});
var LianZhanView = KYNode.extend({
    _zhanImg: null,
    ____1837: -1,
    _label: null,
    ____18: function(value) {
        if (this.____1837 == value) return;
        this.____1837 = value;
        if (this._zhanImg == null) {
            this._zhanImg = ____654.____673.newKYSprite();
            this._zhanImg.setFrame("flag/ui_zhanFlag.png");
            this.addChild(this._zhanImg)
        }
        if (this._label == null) {
            this._label = new NumberView();
            this._label.setType(8);
            this.addChild(this._label)
        }
        this._label.setNumber(Math.abs(this.____1837));
        this._label.setPosition(____654.____673.____159(-this._label.getTotalWidth() * 0.5 - 25, 0))
    },
    clearLabel: function() {
        if (this._label != null) {
            this._label.dispose();
            this._label = null
        }
    },
    dispose: function() {
        this.clearLabel();
        if (this._zhanImg != null) {
            this._zhanImg.dispose();
            this._zhanImg = null
        }
        this._super()
    },
});
var LuckyTreasureAwardView = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____1495: null,
    ____892: null,
    _itemList: null,
    _gridList: null,
    _tickCount: 0,
    ____1626: 5,
    ctor: function(scenePanelController, itemList) {
        this._super("luckyAwardShowPanel.ExportJson");
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1495 = this.getChildByName("outBtn");
        this.____892 = this.getChildByName("titleLabel");
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips6", this.____1626));
        this._itemList = [];
        this._gridList = [];
        for (var i = 0; i < 10; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            this._itemList[i].addChild(grid);
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(itemList[i][0]);
            grid.setItemTemplateInfo(itemTemplateInfo);
            grid.setCount(itemList[i][1]);
            this._gridList.push(grid)
        }
        ____654.____678.____298(this.tick, this);
        this.____6()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn || sender == this.____1495) {
                this._controller.hideLuckyTreasureAwardPanel()
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1495.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.____698, this.reconnectHandler, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.reconnectHandler, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.____698, this.reconnectHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.reconnectHandler, this)
    },
    reconnectHandler: function() {
        this._controller.hideLuckyTreasureAwardPanel()
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tickCount = 0;
            this.____1626 = this.____1626 - 1;
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips6", this.____1626));
            if (this.____1626 <= 0) {
                ____654.____678.____299(this.tick, this);
                this._controller.hideLuckyTreasureAwardPanel()
            }
        }
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._closeBtn = null;
        this.____1495 = null;
        this.____892 = null;
        this._itemList = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        this._tickCount = null;
        this.____1626 = null;
        this._super()
    },
});
var LuckyTreasurePanel = KYPanel.extend({
    _closeBtn: null,
    _timeLabel: null,
    _countDownUtils: null,
    _remainLabel: null,
    _roundLabel: null,
    ____857: null,
    _backGroundPath: null,
    _itemList: null,
    _gridList: null,
    _selectIcon1: null,
    _selectIcon2: null,
    _numsLabel: null,
    _hasLabel: null,
    ____1021: null,
    _comNumsList: null,
    _awardItemList: null,
    _awardGridList: null,
    _okBtn10: null,
    _numsLabel10: null,
    _desLabel10: null,
    _okBtn1: null,
    _numsLabel1: null,
    ____1102: null,
    _aroundFlag: 0,
    ____1756: null,
    ____1219: 0,
    _luckyTotalNum: 0,
    _getFlagList: null,
    _tickCount: 0,
    _currentSelectIndex: 0,
    _transResult: -1,
    _effectList: null,
    _flagList: null,
    _controller: null,
    _gridIndexList: null,
    _titleLabel: null,
    ____1711: null,
    text: null,
    ____1419: null,
    ctor: function(controller, aroundFlag) {
        this._super("luckyTreasurePanel.ExportJson");
        ____655.isShowGetTip = false;
        this._controller = controller;
        this.modeValue = 180;
        this._closeBtn = this.getChildByName("closeBtn");
        this._timeLabel = this.getChildByName("TimesLabel");
        this._timeLabel.setString("00:00:00");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        this._remainLabel = this.getChildByName("remainLabel");
        this._remainLabel.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text1"));
        this._roundLabel = this.getChildByName("roundLabel");
        this.____857 = this.getChildByName("backGround");
        this._backGroundPath = ____654.____675.____139("outPic/luckyTreasureBg.png");
        ____654.____677.____146(this.____857, this._backGroundPath);
        this._effectList = [];
        this._itemList = [];
        this._gridList = [];
        this._flagList = [false, false, false, false];
        this._gridIndexList = [];
        for (var i = 0; i < 10; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            this._itemList[i].addChild(grid);
            this._gridList.push(grid);
            this._gridIndexList[i] = i
        }
        this._selectIcon1 = this.getChildByName("selectIcon1");
        this._selectIcon2 = this.getChildByName("selectIcon2");
        this._selectIcon1.setVisible(false);
        this._selectIcon2.setVisible(false);
        this._numsLabel = this.getChildByName("numsLabel");
        this._hasLabel = this.getChildByName("hasLabel");
        this.____1021 = this.getChildByName("countBar");
        this._comNumsList = [];
        this._awardItemList = [];
        this._awardGridList = [];
        this._getFlagList = [];
        for (var i = 0; i < 4; i++) {
            this._comNumsList.push(this.getChildByName("comNumsLabel" + (i + 1)));
            this._getFlagList.push(this.getChildByName("hasGetFlag" + (i + 1)));
            this._getFlagList[i].setVisible(false);
            this._awardItemList.push(this.getChildByName("awardCell" + (i + 1)));
            var grid = new ____2129(null, null, null, null, false);
            this._awardItemList[i].addChild(grid);
            this._awardGridList.push(grid)
        }
        this._okBtn10 = this.getChildByName("okBtn10");
        this._numsLabel10 = this.getChildByName("nums2");
        this._numsLabel10.setString(" x9");
        this._desLabel10 = this.getChildByName("desLabel2");
        this._desLabel10.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text1"));
        this.____1419 = this.getChildByName("moneyIcon1");
        this._okBtn1 = this.getChildByName("okBtn1");
        this._numsLabel1 = this.getChildByName("nums1");
        this._numsLabel1.setString(" x1");
        this.____1102 = this.getChildByName("desLabel1");
        this.____1102.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text2"));
        this._titleLabel = this.getChildByName("titleLabel");
        this._titleLabel.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text3"));
        this._aroundFlag = aroundFlag;
        this.____1756 = null;
        this.____1219 = 0;
        this._luckyTotalNum = 0;
        this.text = ____654.____682.____108("10101");
        this.____5();
        this.____6();
        ____654.____676.hideBack()
    },
    ____5: function() {
        this.setCountDownTime();
        this.____1756 = ____655.allTemplates.luckyTreasureTemplateList.getInfoById(this._aroundFlag);
        var len1 = this.____1756.showItemList.length;
        if (len1 >= 10) {
            len1 = 10
        }
        for (var i = 0; i < len1; i++) {
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(this.____1756.showItemList[i][0]);
            this._gridList[i].setItemTemplateInfo(itemTemplateInfo);
            this._gridList[i].setCount(this.____1756.showItemList[i][1])
        }
        var len2 = this.____1756.itemList.length;
        if (len2 >= 4) {
            len2 = 4
        }
        for (var i = 0; i < len2; i++) {
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(this.____1756.itemList[i][0]);
            this._awardGridList[i].setItemTemplateInfo(itemTemplateInfo);
            this._awardGridList[i].setCount(this.____1756.itemList[i][1])
        }
        for (var i = 0; i < 4; i++) {
            this._comNumsList[i].setString(____654.yuyanbaoManager.getYuyanbao("____2172.text20", this.____1756.itemList[i][2]))
        }
        this.updateCountView();
        this.updateView()
    },
    setCountDownTime: function() {
        var lastRevertTime = 0;
        var weeksDay = ____655.____662.getClientDate().getDay();
        if (weeksDay == 0) {
            weeksDay = 7
        }
        if (this._aroundFlag == 1) {
            this._roundLabel.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text4"));
            lastRevertTime = ((3 - weeksDay + 1) * ____655.____662.secondsOfDay) - ____655.____662.getZeroPassTime()
        } else {
            this._roundLabel.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text5"));
            lastRevertTime = ((7 - weeksDay + 1) * ____655.____662.secondsOfDay) - ____655.____662.getZeroPassTime()
        }
        this._countDownUtils.start(lastRevertTime)
    },
    updateCountView: function() {
        this.____1219 = ____655.itemInfoList.getCountByTempId(this.____1756.needItemId);
        this._hasLabel.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text6", this.____1219));
        if (this.____1219 <= 0) {
            this.____1419.setVisible(false);
            this._numsLabel1.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text10"));
            this._numsLabel1.setPositionX(483);
            this.____1102.setVisible(false)
        } else {
            this.____1419.setVisible(true);
            this.____1102.setVisible(true);
            this._numsLabel1.setString(" x1");
            this._numsLabel1.setPositionX(470);
            this.____1102.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text2"))
        }
    },
    updateView: function() {
        this._luckyTotalNum = ____655.welfareInfo.luckyTotalNum;
        var getAwardList = ____655.welfareInfo.getAwardList;
        if (this._aroundFlag == 1) {
            this._numsLabel.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text7", this._luckyTotalNum))
        } else {
            this._numsLabel.setString(____654.yuyanbaoManager.getYuyanbao("LuckyTreasurePanel.text8", this._luckyTotalNum))
        }
        for (var i = 0; i < 4; i++) {
            var index = getAwardList.indexOf((i + 1));
            if (index != -1) {
                this._getFlagList[i].setVisible(true);
                if (this._effectList[i] != null) {
                    this._effectList[i].dispose();
                    this._effectList[i] = null
                }
                this._flagList[i] = false
            } else {
                this._getFlagList[i].setVisible(false);
                if (this._effectList[i] != null) {
                    this._effectList[i].dispose();
                    this._effectList[i] = null
                }
                if (this._luckyTotalNum >= this.____1756.itemList[i][2]) {
                    this._effectList[i] = new OpacityEffect("effect/effect_12.png", -5);
                    this._effectList[i].move(41, 41);
                    this._awardGridList[i].addChild(this._effectList[i]);
                    this._flagList[i] = true
                }
            }
        }
        if (this._luckyTotalNum < this.____1756.itemList[0][2]) {
            this.____1021.setPercent(0)
        } else if (this._luckyTotalNum >= this.____1756.itemList[0][2] && this._luckyTotalNum < this.____1756.itemList[1][2]) {
            this.____1021.setPercent(17)
        } else if (this._luckyTotalNum >= this.____1756.itemList[1][2] && this._luckyTotalNum < this.____1756.itemList[2][2]) {
            this.____1021.setPercent(41)
        } else if (this._luckyTotalNum >= this.____1756.itemList[2][2] && this._luckyTotalNum < this.____1756.itemList[3][2]) {
            this.____1021.setPercent(66)
        } else if (this._luckyTotalNum >= this.____1756.itemList[3][2]) {
            this.____1021.setPercent(100)
        }
    },
    setSelectIndex: function(index) {
        this._selectIcon1.setPosition(this._itemList[index].getPositionX(), this._itemList[index].getPositionY());
        this._selectIcon2.setPosition(this._itemList[index].getPositionX(), this._itemList[index].getPositionY())
    },
    pickUpdate: function(evt) {
        var dataList = evt.data;
        if (dataList == null) {
            return
        }
        this._transResult = dataList[0] - 1
    },
    startRun: function() {
        this._transResult = -1;
        this._tickCount = 0;
        this._selectIcon1.setVisible(true);
        this._selectIcon2.setVisible(true);
        this.setSelectIndex(this._currentSelectIndex);
        ____654.____678.____298(this.tick, this)
    },
    stopRun: function() {
        this._tickCount = 0;
        ____654.____678.____299(this.tick, this);
        var itemList = ____655.welfareInfo.itemAwardList;
        if (itemList.length > 0) {
            this._controller.showLuckyTreasureAwardPanel(itemList)
        }
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount < 120) {
            if (this._tickCount % 5 == 0) {
                this._currentSelectIndex++;
                if (this._currentSelectIndex >= this._gridList.length) {
                    this._currentSelectIndex = 0
                }
                this.setSelectIndex(this._currentSelectIndex)
            }
        } else {
            if (this._tickCount % 15 == 0) {
                this._currentSelectIndex++;
                if (this._currentSelectIndex >= this._gridList.length) {
                    this._currentSelectIndex = 0
                }
                this.setSelectIndex(this._currentSelectIndex);
                if (this._gridIndexList[this._currentSelectIndex] == this._transResult) {
                    this.stopRun()
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._tickCount > 0) return;
            var this_ = this;

            function buyHandler1() {
                this_.startRun();
                ____654.luckyTreasureMessageSender.sendPickAward(1)
            }

            function buyHandler10() {
                this_.startRun();
                ____654.luckyTreasureMessageSender.sendPickAward(2)
            }

            function okClick() {
                this._controller.hideLuckyTreasurePanel();
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.welfareTab, ____655.____659.panelTabType.welfare, 2)
            }

            function ok1Click() {
                this._controller.hideLuckyTreasurePanel();
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.llTab, ____655.____659.panelTabType.ll)
            }
            if (sender == this._okBtn10) {
                if (this.____1219 >= this.____1756.tenFee) {
                    this_.startRun();
                    ____654.luckyTreasureMessageSender.sendPickAward(2)
                } else {
                    ____655.getAlert().show(5, this.text, null, 0, this, okClick, ok1Click, null)
                }
            } else if (sender == this._okBtn1) {
                if (this.____1219 >= this.____1756.oneFee) {
                    this_.startRun();
                    ____654.luckyTreasureMessageSender.sendPickAward(1)
                } else {
                    ____655.getAlert().show(5, this.text, null, 0, this, okClick, ok1Click, null)
                }
            } else if (sender == this._closeBtn) {
                this._controller.hideLuckyTreasurePanel()
            }
        }
    },
    clickHandler: function(sender, eventType, pos) {
        var grid = sender.getParent();
        var index = this._awardGridList.indexOf(grid);
        if (this._flagList[index] == true) {
            ____654.luckyTreasureMessageSender.sendGetLuckyAward(index + 1)
        }
    },
    downHandler: function(sender, eventType, pos) {
        var grid = sender.getParent();
        var index = this._awardGridList.indexOf(grid);
        if (this._flagList[index] == false) {
            grid.showTip();
            this.____1711 = pos
        }
    },
    upHandler: function(sender, eventType, pos) {
        if (this.____1711 == null) {
            return
        }
        var grid = sender.getParent();
        grid.hideTip();
        this.____1711 = null
    },
    ____358: function(sender, eventType, pos) {
        if (this.____1711 == null) {
            return
        }
        if (this.____1711.x - pos.x > 15 || this.____1711.y - pos.y > 15) {
            var grid = sender.getParent();
            grid.hideTip();
            this.____1711 = null
        }
    },
    ____6: function() {
        this._okBtn10.addListener(this, this.____16);
        this._okBtn1.addListener(this, this.____16);
        this._closeBtn.addListener(this, this.____16);
        for (var i = 0; i < 4; i++) {
            this._awardGridList[i].____1512.addListener(this, this.clickHandler, this.downHandler, this.upHandler, this.____358)
        }
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.updateCountView, this);
        ____655.welfareInfo.addEventListener(____655.____661.luckyTreasure_infoUpdate, this.updateView, this);
        ____655.welfareInfo.addEventListener(____655.____661.luckyTreasure_pickUpdate, this.pickUpdate, this);
        ____654.____672.addEventListener(____655.____661.____698, this.reconnectHandler, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.reconnectHandler, this)
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.updateCountView, this);
        ____655.welfareInfo.removeEventListener(____655.____661.luckyTreasure_infoUpdate, this.updateView, this);
        ____655.welfareInfo.removeEventListener(____655.____661.luckyTreasure_pickUpdate, this.pickUpdate, this);
        ____654.____672.removeEventListener(____655.____661.____698, this.reconnectHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.reconnectHandler, this)
    },
    reconnectHandler: function() {
        this._controller.hideLuckyTreasurePanel()
    },
    dispose: function() {
        ____654.____676.showBack();
        ____655.isShowGetTip = true;
        this.____17();
        this._controller = null;
        this._closeBtn = null;
        this._timeLabel = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._remainLabel = null;
        this._roundLabel = null;
        ____654.____677.removeImageQuote(this._backGroundPath, this.____857);
        this._backGroundPath = null;
        this.____857 = null;
        if (this._effectList != null) {
            for (var i in this._effectList) {
                if (this._effectList[i] != null) {
                    this._effectList[i].dispose()
                }
            }
            this._effectList = null
        }
        this._itemList = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        this._flagList = null;
        this._selectIcon1 = null;
        this._selectIcon2 = null;
        this._numsLabel = null;
        this._hasLabel = null;
        this.____1021 = null;
        this._comNumsList = null;
        this._awardItemList = null;
        if (this._awardGridList != null) {
            for (var i = 0; i < this._awardGridList.length; i++) {
                this._awardGridList[i].dispose()
            }
            this._awardGridList = null
        }
        this._getFlagList = null;
        this._okBtn10 = null;
        this._numsLabel10 = null;
        this._desLabel10 = null;
        this._okBtn1 = null;
        this._numsLabel1 = null;
        this.____1102 = null;
        this._aroundFlag = null;
        this.____1756 = null;
        this.____1219 = null;
        this._luckyTotalNum = null;
        this._titleLabel = null;
        this.____1711 = null;
        this.text = null;
        this.____1419 = null;
        this._super()
    },
});
var ____2267 = KYNode.extend({
    ____1366: null,
    ____1365: null,
    _closeBtn: null,
    _titleLabel: null,
    ____1001: null,
    ____1285: null,
    ____1479: null,
    ____892: null,
    _gridList: null,
    ____820: null,
    _bg: null,
    ctor: function(parent) {
        this._super("mailContentView.ExportJson");
        this.____1001 = this.getChildByName("contentLabel");
        this._titleLabel = this.getChildByName("titleLabel");
        this.____1285 = this.getChildByName("itemLayer");
        this.____1285.setItemsMargin(86);
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1479 = this.getChildByName("okBtn");
        this.____892 = this.getChildByName("btnLabel");
        this._bg = this.getChildByName("bg");
        this.____1366 = parent;
        this.____6()
    },
    ____6: function() {
        this.____1479.addListener(this, this.____16);
        this._closeBtn.addListener(this, this.____16);
        this._bg.addListener(this, this.____16)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1479) {
                if (this.____1365.hasItemReceive()) {
                    if (!____655.itemInfoList.getHasPos(this.____1365.itemCount)) {
                        ____654.tipsManager.quickTip.show("背包空间不足");
                        return
                    }
                    this.____1365.read = true;
                    ____654.selfDataMessageSender.sendMailAttach([this.____1365.id]);
                    this.setAccepted(true);
                    this.____1479.setFrame("btn/ui_btn1_3.png");
                    this.____892.setString(____654.yuyanbaoManager.getYuyanbao("mail.btnLabel2"))
                } else {
                    ____654.selfDataMessageSender.sendMailRemove([this.____1365.id]);
                    this.____1366.hideContentView()
                }
            } else if (sender == this._closeBtn) {
                this.____1366.hideContentView()
            }
        }
    },
    ____363: function(mailInfo) {
        this.____1365 = mailInfo;
        this._titleLabel.setString(this.____1365.title);
        this.____1001.setString(this.____1365.content);
        this.clearCell();
        this._gridList = [];
        if (this.____1365.items.length > 0) {
            this.____1001.setContentSize(____654.____673.____160(535, 145));
            if (this.____1365.fetchState == 0) {
                for (var i = 0; i < this.____1365.items.length; i++) {
                    var item = new ____2129(true, -41);
                    item.setItemInfo(this.____1365.items[i]);
                    this._gridList.push(item);
                    this.____1285.pushBackItem(item)
                }
                this.setAccepted(false);
                this.____1479.setFrame("btn/ui_btn1_2.png");
                this.____892.setString(____654.yuyanbaoManager.getYuyanbao("mail.btnLabel1"))
            } else {
                this.setAccepted(true);
                this.____1479.setFrame("btn/ui_btn1_3.png");
                this.____892.setString(____654.yuyanbaoManager.getYuyanbao("mail.btnLabel2"))
            }
            this.____1285.setTouchEnabled(true)
        } else {
            this.____1001.setContentSize(____654.____673.____160(535, 265));
            this.setAccepted(false);
            this.____1479.setFrame("btn/ui_btn1_3.png");
            this.____892.setString(____654.yuyanbaoManager.getYuyanbao("mail.btnLabel2"));
            this.____1285.setTouchEnabled(false)
        }
    },
    ____238: function() {
        return this.____1365
    },
    setAccepted: function(value) {
        if (value) {
            if (this.____820 == null) {
                this.____820 = ____654.____673.newKYSprite();
                this.____820.setFrame("flag/ui_acceptedFlag.png");
                this.____820.setPosition(____654.____673.____159(385, 222));
                this.addChild(this.____820, 5)
            }
            this.clearCell()
        } else {
            if (this.____820 != null) {
                this.____820.dispose();
                this.____820 = null
            }
        }
    },
    clearCell: function() {
        this.____1285.removeAllItems();
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
    },
    dispose: function() {
        this.____17();
        this.clearCell();
        this.setAccepted(false);
        this._super();
        this.____1366 = null;
        this.____1365 = null;
        this._closeBtn = null;
        this.____1001 = null;
        this._titleLabel = null;
        this.____1285 = null;
        this.____1479 = null;
        this.____892 = null;
        this._bg = null
    },
});
var ____564 = KYNode.extend({
    ____1365: null,
    ____1201: null,
    _grid: null,
    ____820: null,
    _titleLabel: null,
    _timeLabel: null,
    ____1001: null,
    ____1462: null,
    ctor: function(mailInfo) {
        this._super("mailItemView.ExportJson");
        this.____1365 = mailInfo;
        this.____1201 = this.getChildByName("cellBg");
        this.____820 = this.getChildByName("acceptFlag");
        this._titleLabel = this.getChildByName("titleLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1001 = this.getChildByName("contentLabel");
        this.____5();
        this.____6()
    },
    ____5: function() {
        this._titleLabel.setString(this.____1365.title);
        this._timeLabel.setPositionX(this._titleLabel.getContentSize().width + 50);
        if (this.____1365.leftDay < 1) {
            this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("mail.panelTips2"))
        } else {
            this._timeLabel.setString(____654.yuyanbaoManager.getYuyanbao("mail.panelTips1", this.____1365.leftDay.toString()))
        }
        var content = this.____1365.content;
        if (content.length > 25) {
            content = content.slice(0, 25);
            content += "..."
        }
        this.____1001.setString(content);
        if (this.____1365.items.length > 0) {
            this.____1201.setVisible(true);
            if (this._grid == null) {
                this._grid = new ____2129(false);
                this._grid.setItemInfo(this.____1365.items[0]);
                this.____1201.addChild(this._grid)
            }
            if (this.____1365.fetchState == 0) {
                this.____820.setVisible(false)
            } else {
                this.____820.setVisible(true)
            }
        } else {
            this.____1201.setVisible(false);
            if (this._grid != null) {
                this._grid.dispose();
                this._grid = null
            }
            this.____820.setVisible(false)
        }
        this.setIsRead(this.____1365.read)
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.common_mailFetchUpdate, this.fetchUpdateHandler, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_mailFetchUpdate, this.fetchUpdateHandler, this)
    },
    fetchUpdateHandler: function(evt) {
        if (evt.data != this.____1365.id) {
            return
        }
        if (this.____1365.fetchState == 0) {
            this.____820.setVisible(false)
        } else {
            this.____820.setVisible(true);
            this.setIsRead(true)
        }
    },
    setIsRead: function(value) {
        if (value) {
            if (this.____1462 != null) {
                this.____1462.dispose();
                this.____1462 = null
            }
        } else {
            if (this.____1462 == null) {
                this.____1462 = ____654.____673.newKYSprite();
                this.____1462.setFrame("icon/ui_numTipIcon.png");
                this.____1462.setPosition(____654.____673.____159(11, 87));
                this.addChild(this.____1462, 5)
            }
        }
    },
    ____238: function() {
        return this.____1365
    },
    dispose: function() {
        this.____17();
        this._super();
        this.setIsRead(true);
        this.____1365 = null;
        this.____1201 = null;
        this.____820 = null;
        this._titleLabel = null;
        this._timeLabel = null;
        this.____1001 = null;
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
    },
});
var ____565 = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____1093: null,
    ____819: null,
    _titleLabel: null,
    _tileContainer: null,
    ____1002: null,
    _tipsLabel: null,
    ctor: function(scenePanelController) {
        this._super("mailPanel.ExportJson");
        this.modeValue = 200;
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1093 = this.getChildByName("delBtn");
        this.____819 = this.getChildByName("acceptBtn");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._titleLabel = ____654.____673.newKYLabel(30, true);
        this._titleLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this._titleLabel.setPosition(____654.____673.____159(29, 604));
        this._titleLabel.setString(____654.yuyanbaoManager.getYuyanbao("uiPanel.typeTitle7"));
        this.addChild(this._titleLabel);
        this._tileContainer = this.getChildByName("itemLayer__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____18();
        this.____6();
        ____654.____676.hideBack()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____1093.addListener(this, this.____16);
        this.____819.addListener(this, this.____16);
        ____655.mailItemList.addEventListener(____655.____661.common_mailListUpdate, this.____18, this);
        ____655.mailItemList.addEventListener(____655.____661.common_mailDelete, this.mailDelete, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____655.mailItemList.removeEventListener(____655.____661.common_mailListUpdate, this.____18, this);
        ____655.mailItemList.removeEventListener(____655.____661.common_mailDelete, this.mailDelete, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____18: function() {
        this._tileContainer.setFormat(1, ____655.mailItemList.mailList.length, ____654.____673.____160(720, 97), 0, 14, true);
        if (____655.mailItemList.mailList.length > 0) {
            this._tipsLabel.setVisible(false)
        } else {
            this._tipsLabel.setVisible(true);
            this._tipsLabel.setString("暂时未获得任何邮件信息！")
        }
    },
    mailDelete: function(evt) {
        var id = evt.data;
        this._tileContainer.removeItemById(id)
    },
    showContentView: function(mailInfo) {
        if (mailInfo == null) {
            return
        }
        if (this.____1002 == null) {
            this.____1002 = new ____2267(this)
        }
        if (this.____1002.getParent() == null) {
            this.addChild(this.____1002, 99)
        }
        this.____1002.____363(mailInfo)
    },
    hideContentView: function() {
        if (this.____1002 != null) {
            this.____1002.dispose();
            this.____1002 = null
        }
    },
    getItemByIndex: function(index) {
        var info = ____655.mailItemList.mailList[index];
        if (info == null) {
            return null
        }
        var item = new ____564(info);
        item.addListener(this, this.itemClickHandler, null, null, null, false, true);
        return item
    },
    getIdByIndex: function(index) {
        var info = ____655.mailItemList.mailList[index];
        if (info == null) {
            return -1
        }
        return info.id
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____1093) {
                var list1 = [];
                var info1 = null;
                var len1 = ____655.mailItemList.mailList.length;
                for (var i = 0; i < len1; i++) {
                    info1 = ____655.mailItemList.mailList[i];
                    if (info1 != null && info1.read && !info1.hasItemReceive()) {
                        list1.push(info1.id)
                    }
                }
                if (list1.length == 0) {
                    return
                }
                ____654.selfDataMessageSender.sendMailRemove(list1)
            } else if (sender == this.____819) {
                var list2 = [];
                var info2 = null;
                var len2 = ____655.mailItemList.mailList.length;
                for (var i = 0; i < len2; i++) {
                    info2 = ____655.mailItemList.mailList[i];
                    if (info2 != null && info2.hasItemReceive()) {
                        if (!____655.itemInfoList.getHasPos(info2.itemCount)) {
                            ____654.tipsManager.quickTip.show("背包空间不足");
                            break
                        }
                        info2.setRead(true);
                        list2.push(info2.id)
                    }
                }
                if (list2.length == 0) {
                    return
                }
                ____654.selfDataMessageSender.sendMailAttach(list2)
            }
        }
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var info = sender.____238();
            if (info.read == false) {
                info.setRead(true);
                sender.setIsRead(true);
                ____654.selfDataMessageSender.sendMailRed(info.id)
            }
            this.showContentView(info)
        }
    },
    dispose: function() {
        ____654.____676.showBack();
        this.____17();
        this.hideContentView();
        this._super();
        this._controller = null;
        this._closeBtn = null;
        this.____1093 = null;
        this.____819 = null;
        this._tipsLabel = null;
        if (this._titleLabel != null) {
            this._titleLabel.dispose();
            this._titleLabel = null
        }
        this._tileContainer = null
    },
});
var MainMenu = cc.Class.extend({
    _controller: null,
    ____1143: null,
    ____1142: null,
    ____1384: null,
    ____1004: null,
    ____1682: null,
    ____903: null,
    ____904: null,
    ____905: null,
    ____906: null,
    ____907: null,
    _btnList6: null,
    _btnList4X: 0,
    _isShowList: null,
    ____1684: null,
    ____1843: null,
    ____956: null,
    ____1190: null,
    ____1598: null,
    ____1882: null,
    ____1571: null,
    _tuJianBtn: null,
    ____1229: null,
    ____1178: null,
    ____1577: null,
    ____1406: null,
    ____1859: null,
    ____1007: null,
    ____1343: null,
    ____878: null,
    _shopBtn: null,
    ____1488: null,
    _openBtn: null,
    _feiXianBtn: null,
    _loginGiftBtn: null,
    _openLeiChongBtn: null,
    _dailyRechargeBtn: null,
    _waiXingChongjieBtn: null,
    ____1364: null,
    ____1179: null,
    ____1549: null,
    _clubBossIconBtn: null,
    _kuozhanIconBtn: null,
    ____1663: null,
    ____957: null,
    ____1141: null,
    _afkBtn: null,
    _xianweiBtn: null,
    _actBtnList: null,
    _timeBtnList: null,
    _returnGiftBtn: null,
    ____1266: true,
    _isShow: true,
    _fightMode: 0,
    _isFightUI: false,
    _giftBtnPath: null,
    _giftTempList: null,
    _giftFlag: true,
    _tickCount: null,
    _sceneChatView: null,
    _yugaoTipsLayer: null,
    _currentBtn: null,
    _currentZone: null,
    _downKuozhanTime: 0,
    _qiangzhiList: null,
    _wifiList: null,
    _isDailyFisrtEffect: true,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this.____903 = [];
        this.____904 = [];
        this.____905 = [];
        this.____906 = [];
        this.____907 = [];
        this._btnList6 = [];
        this._btnList4X = ____655.____656 + 588;
        this._isShowList = [true, true, true, true, true, true];
        this._actBtnList = {};
        this._timeBtnList = {};
        this.____5();
        this.____6();
        var this_ = this;

        function touchBegan(touch, event) {
            var pos = touch.getLocation();
            for (var z in ____654.clickZoneList) {
                var zone = ____654.clickZoneList[z];
                if (zone == null) {
                    continue
                }
                if (pos.x >= zone[0] && pos.x <= zone[1] && pos.y >= zone[2] && pos.y <= zone[3]) {
                    this_._currentZone = zone;
                    return true
                }
            }
            var len = 0;
            var tempList = null;
            var i = 0;
            var list = [this_.____903, this_.____904, this_.____905, this_.____906, this_.____907, this_._btnList6, [this_.____1663, this_.____957, this_.____1141, this_._afkBtn, this_._xianweiBtn]];
            for (var k = 0; k < list.length; k++) {
                tempList = list[k];
                if (tempList == null) {
                    continue
                }
                len = tempList.length;
                for (i = 0; i < len; i++) {
                    if (tempList[i] == null) {
                        continue
                    }
                    if (tempList[i].isMouseOver(pos)) {
                        this_._currentBtn = tempList[i];
                        return true
                    }
                }
            }
            if (this_._fightMode == 0) {
                this_.foldMenu(true)
            } else if (this_._fightMode == 1) {
                this_.changeFightUI(true)
            }
            return false
        }

        function touchEnded(touch, event) {
            var pos = touch.getLocation();
            if (this_._currentBtn != null) {
                if (this_._currentBtn.isMouseOver(pos)) {
                    this_._currentBtn.doClick()
                }
            } else if (this_._currentZone != null) {
                if (pos.x >= this_._currentZone[0] && pos.x <= this_._currentZone[1] && pos.y >= this_._currentZone[2] && pos.y <= this_._currentZone[3]) {
                    if (this_._currentZone[4] != null) {
                        this_._currentZone[4]()
                    }
                }
            }
            this_._currentBtn = null;
            this_._currentZone = null
        };
        var touchListener = {
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: touchBegan,
            onTouchEnded: touchEnded
        };
        cc.eventManager.addListener(touchListener, ____654.____676.mainmenuClickContainer)
    },
    ____5: function() {
        this.____1143 = ____654.____673.newKYSprite();
        this.____1143.setFrame("board/ui_blackBoard.png");
        this.____1143.setPosition(____654.____673.____159(____655.____656 * 0.5, 4));
        this.____1143.setOpacity(200);
        this.____1143.setScaleX(____655.____656 / 2);
        ____654.____676.mainMenuBgContainer.addChild(this.____1143);
        this.____1142 = ____654.____673.newKYProgressBar("bar/ui_expBar.png", ____655.____656);
        this.____1142.setPosition(____654.____673.____159(0, 4));
        ____654.____676.mainMenuBgContainer.addChild(this.____1142);
        this.____1384 = [];
        var barW = Math.ceil(____655.____656 * 0.1);
        for (var i = 0; i < 10; i++) {
            var mask = ____654.____673.newKYSprite();
            mask.setFrame("bar/ui_expBarBg.png");
            mask.setScaleX(barW / 96);
            mask.setPosition(____654.____673.____159((i + 0.5) * barW, 4));
            this.____1384.unshift(mask);
            ____654.____676.mainMenuContainer.addChild(mask)
        }
        this.____1004 = new ____2247();
        this.____1004.move(____654.____673.____159(130, 160));
        ____654.____676.mainMenuBgContainer.addChild(this.____1004, 0);
        this.____1682 = new SkillPad(this._controller, ____654.____676.____799);
        this.____1682.hide();
        this.____1663 = new ____2283("sceneIcon/ui_settingIcon.png", 1);
        this.____1663.setCallback(this.clickHandler, this);
        this.____1663.move(45, 49);
        this.____957 = new MenuChatIcon();
        this.____957.setCallback(this.clickHandler, this);
        this.____957.move(____655.____656 * 0.5 - 250, 49);
        this._afkBtn = new MenuAfkIcon();
        this._afkBtn.move(____655.____656 - 325, 62);
        this._afkBtn.hideIcon();
        this.____1843 = new MenuVipIcon();
        this.____1843.setLevelLabel(____655.____667.vipLevel);
        this.____1843.setCallback(this.clickHandler, this);
        this.____907.push(this.____1843);
        this.____956 = new ____2283("sceneIcon/ui_chargeIcon.png", 1);
        this.____956.setCallback(this.clickHandler, this);
        this.____907.push(this.____956);
        this.____1684 = new ____2287(this._controller);
        this.____903.push(this.____1684);
        this.____1598 = new ____2283("sceneIcon/mainmenu_btn1_" + ____655.____667.career + ".png", 1);
        this.____1598.setCallback(this.clickHandler, this);
        this.____906.push(this.____1598);
        this.____1882 = new ____2283("sceneIcon/mainmenu_btn2.png", 1);
        this.____1882.setCallback(this.clickHandler, this);
        this.____906.push(this.____1882);
        this.____1571 = new ____2283("sceneIcon/mainmenu_btn3.png", 1);
        this.____1571.setCallback(this.clickHandler, this);
        this.____906.push(this.____1571);
        this._tuJianBtn = new ____2283("sceneIcon/mainmenu_btn8.png", 1);
        this._tuJianBtn.setCallback(this.clickHandler, this);
        this.____906.push(this._tuJianBtn);
        this.____1229 = new ____2283("sceneIcon/mainmenu_btn4.png", 1);
        this.____1229.setCallback(this.clickHandler, this);
        this.____906.push(this.____1229);
        this.____1178 = new ____2283("sceneIcon/mainmenu_btn6.png", 1);
        this.____1178.setCallback(this.clickHandler, this);
        this.____906.push(this.____1178);
        this.____1577 = new ____2283("sceneIcon/mainmenu_btn7.png", 1);
        this.____1577.setCallback(this.clickHandler, this);
        this.____906.push(this.____1577);
        this.____1406 = new ____2284();
        this.____905.push(this.____1406);
        this.____1859 = new ____2283("sceneIcon/mainmenu_btn11.png", 1);
        this.____1859.setCallback(this.clickHandler, this);
        this.____905.push(this.____1859);
        this.____1007 = new ____2283("sceneIcon/mainmenu_btn12.png", 1);
        this.____1007.setCallback(this.clickHandler, this);
        this.____905.push(this.____1007);
        this.____1343 = new ____2283("sceneIcon/mainmenu_btn13.png", 1);
        this.____1343.setCallback(this.clickHandler, this);
        this.____905.push(this.____1343);
        this.____878 = new ____2283("sceneIcon/mainmenu_btn14.png", 1);
        this.____878.setCallback(this.clickHandler, this);
        this.____905.push(this.____878);
        this._shopBtn = new ____2283("sceneIcon/mainmenu_btn21.png", 1);
        this._shopBtn.setCallback(this.clickHandler, this);
        this._shopBtn.index = 1;
        this.____903.push(this._shopBtn);
        this.____1190 = new ____2283("sceneIcon/mainmenu_btn22.png", 1);
        this.____1190.setCallback(this.clickHandler, this);
        this.____1190.index = 2;
        this.____903.push(this.____1190);
        this.updateAllBtn();
        if (this._sceneChatView == null) {
            this._sceneChatView = new SceneChatView(this);
            this._sceneChatView.setPosition(____655.____656 * 0.5 - 204, 8);
            ____654.____676.mainMenuBgContainer.addChild(this._sceneChatView)
        }
        this.updateExpBar(null);
        this.giftBtnUpdate();
        this.levelUpdate();
        this.dayUpdate();
        this.xianweiUpdate();
        this.popUpdate()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.playerInfo_selfInfo, this.playerInfoUpdate, this);
        ____654.____672.addEventListener(____655.____661.mainmenu_foldBtn, this.showBtnHandler, this);
        ____655.mailItemList.addEventListener(____655.____661.mainmenu_mailBtn, this.mailUpdate, this);
        ____655.____669.addEventListener(____655.____661.____761, this.chatHandler, this);
        ____655.____668.addEventListener(____655.____661.common_deleteFriend, this.deleteFriendHander, this);
        ____654.____672.addEventListener(____655.____661.chat_unreadCountReset, this.privateChatUpdate, this);
        ____655.____668.addEventListener(____655.____661.common_friendResponseUpdate, this.friendResponseUpdate, this);
        ____654.____672.addEventListener(____655.____661.mainmenu_exitBtn, this.exitHandler, this);
        ____654.____672.addEventListener(____655.____661.mainmenu_fightMode, this.fightModeHandler, this);
        ____654.____672.addEventListener(____655.____661.mainmenu_headClick, this.headClickHandler, this);
        ____655.____667.addEventListener(____655.____661.____702, this.updateExpBar, this);
        ____655.____667.addEventListener(____655.____661.____703, this.levelUpdate, this);
        ____655.____667.addEventListener(____655.____661.playerInfo_xianweiUpdate, this.xianweiUpdate, this);
        ____655.____667.addEventListener(____655.____661.____704, this.vipLevelUpdate, this);
        ____655.welfareInfo.addEventListener(____655.____661.welfare_ZhuanShuUpdate, this.giftBtnUpdate, this);
        ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.dayUpdate, this);
        ____655.activityIconList.addEventListener(____655.____661.mainmenu_actIconUpdate, this.actIconUpdate, this);
        ____655.activityIconList.addEventListener(____655.____661.mainmenu_timeIconUpdate, this.timeIconUpdate, this);
        ____655.activityIconList.addEventListener(____655.____661.mainmenu_timeIconRemove, this.timeIconRemove, this);
        ____655.statInfo.addEventListener(____655.____661.returnGiftInfo, this.returnGiftUpdate, this);
        ____655.clubInfo.addEventListener(____655.____661.club_bossInfoUpdate, this.clubBossIconUpdate, this);
        ____655.statInfo.addEventListener(____655.____661.stat_online_update, this.onlineUpdate, this);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.addEventListener(____655.____661.mainmenu_exitTimeUpdate, this.exitTimeUpdate, this);
        ____654.____672.addEventListener(____655.____661.____698, this.reconnectHandler, this);
        ____655.____667.moneyInfo.addEventListener(____655.____661.____701, this.openLeiChongIconUpdate, this);
        ____654.____672.addEventListener(____655.____661.playerInfo_afkChange, this.afkChangeHandler, this);
        ____654.____672.addEventListener(____655.____661.kuozhanUpdate, this.kuozhanUpdate, this);
        ____655.dailyFirstRechargeInfo.addEventListener(____655.____661.dailyRechargeInfoUpdate, this.dailyRechargeIconUpdate, this);
        ____655.openInfo.addEventListener(____655.____661.playerInfo_waiXingChongJie, this.waiXingChongjieUpdate, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.playerInfo_selfInfo, this.playerInfoUpdate, this);
        ____654.____672.removeEventListener(____655.____661.mainmenu_foldBtn, this.showBtnHandler, this);
        ____655.mailItemList.removeEventListener(____655.____661.mainmenu_mailBtn, this.mailUpdate, this);
        ____655.____669.removeEventListener(____655.____661.____761, this.chatHandler, this);
        ____655.____668.removeEventListener(____655.____661.common_deleteFriend, this.deleteFriendHander, this);
        ____654.____672.removeEventListener(____655.____661.chat_unreadCountReset, this.privateChatUpdate, this);
        ____655.____668.removeEventListener(____655.____661.common_friendResponseUpdate, this.friendResponseUpdate, this);
        ____654.____672.removeEventListener(____655.____661.mainmenu_exitBtn, this.exitHandler, this);
        ____654.____672.removeEventListener(____655.____661.mainmenu_fightMode, this.fightModeHandler, this);
        ____654.____672.removeEventListener(____655.____661.mainmenu_headClick, this.headClickHandler, this);
        ____655.____667.removeEventListener(____655.____661.____702, this.updateExpBar, this);
        ____655.____667.removeEventListener(____655.____661.____703, this.levelUpdate, this);
        ____655.____667.removeEventListener(____655.____661.playerInfo_xianweiUpdate, this.xianweiUpdate, this);
        ____655.____667.removeEventListener(____655.____661.____704, this.vipLevelUpdate, this);
        ____655.welfareInfo.removeEventListener(____655.____661.welfare_ZhuanShuUpdate, this.giftBtnUpdate, this);
        ____654.____672.removeEventListener(____655.____661.global_dayUpdate, this.dayUpdate, this);
        ____655.activityIconList.removeEventListener(____655.____661.mainmenu_actIconUpdate, this.actIconUpdate, this);
        ____655.activityIconList.removeEventListener(____655.____661.mainmenu_timeIconUpdate, this.timeIconUpdate, this);
        ____655.activityIconList.removeEventListener(____655.____661.mainmenu_timeIconRemove, this.timeIconRemove, this);
        ____655.statInfo.removeEventListener(____655.____661.returnGiftInfo, this.returnGiftUpdate, this);
        ____655.clubInfo.removeEventListener(____655.____661.club_bossInfoUpdate, this.clubBossIconUpdate, this);
        ____655.statInfo.removeEventListener(____655.____661.stat_online_update, this.onlineUpdate, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.removeEventListener(____655.____661.mainmenu_exitTimeUpdate, this.exitTimeUpdate, this);
        ____654.____672.removeEventListener(____655.____661.____698, this.reconnectHandler, this);
        ____655.____667.moneyInfo.removeEventListener(____655.____661.____701, this.openLeiChongIconUpdate, this);
        ____654.____672.removeEventListener(____655.____661.playerInfo_afkChange, this.afkChangeHandler, this);
        ____654.____672.removeEventListener(____655.____661.kuozhanUpdate, this.kuozhanUpdate, this);
        ____655.dailyFirstRechargeInfo.removeEventListener(____655.____661.dailyRechargeInfoUpdate, this.dailyRechargeIconUpdate, this);
        ____655.openInfo.removeEventListener(____655.____661.playerInfo_waiXingChongJie, this.waiXingChongjieUpdate, this)
    },
    reconnectHandler: function() {
        for (var k in this._timeBtnList) {
            if (this._timeBtnList[k] != null) {
                this._timeBtnList[k].dispose()
            }
        }
        this._timeBtnList = {};
        this._btnList6 = [];
        for (var l in this._actBtnList) {
            var btn = this._actBtnList[l];
            if (btn != null) {
                var index = this.____903.indexOf(btn);
                if (index > -1) {
                    this.____903.splice(index, 1)
                }
                btn.dispose()
            }
        }
        this._actBtnList = {}
    },
    playerInfoUpdate: function(evt) {
        this._isDailyFisrtEffect = true;
        this.____1598.changeImage("sceneIcon/mainmenu_btn1_" + ____655.____667.career + ".png");
        this.updateAllBtn();
        this.friendResponseUpdate();
        this.updateExpBar(null);
        this.giftBtnUpdate();
        this.vipLevelUpdate();
        this.levelUpdate();
        this.dayUpdate();
        this.xianweiUpdate();
        this.popUpdate();
        this.mailUpdate()
    },
    dayUpdate: function() {
        this._giftFlag = true;
        this._tickCount = 200;
        ____654.____678.____298(this.tick, this)
    },
    createOnlineBtn: function() {
        if (this.____1488 == null) {
            this.____1488 = new ____2283("sceneIcon/mainmenu_btn23.png", 1);
            this.____1488.setCallback(this.clickHandler, this);
            this.____1488.index = 3;
            this.____903.push(this.____1488);
            this.updateBtnList(1)
        }
    },
    clearOnlineBtn: function() {
        if (this.____1488 != null) {
            var index = this.____903.indexOf(this.____1488);
            if (index > -1) {
                this.____903.splice(index, 1)
            }
            this.____1488.dispose();
            this.____1488 = null;
            this.updateBtnList(1)
        }
    },
    onlineUpdate: function(evt) {
        var this_ = this;

        function onlineCountComplete() {
            if (this_.____1488 != null) {
                this_.____1488.setLabel("a");
                this_.____1488.setEffect(true)
            }
        }
        if (____655.____667.level < ____655.____659.levelType.onlineLevel || ____655.statInfo.onlineAward_time == -1) {
            this.clearOnlineBtn()
        } else if (____655.statInfo.onlineAward_time != 0) {
            this.createOnlineBtn();
            var leftTime = ____655.statInfo.onlineAward_time - ____655.____662.getSystemTimeSec();
            if (leftTime <= 0) {
                onlineCountComplete()
            } else {
                this.____1488.setEffect(false);
                this.____1488.setTime(3, leftTime, 0, onlineCountComplete)
            }
        }
    },
    createKuozhanBtn: function() {
        if (this._kuozhanIconBtn == null) {
            this._kuozhanIconBtn = new ____2283("sceneIcon/mainmenu_btn34.png", 1);
            this._kuozhanIconBtn.setCallback(this.clickHandler, this);
            this.____904.push(this._kuozhanIconBtn);
            this.updateBtnList(2)
        }
    },
    clearKuozhanBtn: function() {
        if (this._kuozhanIconBtn != null) {
            var index = this.____904.indexOf(this._kuozhanIconBtn);
            if (index > -1) {
                this.____904.splice(index, 1)
            }
            this._kuozhanIconBtn.dispose();
            this._kuozhanIconBtn = null;
            this.updateBtnList(2)
        }
    },
    kuozhanUpdate: function(evt) {
        if (____655.gameConfig.plusList == null) {
            return
        }
        var level = ____655.____667.level;
        if (level >= ____655.____659.levelType.downloadLevel) {
            if (____655.kuozhanList == null) {
                ____655.kuozhanList = [];
                for (var i = 0; i < ____655.gameConfig.plusList.length; i++) {
                    var tempList = ____655.gameConfig.plusList[i].split(",");
                    ____655.kuozhanList = ____655.kuozhanList.concat(tempList)
                }
            }
            this._qiangzhiList = [];
            this._wifiList = [];
            if (____655.kuozhanIsComplate == false) {
                for (var k = 0; k < ____655.kuozhanList.length; k++) {
                    var name = ____655.kuozhanList[k];
                    if (name == null || name.length == "") {
                        continue
                    }
                    if (____654.____673.isFileExist("res/" + name)) {
                        continue
                    }
                    if (name.charAt(0) == "h") {
                        this._qiangzhiList.push(name)
                    } else {
                        this._wifiList.push(name)
                    }
                }
                if (this._qiangzhiList.length + this._wifiList.length == 0) {
                    ____655.kuozhanIsComplate = true
                }
            }
            if (level >= ____655.____659.levelType.showIconLevel) {
                if (this._qiangzhiList.length > 0) {
                    ____655.getAlert().show(1, "亲爱的仙友，为了您能获得更好的游戏体验，需要下载资源拓展包后才能继续游戏！", null, 5, this, this.loadQiangzhiHandler, null, null)
                } else if (____655.statInfo.kuozhanGiftState == 0 || this._wifiList.length > 0) {
                    this.createKuozhanBtn();
                    if (this._wifiList.length == 0) {
                        this._kuozhanIconBtn.setShowPop(true)
                    }
                } else {
                    this.clearKuozhanBtn()
                }
            } else {
                this.clearKuozhanBtn();
                if (!____655.kuozhanIsComplate) {
                    var len = 0;
                    if (____654.sdk.getNetWorkState() == 2) {
                        len = this._qiangzhiList.length + this._wifiList.length
                    } else {
                        len = this._qiangzhiList.length
                    }
                    if (len > 0) {
                        this._downKuozhanTime = 600;
                        ____654.____678.____298(this.downloadKuozhanTick, this)
                    } else {
                        ____654.____678.____299(this.downloadKuozhanTick, this)
                    }
                } else {
                    ____654.____678.____299(this.downloadKuozhanTick, this)
                }
            }
        } else {
            this.clearKuozhanBtn()
        }
    },
    loadQiangzhiHandler: function() {
        ____654.____674.loadKuozhan(this._qiangzhiList, true)
    },
    downloadKuozhanTick: function(delta, count) {
        this._downKuozhanTime--;
        if (this._downKuozhanTime <= 0) {
            if (this._qiangzhiList.length > 0) {
                ____654.____674.loadKuozhan([this._qiangzhiList[0]], false)
            } else if (this._wifiList.length > 0) {
                ____654.____674.loadKuozhan([this._wifiList[0]], false)
            }
            ____654.____678.____299(this.downloadKuozhanTick, this)
        }
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            this.returnGiftUpdate();
            this.openIconUpdate();
            this.loginGiftIconUpdate();
            this.feiXianIconUpdate();
            this.openLeiChongIconUpdate();
            this.dailyRechargeIconUpdate();
            this.waiXingChongjieUpdate();
            this.clubBossIconUpdate();
            ____654.____678.____299(this.tick, this)
        }
    },
    updateExpBar: function(evt) {
        var exp;
        var total;
        var nowTemp = ____655.allTemplates.expTemplateList.____238(____655.____667.level);
        if (____655.____667.level >= ____655.allTemplates.expTemplateList.maxLevel) {
            exp = ____655.____667.exp;
            total = ____655.____667.exp
        } else {
            var nextTemp = ____655.allTemplates.expTemplateList.____238(____655.____667.level + 1);
            if (nowTemp == null) {
                exp = ____655.____667.exp;
                total = nextTemp.totalExp
            } else {
                exp = ____655.____667.exp - nowTemp.totalExp;
                total = nextTemp.totalExp - nowTemp.totalExp
            }
        }
        this.____1142.setPercent(Math.floor(exp / total * 100))
    },
    levelUpdate: function(evt) {
        var level = ____655.____667.level;
        var openLevel = 0;
        openLevel = ____655.____659.levelType.waiguanLevel;
        this.____1882.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.weaponLevel;
        this.____1571.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.tujianLevel;
        this._tuJianBtn.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.shejiaoLevel;
        this.____1178.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.rankLevel;
        this.____1577.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.warLevel;
        this.____1859.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.copyLevel;
        this.____1007.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.lilianLevel;
        this.____1343.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.bossLevel;
        this.____878.setIsOpen(level >= openLevel, openLevel);
        openLevel = ____655.____659.levelType.homeLevel;
        this.____1229.setIsOpen(level >= openLevel, openLevel);
        var index = 0;
        for (index in this._timeBtnList) {
            if (this._timeBtnList[index] != null) {
                var templateInfo = ____655.allTemplates.timingActivityTemplateList.____238(index);
                if (level >= templateInfo.level) {
                    this._timeBtnList[index].setVisible(true);
                    if (this._isShowList[5] == true) {
                        this._timeBtnList[index].showIcon()
                    }
                }
            }
        }
        this.updateBtnList(6);
        for (index in this._actBtnList) {
            if (this._actBtnList[index] != null) {
                var templateInfo = ____655.allTemplates.timingActivityTemplateList.____238(index);
                if (level >= templateInfo.level) {
                    this._actBtnList[index].setVisible(true);
                    if (this._isShowList[0] == true) {
                        this._actBtnList[index].showIcon()
                    }
                }
            }
        }
        this.updateBtnList(1);
        this.onlineUpdate(null);
        this.openIconUpdate();
        this.feiXianIconUpdate();
        this.loginGiftIconUpdate();
        this.updateYugaoLayer();
        this.kuozhanUpdate();
        this.dailyRechargeIconUpdate();
        this.waiXingChongjieUpdate();
        if (____655.____667.level > 35) {
            if (this._xianweiBtn == null) {
                this._xianweiBtn = new MenuXianweiIcon();
                this._xianweiBtn.setCallback(this.clickHandler, this);
                this._xianweiBtn.move(280, 574)
            }
        } else {
            if (this._xianweiBtn != null) {
                this._xianweiBtn.dispose();
                this._xianweiBtn = null
            }
        }
    },
    xianweiUpdate: function() {
        if (this._xianweiBtn != null) {
            this._xianweiBtn.setXianwei(____655.____667.xianwei)
        }
    },
    updateYugaoLayer: function() {
        if (____655.____667.level < 35) {
            if (this._yugaoTipsLayer == null) {
                this._yugaoTipsLayer = new YugaoPanel();
                this._yugaoTipsLayer.setPosition(____654.____673.____159(324, ____655.____657 - 178));
                if (this._isShow && this._fightMode != 2) {
                    ____654.____676.mainMenuBgContainer.addChild(this._yugaoTipsLayer)
                }
            } else {
                this._yugaoTipsLayer.____5()
            }
        } else {
            if (this._yugaoTipsLayer != null) {
                this._yugaoTipsLayer.removeFromParent(false);
                this._yugaoTipsLayer.dispose();
                this._yugaoTipsLayer = null
            }
        }
    },
    vipLevelUpdate: function(evt) {
        this.____1843.setLevelLabel(____655.____667.vipLevel)
    },
    updateSkillPad: function() {
        if (this.____1682 != null) {
            this.____1682.updateSkillPad()
        }
        if (____655.currentMapId < 0) {
            return
        }
        if (this._afkBtn != null) {
            if (!____655.allTemplates.mapTemplateList.canAFK(____655.currentMapId) || !____655.allTemplates.copyTemplateList.canAFK(____655.copyInfo.currentId)) {
                this._afkBtn.setVisible(false)
            } else {
                this._afkBtn.setVisible(true)
            }
        }
    },
    showBtnHandler: function(evt) {
        var isFold = evt.data;
        if (isFold == null) {
            isFold = !this.____1266
        }
        this.foldMenu(isFold)
    },
    foldMenu: function(isFold) {
        if (this.____1266 == isFold) {
            return
        }
        this.____1266 = isFold;
        this.____1406.setFold(this.____1266);
        if (this.____1266) {
            if (this._sceneChatView.getParent() == null) {
                ____654.____676.mainMenuBgContainer.addChild(this._sceneChatView)
            }
            this._sceneChatView.setPositionX(____655.____656 * 0.5 - 204);
            this.____957.moveX(____655.____656 * 0.5 - 250);
            this.____1663.moveX(45)
        } else {
            this.____957.moveX(45);
            this.____1663.moveX(-45);
            this._sceneChatView.setPositionX(90)
        }
        ____654.____678.____298(this.foldTick, this)
    },
    foldTick: function(delta, count) {
        if (this.____1266) {
            var tempX = this._btnList4X + 30;
            if (tempX >= ____655.____656 + 588) {
                tempX = ____655.____656 + 588;
                ____654.____678.____299(this.foldTick, this)
            }
        } else {
            var tempX = this._btnList4X - 30;
            if (tempX <= ____655.____656 - 127) {
                tempX = ____655.____656 - 127;
                ____654.____678.____299(this.foldTick, this)
            }
        }
        this._btnList4X = tempX;
        this.resetIconPos()
    },
    resetIconPos: function() {
        var list = this.____906;
        var index = 0;
        for (var i = 0; i < list.length; i++) {
            var btn = list[i];
            if (btn.getVisible()) {
                btn.moveX(this._btnList4X - index * 90);
                index++
            }
        }
    },
    clickHandler: function(btn) {
        function exitCopy() {
            ____654.copyTester.exitCopy()
        }
        ____654.soundManager.playSound(____654.soundManager.BTN);
        if (btn == this.____1598) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tabGroup1)
        } else if (btn == this.____956) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
        } else if (btn == this.____957) {
            var isClub = this.____957.getClubImg();
            this.____957.setClubImg(false);
            if (!____655.chatPanelFlag) {
                if (isClub) {
                    this._controller.showChatPanel(____655.____659.____693.club)
                } else {
                    this._controller.showChatPanel()
                }
            } else {
                this._controller.hideChatPanel()
            }
        } else if (btn == this._shopBtn) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tabGroup2)
        } else if (btn == this.____1190) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.welfareTab)
        } else if (btn == this.____1007) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.copyTab)
        } else if (btn == this.____1364) {
            this._controller.____253()
        } else if (btn == this.____1549) {
            var userId = ____655.____669.getAUnreadPlayerId();
            if (userId == null) return;
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_friend);
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_friendSelectItem, ____654.____672, userId))
        } else if (btn == this.____1179) {
            this._controller.showFriendResponsePanel()
        } else if (btn == this.____1178) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup)
        } else if (btn == this.____1488) {
            this._controller.showOnlineAwardPanel()
        } else if (btn == this.____1663) {
            this._controller.showSetPanel()
        } else if (btn == this.____878) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.bossTab)
        } else if (btn == this.____1229) {
            ____654.____679.____155(____655.____659.____690.home)
        } else if (btn == this.____1343) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.llTab)
        } else if (btn == this.____1859) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.warPlaceTab)
        } else if (btn == this.____1882) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab)
        } else if (btn == this.____1571) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.weaponTabGroup)
        } else if (btn == this._tuJianBtn) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.tuJianTab)
        } else if (btn == this.____1577) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.rankTab)
        } else if (btn == this.____1141) {
            if (____655.copyInfo.currentId > 0) {
                ____655.getAlert().show(2, ____655.allTemplates.copyTemplateList.getExitDes(____655.copyInfo.currentId), null, 0, this, exitCopy, null, null)
            } else {
                ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_flyToMap, ____654.____672, ____655.allTemplates.mapTemplateList.CITY_ID))
            }
        } else if (btn == this._xianweiBtn) {
            this._controller.showXianWeiTipView()
        } else if (btn == this.____1843) {
            if (!____655.____663.getCurrent().isPay) {
                ____654.tipsManager.quickTip.show("VIP未开放，敬请期待！");
                return
            }
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.vipTab)
        } else if (btn == this._returnGiftBtn) {
            this._controller.showReturnGiftPanel()
        } else if (btn.getActType() > 0) {
            var type = btn.getActType();
            if (this._timeBtnList[type] == btn) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.llTab, ____655.____659.panelTabType.active);
                ____654.____672.dispatchEvent(new ____590(____655.____661.timing_active_jumpTo, ____654.____672, type))
            } else if (this._actBtnList[type] == btn) {
                if (type == 15) {
                    this._controller.showPrePayPanel()
                } else if (type == 39) {
                    var weeksDay = ____655.____662.getClientDate().getDay();
                    if (weeksDay == 0) {
                        weeksDay = 7
                    }
                    var type = 0;
                    if (weeksDay >= 1 && weeksDay <= 3) {
                        type = 1
                    } else if (weeksDay >= 4 && weeksDay <= 7) {
                        type = 2
                    }
                    ____654.____672.dispatchEvent(new ____590(____655.____661.open_luckyTreasurePanel, ____654.____672, type))
                } else if (type == 40) {
                    if (____655.____667.clubId != 0 || ____655.familyTreasuresInfo.isNoClubButHasTask()) {
                        this._controller.showFamilyTreasuresPanel()
                    } else {
                        ____655.getAlert().show(6, ____654.yuyanbaoManager.getYuyanbao("FamilyTreasuresPanel.text6"), null, 5, this, this.noClubCallBack, null, null)
                    }
                }
            }
        } else if (btn == this._openBtn) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.openTab)
        } else if (btn == this._loginGiftBtn) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.loginGiftTab)
        } else if (btn == this._feiXianBtn) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.feiXianTab)
        } else if (btn == this._openLeiChongBtn) {
            ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.openLeiChongTab)
        } else if (btn == this._dailyRechargeBtn) {
            this._dailyRechargeBtn.setEffect(false);
            this._controller.showDailyFirstRechargePanel()
        } else if (btn == this._clubBossIconBtn) {
            var clubBossState = ____655.clubInfo.clubBossState;
            if (clubBossState == 2 || clubBossState == 1) {
                ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_club, 5)
            }
        } else if (btn == this._kuozhanIconBtn) {
            this._controller.showKuozhanGiftPanel()
        } else if (btn == this._waiXingChongjieBtn) {
            this._waiXingChongjieBtn.setEffect(false);
            this._controller.showWaiXingChongJiePanel()
        }
    },
    noClubCallBack: function() {
        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.sheJiaoGroup, ____655.____659.panelTabType.sheJiao_club, 2)
    },
    giftBtnUpdate: function() {
        return;
        var day = ____655.____662.getClientDate().getDay();
        if (day == 0) {
            day = 7
        }
        var openDay = ____655.____662.getBetweenTimeDay(____655.____665, ____655.____662.getSystemTimeSec()) + 1;
        var list = ____655.allTemplates.payTemplateList.getTemplateInfoList();
        if (this._giftFlag) {
            this._giftTempList = [];
            for (var i = 0; i < list.length; i++) {
                if (list[i].payType >= 10 && list[i].sort > 0 && openDay >= list[i].beginDay && openDay <= list[i].endDay) {
                    if (list[i].weekDay == 0 || day == list[i].weekDay) {
                        if (this._giftTempList[list[i].sort - 1] == null) {
                            this._giftTempList[list[i].sort - 1] = []
                        }
                        this._giftTempList[list[i].sort - 1].push(list[i])
                    }
                }
            }
            this._giftFlag = false;
            var time = 86400 - ____655.____662.getZeroPassTime();
            this.____1190.setTime(4, time, 1)
        }
        var isBreak = false;
        for (var i = 0; i < this._giftTempList.length; i++) {
            var infoList = this._giftTempList[i];
            if (infoList != null) {
                for (var j = 0; j < infoList.length; j++) {
                    var hasBuyCount = ____655.welfareInfo.zhuanShuGiftList[infoList[j].id];
                    if (hasBuyCount == null || infoList[j].limitCount > hasBuyCount) {
                        if (this._giftBtnPath != null) {
                            ____654.____677.removeImageQuote(this._giftBtnPath, this.____1190)
                        }
                        this.____1190.changeImage(____654.____675.____139("outPic/ui_welfareGiftIcon" + infoList[j].pic + ".png"));
                        isBreak = true;
                        break
                    }
                }
            }
            if (isBreak) {
                break
            }
        }
        if (!isBreak && this._giftTempList[0] != null && this._giftTempList[0][0] != null) {
            if (this._giftBtnPath != null) {
                ____654.____677.removeImageQuote(this._giftBtnPath, this.____1190)
            }
            this.____1190.changeImage(____654.____675.____139("outPic/ui_welfareGiftIcon" + this._giftTempList[0][0].pic + ".png"))
        }
    },
    mailUpdate: function(evt) {
        var num = -1;
        if (evt != null) {
            num = evt.data
        }
        if (num < 0) {
            if (this.____1364 != null) {
                var index = this.____904.indexOf(this.____1364);
                if (index > -1) {
                    this.____904.splice(index, 1)
                }
                this.____1364.dispose();
                this.____1364 = null;
                this.updateBtnList(2)
            }
        } else {
            if (this.____1364 == null) {
                this.____1364 = new ____2285("sceneIcon/mainmenu_btn31.png", 1);
                this.____1364.setCallback(this.clickHandler, this);
                this.____904.push(this.____1364);
                this.updateBtnList(2)
            }
            this.____1364.setShowNumPop(num)
        }
    },
    deleteFriendHander: function(evt) {
        this.privateChatUpdate()
    },
    chatHandler: function(evt) {
        var info = evt.data;
        if (info != null && info.channel != ____655.____659.____693.system) {
            if (info.message.charAt(0) == " ") {
                return
            }
            if (!____655.chatPanelFlag) {
                this._sceneChatView.show(info)
            }
            if (info.channel == ____655.____659.____693.privat) {
                this.privateChatUpdate()
            }
            if (____655.chatPanelFlag == false && (info.channel == ____655.____659.____693.clubNotice || info.channel == ____655.____659.____693.club)) {
                this.____957.setClubImg(true)
            }
        }
    },
    privateChatUpdate: function(evt) {
        var num = ____655.____669.____39();
        if (num <= 0) {
            if (this.____1549 != null) {
                var index = this.____904.indexOf(this.____1549);
                if (index > -1) {
                    this.____904.splice(index, 1)
                }
                this.____1549.dispose();
                this.____1549 = null;
                this.updateBtnList(2)
            }
        } else {
            if (this.____1549 == null) {
                this.____1549 = new ____2285("sceneIcon/mainmenu_btn32.png", 1);
                this.____1549.setCallback(this.clickHandler, this);
                this.____904.push(this.____1549);
                this.updateBtnList(2)
            }
            this.____1549.setShowNumPop(num)
        }
    },
    friendResponseUpdate: function() {
        var num = ____655.____668.responseList.length;
        if (num <= 0) {
            if (this.____1179 != null) {
                var index = this.____904.indexOf(this.____1179);
                if (index > -1) {
                    this.____904.splice(index, 1)
                }
                this.____1179.dispose();
                this.____1179 = null;
                this.updateBtnList(2)
            }
        } else {
            if (this.____1179 == null) {
                this.____1179 = new ____2285("sceneIcon/mainmenu_btn33.png", 1);
                this.____1179.setCallback(this.clickHandler, this);
                this.____904.push(this.____1179);
                this.updateBtnList(2)
            }
            this.____1179.setShowNumPop(num)
        }
    },
    exitHandler: function(evt) {
        var isShow = evt.data;
        if (isShow) {
            if (this.____1141 == null) {
                this.____1141 = new ____2283("sceneIcon/ui_exitIcon.png", 1);
                this.____1141.setCallback(this.clickHandler, this);
                this.____1141.move(____655.____656 - 50, ____655.____657 - 185)
            }
            var activityInfo = ____654.copyTester.getActivityInfo(____655.copyInfo.currentId);
            if (activityInfo != null && activityInfo.templateId != 2 && activityInfo.templateId != 3 && activityInfo.templateId != 5) {
                var dtime = activityInfo.endTime - ____655.____662.getZeroPassTime();
                if (dtime > 0) {
                    this.____1141.setTime(3, dtime)
                }
            } else {
                this.____1141.setLabel(null)
            }
        } else {
            if (this.____1141 != null) {
                this.____1141.dispose();
                this.____1141 = null
            }
        }
    },
    fightModeHandler: function(evt) {
        var fightMode = evt.data;
        if (fightMode == this._fightMode) {
            return
        }
        this._fightMode = fightMode;
        this.____957.moveX(____655.____656 * 0.5 - 250);
        this.____1663.moveX(45);
        if (this._fightMode == 0) {
            this.____1266 = true;
            this._sceneChatView.setPositionX(____655.____656 * 0.5 - 204);
            this.____1406.setFold(this.____1266);
            this._btnList4X = ____655.____656 + 588;
            this.resetIconPos();
            this.____1682.hide();
            this._afkBtn.hideIcon();
            this.showIcon(1);
            this.showIcon(2);
            this.showIcon(3);
            this.showIcon(4);
            this.showIcon(5);
            this.showIcon(6);
            if (this._yugaoTipsLayer != null && this._yugaoTipsLayer.getParent() == null) {
                ____654.____676.mainMenuBgContainer.addChild(this._yugaoTipsLayer, 0)
            }
            if (this.____1141 != null) {
                this.____1141.hideIcon()
            }
            this._isFightUI = false
        } else if (this._fightMode == 1) {
            this.____1682.show();
            this._afkBtn.showIcon();
            this.showIcon(1);
            this.showIcon(2);
            this.hideIcon(3);
            this.hideIcon(4);
            this.showIcon(5);
            this.showIcon(6);
            this._sceneChatView.setPositionX(____655.____656 * 0.5 - 204);
            if (this._yugaoTipsLayer != null && this._yugaoTipsLayer.getParent() == null) {
                ____654.____676.mainMenuBgContainer.addChild(this._yugaoTipsLayer, 0)
            }
            if (this.____1141 != null) {
                this.____1141.showIcon()
            }
            this._isFightUI = true
        } else {
            this.____1682.show();
            this._afkBtn.showIcon();
            this.hideIcon(1);
            this.hideIcon(2);
            this.hideIcon(3);
            this.hideIcon(4);
            this.hideIcon(5);
            this.hideIcon(6);
            this._sceneChatView.setPositionX(____655.____656 * 0.5 - 204);
            if (this._yugaoTipsLayer != null) {
                this._yugaoTipsLayer.removeFromParent(false)
            }
            if (this.____1141 != null) {
                this.____1141.showIcon()
            }
            this._isFightUI = true
        }
    },
    headClickHandler: function(evt) {
        if (this._fightMode == 2) {
            return
        }
        var value = evt.data;
        if (this._fightMode == 0) {
            if (value == null) {
                value = !this.____1266
            }
            this.foldMenu(value)
        } else {
            if (value == null) {
                value = !this._isFightUI
            }
            this.changeFightUI(value)
        }
    },
    changeFightUI: function(isFightUI) {
        if (this._isFightUI == isFightUI) {
            return
        }
        this._isFightUI = isFightUI;
        if (this._isFightUI) {
            this.____957.moveX(____655.____656 * 0.5 - 250);
            this.____1663.moveX(45);
            this.____1682.show();
            this._afkBtn.showIcon();
            this.hideIcon(3);
            this.hideIcon(4);
            this._sceneChatView.setPositionX(____655.____656 * 0.5 - 204);
            if (this.____1141 != null) {
                this.____1141.showIcon()
            }
        } else {
            this.____1682.hide();
            this._afkBtn.hideIcon();
            this.showIcon(3);
            this.showIcon(4);
            this._sceneChatView.setPositionX(90);
            this.____1266 = false;
            this.____1406.setFold(this.____1266);
            this._btnList4X = ____655.____656 - 127;
            this.resetIconPos();
            this.____957.moveX(45);
            this.____1663.moveX(-45);
            if (this.____1141 != null) {
                this.____1141.hideIcon()
            }
        }
    },
    returnGiftUpdate: function(evt) {
        if (evt == null) {
            evt = {};
            evt.data = null
        }
        var lastTimeOnLine = ____655.statInfo.returnGiftInfo.lastTimeOnLine;
        var backTime = ____655.statInfo.returnGiftInfo.backTime;
        var hour = (backTime - lastTimeOnLine) / 3600;
        var zeroTime = ____655.____662.____1888;
        var dd = ____655.____662.getBetweenTimeDay(backTime - zeroTime, ____655.____662.getSystemTimeSec() - zeroTime);
        if ((____655.statInfo.returnGiftInfo.isLeftGetAward != 1 || ____655.statInfo.returnGiftInfo.isRightGetAward != 1) && hour >= 48 && dd == 0 && ____655.____667.xianwei > 1 && evt.data == null) {
            if (this._returnGiftBtn == null) {
                this._returnGiftBtn = new ____2283(____654.____675.____139("outPic/comeBackIcon.png"), 0);
                this._returnGiftBtn.setCallback(this.clickHandler, this);
                this.____904.push(this._returnGiftBtn);
                this.updateBtnList(2)
            }
        } else {
            if (this._returnGiftBtn != null) {
                var index = this.____904.indexOf(this._returnGiftBtn);
                if (index > -1) {
                    this.____904.splice(index, 1)
                }
                this._returnGiftBtn.dispose();
                this._returnGiftBtn = null;
                this.updateBtnList(2)
            }
        }
    },
    openIconUpdate: function() {
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        if (____655.____667.level >= ____655.____659.levelType.openLevel && openDay < 8) {
            var remainTime = ____655.____662.secondsOfDay - ____655.____662.getZeroPassTime();
            if (this._openBtn == null) {
                this._openBtn = new ____2283("activity/101.png", 1);
                this._openBtn.setCallback(this.clickHandler, this);
                this._openBtn.index = 4;
                this.____903.push(this._openBtn);
                this.updateBtnList(1)
            }
            this._openBtn.setTime(4, remainTime)
        } else {
            if (this._openBtn != null) {
                var index = this.____903.indexOf(this._openBtn);
                if (index > -1) {
                    this.____903.splice(index, 1)
                }
                this._openBtn.dispose();
                this._openBtn = null;
                this.updateBtnList(1)
            }
        }
    },
    loginGiftIconUpdate: function() {
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        if (____655.____667.level >= ____655.____659.levelType.loginGiftLevel && openDay < 8) {
            if (this._loginGiftBtn == null) {
                var remainTime = 7 * ____655.____662.secondsOfDay + ____655.____665 - ____655.____662.getSystemTimeSec();
                this._loginGiftBtn = new ____2283("activity/102.png", 1);
                this._loginGiftBtn.setCallback(this.clickHandler, this);
                this._loginGiftBtn.index = 3;
                this._loginGiftBtn.setTime(4, remainTime);
                this.____903.push(this._loginGiftBtn);
                this._loginGiftBtn.setShowPop(____654.playerInfoTester.loginGiftNum > 0);
                this.updateBtnList(1)
            }
        } else {
            if (this._loginGiftBtn != null) {
                var index = this.____903.indexOf(this._loginGiftBtn);
                if (index > -1) {
                    this.____903.splice(index, 1)
                }
                this._loginGiftBtn.dispose();
                this._loginGiftBtn = null;
                this.updateBtnList(1)
            }
        }
    },
    feiXianIconUpdate: function() {
        var openDay = ____655.____662.getDayByCreatRoleTime();
        if (____655.____667.level >= ____655.____659.levelType.feixianLevel && openDay < 8) {
            if (this._feiXianBtn == null) {
                var createZoreTime = ____655.____667.createRoleTime * 0.001 - ((____655.____667.createRoleTime * 0.001 + ____655.____662.____1888) % ____655.____662.secondsOfDay);
                var remainTime = (7 * ____655.____662.secondsOfDay) + createZoreTime - ____655.____662.getSystemTimeSec();
                this._feiXianBtn = new ____2283("activity/103.png", 1);
                this._feiXianBtn.setEffect(true);
                this._feiXianBtn.setCallback(this.clickHandler, this);
                this._feiXianBtn.index = 5;
                this._feiXianBtn.setTime(4, remainTime);
                this._feiXianBtn.setShowPop((____654.playerInfoTester.feixianGift1Num + ____654.playerInfoTester.feixianGift2Num + ____654.playerInfoTester.feixianGift3Num + ____654.playerInfoTester.feixianGift4Num + ____654.playerInfoTester.feixianGift5Num + ____654.playerInfoTester.feixianGift6Num + ____654.playerInfoTester.feixianGift7Num) > 0);
                this.____903.push(this._feiXianBtn);
                this.updateBtnList(1);
                this.popUpdate()
            }
        } else {
            if (this._feiXianBtn != null) {
                var index = this.____903.indexOf(this._feiXianBtn);
                if (index > -1) {
                    this.____903.splice(index, 1)
                }
                this._feiXianBtn.dispose();
                this._feiXianBtn = null;
                this.updateBtnList(1)
            }
        }
    },
    openLeiChongIconUpdate: function() {
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        var chongZhiScore = ____655.____667.moneyInfo.getChongZhiScore(____655.____665);
        if (openDay < 2 && chongZhiScore < 1280) {
            if (this._openLeiChongBtn == null) {
                var remainTime = ____655.____662.secondsOfDay + ____655.____665 - ____655.____662.getSystemTimeSec();
                this._openLeiChongBtn = new ____2283("activity/104.png", 1);
                this._openLeiChongBtn.setEffect(true);
                this._openLeiChongBtn.setCallback(this.clickHandler, this);
                this._openLeiChongBtn.index = 6;
                this._openLeiChongBtn.setTime(4, remainTime);
                this.____903.push(this._openLeiChongBtn);
                this.updateBtnList(1)
            }
        } else {
            if (this._openLeiChongBtn != null) {
                var index = this.____903.indexOf(this._openLeiChongBtn);
                if (index > -1) {
                    this.____903.splice(index, 1)
                }
                this._openLeiChongBtn.dispose();
                this._openLeiChongBtn = null;
                this.updateBtnList(1)
            }
        }
    },
    waiXingChongjieUpdate: function(refresh) {
        var flag = false;
        if (____655.____667.level >= ____655.____659.levelType.waiXingChongJieLevel) {
            var actInfo = ____655.openInfo.waiXingChongJieInfo;
            if (actInfo.tempId > 0) {
                var tempInfo = ____655.allTemplates.openActivityTemplateList.waiXingChongJieList[actInfo.tempId];
                var systemTime = ____655.____662.getSystemTimeSec();
                var beginSecond = ____655.____662.getTimesByDay(tempInfo.openServerBegin);
                var finishSecond = ____655.____662.getTimesByDay(tempInfo.openServerEnd);
                if (finishSecond > systemTime && beginSecond <= systemTime) {
                    flag = true
                }
            }
        }
        if (flag) {
            var this_ = this;

            function callBack() {
                this_.waiXingChongjieUpdate(true)
            };
            if (this._waiXingChongjieBtn == null) {
                this._waiXingChongjieBtn = new ____2283("sceneIcon/mainmeun_btn25.png", 1);
                this._waiXingChongjieBtn.setCallback(this.clickHandler, this);
                var passTime = ____655.____662.getZeroPassTime();
                var surplusTime = ____655.____662.secondsOfDay - passTime;
                this._waiXingChongjieBtn.setTime(4, surplusTime, 0, callBack);
                this._waiXingChongjieBtn.index = 4;
                this._waiXingChongjieBtn.setEffect(true);
                this._waiXingChongjieBtn.setShowPop(____655.openInfo.waiXingChongJieInfo.state == 0);
                this.____903.push(this._waiXingChongjieBtn);
                this.updateBtnList(1)
            } else {
                this._waiXingChongjieBtn.setEffect(____655.openInfo.waiXingChongJieInfo.state == 0);
                this._waiXingChongjieBtn.setShowPop(____655.openInfo.waiXingChongJieInfo.state == 0)
            }
            if (refresh == true) {
                var passTime = ____655.____662.getZeroPassTime();
                var surplusTime = ____655.____662.secondsOfDay - passTime;
                this._waiXingChongjieBtn.setTime(4, surplusTime, 0, callBack)
            }
        } else {
            if (this._waiXingChongjieBtn != null) {
                var index = this.____903.indexOf(this._waiXingChongjieBtn);
                if (index > -1) {
                    this.____903.splice(index, 1)
                }
                this._waiXingChongjieBtn.dispose();
                this._waiXingChongjieBtn = null;
                this.updateBtnList(1)
            }
        }
    },
    dailyRechargeIconUpdate: function() {
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        var rechargeValue = ____655.____667.moneyInfo.getTodayRecharge();
        var condition = ____655.allTemplates.dailyFirstRechargeTemplateList.getMaxCondition();
        if (openDay > 1 && rechargeValue < condition && ____655.____667.level >= ____655.____659.levelType.dailyFirstRechargeLevel) {
            if (this._dailyRechargeBtn == null) {
                this._dailyRechargeBtn = new ____2283("sceneIcon/mainmenu_btn24.png", 1);
                this._dailyRechargeBtn.setCallback(this.clickHandler, this);
                this._dailyRechargeBtn.index = 7;
                this._isDailyFisrtEffect = true;
                this.____903.push(this._dailyRechargeBtn);
                this.updateBtnList(1)
            }
            if (this._isDailyFisrtEffect) {
                this._isDailyFisrtEffect = false;
                this._dailyRechargeBtn.setEffect(true)
            }
        } else {
            if (this._dailyRechargeBtn != null) {
                var index = this.____903.indexOf(this._dailyRechargeBtn);
                if (index > -1) {
                    this.____903.splice(index, 1)
                }
                this._dailyRechargeBtn.dispose();
                this._dailyRechargeBtn = null;
                this.updateBtnList(1)
            }
        }
    },
    clubBossIconUpdate: function() {
        var clubBossState = ____655.clubInfo.clubBossState;
        var clubBossTime = ____655.clubInfo.clubBossTime;
        if (clubBossState == 1 || clubBossState == 2) {
            var remainTime = 0;
            if (this._clubBossIconBtn == null) {
                this._clubBossIconBtn = new ____2283("activity/105.png", 1);
                this._clubBossIconBtn.setEffect(true);
                this._clubBossIconBtn.setCallback(this.clickHandler, this);
                this._btnList6.push(this._clubBossIconBtn);
                this.updateBtnList(6)
            }
            if (clubBossState == 1) {
                this._clubBossIconBtn.setLabel("60s")
            } else {
                remainTime = clubBossTime + 15 * 60 - ____655.____662.getSystemTimeSec();
                this._clubBossIconBtn.setTime(3, remainTime)
            }
        } else {
            if (this._clubBossIconBtn != null) {
                var index = this._btnList6.indexOf(this._clubBossIconBtn);
                if (index > -1) {
                    this._btnList6.splice(index, 1)
                }
                this._clubBossIconBtn.dispose();
                this._clubBossIconBtn = null;
                this.updateBtnList(6)
            }
        }
    },
    afkChangeHandler: function(evt) {
        this._afkBtn.setAfk(evt.data)
    },
    updateAllBtn: function() {
        this.updateBtnList(1);
        this.updateBtnList(2);
        this.updateBtnList(3);
        this.updateBtnList(4);
        this.updateBtnList(5);
        this.updateBtnList(6)
    },
    updateBtnList: function(type) {
        function btnSortHandler(btn1, btn2) {
            return btn1.index - btn2.index
        };
        var list = null;
        var offsetX = 0;
        var offsetY = 0;
        var addOffset = -80;
        if (type == 1) {
            list = this.____903;
            offsetX = ____655.____656 - 50;
            offsetY = ____655.____657 - 40;
            list.sort(btnSortHandler)
        } else if (type == 2) {
            list = this.____904;
            offsetX = ____655.____656 - 50;
            offsetY = ____655.____657 - 120
        } else if (type == 3) {
            list = this.____905;
            offsetX = ____655.____656 - 45;
            offsetY = 60;
            addOffset = 90
        } else if (type == 4) {
            list = this.____906;
            offsetX = this._btnList4X;
            offsetY = 60;
            addOffset = -90
        } else if (type == 5) {
            list = this.____907;
            offsetX = 60;
            offsetY = ____655.____657 - 134;
            addOffset = 80
        } else if (type == 6) {
            list = this._btnList6;
            offsetX = ____655.____656 * 0.5 + 40 - 40 * list.length;
            offsetY = 155;
            addOffset = 80
        }
        var len = list.length;
        for (var i = 0; i < len; i++) {
            var btn = list[i];
            if (btn.getVisible()) {
                btn.move(offsetX, offsetY);
                if (type == 3) {
                    offsetY += addOffset
                } else {
                    offsetX += addOffset
                }
            }
        }
    },
    showIcon: function(type) {
        if (this._isShowList[type - 1] == true) {
            return
        }
        var list = null;
        if (type == 1) {
            list = this.____903
        } else if (type == 2) {
            list = this.____904
        } else if (type == 3) {
            list = this.____905
        } else if (type == 4) {
            list = this.____906
        } else if (type == 5) {
            list = this.____907
        } else if (type == 6) {
            list = this._btnList6
        }
        for (var i = 0; i < list.length; i++) {
            if (list[i].getVisible()) {
                list[i].showIcon()
            }
        }
        this._isShowList[type - 1] = true
    },
    hideIcon: function(type) {
        if (this._isShowList[type - 1] == false) {
            return
        }
        var list = null;
        if (type == 1) {
            list = this.____903
        } else if (type == 2) {
            list = this.____904
        } else if (type == 3) {
            list = this.____905
        } else if (type == 4) {
            list = this.____906
        } else if (type == 5) {
            list = this.____907
        } else if (type == 6) {
            list = this._btnList6
        }
        for (var i = 0; i < list.length; i++) {
            list[i].hideIcon()
        }
        this._isShowList[type - 1] = false
    },
    actIconUpdate: function(evt) {
        var list = ____655.activityIconList.activityIcons;
        for (var type in list) {
            var info = list[type];
            if (info != null) {
                var btn = this._actBtnList[type];
                if (info.isShow == true && btn == null) {
                    var tempInfo = ____655.allTemplates.timingActivityTemplateList.____238(info.type);
                    if (tempInfo == null) {
                        continue
                    }
                    btn = new ____2283("activity/" + tempInfo.path + ".png", 1);
                    btn.setActType(type);
                    btn.setCallback(this.clickHandler, this);
                    btn.setEffect(true);
                    btn.index = info.type;
                    this.____903.push(btn);
                    this._actBtnList[type] = btn;
                    var playerLevel = ____655.____667.level;
                    if (playerLevel < tempInfo.level) {
                        btn.hideIcon();
                        btn.setVisible(false)
                    } else if (this._isShowList[0] == false) {
                        btn.hideIcon()
                    }
                    this.updateBtnList(1)
                } else if (info.isShow == false && btn != null) {
                    var index = this.____903.indexOf(btn);
                    if (index >= 0) {
                        this.____903.splice(index, 1)
                    }
                    btn.dispose();
                    this._actBtnList[type] = null;
                    this.updateBtnList(1)
                }
            }
        }
    },
    timeIconUpdate: function(evt) {
        var type = evt.data;
        if (this._timeBtnList[type] == null) {
            var tempInfo = ____655.allTemplates.timingActivityTemplateList.____238(type);
            var btn = new ____2283("activity/" + tempInfo.path + ".png", 1);
            btn.setActType(type);
            btn.setCallback(this.clickHandler, this);
            this._btnList6.push(btn);
            this._timeBtnList[type] = btn;
            var templateInfo = ____655.allTemplates.timingActivityTemplateList.____238(type);
            var playerLevel = ____655.____667.level;
            if (playerLevel < templateInfo.level) {
                btn.hideIcon();
                btn.setVisible(false)
            } else if (this._isShowList[5] == false) {
                btn.hideIcon()
            }
            this.updateBtnList(6)
        }
        var info = ____655.activityIconList.timingIcons[type];
        if (this._timeBtnList[type] != null) {
            if (info.timeType == 0) {
                this._timeBtnList[type].setLabel(____655.____662.secondsToDateString3(info.endTime) + "o")
            } else if (info.timeType == 1) {
                var time = Math.floor(info.endTime - ____655.____662.getZeroPassTime() + 0.5);
                this._timeBtnList[type].setTime(3, time);
                this._timeBtnList[type].setEffect(true)
            }
        }
    },
    timeIconRemove: function(evt) {
        var type = evt.data;
        btn = this._timeBtnList[type];
        if (btn != null) {
            var index = this._btnList6.indexOf(btn);
            if (index >= 0) {
                this._btnList6.splice(index, 1)
            }
            btn.dispose();
            this._timeBtnList[type] = null;
            this.updateBtnList(6)
        }
    },
    exitTimeUpdate: function(evt) {
        var time = evt.data;
        if (____655.copyInfo.currentId == 0) {
            return
        }
        if (this.____1141 == null) {
            return
        }
        this.____1141.setTime(3, time)
    },
    show: function() {
        if (this._isShow == true) {
            return
        }
        if (this.____1004.getParent() == null) {
            ____654.____676.mainMenuBgContainer.addChild(this.____1004, 0)
        }
        if (this._fightMode == 0) {
            this.____1682.hide();
            this._afkBtn.hideIcon();
            this.showIcon(1);
            this.showIcon(2);
            this.showIcon(3);
            this.showIcon(4);
            this.showIcon(5);
            this.showIcon(6)
        } else if (this._fightMode == 1) {
            this.____1682.show();
            this._afkBtn.showIcon();
            this.showIcon(1);
            this.showIcon(2);
            this.showIcon(5);
            this.showIcon(6)
        } else {
            this.____1682.show();
            this._afkBtn.showIcon()
        }
        if (this.____1141 != null) {
            this.____1141.showIcon()
        }
        if (this._yugaoTipsLayer != null && this._fightMode != 2 && this._yugaoTipsLayer.getParent() == null) {
            ____654.____676.mainMenuBgContainer.addChild(this._yugaoTipsLayer)
        }
        if (this._sceneChatView.getParent() == null) {
            ____654.____676.mainMenuBgContainer.addChild(this._sceneChatView)
        }
        this._isShow = true
    },
    hide: function() {
        if (this._isShow == false) {
            return
        }
        this.____1004.removeFromParent(false);
        this.____1682.hide();
        this._afkBtn.hideIcon();
        this.hideIcon(1);
        this.hideIcon(2);
        this.hideIcon(3);
        this.hideIcon(4);
        this.hideIcon(5);
        this.hideIcon(6);
        if (this.____1141 != null) {
            this.____1141.hideIcon()
        }
        if (this._yugaoTipsLayer != null) {
            this._yugaoTipsLayer.removeFromParent(false)
        }
        if (this._sceneChatView.getParent() != null) {
            this._sceneChatView.removeFromParent(false)
        }
        this._isShow = false
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 1) {
            if (this._returnGiftBtn != null) {
                this._returnGiftBtn.setShowPop(____654.playerInfoTester.returnGiftNum > 0)
            }
        }
        if (type == 0 || type == 2) {
            if (this._loginGiftBtn != null) {
                this._loginGiftBtn.setShowPop(____654.playerInfoTester.loginGiftNum > 0)
            }
        }
        if (type == 0 || type == 3 || type == 4 || type == 5 || type == 6 || type == 7 || type == 8 || type == 9) {
            if (this._feiXianBtn != null) {
                this._feiXianBtn.setShowPop((____654.playerInfoTester.feixianGift1Num + ____654.playerInfoTester.feixianGift2Num + ____654.playerInfoTester.feixianGift3Num + ____654.playerInfoTester.feixianGift4Num + ____654.playerInfoTester.feixianGift5Num + ____654.playerInfoTester.feixianGift6Num + ____654.playerInfoTester.feixianGift7Num) > 0)
            }
        }
        if (type == 0 || type == 10) {
            if (this._openBtn != null) {
                this._openBtn.setShowPop(____654.playerInfoTester.fudaiNum > 0)
            }
        }
        if (type == 0 || type == 11 || type == 12 || type == 13) {
            if (this.____1190 != null) {
                this.____1190.setShowPop((____654.playerInfoTester.monthCardNum + ____654.playerInfoTester.weekSignNum + ____654.playerInfoTester.recoverNum) > 0)
            }
        }
        if (type == 0 || type == 14) {
            if (this.____1843 != null) {
                this.____1843.setShowPop(____654.playerInfoTester.vipGiftNum > 0)
            }
        }
        if (type == 0 || type == 15 || type == 32 || type == 33) {
            if (this.____1598 != null) {
                this.____1598.setShowPop((____654.playerInfoTester.fasionNum + ____654.playerInfoTester.bagItemNum + ____654.playerInfoTester.bagEquipNum) > 0)
            }
        }
        if (type == 0 || type == 16 || type == 17 || type == 18 || type == 19 || type == 20) {
            if (this.____1571 != null) {
                this.____1571.setShowPop((____654.playerInfoTester.weaponGodNum + ____654.playerInfoTester.weaponStrengthNum + ____654.playerInfoTester.weaponBaoshiNum + ____654.playerInfoTester.wuhunNum + ____654.playerInfoTester.rongluNum) > 0)
            }
        }
        if (type == 0 || type == 21 || type == 22 || type == 23 || type == 24 || type == 63 || type == 64) {
            if (this.____1178 != null) {
                this.____1178.setShowPop((____654.playerInfoTester.clubShenqingNum + ____654.playerInfoTester.clubXinfaNum + ____654.playerInfoTester.clubExpeditionNum + ____654.playerInfoTester.clubTreeNum + ____654.playerInfoTester.marryNum + ____654.playerInfoTester.oathNum) > 0)
            }
        }
        if (type == 0 || type == 25 || type == 26 || type == 27 || type == 28 || type == 29 || type == 30 || type == 31 || type == 67) {
            if (this._tuJianBtn != null) {
                this._tuJianBtn.setShowPop((____654.playerInfoTester.tujianSJNum + ____654.playerInfoTester.tujianMWNum + ____654.playerInfoTester.tujianSXNum + ____654.playerInfoTester.tujianSBNum + ____654.playerInfoTester.tujianBWNum + ____654.playerInfoTester.tujianAwardNum + ____654.playerInfoTester.huanZhuangAwardNum + ____654.playerInfoTester.tujianYaoJingNum) > 0)
            }
        }
        if (type == 0 || type == 34 || type == 35 || type == 36 || type == 37 || type == 38 || type == 39 || type == 40 || type == 41 || type == 42 || type == 43 || type == 55 || type == 56 || type == 57 || type == 58 || type == 59 || type == 60 || type == 61) {
            if (this.____1882 != null) {
                this.____1882.setShowPop((____654.playerInfoTester.riderNum + ____654.playerInfoTester.petNum + ____654.playerInfoTester.wingNum + ____654.playerInfoTester.footNum + ____654.playerInfoTester.fabaoNum + ____654.playerInfoTester.zhenlingNum + ____654.playerInfoTester.shenjianNum + ____654.playerInfoTester.fashionRiderNum + ____654.playerInfoTester.fashingPetNum + ____654.playerInfoTester.fashingWingNum + ____654.playerInfoTester.hunpoRiderNum + ____654.playerInfoTester.hunpoWindNum + ____654.playerInfoTester.hunpoFaBaoNum + ____654.playerInfoTester.hunpoZhenLingNum + ____654.playerInfoTester.hunpoShenJianNum + ____654.playerInfoTester.hunpoFootNum + ____654.playerInfoTester.hunpoPetNum) > 0)
            }
        }
        if (type == 0 || type == 44 || type == 45) {
            if (this.____878 != null) {
                this.____878.setShowPop((____654.playerInfoTester.personBossNum + ____654.playerInfoTester.shenjiangNum) > 0)
            }
        }
        if (type == 0 || type == 46) {
            if (this.____1859 != null) {
                this.____1859.setShowPop(____654.playerInfoTester.doushentanNum > 0)
            }
        }
        if (type == 0 || type == 47) {
            if (this.____1343 != null) {
                this.____1343.setShowPop(____654.playerInfoTester.lilianNum > 0)
            }
        }
        if (type == 0 || type == 48 || type == 49 || type == 50 || type == 51 || type == 52 || type == 53 || type == 66) {
            if (this.____1007 != null) {
                this.____1007.setShowPop((____654.playerInfoTester.copyXiuxianNum + ____654.playerInfoTester.copyWaiguanNum + ____654.playerInfoTester.copyCailiaoNum + ____654.playerInfoTester.copyYaotaNum + ____654.playerInfoTester.copyTongtianNum + ____654.playerInfoTester.copyShouhuNum + ____654.playerInfoTester.copyXianJieNum) > 0)
            }
        }
        if (type == 0 || type == 62) {
            if (this._actBtnList[39] != null) {
                this._actBtnList[39].setShowPop(____654.playerInfoTester.luckyTreasureNum > 0)
            }
        }
        if (type == 0 || type == 65) {
            if (this.____1229 != null) {
                this.____1229.setShowPop((____654.playerInfoTester.homeNum) > 0)
            }
        }
        if (type == 0 || type == 68) {
            if (this._actBtnList[40] != null) {
                this._actBtnList[40].setShowPop((____654.playerInfoTester.familyTreasuresNum) > 0)
            }
        }
        if (type == 0 || type == 70) {
            if (this._openBtn != null) {
                this._openBtn.setShowPop(____654.playerInfoTester.openChongBangNum > 0)
            }
        }
        var isShow = ____654.playerInfoTester.fasionNum + ____654.playerInfoTester.bagItemNum + ____654.playerInfoTester.bagEquipNum + ____654.playerInfoTester.weaponGodNum + ____654.playerInfoTester.weaponStrengthNum + ____654.playerInfoTester.weaponBaoshiNum + ____654.playerInfoTester.wuhunNum + ____654.playerInfoTester.rongluNum + ____654.playerInfoTester.clubShenqingNum + ____654.playerInfoTester.clubXinfaNum + ____654.playerInfoTester.clubExpeditionNum + ____654.playerInfoTester.clubTreeNum + ____654.playerInfoTester.tujianSJNum + ____654.playerInfoTester.tujianMWNum + ____654.playerInfoTester.tujianSXNum + ____654.playerInfoTester.tujianSBNum + ____654.playerInfoTester.tujianBWNum + ____654.playerInfoTester.tujianAwardNum + ____654.playerInfoTester.riderNum + ____654.playerInfoTester.petNum + ____654.playerInfoTester.wingNum + ____654.playerInfoTester.footNum + ____654.playerInfoTester.fabaoNum + ____654.playerInfoTester.zhenlingNum + ____654.playerInfoTester.shenjianNum + ____654.playerInfoTester.fashionRiderNum + ____654.playerInfoTester.fashingPetNum + ____654.playerInfoTester.fashingWingNum + ____654.playerInfoTester.hunpoRiderNum + ____654.playerInfoTester.hunpoWindNum + ____654.playerInfoTester.hunpoFaBaoNum + ____654.playerInfoTester.hunpoZhenLingNum + ____654.playerInfoTester.hunpoShenJianNum + ____654.playerInfoTester.hunpoFootNum + ____654.playerInfoTester.hunpoPetNum + ____654.playerInfoTester.huanZhuangAwardNum + ____654.playerInfoTester.marryNum + ____654.playerInfoTester.oathNum + ____654.playerInfoTester.homeNum + ____654.playerInfoTester.tujianYaoJingNum > 0;
        this.____1406.setShowPop(isShow);
        if (this._controller.headViewPanel != null) {
            this._controller.headViewPanel.____1645.setShowPop(isShow)
        }
    },
    reset: function() {},
    dispose: function() {
        this.____17();
        this._controller = null;
        if (this.____1004 != null) {
            this.____1004.dispose();
            this.____1004 = null
        }
        var i = 0;
        for (i = 0; i < this.____903.length; i++) {
            this.____903[i].dispose()
        }
        this.____903 = null;
        for (i = 0; i < this.____904.length; i++) {
            this.____904[i].dispose()
        }
        this.____904 = null;
        for (i = 0; i < this.____905.length; i++) {
            this.____905[i].dispose()
        }
        this.____905 = null;
        for (i = 0; i < this.____906.length; i++) {
            this.____906[i].dispose()
        }
        this.____906 = null;
        for (i = 0; i < this.____907.length; i++) {
            this.____907[i].dispose()
        }
        this.____907 = null;
        for (i = 0; i < this._btnList6.length; i++) {
            this._btnList6[i].dispose()
        }
        this._btnList6 = null;
        this._isShowList = null;
        this._actBtnList = null;
        this._timeBtnList = null;
        if (this._sceneChatView != null) {
            this._sceneChatView.dispose();
            this._sceneChatView = null
        }
    },
});
var ____2270 = KYPanel.extend({
    _closeBtn: null,
    ____1370: null,
    ____1369: null,
    _personMark: null,
    _controller: null,
    _bgPath: null,
    ____1376: null,
    ____1126: null,
    _posList: null,
    ctor: function(scenePanelController) {
        this.____1376 = [1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009];
        this._posList = [____654.____673.____159(468, 351), ____654.____673.____159(700, 433), ____654.____673.____159(742, 279), ____654.____673.____159(679, 123), ____654.____673.____159(493, 152), ____654.____673.____159(240, 116), ____654.____673.____159(200, 289), ____654.____673.____159(216, 465), ____654.____673.____159(413, 521)];
        this._super("worldMapPanel.ExportJson");
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1369 = this.getChildByName("mapBg");
        this._personMark = this.getChildByName("personMark");
        this.____1370 = [];
        for (var i = 1; i < 10; i++) {
            this.____1370.push(this.getChildByName("mapBtn" + i))
        }
        this._bgPath = ____654.____675.____139("outPic/ui_worldMap.png");
        ____654.____677.____146(this.____1369, this._bgPath);
        var index = ____654.____674.____181(this.____1376, ____655.currentMapId);
        if (index != -1) {
            this._personMark.setVisible(true);
            if (this.____1126 == null) {
                this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.WORLDMAP_EFFECT, false, ____654.____673.____159(24.5, 24.5), this._personMark)
            }
            this._personMark.setPosition(this._posList[index])
        } else {
            this._personMark.setVisible(false)
        }
        this.modeValue = 100;
        this.____6()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        for (var i = 0; i < this.____1370.length; i++) {
            this.____1370[i].addListener(this, this.____16)
        }
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this)
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else {
                for (var i = 0; i < this.____1370.length; i++) {
                    if (sender == this.____1370[i]) {
                        if (i == 8) {
                            ____654.tipsManager.quickTip.show("该地图暂未开放！");
                            return
                        }
                        var map = ____655.allTemplates.mapTemplateList.getMap(this.____1376[i]);
                        if (____655.____667.level < map.minLevel) {
                            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("worldmap.text1", map.minLevel));
                            return
                        }
                        print("进入地图ID", this.____1376[i]);
                        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_flyToMap, ____654.____672, this.____1376[i]));
                        return
                    }
                }
            }
        }
    },
    dispose: function() {
        this.____17();
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        ____654.____677.removeImageQuote(this._bgPath, this.____1369);
        this._bgPath = null;
        this._super();
        this._controller = null;
        this._closeBtn = null;
        this.____1370 = null;
        this.____1369 = null;
        this.____1376 = null;
        this._personMark = null;
        this._posList = null
    },
});
var OnlineAwardPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____1185: null,
    ____892: null,
    _nameLabel: null,
    ____1204: null,
    _countDownUtils: null,
    _itemInfoList: null,
    ctor: function(scenePanelController) {
        this._super("onlineAwardPanel.ExportJson");
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____1185 = this.getChildByName("getBtn");
        this.____892 = this.getChildByName("btnLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1204 = [];
        this._itemInfoList = [];
        for (var i = 0; i < 4; i++) {
            var grid = new ____2129(false);
            this.____1204.push(grid);
            this.getChildByName("cell" + (i + 1)).addChild(grid);
            this._itemInfoList.push(null)
        }
        this.____6();
        this.onlineInfoUpdate(null)
    },
    ____6: function() {
        this.____1185.addListener(this, this.getClickHandler);
        this._closeBtn.addListener(this, this.closeClickHandler);
        ____655.statInfo.addEventListener(____655.____661.stat_online_update, this.onlineInfoUpdate, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.stat_online_update, this.onlineInfoUpdate, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    getClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.statMessageSender.sendOnlineAwardGet()
        }
    },
    closeClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            this.dispose()
        }
    },
    onlineInfoUpdate: function(evt) {
        var this_ = this;

        function countDownComplete() {
            doCountComplete()
        };

        function doCountComplete() {
            ____654.____674.setKYBtnEnabled(this_.____1185, true, 1);
            this_.____892.setString("领取")
        };
        ____654.____674.setKYBtnEnabled(this_.____1185, false, 1);
        if (____655.statInfo.onlineAward_time == -1) {
            this_.____892.setString("领取完")
        } else if (____655.statInfo.onlineAward_time == 0) {} else {
            var itemInfos = ____655.statInfo.onlineAward_items;
            var len = itemInfos.length;
            for (var i = 0; i < 4; i++) {
                var info = itemInfos[i];
                var templateInfo = ____655.allTemplates.____794.getItem(info[0]);
                if (this._itemInfoList[i] != null) {
                    this._itemInfoList[i].dispose()
                }
                this._itemInfoList[i] = new ItemInfo();
                this._itemInfoList[i].____107(info[0]);
                this._itemInfoList[i].count = info[1];
                this._itemInfoList[i].qhLevel = info[2];
                this._itemInfoList[i].quality = info[3];
                this.____1204[i].setItemInfo(this._itemInfoList[i])
            }
            var itemTmp = ____655.allTemplates.____794.getItem(itemInfos[0][0]);
            this._nameLabel.setString(itemTmp.name);
            if (____655.____659.categoryType.isWaiXingEquip(itemTmp.categoryId)) {
                this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTmp.quality + itemInfos[0][2]))
            } else {
                this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTmp.quality))
            }
            var leftTime = ____655.statInfo.onlineAward_time - ____655.____662.getSystemTimeSec();
            if (leftTime <= 0) {
                doCountComplete()
            } else {
                if (this._countDownUtils == null) {
                    this._countDownUtils = new ____2111();
                    this._countDownUtils.setLabel(this.____892, 0, 0, null)
                }
                this._countDownUtils.start(leftTime, null, countDownComplete, null)
            }
        }
    },
    clear: function() {
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
    },
    dispose: function() {
        this.____17();
        this._super();
        this._controller = null;
        this._closeBtn = null;
        this.____1185 = null;
        this.____892 = null;
        this._nameLabel = null;
        if (this.____1204 != null) {
            for (var i = 0; i < this.____1204.length; i++) {
                this.____1204[i].dispose()
            }
            this.____1204 = null
        }
        if (this._itemInfoList != null) {
            for (var i = 0; i < this._itemInfoList.length; i++) {
                if (this._itemInfoList[i] != null) {
                    this._itemInfoList[i].dispose()
                }
            }
            this._itemInfoList = null
        }
        this.clear()
    },
});
var OverCountDownView = KYPanel.extend({
    _controller: null,
    _num: 0,
    _numImg: null,
    _count: 0,
    _executor: null,
    _callBack: null,
    ____857: null,
    _titleLabel: null,
    ctor: function(controller, num, title, callBack, executor) {
        this._super();
        this._controller = controller;
        this._executor = executor;
        this._callBack = callBack;
        this._num = num;
        this._numImg = new NumberView();
        this._numImg.setType(3, null, 2);
        this._numImg.setString(this._num);
        this.addChild(this._numImg, 4);
        this.____857 = ____654.____673.newKYImageView();
        this.____857.setFrame("bar/ui_bar17.png");
        this.____857.setScale9Enabled(true);
        this.____857.setCapInsets(____654.____673.____161(10, 17, 117, 1));
        this.____857.setSize(____654.____673.____160(400, 160));
        this.addChild(this.____857, 2);
        if (title != null) {
            this._titleLabel = ____654.____673.newKYLabel(22);
            this._titleLabel.setColor(____655.____659.____688.lightGreen);
            this._titleLabel.setString(title);
            this._titleLabel.setPositionY(52);
            this.addChild(this._titleLabel, 21)
        }
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._count++;
        if (this._count >= 60) {
            this._num = this._num - 1;
            this._count = 0;
            this._numImg.setString(this._num);
            if (this._num <= 0) {
                if (this._executor != null) {
                    this._callBack.call(this._executor)
                }
                this._controller.hideOverCountDownView()
            }
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this._num = null;
        this._count = null;
        this._executor = null;
        this._callBack = null;
        this._controller = null;
        if (this._numImg != null) {
            this._numImg.dispose();
            this._numImg = null
        }
        if (this.____857 != null) {
            this.____857.dispose();
            this.____857 = null
        }
        if (this._titleLabel != null) {
            this._titleLabel.dispose();
            this._titleLabel = null
        }
        this._super()
    },
});
var DailyFirstRechargePanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____869: null,
    ____872: null,
    ____870: null,
    ____873: null,
    _bg3: null,
    _bgPath3: null,
    _rechargeBtnImg: null,
    _rechargeBtnImgPath: null,
    ____1421: null,
    _itemNameLabel: null,
    ____1736: null,
    _gridList: null,
    ____895: null,
    _rechargeBtn: null,
    _hasGotFlag: null,
    _onlyOneFlag: null,
    _conditionList: null,
    ____1637: -1,
    ctor: function(controller) {
        this._super("dailyFirstRechargePanel.ExportJson");
        this._controller = controller;
        this._closeBtn = this.getChildByName("closeBtn");
        this.____869 = this.getChildByName("bg1");
        this.____872 = ____654.____675.____139("outPic/dailyFirstRechargeBg1.png");
        ____654.____677.____146(this.____869, this.____872);
        this.____870 = this.getChildByName("bg2");
        this.____873 = ____654.____675.____139("outPic/dailyFirstRechargeBg2.png");
        ____654.____677.____146(this.____870, this.____873);
        this._bg3 = this.getChildByName("bg3");
        this._bgPath3 = ____654.____675.____139("outPic/ui_payPanelBg2.png");
        ____654.____677.____146(this._bg3, this._bgPath3);
        this._rechargeBtnImg = this.getChildByName("rechargeBtnImg");
        this._rechargeBtnImgPath = ____654.____675.____139("outPic/dailyFR_btnBg.png");
        ____654.____677.____146(this._rechargeBtnImg, this._rechargeBtnImgPath);
        this._rechargeBtn = this.getChildByName("rechargeBtn");
        this.____1421 = this.getChildByName("moneyLabel");
        this._itemNameLabel = this.getChildByName("itemNameLabel");
        this._hasGotFlag = this.getChildByName("hasGotFlag");
        this._onlyOneFlag = this.getChildByName("ImageView_1197143");
        this.____1736 = [];
        this.____895 = [];
        for (var k = 1; k <= 4; k++) {
            this.____1736.push(this.getChildByName("tabBtn" + k));
            this.____895.push(this.getChildByName("btnLabel" + k))
        }
        this._gridList = [];
        for (var i = 1; i <= 5; i++) {
            var gridBg = this.getChildByName("cell" + i);
            var grid = new ____2129();
            gridBg.addChild(grid);
            this._gridList.push(grid)
        }
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.closeBtnClick);
        for (var i = 0; i < this.____1736.length; i++) {
            this.____1736[i].addListener(this, this.tabBtnClickHandler)
        }
        this._rechargeBtn.addListener(this, this.rechargeBtnClickHandler);
        ____655.dailyFirstRechargeInfo.addEventListener(____655.____661.dailyRechargeInfoUpdate, this.updateView, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____655.dailyFirstRechargeInfo.removeEventListener(____655.____661.dailyRechargeInfoUpdate, this.updateView, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____5: function() {
        this._conditionList = ____655.allTemplates.dailyFirstRechargeTemplateList.getConditionList();
        var rechargeValue = ____655.____667.moneyInfo.getTodayRecharge();
        var index = 0;
        var flag = true;
        for (var i = 0; i < this.____1736.length; i++) {
            if (this._conditionList[i] == null) {
                this.____1736[i].setVisible(false);
                this.____895[i].setVisible(false)
            } else {
                this.____895[i].setString(____654.yuyanbaoManager.getYuyanbao("DailyFirstRechargePanel.text1", this._conditionList[i] / 10));
                if (flag && this._conditionList[i] > rechargeValue) {
                    index = i;
                    flag = false
                }
            }
        }
        this.____225(index)
    },
    ____225: function(index) {
        if (this.____1637 == index || this.____1736[index] == null) return;
        if (this.____1736[this.____1637] != null) {
            this.____1736[this.____1637].setFrame("btn/ui_btn1_1.png")
        }
        this.____1736[index].setFrame("btn/ui_btn1_2.png");
        this.____1637 = index;
        var tempInfo = ____655.allTemplates.dailyFirstRechargeTemplateList.____55(this._conditionList[index]);
        if (tempInfo != null) {
            for (var i = 0; i < tempInfo.awardList.length; i++) {
                if (this._gridList[i] != null) {
                    var itemTemplateInfo = ____655.allTemplates.____794.getItem(tempInfo.awardList[i][0]);
                    this._gridList[i].setItemTemplateInfo(itemTemplateInfo);
                    this._gridList[i].setCount(tempInfo.awardList[i][1]);
                    if (i == 0) {
                        this._itemNameLabel.setString(itemTemplateInfo.name);
                        this._itemNameLabel.setColor(____655.____659.____688.getColorByQuality(itemTemplateInfo.quality))
                    }
                }
            }
            this._onlyOneFlag.setVisible(tempInfo.isShowFlag == 1)
        }
        this.updateView()
    },
    updateView: function() {
        var rechargeValue = ____655.____667.moneyInfo.getTodayRecharge();
        var condition = this._conditionList[this.____1637];
        if (rechargeValue >= condition) {
            this.____1421.setString(0);
            this._rechargeBtn.setVisible(false);
            this._rechargeBtnImg.setVisible(false);
            this._hasGotFlag.setVisible(true)
        } else {
            this.____1421.setString((condition - rechargeValue) / 10);
            this._rechargeBtn.setVisible(true);
            this._rechargeBtnImg.setVisible(true);
            this._hasGotFlag.setVisible(false)
        }
    },
    tabBtnClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this.____1736.indexOf(sender);
            if (index != -1) {
                this.____225(index)
            }
        }
    },
    rechargeBtnClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            this.dispose();
            ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
        }
    },
    closeBtnClick: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this.dispose()
        }
    },
    dispose: function() {
        this.____17();
        if (this.____872 != null) {
            ____654.____677.removeImageQuote(this.____872, this.____869);
            this.____872 = null
        }
        this.____869 = null;
        if (this.____873 != null) {
            ____654.____677.removeImageQuote(this.____873, this.____870);
            this.____873 = null
        }
        this.____870 = null;
        if (this._bgPath3 != null) {
            ____654.____677.removeImageQuote(this._bgPath3, this._bg3);
            this._bgPath3 = null
        }
        this._bg3 = null;
        if (this._rechargeBtnImgPath != null) {
            ____654.____677.removeImageQuote(this._rechargeBtnImgPath, this._rechargeBtnImg);
            this._rechargeBtnImgPath = null
        }
        this._rechargeBtnImg = null;
        this._controller = null;
        this._closeBtn = null;
        this.____1421 = null;
        this._itemNameLabel = null;
        this.____1736 = null;
        this.____895 = null;
        this._rechargeBtn = null;
        this._hasGotFlag = null;
        this._conditionList = null;
        this.____1637 = null;
        this._onlyOneFlag = null;
        for (var i = 0; i < this._gridList.length; i++) {
            this._gridList[i].dispose();
            this._gridList[i] = null
        }
        this._gridList = null;
        this._super()
    },
});
var ____2272 = KYNode.extend({
    _bg: null,
    ____848: null,
    ____1544: null,
    ____1022: null,
    ____1023: null,
    ____1531: null,
    _bgPath: null,
    ____1756: null,
    ctor: function(templateInfo) {
        this._super("payItemView.ExportJson");
        this.____1756 = templateInfo;
        this._bg = this.getChildByName("bg");
        this.____848 = this.getChildByName("awardFlag");
        this.____1544 = this.getChildByName("priceLabel");
        this.____1022 = this.getChildByName("countLabel1");
        this.____1023 = this.getChildByName("countLabel2");
        this.____1531 = this.getChildByName("plusIcon");
        this._bgPath = ____654.____675.____139("outPic/ui_payItemIcon" + this.____1756.pic + ".png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.____1544.setString(____654.yuyanbaoManager.getYuyanbao("____2272.text1", this.____1756.price));
        this.____1022.setString(this.____1756.count);
        var tempId = this.____1756.id;
        var count = ____655.welfareInfo.firsRechargeList[tempId % 10];
        if (!!count && count > 0) {
            this.____1023.setString(this.____1756.gift_yuanbao);
            this.____848.setVisible(false)
        } else {
            this.____1023.setString(this.____1756.first_yuanbao);
            if (this.____1756.plat == 3) {
                this.____848.setVisible(true)
            } else {
                this.____848.setVisible(false)
            }
        }
    },
    ____6: function() {
        ____655.welfareInfo.addEventListener(____655.____661.welfare_ZhuanShuUpdate, this.updateView, this)
    },
    ____17: function() {
        ____655.welfareInfo.removeEventListener(____655.____661.welfare_ZhuanShuUpdate, this.updateView, this)
    },
    updateView: function(evt) {
        this.____5()
    },
    ____238: function() {
        return this.____1756
    },
    dispose: function() {
        this.____17();
        this._super();
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this.____1756 = null;
        this._bg = null;
        this.____848 = null;
        this.____1544 = null;
        this.____1022 = null;
        this.____1023 = null;
        this.____1531 = null
    },
});
var PayItemGift = KYNode.extend({
    _nameLabel: null,
    _icon: null,
    ____919: null,
    _countDownUtils: null,
    ____1418: null,
    _giveLabel: null,
    _countLabel: null,
    _oldPriceLabel: null,
    _newPriceLabel: null,
    _sellOutIcon: null,
    _controller: null,
    _curInfoList: null,
    _payTempInfo: null,
    _count: 0,
    ____1238: null,
    ____1758: null,
    ____1053: -1,
    ____1499: null,
    ____1400: 0,
    _intervalTime: 0,
    ____1770: 0,
    ____1771: 0,
    _tickCount3: 0,
    ____1165: 1,
    ____1478: 227,
    _starPos: null,
    ctor: function(controller) {
        this._super("payItemGiftView.ExportJson");
        this._controller = controller;
        this._nameLabel = this.getChildByName("nameLabel");
        this._icon = this.getChildByName("icon");
        this._icon.setScale(1.3);
        this.____919 = this.getChildByName("buyBtn");
        this.____1418 = this.getChildByName("moneyIcon");
        this._giveLabel = this.getChildByName("giveLabel");
        this._countLabel = this.getChildByName("countLabel");
        this._oldPriceLabel = this.getChildByName("priceLabel1");
        this._newPriceLabel = this.getChildByName("priceLabel2");
        this._sellOutIcon = this.getChildByName("sellOutIcon");
        this._sellOutIcon.setVisible(false);
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("timeLabel"), 0, 0, null);
        this.setTouchEnabled(true);
        this._curInfoList = [];
        this.____1758 = [];
        this.getChildByName("desLabel").setString(____654.yuyanbaoManager.getYuyanbao("WelfareZhuanShuGiftItemView.text1"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this.addListener(this, this.thisClickHandler, this.thisDownHandler, this.thisUpHandler);
        this.____919.addListener(this, this.____16);
        ____655.welfareInfo.addEventListener(____655.____661.welfare_ZhuanShuUpdate, this.updateInfo, this)
    },
    ____17: function() {
        ____655.welfareInfo.addEventListener(____655.____661.welfare_ZhuanShuUpdate, this.updateInfo, this)
    },
    ____5: function() {
        var time = 86400 - ____655.____662.getZeroPassTime();
        this._countDownUtils.start(time, null, null, null);
        var day = ____655.____662.getClientDate().getDay();
        if (day == 0) {
            day = 7
        }
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        var list = ____655.allTemplates.payTemplateList.getTemplateInfoList();
        for (var i = 0; i < list.length; i++) {
            if (list[i].payType >= 10 && list[i].sort > 0 && openDay >= list[i].beginDay && openDay < list[i].endDay) {
                if (list[i].weekDay == 0 || day == list[i].weekDay) {
                    if (this.____1758[list[i].sort - 1] == null) {
                        this.____1758[list[i].sort - 1] = [];
                        this.____1400++
                    }
                    this.____1758[list[i].sort - 1].push(list[i])
                }
            }
        }
        this.____1499 = new ____2145(this.____1400, 30);
        this.getChildByName("pageViewLayer").addChild(this.____1499);
        var isBreak = false;
        var index = 0;
        for (var i = 0; i < this.____1758.length; i++) {
            var infoList = this.____1758[i];
            for (var j = 0; j < infoList.length; j++) {
                var hasBuyCount = ____655.welfareInfo.zhuanShuGiftList[infoList[j].id];
                if (hasBuyCount == null || infoList[j].limitCount > hasBuyCount) {
                    this.setPage(i);
                    isBreak = true;
                    break
                }
            }
            if (isBreak) {
                break
            }
        }
        if (!isBreak) {
            this.setPage(0)
        }
        this.setFloat(true, 3)
    },
    updateInfo: function() {
        if (this._curInfoList == null || this._curInfoList.length <= 0) return;
        this._count = 0;
        this._payTempInfo = this._curInfoList[this._curInfoList.length - 1];
        for (var i = 0; i < this._curInfoList.length; i++) {
            var hasBuyCount = ____655.welfareInfo.zhuanShuGiftList[this._curInfoList[i].id];
            if (hasBuyCount == null) {
                hasBuyCount = 0
            }
            if (this._curInfoList[i].limitCount > hasBuyCount) {
                this._count = this._curInfoList[i].limitCount - hasBuyCount;
                this._payTempInfo = this._curInfoList[i];
                break
            }
        }
        this.updateView()
    },
    updateView: function() {
        var itemTempInfo = ____655.allTemplates.____794.getItem(this._payTempInfo.award[0][0]);
        this._nameLabel.setString(itemTempInfo.name);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTempInfo.quality));
        this._giveLabel.setString(this._payTempInfo.descript);
        this._oldPriceLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2272.text1", this._payTempInfo.oldPrice));
        this._newPriceLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2272.text1", this._payTempInfo.price));
        this._countLabel.setString(this._count);
        if (this._count <= 0) {
            ____654.shaderCache.setColor(this.____919, 1);
            this.____919.setTouchEnabled(false);
            this._sellOutIcon.setVisible(true)
        } else {
            ____654.shaderCache.setColor(this.____919, 0);
            this.____919.setTouchEnabled(true);
            this._sellOutIcon.setVisible(false)
        }
        if (this.____1238 != null) {
            ____654.____677.removeImageQuote(this.____1238, this._icon)
        }
        this.____1238 = ____654.____675.____139("outPic/ui_welfareGiftIcon" + this._payTempInfo.pic + ".png");
        ____654.____677.____146(this._icon, this.____1238)
    },
    setFloat: function(isOn, intervalTime) {
        this._intervalTime = intervalTime * 60;
        if (isOn != null && isOn) {
            ____654.____678.____298(this.tick, this)
        } else {
            ____654.____678.____299(this.tick, this)
        }
    },
    tick: function(delta, count) {
        this.____1770++;
        if (this.____1770 >= this._intervalTime) {
            this.____1771++;
            if (this.____1771 > 1) {
                this.____1771 = 0;
                this.____1478 += this.____1165;
                if (this.____1478 < 227 || this.____1478 > 233) {
                    this.____1165 = -this.____1165;
                    this._tickCount3++;
                    if (this.____1165 > 0 && this._tickCount3 > 3) {
                        this._tickCount3 = 0;
                        this.____1770 = 0
                    }
                }
                this._icon.setPositionY(this.____1478)
            }
        }
    },
    thisDownHandler: function(sender, eventType, pos) {
        this._starPos = pos
    },
    thisUpHandler: function(sender, eventType, pos) {
        var startPos = this._starPos;
        var endPos = pos;
        if (!!startPos) {
            if (startPos.x - endPos.x > 50) {
                this.setPage(this.____1053 + 1)
            } else if (startPos.x - endPos.x < -50) {
                this.setPage(this.____1053 - 1)
            }
        }
    },
    thisClickHandler: function(sender, eventType, pos) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var startPos = this._starPos;
            var endPos = pos;
            if (!!startPos) {
                if (Math.abs(startPos.x - endPos.x) > 50) {
                    return
                }
            }
            if (this._payTempInfo != null) {
                var hasBuyCount = ____655.welfareInfo.zhuanShuGiftList[this._payTempInfo.id];
                if (hasBuyCount == null || this._payTempInfo.limitCount > hasBuyCount) {
                    ____654.____672.dispatchEvent(new ____590(____655.____661.welfare_ZhuanShuShowBuyView, ____654.____672, this._payTempInfo.id))
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._payTempInfo != null) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.welfare_ZhuanShuShowBuyView, ____654.____672, this._payTempInfo.id))
            }
        }
    },
    setPage: function(page) {
        if (page < 0) {
            page = 0
        }
        if (page > this.____1400) {
            page = this.____1400
        }
        if (this.____1053 == page) {
            return
        }
        this.____1499.setPage(page);
        this.____1053 = page;
        this._curInfoList = this.____1758[page];
        this.updateInfo()
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        this._intervalTime = null;
        this.____1770 = null;
        this.____1771 = null;
        this.____1165 = null;
        this.____1478 = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        if (this.____1499 != null) {
            this.____1499.dispose();
            this.____1499 = null
        }
        this._nameLabel = null;
        if (this.____1238 != null) {
            ____654.____677.removeImageQuote(this.____1238, this._icon)
        }
        this.____1238 = null;
        this._icon = null;
        this.____919 = null;
        this.____1418 = null;
        this._giveLabel = null;
        this._countLabel = null;
        this._oldPriceLabel = null;
        this._newPriceLabel = null;
        this._sellOutIcon = null;
        this._controller = null;
        this._curInfoList = null;
        this._payTempInfo = null;
        this._count = null;
        this._starPos = null;
        this._super()
    },
});
var PayPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _bg: null,
    ____1798: null,
    ____1846: null,
    ____1544: null,
    _rechargeBar: null,
    _barLeft: null,
    _barRight: null,
    _nameLabel: null,
    ____851: null,
    ____1284: null,
    _timeLabel: null,
    _zhuanShuGiftView: null,
    _labMaxLevel: null,
    _imgPay: null,
    _imgPay2: null,
    _imgPay3: null,
    ____1418: null,
    _bgPath: null,
    ____873: null,
    _isHideGift: true,
    ____1845: null,
    _itemList: null,
    ctor: function(scenePanelController) {
        this._super("payPanel.ExportJson");
        this.modeValue = 200;
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this._bg = this.getChildByName("bg");
        this.____870 = this.getChildByName("bg2");
        this.____1798 = this.getChildByName("titleLabel1");
        var vipLayer = this.getChildByName("vipLayer");
        this.____1845 = new ____2288();
        this.____1845.setScale(1);
        this.____1845.setPosition(____654.____673.____159(50, 50));
        vipLayer.addChild(this.____1845);
        this.____1846 = this.getChildByName("vipLabel");
        this.____1544 = this.getChildByName("priceLabel");
        this._rechargeBar = this.getChildByName("rechargeBar");
        this._barLeft = this.getChildByName("barLeft");
        this._barRight = this.getChildByName("barRight");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____851 = this.getChildByName("awardLabel");
        this.____1284 = this.getChildByName("itemIcon");
        this._timeLabel = this.getChildByName("timeLabel");
        this._labMaxLevel = this.getChildByName("labMaxLevel");
        this._imgPay = this.getChildByName("ImageView_781388_Copy0");
        this._imgPay2 = this.getChildByName("ImageView_781388");
        this._imgPay3 = this.getChildByName("ImageView_781391");
        this.____1418 = this.getChildByName("ImageView_1038081");
        this._bgPath = ____654.____675.____139("outPic/ui_payPanelBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____5();
        this.____6();
        ____654.____676.hideBack()
    },
    ____5: function() {
        var list = ____655.allTemplates.payTemplateList.getRechargeList();
        this._itemList = [];
        if (this._isHideGift) {
            for (var i = 0; i < list.length; i++) {
                var item = new ____2272(list[i]);
                item.addListener(this, this.buyClickHandler);
                var pos = ____654.____673.____159(260 + (228 * (i % 3)), 235 - (219 * Math.floor(i / 3)));
                item.setPosition(pos);
                this.addChild(item, i);
                this._itemList.push(item)
            }
            this.____873 = ____654.____675.____139("outPic/ui_payPanelBg2.png");
            ____654.____677.____146(this.____870, this.____873)
        } else {
            this.____873 = null;
            for (var i = 0; i < list.length; i++) {
                var item = new ____2272(list[i]);
                item.addListener(this, this.buyClickHandler);
                var pos = ____654.____673.____159(17 + (228 * (i % 3)), 235 - (219 * Math.floor(i / 3)));
                item.setPosition(pos);
                this.addChild(item, i);
                this._itemList.push(item)
            }
            this._zhuanShuGiftView = new PayItemGift(this._controller);
            this.addChild(this._zhuanShuGiftView, 3);
            this._zhuanShuGiftView.setPosition(____654.____673.____159(704, 15))
        }
        this.vipUpdate()
    },
    setPercent: function(per) {
        if (per == 0) {
            this._barLeft.setVisible(false);
            this._barRight.setVisible(false)
        } else {
            this._barLeft.setVisible(true);
            this._barRight.setVisible(true);
            this._barRight.setPositionX(329 + 4.76 * per)
        }
        this._rechargeBar.setPercent(per)
    },
    vipUpdate: function(evt) {
        var curLevel = ____655.____667.vipLevel;
        this.____1845.setLevelLabel(curLevel);
        var nextVipTemp = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(curLevel + 1);
        if (!!nextVipTemp && curLevel < ____655.allTemplates.vipTemplateList.maxLevel) {
            var moneyInfo = ____655.____667.moneyInfo.list[3];
            this.____1846.setString(curLevel + 1);
            this.____1544.setString(nextVipTemp.maxExp - moneyInfo);
            var curVipTempCount = 0;
            if (curLevel > 0) {
                curVipTempCount = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(curLevel).maxExp
            }
            var percent = Math.min(100, Math.max(0, Math.floor((moneyInfo - curVipTempCount) / (nextVipTemp.maxExp - curVipTempCount) * 100)));
            this.setPercent(percent)
        } else {
            this._labMaxLevel.setVisible(true);
            this._labMaxLevel.setString("您当前的VIP已经满级");
            this._labMaxLevel.setPositionX(408);
            this._imgPay.setVisible(false);
            this._imgPay2.setVisible(false);
            this._imgPay3.setVisible(false);
            this.____1418.setVisible(false);
            this.____1846.setVisible(false);
            this.____1544.setVisible(false);
            this.setPercent(100)
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        ____655.statInfo.addEventListener(____655.____661.vip_awardUpdate, this.vipUpdate, this);
        ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.close, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.vip_awardUpdate, this.vipUpdate, this);
        ____654.____672.removeEventListener(____655.____661.global_dayUpdate, this.close, this)
    },
    close: function() {
        this.dispose()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            }
        }
    },
    buyClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var payInfo = sender.____238();
            print("点击充值", payInfo.id);
            ____654.sdk.pay(payInfo, function(retCode, vals) {
                print("########pay return！");
                if (retCode == 0) {
                    print("充值成功！！！！")
                } else if (retCode == 1) {
                    print("充值失败！！！！")
                } else if (retCode == 2) {
                    print("充值取消！！！！")
                }
            })
        }
    },
    dispose: function() {
        ____654.____676.showBack();
        this.____17();
        this._super();
        this._isHideGift = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this.____873 != null) {
            ____654.____677.removeImageQuote(this.____873, this.____870);
            this.____873 = null
        }
        this.____870 = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this.____1845.dispose();
        this.____1845 = null;
        this._controller = null;
        this._closeBtn = null;
        this.____1798 = null;
        this.____1846 = null;
        this.____1544 = null;
        this._rechargeBar = null;
        this._barLeft = null;
        this._barRight = null;
        this._nameLabel = null;
        this.____851 = null;
        this.____1284 = null;
        this._timeLabel = null;
        this._labMaxLevel = null;
        this._imgPay = null;
        this._imgPay2 = null;
        this._imgPay3 = null;
        this.____1418 = null;
        if (this._zhuanShuGiftView != null) {
            this._zhuanShuGiftView.dispose();
            this._zhuanShuGiftView = null
        }
    },
});
var RelivePanel = KYPanel.extend({
    _controller: null,
    _timeLabel: null,
    ____886: null,
    ____887: null,
    ____1094: null,
    _tickCount: 0,
    _timeCount1: 30,
    _timeCount2: 10,
    ctor: function(scenePanelController) {
        this._super("relivePanel.ExportJson");
        this._controller = scenePanelController;
        this._timeLabel = this.getChildByName("timeLabel");
        this._timeLabel.setString(this._timeCount1);
        this.____886 = this.getChildByName("btn1");
        this.____887 = this.getChildByName("btn2");
        this.____1094 = this.getChildByName("btnLabel1");
        this.____1094.setString("安全复活 " + this._timeCount2);
        this.getChildByName("btnLabel2").setString("10 钻原地复活");
        this.____886.addListener(this, this.____234);
        this.____887.addListener(this, this.____235);
        ____654.____674.setKYBtnEnabled(this.____886, false, 0);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____678.____298(this.tick, this)
    },
    ____234: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.sceneModule.sceneMessageSender.sendPlayerRelive(1)
        }
    },
    ____235: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.sceneModule.sceneMessageSender.sendPlayerRelive(2)
        }
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tickCount = 0;
            this._timeCount1--;
            this._timeCount2--;
            this._timeLabel.setString(this._timeCount1);
            if (this._timeCount2 > 0) {
                this.____1094.setString("安全复活 " + this._timeCount2)
            } else {
                this.____1094.setString("安全复活");
                ____654.____674.setKYBtnEnabled(this.____886, true, 1)
            }
            if (this._timeCount1 == 0) {
                ____654.____678.____299(this.tick, this);
                this._controller.sceneModule.sceneMessageSender.sendPlayerRelive(1)
            }
        }
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    dispose: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._timeLabel = null;
        this.____886 = null;
        this.____887 = null;
        this.____1094 = null;
        this._tickCount = null;
        this._timeCount1 = null;
        this._timeCount2 = null;
        this._super()
    },
});
var RoleXianWeiTipView = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _xianWeiLabel: null,
    _xianWeiLabel1: null,
    _condition1: null,
    _condition2: null,
    _trueFlag1: null,
    _trueFlag2: null,
    ____1783: null,
    _content: null,
    ctor: function(controller) {
        this._super("xianWeiTipPanel.ExportJson");
        this._controller = controller;
        this._closeBtn = this.getChildByName("closeBtn");
        this._xianWeiLabel = this.getChildByName("xianWeiLabel");
        this._xianWeiLabel1 = this.getChildByName("xianWeiLabel1");
        this._condition1 = this.getChildByName("condition1");
        this._condition2 = this.getChildByName("condition2");
        this._trueFlag1 = this.getChildByName("trueFlag1");
        this._trueFlag2 = this.getChildByName("trueFlag2");
        this.____1783 = this.getChildByName("tipLabel");
        this._content = this.getChildByName("content");
        this.____6();
        this.____5()
    },
    ____5: function() {
        var xianWei = ____655.____667.xianwei;
        var playerLevel = ____655.____667.level;
        var playerFight = ____655.____667.combat;
        this._xianWeiLabel.setString(____655.____659.nameType.getXianweiName(xianWei));
        this._xianWeiLabel1.setString(____655.____659.nameType.getXianweiName(xianWei + 1));
        var templateInfo = ____655.allTemplates.xianWeiTemplateList.list[xianWei + 1];
        this._condition1.setString(____654.yuyanbaoManager.getYuyanbao("RoleXianWeiTipView.text1", templateInfo.level));
        this._condition2.setString(____654.yuyanbaoManager.getYuyanbao("RoleXianWeiTipView.text2", templateInfo.fightValue));
        if (playerLevel >= templateInfo.level) {
            this._condition1.setColor(____655.____659.____688.green);
            this._trueFlag1.setVisible(true)
        } else {
            this._condition1.setColor(____655.____659.____688.itemColorList[0]);
            this._trueFlag1.setVisible(false)
        }
        if (playerFight >= templateInfo.fightValue) {
            this._condition2.setColor(____655.____659.____688.green);
            this._trueFlag2.setVisible(true)
        } else {
            this._condition2.setColor(____655.____659.____688.itemColorList[0]);
            this._trueFlag2.setVisible(false)
        }
        this.____1783.setString(____654.yuyanbaoManager.getYuyanbao("RoleXianWeiTipView.text3"));
        this._content.setString(____654.____682.____108("10076"))
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this._controller.hideXianWeiTipView()
            }
        }
    },
    hideFormContainer: function() {
        this._controller.hideXianWeiTipView()
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        this._controller = null;
        this._closeBtn = null;
        this._xianWeiLabel = null;
        this._xianWeiLabel1 = null;
        this._condition1 = null;
        this._condition2 = null;
        this._trueFlag1 = null;
        this._trueFlag2 = null;
        this.____1783 = null;
        this._content = null;
        this._super()
    },
});
var GmPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    checkList: null,
    currectIndex: null,
    _inputController: null,
    ____1398: 100,
    sendBtn: null,
    detailLabel: null,
    ctor: function(scenePanelController) {
        this._super("GMPanel.ExportJson");
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this.sendBtn = this.getChildByName("sendBtn");
        this.checkList = [];
        for (var i = 1; i <= 4; i++) {
            var check = this.getChildByName("checkBox_" + i);
            check.setSelected(false);
            this.checkList.push(check)
        }
        this.checkList[2].setSelected(true);
        this.currectIndex = 2;
        var labelLayer = this.getChildByName("layer");
        this.detailLabel = this.getChildByName("detailLabel");
        this._inputController = new InputLabelController(____654.____673.____159(0, 160), labelLayer.getContentSize(), labelLayer, this.____1398, 18, "");
        this._inputController.setCallBack(this.attachHandler, this.detachHandler, this);
        this.detailLabel.setString(____654.yuyanbaoManager.getYuyanbao("common.inputDefalut"));
        this.____5();
        this.____6()
    },
    ____5: function() {},
    ____6: function() {
        this._closeBtn.addListener(this, this.clickHandler);
        this.sendBtn.addListener(this, this.clickHandler);
        for (var i = 0; i < 4; i++) {
            this.checkList[i].setStateCB(this, this.checkHandler)
        }
        ____654.____672.addEventListener(____655.____661.____698, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.____698, this.dispose, this)
    },
    attachHandler: function() {
        this._inputController.setOpacity(255)
    },
    detachHandler: function() {
        this._inputController.setOpacity(0);
        var detail = this._inputController.getString();
        if (detail == "") {
            detail = ____654.yuyanbaoManager.getYuyanbao("common.inputDefalut")
        }
        this.detailLabel.setString(detail)
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this._controller.hideGmPanel()
            } else if (sender == this.sendBtn) {
                if (this.detailLabel.getString() != "" && this.detailLabel.getString() != ____654.yuyanbaoManager.getYuyanbao("common.inputDefalut")) {
                    if (this.currectIndex < 0) {
                        ____654.tipsManager.quickTip.show("请选择发送类型")
                    } else {
                        ____654.tipsManager.quickTip.show("发送成功");
                        var content = this.detailLabel.getString();
                        var type = 2;
                        if (this.currectIndex == 1 || this.currectIndex == 2) {
                            type = 1
                        } else if (this.currectIndex == 3) {
                            type = 3
                        }
                        ____654.sdk.feedback(type, "GM", content);
                        this.detailLabel.setString(____654.yuyanbaoManager.getYuyanbao("common.inputDefalut"))
                    }
                } else {
                    ____654.tipsManager.quickTip.show("发送的内容不能为空")
                }
            }
        }
    },
    checkHandler: function(sender) {
        var index = this.checkList.indexOf(sender);
        if (this.currectIndex != index) {
            if (this.currectIndex >= 0) {
                this.checkList[this.currectIndex].setSelected(false)
            }
            this.checkList[index].setSelected(true);
            this.currectIndex = index
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.checkList = null;
        this.currectIndex = null;
        this._closeBtn = null;
        this.sendBtn = null;
        this.____1398 = null;
        if (this._inputController != null) {
            this._inputController.dispose();
            this._inputController = null
        }
        this.detailLabel = null;
        this._super()
    },
});
var SetLongItem = KYNode.extend({
    ____1241: null,
    _name: null,
    nameLabel: null,
    slider: null,
    clickImg: null,
    isSelect: null,
    ctor: function(index, name) {
        this._super("settingItemToggle2.ExportJson");
        this.____1241 = index;
        this._name = name;
        this.nameLabel = this.getChildByName("nameLabel");
        this.slider = this.getChildByName("slider");
        this.clickImg = this.getChildByName("clickImg");
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.nameLabel.setString(this._name);
        this.____239(____655.gameSetting.tongzhiList[this.____1241])
    },
    ____239: function(flag) {
        if (flag) {
            this.slider.setPositionX(589);
            this.slider.setFrame("btn/ui_keyBtn_open.png")
        } else {
            this.slider.setPositionX(543);
            this.slider.setFrame("btn/ui_keyBtn_close.png")
        }
        if (this.isSelect != flag) {
            if (this.isSelect != null) {
                ____655.gameSetting.changeSet(____655.gameSetting.TONGZHITYPES[this.____1241], flag)
            }
            this.isSelect = flag
        }
    },
    ____6: function() {
        this.clickImg.addListener(this, this.clickHandler, null, null, null, false, true)
    },
    ____17: function() {},
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.clickImg) {
                this.____239(!this.isSelect)
            }
        }
    },
    dispose: function() {
        this.____17();
        this.____1241 = null;
        this._name = null;
        this.nameLabel = null;
        this.slider = null;
        this.clickImg = null;
        this._super()
    },
});
var ____2274 = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    contactGMBtn: null,
    resetBtn: null,
    changeIdBtn: null,
    ____1002: null,
    idLabel: null,
    item_1: null,
    item_2: null,
    ctor: function(scenePanelController) {
        this._super("settingPanel.ExportJson");
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this.contactGMBtn = this.getChildByName("contactGMBtn");
        this.resetBtn = this.getChildByName("resetBtn");
        this.changeIdBtn = this.getChildByName("changeIdBtn");
        this.idLabel = this.getChildByName("idLabel");
        this.____1002 = this.getChildByName("listView__1");
        this.____1002.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____1002.setFormat(1, ____655.gameSetting.TONGZHINAMES.length, ____654.____673.____160(631, 63), 0, 0, true);
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.item_1 = new SetShortItem(0, ____654.yuyanbaoManager.getYuyanbao("____2274.text7"));
        this.item_2 = new SetShortItem(1, ____654.yuyanbaoManager.getYuyanbao("____2274.text8"));
        this.addChild(this.item_1, 9);
        this.addChild(this.item_2, 9);
        this.item_1.setPosition(40, 375);
        this.item_2.setPosition(360, 375);
        this.idLabel.setString("您的ID:" + ____655.____667.shortAccount)
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.clickHandler);
        this.contactGMBtn.addListener(this, this.clickHandler);
        this.changeIdBtn.addListener(this, this.clickHandler);
        this.resetBtn.addListener(this, this.clickHandler);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    getItemByIndex: function(index) {
        var grid = new SetLongItem(index, ____655.gameSetting.TONGZHINAMES[index]);
        return grid
    },
    getIdByIndex: function(index) {
        return index
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this._controller.hideSetPanel()
            } else if (sender == this.contactGMBtn) {
                this._controller.showGmPanel()
            } else if (sender == this.resetBtn) {
                if (____655.copyInfo.currentId > 0) {
                    ____654.copyTester.exitCopy()
                } else {
                    ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_flyToMap, ____654.____672, ____655.allTemplates.mapTemplateList.CITY_ID))
                }
            } else if (sender == this.changeIdBtn) {
                ____654.sdk.logout()
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._closeBtn = null;
        this.contactGMBtn = null;
        this.resetBtn = null;
        this.changeIdBtn = null;
        this.idLabel = null;
        this.____1002 = null;
        if (this.item_1 != null) {
            this.item_1.dispose();
            this.item_1 = null
        }
        if (this.item_2 != null) {
            this.item_2.dispose();
            this.item_2 = null
        }
        this._super()
    },
});
var SetShortItem = KYNode.extend({
    ____1241: null,
    _name: null,
    nameLabel: null,
    slider: null,
    clickImg: null,
    isSelect: null,
    ctor: function(index, name) {
        this._super("settingItemToggle.ExportJson");
        this.____1241 = index;
        this._name = name;
        this.nameLabel = this.getChildByName("nameLabel");
        this.slider = this.getChildByName("slider");
        this.clickImg = this.getChildByName("clickImg");
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.nameLabel.setString(this._name);
        if (this.____1241 == 0) {
            this.____239(____655.gameSetting.isPlayMusic)
        } else if (this.____1241 == 1) {
            this.____239(____655.gameSetting.showOtherPlayer)
        }
    },
    ____239: function(flag) {
        if (flag) {
            this.slider.setPositionX(265);
            this.slider.setFrame("btn/ui_keyBtn_open.png")
        } else {
            this.slider.setPositionX(218);
            this.slider.setFrame("btn/ui_keyBtn_close.png")
        }
        if (this.isSelect != flag) {
            if (this.isSelect != null) {
                if (this.____1241 == 0) {
                    ____655.gameSetting.changeSet(____655.gameSetting.PLAYMUSIC, flag)
                } else if (this.____1241 == 1) {
                    ____655.gameSetting.changeSet(____655.gameSetting.SHOWPLAYER, flag)
                }
            }
            this.isSelect = flag
        }
    },
    ____6: function() {
        this.clickImg.addListener(this, this.clickHandler)
    },
    ____17: function() {},
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this.clickImg) {
                this.____239(!this.isSelect)
            }
        }
    },
    dispose: function() {
        this.____17();
        this.____1241 = null;
        this._name = null;
        this.nameLabel = null;
        this.slider = null;
        this.clickImg = null;
        this._super()
    },
});
var SkillPad = KYNode.extend({
    ____1091: null,
    ____1092: null,
    ____1494: null,
    ____1493: null,
    _controller: null,
    _sceneInfo: null,
    ____1126: null,
    _jiazuWalkType: 100,
    _container: null,
    _isShow: true,
    ctor: function(controller, container) {
        this._super();
        this._controller = controller;
        this._sceneInfo = this._controller.sceneInfo;
        this._container = container;
        this.____1092 = ____654.____673.____159(____655.____656 - 101, 124);
        this.____1493 = [____654.____673.____159(____655.____656 - 221, 62), ____654.____673.____159(____655.____656 - 229, 167), ____654.____673.____159(____655.____656 - 153, 248), ____654.____673.____159(____655.____656 - 44, 243), ____654.____673.____159(____655.____656 - 90, 344), ____654.____673.____159(____655.____656 - 264, 272)];
        this.____1494 = [];
        this.____6();
        this.updateInfo(null)
    },
    ____6: function() {
        ____655.skillItemList.addEventListener(____655.____661.playerInfo_skillListUpdate, this.updateInfo, this);
        this._controller.sceneInfo.sceneMapList.addEventListener(____655.____661.sceneInfo_mapData, this.updateInfo, this)
    },
    ____17: function() {
        ____655.skillItemList.removeEventListener(____655.____661.playerInfo_skillListUpdate, this.updateInfo, this);
        this._controller.sceneInfo.sceneMapList.removeEventListener(____655.____661.sceneInfo_mapData, this.updateInfo, this)
    },
    setItemSkill: function(index, skill) {
        if (skill == null) {
            if (this.____1494[index] != null) {
                this.____1494[index].setSkill(null)
            }
        } else {
            var item = this.____1494[index];
            if (item == null) {
                this.____1494[index] = new ____2276(0, this);
                item = this.____1494[index];
                item.addListener(this, this.itemClickHandler);
                item.move(this.____1493[index])
            }
            item.setSkill(skill)
        }
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var item = sender;
            var objType = item.____402();
            if (objType == ____655.____659.commonStaticType.soType_npc) {
                var obj = this._sceneInfo.getCurrentSelectObjInfo();
                if (obj == null) return;
                this._controller.sceneModule.walkTester.walkToNPC(obj.____357())
            } else if (objType == ____655.____659.commonStaticType.soType_collect) {
                var obj = this._sceneInfo.getCurrentSelectObjInfo();
                if (obj == null) return;
                this._controller.sceneModule.walkTester.walkToCollect(obj)
            } else if (objType == this._jiazuWalkType) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_defaultSkillClick, ____654.____672, null))
            } else {
                var skill = sender.getSkill();
                this._sceneInfo.setCurrentSkill(skill);
                var selfPlayer = this._sceneInfo.scenePlayerList.selfPlayer;
                if (skill.template.isStartAttack()) {
                    if (!selfPlayer.stateInfo.getAFK()) {
                        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_selectAttackTarget, ____654.____672, null));
                        this._sceneInfo.sceneModule.attackTester.startAttack()
                    }
                } else {
                    ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_sendSkillOnce, ____654.____672, skill))
                }
            }
        }
    },
    setDefaultSkill: function(type, value) {
        var isSkill = type == -1;
        if (value == null && isSkill) {
            if (this.____1091 != null) {
                this.____1091.setSkill(null);
                this.____1091.setObjType(-1)
            }
        } else {
            if (this.____1091 == null) {
                this.____1091 = new ____2276(1, this);
                this.____1091.move(this.____1092);
                this.____1091.addListener(this, this.itemClickHandler)
            }
            if (!isSkill) {
                this.____1091.setObjType(type, this.getDefaultIconPath(type))
            } else {
                this.____1091.setSkill(value)
            }
        }
    },
    getDefaultIconPath: function(type) {
        var p = "";
        if (type == ____655.____659.commonStaticType.soType_npc) {
            p = ____654.____675.getSkillNpcPath()
        } else if (type == ____655.____659.commonStaticType.soType_collect) {
            p = ____654.____675.getSkillCollectPath()
        } else if (type == this._jiazuWalkType) {
            p = ____654.____675.getJiazuWarWalkIconPath()
        }
        return p
    },
    updateSkillPad: function() {
        this.updateInfo(null)
    },
    updateInfo: function(evt) {
        var skillList = ____655.skillItemList.getSkillByCopyId(____655.copyInfo.currentId);
        var len = skillList.length;
        if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID && ____655.skillItemList.getState() == 1) {
            this.setDefaultSkill(this._jiazuWalkType, this._sceneInfo.getCurrentSelectObjInfo())
        } else {
            if (len > 0) {
                this.setDefaultSkill(-1, skillList[0])
            }
        }
        for (var i = 1; i < len; i++) {
            this.setItemSkill(i - 1, skillList[i])
        }
        for (var i = len; i < this.____1493.length; i++) {
            this.setItemSkill(i - 1, null)
        }
        this.updateShowState()
    },
    show: function() {
        this._isShow = true;
        this.updateShowState()
    },
    hide: function() {
        this._isShow = false;
        this.updateShowState()
    },
    updateShowState: function() {
        if (this._isShow) {
            if (this._container != null && this.getParent() == null) {
                this._container.addChild(this, 3)
            }
            if (this.____1091 != null) {
                this.____1091.show()
            }
            for (var i = 0; i < this.____1494.length; i++) {
                if (this.____1494[i].isCanBeShow()) this.____1494[i].show();
                else this.____1494[i].hide()
            }
        } else {
            if (this.getParent() != null) {
                this.removeFromParent(false)
            }
            if (this.____1091 != null) {
                this.____1091.hide()
            }
            for (var i = 0; i < this.____1494.length; i++) {
                this.____1494[i].hide()
            }
        }
    },
    dispose: function() {
        if (this.____1090 != null) {
            this.____1090.dispose();
            this.____1090 = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
    },
});
var ____2276 = KYNode.extend({
    ____856: null,
    _icon: null,
    ____1238: "",
    _skill: null,
    ____933: null,
    _type: 0,
    ____1475: -1,
    _container: null,
    ____1539: 0,
    ____1540: 0,
    ctor: function(type, container) {
        this._super();
        this._type = type;
        this._container = container;
        this.setAnchorPoint(____654.____673.anchorPoints[0]);
        this.____5();
        this.____6()
    },
    ____5: function() {
        var path = "cell/ui_cell3.png";
        var size = ____654.____673.____160(118, 118);
        if (this._type == 0) {
            path = "cell/ui_cell4.png";
            size = ____654.____673.____160(90, 90)
        }
        this.____856 = ____654.____673.newKYSprite();
        this.____856.setFrame(path);
        ____654.____676.mainMenuContainer.addChild(this.____856, 3);
        this._icon = ____654.____673.newKYSprite();
        this._icon.setPosition(____654.____673.____159(size.width / 2, size.height / 2));
        this.addChild(this._icon);
        this.setContentSize(size);
        this.setToPos()
    },
    ____6: function() {
        ____655.furnaceInfo.addEventListener(____655.____661.weapon_godInfoUpdate, this.updateIcon, this)
    },
    ____17: function() {
        ____655.furnaceInfo.removeEventListener(____655.____661.weapon_godInfoUpdate, this.updateIcon, this)
    },
    updateIcon: function(evt) {
        if (this.____1238 != "") {
            ____654.____677.removeImageQuote(this.____1238, this._icon);
            this.____1238 = ____655.allTemplates.skillTemplateList.getSkillFullPath(this._skill.template.templateId, ____655.furnaceInfo.getUseGodWeaponType());
            ____654.____677.____146(this._icon, this.____1238)
        }
    },
    clearSkill: function() {
        if (this._skill != null) {
            this._skill.removeEventListener(____655.____661.playerInfo_skillCD, this.updateCD, this)
        }
        this._skill = null;
        if (this.____1238 != "") {
            ____654.____677.removeImageQuote(this.____1238, this._icon)
        }
        this.____1238 = ""
    },
    setSkill: function(skill) {
        if (this._skill == skill) return;
        this.____1475 = -1;
        this.clearSkill();
        this._skill = skill;
        if (this._skill != null) {
            this._skill.addEventListener(____655.____661.playerInfo_skillCD, this.updateCD, this);
            this.____1238 = ____655.allTemplates.skillTemplateList.getSkillFullPath(this._skill.template.templateId, ____655.furnaceInfo.getUseGodWeaponType());
            ____654.____677.____146(this._icon, this.____1238)
        }
        this.updateCD(null)
    },
    getSkill: function() {
        return this._skill
    },
    getCDEffect: function() {
        if (!this.____933) {
            var size = this.____856.getContentSize();
            this.____933 = new ____2362(this, size);
            this.____933.setPosition(____654.____673.____159(size.width >> 1, size.height >> 1))
        }
        return this.____933
    },
    updateCD: function(evt) {
        if (this._skill != null) {
            var time = this._skill.getLeftCD();
            if (time > 0) {
                this.getCDEffect().start(time)
            } else this.stopCD()
        } else this.stopCD()
    },
    stopCD: function() {
        if (this.____933 != null) this.____933.stop()
    },
    isCanBeShow: function() {
        return !!this._skill
    },
    hide: function() {
        if (this.getParent() != null) {
            this.getParent().removeChild(this, false)
        }
        if (this.____856 != null) {
            this.____856.setVisible(false)
        }
    },
    show: function() {
        if (this._skill == null && this.____1475 == -1) return;
        if (this._container != null && this.getParent() == null) {
            this._container.addChild(this)
        }
        if (this.____856 != null) {
            this.____856.setVisible(true)
        }
    },
    move: function(pos) {
        if (this.____1539 == pos.x && this.____1540 == pos.y) return;
        this.____1539 = pos.x;
        this.____1540 = pos.y;
        this.setToPos()
    },
    setToPos: function() {
        var p = ____654.____673.____159(this.____1539, this.____1540);
        this.setPosition(p);
        if (this.____856 != null) {
            this.____856.setPosition(p)
        }
    },
    setObjType: function(objType, iconPath) {
        if (this.____1475 == objType) return;
        this.setSkill(null);
        this.____1475 = objType;
        this.____1238 = iconPath;
        ____654.____677.____146(this._icon, this.____1238)
    },
    ____402: function() {
        return this.____1475
    },
    dispose: function() {
        this.____17();
        this.clearSkill();
        this._skill = null;
        if (!!this.____856) {
            this.____856.dispose();
            this.____856 = null
        }
        if (!!this._icon) {
            this._icon.dispose();
            this._icon = null
        }
        if (!!this.____933) {
            this.____933.dispose();
            this.____933 = null
        }
    }
});
var ____2277 = KYNode.extend({
    _bg: null,
    ____1638: null,
    _titleLabel: null,
    ____1731: null,
    ____1746: null,
    ____1748: null,
    ____1277: false,
    ____1268: false,
    ctor: function(isMain) {
        this._super();
        this.setAnchorPoint(____654.____673.anchorPoints[6]);
        this.setContentSize(____654.____673.____160(244, 40));
        this._bg = ____654.____673.newKYSprite();
        this._bg.setFrame("bar/ui_bar9.png");
        this._bg.setAnchorPoint(____654.____673.anchorPoints[4]);
        this._bg.setPositionY(20);
        this.addChild(this._bg);
        this._titleLabel = ____654.____673.newKYLabel();
        this._titleLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
        this._titleLabel.setPosition(____654.____673.____159(3, 20));
        this.addChild(this._titleLabel);
        this._titleLabel.setColor(____655.____659.____688.yellow);
        this.____1268 = isMain;
        this.____1731 = ____654.____673.newKYLabel();
        this.____1731.setAnchorPoint(____654.____673.anchorPoints[4]);
        this.____1731.setPositionY(20);
        this.addChild(this.____1731);
        this.____1638 = ____654.____673.newKYSprite();
        this.____1638.setFrame("bar/ui_bar10.png");
        this.____1638.setAnchorPoint(____654.____673.anchorPoints[4]);
        this.____1638.setPosition(____654.____673.____159(-2, 20));
        this.addChild(this.____1638);
        this.____1638.setVisible(false);
        this.____6()
    },
    setTaskInfo: function(taskInfo) {
        if (this.____1746 != null) {
            this.____1746.removeEventListener(____655.____661.common_taskCountUpdate, this.updateStyle, this)
        }
        this.____1746 = taskInfo;
        this.____1746.addEventListener(____655.____661.common_taskCountUpdate, this.updateStyle, this);
        this.____1748 = taskInfo._template;
        this._titleLabel.setString(this.____1748.getTaskTypeName() + this.____1748.title);
        this.____1731.setPositionX(this._titleLabel.getContentSize().width + 10);
        this.updateStyle()
    },
    setTaskTempInfo: function(taskTempInfo) {
        if (this.____1746 != null) {
            this.____1746.removeEventListener(____655.____661.common_taskCountUpdate, this.updateStyle, this)
        }
        this.____1746 = null;
        this.____1748 = taskTempInfo;
        this._titleLabel.setString(this.____1748.getTaskTypeName() + this.____1748.title);
        this.____1731.setPositionX(this._titleLabel.getContentSize().width + 20);
        this.updateStyle()
    },
    getTaskType: function() {
        if (this.____1748 != null) {
            return this.____1748.type
        }
        return 0
    },
    getTaskId: function() {
        if (this.____1748 != null) {
            return this.____1748.id
        }
        return 0
    },
    updateStyle: function(evt) {
        if (this.____1748 == null) {
            return
        }
        if (this.____1746 == null) {
            var level = this.____1748.minLv;
            if (level > ____655.____667.level) {
                this.____1731.setColor(____655.____659.____688.red);
                this.____1731.setString(____654.yuyanbaoManager.getYuyanbao("____2278.text2", level))
            } else {
                this.____1731.setColor(____655.____659.____688.lightGreen);
                this.____1731.setString(____654.yuyanbaoManager.getYuyanbao("____2278.text3"))
            }
        } else {
            var maxList = this.____1748.termList;
            var needList = this.____1746.needCounts;
            var isFinish = true;
            var str = "";
            for (var i = 0; i < maxList.length; i++) {
                var currentCount = maxList[i][1] - needList[i];
                if (needList[i] > 0) {
                    isFinish = false
                }
                str += "(" + currentCount.toString() + "/" + maxList[i][1].toString() + ")"
            }
            if (isFinish) {
                this.____1731.setColor(____655.____659.____688.lightGreen);
                str = ____654.yuyanbaoManager.getYuyanbao("____2278.text1")
            } else {
                this.____1731.setColor(____655.____659.____688.yellow)
            }
            this.____1731.setString(str)
        }
    },
    setSelected: function(value) {
        if (this.____1277 == value) {
            return
        }
        this.____1277 = value;
        this.____1638.setVisible(this.____1277)
    },
    clickHandler: function() {
        if (this.____1746 != null) {
            if (this.____1746.state == ____655.____659.commonStaticType.task_acceptNotFinish) {
                if (this.____1746.____55().type == 5) {
                    var type = 2;
                    if (this.____1746.____55().acceptTriggers.length == 0) {
                        type = false
                    }
                    ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [this.____1748.title + this.____1731.getString(), this.____1748.awardList, null, type, this.acceptNotFinishHandler, this]))
                } else {
                    ____655.allTemplates.taskTemplateList.handleNotFinishTrigger(this.____1746.taskId)
                }
            } else if (this.____1746.state == ____655.____659.commonStaticType.task_finishNotSubmit) {
                if (this.____1746.____55().type == 5) {
                    ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [this.____1748.title + this.____1731.getString(), this.____1748.awardList, null, true, this.finishNotSubmitHandler, this]))
                } else {
                    ____655.allTemplates.taskTemplateList.handleFinishTrigger(this.____1746.taskId)
                }
            }
        } else {
            if (this.____1748 != null) {
                if (____655.____667.level >= this.____1748.minLv) {
                    var triggerInfo = new ____539();
                    triggerInfo.initWithString("3$103$0$0$" + this.____1748.acceptNpc.toString() + "$0$0$0");
                    ____654.triggerManager.handlerList([triggerInfo])
                }
            }
        }
    },
    acceptNotFinishHandler: function() {
        ____655.allTemplates.taskTemplateList.handleNotFinishTrigger(this.____1746.taskId)
    },
    finishNotSubmitHandler: function() {
        ____654.selfDataMessageSender.sendTaskSubmit(this.____1746.taskId)
    },
    ____6: function() {
        if (this.____1268 == true) {
            ____655.____667.addEventListener(____655.____661.____703, this.updateStyle, this)
        }
    },
    ____17: function() {
        if (this.____1268 == true) {
            ____655.____667.removeEventListener(____655.____661.____703, this.updateStyle, this)
        }
    },
    dispose: function() {
        this.____17();
        if (this.____1746 != null) {
            this.____1746.removeEventListener(____655.____661.common_taskCountUpdate, this.updateStyle, this)
        }
        this._bg = null;
        this.____1638.dispose();
        this.____1638 = null;
        this._titleLabel.dispose();
        this._titleLabel = null;
        this.____1731.dispose();
        this.____1731 = null;
        this.____1746 = null;
        this.____1748 = null;
        this._super()
    },
});
var ____2278 = KYNode.extend({
    ____1368: null,
    ____1045: null,
    _isShow: true,
    _itemList: null,
    ____1824: null,
    ctor: function() {
        this._super();
        this.____1368 = new ____2277(true);
        this.____1368.addListener(this, this.itemClickHandler);
        this.addChild(this.____1368);
        this._itemList = [];
        this.____1824 = [2, 3, 4, 5];
        this.____6();
        this.____5()
    },
    ____5: function() {
        this.clearItems();
        var finishList = [];
        var noFinishList = [];
        for (var k in ____655.____670.currentList) {
            var info = ____655.____670.currentList[k];
            if (info == null) {
                continue
            }
            if (info.state == ____655.____659.commonStaticType.task_finishNotSubmit) {
                finishList.push(info)
            } else if (info.state == ____655.____659.commonStaticType.task_acceptNotFinish) {
                noFinishList.push(info)
            }
        }
        var canAcceptList = ____655.____670.getFollowViewTemplateList();
        var i = 0;
        var item = null;
        var itemList = {};
        for (i = 0; i < finishList.length; i++) {
            var type = finishList[i].____55().type;
            if (type == 1) {
                this.____1368.setTaskInfo(finishList[i])
            } else {
                item = new ____2277();
                item.setTaskInfo(finishList[i]);
                item.addListener(this, this.itemClickHandler);
                if (itemList[type] == null) {
                    itemList[type] = []
                }
                itemList[type].push(item)
            }
        }
        for (i = 0; i < noFinishList.length; i++) {
            var type = noFinishList[i].____55().type;
            if (type == 1) {
                this.____1368.setTaskInfo(noFinishList[i])
            } else {
                item = new ____2277();
                item.setTaskInfo(noFinishList[i]);
                item.addListener(this, this.itemClickHandler);
                if (itemList[type] == null) {
                    itemList[type] = []
                }
                itemList[type].push(item)
            }
        }
        for (i = 0; i < canAcceptList.length; i++) {
            var type = canAcceptList[i].type;
            if (type == 1) {
                this.____1368.setTaskTempInfo(canAcceptList[i])
            } else {
                item = new ____2277();
                item.setTaskTempInfo(canAcceptList[i]);
                item.addListener(this, this.itemClickHandler);
                if (itemList[type] == null) {
                    itemList[type] = []
                }
                itemList[type].push(item)
            }
        }
        for (var t = 0; t < this.____1824.length; t++) {
            var type = this.____1824[t];
            if (itemList[type] != null) {
                for (var j = 0; j < itemList[type].length; j++) {
                    this._itemList.push(itemList[type][j])
                }
            }
        }
        this.freshView()
    },
    itemClickHandler: function(sender, eventType) {
        sender.clickHandler();
        if (this.____1045 != null) {
            this.____1045.setSelected(false)
        }
        this.____1045 = sender;
        this.____1045.setSelected(true)
    },
    acceptHandler: function(evt) {
        var taskInfo = evt.data;
        if (taskInfo.____55().type == 1) {
            this.____1368.setTaskInfo(taskInfo);
            return
        }
        var id = taskInfo.taskId;
        for (var i = 0; i < this._itemList.length; i++) {
            if (this._itemList[i].getTaskId() == id) {
                this._itemList[i].setTaskInfo(taskInfo);
                return
            }
        }
        var item = new ____2277();
        item.setTaskInfo(taskInfo);
        item.addListener(this, this.itemClickHandler);
        var addIndex = this.____1824.indexOf(taskInfo.____55().type);
        var insertIndex = 0;
        for (var j = 0; j < this._itemList.length; j++) {
            var type = this._itemList[j].getTaskType();
            if (this.____1824.indexOf(type) >= addIndex) {
                insertIndex = j;
                break
            }
        }
        this._itemList.splice(insertIndex, 0, item);
        this.freshView()
    },
    deleteHandler: function(evt) {
        var taskId = evt.data;
        for (var i = 0; i < this._itemList.length; i++) {
            var item = this._itemList[i];
            if (item.getTaskId() == taskId) {
                if (item == this.____1045) {
                    this.____1045 = null
                }
                this._itemList.splice(i, 1);
                item.dispose();
                this.freshView();
                return
            }
        }
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.common_taskSubmit, this.____5, this);
        ____654.____672.addEventListener(____655.____661.common_taskAccept, this.acceptHandler, this);
        ____655.____670.addEventListener(____655.____661.common_taskDelete, this.deleteHandler, this);
        ____654.____672.addEventListener(____655.____661.playerInfo_selfInfo, this.____5, this);
        ____654.____672.addEventListener(____655.____661.guide_doTask, this.guideHandler, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_taskSubmit, this.____5, this);
        ____654.____672.removeEventListener(____655.____661.common_taskAccept, this.acceptHandler, this);
        ____655.____670.removeEventListener(____655.____661.common_taskDelete, this.deleteHandler, this);
        ____654.____672.removeEventListener(____655.____661.playerInfo_selfInfo, this.____5, this);
        ____654.____672.removeEventListener(____655.____661.guide_doTask, this.guideHandler, this)
    },
    guideHandler: function() {
        this.itemClickHandler(this.____1368)
    },
    freshView: function() {
        for (var i = 0; i < this._itemList.length; i++) {
            if (i < 3) {
                if (this._itemList[i].getParent() == null) {
                    this.addChild(this._itemList[i])
                }
                this._itemList[i].setPositionY(-43 - i * 42)
            } else {
                this._itemList[i].removeFromParent(false)
            }
        }
    },
    clearItems: function() {
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this._itemList = [];
        this.____1368.setSelected(false);
        this.____1045 = null;
        ____654.____672.dispatchEvent(new ____590(____655.____661.panel_close_awardPanel, ____654.____672, null))
    },
});
var TaskCompleteView = KYPanel.extend({
    _controller: null,
    _tittleBg: null,
    _bgPath: null,
    ____1803: null,
    ____1479: null,
    ____1481: null,
    ____1690: null,
    ____1085: null,
    _itemList: null,
    _gridList: null,
    _tickCount: 0,
    _timeNum: 10,
    ctor: function(scenePanelController, dataList) {
        this._super("taskCompleteView.ExportJson");
        this._controller = scenePanelController;
        this.____1085 = dataList;
        this.setAnchorPoint(____654.____673.anchorPoints[0]);
        this.____857 = ____654.____673.newKYImageView();
        this.____857.setFrame("board/ui_blackBoard.png");
        this.____857.setAnchorPoint(____654.____673.anchorPoints[0]);
        this.____857.setScale9Enabled(true);
        this.____857.setCapInsets(____654.____673.____161(4, 4, 1, 1));
        this.____857.setOpacity(200);
        this.____857.setSize(____654.____673.____160(____655.____656, ____655.____657));
        this.____857.setPosition(____654.____673.____159(____655.____656 * 0.5 - 784 * 0.25 - 12, ____655.____657 * 0.5 - 305 * 0.5 - 10));
        this.____857.setTouchEnabled(true);
        this.addChild(this.____857);
        this._tittleBg = this.getChildByName("tittleBg");
        this._bgPath = ____654.____675.____139("outPic/taskCompleteBg.png");
        ____654.____677.____146(this._tittleBg, this._bgPath);
        this.____1803 = this.getChildByName("tittleLabel");
        if (dataList[0] == 3) {
            this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("XianWeiUpLevelPanel.text2"))
        } else if (dataList[0] == 4) {
            this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("XianWeiUpLevelPanel.text3"))
        }
        this._itemList = [];
        this._gridList = [];
        var goodsItemList = dataList[1];
        for (var i = 0; i < 4; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            var itemTemplateInfo = ____655.allTemplates.____794.getItem(goodsItemList[i][0]);
            grid.setItemTemplateInfo(itemTemplateInfo);
            grid.setCount(goodsItemList[i][1]);
            this._itemList[i].addChild(grid);
            this._gridList.push(grid)
        }
        this.____1479 = this.getChildByName("OKBtn");
        this.____1481 = this.getChildByName("btnLabel");
        this.____1481.setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips6", this._timeNum));
        this.____6();
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount >= 60) {
            this._tickCount = 0;
            this._timeNum = this._timeNum - 1;
            this.____1481.setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips6", this._timeNum))
        }
        if (this._timeNum <= 0) {
            ____654.____678.____299(this.tick, this);
            this._controller.hideTaskCompleteView()
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.hideTaskCompleteView()
        }
    },
    ____6: function() {
        this.____1479.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._tittleBg, this._bgPath);
            this._bgPath = null
        }
        this._tittleBg = null;
        this._controller = null;
        this.____1803 = null;
        this.____1479 = null;
        this.____1481 = null;
        if (this.____857 != null) {
            this.____857.dispose();
            this.____857 = null
        }
        this.____1085 = null;
        this._itemList = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        this._tickCount = null;
        this._timeNum = null;
        this._super()
    },
});
var TeamPanel = KYPanel.extend({
    _controller: null,
    _type: null,
    _bgList: null,
    _bgPath: null,
    ____1479: null,
    _cancelBtn: null,
    _fightLabels: null,
    _nameLabels: null,
    _inviteLabels: null,
    ____1251: null,
    ____955: null,
    _isSelf: false,
    _bossIndex: 1,
    ctor: function(controller, type, isSelf, bossIndex) {
        this._super("copyTeamView.ExportJson");
        this._controller = controller;
        this._type = type;
        this._isSelf = isSelf;
        if (bossIndex != null) {
            this._bossIndex = bossIndex
        }
        this._bgList = [this.getChildByName("bg1"), this.getChildByName("bg2"), this.getChildByName("bg3")];
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bgList[0], this._bgPath);
        ____654.____677.____146(this._bgList[1], this._bgPath);
        ____654.____677.____146(this._bgList[2], this._bgPath);
        this.____1479 = this.getChildByName("sureBtn");
        this._cancelBtn = this.getChildByName("cancelBtn");
        this._fightLabels = [this.getChildByName("fightLabel1"), this.getChildByName("fightLabel2"), this.getChildByName("fightLabel3")];
        this._nameLabels = [this.getChildByName("nameLabel1"), this.getChildByName("nameLabel2"), this.getChildByName("nameLabel3")];
        this._inviteLabels = [null, this.getChildByName("inviteLabel2"), this.getChildByName("inviteLabel3")];
        this.____1251 = [null, null, null];
        this.____955 = [null, null, null];
        this.____5();
        this.____6()
    },
    updateInfo: function() {
        if (this._isSelf) {
            ____654.copyMessageSender.sendTeamCreat(this._type, this._bossIndex)
        } else {
            ____654.copyMessageSender.sendTeamInfo(this._type);
            ____654.____674.setKYBtnEnabled(this.____1479, false, 1)
        }
    },
    ____5: function() {
        if (this._isSelf) {
            var playerInfo = new ____499();
            playerInfo.userId = ____655.____667.userId;
            playerInfo.career = ____655.____667.career;
            playerInfo.combat = ____655.____667.combat;
            playerInfo.nick = ____655.____667.nick;
            playerInfo.characterInfo.updateStyle(____655.____667.characterInfo.getStyleList());
            playerInfo.characterInfo.getStyleList()[____655.____659.commonStaticType.style_isHorse] = false;
            this.setPlayerInfoList([playerInfo, null, null])
        }
    },
    ____6: function() {
        this.____1479.addListener(this, this.____16);
        this._cancelBtn.addListener(this, this.____16);
        this._bgList[1].addListener(this, this.____16);
        this._bgList[2].addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.team_quit, this.teamQuitHandler, this);
        ____654.____672.addEventListener(____655.____661.team_update, this.teamUpdateHandler, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.team_quit, this.teamQuitHandler, this);
        ____654.____672.removeEventListener(____655.____661.team_update, this.teamUpdateHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this)
    },
    teamQuitHandler: function(evt) {
        var index = evt.data;
        if (this.____1251[index] != null && this.____1251[index].userId == ____655.____667.userId) {
            this._controller.hideTeamPanel()
        } else {
            this.clearCharacterByIndex(index);
            this.____1251[index].dispose();
            this.____1251[index] = null
        }
    },
    teamUpdateHandler: function(evt) {
        var list = evt.data;
        this.setPlayerInfoList(list)
    },
    setPlayerInfoList: function(list) {
        for (var i = 0; i < 3; i++) {
            if (list[i] == null && this.____1251[i] != null) {
                this.clearCharacterByIndex(i);
                this.____1251[i].dispose()
            } else if (list[i] != null && this.____1251[i] == null) {
                this.clearCharacterByIndex(i);
                this.createCharacter(i, list[i])
            } else if (list[i] != null && this.____1251[i] != null) {
                if (list[i].userId != this.____1251[i]) {
                    this.clearCharacterByIndex(i);
                    this.____1251[i].dispose();
                    this.createCharacter(i, list[i])
                }
            }
        }
        this.____1251 = list
    },
    clearCharacterByIndex: function(index) {
        if (this.____955[index] != null) {
            this.____955[index].dispose();
            this.____955[index] = null
        }
        this._fightLabels[index].setString("");
        this._nameLabels[index].setString("");
        if (this._inviteLabels[index] != null) {
            this._inviteLabels[index].setVisible(true)
        }
    },
    createCharacter: function(index, playerInfo) {
        var character = new ____545(playerInfo.characterInfo);
        character.init(____655.____659.____686.rightBottom, this._bgList[index], 1);
        this.____955[index] = character;
        character.move(194, 120);
        character.setScale(2);
        this._fightLabels[index].setString("战:" + playerInfo.combat);
        this._nameLabels[index].setString(playerInfo.nick);
        if (this._inviteLabels[index] != null) {
            this._inviteLabels[index].setVisible(false)
        }
    },
    ____16: function(sender, eventType) {
        var this_ = this;

        function closeHandler() {
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_hideTeamPanel, ____654.____672, null))
        };

        function click1Handler() {
            ____654.copyMessageSender.sendTeamKickout(this._type, 1)
        };

        function click2Handler() {
            ____654.copyMessageSender.sendTeamKickout(this._type, 2)
        };
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1479) {
                if (this._type == 1) {
                    ____654.copyMessageSender.sendTeamEnterCopy(this._type)
                } else if (this._type == 2) {
                    ____654.copyMessageSender.sendTeamEnterCopy(this._type, this._bossIndex, 1)
                }
            } else if (sender == this._cancelBtn) {
                if (this.____1251[1] == null && this.____1251[2] == null) {
                    closeHandler()
                } else {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2107.text16"), null, 0, this, closeHandler, null, null)
                }
            } else if (sender == this._bgList[1]) {
                if (!this._isSelf) {
                    return
                }
                if (this.____1251[1] != null) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2107.text17", this.____1251[1].nick), null, 0, this, click1Handler, null, null)
                } else {
                    this._controller.showYaoqingPanel(this._type)
                }
            } else if (sender == this._bgList[2]) {
                if (!this._isSelf) {
                    return
                }
                if (this.____1251[2] != null) {
                    ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("____2107.text17", this.____1251[2].nick), null, 0, this, click2Handler, null, null)
                } else {
                    this._controller.showYaoqingPanel(this._type)
                }
            }
        }
    },
    dispose: function() {
        this._controller.hideYaoqingPanel();
        ____654.copyMessageSender.sendTeamQuit(this._type);
        this.____17();
        this._controller = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bgList[0]);
            ____654.____677.removeImageQuote(this._bgPath, this._bgList[1]);
            ____654.____677.removeImageQuote(this._bgPath, this._bgList[2]);
            this._bgPath = null
        }
        this._bgList = null;
        this.____1479 = null;
        this._cancelBtn = null;
        this._fightLabels = null;
        this._nameLabels = null;
        this._inviteLabels = null;
        for (var i = 0; i < 3; i++) {
            if (this.____955[i] != null) {
                this.____955[i].dispose()
            }
            if (this.____1251[i] != null) {
                this.____1251[i].dispose()
            }
        }
        this._super()
    },
});
var ____2280 = KYNode.extend({
    ____1523: null,
    ____1166: null,
    ____1221: null,
    _nameLabel: null,
    _levelLabel: null,
    ctor: function(basePlayerInfo, type) {
        this._super("invitationItem.ExportJson");
        this.____1523 = basePlayerInfo;
        this.____1166 = this.getChildByName("flagImg");
        this.____1221 = this.getChildByName("headIcon");
        this._nameLabel = this.getChildByName("nameLabel");
        this._levelLabel = this.getChildByName("levelLabel");
        this.____5()
    },
    ____5: function() {
        if (this.____1523.job != null) {
            this.____1221.setFrame("sceneIcon/PlayerHeadIcon2_1.png");
            this._nameLabel.setString(this.____1523.name);
            this._levelLabel.setString("Lv." + this.____1523.level)
        } else {
            this.____1221.setFrame("sceneIcon/PlayerHeadIcon2_" + this.____1523.career + ".png");
            this._nameLabel.setString(this.____1523.nick);
            this._levelLabel.setString("Lv." + this.____1523.level);
            this.____1166.setFrame("flag/ui_friendFlag.png")
        }
    },
    getInfoId: function() {
        if (this.____1523 == null) return null;
        return this.____1523.userId
    },
    dispose: function() {
        this._super();
        this.____1523 = null;
        this.____1166 = null;
        this.____1221 = null;
        this._nameLabel = null;
        this._levelLabel = null
    },
});
var YaoqingPanel = KYPanel.extend({
    _controller: null,
    _type: null,
    _closeBtn: null,
    _tileContainer: null,
    _tipsLabel: null,
    _list: null,
    _friendIdList: null,
    _yaoqingBtn1: null,
    _yaoqingBtn2: null,
    _yaoqingLabel1: null,
    _yaoqingLabel2: null,
    _count: 0,
    _time: 0,
    CD: 10,
    ctor: function(scenePanelController, type) {
        this._super("invitationPanel.ExportJson");
        this.modeValue = 100;
        this._controller = scenePanelController;
        this._type = type;
        this._closeBtn = this.getChildByName("closeBtn");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._yaoqingBtn1 = this.getChildByName("yaoqingBtn1");
        this._yaoqingBtn2 = this.getChildByName("yaoqingBtn2");
        this._yaoqingLabel1 = this.getChildByName("yaoqingLabel1");
        this._yaoqingLabel2 = this.getChildByName("yaoqingLabel2");
        this._list = [];
        for (var i = 0; i < ____655.____668.list.length; i++) {
            item = ____655.____668.list[i];
            if (item.online == 1) {
                this._list.push(item.info)
            }
        }
        this._tileContainer = this.getChildByName("itemscrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____18();
        this.____6();
        if (____655.clubInfo.id > 0) {
            ____654.clubMessageSender.sendClubMember()
        }
        var time = ____655.____662.getSystemTimeSec() - ____655.yaoqingTime;
        if (time < this.CD) {
            ____654.____674.setKYBtnEnabled(this._yaoqingBtn1, false, 1);
            ____654.____674.setKYBtnEnabled(this._yaoqingBtn2, false, 1);
            this._count = 0;
            this._time = this.CD - time;
            this._yaoqingLabel1.setString("邀请族员" + this._time);
            this._yaoqingLabel2.setString("邀请好友" + this._time);
            ____654.____678.____298(this.countTick, this)
        }
    },
    countTick: function(count, detla) {
        this._count++;
        if (this._count >= 60) {
            this._count = 0;
            this._time--;
            if (this._time == 0) {
                ____654.____674.setKYBtnEnabled(this._yaoqingBtn1, true, 1);
                ____654.____674.setKYBtnEnabled(this._yaoqingBtn2, true, 1);
                this._yaoqingLabel1.setString("邀请族员");
                this._yaoqingLabel2.setString("邀请好友");
                ____654.____678.____299(this.countTick, this)
            } else {
                this._yaoqingLabel1.setString("邀请族员" + this._time);
                this._yaoqingLabel2.setString("邀请好友" + this._time)
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this._yaoqingBtn1.addListener(this, this.____16);
        this._yaoqingBtn2.addListener(this, this.____16);
        ____655.clubInfo.addEventListener(____655.____661.club_memberList_update, this.friendInfoUpdate, this);
        ____655.____668.addEventListener(____655.____661.common_addFriend, this.friendInfoUpdate, this);
        ____655.____668.addEventListener(____655.____661.common_deleteFriend, this.friendInfoUpdate, this)
    },
    ____17: function() {
        ____655.clubInfo.removeEventListener(____655.____661.club_memberList_update, this.friendInfoUpdate, this);
        ____655.____668.removeEventListener(____655.____661.common_addFriend, this.friendInfoUpdate, this);
        ____655.____668.removeEventListener(____655.____661.common_deleteFriend, this.friendInfoUpdate, this)
    },
    friendInfoUpdate: function() {
        this._friendIdList = [];
        this._list = [];
        var i = 0;
        var item = null;
        for (i = 0; i < ____655.____668.list.length; i++) {
            item = ____655.____668.list[i];
            if (item.online == 1) {
                this._list.push(item.info);
                this._friendIdList.push(item.info.userId)
            }
        }
        for (i = 0; i < ____655.clubInfo.members.length; i++) {
            item = ____655.clubInfo.members[i];
            if (item.userId != ____655.____667.userId && item.onlineState && this._friendIdList.indexOf(item.userId) == -1) {
                this._list.push(item)
            }
        }
        this.____18()
    },
    ____18: function() {
        this._tileContainer.setFormat(2, this._list.length, ____654.____673.____160(314, 100), 0, 0, true);
        if (this._list.length > 0) {
            this._tipsLabel.setVisible(false)
        } else {
            this._tipsLabel.setVisible(true);
            this._tipsLabel.setString("当前没有好友或家族成员在线！")
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this._yaoqingBtn1) {
                ____654.copyMessageSender.sendTeamPlayer(this._type, 0, 1);
                ____655.yaoqingTime = ____655.____662.getSystemTimeSec();
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text7"));
                this.dispose()
            } else if (sender == this._yaoqingBtn2) {
                ____654.copyMessageSender.sendTeamPlayer(this._type, 0, 2);
                ____655.yaoqingTime = ____655.____662.getSystemTimeSec();
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2107.text7"));
                this.dispose()
            }
        }
    },
    getItemByIndex: function(index) {
        var itemInfo = this._list[index];
        if (itemInfo == null) {
            return null
        }
        var item = new ____2280(itemInfo);
        item.addListener(this, this.itemClickHandler, null, null, null, false, true);
        return item
    },
    getIdByIndex: function(index) {
        var itemInfo = this._list[index];
        if (itemInfo == null) {
            return -1
        }
        return itemInfo.userId
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var id = sender.getInfoId();
            if (id != null) {
                ____654.copyMessageSender.sendTeamPlayer(this._type, id, 0);
                this.dispose()
            }
        }
    },
    dispose: function() {
        ____654.____678.____299(this.countTick, this);
        this.____17();
        this._super();
        this._controller = null;
        this._closeBtn = null;
        this._tipsLabel = null;
        this._tileContainer = null;
        this._list = null;
        this._friendIdList = null;
        this._yaoqingBtn1 = null;
        this._yaoqingBtn2 = null;
        this._yaoqingLabel1 = null;
        this._yaoqingLabel2 = null
    },
});
var WaiXingChongJiePanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    _titleImg: null,
    _beautyImg: null,
    _tipImg: null,
    ____892: null,
    ____1185: null,
    _tiemDesc: null,
    _timeLabel: null,
    ____1096: null,
    _awardName: null,
    _titleImgPath: null,
    _beautyImgPath: null,
    _gridList: null,
    _countDownUtils: null,
    ____1756: null,
    _btnEffect: null,
    _itemInfoList: null,
    ctor: function(controller) {
        this._super("waiXingChongJiePanel.ExportJson");
        this._controller = controller;
        this._closeBtn = this.getChildByName("closeBtn");
        this._titleImg = this.getChildByName("titleImg");
        this._beautyImg = this.getChildByName("beautyImg");
        this._tipImg = this.getChildByName("tipImg");
        this.____892 = this.getChildByName("btnLabel");
        this.____1185 = this.getChildByName("getBtn");
        this._tiemDesc = this.getChildByName("tiemDesc");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1096 = this.getChildByName("descLabel");
        this._awardName = this.getChildByName("awardName");
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._timeLabel, 0, 0);
        this._itemInfoList = [];
        this._gridList = [];
        for (var i = 1; i <= 5; i++) {
            var gridBg = this.getChildByName("cell" + i);
            var grid = new ____2129();
            this._itemInfoList[i - 1] = new ItemInfo();
            gridBg.addChild(grid);
            this._gridList.push(grid)
        }
        this._titleImgPath = ____654.____675.____139("outPic/ui_waiguanchongjieTitle.png");
        ____654.____677.____146(this._titleImg, this._titleImgPath);
        this._beautyImgPath = ____654.____675.____139("outPic/welcomeBeautyBg.png");
        ____654.____677.____146(this._beautyImg, this._beautyImgPath);
        this.____6();
        this.____5()
    },
    ____5: function() {
        var passTime = ____655.____662.getZeroPassTime();
        var surplusTime = ____655.____662.secondsOfDay - passTime;
        var this_ = this;

        function timeCallBack() {
            var actInfo = ____655.openInfo.waiXingChongJieInfo;
            var flag = false;
            if (actInfo.tempId > 0) {
                var tempInfo = ____655.allTemplates.openActivityTemplateList.waiXingChongJieList[actInfo.tempId];
                var systemTime = ____655.____662.getSystemTimeSec();
                var beginSecond = ____655.____662.getTimesByDay(tempInfo.openServerBegin);
                var finishSecond = ____655.____662.getTimesByDay(tempInfo.openServerEnd);
                if (finishSecond > systemTime && beginSecond <= systemTime) {
                    flag = true
                }
            }
            if (flag) {
                this_.____5()
            } else {
                this_.dispose()
            }
        };
        this._countDownUtils.start(surplusTime, null, timeCallBack);
        var actInfo = ____655.openInfo.waiXingChongJieInfo;
        if (actInfo.tempId > 0) {
            var tempInfo = ____655.allTemplates.openActivityTemplateList.waiXingChongJieList[actInfo.tempId];
            if (!!tempInfo && this.____1756 != tempInfo) {
                this.____1756 = tempInfo;
                var awardList = tempInfo.awardList || [];
                for (var i = 0; i < this._gridList.length; i++) {
                    var info = awardList[i];
                    if (!!info) {
                        this._itemInfoList[i].____107(info[0]);
                        this._itemInfoList[i].count = info[1];
                        if (info[2] != null) {
                            this._itemInfoList[i].qhLevel = info[2]
                        }
                        if (info[3] != null) {
                            this._itemInfoList[i].quality = info[3]
                        }
                        this._gridList[i].setItemInfo(this._itemInfoList[i]);
                        if (i == 0) {
                            if (____655.____659.categoryType.isWaiXingEquip(this._itemInfoList[i].template.categoryId)) {
                                this._awardName.setColor(____655.____659.____688.getColorByQuality(this._itemInfoList[i].template.quality + this._itemInfoList[i].qhLevel))
                            } else {
                                this._awardName.setColor(____655.____659.____688.getColorByQuality(this._itemInfoList[i].template.quality))
                            }
                            this._awardName.setString(this._itemInfoList[i].getName())
                        }
                    } else {
                        this._gridList[i].setItemInfo(null);
                        this._gridList[i].setCount(-1)
                    }
                }
                var type = tempInfo.conditionList[0][0];
                var needStar = tempInfo.conditionList[0][1];
                if (!!type && !!needStar) {
                    var name = ""
                    var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(needStar);
                    var value = ____655.____659.nameType.getChineseNumber2(stage);
                    var star = ____655.allTemplates.advanceTemplateList.getCurrentStar(needStar);
                    if (type == ____655.____659.commonStaticType.style_Horse) {
                        name = ____655.____659.nameType.advanceName[0]
                    } else if (type == ____655.____659.commonStaticType.style_Wind) {
                        name = ____655.____659.nameType.advanceName[2]
                    } else if (type == ____655.____659.commonStaticType.style_FaBao) {
                        name = ____655.____659.nameType.advanceName[4]
                    } else if (type == ____655.____659.commonStaticType.style_ZhengLing) {
                        name = ____655.____659.nameType.advanceName[5]
                    } else if (type == ____655.____659.commonStaticType.style_ShenJian) {
                        name = ____655.____659.nameType.advanceName[6]
                    } else if (type == ____655.____659.commonStaticType.style_Foot) {
                        name = ____655.____659.nameType.advanceName[3]
                    } else if (type == ____655.____659.commonStaticType.style_Pet) {
                        name = ____655.____659.nameType.advanceName[1]
                    }
                    var str = ____654.yuyanbaoManager.getYuyanbao("WaiXingChongJiePanel.text1").format(name, value, star);
                    this.____1096.setString(str)
                }
            }
            if (actInfo.state == 0) {
                this.____892.setString("领取奖励");
                this.____1185.setFrame("btn/ui_btn1_3.png")
            } else if (actInfo.state == 1) {
                this.____892.setString("已领取");
                this.____1185.setFrame("btn/ui_btn1_4.png")
            } else {
                this.____892.setString("我要进阶");
                this.____1185.setFrame("btn/ui_btn1_2.png")
            }
            if (actInfo.state == 0) {
                if (this._btnEffect == null) {
                    this._btnEffect = null;
                    this._btnEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(439, 61), this);
                    this._btnEffect.setScaleY(1.1);
                    this._btnEffect.setScaleX(1.25)
                }
            } else {
                if (this._btnEffect != null) {
                    this._btnEffect.dispose();
                    this._btnEffect = null
                }
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.btnClickEndHandler);
        this.____1185.addListener(this, this.btnClickEndHandler);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.dispose, this);
        ____655.openInfo.addEventListener(____655.____661.playerInfo_waiXingChongJie, this.____5, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.dispose, this);
        ____655.openInfo.removeEventListener(____655.____661.playerInfo_waiXingChongJie, this.____5, this)
    },
    btnClickEndHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____1185) {
                print("##领奖按钮");
                var actInfo = ____655.openInfo.waiXingChongJieInfo;
                if (actInfo.tempId > 0) {
                    if (actInfo.state == 0) {
                        ____654.____683.sendWaiXingChongJieAward(actInfo.tempId);
                        ____654.tipsManager.quickTip.show("领取成功")
                    } else if (actInfo.state == 1) {
                        ____654.tipsManager.quickTip.show("奖励已经领取")
                    } else {
                        if (!!this.____1756) {
                            var type = this.____1756.conditionList[0][0];
                            if (!!type) {
                                if (type == ____655.____659.commonStaticType.style_Horse) {
                                    if (this.checkLevel(____655.____659.levelType.riderLevel)) {
                                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, 1);
                                        this.dispose()
                                    }
                                } else if (type == ____655.____659.commonStaticType.style_Wind) {
                                    if (this.checkLevel(____655.____659.levelType.wingLevel)) {
                                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, 3);
                                        this.dispose()
                                    }
                                } else if (type == ____655.____659.commonStaticType.style_FaBao) {
                                    if (this.checkLevel(____655.____659.levelType.fabaoLevel)) {
                                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, 5);
                                        this.dispose()
                                    }
                                } else if (type == ____655.____659.commonStaticType.style_ZhengLing) {
                                    if (this.checkLevel(____655.____659.levelType.zhenlingLevel)) {
                                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, 6);
                                        this.dispose()
                                    }
                                } else if (type == ____655.____659.commonStaticType.style_ShenJian) {
                                    if (this.checkLevel(____655.____659.levelType.shenjianLevel)) {
                                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, 7);
                                        this.dispose()
                                    }
                                } else if (type == ____655.____659.commonStaticType.style_Foot) {
                                    if (this.checkLevel(____655.____659.levelType.footLevel)) {
                                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, 4);
                                        this.dispose()
                                    }
                                } else if (type == ____655.____659.commonStaticType.style_Pet) {
                                    if (this.checkLevel(____655.____659.levelType.petLevel)) {
                                        ____654.____676.uiPanelContainer.initTabs(____655.____659.panelTabType.waiGuanTab, ____655.____659.panelTabType.advance, 2);
                                        this.dispose()
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },
    checkLevel: function(level) {
        if (____655.____667.level >= level) {
            return true
        } else {
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2340.text1", level));
            return false
        }
    },
    dispose: function() {
        this.____17();
        if (this._btnEffect != null) {
            this._btnEffect.dispose();
            this._btnEffect = null
        }
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        if (!!this._titleImgPath) {
            ____654.____677.removeImageQuote(this._titleImgPath, this._titleImg);
            this._titleImgPath = null
        }
        this._titleImg = null;
        if (!!this._beautyImgPath) {
            ____654.____677.removeImageQuote(this._beautyImgPath, this._beautyImg);
            this._beautyImgPath = null
        }
        this._beautyImg = null;
        for (var i = 0; i < this._gridList.length; i++) {
            this._gridList[i].dispose()
        }
        this._gridList = null;
        this._closeBtn = null;
        this._tipImg = null;
        this.____892 = null;
        this.____1185 = null;
        this._tiemDesc = null;
        this._timeLabel = null;
        this.____1096 = null;
        this._awardName = null;
        this.____1756 = null;
        this._controller = null;
        if (this._itemInfoList != null) {
            for (var i = 0; i < this._itemInfoList.length; i++) {
                this._itemInfoList[i].dispose()
            }
            this._itemInfoList = null
        }
        this._super()
    },
});
var WelcomePanel = KYPanel.extend({
    _controller: null,
    _beautyImg: null,
    _beautyImgPath: null,
    ____1102: null,
    ____1103: null,
    _itemList: null,
    _gridList: null,
    ____1480: null,
    ____1482: null,
    ____854: null,
    _count: 0,
    _itemInfo: null,
    ctor: function(controller) {
        this._super("welcomeAwardPanel.ExportJson");
        this.modeValue = 200;
        this._controller = controller;
        this._beautyImg = this.getChildByName("beautyImg");
        this._beautyImgPath = ____654.____675.____139("outPic/welcomeBeautyBg.png");
        ____654.____677.____146(this._beautyImg, this._beautyImgPath);
        this.____1102 = this.getChildByName("desLabel1");
        this.____1102.setString(____654.yuyanbaoManager.getYuyanbao("WelcomePanel.text1"));
        this.____1103 = this.getChildByName("desLabel2");
        this.____1103.setString(____654.yuyanbaoManager.getYuyanbao("WelcomePanel.text2"));
        this._itemList = [];
        this._gridList = [];
        for (var i = 0; i < 3; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            grid = new ____2129();
            this._itemList[i].addChild(grid);
            this._gridList.push(grid)
        }
        this._itemInfo = new ItemInfo();
        this.____1480 = this.getChildByName("OKBtn");
        this.____1482 = this.getChildByName("btnLabel");
        this.____1482.setString(____654.yuyanbaoManager.getYuyanbao("WelcomePanel.text3", 15));
        var sexType = ____655.____667.career;
        if (sexType == 1) {
            this.____854 = [
                [180001, 1],
                [100004, 88],
                [100003, 200000]
            ]
        } else if (sexType == 2) {
            this.____854 = [
                [180101, 1],
                [100004, 88],
                [100003, 200000]
            ]
        }
        this._count = 15;
        this._second = 1;
        this.____5();
        this.____6()
    },
    ____5: function() {
        for (var i = 0; i < 3; i++) {
            if (i == 0) {
                this._itemInfo.____107(this.____854[i][0]);
                this._itemInfo.count = this.____854[i][1];
                this._itemInfo.qhLevel = 3;
                this._gridList[i].setIsShowQHLevel(true);
                this._gridList[i].setItemInfo(this._itemInfo)
            } else {
                var itemTemplateInfo = ____655.allTemplates.____794.getItem(this.____854[i][0]);
                this._gridList[i].setItemTemplateInfo(itemTemplateInfo);
                this._gridList[i].setCount(this.____854[i][1])
            }
        }
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this._second = this._second + 1;
        if (this._second >= 60) {
            this._second = 1;
            this._count = this._count - 1;
            this.____1482.setString(____654.yuyanbaoManager.getYuyanbao("WelcomePanel.text3", this._count));
            if (this._count <= 0) {
                ____654.____678.____299(this.tick, this);
                this._controller.hideWelcomePanel()
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1480) {
                this._controller.hideWelcomePanel()
            }
        }
    },
    ____6: function() {
        this.____1480.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        ____654.selfDataMessageSender.sendWelcomeAwardGet();
        ____654.guideShow(54);
        this.____17();
        ____654.____678.____299(this.tick, this);
        if (this._beautyImgPath != null) {
            ____654.____677.removeImageQuote(this._beautyImgPath, this._beautyImg);
            this._beautyImgPath = null
        }
        this._beautyImg = null;
        this.____1102 = null;
        this.____1103 = null;
        this._itemList = null;
        this.____1480 = null;
        this.____1482 = null;
        this.____854 = null;
        this._count = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this._itemInfo != null) {
            this._itemInfo.dispose();
            this._itemInfo = null
        }
        this._super()
    },
});
var KuozhanGiftPanel = KYPanel.extend({
    ____886: null,
    ____892: null,
    _closeBtn: null,
    _itemList: null,
    _gridList: null,
    ____1592: null,
    ____1126: null,
    ctor: function(info) {
        this._super("kuozhanGiftPanel.ExportJson");
        this.modeValue = 100;
        this.____886 = this.getChildByName("btn1");
        this.____892 = this.getChildByName("btnLabel");
        this._closeBtn = this.getChildByName("closeBtn");
        this._itemList = [];
        this._gridList = [];
        for (var i = 0; i < 5; i++) {
            this._itemList.push(this.getChildByName("cell" + (i + 1)));
            var grid = new ____2129();
            this._itemList[i].addChild(grid);
            this._gridList.push(grid)
        }
        this.____1592 = ____654.____673.newRichLabel(476);
        this.____1592.setString(____654.____682.____108("10097"));
        this.____1592.setPosition(____654.____673.____159(68 + (400 - this.____1592.getTextWidth()) * 0.5, 286));
        this.addChild(this.____1592, 9);
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        if (____655.kuozhanIsComplate) {
            this.____1126 = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(71, 28), this.____886);
            this.____1126.setScaleX(1.23);
            this.____892.setString("领取奖励")
        }
        var templateList = ____655.allTemplates.awardTemplateList.getTypeList(24);
        if (templateList[0] != null) {
            var len = templateList[0].awardList.length;
            if (len > 5) {
                len = 5
            }
            for (var i = 0; i < len; i++) {
                var itemTemplateInfo = ____655.allTemplates.____794.getItem(templateList[0].awardList[i][0]);
                this._gridList[i].setItemTemplateInfo(itemTemplateInfo);
                this._gridList[i].setCount(templateList[0].awardList[i][1])
            }
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.____16);
        this.____886.addListener(this, this.____16)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._closeBtn) {
                this.dispose()
            } else if (sender == this.____886) {
                if (!____655.kuozhanIsComplate) {
                    var list = [];
                    for (var k = 0; k < ____655.kuozhanList.length; k++) {
                        var name = ____655.kuozhanList[k];
                        if (____654.____673.isFileExist("res/" + name)) {
                            continue
                        }
                        list.push(name)
                    }
                    ____654.____674.loadKuozhan(list, true)
                } else {
                    ____654.welfareMessageSender.sendKuozhanAward(2)
                }
                this.dispose()
            }
        }
    },
    dispose: function() {
        this.____17();
        this.____886 = null;
        this.____892 = null;
        this._closeBtn = null;
        this._itemList = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this.____1592 != null) {
            this.____1592.dispose();
            this.____1592 = null
        }
        if (this.____1126 != null) {
            this.____1126.dispose();
            this.____1126 = null
        }
        this._super()
    },
});
var WelfareZhuanShuGiftBuyItemView = KYNode.extend({
    _info: null,
    _nameLabel: null,
    _numLabel: null,
    _grid: null,
    ctor: function(info) {
        this._super("welfareZhuanShuGiftTipItemView.ExportJson");
        this._info = info;
        var cell = this.getChildByName("cell");
        this._grid = new ____2129();
        cell.addChild(this._grid);
        this._nameLabel = this.getChildByName("nameLabel");
        this._numLabel = this.getChildByName("numLabel");
        this.____5()
    },
    ____5: function() {
        if (this._info == null) return;
        var itemTempInfo = ____655.allTemplates.____794.getItem(this._info[0]);
        if (itemTempInfo != null) {
            this._grid.setItemTemplateInfo(itemTempInfo);
            this._numLabel.setString("x" + this._info[1]);
            this._nameLabel.setString(itemTempInfo.name);
            this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTempInfo.quality))
        }
    },
    dispose: function() {
        this._info = null;
        this._nameLabel = null;
        this._numLabel = null;
        this._grid.dispose();
        this._grid = null;
        this._super()
    },
});
var WelfareZhuanShuGiftBuyView = KYPanel.extend({
    _controller: null,
    _info: null,
    _nameLabel: null,
    ____1166: null,
    ____919: null,
    _oldPriceLabel: null,
    _newPriceLabel: null,
    _closeBtn: null,
    _tileContainer: null,
    ____854: null,
    _bg: null,
    ctor: function(controller, info) {
        this._super("welfareZhuanShuGiftTipView.ExportJson");
        this._controller = controller;
        this._info = info;
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1166 = this.getChildByName("moneyIcon");
        this.____919 = this.getChildByName("buyBtn");
        this._oldPriceLabel = this.getChildByName("priceLabel1");
        this._newPriceLabel = this.getChildByName("priceLabel2");
        this._closeBtn = this.getChildByName("closeBtn");
        this._bg = this.getChildByName("board");
        this.____854 = [];
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._bg.addListener(this, this.bgClickHandler);
        this.____919.addListener(this, this.buyBtnClickHandler);
        this._closeBtn.addListener(this, this.____29)
    },
    bgClickHandler: function(sender, eventType) {},
    ____5: function() {
        if (this._info == null) return;
        var itemTempInfo = ____655.allTemplates.____794.getItem(this._info.award[0][0]);
        this._nameLabel.setString(itemTempInfo.name);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTempInfo.quality));
        this._oldPriceLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2272.text1", this._info.oldPrice));
        this._newPriceLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2272.text1", this._info.price));
        this.____854 = this._info.showAwardList;
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._tileContainer.setFormat(1, this.____854.length + 1, ____654.____673.____160(340, 60), 15, 2, true)
    },
    getItemByIndex: function(index) {
        if (index == 0) {
            return new WelfareZhuanShuGiftBuyItemView([100004, parseInt(this._info.descript)])
        } else {
            var info = this.____854[index - 1];
            if (info != null) {
                return new WelfareZhuanShuGiftBuyItemView(info)
            }
            return null
        }
    },
    getIdByIndex: function(index) {
        if (this.____854[index - 1] == null) {
            return -1
        }
        return index
    },
    ____29: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this.dispose()
        }
    },
    buyBtnClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._info != null) {
                ____654.sdk.pay(this._info, function(retCode, vals) {
                    print("########pay return！");
                    if (retCode == 0) {
                        print("购买月卡成功！！！！")
                    } else if (retCode == 1) {
                        print("购买月卡失败！！！！")
                    } else if (retCode == 2) {
                        print("购买月卡取消！！！！")
                    }
                })
            }
        }
    },
    hideFormContainer: function() {
        this.dispose()
    },
    dispose: function() {
        this._controller = null;
        this._info = null;
        this._bg = null;
        this._nameLabel = null;
        this.____1166 = null;
        this.____919 = null;
        this._oldPriceLabel = null;
        this._newPriceLabel = null;
        this._closeBtn = null;
        this._tileContainer = null;
        this.____854 = null;
        this._super()
    },
});
var XianWeiUpLevelPanel = KYPanel.extend({
    _controller: null,
    _tittleBg: null,
    _bgPath: null,
    ____1803: null,
    _xianWeiIcon: null,
    ____1479: null,
    ____1481: null,
    ____1690: null,
    ctor: function(scenePanelController, xianWei) {
        this._super("xianWeiUpLevelView.ExportJson");
        this._controller = scenePanelController;
        this.setAnchorPoint(____654.____673.anchorPoints[0]);
        this.____857 = ____654.____673.newKYImageView();
        this.____857.setFrame("board/ui_blackBoard.png");
        this.____857.setAnchorPoint(____654.____673.anchorPoints[0]);
        this.____857.setScale9Enabled(true);
        this.____857.setCapInsets(____654.____673.____161(4, 4, 1, 1));
        this.____857.setOpacity(200);
        this.____857.setSize(____654.____673.____160(____655.____656, ____655.____657));
        this.____857.setPosition(____654.____673.____159(____655.____656 * 0.5 - 784 * 0.25 - 12, ____655.____657 * 0.5 - 258 * 0.75 + 10));
        this.____857.setTouchEnabled(true);
        this.addChild(this.____857);
        this._tittleBg = this.getChildByName("tittleBg");
        this._bgPath = ____654.____675.____139("outPic/xianWeiUpLevelBg.png");
        ____654.____677.____146(this._tittleBg, this._bgPath);
        this.____1803 = this.getChildByName("tittleLabel");
        this.____1803.setString(____654.yuyanbaoManager.getYuyanbao("XianWeiUpLevelPanel.text1"));
        this._xianWeiIcon = this.getChildByName("xianWeiIcon");
        this.____1479 = this.getChildByName("OKBtn_Copy0");
        this.____1481 = this.getChildByName("btnLabel");
        this.____1481.setString(____654.yuyanbaoManager.getYuyanbao("____2159.text4"));
        this.____6();
        var templateList = ____655.allTemplates.titleTemplateList.getTitlesByType(8);
        var xianWeiInfo = ____655.allTemplates.xianWeiTemplateList.list[xianWei];
        var template = null;
        for (var index in templateList) {
            if (templateList[index].id == xianWeiInfo.titleId) {
                template = templateList[index];
                break
            }
        }
        if (template != null) {
            this.____1690 = ____654.____675.getTilteImgPath(template.picPath);
            ____654.____677.____146(this._xianWeiIcon, this.____1690)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.hideXianWeiUpLevelPanel()
        }
    },
    ____6: function() {
        this.____1479.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._tittleBg, this._bgPath);
            this._bgPath = null
        }
        if (this.____1690 != null) {
            ____654.____677.removeImageQuote(this._xianWeiIcon, this.____1690);
            this.____1690 = null
        }
        this._xianWeiIcon = null;
        this._tittleBg = null;
        this._controller = null;
        this.____1803 = null;
        this._xianWeiIcon = null;
        this.____1479 = null;
        this.____1481 = null;
        if (this.____857 != null) {
            this.____857.dispose();
            this.____857 = null
        }
        this._super()
    },
});
var YugaoPanel = KYPanel.extend({
    _yugaoImage: null,
    _yugaoImage2: null,
    ____944: null,
    ____1127: null,
    _characterInfo: null,
    _yugaoBgPath: null,
    _yugaoBgPath2: null,
    selfLevel: 0,
    lastIndex: 0,
    _levelLabel: 0,
    ctor: function() {
        this._super();
        this.layer = ____654.____673.newKYNode();
        this._yugaoImage = ____654.____673.newKYSprite();
        this._yugaoImage2 = ____654.____673.newKYSprite();
        this._yugaoBgPath = ____654.____675.____139("outPic/ui_newlyFollowBg.png");
        this._yugaoBgPath2 = ____654.____675.____139("outPic/open_level.png");
        ____654.____677.____146(this._yugaoImage, this._yugaoBgPath);
        ____654.____677.____146(this._yugaoImage2, this._yugaoBgPath2);
        this._levelLabel = new NumberView();
        this._levelLabel.setType(2);
        this._levelLabel.setNumber(10);
        this._levelLabel.setPosition(____654.____673.____159(-30, -20));
        this._yugaoImage2.setPosition(____654.____673.____159(15, -20));
        this.layer.addChild(this._levelLabel, 9);
        this.layer.addChild(this._yugaoImage);
        this.layer.addChild(this._yugaoImage2, 9);
        this.addChild(this.layer);
        this.____5()
    },
    ____5: function() {
        this.createCharacter()
    },
    createCharacter: function() {
        this.selfLevel = ____655.____667.level;
        if (this.selfLevel < 5) {
            if (this.lastIndex == 1) {
                return
            }
            this.clearCharacter();
            this._levelLabel.setString(5);
            var styleList = {};
            var figureId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Horse, 1).figureId;
            styleList[____655.____659.commonStaticType.style_Horse] = figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Horse, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.layer);
            this.____944.move(-4, 46);
            this.lastIndex = 1
        } else if (this.selfLevel < 10) {
            if (this.lastIndex == 2) {
                return
            }
            this.clearCharacter();
            this._levelLabel.setString(10);
            var figureTemplate = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Pet, 1);
            this._characterInfo = ____654.getCharacterInfo(figureTemplate.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.layer);
            this.____944.move(-1, 42);
            this.lastIndex = 2
        } else if (this.selfLevel < 15) {
            if (this.lastIndex == 3) {
                return
            }
            this.clearCharacter();
            this._levelLabel.setString(15);
            var styleList = {};
            var figureId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Wind, 1).figureId;
            styleList[____655.____659.commonStaticType.style_Wind] = figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Wind, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.layer);
            this.____944.move(6, -23);
            this.lastIndex = 3
        } else if (this.selfLevel < 20) {
            if (this.lastIndex == 4) {
                return
            }
            this.clearCharacter();
            this._levelLabel.setString(20);
            this.____944 = new FootShowEffect(1, 4);
            var effectId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Foot, 1).figureId;
            var effectTemplate = ____655.allTemplates.____789.getEffect(effectId);
            var scaleValue = effectTemplate.scale;
            this.____944.setScale(scaleValue);
            this.____944.setPosition(____654.____673.____159(-102, 40));
            this.addChild(this.____944);
            this.lastIndex = 4
        } else if (this.selfLevel < 25) {
            if (this.lastIndex == 5) {
                return
            }
            this.clearCharacter();
            this._levelLabel.setString(25);
            var effectId = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_FaBao, 1).figureId;
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.move(7, 24);
            this.____1127.play();
            this.lastIndex = 5
        } else if (this.selfLevel < 30) {
            if (this.lastIndex == 6) {
                return
            }
            this.clearCharacter();
            this._levelLabel.setString(30);
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ZhengLing, 1).figureId);
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.move(0, 40);
            this.____1127.play();
            this.lastIndex = 6
        } else if (this.selfLevel < 35) {
            if (this.lastIndex == 7) {
                return
            }
            this.clearCharacter();
            this._levelLabel.setString(35);
            var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_ShenJian, 1).figureId);
            this.____1127 = ____654.effectManager.create(effectId, false, null, false);
            this.____1127.move(-2, 36);
            this.____1127.play();
            this.lastIndex = 7
        }
        if (!!this.____1127) {
            this.____1127.addTo(this)
        }
    },
    clearCharacter: function() {
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this.____1127 != null) {
            this.____1127.dispose();
            this.____1127 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
    },
    dispose: function() {
        this.clearCharacter();
        if (this._levelLabel != null) {
            this._levelLabel.dispose();
            this._levelLabel = null
        }
        if (this._yugaoBgPath != null) {
            ____654.____677.removeImageQuote(this._yugaoBgPath, this._yugaoImage);
            this._yugaoBgPath = null
        }
        this._characterBg = null;
        if (this._yugaoBgPath2 != null) {
            ____654.____677.removeImageQuote(this._yugaoBgPath2, this._yugaoImage2);
            this._yugaoBgPath2 = null
        }
        this._super()
    },
});
var ____2282 = cc.Class.extend({
    ____1239: null,
    _path: null,
    ____825: 0,
    _callBack: null,
    _executor: null,
    ____1533: null,
    _isShow: true,
    _isVisible: true,
    ____1539: 0,
    ____1540: 0,
    index: 0,
    ctor: function(path, addImageType) {
        this._path = path;
        this.____825 = addImageType;
        this.____1239 = ____654.____673.newKYSprite();
        if (this.getAddImageType() == 1) {
            this.____1239.setFrame(this.getPath());
            ____654.____676.mainMenuContainer.addChild(this.____1239)
        } else {
            ____654.____676.mainMenuBgContainer.addChild(this.____1239);
            ____654.____677.____146(this.____1239, this.getPath())
        }
        this.____6()
    },
    setShowPop: function(value) {
        if (value) {
            if (this.____1533 == null) {
                this.____1533 = ____654.____673.newKYSprite();
                this.____1533.setFrame("icon/ui_numTipIcon.png");
                if (this._isShow) {
                    ____654.____676.mainMenuContainer.addChild(this.____1533, 5)
                }
            }
        } else {
            if (this.____1533 != null) {
                this.____1533.dispose();
                this.____1533 = null
            }
        }
        this.resetPos()
    },
    move: function(x, y) {
        if (this.____1539 == x && this.____1540 == y) {
            return
        }
        this.____1539 = x;
        this.____1540 = y;
        this.resetPos()
    },
    moveX: function(x) {
        if (this.____1539 == x) {
            return
        }
        this.____1539 = x;
        this.resetPos()
    },
    moveY: function(y) {
        if (this.____1540 == y) {
            return
        }
        this.____1540 = y;
        this.resetPos()
    },
    resetPos: function() {
        if (this.____1239 != null) {
            this.____1239.setPosition(____654.____673.____159(this.____1539, this.____1540))
        }
        if (this.____1533 != null) {
            this.____1533.setPosition(____654.____673.____159(this.____1539 + 25, this.____1540 + 25))
        }
    },
    changeImage: function(path) {
        if (this.getAddImageType() != 1 && this.getPath() != null) {
            ____654.____677.removeImageQuote(this.getPath(), this.____1239)
        }
        this._path = path;
        if (this.getAddImageType() == 1) {
            this.____1239.setFrame(this.getPath())
        } else {
            ____654.____677.____146(this.____1239, this.getPath())
        }
    },
    ____6: function() {},
    ____17: function() {},
    setCallback: function(callBack, executor) {
        this._callBack = callBack;
        this._executor = executor
    },
    getPath: function() {
        return this._path
    },
    getAddImageType: function() {
        return this.____825
    },
    getIsOpen: function() {
        return true
    },
    setVisible: function(value) {
        if (this._isVisible == value) {
            return
        }
        this._isVisible = value;
        this.____1239.setVisible(value)
    },
    getVisible: function() {
        return this._isVisible
    },
    isMouseOver: function(pos) {
        if (!this.getVisible() || !this._isShow || !this.getIsOpen()) {
            return false
        }
        if (pos.x >= this.____1539 - 40 && pos.x <= this.____1539 + 40 && pos.y >= this.____1540 - 40 && pos.y <= this.____1540 + 40) {
            return true
        }
        return false
    },
    doClick: function() {
        if (this._callBack != null && this._executor != null) {
            this._callBack.call(this._executor, this)
        }
    },
    showIcon: function() {
        if (this.____1239 != null && this.____1239.getParent() == null) {
            if (this.getAddImageType() == 1) {
                ____654.____676.mainMenuContainer.addChild(this.____1239)
            } else {
                ____654.____676.mainMenuBgContainer.addChild(this.____1239)
            }
        }
        if (this.____1533 != null && this.____1533.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1533, 5)
        }
        this._isShow = true
    },
    hideIcon: function() {
        if (this.____1239 != null && this.____1239.getParent() != null) {
            this.____1239.removeFromParent(false)
        }
        if (this.____1533 != null && this.____1533.getParent() != null) {
            this.____1533.removeFromParent(true)
        }
        this._isShow = false
    },
    dispose: function() {
        this.____17();
        if (this.getAddImageType() != 1 && this.getPath() != null) {
            ____654.____677.removeImageQuote(this.getPath(), this.____1239)
        }
        this._path = null;
        if (this.____1239 != null) {
            this.____1239.dispose();
            this.____1239 = null
        }
        if (this.____1533 != null) {
            this.____1533.dispose();
            this.____1533 = null
        }
        this._callBack = null;
        this._executor = null
    }
});
var ____2283 = ____2282.extend({
    ____1126: null,
    _numView: null,
    _countDownUtils: null,
    _actType: 0,
    _labelBg: null,
    ____1270: true,
    _bgType: -1,
    _offsetYList: null,
    ctor: function(path, addImageType) {
        this._super(path, addImageType);
        this._offsetYList = [40, 29, 7];
        this.resetPos()
    },
    setEffect: function(value) {
        if (value) {
            if (this.____1126 == null) {
                this.____1126 = this.createEffect();
                if (this._isShow) {
                    ____654.____676.mainMenuBgContainer.addChild(this.____1126, 1)
                }
                this.resetPos()
            }
        } else {
            if (this.____1126 != null) {
                this.____1126.dispose();
                this.____1126 = null
            }
        }
    },
    createEffect: function() {
        return new RotationEffect("effect/effect_10.png", 5)
    },
    setLabel: function(content, bgType) {
        if (content == null) {
            if (this._countDownUtils != null) {
                this._countDownUtils.dispose();
                this._countDownUtils = null
            }
            if (this._numView != null) {
                this._numView.dispose();
                this._numView = null;
                this._bgType = -1
            }
            if (this._labelBg != null) {
                this._labelBg.dispose();
                this._labelBg = null
            }
        } else {
            this.setTime(99, content, bgType, null)
        }
    },
    setTime: function(type, seconds, bgType, callback) {
        var this_ = this;

        function endCallBack() {
            if (callback != null) {
                callback()
            }
            if (this_._actType > 0) {
                ____655.activityIconList.removeTimingIcon(this_._actType)
            }
        };
        if (this._numView == null) {
            this._numView = new NumberView();
            this._numView.setType(0, null, 0.9);
            ____654.____676.mainMenuContainer.addChild(this._numView, 5);
            if (!this._isShow) {
                this._numView.removeFromParent(false)
            }
        }
        if (this._labelBg == null) {
            this._labelBg = ____654.____673.newKYSprite();
            this._labelBg.setFrame("bar/ui_bar18.png");
            if (this._isShow) {
                ____654.____676.mainMenuContainer.addChild(this._labelBg, 1)
            }
        }
        if (type == 99) {
            if (this._countDownUtils != null) {
                this._countDownUtils.dispose();
                this._countDownUtils = null
            }
            this._numView.setString(seconds)
        } else {
            if (this._countDownUtils == null) {
                this._countDownUtils = new ____2111();
                this._countDownUtils.setLabel(this._numView, type)
            }
            this._countDownUtils.start(seconds, null, endCallBack)
        }
        if (bgType == null) {
            bgType = 0
        }
        if (this._bgType != bgType) {
            this._bgType = bgType;
            var frame = null;
            if (this._bgType == 1) {
                frame = "flag/ui_timeBg.png";
                this._labelBg.setScale(1);
                this._numView.setColor(____655.____659.____688.yellow)
            } else if (this._bgType == 0) {
                frame = "bar/ui_bar18.png";
                this._labelBg.setScaleY(0.9);
                this._labelBg.setScaleX(0.7);
                this._numView.setColor(____655.____659.____688.lightGreen)
            } else if (this._bgType == 2) {
                frame = "bar/ui_bar18.png";
                this._labelBg.setScaleY(0.9);
                this._labelBg.setScaleX(0.7);
                this._numView.setColor(____655.____659.____688.yellow)
            }
            if (frame != null) {
                this._labelBg.setFrame(frame)
            }
        }
        this.resetPos()
    },
    setActType: function(actType) {
        this._actType = actType
    },
    getActType: function() {
        return this._actType
    },
    resetPos: function() {
        this._super();
        var pos = ____654.____673.____159(this.____1539, this.____1540 - this._offsetYList[this._bgType]);
        if (this._numView != null) {
            this._numView.setPosition(pos.x, pos.y)
        }
        if (this._labelBg != null) {
            if (this._bgType == 1) {
                pos.y -= 2
            }
            this._labelBg.setPosition(pos)
        }
        if (this.____1126 != null) {
            this.____1126.move(this.____1539, this.____1540)
        }
    },
    setIsOpen: function(value, level) {
        if (this.____1270 == value) {
            return
        }
        this.____1270 = value;
        if (this.____1270 == false) {
            this.setShowPop(false);
            this.setEffect(false);
            this.____1239.setColor(cc.color(175, 175, 175));
            this.setLabel(level.toString() + "l", 2);
            if (this._numView != null) {
                this._numView.setColor(____655.____659.____688.yellow)
            }
        } else {
            this.____1239.setColor(cc.color(255, 255, 255));
            this.setLabel(null)
        }
        this.resetPos()
    },
    getIsOpen: function() {
        return this.____1270
    },
    showIcon: function() {
        this._super();
        if (this._numView != null && this._numView.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._numView, 5)
        }
        if (this._labelBg != null && this._labelBg.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._labelBg, 1)
        }
        if (this.____1126 != null) {
            ____654.____676.mainMenuBgContainer.addChild(this.____1126, 1)
        }
    },
    hideIcon: function() {
        this._super();
        if (this._numView != null) {
            this._numView.removeFromParent(false)
        }
        if (this._labelBg != null) {
            this._labelBg.removeFromParent(false)
        }
        if (this.____1126 != null) {
            this.____1126.removeFromParent(false)
        }
    },
    dispose: function() {
        this._super();
        this.setEffect(false);
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        if (this._numView != null) {
            this._numView.dispose();
            this._numView = null
        }
        if (this._labelBg != null) {
            this._labelBg.dispose();
            this._labelBg = null
        }
        this._offsetYList = null
    },
});
var MenuAfkIcon = ____2283.extend({
    _isAfk: false,
    ctor: function() {
        this._super("icon/ui_hangupBtn.png", 1)
    },
    setAfk: function(value) {
        if (this._isAfk == value) {
            return
        }
        this._isAfk = value;
        if (this._isAfk) {
            this.changeImage("icon/ui_hanguping.png");
            this.setEffect(true);
            this.____1126.setScale(0.85)
        } else {
            this.changeImage("icon/ui_hangupBtn.png");
            this.setEffect(false)
        }
    },
    getAfk: function() {
        return this._isAfk
    },
    createEffect: function() {
        return new OpacityEffect("effect/effect_13.png", -5)
    },
    doClick: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, !this._isAfk))
    },
});
var MenuChatIcon = ____2283.extend({
    ____1166: null,
    _isShowFlag: false,
    ctor: function() {
        this._super("sceneIcon/ui_chatIcon.png", 1);
        this.____1166 = ____654.____673.newKYSprite();
        this.____1166.setFrame("flag/ui_clubChatTip.png");
        ____654.____676.mainMenuContainer.addChild(this.____1166, 5);
        this.updateFlagImg();
        this.resetPos()
    },
    resetPos: function() {
        this._super();
        if (this.____1166 != null) {
            this.____1166.setPosition(____654.____673.____159(this.____1539 + 20, this.____1540 + 22))
        }
    },
    showIcon: function() {
        this._super();
        if (this.____1166 != null && tihs.____1166.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1166, 5)
        }
    },
    hideIcon: function() {
        this._super();
        if (this.____1166 != null && tihs.____1166.getParent() != null) {
            this.____1166.removeFromParent(false)
        }
    },
    setClubImg: function(value) {
        if (value == this._isShowFlag) {
            return
        }
        this._isShowFlag = value;
        this.updateFlagImg()
    },
    getClubImg: function() {
        return this._isShowFlag
    },
    updateFlagImg: function() {
        if (this._isShowFlag) {
            this.____1166.setVisible(true)
        } else {
            this.____1166.setVisible(false)
        }
    },
    dispose: function() {
        this._super();
        if (this.____1166 != null) {
            this.____1166.dispose();
            this.____1166 = null
        }
    },
});
var ____2284 = ____2283.extend({
    ____1266: true,
    ctor: function() {
        this._super("sceneIcon/ui_menuBtn.png", 1);
        this.____1239.setScale(-1)
    },
    setFold: function(value) {
        this.____1266 = value;
        if (value) {
            this.____1239.setScale(-1)
        } else {
            this.____1239.setScale(1)
        }
    },
    doClick: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_foldBtn, ____654.____672, null))
    },
});
var MenuGiftIcon = ____2283.extend({
    _intervalTime: 0,
    ____1770: 0,
    ____1771: 0,
    _tickCount3: 0,
    ____1165: 1,
    ____1478: 0,
    _effect2: null,
    setEffect2: function(value) {
        if (value) {
            if (this._effect2 == null) {
                this._effect2 = ____654.effectManager.create(____655.allTemplates.____789.GIFT_ICON_EFFECT, false, null, false);
                this._effect2.play();
                if (this._isShow) {
                    this._effect2.addTo(____654.____676.mainMenuBgContainer, 6)
                }
                this.resetPos()
            }
        } else {
            if (this._effect2 != null) {
                this._effect2.dispose();
                this._effect2 = null
            }
        }
    },
    setFloat: function(isOn, intervalTime, isShowEffect) {
        this._intervalTime = intervalTime * 60;
        if (isOn != null && isOn) {
            if (isShowEffect != null) {
                this.setEffect2(isShowEffect)
            }
            ____654.____678.____298(this.tick, this)
        } else {
            ____654.____678.____299(this.tick, this)
        }
    },
    tick: function(delta, count) {
        this.____1770++;
        if (this.____1770 >= this._intervalTime) {
            this.____1771++;
            if (this.____1771 > 1) {
                this.____1771 = 0;
                this.____1478 += this.____1165;
                if (this.____1478 < 0 || this.____1478 > 6) {
                    this.____1165 = -this.____1165;
                    this._tickCount3++;
                    if (this.____1165 > 0 && this._tickCount3 > 3) {
                        this._tickCount3 = 0;
                        this.____1770 = 0;
                        if (this._effect2 != null && this._isShow) {
                            this._effect2.addToContainer()
                        }
                    } else {
                        if (this._effect2 != null) {
                            this._effect2.removeFromContainer()
                        }
                    }
                }
                this.____1239.setPositionY(this.____1540 + this.____1478)
            }
        }
    },
    resetPos: function() {
        this._super();
        if (this._effect2 != null) {
            this._effect2.move(this.____1539 + 4, this.____1540 - 5)
        }
    },
    showIcon: function() {
        this._super();
        if (this._effect2 != null) {
            this._effect2.addTo(____654.____676.mainMenuBgContainer, 6)
        }
    },
    hideIcon: function() {
        this._super();
        if (this._effect2 != null) {
            this._effect2.removeFromContainer()
        }
    },
    dispose: function() {
        this._super();
        ____654.____678.____299(this.tick, this);
        this.setEffect2(false)
    },
});
var MenuVipIcon = ____2283.extend({
    ____1844: null,
    _levelLabel: null,
    _level: -1,
    ctor: function() {
        this._super("icon/ui_vipIcon0.png", 1);
        this.____1239.setScale(0.6);
        this.____1844 = ____654.____673.newKYSprite();
        this.____1844.setFrame("flag/ui_vipFlag.png");
        this.____1844.setScale(0.7);
        ____654.____676.mainMenuContainer.addChild(this.____1844, 4);
        this._levelLabel = new NumberView();
        this._levelLabel.setType(2, null, 0.7);
        ____654.____676.mainMenuContainer.addChild(this._levelLabel, 3);
        this.resetPos()
    },
    setLevelLabel: function(level) {
        if (this._level == level) {
            return
        }
        this._level = level;
        this._levelLabel.setString(level);
        if (level > 0) {
            this.changeImage("icon/ui_vipIcon1.png")
        } else {
            this.changeImage("icon/ui_vipIcon0.png")
        }
    },
    resetPos: function() {
        this._super();
        if (this.____1844 != null) {
            this.____1844.setPosition(____654.____673.____159(this.____1539, this.____1540 + 10))
        }
        if (this._levelLabel != null) {
            this._levelLabel.setPosition(this.____1539, this.____1540 - 8)
        }
    },
    showIcon: function() {
        this._super();
        if (this.____1844 != null && this.____1844.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this.____1844, 4)
        }
        if (this._levelLabel != null && this._levelLabel.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._levelLabel, 3)
        }
    },
    hideIcon: function() {
        this._super();
        if (this.____1844 != null) {
            this.____1844.removeFromParent(false)
        }
        if (this._levelLabel != null) {
            this._levelLabel.removeFromParent(false)
        }
    },
    dispose: function() {
        this._super();
        if (this._levelLabel != null) {
            this._levelLabel.dispose();
            this._levelLabel = null
        }
        if (this.____1844 != null) {
            this.____1844.dispose();
            this.____1844 = null
        }
    },
});
var MenuXianweiIcon = ____2282.extend({
    _xianwei: 1,
    ctor: function() {
        this._super("sceneIcon/ui_xianweiIcon1.png", 1)
    },
    setXianwei: function(xianwei) {
        if (this._xianwei == xianwei) {
            return
        }
        this._xianwei = xianwei;
        this.changeImage("sceneIcon/ui_xianweiIcon" + this._xianwei.toString() + ".png")
    },
});
var ____2285 = ____2282.extend({
    _popNumView: null,
    setShowNumPop: function(count) {
        if (count != null && count > 0) {
            this.setShowPop(true);
            this.____1533.setScale(1.5);
            if (this._popNumView == null) {
                this._popNumView = new NumberView();
                this._popNumView.setType(0, ____655.____659.____688.yellow, 0.9);
                ____654.____676.mainMenuContainer.addChild(this._popNumView, 6);
                if (!this._isShow) {
                    this._popNumView.removeFromParent(false)
                }
            }
            this._popNumView.setNumber(count.toString())
        } else {
            this.setShowPop(false);
            if (this._popNumView != null) {
                this._popNumView.dispose();
                this._popNumView = null
            }
        }
        this.resetPos()
    },
    resetPos: function() {
        this._super();
        if (this._popNumView != null) {
            this._popNumView.setPosition(this.____1539 + 25, this.____1540 + 25)
        }
    },
    showIcon: function() {
        if (this._popNumView != null && this._popNumView.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._popNumView, 6)
        }
        this._super()
    },
    hideIcon: function() {
        if (this._popNumView != null) {
            this._popNumView.removeFromParent(false)
        }
        this._super()
    },
    dispose: function() {
        this._super();
        if (this._popNumView != null) {
            this._popNumView.dispose();
            this._popNumView = null
        }
    },
});
var ____2286 = ____2283.extend({
    _isShow: true,
    ctor: function() {
        this._super("sceneIcon/ui_copyShowIcon.png", 1)
    },
    setShow: function(value) {
        this._isShow = value;
        if (value) {
            this.changeImage("sceneIcon/ui_copyShowIcon.png")
        } else {
            this.changeImage("sceneIcon/ui_copyHideIcon.png")
        }
    },
    doClick: function() {},
});
var ____2287 = ____2282.extend({
    _timeView: null,
    ____1379: null,
    ____1049: -1,
    ____1774: 0,
    ____1317: "",
    ____1617: null,
    ctor: function(controller) {
        this._super("sceneIcon/ui_smallMapIcon.png", 1);
        this.____1617 = controller;
        this._timeView = new NumberView();
        this._timeView.setType(0, null, 0.9);
        ____654.____676.mainMenuContainer.addChild(this._timeView, 2);
        this.____1379 = ____654.____673.newKYLabel(17);
        this.____1379.setColor(____655.____659.____688.yellow);
        this.____1379.setPosition(____654.____673.____159(____655.____656 - 50, ____655.____657 - 50));
        ____654.____676.____799.addChild(this.____1379, 4);
        ____654.____678.____298(this.tick, this);
        this.resetPos()
    },
    tick: function(delta, count) {
        this.____1774--;
        if (this.____1774 > 0) {
            return
        }
        this.____1774 = 60;
        var min = Math.floor(____655.____662.getSystemTime() / 60000);
        if (min != this.____1049) {
            var str = ____655.____662.secondsToDateString3(____655.____662.getZeroPassTime());
            this._timeView.setNumber(str);
            this.____1049 = min
        }
        var currentMapName = "";
        if (____655.currentMapId > 0) {
            currentMapName = ____655.allTemplates.mapTemplateList.getMap(____655.currentMapId).name
        }
        var currentP = ____654.____673.____159(-1, -1);
        if (this.____1617.sceneInfo.scenePlayerList.selfPlayer != null) {
            currentP = this.____1617.sceneInfo.scenePlayerList.selfPlayer.____355()
        }
        if (currentMapName != this.____1317) {
            this.____1317 = currentMapName;
            this.____1379.setString(____655.allTemplates.mapTemplateList.getMap(____655.currentMapId).name)
        }
    },
    resetPos: function() {
        this._super();
        if (this._timeView != null) {
            this._timeView.setPosition(this.____1539 + 1, this.____1540 - 30)
        }
    },
    showIcon: function() {
        this._super();
        if (this._timeView != null && this._timeView.getParent() == null) {
            ____654.____676.mainMenuContainer.addChild(this._timeView, 2)
        }
        if (this.____1379 != null && this.____1379.getParent() == null) {
            ____654.____676.____799.addChild(this.____1379, 4)
        }
    },
    hideIcon: function() {
        this._super();
        if (this._timeView != null) {
            this._timeView.removeFromParent(false)
        }
        if (this.____1379 != null && this.____1379.getParent() != null) {
            this.____1379.removeFromParent(false)
        }
    },
    doClick: function() {
        this.____1617.showWorldMapPanel()
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this._super();
        this.____1617 = null;
        if (this._timeView != null) {
            this._timeView.dispose();
            this._timeView = null
        }
        this.____1379.dispose();
        this.____1379 = null
    }
});
var ____2288 = KYNode.extend({
    ____1239: null,
    ____1844: null,
    _levelLabel: null,
    ctor: function() {
        this._super();
        this.____1239 = ____654.____673.newKYSprite();
        this.____1239.setFrame("icon/ui_vipIcon0.png");
        this.addChild(this.____1239, 0);
        this.____1844 = ____654.____673.newKYSprite();
        this.____1844.setFrame("flag/ui_vipFlag.png");
        this.____1844.setPosition(____654.____673.____159(0, 17));
        this.addChild(this.____1844, 1);
        this._levelLabel = new NumberView();
        this._levelLabel.setType(2);
        this._levelLabel.setNumber(0);
        this._levelLabel.setPosition(____654.____673.____159(0, -8));
        this.addChild(this._levelLabel, 2);
        this.____6();
        this.setScale(0.8)
    },
    ____6: function() {},
    ____17: function() {},
    setLevelLabel: function(level) {
        this._levelLabel.setString(level);
        if (level > 0) {
            this.____1239.setFrame("icon/ui_vipIcon1.png")
        } else {
            this.____1239.setFrame("icon/ui_vipIcon0.png")
        }
    },
    dispose: function() {
        this.____17();
        this._super();
        if (this.____1239 != null) {
            this.____1239.dispose();
            this.____1239 = null
        }
        this.____1844.dispose();
        this.____1844 = null;
        if (this._levelLabel != null) {
            this._levelLabel.dispose();
            this._levelLabel = null
        }
    }
});
var ____2289 = KYPanel.extend({
    _controller: null,
    _titleLabel: null,
    ____1580: null,
    ____1435: null,
    ____1434: null,
    ____1436: null,
    ____1751: null,
    ____1467: null,
    ____1468: null,
    ____1469: null,
    ____1622: null,
    ____1623: null,
    ____1624: null,
    ____1578: null,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._super("hdDaLuanDouFollowPanel.ExportJson");
        this._titleLabel = this.getChildByName("titleLabel");
        this._titleLabel.setString("本方阵营前5名有丰富奖励");
        this.____1580 = this.getChildByName("rankPanel");
        this.____1580.setScrollBarEnabled(false);
        this.____1435 = this.getChildByName("myRankLabel");
        this.____1434 = this.getChildByName("myNameLabel");
        this.____1434.setString(____655.____667.nick);
        this.____1436 = this.getChildByName("myScoreLabel");
        this.____1751 = this.getChildByName("teamScoreView");
        this.____1751.setPosition(____654.____673.____159(____655.____656 - 671, 383 - 59));
        this.____1467 = this.____1751.getChildByName("numberLabel1");
        this.____1468 = this.____1751.getChildByName("numberLabel2");
        this.____1469 = this.____1751.getChildByName("numberLabel3");
        this.____1622 = this.____1751.getChildByName("scoreLabel1");
        this.____1623 = this.____1751.getChildByName("scoreLabel2");
        this.____1624 = this.____1751.getChildByName("scoreLabel3");
        this.____1467.setString("0人");
        this.____1468.setString("0人");
        this.____1469.setString("0人");
        this.____1622.setString("0分");
        this.____1623.setString("0分");
        this.____1624.setString("0分");
        this.____1578 = {};
        this.____6();
        this.updateInfoView(null);
        this.updateRankView(null)
    },
    ____6: function() {
        ____655.warDatas.daLuanDouInfo.addEventListener(____655.____661.war_daluandou_info, this.updateInfoView, this);
        ____655.warDatas.daLuanDouInfo.addEventListener(____655.____661.war_daluandou_rank, this.updateRankView, this)
    },
    ____17: function() {
        ____655.warDatas.daLuanDouInfo.removeEventListener(____655.____661.war_daluandou_info, this.updateInfoView, this);
        ____655.warDatas.daLuanDouInfo.removeEventListener(____655.____661.war_daluandou_rank, this.updateRankView, this)
    },
    updateInfoView: function(evt) {
        this.____1435.setString(____655.warDatas.daLuanDouInfo.selfRank);
        this.____1436.setString(____655.warDatas.daLuanDouInfo.selfScore);
        var campData = ____655.warDatas.daLuanDouInfo.camps[1];
        if (campData != null) {
            this.____1467.setString(campData[0] + "人");
            this.____1622.setString(campData[1] + "分")
        }
        campData = ____655.warDatas.daLuanDouInfo.camps[2];
        if (campData != null) {
            this.____1468.setString(campData[0] + "人");
            this.____1623.setString(campData[1] + "分")
        }
        campData = ____655.warDatas.daLuanDouInfo.camps[3];
        if (campData != null) {
            this.____1469.setString(campData[0] + "人");
            this.____1624.setString(campData[1] + "分")
        }
    },
    getItemByIndex: function(index) {
        var item = this.____1578[index];
        if (item != null) return item;
        item = new ____2290();
        this.____1580.pushBackCustomItem(item);
        this.____1578[index] = item;
        return item
    },
    updateRankView: function(evt) {
        var list = ____655.warDatas.daLuanDouInfo.rankList;
        var count = 0;
        for (var i = 1; i <= 5; i++) {
            var info = list[i];
            var item = this.getItemByIndex(count);
            if (info != null) {
                item.____18(info)
            } else {
                item.clear()
            }
            count++
        }
    },
    dispose: function() {
        this.____17();
        if (this.____1578 != null) {
            for (var i in this.____1578) {
                if (this.____1578[i] != null) {
                    this.____1578[i].dispose()
                }
            }
            this.____1578 = null
        }
        this._controller = null;
        this._titleLabel = null;
        this.____1580 = null;
        this.____1435 = null;
        this.____1434 = null;
        this.____1436 = null;
        this.____1751 = null;
        this.____1467 = null;
        this.____1468 = null;
        this.____1469 = null;
        this.____1622 = null;
        this.____1623 = null;
        this.____1624 = null;
        this._super()
    },
});
var ____2290 = KYNode.extend({
    ____1579: null,
    _nameLabel: null,
    ____1621: null,
    ctor: function() {
        this._super("hdDaLuanDouFollowItemView.ExportJson");
        this.____1579 = this.getChildByName("rankLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1621 = this.getChildByName("scoreLabel")
    },
    ____18: function(data) {
        this.____1579.setString(data.rank);
        this._nameLabel.setString(data.nick);
        this.____1621.setString(data.score)
    },
    clear: function() {
        this.____1579.setString("");
        this._nameLabel.setString("");
        this.____1621.setString("")
    },
    dispose: function() {
        this.____1579 = null;
        this._nameLabel = null;
        this.____1621 = null;
        this._super()
    },
});
var ____2291 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: "",
    _jumpBtn: null,
    _headIcon1: null,
    _headIcon2: null,
    _hpBar1: null,
    ____1232: null,
    ____1443: null,
    ____1444: null,
    _levelLabel1: null,
    _levelLabel2: null,
    _player1: null,
    _player2: null,
    _tickCount: 0,
    _player1Blood: 0,
    _player2Blood: 0,
    _bloodDelta1: 0,
    _bloodDelta2: 0,
    _skillList1: null,
    _skillList2: null,
    _isDead: false,
    ctor: function(scenePanelController) {
        this._super("hdDoushenPanel.ExportJson");
        ____655.isShowGetTip = false;
        this._controller = scenePanelController;
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/doushenBg.png");
        this._jumpBtn = this.getChildByName("jumpBtn");
        var leftLayer = this.getChildByName("leftLayer");
        var rightLayer = this.getChildByName("rightLayer");
        this._headIcon1 = leftLayer.getChildByName("headIcon");
        this._headIcon2 = rightLayer.getChildByName("headIcon");
        this._hpBar1 = leftLayer.getChildByName("hpBar");
        this.____1232 = rightLayer.getChildByName("hpBar");
        this.____1443 = leftLayer.getChildByName("nameLabel");
        this.____1444 = rightLayer.getChildByName("nameLabel");
        this._levelLabel1 = leftLayer.getChildByName("levelLabel");
        this._levelLabel2 = rightLayer.getChildByName("levelLabel");
        ____654.____677.____146(this._bg, this._bgPath);
        this._jumpBtn.addListener(this, this.____16);
        ____654.____678.____298(this.tick, this);
        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, false));
        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkStop, ____654.____672))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this.dispose()
        }
    },
    tick: function(delta, count) {
        this._tickCount++;
        var selfP = ____655.warDatas.douShenInfo.selfPlayer;
        var otherP = ____655.warDatas.douShenInfo.otherPlayer;
        if (this._tickCount == 1) {
            this._headIcon1.setFrame("sceneIcon/PlayerHeadIcon2_" + selfP.playerInfo.career + ".png", 1);
            this._headIcon2.setFrame("sceneIcon/PlayerHeadIcon2_" + otherP.playerInfo.career + ".png", 1);
            this.____1443.setString(selfP.playerInfo.nick);
            this.____1444.setString(otherP.playerInfo.nick);
            this._levelLabel1.setString(selfP.playerInfo.level);
            this._levelLabel2.setString(otherP.playerInfo.level);
            this._player1 = new DouShenPlayer(selfP);
            this._player2 = new DouShenPlayer(otherP);
            this._player1.setPosition(200, 260);
            this._player2.setPosition(1000, 260);
            this._player1.____431();
            this._player2.____431();
            this.addChild(this._player1);
            this.addChild(this._player2);
            this._player1Blood = selfP.hp;
            this._player2Blood = otherP.hp;
            if (selfP.isWin) {
                this._bloodDelta1 = Math.ceil(this._player1Blood / 5);
                this._bloodDelta2 = Math.ceil(this._player2Blood / 4)
            } else {
                this._bloodDelta1 = Math.ceil(this._player1Blood / 4);
                this._bloodDelta2 = Math.ceil(this._player2Blood / 5)
            }
            this._skillList1 = ____655.allTemplates.skillTemplateList.getSkillListByCareer(selfP.playerInfo.career).slice(0);
            this._skillList2 = ____655.allTemplates.skillTemplateList.getSkillListByCareer(otherP.playerInfo.career).slice(0);
            this.updateBloodBar()
        } else if (this._tickCount < 100) {
            this._player1.setPosition(this._player1.getPositionX() + 3, 260);
            this._player2.setPosition(this._player2.getPositionX() - 3, 260)
        } else if (this._tickCount == 100) {
            this._player1.doStand();
            this._player2.doStand()
        } else if (this._tickCount < 500) {
            if (this._player1Blood > 0 && this._player2Blood > 0) {
                if (this._tickCount % 60 == 0) {
                    this._player1.doAttack();
                    var tmpd = this._bloodDelta2 - Math.ceil(Math.random() * 10);
                    this._player2.reduceBlood(tmpd);
                    this._player2Blood -= tmpd;
                    this.updateBloodBar()
                }
                if ((this._tickCount - 7) % 60 == 0) {
                    if (this._skillList1.length > 0) {
                        var skillId = this._skillList1.pop();
                        skillId = ____655.allTemplates.skillTemplateList.getChangeSkillId(skillId, selfP.playerInfo.characterInfo.getShenBin());
                        var effectId = ____655.allTemplates.skillTemplateList.getSkill(skillId).attackEffect;
                        if (effectId > 0) {
                            var p1 = ____654.____673.____159(this._player1.getPositionX(), this._player1.getPositionY() + 40);
                            var p2 = ____654.____673.____159(this._player2.getPositionX(), this._player2.getPositionY() + 40);
                            if (effectId >= 9000 && effectId <= 10000) {
                                var particleInfo = ____655.particleInfoList.list[effectId];
                                if (particleInfo != null) {
                                    var p = new particleInfo.cls(this, particleInfo);
                                    var sp = p1;
                                    p.move(sp.x, sp.y);
                                    if (particleInfo.setDegree || particleInfo.setRotate) {
                                        var tp = p2;
                                        var degree = ____655.____659.____686.____97(sp, tp);
                                        if (particleInfo.setDegree) {
                                            p.setDegree(degree)
                                        }
                                        if (particleInfo.setRotate) {
                                            p.setRotate(degree)
                                        }
                                    }
                                    p.play()
                                }
                            } else ____654.effectManager.setEffect(effectId, false, p2, this)
                        }
                    }
                }
                if ((this._tickCount - 10) % 60 == 0) {
                    this._player2.doAttack();
                    var tmpd = this._bloodDelta1 - Math.ceil(Math.random() * 10);
                    this._player1.reduceBlood(tmpd);
                    this._player1Blood -= tmpd;
                    this.updateBloodBar()
                }
                if ((this._tickCount - 17) % 60 == 0) {
                    if (this._skillList2.length > 0) {
                        var skillId = this._skillList2.pop();
                        skillId = ____655.allTemplates.skillTemplateList.getChangeSkillId(skillId, otherP.playerInfo.characterInfo.getShenBin());
                        var effectId = ____655.allTemplates.skillTemplateList.getSkill(skillId).attackEffect;
                        if (effectId > 0) {
                            var p1 = ____654.____673.____159(this._player1.getPositionX(), this._player1.getPositionY() + 40);
                            var p2 = ____654.____673.____159(this._player2.getPositionX(), this._player2.getPositionY() + 40);
                            if (effectId >= 9000 && effectId <= 10000) {
                                var particleInfo = ____655.particleInfoList.list[effectId];
                                if (particleInfo != null) {
                                    var p = new particleInfo.cls(this, particleInfo);
                                    var sp = p2;
                                    p.move(sp.x, sp.y);
                                    if (particleInfo.setDegree || particleInfo.setRotate) {
                                        var tp = p1;
                                        var degree = ____655.____659.____686.____97(sp, tp);
                                        if (particleInfo.setDegree) {
                                            p.setDegree(degree)
                                        }
                                        if (particleInfo.setRotate) {
                                            p.setRotate(degree)
                                        }
                                    }
                                    p.play()
                                }
                            } else ____654.effectManager.setEffect(effectId, false, p1, this)
                        }
                    }
                }
            } else {
                if (!this._isDead) {
                    if (this._player1Blood <= 0) {
                        this._player1.____429();
                        this._player1.doDead();
                        this._player2.doStand()
                    } else if (this._player2Blood <= 0) {
                        this._player2.____429();
                        this._player2.doDead();
                        this._player1.doStand()
                    }
                    this._isDead = true
                }
            }
        } else {
            this.dispose()
        }
    },
    updateBloodBar: function() {
        this._hpBar1.setPercent(Math.ceil(this._player1Blood / ____655.warDatas.douShenInfo.selfPlayer.hp * 100));
        this.____1232.setPercent(Math.ceil(this._player2Blood / ____655.warDatas.douShenInfo.otherPlayer.hp * 100))
    },
    dispose: function() {
        ____655.isShowGetTip = true;
        ____654.____678.____299(this.tick, this);
        var dataList = [____655.warDatas.douShenInfo.selfPlayer.isWin, ____655.rankInfo.doushenSelfRank, ____655.warDatas.douShenInfo.awardExp, ____655.warDatas.douShenInfo.awardHonor, ____655.warDatas.douShenInfo.itemList];
        ____654.____672.dispatchEvent(new ____590(____655.____661.copy_showComplatePanel, ____654.____672, [0, dataList]));
        if (this._bgPath != "") {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = ""
        }
        this._bg = null;
        this._jumpBtn = null;
        this._headIcon1 = null;
        this._headIcon2 = null;
        this._hpBar1 = null;
        this.____1232 = null;
        this.____1443 = null;
        this.____1444 = null;
        this._levelLabel1 = null;
        this._levelLabel2 = null;
        if (this._player1 != null) {
            this._player1.dispose();
            this._player1 = null
        }
        if (this._player2 != null) {
            this._player2.dispose();
            this._player2 = null
        }
        this._player1Blood = null;
        this._player2Blood = null;
        this._skillList1 = null;
        this._skillList2 = null;
        this._controller = null;
        this._super()
    },
});
var DouShenPlayer = KYNode.extend({
    character: null,
    _info: null,
    _isDead: false,
    _batchNode: null,
    ctor: function(info) {
        this._super(null);
        this._info = info;
        this.character = new ____545(this._info.playerInfo.characterInfo, this.____209, this);
        if (this._info.index == 1) {
            this.character.init(____655.____659.____686.rightBottom, this, 1)
        } else {
            this.character.init(____655.____659.____686.leftBottom, this, 1)
        }
        this.character.move(0, 30);
        this._batchNode = ____654.____673.newKYNode();
        this.addChild(this._batchNode)
    },
    ____209: function(anima) {
        if (this._isDead) this.doDead();
        else this.doStand()
    },
    ____429: function() {
        this._isDead = true
    },
    ____431: function() {
        if (this.character != null) {
            this.character.____203(____655.____659.____687.walk)
        }
    },
    doStand: function() {
        if (this.character != null) {
            this.character.____203(____655.____659.____687.stand)
        }
    },
    doAttack: function() {
        if (this.character != null) {
            this.character.____203(____655.____659.____687.attack)
        }
    },
    doDead: function() {
        if (this.character != null) {
            this.character.____203(____655.____659.____687.dead)
        }
    },
    reduceBlood: function(value) {
        var blood = new ____606(this._batchNode, true);
        blood.____18(value, ____655.____659.commonStaticType.attackResult_common, 1);
        blood.play();
        blood.move(0, -80)
    },
    dispose: function() {
        if (this.character != null) {
            this.character.dispose();
            this.character = null
        }
        if (this._info != null) {
            this._info.dispose();
            this._info = null
        }
        if (this._batchNode != null) {
            this._batchNode.dispose();
            this._batchNode = null
        }
        this._super()
    },
});
var ____2292 = KYPanel.extend({
    _controller: null,
    _sceneInfo: null,
    _titleLabel: null,
    ____1580: null,
    ____1435: null,
    ____1434: null,
    ____1436: null,
    _teamInfoView: null,
    _campFlag1: null,
    _campFlag2: null,
    ____1622: null,
    ____1623: null,
    _levelLabel11: null,
    _levelLabel12: null,
    _levelLabel13: null,
    _levelLabel21: null,
    _levelLabel22: null,
    _levelLabel23: null,
    _myLevelLabel1: null,
    _myLevelLabel2: null,
    _myLevelLabel3: null,
    _inspireBtn: null,
    ____1578: null,
    _lastHasCollect: false,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._sceneInfo = this._controller.sceneInfo;
        this._super("hdClubWarFollowPanel.ExportJson");
        this._titleLabel = this.getChildByName("titleLabel");
        this._titleLabel.setString("前5名有丰富奖励");
        this.____1580 = this.getChildByName("rankPanel");
        this.____1580.setScrollBarEnabled(false);
        this.____1435 = this.getChildByName("myRankLabel");
        this.____1434 = this.getChildByName("myNameLabel");
        this.____1436 = this.getChildByName("myScoreLabel");
        this._teamInfoView = this.getChildByName("teamInfoView");
        this._teamInfoView.setPosition(____654.____673.____159(____655.____656 - 813, 385 - 105));
        this._campFlag1 = this._teamInfoView.getChildByName("campFlag1");
        this._campFlag2 = this._teamInfoView.getChildByName("campFlag2");
        this.____1622 = this._teamInfoView.getChildByName("scoreLabel1");
        this.____1623 = this._teamInfoView.getChildByName("scoreLabel2");
        this._levelLabel11 = this._teamInfoView.getChildByName("levelLabel11");
        this._levelLabel12 = this._teamInfoView.getChildByName("levelLabel12");
        this._levelLabel13 = this._teamInfoView.getChildByName("levelLabel13");
        this._levelLabel21 = this._teamInfoView.getChildByName("levelLabel21");
        this._levelLabel22 = this._teamInfoView.getChildByName("levelLabel22");
        this._levelLabel23 = this._teamInfoView.getChildByName("levelLabel23");
        this._myLevelLabel1 = this._teamInfoView.getChildByName("myLevelLabel1");
        this._myLevelLabel2 = this._teamInfoView.getChildByName("myLevelLabel2");
        this._myLevelLabel3 = this._teamInfoView.getChildByName("myLevelLabel3");
        this._inspireBtn = this._teamInfoView.getChildByName("inspireBtn");
        this._teamInfoView.getChildByName("btnLabel").setString("鼓舞");
        this._inspireBtn.addListener(this, this.____16);
        this.____1578 = [];
        this.jiazuInfoUpdate(null);
        this.____6();
        this.addSelfHandler(null);
        this.____338(null)
    },
    ____6: function() {
        ____655.warDatas.jiazuWarInfo.addEventListener(____655.____661.war_jiazu_infoUpdate, this.jiazuInfoUpdate, this);
        ____655.warDatas.jiazuWarInfo.addEventListener(____655.____661.war_jiazu_guwuUpdate, this.jiazuGuwuUpdate, this);
        this._sceneInfo.scenePlayerList.addEventListener(____655.____661.sceneInfo_selfInfo, this.addSelfHandler, this);
        ____654.____672.addEventListener(____655.____661.sceneInfo_defaultSkillClick, this.defaultClickHandler, this)
    },
    ____17: function() {
        ____655.warDatas.jiazuWarInfo.removeEventListener(____655.____661.war_jiazu_infoUpdate, this.jiazuInfoUpdate, this);
        ____655.warDatas.jiazuWarInfo.removeEventListener(____655.____661.war_jiazu_guwuUpdate, this.jiazuGuwuUpdate, this);
        this._sceneInfo.scenePlayerList.removeEventListener(____655.____661.sceneInfo_selfInfo, this.addSelfHandler, this);
        if (this._sceneInfo.scenePlayerList.selfPlayer != null) {
            this._sceneInfo.scenePlayerList.selfPlayer.removeEventListener(____655.____661.playerInfo_move, this.selfMoveHandler, this);
            this._sceneInfo.scenePlayerList.selfPlayer.buffInfo.removeEventListener(____655.____661.playerInfo_updateBuff, this.____338, this)
        }
        ____654.____672.removeEventListener(____655.____661.sceneInfo_defaultSkillClick, this.defaultClickHandler, this)
    },
    addSelfHandler: function(evt) {
        if (this._sceneInfo.scenePlayerList.selfPlayer != null) {
            this._sceneInfo.scenePlayerList.selfPlayer.addEventListener(____655.____661.playerInfo_move, this.selfMoveHandler, this);
            this._sceneInfo.scenePlayerList.selfPlayer.buffInfo.addEventListener(____655.____661.playerInfo_updateBuff, this.____338, this)
        }
    },
    selfMoveHandler: function(evt) {
        var selfPlayer = this._sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer != null && !____655.warDatas.jiazuWarInfo.hasCollectSubmit) {
            if (!selfPlayer.buffInfo.getCanCollect()) {
                var p = selfPlayer.____355();
                var list = ____655.warDatas.jiazuWarInfo.sendPoints;
                for (var i = 0; i < list.length; i++) {
                    var dis = ____654.____674.____179(p, list[i]);
                    if (dis < 200) {
                        ____655.warDatas.jiazuWarInfo.hasCollectSubmit = true;
                        this._controller.warMessageSender.sendJiazuSubmit();
                        return
                    }
                }
            }
        }
    },
    ____338: function(evt) {
        var selfPlayer = this._sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        if (selfPlayer.buffInfo.getCanCollect()) {
            ____655.skillItemList.setState(0);
            if (this._lastHasCollect && !____655.warDatas.jiazuWarInfo.hasCollectSubmit) {
                ____654.tipsManager.quickTip.show("水晶已掉落")
            }
        } else {
            ____655.skillItemList.setState(1)
        }
        this._lastHasCollect = !selfPlayer.buffInfo.getCanCollect();
        this._controller.updateSkillPad()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.showJiazuWarGuwuPanel()
        }
    },
    defaultClickHandler: function(evt) {
        var selfPlayer = this._sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        if (selfPlayer.buffInfo.getCanCollect()) return;
        var points = ____655.warDatas.jiazuWarInfo.sendPoints;
        var dis = 10000;
        var p = null;
        for (var i = 0; i < points.length; i++) {
            var d = ____654.____674.____179(selfPlayer.____355(), points[i]);
            if (d < dis) {
                dis = d;
                p = points[i]
            }
        }
        if (p != null) {
            this._controller.sceneModule.walkTester.walkToPoint(____655.currentMapId, p, 0, null, true)
        }
    },
    jiazuInfoUpdate: function(evt) {
        this.____1435.setString(____655.warDatas.jiazuWarInfo.selfRank);
        this.____1436.setString(____655.warDatas.jiazuWarInfo.selfScore);
        this.____1434.setString(____655.____667.nick);
        var list = ____655.warDatas.jiazuWarInfo.players;
        var len = list.length;
        for (var i = 0; i < len; i++) {
            var item = this.____1578[i];
            if (item == null) {
                item = new ____2293();
                this.____1580.pushBackCustomItem(item);
                this.____1578.push(item)
            }
            item.____18(list[i])
        }
        for (var i = len; i < this.____1578.length; i++) {
            this.____1578[i].clear()
        }
        var redClub = ____655.warDatas.jiazuWarInfo.clubs[1];
        if (redClub != null) {
            this.____1622.setString(redClub.score)
        }
        var blueClub = ____655.warDatas.jiazuWarInfo.clubs[2];
        if (blueClub != null) {
            this.____1623.setString(blueClub.score)
        }
    },
    jiazuGuwuUpdate: function(evt) {
        this._myLevelLabel1.setString("Lv." + ____655.warDatas.jiazuWarInfo.personGuwuInfo[0].level);
        this._myLevelLabel2.setString("Lv." + ____655.warDatas.jiazuWarInfo.personGuwuInfo[1].level);
        this._myLevelLabel3.setString("Lv." + ____655.warDatas.jiazuWarInfo.personGuwuInfo[2].level);
        this._levelLabel11.setString("Lv." + ____655.warDatas.jiazuWarInfo.jiazuGuwu1Info[0].level);
        this._levelLabel12.setString("Lv." + ____655.warDatas.jiazuWarInfo.jiazuGuwu1Info[1].level);
        this._levelLabel13.setString("Lv." + ____655.warDatas.jiazuWarInfo.jiazuGuwu1Info[2].level);
        this._levelLabel21.setString("Lv." + ____655.warDatas.jiazuWarInfo.jiazuGuwu2Info[0].level);
        this._levelLabel22.setString("Lv." + ____655.warDatas.jiazuWarInfo.jiazuGuwu2Info[1].level);
        this._levelLabel23.setString("Lv." + ____655.warDatas.jiazuWarInfo.jiazuGuwu2Info[2].level)
    },
    dispose: function() {
        ____655.skillItemList.setState(0);
        this.____17();
        this._controller = null;
        this._sceneInfo = null;
        this._titleLabel = null;
        this.____1580 = null;
        this.____1435 = null;
        this.____1434 = null;
        this.____1436 = null;
        this._teamInfoView = null;
        this._campFlag1 = null;
        this._campFlag2 = null;
        this.____1622 = null;
        this.____1623 = null;
        this._levelLabel11 = null;
        this._levelLabel12 = null;
        this._levelLabel13 = null;
        this._levelLabel21 = null;
        this._levelLabel22 = null;
        this._levelLabel23 = null;
        this._myLevelLabel1 = null;
        this._myLevelLabel2 = null;
        this._myLevelLabel3 = null;
        this._inspireBtn = null;
        if (this.____1578 != null) {
            for (var i = 0; i < this.____1578.length; i++) {
                if (this.____1578[i] != null) {
                    this.____1578[i].dispose()
                }
            }
            this.____1578 = null
        }
        this._super()
    },
});
var ____2293 = KYNode.extend({
    ____1579: null,
    _nameLabel: null,
    ____1621: null,
    ctor: function() {
        this._super("hdDaLuanDouFollowItemView.ExportJson");
        this.____1579 = this.getChildByName("rankLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1621 = this.getChildByName("scoreLabel")
    },
    ____18: function(data) {
        this.____1579.setString(data.rank);
        this._nameLabel.setString(data.nick);
        this.____1621.setString(data.score)
    },
    clear: function() {
        this.____1579.setString("");
        this._nameLabel.setString("");
        this.____1621.setString("")
    },
    dispose: function() {
        this.____1579 = null;
        this._nameLabel = null;
        this.____1621 = null;
        this._super()
    },
});
var ____2294 = KYNode.extend({
    _skillIcon: null,
    _levelLabel: null,
    _propertyLabel: null,
    _nextPropertyLabel: null,
    _percentLabel: null,
    ____861: null,
    ____1544: null,
    _inspireBtn: null,
    _guwuInfo: null,
    _type: 0,
    _needMoney: 0,
    _controller: null,
    ctor: function(type, guwuInfo, controller) {
        this._super("hdClubWarInpireAlertItemView.ExportJson");
        this._skillIcon = this.getChildByName("skillIcon");
        this._levelLabel = this.getChildByName("levelLabel");
        this._propertyLabel = this.getChildByName("propertyLabel");
        this._nextPropertyLabel = this.getChildByName("nextPropertyLabel");
        this._percentLabel = this.getChildByName("percentLabel");
        this.____861 = this.getChildByName("bar");
        this.____1544 = this.getChildByName("priceLabel");
        this._inspireBtn = this.getChildByName("inspireBtn");
        this._type = type;
        this._guwuInfo = guwuInfo;
        this._controller = controller;
        if (this._type == 1) {
            this._needMoney = ____655.warDatas.jiazuWarInfo.personGuwuNeedMoney
        } else {
            this._needMoney = ____655.warDatas.jiazuWarInfo.jiazuGuwuNeedMoney
        }
        this.____1544.setString(this._needMoney);
        this._skillIcon.setFrame(____655.warDatas.jiazuWarInfo.guwuIconPath[this._guwuInfo.place - 1]);
        this._inspireBtn.addListener(this, this.____16);
        this.update()
    },
    ____16: function(sender, eventType) {
        var tmpType = this._type;
        var tmpPlace = this._guwuInfo.place;

        function sendCell() {
            this._controller.warMessageSender.sendJiazuGuWu(tmpType, tmpPlace)
        }
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (____655.____667.moneyInfo.money1Enough(this._needMoney)) {
                ____655.getAlert().show(2, "是否花费[0x009700]" + this._needMoney + "钻石[-]提升" + ____655.warDatas.jiazuWarInfo.guwuPropertyName[this._guwuInfo.place - 1] + (this._guwuInfo.level + 1) * ____655.warDatas.jiazuWarInfo.guwuAddPercent + "%" + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.JIAZUWARGUWU, 0, this, sendCell, null, null)
            } else {
                ____655.____667.moneyInfo.showNotEnoughTip(1)
            }
        }
    },
    update: function() {
        if (this._guwuInfo.level >= ____655.warDatas.jiazuWarInfo.guwuMaxLevel) {
            this._levelLabel.setString("已满级");
            this._percentLabel.setVisible(false);
            this.____861.setVisible(false);
            ____654.____674.setKYBtnEnabled(this._inspireBtn, false, 0)
        } else {
            this._levelLabel.setString(this._guwuInfo.level);
            var rate = ____655.warDatas.jiazuWarInfo.baseRate + this._guwuInfo.addRate;
            this._percentLabel.setString("成功率:" + rate + "%");
            this.____861.setPercent(rate);
            ____654.____674.setKYBtnEnabled(this._inspireBtn, true, 1)
        }
        var proStr = "全体";
        if (this._type == 1) proStr = "个人";
        proStr += ____655.warDatas.jiazuWarInfo.guwuPropertyName[this._guwuInfo.place - 1];
        var addPer = this._guwuInfo.level * ____655.warDatas.jiazuWarInfo.guwuAddPercent;
        var nextPer = 10;
        proStr += "+" + addPer + "%";
        this._propertyLabel.setString(proStr);
        this._nextPropertyLabel.setString("+" + nextPer + "%")
    },
    dispose: function() {
        this._skillIcon = null;
        this._levelLabel = null;
        this._propertyLabel = null;
        this._nextPropertyLabel = null;
        this._percentLabel = null;
        this.____861 = null;
        this.____1544 = null;
        this._inspireBtn = null;
        this._guwuInfo = null;
        this._controller = null;
        this._super()
    },
});
var JiazuWarGuwuPanel = KYPanel.extend({
    _controller: null,
    _closeBtn: null,
    ____1291: null,
    ____1288: null,
    ctor: function(scenePanelController) {
        this._super("hdClubWarInpireAlertView.ExportJson");
        this._controller = scenePanelController;
        this._closeBtn = this.getChildByName("closeBtn");
        this._closeBtn.setTouchEnabled(true);
        this.____1291 = this.getChildByName("itemView");
        this.____1288 = [];
        this._closeBtn.addListener(this, this.____16);
        ____655.warDatas.jiazuWarInfo.addEventListener(____655.____661.war_jiazu_guwuUpdate, this.guwuUpdateHandler, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        this.____5()
    },
    ____5: function() {
        var selfWarState = this._controller.sceneInfo.scenePlayerList.selfPlayer.warState;
        var jiazuGuwuList = selfWarState == 1 ? ____655.warDatas.jiazuWarInfo.jiazuGuwu1Info : ____655.warDatas.jiazuWarInfo.jiazuGuwu2Info;
        var len = jiazuGuwuList.length;
        for (var i = 0; i < len; i++) {
            var item = new ____2294(2, jiazuGuwuList[i], this._controller);
            this.____1291.addChild(item);
            item.setPosition(____654.____673.____159(2, (len - i) * 120 - 110));
            this.____1288.push(item)
        }
        var personGuwuList = ____655.warDatas.jiazuWarInfo.personGuwuInfo;
        len = personGuwuList.length;
        for (var i = 0; i < personGuwuList.length; i++) {
            var item = new ____2294(1, personGuwuList[i], this._controller);
            this.____1291.addChild(item);
            item.setPosition(____654.____673.____159(440, (len - i) * 120 - 110));
            this.____1288.push(item)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this.dispose()
        }
    },
    guwuUpdateHandler: function(evt) {
        for (var i = 0; i < this.____1288.length; i++) {
            this.____1288[i].update()
        }
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    dispose: function() {
        ____655.warDatas.jiazuWarInfo.removeEventListener(____655.____661.war_jiazu_guwuUpdate, this.guwuUpdateHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        if (this.____1288 != null) {
            for (var i = 0; i < this.____1288.length; i++) {
                this.____1288[i].dispose()
            }
            this.____1288 = null
        }
        this._closeBtn = null;
        this.____1291 = null;
        this._controller = null;
        this._super()
    },
});
var TGHJBoxPanel = KYPanel.extend({
    _controller: null,
    ____938: null,
    _boxType: 0,
    ____1288: null,
    _titleLabel: null,
    _awardCountLabel: null,
    _keyLabel: null,
    _keyCountLabel: null,
    _refreshBtn: null,
    _openBtn: null,
    _closeBtn: null,
    _tipsLabel: null,
    ____1635: null,
    _itemTemplate: null,
    _transCount: 0,
    _itemCount: 0,
    _refreshKeyCountLabel: null,
    _refreshKeyIcon: null,
    _openKeyCountLabel: null,
    _openKeyIcon: null,
    _openNeedMoney: 0,
    _tickCount: 0,
    _currentSelectIndex: 0,
    _transResult: -1,
    ctor: function(controller, boxType) {
        this._super("hdTkhjOpenBoxPanel.ExportJson");
        ____655.isShowGetTip = false;
        this._controller = controller;
        this._boxType = boxType;
        this.____1288 = [];
        this.____938 = [this.getChildByName("cell1"), this.getChildByName("cell2"), this.getChildByName("cell3"), this.getChildByName("cell4"), this.getChildByName("cell5"), this.getChildByName("cell6"), this.getChildByName("cell7"), this.getChildByName("cell8"), this.getChildByName("cell9"), this.getChildByName("cell10")];
        this._titleLabel = this.getChildByName("titleLabel");
        this._itemTemplate = ____655.allTemplates.____794.getItem(____655.allTemplates.____794.tghjKeys[this._boxType - 1]);
        var titleName = boxType == 1 ? "铜宝箱" : "金宝箱";
        this._titleLabel.setString(titleName);
        this._awardCountLabel = this.getChildByName("awardCountLabel");
        this._keyLabel = this.getChildByName("keyLabel");
        this._keyLabel.setString("拥有" + this._itemTemplate.name);
        this._keyCountLabel = this.getChildByName("keyCountLabel");
        this._refreshBtn = this.getChildByName("refreshBtn");
        this._openBtn = this.getChildByName("openBtn");
        this._closeBtn = this.getChildByName("closeBtn");
        this._refreshKeyIcon = this.getChildByName("refreshKeyIcon");
        this._refreshKeyCountLabel = this.getChildByName("refreshKeyCountLabel");
        this._openKeyIcon = this.getChildByName("keyIcon");
        this._openKeyCountLabel = this.getChildByName("countLabel");
        if (this._boxType == 1) {
            this._refreshKeyIcon.setFrame("icon/ui_keyIcon1.png", 1)
        } else {
            this._refreshKeyIcon.setFrame("icon/ui_keyIcon3.png", 1)
        }
        this._refreshKeyCountLabel.setString("x1");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._tipsLabel.setString("获得5份奖励后可刷新");
        this.____1635 = this.getChildByName("selectIcon");
        this.____1635.setVisible(false);
        this._closeBtn.addListener(this, this.closeClickHandler);
        this._openBtn.addListener(this, this.openClickHandler);
        this._refreshBtn.addListener(this, this.refreshClickHandler);
        ____655.warDatas.tghjInfo.addEventListener(____655.____661.war_tghj_boxComplete, this.tghjBoxComplete, this);
        ____655.warDatas.tghjInfo.addEventListener(____655.____661.war_tghj_boxTrans, this.transHandler, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.itemUpdateHandler, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemListUpdate, this.itemUpdateHandler, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        if (____655.warDatas.tghjInfo.boxItems[this._boxType] == null) {
            this._controller.warMessageSender.sendTghjBox(this._boxType)
        }
        this.tghjBoxComplete(null);
        this.itemUpdateHandler(null);
        this.transHandler(null)
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    closeClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            this.dispose()
        }
    },
    openClickHandler: function(sender, eventType) {
        if (this._tickCount > 0) return;
        var this_ = this;

        function buyHandler() {
            if (____655.____667.moneyInfo.moneyEnoughByType(5, this_._openNeedMoney)) {
                this_.startRun();
                this_._controller.warMessageSender.sendTghjBoxTrans(this_._boxType)
            } else {
                ____655.____667.moneyInfo.showNotEnoughTip(1)
            }
        }
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this._openNeedMoney == 0) {
                this_.startRun();
                this._controller.warMessageSender.sendTghjBoxTrans(this._boxType)
            } else {
                ____655.getAlert().show(2, "您确定支付" + this._openNeedMoney + ____655.____667.moneyInfo.getMoneyNameByType(1) + "购买1次开启次数？" + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), ____654.noAlertUtils.TGHJ_OPENTIME, 0, this, buyHandler)
            }
        }
    },
    startRun: function() {
        this._transResult = -1;
        this._tickCount = 0;
        this.____1635.setVisible(true);
        this.setSelectIndex(0);
        ____654.____678.____298(this.tick, this)
    },
    stopRun: function() {
        this._tickCount = 0;
        ____654.____678.____299(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount < 120) {
            if (this._tickCount % 5 == 0) {
                this._currentSelectIndex++;
                if (this._currentSelectIndex >= this.____1288.length) {
                    this._currentSelectIndex = 0
                }
                this.setSelectIndex(this._currentSelectIndex)
            }
        } else {
            if (this._tickCount % 15 == 0) {
                this._currentSelectIndex++;
                if (this._currentSelectIndex >= this.____1288.length) {
                    this._currentSelectIndex = 0
                }
                this.setSelectIndex(this._currentSelectIndex);
                if (this.____1288[this._currentSelectIndex].getPlace() == this._transResult) {
                    this.stopRun();
                    this.____1288[this._currentSelectIndex].updateGet()
                }
            }
        }
    },
    setSelectIndex: function(index) {
        this.____1635.setPosition(____654.____673.____159(this.____938[index].x + 4, this.____938[index].y + 4))
    },
    refreshClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (this._transCount < 5) {
                ____654.tipsManager.quickTip.show("必须抽取至少5次才能刷新")
            } else {
                if (this._itemCount >= 1) {
                    this._controller.warMessageSender.sendTghjBoxRefresh(this._boxType)
                } else {
                    ____654.tipsManager.quickTip.show("钥匙数量不足")
                }
            }
        }
    },
    tghjBoxComplete: function(evt) {
        this.clearItems();
        var list = ____655.warDatas.tghjInfo.boxItems[this._boxType];
        if (list != null) {
            for (var i = 0; i < list.length; i++) {
                var item = new TGHJItem();
                this.____938[i].addChild(item);
                item.setTghjInfo(list[i]);
                this.____1288.push(item)
            }
        }
        this.transHandler(null)
    },
    itemUpdateHandler: function(evt) {
        this._itemCount = ____655.itemInfoList.getCountByTempId(this._itemTemplate.templateId);
        this._keyCountLabel.setString(this._itemCount);
        this.transHandler(null)
    },
    transHandler: function(evt) {
        if (evt != null) {
            this._transResult = evt.data
        }
        var leftCount = ____655.warDatas.tghjInfo.getItemLeftCount(this._boxType);
        this._awardCountLabel.setString(leftCount);
        var list = ____655.warDatas.tghjInfo.boxItems[this._boxType];
        if (list == null) this._transCount = 0;
        else this._transCount = list.length - leftCount;
        if (this._transCount >= 5) {
            this._tipsLabel.setVisible(false)
        } else {
            this._tipsLabel.setVisible(true)
        }
        var tmpC = this._transCount + 1;
        var needKey = tmpC > 5 ? 5 : tmpC;
        if (this._itemCount >= needKey) {
            this._openNeedMoney = 0;
            if (this._boxType == 1) {
                this._openKeyIcon.setFrame("icon/ui_keyIcon1.png", 1)
            } else {
                this._openKeyIcon.setFrame("icon/ui_keyIcon3.png", 1)
            }
            this._openKeyCountLabel.setString("x" + needKey)
        } else {
            this._openNeedMoney = (needKey - this._itemCount) * ____655.warDatas.tghjInfo.keySellMoney[this._boxType - 1];
            this._openKeyIcon.setFrame("icon/ui_moneyIcon1.png", 1);
            this._openKeyCountLabel.setString("x" + this._openNeedMoney)
        }
    },
    clearItems: function() {
        for (var i = 0; i < this.____1288.length; i++) {
            this.____1288[i].dispose()
        }
        this.____1288 = []
    },
    dispose: function() {
        ____655.isShowGetTip = true;
        this.stopRun();
        ____655.warDatas.tghjInfo.removeEventListener(____655.____661.war_tghj_boxComplete, this.tghjBoxComplete, this);
        ____655.warDatas.tghjInfo.removeEventListener(____655.____661.war_tghj_boxTrans, this.transHandler, this);
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.itemUpdateHandler, this);
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemListUpdate, this.itemUpdateHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        this.____938 = null, this.clearItems();
        this._titleLabel = null;
        this._awardCountLabel = null;
        this._keyLabel = null;
        this._keyCountLabel = null;
        this._refreshBtn = null;
        this._openBtn = null;
        this._closeBtn = null;
        this._tipsLabel = null;
        this.____1635 = null;
        this._itemTemplate = null;
        this._refreshKeyCountLabel = null;
        this._refreshKeyIcon = null;
        this._openKeyCountLabel = null;
        this._openKeyIcon = null;
        this._controller = null;
        this._super()
    },
});
var TGHJFollowPanel = KYPanel.extend({
    _controller: null,
    _layerLabel: null,
    ____1621: null,
    _keyCountLabels: null,
    _boxIcons: null,
    _conditionLabels: null,
    _tipsBtn: null,
    _effectList: null,
    _countList: null,
    ____1009: null,
    ctor: function(controller) {
        this._controller = controller;
        this._super("hdTkhjFollowPanel.ExportJson");
        this._layerLabel = this.getChildByName("layerLabel");
        this.____1621 = this.getChildByName("scoreLabel");
        this._keyCountLabels = [this.getChildByName("keyCountLabel1"), this.getChildByName("keyCountLabel3")];
        this._boxIcons = [this.getChildByName("boxIcon1"), this.getChildByName("boxIcon3")];
        this._effectList = [null, null];
        this._countList = [0, 0];
        this._conditionLabels = [this.getChildByName("conditionLabel1"), this.getChildByName("conditionLabel3")];
        this._conditionLabels[0].setString("2层可开启");
        this._conditionLabels[1].setString("5层可开启");
        this._tipsBtn = this.getChildByName("tipsBtn");
        this._tipsBtn.addListener(this, this.____16);
        for (var i = 0; i < this._boxIcons.length; i++) {
            this._boxIcons[i].setTouchEnabled(true);
            this._boxIcons[i].addListener(this, this.boxClickHandler)
        }
        ____655.warDatas.tghjInfo.addEventListener(____655.____661.war_tghj_info, this.tghjInfoHandler, this);
        ____655.warDatas.tghjInfo.addEventListener(____655.____661.war_tghj_nextFloor, this.tghjNextFloorHandler, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.itemUpdateHandler, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemListUpdate, this.itemUpdateHandler, this);
        this.tghjInfoHandler(null);
        this.itemUpdateHandler(null);
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.TGHJ_COPYID);
        this.____6();
        this.updateTime()
    },
    ____6: function() {
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    ____17: function() {
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.tipsManager.showStringTip(____654.____682.____108("10093"), 500)
        }
    },
    boxClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var index = this._boxIcons.indexOf(sender);
            if (index > -1) {
                this._controller.showTGHJBoxPanel(index + 1)
            }
        }
    },
    tghjInfoHandler: function(evt) {
        var layer = ____655.warDatas.tghjInfo.floor;
        this._layerLabel.setString("第" + layer + "层");
        if (layer < ____655.warDatas.tghjInfo.totalFloor) {
            this.____1621.setString(____655.warDatas.tghjInfo.score + "/" + ____655.warDatas.tghjInfo.nextScore)
        } else {
            this.____1621.setString("已达顶层")
        }
        if (layer >= 5) {
            this.setIndexEnable(0, true);
            this.setIndexEnable(1, true)
        } else if (layer >= 2) {
            this.setIndexEnable(0, true);
            this.setIndexEnable(1, false)
        } else {
            this.setIndexEnable(0, false);
            this.setIndexEnable(1, false)
        }
    },
    setIndexEnable: function(index, value) {
        this._conditionLabels[index].setVisible(!value);
        this._boxIcons[index].setTouchEnabled(value);
        ____654.shaderCache.setColor(this._boxIcons[index], value ? 0 : 1);
        this.updateEffect(index)
    },
    itemUpdateHandler: function(evt) {
        for (var i = 0; i < 2; i++) {
            this._countList[i] = ____655.itemInfoList.getCountByTempId(____655.allTemplates.____794.tghjKeys[i]);
            this._keyCountLabels[i].setString("X" + this._countList[i]);
            this.updateEffect(i)
        }
    },
    updateEffect: function(index) {
        if (this._boxIcons[index].isTouchEnabled() && this._countList[index] > 0) {
            if (this._effectList[index] == null) {
                this._effectList[index] = new RotationEffect("effect/effect_10.png", 5);
                var pos = this._boxIcons[index].getPosition();
                this._effectList[index].setScale(0.85);
                this._effectList[index].setPosition(____654.____673.____159(pos.x, pos.y));
                this.addChild(this._effectList[index], 2)
            }
        } else {
            if (this._effectList[index] != null) {
                this._effectList[index].dispose();
                this._effectList[index] = null
            }
        }
    },
    tghjNextFloorHandler: function(evt) {
        if (this._controller != null) {
            this._controller.showOverCountDownView(5, ____654.yuyanbaoManager.getYuyanbao("____2107.text19", ____655.warDatas.tghjInfo.nextScore), this.countDownCallBack, this);
            this._controller.sceneModule.attackTester.stopAFK()
        }
    },
    countDownCallBack: function() {
        if (this._controller != null) this._controller.warMessageSender.sendTghjNextFloor()
    },
    updateTime: function(evt) {
        ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_exitTimeUpdate, ____654.____672, this.____1009.leftTime))
    },
    dispose: function() {
        this.____17();
        ____655.warDatas.tghjInfo.removeEventListener(____655.____661.war_tghj_info, this.tghjInfoHandler, this);
        ____655.warDatas.tghjInfo.removeEventListener(____655.____661.war_tghj_nextFloor, this.tghjNextFloorHandler, this);
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.itemUpdateHandler, this);
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemListUpdate, this.itemUpdateHandler, this);
        this._layerLabel = null;
        this.____1621 = null;
        this._keyCountLabels = null;
        for (var i = 0; i < this._boxIcons.length; i++) {
            ____654.shaderCache.removeColor(this._boxIcons[i])
        }
        this._boxIcons = null;
        for (var i = 0; i < this._effectList.length; i++) {
            if (this._effectList[i] != null) {
                this._effectList[i].dispose()
            }
        }
        this._effectList = null;
        this._countList = null;
        this._conditionLabels = null;
        this._tipsBtn = null;
        this._controller = null;
        this.____1009 = null;
        this._super()
    },
});
var TGHJItem = ____2129.extend({
    getImg: null,
    _isGet: false,
    _tghjInfo: null,
    setTghjInfo: function(tghjInfo) {
        this._tghjInfo = tghjInfo;
        this.setItemTemplateInfo(____655.allTemplates.____794.getItem(tghjInfo.id));
        this.setCount(tghjInfo.count);
        this.updateGet()
    },
    updateGet: function() {
        if (this._tghjInfo.state == 1) this.setIsGet()
    },
    getPlace: function() {
        return this._tghjInfo.place
    },
    setIsGet: function() {
        if (this._isGet == true) return;
        this._isGet = true;
        if (this.getImg == null) {
            this.getImg = ____654.____673.newKYSprite();
            this.getImg.setFrame("icon/ui_yesIcon.png", 1);
            this.getImg.setPosition(30, 30);
            this.addChild(this.getImg, 10)
        }
    },
    dispose: function() {
        this._tghjInfo = null;
        if (this.getImg != null) {
            this.getImg.dispose();
            this.getImg = null
        }
        this._super()
    },
});
var TGHJMatchPanel = KYPanel.extend({
    _controller: null,
    _tipsLabel: null,
    _timeLabel: null,
    ____1185: null,
    _tickCount: 0,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._super("wuShenMatchingPanel.ExportJson");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1185 = this.getChildByName("getBtn");
        this.____1185.addListener(this, this.____16);
        this._controller.warMessageSender.sendTGHJMatch();
        this._tickCount = 60 * 60 + 1;
        ____654.____678.____298(this.tick, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, false));
        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkStop, ____654.____672))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.warMessageSender.sendTGHJMatchExit();
            this.dispose()
        }
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            this._tickCount = 60 * 60
        }
        if (this._tickCount % 60 == 0) {
            this._timeLabel.setString(Math.ceil(this._tickCount / 60))
        }
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    dispose: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._tipsLabel = null;
        this._timeLabel = null;
        this.____1185 = null;
        this._super()
    },
});
var ____2296 = KYPanel.extend({
    _controller: null,
    _titleLabel: null,
    ____1580: null,
    ____1435: null,
    ____1434: null,
    ____1436: null,
    ____1433: null,
    ____1578: null,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._super("hdWuShenFollowPanel.ExportJson");
        this._titleLabel = this.getChildByName("titleLabel");
        this._titleLabel.setString("积分前5名有丰富奖励");
        this.____1580 = this.getChildByName("rankPanel");
        this.____1580.setScrollBarEnabled(false);
        this.____1435 = this.getChildByName("myRankLabel");
        this.____1434 = this.getChildByName("myNameLabel");
        this.____1436 = this.getChildByName("myScoreLabel");
        this.____1433 = this.getChildByName("myCountLabel");
        this.____1578 = [];
        this.____6();
        var remainTime = ____655.warDatas.wuShenInfo.leftTime;
        ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_exitTimeUpdate, ____654.____672, remainTime));
        this.updateInfo(null)
    },
    ____6: function() {
        ____655.warDatas.wuShenInfo.addEventListener(____655.____661.war_wushen_info, this.updateInfo, this)
    },
    ____17: function() {
        ____655.warDatas.wuShenInfo.removeEventListener(____655.____661.war_wushen_info, this.updateInfo, this)
    },
    updateInfo: function(evt) {
        var list = ____655.warDatas.wuShenInfo.list;
        if (list == null) return;
        var len = list.length;
        for (var i = 0; i < len; i++) {
            var item = this.____1578[i];
            if (item == null) {
                item = new ____2297();
                this.____1580.pushBackCustomItem(item);
                this.____1578.push(item)
            }
            item.____18(i + 1, list[i]);
            var info = list[i];
            if (info.userId == ____655.____667.userId) {
                this.____1435.setString(i + 1);
                this.____1434.setString(info.nick);
                this.____1436.setString(info.score);
                if (info.online == 0) {
                    this.____1433.setString("淘汰");
                    this.____1433.setColor(____655.____659.____688.red)
                } else if (info.online == 1) {
                    this.____1433.setString(info.leftCount + "次");
                    this.____1433.setColor(____655.____659.____688.white)
                } else if (info.online == 2) {
                    this.____1433.setString("逃跑");
                    this.____1433.setColor(____655.____659.____688.red)
                }
            }
        }
        for (var i = len; i < this.____1578.length; i++) {
            this.____1578[i].clear()
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._titleLabel = null;
        this.____1580 = null;
        this.____1435 = null;
        this.____1434 = null;
        this.____1436 = null;
        this.____1433 = null;
        if (this.____1578 != null) {
            for (var i = 0; i < this.____1578.length; i++) {
                var item = this.____1578[i];
                if (item != null) {
                    item.dispose()
                }
            }
            this.____1578 = null
        }
        this._super()
    },
});
var ____2297 = KYNode.extend({
    ____1579: null,
    _nameLabel: null,
    ____1621: null,
    _countLabel: null,
    ctor: function() {
        this._super("hdWuShenFollowItemView.ExportJson");
        this.____1579 = this.getChildByName("rankLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1621 = this.getChildByName("scoreLabel");
        this._countLabel = this.getChildByName("countLabel")
    },
    ____18: function(index, data) {
        this.____1579.setString(index);
        this._nameLabel.setString(data.nick);
        this.____1621.setString(data.score);
        if (data.online == 0) {
            this._countLabel.setString("淘汰");
            this._countLabel.setColor(____655.____659.____688.red)
        } else if (data.online == 1) {
            this._countLabel.setString(data.leftCount + "次");
            this._countLabel.setColor(____655.____659.____688.white)
        } else if (data.online == 2) {
            this._countLabel.setString("逃跑");
            this._countLabel.setColor(____655.____659.____688.red)
        }
    },
    clear: function() {
        this.____1579.setString("");
        this._nameLabel.setString("");
        this.____1621.setString("");
        this._countLabel.setString("")
    },
    dispose: function() {
        this.____1579 = null;
        this._nameLabel = null;
        this.____1621 = null;
        this._countLabel = null;
        this._super()
    },
});
var WuShenMatchPanel = KYPanel.extend({
    _controller: null,
    _tipsLabel: null,
    _timeLabel: null,
    ____1185: null,
    _tickCount: 0,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._super("wuShenMatchingPanel.ExportJson");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1185 = this.getChildByName("getBtn");
        this.____1185.addListener(this, this.____16);
        this._controller.warMessageSender.sendWuShenMatchStart();
        this._tickCount = 3600;
        this._timeLabel.setString(60);
        ____654.____678.____298(this.tick, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, false));
        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkStop, ____654.____672))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.warMessageSender.sendWuShenMatchCancel();
            this.dispose()
        }
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            this._tickCount = 3600
        }
        if (this._tickCount % 60 == 0) {
            this._timeLabel.setString(Math.ceil(this._tickCount / 60))
        }
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    dispose: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._tipsLabel = null;
        this._timeLabel = null;
        this.____1185 = null;
        this._super()
    },
});
var XunBaoFollowItem = KYNode.extend({
    ____1435: null,
    ____1101: null,
    _myCopperLabel: null,
    ctor: function() {
        this._super("hdXunBaoFollowItemView.ExportJson");
        this.____1435 = this.getChildByName("myRankLabel_Copy0");
        this.____1101 = this.getChildByName("desLabel2_Copy0");
        this._myCopperLabel = this.getChildByName("myCopperLabel_Copy0")
    },
    ____18: function(data) {
        this.____1435.setString(data.rank);
        this.____1101.setString(data.nick);
        this._myCopperLabel.setString(data.score)
    },
    clear: function() {
        this.____1435.setString("");
        this.____1101.setString("");
        this._myCopperLabel.setString("")
    },
    dispose: function() {
        this.____1435 = null;
        this.____1101 = null;
        this._myCopperLabel = null;
        this._super()
    },
});
var XunBaoFollowPanel = KYPanel.extend({
    _controller: null,
    _titleLabel: null,
    ____1144: null,
    _tipsBtn: null,
    ____1580: null,
    ____1435: null,
    _myCopperLabel: null,
    ____1009: null,
    ____1578: null,
    ctor: function(controller) {
        this._super("hdXunBaoFollowPanel.ExportJson");
        this._controller = controller;
        this._titleLabel = this.getChildByName("titleLabel");
        this._titleLabel.setString("获得经验:");
        this.____1144 = this.getChildByName("expLabel");
        this._tipsBtn = this.getChildByName("tipsBtn");
        this.____1580 = this.getChildByName("rankPanel");
        this.____1580.setScrollBarEnabled(false);
        this.____1435 = this.getChildByName("myRankLabel");
        this._myCopperLabel = this.getChildByName("myCopperLabel");
        this._tipsBtn.addListener(this, this.tipClickHandler);
        this.____1578 = [];
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.XUNBAO_COPYID);
        this.____6();
        this.updateTime()
    },
    ____6: function() {
        ____655.warDatas.xunbaoInfo.addEventListener(____655.____661.war_xunbao_info, this.infoUpdateHandler, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    ____17: function() {
        ____655.warDatas.xunbaoInfo.removeEventListener(____655.____661.war_xunbao_info, this.infoUpdateHandler, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    tipClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____654.tipsManager.showStringTip(____654.____682.____108("10092", 500))
        }
    },
    getItemByIndex: function(index) {
        var item = this.____1578[index];
        if (item != null) return item;
        item = new XunBaoFollowItem();
        this.____1580.pushBackCustomItem(item);
        this.____1578[index] = item;
        return item
    },
    infoUpdateHandler: function(evt) {
        this.____1144.setString(____654.____674.getWanCount(____655.warDatas.xunbaoInfo.selfExp) + "/" + ____654.____674.getWanCount(____655.____667.xianwei * 900000));
        if (____655.warDatas.xunbaoInfo.selfRank > 0) {
            this.____1435.setString(____655.warDatas.xunbaoInfo.selfRank)
        } else {
            this.____1435.setString("无")
        }
        this._myCopperLabel.setString(____655.warDatas.xunbaoInfo.selfScore + "金币");
        var list = ____655.warDatas.xunbaoInfo.list;
        var count = 0;
        for (var i = 0; i < 5; i++) {
            var info = list[i];
            var item = this.getItemByIndex(count);
            if (info != null) {
                item.____18(info)
            } else {
                item.clear()
            }
            count++
        }
    },
    updateTime: function(evt) {
        ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_exitTimeUpdate, ____654.____672, this.____1009.leftTime))
    },
    dispose: function() {
        this.____17();
        this._titleLabel = null;
        this.____1144 = null;
        this._tipsBtn = null;
        this.____1580 = null;
        this.____1435 = null;
        this._myCopperLabel = null;
        if (this.____1578 != null) {
            for (var i = 0; i < this.____1578.length; i++) {
                if (this.____1578[i] != null) {
                    this.____1578[i].dispose()
                }
            }
        }
        this.____1578 = null;
        this.____1009 = null;
        this._controller = null;
        this._super()
    },
});
var XunBaoMatchPanel = KYPanel.extend({
    _controller: null,
    _tipsLabel: null,
    _timeLabel: null,
    ____1185: null,
    _tickCount: 0,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._super("wuShenMatchingPanel.ExportJson");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1185 = this.getChildByName("getBtn");
        this.____1185.addListener(this, this.____16);
        this._controller.warMessageSender.sendXunBaoMatch();
        this._tickCount = 60 * 60 + 1;
        ____654.____678.____298(this.tick, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, false));
        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkStop, ____654.____672))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.warMessageSender.sendXunBaoMatchExit();
            this.dispose()
        }
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            this._tickCount = 60 * 60
        }
        if (this._tickCount % 60 == 0) {
            this._timeLabel.setString(Math.ceil(this._tickCount / 60))
        }
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    dispose: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._tipsLabel = null;
        this._timeLabel = null;
        this.____1185 = null;
        this._super()
    },
});
var ZhuoyaoFollowPanel = KYPanel.extend({
    _controller: null,
    ____1101: null,
    ____1144: null,
    _labels: null,
    _boxes: null,
    _getFlags: null,
    _timeLayer: null,
    _countDownLabel: null,
    _countDownUtils: null,
    ____1009: null,
    _touchBeginPos: null,
    _isShowAlert: false,
    ctor: function(controller) {
        this._super("hdZhuoYaoFollowPanel.ExportJson");
        this._controller = controller;
        this.____1101 = this.getChildByName("desLabel");
        this.____1144 = this.getChildByName("expLabel");
        this._labels = [this.getChildByName("label1"), this.getChildByName("label2"), this.getChildByName("label3"), this.getChildByName("label4"), this.getChildByName("label5"), this.getChildByName("label6"), this.getChildByName("label7"), this.getChildByName("label8"), this.getChildByName("label9")];
        this._boxes = [this.getChildByName("box1"), this.getChildByName("box2"), this.getChildByName("box3")];
        this._getFlags = [this.getChildByName("hasGotFlag1"), this.getChildByName("hasGotFlag2"), this.getChildByName("hasGotFlag3")];
        this.____1101.setString("获得经验:");
        for (var i = 0; i < this._getFlags.length; i++) {
            this._getFlags[i].setVisible(false)
        }
        this._timeLayer = this.getChildByName("timeLayer");
        this._timeLayer.setPosition(____655.____656 / 2 - 150, -160);
        this._countDownLabel = this._timeLayer.getChildByName("timeLabel");
        this._timeLayer.setVisible(false);
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this._countDownLabel, 2, 0, "common.timeTips3");
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.allTemplates.copyTemplateList.ZUOYAO_COPYID);
        this.____6();
        this.updateTime();
        this.zhuoyaoMonsterTimeHandler()
    },
    ____6: function() {
        for (var i = 0; i < this._boxes.length; i++) {
            this._boxes[i].addListener(this, null, this.btnTouchBegin, this.btnTouchUp, this.btnTouchMove)
        }
        ____655.warDatas.zhuoyaoInfo.addEventListener(____655.____661.war_zhuoyao_info, this.zhuoyaoInfoHandler, this);
        ____655.warDatas.zhuoyaoInfo.addEventListener(____655.____661.war_zhuoyao_monsterTime, this.zhuoyaoMonsterTimeHandler, this);
        this.____1009.addEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    ____17: function() {
        ____655.warDatas.zhuoyaoInfo.removeEventListener(____655.____661.war_zhuoyao_info, this.zhuoyaoInfoHandler, this);
        ____655.warDatas.zhuoyaoInfo.removeEventListener(____655.____661.war_zhuoyao_monsterTime, this.zhuoyaoMonsterTimeHandler, this);
        this.____1009.removeEventListener(____655.____661.copy_timeUpdate, this.updateTime, this)
    },
    zhuoyaoInfoHandler: function(evt) {
        var count = 0;
        var list = ____655.warDatas.zhuoyaoInfo.items;
        for (var i = 0; i < list.length; i++) {
            var info = list[i];
            var isComplete = info.isComplete();
            this._labels[i * 3].setString(info.monster1HasCount + "/" + info.monster1NeedCount);
            this._labels[i * 3 + 1].setString(info.monster2HasCount + "/" + info.monster2NeedCount);
            this._labels[i * 3 + 2].setString(info.monster3HasCount + "/" + info.monster3NeedCount);
            if (info.monster1HasCount >= info.monster1NeedCount) this._labels[i * 3].setColor(____655.____659.____688.lightGreen);
            else this._labels[i * 3].setColor(____655.____659.____688.red);
            if (info.monster2HasCount >= info.monster2NeedCount) this._labels[i * 3 + 1].setColor(____655.____659.____688.lightGreen);
            else this._labels[i * 3 + 1].setColor(____655.____659.____688.red);
            if (info.monster3HasCount >= info.monster3NeedCount) this._labels[i * 3 + 2].setColor(____655.____659.____688.lightGreen);
            else this._labels[i * 3 + 2].setColor(____655.____659.____688.red);
            if (isComplete) {
                if (info.hasGet) {
                    this._getFlags[i].setVisible(true);
                    count++
                } else {
                    this._getFlags[i].setVisible(false);
                    if (!info.hasSend) {
                        info.hasSend = true;
                        this._controller.warMessageSender.sendZhuoYaoGetAward(info.id)
                    }
                }
            } else {
                this._getFlags[i].setVisible(false)
            }
        }
        this.____1144.setString(____654.____674.getWanCount(____655.warDatas.zhuoyaoInfo.exp) + "/" + ____654.____674.getWanCount(____655.____667.xianwei * 900000));

        function okClick() {
            ____654.copyTester.exitCopy()
        };
        if (count >= 3 && this._isShowAlert == false) {
            this._isShowAlert = true;
            ____655.getAlert().show(1, "恭喜你获得了所有捉妖奖励啦，即将自动退出活动地图！", null, 5, this, okClick)
        }
    },
    zhuoyaoMonsterTimeHandler: function(evt) {
        var time = ____655.warDatas.zhuoyaoInfo.monsterTime - ____655.____662.getSystemTimeSec();
        if (time > 0 && time < 1000000) {
            this._countDownUtils.start(time);
            this._timeLayer.setVisible(true)
        } else {
            this._countDownUtils.start(0);
            this._timeLayer.setVisible(true)
        }
    },
    updateTime: function(evt) {
        ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_exitTimeUpdate, ____654.____672, this.____1009.leftTime))
    },
    btnTouchBegin: function(sender, eventType, pos) {
        ____654.soundManager.playSound(____654.soundManager.BTN);
        this._touchBeginPos = pos;
        var tempList = ____655.allTemplates.awardTemplateList.getTypeList(7);
        var index = this._boxes.indexOf(sender);
        if (index == -1 || tempList[index] == null) {
            return
        }
        var awardId = tempList[index].awardList[____655.____667.xianwei - 1][0];
        var itemTemplateInfo = ____655.allTemplates.____794.getItem(awardId);
        var position = this.convertToWorldSpace(____654.____673.____159(this._touchBeginPos.x + 5, this._touchBeginPos.y));
        if (itemTemplateInfo != null) {
            ____654.tipsManager.showItemTempFlashTip(itemTemplateInfo, position)
        }
    },
    btnTouchMove: function(sender, eventType, pos) {
        if (this._touchBeginPos.x - pos.x > 15 || this._touchBeginPos.y - pos.y > 15) {
            ____654.tipsManager.hideFlashTip()
        }
    },
    btnTouchUp: function(sender, eventType, pos) {
        ____654.tipsManager.hideFlashTip()
    },
    dispose: function() {
        this.____17();
        this.____1101 = null;
        this.____1144 = null;
        this._labels = null;
        this._boxes = null;
        this._getFlags = null;
        this._controller = null;
        this._timeLayer = null;
        this._countDownLabel = null;
        this._touchBeginPos = null;
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this.____1009 = null;
        this._super()
    },
});
var ZhuoyaoMatchPanel = KYPanel.extend({
    _controller: null,
    _tipsLabel: null,
    _timeLabel: null,
    ____1185: null,
    _tickCount: 0,
    ctor: function(scenePanelController) {
        this._controller = scenePanelController;
        this._super("wuShenMatchingPanel.ExportJson");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._timeLabel = this.getChildByName("timeLabel");
        this.____1185 = this.getChildByName("getBtn");
        this.____1185.addListener(this, this.____16);
        this._controller.warMessageSender.sendZhuoYaoMatch();
        this._tickCount = 60 * 60 + 1;
        ____654.____678.____298(this.tick, this);
        ____654.____672.addEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, false));
        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkStop, ____654.____672))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this._controller.warMessageSender.sendZhuoYaoMatchExit();
            this.dispose()
        }
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount <= 0) {
            this._tickCount = 60 * 60
        }
        if (this._tickCount % 60 == 0) {
            this._timeLabel.setString(Math.ceil(this._tickCount / 60))
        }
    },
    closeHandler: function(evt) {
        this.dispose()
    },
    dispose: function() {
        ____654.____672.removeEventListener(____655.____661.common_closeOtherPanel, this.closeHandler, this);
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this._tipsLabel = null;
        this._timeLabel = null;
        this.____1185 = null;
        this._super()
    },
});
var CifuInfo = ____591.extend({
    ctor: function() {
        this._super()
    },
    initState: function(bytes) {
        var result = bytes.readByte();
        this.dispatchEvent(new ____590(____655.____661.war_cifu_state, this, result))
    },
    initGet: function(bytes) {
        var result = bytes.readByte();
        this.dispatchEvent(new ____590(____655.____661.war_cifu_get, this, result))
    },
    clear: function() {},
});
var ____2299 = ____591.extend({
    selfRank: 0,
    selfScore: 0,
    currentKill: 0,
    camps: null,
    rankList: null,
    ctor: function() {
        this._super();
        this.camps = {};
        this.rankList = {}
    },
    init: function(bytes) {
        this.selfRank = bytes.readUShort();
        this.selfScore = bytes.readUShort();
        var len = bytes.readShort();
        for (var i = 0; i < len; i++) {
            this.camps[bytes.readByte()] = [bytes.readInt(), bytes.readInt()]
        }
        this.dispatchEvent(new ____590(____655.____661.war_daluandou_info, this, null))
    },
    initRank: function(bytes) {
        this.rankList = {};
        var len = bytes.readShort();
        for (var i = 0; i < len; i++) {
            var info = new ____2300();
            info.init(bytes);
            this.rankList[info.rank] = info
        }
        this.dispatchEvent(new ____590(____655.____661.war_daluandou_rank, this, null))
    },
    clear: function() {
        this.selfScore = 0;
        this.currentKill = 0;
        this.camps = {};
        this.rankList = {}
    },
});
var ____2300 = cc.Class.extend({
    warState: 0,
    rank: 0,
    userId: 0,
    nick: "",
    level: 0,
    fighting: 0,
    score: 0,
    init: function(bytes) {
        this.warState = bytes.readByte();
        this.rank = bytes.readShort();
        this.userId = bytes.readNumber();
        this.nick = bytes.readString();
        this.level = bytes.readShort();
        this.fighting = bytes.readInt();
        this.score = bytes.readShort()
    },
});
var DouShenInfo = ____591.extend({
    selfPlayer: null,
    otherPlayer: null,
    awardExp: 0,
    awardHonor: 0,
    itemList: null,
    ctor: function() {
        this._super()
    },
    initFightResult: function(bytes) {
        var result = bytes.readByte();
        if (result > 1) {} else {
            ____655.rankInfo.reduceDoushenCount();
            var targetRank = bytes.readInt();
            var oldTargetRankPlayer = ____655.rankInfo.getDoushenItemByRank(targetRank);
            if (result == 0 && ____655.rankInfo.doushenSelfRank > targetRank) {
                ____655.rankInfo.doushenSelfRank = targetRank
            }
            if (oldTargetRankPlayer == null) return;
            var selfInfo = new ____1940();
            selfInfo.playerInfo.level = ____655.____667.level;
            selfInfo.totalHp = ____655.____667.maxHP;
            selfInfo.playerInfo.combat = ____655.____667.combat;
            selfInfo.playerInfo.nick = ____655.____667.nick;
            selfInfo.playerInfo.setCareer(____655.____667.career);
            var style = ____655.____667.characterInfo.getStyleList();
            var tmpStyle = [];
            for (var i in style) {
                tmpStyle[i] = style[i]
            }
            selfInfo.playerInfo.characterInfo.updateStyle(tmpStyle);
            this.selfPlayer = new DouShenPlayerInfo(selfInfo, result == 0, 1);
            this.otherPlayer = new DouShenPlayerInfo(oldTargetRankPlayer, result == 1, 2);
            this.dispatchEvent(new ____590(____655.____661.war_doushen_result, this, null))
        }
        this.awardExp = bytes.readInt();
        this.awardHonor = bytes.readInt();
        this.itemList = [];
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var templateId = bytes.readInt();
            var count = bytes.readByte();
            this.itemList.push([templateId, count])
        }
    },
    clear: function() {
        if (this.selfPlayer != null) {
            this.selfPlayer.dispose();
            this.selfPlayer = null
        }
        if (this.otherPlayer != null) {
            this.otherPlayer.dispose();
            this.otherPlayer = null
        }
        this.itemList = [];
        this.awardExp = 0;
        this.awardHonor = 0
    },
});
var DouShenPlayerInfo = ____591.extend({
    playerInfo: null,
    hp: 0,
    isWin: false,
    index: 0,
    ctor: function(info, isWin, index) {
        this._super();
        this.playerInfo = new ____499();
        this.playerInfo.setNick(info.playerInfo.nick);
        this.playerInfo.setCareer(info.playerInfo.career);
        this.playerInfo.____64(info.playerInfo.level);
        var style = {};
        var tmpStyle = info.playerInfo.characterInfo.getStyleList();
        for (var i in tmpStyle) {
            style[i] = tmpStyle[i]
        }
        style[____655.____659.commonStaticType.style_isHorse] = false;
        this.hp = info.totalHp;
        this.playerInfo.characterInfo.updateStyle(style);
        this.isWin = isWin;
        this.index = index
    },
    dispose: function() {
        if (this.playerInfo != null) {
            this.playerInfo.dispose();
            this.playerInfo = null
        }
        this._super()
    },
});
var ____2301 = cc.Class.extend({
    place: 0,
    level: 0,
    addRate: 0,
    ctor: function(place) {
        this.place = place
    },
    init: function(level, addRate) {
        this.level = level;
        this.addRate = addRate
    },
    clear: function() {
        this.level = 0;
        this.addRate = 0
    },
});
var ____2302 = ____591.extend({
    hasSign: false,
    clubs: null,
    players: null,
    selfScore: 0,
    selfRank: 0,
    personGuwuInfo: null,
    jiazuGuwu1Info: null,
    jiazuGuwu2Info: null,
    baseRate: 50,
    guwuMaxLevel: 5,
    jiazuGuwuNeedMoney: 50,
    personGuwuNeedMoney: 10,
    guwuAddPercent: 10,
    guwuPropertyName: null,
    guwuIconPath: null,
    _sceneInfo: null,
    ____990: 0,
    _collectLeftCount: 0,
    sendPoints: null,
    hasCollectSubmit: false,
    ctor: function() {
        this._super();
        this.clubs = {};
        this.players = [];
        this.sendPoints = [];
        this.personGuwuInfo = [new ____2301(1), new ____2301(2), new ____2301(3)];
        this.jiazuGuwu1Info = [new ____2301(1), new ____2301(2), new ____2301(3)];
        this.jiazuGuwu2Info = [new ____2301(1), new ____2301(2), new ____2301(3)];
        this.guwuPropertyName = ["攻击", "防御", "血量"];
        this.guwuIconPath = ["icon/ui_clubWarSkillIcon1.png", "icon/ui_clubWarSkillIcon2.png", "icon/ui_clubWarSkillIcon3.png"]
    },
    init: function() {
        this._sceneInfo.sceneCollectList.addEventListener(____655.____661.sceneInfo_addCollect, this.addCollectHandler, this)
    },
    setSceneInfo: function(sceneInfo) {
        this._sceneInfo = sceneInfo
    },
    initSign: function(bytes) {
        this.hasSign = bytes.readShort() > 0;
        this.dispatchEvent(new ____590(____655.____661.war_jiazu_signUpdate, this, null))
    },
    addCollectHandler: function(evt) {
        this.setCollectCount()
    },
    initCollect: function(id, count) {
        this.____990 = id;
        this._collectLeftCount = count;
        this.setCollectCount()
    },
    setCollectCount: function() {
        var collectInfo = this._sceneInfo.sceneCollectList.getCollect(this.____990);
        if (collectInfo != null) {
            collectInfo.setCollectLeftCount(this._collectLeftCount)
        }
    },
    initInfo: function(bytes) {
        var isFirst = this.players.length == 0;
        this.clubs = {};
        var len = bytes.readShort();
        for (var i = 0; i < len; i++) {
            var club = new ____2303();
            club.init(bytes);
            this.clubs[club.warState] = club
        }
        this.players = [];
        len = bytes.readShort();
        for (var i = 0; i < len; i++) {
            var info = new ____2304();
            info.init(bytes);
            this.players.push(info)
        }
        var lastScore = this.selfScore;
        this.selfScore = bytes.readInt();
        if (!isFirst && this.selfScore > lastScore) {
            ____654.tipsManager.quickTip.show("获得积分:" + (this.selfScore - lastScore))
        }
        this.selfRank = bytes.readShort();
        this.dispatchEvent(new ____590(____655.____661.war_jiazu_infoUpdate, this, null))
    },
    initGuWu: function(bytes) {
        var personLen = bytes.readByte();
        for (var i = 0; i < personLen; i++) {
            var place = bytes.readByte();
            this.personGuwuInfo[place - 1].init(bytes.readByte(), bytes.readByte())
        }
        var clubLen = bytes.readByte();
        for (var i = 0; i < clubLen; i++) {
            var warState = bytes.readInt();
            var clubGuwu = warState == 1 ? this.jiazuGuwu1Info : this.jiazuGuwu2Info;
            var len2 = bytes.readByte();
            for (var j = 0; j < len2; j++) {
                var place = bytes.readByte();
                clubGuwu[place - 1].init(bytes.readByte(), bytes.readByte())
            }
        }
        this.dispatchEvent(new ____590(____655.____661.war_jiazu_guwuUpdate, this, null))
    },
    initPoints: function(bytes) {
        var selfWarState = this._sceneInfo.scenePlayerList.selfPlayer.warState;
        this.sendPoints = [];
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var warState = bytes.readInt();
            var p = ____654.____673.____159(bytes.readShort(), bytes.readShort());
            print(warState, selfWarState, "-=-=-=-=-=-=initPoints");
            if (warState == selfWarState) {
                this.sendPoints.push(p)
            }
        }
        this.dispatchEvent(new ____590(____655.____661.war_jiazu_pointUpdate, this, null))
    },
    clear: function() {
        if (this._sceneInfo != null) {
            this._sceneInfo.sceneCollectList.removeEventListener(____655.____661.sceneInfo_addCollect, this.addCollectHandler, this)
        }
        this.hasSign = false;
        this.clubs = {};
        this.players = [];
        this.____990 = 0;
        this._collectLeftCount = 0;
        this.selfScore = 0;
        this.selfRank = 0;
        this.sendPoints = [];
        this.hasCollectSubmit = false;
        var len = this.personGuwuInfo.length;
        for (var i = 0; i < len; i++) {
            this.personGuwuInfo[i].clear()
        }
        len = this.jiazuGuwu1Info.length;
        for (var i = 0; i < len; i++) {
            this.jiazuGuwu1Info[i].clear()
        }
        len = this.jiazuGuwu2Info.length;
        for (var i = 0; i < len; i++) {
            this.jiazuGuwu2Info[i].clear()
        }
    },
});
var ____2303 = cc.Class.extend({
    id: 0,
    score: 0,
    warState: 0,
    init: function(bytes) {
        this.id = bytes.readNumber();
        this.score = bytes.readInt();
        this.warState = bytes.readInt()
    },
});
var ____2304 = cc.Class.extend({
    rank: 0,
    score: 0,
    nick: "",
    init: function(bytes) {
        this.rank = bytes.readShort();
        this.score = bytes.readInt();
        this.nick = bytes.readString()
    },
});
var TGHJInfo = ____591.extend({
    totalFloor: 5,
    floor: 0,
    score: 0,
    nextScore: 0,
    boxItems: null,
    keySellMoney: null,
    ctor: function() {
        this._super();
        this.boxItems = {};
        this.keySellMoney = [8, 30]
    },
    initInfo: function(bytes) {
        this.floor = bytes.readByte();
        this.score = bytes.readInt();
        this.nextScore = bytes.readInt();
        this.dispatchEvent(new ____590(____655.____661.war_tghj_info, this, null))
    },
    initBox: function(bytes) {
        function sortFunc(info1, info2) {
            return info1.place - info2.place
        }
        var index = bytes.readByte();
        var list = [];
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var info = new TGHJItemInfo();
            info.init(bytes);
            list.push(info)
        }
        list.sort(sortFunc);
        this.boxItems[index] = list;
        this.dispatchEvent(new ____590(____655.____661.war_tghj_boxComplete, this, null))
    },
    getItemLeftCount: function(index) {
        var list = this.boxItems[index];
        if (list == null) return 0;
        var c = 0;
        for (var i = 0; i < list.length; i++) {
            if (list[i].state == 0) c++
        }
        return c
    },
    initTrans: function(bytes) {
        var index = bytes.readByte();
        var place = bytes.readByte();
        if (place > 0) {
            var list = this.boxItems[index];
            if (list != null) {
                for (var i = 0; i < list.length; i++) {
                    if (list[i].place == place) {
                        list[i].state = 1;
                        break
                    }
                }
                this.dispatchEvent(new ____590(____655.____661.war_tghj_boxTrans, this, place))
            }
        }
    },
    nextFloor: function() {
        this.dispatchEvent(new ____590(____655.____661.war_tghj_nextFloor, this, null))
    },
    clear: function() {
        this.floor = 0;
        this.score = 0;
        this.nextScore = 0;
        this.boxItems = {}
    },
});
var TGHJItemInfo = cc.Class.extend({
    place: 0,
    id: 0,
    count: 0,
    state: 0,
    init: function(bytes) {
        this.place = bytes.readByte();
        this.id = bytes.readInt();
        this.count = bytes.readInt();
        this.state = bytes.readByte()
    },
});
var ____2305 = ____591.extend({
    daLuanDouInfo: null,
    wuShenInfo: null,
    jiazuWarInfo: null,
    douShenInfo: null,
    cifuInfo: null,
    zhuoyaoInfo: null,
    xunbaoInfo: null,
    tghjInfo: null,
    sceneInfo: null,
    ctor: function() {
        this._super();
        this.daLuanDouInfo = new ____2299();
        this.wuShenInfo = new ____2306();
        this.jiazuWarInfo = new ____2302();
        this.douShenInfo = new DouShenInfo();
        this.cifuInfo = new CifuInfo();
        this.zhuoyaoInfo = new ZhuoYaoInfo();
        this.xunbaoInfo = new XunBaoInfo();
        this.tghjInfo = new TGHJInfo()
    },
    setSceneInfo: function(sceneInfo) {
        this.jiazuWarInfo.setSceneInfo(sceneInfo)
    },
    setCopyIdComplete: function() {
        if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID) this.jiazuWarInfo.init();
        else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.ZUOYAO_COPYID) this.zhuoyaoInfo.init()
    },
    clearCopyId: function() {
        this.jiazuWarInfo.clear();
        this.daLuanDouInfo.clear();
        this.wuShenInfo.clear();
        this.douShenInfo.clear();
        this.cifuInfo.clear();
        this.zhuoyaoInfo.clear();
        this.xunbaoInfo.clear();
        this.tghjInfo.clear()
    },
    ____61: function() {
        this.clearCopyId()
    },
});
var ____2306 = ____591.extend({
    leftTime: 5,
    list: null,
    nums: 0,
    ctor: function() {
        this._super();
        this.list = []
    },
    setNums: function(bytes) {
        this.nums = bytes.readShort();
        this.dispatchEvent(new ____590(____655.____661.war_wushen_enterCount, this, null))
    },
    init: function(bytes) {
        function sortFunc(info1, info2) {
            return info2.score - info1.score
        }
        this.leftTime = bytes.readShort();
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var id = bytes.readNumber();
            var info = this.____238(id);
            if (info == null) {
                info = new ____2307();
                this.list.push(info)
            }
            info.init(id, bytes)
        }
        this.list.sort(sortFunc);
        this.dispatchEvent(new ____590(____655.____661.war_wushen_info, this, null))
    },
    ____238: function(id) {
        for (var i = 0; i < this.list.length; i++) {
            if (this.list[i].userId == id) return this.list[i]
        }
        return null
    },
    clear: function() {
        this.leftTime = 5;
        this.nums = 0;
        this.list = []
    },
});
var ____2307 = cc.Class.extend({
    userId: 0,
    serverId: 0,
    score: 0,
    nick: "",
    leftCount: 0,
    online: 1,
    init: function(userId, bytes) {
        this.userId = userId;
        this.leftCount = bytes.readByte();
        this.online = bytes.readByte();
        this.score = bytes.readInt();
        this.serverId = bytes.readShort();
        this.nick = bytes.readString()
    },
});
var XunBaoInfo = ____591.extend({
    list: null,
    selfRank: 0,
    selfScore: 0,
    selfExp: 0,
    ctor: function() {
        this.list = [];
        this._super()
    },
    initInfo: function(bytes) {
        function sortFunc(info1, info2) {
            return info1.rank - info2.rank
        }
        this.list = [];
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var info = new XunBaoItemInfo();
            info.init(bytes);
            this.list.push(info)
        }
        this.list.sort(sortFunc);
        this.selfRank = bytes.readByte();
        this.selfScore = bytes.readInt();
        this.selfExp = bytes.readInt();
        this.dispatchEvent(new ____590(____655.____661.war_xunbao_info, this, null))
    },
    clear: function() {
        this.list = [];
        this.selfRank = 0;
        this.selfScore = 0;
        this.selfExp = 0;
        this.selfTotalExp = 0
    },
});
var XunBaoItemInfo = cc.Class.extend({
    rank: 0,
    nick: "",
    score: 0,
    init: function(bytes) {
        this.rank = bytes.readByte();
        this.nick = bytes.readString();
        this.score = bytes.readInt()
    },
});
var ZhuoYaoInfo = ____591.extend({
    exp: 0,
    items: null,
    monsterTime: 0,
    ctor: function() {
        this._super();
        this.items = []
    },
    init: function() {
        var awards = ____655.allTemplates.awardTemplateList.getTypeList(7);
        for (var i = 0; i < awards.length; i++) {
            var item = new ZhuoYaoItemInfo();
            item.initTemp(awards[i]);
            this.items.push(item)
        }
    },
    initInfo: function(bytes) {
        this.exp = bytes.readInt();
        var len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var monsterId = bytes.readInt();
            var count = bytes.readShort();
            for (var j = 0; j < this.items.length; j++) {
                this.items[j].setMonsterCount(monsterId, count)
            }
        }
        len = bytes.readByte();
        for (var i = 0; i < len; i++) {
            var id = bytes.readInt();
            for (var j = 0; j < this.items.length; j++) {
                if (this.items[j].setGetAward(id)) break
            }
        }
        this.dispatchEvent(new ____590(____655.____661.war_zhuoyao_info, this, null))
    },
    initMonsterTime: function(bytes) {
        this.monsterTime = bytes.readInt();
        this.dispatchEvent(new ____590(____655.____661.war_zhuoyao_monsterTime, this, null))
    },
    clear: function() {
        this.exp = 0;
        this.monsterTime = 0;
        if (this.items != null) {
            for (var i = 0; i < this.items.length; i++) {
                if (this.items[i] != null) this.items[i].dispose()
            }
        }
        this.items = []
    },
});
var ZhuoYaoItemInfo = ____591.extend({
    id: 0,
    awardId: 0,
    awardCount: 0,
    hasGet: false,
    hasSend: false,
    monster1Id: 0,
    monster1NeedCount: 0,
    monster1HasCount: 0,
    monster2Id: 0,
    monster2NeedCount: 0,
    monster2HasCount: 0,
    monster3Id: 0,
    monster3NeedCount: 0,
    monster3HasCount: 0,
    initTemp: function(tempInfo) {
        this.id = tempInfo.id;
        this.awardId = tempInfo.awardList[0][0];
        this.awardCount = tempInfo.awardList[0][1];
        var monsterList = ____654.____674.strItemSplitToInts(tempInfo.condition);
        this.monster1Id = monsterList[0][0];
        this.monster1NeedCount = monsterList[0][1];
        this.monster2Id = monsterList[1][0];
        this.monster2NeedCount = monsterList[1][1];
        this.monster3Id = monsterList[2][0];
        this.monster3NeedCount = monsterList[2][1]
    },
    setMonsterCount: function(monsterId, count) {
        if (this.monster1Id == monsterId) {
            this.monster1HasCount = count;
            return true
        }
        if (this.monster2Id == monsterId) {
            this.monster2HasCount = count;
            return true
        }
        if (this.monster3Id == monsterId) {
            this.monster3HasCount = count;
            return true
        }
        return false
    },
    setGetAward: function(id) {
        if (this.id == id) {
            this.hasGet = true;
            return true
        }
        return false
    },
    isComplete: function() {
        return this.monster1HasCount >= this.monster1NeedCount && this.monster2HasCount >= this.monster2NeedCount && this.monster3HasCount >= this.monster3NeedCount
    },
    dispose: function() {
        this._super()
    },
});
var ____2244 = cc.Class.extend({
    sceneModule: null,
    sceneInfo: null,
    headViewPanel: null,
    mainMenu: null,
    chatPanel: null,
    gmPanel: null,
    ____156: null,
    mailPanel: null,
    onlineAwardPanel: null,
    copyComplatePanel: null,
    newlyCopyComplatePanel: null,
    payPanel: null,
    sceneTaskPanel: null,
    friendResponsePanel: null,
    followPanel: null,
    awardPanel: null,
    numberPanel: null,
    worldMapPanel: null,
    teamPanel: null,
    wuShenMatchPanel: null,
    jiazuWarGuwuPanel: null,
    relivePanel: null,
    doushenPanel: null,
    welfareZhuanShuGiftBuyView: null,
    xiLianPanel: null,
    xunbaoMatchPanel: null,
    zhuoyaoMatchPanel: null,
    tghjMatchPanel: null,
    tghjBoxPanel: null,
    warMessageSender: null,
    returnGiftPanel: null,
    prePayPanel: null,
    familyTreasuresPanel: null,
    kuozhanGiftPanel: null,
    cifuController: null,
    welcomeAwardPanel: null,
    newlyCopyTalkView: null,
    xianWeiUpLevelPanel: null,
    overCountDownView: null,
    guideRiderView: null,
    awardZhanChangPanel: null,
    lianZhanView: null,
    luckyTreasurePanel: null,
    luckyTreasureAwardPanel: null,
    xianWeiTipView: null,
    citykingPanel: null,
    taskCompleteView: null,
    dailyFirstRechargePanel: null,
    waiXingChongJiePanel: null,
    sceneChatView: null,
    ctor: function(sceneModule) {
        this.sceneModule = sceneModule;
        this.sceneInfo = sceneModule.sceneInfo
    },
    init: function() {
        this.warMessageSender = new ____2246();
        this.warMessageSender.add(this.sceneModule);
        this.initViews();
        this.____6()
    },
    initViews: function() {
        this.sceneTaskPanel = new ____2278(this);
        this.sceneTaskPanel.setPosition(____654.____673.____159(4, ____655.____657 - 213));
        ____654.____676.____799.addChild(this.sceneTaskPanel);
        this.mainMenu = new MainMenu(this);
        this.headViewPanel = new ____2263(this);
        this.cifuController = new CifuController(this)
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this);
        ____654.____672.addEventListener(____655.____661.copy_showComplatePanel, this.showCopyComplatePanel, this);
        ____654.____672.addEventListener(____655.____661.panel_open_payPanel, this.showPayPanel, this);
        ____654.____672.addEventListener(____655.____661.warPlacePanel, this.showWarPlacePanel, this);
        ____654.____672.addEventListener(____655.____661.panel_open_awardPanel, this.showAwardPanel, this);
        ____654.____672.addEventListener(____655.____661.panel_close_awardPanel, this.hideAwardPanel, this);
        ____654.____672.addEventListener(____655.____661.common_showFollowPanel, this.showFollowPanel, this);
        ____654.____672.addEventListener(____655.____661.common_showNumberPanel, this.showNumberPanel, this);
        ____654.____672.addEventListener(____655.____661.war_showWushenMatchPanel, this.showWuShenMatchPanel, this);
        ____654.____672.addEventListener(____655.____661.common_showTeamPanel, this.showTeamPanel, this);
        ____654.____672.addEventListener(____655.____661.common_hideTeamPanel, this.hideTeamPanel, this);
        ____655.warDatas.douShenInfo.addEventListener(____655.____661.war_doushen_result, this.showDoushenPanel, this);
        ____654.____672.addEventListener(____655.____661.welfare_ZhuanShuShowBuyView, this.showZhuanShuGiftBuyPanel, this);
        ____655.copyInfo.addEventListener(____655.____661.copy_sweepComplate, this.showSweepPanel, this);
        ____654.____672.addEventListener(____655.____661.common_showChatPanel, this.showChatPanelHandler, this);
        ____654.____672.addEventListener(____655.____661.common_hideChatPanel, this.hideChatPanel, this);
        ____654.____672.addEventListener(____655.____661.war_showXunBaoMatchPanel, this.showXunBaoMatchPanel, this);
        ____654.____672.addEventListener(____655.____661.war_showZhuoYaoMatchPanel, this.showZhuoYaoMatchPanel, this);
        ____654.____672.addEventListener(____655.____661.war_showTGHJMatchPanel, this.showTGHJMatchPanel, this);
        ____654.____672.addEventListener(____655.____661.weapon_showXiLianPanel, this.showXiLianPanel, this);
        ____654.____672.addEventListener(____655.____661.guide_npcTalkView, this.showNpcTalkViewHandler, this);
        ____654.____672.addEventListener(____655.____661.welcome_awardPanel, this.showWelcomeAwardPanel, this);
        ____654.____672.addEventListener(____655.____661.open_xianWeiUpLevelPanel, this.showXianWeiUpLevelPanel, this);
        ____654.____672.addEventListener(____655.____661.open_guideRiderPanel, this.showGuideRiderPanel, this);
        ____654.____672.addEventListener(____655.____661.open_onlineAwardPanel, this.showOnlineAwardPanel, this);
        ____654.____672.addEventListener(____655.____661.open_luckyTreasurePanel, this.showLuckyTreasurePanel, this);
        ____654.____672.addEventListener(____655.____661.open_xianweiTipsPanel, this.showXianWeiTipView, this);
        ____654.____672.addEventListener(____655.____661.common_taskClubAndDailyUpdate, this.showTaskCompleteView, this);
        ____654.____672.addEventListener(____655.____661.panel_open_dailyFirst, this.showDailyFirstRechargePanel, this);
        ____654.____672.addEventListener(____655.____661.panel_open_waiXingChongJie, this.showWaiXingChongJiePanel, this)
    },
    updateSkillPad: function() {
        if (this.mainMenu != null) {
            this.mainMenu.updateSkillPad()
        }
    },
    setLianZhan: function(value) {
        if (value == null) return;
        if (value < 2) {
            if (this.lianZhanView != null) {
                this.lianZhanView.dispose();
                this.lianZhanView = null
            }
        } else {
            if (this.lianZhanView == null) {
                this.lianZhanView = new LianZhanView();
                this.lianZhanView.setPosition(____655.____656 - 150, ____655.____657 - 150)
            }
            this.lianZhanView.____18(value);
            if (this.lianZhanView.getParent() == null) {
                ____654.____676.____799.addChild(this.lianZhanView)
            }
        }
    },
    showZhuanShuGiftBuyPanel: function(evt) {
        var info = null;
        if (evt != null) {
            var id = evt.data;
            info = ____655.allTemplates.payTemplateList.getInfoById(id)
        }
        if (this.welfareZhuanShuGiftBuyView == null) {
            this.welfareZhuanShuGiftBuyView = new WelfareZhuanShuGiftBuyView(this, info)
        }
        ____654.____676.____125(this.welfareZhuanShuGiftBuyView, true)
    },
    showChatPanelHandler: function(evt) {
        var channel = evt.data;
        this.showChatPanel(channel)
    },
    showChatPanel: function(channel) {
        if (this.chatPanel == null) {
            this.chatPanel = new ChatPanel(this, channel);
            this.chatPanel.setPosition(____654.____673.____159(____655.____656 - 480, 0))
        }
        ____654.____676.____125(this.chatPanel, false)
    },
    hideChatPanel: function() {
        if (this.chatPanel != null) {
            this.chatPanel.dispose();
            this.chatPanel = null
        }
    },
    ____253: function() {
        if (this.mailPanel == null) {
            this.mailPanel = new ____565(this)
        }
        ____654.____676.____125(this.mailPanel)
    },
    showFriendResponsePanel: function() {
        if (this.friendResponsePanel == null) {
            this.friendResponsePanel = new ____2261(this)
        }
        ____654.____676.____125(this.friendResponsePanel)
    },
    showOnlineAwardPanel: function() {
        if (this.onlineAwardPanel == null) {
            this.onlineAwardPanel = new OnlineAwardPanel(this)
        }
        ____654.____676.____125(this.onlineAwardPanel)
    },
    showWorldMapPanel: function() {
        if (this.worldMapPanel == null) {
            this.worldMapPanel = new ____2270(this)
        }
        ____654.____676.____125(this.worldMapPanel)
    },
    showXiLianPanel: function(evt) {
        if (this.xiLianPanel == null) {
            this.xiLianPanel = new WeaponXiLianPanel(evt.data)
        }
        ____654.____676.____125(this.xiLianPanel)
    },
    showSetPanel: function() {
        if (this.____156 == null) {
            this.____156 = new ____2274(this)
        }
        ____654.____676.____125(this.____156)
    },
    hideSetPanel: function(evt) {
        if (this.____156 != null) {
            this.____156.dispose();
            this.____156 = null
        }
    },
    showGmPanel: function() {
        if (this.gmPanel == null) {
            this.gmPanel = new GmPanel(this)
        }
        ____654.____676.____125(this.gmPanel)
    },
    hideGmPanel: function(evt) {
        if (this.gmPanel != null) {
            this.gmPanel.dispose();
            this.gmPanel = null
        }
    },
    showCopyComplatePanel: function(evt) {
        var list = evt.data;
        if (this.copyComplatePanel == null) {
            this.copyComplatePanel = new ____2253(this);
            if (list[0] == 0) {
                this.copyComplatePanel.initDouShen(list[1])
            } else {
                this.copyComplatePanel.initData(list[0], list[1])
            }
        }
        ____654.____676.____125(this.copyComplatePanel)
    },
    showPayPanel: function(evt) {
        if (!____655.____663.getCurrent().isPay) {
            ____654.tipsManager.quickTip.show("充值未开放，敬请期待！");
            return
        }
        if (this.payPanel == null) {
            this.payPanel = new PayPanel(this)
        }
        ____654.____676.____125(this.payPanel)
    },
    showWarPlacePanel: function(evt) {
        var index = 0;
        if (evt != null && evt.data != null) {
            index = evt.data
        }
        if (this.warPlacePanel == null) {
            this.warPlacePanel = new ____2259(this, index)
        }
        ____654.____676.uiPanelContainer.____125(this.warPlacePanel, ____655.____659.panelTabType.warPlace)
    },
    showAwardPanel: function(evt) {
        var data = evt.data;
        if (this.awardPanel == null) {
            this.awardPanel = new ____2126(data[0], data[1], data[2], data[3], data[4], data[5])
        }
        ____654.____676.____125(this.awardPanel)
    },
    hideAwardPanel: function(evt) {
        if (this.awardPanel != null) {
            this.awardPanel.dispose();
            this.awardPanel = null
        }
    },
    showTeamPanel: function(evt) {
        var data = evt.data;
        if (this.teamPanel == null) {
            this.teamPanel = new TeamPanel(this, data[0], data[1], data[2]);
            this.teamPanel.updateInfo()
        }
        ____654.____676.____125(this.teamPanel)
    },
    showWelcomeAwardPanel: function() {
        if (this.welcomeAwardPanel == null) {
            this.welcomeAwardPanel = new WelcomePanel(this)
        }
        if (this.mainMenu != null) {
            this.mainMenu.hide()
        }
        if (this.sceneTaskPanel != null) {
            this.sceneTaskPanel.setVisible(false)
        }
        ____654.____676.____125(this.welcomeAwardPanel)
    },
    hideWelcomePanel: function(evt) {
        if (this.welcomeAwardPanel != null) {
            this.welcomeAwardPanel.dispose();
            this.welcomeAwardPanel = null;
            if (this.mainMenu != null) {
                this.mainMenu.show()
            }
            if (this.sceneTaskPanel != null) {
                this.sceneTaskPanel.setVisible(true)
            }
        }
    },
    showXianWeiUpLevelPanel: function(evt) {
        if (this.xianWeiUpLevelPanel == null) {
            this.xianWeiUpLevelPanel = new XianWeiUpLevelPanel(this, evt.data);
            this.xianWeiUpLevelPanel.setPosition(____655.____656 * 0.5, ____655.____657 * 0.5)
        }
        ____654.____676.____802.addChild(this.xianWeiUpLevelPanel)
    },
    hideXianWeiUpLevelPanel: function(evt) {
        if (this.xianWeiUpLevelPanel != null) {
            this.xianWeiUpLevelPanel.dispose();
            this.xianWeiUpLevelPanel = null
        }
    },
    showLuckyTreasurePanel: function(evt) {
        var type = evt.data;
        if (this.luckyTreasurePanel == null) {
            this.luckyTreasurePanel = new LuckyTreasurePanel(this, type)
        }
        ____654.____676.____125(this.luckyTreasurePanel)
    },
    hideLuckyTreasurePanel: function(evt) {
        if (this.luckyTreasurePanel != null) {
            this.luckyTreasurePanel.dispose();
            this.luckyTreasurePanel = null
        }
    },
    showLuckyTreasureAwardPanel: function(itemList) {
        if (this.luckyTreasureAwardPanel == null) {
            this.luckyTreasureAwardPanel = new LuckyTreasureAwardView(this, itemList);
            this.luckyTreasureAwardPanel.setPosition(____655.____656 * 0.5 - 268, ____655.____657 * 0.5 - 268)
        }
        ____654.____676.____802.addChild(this.luckyTreasureAwardPanel)
    },
    hideLuckyTreasureAwardPanel: function() {
        if (this.luckyTreasureAwardPanel != null) {
            this.luckyTreasureAwardPanel.dispose();
            this.luckyTreasureAwardPanel = null
        }
    },
    showGuideRiderPanel: function() {
        if (this.guideRiderView == null) {
            this.guideRiderView = new GuideRiderView(this)
        }
        ____654.____676.____802.addChild(this.guideRiderView);
        this.guideRiderView.setPosition(____655.____656 * 0.5, ____655.____657 * 0.5)
    },
    hideGuideRiderPanel: function() {
        if (this.guideRiderView != null) {
            this.guideRiderView.dispose();
            this.guideRiderView = null
        }
    },
    showAwardZhanChangPanel: function(type, title, list, callBack, executor) {
        if (this.awardZhanChangPanel == null) {
            this.awardZhanChangPanel = new AwardZhanChangPanel(this, type, title, list, callBack, executor)
        }
        ____654.____676.____125(this.awardZhanChangPanel)
    },
    hideAwardZhanChangPanel: function() {
        if (this.awardZhanChangPanel != null) {
            this.awardZhanChangPanel.dispose();
            this.awardZhanChangPanel = null
        }
    },
    showSceneChatView: function() {
        if (this.sceneChatView == null) {
            this.sceneChatView = new SceneChatView(this)
        }
        this.sceneChatView.setPosition(____655.____656 * 0.5 - 204, 8);
        ____654.____676.____802.addChild(this.sceneChatView)
    },
    hideSceneChatView: function() {
        if (this.sceneChatView != null) {
            this.sceneChatView.dispose();
            this.sceneChatView = null
        }
    },
    showOverCountDownView: function(num, title, callBack, executor) {
        if (this.overCountDownView == null) {
            this.overCountDownView = new OverCountDownView(this, num, title, callBack, executor)
        }
        ____654.____676.____125(this.overCountDownView)
    },
    hideOverCountDownView: function(evt) {
        if (this.overCountDownView != null) {
            this.overCountDownView.dispose();
            this.overCountDownView = null
        }
    },
    hideTeamPanel: function(evt) {
        if (this.teamPanel != null) {
            this.teamPanel.dispose();
            this.teamPanel = null
        }
    },
    showYaoqingPanel: function(type) {
        if (this.yaoqingPanel == null) {
            this.yaoqingPanel = new YaoqingPanel(this, type)
        }
        ____654.____676.____125(this.yaoqingPanel)
    },
    hideYaoqingPanel: function() {
        if (this.yaoqingPanel != null) {
            this.yaoqingPanel.dispose();
            this.yaoqingPanel = null
        }
    },
    addMonsterHeadView: function() {
        if (this.headViewPanel != null) {
            this.headViewPanel.addMonsterHeadView()
        }
    },
    addPlayerHeadView: function() {
        if (this.headViewPanel != null) {
            this.headViewPanel.addPlayerHeadView()
        }
    },
    showFollowPanel: function() {
        if (this.followPanel != null) {
            this.followPanel.dispose();
            this.followPanel = null
        }
        if (____655.copyInfo.currentId <= 0) {
            if (____655.currentMapId >= ____655.allTemplates.copyTemplateList.WORLDBOSSMAPID_MIN && ____655.currentMapId <= ____655.allTemplates.copyTemplateList.WORLDBOSSMAPID_MAX) {
                this.followPanel = new ____2254(this, ____655.currentMapId);
                this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 383))
            }
        } else if (____655.allTemplates.copyTemplateList.WORLDBOSSPERSON_IDLIST.indexOf(____655.copyInfo.currentId) != -1) {
            this.followPanel = new PersonBossFollowPanel(this, ____655.copyInfo.currentId);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 208))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.TGXS_COPYID) {
            this.followPanel = new PersonBossFollowPanel(this, ____655.copyInfo.currentId);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 208))
        } else if (____655.allTemplates.copyTemplateList.WORLDBOSSGOD_IDLIST.indexOf(____655.copyInfo.currentId) != -1) {
            this.followPanel = new PersonBossFollowPanel(this, ____655.copyInfo.currentId);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 208))
        } else if (____655.allTemplates.copyTemplateList.clubExpeditionCopyList.indexOf(____655.copyInfo.currentId) != -1) {
            this.followPanel = new PersonBossFollowPanel(this, ____655.copyInfo.currentId);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 208))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.XIUXIAN_COPYID) {
            this.followPanel = new CopyXiuXianFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 278))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.WAIGUAN_COPYID) {
            this.followPanel = new CopyWaiGuanFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 208))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.YAOTA_COPYID) {
            this.followPanel = new CopyYaoTaFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 248))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.TONGTIAN_COPYID) {
            this.followPanel = new CopyTongTianFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 248))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.CAILIAO_COPYID || ____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.XIANYUAN_COPYID || ____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.JIEYI_COPYID) {
            this.followPanel = new CopyBaseFollowPanel(this, ____655.copyInfo.currentId);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 208))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.SHOUHU_COPYID) {
            this.followPanel = new CopyShouHuFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 388))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.CLUBBOSS_COPYID) {
            this.followPanel = new ____2252(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 333))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.DALUANDOU_COPYID) {
            this.followPanel = new ____2289(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 383))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.WUSHEN_COPYID) {
            this.followPanel = new ____2296(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 383))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID) {
            this.followPanel = new ____2292(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 383))
        } else if (____655.allTemplates.copyTemplateList.NEWLY_COPYIDLIST.indexOf(____655.copyInfo.currentId) >= 0) {
            this.followPanel = new CopyNewlyFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 178))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.XUNBAO_COPYID) {
            this.followPanel = new XunBaoFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 400))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.TGHJ_COPYID) {
            this.followPanel = new TGHJFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 383))
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.ZUOYAO_COPYID) {
            this.followPanel = new ZhuoyaoFollowPanel(this);
            this.followPanel.setPosition(____654.____673.____159(4, ____655.____657 - 358))
        }
        if (this.followPanel != null) {
            ____654.____676.____799.addChild(this.followPanel);
            this.sceneTaskPanel.removeFromParent(false)
        } else {
            if (this.sceneTaskPanel.getParent() == null) {
                ____654.____676.____799.addChild(this.sceneTaskPanel)
            }
        }
        this.updateSkillPad()
    },
    showNumberPanel: function(evt) {
        var dataList = evt.data;
        if (this.numberPanel == null) {
            this.numberPanel = new NumberPanel(dataList[0], dataList[1], dataList[2], dataList[3], dataList[4], dataList[5], dataList[6], dataList[7], dataList[8]);
            ____654.____676.____125(this.numberPanel)
        }
    },
    showWuShenMatchPanel: function(evt) {
        if (____654.copyTester.checkCopy(____655.allTemplates.copyTemplateList.WUSHEN_COPYID, 0)) {
            if (this.wuShenMatchPanel == null) {
                this.wuShenMatchPanel = new WuShenMatchPanel(this);
                ____654.____676.____125(this.wuShenMatchPanel)
            }
        }
    },
    closeWuShenMatchPanel: function() {
        if (this.wuShenMatchPanel != null) {
            this.wuShenMatchPanel.dispose();
            this.wuShenMatchPanel = null
        }
    },
    showJiazuWarGuwuPanel: function() {
        if (this.jiazuWarGuwuPanel == null) {
            this.jiazuWarGuwuPanel = new JiazuWarGuwuPanel(this);
            ____654.____676.____125(this.jiazuWarGuwuPanel)
        }
    },
    showDoushenPanel: function(evt) {
        if (this.doushenPanel == null) {
            this.doushenPanel = new ____2291();
            ____654.____676.____125(this.doushenPanel)
        }
    },
    showXunBaoMatchPanel: function(evt) {
        if (____654.copyTester.checkCopy(____655.allTemplates.copyTemplateList.XUNBAO_COPYID, 0)) {
            if (this.xunbaoMatchPanel == null) {
                this.xunbaoMatchPanel = new XunBaoMatchPanel(this);
                ____654.____676.____125(this.xunbaoMatchPanel)
            }
        }
    },
    hideXunBaoMatchPanel: function() {
        if (this.xunbaoMatchPanel != null) {
            this.xunbaoMatchPanel.dispose();
            this.xunbaoMatchPanel = null
        }
    },
    showZhuoYaoMatchPanel: function(evt) {
        if (____654.copyTester.checkCopy(____655.allTemplates.copyTemplateList.ZUOYAO_COPYID, 0)) {
            if (this.zhuoyaoMatchPanel == null) {
                this.zhuoyaoMatchPanel = new ZhuoyaoMatchPanel(this);
                ____654.____676.____125(this.zhuoyaoMatchPanel)
            }
        }
    },
    hideZhuoYaoMatchPanel: function() {
        if (this.zhuoyaoMatchPanel != null) {
            this.zhuoyaoMatchPanel.dispose();
            this.zhuoyaoMatchPanel = null
        }
    },
    showTGHJMatchPanel: function(evt) {
        if (____654.copyTester.checkCopy(____655.allTemplates.copyTemplateList.TGHJ_COPYID, 0)) {
            if (this.tghjMatchPanel == null) {
                this.tghjMatchPanel = new TGHJMatchPanel(this);
                ____654.____676.____125(this.tghjMatchPanel)
            }
        }
    },
    hideTGHJMatchPanel: function() {
        if (this.tghjMatchPanel != null) {
            this.tghjMatchPanel.dispose();
            this.tghjMatchPanel = null
        }
    },
    showTGHJBoxPanel: function(boxType) {
        if (this.tghjBoxPanel == null) {
            this.tghjBoxPanel = new TGHJBoxPanel(this, boxType);
            ____654.____676.____125(this.tghjBoxPanel)
        }
    },
    showRelivePanel: function() {
        if (this.relivePanel == null) {
            this.relivePanel = new RelivePanel(this);
            ____654.____676.____125(this.relivePanel)
        }
    },
    hideRelivePanel: function() {
        if (this.relivePanel != null) {
            this.relivePanel.dispose();
            this.relivePanel = null
        }
    },
    showReturnGiftPanel: function() {
        if (this.returnGiftPanel == null) {
            this.returnGiftPanel = new ReturnGiftPanel(this)
        }
        ____654.____676.____125(this.returnGiftPanel)
    },
    showSweepPanel: function(evt) {
        if (this.copyComplatePanel == null) {
            this.copyComplatePanel = new ____2253();
            this.copyComplatePanel.initSweep(evt.data);
            ____654.____676.____125(this.copyComplatePanel)
        }
    },
    showPrePayPanel: function() {
        if (this.prePayPanel == null) {
            this.prePayPanel = new PrePayPanel(this)
        }
        ____654.____676.____125(this.prePayPanel)
    },
    showFamilyTreasuresPanel: function() {
        if (this.familyTreasuresPanel == null) {
            this.familyTreasuresPanel = new FamilyTreasuresPanel(this)
        }
        ____654.____676.____125(this.familyTreasuresPanel)
    },
    showNewlyCopyComplatePanel: function(index) {
        if (this.newlyCopyComplatePanel == null) {
            this.newlyCopyComplatePanel = new CopyNewlyComplatePanel(this, index)
        }
        ____654.____676.____125(this.newlyCopyComplatePanel)
    },
    showNpcTalkViewHandler: function(evt) {
        this.showNpcTalkView(evt.data)
    },
    showNpcTalkView: function(desId) {
        if (this.newlyCopyTalkView == null) {
            this.newlyCopyTalkView = new NewlyCopyTalkView(this);
            ____654.____676.____125(this.newlyCopyTalkView, false)
        }
        this.newlyCopyTalkView.____363(desId);
        if (this.mainMenu != null) {
            this.mainMenu.hide()
        }
    },
    hideNpcTalkView: function() {
        if (this.newlyCopyTalkView != null) {
            this.newlyCopyTalkView.dispose();
            this.newlyCopyTalkView = null
        }
        if (this.mainMenu != null) {
            this.mainMenu.show()
        }
    },
    showKuozhanGiftPanel: function() {
        if (this.kuozhanGiftPanel == null) {
            this.kuozhanGiftPanel = new KuozhanGiftPanel(this);
            ____654.____676.____125(this.kuozhanGiftPanel)
        }
    },
    hideKuozhanGiftPanel: function() {
        if (this.kuozhanGiftPanel != null) {
            this.kuozhanGiftPanel.dispose();
            this.kuozhanGiftPanel = null
        }
    },
    showXianWeiTipView: function() {
        if (this.xianWeiTipView == null) {
            this.xianWeiTipView = new RoleXianWeiTipView(this)
        }
        ____654.____676.____125(this.xianWeiTipView, true)
    },
    hideXianWeiTipView: function() {
        if (this.xianWeiTipView != null) {
            this.xianWeiTipView.dispose();
            this.xianWeiTipView = null
        }
    },
    showTaskCompleteView: function(evt) {
        var dataList = evt.data;
        if (dataList != null) {
            if (this.taskCompleteView == null) {
                this.taskCompleteView = new TaskCompleteView(this, dataList);
                this.taskCompleteView.setPosition(____655.____656 * 0.5, ____655.____657 * 0.5)
            }
            ____654.____676.____802.addChild(this.taskCompleteView)
        }
    },
    hideTaskCompleteView: function() {
        if (this.taskCompleteView != null) {
            this.taskCompleteView.dispose();
            this.taskCompleteView = null
        }
    },
    showCityKingPanel: function() {
        if (this.citykingPanel == null) {
            this.citykingPanel = new CitykingPanel(this)
        }
        ____654.____676.____125(this.citykingPanel, true)
    },
    showDailyFirstRechargePanel: function(evt) {
        if (this.dailyFirstRechargePanel == null) {
            this.dailyFirstRechargePanel = new DailyFirstRechargePanel(this);
            if (evt != null && evt.data != null) {
                var index = evt.data;
                this.dailyFirstRechargePanel.____225(index - 1)
            }
        }
        ____654.____676.____125(this.dailyFirstRechargePanel, true)
    },
    showWaiXingChongJiePanel: function(evt) {
        if (this.waiXingChongJiePanel == null) {
            this.waiXingChongJiePanel = new WaiXingChongJiePanel(this)
        }
        ____654.____676.____125(this.waiXingChongJiePanel, true)
    },
    clear: function() {
        this.setLianZhan(0)
    },
    ____61: function() {
        if (this.cifuController != null) {
            this.cifuController.clear()
        }
        this.setLianZhan(0)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.chatPanel) {
            this.chatPanel = null
        } else if (p == this.mailPanel) {
            this.mailPanel = null
        } else if (p == this.onlineAwardPanel) {
            this.onlineAwardPanel = null
        } else if (p == this.copyComplatePanel) {
            this.copyComplatePanel = null
        } else if (p == this.payPanel) {
            this.payPanel = null
        } else if (p == this.friendResponsePanel) {
            this.friendResponsePanel = null
        } else if (p == this.awardPanel) {
            this.awardPanel = null
        } else if (p == this.numberPanel) {
            this.numberPanel = null
        } else if (p == this.worldMapPanel) {
            this.worldMapPanel = null
        } else if (p == this.wuShenMatchPanel) {
            this.wuShenMatchPanel = null
        } else if (p == this.relivePanel) {
            this.relivePanel = null
        } else if (p == this.jiazuWarGuwuPanel) {
            this.jiazuWarGuwuPanel = null
        } else if (p == this.warPlacePanel) {
            this.warPlacePanel = null
        } else if (p == this.doushenPanel) {
            this.doushenPanel = null
        } else if (p == this.welfareZhuanShuGiftBuyView) {
            this.welfareZhuanShuGiftBuyView = null
        } else if (p == this.returnGiftPanel) {
            this.returnGiftPanel = null
        } else if (p == this.copySweepPanel) {
            this.copySweepPanel = null
        } else if (p == this.prePayPanel) {
            this.prePayPanel = null
        } else if (p == this.familyTreasuresPanel) {
            this.familyTreasuresPanel = null
        } else if (p == this.yaoqingPanel) {
            this.yaoqingPanel = null
        } else if (p == this.teamPanel) {
            this.teamPanel = null
        } else if (p == this.newlyCopyComplatePanel) {
            this.newlyCopyComplatePanel = null
        } else if (p == this.xunbaoMatchPanel) {
            this.xunbaoMatchPanel = null
        } else if (p == this.tghjMatchPanel) {
            this.tghjMatchPanel = null
        } else if (p == this.zhuoyaoMatchPanel) {
            this.zhuoyaoMatchPanel = null
        } else if (p == this.xiLianPanel) {
            this.xiLianPanel = null
        } else if (p == this.tghjBoxPanel) {
            this.tghjBoxPanel = null
        } else if (p == this.newlyCopyTalkView) {
            this.newlyCopyTalkView = null
        } else if (p == this.welcomeAwardPanel) {
            this.welcomeAwardPanel = null
        } else if (p == this.xianWeiUpLevelPanel) {
            this.xianWeiUpLevelPanel = null
        } else if (p == this.sceneChatView) {
            this.sceneChatView = null
        } else if (p == this.kuozhanGiftPanel) {
            this.kuozhanGiftPanel = null
        } else if (p == this.gmPanel) {
            this.gmPanel = null
        } else if (p == this.____156) {
            this.____156 = null
        } else if (p == this.xianWeiTipView) {
            this.xianWeiTipView = null
        } else if (p == this.citykingPanel) {
            this.citykingPanel = null
        } else if (p == this.dailyFirstRechargePanel) {
            this.dailyFirstRechargePanel = null
        } else if (p == this.luckyTreasurePanel) {
            this.luckyTreasurePanel = null
        } else if (p == this.luckyTreasureAwardPanel) {
            this.luckyTreasureAwardPanel = null
        } else if (p == this.lianZhanView) {
            this.lianZhanView = null
        } else if (p == this.awardZhanChangPanel) {
            this.awardZhanChangPanel = null
        } else if (p == this.guideRiderView) {
            this.guideRiderView = null
        } else if (p == this.overCountDownView) {
            this.overCountDownView = null
        } else if (p == this.taskCompleteView) {
            this.taskCompleteView = null
        } else if (p == this.waiXingChongJiePanel) {
            this.waiXingChongJiePanel = null
        }
    },
});
var ____2245 = ____537.extend({
    scenePanelController: null,
    setup: function(data) {
        this.scenePanelController = new ____2244(this)
    },
    ____151: function(data) {},
    clear: function() {},
});
var ____2246 = cc.Class.extend({
    sceneModule: null,
    sceneInfo: null,
    scenePanelController: null,
    add: function(sceneModule) {
        this.sceneModule = sceneModule;
        this.sceneInfo = sceneModule.sceneInfo;
        this.scenePanelController = sceneModule.scenePanelController;
        var this_ = this;

        function daLuanDouInfoReturn(bytes) {
            ____655.warDatas.daLuanDouInfo.init(bytes)
        };

        function daLuanDouRankReturn(bytes) {
            ____655.warDatas.daLuanDouInfo.initRank(bytes)
        };

        function wuShenMatchStartReturn(bytes) {
            var result = bytes.readByte();
            ____655.rankInfo.wushenJoinTimes = bytes.readShort();
            if (result > 1) {
                this_.scenePanelController.closeWuShenMatchPanel()
            }
        };

        function wuShenInfoReturn(bytes) {
            ____655.warDatas.wuShenInfo.init(bytes)
        };

        function jiazuWarInfoReturn(bytes) {
            ____655.warDatas.jiazuWarInfo.initInfo(bytes)
        };

        function jiazuWarGuWuReturn(bytes) {
            ____655.warDatas.jiazuWarInfo.initGuWu(bytes)
        };

        function jiazuWarGuWuResultReturn(bytes) {
            var rate = bytes.readUByte();
            if (rate == 0) {
                ____654.tipsManager.quickTip.show("鼓励成功")
            } else {
                ____654.tipsManager.quickTip.show("鼓舞失败，成功率+" + rate + "%")
            }
        };

        function jiazuWarSignNumReturn(bytes) {
            ____655.warDatas.jiazuWarInfo.initSign(bytes)
        };

        function jiazuWarCollectReturn(bytes) {
            ____655.warDatas.jiazuWarInfo.initCollect(bytes.readInt(), bytes.readByte())
        };

        function jiazuWarPointReturn(bytes) {
            ____655.warDatas.jiazuWarInfo.initPoints(bytes)
        };

        function jiazuWarSubmitReturn(bytes) {
            print("收到家族战提交");
            ____655.warDatas.jiazuWarInfo.hasCollectSubmit = false
        };

        function douShenFightReturn(bytes) {
            print("收到斗神返回");
            ____655.warDatas.douShenInfo.initFightResult(bytes)
        };

        function cifuStateReturn(bytes) {
            ____655.warDatas.cifuInfo.initState(bytes)
        };

        function cifuGetReturn(bytes) {
            ____655.warDatas.cifuInfo.initGet(bytes)
        };

        function zhuoYaoInfoReturn(bytes) {
            ____655.warDatas.zhuoyaoInfo.initInfo(bytes)
        };

        function zhuoYaoAwardReturn(bytes) {};

        function zhuoYaoTimeReturn(bytes) {
            ____655.warDatas.zhuoyaoInfo.initMonsterTime(bytes)
        };

        function zhuoYaoMatchReturn(bytes) {
            var result = bytes.readByte();
            if (result > 0) {
                this_.scenePanelController.hideZhuoYaoMatchPanel();
                if (result == 2) {
                    ____654.tipsManager.quickTip.show("次数已用完")
                }
            }
        };

        function xunbaoMatchReturn(bytes) {
            var result = bytes.readByte();
            if (result > 0) {
                this_.scenePanelController.hideXunBaoMatchPanel();
                if (result == 2) {
                    ____654.tipsManager.quickTip.show("次数已用完")
                }
            }
        };

        function xunbaoInfoReturn(bytes) {
            print("收到寻宝info");
            ____655.warDatas.xunbaoInfo.initInfo(bytes)
        };

        function tghjMatchReturn(bytes) {
            var result = bytes.readByte();
            if (result > 0) {
                this_.scenePanelController.hideTGHJMatchPanel();
                if (result == 2) {
                    ____654.tipsManager.quickTip.show("次数已用完")
                }
            }
        };

        function tghjInfoReturn(bytes) {
            ____655.warDatas.tghjInfo.initInfo(bytes)
        };

        function tghjBoxReturn(bytes) {
            print("获取宝箱返回");
            ____655.warDatas.tghjInfo.initBox(bytes)
        };

        function tghjTransReturn(bytes) {
            print("摇宝箱返回");
            ____655.warDatas.tghjInfo.initTrans(bytes)
        };

        function tghjNextFloorReturn(bytes) {
            print("收到下一层");
            ____655.warDatas.tghjInfo.nextFloor(bytes)
        };

        function wuShenNumsReturn(bytes) {
            ____655.warDatas.wuShenInfo.setNums(bytes)
        };
        ____654.____680.addSocketHandler(____655.____659.____691.DALUANDOU_INFO, daLuanDouInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.DALUANDOU_RANK, daLuanDouRankReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.WUSHEN_MATCH_START, wuShenMatchStartReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.WUSHEN_INFO, wuShenInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.JIAZU_WAR_INFO, jiazuWarInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.JIAZU_WAR_GUWU, jiazuWarGuWuReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.JIAZU_WAR_GUWURESULT, jiazuWarGuWuResultReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.JIAZU_WAR_SIGNNUM, jiazuWarSignNumReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.JIAZU_WAR_COLLECT, jiazuWarCollectReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.JIAZU_WAR_POINT, jiazuWarPointReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.JIAZU_WAR_SUBMIT, jiazuWarSubmitReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.DOUSHEN_FIGTH, douShenFightReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CIFU_GET, cifuGetReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CIFU_STATE, cifuStateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ZHUOYAO_INFO, zhuoYaoInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ZHUOYAO_AWARD, zhuoYaoAwardReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ZHUOYAO_TIME, zhuoYaoTimeReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.ZHUOYAO_MATCH, zhuoYaoMatchReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_XUNBAO_MATCH, xunbaoMatchReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COPY_XUNBAO_INFO, xunbaoInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TGHJ_MATCH, tghjMatchReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TGHJ_INFO, tghjInfoReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TGHJ_BOX, tghjBoxReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TGHJ_TRANS, tghjTransReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TGHJ_NEXT_FLOOR, tghjNextFloorReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.WUSHEN_BEGIN_TIME, wuShenNumsReturn)
    },
    sendWuShenMatchStart: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WUSHEN_MATCH_START);
        ____654.____680.send(messOut)
    },
    sendWuShenMatchCancel: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.WUSHEN_MATCH_CANCEL);
        ____654.____680.send(messOut)
    },
    sendJiazuSign: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.JIAZU_WAR_SIGN);
        ____654.____680.send(messOut)
    },
    sendJiazuSignNum: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.JIAZU_WAR_SIGNNUM);
        ____654.____680.send(messOut)
    },
    sendJiazuGuWu: function(type, place) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.JIAZU_WAR_GUWU);
        messOut.writeByte(type);
        messOut.writeByte(place);
        ____654.____680.send(messOut)
    },
    sendJiazuSubmit: function() {
        print("发送家族战提交");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.JIAZU_WAR_SUBMIT);
        ____654.____680.send(messOut)
    },
    sendDoushenFight: function(id, rank) {
        print("发送斗神挑战", id, rank);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.DOUSHEN_FIGTH);
        messOut.writeNumber(id);
        messOut.writeInt(rank);
        ____654.____680.send(messOut)
    },
    sendDoushenAddTime: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.DOUSHEN_TIMES);
        ____654.____680.send(messOut)
    },
    sendCifuGet: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CIFU_GET);
        ____654.____680.send(messOut)
    },
    sendXunBaoMatch: function() {
        print("寻宝撮合开始");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_XUNBAO_MATCH);
        ____654.____680.send(messOut)
    },
    sendXunBaoMatchExit: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COPY_XUNBAO_MATCH_EXIT);
        ____654.____680.send(messOut)
    },
    sendZhuoYaoMatch: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ZHUOYAO_MATCH);
        ____654.____680.send(messOut)
    },
    sendZhuoYaoMatchExit: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ZHUOYAO_MATCH_EXIT);
        ____654.____680.send(messOut)
    },
    sendZhuoYaoGetAward: function(id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.ZHUOYAO_AWARD);
        messOut.writeInt(id);
        ____654.____680.send(messOut)
    },
    sendTGHJMatch: function() {
        print("发送天宫幻境撮合");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TGHJ_MATCH);
        ____654.____680.send(messOut)
    },
    sendTGHJMatchExit: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TGHJ_MATCH_EXTI);
        ____654.____680.send(messOut)
    },
    sendTghjBox: function(boxType) {
        print("发送获取宝箱");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TGHJ_BOX);
        messOut.writeByte(boxType);
        ____654.____680.send(messOut)
    },
    sendTghjBoxTrans: function(boxType) {
        print("发送摇宝箱");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TGHJ_TRANS);
        messOut.writeByte(boxType);
        ____654.____680.send(messOut)
    },
    sendTghjBoxRefresh: function(boxType) {
        print("发送宝箱刷新");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TGHJ_REFLESH);
        messOut.writeByte(boxType);
        ____654.____680.send(messOut)
    },
    sendTghjNextFloor: function() {
        print("发送下一层");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.TGHJ_NEXT_FLOOR);
        ____654.____680.send(messOut)
    },
    sendDoushenAward: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.DOUSHEN_AWARD);
        ____654.____680.send(messOut)
    },
});
var ____2310 = KYNode.extend({
    _grid: null,
    ____1165: null,
    _countLabel: null,
    _nameLabel: null,
    ____1418: null,
    ____1544: null,
    ____1649: null,
    _sellOutIcon: null,
    _buyLabel: null,
    ____1752: null,
    _limitInfo: null,
    _limitEventFlag: false,
    ctor: function(tempInfo) {
        this._super("shopItemView.ExportJson");
        this.____1752 = tempInfo;
        var cellLayer = this.getChildByName("cellLayer");
        this._grid = new ____2129(null, null, null, true);
        this._grid.getIsShowCount(true);
        cellLayer.addChild(this._grid);
        this.____1165 = this.getChildByName("flagView");
        this._buyLabel = this.getChildByName("buyLabel");
        this._countLabel = this.getChildByName("countLabel");
        this.____1165.setVisible(false);
        this._buyLabel.setVisible(false);
        this._countLabel.setVisible(false);
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____1544 = this.getChildByName("priceLabel");
        this.____1649 = this.getChildByName("sellOutMask");
        this._sellOutIcon = this.getChildByName("sellOutIcon");
        this.____1649.setVisible(false);
        this._sellOutIcon.setVisible(false);
        this.____5();
        this.____6()
    },
    ____5: function() {
        if (this.____1752 != null) {
            this._nameLabel.setString(this.____1752.itemTemplateInfo.name);
            this._nameLabel.setColor(____655.____659.____688.getColorByQuality(this.____1752.itemTemplateInfo.quality));
            this._grid.setItemTemplateInfo(this.____1752.itemTemplateInfo);
            this._grid.setCount(this.____1752.amount);
            this.____1544.setString(this.____1752.price);
            this.____1418.setFrame(____654.____675.getMoneyPathByType(this.____1752.payType));
            if (this.____1752.isLimit) {
                this.setLimitInfoView()
            }
        } else {}
    },
    ____6: function() {
        this.addListener(this, this.____16, null, null, null, false, true);
        ____655.statInfo.addEventListener(____655.____661.stat_shopList_update, this.setLimitInfoView, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.stat_shopList_update, this.setLimitInfoView, this);
        if (this._limitInfo != null) {
            this._limitInfo.removeEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
        }
    },
    setLimitInfoView: function(evt) {
        if (this.____1752 == null || !this.____1752.isLimit) {
            return
        }
        this.____1165.setVisible(true);
        this._buyLabel.setVisible(true);
        this._countLabel.setVisible(true);
        var limitInfo = this._limitInfo;
        if (limitInfo == null) {
            limitInfo = ____655.statInfo.statShopItemList[this.____1752.id]
        }
        var count = 0;
        if (limitInfo != null) {
            count = limitInfo.hasBuyCount;
            if (!this._limitEventFlag) {
                this._limitEventFlag = true;
                this._limitInfo = limitInfo;
                this._limitInfo.addEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
            }
        }
        count = this.____1752.limitBuyCount - count;
        this._countLabel.setString(count);
        if (count <= 0) {
            this.____1649.setVisible(true);
            this._sellOutIcon.setVisible(true)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this.____1752 == null) {
                return
            }
            var count = 1;
            if (this.____1752.isLimit) {
                count = this.____1752.limitBuyCount;
                var limitInfo = ____655.statInfo.statShopItemList[this.____1752.id];
                if (limitInfo != null) {
                    count -= limitInfo.hasBuyCount
                }
                if (count <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("shopItemView.text2"));
                    return
                }
                count = Math.min(count, Math.floor(____655.____667.moneyInfo.getMoneyCountByType(this.____1752.payType) / this.____1752.price));
                if (count <= 0) {
                    this.moneyNotEnough();
                    return
                }
                ____654.____672.dispatchEvent(new ____590(____655.____661.common_showNumberPanel, ____654.____672, [1, this.____1752.itemTemplateInfo, this.____1752.price, this.____1752.payType, count, this.____1752.limitBuyCount, this, this.sendBuy, this.____1752.amount]))
            } else {
                if (____655.____667.moneyInfo.moneyEnoughByType(this.____1752.payType, this.____1752.price)) {
                    ____654.____672.dispatchEvent(new ____590(____655.____661.common_showNumberPanel, ____654.____672, [1, this.____1752.itemTemplateInfo, this.____1752.price, this.____1752.payType, 1, 0, this, this.sendBuy, this.____1752.amount]))
                } else {
                    this.moneyNotEnough()
                }
            }
        }
    },
    sendBuy: function(count) {
        if (____655.____667.moneyInfo.moneyEnoughByType(this.____1752.payType, this.____1752.price * count)) {
            print("购买商品，", this.____1752.id, count);
            ____654.statMessageSender.sendShopBuy(this.____1752.id, count)
        } else {
            this.moneyNotEnough()
        }
    },
    moneyNotEnough: function() {
        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("shopItemView.text1", ____655.____667.moneyInfo.getMoneyNameByType(this.____1752.payType)))
    },
    setCount: function(count) {
        if (count == -1) {
            this.____1165.setVisible(false);
            this._buyLabel.setVisible(false);
            this._countLabel.setVisible(false)
        } else {
            this.____1165.setVisible(true);
            this._buyLabel.setVisible(true);
            this._countLabel.setVisible(true);
            this._countLabel.setString(count.toString())
        }
    },
    dispose: function() {
        this.____17();
        if (this._grid != null) {
            this._grid.dispose();
            this._grid = null
        }
        this._super();
        this.____1165 = null;
        this._countLabel = null;
        this._nameLabel = null;
        this.____1418 = null;
        this.____1544 = null;
        this.____1649 = null;
        this._sellOutIcon = null;
        this._limitEventFlag = null;
        this._limitInfo = null;
        this._buyLabel = null
    },
});
var ShopPanel = KYPanel.extend({
    _controller: null,
    _moneyView: null,
    _tileContainer: null,
    _type: -1,
    ____1758: null,
    ____891: null,
    ____1629: null,
    ctor: function(controller) {
        this._super("shopPanel.ExportJson");
        this._controller = controller;
        this.____1758 = [];
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(1);
        moneyLayer.addChild(this._moneyView);
        this.____891 = [];
        var titleList = [____654.yuyanbaoManager.getYuyanbao("shop.title1"), ____654.yuyanbaoManager.getYuyanbao("shop.title2"), ____654.yuyanbaoManager.getYuyanbao("shop.title3")];
        var count = 0;
        for (var i = 0; i < titleList.length; i++) {
            var btn = new ____2143();
            btn.setLabel(titleList[i]);
            btn.addListener(this, this.tabClickHandler);
            btn.setPosition(____654.____673.____159(939, 496 - 102 * count));
            this.addChild(btn, 10 + count);
            count++;
            this.____891.push(btn)
        }
        this._tileContainer = this.getChildByName("itemLayer__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this)
    },
    showType: function(type) {
        if (this._type == type) {
            return
        }
        this._type = type;
        this.____1758 = ____655.allTemplates.shopTemplateList.getShopTempListByType(this._type);
        this._tileContainer.clearAllItems();
        this._tileContainer.setFormat(2, this.____1758.length, ____654.____673.____160(279, 243), 3, 8, true)
    },
    tabClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            for (var i = 0; i < this.____891.length; i++) {
                if (sender == this.____891[i]) {
                    this.setBtnSelect(i);
                    return
                }
            }
        }
    },
    setBtnSelect: function(index) {
        if (this.____1629 != null) {
            this.____1629.setSelected(false)
        }
        this.____1629 = this.____891[index];
        if (this.____1629 != null) {
            this.____1629.setSelected(true);
            if (this.____1629 == this.____891[0]) {
                this.showType(____655.allTemplates.shopTemplateList.shopType_1)
            } else if (this.____1629 == this.____891[1]) {
                this.showType(____655.allTemplates.shopTemplateList.shopType_3)
            } else if (this.____1629 == this.____891[2]) {
                this.showType(____655.allTemplates.shopTemplateList.shopType_2)
            }
        }
    },
    getItemByIndex: function(index) {
        var tempInfo = this.____1758[index];
        if (tempInfo != null) {
            return new ____2310(tempInfo)
        }
        return null
    },
    getIdByIndex: function(index) {
        if (this.____1758[index] == null) {
            return -1
        }
        return this.____1758[index].id
    },
    dispose: function() {
        this._controller = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this._tileContainer = null;
        this.____1629 = null;
        if (this.____891 != null) {
            for (var i = 0; i < this.____891.length; i++) {
                this.____891[i].dispose()
            }
            this.____891 = null
        }
        this._super()
    },
});
var ____573 = cc.Class.extend({
    shopModule: null,
    ctor: function(shopModule) {
        this.shopModule = shopModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    ____265: function(type) {
        if (this.shopModule.shopPanel == null) {
            this.shopModule.shopPanel = new ShopPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.shopModule.shopPanel, type);
        this.shopModule.shopPanel.setBtnSelect(0)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.shopModule.shopPanel) {
            this.shopModule.shopPanel = null
        }
    },
});
var ____574 = ____537.extend({
    shopController: null,
    shopPanel: null,
    setup: function(data) {
        this.shopController = new ____573(this);
        this.____151(data)
    },
    ____151: function(data) {
        this.shopController.____265(data[0])
    },
    clear: function() {},
});
var ____581 = cc.Class.extend({
    startModule: null,
    ____1685: false,
    ____1754: false,
    ____1098: false,
    ctor: function(startModule) {
        this.startModule = startModule;
        this.____271();
        this.____6()
    },
    ____6: function() {
        ____655.____663.addEventListener(____655.____661.____699, this.____281, this);
        ____655.____663.addEventListener(____655.____661.start_clearAllView, this.clearAllView, this);
        ____654.____672.addEventListener(____655.____661.global_sdkLoginSuccess, this.sdkLoginSuccess, this);
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    ____17: function() {},
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.startModule.startLoginView) {
            this.startModule.startLoginView = null
        } else if (p == this.startModule.selectRolePanel) {
            this.startModule.selectRolePanel = null
        } else if (p == this.startModule.startServerPanel) {
            this.startModule.startServerPanel = null
        } else if (p == this.startModule.createRolePanel) {
            this.startModule.createRolePanel = null
        } else if (p == this.startModule.deleteRolePanel) {
            this.startModule.deleteRolePanel = null
        }
    },
    ____271: function() {
        var this_ = this;
        var path = ____654.____675.____134();
        var ui1Complete = false;

        function uiDataComplete(loader) {
            ____655.uiDataListII.____291(loader.data);
            ui1Complete = true;
            ____116()
        }

        function ____116() {
            if (ui1Complete) {
                this_.loadUIImage();
                ____654.____677.removeBinaryQuote(path, this_)
            }
        }
        ____654.____677.loadBinary(path, uiDataComplete, this, ____655.____659.commonStaticType.source_clearImmedia)
    },
    loadUIImage: function() {
        var this_ = this;
        var ui1Complete = false;
        var ui2Complete = false;
        var ui3Complete = false;

        function uiImageComplete1() {
            ui1Complete = true;
            uiImageComplete()
        }

        function uiImageComplete2() {
            ui2Complete = true;
            uiImageComplete()
        }

        function bgImageComplete3() {
            ui3Complete = true;
            ____654.____677.removeImageQuote(path3, this);
            uiImageComplete()
        }

        function uiImageComplete() {
            if (ui1Complete && ui2Complete && ui3Complete) {
                ____654.____676.setupUIPanel();
                ____654.____680.close();
                this_.____273()
            }
        }
        var path = ____654.____675.getUIPlistPath();
        ____654.____677.____147(path, uiImageComplete1, this);
        var path2 = ____654.____675.____139("outPic/skillPack.png");
        ____654.____677.____147(path2, uiImageComplete2, this);
        var path3 = ____654.____675.getPlatFromPath(____655.sources, "loginBg.png");
        ____654.____677.____148(path3, bgImageComplete3, this)
    },
    ____277: function() {
        var this_ = this,
            path = ____654.____675.____136();

        function parseTempComplete() {
            print("模版解析成功");
            this_.____1754 = true;
            this_.____116();
            ____654.____677.removeBinaryQuote(path, this_)
        };

        function templateComplete(loaderInfo) {
            var data = loaderInfo.data;
            print("模板表加载成功");
            try {
                ____654.____681.start(data, parseTempComplete)
            } catch (err) {
                print("解析模版表出错", err);
                ____655.getAlert().show(1, "解析模版表出错" + err)
            }
        };
        ____654.____677.loadBinary(path, templateComplete, this, ____655.____659.commonStaticType.source_clearImmedia)
    },
    preLoadStart: function() {
        ____654.firstPreLoad.loadStart()
    },
    ____276: function() {
        var this_ = this,
            path = ____654.____675.____137();

        function descripComplete(loaderInfo) {
            print("描述表加载成功");
            var data = loaderInfo.data;
            this_.____1098 = true;
            try {
                ____654.____682.init(data)
            } catch (err) {
                print("解析描述表出错：", err);
                ____655.getAlert().show(1, "解析描述表出错：" + err)
            }
            this_.____116();
            ____654.____677.removeBinaryQuote(path, this_)
        };
        ____654.____677.loadBinary(path, descripComplete, this, ____655.____659.commonStaticType.source_clearImmedia)
    },
    ____275: function(server, name) {
        ____654.panelQuote.showLoading("loginServer");
        if (____655.gameConfig.isNoSdkOrTestSdk()) {
            ____655.____663.userName = name
        }
        ____655.____663.serverId = server.id;
        ____655.____663.serverName = server.name();
        var this_ = this;
        server.getIPPort(function(ip, port) {
            if (____655.gameConfig.isNoSdkOrTestSdk()) {
                ____654.sdk.setLocalUserId(name);
                ____654.sdk.setLocalServer(server.getAreaId(), server.id)
            }
            ip = ____654.sdk.chgHostToIp(ip);
            ____655.____663.ip = ip;
            ____655.____663.port = port;
            ____655.lowValue = parseInt(server.lowValue);
            ____655.selfRankPos = parseInt(server.selfRankPos);
            ____655.totalRank = parseInt(server.totalRank);
            ____655.____663.uploadLastServer();
            if (____655.selfRankPos == 0) {
                this_.____278()
            } else {
                this_.showLoginQueuingPanel(this_, name)
            }
        })
    },
    ____273: function() {
        if (____654.____676.____1182.clearUpdateView != null) {
            ____654.____676.____1182.clearUpdateView()
        }
        if (this.startModule.startLoginView == null) {
            this.startModule.startLoginView = new ____583(this)
        }
        ____654.____676.____125(this.startModule.startLoginView);
        ____654.____676.hideBack()
    },
    loadTempAndDes: function() {
        if (!this.____1754) {
            this.____277()
        }
        if (!this.____1098) {
            this.____276()
        }
    },
    ____274: function() {
        if (this.startModule.startLoginView != null) {
            this.startModule.startLoginView.dispose()
        }
    },
    doSdkLogin: function() {
        var this_ = this;

        function tipErrorAndConnect(tips) {
            ____655.getAlert().show(1, "登录失败：" + tips, null, null, this_, this_.doSdkLogin)
        }

        function formatParam(vals) {
            return vals.replace(/\n/g, "\\n").replace(/\t/g, "\\t").replace(/\r/g, "\\r")
        }
        if (!____655.____663.dataComplete || !____654.sdk.userCenter()) {
            ____654.sdk.showLogin(function(ret, vals) {
                print("#doSdkLogin", ret, vals);
                if (ret) {
                    var suffix = ____654.sdk.getSdkSuffix(),
                        url = ____655.gameConfig.loginUrl + suffix + ".php?" + formatParam(unescape(vals));
                    print("#login url", url);
                    ____654.____677.loadRemoteTxt(url, function(loader) {
                        var ret = loader.data,
                            json = JSON.parse(ret || "{}");
                        print("#ret", ret);
                        if (parseInt(json.rs) != 1) {
                            tipErrorAndConnect(json.msg || "未知空返回")
                        } else {
                            var jsonData = json.data;
                            ____655.____663.parseUserInfo(jsonData)
                        }
                    })
                } else {
                    tipErrorAndConnect("sdk失败");
                    print("#登录失败？重试？")
                }
            })
        }
    },
    showSelectServerView: function() {
        if (____655.____663.isLoaded()) {
            this.doShowServerView()
        } else {
            var this_ = this,
                canPost = false;
            if (____655.gameConfig.isNoSdkOrTestSdk()) {
                canPost = true
            } else if (____655.____663.dataComplete) {
                canPost = true
            }
            if (canPost) {
                ____654.panelQuote.showLoading("loadServerList");
                this.doPostURL(function() {
                    ____654.panelQuote.hideLoading("loadServerList");
                    this_.doShowServerView()
                }, this.startModule.startLoginView.getUserId(), this)
            }
        }
    },
    doPostURL: function(callback, userId, cbTarget) {
        var path = ____655.gameConfig.getServerUrl(userId || "kuyou");
        print("#load server list: " + path);
        ____654.____677.loadRemoteTxt(path, function(loader) {
            var jsonReturn = JSON.parse(loader.data);
            if (!!jsonReturn && jsonReturn.rs == "1") {
                var jsonData = jsonReturn.data;
                ____655.____663.parseServerList(jsonData, true)
            }
            if (!!callback) {
                callback.call(cbTarget)
            }
        })
    },
    doShowServerView: function() {
        if (this.startModule.startServerPanel == null) {
            this.startModule.startServerPanel = new ____2320(this)
        }
        ____654.____676.____125(this.startModule.startServerPanel)
    },
    hideSelectServerView: function() {
        if (this.startModule.startServerPanel != null) {
            this.startModule.startServerPanel.dispose()
        }
    },
    showCreateRolePanel: function() {
        if (this.startModule.createRolePanel == null) {
            this.startModule.createRolePanel = new ____2317(this)
        }
        ____654.____676.____125(this.startModule.createRolePanel);
        ____654.____676.hideBack()
    },
    hideCreateRolePanel: function() {
        if (this.startModule.createRolePanel != null) {
            this.startModule.createRolePanel.dispose()
        }
    },
    showChoiseRolePanel: function() {
        if (this.startModule.selectRolePanel == null) {
            this.startModule.selectRolePanel = new ____2316(this)
        }
        ____654.____676.____125(this.startModule.selectRolePanel);
        ____654.____676.hideBack()
    },
    hideChoiseRolePanel: function() {
        if (this.startModule.selectRolePanel != null) {
            this.startModule.selectRolePanel.dispose()
        }
    },
    ____278: function() {
        ____654.____680.setCallbacks(this.____279, this.closeCallback, this.____280, this);
        try {
            print("连接服务器:", ____655.____663.serverName, ____655.____663.ip, ____655.____663.port);
            ____654.____680.connect(____655.____663.ip, ____655.____663.port)
        } catch (err) {
            ____654.panelQuote.hideLoading("loginServer");
            ____655.getAlert().show(1, "连接服务器出错:" + err);
            print("连接服务器出错:", err)
        }
    },
    ____279: function() {
        print("连接成功");
        ____654.____680.setIsInSpecialPanel(false);
        this.____1685 = true;
        this.____116()
    },
    ____280: function() {
        ____654.panelQuote.hideLoading("loginServer");
        print("连接失败");
        ____654.____680.setIsInSpecialPanel(false);
        ____655.getAlert().show(1, "连接服务器失败，请重新连接", null, 0, this, this.closeConfirm)
    },
    closeCallback: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_afkUpdate, ____654.____672, false));
        ____654.____672.dispatchEvent(new ____590(____655.____661.trigger_walkStop, ____654.____672));
        ____654.____672.dispatchEvent(new ____590(____655.____661.global_socketClose, ____654.____672));
        ____654.panelQuote.hideLoading("loginServer");
        print("断开连接");
        ____654.____680.setIsInSpecialPanel(false);
        if (____655.isLogout == false) {
            var type = "";
            if (____655.logoutType != null) {
                type = "(" + ____655.logoutType + ")"
            }
            ____655.getAlert().show(1, "服务器连接断开，请重新连接" + type, null, 0, this, this.closeConfirm)
        } else {
            ____654.____679.____155(____655.____659.____690.startLib);
            ____655.isLogout = false
        }
    },
    closeConfirm: function() {
        this.____278()
    },
    ____116: function() {
        if (this.____1685 && this.____1754 && this.____1098) {
            ____654.clearAll();
            ____654.____683.____194()
        }
    },
    ____281: function(evt) {
        var path = "";
        if (____655.____663.roleList.length == 0) {
            path = ____654.____675.____139("outPic/roleCreateBg.png")
        } else {
            path = ____654.____675.____139("outPic/roleSelectBg.png")
        }

        function loadBgImageComplete() {
            ____654.____677.removeImageQuote(path, this);
            ____654.panelQuote.hideLoading("loginServer");
            ____654.____676.____129();
            ____654.____672.dispatchEvent(new ____590(____655.____661.____698, ____654.____672, null));
            if (____655.____663.roleList.length == 0) {
                this.showCreateRolePanel()
            } else {
                this.showChoiseRolePanel()
            }
            this.preLoadStart()
        }
        ____654.____677.____148(path, loadBgImageComplete, this)
    },
    showDeleteRolePanel: function(userId) {
        if (userId <= 0) {
            return
        }
        if (this.startModule.deleteRolePanel == null) {
            this.startModule.deleteRolePanel = new DeleteRolePanel(userId, this)
        }
        ____654.____676.____125(this.startModule.deleteRolePanel)
    },
    hideDeleteRolePanel: function() {
        if (this.startModule.deleteRolePanel != null) {
            this.startModule.deleteRolePanel.dispose()
        }
    },
    showLoginQueuingPanel: function(controller, userId) {
        ____654.panelQuote.hideLoading("loginServer");
        if (this.startModule.loginQueuingPanel == null) {
            this.startModule.loginQueuingPanel = new LoginQueuingPanel(controller, userId)
        }
        ____654.____676.____125(this.startModule.loginQueuingPanel)
    },
    hideLoginQueuingPanel: function() {
        if (this.startModule.loginQueuingPanel != null) {
            this.startModule.loginQueuingPanel.dispose();
            this.startModule.loginQueuingPanel = null
        }
    },
    clearAllView: function() {
        this.____274();
        this.hideSelectServerView();
        this.hideCreateRolePanel();
        this.hideChoiseRolePanel();
        this.hideDeleteRolePanel();
        ____654.____676.showBack()
    },
    sdkLoginSuccess: function() {},
});
var ____582 = ____537.extend({
    startController: null,
    startLoginView: null,
    selectRolePanel: null,
    createRolePanel: null,
    startServerPanel: null,
    deleteRolePanel: null,
    loginQueuingPanel: null,
    setup: function(data) {
        this.startController = new ____581(this);
        this.____151(data)
    },
    ____151: function(data) {
        print("enter start module", ____655.uiDataListII.isComplete());
        if (____655.uiDataListII.isComplete()) {
            this.startController.____273()
        }
    },
    clear: function() {
        if (this.startLoginView != null) {
            this.startLoginView.dispose();
            this.startLoginView = null
        }
        if (this.selectRolePanel != null) {
            this.selectRolePanel.dispose();
            this.selectRolePanel = null
        }
        if (this.createRolePanel != null) {
            this.createRolePanel.dispose();
            this.createRolePanel = null
        }
        if (this.startServerPanel != null) {
            this.startServerPanel.dispose();
            this.startServerPanel = null
        }
    },
});
var DeleteRolePanel = Alert.extend({
    _controller: null,
    _label: null,
    _inputController: null,
    _inputBg: null,
    ____1835: 0,
    ctor: function(userId, controller) {
        this._super();
        this.____1835 = userId;
        this._controller = controller;
        this.setType(0);
        this._label = ____654.____673.newKYLabel();
        this._label.setAnchorPoint(____654.____673.anchorPoints[1]);
        this._label.setPosition(____654.____673.____159(26, 272));
        this._label.setString(____654.yuyanbaoManager.getYuyanbao("start.loginTips5", ____654.yuyanbaoManager.getYuyanbao("start.loginTips6")));
        this.addChild(this._label, 9);
        this._inputBg = ____654.____673.newKYImageView();
        this._inputBg.setScale9Enabled(true);
        this._inputBg.setCapInsets(____654.____673.____161(51, 18, 1, 1));
        this._inputBg.setSize(____654.____673.____160(210, 36));
        this._inputBg.setAnchorPoint(____654.____673.anchorPoints[1]);
        this._inputBg.setFrame("board/ui_board11.png");
        this._inputBg.setPosition(____654.____673.____159(26, 198));
        this.addChild(this._inputBg, 8);
        this._inputController = new InputLabelController(____654.____673.____159(31, 183), ____654.____673.____160(200, 28), this, 12, 20);
        this.____893.setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips3"));
        this.____894.setString(____654.yuyanbaoManager.getYuyanbao("alert.btnTips4"))
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____886) {
                var str = this._inputController.getString();
                if (str == ____654.yuyanbaoManager.getYuyanbao("start.loginTips6")) {
                    ____654.____683.sendAccountDeleteMessage(this.____1835);
                    if (this._controller.startModule.selectRolePanel != null) {
                        var list = ____655.____663.roleList;
                        for (var i = 0; i < list.length; i++) {
                            if (list[i].userId == this.____1835) {
                                list.splice(i, 1);
                                break
                            }
                        }
                        this._controller.startModule.selectRolePanel.____5();
                        this._controller.hideDeleteRolePanel()
                    }
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("start.loginTips7", ____654.yuyanbaoManager.getYuyanbao("start.loginTips6")))
                }
            } else if (sender == this.____887) {
                this._controller.hideDeleteRolePanel()
            }
        }
    },
    dispose: function() {
        this._controller = null;
        if (this._inputController != null) {
            this._inputController.dispose();
            this._inputController = null
        }
        if (this._label != null) {
            this._label.dispose();
            this._label = null
        }
        if (this._inputBg != null) {
            this._inputBg.dispose();
            this._inputBg = null
        }
        this._super()
    },
});
var LoginQueuingPanel = KYPanel.extend({
    _tittleName: null,
    ____1480: null,
    ____1482: null,
    _overContent1: null,
    _overContent2: null,
    _closeBtn: null,
    _waitingPanel: null,
    _numLabel: null,
    _queuingNumLabel: null,
    _queuingTimeLabel: null,
    count: 0,
    count1: 0,
    num: 0,
    queuingNum: 0,
    lowNum: 0,
    remainTime: 0,
    jumpNums: 0,
    btnCount: 0,
    btnTime: 5,
    rangeA: 50,
    rangeB: 30,
    _controller: null,
    ____1835: "",
    ctor: function(controller, userId) {
        this._super("loginQueuingPanel.ExportJson");
        this._controller = controller;
        this.____1835 = userId;
        this._tittleName = this.getChildByName("titleName");
        this._tittleName.setString("登录排队");
        this.____1480 = this.getChildByName("OKBtn__1");
        this.____1482 = this.getChildByName("btnLabel");
        this.____1482.setString("我要优先");
        this._overContent1 = this.getChildByName("overContent1");
        this._overContent1.setString("本服务器已经爆满.........");
        this._overContent2 = this.getChildByName("overContent2");
        this._overContent2.setString("请稍后再试，或重新选择其他服务器进行登录");
        this._closeBtn = this.getChildByName("closeBtn");
        this.getChildByName("content1").setString("当前服务器用户过多，正在排队等候进入");
        this.getChildByName("content2").setString("共");
        this.getChildByName("content3").setString("位玩家等候中，您排在");
        this.getChildByName("content4").setString("位");
        this.getChildByName("content5").setString("预计排队时间");
        this.getChildByName("content6").setString("秒... ...");
        this._numLabel = this.getChildByName("numLabel");
        this._queuingNumLabel = this.getChildByName("queuingNumLabel");
        this._queuingTimeLabel = this.getChildByName("queuingTimeLabel");
        this.lowNum = ____655.lowValue;
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.num = Math.ceil(____655.selfRankPos * (Math.random() * 0.4 + 0.8));
        if (this.num >= 99999) {
            this._waitingPanel.setVisible(false);
            this._overContent1.setVisible(true);
            this._overContent2.setVisible(true)
        } else {
            this._waitingPanel.setVisible(true);
            this._overContent1.setVisible(false);
            this._overContent2.setVisible(false)
        }
        this.remainTime = Math.floor(this.num / this.lowNum);
        this.queuingNum = Math.ceil(____655.totalRank * (Math.random() * 0.4 + 0.8)) + this.num;
        this._numLabel.setString(this.num);
        this._queuingNumLabel.setString(this.queuingNum);
        this._queuingTimeLabel.setString(this.remainTime);
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this.count = this.count + 1;
        this.count1 = this.count1 + 1;
        if (this.count1 >= 60) {
            this.count1 = 0;
            this.remainTime = this.remainTime - 1;
            if (this.remainTime <= 0) {
                this.remainTime = 0;
                this._queuingTimeLabel.setString(this.remainTime);
                ____654.____678.____299(this.tick, this);
                this._controller.____278();
                this._controller.hideLoginQueuingPanel()
            } else {
                this._queuingTimeLabel.setString(this.remainTime)
            }
        }
        if (this.count >= 120) {
            this.count = 0;
            this.num = this.num - Math.ceil(this.lowNum * (Math.random() * 0.4 + 0.8));
            this.queuingNum = this.queuingNum + Math.ceil(this.lowNum / 3 * (Math.random() * 0.4 + 0.8));
            if (this.num <= 0) {} else {
                this._numLabel.setString(this.num);
                this._queuingNumLabel.setString(this.queuingNum)
            }
        }
    },
    btnTick: function(delta, count) {
        this.btnCount++;
        if (this.btnCount >= 60) {
            this.btnTime--;
            this.btnCount = 0
        }
        if (this.btnTime <= 0) {
            this.btnTime = 5;
            ____654.____678.____299(this.btnTick, this);
            ____654.____674.setKYBtnEnabled(this.____1480, true, 1)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1480) {
                var c = this.rangeA - this.rangeB + 1;
                this.jumpNums = Math.floor(Math.random() * c + this.rangeB);
                this.num = this.num - this.jumpNums;
                this.remainTime = Math.floor(this.num / this.lowNum);
                ____654.____674.setKYBtnEnabled(this.____1480, false, 0);
                ____654.____678.____298(this.btnTick, this)
            } else if (sender == this._closeBtn) {
                this._controller.hideLoginQueuingPanel()
            }
        }
    },
    ____6: function() {
        this.____1480.addListener(this, this.____16);
        this._closeBtn.addListener(this, this.____16)
    },
    ____17: function() {},
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tick, this);
        ____654.____678.____299(this.btnTick, this);
        this._tittleName = null;
        this.____1480 = null;
        this.____1482 = null;
        this._controller = null;
        this._overContent1 = null;
        this._overContent2 = null;
        this._closeBtn = null;
        this._waitingPanel = null;
        this._numLabel = null;
        this._queuingNumLabel = null;
        this._queuingTimeLabel = null;
        this.count = null;
        this.count1 = null;
        this.num = null;
        this.queuingNum = null;
        this.lowNum = null;
        this.remainTime = null;
        this.jumpNums = null;
        this.btnCount = null;
        this.btnTime = null;
        this.rangeA = null;
        this.rangeB = null;
        this._super()
    }
});
var ____2315 = KYNode.extend({
    _controller: null,
    ____1027: null,
    ____1603: null,
    ____1093: null,
    ____1459: null,
    _levelLabel: null,
    ____927: null,
    ____1881: null,
    _roleInfo: null,
    ctor: function(info, controller) {
        this._controller = controller;
        this._roleInfo = info;
        this._super("selectRoleItem.ExportJson");
        this.____1027 = this.getChildByName("createLabel");
        this.____1603 = this.getChildByName("roleLayer");
        this.____1093 = this.____1603.getChildByName("delBtn");
        this.____1459 = this.____1603.getChildByName("nickLabel");
        this._levelLabel = this.____1603.getChildByName("levelLabel");
        this.____1881 = this.____1603.getChildByName("xianweiLabel");
        this.____927 = this.____1603.getChildByName("careerIcon");
        this.____6();
        this.____5()
    },
    ____5: function() {
        if (this._roleInfo == null) {
            this.____1603.setVisible(false)
        } else {
            this.____1027.setVisible(false);
            this.____1459.setString(this._roleInfo.nickName);
            this._levelLabel.setString(this._roleInfo.level.toString());
            this.____1881.setString(____655.____659.nameType.getXianweiName(this._roleInfo.xianwei));
            this.____927.setFrame("sceneIcon/PlayerHeadIcon2_" + this._roleInfo.career.toString() + ".png");
            if (this._roleInfo.level >= 50) {
                this.____1093.setVisible(false)
            }
        }
    },
    ____6: function() {
        this.____1093.addListener(this, this.____248)
    },
    ____17: function() {},
    ____248: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1093) {
                this._controller.showDeleteRolePanel(this._roleInfo.userId)
            }
        }
    },
    getUserId: function() {
        if (this._roleInfo == null) return null;
        return this._roleInfo.userId
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1603 = null;
        this.____1093 = null;
        this.____927 = null;
        this.____1881 = null;
        this.____1459 = null;
        this._levelLabel = null;
        this.____1027 = null;
        this._roleInfo = null;
        this._super()
    },
});
var ____2316 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    ____1135: null,
    ____1136: null,
    ____855: null,
    ____1128: null,
    ____1285: null,
    ____1631: null,
    ____1633: null,
    ____1522: null,
    _itemList: null,
    ____1527: null,
    ____1637: -2,
    ctor: function(controller) {
        this._super("selectRolePanel.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this.____1135 = this.getChildByName("enterBtn");
        this.____855 = this.getChildByName("backBtn");
        this.____1128 = this.getChildByName("effectLayer");
        this.____1522 = this.getChildByName("playerImg");
        this.____1631 = this.getChildByName("selectedIcon");
        this.____1285 = this.getChildByName("itemLayer");
        this._bgPath = ____654.____675.____139("outPic/roleSelectBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1633 = ____654.____675.____139("outPic/ui_selected.png");
        ____654.____677.____146(this.____1631, this.____1633);
        this.____1136 = ____654.____675.____139("outPic/loginBtn.png");
        ____654.____677.____146(this.____1135, this.____1136);
        this.____5();
        this.____6();
        if (____654.useTry()) {
            new MemoryTester(this).setP(____654.____673.____159(500, 300))
        }
    },
    ____5: function() {
        this.clearItems();
        this._itemList = [];
        var list = ____655.____663.roleList;
        var len = list.length;
        var index = -1;
        var level = 0;
        for (var i = 0; i < len; i++) {
            this.createItem(list[i], i);
            if (list[i].level > level) {
                level = list[i].level;
                index = i
            }
        }
        if (len < 3) {
            this.createItem(null, len)
        }
        this.selectIndex(index)
    },
    createItem: function(info, index) {
        var item = new ____2315(info, this._controller);
        item.setPositionY(256 - 128 * index);
        item.addListener(this, this.itemClickHandler);
        this.____1285.addChild(item);
        this._itemList.push(item)
    },
    ____6: function() {
        this.____855.addListener(this, this.____16);
        this.____1135.addListener(this, this.____16)
    },
    ____17: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____855) {
                this._controller.____273();
                this._controller.hideChoiseRolePanel()
            } else if (sender == this.____1135) {
                if (this.____1637 < 0) {
                    this._controller.showCreateRolePanel();
                    this._controller.hideChoiseRolePanel()
                } else {
                    ____654.____683.____195(this._itemList[this.____1637].getUserId())
                }
            }
        }
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender.getUserId() == null) {
                this._controller.showCreateRolePanel();
                this._controller.hideChoiseRolePanel()
            } else {
                this.selectIndex(this._itemList.indexOf(sender))
            }
        }
    },
    selectIndex: function(index) {
        if (this.____1637 == index) {
            return
        }
        this.____1637 = index;
        if (index < 0) {
            this.____1631.setVisible(false);
            this.____1522.setVisible(false)
        } else {
            this.____1631.setVisible(true);
            this.____1522.setVisible(true);
            this.____1631.setPositionY(475 - 128 * index);
            var path = ____654.____675.____139("outPic/roleImg" + ____655.____663.roleList[index].career + ".png");
            if (this.____1527 == path) {
                return
            }
            if (this.____1527 != null) {
                ____654.____677.removeImageQuote(this.____1527, this.____1522)
            }
            this.____1527 = path;
            ____654.____677.____146(this.____1522, this.____1527)
        }
    },
    clearItems: function() {
        if (this._itemList != null) {
            var len = this._itemList.length;
            for (var i = 0; i < len; i++) {
                this._itemList[i].dispose()
            }
            this._itemList = null
        }
    },
    dispose: function() {
        this.____17();
        this._super();
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this.clearItems();
        if (this.____1136 != null) {
            ____654.____677.removeImageQuote(this.____1136, this.____1135);
            this.____1136 = null
        }
        this.____1135 = null;
        this._controller = null;
        this.____855 = null;
        this.____1128 = null;
        this.____1285 = null;
        if (this.____1633 != null) {
            ____654.____677.removeImageQuote(this.____1633, this.____1631);
            this.____1633 = null
        }
        this.____1631 = null;
        if (this.____1527 != null) {
            ____654.____677.removeImageQuote(this.____1527, this.____1522);
            this.____1527 = null
        }
    },
});
var ____2317 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    ____1599: null,
    ____1600: null,
    ____1575: null,
    _nameLabel: null,
    ____1135: null,
    ____1136: null,
    ____855: null,
    _tipsLabel: null,
    ____1601: null,
    ____1602: null,
    ____1604: null,
    ____1605: null,
    ____1128: null,
    _inputNameController: null,
    ____1034: 0,
    ____1576: null,
    ____1558: null,
    ____1559: null,
    ____1561: null,
    ____1562: null,
    ctor: function(controller) {
        this._super("startCreatePanel.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1575 = this.getChildByName("randomBtn");
        this.____855 = this.getChildByName("backBtn");
        this.____1135 = this.getChildByName("enterBtn");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____1601 = this.getChildByName("roleImg1");
        this.____1602 = this.getChildByName("roleImg2");
        this.____1599 = this.getChildByName("roleBtn1");
        this.____1600 = this.getChildByName("roleBtn2");
        this.____1128 = this.getChildByName("effectLayer");
        var this_ = this;

        function imgComplate() {
            if (this_.____1034 == 1) {
                this_.____1601.setColor(____655.____659.____688.white);
                this_.____1602.setColor(____655.____659.____688.smoke)
            } else if (this_.____1034 == 2) {
                this_.____1601.setColor(____655.____659.____688.smoke);
                this_.____1602.setColor(____655.____659.____688.white)
            }
        };
        this._bgPath = ____654.____675.____139("outPic/roleCreateBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____1604 = ____654.____675.____139("outPic/roleImg1.png");
        ____654.____677.____146(this.____1601, this.____1604, imgComplate);
        this.____1605 = ____654.____675.____139("outPic/roleImg2.png");
        ____654.____677.____146(this.____1602, this.____1605, imgComplate);
        this.____1136 = ____654.____675.____139("outPic/loginBtn.png");
        ____654.____677.____146(this.____1135, this.____1136);
        this.____1558 = new PropController();
        this.____1558.addInfo(new PropInfo(this.____1601, 5, 0, 0.8, 1, 0.02, 0));
        this.____1559 = new PropController();
        this.____1559.addInfo(new PropInfo(this.____1601, 5, 0, 1, 0.8, -0.02, 0));
        this.____1561 = new PropController();
        this.____1561.addInfo(new PropInfo(this.____1602, 5, 0, 0.8, 1, 0.02, 0));
        this.____1562 = new PropController();
        this.____1562.addInfo(new PropInfo(this.____1602, 5, 0, 1, 0.8, -0.02, 0));
        this._inputNameController = new InputLabelController(this._nameLabel.getPosition(), this._nameLabel.getDimensions(), this, 15, 20, ____654.yuyanbaoManager.getYuyanbao("start.loginTips2"));
        this.____6();
        this.setCareer(Math.floor(Math.random(0, 1) + 1.5))
    },
    ____6: function() {
        this.____1575.addListener(this, this.____16);
        this.____855.addListener(this, this.____16);
        this.____1135.addListener(this, this.____16);
        this.____1599.addListener(this, this.____16);
        this.____1600.addListener(this, this.____16)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1575) {
                this.setRandomName()
            } else if (sender == this.____855) {
                this._controller.showChoiseRolePanel();
                this._controller.hideCreateRolePanel()
            } else if (sender == this.____1135) {
                var name = this._inputNameController.getString();
                if (name == null || name == "") {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("start.loginTips3"));
                    return
                }
                var nameLen = ____655.wordFiltersInfo.getStringLen(name);
                if (nameLen < 4 || nameLen > 10) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("start.loginTips3"));
                    return
                }
                if (____655.wordFiltersInfo.checkName(name)) {
                    ____654.panelQuote.showLoading("createRole");
                    ____654.____683.sendAccountRoleCreate(____655.____663.serverId, name, this.____1034)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("start.loginTips8"))
                }
            } else if (sender == this.____1599) {
                this.setCareer(1)
            } else if (sender == this.____1600) {
                this.setCareer(2)
            }
        }
    },
    setCareer: function(career) {
        if (this.____1034 == career) {
            return
        };
        this.____1034 = career;
        if (this.____1576 == null || this.____1576 == this._inputNameController.getString()) {
            this.setRandomName()
        }
        if (career == 1) {
            this.____1601.setColor(____655.____659.____688.white);
            this.____1602.setColor(____655.____659.____688.smoke);
            this.____1558.pStart();
            this.____1559.pEnd();
            this.____1561.pEnd();
            this.____1562.pStart()
        } else if (career == 2) {
            this.____1601.setColor(____655.____659.____688.smoke);
            this.____1602.setColor(____655.____659.____688.white);
            this.____1558.pEnd();
            this.____1559.pStart();
            this.____1561.pStart();
            this.____1562.pEnd()
        }
    },
    ____17: function() {},
    setRandomName: function() {
        this.____1576 = ____655.randomNameInfo.getName(this.____1034);
        this._inputNameController.setString(this.____1576)
    },
    dispose: function() {
        this.____17();
        this.____1558.dispose();
        this.____1558 = null;
        this.____1559.dispose();
        this.____1559 = null;
        this.____1561.dispose();
        this.____1561 = null;
        this.____1562.dispose();
        this.____1562 = null;
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this.____1136 != null) {
            ____654.____677.removeImageQuote(this.____1136, this.____1135);
            this.____1136 = null
        }
        this.____1135 = null;
        if (this.____1604 != null) {
            ____654.____677.removeImageQuote(this.____1604, this.____1601);
            this.____1604 = null
        }
        this.____1601 = null;
        if (this.____1605 != null) {
            ____654.____677.removeImageQuote(this.____1605, this.____1602);
            this.____1605 = null
        }
        this.____1602 = null;
        this._controller = null;
        this.____1599 = null;
        this.____1600 = null;
        this.____1575 = null;
        this._nameLabel = null;
        this.____855 = null;
        this._tipsLabel = null;
        this.____1128 = null;
        this.____1576 = null;
        if (this._inputNameController != null) {
            this._inputNameController.dispose();
            this._inputNameController = null
        }
        this._super()
    },
});
var ____583 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _logo: null,
    _nameLabel: null,
    ____1660: null,
    ____1722: null,
    _tipsLabel: null,
    _versionLabel: null,
    ____1135: null,
    ____940: null,
    ____1655: null,
    ____1676: 0,
    _bgPath: null,
    ____1363: null,
    ____910: null,
    _server: null,
    ____831: null,
    ____1253: null,
    _versionState: 0,
    _selectServerInfo: null,
    _backgroundLoaded: false,
    _tickLoginCount: 0,
    ctor: function(controller) {
        this._super("startLoginView.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this._logo = this.getChildByName("logoIcon");
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1660 = this.getChildByName("serverLabel");
        this.____1722 = this.getChildByName("stateLabel");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____1135 = this.getChildByName("enterBtn");
        this.____940 = this.getChildByName("changeStateBtn");
        this.____1655 = this.getChildByName("changeServerBtn");
        this._versionLabel = this.getChildByName("versionLabel");
        this._versionLabel.setTouchEnabled(true);
        this._versionLabel.setPositionX(600 - ____655.____656 * 0.5);
        this._bgPath = ____654.____675.getPlatFromPath(____655.sources, "loginBg.png");
        this.____1363 = ____654.____675.getPlatFromPath(____655.sources, "logo.png");
        this.____910 = ____654.____675.____139("outPic/loginBtn.png");
        this._backgroundLoaded = false;
        var this_ = this;
        ____654.____677.____146(this._bg, this._bgPath, function() {
            this_._backgroundLoaded = true
        });
        ____654.____677.____146(this._logo, this.____1363);
        ____654.____677.____146(this.____1135, this.____910);
        ____654.soundManager.playMusic(1001, true);
        this.____5();
        this.____6();
        this.showAnima();
        this.serverHandler()
    },
    ____5: function() {
        this.____1253 = ____654.____673.newKYTextField(____654.____673.____160(300, 30), 12, null, null, null, ____654.yuyanbaoManager.getYuyanbao("start.loginTips1"));
        this.____1253.setPosition(this._nameLabel.getPosition());
        this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("start.loginTips4"));
        this.changeVersionLabel();
        this.addChild(this.____1253, 9);
        if (____655.gameConfig.isNoSdkOrTestSdk()) {
            this._nameLabel.setEnabled(false);
            var saveName = ____654.sdk.getLocalUserId();
            if (!!saveName && saveName.length > 0) {
                this.____1253.setString(saveName)
            }
            this._controller.doPostURL(function() {
                var server = ____654.sdk.getLocalServer(),
                    areaId = 0,
                    serverId = 0;
                if (server.length == 2) {
                    areaId = server[0].toString();
                    serverId = server[1].toString()
                }
                var currentServer = ____655.____663.____238(areaId, serverId);
                if (!!currentServer) {
                    ____655.____663.setCurrent(currentServer)
                }
            }, null, this);
            this._controller.loadTempAndDes()
        } else {
            this.____1253.setVisible(false);
            this._nameLabel.setEnabled(true);
            this._nameLabel.setString("未登录");
            ____655.____663.____61();
            this.startLogin()
        }
        ____654.sdk.startLock();
        ____654.sdk.regNotify()
    },
    startLogin: function() {
        this._tickLoginCount = 100;
        ____654.____678.____298(this.tickLogin, this)
    },
    tickLogin: function(delta, count) {
        this._tickLoginCount--;
        if (this._backgroundLoaded && this._tickLoginCount < 0) {
            this._controller.loadTempAndDes();
            ____654.____678.____299(this.tickLogin, this);
            this._controller.doSdkLogin()
        }
    },
    getUserId: function() {
        if (!!this.____1253) return this.____1253.getString();
        return this._nameLabel.getString()
    },
    showAnima: function() {
        function animaCB(name) {
            print("#animaCB", name)
        }
        if (this.____831 != null) return;
        this.____831 = ____654.____673.newAnima("dljm", animaCB, this), size = cc.winSize;
        this.addChild(this.____831);
        this.____831.setPosition(604, 326);
        this.____831.play("dljm")
    },
    ____6: function() {
        this.____1135.addListener(this, this.____16);
        this.____1655.addListener(this, this.____16);
        this.____940.addListener(this, this.____16);
        this._versionLabel.addListener(this, this.____16);
        ____654.____672.addEventListener(____655.____661.start_selectServer, this.serverHandler, this);
        ____654.____672.addEventListener(____655.____661.start_restart, this.reStart, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.start_selectServer, this.serverHandler, this);
        ____654.____672.removeEventListener(____655.____661.start_restart, this.reStart, this)
    },
    reStart: function(evt) {
        ____655.isLogout = true;
        ____654.____680.close();
        this.____1253.setVisible(false);
        this._nameLabel.setEnabled(true);
        this._nameLabel.setString("未登录");
        ____655.____663.____61();
        this.startLogin()
    },
    serverHandler: function(evt) {
        var serverInfo = ____655.____663.getCurrent();
        if (serverInfo != null) {
            this.setSelectServerInfo(serverInfo)
        }
    },
    changeVersionLabel: function() {
        var vals = null,
            gc = ____655.gameConfig;
        switch (this._versionState) {
            case 0:
                vals = ____654.yuyanbaoManager.getYuyanbao("start.loginTips9", gc.bigVersion);
                break;
            case 1:
                vals = "sdkid:{0},res:{1},agentId:{2}".format(gc.sdkId, gc.resVersion, gc.agentId);
                break;
            case 2:
                vals = "account:{0}".format(____655.____663.userName);
                break;
            case 3:
                vals = "verUrl:{0}".format(gc.verUrl);
                break;
            case 4:
                vals = "loginUrl:{0}".format(gc.loginUrl);
                break
        }
        if (!!vals) {
            this._versionLabel.setString(vals)
        }
        this._versionState++;
        if (this._versionState > 4) this._versionState = 0
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1135) {
                if (this._selectServerInfo != null) {
                    if (this._selectServerInfo.state == 5) {
                        if (this._selectServerInfo.msg != null && this._selectServerInfo.msg != "") {
                            ____655.getAlert().show(1, this._selectServerInfo.msg, null, 0, null, null, null, null)
                        } else {
                            ____654.tipsManager.quickTip.show("服务器正在维护，请稍等")
                        }
                        return
                    }
                    this._controller.____275(____655.____663.getCurrent(), this.getUserId())
                } else {
                    ____654.tipsManager.quickTip.show("请选择服务器")
                }
            } else if (sender == this.____1655) {
                this._controller.showSelectServerView()
            } else if (sender == this.____940) {} else if (sender == this._versionLabel) {
                this.changeVersionLabel()
            }
        }
    },
    setSelectServerInfo: function(serverItemInfo) {
        this._selectServerInfo = serverItemInfo;
        this.____1660.setString(this._selectServerInfo.name());
        if (!____655.gameConfig.isNoSdkOrTestSdk()) {
            var ____347 = ____654.sdk.confirmUserName(____655.____663.userName);
            this._nameLabel.setString(____347);
            this.____1253.setString(____655.____663.userName)
        }
    },
    dispose: function() {
        this.____17();
        ____654.____678.____299(this.tickLogin, this);
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        ____654.____677.removeImageQuote(this.____1363, this._logo);
        ____654.____677.removeImageQuote(this.____910, this.____1135);
        this._controller = null;
        this._bg = null;
        this._logo = null;
        this._nameLabel = null;
        this.____1660 = null;
        this.____1722 = null;
        this._tipsLabel = null;
        this.____1135 = null;
        this.____940 = null;
        this.____1655 = null;
        this._bgPath = null;
        this.____1363 = null;
        this.____910 = null;
        this._server = null;
        this._versionLabel = null;
        if (this.____831 != null) {
            this.____831.dispose();
            this.____831 = null
        }
        if (this.____1253 != null) {
            this.____1253.dispose();
            this.____1253 = null
        }
        this._super()
    },
});
var ____2319 = KYNode.extend({
    ____836: null,
    _titleLabel: null,
    _executor: null,
    _callBack: null,
    ____1658: null,
    ctor: function(serverInfo) {
        this._super("startServerBtn.ExportJson");
        this.____1658 = serverInfo;
        this.____836 = this.getChildByName("areaBtn__1");
        this._titleLabel = this.getChildByName("titleLabel");
        this.____5();
        this.____6()
    },
    ____5: function() {
        this._titleLabel.setString(this.____1658.name)
    },
    ____6: function() {
        this.____836.addListener(this, this.____16, null, null, null, false, true)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._executor != null && this._callBack != null) {
                this._callBack.call(this._executor, this)
            }
        }
    },
    getServerInfo: function() {
        return this.____1658
    },
    setCallBack: function(callBack, executor) {
        this._callBack = callBack;
        this._executor = executor
    },
    ____239: function(flag) {
        if (flag) {
            this.____836.setFrame("btn/ui_btn1_2.png")
        } else {
            this.____836.setFrame("btn/ui_btn1_1.png")
        }
    },
    dispose: function() {
        this.____836 = null;
        this._titleLabel = null;
        this._executor = null;
        this._callBack = null;
        this.____1658 = null;
        this._super()
    },
});
var ____2320 = KYPanel.extend({
    _controller: null,
    ____855: null,
    ____1660: null,
    ____908: null,
    ____1659: null,
    ____1718: null,
    ____1723: null,
    _itemPanel1: null,
    _itemPanel2: null,
    ____1096: null,
    _line: null,
    ____891: null,
    ____1002: null,
    ____1629: null,
    ____1640: null,
    ____1290: -1,
    _newServerItem1: null,
    _newServerItem2: null,
    ctor: function(controller) {
        this._super("startServerChooseView.ExportJson");
        this.modeValue = 100;
        this._controller = controller;
        this.____855 = this.getChildByName("backBtn");
        this.____1660 = this.getChildByName("serverLabel");
        this.____908 = this.getChildByName("btnListView");
        this.____1659 = this.getChildByName("serverItemScrollView__1");
        this._itemPanel1 = this.getChildByName("itemPanel1");
        this._itemPanel2 = this.getChildByName("itemPanel2");
        this.____1096 = this.getChildByName("descLabel");
        this._line = this.getChildByName("ImageView_754757");
        this._newServerItem1 = new ____2321(this._controller);
        this._newServerItem2 = new ____2321(this._controller);
        this.____1659.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____1718 = [];
        this.____1723 = [];
        for (var i = 1; i <= 3; i++) {
            this.____1718.push(this.getChildByName("stateIcon" + i));
            this.____1723.push(this.getChildByName("stateLabel" + i))
        }
        this.btnInfoList = ____655.____663.serverList;
        this.____891 = [];
        this.____5();
        this.____6()
    },
    ____5: function() {
        var btn = new ____2319({
            "name": "新服区"
        });
        btn.setCallBack(this.btnCallBack, this);
        this.____908.pushBackItem(btn);
        this.____891.push(btn);
        for (var i = 0; i < this.btnInfoList.length; i++) {
            var btn = new ____2319(this.btnInfoList[i]);
            btn.setCallBack(this.btnCallBack, this);
            this.____908.pushBackItem(btn);
            this.____891.push(btn)
        }
        var newServerList = ____655.____663.getNewServerList(2);
        if (newServerList[0] != null) {
            this._newServerItem1.____363(newServerList[0]);
            if (this._newServerItem1.getParent() == null) {
                this._itemPanel1.addChild(this._newServerItem1, 1)
            }
        } else {
            if (this._newServerItem1.getParent() != null) {
                this._newServerItem1.removeFromParent(false)
            }
        }
        if (newServerList[1] != null) {
            this._newServerItem2.____363(newServerList[1]);
            if (this._newServerItem2.getParent() == null) {
                this._itemPanel2.addChild(this._newServerItem2, 1)
            }
        } else {
            if (this._newServerItem2.getParent() != null) {
                this._newServerItem2.removeFromParent(false)
            }
        }
        this.btnCallBack(this.____891[0])
    },
    btnCallBack: function(btn) {
        if (this.____1629 == btn) {
            return
        }
        if (this.____1629 != null) {
            this.____1629.____239(false)
        }
        this.____1629 = btn;
        if (this.____1629 == null) {
            return
        }
        this.____1629.____239(true);
        if (this.____1629 == this.____891[0]) {
            this.serverList = ____655.____663.lastServer;
            this.____1290 = 1;
            if (this._newServerItem1.getParent() == null && this._newServerItem1.getHasInfo()) {
                this._itemPanel1.addChild(this._newServerItem1, 1)
            }
            if (this._newServerItem2.getParent() == null && this._newServerItem2.getHasInfo()) {
                this._itemPanel2.addChild(this._newServerItem2, 1)
            };
            this.____1096.setVisible(true);
            this._line.setVisible(true);
            this.____1659.resetSize(____654.____673.____160(560, 240));
            this.____1659.clearAllItems();
            this.____1659.setFormat(2, this.serverList.length, ____654.____673.____160(280, 80), 0, 0, true)
        } else {
            this.serverList = this.____1629.getServerInfo().list;
            this.____1290 = 2;
            if (this._newServerItem1.getParent() != null) {
                this._newServerItem1.removeFromParent(false)
            }
            if (this._newServerItem2.getParent() != null) {
                this._newServerItem2.removeFromParent(false)
            }
            this.____1096.setVisible(false);
            this._line.setVisible(false);
            this.____1659.resetSize(____654.____673.____160(560, 400));
            this.____1659.clearAllItems();
            this.____1659.setFormat(3, this.serverList.length, ____654.____673.____160(187, 75), 0, 0, true)
        }
    },
    ____6: function() {
        this.____855.addListener(this, this.____16, null, null, null, false)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____855) {
                this._controller.hideSelectServerView()
            }
        }
    },
    getItemByIndex: function(index) {
        var info = this.serverList[index];
        if (info == null) {
            return null
        }
        var item = null;
        if (this.____1290 == 1) {
            item = new ____2321(this._controller);
            info = ____655.____663.____238(info.aid, info.sid, false);
            item.____363(info)
        } else {
            item = new ____2322(this._controller, info)
        }
        return item
    },
    getIdByIndex: function(index) {
        var info = this.serverList[index];
        if (info == null) {
            return -1
        }
        return index
    },
    dispose: function() {
        if (this._newServerItem1 != null) {
            this._newServerItem1.dispose();
            this._newServerItem1 = null
        }
        if (this._newServerItem2 != null) {
            this._newServerItem2.dispose();
            this._newServerItem2 = null
        }
        if (this.____891 != null) {
            var len = this.____891.length;
            for (var i = 0; i < len; i++) {
                this.____891[i].dispose()
            }
            this.____891 = null
        }
        this.____855 = null;
        this.____1660 = null;
        this.____908 = null;
        this.____1659 = null;
        this.____1718 = null;
        this.____1723 = null;
        this._itemPanel1 = null;
        this._itemPanel2 = null;
        this.____1096 = null;
        this._line = null;
        this._controller = null;
        this._super()
    },
});
var ____2321 = KYNode.extend({
    ____1655: null,
    ____1717: null,
    ____1661: null,
    ____1720: null,
    _controller: null,
    _serverItemInfo: null,
    ctor: function(controller) {
        this._super("startServerItem1.ExportJson");
        this._controller = controller;
        this.____1655 = this.getChildByName("serverBtn__1");
        this.____1717 = this.getChildByName("stateIcon");
        this.____1661 = this.getChildByName("serverName");
        this.____1720 = this.getChildByName("stateImg");
        this.____6()
    },
    ____363: function(info) {
        this._serverItemInfo = info;
        this.____1661.setString(this._serverItemInfo.name());
        if (this._serverItemInfo.state == 5) {
            this.____1717.setFrame("icon/ui_serverStateIcon3.png")
        } else {
            this.____1717.setFrame("icon/ui_serverStateIcon2.png")
        }
        if (this._serverItemInfo.state == 1 || this._serverItemInfo.state == 3) {
            this.____1720.setFrame("flag/ui_serverStateFlag1.png");
            this.____1720.setVisible(true)
        } else if (this._serverItemInfo.state == 2) {
            this.____1720.setFrame("flag/ui_serverStateFlag2.png");
            this.____1720.setVisible(true)
        } else {
            this.____1720.setVisible(false)
        }
    },
    ____6: function() {
        this.____1655.addListener(this, this.____16, null, null, null, false, true)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____655.____663.setCurrent(this._serverItemInfo);
            this._controller.hideSelectServerView()
        }
    },
    getHasInfo: function() {
        return this._serverItemInfo != null
    },
    dispose: function() {
        this.____1655 = null;
        this.____1717 = null;
        this.____1661 = null;
        this.____1720 = null;
        this._controller = null;
        this._serverItemInfo = null;
        this._super()
    },
});
var ____2322 = KYNode.extend({
    ____1655: null,
    ____1717: null,
    ____1661: null,
    _serverItemInfo: null,
    _controller: null,
    ctor: function(controller, serverItemInfo) {
        this._super("startServerItem2.ExportJson");
        this._controller = controller;
        this._serverItemInfo = serverItemInfo;
        this.____1655 = this.getChildByName("serverBtn__1");
        this.____1717 = this.getChildByName("stateIcon");
        this.____1661 = this.getChildByName("serverName");
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.____1661.setString(this._serverItemInfo.name());
        if (this._serverItemInfo.state == 5) {
            this.____1717.setFrame("icon/ui_serverStateIcon3.png")
        } else {
            this.____1717.setFrame("icon/ui_serverStateIcon2.png")
        }
    },
    ____6: function() {
        this.____1655.addListener(this, this.____16, null, null, null, false, true)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____655.____663.setCurrent(this._serverItemInfo);
            this._controller.hideSelectServerView()
        }
    },
    dispose: function() {
        this.____1655 = null;
        this.____1717 = null;
        this.____1661 = null;
        this._serverItemInfo = null;
        this._controller = null;
        this._super()
    },
});
var HuanZhuangPanel = KYPanel.extend({
    ____1740: null,
    ____1287: null,
    ____1185: null,
    ____892: null,
    _tipsLabel: null,
    ____861: null,
    _totalStarLabel: null,
    _starProValueList: null,
    ____995: null,
    _boxIconList: null,
    _boxNameList: null,
    ____1737: null,
    ____1758: null,
    ____1738: null,
    _itemList: null,
    ____1241: -1,
    _boxTemplateList: null,
    _myTotalStarCount: 0,
    _myCount: 0,
    _boxAwardTemplateId: 0,
    _propertyId: 0,
    _startIndex: 0,
    _effectList: null,
    ctor: function() {
        this._super("huanZhuangPanel.ExportJson");
        this.____1740 = this.getChildByName("tabLayer");
        this.____1287 = this.getChildByName("itemPanel");
        this.____1185 = this.getChildByName("getBtn");
        this.____892 = this.getChildByName("btnLabel");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____861 = this.getChildByName("loadingBar");
        this._totalStarLabel = this.getChildByName("totalLabel");
        this._starProValueList = [];
        for (var i = 1; i < 7; i++) {
            this._starProValueList.push(this.getChildByName("starProValue" + i))
        }
        this.____995 = this.getChildByName("combatLabel");
        this._boxIconList = [];
        this._boxNameList = [];
        for (var i = 1; i < 5; i++) {
            this._boxIconList.push(this.getChildByName("box" + i));
            this._boxNameList.push(this.getChildByName("progressLabel" + i))
        }
        this.getChildByName("titleLabel").setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangPanel.text3"));
        this.getChildByName("desLabel2").setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangPanel.text4"));
        this.getChildByName("desLabel4").setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangPanel.text5"));
        this.____1738 = [];
        this._itemList = [];
        this._effectList = {};
        this.____6();
        this.____5()
    },
    ____6: function() {
        for (var i = 0; i < this._boxIconList.length; i++) {
            this._boxIconList[i].addListener(this, this.boxClickHandler)
        }
        this.____1185.addListener(this, this.____16);
        ____655.fashionInfo.addEventListener(____655.____661.tuJian_awardUpdate, this.boxStateHandler, this)
    },
    ____17: function() {
        ____655.fashionInfo.removeEventListener(____655.____661.tuJian_awardUpdate, this.boxStateHandler, this)
    },
    ____5: function() {
        this._boxTemplateList = ____655.allTemplates.awardTemplateList.getTypeList(23);
        for (var i = 0; i < 6; i++) {
            var item = new HuanZhuangItemView();
            item.setPosition(____654.____673.____159((i % 3) * 160 - 17, 205 - Math.floor(i / 3) * 210));
            this.____1287.addChild(item);
            this._itemList.push(item)
        }
        this.____1758 = ____655.allTemplates.tuJianTemplateList.huanZhuangList;
        var fightValue = 0;
        for (var i = 0; i < this.____1758.length; i++) {
            var fashionIdList = this.____1758[i].fashionIdList;
            var count = 0;
            for (var j = 0; j < fashionIdList.length; j++) {
                var type = fashionIdList[j][0];
                var id = 0;
                if (type == ____655.____659.commonStaticType.style_fashion_cloth && !____655.____667.getSex()) {
                    id = fashionIdList[j][2]
                } else {
                    id = fashionIdList[j][1]
                }
                var info = ____655.fashionInfo.getFashionInfo(type, id);
                if (info != null) {
                    count++;
                    this._myTotalStarCount++
                }
            }
            var propertyList = this.____1758[i].propertyList;
            var propertyId = propertyList[i][1];
            var propertyValue = 0;
            for (var j = 0; j < propertyList.length; j++) {
                if (propertyList[j][0] <= count) {
                    propertyValue += propertyList[j][2]
                }
            }
            fightValue += ____655.____659.propertyType.getFight(propertyId, propertyValue);
            this.____995.setString(fightValue);
            var name = this.____1758[i].name + " " + count + "/" + fashionIdList.length;
            var path = ____654.____675.getTuJianPath(this.____1758[i].iconPath);
            this.____1738.push([i, name, path, true, 1, true])
        }
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(540);
        this.____1740.addChild(this.____1737);
        if (this.____1738.length > 0) {
            this.____1737.setTabIndex(0)
        }
        this.boxStateHandler()
    },
    setTab: function(tab) {
        this.____225(tab)
    },
    ____225: function(index) {
        if (this.____1241 == index || this.____1758[index] == null) return;
        this.____1241 = index;
        var fashionIdList = this.____1758[index].fashionIdList;
        var value = 0;
        this._myCount = 0;
        for (var i = 0; i < this._itemList.length; i++) {
            if (fashionIdList[i] != null) {
                this._itemList[i].____363(fashionIdList[i]);
                var type = fashionIdList[i][0];
                var id = 0;
                if (type == ____655.____659.commonStaticType.style_fashion_cloth && !____655.____667.getSex()) {
                    id = fashionIdList[i][2]
                } else {
                    id = fashionIdList[i][1]
                }
                var info = ____655.fashionInfo.getFashionInfo(type, id);
                if (info != null) {
                    this._myCount++
                }
            } else {
                this._itemList[i].____363(null)
            }
        }
        var propertyList = this.____1758[index].propertyList;
        this._propertyId = propertyList[0][1];
        var proPertyName = ____655.____659.propertyType.getNameByType(this._propertyId);
        var nextCount = 99;
        for (var i = 0; i < propertyList.length; i++) {
            if (this._starProValueList[i] != null) {
                this._starProValueList[i].setString(proPertyName + " +" + propertyList[i][2]);
                if (propertyList[i][0] <= this._myCount) {
                    this._starProValueList[i].setColor(____655.____659.____688.system)
                } else {
                    nextCount = Math.min(propertyList[i][0], nextCount);
                    this._starProValueList[i].setColor(____655.____659.____688.gray)
                }
            }
        }
        if (nextCount != 99) {
            this._tipsLabel.setVisible(true);
            this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangPanel.text1", nextCount))
        } else {
            this._tipsLabel.setVisible(false)
        }
        if (this.____1758[index].deploy[0] != null) {
            this.____892.setString(this.____1758[index].deploy[0].descript)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this.____1758[this.____1241] == null) return;
            if (this.____1758[this.____1241].deploy.length > 0) {
                ____654.triggerManager.handlerList(this.____1758[this.____1241].deploy)
            }
        }
    },
    boxClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var index = this._boxIconList.indexOf(sender);
            var index2 = this._startIndex + index;
            if (index == -1 || this._boxTemplateList[index2] == null) return;
            var isCanGet = false;
            if (this._boxTemplateList[index2].condition <= this._myTotalStarCount) {
                var hasGot = ____655.fashionInfo.huanZhuangAwardRecord.indexOf(parseInt(this._boxTemplateList[index2].condition));
                if (hasGot == -1) {
                    isCanGet = true
                }
            }
            var str = ____654.yuyanbaoManager.getYuyanbao("HuanZhuangPanel.text2", this._boxTemplateList[index2].condition);
            this._boxAwardTemplateId = this._boxTemplateList[index2].id;
            ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [str, this._boxTemplateList[index2].awardList, null, isCanGet, this.getAward, this]))
        }
    },
    getAward: function() {
        ____654.fashionMessageSender.sendTuJianAward(2, this._boxAwardTemplateId)
    },
    boxStateHandler: function() {
        this._totalStarLabel.setString(this._myTotalStarCount);
        var canGetIndex = 0;
        var index = 0;
        var isStart = false;
        this._startIndex = 0;
        if (this._boxTemplateList != null) {
            for (var i = 0; i < this._boxTemplateList.length; i++) {
                var hasGot = ____655.fashionInfo.huanZhuangAwardRecord.indexOf(parseInt(this._boxTemplateList[i].condition));
                if (!isStart && (hasGot == -1 || i >= this._boxTemplateList.length - 4)) {
                    isStart = true;
                    this._startIndex = i
                }
                if (isStart) {
                    if (this._boxTemplateList[i].condition <= this._myTotalStarCount) {
                        if (hasGot != -1) {
                            this._boxIconList[index].setFrame("icon/ui_boxIcon0.png");
                            this._boxNameList[index].setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn1"));
                            this._boxNameList[index].setColor(____655.____659.____688.gray);
                            if (this._effectList[index] != null) {
                                this._effectList[index].dispose();
                                this._effectList[index] = null
                            }
                        } else {
                            this._boxIconList[index].setFrame("icon/ui_boxIcon" + (index + 1) + ".png");
                            this._boxNameList[index].setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangPanel.text6"));
                            this._boxNameList[index].setColor(____655.____659.____688.green);
                            if (this._effectList[index] == null) {
                                this._effectList[index] = new RotationEffect("effect/effect_10.png", 5);
                                this._effectList[index].move(476 + index * 120, 74);
                                this.addChild(this._effectList[index], 2)
                            }
                        }
                        canGetIndex = i
                    } else {
                        this._boxIconList[index].setFrame("icon/ui_boxIcon" + (index + 1) + ".png");
                        this._boxNameList[index].setString(this._boxTemplateList[i].condition);
                        this._boxNameList[index].setColor(____655.____659.____688.orange);
                        if (this._effectList[index] != null) {
                            this._effectList[index].dispose();
                            this._effectList[index] = null
                        }
                    }
                    index++
                }
                if (index >= 4) {
                    break
                }
            }
            if (this._myTotalStarCount >= this._boxTemplateList[this._startIndex + 3].condition) {
                this.____861.setPercent(100)
            } else {
                var percent = 0;
                if (canGetIndex > this._startIndex) {
                    percent += (canGetIndex - this._startIndex + 1) * 25;
                    var condition = this._boxTemplateList[canGetIndex].condition;
                    percent += (this._myTotalStarCount - condition) / (this._boxTemplateList[canGetIndex + 1].condition - condition) * 100 / 4
                } else {
                    if (this._boxTemplateList[this._startIndex - 1] != null) {
                        var condition = this._boxTemplateList[this._startIndex - 1].condition;
                        percent += (this._myTotalStarCount - condition) / (this._boxTemplateList[this._startIndex].condition - condition) * 100 / 4
                    } else {
                        percent += this._myTotalStarCount / this._boxTemplateList[this._startIndex].condition * 100 / 4
                    }
                }
                percent = Math.max(0, Math.min(percent, 100));
                this.____861.setPercent(percent)
            }
        }
    },
    dispose: function() {
        this.____17();
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        for (var i in this._effectList) {
            if (this._effectList[i] != null) {
                this._effectList[i].dispose()
            }
        }
        this.____1740 = null;
        this.____1287 = null;
        this.____1185 = null;
        this.____892 = null;
        this._tipsLabel = null;
        this.____861 = null;
        this._totalStarLabel = null;
        this._starProValueList = null;
        this.____995 = null;
        this._boxIconList = null;
        this._boxNameList = null;
        this.____1758 = null;
        this.____1738 = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose();
            this._itemList[i] = null
        }
        this._itemList = null;
        this.____1241 = null;
        this._boxTemplateList = null;
        this._myTotalStarCount = null;
        this._myCount = null;
        this._boxAwardTemplateId = null;
        this._propertyId = null;
        this._super()
    },
});
var HuanZhuangItemView = KYNode.extend({
    _bg: null,
    _bgPath: null,
    _nameLabel: null,
    _showView: null,
    _nameLabel: null,
    _showView: null,
    _hasGotLabel: null,
    _nothingImg: null,
    _nothingImgPath: null,
    _info: null,
    ____1752: null,
    _templateId: 0,
    ____944: null,
    _characterInfo: null,
    _panelType: 0,
    ctor: function() {
        this._super("huanZhuangItemView.ExportJson");
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._nameLabel = this.getChildByName("nameLabel");
        this._showView = this.getChildByName("showView");
        this._hasGotLabel = this.getChildByName("hasGotLabel");
        this._nothingImg = this.getChildByName("nothingImg");
        this._nothingImgPath = null;
        this.____6()
    },
    ____6: function() {},
    ____17: function() {},
    ____363: function(info) {
        if (info == null) {
            this._nothingImgPath = ____654.____675.____139("outPic/ui_wenHaoIcon.png");
            ____654.____677.____146(this._nothingImg, this._nothingImgPath);
            this._nothingImg.setVisible(true);
            this._nameLabel.setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangItemView.text1"));
            this._hasGotLabel.setString("");
            this.____1752 = null
        } else {
            this._nothingImg.setVisible(false);
            this._panelType = info[0];
            if (this._panelType == ____655.____659.commonStaticType.style_fashion_cloth && !____655.____667.getSex()) {
                id = info[2]
            } else {
                id = info[1]
            }
            this.____1752 = ____655.allTemplates.fashionTemplateList.getFashion(id);
            if (this.____1752 != null) {
                this._nameLabel.setString(this.____1752.name);
                this._info = ____655.fashionInfo.getFashionInfo(this._panelType, id);
                if (this._info != null) {
                    this._hasGotLabel.setString("")
                } else {
                    this._hasGotLabel.setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangItemView.text2"))
                }
            }
        }
        this.showCharacter(this.____1752)
    },
    showCharacter: function(tempInfo) {
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (tempInfo == null) return;
        if (this._panelType == ____655.____659.commonStaticType.style_fashion_horse) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Horse] = tempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Horse, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this._showView);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale * 0.6;
            this.____944.setScale(scaleValue);
            var y = (33 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(56, y)
        } else if (this._panelType == ____655.____659.commonStaticType.style_fashion_wing) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Wind] = tempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Wind, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this._showView);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var y = (figureTemplate.windowOffsetY - 60) * scaleValue;
            this.____944.move(68, y)
        } else if (this._panelType == ____655.____659.commonStaticType.style_fashion_pet) {
            this._characterInfo = ____654.getCharacterInfo(tempInfo.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this._showView);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale * 0.8;
            this.____944.setScale(scaleValue);
            var y = (20 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(55, y)
        } else if (this._panelType == ____655.____659.commonStaticType.style_fashion_cloth) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Cloth] = tempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Cloth, ____655.____659.____687.playerStand1);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this._showView);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var x = 56 * scaleValue;
            var y = 30 * scaleValue;
            this.____944.move(x, y)
        }
    },
    dispose: function() {
        this.____17();
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        if (this._nothingImgPath != null) {
            ____654.____677.removeImageQuote(this._nothingImgPath, this._nothingImg);
            this._nothingImgPath = null
        }
        this._nothingImg = null;
        this._nameLabel = null;
        this._showView = null;
        this._hasGotLabel = null;
        this._info = null;
        this.____1752 = null;
        this._templateId = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        this._panelType = null;
        this._super()
    },
});
var TuJianItemView = KYNode.extend({
    _bg: null,
    _bgPath: null,
    _countLabel: null,
    ____861: null,
    ____862: null,
    _upBtn: null,
    _upFightLabel: null,
    _nameLabel: null,
    _showView: null,
    ____1706: null,
    _characterImg: null,
    _characterImgPath: null,
    _info: null,
    ____1752: null,
    ____944: null,
    _characterInfo: null,
    _btnEffect: null,
    ctor: function() {
        this._super("tuJianItemView.ExportJson");
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._countLabel = this.getChildByName("countLabel");
        this.____861 = this.getChildByName("bar");
        this.____862 = this.getChildByName("barBg");
        this._nameLabel = this.getChildByName("nameLabel");
        this._showView = this.getChildByName("showView");
        this._characterImg = this.getChildByName("characterImg");
        this._upBtn = this.getChildByName("upBtn");
        this.____892 = this.getChildByName("titleLabel");
        this._upBg = this.getChildByName("bg1");
        this._upFightLabel = this.getChildByName("upLabel");
        this.____1706 = [];
        for (var i = 1; i < 6; i++) {
            this.____1706.push(this.getChildByName("starIcon" + i))
        }
        this.____892.setString(____654.yuyanbaoManager.getYuyanbao("TuJianItemView.text1"));
        this.____6()
    },
    ____6: function() {
        this._upBtn.addListener(this, this.____16);
        ____655.fashionInfo.addEventListener(____655.____661.fashion_infoUpdate, this.infoUpdateHandler, this)
    },
    ____17: function() {
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_infoUpdate, this.infoUpdateHandler, this)
    },
    ____363: function(info) {
        this.____1752 = info;
        this.showCharacter();
        if (this.____1752 == null) return;
        this._nameLabel.setString(info.name);
        this.infoUpdateHandler()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this.____1752 == null) return;
            if (this._info != null) {
                ____654.fashionMessageSender.sendUpStar(this.____1752.type, this.____1752.templateId)
            } else {
                ____654.fashionMessageSender.sendActive(this.____1752.type, this.____1752.templateId)
            }
        }
    },
    infoUpdateHandler: function(evt) {
        if (this.____1752 == null) return;
        if (evt != null) {
            var data = evt.data;
            if (data[0] != this.____1752.type || data[1] != this.____1752.templateId) return
        }
        var star = 0;
        this._info = ____655.fashionInfo.getFashionInfo(this.____1752.type, this.____1752.templateId);
        if (this._info != null) {
            star = this._info.star
        }
        this.materialInfoUpdate();
        this.setStar(star)
    },
    materialInfoUpdate: function() {
        var star = 0;
        if (this._info != null) {
            star = this._info.star
        }
        if (this.____1752.stars[star + 1] != null) {
            var hasCount = ____655.itemInfoList.getCountByTempId(this.____1752.stars[star + 1].needItems[0][0]);
            var needCount = this.____1752.stars[star + 1].needItems[0][1];
            if (hasCount >= needCount) {
                this._upBtn.setVisible(true);
                this.____892.setVisible(true);
                this._upBg.setVisible(true);
                this._upFightLabel.setVisible(true);
                this.____861.setVisible(false);
                this.____862.setVisible(false);
                this._countLabel.setVisible(false);
                if (this._btnEffect == null) {
                    this._btnEffect = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                    this._btnEffect.setScaleX(0.8);
                    this._btnEffect.setScaleY(0.7);
                    this._btnEffect.move(80, 26);
                    this._btnEffect.play();
                    this._btnEffect.addTo(this, 5)
                }
                var propertyId = this.____1752.stars[star + 1].attrStr[0].id;
                var value = 0;
                if (this.____1752.stars[star] != null) {
                    value = this.____1752.stars[star + 1].attrStr[0].value - this.____1752.stars[star].attrStr[0].value
                } else {
                    value = this.____1752.stars[star + 1].attrStr[0].value
                }
                var proPertyName = ____655.____659.propertyType.getNameByType(propertyId);
                this._upFightLabel.setString(proPertyName + ":+" + value)
            } else {
                this._upBtn.setVisible(false);
                this.____892.setVisible(false);
                this._upBg.setVisible(false);
                this._upFightLabel.setVisible(false);
                this.____861.setVisible(true);
                this.____862.setVisible(true);
                this._countLabel.setVisible(true);
                if (this._btnEffect != null) {
                    this._btnEffect.dispose();
                    this._btnEffect = null
                }
                this._countLabel.setString(hasCount + "/" + needCount);
                var percent = Math.floor((hasCount / needCount) * 100);
                percent = Math.min(percent, 100);
                this.____861.setPercent(percent)
            }
        } else {
            this._upBtn.setVisible(false);
            this.____892.setVisible(false);
            this._upBg.setVisible(false);
            this._upFightLabel.setVisible(false);
            this.____861.setVisible(false);
            this.____862.setVisible(false);
            this._countLabel.setVisible(false);
            if (this._btnEffect != null) {
                this._btnEffect.dispose();
                this._btnEffect = null
            }
        }
    },
    setStar: function(starCount) {
        for (var i = 0; i < this.____1706.length; i++) {
            var count = (starCount - 1) % 5 + 1;
            var colorIndex = Math.min(Math.ceil(starCount / 5) + 2, 6);
            if (i < count) {
                this.____1706[i].setFrame("icon/ui_startIcon" + colorIndex + ".png")
            } else {
                this.____1706[i].setFrame("icon/ui_startIcon0.png")
            }
        }
    },
    showCharacter: function() {
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this.____1752 == null) return;
        if (this.____1752.type == ____655.____659.commonStaticType.style_shangGuShenBing || this.____1752.type == ____655.____659.commonStaticType.style_tianShenBaoWu) {
            this._characterImg.setVisible(true);
            this._characterImgPath = ____654.____675.getTuJianPath(this.____1752.iconPath);
            ____654.____677.____146(this._characterImg, this._characterImgPath)
        } else {
            this._characterImg.setVisible(false);
            if (this.____944 != null) {
                this.____944.dispose();
                this.____944 = null
            }
            if (this._characterInfo != null) {
                this._characterInfo.dispose();
                this._characterInfo = null
            }
            this._characterInfo = ____654.getCharacterInfo(this.____1752.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.bottom, this._showView, 10);
            this.____944.stillAnima();
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(this.____1752.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var y = (10 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(56, y)
        }
    },
    dispose: function() {
        this.____17();
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        if (this._characterImgPath != null) {
            ____654.____677.removeImageQuote(this._characterImgPath, this._characterImg);
            this._characterImgPath = null
        }
        this._characterImg = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._btnEffect != null) {
            this._btnEffect.dispose();
            this._btnEffect = null
        }
        this._countLabel = null;
        this.____861 = null;
        this.____862 = null;
        this._upBtn = null;
        this.____892 = null;
        this._upBg = null;
        this._upFightLabel = null;
        this._upFightLabel = null;
        this._nameLabel = null;
        this._showView = null;
        this.____1706 = null;
        this._info = null;
        this.____1752 = null;
        this._super()
    },
});
var TuJianYaoJingItemView = KYNode.extend({
    _bg: null,
    _bgPath: null,
    ____1706: null,
    ____1533: null,
    _tipsLabel: null,
    ctor: function() {
        this._super("yaoJingItemView.ExportJson");
        this._bg = this.getChildByName("bg");
        this.____1533 = this.getChildByName("popIcon");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____1706 = [];
        for (var i = 1; i < 6; i++) {
            this.____1706.push(this.getChildByName("starIcon" + i))
        }
    },
    ____18: function(tempInfo) {
        this.____1752 = tempInfo;
        var this_ = this;

        function complateHandler() {
            this_.updateView()
        };
        if (tempInfo == null) {
            this._bgPath = ____654.____675.getTuJianYaoJingPath("0");
            ____654.____677.____146(this._bg, this._bgPath);
            this.setStar(0);
            this._tipsLabel.setVisible(true);
            this.setPopIcon(false);
            for (var i = 0; i < this.____1706.length; i++) {
                this.____1706[i].setVisible(false)
            }
            ____654.shaderCache.setColor(this._bg, 0)
        } else {
            for (var i = 0; i < this.____1706.length; i++) {
                this.____1706[i].setVisible(true)
            }
            if (this._bgPath != null) {
                ____654.____677.removeImageQuote(this._bgPath, this._bg);
                this._bgPath = null
            }
            this._bgPath = ____654.____675.getTuJianYaoJingPath(tempInfo.iconPath);
            ____654.____677.____146(this._bg, this._bgPath, complateHandler);
            this._tipsLabel.setVisible(false)
        }
    },
    updateView: function() {
        var star = 0;
        var info = ____655.fashionInfo.getFashionInfo(this.____1752.type, this.____1752.templateId);
        if (info != null) {
            star = info.star;
            ____654.shaderCache.setColor(this._bg, 0)
        } else {
            ____654.shaderCache.setColor(this._bg, 1)
        }
        this.setStar(star)
    },
    setStar: function(starCount) {
        for (var i = 0; i < this.____1706.length; i++) {
            var count = (starCount - 1) % 5 + 1;
            var colorIndex = Math.min(Math.ceil(starCount / 5), 6);
            if (i < count) {
                this.____1706[i].setFrame("icon/ui_startIcon" + colorIndex + ".png")
            } else {
                this.____1706[i].setFrame("icon/ui_startIcon0.png")
            }
        }
    },
    setPopIcon: function(flag) {
        this.____1533.setVisible(flag)
    },
    dispose: function() {
        ____654.shaderCache.removeColor(this._bg);
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        this.____1706 = null;
        this.____1533 = null;
        this._tipsLabel = null;
        this._super()
    },
});
var TuJianPanel = KYPanel.extend({
    _controller: null,
    ____1740: null,
    ____1287: null,
    ____1185: null,
    ____892: null,
    _tipsLabel: null,
    _baseProLabel: null,
    ____861: null,
    _totalStarLabel: null,
    _starProValueList: null,
    ____995: null,
    _boxIconList: null,
    _boxNameList: null,
    ____1737: null,
    ____1758: null,
    ____1738: null,
    _itemList: null,
    ____1241: -1,
    _boxTemplateList: null,
    _myTotalStarCount: 0,
    _star: 0,
    _hasJiHuoIndex: -1,
    _boxAwardTemplateId: 0,
    _curPropertyId: 0,
    ____1159: 0,
    _basePropertyValue: 0,
    _effectList: null,
    _startIndex: 0,
    _addNumberUtils: null,
    ctor: function(controller) {
        this._super("tuJianPanel.ExportJson");
        this._controller = controller;
        this.____1740 = this.getChildByName("tabLayer");
        this.____1287 = this.getChildByName("itemPanel");
        this.____1185 = this.getChildByName("getBtn");
        this.____892 = this.getChildByName("btnLabel");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this._baseProLabel = this.getChildByName("baseProValue");
        this.____861 = this.getChildByName("loadingBar");
        this._totalStarLabel = this.getChildByName("totalLabel");
        this._starProValueList = [];
        for (var i = 1; i < 5; i++) {
            this._starProValueList.push(this.getChildByName("starProValue" + i))
        }
        this.____995 = this.getChildByName("combatLabel");
        this._boxIconList = [];
        this._boxNameList = [];
        for (var i = 1; i < 5; i++) {
            this._boxIconList.push(this.getChildByName("box" + i));
            this._boxNameList.push(this.getChildByName("progressLabel" + i))
        }
        this.getChildByName("titleLabel").setString(____654.yuyanbaoManager.getYuyanbao("TuJianPanel.text3"));
        this.getChildByName("desLabel2").setString(____654.yuyanbaoManager.getYuyanbao("TuJianPanel.text4"));
        this.getChildByName("desLabel").setString(____654.yuyanbaoManager.getYuyanbao("TuJianPanel.text5"));
        this.getChildByName("desLabel4").setString(____654.yuyanbaoManager.getYuyanbao("TuJianPanel.text6"));
        this.____1738 = [];
        this._itemList = [];
        this._effectList = {};
        this.____6();
        this.____5();
        this.popUpdate()
    },
    ____6: function() {
        for (var i = 0; i < this._boxIconList.length; i++) {
            this._boxIconList[i].addListener(this, this.boxClickHandler)
        }
        this.____1185.addListener(this, this.____16);
        ____655.fashionInfo.addEventListener(____655.____661.fashion_infoUpdate, this.infoUpdate, this);
        ____655.fashionInfo.addEventListener(____655.____661.tuJian_awardUpdate, this.boxStateHandler, this);
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    ____17: function() {
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_infoUpdate, this.infoUpdate, this);
        ____655.fashionInfo.removeEventListener(____655.____661.tuJian_awardUpdate, this.boxStateHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 25) {
            this.____1737.setShowPop(0, ____654.playerInfoTester.tujianSJNum > 0)
        }
        if (type == 0 || type == 26) {
            this.____1737.setShowPop(1, ____654.playerInfoTester.tujianMWNum > 0)
        }
        if (type == 0 || type == 27) {
            this.____1737.setShowPop(2, ____654.playerInfoTester.tujianSXNum > 0)
        }
        if (type == 0 || type == 28) {
            this.____1737.setShowPop(3, ____654.playerInfoTester.tujianSBNum > 0)
        }
        if (type == 0 || type == 29) {
            this.____1737.setShowPop(4, ____654.playerInfoTester.tujianBWNum > 0)
        }
    },
    ____5: function() {
        this._boxTemplateList = ____655.allTemplates.awardTemplateList.getTypeList(22);
        for (var i = 0; i < 6; i++) {
            var item = new TuJianItemView();
            item.setPosition(____654.____673.____159((i % 3) * 160 - 17, 205 - Math.floor(i / 3) * 210));
            this.____1287.addChild(item);
            this._itemList.push(item)
        }
        this.____1758 = ____655.allTemplates.tuJianTemplateList.tuJianList;
        for (var i = 0; i < this.____1758.length; i++) {
            var name = this.____1758[i].name;
            var path = ____654.____675.getTuJianPath(this.____1758[i].iconPath);
            this.____1738.push([i, name, path, true, 1, true])
        }
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(540);
        this.____1740.addChild(this.____1737);
        if (this.____1738.length > 0) {
            this.____1737.setTabIndex(0)
        }
        this.calculateFight()
    },
    setTab: function(tab) {
        this.____225(tab)
    },
    ____225: function(index) {
        if (this.____1241 == index || this.____1758[index] == null) return;
        this.____1241 = index;
        var type = this.____1758[index].id;
        var tempInfoList = ____655.allTemplates.fashionTemplateList.getList(type);
        var star = 99;
        this._basePropertyValue = 0;
        var proPertyName = "";
        if (tempInfoList != null) {
            for (var i = 0; i < tempInfoList.length; i++) {
                if (this._itemList[i] != null) {
                    this._itemList[i].____363(tempInfoList[i])
                }
                var id = tempInfoList[i].templateId;
                var info = ____655.fashionInfo.getFashionInfo(type, id);
                if (info != null) {
                    if (star > info.star) {
                        star = info.star
                    };
                    this._basePropertyValue += tempInfoList[i].stars[info.star].attrStr[0].value
                } else {
                    star = 0
                }
            }
            if (tempInfoList[0] != null) {
                this._curPropertyId = tempInfoList[0].stars[1].attrStr[0].id
            }
            proPertyName = ____655.____659.propertyType.getNameByType(this._curPropertyId);
            this._baseProLabel.setString(proPertyName + " +" + this._basePropertyValue)
        }
        var propertyList = this.____1758[index].propertyList;
        var nextStar = 99;
        this._hasJiHuoIndex = -1;
        for (var i = 0; i < propertyList.length; i++) {
            if (this._starProValueList[i] != null) {
                this._starProValueList[i].setString(proPertyName + " +" + propertyList[i][2]);
                if (propertyList[i][0] <= star) {
                    this._starProValueList[i].setColor(____655.____659.____688.system);
                    this._hasJiHuoIndex++
                } else {
                    nextStar = Math.min(propertyList[i][0], nextStar);
                    this._starProValueList[i].setColor(____655.____659.____688.gray)
                }
            }
        }
        if (nextStar != 99) {
            this._tipsLabel.setVisible(true);
            this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("TuJianPanel.text1", nextStar))
        } else {
            this._tipsLabel.setVisible(false)
        }
        this._star = star;
        if (this.____1758[index].deploy[0] != null) {
            this.____892.setString(this.____1758[index].deploy[0].descript)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this.____1758[this.____1241] == null) return;
            if (this.____1758[this.____1241].deploy.length > 0) {
                ____654.triggerManager.handlerList(this.____1758[this.____1241].deploy)
            }
        }
    },
    boxClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var index = this._boxIconList.indexOf(sender);
            var index2 = this._startIndex + index;
            if (index == -1 || this._boxTemplateList[index2] == null) return;
            var isCanGet = false;
            if (this._boxTemplateList[index2].condition <= this._myTotalStarCount) {
                var hasGot = ____655.fashionInfo.tuJianAwardRecord.indexOf(parseInt(this._boxTemplateList[index2].condition));
                if (hasGot == -1) {
                    isCanGet = true
                }
            }
            var str = ____654.yuyanbaoManager.getYuyanbao("TuJianPanel.text2", this._boxTemplateList[index2].condition);
            this._boxAwardTemplateId = this._boxTemplateList[index2].id;
            ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_awardPanel, ____654.____672, [str, this._boxTemplateList[index2].awardList, null, isCanGet, this.getAward, this]))
        }
    },
    getAward: function() {
        ____654.fashionMessageSender.sendTuJianAward(1, this._boxAwardTemplateId)
    },
    infoUpdate: function(evt) {
        var data = evt.data;
        if (this.____1758[this.____1241] == null) return;
        var type = this.____1758[this.____1241].id;
        if (data[0] == type) {
            var tempInfoList = ____655.allTemplates.fashionTemplateList.getList(type);
            var star = 99;
            if (tempInfoList != null) {
                for (var i = 0; i < tempInfoList.length; i++) {
                    var id = tempInfoList[i].templateId;
                    var info = ____655.fashionInfo.getFashionInfo(type, id);
                    if (info != null) {
                        if (star > info.star) {
                            star = info.star
                        }
                    } else {
                        star = 0
                    }
                }
            }
            var info = ____655.fashionInfo.getFashionInfo(data[0], data[1]);
            var tempInfo = ____655.allTemplates.fashionTemplateList.getFashion(data[1]);
            if (tempInfo.stars[info.star - 1] != null) {
                this.____1159 += tempInfo.stars[info.star].fightValue - tempInfo.stars[info.star - 1].fightValue;
                this._basePropertyValue += tempInfo.stars[info.star].attrStr[0].value - tempInfo.stars[info.star - 1].attrStr[0].value
            } else {
                this.____1159 += tempInfo.stars[info.star].fightValue;
                this._basePropertyValue += tempInfo.stars[info.star].attrStr[0].value
            }
            var propertyList = this.____1758[this.____1241].propertyList;
            if (star > this._star && propertyList[this._hasJiHuoIndex + 1] != null && star >= propertyList[this._hasJiHuoIndex + 1][0]) {
                this._hasJiHuoIndex++;
                this._starProValueList[this._hasJiHuoIndex].setColor(____655.____659.____688.system);
                var propertyValue = propertyList[this._hasJiHuoIndex][2];
                this.____1159 += ____655.____659.propertyType.getFight(this._curPropertyId, propertyValue);
                if (propertyList[this._hasJiHuoIndex + 1] == null) {
                    this._tipsLabel.setVisible(false)
                } else {
                    this._tipsLabel.setVisible(true);
                    this._tipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("TuJianPanel.text1", propertyList[this._hasJiHuoIndex + 1][0]))
                }
            }
            this._star = star;
            proPertyName = ____655.____659.propertyType.getNameByType(this._curPropertyId);
            this._baseProLabel.setString(proPertyName + " +" + this._basePropertyValue);
            if (this._addNumberUtils == null) {
                this._addNumberUtils = new AddNumberUtils(this.____995, this.____1159)
            } else {
                this._addNumberUtils.setValue(this.____1159)
            }
        }
        this._myTotalStarCount++;
        this.boxStateHandler()
    },
    calculateFight: function() {
        this._myTotalStarCount = 0;
        for (var i = 0; i < this.____1758.length; i++) {
            var type = this.____1758[i].id;
            var tempInfoList = ____655.allTemplates.fashionTemplateList.getList(type);
            if (tempInfoList != null && tempInfoList.length > 0) {
                var star = 99;
                for (var j = 0; j < tempInfoList.length; j++) {
                    var id = tempInfoList[j].templateId;
                    var info = ____655.fashionInfo.getFashionInfo(type, id);
                    if (info != null) {
                        this.____1159 += tempInfoList[j].stars[info.star].fightValue;
                        this._myTotalStarCount += info.star;
                        if (star > info.star) {
                            star = info.star
                        }
                    } else {
                        star = 0
                    }
                }
                var propertyList = this.____1758[i].propertyList;
                var propertyId = tempInfoList[0].stars[1].attrStr[0].id;
                var propertyValue = 0;
                for (var j = 0; j < propertyList.length; j++) {
                    if (propertyList[j][0] <= star) {
                        propertyValue += propertyList[j][2]
                    }
                }
                this.____1159 += ____655.____659.propertyType.getFight(propertyId, propertyValue)
            }
        }
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____995, this.____1159)
        } else {
            this._addNumberUtils.setValue(this.____1159)
        }
        this.boxStateHandler()
    },
    boxStateHandler: function() {
        this._totalStarLabel.setString(this._myTotalStarCount);
        var canGetIndex = 0;
        var index = 0;
        var isStart = false;
        this._startIndex = 0;
        if (this._boxTemplateList != null) {
            for (var i = 0; i < this._boxTemplateList.length; i++) {
                var hasGot = ____655.fashionInfo.tuJianAwardRecord.indexOf(parseInt(this._boxTemplateList[i].condition));
                if (!isStart && (hasGot == -1 || i >= this._boxTemplateList.length - 4)) {
                    isStart = true;
                    this._startIndex = i
                }
                if (isStart) {
                    if (this._boxTemplateList[i].condition <= this._myTotalStarCount) {
                        if (hasGot != -1) {
                            this._boxIconList[index].setFrame("icon/ui_boxIcon0.png");
                            this._boxNameList[index].setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn1"));
                            this._boxNameList[index].setColor(____655.____659.____688.gray);
                            if (this._effectList[index] != null) {
                                this._effectList[index].dispose();
                                this._effectList[index] = null
                            }
                        } else {
                            this._boxIconList[index].setFrame("icon/ui_boxIcon" + (index + 1) + ".png");
                            this._boxNameList[index].setString(____654.yuyanbaoManager.getYuyanbao("HuanZhuangPanel.text6"));
                            this._boxNameList[index].setColor(____655.____659.____688.green);
                            if (this._effectList[index] == null) {
                                this._effectList[index] = new RotationEffect("effect/effect_10.png", 5);
                                this._effectList[index].move(476 + index * 120, 74);
                                this.addChild(this._effectList[index], 2)
                            }
                        }
                        canGetIndex = i
                    } else {
                        this._boxIconList[index].setFrame("icon/ui_boxIcon" + (index + 1) + ".png");
                        this._boxNameList[index].setString(this._boxTemplateList[i].condition);
                        this._boxNameList[index].setColor(____655.____659.____688.orange);
                        if (this._effectList[index] != null) {
                            this._effectList[index].dispose();
                            this._effectList[index] = null
                        }
                    }
                    index++
                }
                if (index >= 4) {
                    break
                }
            }
            if (this._myTotalStarCount >= this._boxTemplateList[this._startIndex + 3].condition) {
                this.____861.setPercent(100)
            } else {
                var percent = 0;
                if (canGetIndex > this._startIndex) {
                    percent += (canGetIndex - this._startIndex + 1) * 25;
                    var condition = this._boxTemplateList[canGetIndex].condition;
                    percent += (this._myTotalStarCount - condition) / (this._boxTemplateList[canGetIndex + 1].condition - condition) * 100 / 4
                } else {
                    if (this._boxTemplateList[this._startIndex - 1] != null) {
                        var condition = this._boxTemplateList[this._startIndex - 1].condition;
                        percent += (this._myTotalStarCount - condition) / (this._boxTemplateList[this._startIndex].condition - condition) * 100 / 4
                    } else {
                        percent += this._myTotalStarCount / this._boxTemplateList[this._startIndex].condition * 100 / 4
                    }
                }
                percent = Math.max(0, Math.min(percent, 100));
                this.____861.setPercent(percent)
            }
        }
    },
    dispose: function() {
        this.____17();
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        for (var i in this._effectList) {
            if (this._effectList[i] != null) {
                this._effectList[i].dispose()
            }
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this._effectList = null;
        this.____1740 = null;
        this.____1287 = null;
        this.____1185 = null;
        this.____892 = null;
        this._tipsLabel = null;
        this._baseProLabel = null;
        this.____861 = null;
        this._totalStarLabel = null;
        this._starProValueList = null;
        this.____995 = null;
        this._boxIconList = null;
        this._boxNameList = null;
        this.____1758 = null;
        this.____1738 = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose()
        }
        this._itemList = null;
        this.____1241 = null;
        this._boxTemplateList = null;
        this._myTotalStarCount = null;
        this._star = null;
        this._hasJiHuoIndex = null;
        this._controller = null;
        this._super()
    },
});
var TuJianYaoJingPanel = KYPanel.extend({
    _controller: null,
    ____892: null,
    _upBtn: null,
    ____995: null,
    _combatImg: null,
    _combatImgPath: null,
    ____1291: null,
    ____1636: null,
    _starProValueList: null,
    _type: 0,
    ____1637: -1,
    _itemList: null,
    _tempInfoList: null,
    _isCanUp: false,
    _info: null,
    ____1828: null,
    _isCanClick: true,
    ____1499: null,
    ____1400: 0,
    ____1053: -1,
    _beginPos: null,
    ctor: function(controller) {
        this._super("yaoJingPanel.ExportJson");
        this._controller = controller;
        this.____892 = this.getChildByName("btnLabel");
        this._upBtn = this.getChildByName("upBtn");
        this.____995 = this.getChildByName("combatLabel");
        this._combatImg = this.getChildByName("combatImg");
        this._combatImgPath = ____654.____675.____139("outPic/ui_yaojingFlag.png");
        ____654.____677.____146(this._combatImg, this._combatImgPath);
        this.____1291 = this.getChildByName("itemView");
        this.____1636 = this.getChildByName("selectImg");
        this._starProValueList = [];
        for (var i = 1; i < 8; i++) {
            this._starProValueList.push(this.getChildByName("starProValue" + i))
        }
        this._itemList = [];
        this.getChildByName("titleLabel").setString("※妖精激活及升星增加的属性及战力直接加成到人物");
        this.getChildByName("desLabel").setString("该妖精为主人加成");
        this.____6();
        this.____5()
    },
    ____6: function() {
        this._upBtn.addListener(this, this.____16);
        this.____1291.addListener(this, null, this.itemViewTouchBegin, this.itemViewTouchUp);
        ____655.fashionInfo.addEventListener(____655.____661.fashion_infoUpdate, this.infoUpdate, this)
    },
    ____17: function() {
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_infoUpdate, this.infoUpdate, this)
    },
    ____5: function() {
        this._type = ____655.____659.commonStaticType.style_tuJianYaoJing;
        this._tempInfoList = ____655.allTemplates.fashionTemplateList.getList(this._type);
        if (this._tempInfoList == null) return;
        for (var i = 0; i < 8; i++) {
            var item = new TuJianYaoJingItemView();
            item.setPosition(____654.____673.____159(2 + 175 * (i % 4), 505 - 250 - 250 * Math.floor((i / 4))));
            item.addListener(this, this.itemClickHandler, null, null, null, false, true);
            this.____1291.addChild(item);
            this._itemList.push(item)
        }
        this.____1400 = Math.ceil(this._tempInfoList.length / 8);
        if (this.____1499 == null) {
            this.____1499 = new ____2145(this.____1400, 30);
            this.____1499.setPosition(____654.____673.____159(445, 25));
            this.addChild(this.____1499)
        }
        this.calculateFight();
        this.setPage(1)
    },
    setPage: function(page) {
        if (page < 1) {
            page = 1
        }
        if (page > this.____1400) {
            page = this.____1400
        }
        if (this.____1053 == page) {
            return
        }
        this.____1499.setPage(page - 1);
        this.____1053 = page;
        var index = 0;
        for (var i = (page - 1) * 8; i < page * 8; i++) {
            if (this._tempInfoList[i] != null) {
                this._itemList[index].____18(this._tempInfoList[i])
            } else {
                this._itemList[index].____18(null)
            }
            index++
        }
        var day = ____655.____662.getClientDate().getDay();
        if (day == 0) {
            day = 7
        }
        this.____225(day - 1);
        this.popUpdate()
    },
    ____225: function(itemIndex) {
        var index = 8 * (this.____1053 - 1) + itemIndex;
        if (this.____1637 == index || this._tempInfoList[index] == null) return;
        this.____1637 = index;
        this.____1636.setPosition(____654.____673.____159(this._itemList[index].getPositionX() + 95, this._itemList[index].getPositionY() + 150));
        var tempInfo = this._tempInfoList[index];
        var starLevel = 1;
        this._info = ____655.fashionInfo.getFashionInfo(this._type, tempInfo.templateId);
        if (this._info != null) {
            starLevel = this._info.star;
            this.____892.setString("升星")
        } else {
            this.____892.setString("未激活")
        }
        var starTempInfo = tempInfo.stars[starLevel];
        if (starTempInfo != null) {
            for (var i = 0; i < starTempInfo.attrStr.length; i++) {
                if (this._starProValueList[i] != null) {
                    var name = ____655.____659.propertyType.getNameByType(starTempInfo.attrStr[i].id);
                    if (this._info == null) {
                        this._starProValueList[i].setString(name + "：0")
                    } else {
                        this._starProValueList[i].setString(name + "：" + starTempInfo.attrStr[i].value)
                    }
                }
            }
        }
        if (this._info != null && tempInfo.stars[starLevel + 1] == null) {
            this.____892.setString("已满级");
            ____654.____674.setKYBtnEnabled(this._upBtn, false, 1);
            this._isCanUp = false;
            if (this.____1828 != null) {
                this.____1828.dispose();
                this.____1828 = null
            }
            this._itemList[index].setPopIcon(false)
        } else {
            ____654.____674.setKYBtnEnabled(this._upBtn, true, 1);
            var star = 0;
            if (this._info != null) {
                star = starLevel
            }
            var hasCount = ____655.itemInfoList.getCountByTempId(tempInfo.stars[star + 1].needItems[0][0]);
            var needCount = tempInfo.stars[starLevel + 1].needItems[0][1];
            if (hasCount >= needCount) {
                this._isCanUp = true;
                this._itemList[index].setPopIcon(true);
                if (this.____1828 == null) {
                    this.____1828 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                    this.____1828.setScaleX(1.2);
                    this.____1828.move(804, 91);
                    this.____1828.play();
                    this.____1828.addTo(this, 10)
                }
                if (this._info == null) {
                    this.____892.setString("可激活")
                }
            } else {
                this._isCanUp = false;
                this._itemList[index].setPopIcon(false);
                if (this.____1828 != null) {
                    this.____1828.dispose();
                    this.____1828 = null
                }
            }
        }
        this._isCanClick = true
    },
    calculateFight: function() {
        var fight = 0;
        for (var i = 0; i < this._tempInfoList.length; i++) {
            var id = this._tempInfoList[i].templateId;
            var info = ____655.fashionInfo.getFashionInfo(this._type, id);
            if (info != null) {
                fight += this._tempInfoList[i].stars[info.star].fightValue
            }
        }
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____995, fight)
        } else {
            this._addNumberUtils.setValue(fight, true)
        }
    },
    popUpdate: function() {
        for (var i = 0; i < this._tempInfoList.length; i++) {
            var tempInfo = this._tempInfoList[i];
            var star = 0;
            var info = ____655.fashionInfo.getFashionInfo(this._type, tempInfo.templateId);
            if (info != null) {
                star = info.star
            }
            if (tempInfo.stars[star + 1] == null) {
                this._itemList[i].setPopIcon(false)
            } else {
                var needItemId = tempInfo.stars[star + 1].needItems[0][0]
                var hasCount = ____654.playerInfoTester.hunshiList[needItemId];
                if (hasCount == null) {
                    hasCount = 0
                }
                var needCount = tempInfo.stars[star + 1].needItems[0][1];
                if (hasCount >= needCount) {
                    this._itemList[i].setPopIcon(true)
                } else {
                    this._itemList[i].setPopIcon(false)
                }
            }
        }
    },
    infoUpdate: function(evt) {
        var data = evt.data;
        if (this._tempInfoList[this.____1637] == null) return;
        for (var i = 0; i < this._tempInfoList.length; i++) {
            if (this._tempInfoList[i].templateId == data[1]) {
                this._itemList[i].updateView(this._tempInfoList[i]);
                break
            }
        }
        var index = this.____1637;
        this.____1637 = -1;
        this.____225(index);
        this.calculateFight()
    },
    ____16: function(sender, eventType) {
        function dailyFirstRechargeHandler() {
            ____654.____676.uiPanelContainer.close();
            ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_dailyFirst, ____654.____672))
        };
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._isCanClick) {
                var tempInfo = this._tempInfoList[this.____1637];
                if (tempInfo == null) return;
                if (this._isCanUp) {
                    if (this._info != null) {
                        this._isCanClick = false;
                        ____654.fashionMessageSender.sendUpStar(tempInfo.type, tempInfo.templateId)
                    } else {
                        this._isCanClick = false;
                        ____654.fashionMessageSender.sendActive(tempInfo.type, tempInfo.templateId)
                    }
                    this._isCanUp = false
                } else {
                    var day = ____655.____662.getClientDate().getDay();
                    if (day == 0) {
                        day = 7
                    }
                    if (day == this.____1637 + 1) {
                        ____655.getAlert().show(2, "完成每日首充可领取妖精卡片，是否前往？", null, 0, this, dailyFirstRechargeHandler, null, null)
                    } else {
                        ____654.tipsManager.quickTip.show("妖精卡可通过每日首充获得")
                    }
                }
            }
        }
    },
    itemClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var index = this._itemList.indexOf(sender);
            if (index != -1) {
                this.____225(index)
            }
        }
    },
    itemViewTouchBegin: function(sender, eventType, pos) {
        this._beginPos = pos
    },
    itemViewTouchUp: function(sender, eventType, pos) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            var startPos = this._beginPos;
            var endPos = pos;
            if (startPos.x - endPos.x > 50) {
                this.setPage(this.____1053 + 1)
            } else if (startPos.x - endPos.x < -50) {
                this.setPage(this.____1053 - 1)
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____892 = null;
        this._upBtn = null;
        this.____995 = null;
        this._isCanUp = null;
        this.____1400 = null;
        this.____1053 = null;
        this._beginPos = null;
        if (this.____1499 != null) {
            this.____1499.dispose();
            this.____1499 = null
        }
        if (this._combatImgPath != null) {
            ____654.____677.removeImageQuote(this._combatImgPath, this._combatImg);
            this._combatImgPath = null
        }
        this._bg = null;
        this._combatImg = null;
        this.____1291 = null;
        this.____1636 = null;
        this._starProValueList = null;
        this._type = null;
        this.____1637 = null;
        if (this.____1828 != null) {
            this.____1828.dispose();
            this.____1828 = null
        }
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose();
            this._itemList[i] = null
        }
        this._itemList = null;
        this._tempInfoList = null;
        this._super()
    },
});
var TuJianController = cc.Class.extend({
    tuJianModule: null,
    ctor: function(tuJianModule) {
        this.tuJianModule = tuJianModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showTuJianPanel: function(type) {
        if (this.tuJianModule.tuJianPanel == null) {
            this.tuJianModule.tuJianPanel = new TuJianPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.tuJianModule.tuJianPanel, type)
    },
    showHuanZhuangPanel: function(type) {
        if (this.tuJianModule.huanZhuangPanel == null) {
            this.tuJianModule.huanZhuangPanel = new HuanZhuangPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.tuJianModule.huanZhuangPanel, type)
    },
    showTuJianYaoJingPanel: function(type) {
        if (this.tuJianModule.tuJianYaoJingPanel == null) {
            this.tuJianModule.tuJianYaoJingPanel = new TuJianYaoJingPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this.tuJianModule.tuJianYaoJingPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.tuJianModule.tuJianPanel) {
            this.tuJianModule.tuJianPanel = null
        } else if (p == this.tuJianModule.huanZhuangPanel) {
            this.tuJianModule.huanZhuangPanel = null
        } else if (p == this.tuJianModule.tuJianYaoJingPanel) {
            this.tuJianModule.tuJianYaoJingPanel = null
        }
    },
});
var TuJianModule = ____537.extend({
    tuJianController: null,
    tuJianPanel: null,
    huanZhuangPanel: null,
    tuJianYaoJingPanel: null,
    setup: function(data) {
        this.tuJianController = new TuJianController(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.tuJian) {
            this.tuJianController.showTuJianPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.huanZhuang) {
            this.tuJianController.showHuanZhuangPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.tuJianYaoJing) {
            this.tuJianController.showTuJianYaoJingPanel(data[0])
        }
    },
    clear: function() {},
});
var VipItemView = KYNode.extend({
    ____1237: null,
    _propNameList: null,
    _propValueList: null,
    ctor: function() {
        this._super("vipInfoItem.ExportJson");
        this.____1237 = this.getChildByName("iconImg");
        this._propNameList = [];
        this._propValueList = [];
        for (var i = 1; i <= 2; i++) {
            var propName = this.getChildByName("propName" + i);
            this._propNameList.push(propName);
            var propValue = this.getChildByName("propValue" + i);
            this._propValueList.push(propValue)
        }
    },
    ____18: function(leftInfo, rightInfo) {
        var index = rightInfo[0];
        var leftPropStr = "+0";
        var rightPropStr = "+0";
        var name = ____654.yuyanbaoManager.getYuyanbao("VipItemView.text" + index);
        this.____1237.setFrame("icon/ui_vipPlusIcon" + index + ".png");
        this._propNameList[0].setString(name);
        this._propNameList[1].setString(name);
        if (leftInfo != null) {
            leftPropStr = "+" + leftInfo[1];
            if (leftInfo[1] > 0) {
                this._propValueList[0].setColor(____655.____659.____688.smoke)
            }
        }
        rightPropStr = "+" + rightInfo[1];
        if (index < 4) {
            leftPropStr += "%";
            rightPropStr += "%"
        }
        this._propValueList[0].setString(leftPropStr);
        this._propValueList[1].setString(rightPropStr)
    },
    dispose: function() {
        this.____1237 = null;
        this._propNameList = null;
        this._propValueList = null;
        this._super()
    },
});
var VipPanel = KYPanel.extend({
    _contrller: null,
    _rechargeBtn: null,
    _vipLevel: null,
    _rechargeBar: null,
    _barLeft: null,
    _barRight: null,
    _awardLevelLabel: null,
    _leftLevel: null,
    _rightLevel: null,
    _moneyCount: null,
    ____1286: null,
    _gridList: null,
    _receiveBtn: null,
    _awardNameLabel: null,
    ____1499: null,
    _pageList: null,
    _iconPanel: null,
    _moneyView: null,
    ____1053: -1,
    _itemList: null,
    _totalPage: 0,
    _maxLevel: null,
    _awardLevel: null,
    _labMaxLevel: null,
    _imgPay: null,
    _imgPay2: null,
    _imgPay3: null,
    ____1418: null,
    ____909: null,
    _moneyLayer: null,
    ____1845: null,
    _btnEffect: null,
    ____1711: null,
    _sliderLayer: null,
    ctor: function(controller) {
        this._super("vipPanel.ExportJson");
        this._contrller = controller;
        this._moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(3);
        this._moneyLayer.addChild(this._moneyView);
        this._rechargeBtn = this.getChildByName("rechargeBtn");
        this._vipLevel = this.getChildByName("level");
        this._moneyCount = this.getChildByName("vipLevel");
        this._rechargeBar = this.getChildByName("rechargeBar");
        this._barLeft = this.getChildByName("barLeft");
        this._barRight = this.getChildByName("barRight");
        this._awardLevelLabel = this.getChildByName("vipLevel1");
        this._leftLevel = this.getChildByName("vipLevel11");
        this._rightLevel = this.getChildByName("vipLevel21");
        this._receiveBtn = this.getChildByName("receiveBrn");
        this.____909 = this.getChildByName("titleLabel");
        this._awardNameLabel = this.getChildByName("awardNameLabel");
        this.____1286 = this.getChildByName("itemListView");
        this.____1499 = this.getChildByName("pageList");
        this._iconPanel = this.getChildByName("iconPanel");
        this._labMaxLevel = this.getChildByName("labMaxLevel");
        this._imgPay = this.getChildByName("ImageView_739511");
        this._imgPay2 = this.getChildByName("ImageView_739513");
        this._imgPay3 = this.getChildByName("ImageView_739517");
        this.____1418 = this.getChildByName("moneyIcon");
        this._sliderLayer = this.getChildByName("clickLayer");
        this.____1845 = new ____2288();
        this.____1845.setPosition(50, 50);
        this.____1845.setLevelLabel(____655.____667.vipLevel);
        this._iconPanel.addChild(this.____1845);
        this._maxLevel = ____655.allTemplates.vipTemplateList.maxLevel;
        this._itemList = [];
        this._gridList = [];
        for (var i = 0; i < 4; i++) {
            var grid = new ____2129(true, 0, 0);
            var awardCell = this.getChildByName("awardCell" + i);
            grid.setPosition(41, 41);
            awardCell.addChild(grid);
            this._gridList.push(grid)
        }
        this.____5();
        this.____6();
        this.updateGoods()
    },
    ____6: function() {
        this._rechargeBtn.addListener(this, this.clickHandler);
        this._receiveBtn.addListener(this, this.clickHandler);
        this._sliderLayer.addListener(this, null, this.downHandler, this.upHandler, null, false);
        ____655.statInfo.addEventListener(____655.____661.vip_awardUpdate, this.updateGoodsHandler, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.vip_awardUpdate, this.updateGoodsHandler, this)
    },
    clickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            if (sender == this._rechargeBtn) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                ____654.____676.uiPanelContainer.close();
                ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
            } else if (sender == this._receiveBtn) {
                ____654.soundManager.playSound(____654.soundManager.BTN);
                ____654.____683.sendGetVipAward(this._awardLevel)
            }
        }
    },
    downHandler: function(sender, eventType, pos) {
        this.____1711 = pos
    },
    upHandler: function(sender, eventType, pos) {
        if (sender == this._sliderLayer) {
            if (this.____1711 == null) {
                return
            }
            var startPos = this.____1711;
            var endPos = pos;
            var offsetX = endPos.x - startPos.x;
            if (offsetX > 50) {
                if (this.____1053 > 0) {
                    this.setPage(this.____1053 - 1)
                }
            } else if (offsetX < -50) {
                if (this.____1053 < this._totalPage - 1) {
                    this.setPage(this.____1053 + 1)
                }
            }
        }
    },
    ____5: function() {
        var moneyCount = ____655.____667.moneyInfo.list[3];
        var currentLevel = ____655.____667.vipLevel;
        if (currentLevel < this._maxLevel) {
            var vipTemplateInfo = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(currentLevel + 1);
            var curVipTempCount = 0;
            if (currentLevel > 0) {
                curVipTempCount = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(currentLevel).maxExp
            }
            this._vipLevel.setString(currentLevel + 1);
            this._moneyCount.setString(vipTemplateInfo.maxExp - moneyCount);
            this.setPercent((moneyCount - curVipTempCount) / (vipTemplateInfo.maxExp - curVipTempCount) * 100)
        } else {
            this._labMaxLevel.setVisible(true);
            this._labMaxLevel.setString(____654.yuyanbaoManager.getYuyanbao("VipPanel.text1"));
            this._labMaxLevel.setPositionX(292);
            this._imgPay.setVisible(false);
            this._imgPay2.setVisible(false);
            this._imgPay3.setVisible(false);
            this.____1418.setVisible(false);
            this._moneyCount.setVisible(false);
            this.setPercent(100)
        }
        this._totalPage = this._maxLevel;
        this.initPageIconView();
        if (currentLevel == this._maxLevel) {
            this.setPage(currentLevel - 1)
        } else {
            this.setPage(currentLevel)
        }
    },
    setPercent: function(per) {
        if (per == 0) {
            this._barLeft.setVisible(false);
            this._barRight.setVisible(false)
        } else {
            this._barLeft.setVisible(true);
            this._barRight.setVisible(true);
            this._barRight.setPositionX(211 + 4.76 * per)
        }
        this._rechargeBar.setPercent(per)
    },
    initPageIconView: function() {
        this._pageList = [];
        if (this._totalPage == 0) {
            return
        }
        for (var i = 0; i < this._totalPage; i++) {
            var pageIcon = ____654.____673.newKYSprite();
            if (this.____1053 == i) {
                pageIcon.setFrame("btn/ui_checkBox2_2.png")
            } else {
                pageIcon.setFrame("btn/ui_checkBox2_1.png")
            }
            pageIcon.setPosition(____654.____673.____159(-(this._totalPage - 3) * 20 + (i - 1) * 40, 0));
            this._pageList.push(pageIcon);
            this.____1499.addChild(pageIcon)
        }
    },
    setPage: function(page) {
        if (this.____1053 == page) {
            return
        }
        if (this._pageList[this.____1053] != null) {
            this._pageList[this.____1053].setFrame("btn/ui_checkBox2_1.png")
        }
        this.____1053 = page;
        if (this._pageList[this.____1053] != null) {
            this._pageList[this.____1053].setFrame("btn/ui_checkBox2_2.png")
        }
        this.updateItemView(this.____1053);
        this.updateGoods(this.____1053 + 1)
    },
    updateItemView: function(index) {
        this.clearAllItems();
        this._leftLevel.setString(index);
        this._rightLevel.setString(index + 1);
        var currentTemplate = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(index);
        var height = 360;
        var nextTemplate = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(index + 1);
        var num = nextTemplate.____229();
        height = Math.max(360, num * 100 + 10);
        var i = 1;
        for (var k = num - 1; k >= 0; k--) {
            var item = new VipItemView();
            if (currentTemplate == null) {
                item.____18(null, nextTemplate.show[k])
            } else {
                item.____18(currentTemplate.show[k], nextTemplate.show[k])
            }
            item.setPosition(____654.____673.____159(10, height - 100 * i));
            this._itemList.push(item);
            this.____1286.addContent(item);
            i = i + 1
        }
        this.____1286.setInnerSize(____654.____673.____160(870, height));
        this.____1286.jumpToTop()
    },
    updateGoodsHandler: function(evt) {
        this.updateGoods()
    },
    updateGoods: function(index) {
        var getAwardList = ____655.statInfo.vipGetAwardList;
        if (index == null) {
            if (getAwardList[this._maxLevel] != null) {
                index = this._maxLevel
            } else {
                for (var l = 1; l <= this._maxLevel; l++) {
                    if (getAwardList[l] == null) {
                        index = l;
                        break
                    }
                }
            }
        }
        this._awardLevelLabel.setString(index);
        var awardList = ____655.allTemplates.vipTemplateList.getVipTemplateByLevel(index).awardList;
        for (var i = 0; i < 4; i++) {
            var itemInfo = ____655.allTemplates.____794.getItem(awardList[i][0]);
            this._gridList[i].setItemTemplateInfo(itemInfo);
            this._gridList[i].setCount(awardList[i][1]);
            if (i == 0) {
                this._awardNameLabel.setString(itemInfo.name);
                this._awardNameLabel.setColor(____655.____659.____688.getColorByQuality(itemInfo.quality))
            }
        }
        if (getAwardList[index] == null) {
            this.____909.setString(____654.yuyanbaoManager.getYuyanbao("AwardZhanChangPanel.text5"));
            if (____655.____667.vipLevel < index) {
                ____654.____674.setKYBtnEnabled(this._receiveBtn, false, 1);
                this.setBtnEffect(false)
            } else {
                ____654.____674.setKYBtnEnabled(this._receiveBtn, true, 1);
                this.setBtnEffect(true);
                this._awardLevel = index
            }
        } else {
            this.____909.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn1"));
            ____654.____674.setKYBtnEnabled(this._receiveBtn, false, 1);
            this.setBtnEffect(false)
        }
    },
    clearAllItems: function() {
        if (this._itemList.length > 0) {
            for (var index = 0; index < this._itemList.length; index++) {
                this._itemList[index].removeFromParent();
                this._itemList[index].dispose()
            }
        }
        this._itemList = []
    },
    setBtnEffect: function(value) {
        if (value && this._btnEffect == null) {
            this._btnEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.BTN_EFFECT, false, ____654.____673.____159(71, 28), this._receiveBtn);
            this._btnEffect.setScaleX(1.23)
        } else if (!value && this._btnEffect != null) {
            this._btnEffect.dispose();
            this._btnEffect = null
        }
    },
    dispose: function() {
        this.setBtnEffect(false);
        this.____17();
        this._contrller = null;
        if (this._gridList != null) {
            for (var i = 0; i < this._gridList.length; i++) {
                this._gridList[i].dispose()
            }
            this._gridList = null
        }
        if (this._itemList != null) {
            for (var i = 0; i < this._itemList.length; i++) {
                this._itemList[i].dispose()
            }
            this._itemList = null
        }
        if (this._pageList != null) {
            for (var i = 0; i < this._pageList.length; i++) {
                this._pageList[i].dispose()
            }
            this._pageList = null
        }
        this._moneyLayer = null;
        this._rechargeBtn = null;
        this._vipLevel = null;
        this._rechargeBar = null;
        this._barLeft = null;
        this._barRight = null;
        this._awardLevelLabel = null;
        this._leftLevel = null;
        this._rightLevel = null;
        this._moneyCount = null;
        this.____1286 = null;
        this._gridList = null;
        this._receiveBtn = null;
        this._awardNameLabel = null;
        this.____1499 = null;
        this._iconPanel = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this.____1053 = null;
        this._itemList = null;
        this._totalPage = null;
        this._labMaxLevel = null;
        this._awardLevel = null;
        if (this.____1845 != null) {
            this.____1845.dispose();
            this.____1845 = null
        }
        this.____1711 = null;
        this._imgPay = null;
        this._imgPay2 = null;
        this._imgPay3 = null;
        this._super()
    },
});
var VipController = cc.Class.extend({
    _vipModule: null,
    ctor: function(vipModule) {
        this._vipModule = vipModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showVipPanel: function(type) {
        if (this._vipModule.vipPanel == null) {
            this._vipModule.vipPanel = new VipPanel(this)
        }
        ____654.____676.uiPanelContainer.____125(this._vipModule.vipPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this._vipModule.vipPanel) {
            this._vipModule.vipPanel = null
        }
    },
});
var VipModule = ____537.extend({
    vipController: null,
    vipPanel: null,
    setup: function(data) {
        this.vipController = new VipController(this);
        this.____151(data)
    },
    ____151: function(data) {
        this.vipController.showVipPanel(data[0])
    },
    clear: function() {},
});
var AdvancePanel = KYPanel.extend({
    _controller: null,
    ____1740: null,
    ____1502: null,
    ____1737: null,
    ____1738: null,
    _panelList: null,
    ____1054: null,
    _moneyView: null,
    _addFriendBtn: null,
    _flagIndex: -1,
    _type: null,
    ctor: function(controller, index, type) {
        this._super("waiGuanPanel.ExportJson");
        this._controller = controller;
        this._type = type;
        this.____1740 = this.getChildByName("tabLayer");
        this.____1502 = this.getChildByName("panelLayer");
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this._addFriendBtn = this.getChildByName("addFriendBtn");
        this.getChildByName("tipLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2238.text1"));
        this._panelList = {};
        this.____5(index);
        if (this._type == 1) {
            this._moneyView.setVisible(false)
        } else {
            this._addFriendBtn.setVisible(false);
            this.getChildByName("tipLabel").setVisible(false)
        }
        this.____6()
    },
    ____5: function(index) {
        if (this._type == 1) {
            var playerLevel = ____655.lookInfo.playerInfo.level;
            this.____1738 = [
                [1, ____655.____659.nameType.advanceName[0], "icon/ui_waixingIcon1.png", playerLevel >= ____655.____659.levelType.riderLevel],
                [2, ____655.____659.nameType.advanceName[1], "icon/ui_waixingIcon2.png", playerLevel >= ____655.____659.levelType.petLevel],
                [3, ____655.____659.nameType.advanceName[2], "icon/ui_waixingIcon3.png", playerLevel >= ____655.____659.levelType.wingLevel],
                [4, ____655.____659.nameType.advanceName[3], "icon/ui_waixingIcon4.png", playerLevel >= ____655.____659.levelType.footLevel],
                [5, ____655.____659.nameType.advanceName[4], "icon/ui_waixingIcon5.png", playerLevel >= ____655.____659.levelType.fabaoLevel],
                [6, ____655.____659.nameType.advanceName[5], "icon/ui_waixingIcon6.png", playerLevel >= ____655.____659.levelType.zhenlingLevel],
                [7, ____655.____659.nameType.advanceName[6], "icon/ui_waixingIcon7.png", playerLevel >= ____655.____659.levelType.shenjianLevel]
            ]
        } else {
            this.____1738 = [
                [1, ____655.____659.nameType.advanceName[0], "icon/ui_waixingIcon1.png", true, ____655.____659.levelType.riderLevel],
                [2, ____655.____659.nameType.advanceName[1], "icon/ui_waixingIcon2.png", true, ____655.____659.levelType.petLevel],
                [3, ____655.____659.nameType.advanceName[2], "icon/ui_waixingIcon3.png", true, ____655.____659.levelType.wingLevel],
                [4, ____655.____659.nameType.advanceName[3], "icon/ui_waixingIcon4.png", true, ____655.____659.levelType.footLevel],
                [5, ____655.____659.nameType.advanceName[4], "icon/ui_waixingIcon5.png", true, ____655.____659.levelType.fabaoLevel],
                [6, ____655.____659.nameType.advanceName[5], "icon/ui_waixingIcon6.png", true, ____655.____659.levelType.zhenlingLevel],
                [7, ____655.____659.nameType.advanceName[6], "icon/ui_waixingIcon7.png", true, ____655.____659.levelType.shenjianLevel]
            ]
        }
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(540);
        this.____1740.addChild(this.____1737);
        if (index == null || index == 0) {
            index = 1
        }
        this.____1737.setTabIndex(index - 1);
        if (this._type == 1) {} else {
            this.popUpdate();
            this.setBtnFlag()
        }
    },
    setBtnFlag: function() {
        if (this._flagIndex != -1) {
            this.____1737.setBtnFlagImg(this._flagIndex, null);
            this._flagIndex = -1
        }
        var tabList = ____655.allTemplates.openActivityTemplateList.typeList;
        for (var i = 0; i < tabList.length; i++) {
            var type = tabList[i];
            if (type >= 3 && type <= 9) {
                if (type == 3) {
                    this.____1737.setBtnFlagImg(1, "flag/ui_huoFlag.png", 2);
                    this._flagIndex = 1
                } else if (type == 4) {
                    this.____1737.setBtnFlagImg(2, "flag/ui_huoFlag.png", 2);
                    this._flagIndex = 2
                } else if (type == 5) {
                    this.____1737.setBtnFlagImg(3, "flag/ui_huoFlag.png", 2);
                    this._flagIndex = 3
                } else if (type == 6) {
                    this.____1737.setBtnFlagImg(4, "flag/ui_huoFlag.png", 2);
                    this._flagIndex = 4
                } else if (type == 7) {
                    this.____1737.setBtnFlagImg(5, "flag/ui_huoFlag.png", 2);
                    this._flagIndex = 5
                } else if (type == 8) {
                    this.____1737.setBtnFlagImg(6, "flag/ui_huoFlag.png", 2);
                    this._flagIndex = 6
                } else if (type == 9) {
                    this.____1737.setBtnFlagImg(7, "flag/ui_huoFlag.png", 2);
                    this._flagIndex = 7
                }
            }
        }
        if (this._flagIndex == -1) {
            var day = ____655.____662.getClientDate().getDay();
            if (day == 0) {
                day = 7
            }
            this.____1737.setBtnFlagImg(day, "flag/ui_liFlag.png", 2);
            this._flagIndex = day
        }
    },
    addFriendHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____655.lookInfo.addFriend()
        }
    },
    ____6: function() {
        if (this._type == 1) {
            this._addFriendBtn.addListener(this, this.addFriendHandler)
        } else {
            ____654.____672.addEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
            ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this);
            ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.setBtnFlag, this)
        }
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.removeEventListener(____655.____661.global_dayUpdate, this.setBtnFlag, this)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 34) {
            this.____1737.setShowPop(1, ____654.playerInfoTester.riderNum > 0)
        }
        if (type == 0 || type == 35) {
            this.____1737.setShowPop(2, ____654.playerInfoTester.petNum > 0)
        }
        if (type == 0 || type == 36) {
            this.____1737.setShowPop(3, ____654.playerInfoTester.wingNum > 0)
        }
        if (type == 0 || type == 37) {
            this.____1737.setShowPop(4, ____654.playerInfoTester.footNum > 0)
        }
        if (type == 0 || type == 38) {
            this.____1737.setShowPop(5, ____654.playerInfoTester.fabaoNum > 0)
        }
        if (type == 0 || type == 39) {
            this.____1737.setShowPop(6, ____654.playerInfoTester.zhenlingNum > 0)
        }
        if (type == 0 || type == 40) {
            this.____1737.setShowPop(7, ____654.playerInfoTester.shenjianNum > 0)
        }
    },
    changeTabIndexHandler: function(evt) {
        if (this.getParent() != null) {
            var tabIndex = evt.data;
            this.jumpToTab(tabIndex)
        }
    },
    jumpToTab: function(index) {
        if (index < this.____1738.length) {
            this.____1737.setTabIndex(index)
        }
    },
    setTab: function(tab) {
        var panel = this.getPanel(tab);
        if (panel == null) return;
        if (this.____1054 != null) {
            this.____1054.removeFromParent(false)
        }
        this.____1054 = panel;
        if (this.____1054 != null && this.____1054.getParent() == null) {
            this.addChild(this.____1054)
        }
    },
    getPanel: function(tab) {
        var list = null;
        if (this._type == 1) {
            list = ____655.lookInfo.advanceItemList
        } else {
            list = ____655.advanceItemList
        }
        var panel = this._panelList[tab];
        var info = null;
        if (panel == null) {
            if (tab == 1) {
                info = list.getItemByType(____655.____659.commonStaticType.style_Horse)
            } else if (tab == 2) {
                info = list.getItemByType(____655.____659.commonStaticType.style_Pet)
            } else if (tab == 3) {
                info = list.getItemByType(____655.____659.commonStaticType.style_Wind)
            } else if (tab == 4) {
                info = list.getItemByType(____655.____659.commonStaticType.style_Foot)
            } else if (tab == 5) {
                info = list.getItemByType(____655.____659.commonStaticType.style_FaBao)
            } else if (tab == 6) {
                info = list.getItemByType(____655.____659.commonStaticType.style_ZhengLing)
            } else if (tab == 7) {
                info = list.getItemByType(____655.____659.commonStaticType.style_ShenJian)
            }
            if (info != null) {
                panel = new ____2326(this._controller, this._type);
                panel.____363(info);
                this._panelList[tab] = panel
            } else {
                if (this._type == 1) {} else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("AdvancePanel.text1"))
                }
                return null
            }
        }
        return panel
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this._addFriendBtn = null;
        this.____1740 = null;
        this.____1502 = null;
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        this.____1738 = null;
        if (this._panelList != null) {
            for (var i in this._panelList) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this.____1054 = null;
        this._super()
    },
});
var ____2326 = KYNode.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    _nameLabel: null,
    ____1832: null,
    ____1833: null,
    ____995: null,
    ____1138: null,
    ____1555: null,
    ____1568: null,
    _proPlusValueList: null,
    _upBtn: null,
    ____1829: null,
    ____1392: null,
    ____1388: null,
    ____1387: null,
    _materialBar: null,
    ____1391: null,
    ____1393: null,
    ____1385: null,
    ____1565: null,
    _proTipsLabel2: null,
    ____919: null,
    ____1544: null,
    ____1336: null,
    ____1593: null,
    ____823: null,
    ____1704: null,
    ____1705: null,
    ____1701: null,
    ____1702: null,
    ____1080: null,
    ____1082: null,
    ____1081: null,
    ____1674: null,
    _charaterView: null,
    _buyTipsLabel: null,
    _btnView: null,
    _skillView: null,
    ____1563: null,
    _info: null,
    ____1752: null,
    _panelType: 0,
    ____1828: null,
    ____1572: null,
    ____1879: null,
    _currentStar: 0,
    ____1402: 0,
    _maxStar: 0,
    ____1573: 0,
    ____1880: 0,
    ____1079: true,
    ____1812: 0,
    ____1679: null,
    ____1716: null,
    ____944: null,
    _characterInfo: null,
    _characterEffect: null,
    _addNumberUtils: null,
    _downPos: null,
    _pageDownPos: null,
    ____1418: null,
    _type: 0,
    ctor: function(controller, type) {
        this._super("waiGuanShapePanel.ExportJson");
        this._controller = controller;
        this._type = type;
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._nameLabel = this.getChildByName("nameLabel");
        this.____1832 = this.getChildByName("useBtn");
        this.____1833 = this.getChildByName("useBtnLabel");
        this._btnView = this.getChildByName("btnView");
        this._upBtn = this._btnView.getChildByName("upBtn");
        this.____1829 = this._btnView.getChildByName("upBtnLabel");
        this.____919 = this._btnView.getChildByName("buyBtn");
        this.____1544 = this._btnView.getChildByName("moneyLabel");
        this._buyTipsLabel = this._btnView.getChildByName("buyTipsLabel");
        this.____1418 = this._btnView.getChildByName("moneyIcon");
        this.____1392 = this._btnView.getChildByName("materialPanel");
        var cellBg = this.____1392.getChildByName("materialCell");
        this.____1388 = new ____2129();
        cellBg.addChild(this.____1388);
        this.____1387 = this.____1392.getChildByName("countLabel");
        this._materialBar = this.____1392.getChildByName("countBar");
        this.____1391 = this.____1392.getChildByName("nameLabel");
        this.____1336 = this.getChildByName("leftBtn");
        this.____1593 = this.getChildByName("rightBtn");
        this.____1563 = this.getChildByName("propertyView");
        this.____1565 = this.____1563.getChildByName("proTipsLabel");
        this._proTipsLabel2 = this.____1563.getChildByName("proTipsLabel2");
        this.____1704 = this.getChildByName("stage_label1");
        this.____1705 = this.getChildByName("stage_label2");
        this.____1701 = this.getChildByName("stage_iconbg1");
        this.____1702 = this.getChildByName("stage_iconbg2");
        this.____1674 = this.getChildByName("show_panel");
        this._charaterView = this.getChildByName("charaterView");
        this.____1393 = this._btnView.getChildByName("materialPanel2");
        this.____1385 = [];
        for (var i = 1; i <= 2; i++) {
            var cellBg2 = this.____1393.getChildByName("materialCell" + i);
            var item = new ____2129();
            cellBg2.addChild(item);
            this.____1385.push(item)
        }
        this.____1138 = [];
        for (var i = 1; i <= 4; i++) {
            var cellBg = this.getChildByName("equipCell" + i);
            var equipCell = new AdvanceEquipGrid();
            cellBg.addChild(equipCell);
            this.____1138.push(equipCell)
        }
        this.____1080 = [];
        this.____1082 = [];
        this.____1081 = [];
        for (var i = 1; i <= 2; i++) {
            this.____1082.push(this.getChildByName("numLabel" + i));
            this.____1080.push(this.getChildByName("danIcon" + i));
            this.____1081.push(this.getChildByName("numBg" + i))
        }
        this.____1555 = [];
        this.____1568 = [];
        this._proPlusValueList = [];
        for (var i = 1; i <= 5; i++) {
            this.____1555.push(this.____1563.getChildByName("proName" + i));
            this.____1568.push(this.____1563.getChildByName("proValue" + i));
            this._proPlusValueList.push(this.____1563.getChildByName("proPlusValue" + i))
        }
        this._skillView = this.getChildByName("skillView");
        this.____1679 = [];
        for (var i = 1; i <= 3; i++) {
            var skillGrid = new ____2131();
            var skillBg = this._skillView.getChildByName("skillCell" + i);
            skillBg.addChild(skillGrid);
            skillGrid.setPosition(____654.____673.____159(43, 43));
            this.____1679.push(skillGrid)
        }
        this.____823 = this.getChildByName("descLabel1");
        this.____823.setString(____654.yuyanbaoManager.getYuyanbao("____2131.tips1"));
        this.____995 = this.getChildByName("combatLabel");
        this.____1716 = new StarView();
        this.____1716.setPosition(____654.____673.____159(415, 490));
        this.addChild(this.____1716, 13);
        if (this._type == 1) {
            this._skillView.setPositionY(60);
            this.____1563.setPositionY(265);
            this._btnView.setVisible(false);
            this.____1336.setVisible(false);
            this.____1593.setVisible(false);
            this._skillView.getChildByName("line1").setPositionY(150);
            this._skillView.getChildByName("line2").setVisible(false)
        } else {
            this.____6()
        }
    },
    ____6: function() {
        this.____1832.addListener(this, this.____16);
        this.____919.addListener(this, this.____16);
        this._upBtn.addListener(this, this.____16);
        this._charaterView.addListener(this, null, this.charaterDownHandler, this.charaterUpHandler);
        this.____1336.addListener(this, this.pageTouchUpHandler);
        this.____1593.addListener(this, this.pageTouchUpHandler);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.materialInfoUpdate, this);
        ____655.advanceItemList.addEventListener(____655.____661.advance_equipUpdate, this.equipUpdate, this);
        ____654.____672.addEventListener(____655.____661.guide_advanceUp, this.guideHandler, this);
        ____654.____672.addEventListener(____655.____661.advance_infoUpdate, this.infoUpdate, this)
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.materialInfoUpdate, this);
        ____655.advanceItemList.removeEventListener(____655.____661.advance_equipUpdate, this.equipUpdate, this);
        ____654.____672.removeEventListener(____655.____661.guide_advanceUp, this.guideHandler, this);
        ____654.____672.removeEventListener(____655.____661.advance_infoUpdate, this.infoUpdate, this)
    },
    guideHandler: function(evt) {
        if (this.getParent() != null && this._upBtn.isTouchEnabled()) {
            ____654.fashionMessageSender.sendAdvanceUp(this._panelType, false)
        }
    },
    materialInfoUpdate: function() {
        this.materialCountUpdate();
        this.danCountUpdate()
    },
    ____363: function(info) {
        if (this._type == 1) {
            this._info = info;
            if (this._info == null) return
        } else {
            if (this._info != null) {
                this._info.removeEventListener(____655.____661.advance_danUpdate, this.danUpdateHandler, this);
                this._info.removeEventListener(____655.____661.advance_useStarUpdate, this.useStarUpdate, this);
                this._info.removeEventListener(____655.____661.adavnce_propertyUpdate, this.setProValue, this)
            }
            this._info = info;
            if (this._info == null) return;
            this._info.addEventListener(____655.____661.advance_useStarUpdate, this.useStarUpdate, this);
            this._info.addEventListener(____655.____661.advance_danUpdate, this.danUpdateHandler, this);
            this._info.addEventListener(____655.____661.adavnce_propertyUpdate, this.setProValue, this)
        }
        this._panelType = this._info.type;
        this.setTipsLabel();
        for (var i = 0; i <= 1; i++) {
            this.____1080[i].setFrame("icon/ui_danIcon" + this._panelType + (i + 1) + ".png")
        }
        if (this.____1079) {
            for (var i = 0; i <= 1; i++) {
                this.____1080[i].addListener(this, this.danIconClickHandler, this.danClickDownHandler, this.danClickUpHandler, this.danTouchMoveHandler)
            }
            this.____1079 = false
        }
        this.____1402 = ____655.allTemplates.advanceTemplateList.getMaxStage(this._panelType);
        this._maxStar = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(this.____1402);
        this.setProValue();
        this.materialUpdate();
        this.danCountUpdate();
        this.setSkillInfo();
        this.setEquipInfo();
        this.setStage(this._info.starCount)
    },
    danUpdateHandler: function() {
        this.danCountUpdate();
        this.setProValue()
    },
    setTipsLabel: function() {
        if (this._panelType == ____655.____659.commonStaticType.style_Horse) {
            this._proTipsLabel2.setString("");
            this.____1565.setString(____654.____682.____108(10084))
        } else if (this._panelType == ____655.____659.commonStaticType.style_Pet) {
            this._proTipsLabel2.setString(____654.____682.____108(10082));
            this.____1565.setString(____654.____682.____108(10083))
        } else if (this._panelType == ____655.____659.commonStaticType.style_Wind) {
            this._proTipsLabel2.setString("");
            this.____1565.setString(____654.____682.____108(10085))
        } else if (this._panelType == ____655.____659.commonStaticType.style_Foot) {
            this._proTipsLabel2.setString("");
            this.____1565.setString(____654.____682.____108(10086))
        } else if (this._panelType == ____655.____659.commonStaticType.style_FaBao) {
            this._proTipsLabel2.setString("");
            this.____1565.setString(____654.____682.____108(10087))
        } else if (this._panelType == ____655.____659.commonStaticType.style_ZhengLing) {
            this._proTipsLabel2.setString("");
            this.____1565.setString(____654.____682.____108(10088))
        } else if (this._panelType == ____655.____659.commonStaticType.style_ShenJian) {
            this._proTipsLabel2.setString("");
            this.____1565.setString(____654.____682.____108(10089))
        }
    },
    setEquipInfo: function() {
        if (this._info != null) {
            for (var i = 0; i < 4; i++) {
                var place = i + 1;
                var equipInfo = this._info.equipList[place];
                var isMine = true;
                if (this._type == 1) {
                    isMine = false
                }
                this.____1138[i].setEquipInfo(equipInfo, this._panelType, place, isMine)
            }
        }
    },
    equipUpdate: function(evt) {
        var list = evt.data;
        if (list == null || list.length <= 0) return;
        if (this._panelType == list[0]) {
            var place = list[1];
            var equipInfo = this._info.equipList[place];
            this.____1138[place - 1].setEquipInfo(equipInfo, this._panelType, place, true)
        }
        this.setProValue()
    },
    infoUpdate: function(evt) {
        var info = evt.data;
        if (info != null) {
            if (info.type == this._panelType) {
                this.____363(info)
            }
        }
    },
    useStarUpdate: function(evt) {
        var currentUseStar = evt.data;
        if (currentUseStar != null) {
            this.huanHuaBtnUpdate(currentUseStar)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._upBtn) {
                ____654.fashionMessageSender.sendAdvanceUp(this._panelType, false)
            } else if (sender == this.____919) {
                var this_ = this;

                function sendAdvanceUp() {
                    ____654.fashionMessageSender.sendAdvanceUp(this_._panelType, true)
                };
                if (____655.____667.moneyInfo.money1Enough(this.____1812)) {
                    var st1 = ____654.yuyanbaoManager.getYuyanbao("____2326.text2");
                    if (this._info != null && this._info.template.needItems.length > 1) {
                        st1 = ____654.yuyanbaoManager.getYuyanbao("____2326.text3")
                    }
                    var str = ____654.yuyanbaoManager.getYuyanbao("____2326.text1", this.____1812, st1) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold");
                    ____655.getAlert().show(2, str, ____654.noAlertUtils.ADVANCE_UP, 0, this, sendAdvanceUp)
                } else {
                    ____655.____667.moneyInfo.showNotEnoughTip(1)
                }
            } else if (sender == this.____1832) {
                var index = ____655.____659.commonStaticType.advanceTypeList.indexOf(this._panelType);
                var fashionType = ____655.____659.commonStaticType.fashionTypeList[index];
                if (fashionType != null) {
                    ____654.fashionMessageSender.sendMoveEquip(0, this._currentStar, this._panelType, fashionType, 1)
                } else {
                    print("+++++找不到对应的时装类型+++++", this._panelType)
                }
            }
        }
    },
    danClickDownHandler: function(sender, eventType, pos) {
        this._downPos = pos;
        if (sender == this.____1080[0]) {
            if (this.____1573 <= 0 || this._type == 1) {
                var itemTempInfo = ____655.allTemplates.____794.getItem(this._info.template.parentStage.qianNengId);
                ____654.tipsManager.showDanTempFlashTip(itemTempInfo, this._panelType, this._info.qiangNeng, this._info.template.parentStage.qianNengMax, pos, this._type)
            }
        } else if (sender == this.____1080[1]) {
            if (this.____1880 <= 0 || this._type == 1) {
                var itemTempInfo = ____655.allTemplates.____794.getItem(this._info.template.parentStage.wuxingId);
                ____654.tipsManager.showDanTempFlashTip(itemTempInfo, this._panelType, this._info.wuxing, this._info.template.parentStage.wuxingMax, pos, this._type)
            }
        }
    },
    danClickUpHandler: function(sender, eventType, pos) {
        if (sender == this.____1080[0] && (this.____1573 <= 0 || this._type == 1)) {
            ____654.tipsManager.hideFlashTip()
        } else if (sender == this.____1080[1] && (this.____1880 <= 0 || this._type == 1)) {
            ____654.tipsManager.hideFlashTip()
        }
    },
    danTouchMoveHandler: function(sender, eventType, pos) {
        if (sender == this.____1080[0] && (this.____1573 <= 0 || this._type == 1)) {
            if (this._downPos.x - pos.x > 15 || this._downPos.y - pos.y > 15) {
                ____654.tipsManager.hideFlashTip()
            }
        } else if (sender == this.____1080[1] && (this.____1880 <= 0 || this._type == 1)) {
            if (this._downPos.x - pos.x > 15 || this._downPos.y - pos.y > 15) {
                ____654.tipsManager.hideFlashTip()
            }
        }
    },
    danIconClickHandler: function(sender, eventType) {
        if (this._info == null) {
            return
        }
        if (sender == this.____1080[0]) {
            if (this.____1573 > 0 && this._type != 1) {
                if (eventType == ccui.Widget.TOUCH_ENDED) {
                    ____654.fashionMessageSender.sendUseQnWx(this._panelType, 2, this.____1573)
                }
            }
        } else if (sender == this.____1080[1]) {
            if (this.____1880 > 0 && this._type != 1) {
                if (eventType == ccui.Widget.TOUCH_ENDED) {
                    ____654.fashionMessageSender.sendUseQnWx(this._panelType, 1, this.____1880)
                }
            }
        }
    },
    charaterDownHandler: function(sender, eventType, pos) {
        this._pageDownPos = pos
    },
    charaterUpHandler: function(sender, eventType, pos) {
        var offsetX = pos.x - this._pageDownPos.x;
        if (this._info == null) return;
        var myStage = ____655.allTemplates.advanceTemplateList.getStageByStar(this._info.starCount);
        var curStage = ____655.allTemplates.advanceTemplateList.getStageByStar(this._currentStar);
        if (offsetX > 50 && curStage > 1) {
            if (myStage == curStage - 1) {
                this.setStage(this._info.starCount)
            } else {
                if (myStage > curStage - 1) {
                    var star = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(curStage - 1);
                    this.setStage(star)
                } else {
                    var star = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(curStage - 2);
                    this.setStage(star + 1)
                }
            }
        } else if (offsetX < -50 && curStage < this.____1402) {
            if (myStage == curStage + 1) {
                this.setStage(this._info.starCount)
            } else {
                if (myStage > curStage + 1) {
                    var star = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(curStage + 1);
                    this.setStage(star)
                } else {
                    var star = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(curStage);
                    this.setStage(star + 1)
                }
            }
        }
    },
    pageTouchUpHandler: function(sender, eventType, pos) {
        var myStage = ____655.allTemplates.advanceTemplateList.getStageByStar(this._info.starCount);
        var curStage = ____655.allTemplates.advanceTemplateList.getStageByStar(this._currentStar);
        if (sender == this.____1336 && curStage > 1) {
            if (myStage == curStage - 1) {
                this.setStage(this._info.starCount)
            } else {
                if (myStage > curStage - 1) {
                    var star = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(curStage - 1);
                    this.setStage(star)
                } else {
                    var star = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(curStage - 2);
                    this.setStage(star + 1)
                }
            }
        } else if (sender == this.____1593 && curStage < this.____1402) {
            if (myStage == curStage + 1) {
                this.setStage(this._info.starCount)
            } else {
                if (myStage > curStage + 1) {
                    var star = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(curStage + 1);
                    this.setStage(star)
                } else {
                    var star = ____655.allTemplates.advanceTemplateList.getTotalStarByStage(curStage);
                    this.setStage(star + 1)
                }
            }
        }
    },
    setSkillInfo: function() {
        var skillTempList = ____655.allTemplates.skillTemplateList.getList(this._panelType);
        if (skillTempList == null) return;
        for (var i = 0; i < skillTempList.length; i++) {
            if (this.____1679[i] != null) {
                var templateId = skillTempList[i].templateId;
                if (this._info.skillList[templateId] != null && this._info.skillList[templateId].level > 0) {
                    this.____1679[i].setSkillInfo(this._info.skillList[templateId])
                } else {
                    this.____1679[i].setSkillInfo(null);
                    this.____1679[i].setSkillTemplateInfo(skillTempList[i]);
                    this.____1679[i].____64(0)
                }
            }
        }
    },
    setProValue: function() {
        if (this._info == null) return;
        var nextTemplate = null;
        if (this._type == 1) {} else {
            nextTemplate = ____655.allTemplates.advanceTemplateList.getStarInfo(this._panelType, this._info.starCount + 1)
        }
        var isShowTips = false;
        for (var i = 0; i < this._info.template.baseAttrs.length; i++) {
            if (this.____1555[i] != null) {
                var name = ____655.____659.propertyType.getNameByType(this._info.template.baseAttrs[i].id);
                this.____1555[i].setString(name + "：");
                for (var j = 0; j < this._info.attList.length; j++) {
                    if (this._info.attList[j].id == this._info.template.baseAttrs[i].id) {
                        if (!____655.____659.propertyType.isPerProperty(this._info.attList[j].id)) {
                            this.____1568[i].setString(this._info.attList[j].value)
                        } else {
                            if (this._info.attList[j].value > 0) {
                                var value = this._info.attList[j].value / 100;
                                this.____1568[i].setString(value + "%")
                            } else {
                                isShowTips = true;
                                this.____1568[i].setString("")
                            }
                        }
                    }
                }
                this.____1565.setVisible(isShowTips);
                this._proTipsLabel2.setVisible(isShowTips);
                var posX = this.____1555[i].getPositionX();
                var width = this.____1555[i].getContentSize().width;
                this.____1568[i].setPositionX(posX + width);
                if (nextTemplate != null && this._info.starCount < this._maxStar) {
                    if (!____655.____659.propertyType.isPerProperty(nextTemplate.baseAttrs[i].id)) {
                        var proPlusValue = nextTemplate.baseAttrs[i].value - this._info.template.baseAttrs[i].value;
                        this._proPlusValueList[i].setString("+" + proPlusValue)
                    } else {
                        if (!isShowTips) {
                            var proPlusValue = nextTemplate.baseAttrs[i].value - this._info.template.baseAttrs[i].value;
                            var value = proPlusValue / 100;
                            this._proPlusValueList[i].setString("+" + value + "%")
                        } else {
                            this._proPlusValueList[i].setString("")
                        }
                    }
                } else {
                    this._proPlusValueList[i].setString("")
                }
            }
        }
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____995, this._info.fight)
        } else {
            this._addNumberUtils.setValue(this._info.fight)
        }
    },
    materialUpdate: function() {
        if (this._info == null || this._type == 1) return;
        if (this._info.template.needItems.length > 1) {
            this.____1393.setVisible(true);
            this.____1392.setVisible(false);
            for (var i = 0; i < 2; i++) {
                var itemTempInfo = ____655.allTemplates.____794.getItem(this._info.template.needItems[i][0]);
                this.____1385[i].setItemTemplateInfo(itemTempInfo)
            }
            this.____1829.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text3"))
        } else {
            this.____1393.setVisible(false);
            this.____1392.setVisible(true);
            var itemTempInfo = ____655.allTemplates.____794.getItem(this._info.template.needItems[0][0]);
            this.____1388.setItemTemplateInfo(itemTempInfo);
            this.____1391.setString(itemTempInfo.name);
            this.____1391.setColor(____655.____659.____688.getColorByQuality(itemTempInfo.quality));
            this.____1829.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text2"))
        }
        this.materialCountUpdate()
    },
    materialCountUpdate: function() {
        if (this._info == null) return;
        if (this._info.starCount >= this._maxStar) {
            this.____919.setVisible(false);
            this._upBtn.setVisible(false);
            this.____1544.setVisible(false);
            this.____1829.setVisible(false);
            this._buyTipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text12"));
            this._buyTipsLabel.setColor(____655.____659.____688.yellow);
            var posX = 65;
            var posY = 43;
            this._buyTipsLabel.setPosition(____654.____673.____159(posX, posY));
            this.____1418.setVisible(false);
            this.____1385[0].setCount(-1);
            this.____1385[1].setCount(-1);
            this._materialBar.setPercent(0);
            var hasCount = ____655.itemInfoList.getCountByTempId(this._info.template.needItems[0][0]);
            this.____1387.setString(hasCount);
            if (this.____1828 != null) {
                this.____1828.dispose();
                this.____1828 = null
            }
            return
        }
        var isCanUp = true;
        var totalPrice = 0;
        if (this._info.template.needItems.length == 1) {
            var needCount = this._info.template.needItems[0][1];
            var hasCount = ____655.itemInfoList.getCountByTempId(this._info.template.needItems[0][0]);
            var percent = Math.floor(hasCount / needCount * 100);
            if (percent > 100) percent = 100;
            this._materialBar.setPercent(percent);
            this.____1387.setString(hasCount + "/" + needCount);
            if (hasCount < needCount) {
                var item = ____655.allTemplates.shopTemplateList.getZuanshiShopItemByTempId(this._info.template.needItems[0][0]);
                if (item == null) {
                    print("进阶材料不能购买，价格为NULL", this._info.template.needItems[0][0])
                } else {
                    totalPrice = item.price * (needCount - hasCount)
                }
                isCanUp = false
            }
            this._buyTipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text6"))
        } else {
            for (var i = 0; i < 2; i++) {
                var needCount = this._info.template.needItems[i][1];
                var hasCount = ____655.itemInfoList.getCountByTempId(this._info.template.needItems[i][0]);
                this.____1385[i].setNeedCount(hasCount, this._info.template.needItems[i][1]);
                if (hasCount < needCount) {
                    var item = ____655.allTemplates.shopTemplateList.getZuanshiShopItemByTempId(this._info.template.needItems[i][0]);
                    if (item == null) {
                        print("进阶材料不能购买，价格为NULL", this._info.template.needItems[i][0])
                    } else {
                        totalPrice = item.price * (needCount - hasCount) + totalPrice
                    }
                    isCanUp = false
                }
            }
            this._buyTipsLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text5"))
        }
        if (isCanUp) {
            this.____1544.setString(0);
            this.____1812 = 0;
            this.____919.setTouchEnabled(false);
            this.____919.setFrame("btn/ui_btn1_4.png");
            this._upBtn.setTouchEnabled(true);
            this._upBtn.setFrame("btn/ui_btn1_2.png");
            this._buyTipsLabel.setVisible(false);
            if (this.____1828 == null) {
                this.____1828 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                this.____1828.setScaleX(0.85);
                this.____1828.move(815, 52);
                this.____1828.play();
                this.____1828.addTo(this, 10)
            }
        } else {
            this.____1544.setString(totalPrice);
            this.____1812 = totalPrice;
            this.____919.setTouchEnabled(true);
            this.____919.setFrame("btn/ui_btn1_3.png");
            this._upBtn.setTouchEnabled(false);
            this._upBtn.setFrame("btn/ui_btn1_4.png");
            this._buyTipsLabel.setVisible(true);
            if (this.____1828 != null) {
                this.____1828.dispose();
                this.____1828 = null
            }
        }
    },
    setStar: function(starIndex) {
        if (this._info == null || starIndex <= 0) return;
        var stage = ____655.allTemplates.advanceTemplateList.getStageByStar(starIndex);
        var myStage = ____655.allTemplates.advanceTemplateList.getStageByStar(this._info.starCount);
        var count = 0;
        if (stage <= myStage) {
            count = ____655.allTemplates.advanceTemplateList.getCurrentStar(starIndex)
        }
        var colorIndex = Math.floor(stage / 2) + 1;
        var totalCount = ____655.allTemplates.advanceTemplateList.getCurTotalStar(stage);
        this.____1716.____363(totalCount, count, colorIndex)
    },
    setStage: function(starCount) {
        if (starCount <= 0) return;
        var myStarCount = 0;
        var myUseStar = 0;
        if (this._info != null) {
            myStarCount = this._info.starCount;
            myUseStar = this._info.currentUseStar
        }
        if (this._currentStar == starCount) return;
        var showStage = ____655.allTemplates.advanceTemplateList.getStageByStar(starCount);
        var myStage = ____655.allTemplates.advanceTemplateList.getStageByStar(myStarCount);
        if (showStage > myStage + 3) {
            return
        }
        if (showStage == myStage + 3) {
            ____654.shaderCache.setColor(this.____1593, 1)
        } else {
            ____654.shaderCache.setColor(this.____1593, 0)
        }
        this.____1336.setTouchEnabled(showStage > 1);
        this._currentStar = starCount;
        this.____1593.setTouchEnabled(showStage < this.____1402);
        if (showStage > 10) {
            this.____1701.setVisible(false);
            this.____1702.setVisible(true);
            this.____1705.setVisible(true);
            this.____1704.setString(9);
            this.____1705.setString(showStage - 11)
        } else {
            this.____1701.setVisible(true);
            this.____1702.setVisible(false);
            this.____1705.setVisible(false);
            this.____1704.setString(showStage - 1)
        }
        var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(this._panelType, starCount);
        if (stageTempInfo != null) {
            this.showCharacter(stageTempInfo, starCount);
            this.setStar(starCount);
            this._nameLabel.setString(stageTempInfo.name);
            var colorIndex = Math.floor(showStage / 2) + 1;
            if (colorIndex > 6) {
                colorIndex = 6
            }
            this._nameLabel.setColor(____655.____659.____688.itemColorList[colorIndex])
        }
        this.huanHuaBtnUpdate(myUseStar)
    },
    huanHuaBtnUpdate: function(myUseStar) {
        if (this._type == 1) {
            this.____823.setVisible(false);
            this.____1832.setVisible(false);
            this.____1833.setVisible(false);
            this.____1832.setTouchEnabled(false)
        } else {
            var starCount = this._currentStar;
            var myUseStar = myUseStar;
            var myStarCount = 0;
            if (this._info != null) {
                myStarCount = this._info.starCount
            }
            if (myUseStar == 0) {
                var index = ____655.____659.commonStaticType.advanceTypeList.indexOf(this._panelType);
                var fashionType = ____655.____659.commonStaticType.fashionTypeList[index];
                if (fashionType != null) {
                    var fashionInfo = ____655.fashionInfo.getFashion(fashionType);
                    if (fashionInfo == null || fashionInfo.currentHuaxing <= 0) {
                        myUseStar = myStarCount
                    }
                } else {
                    myUseStar = myStarCount
                }
            }
            var myUseStage = ____655.allTemplates.advanceTemplateList.getStageByStar(myUseStar);
            var showStage = ____655.allTemplates.advanceTemplateList.getStageByStar(starCount);
            if (starCount > myStarCount) {
                this.____823.setVisible(true);
                this.____1832.setVisible(false);
                this.____1832.setTouchEnabled(false);
                this.____1833.setVisible(false)
            } else if (myUseStage == showStage) {
                this.____823.setVisible(false);
                this.____1832.setVisible(true);
                this.____1832.setTouchEnabled(false);
                this.____1832.setFrame("btn/ui_btn1_4.png");
                this.____1833.setVisible(true);
                if (this._panelType == ____655.____659.commonStaticType.style_Horse) {
                    this.____1833.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text7"))
                } else if (this._panelType == ____655.____659.commonStaticType.style_Pet) {
                    this.____1833.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text8"))
                } else {
                    this.____1833.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text9"))
                }
            } else {
                this.____823.setVisible(false);
                this.____1832.setVisible(true);
                this.____1832.setTouchEnabled(true);
                this.____1832.setFrame("btn/ui_btn1_2.png");
                this.____1833.setVisible(true);
                if (this._panelType == ____655.____659.commonStaticType.style_Horse) {
                    this.____1833.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text10"))
                } else if (this._panelType == ____655.____659.commonStaticType.style_Pet) {
                    this.____1833.setString(____654.yuyanbaoManager.getYuyanbao("____2326.text11"))
                } else {
                    this.____1833.setString(____654.yuyanbaoManager.getYuyanbao("itemTip.btnLabel7"))
                }
            }
        }
    },
    showCharacter: function(stageTempInfo, starCount) {
        if (stageTempInfo == null) return;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._characterEffect == null) {
            this._characterEffect = ____654.effectManager.create(____655.allTemplates.____789.CHARACTER_BG_EFFECT, false, null, false);
            this._characterEffect.setScale(1);
            this._characterEffect.move(162, 69);
            this._characterEffect.play();
            this._characterEffect.addTo(this.____1674)
        }
        if (this._panelType == ____655.____659.commonStaticType.style_Horse) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Horse] = stageTempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Horse, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(stageTempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var y = (83 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(156, y)
        } else if (this._panelType == ____655.____659.commonStaticType.style_Pet) {
            this._characterInfo = ____654.getCharacterInfo(stageTempInfo.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(stageTempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var y = (70 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(165, y)
        } else if (this._panelType == ____655.____659.commonStaticType.style_Wind) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Wind] = stageTempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Wind, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(stageTempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var y = (47 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(166, y)
        } else if (this._panelType == ____655.____659.commonStaticType.style_Foot) {
            this.____944 = new FootShowEffect(starCount);
            this.____944.setPosition(____654.____673.____159(24, 120));
            this.____1674.addChild(this.____944)
        } else if (this._panelType == ____655.____659.commonStaticType.style_FaBao) {
            var effectId = parseInt(stageTempInfo.figureId);
            this.____944 = ____654.effectManager.create(effectId, false, null, false);
            this.____944.move(164, 120);
            this.____944.play();
            this.____944.addTo(this.____1674)
        } else if (this._panelType == ____655.____659.commonStaticType.style_ZhengLing) {
            var effectId = parseInt(stageTempInfo.figureId);
            this.____944 = ____654.effectManager.create(effectId, false, null, false);
            this.____944.move(164, 160);
            this.____944.play();
            this.____944.addTo(this.____1674)
        } else if (this._panelType == ____655.____659.commonStaticType.style_ShenJian) {
            var effectId = parseInt(stageTempInfo.figureId);
            this.____944 = ____654.effectManager.create(effectId, false, null, false);
            this.____944.move(164, 110);
            this.____944.play();
            this.____944.addTo(this.____1674)
        }
    },
    danCountUpdate: function() {
        if (this._info == null) return;
        if (this._type == 1) {
            this.____1082[1].setString("");
            this.____1081[1].setVisible(false);
            this.____1082[0].setString("");
            this.____1081[0].setVisible(false)
        } else {
            var stageTempInfo = ____655.allTemplates.advanceTemplateList.getStageInfo(this._panelType, this._info.starCount);
            var hasCount1 = ____655.itemInfoList.getCountByTempId(stageTempInfo.qianNengId);
            this.____1573 = Math.min(hasCount1, stageTempInfo.qianNengMax - this._info.qiangNeng);
            if (hasCount1 > 0) {
                this.____1082[0].setString(hasCount1);
                this.____1081[0].setVisible(true);
                if (this._info.qiangNeng < stageTempInfo.qianNengMax) {
                    if (this.____1572 == null) {
                        this.____1572 = new OpacityEffect("effect/effect_13.png", -5);
                        this.____1572.move(297, 169);
                        this.addChild(this.____1572, 11)
                    }
                } else {
                    if (this.____1572 != null) {
                        this.____1572.dispose();
                        this.____1572 = null
                    }
                }
            } else {
                this.____1082[0].setString("");
                this.____1081[0].setVisible(false);
                if (this.____1572 != null) {
                    this.____1572.dispose();
                    this.____1572 = null
                }
            }
            var hasCount2 = ____655.itemInfoList.getCountByTempId(stageTempInfo.wuxingId);
            this.____1880 = Math.min(hasCount2, stageTempInfo.wuxingMax - this._info.wuxing);
            if (hasCount2 > 0) {
                this.____1082[1].setString(hasCount2);
                this.____1081[1].setVisible(true);
                if (this._info.wuxing < stageTempInfo.wuxingMax) {
                    if (this.____1879 == null) {
                        this.____1879 = new OpacityEffect("effect/effect_13.png", -5);
                        this.____1879.move(527, 169);
                        this.addChild(this.____1879, 11)
                    }
                } else {
                    if (this.____1879 != null) {
                        this.____1879.dispose();
                        this.____1879 = null
                    }
                }
            } else {
                this.____1082[1].setString("");
                this.____1081[1].setVisible(false);
                if (this.____1879 != null) {
                    this.____1879.dispose();
                    this.____1879 = null
                }
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        this._nameLabel = null;
        this.____1832 = null;
        this.____1833 = null;
        this.____995 = null;
        this.____1555 = null;
        this.____1568 = null;
        this._proPlusValueList = null;
        this._upBtn = null;
        this.____1829 = null;
        this.____1392 = null;
        this.____1388.dispose();
        this.____1388 = null;
        this.____1393 = null;
        for (var i = 0; i < this.____1385.length; i++) {
            this.____1385[i].dispose();
            this.____1385[i] = null
        }
        this.____1385 = null;
        this.____1387 = null;
        this._materialBar = null;
        this.____1391 = null;
        this.____1544 = null;
        this.____919 = null;
        ____654.shaderCache.removeColor(this.____1336);
        this.____1336 = null;
        ____654.shaderCache.removeColor(this.____1593);
        this.____1593 = null;
        if (this._info != null) {
            this._info.removeEventListener(____655.____661.advance_useStarUpdate, this.useStarUpdate, this);
            this._info.removeEventListener(____655.____661.advance_danUpdate, this.danUpdateHandler, this);
            this._info.removeEventListener(____655.____661.adavnce_propertyUpdate, this.setProValue, this);
            this._info = null
        }
        this.____1752 = null;
        this.____1565 = null;
        this._proTipsLabel2 = null;
        this.____1704 = null;
        this.____1705 = null;
        this.____1701 = null;
        this.____1702 = null;
        this.____1674 = null;
        this.____823 = null;
        this.____1080 = null;
        this.____1082 = null;
        this.____1081 = null;
        this._maxStar = null;
        this._buyTipsLabel = null;
        this._panelType = null;
        this._currentStar = null;
        this.____1402 = null;
        this._info = null;
        this.____1573 = null;
        this.____1880 = null;
        this.____1812 = null;
        this._btnView = null;
        this._skillView = null;
        this.____1563 = null;
        this._charaterView = null;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this.____1679 != null) {
            for (var i = 0; i < this.____1679.length; i++) {
                this.____1679[i].dispose()
            }
            this.____1679 = null
        }
        if (this.____1138 != null) {
            for (var i = 0; i < this.____1138.length; i++) {
                this.____1138[i].dispose()
            }
            this.____1138 = null
        }
        if (this.____1828 != null) {
            this.____1828.dispose();
            this.____1828 = null
        }
        if (this.____1572 != null) {
            this.____1572.dispose();
            this.____1572 = null
        }
        if (this.____1879 != null) {
            this.____1879.dispose();
            this.____1879 = null
        }
        if (this._characterEffect != null) {
            this._characterEffect.dispose();
            this._characterEffect = null
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this.____1716.dispose();
        this.____1716 = null;
        this._pageDownPos = null;
        this._downPos = null;
        this.____1418 = null;
        ____654.tipsManager.hideFlashTip();
        this._super()
    },
});
var ____2327 = KYPanel.extend({
    _controller: null,
    _bg: null,
    _bgPath: null,
    ____995: null,
    _upBtn: null,
    ____1706: null,
    ____1555: null,
    ____1568: null,
    _proPlusValueList: null,
    ____865: null,
    ____861: null,
    ____1185: null,
    ____1829: null,
    ____1674: null,
    _moneyView: null,
    ____1637: -1,
    ____1252: null,
    ____1076: null,
    ____1031: null,
    _panelType: 0,
    ____1151: null,
    ____1042: 0,
    ____1043: 0,
    _tileContainer: null,
    ____944: null,
    _characterInfo: null,
    _characterEffect: null,
    _addNumberUtils: null,
    ____1828: null,
    ____1834: true,
    ctor: function(controller, panelType) {
        this._super("waiGuanChangePanel.ExportJson");
        this._controller = controller;
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/role_fasionBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this.____995 = this.getChildByName("combatLabel");
        this._upBtn = this.getChildByName("upBtn");
        this.____865 = this.getChildByName("moneyLabel");
        this.____861 = this.getChildByName("countBar");
        this.____1185 = this.getChildByName("addBtn");
        this.____1829 = this.getChildByName("upBtnLabel");
        this.____1674 = this.getChildByName("show_panel");
        this.____1706 = [];
        this.____1555 = [];
        this.____1568 = [];
        this._proPlusValueList = [];
        for (var i = 1; i <= 5; i++) {
            this.____1706.push(this.getChildByName("starIcon" + i))
        }
        for (var i = 1; i <= 4; i++) {
            this.____1555.push(this.getChildByName("proName" + i));
            this.____1568.push(this.getChildByName("proValue" + i));
            this._proPlusValueList.push(this.getChildByName("proPlusValue" + i))
        }
        this._tileContainer = this.getChildByName("btnListView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._panelType = panelType;
        this.____5();
        this.____6()
    },
    ____6: function() {
        this.____1185.addListener(this, this.____16);
        this._upBtn.addListener(this, this.____16);
        ____655.fashionInfo.addEventListener(____655.____661.fashion_infoUpdate, this.updateInfoHandler, this);
        ____655.fashionInfo.addEventListener(____655.____661.fashion_hauxingUpdate, this.huaxingUpdate, this);
        ____654.____672.addEventListener(____655.____661.common_testerItemUpdate, this.updateCount, this)
    },
    ____17: function() {
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_infoUpdate, this.updateInfoHandler, this);
        ____655.fashionInfo.removeEventListener(____655.____661.fashion_hauxingUpdate, this.huaxingUpdate, this);
        ____654.____672.removeEventListener(____655.____661.common_testerItemUpdate, this.updateCount, this)
    },
    updateCount: function() {
        for (var i = 0; i < this.____1252.length; i++) {
            var tabBtn = this._tileContainer.getItemByIndex(i);
            if (tabBtn != null) {
                var tempInfo = tabBtn.getTempInfo();
                if (tabBtn != null && tempInfo != null) {
                    this.tabBtnSetCount(tabBtn, tempInfo)
                }
            }
        }
    },
    tabBtnSetCount: function(tabBtn, tempInfo) {
        var starLevel = 0;
        var selfInfo = ____655.fashionInfo.getFashionInfo(tempInfo.type, tempInfo.templateId);
        if (selfInfo != null) {
            starLevel = selfInfo.star
        }
        if (starLevel < tempInfo.maxStars) {
            var needItemId = tabBtn.getTempInfo().stars[starLevel + 1].needItems[0][0];
            var hasCount = ____654.playerInfoTester.hunshiList[needItemId];
            if (hasCount == null) {
                hasCount = 0
            }
            var needCount = tempInfo.stars[starLevel + 1].needItems[0][1];
            if (needCount > hasCount) {
                tabBtn.setShowPop(false)
            } else {
                tabBtn.setShowPop(true)
            }
            if (selfInfo == null) {
                tabBtn.updateCount(hasCount, needCount)
            }
        } else {
            tabBtn.setShowPop(false)
        }
    },
    huaxingUpdate: function(evt) {
        var data = evt.data;
        if (data == null) return;
        var type = data[0];
        var currentHuaxing = data[1];
        this.____1834 = true;
        if (currentHuaxing != null && currentHuaxing != this.____1042) {
            var tabBtn = this._tileContainer.getItemByIndex(this.____1043);
            if (tabBtn != null) {
                tabBtn.setUse(false)
            }
            this.____1042 = currentHuaxing;
            if (currentHuaxing > 0) {
                for (var i = 0; i < this.____1252.length; i++) {
                    var tabBtn2 = this._tileContainer.getItemByIndex(i);
                    if (tabBtn2 != null && tabBtn2.getTempInfoId() != null && tabBtn2.getTempInfoId() == currentHuaxing) {
                        this.____1043 = i;
                        tabBtn2.setUse(true);
                        break
                    }
                }
            }
        }
    },
    updateInfoHandler: function(evt) {
        var data = evt.data;
        if (data == null) return;
        var type = data[0];
        if (type != null && type == this._panelType) {
            var index = this.____1637;
            this.____1637 = -1;
            this.____225(index, true)
        }
    },
    ____5: function() {
        var this_ = this;

        function sortFunc(item1, item2) {
            var info1 = ____655.fashionInfo.getFashionInfo(this_._panelType, item1.templateId);
            var info2 = ____655.fashionInfo.getFashionInfo(this_._panelType, item2.templateId);
            if (info1 != null && info2 != null) {
                if (info2.star == info1.star) {
                    return item2.stars[1].fightValue - item1.stars[1].fightValue
                }
                return info2.star - info1.star
            } else if (info1 != null) {
                return -1
            } else if (info2 != null) {
                return 1
            }
            return item2.stars[1].fightValue - item1.stars[1].fightValue
        };
        this.____1151 = ____655.fashionInfo.getFashion(this._panelType);
        if (this.____1151 != null) {
            this.____1042 = this.____1151.currentHuaxing
        }
        this.____1252 = ____655.allTemplates.fashionTemplateList.getList(this._panelType);
        this.____1252.sort(sortFunc);
        this._tileContainer.setFormat(1, this.____1252.length, ____654.____673.____160(314, 110), 0, 0, true);
        this.____225(0)
    },
    getItemByIndex: function(index) {
        var tabBtn = new ____2236(index);
        tabBtn.____18(this._panelType, this.____1252[index]);
        tabBtn.addListener(this, this.tabBtnClickHandler, null, null, null, false, true);
        tabBtn.setClickCallBack(this.checkBoxClickHandler, this);
        if (this.____1042 == this.____1252[index].templateId) {
            this.____1043 = index;
            tabBtn.setUse(true)
        }
        if (this.____1637 == index) {
            tabBtn.____239(true)
        }
        this.tabBtnSetCount(tabBtn, this.____1252[index]);
        return tabBtn
    },
    getIdByIndex: function(index) {
        var info = this.____1252[index];
        if (info == null) return -1;
        return this.____1252[index].templateId
    },
    checkItemSelect: function() {
        if (this.____1252 != null) {
            for (var i = 0; i < this.____1252.length; i++) {
                var tempInfo = this.____1252[i];
                if (this.checkIsCanUp(tempInfo)) {
                    this.____225(i);
                    return
                }
            }
            this.____225(0)
        }
    },
    checkIsCanUp: function(tempInfo, isShowTip) {
        if (tempInfo == null) return false;
        var info = ____655.fashionInfo.getFashionInfo(this._panelType, tempInfo.templateId);
        var starLevel = 0;
        if (info != null) {
            starLevel = info.star
        }
        if (tempInfo.stars[starLevel + 1] == null) {
            return false
        } else {
            var hasCount = ____655.itemInfoList.getCountByTempId(tempInfo.stars[starLevel + 1].needItems[0][0]);
            var needCount = tempInfo.stars[starLevel + 1].needItems[0][1];
            if (hasCount >= needCount) {
                return true
            } else {
                if (isShowTip != null && isShowTip) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2327.text1"))
                }
                return false
            }
        }
        return false
    },
    tabBtnClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = sender.getIndex();
            this.____225(index)
        }
    },
    checkBoxClickHandler: function(tabBtn) {
        if (this.____1834 == false) return;
        var index = tabBtn.getIndex();
        this.____225(index);
        var tempInfo = tabBtn.getTempInfo();
        if (tempInfo == null) return;
        var info = ____655.fashionInfo.getFashionInfo(this._panelType, tempInfo.templateId);
        if (info != null) {
            var index2 = ____655.____659.commonStaticType.fashionTypeList.indexOf(this._panelType);
            var advanceType = ____655.____659.commonStaticType.advanceTypeList[index2];
            if (tempInfo.templateId == this.____1042) {
                ____654.fashionMessageSender.sendMoveEquip(this.____1076.templateId, 0, advanceType, this._panelType, 2);
                tabBtn.setUse(false)
            } else {
                ____654.fashionMessageSender.sendMoveEquip(this.____1076.templateId, 0, advanceType, this._panelType, 1);
                var btn = this._tileContainer.getItemByIndex(this.____1043);
                if (btn != null) {
                    btn.setUse(false)
                }
                this.____1043 = index;
                this.____1042 = tempInfo.templateId;
                tabBtn.setUse(true)
            }
            this.____1834 = false
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1185) {
                if (this.____1076 == null || this.____1076.deploy.length <= 0) {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2327.text1"));
                    return
                }
                if (this.____1076.deploy.length > 0) {
                    ____654.triggerManager.handlerList(this.____1076.deploy)
                }
            } else if (sender == this._upBtn) {
                if (this.checkIsCanUp(this.____1076, true)) {
                    if (this.____1031 != null) {
                        ____654.fashionMessageSender.sendUpStar(this._panelType, this.____1076.templateId)
                    } else {
                        ____654.fashionMessageSender.sendActive(this._panelType, this.____1076.templateId)
                    }
                }
            }
        }
    },
    ____225: function(index, isInfoUpdate) {
        if (index == this.____1637) return;
        var tempInfo = this.____1252[index];
        if (tempInfo == null) {
            return
        }
        this.____1076 = tempInfo;
        var tabBtn = this._tileContainer.getItemByIndex(this.____1637);
        if (tabBtn != null) {
            tabBtn.____239(false)
        }
        this.____1637 = index;
        var curTabBtn = this._tileContainer.getItemByIndex(this.____1637);
        if (curTabBtn != null) {
            curTabBtn.____239(true)
        }
        var starLevel = 1;
        this.____1031 = ____655.fashionInfo.getFashionInfo(this._panelType, tempInfo.templateId);
        if (this.____1031 == null) {
            this.setStar(0);
            this.____1829.setString(____654.yuyanbaoManager.getYuyanbao("____2235.text3"))
        } else {
            starLevel = this.____1031.star;
            this.setStar(starLevel);
            this.____1829.setString(____654.yuyanbaoManager.getYuyanbao("____2235.text4"))
        }
        var starTempInfo = tempInfo.stars[starLevel];
        var nextStarTempInfo = tempInfo.stars[starLevel + 1];
        if (starTempInfo != null) {
            if (this._addNumberUtils == null) {
                this._addNumberUtils = new AddNumberUtils(this.____995, starTempInfo.fightValue)
            }
            if (isInfoUpdate != null && isInfoUpdate) {
                this._addNumberUtils.setValue(starTempInfo.fightValue, true)
            } else {
                this._addNumberUtils.setValue(starTempInfo.fightValue, false)
            }
            for (var i = 0; i < this.____1555.length; i++) {
                if (starTempInfo.attrStr[i] != null) {
                    var name = ____655.____659.propertyType.getNameByType(starTempInfo.attrStr[i].id);
                    this.____1555[i].setString(name + "：");
                    this.____1568[i].setString(starTempInfo.attrStr[i].value)
                } else {
                    this.____1555[i].setString("");
                    this.____1568[i].setString("")
                }
            }
        }
        if (nextStarTempInfo != null) {
            var hasCount = 0;
            var needCount = 0;
            if (this.____1031 != null) {
                for (var i = 0; i < this._proPlusValueList.length; i++) {
                    if (nextStarTempInfo.attrStr[i] != null && starTempInfo != null) {
                        var value = nextStarTempInfo.attrStr[i].value - starTempInfo.attrStr[i].value;
                        this._proPlusValueList[i].setString("+" + value)
                    } else {
                        this._proPlusValueList[i].setString("")
                    }
                }
                hasCount = ____655.itemInfoList.getCountByTempId(nextStarTempInfo.needItems[0][0]);
                needCount = nextStarTempInfo.needItems[0][1]
            } else {
                for (var i = 0; i < this._proPlusValueList.length; i++) {
                    this._proPlusValueList[i].setString("")
                }
                hasCount = ____655.itemInfoList.getCountByTempId(starTempInfo.needItems[0][0]);
                needCount = starTempInfo.needItems[0][1]
            }
            var percent = Math.floor(hasCount / needCount * 100);
            if (percent > 100) percent = 100;
            this.____861.setPercent(percent);
            this.____865.setString(hasCount + "/" + needCount);
            this._upBtn.setFrame("btn/ui_btn1_2.png");
            this._upBtn.setTouchEnabled(true);
            if (hasCount >= needCount) {
                if (this.____1828 == null) {
                    this.____1828 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                    this.____1828.setScaleX(1.2);
                    this.____1828.move(774, 66);
                    this.____1828.play();
                    this.____1828.addTo(this, 10)
                }
            } else {
                if (this.____1828 != null) {
                    this.____1828.dispose();
                    this.____1828 = null
                }
            }
        } else {
            for (var i = 0; i < this._proPlusValueList.length; i++) {
                if (this._proPlusValueList[i] != null) {
                    this._proPlusValueList[i].setString("")
                }
            }
            this.____861.setPercent(100);
            this.____865.setString("MAX");
            this.____1829.setString(____654.yuyanbaoManager.getYuyanbao("____2235.text5"));
            this._upBtn.setFrame("btn/ui_btn1_4.png");
            this._upBtn.setTouchEnabled(false);
            if (this.____1828 != null) {
                this.____1828.dispose();
                this.____1828 = null
            }
        }
        this.showCharacter(tempInfo)
    },
    showCharacter: function(tempInfo) {
        if (tempInfo == null) return;
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._characterEffect == null) {
            this._characterEffect = ____654.effectManager.create(____655.allTemplates.____789.CHARACTER_BG_EFFECT, false, null, false);
            this._characterEffect.move(167, 75);
            this._characterEffect.play();
            this._characterEffect.addTo(this.____1674)
        }
        if (this._panelType == ____655.____659.commonStaticType.style_fashion_horse) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Horse] = tempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Horse, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var y = (83 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(185, y)
        } else if (this._panelType == ____655.____659.commonStaticType.style_fashion_wing) {
            var styleList = {};
            styleList[____655.____659.commonStaticType.style_Wind] = tempInfo.figureId;
            this._characterInfo = new CharacterInfo(____655.____659.commonStaticType.style_Wind, ____655.____659.____687.playerStand2);
            this._characterInfo.updateStyle(styleList);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var y = (27 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(181, y)
        } else if (this._panelType == ____655.____659.commonStaticType.style_fashion_pet) {
            this._characterInfo = ____654.getCharacterInfo(tempInfo.figureId, ____655.____659.____687.stand);
            this.____944 = new ____545(this._characterInfo);
            this.____944.init(____655.____659.____686.rightBottom, this.____1674);
            var figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(tempInfo.figureId).getFigureTemplate();
            var scaleValue = figureTemplate.windowScale;
            this.____944.setScale(scaleValue);
            var y = (70 + figureTemplate.windowOffsetY) * scaleValue;
            this.____944.move(165, y)
        }
    },
    setStar: function(count) {
        for (var i = 0; i < this.____1706.length; i++) {
            if (i < count) {
                this.____1706[i].setFrame("icon/ui_startIcon1.png")
            } else {
                this.____1706[i].setFrame("icon/ui_startIcon0.png")
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1151 = null;
        this._tileContainer = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this.____944 != null) {
            this.____944.dispose();
            this.____944 = null
        }
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        if (this._characterEffect != null) {
            this._characterEffect.dispose();
            this._characterEffect = null
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        if (this.____1828 != null) {
            this.____1828.dispose();
            this.____1828 = null
        }
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        this.____995 = null;
        this._upBtn = null;
        this.____1706 = null;
        this.____1555 = null;
        this.____1568 = null;
        this._proPlusValueList = null;
        this.____865 = null;
        this.____861 = null;
        this.____1185 = null;
        this.____1829 = null;
        this.____1637 = null;
        this.____1252 = null;
        this.____1076 = null;
        this.____1031 = null;
        this._panelType = null;
        this.____1077 = null;
        this.____1834 = null;
        this._super()
    },
});
var ____2328 = ____2327.extend({
    _controller: null,
    ctor: function(controller) {
        this._controller = controller;
        var type = ____655.____659.commonStaticType.style_fashion_pet;
        this._super(controller, type)
    },
    dispose: function() {
        this._controller = null;
        this._super()
    },
});
var ____2329 = ____2327.extend({
    _controller: null,
    ctor: function(controller) {
        this._controller = controller;
        var type = ____655.____659.commonStaticType.style_fashion_horse;
        this._super(controller, type)
    },
    dispose: function() {
        this._controller = null;
        this._super()
    },
});
var ____2330 = KYPanel.extend({
    _controller: null,
    ____1740: null,
    _bg: null,
    _bgPath: null,
    ____995: null,
    _materGrid: null,
    _upBtn: null,
    ____1391: null,
    _countLabel: null,
    ____1555: null,
    ____1568: null,
    _proPlusValueList: null,
    ____1636: null,
    _countPerPage: 0,
    _starPerPage: 0,
    _maxLevel: 0,
    _curType: 0,
    _combatView: null,
    _materialView: null,
    ____892: null,
    ____1563: null,
    _curLevel: 0,
    ____1828: null,
    ____1774: 82,
    plusNum: 2,
    _advanceInfo: null,
    _addNumberUtils: null,
    _myLevel: 0,
    _oldType: 0,
    _moneyView: null,
    _addFriendBtn: null,
    _effectIdList: null,
    _effectList: null,
    _effectLevelList: null,
    _type: 0,
    ctor: function(controller, index, type) {
        this._super("waiGuanSoulPanel.ExportJson");
        this._controller = controller;
        this._type = type;
        this.____1740 = this.getChildByName("tabLayer");
        this._combatView = this.getChildByName("combatView");
        this.____995 = this._combatView.getChildByName("combatLabel");
        this._materialView = this.getChildByName("materialView");
        this.____892 = this._materialView.getChildByName("btnLabel");
        var materialCell = this._materialView.getChildByName("materialCell");
        this._materGrid = new ____2129();
        materialCell.addChild(this._materGrid);
        this._upBtn = this._materialView.getChildByName("upBtn");
        this.____1391 = this._materialView.getChildByName("materialLabel");
        this._countLabel = this._materialView.getChildByName("countLabel");
        this._bg = this.getChildByName("bg");
        this.____1636 = this.getChildByName("selectImg");
        this._addFriendBtn = this.getChildByName("addFriendBtn");
        this.getChildByName("tipLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2238.text1"));
        this.____892.setString("炼 魂");
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this.____1555 = [];
        this.____1568 = [];
        this._proPlusValueList = [];
        this.____1563 = this.getChildByName("propertyView");
        for (var i = 1; i <= 4; i++) {
            this.____1555.push(this.____1563.getChildByName("proName" + i));
            this.____1568.push(this.____1563.getChildByName("proValue" + i));
            this._proPlusValueList.push(this.____1563.getChildByName("proPlusValue" + i))
        }
        this.____1824 = [____655.____659.commonStaticType.style_Horse, ____655.____659.commonStaticType.style_Pet, ____655.____659.commonStaticType.style_Wind, ____655.____659.commonStaticType.style_Foot, ____655.____659.commonStaticType.style_FaBao, ____655.____659.commonStaticType.style_ZhengLing, ____655.____659.commonStaticType.style_ShenJian];
        this._posList = {};
        this._posList[____655.____659.commonStaticType.style_Horse] = [
            [370, 423],
            [445, 364],
            [395, 278],
            [500, 237],
            [564, 320],
            [646, 252],
            [748, 278],
            [729, 370]
        ];
        this._posList[____655.____659.commonStaticType.style_Pet] = [
            [430, 418],
            [392, 327],
            [473, 301],
            [549, 353],
            [535, 243],
            [610, 292],
            [715, 278],
            [680, 383]
        ];
        this._posList[____655.____659.commonStaticType.style_Wind] = [
            [434, 440],
            [404, 342],
            [462, 274],
            [551, 314],
            [552, 219],
            [647, 274],
            [705, 343],
            [677, 440]
        ];
        this._posList[____655.____659.commonStaticType.style_Foot] = [
            [384, 377],
            [459, 431],
            [548, 401],
            [608, 343],
            [513, 293],
            [610, 238],
            [714, 266],
            [723, 359]
        ];
        this._posList[____655.____659.commonStaticType.style_FaBao] = [
            [370, 423],
            [494, 411],
            [416, 309],
            [485, 235],
            [572, 292],
            [682, 234],
            [747, 318],
            [687, 412]
        ];
        this._posList[____655.____659.commonStaticType.style_ZhengLing] = [
            [403, 431],
            [454, 359],
            [401, 269],
            [504, 275],
            [574, 333],
            [615, 237],
            [686, 335],
            [674, 431]
        ];
        this._posList[____655.____659.commonStaticType.style_ShenJian] = [
            [412, 414],
            [377, 329],
            [415, 244],
            [494, 292],
            [516, 388],
            [600, 325],
            [695, 347],
            [676, 445]
        ];
        this._effectLevelList = [40, 41, 42, 43, 44, 39];
        this._effectIdList = [0, 0, 0, 0, 0, 0, 0, 0];
        this._effectList = [null, null, null, null, null, null, null, null];
        this._countPerPage = ____655.allTemplates.hunPoTemplateList.getLevelPerRound();
        this._starPerPage = 10;
        if (this._type == 1) {
            this._materialView.setVisible(false);
            this.____1563.setPositionY(30);
            this._combatView.setPositionY(133);
            this._moneyView.setVisible(false)
        } else {
            this._addFriendBtn.setVisible(false);
            this.getChildByName("tipLabel").setVisible(false);
            this.getChildByName("addIcon").setVisible(false)
        }
        this.____6();
        this.____5(index)
    },
    ____6: function() {
        if (this._type == 1) {
            this._addFriendBtn.addListener(this, this.addFriendHandler)
        } else {
            this._upBtn.addListener(this, this.____16);
            ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.setMaterialView, this);
            ____655.advanceItemList.addEventListener(____655.____661.advance_soulUpdate, this.soulLevelUpdate, this);
            ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this);
            ____654.____672.addEventListener(____655.____661.advance_infoUpdate, this.setMaterialView, this)
        }
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.setMaterialView, this);
        ____655.advanceItemList.removeEventListener(____655.____661.advance_soulUpdate, this.soulLevelUpdate, this);
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.removeEventListener(____655.____661.advance_infoUpdate, this.setMaterialView, this)
    },
    soulLevelUpdate: function(evt) {
        var type = evt.data;
        if (type != null && type == this._curType) {
            this._curLevel = ____655.advanceItemList.getSoulLevelByType(this._curType);
            this.updateView(true);
            var effect = ____654.effectManager.setEffect(38, false, ____654.____673.____159(555, 320), this, true, null, null, null, 100)
        }
    },
    ____5: function(index) {
        if (this._type == 1) {
            var playerLevel = ____655.lookInfo.playerInfo.level;
            this.____1738 = [
                [0, ____655.____659.nameType.advanceName[0], "icon/ui_waixingIcon1.png", playerLevel >= ____655.____659.levelType.riderLevel],
                [1, ____655.____659.nameType.advanceName[1], "icon/ui_waixingIcon2.png", playerLevel >= ____655.____659.levelType.petLevel],
                [2, ____655.____659.nameType.advanceName[2], "icon/ui_waixingIcon3.png", playerLevel >= ____655.____659.levelType.wingLevel],
                [3, ____655.____659.nameType.advanceName[3], "icon/ui_waixingIcon4.png", playerLevel >= ____655.____659.levelType.footLevel],
                [4, ____655.____659.nameType.advanceName[4], "icon/ui_waixingIcon5.png", playerLevel >= ____655.____659.levelType.fabaoLevel],
                [5, ____655.____659.nameType.advanceName[5], "icon/ui_waixingIcon6.png", playerLevel >= ____655.____659.levelType.zhenlingLevel],
                [6, ____655.____659.nameType.advanceName[6], "icon/ui_waixingIcon7.png", playerLevel >= ____655.____659.levelType.shenjianLevel]
            ]
        } else {
            this.____1738 = [
                [0, ____655.____659.nameType.advanceName[0], "icon/ui_waixingIcon1.png", true, ____655.____659.levelType.riderLevel],
                [1, ____655.____659.nameType.advanceName[1], "icon/ui_waixingIcon2.png", true, ____655.____659.levelType.petLevel],
                [2, ____655.____659.nameType.advanceName[2], "icon/ui_waixingIcon3.png", true, ____655.____659.levelType.wingLevel],
                [3, ____655.____659.nameType.advanceName[3], "icon/ui_waixingIcon4.png", true, ____655.____659.levelType.footLevel],
                [4, ____655.____659.nameType.advanceName[4], "icon/ui_waixingIcon5.png", true, ____655.____659.levelType.fabaoLevel],
                [5, ____655.____659.nameType.advanceName[5], "icon/ui_waixingIcon6.png", true, ____655.____659.levelType.zhenlingLevel],
                [6, ____655.____659.nameType.advanceName[6], "icon/ui_waixingIcon7.png", true, ____655.____659.levelType.shenjianLevel]
            ]
        }
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(540);
        this.____1740.addChild(this.____1737);
        if (index == null || index == 0) {
            var day = ____655.____662.getClientDate().getDay();
            if (day == 0) {
                day = 7
            }
            index = day
        }
        this.____1737.setTabIndex(index - 1);
        ____654.____678.____298(this.tick, this);
        if (this._type == 1) {} else {
            this.popUpdate()
        }
    },
    setTab: function(tab) {
        if (this.____1824[tab] != null) {
            this._curType = this.____1824[tab];
            this._maxLevel = ____655.allTemplates.hunPoTemplateList.getMaxLevel(this._curType);
            this._myLevel = 0;
            this._curLevel = ____655.advanceItemList.getSoulLevelByType(this._curType);
            this.updateView()
        }
    },
    updateView: function(isInfoUpdate) {
        if (this._type == 1) {
            this._curLevel = ____655.lookInfo.advanceItemList.getSoulLevelByType(this._curType);
            this._advanceInfo = ____655.lookInfo.advanceItemList.getItemByType(this._curType)
        } else {
            if (this._curType != this._oldType) {
                this._advanceInfo = ____655.advanceItemList.getItemByType(this._curType)
            }
            this.setMaterialView()
        }
        this._bgPath = ____654.____675.____139("outPic/star_bg" + this._curType + ".png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.setStar(this._curLevel);
        this.setProperty(isInfoUpdate)
    },
    setProperty: function(isInfoUpdate) {
        var propertyList = ____655.allTemplates.hunPoTemplateList.getTotalPropertyByLevel(this._curType, this._curLevel);
        var proTypeList = ____655.allTemplates.hunPoTemplateList.getProTypeList(this._curType);
        var fight = ____655.allTemplates.hunPoTemplateList.getFightByLevel(this._curType, this._curLevel);
        var plusValueList = ____655.allTemplates.hunPoTemplateList.getTotalPropertyByLevel(this._curType, this._curLevel + 1);
        if (proTypeList != null) {
            for (var i = 0; i < this.____1555.length; i++) {
                var propertyId = proTypeList[i];
                if (propertyId != null) {
                    var name = ____655.____659.propertyType.getNameByType(propertyId);
                    this.____1555[i].setString(name + "：");
                    var value = 0;
                    if (propertyList[propertyId] != null) {
                        value = propertyList[propertyId]
                    }
                    this.____1568[i].setString(value);
                    if (this._curLevel < this._maxLevel && this._type != 1) {
                        var plus = plusValueList[propertyId] - value;
                        this._proPlusValueList[i].setString("+" + plus)
                    } else {
                        this._proPlusValueList[i].setString("")
                    }
                } else {
                    this.____1555[i].setString("");
                    this.____1568[i].setString("");
                    this._proPlusValueList[i].setString("")
                }
            }
        }
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____995, fight)
        }
        if (isInfoUpdate != null && isInfoUpdate) {
            this._addNumberUtils.setValue(fight, true)
        } else {
            this._addNumberUtils.setValue(fight, false)
        }
    },
    setStar: function(level) {
        var count = level % this._countPerPage;
        var index = Math.floor(level / this._countPerPage);
        if (level >= this._maxLevel) {
            this.____1636.setVisible(false)
        } else {
            this.____1636.setVisible(true);
            if (this._posList[this._curType] != null) {
                var x = this._posList[this._curType][count][0];
                var y = this._posList[this._curType][count][1];
                this.____1636.setPosition(____654.____673.____159(x, y))
            }
        }
        for (var i = 0; i < 8; i++) {
            var id = 0;
            if (i < count) {
                id = this._effectLevelList[index]
            } else if (index > 0) {
                id = this._effectLevelList[index - 1]
            }
            var x = this._posList[this._curType][i][0];
            var y = this._posList[this._curType][i][1];
            if (this._effectIdList[i] != id) {
                this._effectIdList[i] = id;
                if (this._effectList[i] != null) {
                    this._effectList[i].dispose();
                    this._effectList[i] = null
                }
                if (id > 0) {
                    this._effectList[i] = ____654.effectManager.setEffect(id, false, ____654.____673.____159(x, y), this, false, null, null, null, 99)
                }
            } else {
                if (this._effectList[i] != null) {
                    this._effectList[i].move(x, y)
                }
            }
        }
    },
    setMaterialView: function(evt) {
        if (evt != null && evt.data != null && evt.data.type != this._curType) {
            return
        }
        var needItemId = 0;
        if (this._curLevel < this._maxLevel) {
            var tempInfo = ____655.allTemplates.hunPoTemplateList.getInfoByLevel(this._curType, this._curLevel + 1);
            if (tempInfo != null) {
                needItemId = tempInfo.needItem[0]
            }
            var hasCount = ____655.itemInfoList.getCountByTempId(needItemId);
            this._countLabel.setString("当前拥有：" + hasCount);
            if (hasCount > 0) {
                if (this.____1828 == null) {
                    this.____1828 = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                    this.____1828.move(654, 68);
                    this.____1828.play();
                    this.____1828.addTo(this, 20)
                }
                this.____892.setString("炼 魂")
            } else {
                if (this.____1828 != null) {
                    this.____1828.dispose();
                    this.____1828 = null
                }
                this.____892.setString("获 得")
            }
            ____654.____674.setKYBtnEnabled(this._upBtn, true, 1)
        } else {
            var tempInfo = ____655.allTemplates.hunPoTemplateList.getInfoByLevel(this._curType, this._curLevel);
            if (tempInfo != null) {
                needItemId = tempInfo.needItem[0]
            }
            this._countLabel.setString("已提升到顶级");
            if (this.____1828 != null) {
                this.____1828.dispose();
                this.____1828 = null
            }
            ____654.____674.setKYBtnEnabled(this._upBtn, false, 1)
        }
        var itemTempInfo = ____655.allTemplates.____794.getItem(needItemId);
        this._materGrid.setItemTemplateInfo(itemTempInfo);
        this.____1391.setString(itemTempInfo.name)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this.____1828 == null) {
                var index = this.____1824.indexOf(this._curType);
                var nowDay = ____655.____662.getClientDate().getDay();
                var openDay = ____655.____662.getOpenDayByCurrentTime();
                if (nowDay == 0) {
                    nowDay = 7
                }
                if (openDay <= 1 || index + 1 != nowDay) {
                    ____654.tipsManager.quickTip.show("魂魄丹可通过每日累充获得")
                } else {
                    ____655.getAlert().show(2, "魂魄丹可通过每日首充获取，是否前往？", null, 0, this, this.openDailyFirstRecharge, null, null)
                }
            } else {
                ____654.fashionMessageSender.sendSoulLevelUp(this._curType)
            }
        }
    },
    openDailyFirstRecharge: function() {
        ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_dailyFirst, ____654.____672, 2));
        ____654.____676.uiPanelContainer.close()
    },
    addFriendHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____655.lookInfo.addFriend()
        }
    },
    tick: function(delta, count) {
        if (this.____1774 == 80 || this.____1774 == 120) {
            this.plusNum = -this.plusNum
        }
        this.____1774 = this.____1774 + this.plusNum;
        this.____1636.setScale(this.____1774 / 100)
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 55) {
            this.____1737.setShowPop(0, ____654.playerInfoTester.hunpoRiderNum > 0)
        }
        if (type == 0 || type == 56) {
            this.____1737.setShowPop(2, ____654.playerInfoTester.hunpoWindNum > 0)
        }
        if (type == 0 || type == 57) {
            this.____1737.setShowPop(4, ____654.playerInfoTester.hunpoFaBaoNum > 0)
        }
        if (type == 0 || type == 58) {
            this.____1737.setShowPop(5, ____654.playerInfoTester.hunpoZhenLingNum > 0)
        }
        if (type == 0 || type == 59) {
            this.____1737.setShowPop(6, ____654.playerInfoTester.hunpoShenJianNum > 0)
        }
        if (type == 0 || type == 60) {
            this.____1737.setShowPop(3, ____654.playerInfoTester.hunpoFootNum > 0)
        }
        if (type == 0 || type == 61) {
            this.____1737.setShowPop(1, ____654.playerInfoTester.hunpoPetNum > 0)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this._controller = null;
        this.____17();
        if (this._bgPath != null) {
            ____654.____677.removeImageQuote(this._bgPath, this._bg);
            this._bgPath = null
        }
        this._bg = null;
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        if (this.____1828 != null) {
            this.____1828.dispose();
            this.____1828 = null
        }
        this._advanceInfo = null;
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        for (var i = 0; i < this._effectList.length; i++) {
            if (this._effectList[i] != null) {
                this._effectList[i].dispose()
            }
        }
        this._effectList = null;
        this._effectIdList = null;
        this._effectLevelList = null;
        this.____1740 = null;
        this.____995 = null;
        this._materGrid.dispose();
        this._materGrid = null;
        this._upBtn = null;
        this.____1391 = null;
        this._countLabel = null;
        this.____1555 = null;
        this.____1568 = null;
        this._proPlusValueList = null;
        this.____1636 = null;
        this._countPerPage = null;
        this._starPerPage = null;
        this._maxLevel = null;
        this._curType = null;
        this._combatView = null;
        this._materialView = null;
        this.____892 = null;
        this.____1563 = null;
        this._curLevel = null;
        this._addFriendBtn = null;
        this._posList = null;
        this._super()
    },
});
var ____2331 = ____2327.extend({
    _controller: null,
    ctor: function(controller) {
        this._controller = controller;
        var type = ____655.____659.commonStaticType.style_fashion_wing;
        this._super(controller, type)
    },
    dispose: function() {
        this._controller = null;
        this._super()
    },
});
var ____2323 = cc.Class.extend({
    waiGuanModule: null,
    ctor: function(waiGuanModule) {
        this.waiGuanModule = waiGuanModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showAdvancePanel: function(type, index) {
        if (this.waiGuanModule.advancePanel == null) {
            this.waiGuanModule.advancePanel = new AdvancePanel(this, index)
        }
        ____654.____676.uiPanelContainer.____125(this.waiGuanModule.advancePanel, type)
    },
    showSoulPanel: function(type, index) {
        if (this.waiGuanModule.soulPanel == null) {
            this.waiGuanModule.soulPanel = new ____2330(this, index)
        }
        ____654.____676.uiPanelContainer.____125(this.waiGuanModule.soulPanel, type)
    },
    showRiderPanel: function(type) {
        if (this.waiGuanModule.riderPanel == null) {
            this.waiGuanModule.riderPanel = new ____2329(this)
        }
        ____654.____676.uiPanelContainer.____125(this.waiGuanModule.riderPanel, type)
    },
    showPetPanel: function(type) {
        if (this.waiGuanModule.petPanel == null) {
            this.waiGuanModule.petPanel = new ____2328(this)
        }
        ____654.____676.uiPanelContainer.____125(this.waiGuanModule.petPanel, type)
    },
    showWingPanel: function(type) {
        if (this.waiGuanModule.wingPanel == null) {
            this.waiGuanModule.wingPanel = new ____2331(this)
        }
        ____654.____676.uiPanelContainer.____125(this.waiGuanModule.wingPanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.waiGuanModule.advancePanel) {
            this.waiGuanModule.advancePanel = null
        }
        if (p == this.waiGuanModule.soulPanel) {
            this.waiGuanModule.soulPanel = null
        }
        if (p == this.waiGuanModule.riderPanel) {
            this.waiGuanModule.riderPanel = null
        }
        if (p == this.waiGuanModule.petPanel) {
            this.waiGuanModule.petPanel = null
        }
        if (p == this.waiGuanModule.wingPanel) {
            this.waiGuanModule.wingPanel = null
        }
    },
});
var ____2324 = ____537.extend({
    waiGuanController: null,
    advancePanel: null,
    soulPanel: null,
    riderPanel: null,
    petPanel: null,
    wingPanel: null,
    setup: function(data) {
        this.waiGuanController = new ____2323(this);
        this.____151(data)
    },
    ____151: function(data) {
        if (data[0] == ____655.____659.panelTabType.advance) {
            this.waiGuanController.showAdvancePanel(data[0], data[1])
        } else if (data[0] == ____655.____659.panelTabType.waiGuan_soul) {
            this.waiGuanController.showSoulPanel(data[0], data[1])
        } else if (data[0] == ____655.____659.panelTabType.huaXing_rider) {
            this.waiGuanController.showRiderPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.huaXing_pet) {
            this.waiGuanController.showPetPanel(data[0])
        } else if (data[0] == ____655.____659.panelTabType.huaXing_wing) {
            this.waiGuanController.showWingPanel(data[0])
        }
    },
    clear: function() {},
});
var ____2334 = ____2120.extend({
    ctor: function(categoryType) {
        this._super(categoryType);
        this.____6()
    },
    ____6: function() {
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.itemsUpdate, this);
        ____655.furnaceInfo.addEventListener(____655.____661.weapon_stoneInfoUpdate, this.itemInfoUpdate, this)
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.itemsUpdate, this);
        ____655.furnaceInfo.removeEventListener(____655.____661.weapon_stoneInfoUpdate, this.itemInfoUpdate, this)
    },
    setItemInfo: function(itemInfo) {
        this.____1139 = itemInfo;
        this.____1283.setItemInfo(this.____1139);
        this.itemInfoUpdate()
    },
    itemsUpdate: function(evt) {
        this.setTipIocnVisible(this.checkCanUpgrad())
    },
    itemInfoUpdate: function(evt) {
        var itemInfo = ____655.itemInfoList.getBodyEquipByType(this.____928);
        if (!!itemInfo) {
            var baoshiEquipTemplate = ____655.allTemplates.baoShiEquipTemplateList.getTemplateInfoByType(this.____928);
            var level = 0;
            if (!!baoshiEquipTemplate) {
                for (var i = 0; i < baoshiEquipTemplate.baoshiList.length; i++) {
                    var info = baoshiEquipTemplate.baoshiList[i];
                    var stoneType = info[0];
                    var openLevel = info[1];
                    if (____655.____667.level >= openLevel) {
                        var exp = ____655.furnaceInfo.getStoneExpByType(this.____928, stoneType);
                        var template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndExp(stoneType, exp);
                        if (!!template) {
                            level += template.level
                        }
                    }
                }
            }
            this._nameLabel.setString(this.____1764 + " Lv" + level)
        } else {
            this._nameLabel.setString(this.____1764)
        }
        this.setTipIocnVisible(this.checkCanUpgrad())
    },
    checkCanUpgrad: function() {
        return ____655.furnaceInfo.checkEquipStoneByCategoryType(this.____928)
    },
    dispose: function() {
        this.____17();
        this._super()
    },
});
var ____2335 = ____2120.extend({
    ctor: function(categoryType) {
        this._super(categoryType);
        this.____6()
    },
    ____6: function() {
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.itemsUpdate, this)
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.itemsUpdate, this)
    },
    itemsUpdate: function(evt) {
        this.setTipIocnVisible(this.checkCanStrength())
    },
    itemInfoUpdate: function(evt) {
        this._super(evt);
        this.setTipIocnVisible(this.checkCanStrength())
    },
    checkCanStrength: function() {
        return ____655.furnaceInfo.checkQHByCategoryType(this.____928)
    },
    dispose: function() {
        this.____17();
        this._super()
    },
});
var ____2336 = KYNode.extend({
    ____871: null,
    ____1442: null,
    ____995: null,
    _liveImg: null,
    _liveImg2: null,
    ____1353: null,
    ____862: null,
    ____1418: null,
    ____1421: null,
    ____1021: null,
    _upBtn: null,
    _btnTitle: null,
    ____964: null,
    ____963: null,
    ____1707: null,
    ____1555: null,
    ____1568: null,
    _proPlusValueList: null,
    _tipsLabel: null,
    _type: null,
    _bgPath: null,
    ____1868: null,
    ____1756: null,
    _godWeaponEffect: null,
    _addNumberUtils: null,
    _bgEffect: null,
    ctor: function(type) {
        this._super("weaponGodItem.ExportJson");
        this._type = type;
        this.____871 = this.getChildByName("bgImg");
        this.____1442 = this.getChildByName("nameImg");
        this.____995 = this.getChildByName("combatLabel");
        this._liveImg = this.getChildByName("liveImg");
        this._liveImg2 = this.getChildByName("liveImg2");
        this.____1353 = this.getChildByName("liveLabel");
        this.____862 = this.getChildByName("barBg");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____1421 = this.getChildByName("moneyLabel");
        this.____1021 = this.getChildByName("countBar");
        this._upBtn = this.getChildByName("upBtn");
        this._btnTitle = this.getChildByName("titleLabel");
        this.____964 = this.getChildByName("checkBoxBtn");
        this._tipsLabel = this.getChildByName("tipsLabel");
        this.____963 = this.getChildByName("checkBox");
        this.____963.setTouchEnabled(false);
        this.____963.setSelected(false);
        this.____1707 = [];
        for (var i = 0; i < 5; i++) {
            this.____1707.push(this.getChildByName("starIcon" + (i + 1)))
        }
        this.____1555 = [];
        this.____1568 = [];
        this._proPlusValueList = [];
        for (var i = 0; i < 4; i++) {
            this.____1555.push(this.getChildByName("proName" + (i + 1)));
            this.____1568.push(this.getChildByName("proValue" + (i + 1)));
            this._proPlusValueList.push(this.getChildByName("proPlusValue" + (i + 1)))
        }
        this._bgPath = ____654.____675.____139("outPic/strength_bg4.png");
        if (this._type == ____655.furnaceInfo.GOD_WEAPON_TYPE[0]) {
            this._godWeaponEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.SHENBING_EFFECT1, false, ____654.____673.____159(160, 290), this);
            this._godWeaponEffect.setLocalZOrder(10)
        } else if (this._type == ____655.furnaceInfo.GOD_WEAPON_TYPE[1]) {
            this._godWeaponEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.SHENBING_EFFECT2, false, ____654.____673.____159(160, 280), this);
            this._godWeaponEffect.setLocalZOrder(10)
        } else if (this._type == ____655.furnaceInfo.GOD_WEAPON_TYPE[2]) {
            this._godWeaponEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.SHENBING_EFFECT3, false, ____654.____673.____159(180, 380), this);
            this._godWeaponEffect.setLocalZOrder(10)
        }
        this.____1868 = ____654.____675.____139("outPic/weaponFlag" + this._type + ".png");
        ____654.____677.____146(this.____871, this._bgPath);
        ____654.____677.____146(this.____1442, this.____1868);
        this.____1756 = ____655.allTemplates.fashionTemplateList.getList(this._type);
        if (this.____1756 != null) {
            this.____1756 = this.____1756[0]
        }
        this._bgEffect = ____654.effectManager.setEffect(____655.allTemplates.____789.CHARACTER_BG_EFFECT, false, ____654.____673.____159(147, 307), this);
        this._bgEffect.setLocalZOrder(9);
        this.____5();
        this.____6()
    },
    ____5: function() {
        var info = ____655.furnaceInfo.getGodWeaponInfoByType(this._type);
        if (info == null) {
            this.____963.setSelected(false);
            this.____862.setVisible(false);
            this.____1418.setVisible(false);
            this.____1421.setVisible(false);
            this.____1021.setVisible(false);
            this.____1353.setVisible(true);
            ____654.____674.setKYStarListColor(this.____1707, 0);
            if (this._type == ____655.furnaceInfo.GOD_WEAPON_TYPE[0]) {
                this._liveImg.setVisible(true);
                this._liveImg2.setVisible(true);
                this.____1353.setString("");
                ____654.____674.setKYBtnEnabled(this._upBtn, true, 2);
                this._btnTitle.setString(____654.yuyanbaoManager.getYuyanbao("____2336.text3"))
            } else if (this._type == ____655.furnaceInfo.GOD_WEAPON_TYPE[1]) {
                this._liveImg.setVisible(false);
                this._liveImg2.setVisible(false);
                this.____1353.setString(____654.yuyanbaoManager.getYuyanbao("____2336.text1"));
                ____654.____674.setKYBtnEnabled(this._upBtn, false, 1);
                this._btnTitle.setString(____654.yuyanbaoManager.getYuyanbao("____2336.text4"))
            } else if (this._type == ____655.furnaceInfo.GOD_WEAPON_TYPE[2]) {
                this._liveImg.setVisible(false);
                this._liveImg2.setVisible(false);
                this.____1353.setString(____654.yuyanbaoManager.getYuyanbao("____2336.text2"));
                ____654.____674.setKYBtnEnabled(this._upBtn, false, 1);
                this._btnTitle.setString(____654.yuyanbaoManager.getYuyanbao("____2336.text4"))
            }
            var starTempInfo = this.____1756.stars[1];
            if (starTempInfo != null) {
                if (this._addNumberUtils == null) {
                    this._addNumberUtils = new AddNumberUtils(this.____995, starTempInfo.fightValue)
                } else {
                    this._addNumberUtils.setValue(starTempInfo.fightValue)
                }
                for (var i = 0; i < starTempInfo.attrStr.length; i++) {
                    if (this.____1555[i] != null) {
                        var name = ____655.____659.propertyType.getNameByType(starTempInfo.attrStr[i].id);
                        this.____1555[i].setString(name + "：");
                        this.____1568[i].setString("0");
                        this._proPlusValueList[i].setString("+" + starTempInfo.attrStr[i].value)
                    }
                }
            }
        } else {
            this.____1353.setVisible(false);
            this._liveImg.setVisible(false);
            this._liveImg2.setVisible(false);
            this.____963.setSelected(info.isUse);
            ____654.____674.setKYStarListColor(this.____1707, info.level);
            var starTempInfo = this.____1756.stars[info.level];
            var nextStartTempInfo = this.____1756.stars[info.level + 1];
            if (starTempInfo != null) {
                if (this._addNumberUtils == null) {
                    this._addNumberUtils = new AddNumberUtils(this.____995, starTempInfo.fightValue)
                } else {
                    this._addNumberUtils.setValue(starTempInfo.fightValue)
                }
                for (var i = 0; i < starTempInfo.attrStr.length; i++) {
                    if (this.____1555[i] != null) {
                        var name = ____655.____659.propertyType.getNameByType(starTempInfo.attrStr[i].id);
                        this.____1555[i].setString(name + "：");
                        this.____1568[i].setString(starTempInfo.attrStr[i].value);
                        if (nextStartTempInfo != null) {
                            this._proPlusValueList[i].setString("+" + (nextStartTempInfo.attrStr[i].value - starTempInfo.attrStr[i].value))
                        } else {
                            this._proPlusValueList[i].setString("")
                        }
                    }
                }
            }
            if (nextStartTempInfo != null) {
                this.____862.setVisible(true);
                this.____1418.setVisible(true);
                this.____1421.setVisible(true);
                this.____1021.setVisible(true);
                var count = ____655.itemInfoList.getCountByTempId(nextStartTempInfo.needItems[0][0]);
                this.____1421.setString(count + "/" + nextStartTempInfo.needItems[0][1]);
                var percent = Math.max(0, Math.min(100, Math.floor(count / nextStartTempInfo.needItems[0][1] * 100)));
                this.____1021.setPercent(percent);
                ____654.____674.setKYBtnEnabled(this._upBtn, true, 1);
                this._btnTitle.setString(____654.yuyanbaoManager.getYuyanbao("____2336.text4"))
            } else {
                this.____862.setVisible(false);
                this.____1418.setVisible(false);
                this.____1421.setVisible(false);
                this.____1021.setVisible(false);
                ____654.____674.setKYBtnEnabled(this._upBtn, false, 1);
                this._btnTitle.setString(____654.yuyanbaoManager.getYuyanbao("____2336.text5"))
            }
        }
    },
    ____6: function() {
        this._upBtn.addListener(this, this.____16);
        this.____964.addListener(this, this.____16);
        ____655.furnaceInfo.addEventListener(____655.____661.weapon_godInfoUpdate, this.updateView, this)
    },
    ____17: function() {
        ____655.furnaceInfo.removeEventListener(____655.____661.weapon_godInfoUpdate, this.updateView, this)
    },
    updateView: function(evt) {
        this.____5()
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._upBtn) {
                var info = ____655.furnaceInfo.getGodWeaponInfoByType(this._type);
                if (info != null) {
                    var nextStartTempInfo = this.____1756.stars[info.level + 1];
                    if (nextStartTempInfo != null) {
                        var count = ____655.itemInfoList.getCountByTempId(nextStartTempInfo.needItems[0][0]);
                        if (count >= nextStartTempInfo.needItems[0][1]) {
                            ____654.weaponMessageSender.sendWeaponGadUp(this._type);
                            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2336.text6"))
                        } else {
                            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2336.text7"))
                        }
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2336.text8"))
                    }
                } else {
                    if (this._type == ____655.furnaceInfo.GOD_WEAPON_TYPE[0]) {
                        ____654.____672.dispatchEvent(new ____590(____655.____661.panel_open_payPanel, ____654.____672))
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2336.text9"))
                    }
                }
                return
            } else if (sender == this.____964) {
                var info = ____655.furnaceInfo.getGodWeaponInfoByType(this._type);
                if (info != null) {
                    var type = this._type;
                    if (info.isUse) {
                        type = 0
                    }
                    ____654.weaponMessageSender.sendWeaponGodUse(type);
                    if (type == 0) {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2336.text10"))
                    } else {
                        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2336.text11"))
                    }
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2336.text12"))
                }
                return
            }
        }
    },
    dispose: function() {
        this.____17();
        this._super();
        ____654.____677.removeImageQuote(this._bgPath, this.____871);
        ____654.____677.removeImageQuote(this.____1868, this.____1442);
        if (this._godWeaponEffect != null) {
            this._godWeaponEffect.dispose();
            this._godWeaponEffect = null
        }
        if (this._bgEffect != null) {
            this._bgEffect.dispose();
            this._bgEffect = null
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this._bgPath = null;
        this.____1868 = null;
        this.____871 = null;
        this.____1442 = null;
        this.____995 = null;
        this._liveImg = null;
        this._liveImg2 = null;
        this.____1353 = null;
        this.____862 = null;
        this.____1418 = null;
        this.____1421 = null;
        this.____1021 = null;
        this._upBtn = null;
        this._btnTitle = null;
        this.____964 = null;
        this._tipsLabel = null;
        this.____963 = null;
        this.____1707 = null;
        this.____1555 = null;
        this.____1568 = null;
        this._proPlusValueList = null;
        this.____1756 = null
    },
});
var ____2337 = KYPanel.extend({
    _controller: null,
    _moneyView: null,
    ____1873: null,
    ctor: function(controller) {
        this._super("weaponGodPanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        var weaponLayer = this.getChildByName("weaponLayer");
        this.____1873 = [];
        var list = ____655.furnaceInfo.GOD_WEAPON_TYPE;
        for (var i = 0; i < list.length; i++) {
            var view = new ____2336(list[i]);
            view.setPositionX(295 * i);
            weaponLayer.addChild(view);
            this.____1873.push(view)
        }
    },
    dispose: function() {
        this._controller = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this.____1873 != null) {
            var len = this.____1873.length;
            for (var i = 0; i < len; i++) {
                this.____1873[i].dispose()
            }
            this.____1873 = null
        }
        this._super()
    },
});
var ____2338 = KYPanel.extend({
    _controller: null,
    _bg: null,
    ____995: null,
    _upBtn: null,
    _countLabel: null,
    ____1023: null,
    ____963: null,
    _levelLabel: null,
    ____1021: null,
    ____1696: null,
    ____1555: null,
    ____1568: null,
    ____1564: null,
    _moneyView: null,
    _bgPath: null,
    ____1553: null,
    _materialResult: null,
    _tickCount: -1,
    _addNumberUtils: null,
    ctor: function(controller) {
        this._super("weaponPotPanel.ExportJson");
        this._controller = controller;
        this._levelLabel = this.getChildByName("levelLabel");
        this.____1021 = this.getChildByName("countBar");
        this.____1696 = this.getChildByName("speedLabel");
        var proPanel = this.getChildByName("proPanel");
        this.____995 = this.getChildByName("combatLabel");
        this._upBtn = this.getChildByName("upBtn");
        this._countLabel = this.getChildByName("countLabel");
        this.____1023 = this.getChildByName("countLabel2");
        this.____963 = this.getChildByName("checkBox");
        this.____963.setSelected(false);
        this.____1555 = [];
        this.____1568 = [];
        this.____1564 = [];
        for (var i = 1; i < 8; i++) {
            this.____1555.push(this.getChildByName("proName" + i));
            this.____1568.push(this.getChildByName("proValue" + i));
            this.____1564.push(this.getChildByName("proPlusValue" + i))
        }
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/strength_bg3.png");
        ____654.____677.____146(this._bg, this._bgPath);
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this.getChildByName("descLabel1").setString(____654.yuyanbaoManager.getYuyanbao("____2338.text1"));
        this.getChildByName("descLabel2").setString(____654.yuyanbaoManager.getYuyanbao("____2338.text2"));
        this.____963.setString("支持同品质人物装备熔炼");
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.____1553 = ____655.allTemplates.rongluTemplateList.____1566;
        for (var i = 0; i < this.____1553.length; i++) {
            this.____1555[i].setString(____655.____659.propertyType.getNameByType(this.____1553[i]))
        }
        this.updateView()
    },
    okClick: function() {
        var res1 = this._materialResult[0][0];
        var res2 = [];
        if (this.____963.getSelected()) {
            res2 = this._materialResult[1][0]
        }
        ____654.weaponMessageSender.sendPotUpdate(res1, res2);
        ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2338.text7"))
    },
    rongLianHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._materialResult != null) {
                var res1 = this._materialResult[0][0];
                var res2 = [];
                if (this.____963.getSelected()) {
                    res2 = this._materialResult[1][0]
                }
                if ((res1.length + res2.length) > 0) {
                    var value = this._materialResult[0][2];
                    var count1 = this._materialResult[0][1];
                    var count2 = 0;
                    if (this.____963.getSelected()) {
                        value += this._materialResult[1][2];
                        count2 = this._materialResult[1][1]
                    }
                    var str = ____654.yuyanbaoManager.getYuyanbao("____2338.text5").format(value, count1, count2);
                    ____655.getAlert().show(2, str, null, 0, this, this.okClick, null, null)
                } else {
                    ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2338.text6"))
                }
            } else {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2338.text6"))
            }
        }
    },
    ____6: function() {
        this._upBtn.addListener(this, this.rongLianHandler);
        ____655.furnaceInfo.addEventListener(____655.____661.weapon_potInfoUpdate, this.potInfoUpdate, this);
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.itemInfoUpdate, this)
    },
    ____17: function() {
        ____655.furnaceInfo.removeEventListener(____655.____661.weapon_potInfoUpdate, this.potInfoUpdate, this);
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.itemInfoUpdate, this)
    },
    potInfoUpdate: function(evt) {
        this.updateView()
    },
    updateView: function() {
        var curLevel = ____655.furnaceInfo.weaponPotLevel;
        this._levelLabel.setString("Lv." + curLevel.toString());
        var nexLevel = curLevel + 1;
        var curTemplate = ____655.allTemplates.rongluTemplateList.____238(curLevel);
        var nexTemplate = ____655.allTemplates.rongluTemplateList.____238(nexLevel);
        var fight = 0;
        for (var i = 0; i < this.____1553.length; i++) {
            var curPro = 0;
            var nexPro = 0;
            if (curTemplate != null) {
                curPro = curTemplate.getProByType(this.____1553[i])
            }
            if (nexTemplate != null) {
                nexPro = nexTemplate.getProByType(this.____1553[i])
            }
            nexPro -= curPro;
            this.____1568[i].setString(curPro.toString());
            fight += ____655.____659.propertyType.getFight(this.____1553[i], curPro);
            if (nexPro > 0) {
                this.____1564[i].setString("+" + nexPro.toString())
            } else {
                this.____1564[i].setString("")
            }
        }
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____995, fight)
        } else {
            this._addNumberUtils.setValue(fight)
        }
        if (nexTemplate != null) {
            var nexExp = nexTemplate.totalExp;
            var curExp = ____655.furnaceInfo.weaponPotExp;
            if (curTemplate != null) {
                nexExp -= curTemplate.totalExp;
                curExp -= curTemplate.totalExp
            }
            this.____1696.setString(curExp.toString() + "/" + nexExp.toString());
            this.____1021.setPercent(Math.max(0, Math.min(100, Math.floor(curExp / nexExp * 100))))
        } else {
            this.____1696.setString("Max");
            this.____1021.setPercent(100)
        }
        this.equipInfoUpdate()
    },
    itemInfoUpdate: function(evt) {
        this._tickCount = 50;
        ____654.____678.____298(this.tick, this)
    },
    tick: function() {
        this._tickCount--;
        if (this._tickCount < 0) {
            this.equipInfoUpdate();
            ____654.____678.____299(this.tick, this)
        }
    },
    equipInfoUpdate: function() {
        this._materialResult = ____655.furnaceInfo.getPotEquipList();
        var res1 = this._materialResult[0];
        this._countLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2338.text3", res1[1]));
        var res2 = this._materialResult[1];
        this.____1023.setString(____654.yuyanbaoManager.getYuyanbao("____2338.text4", res2[1]))
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____17();
        this._controller = null;
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this.____995 = null;
        this._upBtn = null;
        this._countLabel = null;
        this._levelLabel = null;
        this.____1021 = null;
        this.____1696 = null;
        this.____1555 = null;
        this.____1568 = null;
        this.____1564 = null;
        this.____1023 = null;
        this.____963 = null;
        this.____1553 = null;
        this._materialResult = null;
        this._tickCount = null;
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this._super()
    },
});
var ____2339 = KYPanel.extend({
    _controller: null,
    _bg: null,
    ____995: null,
    _upBtn: null,
    ____1421: null,
    ____1418: null,
    ____1555: null,
    ____1568: null,
    ____1564: null,
    ____1552: null,
    _moneyView: null,
    _bgPath: null,
    ____1556: null,
    _selectEffect: null,
    _posList: null,
    _addNumberUtils: null,
    _oldLevel: 0,
    _tickCount: 0,
    ctor: function(controller) {
        this._super("weaponSoulPanel.ExportJson");
        this._controller = controller;
        var proPanel = this.getChildByName("proPanel");
        this.____995 = this.getChildByName("combatLabel");
        this._upBtn = this.getChildByName("upBtn");
        this.____1421 = this.getChildByName("moneyLabel");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____1555 = [];
        this.____1568 = [];
        this.____1564 = [];
        this.____1552 = [];
        for (var i = 1; i < 8; i++) {
            this.____1555.push(this.getChildByName("proName" + i));
            this.____1568.push(this.getChildByName("proValue" + i));
            this.____1564.push(this.getChildByName("proPlusValue" + i));
            this.____1552.push(this.getChildByName("proLabel" + i))
        }
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/strength_bg5.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._posList = [____654.____673.____159(311, 284), ____654.____673.____159(311, 449), ____654.____673.____159(448, 364), ____654.____673.____159(448, 202), ____654.____673.____159(311, 117), ____654.____673.____159(174, 202), ____654.____673.____159(174, 364)];
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.____1556 = [];
        var list = ____655.allTemplates.wuhunTemplateList.____1566;
        for (var i = 0; i < list.length; i++) {
            var name = ____655.____659.propertyType.getNameByType(list[i]);
            this.____1555[i].setString(name);
            this.____1556.push(name)
        }
        this._oldLevel = ____655.furnaceInfo.weaponSoulLevel;
        this.updateView(this._oldLevel)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._upBtn) {
                this.soulLevelUpHandler()
            }
        }
    },
    soulLevelUpHandler: function() {
        var upLevel = this.getUpLevel();
        if (upLevel == 0) {
            ____654.tipsManager.quickTip.show("铜币不足");
            return
        } else {
            ____654.weaponMessageSender.sendWeaponSoulUp(upLevel);
            this._upBtn.setTouchEnabled(false);
            this._upBtn.setFrame("btn/ui_btn1_4.png", 1);
            return
        }
    },
    getUpLevel: function() {
        var soulLevel = ____655.furnaceInfo.weaponSoulLevel;
        var upLevel = 0;
        var copper = 0;
        for (var i = 0; i < ____655.allTemplates.wuhunTemplateList.levelPerRound + 1; i++) {
            var higherNum = (soulLevel + upLevel) % ____655.allTemplates.wuhunTemplateList.levelPerRound;
            if (higherNum == 0 && upLevel > 0) {
                return upLevel
            }
            copper += ____655.allTemplates.wuhunTemplateList.getNeedCopperByLevel(soulLevel + upLevel + 1);
            if (!____655.____667.moneyInfo.money2Enough(copper)) {
                return upLevel
            }
            upLevel++
        }
    },
    ____6: function() {
        this._upBtn.addListener(this, this.____16);
        ____655.furnaceInfo.addEventListener(____655.____661.weapon_soulInfoUpdate, this.levelUpdate, this);
        ____654.____672.addEventListener(____655.____661.guide_wuHunLevelUp, this.soulLevelUpHandler, this)
    },
    ____17: function() {
        ____655.furnaceInfo.removeEventListener(____655.____661.weapon_soulInfoUpdate, this.levelUpdate, this);
        ____654.____672.removeEventListener(____655.____661.guide_wuHunLevelUp, this.soulLevelUpHandler, this)
    },
    levelUpdate: function(evt) {
        if (____655.furnaceInfo.weaponSoulLevel > this._oldLevel) {
            this._tickCount = 0;
            ____654.____678.____298(this.tick, this)
        }
    },
    tick: function() {
        this._tickCount--;
        if (this._tickCount < 0) {
            this.updateView(++this._oldLevel);
            if (this._oldLevel == ____655.furnaceInfo.weaponSoulLevel) {
                this._upBtn.setTouchEnabled(true);
                this._upBtn.setFrame("btn/ui_btn1_2.png", 1);
                ____654.____678.____299(this.tick, this)
            }
            this._tickCount = 18
        }
    },
    updateView: function(soulLevel) {
        var fight = 0;
        var roundLevel = Math.floor(soulLevel / ____655.allTemplates.wuhunTemplateList.levelPerRound);
        var higherNum = soulLevel % ____655.allTemplates.wuhunTemplateList.levelPerRound;
        for (var i = 0; i < this.____1552.length; i++) {
            var level = roundLevel;
            if (i < higherNum) {
                level++
            };
            this.____1552[i].setString(this.____1556[i] + "Lv" + level)
        }
        var proList = ____655.allTemplates.wuhunTemplateList.getTotalPropertyByLevel(soulLevel);
        var proTypeList = ____655.allTemplates.wuhunTemplateList.____1566;
        for (var i = 0; i < this.____1568.length; i++) {
            var num = proList[i] || 0;
            this.____1568[i].setString(num.toString());
            fight += ____655.____659.propertyType.getFight(proTypeList[i], num)
        }
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____995, fight)
        } else {
            this._addNumberUtils.setValue(fight)
        }
        var pluNum = ____655.allTemplates.wuhunTemplateList.getAddPropertyByLevel(soulLevel + 1);
        for (var i = 0; i < this.____1564.length; i++) {
            if (i == higherNum) {
                this.____1564[i].setString("+" + pluNum.toString());
                var pos = this._posList[i];
                if (this._selectEffect == null) {
                    this._selectEffect = new OpacityEffect("effect/effect_13.png", -5);
                    this._selectEffect.setPosition(pos);
                    this.addChild(this._selectEffect);
                    this._selectEffect.setLocalZOrder(10)
                } else {
                    this._selectEffect.move(pos.x, pos.y)
                }
            } else {
                this.____1564[i].setString("")
            }
        }
        var copper = ____655.allTemplates.wuhunTemplateList.getNeedCopperByLevel(soulLevel + 1);
        var upLevel = this.getUpLevel();
        if (upLevel > 0) {
            this.____1421.setString(____654.yuyanbaoManager.getYuyanbao("____2330.text2", ____654.____674.getWanCount(copper), upLevel))
        } else {
            this.____1421.setString(____654.____674.getWanCount(copper))
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____17();
        this._controller = null;
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        if (this._selectEffect != null) {
            this._selectEffect.dispose();
            this._selectEffect = null
        }
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        this.____995 = null;
        this._upBtn = null;
        this.____1421 = null;
        this.____1418 = null;
        this.____1555 = null;
        this.____1568 = null;
        this.____1564 = null;
        this.____1552 = null;
        this._oldLevel = null;
        this._tickCount = null;
        this._super()
    },
});
var ____2340 = ____2130.extend({
    ____1725: -1,
    ____1491: -1,
    ____1140: -1,
    ____1238: null,
    ____1341: null,
    _levelLabel: null,
    ____1458: null,
    _selectEffect: null,
    _proType: -1,
    _proValue: -1,
    ctor: function() {
        this._super();
        this.____1237.setScale(1.2);
        this.____6()
    },
    ____363: function(type, info) {
        this.____1140 = type;
        this.____1725 = info[0];
        this.____1491 = info[1];
        if (this.____1238 != null) {
            ____654.____677.removeImageQuote(this.____1238, this.____1237);
            this.____1238 = null
        }
        if (____655.____667.level < this.____1491) {
            var template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndLv(this.____1725, 1);
            this.____1458 = template;
            this.____1361.setVisible(true);
            this._lockImg.setVisible(true);
            this.____1694.setVisible(false);
            this.____1693.setPercent(0);
            this.____1457.setPercent(0);
            this.____999.setString(____654.yuyanbaoManager.getYuyanbao("____2340.text1", this.____1491));
            this._proValueLabel.setString("");
            this._proName.setString("");
            this.____64(-1);
            this.____1238 = ____654.____675.getIconPath(template.icon, ____655.____659.iconPathType.item)
        } else {
            this.____1361.setVisible(false);
            this._lockImg.setVisible(false);
            this.____1694.setVisible(true);
            this.____999.setString("");
            var exp = ____655.furnaceInfo.getStoneExpByType(this.____1140, this.____1725);
            var template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndExp(this.____1725, exp);
            var nextTemplate = ____655.allTemplates.baoShiTemplateList.getNextTemplateByTypeAndExp(this.____1725, exp);
            this.____1458 = nextTemplate;
            if (template != null) {
                this.____64(template.level);
                this._proValueLabel.setString(template.atrrList[0].value);
                this._proName.setString(____655.____659.propertyType.getNameByType(template.atrrList[0].id));
                this._proType = template.atrrList[0].id;
                this._proValue = template.atrrList[0].value;
                if (nextTemplate != null) {
                    var percent = Math.min(100, Math.max(0, Math.floor((exp - template.needExp) / (nextTemplate.needExp - template.needExp) * 100)));
                    this.____1693.setPercent(percent)
                } else {
                    this.____1693.setPercent(100)
                }
                this.____1238 = ____654.____675.getIconPath(template.icon, ____655.____659.iconPathType.item)
            } else {
                this.____64(0);
                this._proValueLabel.setString("");
                this._proName.setString("");
                var percent = Math.min(100, Math.max(0, Math.floor(exp / nextTemplate.needExp * 100)));
                this.____1693.setPercent(percent);
                this.____1238 = ____654.____675.getIconPath(nextTemplate.icon, ____655.____659.iconPathType.item)
            }
        }
        if (this.____1238 != null) {
            ____654.____677.____146(this.____1237, this.____1238)
        }
        this.setTipVisible(this.checkUpgrad())
    },
    ____6: function() {
        ____655.itemInfoList.addEventListener(____655.____661.common_itemCountUpdate, this.itemsUpdate, this)
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.common_itemCountUpdate, this.itemsUpdate, this)
    },
    itemsUpdate: function(evt) {
        this.setTipVisible(this.checkUpgrad())
    },
    ____239: function(flag) {
        if (flag) {
            if (this._selectEffect == null) {
                this._selectEffect = new OpacityEffect("effect/effect_12.png", -5);
                this._selectEffect.move(41, 41);
                this.addChild(this._selectEffect)
            }
        } else {
            if (this._selectEffect != null) {
                this._selectEffect.dispose();
                this._selectEffect = null
            }
        }
    },
    getFight: function() {
        if (this.____1491 == -1 || ____655.____667.level < this.____1491 || this._proType == -1 || this._proValue == -1) {
            return 0
        }
        return ____655.____659.propertyType.getFight(this._proType, this._proValue)
    },
    setTipVisible: function(flag) {
        this.____1830.setVisible(flag);
        if (____655.____667.level >= this.____1491) {
            var addExp = this.getUpLevelList(true);
            if (this.____1458 != null) {
                var exp = ____655.furnaceInfo.getStoneExpByType(this.____1140, this.____1725);
                var template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndExp(this.____1725, exp);
                var percent = 0;
                if (template != null) {
                    percent = Math.min(100, Math.max(0, Math.floor((exp - template.needExp + addExp) / (this.____1458.needExp - template.needExp) * 100)))
                } else {
                    percent = Math.min(100, Math.max(0, Math.floor((exp + addExp) / this.____1458.needExp * 100)))
                }
                this.____1457.setPercent(percent)
            } else {
                this.____1457.setPercent(0)
            }
        } else {
            this.____1457.setPercent(0)
        }
    },
    checkUpgrad: function() {
        if (this.____1491 == -1 || ____655.____667.level < this.____1491) {
            return false
        } else {
            var exp = ____655.furnaceInfo.getStoneExpByType(this.____1140, this.____1725);
            return ____655.furnaceInfo.checkStoneByTypeAndExp(this.____1725, exp)
        }
    },
    getNextTemplate: function() {
        return this.____1458
    },
    checkIsOpen: function() {
        if (____655.____667.level < this.____1491) {
            return false
        } else {
            return true
        }
    },
    getUpLevelList: function(getExp) {
        if (this.____1458 == null) {
            if (getExp) {
                return 0
            }
            return []
        }
        var needExp = this.____1458.needExp - ____655.furnaceInfo.getStoneExpByType(this.____1140, this.____1725);
        var exp = 0;
        var res = [];
        for (var i = 0; i < this.____1458.itemList.length; i++) {
            var tempId = this.____1458.itemList[i];
            var templateItemInfo = ____655.allTemplates.____794.getItem(tempId);
            var info = ____655.itemInfoList.getItemInfoByTempId(tempId);
            if (info != null && info.count > 0) {
                var tempExp = needExp - exp;
                var needCount = Math.min(info.count, Math.ceil(tempExp / templateItemInfo.propertys[3]));
                var temp = [];
                temp.push(info.id);
                temp.push(needCount);
                res.push(temp);
                exp += (needCount * templateItemInfo.propertys[3]);
                if (exp >= needExp) {
                    if (getExp) {
                        return exp
                    }
                    return res
                }
            }
        }
        if (getExp) {
            return exp
        }
        return res
    },
    getEuipType: function() {
        return this.____1140
    },
    getStoneType: function() {
        return this.____1725
    },
    ____64: function(level) {
        if (level > -1) {
            if (this.____1341 == null) {
                this.____1341 = ____654.____673.newKYSprite();
                this.____1341.setFrame("flag/ui_levelIcon.png");
                this.____1341.setPosition(____654.____673.____159(22, 66));
                this.addChild(this.____1341, 5)
            }
            if (this._levelLabel == null) {
                this._levelLabel = new NumberView();
                this._levelLabel.setType(3);
                this._levelLabel.setAnchorPoint(____654.____673.anchorPoints[4]);
                this._levelLabel.setPosition(____654.____673.____159(35, 66));
                this.addChild(this._levelLabel, 5)
            }
            this._levelLabel.setNumber(level)
        } else {
            if (this._levelLabel != null) {
                this._levelLabel.dispose();
                this._levelLabel = null
            }
            if (this.____1341 != null) {
                this.____1341.dispose();
                this.____1341 = null
            }
        }
    },
    dispose: function() {
        this.____17();
        this.____239(false);
        this.____64(-1);
        if (this.____1238 != null) {
            ____654.____677.removeImageQuote(this.____1238, this.____1237);
            this.____1238 = null
        }
        this.____1140 = null;
        this.____1725 = null;
        this.____1491 = null;
        this.____1458 = null;
        this._proType = null;
        this._proValue = null;
        this._super()
    },
});
var ____2341 = KYPanel.extend({
    _controller: null,
    _bg: null,
    ____908: null,
    ____995: null,
    ____1421: null,
    _upBtn: null,
    _moneyView: null,
    _bgPath: null,
    ____1724: null,
    ____888: null,
    ____1029: null,
    ____1389: null,
    ____1634: null,
    ____1642: null,
    _addNumberUtils: null,
    ctor: function(controller) {
        this._super("weaponStonePanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/strength_bg1.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____908 = this.getChildByName("btnListView");
        this.____908.setScrollBarEnabled(false);
        this.____995 = this.getChildByName("combatLabel");
        this.____1421 = this.getChildByName("combatLabel");
        this._upBtn = this.getChildByName("upBtn");
        var curEquipCell = this.getChildByName("curEquipCell");
        this.____1029 = new ____2129();
        this.____1029.addListener(this, this.gridClickHandler);
        this.____1029.setIsShowCount(false);
        this.____1029.setIsShowQHLevel(true);
        curEquipCell.addChild(this.____1029, 1);
        this.____1389 = [];
        for (var i = 0; i < 3; i++) {
            var materialCell = this.getChildByName("materialCell" + (i + 1));
            var item = new ____2129();
            materialCell.addChild(item, 1);
            this.____1389.push(item)
        }
        this.____1724 = [];
        for (var i = 0; i < 3; i++) {
            var view = new ____2340();
            this.getChildByName("stonePanel" + (i + 1)).addChild(view, 1);
            view.addListener(this, this.____16);
            this.____1724.push(view)
        }
        this.____888 = [];
        var equipItemList = ____655.____659.categoryType.equipList;
        for (var i = 0; i < equipItemList.length; i++) {
            var btn = new ____2334(equipItemList[i]);
            btn.addListener(this, this.____16, null, null, null, false, true);
            this.____908.pushBackItem(btn);
            this.____888.push(btn)
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        for (var i = 0; i < this.____888.length; i++) {
            if (this.____888[i].checkCanUpgrad()) {
                this.setEquipSelect(this.____888[i]);
                return
            }
        }
        for (var i = 0; i < this.____888.length; i++) {
            if (this.____888[i].getItemInfo(false) != null) {
                this.setEquipSelect(this.____888[i]);
                return
            }
        }
        this.setEquipSelect(this.____888[0])
    },
    ____6: function() {
        this._upBtn.addListener(this, this.____16);
        ____655.furnaceInfo.addEventListener(____655.____661.weapon_stoneInfoUpdate, this.updateView, this)
    },
    ____17: function() {
        ____655.furnaceInfo.removeEventListener(____655.____661.weapon_stoneInfoUpdate, this.updateView, this)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._upBtn) {
                print("点击升级宝石");
                if (this.____1642 == null) {
                    print("没选择升级宝石");
                    return
                }
                if (this.____1642.getNextTemplate() == null) {
                    ____654.tipsManager.quickTip.show("该宝石已满级");
                    return
                }
                var list = this.____1642.getUpLevelList();
                if (list == null || list.length <= 0) {
                    ____654.tipsManager.quickTip.show("材料不足");
                    return
                }
                var equipType = this.____1642.getEuipType();
                var stoneType = this.____1642.getStoneType();
                ____654.weaponMessageSender.sendStoneUp(equipType, stoneType, list);
                return
            }
            for (var i = 0; i < this.____888.length; i++) {
                if (sender == this.____888[i]) {
                    print("点击选择装备", i);
                    this.setEquipSelect(this.____888[i]);
                    return
                }
            }
            for (var i = 0; i < this.____1724.length; i++) {
                if (sender == this.____1724[i]) {
                    print("选择宝石", i);
                    if (this.____1724[i].checkIsOpen()) {
                        this.setSelectItem(this.____1724[i])
                    } else {
                        ____654.tipsManager.quickTip.show("该宝石未解锁")
                    }
                    return
                }
            }
        }
    },
    setEquipSelect: function(equipItem) {
        if (this.____1634 == equipItem) {
            return
        }
        if (equipItem.getItemInfo(true) == null) {
            return
        }
        if (this.____1634 != null) {
            this.____1634.____239(false)
        }
        this.____1634 = equipItem;
        if (this.____1634 != null) {
            this.____1634.____239(true)
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this.updateView()
    },
    gridClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_BEGAN) {
            this.showTip(sender)
        } else if (eventType == ccui.Widget.TOUCH_ENDED || eventType == ccui.Widget.TOUCH_CANCELED) {
            this.hideTip()
        } else if (eventType == ccui.Widget.TOUCH_MOVED) {
            if (sender.getTouchBeganPosition().x - sender.getTouchMovePosition().x > 10 || sender.getTouchBeganPosition().y - sender.getTouchMovePosition().y > 10) {
                this.hideTip()
            }
        }
    },
    showTip: function(sender) {
        var pos = sender.getParent().convertToWorldSpace(____654.____673.____159(sender.getParent().____1477, sender.getParent().____1478));
        if (sender.getParent().getItemInfo() != null) {
            var stoneList = new TipStoneInfoList(____655.____667.level);
            var equipType = sender.getParent().getItemInfo().template.categoryId;
            var baoshiEquipTemplate = ____655.allTemplates.baoShiEquipTemplateList.getTemplateInfoByType(equipType);
            for (var i = 0; i < baoshiEquipTemplate.baoshiList.length; i++) {
                var stoneInfo = new TipStoneInfo();
                var type = baoshiEquipTemplate.baoshiList[i][0];
                stoneInfo.stoneType = type;
                stoneInfo.openLevel = baoshiEquipTemplate.baoshiList[i][1];
                var template = null;
                if (baoshiEquipTemplate.baoshiList[i][1] >= ____655.____667.level) {
                    var exp = ____655.furnaceInfo.getStoneExpByType(equipType, type);
                    template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndExp(type, exp)
                }
                if (template == null) {
                    template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndLv(type, 1)
                }
                stoneInfo.stoneLevel = template.level;
                stoneInfo.template = template;
                stoneList.stoneList.push(stoneInfo)
            }
            ____654.tipsManager.showItemFlashTip(sender.getParent().getItemInfo(), pos, stoneList)
        }
    },
    hideTip: function() {
        ____654.tipsManager.hideFlashTip()
    },
    updateView: function(evt) {
        if (this.____1634 == null) {
            return
        }
        var info = this.____1634.getItemInfo();
        this.____1029.setItemInfo(info);
        var fight = 0;
        var equipType = info.template.categoryId;
        var baoshiEquipTemplate = ____655.allTemplates.baoShiEquipTemplateList.getTemplateInfoByType(equipType);
        for (var i = 0; i < baoshiEquipTemplate.baoshiList.length; i++) {
            this.____1724[i].____363(equipType, baoshiEquipTemplate.baoshiList[i]);
            fight += this.____1724[i].getFight()
        }
        if (this._addNumberUtils == null) {
            this._addNumberUtils = new AddNumberUtils(this.____995, fight)
        } else {
            this._addNumberUtils.setValue(fight)
        }
        if (this.____1642 != null && this.____1642.checkUpgrad()) {
            this.setSelectItem(this.____1642);
            return
        }
        for (var i = 0; i < this.____1724.length; i++) {
            if (this.____1724[i].checkUpgrad()) {
                this.setSelectItem(this.____1724[i]);
                return
            }
        }
        if (this.____1642 != null) {
            this.setSelectItem(this.____1642);
            return
        }
        this.setSelectItem(this.____1724[0])
    },
    setSelectItem: function(stoneItem) {
        if (this.____1642 != null) {
            this.____1642.____239(false)
        }
        this.____1642 = stoneItem;
        this.____1642.____239(true);
        for (var i = 0; i < this.____1389.length; i++) {
            this.____1389[i].setItemInfo(null);
            this.____1389[i].setCount(-1)
        }
        var temp = this.____1642.getNextTemplate();
        if (temp != null) {
            var index = 0;
            for (var i = 0; i < temp.itemList.length; i++) {
                var tempId = temp.itemList[i];
                if (tempId != null) {
                    var count = ____655.itemInfoList.getCountByTempId(tempId);
                    if (count > 0) {
                        var templateItemInfo = ____655.allTemplates.____794.getItem(tempId);
                        if (this.____1389[index] != null) {
                            this.____1389[index].setItemTemplateInfo(templateItemInfo);
                            this.____1389[index].setCount(count);
                            index++
                        }
                    }
                }
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        if (this.____1724 != null) {
            var len = this.____1724.length;
            for (var i = 0; i < len; i++) {
                this.____1724[i].dispose()
            }
            this.____1724 = null
        }
        if (this.____888 != null) {
            var len = this.____888.length;
            for (var i = 0; i < len; i++) {
                this.____888[i].dispose()
            }
            this.____888 = null
        }
        if (this.____1389 != null) {
            var len = this.____1389.length;
            for (var i = 0; i < len; i++) {
                this.____1389[i].dispose()
            }
            this.____1389 = null
        }
        this.____1029.dispose();
        this.____1029 = null;
        this.____1634 = null;
        this.____1642 = null;
        this._bg = null;
        this.____908 = null;
        this.____995 = null;
        this.____1421 = null;
        this._upBtn = null;
        ____654.tipsManager.hideFlashTip();
        this._super()
    },
});
var ____2342 = KYPanel.extend({
    _controller: null,
    ____908: null,
    _bg: null,
    ____995: null,
    ____1418: null,
    ____1421: null,
    _upBtn: null,
    ____1555: null,
    ____1568: null,
    _proPlusValueList: null,
    ____1390: null,
    _moneyView: null,
    _bgPath: null,
    ____888: null,
    ____1029: null,
    ____1453: null,
    ____1389: null,
    ____1454: null,
    ____1634: null,
    ____1015: null,
    _addNumberUtils: null,
    ctor: function(controller) {
        this._super("weaponStrengthenPanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this.____908 = this.getChildByName("btnListView");
        this.____908.setScrollBarEnabled(false);
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/strength_bg2.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this.____995 = this.getChildByName("combatLabel");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____1421 = this.getChildByName("moneyLabel");
        this._upBtn = this.getChildByName("upBtn");
        this.____1555 = [];
        this.____1568 = [];
        this._proPlusValueList = [];
        this.getChildByName("proName1").setString("");
        this.getChildByName("proValue1").setString("");
        this.getChildByName("proPlusValue1").setString("");
        this.getChildByName("proName4").setString("");
        this.getChildByName("proValue4").setString("");
        this.getChildByName("proPlusValue4").setString("");
        for (var i = 2; i <= 3; i++) {
            this.____1555.push(this.getChildByName("proName" + i));
            this.____1568.push(this.getChildByName("proValue" + i));
            this._proPlusValueList.push(this.getChildByName("proPlusValue" + i))
        }
        this.____1390 = [];
        this.____1389 = [];
        for (var i = 0; i < 3; i++) {
            this.____1390.push(this.getChildByName("materialLock" + (i + 1)));
            var materialCell = this.getChildByName("materialCell" + (i + 1));
            var item = new ____2129();
            materialCell.addChild(item, 1);
            this.____1389.push(item)
        }
        var curEquipCell = this.getChildByName("curEquipCell");
        this.____1029 = new ____2129();
        this.____1029.addListener(this, this.gridClickHandler);
        this.____1029.setIsShowCount(false);
        this.____1029.setIsShowQHLevel(true);
        curEquipCell.addChild(this.____1029, 1);
        var nextEquipCell = this.getChildByName("nextEquipCell");
        this.____1453 = new ____2129();
        this.____1453.addListener(this, this.gridClickHandler);
        this.____1453.setIsShowCount(false);
        this.____1453.setIsShowQHLevel(true);
        nextEquipCell.addChild(this.____1453, 1);
        this.____888 = [];
        var equipItemList = ____655.____659.categoryType.equipList;
        for (var i = 0; i < equipItemList.length; i++) {
            var btn = new ____2335(equipItemList[i]);
            btn.addListener(this, this.____16, null, null, null, false, true);
            this.____908.pushBackItem(btn);
            this.____888.push(btn)
        }
        this.____5();
        this.____6()
    },
    ____5: function() {
        for (var i = 0; i < this.____888.length; i++) {
            if (this.____888[i].checkCanStrength()) {
                this.setEquipSelect(this.____888[i]);
                return
            }
        }
        for (var i = 0; i < this.____888.length; i++) {
            if (this.____888[i].getItemInfo(false) != null) {
                this.setEquipSelect(this.____888[i]);
                return
            }
        }
        this.setEquipSelect(this.____888[0])
    },
    ____6: function() {
        this._upBtn.addListener(this, this.____16);
        ____655.itemInfoList.addEventListener(____655.____661.weapon_strengthResult, this.itemInfoUpdate, this);
        ____654.____672.addEventListener(____655.____661.guide_strength, this.strengthHandler, this);
        ____654.____672.addEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this)
    },
    ____17: function() {
        ____655.itemInfoList.removeEventListener(____655.____661.weapon_strengthResult, this.itemInfoUpdate, this);
        ____654.____672.removeEventListener(____655.____661.guide_strength, this.strengthHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_changeTabIndex, this.changeTabIndexHandler, this)
    },
    changeTabIndexHandler: function(evt) {
        if (this.getParent() != null) {
            var index = evt.data;
            if (this.____888[index] != null) {
                this.setEquipSelect(this.____888[index])
            }
        }
    },
    itemInfoUpdate: function(evt) {
        var result = evt.data;
        if (this.____1634 == null || this.____1634.getItemInfo() == null) {
            return
        }
        if (result[0] && this.____1634.getItemInfo().id == result[1]) {
            this.updateView()
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this._upBtn) {
                this.strengthHandler();
                return
            }
            for (var i = 0; i < this.____888.length; i++) {
                if (sender == this.____888[i]) {
                    print("点击选择装备", i);
                    this.setEquipSelect(this.____888[i]);
                    return
                }
            }
        }
    },
    strengthHandler: function() {
        print("强化点击");
        if (this.____1015 != null) {
            for (var i = 0; i < this.____1015.items.length; i++) {
                var count = ____655.itemInfoList.getCountByTempId(this.____1015.items[i][0]);
                if (count < this.____1015.items[i][1]) {
                    ____654.tipsManager.quickTip.show("强化石不足");
                    return
                }
            }
            if (!____655.____667.moneyInfo.money2Enough(this.____1015.needCopper)) {
                ____654.tipsManager.quickTip.show("铜币不足");
                return
            }
            if (this.____1634 != null) {
                var info = this.____1634.getItemInfo();
                if (info != null) {
                    print("发送强化物品协议~~");
                    ____654.weaponMessageSender.sendEquipStrength(info.id, 0, 0)
                }
            }
        }
    },
    setEquipSelect: function(equipItem) {
        if (this.____1634 == equipItem) {
            return
        }
        if (equipItem.getItemInfo(true) == null) {
            return
        }
        if (this.____1634 != null) {
            this.____1634.____239(false)
        }
        this.____1634 = equipItem;
        if (this.____1634 != null) {
            this.____1634.____239(true)
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        this.updateView()
    },
    updateView: function() {
        if (this.____1634 == null) {
            return
        }
        var info = this.____1634.getItemInfo();
        this.____1029.setItemInfo(info);
        if (this.____1454 != null) {
            this.____1454.dispose();
            this.____1454 = null
        }
        this.____1015 = null;
        if (info != null) {
            if (info.qhLevel < ____655.allTemplates.strengthPropertyTemplateList.MAX_STRENGTH_LEVEL) {
                this.____1454 = info.getClone();
                this.____1454.qhLevel += 1;
                this.____1453.setItemInfo(this.____1454);
                this._upBtn.setTouchEnabled(true);
                this._upBtn.setFrame("btn/ui_btn1_2.png", 1);
                this.getChildByName("titleLabel").setString("强   化")
            } else {
                this.____1453.setItemInfo(null);
                this.____1453.setQHLevel(-1);
                this._upBtn.setTouchEnabled(false);
                this._upBtn.setFrame("btn/ui_btn1_4.png", 1);
                this.getChildByName("titleLabel").setString("满   级")
            }
            var curProTemplate = ____655.allTemplates.strengthPropertyTemplateList.____238(info.template.categoryId, info.qhLevel);
            var nextProTemplate = null;
            if (this.____1454 != null) {
                nextProTemplate = ____655.allTemplates.strengthPropertyTemplateList.____238(info.template.categoryId, info.qhLevel + 1)
            }
            var proList = null;
            var fight = 0;
            if (curProTemplate != null) {
                proList = curProTemplate.propertyAdd;
                for (var i = 0; i < this.____1568.length; i++) {
                    if (proList[i] != null) {
                        this.____1568[i].setString(proList[i].value);
                        fight += ____655.____659.propertyType.getFight(proList[i].id, proList[i].value)
                    } else {
                        this.____1568[i].setString("")
                    }
                }
            } else {
                proList = nextProTemplate.propertyAdd;
                for (var i = 0; i < this.____1568.length; i++) {
                    if (proList[i] != null) {
                        this.____1568[i].setString("0")
                    } else {
                        this.____1568[i].setString("")
                    }
                }
            }
            if (this._addNumberUtils == null) {
                this._addNumberUtils = new AddNumberUtils(this.____995, fight)
            } else {
                this._addNumberUtils.setValue(fight)
            }
            for (var i = 0; i < this.____1555.length; i++) {
                if (proList[i] != null) {
                    this.____1555[i].setString(____655.____659.propertyType.getNameByType(proList[i].id))
                } else {
                    this.____1555[i].setString("")
                }
            }
            if (nextProTemplate != null) {
                for (var i = 0; i < this._proPlusValueList.length; i++) {
                    if (nextProTemplate.propertyAdd[i] != null) {
                        var num = 0;
                        if (curProTemplate != null) {
                            num = curProTemplate.propertyAdd[i].value
                        }
                        this._proPlusValueList[i].setString("+" + (nextProTemplate.propertyAdd[i].value - num))
                    } else {
                        this._proPlusValueList[i].setString("")
                    }
                }
                var costTemplateInfo = ____655.allTemplates.strengthCostTemplateList.getCost(nextProTemplate.strengthLevel);
                this.____1015 = costTemplateInfo;
                if (costTemplateInfo != null) {
                    this.____1421.setString(costTemplateInfo.needCopper);
                    for (var i = 0; i < this.____1389.length; i++) {
                        if (costTemplateInfo.items[i] != null) {
                            var templateItemInfo = ____655.allTemplates.____794.getItem(costTemplateInfo.items[i][0]);
                            this.____1389[i].setItemTemplateInfo(templateItemInfo);
                            this.____1390[i].setVisible(false)
                        } else {
                            this.____1389[i].setItemTemplateInfo(null);
                            this.____1389[i].setCount(-1);
                            this.____1390[i].setVisible(true)
                        }
                    }
                    this.updateCost()
                } else {
                    this.____1421.setString(0);
                    for (var i = 0; i < this.____1389.length; i++) {
                        this.____1389[i].setItemTemplateInfo(null);
                        this.____1389[i].setCount(-1);
                        this.____1390[i].setVisible(true)
                    }
                }
            } else {
                for (var i = 0; i < this._proPlusValueList.length; i++) {
                    this._proPlusValueList[i].setString("")
                }
                this.____1421.setColor(____655.____659.____688.white);
                this.____1421.setString("0");
                for (var i = 0; i < this.____1389.length; i++) {
                    this.____1389[i].setItemTemplateInfo(null);
                    this.____1389[i].setCount(-1);
                    this.____1390[i].setVisible(true)
                }
            }
        } else {
            this.____1453.setItemInfo(null);
            this.____1453.setQHLevel(-1);
            this.____1421.setColor(____655.____659.____688.white);
            this.____1421.setString("0");
            for (var i = 0; i < this.____1389.length; i++) {
                this.____1389[i].setItemTemplateInfo(null);
                this.____1389[i].setCount(-1);
                this.____1390[i].setVisible(true)
            }
        }
    },
    updateCost: function() {
        if (this.____1015 != null) {
            for (var i = 0; i < this.____1389.length; i++) {
                if (this.____1015.items[i] != null) {
                    var count = ____655.itemInfoList.getCountByTempId(this.____1015.items[i][0]);
                    this.____1389[i].setNeedCount(count, this.____1015.items[i][1])
                } else {
                    this.____1389[i].setCount(-1)
                }
            }
            if (____655.____667.moneyInfo.money2Enough(this.____1015.needCopper)) {
                this.____1421.setColor(____655.____659.____688.white)
            } else {
                this.____1421.setColor(____655.____659.____688.red)
            }
        } else {
            for (var i = 0; i < this.____1389.length; i++) {
                this.____1389[i].setCount(-1)
            }
        }
    },
    gridClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_BEGAN) {
            this.showTip(sender)
        } else if (eventType == ccui.Widget.TOUCH_ENDED || eventType == ccui.Widget.TOUCH_CANCELED) {
            this.hideTip()
        } else if (eventType == ccui.Widget.TOUCH_MOVED) {
            if (sender.getTouchBeganPosition().x - sender.getTouchMovePosition().x > 10 || sender.getTouchBeganPosition().y - sender.getTouchMovePosition().y > 10) {
                this.hideTip()
            }
        }
    },
    showTip: function(sender) {
        var pos = sender.getParent().convertToWorldSpace(____654.____673.____159(sender.getParent().____1477, sender.getParent().____1478));
        if (sender.getParent().getItemInfo() != null) {
            var stoneList = new TipStoneInfoList(____655.____667.level);
            var equipType = sender.getParent().getItemInfo().template.categoryId;
            var baoshiEquipTemplate = ____655.allTemplates.baoShiEquipTemplateList.getTemplateInfoByType(equipType);
            for (var i = 0; i < baoshiEquipTemplate.baoshiList.length; i++) {
                var stoneInfo = new TipStoneInfo();
                var type = baoshiEquipTemplate.baoshiList[i][0];
                stoneInfo.stoneType = type;
                stoneInfo.openLevel = baoshiEquipTemplate.baoshiList[i][1];
                var template = null;
                if (baoshiEquipTemplate.baoshiList[i][1] >= ____655.____667.level) {
                    var exp = ____655.furnaceInfo.getStoneExpByType(equipType, type);
                    template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndExp(type, exp)
                }
                if (template == null) {
                    template = ____655.allTemplates.baoShiTemplateList.getTemplateByTypeAndLv(type, 1)
                }
                stoneInfo.stoneLevel = template.level;
                stoneInfo.template = template;
                stoneList.stoneList.push(stoneInfo)
            }
            ____654.tipsManager.showItemFlashTip(sender.getParent().getItemInfo(), pos, stoneList)
        }
    },
    hideTip: function() {
        ____654.tipsManager.hideFlashTip()
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this._addNumberUtils != null) {
            this._addNumberUtils.dispose();
            this._addNumberUtils = null
        }
        if (this.____888 != null) {
            var len = this.____888.length;
            for (var i = 0; i < len; i++) {
                this.____888[i].dispose()
            }
            this.____888 = null
        }
        if (this.____1454 != null) {
            this.____1454.dispose();
            this.____1454 = null
        }
        if (this.____1389 != null) {
            var len = this.____1389.length;
            for (var i = 0; i < len; i++) {
                this.____1389[i].dispose()
            }
            this.____1389 = null
        }
        this.____1029.dispose();
        this.____1029 = null;
        this.____1453.dispose();
        this.____1453 = null;
        this.____1015 = null;
        this.____908 = null;
        this._bg = null;
        this.____995 = null;
        this.____1418 = null;
        this.____1421 = null;
        this._upBtn = null;
        this.____1555 = null;
        this.____1568 = null;
        this._proPlusValueList = null;
        this.____1390 = null;
        this.____1634 = null;
        ____654.tipsManager.hideFlashTip();
        this._super()
    },
});
var WeaponXiLianPanel = KYPanel.extend({
    _closeBtn: null,
    _curProLabel: null,
    _newProLabel: null,
    _huifuBtn: null,
    _xilianBtn: null,
    _equipNameLabel: null,
    ____1391: null,
    _checkBtnList: null,
    _equipProLabelList: null,
    _equipProStarLabelList: null,
    _equipCheckBoxList: null,
    _equipRecommendList: null,
    _materialProLabelList: null,
    _materialProStarLabelList: null,
    ____1636: null,
    _equipGrid: null,
    _materialGrid: null,
    _equipInfo: null,
    ____1139: null,
    ____1637: -1,
    _xilianFlag: true,
    _tickCount: -1,
    _tickIndex: 1,
    _xilianIndex: -1,
    ctor: function(equipInfo) {
        this._super("weaponXiLianView.ExportJson");
        this._equipInfo = equipInfo;
        this._closeBtn = this.getChildByName("closeBtn");
        this._curProLabel = this.getChildByName("curProLabel");
        this._newProLabel = this.getChildByName("newProLabel");
        this._huifuBtn = this.getChildByName("huifuBtn");
        this._huifuBtn.setFrame("btn/ui_btn1_4.png");
        this._huifuBtn.setTouchEnabled(false);
        this._xilianBtn = this.getChildByName("xilianBtn");
        this.____1636 = this.getChildByName("selectImg");
        this.____1636.setVisible(false);
        this._equipNameLabel = this.getChildByName("nameLabel1");
        this.____1391 = this.getChildByName("nameLabel2");
        this._checkBtnList = [];
        this._equipProLabelList = [];
        this._equipProStarLabelList = [];
        this._equipCheckBoxList = [];
        this._equipRecommendList = [];
        this._materialProLabelList = [];
        this._materialProStarLabelList = [];
        for (var i = 1; i <= 5; i++) {
            this._equipProLabelList.push(this.getChildByName("proLabel1" + i));
            this._equipProStarLabelList.push(this.getChildByName("proStarLabel1" + i));
            var checkBtn = this.getChildByName("checkBoxBtn1" + i);
            var checkBox = this.getChildByName("checkBox1" + i);
            checkBox.setTouchEnabled(false);
            checkBox.setSelected(false);
            var recommendFlag = this.getChildByName("flag1" + i);
            recommendFlag.setVisible(false);
            this._checkBtnList.push(checkBtn);
            this._equipCheckBoxList.push(checkBox);
            this._equipRecommendList.push(recommendFlag);
            this._materialProLabelList.push(this.getChildByName("proLabel2" + i));
            this._materialProStarLabelList.push(this.getChildByName("proStarLabel2" + i))
        }
        this._equipGrid = new ____2129();
        this._equipGrid.setIsShowCount(false);
        this._equipGrid.setIsShowQHLevel(true);
        this.getChildByName("cell1").addChild(this._equipGrid, 1);
        this._materialGrid = new ____2129();
        this._materialGrid.setIsShowCount(false);
        this.getChildByName("cell2").addChild(this._materialGrid, 1);
        this.____5();
        this.____6()
    },
    ____5: function() {
        this.setMaterialInfo(this._equipInfo);
        var itemInfo = ____655.itemInfoList.getBodyEquipByType(this._equipInfo.template.categoryId);
        this.setItemInfo(itemInfo);
        this.rollProRecommend()
    },
    setMaterialInfo: function(materialInfo) {
        this._materialGrid.setItemInfo(materialInfo);
        var rollPropertyList = {};
        if (materialInfo != null) {
            rollPropertyList = this._equipInfo.rollProperty;
            this.____1391.setColor(____655.____659.____688.getColorByQuality(this._equipInfo.____57()));
            var materialName = this._equipInfo.getName();
            if (this._equipInfo.qhLevel > 0) {
                materialName = materialName + " +" + this._equipInfo.qhLevel
            }
            this.____1391.setString(materialName)
        } else {
            this.____1391.setString("")
        }
        for (var i = 0; i < this._materialProLabelList.length; i++) {
            var rollProInfo = rollPropertyList[i + 1];
            if (rollProInfo != null) {
                this._materialProLabelList[i].setString(____655.____659.propertyType.getNameByType(rollProInfo.id) + "+" + rollProInfo.value);
                this._materialProStarLabelList[i].setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text1", rollProInfo.star));
                var ____688 = ____655.____659.____688.getColorByQuality(rollProInfo.quality);
                this._materialProLabelList[i].setColor(____688);
                this._materialProStarLabelList[i].setColor(____688)
            } else {
                this._materialProLabelList[i].setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text2"));
                this._materialProStarLabelList[i].setString("");
                var ____688 = ____655.____659.____688.itemColorList[0];
                this._materialProLabelList[i].setColor(____688);
                this._materialProStarLabelList[i].setColor(____688)
            }
        }
    },
    setItemInfo: function(itemInfo) {
        if (this.____1139 != null) {
            this.____1139.removeEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this)
        }
        this.____1139 = itemInfo;
        if (this.____1139 != null) {
            this.____1139.addEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this);
            this._equipNameLabel.setColor(____655.____659.____688.getColorByQuality(this.____1139.____57()));
            var equiplName = this.____1139.getName();
            if (itemInfo.qhLevel > 0) {
                equiplName = equiplName + " +" + this.____1139.qhLevel
            }
            this._equipNameLabel.setString(equiplName)
        }
        this._equipGrid.setItemInfo(this.____1139);
        this.itemInfoUpdate()
    },
    itemInfoUpdate: function() {
        if (this.____1139 == null) {
            return
        }
        for (var i = 0; i < this._equipProLabelList.length; i++) {
            var rollProInfo = this.____1139.rollProperty[i + 1];
            if (rollProInfo != null) {
                this._equipProLabelList[i].setString(____655.____659.propertyType.getNameByType(rollProInfo.id) + "+" + rollProInfo.value);
                this._equipProStarLabelList[i].setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text1", rollProInfo.star));
                var ____688 = ____655.____659.____688.getColorByQuality(rollProInfo.quality);
                this._equipProLabelList[i].setColor(____688);
                this._equipProStarLabelList[i].setColor(____688)
            } else {
                this._equipProLabelList[i].setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text2"));
                this._equipProStarLabelList[i].setString("");
                var ____688 = ____655.____659.____688.itemColorList[0];
                this._equipProLabelList[i].setColor(____688);
                this._equipProStarLabelList[i].setColor(____688)
            }
        }
    },
    rollProRecommend: function() {
        if (this.____1139 == null) {
            return
        }
        var index = -1;
        var star = 99999;
        var quality = 99999;
        for (var i = 0; i < this._equipRecommendList.length; i++) {
            this._equipRecommendList[i].setVisible(false);
            var rollProInfo = this.____1139.rollProperty[i + 1];
            var rollStar = 0;
            var rollQuality = 0;
            if (rollProInfo != null) {
                rollStar = rollProInfo.star;
                rollQuality = rollProInfo.quality
            }
            if ((quality > rollQuality) || (quality == rollQuality && star > rollStar)) {
                star = rollStar;
                quality = rollQuality;
                index = i
            }
        }
        if (index > -1) {
            this._equipRecommendList[index].setVisible(true);
            this.selectProIndex(index)
        }
    },
    selectProIndex: function(index) {
        if (this.____1637 == index) {
            return
        }
        if (this.____1637 > -1) {
            this._equipCheckBoxList[this.____1637].setSelected(false)
        }
        this.____1637 = index;
        if (this.____1637 > -1) {
            this._equipCheckBoxList[this.____1637].setSelected(true);
            if (this.____1139 != null) {
                var rollProInfo = this.____1139.rollProperty[this.____1637 + 1];
                if (rollProInfo != null) {
                    this._curProLabel.setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text3", ____655.____659.propertyType.getNameByType(rollProInfo.id) + "+" + rollProInfo.value + ____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text1", rollProInfo.star)))
                } else {
                    this._curProLabel.setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text3", ____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text2")))
                }
            } else {
                this._curProLabel.setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text3", ____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text2")))
            }
        } else {
            this._curProLabel.setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text3", ____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text2")))
        }
    },
    xilianHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._xilianFlag) {
                this.getChildByName("xilianBtnLabel").setString("确 定");
                this._xilianBtn.setFrame("btn/ui_btn1_4.png");
                this._xilianBtn.setTouchEnabled(false);
                this._closeBtn.setVisible(false);
                for (var i = 0; i < this._checkBtnList.length; i++) {
                    this._checkBtnList[i].setTouchEnabled(false)
                }
                ____654.____683.sendXiLianMaterial(this._equipInfo.id, this.____1637 + 1)
            } else {
                ____654.____683.sendChooseXilian(1);
                this.setMaterialInfo(null);
                this._closeBtn.setVisible(true);
                this._xilianBtn.setFrame("btn/ui_btn1_4.png");
                this._xilianBtn.setTouchEnabled(false);
                this._huifuBtn.setFrame("btn/ui_btn1_4.png");
                this._huifuBtn.setTouchEnabled(false);
                this.____1636.setVisible(false);
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text6"))
            }
        }
    },
    okClick: function() {
        if (____655.____667.moneyInfo.moneyEnoughByType(5, 10)) {
            ____654.____683.sendChooseXilian(2);
            this.setMaterialInfo(null);
            this._closeBtn.setVisible(true);
            this._xilianBtn.setFrame("btn/ui_btn1_4.png");
            this._xilianBtn.setTouchEnabled(false);
            this._huifuBtn.setFrame("btn/ui_btn1_4.png");
            this._huifuBtn.setTouchEnabled(false);
            this.____1636.setVisible(false);
            ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text7"))
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    huifuHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            ____655.getAlert().show(2, ____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text8") + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold"), null, 0, this, this.okClick, null, null)
        }
    },
    ____6: function() {
        this._closeBtn.addListener(this, this.closeClickHandler);
        for (var i = 0; i < this._checkBtnList.length; i++) {
            this._checkBtnList[i].addListener(this, this.selectProHandler)
        }
        this._xilianBtn.addListener(this, this.xilianHandler);
        this._huifuBtn.addListener(this, this.huifuHandler);
        ____655.furnaceInfo.addEventListener(____655.____661.weapon_xilianResult, this.xilianResultHandler, this);
        ____654.____672.addEventListener(____655.____661.guide_confirmXiLianPro, this.guideHandler1, this);
        ____654.____672.addEventListener(____655.____661.guide_closeXiLianPanel, this.guideHandler2, this);
        ____654.____672.addEventListener(____655.____661.guide_confirmXiLianAgain, this.guideHandler3, this)
    },
    ____17: function() {
        if (this.____1139 != null) {
            this.____1139.removeEventListener(____655.____661.common_itemInfoUpdate, this.itemInfoUpdate, this)
        }
        ____655.furnaceInfo.removeEventListener(____655.____661.weapon_xilianResult, this.xilianResultHandler, this);
        ____654.____672.removeEventListener(____655.____661.guide_confirmXiLianPro, this.guideHandler1, this);
        ____654.____672.removeEventListener(____655.____661.guide_closeXiLianPanel, this.guideHandler2, this);
        ____654.____672.removeEventListener(____655.____661.guide_confirmXiLianAgain, this.guideHandler3, this)
    },
    guideHandler1: function() {
        this.xilianHandler(null, ccui.Widget.TOUCH_ENDED)
    },
    guideHandler2: function() {
        this.closeClickHandler(null, ccui.Widget.TOUCH_ENDED)
    },
    guideHandler3: function() {
        this.xilianHandler(null, ccui.Widget.TOUCH_ENDED)
    },
    xilianResultHandler: function(evt) {
        this._xilianIndex = evt.data;
        this._xilianFlag = false;
        if (this._xilianIndex > 0) {
            this.____1636.setVisible(true);
            this.____1636.setPositionY(366);
            this._tickCount = 600;
            this._tickIndex = 1;
            ____654.____678.____298(this.tick, this)
        } else {
            this.____1636.setVisible(false)
        }
    },
    tick: function() {
        this._tickCount--;
        var num = this._tickCount % 5;
        if (num > 0) {
            return
        }
        this._tickIndex++;
        this.____1636.setPositionY(366 - ((this._tickIndex - 1) % 5) * 42);
        if (this._tickIndex > 15 && ((this._tickIndex - 1) % 5) == (this._xilianIndex - 1)) {
            ____654.____678.____299(this.tick, this);
            this._xilianBtn.setFrame("btn/ui_btn1_2.png");
            this._xilianBtn.setTouchEnabled(true);
            if (this.____1139 != null && this.____1139.rollProperty[this.____1637 + 1] != null) {
                this._huifuBtn.setFrame("btn/ui_btn1_3.png");
                this._huifuBtn.setTouchEnabled(true)
            }
            if (this._equipInfo != null && this._equipInfo.rollProperty[this._xilianIndex] != null) {
                var rollProInfo = this._equipInfo.rollProperty[this._xilianIndex];
                this._newProLabel.setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text4", ____655.____659.propertyType.getNameByType(rollProInfo.id) + "+" + rollProInfo.value + ____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text1", rollProInfo.star)))
            } else {
                this._newProLabel.setString(____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text4", ____654.yuyanbaoManager.getYuyanbao("WeaponXiLianPanel.text2")))
            }
        }
    },
    selectProHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            for (var i = 0; i < this._checkBtnList.length; i++) {
                if (sender == this._checkBtnList[i]) {
                    this.selectProIndex(i);
                    return
                }
            }
        }
    },
    closeClickHandler: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            this.dispose()
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____17();
        this._super();
        this._equipInfo = null;
        this._closeBtn = null;
        this._curProLabel = null;
        this._newProLabel = null;
        this._huifuBtn = null;
        this._xilianBtn = null;
        this._equipNameLabel = null;
        this.____1391 = null;
        this._checkBtnList = null;
        this._equipProLabelList = null;
        this._equipProStarLabelList = null;
        this._equipCheckBoxList = null;
        this._equipRecommendList = null;
        this._materialProLabelList = null;
        this._materialProStarLabelList = null;
        this.____1636 = null;
        this._equipGrid.dispose();
        this._equipGrid = null;
        this._materialGrid.dispose();
        this._materialGrid = null;
        this.____1139 = null;
        this._tickCount = null;
        this._tickIndex = null;
        this._xilianIndex = null
    },
});
var ____2332 = cc.Class.extend({
    weaponMondule: null,
    ctor: function(weaponMondule) {
        this.weaponMondule = weaponMondule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    showWeaponPanel: function(type) {
        if (type == ____655.____659.panelTabType.weaponGod) {
            if (this.weaponMondule.weaponGodPanel == null) {
                this.weaponMondule.weaponGodPanel = new ____2337(this)
            }
            ____654.____676.uiPanelContainer.____125(this.weaponMondule.weaponGodPanel, type)
        } else if (type == ____655.____659.panelTabType.weaponStrength) {
            if (this.weaponMondule.weaponStrengthPanel == null) {
                this.weaponMondule.weaponStrengthPanel = new ____2342(this)
            }
            ____654.____676.uiPanelContainer.____125(this.weaponMondule.weaponStrengthPanel, type)
        } else if (type == ____655.____659.panelTabType.weaponStone) {
            if (this.weaponMondule.weaponStonePanel == null) {
                this.weaponMondule.weaponStonePanel = new ____2341(this)
            }
            ____654.____676.uiPanelContainer.____125(this.weaponMondule.weaponStonePanel, type)
        } else if (type == ____655.____659.panelTabType.weaponSoul) {
            if (this.weaponMondule.weaponSoulPanel == null) {
                this.weaponMondule.weaponSoulPanel = new ____2339(this)
            }
            ____654.____676.uiPanelContainer.____125(this.weaponMondule.weaponSoulPanel, type)
        } else if (type == ____655.____659.panelTabType.weaponPot) {
            if (this.weaponMondule.weaponPotPanel == null) {
                this.weaponMondule.weaponPotPanel = new ____2338(this)
            }
            ____654.____676.uiPanelContainer.____125(this.weaponMondule.weaponPotPanel, type)
        }
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.weaponMondule.weaponGodPanel) {
            this.weaponMondule.weaponGodPanel = null
        } else if (p == this.weaponMondule.weaponStrengthPanel) {
            this.weaponMondule.weaponStrengthPanel = null
        } else if (p == this.weaponMondule.weaponStonePanel) {
            this.weaponMondule.weaponStonePanel = null
        } else if (p == this.weaponMondule.weaponSoulPanel) {
            this.weaponMondule.weaponSoulPanel = null
        } else if (p == this.weaponMondule.weaponPotPanel) {
            this.weaponMondule.weaponPotPanel = null
        }
    },
});
var ____2333 = ____537.extend({
    weaponController: null,
    weaponGodPanel: null,
    weaponStrengthPanel: null,
    weaponStonePanel: null,
    weaponSoulPanel: null,
    weaponPotPanel: null,
    setup: function(data) {
        this.weaponController = new ____2332(this);
        this.____151(data)
    },
    ____151: function(data) {
        this.weaponController.showWeaponPanel(data[0])
    },
    clear: function() {},
});
var ____2352 = KYNode.extend({
    _cell: null,
    ____1344: null,
    _nameLabel: null,
    _oldPriceLabel: null,
    ____1544: null,
    ____919: null,
    _outFlag: null,
    _grid: null,
    ____1752: null,
    _limitInfo: null,
    _flagIcon: null,
    _limitEventFlag: false,
    ctor: function(info) {
        this._super("welfareLimitBuyItemView.ExportJson");
        this.____1752 = info;
        this._cell = this.getChildByName("cell");
        this._grid = new ____2129();
        this._grid.setIsShowCount(false);
        this._cell.addChild(this._grid);
        this.____1344 = this.getChildByName("limitLabel");
        this._nameLabel = this.getChildByName("nameLabel");
        this._oldPriceLabel = this.getChildByName("oriPrice");
        this.____1544 = this.getChildByName("price");
        this.____919 = this.getChildByName("buyBtn");
        this._outFlag = this.getChildByName("outFlag");
        this._outFlag.setVisible(false);
        this._flagIcon = this.getChildByName("flagIcon");
        this._flagIcon.setVisible(false);
        this.____6();
        this.____5();
        this.getChildByName("cotent1").setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text7"));
        this.getChildByName("cotent2").setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text8"));
        this.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text9"))
    },
    ____6: function() {
        this.____919.addListener(this, this.____16, null, null, null, false, true);
        ____655.statInfo.addEventListener(____655.____661.stat_shopList_update, this.setLimitInfoView, this)
    },
    ____17: function() {
        ____655.statInfo.removeEventListener(____655.____661.stat_shopList_update, this.setLimitInfoView, this);
        if (this._limitInfo != null) {
            this._limitInfo.removeEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
        }
    },
    ____5: function() {
        if (this.____1752 == null) return;
        this._nameLabel.setString(this.____1752.itemTemplateInfo.name);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(this.____1752.itemTemplateInfo.quality));
        this._grid.setItemTemplateInfo(this.____1752.itemTemplateInfo);
        this._grid.setCount(this.____1752.amount);
        this.____1544.setString(this.____1752.price);
        this._oldPriceLabel.setString(this.____1752.oldPrice);
        var discount = Math.ceil(this.____1752.price / this.____1752.oldPrice * 10);
        if (discount < 10) {
            this._flagIcon.setVisible(true)
        } else {
            this._flagIcon.setVisible(false)
        }
        this._flagIcon.setFrame("flag/ui_discountFlag" + discount + ".png");
        this.setLimitInfoView()
    },
    setLimitInfoView: function(evt) {
        if (this.____1752 == null || !this.____1752.isLimit) {
            return
        }
        var limitInfo = this._limitInfo;
        if (limitInfo == null) {
            limitInfo = ____655.statInfo.statShopItemList[this.____1752.id]
        }
        var count = 0;
        if (limitInfo != null) {
            count = limitInfo.hasBuyCount;
            if (!this._limitEventFlag) {
                this._limitEventFlag = true;
                this._limitInfo = limitInfo;
                this._limitInfo.addEventListener(____655.____661.stat_shopItem_update, this.setLimitInfoView, this)
            }
        }
        count = this.____1752.limitBuyCount - count;
        this.____1344.setString(____654.yuyanbaoManager.getYuyanbao("OpenPanel.text10", count));
        if (count <= 0) {
            this._outFlag.setVisible(true);
            ____654.____674.setKYBtnEnabled(this.____919, false, 0)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this.____1752 == null) {
                return
            }
            var count = 1;
            count = this.____1752.limitBuyCount;
            var limitInfo = ____655.statInfo.statShopItemList[this.____1752.id];
            if (limitInfo != null) {
                count -= limitInfo.hasBuyCount
            }
            var limitBuyCount = count;
            if (count <= 0) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("shopItemView.text2"));
                return
            }
            count = Math.min(count, Math.floor(____655.____667.moneyInfo.getMoneyCountByType(this.____1752.payType) / this.____1752.price));
            if (count <= 0) {
                ____655.____667.moneyInfo.showNotEnoughTip(this.____1752.payType);
                return
            }
            ____654.____672.dispatchEvent(new ____590(____655.____661.common_showNumberPanel, ____654.____672, [1, this.____1752.itemTemplateInfo, this.____1752.price, this.____1752.payType, count, limitBuyCount, this, this.sendBuy, this.____1752.amount]))
        }
    },
    sendBuy: function(count) {
        if (____655.____667.moneyInfo.moneyEnoughByType(this.____1752.payType, this.____1752.price * count)) {
            print("购买商品，", this.____1752.id, count);
            ____654.statMessageSender.sendShopBuy(this.____1752.id, count)
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(this.____1752.payType)
        }
    },
    dispose: function() {
        this.____17();
        this._nameLabel = null;
        this._grid.dispose();
        this._grid = null;
        this.____1344 = null;
        this.____1544 = null;
        this._oldPriceLabel = null;
        this.____1752 = null;
        this._limitInfo = null;
        this._limitEventFlag = null;
        this._outFlag = null;
        this._cell = null;
        this.____919 = null;
        this._flagIcon = null;
        this._super()
    },
});
var WelfareResGetBackAwardItemView = KYNode.extend({
    ____854: null,
    _gridList: null,
    _moneyPrecent: 0,
    ctor: function(awardList, moneyPrecent) {
        this._super("welfareResGetBackAwardItem.ExportJson");
        this.____854 = awardList;
        this._moneyPrecent = moneyPrecent;
        this._gridList = [];
        for (var i = 1; i <= 4; i++) {
            var cellBg = this.getChildByName("cell" + i);
            var grid = new ____2129();
            cellBg.addChild(grid);
            this._gridList.push(grid)
        }
        this.____5()
    },
    ____5: function() {
        if (this.____854 == null) return;
        var precent = Math.max(0, 140 - ____655.welfareInfo.activityValue) / 140 + 0.1;
        for (var i = 0; i < this.____854.length; i++) {
            var itemTempInfo = ____655.allTemplates.____794.getItem(this.____854[i][0]);
            this._gridList[i].setItemTemplateInfo(itemTempInfo);
            var count = Math.ceil(this.____854[i][1] * precent * this._moneyPrecent / 100 - 0.00001);
            this._gridList[i].setCount(count)
        }
    },
    dispose: function() {
        for (var i = 0; i < this._gridList.length; i++) {
            this._gridList[i].dispose();
            this._gridList[i] = null
        }
        this._gridList = null;
        this.____854 = null;
        this._super()
    },
});
var ____2353 = KYNode.extend({
    ____1752: null,
    ____1241: -1,
    _titleImg: null,
    ____919: null,
    ____1144: null,
    ____1418: null,
    ____892: null,
    ____1544: null,
    _hasGotFlag: null,
    _payType: 0,
    _price: 0,
    ctor: function(index) {
        this._super("welfareResGetBackItemView.ExportJson");
        this.____1241 = index;
        this._titleImg = this.getChildByName("titleImg");
        this.____1144 = this.getChildByName("expLabel");
        this.____919 = this.getChildByName("buyBtn");
        this.____1418 = this.getChildByName("moneyIcon");
        this.____1544 = this.getChildByName("priceLabel");
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this._hasGotFlag = this.getChildByName("hasGotFlag");
        this.getChildByName("decLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2353.text4"));
        this.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2353.text5"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this.____919.addListener(this, this.____16);
        ____655.welfareInfo.addEventListener(____655.____661.welfare_ResRecoverUpdate, this.btnStateHandler, this)
    },
    ____17: function() {
        ____655.welfareInfo.removeEventListener(____655.____661.welfare_ResRecoverUpdate, this.btnStateHandler, this)
    },
    ____5: function() {
        var xianwei = Math.max(2, ____655.____667.xianwei);
        this.____1752 = ____655.allTemplates.resRecoverTemplateList.____238(xianwei);
        if (this.____1752 == null) return;
        var precent = Math.max(0, 140 - ____655.welfareInfo.activityValue) / 140 + 0.1;
        if (this.____1241 == 0) {
            this._titleImg.setFrame("flag/ui_welfareResFlag1.png", 1);
            this._payType = 3;
            this._price = Math.ceil(this.____1752.copperFee * precent);
            this.____1544.setString(____654.____674.getWanCount(this._price));
            this.____1144.setString(Math.ceil(this.____1752.exp * precent * this.____1752.copperPrecent / 100 - 0.00001))
        } else if (this.____1241 == 1) {
            this._titleImg.setFrame("flag/ui_welfareResFlag2.png", 1);
            this._payType = 1;
            this._price = Math.ceil(this.____1752.goldFee * precent);
            this.____1544.setString(this._price);
            this.____1144.setString(Math.ceil(this.____1752.exp * precent * this.____1752.goldPrecent / 100 - 0.00001))
        }
        this.____1418.setFrame(____654.____675.getMoneyPathByType(this._payType), 1);
        var len = Math.ceil(this.____1752.awardList.length / 4);
        this._tileContainer.setFormat(1, len, ____654.____673.____160(330, 80), 2, 2, true);
        this.btnStateHandler()
    },
    btnStateHandler: function() {
        if (____655.welfareInfo.resHasBuy > 0) {
            if (____655.welfareInfo.resHasBuy == this._payType) {
                this._hasGotFlag.setVisible(true)
            } else {
                this._hasGotFlag.setVisible(false)
            }
            ____654.____674.setKYBtnEnabled(this.____919, false, 1)
        } else {
            this._hasGotFlag.setVisible(false);
            ____654.____674.setKYBtnEnabled(this.____919, true, 1)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (____655.____667.xianwei <= 1) {
                var name = ____655.____659.nameType.getXianweiName(2);
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("____2353.text1", name));
                return
            }
            var price = this._price;
            var str1 = "";
            var str2 = "";
            if (this._payType == 1) {
                str2 = ____654.yuyanbaoManager.getYuyanbao("____2353.text2", price) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold")
            } else if (this._payType == 3) {
                str1 = ____654.____674.getWanCount(price);
                str2 = ____654.yuyanbaoManager.getYuyanbao("____2353.text3", str1)
            }
            ____655.getAlert().show(2, str2, null, 0, this, this.buyHandler)
        }
    },
    buyHandler: function() {
        if (this._payType == 1 && !____655.____667.moneyInfo.money1Enough(this._price)) {
            ____655.____667.moneyInfo.showNotEnoughTip(this._payType);
            return
        }
        if (this._payType == 3 && !____655.____667.moneyInfo.money2Enough(this._price)) {
            ____655.____667.moneyInfo.showNotEnoughTip(this._payType);
            return
        }
        ____654.welfareMessageSender.sendGetResRecoverAward(this._payType)
    },
    getItemByIndex: function(index) {
        var list = this.getAwardList(index);
        if (list.length > 0) {
            var precent = 0;
            if (this._payType == 1) {
                precent = this.____1752.goldPrecent
            } else {
                precent = this.____1752.copperPrecent
            }
            return new WelfareResGetBackAwardItemView(list, precent)
        }
        return null
    },
    getIdByIndex: function(index) {
        if (this.____1752.awardList[index * 4] == null) {
            return -1
        }
        return index * 4
    },
    getAwardList: function(index) {
        var list = [];
        var len = Math.min(this.____1752.awardList.length, index * 4 + 4);
        for (var i = index * 4; i < len; i++) {
            list.push(this.____1752.awardList[i])
        }
        return list
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        this.____1752 = null;
        this.____1241 = null;
        this._titleImg = null;
        this.____919 = null;
        this.____1144 = null;
        this.____1418 = null;
        this.____892 = null;
        this._payType = null;
        this._price = null;
        this._hasGotFlag = null;
        this._tileContainer = null;
        this._super()
    },
});
var WelfareZhuanShuGiftItemView = KYNode.extend({
    _nameLabel: null,
    _icon: null,
    ____919: null,
    _countDownUtils: null,
    ____1418: null,
    _giveLabel: null,
    _countLabel: null,
    _oldPriceLabel: null,
    _newPriceLabel: null,
    _sellOutIcon: null,
    _controller: null,
    ____1251: null,
    _payTempInfo: null,
    _count: 0,
    ____1238: null,
    _intervalTime: 0,
    ____1770: 0,
    ____1771: 0,
    _tickCount3: 0,
    ____1165: 1,
    ____1478: 209,
    ctor: function(controller, infoList) {
        this._super("welfareZhuanShuGiftItemView.ExportJson");
        this._controller = controller;
        this.____1251 = infoList;
        this._nameLabel = this.getChildByName("nameLabel");
        this._icon = this.getChildByName("icon");
        this.____919 = this.getChildByName("buyBtn");
        this.____1418 = this.getChildByName("moneyIcon");
        this._giveLabel = this.getChildByName("giveLabel");
        this._countLabel = this.getChildByName("countLabel");
        this._oldPriceLabel = this.getChildByName("priceLabel1");
        this._newPriceLabel = this.getChildByName("priceLabel2");
        this._sellOutIcon = this.getChildByName("sellOutIcon");
        this._sellOutIcon.setVisible(false);
        this._countDownUtils = new ____2111();
        this._countDownUtils.setLabel(this.getChildByName("timeLabel"), 0, 0, null);
        this.setTouchEnabled(true);
        this.getChildByName("desLabel").setString(____654.yuyanbaoManager.getYuyanbao("WelfareZhuanShuGiftItemView.text1"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this.addListener(this, this.____16, null, null, null, false, true);
        this.____919.addListener(this, this.____16);
        ____655.welfareInfo.addEventListener(____655.____661.welfare_ZhuanShuUpdate, this.updateView, this)
    },
    ____17: function() {
        ____655.welfareInfo.addEventListener(____655.____661.welfare_ZhuanShuUpdate, this.updateView, this)
    },
    ____5: function() {
        var time = 86400 - ____655.____662.getZeroPassTime();
        this._countDownUtils.start(time, null, null, null);
        this.updateView();
        this.setFloat(true, 3)
    },
    updateView: function() {
        if (this.____1251 == null || this.____1251.length <= 0) return;
        this._count = 0;
        this._payTempInfo = this.____1251[this.____1251.length - 1];
        for (var i = 0; i < this.____1251.length; i++) {
            var hasBuyCount = ____655.welfareInfo.zhuanShuGiftList[this.____1251[i].id];
            if (hasBuyCount == null) {
                hasBuyCount = 0
            }
            if (this.____1251[i].limitCount > hasBuyCount) {
                this._count = this.____1251[i].limitCount - hasBuyCount;
                this._payTempInfo = this.____1251[i];
                break
            }
        }
        var itemTempInfo = ____655.allTemplates.____794.getItem(this._payTempInfo.award[0][0]);
        this._nameLabel.setString(itemTempInfo.name);
        this._nameLabel.setColor(____655.____659.____688.getColorByQuality(itemTempInfo.quality));
        this._giveLabel.setString(____654.yuyanbaoManager.getYuyanbao("WelfareZhuanShuGiftItemView.text2", this._payTempInfo.descript));
        this._oldPriceLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2272.text1", this._payTempInfo.oldPrice));
        this._newPriceLabel.setString(____654.yuyanbaoManager.getYuyanbao("____2272.text1", this._payTempInfo.price));
        this._countLabel.setString(this._count);
        if (this._count <= 0) {
            ____654.____674.setKYBtnEnabled(this.____919, false, 1);
            this.setTouchEnabled(false);
            this._sellOutIcon.setVisible(true)
        }
        if (this.____1238 != null) {
            ____654.____677.removeImageQuote(this.____1238, this._icon)
        }
        this.____1238 = ____654.____675.____139("outPic/ui_welfareGiftIcon" + this._payTempInfo.pic + ".png");
        ____654.____677.____146(this._icon, this.____1238)
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (this._payTempInfo != null) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.welfare_ZhuanShuShowBuyView, ____654.____672, this._payTempInfo.id))
            }
        }
    },
    setFloat: function(isOn, intervalTime) {
        this._intervalTime = intervalTime * 60;
        if (isOn != null && isOn) {
            ____654.____678.____298(this.tick, this)
        } else {
            ____654.____678.____299(this.tick, this)
        }
    },
    tick: function(delta, count) {
        this.____1770++;
        if (this.____1770 >= this._intervalTime) {
            this.____1771++;
            if (this.____1771 > 1) {
                this.____1771 = 0;
                this.____1478 += this.____1165;
                if (this.____1478 < 209 || this.____1478 > 215) {
                    this.____1165 = -this.____1165;
                    this._tickCount3++;
                    if (this.____1165 > 0 && this._tickCount3 > 3) {
                        this._tickCount3 = 0;
                        this.____1770 = 0
                    }
                }
                this._icon.setPositionY(this.____1478)
            }
        }
    },
    dispose: function() {
        this.____17();
        if (this._countDownUtils != null) {
            this._countDownUtils.dispose();
            this._countDownUtils = null
        }
        this._nameLabel = null;
        if (this.____1238 != null) {
            ____654.____677.removeImageQuote(this.____1238, this._icon)
        }
        ____654.____678.____299(this.tick, this);
        this._intervalTime = null;
        this.____1770 = null;
        this.____1771 = null;
        this.____1165 = null;
        this.____1478 = null;
        this.____1238 = null;
        this._icon = null;
        this.____919 = null;
        this.____1418 = null;
        this._giveLabel = null;
        this._countLabel = null;
        this._oldPriceLabel = null;
        this._newPriceLabel = null;
        this._sellOutIcon = null;
        this._controller = null;
        this.____1251 = null;
        this._payTempInfo = null;
        this._count = null;
        this._super()
    },
});
var ____2345 = KYPanel.extend({
    _controller: null,
    _titileBg: null,
    ____1793: null,
    ____1185: null,
    _inputController: null,
    ____1398: 30,
    ctor: function(controller) {
        this._super("welfareGiftView.ExportJson");
        this._controller = controller;
        this._titileBg = this.getChildByName("titileBg");
        this.____1793 = ____654.____675.____139("outPic/ui_welfareGiftTitleBg.png");
        ____654.____677.____146(this._titileBg, this.____1793);
        this.____1185 = this.getChildByName("getBtn");
        var labelLayer = this.getChildByName("labelLayer");
        this._inputController = new InputLabelController(____654.____673.____159(0, 21), labelLayer.getContentSize(), labelLayer, this.____1398, 20);
        this.getChildByName("tipsLabel1").setString(____654.yuyanbaoManager.getYuyanbao("____2345.text1"));
        this.getChildByName("tipsLabel2").setString(____654.yuyanbaoManager.getYuyanbao("____2345.text2"));
        this.getChildByName("tipsLabel3").setString(____654.yuyanbaoManager.getYuyanbao("____2345.text3"));
        this.getChildByName("btnLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2345.text4"));
        this.____6();
        this.____5()
    },
    ____6: function() {
        this.____1185.addListener(this, this.____16)
    },
    ____5: function() {},
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var code = this._inputController.getString();
            code = code.replace(/ /g, "");
            if (code == null || code == "") {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("chatPanel.sendTip1"));
                return
            }
            var codeLen = ____655.wordFiltersInfo.getStringLen(code);
            if (codeLen < 10 || codeLen > 20) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("ActiveCodeMessageHandler.text2"));
                return
            }
            ____654.welfareMessageSender.sendActiveCode(code);
            this._inputController.setString("")
        }
    },
    dispose: function() {
        this._controller = null;
        ____654.____677.removeImageQuote(this.____1793, this._titileBg);
        this.____1793 = null;
        this._titileBg = null;
        this.____1185 = null;
        if (this._inputController != null) {
            this._inputController.dispose();
            this._inputController = null
        }
        this._super()
    },
});
var ____2346 = KYPanel.extend({
    _controller: null,
    _titileBg: null,
    ____1793: null,
    _tileContainer: null,
    ____1758: null,
    _day: null,
    ctor: function(controller) {
        this._super("welfareLimitBuyView.ExportJson");
        this._controller = controller;
        this._titileBg = this.getChildByName("titileBg");
        this.____1793 = ____654.____675.____139("outPic/ui_welfareLimitBuyTitleBg.png");
        ____654.____677.____146(this._titileBg, this.____1793);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____1758 = [];
        this.____6();
        this.____5()
    },
    ____6: function() {},
    ____5: function() {
        this._day = ____655.____662.getClientDate().getDay();
        if (this._day == 0) {
            this._day = 7
        }
        var list = ____655.allTemplates.shopTemplateList.getShopTempListByType(8);
        for (var i = 0; i < list.length; i++) {
            var openDay = ____655.____662.getOpenDayByCurrentTime();
            if (openDay >= list[i].beginDay && openDay < list[i].endDay) {
                if (list[i].weekDay == 0 || this._day == list[i].weekDay) {
                    this.____1758.push(list[i])
                }
            }
        }
        this._tileContainer.setFormat(2, this.____1758.length, ____654.____673.____160(350, 200), 10, 0, true)
    },
    getItemByIndex: function(index) {
        var tempInfo = this.____1758[index];
        if (tempInfo != null) {
            return new ____2352(tempInfo)
        }
        return null
    },
    getIdByIndex: function(index) {
        if (this.____1758[index] == null) {
            return -1
        }
        return this.____1758[index].id
    },
    dispose: function() {
        this._controller = null;
        ____654.____677.removeImageQuote(this.____1793, this._titileBg);
        this.____1793 = null;
        this._titileBg = null;
        this.____1758 = null;
        if (this._tileContainer != null) {
            this._tileContainer.dispose();
            this._tileContainer = null
        }
        this._day = null;
        this._super()
    },
});
var ____2347 = KYPanel.extend({
    _controller: null,
    _titileBg: null,
    ____1793: null,
    _bg: null,
    _gridList: null,
    ____1185: null,
    ____1508: null,
    ____1544: null,
    _dayLabel: null,
    ____892: null,
    _monthCardInfo: null,
    ctor: function(controller) {
        this._super("welfareMonthCardView.ExportJson");
        this._controller = controller;
        this._titileBg = this.getChildByName("titileBg");
        this.____1793 = ____654.____675.____139("outPic/ui_welfareMonthCardTitleBg.png");
        ____654.____677.____146(this._titileBg, this.____1793);
        this._bg = this.getChildByName("bg");
        this._bgPath = ____654.____675.____139("outPic/ui_welfareMonthCardBg.png");
        ____654.____677.____146(this._bg, this._bgPath);
        this._gridList = [];
        for (var i = 1; i < 3; i++) {
            var cellBg = this.getChildByName("cell" + i);
            var grid = new ____2129();
            cellBg.addChild(grid);
            this._gridList.push(grid)
        }
        this.____1185 = this.getChildByName("getBtn");
        this.____1508 = this.getChildByName("payBtn");
        this.____1544 = this.getChildByName("priceLabel1");
        this.____892 = this.getChildByName("btnLabel");
        this._dayLabel = this.getChildByName("dayLabel");
        this.____6();
        this.____5()
    },
    ____6: function() {
        this.____1185.addListener(this, this.____16);
        this.____1508.addListener(this, this.____16);
        ____655.welfareInfo.addEventListener(____655.____661.welfare_MonthCardUpdate, this.updateView, this)
    },
    ____17: function() {
        ____655.welfareInfo.removeEventListener(____655.____661.welfare_MonthCardUpdate, this.updateView, this)
    },
    ____5: function() {
        this._monthCardInfo = ____655.allTemplates.payTemplateList.getMonthCardInfo();
        if (this._monthCardInfo == null) return;
        this.____1544.setString(____654.yuyanbaoManager.getYuyanbao("____2272.text1", this._monthCardInfo.price));
        var tempList = ____655.allTemplates.awardTemplateList.getTypeList(5);
        var awardList = [];
        for (var i = 0; i < tempList.length; i++) {
            if (parseInt(tempList[i].condition) == ____655.____667.xianwei) {
                awardList = tempList[i].awardList;
                break
            }
        }
        for (var i = 0; i < awardList.length; i++) {
            if (this._gridList[i] != null) {
                var itemTempInfo = ____655.allTemplates.____794.getItem(awardList[i][0]);
                this._gridList[i].setItemTemplateInfo(itemTempInfo);
                this._gridList[i].setCount(awardList[i][1])
            }
        }
        this.updateView()
    },
    updateView: function() {
        var day = ____655.welfareInfo.monthCardDays;
        if (day > 0) {
            this.____1508.setVisible(false);
            this.____1544.setVisible(false);
            this.____892.setVisible(true);
            this.____1185.setVisible(true);
            this._dayLabel.setVisible(true);
            this._dayLabel.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.tips1", day));
            if (____655.welfareInfo.monthCardIsHasGot != 1) {
                ____654.____674.setKYBtnEnabled(this.____1185, false, 1);
                this.____892.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn1"))
            } else {
                ____654.____674.setKYBtnEnabled(this.____1185, true, 1);
                this.____892.setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn2"))
            }
        } else {
            this._dayLabel.setVisible(false);
            this.____1508.setVisible(true);
            this.____1544.setVisible(true);
            this.____892.setVisible(false);
            this.____1185.setVisible(false)
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            if (sender == this.____1185) {
                if (____655.welfareInfo.monthCardDays > 0 && ____655.welfareInfo.monthCardIsHasGot == 1) {
                    ____654.welfareMessageSender.sendMonthCardAward()
                }
            } else if (sender == this.____1508) {
                if (this._monthCardInfo != null && ____655.welfareInfo.monthCardDays <= 0) {
                    ____654.sdk.pay(this._monthCardInfo, function(retCode, vals) {
                        print("########pay return！");
                        if (retCode == 0) {
                            print("购买月卡成功！！！！")
                        } else if (retCode == 1) {
                            print("购买月卡失败！！！！")
                        } else if (retCode == 2) {
                            print("购买月卡取消！！！！")
                        }
                    })
                }
            }
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        ____654.____677.removeImageQuote(this.____1793, this._titileBg);
        this.____1793 = null;
        this._titileBg = null;
        ____654.____677.removeImageQuote(this._bgPath, this._bg);
        this._bgPath = null;
        this._bg = null;
        for (var i = 0; i < this._gridList.length; i++) {
            this._gridList[i].dispose();
            this._gridList[i] = null
        }
        this._gridList = null;
        this.____1185 = null;
        this.____1508 = null;
        this.____1544 = null;
        this._dayLabel = null;
        this.____892 = null;
        this._super()
    },
});
var ____2348 = KYPanel.extend({
    _controller: null,
    _titileBg: null,
    ____1793: null,
    ____1625: null,
    _infoLabel: null,
    ctor: function(controller) {
        this._super("welfareNoticeView.ExportJson");
        this._controller = controller;
        this._titileBg = this.getChildByName("titileBg");
        this.____1793 = ____654.____675.____139("outPic/ui_welfareNoticeTitleBg.png");
        ____654.____677.____146(this._titileBg, this.____1793);
        this._infoLabel = ____654.____673.newRichLabel(710);
        this.____1625 = this.getChildByName("scrollView");
        this.____5()
    },
    ____5: function() {
        this._infoLabel.setString(this._controller.getNotice());
        this.____1625.addContent(this._infoLabel);
        var height = this._infoLabel.getHeight();
        height = Math.max(380, height);
        this._infoLabel.setPosition(____654.____673.____159(20, height - 15));
        this.____1625.setInnerSize(____654.____673.____160(729, height + 15));
        this.____1625.jumpToTop()
    },
    dispose: function() {
        this._controller = null;
        ____654.____677.removeImageQuote(this.____1793, this._titileBg);
        this.____1793 = null;
        this._titileBg = null;
        this.____1625 = null;
        this._infoLabel.dispose();
        this._infoLabel = null;
        this._super()
    },
});
var ____2349 = KYPanel.extend({
    _controller: null,
    _moneyView: null,
    ____1738: null,
    ____1740: null,
    ____1737: null,
    _panelList: null,
    ____1054: null,
    _nameList: null,
    ctor: function(controller, index) {
        this._super("welfarePanel.ExportJson");
        this._controller = controller;
        var moneyLayer = this.getChildByName("moneyLayer");
        this._moneyView = new ____2237(0);
        moneyLayer.addChild(this._moneyView);
        this.____1740 = this.getChildByName("tabLayer");
        this._panelList = {};
        this.____5(index);
        this.____6();
        this.popUpdate()
    },
    ____5: function(index) {
        this._nameList = [____654.yuyanbaoManager.getYuyanbao("____2349.text1"), ____654.yuyanbaoManager.getYuyanbao("____2349.text2"), ____654.yuyanbaoManager.getYuyanbao("____2349.text3"), ____654.yuyanbaoManager.getYuyanbao("____2349.text4"), ____654.yuyanbaoManager.getYuyanbao("____2349.text5"), ____654.yuyanbaoManager.getYuyanbao("____2349.text6"), ____654.yuyanbaoManager.getYuyanbao("____2349.text7")];
        var isPrePay = ____655.activityIconList.activityIcons[15] != null && ____655.activityIconList.activityIcons[15].isShow == true;
        this.____1738 = [
            [1, this._nameList[0], "icon/ui_welfareIcon1.png", false, 1],
            [2, this._nameList[1], "icon/ui_welfareIcon2.png", true, 1],
            [3, this._nameList[2], "icon/ui_welfareIcon3.png", ____655.____663.getCurrent().isPay && !isPrePay, 1],
            [4, this._nameList[3], "icon/ui_welfareIcon4.png", true, 1],
            [5, this._nameList[4], "icon/ui_welfareIcon5.png", true, 1],
            [6, this._nameList[5], "icon/ui_welfareIcon6.png", !____655.isShenHe(), 1],
            [7, this._nameList[6], "icon/ui_welfareIcon7.png", true, 1]
        ];
        this.____1737 = new TabGroup(1, this.____1738, this.setTab, this);
        this.____1737.setPositionY(540);
        this.____1740.addChild(this.____1737);
        this.____1737.setBtnFlagImg(1, "flag/ui_welfareFlag1.png");
        this.____1737.setBtnFlagImg(2, "flag/ui_welfareFlag2.png");
        this.____1737.setBtnFlagImg(3, "flag/ui_welfareFlag3.png");
        if (index == null || index == 0) {
            if (!____655.____663.getCurrent().isPay) {
                index = 2
            } else {
                index = 2
            }
        }
        this.____1737.setTabIndex(index - 1)
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.addEventListener(____655.____661.global_dayUpdate, this.close, this)
    },
    ____17: function() {
        ____654.____672.removeEventListener(____655.____661.common_popData, this.popUpdate, this);
        ____654.____672.removeEventListener(____655.____661.global_dayUpdate, this.close, this)
    },
    close: function() {
        ____654.____676.uiPanelContainer.close()
    },
    popUpdate: function(evt) {
        var type = 0;
        if (evt != null) {
            type = evt.data
        }
        if (type == 0 || type == 11) {
            this.____1737.setShowPop(3, ____654.playerInfoTester.monthCardNum > 0)
        }
        if (type == 0 || type == 12) {
            this.____1737.setShowPop(4, ____654.playerInfoTester.weekSignNum > 0)
        }
        if (type == 0 || type == 13) {
            this.____1737.setShowPop(5, ____654.playerInfoTester.recoverNum > 0)
        }
    },
    setTab: function(tab) {
        if (this.____1054 != null) {
            this.____1054.removeFromParent(false)
        }
        this.____1054 = this.getPanel(tab);
        if (this.____1054 != null && this.____1054.getParent() == null) {
            this.addChild(this.____1054)
        }
    },
    getPanel: function(tab) {
        var panel = this._panelList[tab];
        if (panel == null) {
            if (tab == 1) {
                panel = new WelfareZhuanShuGiftView(this._controller)
            } else if (tab == 2) {
                panel = new ____2346(this._controller)
            } else if (tab == 3) {
                panel = new ____2347(this._controller)
            } else if (tab == 4) {
                panel = new ____2351(this._controller)
            } else if (tab == 5) {
                panel = new ____2350(this._controller)
            } else if (tab == 6) {
                panel = new ____2345(this._controller)
            } else if (tab == 7) {
                panel = new ____2348(this._controller)
            }
            this._panelList[tab] = panel
        }
        return panel
    },
    dispose: function() {
        this.____17();
        if (this._moneyView != null) {
            this._moneyView.dispose();
            this._moneyView = null
        }
        if (this.____1737 != null) {
            this.____1737.dispose();
            this.____1737 = null
        }
        if (this._panelList != null) {
            for (var i in this._panelList) {
                if (this._panelList[i] != null) {
                    this._panelList[i].dispose()
                }
            }
            this._panelList = null
        }
        this.____1738 = null;
        this.____1740 = null;
        this.____1054 = null;
        this._nameList = null;
        this._super()
    },
});
var ____2350 = KYPanel.extend({
    _controller: null,
    _titileBg: null,
    ____1793: null,
    _itemList: null,
    ctor: function(controller) {
        this._super("welfareResGetBackView.ExportJson");
        this._controller = controller;
        this._titileBg = this.getChildByName("titileBg");
        this.____1793 = ____654.____675.____139("outPic/ui_welfareGetBackTitleBg.png");
        ____654.____677.____146(this._titileBg, this.____1793);
        this.____1291 = this.getChildByName("itemView");
        this.getChildByName("tipsLabel").setString(____654.yuyanbaoManager.getYuyanbao("____2350.text1"));
        this._tempList = [];
        this._itemList = [];
        this.____5()
    },
    ____5: function() {
        for (var i = 0; i <= 1; i++) {
            var item = new ____2353(i);
            this._itemList.push(item);
            this.____1291.addChild(item);
            item.setPosition(____654.____673.____159(i * 368 - 9, 0))
        }
    },
    dispose: function() {
        this._controller = null;
        ____654.____677.removeImageQuote(this.____1793, this._titileBg);
        this.____1793 = null;
        this._titileBg = null;
        this.____1291 = null;
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].dispose();
            this._itemList[i] = null
        }
        this._itemList = null;
        this._super()
    },
});
var ____2351 = KYPanel.extend({
    _controller: null,
    _titileBg: null,
    ____1793: null,
    _btnList: null,
    _gridList: null,
    _sundayGridList: null,
    _tipsLabelList: null,
    ____895: null,
    _hasGotFlagList: null,
    ____1251: null,
    ____1398: 30,
    _day: 0,
    _tempIndex: 0,
    _btnEffect: null,
    ctor: function(controller) {
        this._super("welfareSignView.ExportJson");
        this._controller = controller;
        this._titileBg = this.getChildByName("titileBg");
        this.____1793 = ____654.____675.____139("outPic/ui_welfareSignTitleBg.png");
        ____654.____677.____146(this._titileBg, this.____1793);
        this._btnList = [];
        this._gridList = [];
        this._sundayGridList = [];
        this._tipsLabelList = [];
        this.____895 = [];
        this._hasGotFlagList = [];
        for (var i = 1; i <= 7; i++) {
            var item = this.getChildByName("item" + i);
            this.getChildByName("titleLabel" + i).setString(____655.____659.nameType.getWeekName(i - 1));
            this._btnList.push(this.getChildByName("getBtn" + i));
            this.____895.push(this.getChildByName("btnLabel" + i));
            this._tipsLabelList.push(this.getChildByName("tipsLabel" + i));
            this._hasGotFlagList.push(this.getChildByName("hasGotFlag" + i));
            if (i <= 6) {
                var cellBg = this.getChildByName("cell" + i);
                var grid = new ____2129();
                cellBg.addChild(grid);
                this._gridList.push(grid)
            } else {
                for (var j = 1; j <= 3; j++) {
                    var cellBg = this.getChildByName("cell" + (j + 6));
                    var grid = new ____2129();
                    cellBg.addChild(grid);
                    this._sundayGridList.push(grid)
                }
            }
        }
        this.____6();
        this.____5()
    },
    ____6: function() {
        for (var i = 0; i < 7; i++) {
            this._btnList[i].addListener(this, this.____16)
        }
        ____655.welfareInfo.addEventListener(____655.____661.welfare_weekSignUpdate, this.updateBtnState, this)
    },
    ____17: function() {
        ____655.welfareInfo.removeEventListener(____655.____661.welfare_weekSignUpdate, this.updateBtnState, this)
    },
    ____5: function() {
        this.____1251 = ____655.allTemplates.weekSignTemplateList.getTypeList(____655.____667.xianwei);
        if (this.____1251 == null) return;
        this._day = ____655.____662.getClientDate().getDay();
        this._day = (this._day + 6) % 7;
        for (var i = 0; i < this.____1251.length; i++) {
            if (this.____1251[i] != null) {
                var index = this.____1251[i].day - 1;
                if (index < 6) {
                    var itemTempInfo = ____655.allTemplates.____794.getItem(this.____1251[i].awardList[0][0]);
                    this._gridList[index].setItemTemplateInfo(itemTempInfo);
                    this._gridList[index].setCount(this.____1251[i].awardList[0][1])
                } else {
                    for (var j = 0; j < 3; j++) {
                        var itemTempInfo = ____655.allTemplates.____794.getItem(this.____1251[i].awardList[j][0]);
                        this._sundayGridList[j].setItemTemplateInfo(itemTempInfo);
                        this._sundayGridList[j].setCount(this.____1251[i].awardList[j][1])
                    }
                }
            }
        }
        this.updateBtnState()
    },
    updateBtnState: function() {
        for (var i = 0; i < this.____1251.length; i++) {
            if (this.____1251[i] != null) {
                var index = this.____1251[i].day - 1;
                if (index <= this._day) {
                    var hasGot = ____655.welfareInfo.weekSignHasGotList.indexOf(index + 1);
                    var hasGotCount = ____655.welfareInfo.weekSignHasGotList.length;
                    if (hasGot == -1) {
                        if (index == this._day) {
                            if (this._day == 6 && hasGotCount < 6) {
                                this._tipsLabelList[index].setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip1"));
                                this._tipsLabelList[index].setVisible(true);
                                this._btnList[index].setVisible(false);
                                this.____895[index].setVisible(false);
                                this._btnList[index].setTouchEnabled(false);
                                if (this._btnEffect != null) {
                                    this._btnEffect.dispose();
                                    this._btnEffect = null
                                }
                            } else {
                                ____654.____674.setKYBtnEnabled(this._btnList[index], true, 1);
                                this.____895[index].setString(____654.yuyanbaoManager.getYuyanbao("welfareResGetBackView.btn2"));
                                this._tipsLabelList[index].setVisible(false);
                                this._btnList[index].setVisible(true);
                                this.____895[index].setVisible(true);
                                if (this._btnEffect == null) {
                                    this._btnEffect = ____654.effectManager.create(____655.allTemplates.____789.BTN_EFFECT, false, null, false);
                                    if (this._day < 6) {
                                        this._btnEffect.move(38, 22);
                                        this._btnEffect.setScaleX(0.65);
                                        this._btnEffect.setScaleY(0.8)
                                    } else {
                                        this._btnEffect.move(55, 27);
                                        this._btnEffect.setScaleX(0.95);
                                        this._btnEffect.setScaleY(1)
                                    }
                                    this._btnEffect.play();
                                    this._btnEffect.addTo(this._btnList[index], 1)
                                }
                            }
                        } else {
                            ____654.____674.setKYBtnEnabled(this._btnList[index], true, 2);
                            this.____895[index].setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip2"));
                            this._tipsLabelList[index].setVisible(false);
                            this._btnList[index].setVisible(true);
                            this.____895[index].setVisible(true);
                            if (this._btnEffect != null) {
                                this._btnEffect.dispose();
                                this._btnEffect = null
                            }
                        }
                        this._hasGotFlagList[index].setVisible(false)
                    } else {
                        this._tipsLabelList[index].setVisible(false);
                        this._hasGotFlagList[index].setVisible(true);
                        this._btnList[index].setVisible(false);
                        this.____895[index].setVisible(false);
                        this._btnList[index].setTouchEnabled(false);
                        if (this._btnEffect != null) {
                            this._btnEffect.dispose();
                            this._btnEffect = null
                        }
                    }
                } else {
                    this._hasGotFlagList[index].setVisible(false);
                    this._tipsLabelList[index].setVisible(true);
                    if (index < 6) {
                        this._tipsLabelList[index].setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip3"))
                    } else {
                        this._tipsLabelList[index].setString(____654.yuyanbaoManager.getYuyanbao("____2351.tip1"))
                    }
                    this._btnList[index].setVisible(false);
                    this.____895[index].setVisible(false);
                    this._btnList[index].setTouchEnabled(false)
                }
            }
        }
    },
    ____16: function(sender, eventType) {
        if (eventType == ccui.Widget.TOUCH_ENDED) {
            ____654.soundManager.playSound(____654.soundManager.BTN);
            var index = this._btnList.indexOf(sender);
            if (this._day == index) {
                ____654.welfareMessageSender.sendGetSignAward(this._day + 1)
            } else {
                var price = this.____1251[index].fee;
                this._tempIndex = index;
                var str = ____654.yuyanbaoManager.getYuyanbao("____2351.tip4", price) + ____654.yuyanbaoManager.getYuyanbao("moneyInfo.canBindGold");
                ____655.getAlert().show(2, str, null, 0, this, this.buQianHandler)
            }
        }
    },
    buQianHandler: function() {
        var price = this.____1251[this._tempIndex].fee;
        if (____655.____667.moneyInfo.money1Enough(price)) {
            ____654.welfareMessageSender.sendGetSignAward(this._tempIndex + 1)
        } else {
            ____655.____667.moneyInfo.showNotEnoughTip(1)
        }
    },
    dispose: function() {
        this.____17();
        this._controller = null;
        ____654.____677.removeImageQuote(this.____1793, this._titileBg);
        this.____1793 = null;
        this._titileBg = null;
        this._btnList = null;
        this._tipsLabelList = null;
        this._hasGotFlagList = null;
        this.____895 = null;
        for (var i = 0; i < this._gridList.length; i++) {
            this._gridList[i].dispose();
            this._gridList[i] = null
        }
        this._gridList = null;
        for (var i = 0; i < this._sundayGridList.length; i++) {
            this._sundayGridList[i].dispose();
            this._sundayGridList[i] = null
        }
        if (this._btnEffect != null) {
            this._btnEffect.dispose();
            this._btnEffect = null
        }
        this._sundayGridList = null;
        this.____1251 = null;
        this.____1398 = null;
        this._day = null;
        this._tempIndex = null;
        this._super()
    },
});
var WelfareZhuanShuGiftView = KYPanel.extend({
    _controller: null,
    _titileBg: null,
    ____1793: null,
    _tileContainer: null,
    ____1758: null,
    ____1338: 0,
    ctor: function(controller) {
        this._super("welfareZhuanShuGiftView.ExportJson");
        this._controller = controller;
        this._titileBg = this.getChildByName("titileBg");
        this.____1793 = ____654.____675.____139("outPic/ui_welfareZhuanShuTitleBg.png");
        ____654.____677.____146(this._titileBg, this.____1793);
        this._tileContainer = this.getChildByName("scrollView__1");
        this._tileContainer.setCallbacks(this.getItemByIndex, this.getIdByIndex, this);
        this.____1758 = {};
        this.____6();
        this.____5()
    },
    ____6: function() {},
    ____5: function() {
        var day = ____655.____662.getClientDate().getDay();
        if (day == 0) {
            day = 7
        }
        var openDay = ____655.____662.getOpenDayByCurrentTime();
        var list = ____655.allTemplates.payTemplateList.getTemplateInfoList();
        for (var i = 0; i < list.length; i++) {
            if (list[i].payType >= 10 && list[i].sort > 0 && openDay >= list[i].beginDay && openDay < list[i].endDay) {
                if (list[i].weekDay == 0 || day == list[i].weekDay) {
                    if (this.____1758[list[i].sort] == null) {
                        this.____1758[list[i].sort] = [];
                        this.____1338++
                    }
                    this.____1758[list[i].sort].push(list[i])
                }
            }
        }
        this._tileContainer.setFormat(1, this.____1338, ____654.____673.____160(275, 401), 0, 2, true)
    },
    getItemByIndex: function(index) {
        var pos = index + 1;
        var list = this.____1758[pos];
        if (list != null) {
            return new WelfareZhuanShuGiftItemView(this._controller, list)
        }
        return null
    },
    getIdByIndex: function(index) {
        if (this.____1758[index + 1] == null) {
            return -1
        }
        return index + 1
    },
    dispose: function() {
        this._controller = null;
        ____654.____677.removeImageQuote(this.____1793, this._titileBg);
        this.____1793 = null;
        this._titileBg = null;
        if (this._tileContainer != null) {
            this._tileContainer.dispose();
            this._tileContainer = null
        }
        this.____1758 = null;
        this.____1338 = null;
        this._super()
    },
});
var ____2343 = cc.Class.extend({
    welfareModule: null,
    ctor: function(welfareModule) {
        this.welfareModule = welfareModule;
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.global_panelClose, this.panelClose, this)
    },
    getNotice: function() {
        return ____654.____682.____108(10060)
    },
    showWelfarePanel: function(type, index) {
        if (this.welfareModule.welfarePanel == null) {
            this.welfareModule.welfarePanel = new ____2349(this, index)
        }
        ____654.____676.uiPanelContainer.____125(this.welfareModule.welfarePanel, type)
    },
    panelClose: function(evt) {
        var p = evt.data;
        if (p == this.welfareModule.welfarePanel) {
            this.welfareModule.welfarePanel = null
        }
    },
});
var ____2344 = ____537.extend({
    welfareController: null,
    welfarePanel: null,
    welfareZhuanShuGiftBuyView: null,
    setup: function(data) {
        this.welfareController = new ____2343(this);
        this.____151(data)
    },
    ____151: function(data) {
        this.welfareController.showWelfarePanel(data[0], data[1])
    },
    clear: function() {},
});
var ____544 = cc.Class.extend({
    character: null,
    ____1033: null,
    ____1037: 0,
    _currentIndex: 0,
    ____1205: false,
    ____1069: 0,
    _isStill: false,
    ctor: function(character) {
        this.character = character
    },
    ____68: function(anima) {
        if (anima == null) return false;
        if (!!this.____1033) {
            if (anima == this.____1033) {
                if (anima.unreplaceTime > 0) this.____1069 = anima.unreplaceTime;
                return false
            } else if (this.____1069 > 0) {
                return false
            }
        }
        return true
    },
    cleanTickCount: function() {
        this.____1069 = 0
    },
    ____203: function(anima) {
        if (!this.____68(anima)) return;
        this.____1037 = 0;
        this.____1033 = anima;
        this._currentIndex = 0;
        this.____1205 = false;
        if (anima.unreplaceTime > 0) this.____1069 = anima.unreplaceTime
    },
    ____204: function() {
        ____654.____678.____298(this.tick, this)
    },
    ____205: function() {
        ____654.____678.____299(this.tick, this)
    },
    setStill: function() {
        this._isStill = true
    },
    tick: function(delta, tickCount) {
        if (this.____1033.unreplaceTime > 0) {
            this.____1069--;
            if (this.____1069 == 0) {
                if (this.____1205 == false) {
                    this.character.____209(this.____1033);
                    this.____1205 = true
                }
                return
            }
        }
        this.____1037++;
        if (this.____1037 % this.____1033.framePlayCount != 0) return;
        if (this._currentIndex >= this.____1033.frameCount) {
            if (this.____1033.repeat) {
                this._currentIndex = 0
            } else {
                if (this.____1205 == false) {
                    this.character.____209(this.____1033);
                    this.____1205 = true
                }
                return
            }
        }
        this.character.setFrame(this.____1033.____66(this._currentIndex, this.character.____96()));
        this._currentIndex++;
        if (this._isStill) {
            this.____205()
        }
    },
    dispose: function() {
        this.____205();
        this.character = null;
        this.____1033 = null
    },
});
var ____506 = cc.Class.extend({
    playerStand1: null,
    playerWalk1: null,
    playerStand2: null,
    playerWalk2: null,
    playerAttack: null,
    playerDead: null,
    npcStand: null,
    monsterStand: null,
    monsterWalk: null,
    monsterAttack: null,
    monsterDead: null,
    petStand: null,
    petWalk: null,
    petAttack: null,
    stand: 1,
    walk: 2,
    attack: 3,
    behit: 4,
    dead: 5,
    ctor: function() {
        this.attackList = [3];
        this.playerStand1 = new ____496(6, [
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"]
        ], true, 8, 0);
        this.playerWalk1 = new ____496(2, [
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"]
        ], true, 8, 0);
        this.playerStand2 = new ____496(8, [
            ["200.png", "201.png", "202.png", "203.png", "400.png", "401.png", "402.png", "403.png"],
            ["200.png", "201.png", "202.png", "203.png", "400.png", "401.png", "402.png", "403.png"],
            ["200.png", "201.png", "202.png", "203.png", "400.png", "401.png", "402.png", "403.png"],
            ["200.png", "201.png", "202.png", "203.png", "400.png", "401.png", "402.png", "403.png"]
        ], true, 8, 0);
        this.playerWalk2 = new ____496(7, [
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"]
        ], true, 8, 0);
        this.playerAttack = new ____496(3, [
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"],
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"]
        ], true, 1, 80);
        this.playerAttack.frames = [];
        var tmp = [0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 10, 10, 10, 10, 10, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 14, 14, 14, 14, 14, 14, 14, 14, 15, 15, 15, 15, 15, 16, 16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 17, 18, 18, 18, 18, 18, 19, 19, 19, 19, 19, 20, 20, 20, 20, 20, 21, 21, 21, 21, 21, 22, 22, 22, 22, 22, 23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 25, 25, 25, 25, 25, 25, 25, 25, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 27, 27, 27, 27, 27];
        for (var i = 0; i < 4; i++) {
            var fra = [];
            for (var j = 0; j < tmp.length; j++) {
                if (tmp[j] < 10) fra.push("20" + tmp[j] + ".png");
                else fra.push("2" + tmp[j] + ".png")
            }
            for (var j = 0; j < tmp.length; j++) {
                if (tmp[j] < 10) fra.push("40" + tmp[j] + ".png");
                else fra.push("4" + tmp[j] + ".png")
            }
            this.playerAttack.frames.push(fra)
        }
        this.playerAttack.frameCount = this.playerAttack.frames[0].length / this.playerAttack.DIR_COUNT;
        this.playerDead = new ____496(5, [
            ["200.png", "400.png"],
            ["200.png", "400.png"],
            ["200.png", "400.png"],
            ["200.png", "400.png"]
        ], true, 8, 0, [
            [2, 0, 1, 3],
            [2, 0, 1, 3],
            [1, 2, 0, 3],
            [1, 2, 0, 3]
        ]);
        this.npcStand = new ____496(20, [
            ["000.png", "001.png", "002.png", "003.png", "000.png", "001.png", "002.png", "003.png"]
        ], true, 8, 0);
        this.monsterStand = new ____496(6, [
            ["200.png", "201.png", "202.png", "203.png", "400.png", "401.png", "402.png", "403.png"]
        ], true, 8, 0);
        this.monsterWalk = new ____496(2, [
            ["200.png", "201.png", "202.png", "203.png", "400.png", "401.png", "402.png", "403.png"]
        ], true, 8, 0);
        this.monsterAttack = new ____496(3, [
            ["200.png", "201.png", "202.png", "203.png", "400.png", "401.png", "402.png", "403.png"]
        ], true, 8, 40);
        this.monsterDead = new ____496(5, [
            ["200.png", "400.png"]
        ], true, 8, 0);
        this.petStand = new ____496(6, [
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"]
        ], true, 8, 0);
        this.petWalk = new ____496(2, [
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"]
        ], true, 8, 0);
        this.petAttack = new ____496(3, [
            ["200.png", "201.png", "202.png", "203.png", "204.png", "205.png", "400.png", "401.png", "402.png", "403.png", "404.png", "405.png"]
        ], true, 8, 60)
    },
    isAttackAnima: function(animaInfo) {
        if (!animaInfo) return false;
        return this.attackList.indexOf(animaInfo.id) > -1
    },
    isPlayerDead: function(anima) {
        return anima == this.dead
    },
    isRiderAnima: function(anima) {
        return this.playerWalk2 == anima || this.playerStand2 == anima
    }
});
var ____545 = BaseContainer.extend({
    ____1112: 0,
    _characterInfo: null,
    ____1033: null,
    ____834: null,
    ____1810: 0,
    ____1047: 0,
    ____1335: null,
    ____832: null,
    ____833: null,
    ____1515: null,
    ____1359: null,
    ____1334: 1,
    ____1173: null,
    ____1174: null,
    _defaultColor: null,
    ____993: null,
    _scaleDir: 1,
    _isShow: null,
    ctor: function(info, callback, callTarget) {
        this.____1335 = [];
        this.____1173 = [];
        this.____1174 = [];
        this._characterInfo = info;
        this.____832 = callback;
        this.____833 = callTarget;
        this.____834 = new ____544(this);
        this._characterInfo.addEventListener(____655.____661.playerInfo_styleReload, this.styleReloadHandler, this);
        this.____1334 = this._characterInfo.getLayerCount();
        for (var i = 0; i < this.____1334; i++) {
            this.____1335.push(____654.____673.newKYSprite())
        }
        this._defaultColor = this.____1335[0].getColor()
    },
    setToPos: function() {
        for (var i = 0; i < this.____1335.length; i++) {
            if (!!this.____1335[i]) {
                this.____1335[i].setPosition(this.____1539, this.____1540)
            }
        }
    },
    styleReloadHandler: function(evt) {
        this.____834.____205();
        this.____211()
    },
    ____209: function(anima) {
        if (this.____832 != null) {
            this.____832.call(this.____833, anima)
        }
    },
    updateAlpha: function() {
        if (this.____1335 != null) {
            for (var i = this.____1335.length - 1; i >= 0; i--) {
                if (this.____1335[i] != null) {
                    this.____1335[i].setOpacity(this._alpha)
                }
            }
        }
    },
    setColor: function(color) {
        if (color == this.____993) return;
        this.____993 = color;
        var tmpColor = this.____993;
        if (tmpColor == null) tmpColor = this._defaultColor;
        if (this.____1335 != null) {
            for (var i = this.____1335.length - 1; i >= 0; i--) {
                if (this.____1335[i] != null) {
                    this.____1335[i].setColor(tmpColor)
                }
            }
        }
    },
    init: function(dir, container, orderIndex) {
        this._super(container, orderIndex);
        this.updateDir(dir);
        this.____203(this._characterInfo.____74())
    },
    show: function() {
        if (!this._container || !this.____1515) return;
        for (var i = 0; i < this.____1515.length; i++) {
            if (!!this.____1515[i] && this.____1515[i] != "" && !!this.____1335[i]) {
                this._container.addChild(this.____1335[i])
            } else if (!!this.____1335[i]) {
                this.____1335[i].removeFromParent(false)
            }
        }
        this.updateAlpha();
        this.updateZIndex();
        this._isShow = true
    },
    hide: function() {
        for (var i = 0; i < this.____1335.length; i++) {
            if (!!this.____1335[i]) {
                this.____1335[i].removeFromParent(false)
            }
        }
        this._isShow = false
    },
    stopAttack: function() {
        if (____655.____659.____687.isAttackAnima(this.____1033)) {
            this.____834.cleanTickCount();
            this.____209(this.____1033)
        }
    },
    ____203: function(anima) {
        anima = this._characterInfo.getAnima(anima);
        if (!this.____834.____68(anima)) return false;
        var needReload = this._characterInfo.needReload(this.____1033, anima);
        this.____1033 = anima;
        if (needReload) {
            this.____211()
        } else {
            this.allLayerLoadComplete()
        }
        return true
    },
    stillAnima: function() {
        this.____834.setStill()
    },
    updateDir: function(dir) {
        if (this.____1112 == dir) return;
        this.____1112 = dir;
        this.updateZIndex()
    },
    ____96: function() {
        return this.____1112
    },
    updateZIndex: function() {
        if (!!this.____1515 && this.____1515.length > 0) {
            var orders = this._characterInfo.getOrders(this.____1033, this.____1112);
            for (var i = 0; i < this.____1335.length; i++) {
                if (this.____1335[i] != null) {
                    this.____1335[i].setLocalZOrder(this._orderIndex + orders[i])
                }
            }
        }
    },
    allLayerLoadComplete: function() {
        this.updateZIndex();
        this.____1173 = [];
        this.____834.____203(this.____1033);
        this.____834.____204()
    },
    ____211: function() {
        var this_ = this,
            allPath = this._characterInfo.____72(this.____1033),
            newPath = allPath[0],
            loadPath = allPath[1],
            pathLen = newPath.length,
            needLoadRes = false,
            cleanPaths = [],
            loadList = [];

        function layerLoadComplete() {
            this_.____1047++;
            if (this_.____1047 >= this_.____1810) {
                if (!this_.____1335) return;
                for (var i = 0; i < cleanPaths.length; i++) {
                    ____654.____677.removePlistQuote(cleanPaths[i], this_)
                }
                cleanPaths = [];
                this_.____1515 = newPath;
                this_.____1359 = loadPath;
                if (this._isShow != false) {
                    this_.show()
                }
                this_.allLayerLoadComplete()
            }
        }
        this.____1810 = 0;
        this.____1047 = 0;
        for (var i = 0; i < pathLen; i++) {
            var path = newPath[i],
                opath = !!this.____1515 ? this.____1515[i] : null;
            if (!!opath && newPath.indexOf(opath) == -1) {
                cleanPaths.push(this.____1359[i])
            }
            if (path != null) {
                if (!this.____1515 || this.____1515.indexOf(path) == -1) {
                    needLoadRes = true;
                    this.____1810++;
                    loadList.push(loadPath[i])
                }
            }
        }
        if (!needLoadRes) {
            layerLoadComplete()
        } else {
            for (var i = 0; i < loadList.length; i++) {
                ____654.____677.____147(loadList[i], layerLoadComplete, this, ____655.____659.commonStaticType.source_clearOneM)
            }
        }
    },
    getFrameName: function(idx, frameName) {
        var type = this._characterInfo.getSourceType(),
            picPath = this.____1515[idx],
            animatype = this.____1033.id,
            fnc = ____655.frameNameCache,
            fncT = fnc[type];
        if (fncT == null) {
            fncT = ____655.frameNameCache[type] = {}
        }
        var fncTP = fncT[picPath];
        if (fncTP == null) {
            fncTP = ____655.frameNameCache[type][picPath] = {}
        }
        var fncTPA = fncTP[animatype];
        if (fncTPA == null) {
            fncTPA = ____655.frameNameCache[type][picPath][animatype] = {}
        }
        var fncTPAF = fncTPA[frameName];
        if (fncTPAF == null) {
            fncTPAF = this._characterInfo.____73(picPath, this.____1033.id) + frameName;
            ____655.frameNameCache[type][picPath][animatype][frameName] = fncTPAF
        }
        return fncTPAF
    },
    getFrameCache: function(idx, name) {
        var actionIdx = this.____1033.id;
        if (null == this.____1173[idx]) {
            this.____1173[idx] = []
        }
        if (null == this.____1173[idx][actionIdx]) {
            this.____1173[idx][actionIdx] = {}
        }
        var frame = this.____1173[idx][actionIdx][name];
        if (null == frame) {
            var frameName = this.getFrameName(idx, name),
                frame = ____654.____673.spriteFrameCache.getSpriteFrame(frameName);
            if (null == frame) {
                print("#empty frame:", frameName, JSON.stringify(this._characterInfo.getStyleList()));
                this.____834.____205();
                this.____834.cleanTickCount()
            }
            this.____1173[idx][actionIdx][name] = frame
        }
        return frame
    },
    setFrame: function(frames) {
        for (var i = 0; i < frames.length; i++) {
            if (!this.____1515) break;
            var picPath = this.____1515[i];
            var layer = this.____1335[i];
            if (picPath == null || layer == null) continue;
            var frame = this.getFrameCache(i, frames[i]);
            if (null == frame) continue;
            layer.setSpriteFrame(frame)
        }
        this._scaleDir = ____655.____659.____686.isLeft(this.____1112) ? -1 : 1;
        this.updateScale()
    },
    updateScale: function() {
        for (var i = 0; i < this.____1335.length; i++) {
            if (!!this.____1335[i]) {
                this.____1335[i].setScaleX(this.____1613 * this._scaleDir);
                this.____1335[i].setScaleY(this._scaleY)
            }
        }
    },
    dispose: function() {
        if (!!this.____1359 && !!this.____1335) {
            for (var i = 0; i < this.____1359.length; i++) {
                if (this.____1335[i] != null) {
                    this.____1335[i].dispose()
                }
                if (this.____1359[i] != null) {
                    ____654.____677.removePlistQuote(this.____1359[i], this)
                }
            }
        }
        this._characterInfo.removeEventListener(____655.____661.playerInfo_styleReload, this.styleReloadHandler, this);
        if (this.____834 != null) {
            this.____834.dispose();
            this.____834 = null
        }
        this._container = null;
        this._characterInfo = null;
        this.____1033 = null;
        this.____832 = null;
        this.____833 = null;
        this.____1515 = null;
        this.____1173 = null;
        this.____1335 = null;
        this.____1359 = null
    },
});
var ____496 = cc.Class.extend({
    id: 0,
    frames: null,
    frameCount: 0,
    repeat: false,
    unreplaceTime: 0,
    framePlayCount: 2,
    DIR_COUNT: 2,
    layerOrders: [
        [1, 2, 0, 3],
        [1, 2, 0, 3],
        [3, 2, 0, 1],
        [3, 2, 0, 1]
    ],
    ctor: function(id, frames, repeat, framePlayCount, unreplaceTime, layerOrders) {
        this.id = id;
        this.frames = frames;
        this.frameCount = this.frames[0].length / this.DIR_COUNT;
        this.repeat = repeat;
        this.framePlayCount = framePlayCount;
        this.unreplaceTime = unreplaceTime;
        this.layerOrders = layerOrders || this.layerOrders
    },
    ____66: function(index, dir) {
        var result = [];
        for (var i = 0; i < this.frames.length; i++) {
            if (this.frames[i] == null) {
                result.push(-1)
            } else {
                result.push(this.frames[i][index + this.____67(dir)])
            }
        }
        return result
    },
    ____67: function(dir) {
        if (dir == ____655.____659.____686.leftTop || dir == ____655.____659.____686.rightTop) {
            return this.frameCount
        }
        return 0
    }
});
var ____2358 = KYNode.extend({
    animaName: "",
    ____1164: "",
    ____831: null,
    ____922: null,
    ____925: null,
    ____837: null,
    _delayAnimaName: null,
    ctor: function(animaName, callback, callTarget) {
        this._super();
        this.animaName = animaName;
        this.____1164 = ____654.____675.getAnimation(animaName);
        this.____922 = callback;
        this.____925 = callTarget;
        ____654.____678.____298(this.tick, this)
    },
    doCallback: function(eventName) {
        if (this.____922 != null) {
            this.____922.call(this.____925, eventName)
        }
    },
    tick: function(delta, tickCount) {
        ____654.____678.____299(this.tick, this);
        var this_ = this;

        function scb() {
            this_.doCallback("loaded");
            ccs.ArmatureDataManager.getInstance().addArmatureFileInfo(this_.____1164 + "0.png", this_.____1164 + "0.plist", this_.____1164 + ".ExportJson");
            this_.____837 = ____654.____673.newArmature(this_.animaName);
            this_.____831 = this_.____837.getAnimation();
            this_.addChild(this_.____837);
            if (this_.____922 != null) {
                function onFrameEvent(bone, frameEventName, originFrameIndex, currentFrameIndex) {
                    this_.doCallback(frameEventName)
                }
                this_.____831.setFrameEventCallFunc(onFrameEvent)
            }
            if (!!this_._delayAnimaName) {
                this_.play(this_._delayAnimaName);
                this_._delayAnimaName = null
            }
        }
        ____654.____677.____148(this.____1164 + "0.png", scb, this, ____655.____659.commonStaticType.source_clearOneM)
    },
    play: function(animaName) {
        if (this.____831 == null) {
            this._delayAnimaName = animaName;
            return
        }
        this.____831.play(animaName)
    },
    stop: function() {
        this._delayAnimaName = null;
        if (this.____831 == null) return;
        this.____831.stop()
    },
    getAnima: function() {
        return this.____831
    },
    gotoAndPause: function(index) {
        if (this.____831 == null) return;
        if (index == null) index = 1;
        this.____831.gotoAndPause(index)
    },
    gotoAndPlay: function(index) {
        if (this.____831 == null) return;
        if (index == null) index = 1;
        this.____831.gotoAndPlay(index)
    },
    stopAndRemove: function() {
        if (this.____831 != null) {
            this.____831.stop()
        }
        if (this.getParent() != null) {
            this.removeFromParent()
        }
    },
    changeBone: function(index, picPath) {
        var boneName = "bone" + index,
            bone = this.____837.getBone(boneName),
            skin = ____654.____673.newSkin(picPath);
        if (skin != null) {
            bone.addDisplay(skin, 1);
            bone.changeDisplayWithIndex(1, true)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.stopAndRemove();
        this.____831 = null;
        this.____922 = null;
        this.____925 = null;
        if (this.____837 != null) {
            ____654.____673.release(this.____837)
        }
        ____654.____677.removeImageQuote(this.____1164 + "0.png", this);
        if (this.____1164 != null) {
            ccs.ArmatureDataManager.getInstance().removeArmatureFileInfo(this.____1164 + ".ExportJson");
            this.____1164 = null
        }
        this._delayAnimaName = null;
        this.animaName = null;
        this._super()
    },
});
var ____2359 = KYNode.extend({
    _info: null,
    autoDispose: true,
    ____1727: false,
    ____1037: 0,
    _currentIndex: -1,
    ____1712: 0,
    ____1271: false,
    sp: null,
    _frameCount: 0,
    ____1613: 1,
    ____1518: null,
    ____1129: null,
    ____1360: false,
    ____1689: null,
    ____1216: false,
    ____1585: true,
    ____1619: 0,
    ____1620: 0,
    ____1274: false,
    ctor: function(info, isScene, autoDispose, stopAtEnd) {
        this._super();
        this._info = info;
        this.autoDispose = autoDispose != null ? autoDispose : true;
        this.stopAtEnd = !!stopAtEnd ? stopAtEnd : false;
        this.____1619 = 0;
        this.____1620 = 0;
        this.____1274 = !!isScene ? isScene : false;
        this.____1037 = 0;
        this._currentIndex = -1;
        this.____1712 = 0;
        this.____1271 = false;
        this.sp = null;
        this._frameCount = 0;
        this.____1613 = 1;
        this.____1518 = null;
        this.____1129 = null;
        this.____1689 = null
    },
    play: function() {
        this.____1271 = true;
        this.____1712 = ____655.____662.getSystemTime();
        this.____1037 = 0;
        if (this.____1360) {
            this.doPlay()
        } else {
            var this_ = this;
            this.____1689 = function() {
                this_.doPlay();
                this_.____1360 = true
            };
            this.____1129 = this._info.getLoadPath();
            ____654.____677.____147(this.____1129, this.____1689, this, ____655.____659.commonStaticType.source_clearOneM)
        }
    },
    stop: function() {
        this.____1271 = false;
        ____654.____678.____299(this.tick, this)
    },
    doPlay: function() {
        this.____1271 = true;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        if (!this._info) {
            if (this.autoDispose) this.dispose();
            return
        }
        this._frameCount += 1;
        if (this._frameCount % 3 != 0) return;
        if (this._info.time != -1) {
            if (this._info.time < 800000000 && ____655.____662.getSystemTime() - this.____1712 >= this._info.time) {
                if (this.____1727) {
                    this.stop();
                    if (!!this.____1518) {
                        this.____1518.call(this._target);
                        this.____1518 = null
                    }
                } else if (this.autoDispose) {
                    this.dispose()
                } else {
                    this.doEnd()
                }
                return
            }
        }
        var tmp = parseInt(this._info.frames[this.____1037]);
        if (this._currentIndex != tmp) {
            this._currentIndex = tmp;
            if (!this.sp) {
                this.sp = ____654.____673.newKYSprite();
                this.sp.setScaleX(this.____1613);
                this.addChild(this.sp)
            }
            var frameName = ____654.____675.getEffectPicPath(this._info.picPath, this._currentIndex) + ".png";
            var frame = ____654.____673.spriteFrameCache.getSpriteFrame(frameName);
            if (!!frame) {
                this.sp.setSpriteFrame(frame)
            }
        }
        this.____1037 += tickCount;
        if (this.____1037 >= this._info.frameCount) {
            if (this._info.time == -1) {
                if (this.____1727) {
                    this.stop();
                    if (!!this.____1518) {
                        this.____1518.call(this._target);
                        this.____1518 = null
                    }
                } else if (this.autoDispose) {
                    this.dispose()
                } else {
                    this.doEnd()
                }
                return
            } else {
                this.____1037 = 0
            }
        }
        this.setToPos()
    },
    getCurrentFrameName: function() {
        if (this.____1271 && this._currentIndex > 0) {
            return ____654.____675.getEffectPicPath(this._info.picPath, this._currentIndex) + ".png"
        }
        return null
    },
    setAlpha: function(value) {
        if (!!this.sp) {
            this.sp.setOpacity(value)
        }
    },
    setEnabled: function(value) {
        if (value) this.doPlay();
        else this.stop()
    },
    setStopAtEnd: function(stopAtEnd) {
        this.____1727 = stopAtEnd
    },
    move: function(x, y) {
        this.____1619 = x;
        this.____1620 = y;
        this.setToPos()
    },
    setToPos: function() {
        var plus = this.____1274 ? -1 : 1;
        if (!!this.sp) {
            this.sp.setPosition(____654.____673.____159(this._info.xoffset, this._info.yoffset * plus))
        }
        this.setPosition(____654.____673.____159(this.____1619, this.____1620 * plus))
    },
    getSceneX: function() {
        return this.____1619
    },
    getSceneY: function() {
        return this.____1620
    },
    setCallback: function(callback, target) {
        this.____1518 = callback;
        this._target = target;
        return this
    },
    setScaleDir: function(scale) {
        this.____1613 = scale;
        if (!!this.sp) {
            this.sp.setScaleX(this.____1613)
        }
    },
    setRemoveAndRecovery: function(flag) {
        this.____1585 = flag
    },
    getScaleDir: function() {
        return this.____1613
    },
    doEnd: function() {
        if (!!this.stop) {
            this.stop()
        }
        if (!!this.getParent && !!this.getParent()) {
            this.getParent().removeChild(this, this.____1585)
        }
        if (!!this.____1518) {
            this.____1518.call(this._target);
            this.____1518 = null
        }
    },
    dispose: function() {
        if (this.____1216) return;
        this.____1216 = true;
        ____654.____677.removePlistQuote(this.____1129, this);
        this.____1689 = null;
        this.doEnd();
        this.____1518 = null;
        this._target = null;
        this._info = null;
        if (this.sp != null) {
            this.sp.dispose();
            this.sp = null
        }
        this._super()
    }
});
var BatchEffect = cc.Class.extend({
    _info: null,
    autoDispose: true,
    ____1037: 0,
    _currentIndex: -1,
    ____1712: 0,
    ____1271: false,
    sp: null,
    _frameCount: 0,
    ____1613: 1,
    _scaleY: 1,
    _scaleXDir: 1,
    _rotate: 0,
    ____1518: null,
    ____1129: null,
    ____1360: false,
    ____1216: false,
    ____1619: 0,
    ____1620: 0,
    ____1274: false,
    _container: null,
    _tmpAnchorPoint: null,
    _clearFlag: null,
    _order: 0,
    ctor: function(info, isScene, autoDispose, scale, stopAtEnd, clearFlag) {
        this._info = info;
        this.____1129 = this._info.getLoadPath();
        this.autoDispose = autoDispose != null ? autoDispose : true;
        this.stopAtEnd = !!stopAtEnd ? stopAtEnd : false;
        this.____1619 = 0;
        this.____1620 = 0;
        this.____1274 = !!isScene ? isScene : false;
        this.____1037 = 0;
        this._currentIndex = -1;
        this.____1712 = 0;
        this.____1613 = this._scaleY = scale == null ? info.scale : scale;
        this.____1271 = false;
        this._clearFlag = clearFlag == null ? ____655.____659.commonStaticType.source_clearOneM : clearFlag;
        this.sp = null;
        this._frameCount = 0;
        this.____1518 = null
    },
    addTo: function(parent, order) {
        assert(parent);
        this._order = order || this._order;
        this.setContainer(parent);
        return this
    },
    setLocalZOrder: function(index) {
        if (!!this.sp) {
            this.sp.setLocalZOrder(index)
        }
    },
    setContainer: function(container) {
        this._container = container
    },
    addToContainer: function() {
        if (!!this._container && !!this.sp && this.sp.getParent() == null && !this._container.___release) {
            this._container.addChild(this.sp, this._order)
        }
    },
    removeFromContainer: function() {
        if (!!this._container && !!this.sp && this.sp.getParent() == this._container) {
            this.sp.removeFromParent(false)
        }
    },
    play: function(index) {
        this.____1271 = true;
        this.____1712 = ____655.____662.getSystemTime();
        if (index == null) {
            index = 0
        }
        this.____1037 = index;
        if (this.____1360) {
            this.doPlay()
        } else {
            var this_ = this;

            function sourceCallback() {
                this_.doPlay();
                this_.____1360 = true
            }
            ____654.____677.____147(this.____1129, sourceCallback, this, this._clearFlag)
        }
    },
    stop: function() {
        this.____1271 = false;
        ____654.____678.____299(this.tick, this)
    },
    doPlay: function() {
        this.____1271 = true;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        if (!this._info) {
            if (this.autoDispose) {
                this.dispose()
            }
            return
        }
        this._frameCount += 1;
        var framePerCount = 3;
        if (this._info.id == ____655.allTemplates.____789.WEAPON_TOP_EFFECT || this._info.id == ____655.allTemplates.____789.WEAPON_BOTTOM_EFFECT) {
            framePerCount = 1
        }
        if (this._frameCount % framePerCount != 0) return;
        var doStop = false;
        var tmp = parseInt(this._info.frames[this.____1037]);
        if (this._currentIndex != tmp) {
            this._currentIndex = tmp;
            if (this.sp == null) {
                this.sp = ____654.____673.newKYSprite();
                this.updateScale();
                this.updateRotate();
                this.updateAnchor();
                if (!this._container.___release) this._container.addChild(this.sp, this._order)
            }
            var frameName = ____654.____675.getEffectPicPath(this._info.picPath, this._currentIndex) + ".png";
            this.sp.setFrame(frameName)
        }
        this.____1037++;
        if (this._info.time > 800000000) {
            if (this.____1037 >= this._info.frameCount) {
                this.____1037 = 0
            }
        } else {
            if (parseInt(this._info.picPath) == 1074) {
                print("#int", this.____1037, this._info.frameCount, this._info.time, this._frameCount)
            }
            if (this.____1037 >= this._info.frameCount) {
                if (this._info.time == -1) {
                    doStop = true
                } else {
                    if (this._frameCount >= this._info.time) {
                        doStop = true
                    } else {
                        this.____1037 = 0
                    }
                }
            }
        }
        this.setToPos();
        if (doStop) {
            this.stop();
            if (this.____1518 != null) {
                this.____1518.call(this._target);
                this.____1518 = null
            }
            if (this.autoDispose) {
                this.dispose()
            }
        }
    },
    getCurrentFrameName: function() {
        if (this.____1271 && this._currentIndex > 0) {
            return ____654.____675.getEffectPicPath(this._info.picPath, this._currentIndex) + ".png"
        }
        return null
    },
    getCurrentFrame: function() {
        return this.____1037
    },
    setAnchorPoint: function(p) {
        if (this._tmpAnchorPoint == p) return;
        this._tmpAnchorPoint = p;
        this.updateAnchor()
    },
    updateAnchor: function() {
        if (this.sp != null && this._tmpAnchorPoint != null) {
            this.sp.setAnchorPoint(this._tmpAnchorPoint)
        }
    },
    setAlpha: function(value) {
        if (!!this.sp) {
            this.sp.setOpacity(value)
        }
    },
    move: function(x, y) {
        this.____1619 = x;
        this.____1620 = y;
        this.setToPos()
    },
    setVisible: function(value) {
        if (this.sp != null) this.sp.setVisible(value)
    },
    setToPos: function() {
        var plus = this.____1274 ? -1 : 1;
        if (!!this.sp) {
            this.sp.setPosition(____654.____673.____159(this.____1619 + this._info.xoffset, this.____1620 * plus + this._info.yoffset * plus))
        }
    },
    getSceneX: function() {
        return this.____1619
    },
    getSceneY: function() {
        return this.____1620
    },
    setCallback: function(callback, target) {
        this.____1518 = callback;
        this._target = target;
        return this
    },
    setRotate: function(rotate) {
        if (this._rotate == rotate) return;
        this._rotate = rotate;
        this.updateRotate()
    },
    updateRotate: function() {
        if (this.sp != null) {
            this.sp.setRotation(this._rotate)
        }
    },
    setScaleDir: function(scale) {
        this.____1613 = scale;
        this.updateScale()
    },
    getScaleDir: function() {
        return this.____1613
    },
    setScale: function(scale) {
        this.____1613 = this._scaleY = scale == null ? info.scale : scale;
        this.updateScale()
    },
    setScaleX: function(value) {
        if (this.____1613 == value) return;
        this.____1613 = value;
        this.updateScale()
    },
    setScaleY: function(value) {
        if (this._scaleY == value) return;
        this._scaleY = value;
        this.updateScale()
    },
    updateScale: function() {
        if (!!this.sp) {
            this.sp.setScaleX(this.____1613 * this._scaleXDir);
            this.sp.setScaleY(this._scaleY)
        }
    },
    getPath: function() {
        return this.____1129
    },
    dispose: function() {
        if (this.____1216) return;
        this.____1216 = true;
        ____654.____677.removePlistQuote(this.____1129, this);
        this.stop();
        this.____1518 = null;
        this._target = null;
        this._info = null;
        if (this.sp != null) {
            this.sp.dispose();
            this.sp = null
        }
        this._tmpAnchorPoint = null;
        this._container = null
    }
});
var ____2362 = KYNode.extend({
    time: 0,
    total: 0,
    timer: null,
    destroyed: false,
    image: null,
    scaleSize: null,
    _container: null,
    ctor: function(container, size) {
        this._super();
        this._container = container;
        this.setAnchorPoint(____654.____673.anchorPoints[0]);
        var path = ____654.____675.____139("outPic/skill_cd_mask.png"),
            this_ = this;

        function ____105() {
            this_.timer = ____654.____673.____177(this_.image);
            this_.timer.setScaleX(-(size.width - 4) / 70);
            this_.timer.setScaleY((size.height - 4) / 70);
            this_.addChild(this_.timer);
            this_.start(this_.total);
            if (!!this_.scaleSize) this_.scaleTo(this_.scaleSize)
        }
        this.image = ____654.____673.newKYSprite();
        ____654.____677.____146(this.image, path, ____105)
    },
    start: function(time) {
        this.total = time || 0;
        this.time = 0;
        if (!!this.timer) ____654.____678.____298(this.tick, this);
        if (this._container != null && this.getParent() != this._container) {
            this._container.addChild(this)
        }
    },
    stop: function() {
        if (!!this.timer) this.timer.setPercentage(0);
        ____654.____678.____299(this.tick, this);
        if (this.getParent() != null) {
            this.getParent().removeChild(this, false)
        }
    },
    tick: function(delta, count) {
        this.time += delta * 1000;
        if (this.time >= this.total) this.stop();
        else {
            var pre = 100 - Math.floor(this.time / this.total * 100);
            this.timer.setPercentage(pre)
        }
    },
    dispose: function() {
        this.destroyed = true;
        this._container = null;
        this.stop();
        if (!!this.image) {
            this.image.dispose();
            this.image = null
        }
        if (!!this.timer) {
            ____654.____673.release(this.timer);
            this.timer = null
        }
        this._super()
    }
});
var ____2366 = cc.Class.extend({
    changeType: 0,
    propertyType: 0,
    speed: 0,
    _target: null,
    ____1713: 0,
    ____1072: 0,
    ____1529: false,
    ____1134: 0,
    ____1697: 0,
    ____1698: 0,
    ____1132: null,
    ____1710: null,
    ____1056: null,
    ____1664: null,
    ____922: null,
    ctor: function(target, propertyType, changeType) {
        if (!changeType) changeType = 1;
        this.changeType = changeType;
        this._target = target;
        this.propertyType = propertyType;
        if (this.propertyType == 4 || this.propertyType == 5) {
            this.____1710 = ____654.____673.____159(this._target.getSceneX(), this._target.getSceneY());
            this.____1056 = ____654.____673.____159(this._target.getSceneX(), this._target.getSceneY())
        } else if (this.propertyType == 1) {
            this.____1072 = this.____1713 = this._target.getSceneX()
        } else if (this.propertyType == 2) {
            this.____1072 = this.____1713 = this._target.getSceneY()
        }
    },
    start: function(endValue, speed, callback) {
        this.____1529 = true;
        this.____922 = callback;
        if (this.propertyType == 4 || this.propertyType == 5) {
            this.setSpeed(endValue, speed);
            this.____1132 = endValue;
            this.____1664 = this.setMoveValue
        } else {
            this.____1134 = endValue;
            var plus = this.____1072 > this.____1134 ? -1 : 1;
            if (this.propertyType == 1) {
                speed *= plus;
                this.____1664 = this.setXValue
            } else if (this.propertyType == 2) {
                speed *= plus;
                this.____1664 = this.setYValue
            } else {
                this.____1664 = this.setNoneValue
            }
        }
        this.speed = speed
    },
    setSpeed: function(endPoint, speed) {
        this.____1056.x = this._target.getSceneX();
        this.____1056.y = this._target.getSceneY();
        var angle = ____655.____659.____686.____98(this.____1056, endPoint);
        this.____1697 = Math.cos(angle) * speed;
        this.____1698 = Math.sin(angle) * speed
    },
    setXValue: function(x) {
        var y = this._target.getSceneY();
        this._target.move(x, y)
    },
    setYValue: function(y) {
        var x = this._target.getSceneX();
        this._target.move(x, y)
    },
    setMoveValue: function(x, y) {
        this._target.move(x, y)
    },
    setNoneValue: function() {},
    tick: function(delta, tickCount) {
        if (!this.____1529) return;
        if (this.propertyType == 4 || this.propertyType == 5) {
            this.____358(tickCount)
        } else {
            if (Math.abs(this.____1072 - this.____1134) <= Math.abs(this.speed * tickCount)) {
                this.____1072 = this.____1134;
                if (this.changeType == 1) {
                    this.____1664(this.____1072);
                    if (!!this.____922) {
                        this.____922();
                        this.____1529 = false;
                        return
                    }
                } else if (this.changeType == 2) {
                    this.____1072 = this.____1713
                } else if (this.changeType == 3) {
                    this.____1134 = this.____1713;
                    this.____1713 = this.____1072;
                    this.speed *= -1
                }
            } else {
                this.____1072 = this.____1072 + this.speed * tickCount
            }
            this.____1664(this.____1072)
        }
    },
    ____358: function(counts) {
        this.____1056.x = this._target.getSceneX();
        this.____1056.y = this._target.getSceneY();
        if (____654.____674.____179(this.____1056, this.____1132) <= this.speed * counts) {
            this.____1056.x = this.____1132.x;
            this.____1056.y = this.____1132.y;
            if (this.changeType == 1) {
                this.____1664(this.____1056.x, this.____1056.y);
                if (!!this.____922) this.____922();
                this.____1529 = false;
                return
            } else if (this.changeType == 2) {
                this.____1056.x = this.____1710.x;
                this.____1056.y = this.____1710.y
            } else if (this.changeType == 3) {
                this.____1697 *= -1;
                this.____1698 *= -1;
                this.____1132.x = this.____1710.x;
                this.____1132.y = this.____1710.y;
                this.____1710.x = this._target.getSceneX();
                this.____1710.y = this._target.getSceneY()
            }
        } else {
            this.____1056.x = this.____1056.x + this.____1697 * counts;
            this.____1056.y = this.____1056.y + this.____1698 * counts
        }
        this.____1664(this.____1056.x, this.____1056.y)
    },
    dispose: function() {
        this.____1664 = this.____922 = this._target = this.____1132 = this.____1710 = this.____1056 = null
    }
});
var BatchParticleEffect = cc.Class.extend({
    ____1130: null,
    _batchNode: null,
    _container: null,
    ____1164: null,
    _frameCount: -1,
    _pauseTick: -1,
    _effectInfo: null,
    _particleInfo: null,
    _createCount: 0,
    _stopCreate: false,
    _yflag: 1,
    ____1539: 0,
    ____1540: 0,
    ctor: function(container, particleInfo) {
        this._container = container;
        this._particleInfo = particleInfo;
        if (this._particleInfo.isScene) this._yflag = -1;
        this._effectInfo = ____655.allTemplates.____789.getEffect(this._particleInfo.effectId);
        this.____1164 = this._effectInfo.getLoadPath();
        this.____1130 = [];
        this._batchNode = ____654.____673.newKYNode();
        this._container.addChild(this._batchNode)
    },
    play: function() {
        this._frameCount = -1;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        if (this.____1130 == null) return;
        for (var i = this.____1130.length - 1; i >= 0; i--) {
            var e = this.____1130[i];
            e.update();
            if (e.isComplete) {
                e.dispose();
                this.____1130.splice(i, 1)
            }
        }
        if (this._pauseTick > 0) {
            this._pauseTick--;
            return
        }
        this._frameCount++;
        if (this._frameCount >= this._particleInfo.life) {
            this.dispose();
            return
        }
        if (this._frameCount % this._particleInfo.createDFrame != 0) return;
        for (var i = 0; i < this._particleInfo.createPerFrame; i++) {
            if (this._createCount < this._particleInfo.totalCount && !this._stopCreate) {
                this._createCount++;
                var effect = this.createEffect();
                this.setProps(effect);
                this.____1130.push(effect)
            }
        }
    },
    createEffect: function() {
        return new ParticleItemController(this._particleInfo.effectId, this._batchNode)
    },
    setProps: function(ic) {
        ic.setValues(0, 0, 0, 0)
    },
    move: function(x, y) {
        if (this.____1539 == x && this.____1540 == y) return;
        this.____1539 = x;
        this.____1540 = y;
        this._batchNode.setPosition(____654.____673.____159(x, y))
    },
    setRotate: function(rotate) {
        if (this._batchNode != null) {
            this._batchNode.setRotation(rotate)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        if (this.____1130 != null) {
            for (var i = 0; i < this.____1130.length; i++) {
                this.____1130[i].dispose()
            }
        }
        this.____1130 = null;
        if (this._batchNode != null) {
            this._batchNode.dispose();
            this._batchNode = null
        }
        this._container = null;
        this._effectInfo = null
    },
});
var ParticleEffect1 = BatchParticleEffect.extend({
    setProps: function(ic) {
        var round = Math.ceil(this._createCount / this._particleInfo.createPerFrame);
        var index = this._createCount % this._particleInfo.createPerFrame;
        if (index == 0) {
            ic.setValues(round * 80 * 0.8, round * 60 * 0.8 * this._yflag, 0, 0, 0, 0, 0, 0, 0.8, 0)
        } else if (index == 1) {
            ic.setValues(-round * 80 * 0.8, round * 60 * 0.8 * this._yflag, 0, 0, 0, 0, 0, 0, 0.8, 0)
        } else if (index == 2) {
            ic.setValues(-round * 80 * 1.2, -round * 60 * 1.2 * this._yflag, 0, 0, 0, 0, 0, 0, 1.1, 0)
        } else if (index == 3) {
            ic.setValues(round * 80 * 1.2, -round * 60 * 1.2 * this._yflag, 0, 0, 0, 0, 0, 0, 1.1, 0)
        }
    },
});
var ParticleEffect2 = BatchParticleEffect.extend({
    _degree: 0,
    setDegree: function(degree) {
        this._degree = degree
    },
    setProps: function(ic) {
        var round = Math.ceil(this._createCount / this._particleInfo.createPerFrame);
        var index = this._createCount % this._particleInfo.createPerFrame;
        var tmp = round * 80;
        if (index == 0) {
            ic.setValues(tmp * Math.cos(this._degree / 180 * Math.PI), tmp * Math.sin(this._degree / 180 * Math.PI) * this._yflag)
        } else if (index == 1) {
            ic.setValues(tmp * Math.cos((this._degree + 15) / 180 * Math.PI), tmp * Math.sin((this._degree + 15) / 180 * Math.PI) * this._yflag)
        } else if (index == 2) {
            ic.setValues(tmp * Math.cos((this._degree - 15) / 180 * Math.PI), tmp * Math.sin((this._degree - 15) / 180 * Math.PI) * this._yflag)
        }
    },
});
var ParticleEffect3 = BatchParticleEffect.extend({
    _degree: 0,
    _tmpCount: 0,
    _dtmp: 10,
    setDegree: function(value) {
        this._degree = value
    },
    setProps: function(ic) {
        this._tmpCount += this._dtmp;
        if (this._tmpCount >= 20) this._dtmp *= -1;
        if (this._tmpCount <= -15) this._dtmp *= -1;
        var degree = this._degree + this._tmpCount;
        var speed = 20 + Math.random() * 14 - 7;
        var dX = Math.cos(degree / 180 * Math.PI);
        var dY = Math.sin(degree / 180 * Math.PI);
        ic.setValues(0, 0, speed * dX, speed * dY * this._yflag)
    },
});
var ParticleEffect4 = BatchParticleEffect.extend({
    _degree: 0,
    setDegree: function(value) {
        this._degree = value
    },
    createEffect: function() {
        if (this._createCount < 10) {
            return this._super()
        }
        return new ParticleItemController(this._particleInfo.effectId2, this._batchNode)
    },
    setProps: function(ic) {
        if (this._createCount < 10) {
            var d = -50 + this._createCount * 10 + this._degree;
            var dx = Math.cos(d / 180 * Math.PI);
            var dy = Math.sin(d / 180 * Math.PI);
            ic.setValues(dx * 110, dy * 110 * this._yflag, dx, dy * this._yflag, 0, 0, d, 0)
        } else {
            var d = this._degree;
            var dx = Math.cos(d / 180 * Math.PI);
            var dy = Math.sin(d / 180 * Math.PI);
            ic.setValues(dx * 80, dy * 80 * this._yflag, 0, 0, 0, 0, d, 0, 1.4, 0.04)
        }
    },
});
var ParticleEffect5 = BatchParticleEffect.extend({
    _pointList: null,
    _pointIndex: 0,
    _startSceneX: 0,
    _startSceneY: 0,
    _dis: 20,
    _tmpIndex: 0,
    setPoints: function(pointList, sceneX, sceneY) {
        this._pointList = pointList;
        this._startSceneX = sceneX;
        this._startSceneY = sceneY
    },
    setProps: function(ic) {
        var startPoint = this._pointList[this._pointIndex];
        var nextPoint = this._pointList[this._pointIndex + 1];
        var radian = ____655.____659.____686.____98(startPoint, nextPoint);
        var currentP = ____654.____673.____159(this._dis * this._tmpIndex * Math.cos(radian) + startPoint.x, this._dis * this._tmpIndex * Math.sin(radian) + startPoint.y);
        var isTmpEnd = false;
        if (____654.____674.____179(currentP, nextPoint) < this._dis) {
            currentP.x = nextPoint.x;
            currentP.y = nextPoint.y;
            isTmpEnd = true
        }
        ic.setValues(currentP.x, currentP.y * this._yflag, 0, 0, 255, -10, Math.random() * 360, 0, Math.random() * 0.4 - 0.2 + 0.8);
        if (isTmpEnd) {
            this._tmpIndex = 0;
            this._pointIndex++;
            if (this._pointIndex >= this._pointList.length - 1) {
                this._stopCreate = true
            }
        } else {
            this._tmpIndex++
        }
    },
});
var ParticleEffect6 = BatchParticleEffect.extend({
    _degree: 0,
    setDegree: function(degree) {
        this._degree = degree
    },
    setProps: function(ic) {
        var tmp = this._createCount * 80;
        ic.setValues(tmp * Math.cos(this._degree / 180 * Math.PI), tmp * Math.sin(this._degree / 180 * Math.PI) * this._yflag)
    },
});
var ParticleEffect7 = BatchParticleEffect.extend({
    _lastDis: 0,
    _degrees: null,
    ctor: function(container, particleInfo) {
        this._super(container, particleInfo);
        this._degrees = [0, 120, 240, 180, 60, 300, 30, 150, 270, 210, 90, 330]
    },
    setProps: function(ic) {
        var round = Math.ceil(this._createCount / 6);
        var x = 0;
        var y = 0;
        var tmpScale = 1.4;
        if (round == 1) {
            this._lastDis = 150
        } else if (round == 2) {
            this._lastDis = 320;
            tmpScale = 1.8
        }
        var degree = this._degrees[this._createCount - 1];
        x = Math.cos(degree * Math.PI / 180) * (this._lastDis + Math.random() * (100 - 50));
        y = Math.sin(degree * Math.PI / 180) * (this._lastDis + Math.random() * (100 - 50));
        ic.setValues(x, y * this._yflag, 0, 0, 255, 0, 0, 0, tmpScale, 0);
        if (this._createCount == 6) this._pauseTick = 35
    },
});
var ParticleEffect9011 = BatchParticleEffect.extend({
    setProps: function(ic) {
        if (this._createCount == 2) {
            var x = 120;
            var y = 0;
            ic.setValues(x, y, 0, 0, 0, 0, 0, 0, 1.6)
        } else {
            ic.setValues(-180, 0, 18, 0, 0, 0, 0, 0, 1.5);
            ic.setSpeedFrame(8)
        }
    },
});
var ParticleEffect9012 = BatchParticleEffect.extend({
    _lastDis: 0,
    _degrees: null,
    ctor: function(container, particleInfo) {
        this._super(container, particleInfo);
        this._degrees = [0, 180, 120, 60, 240, 30, 150, 300, 270, 210, 0]
    },
    setProps: function(ic) {
        var x = 0;
        var y = 0;
        var tmpScale = 1;
        if (this._createCount <= 5) {
            this._lastDis = 150
        } else if (this._createCount <= 10) {
            this._lastDis = 240;
            tmpScale = 1.2
        } else this._lastDis = 0;
        var degree = this._degrees[this._createCount - 1];
        x = Math.cos(degree * Math.PI / 180) * this._lastDis * 1.2;
        y = Math.sin(degree * Math.PI / 180) * this._lastDis * 0.8;
        ic.setValues(x, y * this._yflag, 0, 0, 255, 0, 0, 0, tmpScale, 0);
        if (this._createCount == 5) this._pauseTick = 3
    },
});
var ParticleEffect9013 = BatchParticleEffect.extend({
    _degree: 0,
    setDegree: function(degree) {
        this._degree = degree
    },
    setProps: function(ic) {
        var tmp = this._createCount * 100;
        ic.setValues(tmp * Math.cos(this._degree / 180 * Math.PI), 0.5 * tmp * Math.sin(this._degree / 180 * Math.PI) * this._yflag, 0, 0, 0, 0, 0, 0);
        ic.setScaleY(2)
    },
});
var ParticleEffect9014 = BatchParticleEffect.extend({
    setProps: function(ic) {
        ic.setScaleX(1);
        ic.setScaleY(1)
    },
});
var ParticleEffect9021 = BatchParticleEffect.extend({
    setProps: function(ic) {
        ic.setValues(-180, 0, 25, 0, 0, 0, 0, 0, 1.5);
        ic.setSpeedFrame(8)
    },
});
var ParticleEffect9022 = BatchParticleEffect.extend({
    _degree: 0,
    setDegree: function(degree) {
        this._degree = degree
    },
    setProps: function(ic) {
        var tmp = this._createCount * 120;
        ic.setValues(tmp * Math.cos(this._degree / 180 * Math.PI), tmp * Math.sin(this._degree / 180 * Math.PI) * this._yflag, 0, 0, 0, 0, 0, 0, 0.8 + this._createCount * 0.1)
    },
});
var ParticleEffect9023 = BatchParticleEffect.extend({
    _lastDis: 0,
    _degrees: null,
    ctor: function(container, particleInfo) {
        this._super(container, particleInfo);
        this._degrees = [0, 180, 120, 60, 240, 30, 150, 300, 270, 210, 0, 120, 60, 240, 30, 150, 300, 210, 0, 120, 60]
    },
    setProps: function(ic) {
        var x = 0;
        var y = 0;
        var tmpScale = 1;
        if (this._createCount <= 7) {
            this._lastDis = 150
        } else if (this._createCount <= 10) {
            this._lastDis = 240;
            tmpScale = 1.5
        }
        var degree = this._degrees[this._createCount - 1];
        x = Math.cos(degree * Math.PI / 180) * this._lastDis * 1.2;
        y = Math.sin(degree * Math.PI / 180) * this._lastDis * 0.8;
        ic.setValues(x, y * this._yflag, 0, 0, 255, 0, 0, 0, tmpScale, 0);
        if (this._createCount == 7) this._pauseTick = 3
    },
});
var ParticleEffect9024 = BatchParticleEffect.extend({
    setProps: function(ic) {
        var x = Math.cos((this._createCount * 120) / 180 * Math.PI) * 40;
        var y = Math.sin((this._createCount * 120) / 180 * Math.PI) * 40;
        var s = 2;
        if (this._createCount == 1) s = 1.6;
        ic.setValues(x, y * this._yflag, 0, 0, 0, 0, 0, 0, s, 0)
    },
});
var ParticleEffect9031 = BatchParticleEffect.extend({
    setProps: function(ic) {
        ic.setValues(0);
        ic.setScaleY(2)
    },
});
var ParticleEffect9032 = BatchParticleEffect.extend({
    _degree: 0,
    _tmpCount: 0,
    _dtmp: 10,
    ctor: function(container, particleInfo) {
        this._super(container, particleInfo)
    },
    setDegree: function(value) {
        this._degree = value
    },
    setProps: function(ic) {
        this._tmpCount += this._dtmp;
        if (this._tmpCount >= 20) this._dtmp *= -1;
        if (this._tmpCount <= -15) this._dtmp *= -1;
        var degree = this._degree + this._tmpCount;
        var speed = 20 + Math.random() * 14 - 7;
        var dX = Math.cos(degree / 180 * Math.PI);
        var dY = Math.sin(degree / 180 * Math.PI);
        ic.setValues(0, 0, speed * dX, speed * dY * this._yflag, 0, 0, 0, 0, 1, 0.02)
    },
});
var ParticleEffect9034 = BatchParticleEffect.extend({
    setProps: function(ic) {
        var r = 200;
        var round = Math.ceil(this._createCount / this._particleInfo.createPerFrame);
        var index = this._createCount % this._particleInfo.createPerFrame;
        var degree = index * 72;
        var rFlagX = 1;
        var rFlagY = 0.5;
        var d = degree + 180 + round * 30;
        var s = 0.5;
        var r1 = 6;
        var r2 = 13;
        if (round <= r1) {} else if (round <= r2) {
            d = degree + 180 + r1 * 30 + round * 3;
            r *= (r1 + r2 - round) * 0.1;
            s *= (r1 + r2 - round) * 0.1
        } else {
            d = degree + 180 + r1 * 30 + round * 5;
            r = r * (r1 + r2 - r2) * 0.1 + (round - r2) * 100;
            s += (round - r2) * 0.1
        }
        var cx = Math.cos(degree / 180 * Math.PI) * r;
        var cy = Math.sin(degree / 180 * Math.PI) * r;
        ic.setValues((cx + Math.cos(d / 180 * Math.PI) * r) * rFlagX, (cy + Math.sin(d / 180 * Math.PI) * r) * this._yflag * rFlagY, 0, 0, 255, -6, 0, 0, s);
        if (round <= r1) this._pauseTick = 5;
        else if (round <= r2) this._pauseTick = 8
    },
});
var ParticleEffect9041 = BatchParticleEffect.extend({
    setProps: function(ic) {
        ic.setValues(-180, 0, 25, 0, 0, 0, 0, 0, 1.5);
        ic.setSpeedFrame(8)
    },
});
var ParticleEffect9042 = BatchParticleEffect.extend({
    _degree: 0,
    setDegree: function(degree) {
        this._degree = degree
    },
    setProps: function(ic) {
        var tmp = this._createCount * 120;
        ic.setScaleY(2);
        ic.setValues(tmp * Math.cos(this._degree / 180 * Math.PI), tmp * Math.sin(this._degree / 180 * Math.PI) * this._yflag, 0, 0, 0, 0, 0, 0)
    },
});
var ParticleEffect9044 = BatchParticleEffect.extend({
    setProps: function(ic) {
        var dDegree = 360 / this._particleInfo.createPerFrame;
        var degree = this._createCount * dDegree;
        var r = 200;
        ic.setValues(Math.cos(degree / 180 * Math.PI) * r, Math.sin(degree / 180 * Math.PI) * r * this._yflag, 0, 0, 0, 0, -degree, 0);
        var s = 1;
        if (this._createCount == 1 || this._createCount == 3 || this._createCount == 2 || this._createCount == 4 || this._createCount == 8) s = 1;
        else if (this._createCount == 5 || this._createCount == 7) s = 0.5;
        else if (this._createCount == 6) s = 0.4;
        ic.setScaleX(s)
    },
});
var ParticleEffect9053 = BatchParticleEffect.extend({
    _degree: 0,
    setDegree: function(degree) {
        this._degree = degree
    },
    setProps: function(ic) {
        ic.setScaleX(2);
        ic.setScaleY(2)
    },
});
var ParticleEffect9999 = BatchParticleEffect.extend({
    _degree: 0,
    ____1692: 10,
    setDegree: function(degree) {
        this._degree = degree
    },
    setProps: function(ic) {
        var dspx = Math.cos(this._degree / 180 * Math.PI) * this.____1692;
        var dspy = Math.sin(this._degree / 180 * Math.PI) * this.____1692;
        ic.setValues(0, 0, dspx, dspy * this._yflag, 0, 0, -this._degree)
    },
});
var ParticleFloower = BatchParticleEffect.extend({
    _flowerDx: 0,
    createEffect: function() {
        var id = this._particleInfo.effectId;
        if (Math.random() > 0.6) id = this._particleInfo.effectId2;
        else if (Math.random() > 0.2) id = this._particleInfo.effectId3;
        return new ParticleItemController(id, this._batchNode)
    },
    setProps: function(ic) {
        var round = Math.ceil(this._createCount / this._particleInfo.createPerFrame);
        var index = this._createCount % this._particleInfo.createPerFrame;
        this._flowerDx = ____655.____656 / this._particleInfo.createPerFrame;
        var startX = this._flowerDx * index + Math.random() * 100 - 50;
        var startY = ____655.____657 + Math.random() * 60;
        var dalpha = 0;
        if (Math.random() > 0.6) dalpha = -Math.random() * 3;
        var drotate = 0;
        if (Math.random() > 0.6) drotate = Math.random() * 3;
        var dscale = 0;
        if (Math.random() > 0.6) dscale = Math.random() * 0.004;
        ic.setValues(startX, startY * this._yflag, -Math.random() * 4 + 1, -Math.random() * 6, 255, dalpha, 0, drotate, 1, dscale)
    },
});
var ParticleInfo = cc.Class.extend({
    effectId: 0,
    effectId2: 0,
    effectId3: 0,
    life: 0,
    totalCount: 0,
    createPerFrame: 0,
    createDFrame: 1,
    setDegree: false,
    setRotate: false,
    isScene: true,
    cls: null,
});
var ParticleInfoList = cc.Class.extend({
    list: null,
    ctor: function() {
        this.list = {};
        var pInfo1 = new ParticleInfo();
        pInfo1.effectId = 1057;
        pInfo1.life = 600;
        pInfo1.totalCount = 20;
        pInfo1.createPerFrame = 4;
        pInfo1.createDFrame = 12;
        pInfo1.cls = ParticleEffect1;
        this.list[9001] = pInfo1;
        var pInfo2 = new ParticleInfo();
        pInfo2.effectId = 1057;
        pInfo2.life = 600;
        pInfo2.totalCount = 18;
        pInfo2.createPerFrame = 3;
        pInfo2.createDFrame = 12;
        pInfo2.cls = ParticleEffect2;
        this.list[9002] = pInfo2;
        var pInfo3 = new ParticleInfo();
        pInfo3.effectId = 8003;
        pInfo3.life = 150;
        pInfo3.totalCount = 25;
        pInfo3.createPerFrame = 1;
        pInfo3.createDFrame = 4;
        pInfo3.setDegree = true;
        pInfo3.cls = ParticleEffect3;
        this.list[9003] = pInfo3;
        var pInfo4 = new ParticleInfo();
        pInfo4.effectId = 4002;
        pInfo4.effectId2 = 4003;
        pInfo4.life = 600;
        pInfo4.totalCount = 10;
        pInfo4.createPerFrame = 9;
        pInfo4.createDFrame = 6;
        pInfo4.cls = ParticleEffect4;
        this.list[9004] = pInfo4;
        var pInfo5 = new ParticleInfo();
        pInfo5.effectId = 1119;
        pInfo5.life = 600;
        pInfo5.totalCount = 1000;
        pInfo5.createPerFrame = 1;
        pInfo5.createDFrame = 1;
        pInfo5.cls = ParticleEffect5;
        this.list[9005] = pInfo5;
        var pInfo9011 = new ParticleInfo();
        pInfo9011.effectId = 5001;
        pInfo9011.life = 40;
        pInfo9011.totalCount = 2;
        pInfo9011.createPerFrame = 1;
        pInfo9011.createDFrame = 16;
        pInfo9011.setRotate = true;
        pInfo9011.cls = ParticleEffect9011;
        this.list[9011] = pInfo9011;
        var pInfo9012 = new ParticleInfo();
        pInfo9012.effectId = 5004;
        pInfo9012.life = 100;
        pInfo9012.totalCount = 11;
        pInfo9012.createPerFrame = 1;
        pInfo9012.createDFrame = 4;
        pInfo9012.cls = ParticleEffect9012;
        this.list[9012] = pInfo9012;
        var pInfo9013 = new ParticleInfo();
        pInfo9013.effectId = 5002;
        pInfo9013.life = 65;
        pInfo9013.totalCount = 8;
        pInfo9013.createPerFrame = 1;
        pInfo9013.createDFrame = 4;
        pInfo9013.setDegree = true;
        pInfo9013.cls = ParticleEffect9013;
        this.list[9013] = pInfo9013;
        var pInfo9014 = new ParticleInfo();
        pInfo9014.effectId = 5003;
        pInfo9014.life = 100;
        pInfo9014.totalCount = 3;
        pInfo9014.createPerFrame = 1;
        pInfo9014.createDFrame = 20;
        pInfo9014.cls = ParticleEffect9014;
        this.list[9014] = pInfo9014;
        var pInfo9021 = new ParticleInfo();
        pInfo9021.effectId = 4001;
        pInfo9021.life = 40;
        pInfo9021.totalCount = 1;
        pInfo9021.createPerFrame = 1;
        pInfo9021.createDFrame = 1;
        pInfo9021.setRotate = true;
        pInfo9021.cls = ParticleEffect9021;
        this.list[9021] = pInfo9021;
        var pInfo9022 = new ParticleInfo();
        pInfo9022.effectId = 4002;
        pInfo9022.life = 65;
        pInfo9022.totalCount = 6;
        pInfo9022.createPerFrame = 1;
        pInfo9022.createDFrame = 4;
        pInfo9022.setDegree = true;
        pInfo9022.cls = ParticleEffect9022;
        this.list[9022] = pInfo9022;
        var pInfo9023 = new ParticleInfo();
        pInfo9023.effectId = 4004;
        pInfo9023.life = 100;
        pInfo9023.totalCount = 16;
        pInfo9023.createPerFrame = 1;
        pInfo9023.createDFrame = 4;
        pInfo9023.cls = ParticleEffect9012;
        this.list[9023] = pInfo9023;
        var pInfo9024 = new ParticleInfo();
        pInfo9024.effectId = 4004;
        pInfo9024.life = 80;
        pInfo9024.totalCount = 4;
        pInfo9024.createPerFrame = 1;
        pInfo9024.createDFrame = 11;
        pInfo9024.cls = ParticleEffect9024;
        this.list[9024] = pInfo9024;
        var pInfo9051 = new ParticleInfo();
        pInfo9051.effectId = 6001;
        pInfo9051.life = 40;
        pInfo9051.totalCount = 1;
        pInfo9051.createPerFrame = 1;
        pInfo9051.createDFrame = 1;
        pInfo9051.cls = BatchParticleEffect;
        this.list[9051] = pInfo9051;
        var pInfo9052 = new ParticleInfo();
        pInfo9052.effectId = 6002;
        pInfo9052.life = 80;
        pInfo9052.totalCount = 8;
        pInfo9052.createPerFrame = 1;
        pInfo9052.createDFrame = 4;
        pInfo9052.setDegree = true;
        pInfo9052.cls = ParticleEffect9022;
        this.list[9052] = pInfo9052;
        var pInfo9053 = new ParticleInfo();
        pInfo9053.effectId = 6003;
        pInfo9053.life = 40;
        pInfo9053.totalCount = 1;
        pInfo9053.createPerFrame = 1;
        pInfo9053.createDFrame = 1;
        pInfo9053.cls = ParticleEffect9053;
        this.list[9053] = pInfo9053;
        var pInfo9054 = new ParticleInfo();
        pInfo9054.effectId = 6004;
        pInfo9054.life = 100;
        pInfo9054.totalCount = 11;
        pInfo9054.createPerFrame = 1;
        pInfo9054.createDFrame = 4;
        pInfo9054.cls = ParticleEffect9012;
        this.list[9054] = pInfo9054;
        var pInfo9041 = new ParticleInfo();
        pInfo9041.effectId = 7001;
        pInfo9041.life = 40;
        pInfo9041.totalCount = 1;
        pInfo9041.createPerFrame = 1;
        pInfo9041.createDFrame = 1;
        pInfo9041.setRotate = true;
        pInfo9041.cls = ParticleEffect9041;
        this.list[9041] = pInfo9041;
        var pInfo9042 = new ParticleInfo();
        pInfo9042.effectId = 7002;
        pInfo9042.life = 65;
        pInfo9042.totalCount = 8;
        pInfo9042.createPerFrame = 1;
        pInfo9042.createDFrame = 4;
        pInfo9042.setDegree = true;
        pInfo9042.cls = ParticleEffect9042;
        this.list[9042] = pInfo9042;
        var pInfo9043 = new ParticleInfo();
        pInfo9043.effectId = 7003;
        pInfo9043.life = 65;
        pInfo9043.totalCount = 1;
        pInfo9043.createPerFrame = 1;
        pInfo9043.createDFrame = 4;
        pInfo9043.cls = BatchParticleEffect;
        this.list[9043] = pInfo9043;
        var pInfo9044 = new ParticleInfo();
        pInfo9044.effectId = 7004;
        pInfo9044.life = 65;
        pInfo9044.totalCount = 8;
        pInfo9044.createPerFrame = 8;
        pInfo9044.createDFrame = 4;
        pInfo9044.cls = ParticleEffect9044;
        this.list[9044] = pInfo9044;
        var pInfo9031 = new ParticleInfo();
        pInfo9031.effectId = 8001;
        pInfo9031.life = 90;
        pInfo9031.totalCount = 1;
        pInfo9031.createPerFrame = 1;
        pInfo9031.createDFrame = 1;
        pInfo9031.cls = ParticleEffect9031;
        this.list[9031] = pInfo9031;
        var pInfo9032 = new ParticleInfo();
        pInfo9032.effectId = 8002;
        pInfo9032.life = 150;
        pInfo9032.totalCount = 25;
        pInfo9032.createPerFrame = 1;
        pInfo9032.createDFrame = 4;
        pInfo9032.setDegree = true;
        pInfo9032.cls = ParticleEffect9032;
        this.list[9032] = pInfo9032;
        var pInfo9033 = new ParticleInfo();
        pInfo9033.effectId = 8003;
        pInfo9033.life = 40;
        pInfo9033.totalCount = 1;
        pInfo9033.createPerFrame = 1;
        pInfo9033.createDFrame = 1;
        pInfo9033.cls = BatchParticleEffect;
        this.list[9033] = pInfo9033;
        var pInfo9034 = new ParticleInfo();
        pInfo9034.effectId = 8004;
        pInfo9034.life = 200;
        pInfo9034.totalCount = 80;
        pInfo9034.createPerFrame = 5;
        pInfo9034.createDFrame = 1;
        pInfo9034.cls = ParticleEffect9034;
        this.list[9034] = pInfo9034;
        var pInfoFloower = new ParticleInfo();
        pInfoFloower.effectId = 125;
        pInfoFloower.effectId2 = 126;
        pInfoFloower.effectId3 = 127;
        pInfoFloower.life = 400;
        pInfoFloower.totalCount = 200;
        pInfoFloower.createPerFrame = 15;
        pInfoFloower.createDFrame = 10;
        pInfoFloower.cls = ParticleFloower;
        pInfoFloower.isScene = false;
        this.list["floower"] = pInfoFloower;
        var pInfoFloower2 = new ParticleInfo();
        pInfoFloower2.effectId = 128;
        pInfoFloower2.effectId2 = 129;
        pInfoFloower2.effectId3 = 130;
        pInfoFloower2.life = 400;
        pInfoFloower2.totalCount = 200;
        pInfoFloower2.createPerFrame = 15;
        pInfoFloower2.createDFrame = 10;
        pInfoFloower2.cls = ParticleFloower;
        pInfoFloower2.isScene = false;
        this.list["floower2"] = pInfoFloower2;
        var pInfo5310 = new ParticleInfo();
        pInfo5310.effectId = 30;
        pInfo5310.life = 120;
        pInfo5310.totalCount = 1;
        pInfo5310.createPerFrame = 1;
        pInfo5310.createDFrame = 1;
        pInfo5310.cls = ParticleEffect9999;
        pInfo5310.setDegree = true;
        this.list[9310] = pInfo5310;
        var pInfo5311 = new ParticleInfo();
        pInfo5311.effectId = 32;
        pInfo5311.life = 120;
        pInfo5311.totalCount = 1;
        pInfo5311.createPerFrame = 1;
        pInfo5311.createDFrame = 1;
        pInfo5311.cls = ParticleEffect9999;
        pInfo5311.setDegree = true;
        this.list[9311] = pInfo5311;
        var pInfo5312 = new ParticleInfo();
        pInfo5312.effectId = 34;
        pInfo5312.life = 120;
        pInfo5312.totalCount = 1;
        pInfo5312.createPerFrame = 1;
        pInfo5312.createDFrame = 1;
        pInfo5312.cls = ParticleEffect9999;
        pInfo5312.setDegree = true;
        this.list[9312] = pInfo5312;
        var pInfo9999 = new ParticleInfo();
        pInfo9999.effectId = 60005;
        pInfo9999.life = 40;
        pInfo9999.totalCount = 1;
        pInfo9999.createPerFrame = 1;
        pInfo9999.createDFrame = 1;
        pInfo9999.cls = ParticleEffect9999;
        pInfo9999.setDegree = true;
        this.list[9999] = pInfo9999
    },
});
var ParticleItemController = cc.Class.extend({
    _item: null,
    ____1074: 0,
    ____1075: 0,
    _currentAlpha: 255,
    _dAlpha: 0,
    _currentSpeedX: 0,
    _currentSpeedY: 0,
    _dSpeedX: 0,
    _dSpeedY: 0,
    _speedFrame: -1,
    _currentRotate: 0,
    _dRotate: 0,
    _currentScale: 1,
    _dScale: 0,
    _frameCount: 0,
    ____1329: 0,
    ____1330: 0,
    ____1312: 0,
    _lastRotate: 0,
    _lastScale: 1,
    isComplete: false,
    _effectId: 0,
    ctor: function(effectId, batchNode) {
        this._effectId = effectId;
        this._item = ____654.effectManager.create(this._effectId, false, null, false, null, null, ____655.____659.commonStaticType.source_neverClear);
        this._item.setCallback(this.playComplete, this);
        this._item.setContainer(batchNode);
        this._item.play();
        this.setPros()
    },
    playComplete: function() {
        this.isComplete = true
    },
    setValues: function(startX, startY, speedX, speedY, startAlpha, dAlpha, startRotate, dRotate, startScale, dScale) {
        startX = startX == null ? 0 : startX;
        startY = startY == null ? 0 : startY;
        speedX = speedX == null ? 0 : speedX;
        speedY = speedY == null ? 0 : speedY;
        startAlpha = startAlpha == null ? 255 : startAlpha;
        dAlpha = dAlpha == null ? 0 : dAlpha;
        startRotate = startRotate == null ? 0 : startRotate;
        dRotate = dRotate == null ? 0 : dRotate;
        startScale = startScale == null ? 1 : startScale;
        dScale = dScale == null ? 0 : dScale;
        this.____1074 = startX;
        this.____1075 = startY;
        this._currentSpeedX = speedX;
        this._currentSpeedY = speedY;
        this._currentAlpha = startAlpha;
        this._dAlpha = dAlpha;
        this._currentRotate = startRotate;
        this._dRotate = dRotate;
        this._currentScale = startScale;
        this._dScale = dScale
    },
    setScaleX: function(value) {
        this._item.setScaleX(value)
    },
    setScaleY: function(value) {
        this._item.setScaleY(value)
    },
    setAnchorPoint: function(p) {
        this._item.setAnchorPoint(p)
    },
    setSpeedFrame: function(value) {
        this._speedFrame = value
    },
    update: function() {
        this._frameCount++;
        if (this.isComplete == true) {} else {
            if (this._dSpeedX != 0) {
                this._currentSpeedX += this._dSpeedX
            }
            if (this._dSpeedY != 0) {
                this._currentSpeedY += this._dSpeedY
            }
            if (this._speedFrame > 0 && this._frameCount > this._speedFrame) {} else {
                if (this._currentSpeedX != 0) {
                    this.____1074 += this._currentSpeedX
                }
                if (this._currentSpeedY != 0) {
                    this.____1075 += this._currentSpeedY
                }
            }
            if (this._dAlpha != 0) {
                this._currentAlpha += this._dAlpha;
                if (this._currentAlpha < 0) this._currentAlpha = 0;
                else if (this._currentAlpha > 255) this._currentAlpha = 255
            }
            if (this._dRotate != 0) {
                this._currentRotate += this._dRotate
            }
            if (this._dScale != 0) {
                this._currentScale += this._dScale
            }
            this.setPros()
        }
    },
    setPros: function() {
        if (this.____1074 != this.____1329 || this.____1075 != this.____1330) {
            this._item.move(this.____1074, this.____1075);
            this.____1329 = this.____1074;
            this.____1330 = this.____1075
        }
        if (this._currentAlpha != this.____1312) {
            this._item.setAlpha(this._currentAlpha);
            this.____1312 = this._currentAlpha;
            if (this._currentAlpha <= 0) {
                this._item.removeFromContainer()
            }
        }
        if (this._currentScale != this._lastScale) {
            this._item.setScale(this._currentScale);
            this._lastScale = this._currentScale
        }
        if (this._currentRotate != this._lastRotate) {
            this._item.setRotate(-this._currentRotate);
            this._lastRotate = this._currentRotate
        }
    },
    dispose: function() {
        if (this._item != null) {
            this._item.dispose()
        }
        this._item = null
    },
});
var UIDataII = cc.Class.extend({
    className: null,
    name: null,
    designHeight: 0,
    designWidth: 0,
    widgetTree: null,
    ____289: function(data) {
        this.className = data.readString();
        this.name = data.readString();
        this.designHeight = data.readShort();
        this.designWidth = data.readShort();
        this.widgetTree = new WidgetChildrenII();
        this.widgetTree.____289(data)
    },
});
var WidgetChildrenII = cc.Class.extend({
    className: null,
    name: null,
    childrens: null,
    optionData: null,
    ____289: function(data) {
        this.className = data.readString();
        this.name = data.readString();
        this.childrens = [];
        var childrenLen = data.readUByte();
        for (var i = 0; i < childrenLen; i++) {
            var child = new WidgetChildrenII();
            child.____289(data);
            this.childrens.push(child)
        }
        this.optionData = this.____290(data, this.className);
        this.optionData.____289(data)
    },
    ____290: function(data, className) {
        switch (className) {
            case "Panel":
                return new OptionPanelDataII();
            case "ImageView":
            case "Button":
                return new OptionImageDataII();
            case "CCUIImageView":
                return new OptionCCUIImageDataII();
            case "CheckBox":
                return new OptionCheckBoxDataII();
            case "Label":
                return new OptionLabelDataII();
            case "ScrollView":
                return new OptionScrollViewDataII();
            case "TextField":
                return new OptionTextFieldDataII();
            case "ListView":
                return new OptionListViewDataII();
            case "TileContainer":
                return new OptionTileContainerDataII();
            case "LoadingBar":
                return new OptionLoadingBarDataII();
            case "LabelAtlas":
                return new OptionLabelAtlasDataII();
            default:
                return null
        }
        return null;
        return null
    },
});
var OptionDataII = cc.Class.extend({
    className: null,
    width: 0,
    height: 0,
    tag: 0,
    name: null,
    x: 0,
    y: 0,
    scaleX: 0,
    scaleY: 0,
    rotation: 0,
    visible: false,
    zorder: 0,
    opacity: 0,
    colorR: 0,
    colorG: 0,
    colorB: 0,
    anchorPointX: 0,
    anchorPointY: 0,
    ____289: function(data) {
        this.className = data.readString();
        this.width = data.readShort();
        this.height = data.readShort();
        this.tag = data.readInt();
        this.name = data.readString();
        this.x = data.readShort();
        this.y = data.readShort();
        this.scaleX = data.readTmpFloat();
        this.scaleY = data.readTmpFloat();
        this.rotation = data.readShort();
        this.visible = data.readBoolean();
        this.zorder = data.readShort();
        this.opacity = data.readShort();
        this.colorB = data.readShort();
        this.colorG = data.readShort();
        this.colorR = data.readShort();
        this.anchorPointX = data.readTmpFloat();
        this.anchorPointY = data.readTmpFloat()
    },
});
var OptionImageDataII = OptionDataII.extend({
    path: null,
    ____289: function(data) {
        this._super(data);
        this.path = data.readString()
    },
});
var OptionCCUIImageDataII = OptionDataII.extend({
    capInsetsHeight: 0,
    capInsetsWidth: 0,
    capInsetsX: 0,
    capInsetsY: 0,
    path: null,
    scale9Enable: true,
    scale9Height: 0,
    scale9Width: 0,
    ____289: function(data) {
        this._super(data);
        this.capInsetsHeight = data.readShort();
        this.capInsetsWidth = data.readShort();
        this.capInsetsX = data.readShort();
        this.capInsetsY = data.readShort();
        this.path = data.readString();
        this.scale9Enable = data.readBoolean();
        this.scale9Height = data.readShort();
        this.scale9Width = data.readShort()
    }
});
var OptionPanelDataII = OptionDataII.extend({});
var OptionLabelDataII = OptionDataII.extend({
    areaWidth: 0,
    areaHeight: 0,
    fontSize: 0,
    fontName: null,
    text: null,
    hAlignment: 0,
    vAlignment: 0,
    ____289: function(data) {
        this._super(data);
        this.areaWidth = data.readShort();
        this.areaHeight = data.readShort();
        this.fontSize = data.readByte();
        this.fontName = ____655.defaultFontName;
        this.hAlignment = data.readByte();
        this.vAlignment = data.readByte();
        this.text = data.readString()
    },
});
var OptionTextFieldDataII = OptionDataII.extend({
    areaWidth: 0,
    areaHeight: 0,
    fontName: null,
    text: null,
    fontSize: 0,
    maxLengthEnable: false,
    maxLength: 0,
    passwordEnable: false,
    passwordStyleText: null,
    placeHolder: null,
    ____289: function(data) {
        this._super(data);
        this.placeHolder = data.readString();
        this.areaWidth = data.readShort();
        this.areaHeight = data.readShort();
        this.fontName = ____655.defaultFontName;
        this.fontSize = data.readByte();
        this.text = data.readString();
        this.maxLengthEnable = data.readBoolean();
        this.maxLength = data.readShort();
        this.passwordEnable = data.readBoolean();
        this.passwordStyleText = data.readString()
    },
});
var OptionCheckBoxDataII = OptionDataII.extend({
    selectedState: false,
    selectPath: null,
    unselectPath: null,
    ____289: function(data) {
        this._super(data);
        this.selectedState = data.readBoolean();
        this.selectPath = data.readString();
        this.unselectPath = data.readString()
    },
});
var OptionScrollViewDataII = OptionDataII.extend({
    direction: 0,
    innerWidth: 0,
    innerHeight: 0,
    ____289: function(data) {
        this._super(data);
        this.direction = data.readByte();
        this.innerWidth = data.readShort();
        this.innerHeight = data.readShort()
    },
});
var OptionListViewDataII = OptionDataII.extend({
    direction: 0,
    ____289: function(data) {
        this._super(data);
        this.direction = data.readByte()
    },
});
var OptionTileContainerDataII = OptionDataII.extend({
    direction: 0,
    ____289: function(data) {
        this._super(data);
        this.direction = data.readByte()
    },
});
var OptionLoadingBarDataII = OptionDataII.extend({
    path: null,
    direction: 0,
    percent: 0,
    ____289: function(data) {
        this._super(data);
        this.path = data.readString();
        this.direction = data.readByte();
        this.percent = data.readUByte()
    },
});
var OptionLabelAtlasDataII = OptionDataII.extend({
    labelAtlasType: 0,
    ____289: function(data) {
        this._super(data);
        this.labelAtlasType = data.readByte()
    },
});
var UIDataListII = cc.Class.extend({
    _source: null,
    ____1163: null,
    ____1162: null,
    ____291: function(data) {
        this._source = new ByteArray();
        this._source.____284(data);
        this._source = ____654.____674.____182(this._source);
        this.____1163 = [];
        this.____1162 = [];
        var fileCount = this._source.readShort();
        print("文件数量", fileCount);
        for (var i = 0; i < fileCount; i++) {
            var path = this._source.readString();
            var len = this._source.readInt();
            print("路径", path, len);
            this.____1163[path] = this._source.getPosition();
            this._source.setPosition(this._source.getPosition() + len)
        }
    },
    isComplete: function() {
        return !!this._source
    },
    ____292: function(path) {
        if (this.____1162[path] != null) return this.____1162[path];
        var p = this.____1163[path];
        if (p == null) return null;
        this._source.setPosition(p);
        var file = new UIDataII();
        file.____289(this._source);
        this.____1162[path] = file;
        return file
    },
});
var KYCheckBox = KYButton.extend({
    ____1630: false,
    _selectPath: null,
    _unselectPath: null,
    _label: null,
    _imgSize: 40,
    _fontSize: 20,
    _clickTarget: null,
    _clickCB: null,
    ctor: function(selectPath, unselectPath, defaultSelect) {
        this._super();
        this.addListener(this, this.clickCB)
    },
    initUI: function(selectPath, unselectPath, defaultSelect) {
        this._selectPath = selectPath;
        this._unselectPath = unselectPath;
        this.____1630 = defaultSelect == null ? false : defaultSelect;
        this.updateImg();
        this._imgSize = this.getContentSize().width;
        this._label = ____654.____673.newKYLabel(this._fontSize, false);
        this._label.setAnchorPoint(cc.p(0, 0));
        this._label.setPosition(this._imgSize + 6, (this._imgSize - this._fontSize) / 2 - 3);
        this.addChild(this._label)
    },
    getMouseRect: function() {
        return ____654.____673.____161(this.getPositionX(), this.getPositionY(), this._label.width + this._imgSize + 6, this._imgSize)
    },
    setString: function(value) {
        this._label.setString(value)
    },
    setSelected: function(value) {
        if (this.____1630 == value) return;
        this.____1630 = value;
        this.updateImg()
    },
    getSelected: function() {
        return this.____1630
    },
    updateImg: function() {
        var p = this._selectPath;
        if (!this.____1630) {
            p = this._unselectPath
        }
        this.setFrame(p)
    },
    setStateCB: function(target, clickCB) {
        this._clickTarget = target;
        this._clickCB = clickCB
    },
    clickCB: function() {
        this.setSelected(!this.getSelected());
        if (this._clickCB != null) {
            this._clickCB.call(this._clickTarget, this)
        }
    },
    dispose: function() {
        if (this._label != null) {
            this._label.dispose();
            this._label = null
        }
        this._clickTarget = null;
        this._clickCB = null;
        this._super()
    },
});
var KYDrawNode = cc.DrawNode.extend({
    ctor: function() {
        this._super();
        this.retain()
    },
    dispose: function() {
        ____654.____673.release(this)
    },
});
var KYLabel = cc.LabelTTF.extend({
    _touchEnabled: false,
    _mouse: null,
    _enabled: true,
    ctor: function() {
        this._super();
        this.retain()
    },
    setTouchEnabled: function(value) {
        if (this._touchEnabled == value) return;
        this._touchEnabled = value
    },
    addTouchEventListener: function(target, handler) {
        if (this._touchEnabled) {
            this.addListener(target, handler)
        }
    },
    addListener: function(target, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove) {
        if (this._mouse == null) {
            this._mouse = new KYMouse(this, target, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove)
        }
    },
    setEnabled: function(value) {
        if (this._enabled == value) return;
        this._enabled = value;
        this.setVisible(value)
    },
    dispose: function() {
        if (this._mouse != null) {
            this._mouse.dispose();
            this._mouse = null
        }
        ____654.____673.release(this)
    },
});
var KYListView = KYScrollView.extend({
    _itemList: null,
    _margin: 0,
    _isRsetPosFlag: true,
    initUI: function(dir, size) {
        this._super(size);
        this.setScrollDir(dir);
        this._itemList = []
    },
    requestRefreshView: function() {
        ____654.____678.____298(this.refreshTick, this)
    },
    refreshTick: function(delta, count) {
        this.refreshView();
        ____654.____678.____299(this.refreshTick, this)
    },
    refreshView: function() {
        var len = this._itemList.length;
        var i = 0;
        var total = this._margin;
        if (this._scrollDir == ccui.ScrollView.DIR_VERTICAL) {
            for (i = len - 1; i >= 0; i--) {
                var height = this._itemList[i].getContentSize().height;
                this._itemList[i].setPositionY(total);
                total += (height + this._margin)
            }
            if (total < this._clippingNode.height) {
                this._contentSp.setPositionY(this._clippingNode.height - total)
            }
            this.setInnerSize(____654.____673.____160(this._clippingNode.width, total))
        } else {
            for (i = 0; i < len; i++) {
                var width = this._itemList[i].getContentSize().width;
                this._itemList[i].setPositionX(total);
                total += (width + this._margin)
            }
            if (total < this._clippingNode.width) {
                total = this._clippingNode.width
            }
            this.setInnerSize(____654.____673.____160(total, this._clippingNode.height))
        }
        if (this._isRsetPosFlag) {
            this.jumpToTop();
            this.jumpToLeft();
            this._isRsetPosFlag = false
        }
    },
    resetPos: function() {
        this._isRsetPosFlag = true;
        this.requestRefreshView()
    },
    pushBackItem: function(item) {
        this.addContent(item);
        this._itemList.push(item);
        this.requestRefreshView()
    },
    pushBackCustomItem: function(item) {
        this.pushBackItem(item)
    },
    insertCustomItem: function(item, index) {
        this.addContent(item);
        this._itemList.splice(index, 0, item);
        this.requestRefreshView()
    },
    setItemsMargin: function(margin) {
        if (this._margin == margin) {
            return
        }
        this._margin = margin;
        this.requestRefreshView()
    },
    getItemsMargin: function() {
        return this._margin
    },
    removeItem: function(index) {
        this._itemList[index].removeFromParent(false);
        this._itemList.splice(index, 1);
        this.requestRefreshView()
    },
    removeLastItem: function() {
        var item = this._itemList.pop();
        if (item != null) {
            item.removeFromParent(false)
        }
        this.requestRefreshView()
    },
    removeAllItems: function() {
        for (var i = 0; i < this._itemList.length; i++) {
            this._itemList[i].removeFromParent(false)
        }
        this._itemList = [];
        this.requestRefreshView()
    },
    getItem: function(index) {
        if (this._itemList.length <= index) {
            return null
        }
        return this._itemList[index]
    },
    getItems: function() {
        return this._itemList
    },
    dispose: function() {
        ____654.____678.____299(this.refreshTick, this);
        this._itemList = null;
        this._super()
    },
});
var KYMouse = cc.Class.extend({
    _mouseCaller: null,
    ____932: null,
    _clickCB: null,
    _downCB: null,
    _upCB: null,
    _moveCB: null,
    _downP: null,
    _hasDown: false,
    _isSwallow: true,
    _ignoreUpWhenMove: false,
    ctor: function(mouseCaller, cbTarget, clickCB, downCB, upCB, moveCB, isSwallow, ignoreUpWhenMove) {
        this._mouseCaller = mouseCaller;
        this.____932 = cbTarget;
        this._ignoreUpWhenMove = ignoreUpWhenMove == true;
        this._clickCB = clickCB;
        this._downCB = downCB;
        this._upCB = upCB;
        this._moveCB = moveCB;
        if (isSwallow != null) {
            this._isSwallow = isSwallow
        }
        this.addListener()
    },
    addListener: function() {
        if (this._clickCB != null || this._downCB != null || this._upCB != null || this._moveCB != null) {
            var this_ = this;
            touchListener = {
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: this._isSwallow
            };
            var touchBegan = function(touch, event) {
                if (this_._mouseCaller._isTouchEnabled == false) {
                    return false
                }
                this_._hasDown = false;
                this_._downP = cc.p(touch.getLocation().x, touch.getLocation().y);
                if (this_.hitOn(this_._downP)) {
                    if (this_._downCB != null) {
                        this_._downCB.call(this_.____932, this_._mouseCaller, ccui.Widget.TOUCH_BEGAN, this_._downP)
                    }
                    this_._hasDown = true;
                    return true
                }
                return false
            };
            touchListener.onTouchBegan = touchBegan;
            if (this._upCB != null || this._clickCB != null) {
                var touchEnded = function(touch, event) {
                    if (this_._downP == null) {
                        return
                    }
                    if (this_._mouseCaller._isTouchEnabled == false) {
                        return
                    }
                    var p = touch.getLocation();
                    if (this_._ignoreUpWhenMove) {
                        if (Math.abs(this_._downP.x - p.x) > 25 || Math.abs(this_._downP.y - p.y) > 25) {
                            return
                        }
                    }
                    if (this_.hitOn(p)) {
                        if (this_._upCB != null) {
                            this_._upCB.call(this_.____932, this_._mouseCaller, ccui.Widget.TOUCH_ENDED, p)
                        }
                        if (this_._hasDown) {
                            if (this_._clickCB != null) {
                                this_._clickCB.call(this_.____932, this_._mouseCaller, ccui.Widget.TOUCH_ENDED, p)
                            }
                        }
                    } else {
                        if (this_._upCB != null) {
                            this_._upCB.call(this_.____932, this_._mouseCaller, ccui.Widget.TOUCH_CANCELED, p)
                        }
                    }
                    this_._hasDown = false;
                    this_._downP = null
                };
                touchListener.onTouchEnded = touchEnded
            }
            if (this._moveCB != null) {
                var touchMove = function(touch, event) {
                    if (this_._mouseCaller._isTouchEnabled == false) {
                        return
                    }
                    if (this_._hasDown) {
                        if (this_._moveCB != null) {
                            this_._moveCB.call(this_.____932, this_._mouseCaller, ccui.Widget.TOUCH_CANCELED, touch.getLocation())
                        }
                    }
                };
                touchListener.onTouchMoved = touchMove
            }
            cc.eventManager.addListener(touchListener, this._mouseCaller)
        }
    },
    hitOn: function(p) {
        if (!this.showInScreen(p)) return false;
        return this.pointInRect(p)
    },
    showInScreen: function(pos) {
        if (this._mouseCaller.isVisible() == false) return false;
        var p = this._mouseCaller.getParent();
        while (p != null) {
            if (p.isVisible() == false) return false;
            if (p instanceof KYScrollView || p instanceof KYListView || p instanceof KYTileContainer) {
                if (!p.printInMouseRect(pos)) return false
            }
            p = p.getParent()
        }
        return true
    },
    pointInRect: function(p) {
        var t = this._mouseCaller.getNodeToWorldTransform();
        var size = null;
        if (this._mouseCaller.getMouseRect != null) size = this._mouseCaller.getMouseRect();
        else size = this._mouseCaller.getContentSize();
        var startX = t.tx;
        var startY = t.ty;
        var endX = startX + size.width * Math.abs(t.a);
        if (t.a < 0) {
            startX -= size.width;
            endX -= size.width
        }
        var endY = startY + size.height * Math.abs(t.d);
        if (t.d < 0) {
            startY -= size.height;
            endY -= size.height
        }
        if (p.x >= startX && p.x <= endX && p.y >= startY && p.y <= endY) {
            return true
        }
        return false
    },
    dispose: function() {
        this._mouseCaller = null;
        this.____932 = null;
        this._clickCB = null;
        this._downCB = null;
        this._upCB = null;
        this._moveCB = null
    },
});
var KYProgressBar = KYSprite.extend({
    _percent: 0,
    ____1112: 1,
    _fullScale: 1,
    ctor: function() {
        this._super();
        this.setAnchorPoint(____654.____673.anchorPoints[4])
    },
    initUI: function(path, dir, long) {
        this.setFrame(path);
        this.____1112 = dir;
        this._fullScale = long / this.getContentSize().width
    },
    ____206: function(dir) {
        this.____1112 = value
    },
    setPercent: function(value) {
        if (value < 0) {
            value = 0
        } else if (value > 100) {
            value = 100
        }
        this.setScaleX(value / 100 * this._fullScale)
    },
});
var KYScrollMoveController = cc.Class.extend({
    _scroll: null,
    _dPix: 0,
    _totalPix: 0,
    _addFlag: 1,
    _lastMoveTime: 0,
    _downP: null,
    _isCanScrollWhenLess: false,
    ctor: function(scroll) {
        this._scroll = scroll
    },
    setCanScrollWhenLess: function(value) {
        this._isCanScrollWhenLess = value
    },
    downHandler: function(p) {
        this._totalPix = 0;
        if (this._isCanScrollWhenLess == false) {
            if ((this._scroll.getScrollDir() == ccui.ScrollView.DIR_VERTICAL && this._scroll.getShowHeight() >= this._scroll.getInnerSize().height) || (this._scroll.getScrollDir() == ccui.ScrollView.DIR_HORIZONTAL && this._scroll.getShowWidth() >= this._scroll.getInnerSize().width)) {
                this._downP = null;
                return
            }
        }
        this._downP = p
    },
    ____358: function(p) {
        if (this._downP == null) return;
        var dx = p.x - this._downP.x;
        var dy = p.y - this._downP.y;
        this._scroll.moveDis(dx, dy);
        if (this._scroll.getScrollDir() == ccui.ScrollView.DIR_VERTICAL) {
            this._totalPix = dy
        } else {
            this._totalPix = p.x - this._downP.x
        }
        this._downP = p;
        this._lastMoveTime = ____655.____662.getSystemTime()
    },
    upHandler: function(p) {
        if (____655.____662.getSystemTime() - this._lastMoveTime > 60) return;
        this._totalPix *= 3;
        this._addFlag = this._totalPix > 0 ? 1 : -1;
        this._totalPix = Math.abs(this._totalPix);
        if (this._totalPix < 5) {} else {
            this._dPix = this._totalPix / 20;
            this.startRoll()
        }
        this._downP = null
    },
    rollEndTick: function(delta, count) {
        if (this._downP != null) {
            this.stopRoll();
            return
        }
        this._totalPix -= this._dPix;
        if (this._scroll.getScrollDir() == ccui.ScrollView.DIR_VERTICAL) {
            this._scroll.moveDis(0, this._totalPix * this._addFlag)
        } else {
            this._scroll.moveDis(this._totalPix * this._addFlag, 0)
        }
        if (this._totalPix <= this._dPix) {
            this.stopRoll()
        }
    },
    startRoll: function() {
        ____654.____678.____298(this.rollEndTick, this)
    },
    stopRoll: function() {
        ____654.____678.____299(this.rollEndTick, this)
    },
    dispose: function() {
        this.stopRoll();
        this._downP = null;
        this._scroll = null
    },
});
var KYScrollPageController = KYScrollMoveController.extend({
    _page: 0,
    _pageLong: 0,
    _stopPix: 0,
    _startP: null,
    ____1499: null,
    ctor: function(scroll) {
        this._super(scroll);
        this._dPix = 30
    },
    setPageLong: function(value) {
        this._pageLong = value
    },
    setPageView: function(pageView) {
        this.____1499 = pageView
    },
    downHandler: function(p) {
        if (this._isCanScrollWhenLess == false) {
            if ((this._scroll.getScrollDir() == ccui.ScrollView.DIR_VERTICAL && this._scroll.getShowHeight() >= this._scroll.getInnerSize().height) || (this._scroll.getScrollDir() == ccui.ScrollView.DIR_HORIZONTAL && this._scroll.getShowWidth() >= this._scroll.getInnerSize().width)) {
                this._downP = null;
                this._startP = null;
                return
            }
        }
        this._downP = p;
        this._startP = p
    },
    ____358: function(p) {
        if (this._downP == null) return;
        var dx = p.x - this._downP.x;
        var dy = p.y - this._downP.y;
        this._scroll.moveDis(dx, dy);
        this._downP = p
    },
    upHandler: function(p) {
        if (this._startP == null) return;
        if (this._scroll.getScrollDir() == ccui.ScrollView.DIR_VERTICAL) {} else {
            if (p.x < this._startP.x) {
                if (this._startP.x - p.x < 100) {
                    this.forceRollToPage(this._page)
                } else {
                    var totalPage = Math.ceil(this._scroll.getInnerSize().width / this._pageLong) - 1;
                    if (this._page >= totalPage) this.forceRollToPage(this._page);
                    else this.setPage(this._page + 1)
                }
            } else {
                if (p.x - this._startP.x < 100) {
                    this.forceRollToPage(this._page)
                } else {
                    if (this._page <= 0) this.forceRollToPage(this._page);
                    else this.setPage(this._page - 1)
                }
            }
        }
        this._startP = null;
        this._downP = null
    },
    setPage: function(page) {
        if (page == this._page) return;
        this._page = page;
        this._stopPix = -this._page * this._pageLong;
        this._tmpCount = 0;
        this.startRoll();
        if (this.____1499 != null) {
            this.____1499.setPage(page)
        }
    },
    forceRollToPage: function(page) {
        this._stopPix = -this._page * this._pageLong;
        this.startRoll();
        if (this.____1499 != null) {
            this.____1499.setPage(page)
        }
    },
    rollEndTick: function(delta, count) {
        if (this._downP != null) {
            this.stopRoll();
            return
        }
        if (this._scroll.getScrollDir() == ccui.ScrollView.DIR_VERTICAL) {} else {
            var currentPix = this._scroll.getContentSp().getPositionX();
            var dis = this._stopPix - currentPix;
            if (Math.abs(dis) < this._dPix) {
                this._scroll.moveDis(dis, 0);
                this.stopRoll()
            } else {
                if (dis > 0) this._scroll.moveDis(this._dPix, 0);
                else this._scroll.moveDis(-this._dPix, 0)
            }
        }
    },
    dispose: function() {
        this._super();
        this._startP = null;
        this.____1499 = null
    },
});
var KYTextField = ccui.TextField.extend({
    ctor: function() {
        this._super();
        this.retain()
    },
    dispose: function() {
        ____654.____673.release(this)
    },
});
var KYTileContainer = KYScrollView.extend({
    _itemList: null,
    ____1853: null,
    _executor: null,
    ____1188: null,
    ____1187: null,
    ____1607: 0,
    _count: 0,
    ____1289: null,
    ____1877: null,
    ____1255: 0,
    ____1256: 0,
    _paddingX: 0,
    _paddingY: 0,
    _tickCount: 5,
    ____1324: 0,
    ____1313: 0,
    ____1275: false,
    ctor: function() {
        this._super();
        this._itemList = {};
        this.____1853 = [];
        ____654.____678.____298(this.updateTick, this)
    },
    initUI: function(dir, size) {
        this._super(size);
        this.setScrollDir(dir)
    },
    setCallbacks: function(getItemCallBack, getIdCallBack, executor) {
        this.____1188 = getItemCallBack;
        this.____1187 = getIdCallBack;
        this._executor = executor
    },
    setFormat: function(rowCount, count, itemSize, intervalX, intervalY, isResetPos) {
        var pos = null;
        if (isResetPos != true) {
            pos = ____654.____673.____159(this._contentSp.getPositionX(), this._contentSp.getPositionY())
        }
        this.____1853 = [];
        this.____1877 = ____654.____673.____160(this._clippingNode.width, this._clippingNode.height);
        this.____1607 = rowCount;
        this._count = count;
        this.____1289 = itemSize;
        this.____1255 = intervalX == null ? 0 : intervalX;
        this.____1256 = intervalY == null ? 0 : intervalY;
        var row = Math.ceil(count / rowCount);
        if (this._scrollDir == ccui.ScrollView.DIR_HORIZONTAL) {
            this.setInnerSize(____654.____673.____160(Math.max(row * (this.____1289.width + this.____1255) + this.____1255, this.____1877.width), this.____1877.height));
            if (pos == null) {
                this.jumpToLeft()
            }
        } else {
            this.setInnerSize(____654.____673.____160(this.____1877.width, Math.max(row * (this.____1289.height + this.____1256) + this.____1256, this.____1877.height)));
            if (pos == null) {
                this.jumpToTop()
            }
        }
        if (this.getInnerSize().width > this.____1877.width || this.getInnerSize().height > this.____1877.height) {
            this.____1275 = true;
            if (pos != null) {
                if (pos.x < this.____1877.width - this.getInnerSize().width) {
                    pos.x = this.____1877.width - this.getInnerSize().width
                }
                if (pos.y < this.____1877.height - this.getInnerSize().height) {
                    pos.y = this.____1877.height - this.getInnerSize().height
                }
            }
        } else {
            this.____1275 = false;
            if (pos != null) {
                pos.x = 0;
                pos.y = 0
            }
        }
        if (pos != null) {
            this.moveDis(pos.x, pos.y)
        }
        this.refresh()
    },
    moveDis: function(x, y) {
        this._super(x, y);
        this.scroll()
    },
    setPadding: function(x, y) {
        this._paddingX = x;
        this._paddingY = y
    },
    refresh: function() {
        this.____1324 = 0;
        this.____1313 = 0;
        this._tickCount = -1;
        this.scroll()
    },
    scroll: function() {
        if (this._tickCount < 0) {
            this._tickCount = 5
        }
    },
    updateTick: function(delta, count) {
        if (this.____1289 == null) {
            return
        }
        this._tickCount--;
        if (this._tickCount == 0) {
            this.updateView()
        }
        if (this.____1853.length > 0) {
            var i = this.____1853.shift();
            item = this.createItemByIndex(i);
            if (item == null) {
                return
            }
            if (this._scrollDir == ccui.ScrollView.DIR_HORIZONTAL) {
                item.setPosition(____654.____673.____159(this.____1255 + Math.floor(i / this.____1607) * (this.____1289.width + this.____1255) + this._paddingX, this.____1256 + (this.____1607 - (i % this.____1607) - 1) * (this.____1289.height + this.____1256) + this._paddingY))
            } else {
                item.setPosition(____654.____673.____159(this.____1255 + (i % this.____1607) * (this.____1289.width + this.____1255) + this._paddingX, this.getInnerSize().height - (Math.floor(i / this.____1607 + 1) * (this.____1289.height + this.____1256)) + this._paddingY))
            }
            if (item.getParent() == null) {
                this._contentSp.addChild(item)
            }
        }
    },
    updateView: function() {
        var pos = this._contentSp.getPosition();
        var startIndex = 0;
        var endIndex = 0;
        if (this._scrollDir == ccui.ScrollView.DIR_HORIZONTAL) {
            startIndex = Math.floor((0 - pos.x) / (this.____1289.width + this.____1255)) * this.____1607;
            endIndex = Math.ceil((this.____1877.width - pos.x) / (this.____1289.width + this.____1255)) * this.____1607
        } else {
            startIndex = Math.floor((this.getInnerSize().height - (this.____1877.height - pos.y)) / (this.____1289.height + this.____1256)) * this.____1607;
            endIndex = Math.ceil(((this.getInnerSize().height + pos.y) / (this.____1289.height + this.____1256)) + 1) * this.____1607
        }
        if (startIndex < 0) {
            startIndex = 0
        }
        if (endIndex > this._count) {
            endIndex = this._count
        }
        if (this.____1324 == startIndex && this.____1313 == endIndex) {
            return
        }
        this.____1324 = startIndex;
        this.____1313 = endIndex;
        this.____1853 = [];
        for (var i = 0; i < this._count; i++) {
            if (i >= startIndex && i < endIndex) {
                this.____1853.push(i)
            } else {
                var item = this.getItemByIndex(i);
                if (item != null && item.getParent() != null) {
                    item.removeFromParent(false)
                }
            }
        }
    },
    createItemByIndex: function(index) {
        var id = this.____1187.call(this._executor, index);
        var item = this._itemList[id];
        if (item == null) {
            item = this.____1188.call(this._executor, index);
            this._itemList[id] = item
        }
        return item
    },
    getItemByIndex: function(index) {
        var id = this.____1187.call(this._executor, index);
        return this.getItemById(id)
    },
    getItemById: function(id) {
        return this._itemList[id]
    },
    removeItemById: function(id) {
        var item = this.getItemById(id);
        if (item != null) {
            item.dispose();
            this._itemList[id] = null;
            this.refresh()
        }
    },
    getCount: function() {
        return this._count
    },
    getRowCount: function() {
        return this.____1607
    },
    clearAllItems: function() {
        for (var i in this._itemList) {
            var item = this._itemList[i];
            if (item != null) {
                item.dispose()
            }
        }
        this._itemList = {};
        this.____1324 = 0;
        this.____1313 = 0
    },
    dispose: function() {
        ____654.____678.____299(this.updateTick, this);
        this.clearAllItems();
        this.____1853 = null;
        this._executor = null;
        this.____1188 = null;
        this.____1187 = null;
        this.____1289 = null;
        this.____1877 = null;
        this._super()
    },
});
var ____536 = cc.Class.extend({
    path: "",
    ____1355: 0,
    ____1709: 0,
    ____967: 0,
    ____931: null,
    state: 0,
    data: null,
    ctor: function(loaderType, path, clearType) {
        this.____1355 = loaderType;
        this.path = path;
        this.____967 = clearType;
        this.____931 = []
    },
    ____140: function() {
        var this_ = this;

        function getPlistCB() {
            if (____654.useTry()) {
                try {
                    cc.spriteFrameCache.addSpriteFrames(this_.____141());
                    this_.____105()
                } catch (e) {
                    ____654.doPrintError(e)
                }
            } else {
                cc.spriteFrameCache.addSpriteFrames(this_.____141());
                this_.____105()
            }
        }

        function getPicCB() {
            if (____654.useTry()) {
                try {
                    this_.____105()
                } catch (e) {
                    ____654.doPrintError(e)
                }
            } else {
                this_.____105()
            }
        }

        function getBinaryCB(nil, data) {
            if (____654.useTry()) {
                try {
                    this_.data = data;
                    this_.____105()
                } catch (e) {
                    ____654.doPrintError(e)
                }
            } else {
                this_.data = data;
                this_.____105()
            }
        }

        function getRemoteTextCB(error, data) {
            if (____654.useTry()) {
                try {
                    if (!!error) print("getRemoteTxt", error);
                    this_.data = data;
                    this_.____105()
                } catch (e) {
                    ____654.doPrintError(e)
                }
            } else {
                this_.data = data;
                this_.____105()
            }
        }
        if (this.____1355 == 1) {
            cc.loader.load([this.path, this.____141()], getPlistCB)
        } else if (this.____1355 == 2) {
            cc.loader.loadBinary(this.path, getBinaryCB)
        } else if (this.____1355 == 3) {
            cc.loader.loadTxtRemote(this.path, getRemoteTextCB)
        } else if (this.____1355 == 4) {
            cc.loader.load(this.path, getPicCB)
        } else {
            cc.loader.load(this.path, getPicCB)
        }
    },
    ____141: function() {
        return this.path.substring(0, this.path.length - 4) + ".plist"
    },
    ____105: function() {
        this.state = 2;
        var len = this.____931.length;
        for (var i = len - 1; i >= 0; i--) {
            if (this.____931[i][1] != null) {
                this.____931[i][1].call(this.____931[i][0], this)
            }
        }
    },
    addCallback: function(cb, quoteTarget) {
        var len = this.____931.length;
        var add = true;
        for (var i = 0; i < len; i++) {
            if (this.____931[i][0] == quoteTarget) {
                add = false;
                break
            }
        }
        if (add) {
            this.____931.push([quoteTarget, cb])
        }
        if (this.____931.length > 0) {
            this.____1709 = 10000000000000
        }
    },
    ____143: function(quoteTarget) {
        for (var i = this.____931.length - 1; i >= 0; i--) {
            if (this.____931[i][0] == quoteTarget) {
                this.____931.splice(i, 1);
                break
            }
        }
        if (this.____931.length == 0 && this.clearType != ____655.____659.commonStaticType.source_changeSceneAndOneM) {
            this.____1709 = ____655.____662.getSystemTime()
        }
    },
    ____144: function() {
        if (this.____967 == ____655.____659.commonStaticType.source_neverClear) {
            return false
        } else if (this.____931.length > 0) {
            return false
        } else if (this.____967 == ____655.____659.commonStaticType.source_clearImmedia) {
            return true
        } else {
            return ____655.____662.getSystemTime() - this.____1709 > 120000
        }
        return false
    },
    ____145: function() {
        if (this.____931.length == 0 && this.____967 == ____655.____659.commonStaticType.source_changeSceneAndOneM) {
            this.____1709 = ____655.____662.getSystemTime()
        }
    },
    dispose: function() {
        ____654.____673.releaseTexture(this.path);
        cc.loader.release(this.path);
        if (this.____1355 == 1) {
            var plistPath = this.____141();
            ____654.____673.releasePlist(plistPath);
            cc.loader.release(plistPath)
        }
        this.____931 = [];
        this.data = null
    },
});
var ____2392 = cc.Class.extend({
    ____1273: false,
    ____1506: null,
    ____1853: null,
    ____1608: null,
    ____1609: null,
    ____1059: null,
    _tickCount: 0,
    ctor: function(isRuntime) {
        this.____1273 = isRuntime;
        this.____1506 = {};
        this.____1853 = [];
        this.____1608 = {};
        this.____1609 = [];
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        this._tickCount++;
        if (this._tickCount % 2 != 0) return;
        var len = 0;
        var info = null;
        if (this.____1059 == null) {
            len = this.____1609.length;
            if (len > 0) {
                this.____1059 = this.____1609.shift();
                this.____1059.____140()
            }
        }
        len = this.____1853.length;
        if (len > 0) {
            info = this.____1853.shift();
            info.____140()
        }
        info = null;
        for (var o in this.____1506) {
            info = this.____1506[o];
            if (info != null && info.____144()) {
                info.dispose();
                delete this.____1506[o]
            }
        }
    },
    ____146: function(image, path, cb, clearType, tofront) {
        if (!!image) image.setWhenImageCB = true;
        else return;
        var tmpCB = function() {
            var doCB = false;
            if (image != null && image.setWhenImageCB == true) {
                doCB = true;
                if (image.loadTexture != null) {
                    image.loadTexture(path)
                } else if (image.loadTextureNormal != null) {
                    image.loadTextureNormal(path)
                } else if (image.initWithFile != null) {
                    image.initWithFile(path)
                }
            }
            if (doCB && cb != null) {
                cb()
            }
        };
        this.____142(0, path, tmpCB, image, clearType, tofront)
    },
    post: function(url, cb, data) {
        var xhr = cc.loader.getXMLHttpRequest(),
            errInfo = "load " + url + " failed!";
        url += (url.indexOf("?") > 0 ? "&" : "?") + Math.random();
        xhr.open("POST", url, true);
        xhr.setRequestHeader("Accept-Charset", "utf-8");
        xhr.onreadystatechange = function() {
            if (xhr.readyState === 4) xhr.status === 200 ? cb(null, xhr.responseText) : cb(errInfo)
        };
        xhr.send(this.formatPostData(data))
    },
    formatPostData: function(data) {
        if (!data) return "";
        if (typeof(data) == "string") {
            return data
        }
        ret = "";
        for (var key in data) {
            ret += "&{0}={1}".format(key, data[key])
        }
        if (ret.length > 0) {
            ret = ret.substr(1)
        }
        return ret
    },
    loadMusic: function(path, cb, quoteTarget, clearType, tofront) {
        this.____142(4, path, cb, quoteTarget, clearType, tofront)
    },
    loadRemoteTxt: function(path, cb, quoteTarget) {
        this.____142(3, path, cb, quoteTarget)
    },
    loadBinary: function(path, cb, quoteTarget, clearType, tofront) {
        this.____142(2, path, cb, quoteTarget, clearType, tofront)
    },
    ____147: function(path, cb, quoteTarget, clearType, tofront) {
        this.____142(1, path, cb, quoteTarget, clearType, tofront)
    },
    ____148: function(path, cb, quoteTarget, clearType, tofront) {
        this.____142(0, path, cb, quoteTarget, clearType, tofront)
    },
    ____142: function(loaderType, path, cb, quoteTarget, clearType, tofront) {
        if (loaderType != 3 && loaderType != 5 && quoteTarget == null) {
            throw new Error("加载未设置引用对象", path)
        }
        if (clearType == null) clearType = ____655.____659.commonStaticType.source_clearOneM;
        if (tofront == null) tofront = false;
        if (this.____1273) {
            this.loadRemote()
        } else {
            this.loadToMemory(loaderType, path, cb, quoteTarget, clearType, tofront)
        }
    },
    loadRemote: function(loaderType, path, cb, quoteTarget, clearType, tofront) {
        var cpkPath = ____655.____659.packPaths[path];
        if (!!cpkPath) {
            var cpkCache = this.runtimeCpkList[cpkPath];
            if (cpkCache == null) {
                cpkCache = new ____2393(cpkPath, this.runtimeCpkCB, this);
                this.____1608[cpkPath] = cpkCache
            }
            if (cpkCache.state == 2) {
                cpkCache.addCacheInfo(loaderType, path, cb, quoteTarget, clearType, tofront);
                this.loadToMemory(loaderType, path, cb, quoteTarget, clearType, tofront)
            } else {
                cpkCache.addCacheInfo(loaderType, path, cb, quoteTarget, clearType, tofront);
                if (!this.inCpkWaiting(cpkCache)) {
                    if (tofront) {
                        this.____1609.splice(0, 0, cpkCache)
                    } else {
                        this.____1609.push(cpkCache)
                    }
                }
            }
        }
    },
    inCpkWaiting: function(cpkCache) {
        var len = this.____1609.length;
        for (var i = 0; i < len; i++) {
            if (this.____1609[i] == cpkCache) return true
        }
        return false
    },
    runtimeCpkCB: function(cpkCache) {
        if (!!cpkCache && cpkCache.state == 2) {
            for (var i = cpkCache.cacheInfoList.length - 1; i >= 0; i--) {
                var info = cpkCache.cacheInfoList[i];
                this.loadToMemory(info[0], info[1], info[2], info[3], info[4], info[5])
            }
        }
        if (this.currentRuntime == cpkCache) {
            this.currentRuntime = null
        }
    },
    loadToMemory: function(loaderType, path, cb, quoteTarget, clearType, tofront) {
        if (this.____1506[path] == null) {
            this.____1506[path] = new ____536(loaderType, path, clearType)
        }
        var info = this.____1506[path];
        if (info.state == 0) {
            info.state = 1;
            info.addCallback(cb, quoteTarget);
            if (tofront) {
                this.____1853.splice(0, 0, info)
            } else {
                this.____1853.push(info)
            }
        } else if (info.state == 1) {
            info.addCallback(cb, quoteTarget)
        } else if (info.state == 2) {
            info.addCallback(cb, quoteTarget);
            if (cb != null) {
                cb.call(quoteTarget, info)
            }
        }
    },
    ____143: function(path, quoteTarget, img) {
        if (quoteTarget == null) {
            throw new Error("removeQuote没有引用对象", path)
        }
        var info = this.____1506[path];
        if (!!info) {
            info.____143(quoteTarget)
        }
        if (!!img) {
            img.setWhenImageCB = false
        }
        if (this.____1273) {
            var cpkPath = ____655.____659.packPaths[path];
            if (cpkPath != null) {
                var cpkCache = this.____1608[cpkPath];
                if (cpkCache != null) {
                    cpkCache.removeCacheInfoByQuoteTarget(quoteTarget);
                    this.removeCpkFromWaitingList(cpkCache)
                }
            }
        }
    },
    removeImageQuote: function(path, img) {
        this.____143(path, img, img)
    },
    removeBinaryQuote: function(path, quoteTarget) {
        this.____143(path, quoteTarget, null)
    },
    removePlistQuote: function(path, quoteTarget) {
        this.____143(path, quoteTarget, null)
    },
    removeCpkFromWaitingList: function(cpkCache) {
        if (cpkCache.cacheInfoList.length == 0) {
            for (var i = this.____1609.length - 1; i >= 0; i--) {
                if (this.____1609[i] == cpkCache) {
                    this.____1609.splice(i, 1);
                    break
                }
            }
        }
    },
});
var ____2393 = cc.Class.extend({
    cacheInfoList: null,
    state: 0,
    packageName: null,
    _cb: null,
    ____932: null,
    ctor: function(packageName, cb, cbTarget) {
        this.packageName = packageName;
        this._cb = cb;
        this.____932 = cbTarget;
        this.cacheInfoList = []
    },
    addCacheInfo: function(loaderType, path, cb, quoteTarget, clearType, tofront) {
        if (!this.inList(quoteTarget, path)) {
            this.cacheInfoList.push([loaderType, path, cb, quoteTarget, clearType, tofront])
        }
    },
    inList: function(quoteTarget, path) {
        for (var i = 0; i < this.cacheInfoList.length; i++) {
            if (this.cacheInfoList[i][3] == quoteTarget && this.cacheInfoList[i][0] == path) {
                return true
            }
        }
        return false
    },
    removeCacheInfoByQuoteTarget: function(quoteTarget) {
        for (var i = 0; i < this.cacheInfoList.length; i++) {
            if (this.cacheInfoList[i][3] == quoteTarget) {
                this.cacheInfoList.splice(i, 1);
                break
            }
        }
    },
    ____140: function() {
        var this_ = this;
        cc.loader.preload(this.packageName, function(info) {
            if (info.isCompleted || info.isFailed) {
                if (info.isCompleted) {
                    this_.state = 2
                } else {
                    this_.state = 3
                }
                this_._cb.call(this_.____932, this_)
            }
        }, this)
    },
});
var MessageManager = cc.Class.extend({
    socket: null,
    ____279: null,
    closeCallback: null,
    ____280: null,
    callbackTarget: null,
    ____1407: null,
    ____1261: false,
    ____1408: null,
    ____1115: false,
    ____1254: false,
    ctor: function() {
        this.____1407 = [];
        this.____1408 = []
    },
    setCallbacks: function(____279, closeCallback, ____280, target) {
        assert(target, "#setCallbacks:target cannot be undefined.");
        this.____279 = ____279;
        this.closeCallback = closeCallback;
        this.____280 = ____280;
        this.callbackTarget = target;
        ____654.____678.____298(this.tick, this)
    },
    setIsInSpecialPanel: function(value) {
        this.____1254 = value
    },
    connect: function(ip, host) {
        print("#connect", ip, host);
        try {
            var this_ = this;
            var WebSocket = WebSocket || window.WebSocket || window.MozWebSocket;
            if (!!this.socket) {
                this.socket.onclose = this.socket.onerror = this.socket.onmessage = this.socket.open = function() {}
            }
            this.socket = new WebSocket("ws://" + ip + ":" + host);
            this.socket.binaryType = "arraybuffer";
            this.socket.onopen = function() {
                print("socket open");
                this_.____1115 = true;
                this_.____1261 = true;
                if (this_.callbackTarget != null && this_.____279 != null) {
                    this_.____279.call(this_.callbackTarget)
                }
            };
            this.socket.onclose = function() {
                print("socket close", this_.____1115, this_.____1254);
                this_.____1408 = [];
                this_.____1261 = false;
                if (!this_.____1115 || this_.____1254) return;
                if (this_.callbackTarget != null && this_.closeCallback != null) {
                    this_.closeCallback.call(this_.callbackTarget)
                }
            };
            this.socket.onerror = function() {
                print("socket error");
                this_.____1408 = [];
                this_.____1261 = false;
                if (this_.callbackTarget != null && this_.____280 != null) {
                    this_.____280.call(this_.callbackTarget)
                }
            };
            this.socket.onmessage = function(msg) {
                var pkgIn = new ByteArray();
                pkgIn.____284(msg.data);
                this_.____295(pkgIn)
            }
        } catch (exception) {
            ____655.getAlert().show(1, "#########socket 异常!" + exception);
            throw new ERROR(exception)
        }
    },
    getMessageOut: function(messId) {
        if (____655.packageBUffIsUse) {
            print("ERROR:::协议容器正在使用###############");
            return
        }
        ____655.packageBUffIsUse = true;
        ____655.packageBuff.setPosition(0);
        ____655.packageBuff.writeShort(0);
        ____655.packageBuff.writeShort(messId);
        return ____655.packageBuff
    },
    ____295: function(pkgIn) {
        this.____1408.push(pkgIn)
    },
    tick: function(delta, count) {
        if (!this.isConnect()) return;
        var len = this.____1408.length;
        if (len == 0) return;
        for (var i = 0; i < len; i++) {
            var pkg = this.____1408[i];
            var p = pkg.getPosition();
            var totalLen = pkg.getLength();
            while (p < totalLen) {
                var plen = pkg.readShort();
                p = pkg.getPosition();
                var code = pkg.readShort();
                var handler = this.____1407[code];
                if (handler != null) {
                    handler(pkg)
                } else {
                    print("未处理协议", code)
                }
                p += plen;
                pkg.setPosition(p)
            }
        }
        this.____1408 = []
    },
    send: function(msg) {
        if (this.isConnect()) {
            var len = ____655.packageBuff.getPosition();
            var buff = new ByteArray(len);
            buff.____8(____655.packageBuff, 0, len);
            buff.setPosition(0);
            buff.writeShort(len - 2);
            this.socket.send(buff.getBuffer())
        }
        ____655.packageBUffIsUse = false
    },
    sendCode: function(code) {
        this.send(this.getMessageOut(code))
    },
    isConnect: function() {
        return this.socket != null && this.____1261
    },
    addSocketHandler: function(code, handler) {
        this.____1407[code] = handler
    },
    removeSocketHandler: function(code) {
        this.____1407[code] = null
    },
    chgHost2Ip: function(host) {
        return host
    },
    close: function() {
        if (!!this.socket) {
            this.callbackTarget = null;
            this.socket.close()
        }
    }
});
var MessageManagerNative = cc.Class.extend({
    socket: null,
    ____279: null,
    closeCallback: null,
    ____280: null,
    callbackTarget: null,
    ____1115: false,
    ____1254: false,
    ctor: function() {
        this.socket = jsb.MessageManager.createManager()
    },
    setCallbacks: function(____279, closeCallback, ____280, target) {
        this.____279 = ____279;
        this.closeCallback = closeCallback;
        this.____280 = ____280;
        this.callbackTarget = target
    },
    connect: function(ip, host) {
        ____654.____678.____298(this.tick, this);
        var this_ = this;

        function callback(xx, value) {
            if (value == 1) {
                this_.____1115 = true;
                if (this_.callbackTarget != null && this_.____279 != null) {
                    this_.____279.call(this_.callbackTarget)
                }
            } else {
                this_.____1115 = false;
                if (this_.callbackTarget != null && this_.____280 != null) {
                    this_.____280.call(this_.callbackTarget)
                }
            }
        }
        print("#connectNative", ip, host);
        this.socket.create(ip, host);
        this.socket.setCallback(callback)
    },
    setIsInSpecialPanel: function(value) {
        this.____1254 = value
    },
    tick: function(delta, count) {
        if (!this.____1115 || this.____1254) return;
        if (this.isConnect()) return;
        this.____1115 = false;
        if (this.callbackTarget != null && this.closeCallback != null) {
            this.closeCallback.call(this.callbackTarget)
        }
    },
    getMessageOut: function(messId) {
        return this.socket.getMessageOut(messId)
    },
    send: function(msg) {
        this.socket.send(msg)
    },
    sendCode: function(code) {
        this.send(this.getMessageOut(code))
    },
    isConnect: function() {
        return this.socket.isConnect()
    },
    addSocketHandler: function(code, handler) {
        function socketHandler(bytes) {
            try {
                if (____655.showProtocolNum) {
                    print("%%%%处理协议: " + code + "," + bytes.getLength() + " %%%%%%%")
                }
                handler(bytes)
            } catch (e) {
                ____654.doPrintError(e)
            }
        }
        if (____654.useTry()) {
            this.socket.addSocketHandler(code, socketHandler)
        } else {
            this.socket.addSocketHandler(code, handler)
        }
    },
    removeSocketHandler: function(code) {
        this.socket.removeSocketHandler(code)
    },
    getNodeCount: function() {
        if (!!this.socket && !!this.socket.getNodeCount) {
            return this.socket.getNodeCount()
        }
        return 0
    },
    chgHost2Ip: function(host) {
        print("#chgHost2Ip", !!this.socket, !!this.socket.getIPWithHost);
        if (!!this.socket && !!this.socket.getIPWithHost) {
            return this.socket.getIPWithHost(host)
        }
        return host
    },
    close: function() {
        this.socket.close()
    },
});
if (!!jsb.MessageOut) {
    var ccMessageOutWriteString = jsb.MessageOut.prototype.writeString;
    jsb.MessageOut.prototype.writeString = function(value) {
        if (!value) value = "";
        ccMessageOutWriteString.call(this, value)
    }
}
if (!!jsb.ByteArray) {
    jsb.ByteArray.prototype.readNumber = function() {
        var pre = this.readInt(),
            follow = this.readUInt(),
            val = pre * 4294967296 + follow;
        return val
    };
    jsb.ByteArray.prototype.writeNumber = function(value) {
        var val2 = value & 0xffffffff;
        if (val2 < 0) val2 = 4294967296 + val2;
        var val = (value - val2) / 4294967296;
        this.writeByte((val & 0xff000000) >> 24);
        this.writeByte((val & 0x00ff0000) >> 16);
        this.writeByte((val & 0x0000ff00) >> 8);
        this.writeByte(val & 0x000000ff);
        this.writeByte((val2 & 0xff000000) >> 24);
        this.writeByte((val2 & 0x00ff0000) >> 16);
        this.writeByte((val2 & 0x0000ff00) >> 8);
        this.writeByte(val2 & 0x000000ff)
    };
    jsb.ByteArray.prototype.writeInt = function(value) {
        this.writeByte((value & 0xff000000) >> 24);
        this.writeByte((value & 0x00ff0000) >> 16);
        this.writeByte((value & 0x0000ff00) >> 8);
        this.writeByte(value & 0x000000ff)
    }
};
var ____592 = cc.Class.extend({
    ____1772: null,
    ticks: null,
    showMemory: false,
    showMemoryTick: 0,
    ctor: function(gameLayer) {
        this.____1548 = 10;
        this.ticks = [];
        this.resetShowMemory();
        var this_ = this;

        function tick(delta) {
            if (____654.useTry()) {
                try {
                    this_.____300(delta)
                } catch (e) {
                    ____654.doPrintError(e);
                    this_.____1772.unschedule(tick)
                }
            } else {
                this_.____300(delta)
            }
        }
        this.____1772 = gameLayer;
        this.____1772.schedule(tick)
    },
    resetShowMemory: function(showValue) {
        if (showValue == undefined) {
            print("#cc.game.config", cc.game.config["showMemory"]);
            this.showMemory = !!cc.game.config["showMemory"]
        } else {
            this.showMemory = showValue
        }
    },
    ____296: function(callback, target) {
        assert(target, "#____296: target cannot be undefined.");
        var len = this.ticks.length;
        for (var i = 0; i < len; i++) {
            if (this.ticks[i].callback == callback && this.ticks[i].target == target) {
                return i
            }
        }
        return -1
    },
    ____297: function() {
        return this.ticks.length
    },
    ____298: function(callback, target) {
        if (!callback) {
            throw new Error("____298 error!!!")
        }
        var index = this.____296(callback, target);
        if (index == -1) {
            var qd = new ____480(callback, target);
            qd.flag = 1;
            this.ticks.push(qd)
        } else {
            this.ticks[index].flag = 1
        }
    },
    ____299: function(callback, target) {
        var index = this.____296(callback, target);
        if (index > -1) {
            this.ticks[index].flag = 0
        }
    },
    ____300: function(tmpTime) {
        var delta = tmpTime;
        var tickCount = 1;
        var len = this.ticks.length;
        for (var i = len - 1; i >= 0; i--) {
            var fd = this.ticks[i];
            if (fd != null) {
                if (fd.flag == 0) {
                    this.ticks.splice(i, 1)
                } else {
                    fd.callback.call(fd.target, delta, tickCount)
                }
            }
        }
        if (this.showMemory) {
            this.showMemoryTick--;
            if (this.showMemoryTick < 0) {
                this.showMemoryTick = 60;
                print("#showNodeCount:{0}, tickCount:{1}".format(showNodeCount, len))
            }
        }
    }
});
var ____593 = cc.Class.extend({
    MAXBITS: 15,
    MAXLCODES: 286,
    MAXDCODES: 30,
    MAXCODES: 0,
    FIXLCODES: 288,
    LENS: [3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31, 35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258],
    LEXT: [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0],
    DISTS: [1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193, 257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577],
    DEXT: [0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13],
    inbuf: null,
    incnt: 0,
    bitbuf: 0,
    bitcnt: 0,
    lencode: null,
    distcode: null,
    ctor: function() {
        this.MAXCODES = this.MAXLCODES + this.MAXDCODES
    },
    ____182: function(byteArr) {
        this.inbuf = byteArr.toArray();
        var buf = [];
        this.incnt = this.bitbuf = this.bitcnt = 0;
        var err = 0;
        do {
            var last = this.____301(1);
            var type = this.____301(2);
            if (type == 0) this.____304(buf);
            else if (type == 3) throw new Error('invalid block type (type == 3)');
            else {
                this.lencode = {
                    count: [],
                    symbol: []
                };
                this.distcode = {
                    count: [],
                    symbol: []
                };
                if (type == 1) this.____305();
                else if (type == 2) err = this.____306();
                if (err != 0) {
                    return err
                }
                err = this.____303(buf)
            }
            if (err != 0) break
        } while (!last);
        var result = new ByteArray();
        result.____284(buf);
        return result
    },
    ____301: function(need) {
        var val = this.bitbuf;
        while (this.bitcnt < need) {
            if (this.incnt == this.inbuf.length) throw new Error('available ____182 data did not terminate');
            val |= this.inbuf[this.incnt++] << this.bitcnt;
            this.bitcnt += 8
        }
        this.bitbuf = val >> need;
        this.bitcnt -= need;
        return val & ((1 << need) - 1)
    },
    construct: function(h, length, n) {
        var offs = [];
        for (var len = 0; len <= this.MAXBITS; len++) h.count[len] = 0;
        for (var symbol = 0; symbol < n; symbol++) h.count[length[symbol]]++;
        if (h.count[0] == n) return 0;
        var left = 1;
        for (var len = 1; len <= this.MAXBITS; len++) {
            left <<= 1;
            left -= h.count[len];
            if (left < 0) return left
        }
        offs[1] = 0;
        for (var len = 1; len < this.MAXBITS; len++) offs[len + 1] = offs[len] + h.count[len];
        for (symbol = 0; symbol < n; symbol++)
            if (length[symbol] != 0) h.symbol[offs[length[symbol]]++] = symbol;
        return left
    },
    ____302: function(h) {
        var code = 0,
            first = 0,
            index = 0;
        for (var len = 1; len <= this.MAXBITS; len++) {
            code |= this.____301(1);
            var count = h.count[len];
            if (code < first + count) return h.symbol[index + (code - first)];
            index += count;
            first += count;
            first <<= 1;
            code <<= 1
        }
        return -9
    },
    ____303: function(buf) {
        do {
            var symbol = this.____302(this.lencode);
            if (symbol < 0) return symbol;
            if (symbol < 256) buf[buf.length] = symbol;
            else if (symbol > 256) {
                symbol -= 257;
                if (symbol >= 29) throw new Error("invalid literal/length or distance code in fixed or dynamic block");
                var len = this.LENS[symbol] + this.____301(this.LEXT[symbol]);
                symbol = this.____302(this.distcode);
                if (symbol < 0) return symbol;
                var dist = this.DISTS[symbol] + this.____301(this.DEXT[symbol]);
                if (dist > buf.length) throw new Error("distance is too far back in fixed or dynamic block");
                while (len--) buf[buf.length] = buf[buf.length - dist]
            }
        } while (symbol != 256);
        return 0
    },
    ____304: function(buf) {
        this.bitbuf = 0;
        this.bitcnt = 0;
        if (this.incnt + 4 > this.inbuf.length) throw new Error('available ____182 data did not terminate');
        var len = this.inbuf[this.incnt++];
        len |= this.inbuf[this.incnt++] << 8;
        if (this.inbuf[this.incnt++] != (~len & 0xff) || this.inbuf[this.incnt++] != ((~len >> 8) & 0xff)) throw new Error("____304 block length did not match one's complement");
        if (this.incnt + len > this.inbuf.length) throw new Error('available ____182 data did not terminate');
        while (len--) buf[buf.length] = this.inbuf[this.incnt++]
    },
    ____305: function() {
        var lengths = [],
            symbol = 0;
        for (; symbol < 144; symbol++) lengths[symbol] = 8;
        for (; symbol < 256; symbol++) lengths[symbol] = 9;
        for (; symbol < 280; symbol++) lengths[symbol] = 7;
        for (; symbol < this.FIXLCODES; symbol++) lengths[symbol] = 8;
        this.construct(this.lencode, lengths, this.FIXLCODES);
        for (symbol = 0; symbol < this.MAXDCODES; symbol++) lengths[symbol] = 5;
        this.construct(this.distcode, lengths, this.MAXDCODES)
    },
    ____306: function() {
        var lengths = [],
            order = [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15],
            nlen = this.____301(5) + 257,
            ndist = this.____301(5) + 1,
            ncode = this.____301(4) + 4,
            index = 0;
        if (nlen > this.MAXLCODES || ndist > this.MAXDCODES) throw new Error("dynamic block code description: too many length or distance ____303");
        for (; index < ncode; index++) lengths[order[index]] = this.____301(3);
        for (; index < 19; index++) lengths[order[index]] = 0;
        var err = this.construct(this.lencode, lengths, 19);
        if (err != 0) throw new Error("dynamic block code description: code lengths ____303 incomplete");
        index = 0;
        while (index < nlen + ndist) {
            var symbol = 0,
                len = 0;
            symbol = this.____302(this.lencode);
            if (symbol < 16) lengths[index++] = symbol;
            else {
                len = 0;
                if (symbol == 16) {
                    if (index == 0) throw new Error("dynamic block code description: repeat lengths with no first length");
                    len = lengths[index - 1];
                    symbol = 3 + this.____301(2)
                } else if (symbol == 17) symbol = 3 + this.____301(3);
                else symbol = 11 + this.____301(7);
                if (index + symbol > nlen + ndist) throw new Error("dynamic block code description: repeat more than specified lengths");
                while (symbol--) lengths[index++] = len
            }
        }
        err = this.construct(this.lencode, lengths, nlen);
        if (err < 0 || (err > 0 && nlen - this.lencode.count[0] != 1)) throw new Error("dynamic block code description: invalid literal/length code lengths");
        err = this.construct(this.distcode, lengths.slice(nlen), ndist);
        if (err < 0 || (err > 0 && ndist - this.distcode.count[0] != 1)) throw new Error("dynamic block code description: invalid distance code lengths");
        return err
    }
});
var SoundManager = cc.Class.extend({
    _en: null,
    _soundDict: null,
    _musicDict: null,
    _isSoundMute: false,
    _isMusicMute: false,
    _currentMusic: 0,
    BTN: "Sound1001",
    PICKUP: "2001",
    DEFAULT: 0.2,
    ctor: function() {
        this._soundDict = {};
        this._musicDict = {};
        this._en = cc.audioEngine;
        this.setMusicVolume(this.DEFAULT)
    },
    playSound: function(id, loops, stopOther) {
        if (id == null) return;
        if (this._isSoundMute) return;
        if (loops == null) loops = false;
        if (stopOther == null) stopOther = false;
        if (stopOther) this.stopAllSound();
        if (this._soundDict[id] != null) {
            this.stopSound(id);
            this._soundDict[id] = null
        }
        var effectPath = ____654.____675.getMusicPath(id);
        var this_ = this;

        function effectCallback(path) {
            this_._soundDict[id] = this_._en.playEffect(effectPath, loops)
        }
        ____654.____677.loadMusic(effectPath, effectCallback, this, ____655.____659.commonStaticType.source_neverClear)
    },
    stopSound: function(id) {
        var mid = this._soundDict[id];
        if (mid != null) {
            this._en.stopEffect(mid)
        }
    },
    stopAllSound: function() {
        for (var i in this._soundDict) {
            if (this._soundDict[i] != null) {
                this.stopSound(i)
            }
        }
        this._soundDict = {}
    },
    setSoundVolume: function(value) {
        this._en.setEffectsVolume(value)
    },
    setSoundMute: function(value) {
        if (this._isSoundMute != value) {
            this._isSoundMute = value;
            if (value == true) {
                this.stopAllSound()
            }
        }
    },
    playMusic: function(id, force) {
        if (force == null) force = false;
        if (force != true && this._currentMusic == id) return;
        if (this._currentMusic != 0) {
            this.stopMusic()
        }
        this._currentMusic = id;
        if (id == 0) return;
        if (this._isMusicMute == true) return;
        var effectPath = ____654.____675.getMusicPath(id);
        var this_ = this;

        function effectCallback(loader) {
            var path = loader.path;
            if (____654.____675.getMusicPath(this_._currentMusic) == path) {
                this_._en.playMusic(path, true)
            }
        }
        ____654.____677.loadMusic(effectPath, effectCallback, this, ____655.____659.commonStaticType.source_neverClear)
    },
    stopMusic: function() {
        if (this._currentMusic != 0) {
            this._en.stopMusic(false)
        }
    },
    setMusicVolume: function(value) {
        this._en.setMusicVolume(value)
    },
    setMusicMute: function(value) {
        if (this._isMusicMute == value) return;
        this._isMusicMute = value;
        if (this._isMusicMute == true) {
            this.stopMusic()
        } else {
            if (this._currentMusic != 0) {
                this.playMusic(this._currentMusic, true)
            }
        }
    },
    updateBackgroundMusic: function() {
        var mapTemplateInfo = ____655.allTemplates.mapTemplateList.getMap(____655.currentMapId);
        if (!!mapTemplateInfo) {
            this.playMusic(mapTemplateInfo.music, true)
        }
    }
});
var UICreator = cc.Class.extend({
    uiPath: null,
    zeroSize: null,
    ctor: function(path) {
        this.uiPath = path;
        this.zeroSize = cc.size(0, 0)
    },
    create: function(data, uiContainer) {
        var uiArr = [];
        var uiNode = this.uiNodeFromJsonDictionary(data.widgetTree, uiContainer, uiArr);
        if (____654.____674.sizeEquals(uiNode.getContentSize(), this.zeroSize)) {
            uiNode.setContentSize(____654.____673.____160(data.designWidth, data.designHeight))
        }
        uiContainer.___uiClearList = uiArr;
        return uiNode
    },
    uiNodeFromJsonDictionary: function(data, uiContainer, uiArr, offsetX, offsetY) {
        offsetX = offsetX == null ? 0 : offsetX;
        offsetY = offsetY == null ? 0 : offsetY;
        var uiNode = null;
        if (uiContainer != null) uiNode = uiContainer;
        else {
            uiNode = this.createUI(data.className);
            uiArr.push(uiNode)
        }
        this.setPropsForAllUIFromJsonDictionary(data.className, uiNode, data.optionData, offsetX, offsetY);
        if (uiContainer != null) {
            offsetX = 0;
            offsetY = 0
        } else {
            offsetX = data.optionData.anchorPointX * data.optionData.width;
            offsetY = data.optionData.anchorPointY * data.optionData.height
        }
        var childrenCount = data.childrens.length;
        for (var i = 0; i < childrenCount; i++) {
            var child = this.uiNodeFromJsonDictionary(data.childrens[i], null, uiArr, offsetX, offsetY);
            if (child != null) {
                uiNode.addChild(child)
            }
        }
        return uiNode
    },
    createUI: function(className) {
        var uiNode = null;
        if (className == "Panel") {
            uiNode = cc.Node.create()
        } else if (className == "ImageView" || className == "Button") {
            uiNode = new KYSprite()
        } else if (className == "CCUIImageView") {
            uiNode = new KYImageView()
        } else if (className == "CheckBox") {
            uiNode = new KYCheckBox()
        } else if (className == "Label") {
            uiNode = new KYLabel()
        } else if (className == "ScrollView") {
            uiNode = new KYScrollView()
        } else if (className == "TextField") {
            uiNode = ccui.TextField.create()
        } else if (className == "ListView") {
            uiNode = new KYListView()
        } else if (className == "TileContainer") {
            uiNode = new KYTileContainer()
        } else if (className == "LoadingBar") {
            uiNode = new KYProgressBar()
        } else if (className == "LabelAtlas") {
            uiNode = new NumberView()
        }
        return uiNode
    },
    setPropsForAllUIFromJsonDictionary: function(className, uiNode, optionData, offsetX, offsetY) {
        if (className == "Panel") {
            this.____313(uiNode, optionData, offsetX, offsetY)
        } else if (className == "ImageView" || className == "Button") {
            this.setSpriteProps(uiNode, optionData, offsetX, offsetY)
        } else if (className == "CCUIImageView") {
            this.setKYImageViewProps(uiNode, optionData, offsetX, offsetY)
        } else if (className == "CheckBox") {
            this.____320(uiNode, optionData, offsetX, offsetY)
        } else if (className == "Label") {
            this.____315(uiNode, optionData, offsetX, offsetY)
        } else if (className == "ScrollView") {
            this.____321(uiNode, optionData, offsetX, offsetY)
        } else if (className == "TextField") {
            this.____324(uiNode, optionData, offsetX, offsetY)
        } else if (className == "ListView") {
            this.____322(uiNode, optionData, offsetX, offsetY)
        } else if (className == "TileContainer") {
            this.setTileContainerProps(uiNode, optionData, offsetX, offsetY)
        } else if (className == "LoadingBar") {
            this.setProgressBarProps(uiNode, optionData, offsetX, offsetY)
        } else if (className == "LabelAtlas") {
            this.____316(uiNode, optionData, offsetX, offsetY)
        }
    },
    ____311: function(uiNode, optionData, offsetX, offsetY) {
        uiNode.setContentSize(____654.____673.____160(optionData.width, optionData.height));
        uiNode.setTag(optionData.tag);
        uiNode.setName((optionData.name != "" && optionData.name != "null") ? optionData.name : "default");
        uiNode.setPosition(____654.____673.____159(optionData.x + offsetX, optionData.y + offsetY));
        uiNode.setScaleX(optionData.scaleX);
        uiNode.setScaleY(optionData.scaleY);
        uiNode.setRotation(optionData.rotation);
        uiNode.setVisible(optionData.visible);
        uiNode.setLocalZOrder(optionData.zorder)
    },
    ____312: function(uiNode, optionData) {
        uiNode.setOpacity(optionData.opacity);
        uiNode.setColor(cc.color(optionData.colorR, optionData.colorG, optionData.colorB));
        uiNode.setAnchorPoint(____654.____673.____159(optionData.anchorPointX, optionData.anchorPointY))
    },
    ____313: function(uiNode, optionData, offsetX, offsetY) {
        this.____311(uiNode, optionData, offsetX, offsetY);
        this.____312(uiNode, optionData)
    },
    setSpriteProps: function(uiNode, optionData, offsetX, offsetY) {
        uiNode.setTag(optionData.tag);
        uiNode.setName((optionData.name != "" && optionData.name != "null") ? optionData.name : "default");
        uiNode.setPosition(____654.____673.____159(optionData.x + offsetX, optionData.y + offsetY));
        uiNode.setScaleX(optionData.scaleX);
        uiNode.setScaleY(optionData.scaleY);
        uiNode.setRotation(optionData.rotation);
        uiNode.setVisible(optionData.visible);
        uiNode.setLocalZOrder(optionData.zorder);
        if (optionData.path != "" && optionData.path != "null") {
            uiNode.setFrame(optionData.path)
        }
        this.____312(uiNode, optionData)
    },
    setKYImageViewProps: function(uiNode, optionData, offsetX, offsetY) {
        this.____311(uiNode, optionData, offsetX, offsetY);
        if (optionData.path != "" && optionData.path != "null") uiNode.loadTexture(optionData.path, 1);
        uiNode.setScale9Enabled(optionData.scale9Enable);
        if (optionData.scale9Enable) {
            uiNode.setSize(cc.size(optionData.scale9Width, optionData.scale9Height));
            uiNode.setCapInsets(cc.rect(optionData.capInsetsX, optionData.capInsetsY, optionData.capInsetsWidth, optionData.capInsetsHeight))
        }
        this.____312(uiNode, optionData)
    },
    ____320: function(uiNode, optionData, offsetX, offsetY) {
        this.____311(uiNode, optionData, offsetX, offsetY);
        uiNode.initUI(optionData.unselectPath, optionData.selectPath, optionData.selectedState);
        this.____312(uiNode, optionData)
    },
    ____315: function(uiNode, optionData, offsetX, offsetY) {
        this.____311(uiNode, optionData, offsetX, offsetY);
        uiNode.setString(optionData.text);
        uiNode.setFontSize(optionData.fontSize);
        uiNode.setFontName(optionData.fontName);
        uiNode.setDimensions(____654.____673.____160(optionData.areaWidth, optionData.areaHeight));
        uiNode.setHorizontalAlignment(optionData.hAlignment);
        uiNode.setVerticalAlignment(optionData.vAlignment);
        this.____312(uiNode, optionData)
    },
    ____321: function(uiNode, optionData, offsetX, offsetY) {
        this.____311(uiNode, optionData, offsetX, offsetY);
        uiNode.initUI(cc.size(optionData.width, optionData.height));
        uiNode.setInnerSize(cc.size(optionData.innerWidth, optionData.innerHeight));
        uiNode.setScrollDir(optionData.direction);
        this.____312(uiNode, optionData)
    },
    ____324: function(uiNode, optionData, offsetX, offsetY) {
        this.____311(uiNode, optionData, offsetX, offsetY);
        uiNode.setDimensions(____654.____673.____160(optionData.areaWidth, optionData.areaHeight));
        uiNode.setPlaceHolder(optionData.placeHolder);
        uiNode.setString(optionData.text);
        uiNode.setFontSize(optionData.fontSize);
        uiNode.setFontName(optionData.fontName);
        uiNode.setMaxLengthEnabled(optionData.maxLengthEnable);
        if (optionData.maxLengthEnable) {
            uiNode.setMaxLength(optionData.maxLength)
        }
        uiNode.setPasswordEnabled(optionData.passwordEnable);
        if (optionData.passwordEnable) {
            uiNode.setPasswordStyleText(optionData.passwordStyleText)
        }
        this.____312(uiNode, optionData)
    },
    ____322: function(uiNode, optionData, offsetX, offsetY) {
        this.____311(uiNode, optionData, offsetX, offsetY);
        uiNode.initUI(optionData.direction, cc.size(optionData.width, optionData.height));
        this.____312(uiNode, optionData)
    },
    setTileContainerProps: function(uiNode, optionData, offsetX, offsetY) {
        this.____311(uiNode, optionData, offsetX, offsetY);
        uiNode.initUI(optionData.direction, cc.size(optionData.width, optionData.height));
        this.____312(uiNode, optionData)
    },
    setProgressBarProps: function(uiNode, optionData, offsetX, offsetY) {
        uiNode.setContentSize(____654.____673.____160(optionData.width, optionData.height));
        uiNode.setTag(optionData.tag);
        uiNode.setName((optionData.name != "" && optionData.name != "null") ? optionData.name : "default");
        uiNode.setPosition(____654.____673.____159(optionData.x + offsetX, optionData.y + offsetY));
        uiNode.setScaleY(optionData.scaleY);
        uiNode.setRotation(optionData.rotation);
        uiNode.setVisible(optionData.visible);
        uiNode.setLocalZOrder(optionData.zorder);
        var long = optionData.width;
        uiNode.initUI(optionData.path, optionData.direction, long);
        uiNode.setPercent(optionData.percent);
        uiNode.setOpacity(optionData.opacity);
        uiNode.setColor(cc.color(optionData.colorR, optionData.colorG, optionData.colorB));
        var rotateOffsetX = 0;
        var rotateOffsetY = 0;
        if (optionData.rotation == 0) rotateOffsetX = -optionData.width / 2;
        else if (optionData.rotation == 180) rotateOffsetX = optionData.width / 2;
        else if (optionData.rotation == 90) rotateOffsetY = optionData.width / 2;
        else if (optionData.rotation == 270) rotateOffsetY = -optionData.width / 2;
        uiNode.setPosition(____654.____673.____159(optionData.x + offsetX + rotateOffsetX, optionData.y + offsetY + rotateOffsetY))
    },
    ____316: function(uiNode, optionData, offsetX, offsetY) {
        uiNode.setTag(optionData.tag);
        uiNode.setName((optionData.name != "" && optionData.name != "null") ? optionData.name : "default");
        uiNode.setPosition(____654.____673.____159(optionData.x + offsetX, optionData.y + offsetY));
        uiNode.setScaleX(optionData.scaleX);
        uiNode.setScaleY(optionData.scaleY);
        uiNode.setRotation(optionData.rotation);
        uiNode.setVisible(optionData.visible);
        uiNode.setLocalZOrder(optionData.zorder);
        uiNode.setType(optionData.labelAtlasType);
        this.____312(uiNode, optionData)
    },
});
var ____595 = cc.Class.extend({
    uiPath: null,
    zeroSize: null,
    hasLoadTexture: false,
    ctor: function(path) {
        this.uiPath = path;
        this.zeroSize = cc.size(0, 0)
    },
    create: function(data, widgetContainer, batchContainer1, batchContainer2) {
        var widget = this.____308(data.widgetTree, widgetContainer, batchContainer1, batchContainer2);
        if (cc.sizeEqualToSize(widget.getContentSize(), this.zeroSize)) {
            widget.setSize(cc.size(data.designWidth, data.designHeight))
        }
        return widget
    },
    ____308: function(data, widgetContainer, batchContainer1, batchContainer2) {
        var widget = null;
        if (!!widgetContainer) widget = widgetContainer;
        else widget = this.____309(data.className);
        this.____310(data.className, widget, data.optionData);
        var childrenCount = data.childrens.length;
        for (var i = 0; i < childrenCount; i++) {
            var child = this.____308(data.childrens[i], null, batchContainer1, batchContainer2);
            if (child != null) {
                if (data.className == "____2145") {
                    widget.addPage(child)
                } else {
                    if (data.className == "ListView") {
                        widget.pushBackCustomItem(child)
                    } else {
                        if (!(widget instanceof ccui.Layout)) {
                            if (child.getPositionType() === ccui.Widget.POSITION_PERCENT) {
                                var position = child.getPositionPercent();
                                var anchor = widget.getAnchorPoint();
                                child.setPositionPercent(cc.p(position.x + anchor.x, position.y + anchor.y))
                            }
                            var AnchorPointIn = widget.getAnchorPointInPoints();
                            child.setPosition(cc.p(child.getPositionX() + AnchorPointIn.x, child.getPositionY() + AnchorPointIn.y))
                        }
                        widget.addChild(child)
                    }
                }
            }
        }
        return widget
    },
    ____309: function(name) {
        var widget = null;
        if (name == "Panel") {
            widget = ccui.Layout.create()
        } else if (name == "TextArea" || name == "Label") {
            widget = ccui.Text.create()
        } else if (name == "TextButton" || name == "Button") {
            widget = ccui.Button.create()
        } else if (name == "LabelAtlas") {
            widget = ccui.TextAtlas.create()
        } else if (name == "LabelBMFont") {
            widget = ccui.TextBMFont.create()
        } else if (name == "____2145") {
            widget = ccui.____2145.create()
        } else if (name == "ImageView") {
            widget = ccui.ImageView.create()
        } else if (name == "CheckBox") {
            widget = ccui.CheckBox.create()
        } else if (name == "ListView") {
            widget = ccui.ListView.create()
        } else if (name == "LoadingBar") {
            widget = ccui.LoadingBar.create()
        } else if (name == "ScrollView") {
            widget = ccui.ScrollView.create()
        } else if (name == "Slider") {
            widget = ccui.Slider.create()
        } else if (name == "TextField") {
            widget = ccui.TextField.create()
        }
        return widget
    },
    ____310: function(className, widget, optionData) {
        if (className == "Panel") {
            this.____313(widget, optionData)
        } else if (className == "Label") {
            this.____315(widget, optionData)
        } else if (className == "Button") {
            this.____314(widget, optionData)
        } else if (className == "LabelAtlas") {
            this.____316(widget, optionData)
        } else if (className == "LabelBMFont") {
            this.____317(widget, optionData)
        } else if (className == "____2145") {
            this.____318(widget, optionData)
        } else if (className == "ImageView") {
            this.____319(widget, optionData)
        } else if (className == "CheckBox") {
            this.____320(widget, optionData)
        } else if (className == "ListView") {
            this.____322(widget, optionData)
        } else if (className == "LoadingBar") {
            this.____323(widget, optionData)
        } else if (className == "ScrollView") {
            this.____321(widget, optionData)
        } else if (className == "Slider") {
            print("error parse slider")
        } else if (className == "TextField") {
            this.____324(widget, optionData)
        }
    },
    ____311: function(widget, optionData) {
        widget.ignoreContentAdaptWithSize(optionData.ignoreSize);
        widget.setSizeType(optionData.sizeType);
        widget.setPositionType(optionData.positionType);
        widget.setSizePercent(____654.____673.____159(optionData.sizePercentX, optionData.sizePercentY));
        widget.setPositionPercent(____654.____673.____159(optionData.positionPercentX, optionData.positionPercentY));
        var w = 0;
        var h = 0;
        if (optionData.adaptScreen) {
            w = ____655.____656;
            h = ____655.____657
        } else {
            w = optionData.width;
            h = optionData.height
        }
        widget.setContentSize(____654.____673.____160(w, h));
        widget.setTag(optionData.tag);
        widget.setActionTag(optionData.actionTag);
        if (optionData.touchAble == true) widget.setTouchEnabled(optionData.touchAble);
        var name = optionData.name;
        widget.setName((optionData.name != "" && optionData.name != "null") ? optionData.name : "default");
        widget.setPosition(____654.____673.____159(optionData.x, optionData.y));
        widget.setScaleX(optionData.scaleX);
        widget.setScaleY(optionData.scaleY);
        widget.setRotation(optionData.rotation);
        widget.setVisible(optionData.visible);
        widget.setLocalZOrder(optionData.zorder)
    },
    ____312: function(widget, optionData) {
        widget.setOpacity(optionData.opacity);
        widget.setColor(cc.color(optionData.colorR, optionData.colorG, optionData.colorB));
        widget.setAnchorPoint(____654.____673.____159(optionData.anchorPointX, optionData.anchorPointY));
        widget.setFlippedX(optionData.flipX);
        widget.setFlippedY(optionData.flipY)
    },
    ____313: function(widget, optionData) {
        this.____311(widget, optionData);
        widget.setClippingEnabled(optionData.clipAble);
        var backGroundScale9Enable = optionData.backGroundScale9Enable;
        widget.setBackGroundImageScale9Enabled(backGroundScale9Enable);
        widget.setBackGroundColorVector(____654.____673.____159(optionData.vectorX, optionData.vectorY));
        widget.setBackGroundColorType(optionData.____688);
        widget.setBackGroundColor(cc.color(optionData.bgStartColorR, optionData.bgStartColorG, optionData.bgStartColorB), cc.color(optionData.bgEndColorR, optionData.bgEndColorG, optionData.bgEndColorB));
        widget.setBackGroundColor(cc.color(optionData.bgColorR, optionData.bgColorG, optionData.bgColorB));
        widget.setBackGroundColorOpacity(optionData.bgColorOpacity);
        if (backGroundScale9Enable) {
            widget.setBackGroundImageCapInsets(cc.rect(optionData.capInsetsX, optionData.capInsetsY, optionData.capInsetsWidth, optionData.capInsetsHeight))
        }
        widget.setLayoutType(optionData.layoutType);
        this.____312(widget, optionData)
    },
    ____314: function(widget, optionData) {
        this.____311(widget, optionData);
        widget.setScale9Enabled(optionData.scale9Enable);
        if (optionData.normalData.path != "null") {
            switch (optionData.normalData.resourceType) {
                case 0:
                    var normalFileName = optionData.normalData.path;
                    var normalFileName_tp = normalFileName != "null" ? this.uiPath + normalFileName : "";
                    widget.loadTextureNormal(normalFileName_tp);
                    break;
                case 1:
                    widget.loadTextureNormal(optionData.normalData.path, 1);
                    break
            }
        }
        if (optionData.pressedData.path != "null") {
            switch (optionData.pressedData.resourceType) {
                case 0:
                    var pressedFileName = optionData.pressedData.path;
                    var pressedFileName_tp = pressedFileName != "null" ? this.uiPath + pressedFileName : "";
                    widget.loadTexturePressed(pressedFileName_tp);
                    break;
                case 1:
                    widget.loadTexturePressed(optionData.pressedData.path, 1);
                    break
            }
        }
        if (optionData.disableData.path != "null") {
            switch (optionData.disableData.resourceType) {
                case 0:
                    var disabledFileName = optionData.disableData.path;
                    var disabledFileName_tp = disabledFileName != "null" ? this.uiPath + disabledFileName : "";
                    widget.loadTextureDisabled(disabledFileName_tp);
                    break;
                case 1:
                    widget.loadTextureDisabled(optionData.disableData.path, 1);
                    break
            }
        }
        if (optionData.scale9Enable) {
            widget.setCapInsets(cc.rect(optionData.capInsetsX, optionData.capInsetsY, optionData.capInsetsWidth, optionData.capInsetsHeight));
            widget.setSize(cc.size(optionData.scale9Width, optionData.scale9Height))
        }
        widget.setTitleText(optionData.text);
        widget.setTitleColor(cc.color(optionData.textColorR, optionData.textColorG, optionData.textColorB));
        widget.setTitleFontSize(optionData.fontSize);
        widget.setTitleFontName(optionData.fontName);
        this.____312(widget, optionData)
    },
    ____315: function(widget, optionData) {
        this.____311(widget, optionData);
        widget.setTouchScaleChangeEnabled(optionData.touchScaleEnable);
        widget.setString(optionData.text);
        widget.setFontSize(optionData.fontSize);
        widget.setFontName(optionData.fontName);
        widget.setTextAreaSize(cc.size(optionData.areaWidth, optionData.areaHeight));
        widget.setTextHorizontalAlignment(optionData.hAlignment);
        widget.setTextVerticalAlignment(optionData.vAlignment);
        this.____312(widget, optionData)
    },
    ____316: function(widget, optionData) {
        this.____311(widget, optionData);
        switch (optionData.charMapFileData.resourceType) {
            case 0:
                widget.setProperty(optionData.stringValue, this.uiPath + optionData.charMapFileData.path, optionData.itemWidth, optionData.itemHeight, optionData.startCharMap);
                break;
            case 1:
                print("Wrong res type of LabelAtlas!");
                break
        }
        this.____312(widget, optionData)
    },
    ____317: function(widget, optionData) {
        this.____311(widget, optionData);
        switch (optionData.fileNameData.resourceType) {
            case 0:
                widget.setFntFile("res/GameUI/" + optionData.fileNameData.path);
                break;
            case 1:
                print("Wrong res type of LabelAtlas!");
                break
        }
        widget.setString(optionData.text);
        this.____312(widget, optionData)
    },
    ____318: function(widget, optionData) {
        this.____313(widget, optionData)
    },
    ____319: function(widget, optionData) {
        this.____311(widget, optionData);
        var imageFileName = optionData.fileNameData.path;
        if (imageFileName != "null") {
            switch (optionData.fileNameData.resourceType) {
                case 0:
                    widget.loadTexture(this.uiPath + imageFileName);
                    break;
                case 1:
                    widget.loadTexture(imageFileName, 1);
                    break
            }
        }
        widget.setScale9Enabled(optionData.scale9Enable);
        if (optionData.scale9Enable) {
            widget.setSize(cc.size(optionData.scale9Width, optionData.scale9Height));
            widget.setCapInsets(cc.rect(optionData.capInsetsX, optionData.capInsetsY, optionData.capInsetsWidth, optionData.capInsetsHeight))
        }
        this.____312(widget, optionData)
    },
    ____320: function(widget, optionData) {
        this.____311(widget, optionData);
        if (optionData.backGroundBoxData.path != "null") {
            switch (optionData.backGroundBoxData.resourceType) {
                case 0:
                    var backGroundFileName = optionData.backGroundBoxData.path;
                    var backGroundFileName_tp = backGroundFileName != "null" ? this.uiPath + backGroundFileName : "";
                    widget.loadTextureBackGround(backGroundFileName_tp);
                    break;
                case 1:
                    widget.loadTextureBackGround(optionData.backGroundBoxData.path, 1);
                    break
            }
        }
        if (optionData.backGroundBoxSelectedData.path) {
            switch (optionData.backGroundBoxSelectedData.resourceType) {
                case 0:
                    var backGroundSelectedFileName = optionData.backGroundBoxSelectedData.path;
                    var backGroundSelectedFileName_tp = backGroundSelectedFileName != "null" ? this.uiPath + backGroundSelectedFileName : "";
                    widget.loadTextureBackGroundSelected(backGroundSelectedFileName_tp);
                    break;
                case 1:
                    widget.loadTextureBackGroundSelected(optionData.backGroundBoxSelectedData.path, 1);
                    break
            }
        }
        if (optionData.frontCrossData.path) {
            switch (optionData.frontCrossData.resourceType) {
                case 0:
                    var frontCrossFileName = optionData.frontCrossData.path;
                    var frontCrossFileName_tp = frontCrossFileName != "null" ? this.uiPath + frontCrossFileName : "";
                    widget.loadTextureFrontCross(frontCrossFileName_tp);
                    break;
                case 1:
                    widget.loadTextureFrontCross(optionData.frontCrossData.path, 1);
                    break
            }
        }
        if (optionData.backGroundBoxDisabledData.path) {
            switch (optionData.backGroundBoxDisabledData.resourceType) {
                case 0:
                    var backGroundDisabledFileName = optionData.backGroundBoxDisabledData.path;
                    var backGroundDisabledFileName_tp = backGroundDisabledFileName != "null" ? this.uiPath + backGroundDisabledFileName : "";
                    widget.loadTextureBackGroundDisabled(backGroundDisabledFileName_tp);
                    break;
                case 1:
                    widget.loadTextureBackGroundDisabled(optionData.backGroundBoxDisabledData.path, 1);
                    break
            }
        }
        if (optionData.frontCrossDisabledData.path) {
            switch (optionData.frontCrossDisabledData.resourceType) {
                case 0:
                    var frontCrossDisabledFileName = optionData.frontCrossDisabledData.path;
                    var frontCrossDisabledFileName_tp = frontCrossDisabledFileName != "null" ? this.uiPath + frontCrossDisabledFileName : "";
                    widget.loadTextureFrontCrossDisabled(frontCrossDisabledFileName_tp);
                    break;
                case 1:
                    widget.loadTextureFrontCrossDisabled(optionData.frontCrossDisabledData.path, 1);
                    break
            }
        }
        this.____312(widget, optionData)
    },
    ____321: function(widget, optionData) {
        this.____311(widget, optionData);
        widget.setBackGroundImageScale9Enabled(optionData.backGroundScale9Enable);
        widget.setBackGroundColorVector(____654.____673.____159(optionData.vectorX, optionData.vectorY));
        widget.setBackGroundColorType(optionData.____688);
        widget.setBackGroundColor(cc.color(optionData.bgStartColorR, optionData.bgStartColorG, optionData.bgStartColorB), cc.color(optionData.bgEndColorR, optionData.bgEndColorG, optionData.bgEndColorB));
        widget.setBackGroundColor(cc.color(optionData.bgColorR, optionData.bgColorG, optionData.bgColorB));
        widget.setBackGroundColorOpacity(optionData.bgColorOpacity);
        if (optionData.backGroundScale9Enable) {
            widget.setBackGroundImageCapInsets(cc.rect(optionData.capInsetsX, optionData.capInsetsY, optionData.capInsetsWidth, optionData.capInsetsHeight))
        }
        widget.setLayoutType(optionData.layoutType);
        widget.setInnerContainerSize(cc.size(optionData.innerWidth, optionData.innerHeight));
        widget.setDirection(optionData.direction);
        widget.setBounceEnabled(optionData.bounceEnable);
        this.____312(widget, optionData)
    },
    ____322: function(widget, optionData) {
        this.____311(widget, optionData);
        widget.setBackGroundImageScale9Enabled(optionData.backGroundScale9Enable);
        widget.setBackGroundColorVector(____654.____673.____159(optionData.vectorX, optionData.vectorY));
        widget.setBackGroundColorType(optionData.____688);
        widget.setBackGroundColor(cc.color(optionData.bgStartColorR, optionData.bgStartColorG, optionData.bgStartColorB), cc.color(optionData.bgEndColorR, optionData.bgEndColorG, optionData.bgEndColorB));
        widget.setBackGroundColor(cc.color(optionData.bgColorR, optionData.bgColorG, optionData.bgColorB));
        widget.setBackGroundColorOpacity(optionData.bgColorOpacity);
        if (optionData.backGroundScale9Enable) {
            widget.setBackGroundImageCapInsets(cc.rect(optionData.capInsetsX, optionData.capInsetsY, optionData.capInsetsWidth, optionData.capInsetsHeight))
        }
        widget.setDirection(optionData.direction);
        widget.setGravity(optionData.gravity);
        widget.setItemsMargin(optionData.itemMargin);
        this.____312(widget, optionData)
    },
    ____323: function(widget, optionData) {
        this.____311(widget, optionData);
        if (optionData.textureData.path) {
            switch (optionData.textureData.resourceType) {
                case 0:
                    var imageFileName = optionData.textureData.path;
                    var imageFileName_tp = imageFileName != "null" ? this.uiPath + imageFileName : "";
                    widget.loadTexture(imageFileName_tp);
                    break;
                case 1:
                    widget.loadTexture(optionData.textureData.path, 1);
                    break
            }
        }
        widget.setScale9Enabled(optionData.scale9Enable);
        if (optionData.scale9Enable) {
            widget.setCapInsets(cc.rect(optionData.capInsetsX, optionData.capInsetsY, optionData.capInsetsWidth, optionData.capInsetsHeight));
            widget.setSize(cc.size(optionData.width, optionData.height))
        }
        widget.setDirection(optionData.direction);
        widget.setPercent(optionData.percent);
        this.____312(widget, optionData)
    },
    ____324: function(widget, optionData) {
        this.____311(widget, optionData);
        widget.setPlaceHolder(optionData.placeHolder);
        widget.setString(optionData.text);
        widget.setFontSize(optionData.fontSize);
        widget.setFontName(optionData.fontName);
        widget.setMaxLengthEnabled(optionData.maxLengthEnable);
        if (optionData.maxLengthEnable) {
            widget.setMaxLength(optionData.maxLength)
        }
        widget.setPasswordEnabled(optionData.passwordEnable);
        if (optionData.passwordEnable) {
            widget.setPasswordStyleText(optionData.passwordStyleText)
        }
        this.____312(widget, optionData)
    }
});
var ____2399 = cc.Class.extend({
    attackId: 0,
    attackType: 0,
    attackName: "",
    attackState: 0,
    skillId: 0,
    skillLevel: 0,
    skillX: -1,
    skillY: -1,
    behitRoles: null,
    targetId: 0,
    targetType: 0,
    ctor: function() {
        this.behitRoles = []
    },
    attackIsSelf: function() {
        if (this.attackType == ____655.____659.commonStaticType.soType_player || this.attackType == ____655.____659.commonStaticType.soType_pet) {
            if (this.attackId == ____655.____667.userId) {
                return true
            }
        }
        return false
    },
    behitIsSelf: function() {
        for (var i = 0; i < this.behitRoles.length; i++) {
            if (this.behitRoles[i].behitIsSelf()) return true
        }
        return false
    },
    attackIsPet: function() {
        return this.attackType == ____655.____659.commonStaticType.soType_pet
    },
    getBehitRoleInfo: function(type, id) {
        for (var i = 0; i < this.behitRoles.length; i++) {
            var role = this.behitRoles[i];
            if (role.behitId == id && role.behitType == type) return role
        }
        return null
    }
});
var FabaoFlyBehavior = cc.Class.extend({
    _fabao: null,
    ____1539: 0,
    ____1540: 0,
    _curX: 0,
    _curY: 0,
    ____1697: 0,
    ____1698: 0,
    ctor: function() {},
    init: function(fabao, x, y) {
        this._fabao = fabao;
        this.____1539 = this._fabao.getSceneX();
        this.____1540 = this._fabao.getSceneY();
        this._curX = 0;
        if (x != null) {
            this._curX = x
        }
        this._curY = 0;
        if (y != null) {
            this._curY = y
        }
        this.____1697 = 0;
        this.____1698 = 0.3;
        ____654.____678.____298(this.tick, this)
    },
    move: function(x, y) {
        this.____1539 = x;
        this.____1540 = y;
        this.____344()
    },
    tick: function(delta, tickCount) {
        this._curX += this.____1697;
        this._curY += this.____1698;
        if (this._curY >= 15 || this._curY <= -15) {
            this.____1698 *= -1
        }
        this.____344()
    },
    ____344: function() {
        if (this._fabao != null) {
            this._fabao.move(this.____1539 + this._curX, this.____1540 + this._curY)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this._fabao = null
    },
});
var ____2400 = cc.Class.extend({
    ____1122: null,
    ____1124: null,
    _currentIndex: 0,
    ____1035: 0,
    ____1036: 0,
    ____1667: false,
    _frameCount: 0,
    ctor: function() {},
    init: function(type) {
        if (this.____1667) {
            this.stop()
        }
        if (type == null) {
            type = 1
        }
        if (type == 1) {
            this.____1122 = [0, 0, 0, 4, -6, 2, 0, 0, 0, 2, -3, 1, 0, 0, 0, 1, -2, 1, 0, 0, 0];
            this.____1124 = [6, -8, 2, 0, 0, 0, 4, -6, 2, 0, 0, 0, 2, -3, 1, 0, 0, 0, 1, -2, 1]
        } else if (type == 2) {
            this.____1122 = [0, 0, 0, 8, -12, 4, 0, 0, 0, 6, -10, 4, 0, 0, 0, 4, -7, 3, 0, 0, 0, 3, -5, 2, 0, 0, 0, 2, -4, 2, 0, 0, 0, 1, -2, 1, 0, 0, 0];
            this.____1124 = [12, -16, 4, 0, 0, 0, 10, -14, 4, 0, 0, 0, 8, -12, 4, 0, 0, 0, 6, -10, 4, 0, 0, 0, 4, -6, 2, 0, 0, 0, 2, -4, 2, 0, 0, 0, 1, -2, 1]
        }
        this.____1667 = true;
        ____654.____678.____298(this.tick, this)
    },
    stop: function() {
        this.____1667 = false;
        this.setPos(-1 * this.____1035, -1 * this.____1036);
        this.____1035 = 0;
        this.____1036 = 0;
        this._currentIndex = 0;
        this._frameCount = 0;
        ____654.____678.____299(this.tick, this)
    },
    setPos: function(x, y) {
        var px = ____654.____676.____796.getPositionX();
        var py = ____654.____676.____796.getPositionY();
        var p1 = ____654.____673.____159(px + x, py + y);
        ____654.____676.____354(p1)
    },
    tick: function(deltaTime, tickCount) {
        this._frameCount++;
        if (this._frameCount % 2 != 0) return;
        if (this.____1667 == false || this._currentIndex >= this.____1122.length) {
            this.stop();
            return
        }
        this.____1035 += this.____1122[this._currentIndex];
        this.____1036 += this.____1124[this._currentIndex];
        this.setPos(this.____1122[this._currentIndex], this.____1124[this._currentIndex]);
        this._currentIndex++
    },
    dispose: function() {
        this.stop()
    },
});
var NewlyBehavior = cc.Class.extend({
    ____1615: null,
    ____1009: null,
    ____1241: -1,
    _wave: 0,
    ctor: function(module) {
        this.____1615 = module
    },
    reset: function(index) {
        if (this.____1241 == index) {
            return
        }
        this.clear();
        this.____1241 = index;
        this.____1009 = ____655.copyInfo.getCopyInfo(____655.copyInfo.currentId);
        this._wave = 0;
        if (this.____1009 != null) {
            this.____1009.addEventListener(____655.____661.copy_waveUpdate, this.updateWave, this)
        }
    },
    updateWave: function(evt) {
        print("触发剧情", this.____1241, this.____1009.currentWave);
        if (this._wave == this.____1009.currentWave) {
            return
        }
        this._wave = this.____1009.currentWave;
        if (this.____1241 == 0) {
            if (this.____1009.currentWave == 1) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50100")
            }
        } else if (this.____1241 == 1) {
            if (this.____1009.currentWave == 1) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50200")
            } else if (this.____1009.currentWave == 3) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50220")
            }
        } else if (this.____1241 == 2) {
            if (this.____1009.currentWave == 1) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50300")
            } else if (this.____1009.currentWave == 3) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50310")
            }
        } else if (this.____1241 == 3) {
            if (this.____1009.currentWave == 1) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50400")
            } else if (this.____1009.currentWave == 3) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50410")
            }
        } else if (this.____1241 == 4) {
            if (this.____1009.currentWave == 1) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50500")
            } else if (this.____1009.currentWave == 2) {
                this.____1615.walkTester.walkToCollectByTemplateId(1100);
                ____654.tipsManager.quickTip.showScene(____654.____682.____108("50802"))
            } else if (this.____1009.currentWave == 3) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50520")
            } else if (this.____1009.currentWave == 4) {
                this.____1615.walkTester.walkToCollectByTemplateId(1103);
                ____654.tipsManager.quickTip.showScene(____654.____682.____108("50803"))
            }
        } else if (this.____1241 == 5) {
            if (this.____1009.currentWave == 1) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50600")
            } else if (this.____1009.currentWave == 2) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50610");
                ____654.fashionMessageSender.sendJihuo(____655.____659.commonStaticType.style_ZhengLing)
            }
        } else if (this.____1241 == 6) {
            if (this.____1009.currentWave == 1) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50700")
            } else if (this.____1009.currentWave == 3) {
                this.____1615.attackTester.stopAFK();
                this.____1615.scenePanelController.showNpcTalkView("50710")
            }
        }
    },
    clear: function() {
        if (this.____1009 != null) {
            this.____1009.removeEventListener(____655.____661.copy_waveUpdate, this.updateWave, this)
        }
        this.____1241 = -1;
        this._wave = 0
    },
});
var ____2401 = cc.Class.extend({
    ____1767: null,
    ____1768: null,
    _controller: null,
    _sceneInfo: null,
    _tickCount: 0,
    ____1683: null,
    ____868: null,
    ____1403: 0,
    ____846: false,
    ____847: null,
    ____1742: null,
    ____1208: true,
    ____1210: true,
    ctor: function(roleInfo, controller) {
        this.____1768 = roleInfo;
        this._controller = controller;
        this._sceneInfo = controller.sceneInfo
    },
    init: function(data) {
        if (this.____1767 == null) {
            this.____1767 = this._controller.sceneModule.getAttackableRole(this.____1768.____402(), this.____1768.____357())
        }
        this.doEnd();
        this.____868 = data;
        this.doFirst();
        if (this.____1767 != null && this.____1767.getParent() != null && this.____1683 != null) {
            ____654.____678.____298(this.tick, this)
        } else {
            this.doEnd()
        }
    },
    doFirst: function() {
        this.____1208 = false;
        this.____1210 = false;
        this.____1683 = ____655.allTemplates.skillTemplateList.getSkill(this.____868.skillId);
        this.____846 = this.____868.attackIsSelf();
        this.____847 = this.____1768.____355();
        if (this.____868.skillX != -1 && this.____868.skillY != -1) {
            this.____1742 = ____654.____673.____159(this.____868.skillX, this.____868.skillY)
        } else {
            var targetRole = this._sceneInfo.getAttackableRoleInfo(this.____868.targetType, this.____868.targetId);
            if (targetRole != null) {
                this.____1742 = targetRole.____355()
            }
        }
        if (this.____1742 != null && ____654.____674.____180(this.____847, this.____1742) == false) {
            this.____1768.____206(____655.____659.____686.____96(this.____847, this.____1742));
            this.____1768.currentAngle = ____655.____659.____686.____98(this.____847, this.____1742)
        }
        if (this.____1683 != null && this.____1767 != null) {
            if (this.____1683.playAction) {
                this.____1767.playAttack()
            }
        }
        if (this.____1683.hitEffectDelay > this.____1403) this.____1403 = this.____1683.hitEffectDelay;
        if (this.____1683.shakeDelay > this.____1403) this.____1403 = this.____1683.shakeDelay
    },
    doEnd: function() {
        this.doEffectAction();
        this.doShakeAction();
        ____654.____678.____299(this.tick, this);
        this._tickCount = 0;
        this.____1403 = 0;
        this.____1683 = null;
        this.____868 = null;
        this.____846 = false;
        this.____847 = null;
        this.____1742 = null
    },
    getTargetPointList: function() {
        var ret = [],
            beHitRoles = this.____868.behitRoles;
        for (var i = 0; i < beHitRoles.length; i++) {
            var role = beHitRoles[i],
                sceneRole = this._controller.sceneModule.getAttackableRole(role.behitType, role.behitId);
            if (sceneRole != null) {
                roleInfo = sceneRole.____356();
                ret.push(roleInfo.getHitPos())
            }
        }
        return ret
    },
    tick: function(deltaTime, tickCount) {
        if (this.____1767 == null || this.____1767.getParent() == null || this.____868 == null || this.____1683 == null || this._tickCount > this.____1403) {
            this.doEnd();
            return
        }
        if (this._tickCount == this.____1683.hitEffectDelay) {
            this.doEffectAction()
        }
        if (this._tickCount == this.____1683.shakeDelay) {
            this.doShakeAction()
        }
        this._tickCount++
    },
    doEffectAction: function() {
        if (this.____1683 == null || this.____1208) return;
        this.____1208 = true;
        if (this.____868 == null) return;
        if ((this.____868.attackType == ____655.____659.commonStaticType.soType_player || this.____868.attackType == ____655.____659.commonStaticType.soType_pet) && this.____868.attackId != ____655.____667.userId) {
            return
        }
        if (this.____1767 == null || this.____1767.____356() == null) return;
        if (this.____1767.____351()) {
            if (this.____1742 != null) {
                var id = this.____1683.attackEffect;
                if (this.____1768.____402() == ____655.____659.commonStaticType.soType_player) {
                    var sb = this.____1768.figureInfo.characterInfo.getShenBin();
                    if (sb > 0) {
                        var tmpSkillId = ____655.allTemplates.skillTemplateList.getChangeSkillId(this.____1683.templateId, sb);
                        id = ____655.allTemplates.skillTemplateList.getSkill(tmpSkillId).attackEffect
                    }
                }
                if (id >= 9000 && id <= 10000) {
                    var particleInfo = ____655.particleInfoList.list[id];
                    if (particleInfo != null) {
                        var p = new particleInfo.cls(____654.____676.____798, particleInfo);
                        var sp = this.____1767.____356().getHitPos();
                        p.move(sp.x, -sp.y);
                        if (particleInfo.setDegree || particleInfo.setRotate) {
                            var tp = this.____1742;
                            var degree = ____655.____659.____686.____97(this.____1767.____356().____355(), tp);
                            if (particleInfo.setDegree) {
                                p.setDegree(degree)
                            }
                            if (particleInfo.setRotate) {
                                p.setRotate(degree)
                            }
                        }
                        p.play()
                    }
                }
            }
        }
    },
    doShakeAction: function() {
        if (this.____1683 == null || this.____1210) return;
        this.____1210 = true;
        if (this.____1767 == null) return;
        if (this.____1767.____357() == ____655.____667.userId && this.____1683.isShake) {
            this._controller.sceneModule.mapShakeBehavior.init(2)
        }
    },
    dispose: function() {
        this.____1683 = null;
        this.doEnd();
        this.____868 = null;
        this.____1767 = null;
        this.____1768 = null;
        this._roleInfo = null;
        this._controller = null;
        this._sceneInfo = null;
        this.____847 = null;
        this.____1742 = null
    },
});
var ____2402 = cc.Class.extend({
    ____1767: null,
    ____1768: null,
    ____1766: null,
    _controller: null,
    _sceneInfo: null,
    _tickCount: 0,
    ____1683: null,
    ____868: null,
    ____1395: 0,
    ____1206: true,
    ____1208: true,
    ____1207: true,
    ____1209: true,
    ____1210: true,
    _colorTick: -1,
    ctor: function(roleInfo, controller) {
        this.____1768 = roleInfo;
        this._controller = controller;
        this._sceneInfo = controller.sceneInfo
    },
    init: function(data) {
        if (this.____1767 == null) {
            this.____1767 = this._controller.sceneModule.getAttackableRole(this.____1768.____402(), this.____1768.____357())
        }
        if (this.____868 != null) {
            this.doEnd()
        }
        this.____868 = data;
        this.____1766 = this.____868.getBehitRoleInfo(this.____1768.____402(), this.____1768.____357());
        this.doFirst();
        if (this.____1767 != null && this.____1767.getParent() != null && this.____1683 != null) {
            ____654.____678.____298(this.tick, this)
        } else {
            this.doEnd()
        }
    },
    doFirst: function() {
        this.____1768.____91(this.____1766.serverState);
        this.____1683 = ____655.allTemplates.skillTemplateList.getSkill(this.____868.skillId);
        if (this.____1683.behitEffectDelay > this.____1395) this.____1395 = this.____1683.behitEffectDelay;
        if (this.____1683.bloodDelay > this.____1395) this.____1395 = this.____1683.bloodDelay;
        if (this.____1683.shakeDelay > this.____1395) this.____1395 = this.____1683.shakeDelay;
        if (this.____1683.hitBackDelay > this.____1395) this.____1395 = this.____1683.hitBackDelay;
        this.____1206 = false;
        this.____1208 = false;
        this.____1207 = false;
        this.____1209 = false;
        this.____1210 = false
    },
    doEnd: function() {
        this.doBehitAction();
        this.doEffectAction();
        this.doBloodAction();
        this.doHitBackAction();
        this.doShakeAction();
        ____654.____678.____299(this.tick, this);
        this.____1683 = null;
        this._tickCount = 0;
        this.____1395 = 0;
        this.____868 = null
    },
    tick: function(deltaTime, tickCount) {
        if (this.____1767 == null || this.____1767.getParent() == null || this.____1683 == null || this._tickCount > this.____1395) {
            this.doEnd();
            return
        }
        if (this._tickCount == this.____1683.behitActionDelay) {
            this.doBehitAction()
        }
        if (this._tickCount == this.____1683.behitEffectDelay) {
            this.doEffectAction()
        }
        if (this._tickCount == this.____1683.bloodDelay) {
            this.doBloodAction()
        }
        if (this._tickCount == this.____1683.hitBackDelay) {
            this.doHitBackAction()
        }
        if (this._tickCount == this.____1683.shakeDelay) {
            this.doShakeAction()
        }
        this._tickCount++
    },
    colorTick: function(delta, count) {
        this._colorTick--;
        if (this._colorTick <= 0) {
            ____654.____678.____299(this.colorTick, this);
            if (this.____1767 != null) {
                this.____1767.setCharacterColor(null)
            }
        }
    },
    hitColor: function() {
        if (this.____1767 != null) {
            this.____1767.setCharacterColor(____655.____659.____688.behitWhite);
            this._colorTick = 12;
            ____654.____678.____298(this.colorTick, this)
        }
    },
    doBehitAction: function() {
        if (this.____1206) return;
        this.____1206 = true;
        var attacker = null;
        if (this.____1768.stateInfo.getIsDead() || this.____1768.____386() <= 0) {
            if (this.____1768.____402() == ____655.____659.commonStaticType.soType_monster && this.____868.attackIsSelf()) {
                attacker = this._sceneInfo.getAttackableRoleInfo(this.____868.attackType, this.____868.attackId);
                if (attacker != null) {
                    var thisP = this.____1768.____355();
                    var angle = ____655.____659.____686.____98(thisP, attacker.____355());
                    var p = ____654.____673.____159(-Math.cos(angle) * 200 + thisP.x, -Math.sin(angle) * 200 + thisP.y);
                    this._controller.sceneModule.jumpTester.otherDoJump(this.____1768.____402(), this.____1768.____357(), p, 5)
                }
            }
        } else {
            if (this.____1767 != null) {
                this.____1767.playBehit();
                this.____1767.doShake();
                this.hitColor()
            }
            if (this.thisIsSelf()) {
                var selectTarget = this._sceneInfo.getCurrentSelectObjInfo();
                if (selectTarget != null) {
                    if (this._controller.sceneModule.attackTester.targetCanBeAttack(selectTarget, false) == false) {
                        selectTarget = null
                    }
                }
                if (selectTarget == null) {
                    attacker = this._sceneInfo.getAttackableRoleInfo(this.____868.attackType, this.____868.attackId);
                    if (attacker != null && this._controller.sceneModule.attackTester.targetCanBeAttack(attacker, false)) {
                        selectTarget = attacker
                    }
                }
                this._sceneInfo.setCurrentSelectObjInfo(selectTarget);
                this.showSkillNameTip();
                if (this.____1683.breakCollect && ____655.allTemplates.copyTemplateList.collectCanBeStop(____655.copyInfo.currentId)) {
                    this.____1768.setCollectId(-1)
                }
            }
        }
    },
    thisIsSelf: function() {
        return this.____1768.____357() == ____655.____667.userId && this.____1768.____402() == ____655.____659.commonStaticType.soType_player
    },
    doEffectAction: function() {
        if (this.____1208) return;
        this.____1208 = true;
        if (this.____868 == null) return;
        if ((this.____868.attackType == ____655.____659.commonStaticType.soType_player || this.____868.attackType == ____655.____659.commonStaticType.soType_pet) && this.____868.attackId != ____655.____667.userId) {
            return
        }
        var attackRole = this._controller.sceneModule.getAttackableRole(this.____868.attackType, this.____868.attackId);
        if (attackRole != null && attackRole.____351() && this.____1767 != null) {
            var id = this.____1683.behitEffect;
            if (this.____868.attackType == ____655.____659.commonStaticType.soType_player) {
                var sb = attackRole.____356().figureInfo.characterInfo.getShenBin();
                if (sb > 0) {
                    var tmpSkillId = ____655.allTemplates.skillTemplateList.getChangeSkillId(this.____1683.templateId, sb);
                    id = ____655.allTemplates.skillTemplateList.getSkill(tmpSkillId).behitEffect
                }
            }
            if (id > 0) {
                var pos = this.____1767.____356().getHitPos();
                if (id >= 9000 && id <= 10000) {
                    var particleInfo = ____655.particleInfoList.list[id];
                    if (particleInfo != null) {
                        var p = new particleInfo.cls(____654.____676.____798, particleInfo);
                        p.move(pos.x, -pos.y);
                        var atp = attackRole.____356().getHitPos();
                        if (particleInfo.setDegree || particleInfo.setRotate) {
                            var degree = ____655.____659.____686.____97(atp, pos);
                            if (particleInfo.setDegree) {
                                p.setDegree(degree)
                            }
                            if (particleInfo.setRotate) {
                                p.setRotate(degree)
                            }
                        }
                        if (particleInfo.setMoveLen) {
                            p.setMoveLen(____654.____674.____179(atp, pos))
                        }
                        p.play()
                    }
                } else {
                    var effect = ____654.effectManager.create(id, true, pos, true, null, null, ____655.____659.commonStaticType.source_neverClear);
                    if (effect != null) {
                        var path = effect.getPath();
                        var container = ____654.____676.getBatchNodeByType(path, 5);
                        effect.setContainer(container, true);
                        effect.addToContainer();
                        effect.play()
                    }
                }
            }
        }
    },
    doBloodAction: function() {
        if (this.____1207) return;
        this.____1207 = true;
        if (this.____868.attackIsSelf() || this.thisIsSelf()) {
            var behitRoleInfo = this.____1766;
            if (behitRoleInfo != null && behitRoleInfo.dHps.length > 0) {
                var bloodBehavior = new ____2404(this.____1768, this._controller);
                if (this.____868.attackIsSelf()) {
                    if (this.____868.attackType == ____655.____659.commonStaticType.soType_player) {
                        bloodBehavior.init(behitRoleInfo.dHps, behitRoleInfo.behitResult, 1)
                    } else {
                        bloodBehavior.init(behitRoleInfo.dHps, behitRoleInfo.behitResult, 2)
                    }
                } else {
                    bloodBehavior.init(behitRoleInfo.dHps, behitRoleInfo.behitResult, 4)
                }
            }
        }
    },
    doHitBackAction: function() {
        if (this.____1209) return;
        this.____1209 = true;
        var behitRole = this.____1766;
        if (behitRole != null && behitRole.isHitBack > 0) {
            this._controller.sceneModule.jumpTester.otherDoJump(behitRole.behitType, behitRole.behitId, behitRole.hitBackPos, 4)
        }
    },
    doShakeAction: function() {
        if (this.____1210) return;
        this.____1210 = true;
        if (this.thisIsSelf()) {
            if (this.____1683.isShake) {
                this._controller.sceneModule.mapShakeBehavior.init(2)
            }
        }
    },
    showSkillNameTip: function() {},
    dispose: function() {
        ____654.____678.____299(this.colorTick, this);
        this.____1206 = true;
        this.____1208 = true;
        this.____1207 = true;
        this.____1209 = true;
        this.____1210 = true;
        this.doEnd();
        this.____1767 = null;
        this.____1768 = null;
        this._controller = null;
        this._sceneInfo = null;
        this.____1683 = null;
        this.____868 = null;
        this.____1766 = null
    },
});
var ____2403 = cc.Class.extend({
    behitId: 0,
    behitType: 0,
    behitName: "",
    dHps: null,
    behitResult: null,
    isHitBack: 0,
    hitBackPos: null,
    currentHp: 0,
    serverState: 0,
    ctor: function() {
        this.dHps = [];
        this.behitResult = []
    },
    behitIsSelf: function() {
        if (this.behitType == ____655.____659.commonStaticType.soType_player && this.behitId == ____655.____667.userId) {
            return true
        }
        return false
    },
});
var ____2404 = cc.Class.extend({
    ____1768: null,
    ____874: null,
    _tickCount: 0,
    _controller: null,
    ____1262: false,
    ____1618: null,
    ctor: function(roleInfo, controller) {
        this.____1768 = roleInfo;
        this.____874 = [];
        this._controller = controller
    },
    init: function(dhps, resultTypes, ____688) {
        var thisRole = this._controller.sceneModule.getAttackableRole(this.____1768.____402(), this.____1768.____357());
        if (thisRole == null || thisRole.getParent() == null) return;
        this.____1618 = thisRole.____355();
        var len = dhps.length;
        for (var i = 0; i < len; i++) {
            if (dhps[i] == 0 && resultTypes[i] != ____655.____659.commonStaticType.attackResult_miss) {
                continue
            }
            var blood = new ____606(____654.____676.sceneBloodNode, true);
            blood.____18(dhps[i], resultTypes[i], ____688);
            this.____874.push(blood)
        }
        this._tickCount = 0;
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        if (!!this.____1262) return;
        if (this.____874.length <= 0) {
            this.dispose();
            return
        }
        this._tickCount--;
        if (this._tickCount <= 0) {
            var blood = this.____874.splice(0, 1)[0];
            blood.play();
            blood.move(this.____1618.x, this.____1618.y - 80);
            this._tickCount = 6
        }
    },
    dispose: function() {
        this.____1262 = true;
        ____654.____678.____299(this.tick, this);
        this.____1768 = null;
        this.____1618 = null;
        if (this.____874 != null) {
            for (var i = 0; i < this.____874.length; i++) {
                this.____874[i].dispose()
            }
            this.____874 = null
        }
    },
});
var ____2405 = cc.Class.extend({
    _role: null,
    _roleInfo: null,
    _target: null,
    ____1037: 0,
    ____1808: 0,
    ____1714: 0,
    ____1715: 0,
    _dx: 0,
    _dy: 0,
    ____1300: null,
    ____1816: 0,
    ____1301: 0,
    ctor: function(role) {
        this._role = role;
        this._roleInfo = role.____356();
        this.____1300 = [0, 30, 60, 75, 82, 86, 88, 90, 90, 88, 86, 82, 75, 60, 30, 0]
    },
    init: function(target, type) {
        this._target = target;
        this.____1301 = type;
        if (this.____1301 == 1) {
            this.____1808 = 16
        } else {
            this.____1808 = 8
        }
        var p = this._roleInfo.____355();
        this.____1714 = p.x;
        this.____1715 = p.y;
        this._dx = (this._target.x - p.x) / this.____1808;
        this._dy = (this._target.y - p.y) / this.____1808;
        if (this.____1301 == 4 || this.____1301 == 5) {
            this._roleInfo.____206(____655.____659.____686.____96(this._target, p))
        } else {
            this._roleInfo.____206(____655.____659.____686.____96(p, this._target))
        }
        this.____1037 = 0;
        this._roleInfo.stateInfo.jumping = true;
        ____654.____678.____298(this.tick, this);
        this._roleInfo.walkStop()
    },
    tick: function(delta, tickCount) {
        this.____1714 += this._dx;
        this.____1715 += this._dy;
        this._roleInfo.____354(____654.____673.____159(this.____1714, this.____1715));
        if (this.____1301 == 1) {
            this._role.setCharacterYOffset(this.____1300[this.____1037])
        }
        this.____1037++;
        if (this.____1037 >= this.____1808) {
            this.____307()
        }
    },
    stop: function() {
        this._roleInfo.stateInfo.jumping = false;
        ____654.____678.____299(this.tick, this)
    },
    ____307: function() {
        if (this._roleInfo.stateInfo.jumping == false) return;
        this.stop();
        this._roleInfo.____354(this._target);
        this._role.cancelAnima()
    },
    dispose: function() {
        this.stop();
        this._role = null;
        this._roleInfo = null;
        this._target = null;
        this.____1300 = null
    },
});
var ____601 = cc.Class.extend({
    _roleInfo: null,
    ____1857: null,
    ____1278: false,
    _path: null,
    ____1505: 0,
    ____1057: null,
    ____1456: null,
    ____1697: 0,
    ____1698: 0,
    ____1322: 0,
    ____1065: 0,
    ____1032: 0,
    ____1409: null,
    ____1260: false,
    _footTick: 0,
    ctor: function(roleInfo, walkComplete) {
        this._roleInfo = roleInfo;
        this.____1857 = walkComplete;
        this._path = []
    },
    setSender: function(sender) {
        this.____1409 = sender
    },
    setPath: function(data) {
        this.____1278 = (this._roleInfo.____357() == ____655.____667.userId && ____655.____659.commonStaticType.soType_player == this._roleInfo.____402());
        this._path = data;
        var len = this._path.length;
        var selfP = this._roleInfo.____355();
        if (____654.____674.____180(selfP, this._path[0])) {
            this._path.splice(0, 1)
        }
        len = this._path.length;
        var p = this._roleInfo.____355();
        if (len == 0) {
            this.____105();
            return
        }
        this.____1505 = len - 1;
        this.____1260 = false;
        this.____1456 = ____654.____673.____159(p.x, p.y);
        this.____1065 = this._roleInfo.speed;
        this.updateNextPos();
        ____654.____678.____298(this.tick, this)
    },
    ____105: function() {
        this.walkStop();
        if (this.____1857 != null) {
            this.____1857.call(this._roleInfo)
        }
    },
    updateNextPos: function() {
        var len = this._path.length;
        if (len <= 0) return;
        this.____1057 = ____654.____673.____159(this.____1456.x, this.____1456.y);
        this.____1456 = this._path[0];
        this._path.splice(0, 1);
        if (this.____1057.x != this.____1456.x || this.____1057.y != this.____1456.y) {
            this._roleInfo.____206(____655.____659.____686.____96(this.____1057, this.____1456))
        }
        this._roleInfo.currentAngle = ____655.____659.____686.____98(this.____1057, this.____1456);
        this.____1032 = this._roleInfo.currentAngle;
        this.updateSpeed();
        if (this.____1278) {
            this.____1322 = 0;
            this.____1409.sendWalkStep(this.____1057.x, this.____1057.y, this.____1505 - this._path.length)
        }
    },
    updateSpeed: function() {
        this.____1697 = Math.cos(this.____1032) * this.____1065;
        this.____1698 = Math.sin(this.____1032) * this.____1065
    },
    tick: function(delta, tickCount) {
        if (this._roleInfo == null) return;
        if (this._roleInfo.speed != this.____1065) {
            this.____1065 = this._roleInfo.speed;
            this.updateSpeed()
        }
        if (tickCount == 1) {
            this.walkStep()
        } else {
            for (var i = 0; i < tickCount; i++) {
                this.walkStep();
                if (this.____1260) break
            }
        }
        this._roleInfo.____354(this.____1057);
        this._footTick++;
        if (this._footTick >= 10) {
            this._footTick = 0;
            this.createFootEffect()
        }
        if (this.____1260) this.____105()
    },
    walkStep: function() {
        if (this.____1260 || this.____1057 == null) return;
        if (____654.____674.____179(this.____1057, this.____1456) < this.____1065) {
            this.____1057.x = this.____1456.x;
            this.____1057.y = this.____1456.y;
            if (this._path.length == 0) {
                if (this.____1278 == true) {
                    this.____1322 = 0;
                    this.____1409.sendWalkStep(this.____1057.x, this.____1057.y, this.____1505 - this._path.length)
                }
                this.____1260 = true
            }
            this.updateNextPos()
        } else {
            this.____1057.x = this.____1057.x + this.____1697;
            this.____1057.y = this.____1057.y + this.____1698
        }
        if (this.____1278) {
            this.____1322 = this.____1322 + this.____1065;
            if (this.____1322 >= ____655.GRID_SIZE) {
                this.____1322 = 0;
                this.____1409.sendWalkStep(this.____1057.x, this.____1057.y, this.____1505 - this._path.length)
            }
        }
    },
    walkStop: function() {
        this.____1260 = true;
        this.____1057 = null;
        this.____1456 = null;
        this._path = [];
        ____654.____678.____299(this.tick, this)
    },
    createFootEffect: function() {
        if (this._roleInfo == null) return;
        if (!____655.allTemplates.copyTemplateList.isShowZuJi(____655.copyInfo.currentId)) return;
        if (this._roleInfo.____402() != ____655.____659.commonStaticType.soType_player) return;
        if (this._roleInfo.figureInfo.characterInfo.getIsBuffChange()) return;
        var roleView = this._roleInfo.sceneModule.scenePlayerController.____422(this._roleInfo.____357());
        if (roleView == null || roleView.____351() == false) return;
        var zuji = this._roleInfo.figureInfo.characterInfo.getZuji();
        if (zuji == null || zuji == 0) return;
        var effectId = parseInt(____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Foot, zuji).figureId);
        var zujiEffect = ____654.effectManager.create(effectId, true, this._roleInfo.____355(), true, null, null, ____655.____659.commonStaticType.source_neverClear),
            path = zujiEffect.getPath(),
            container = ____654.____676.getBatchNodeByType(path, 1);
        zujiEffect.setContainer(container, true);
        zujiEffect.play()
    },
    dispose: function() {
        this._roleInfo = null;
        this.____1857 = null;
        this.____1409 = null;
        this.walkStop()
    },
});
var ____2407 = cc.Class.extend({
    ____1648: null,
    ____1614: null,
    ____1615: null,
    _frameCount: 0,
    _sceneInfo: null,
    ____1320: null,
    ____828: false,
    ctor: function(selfPlayer, controller) {
        this.____1648 = selfPlayer;
        this.____1614 = controller;
        this.____1615 = controller.sceneModule;
        this._sceneInfo = controller.sceneInfo;
        this.____1320 = ____654.____673.____159(0, 0);
        this.____1648.stateInfo.addEventListener(____655.____661.____709, this.clientStateChange, this);
        ____654.____672.addEventListener(____655.____661.sceneInfo_sendSkillOnce, this.sendSkillOnce, this);
        ____654.____672.addEventListener(____655.____661.sceneInfo_selectAttackTarget, this.selectAttackTargetHandler, this)
    },
    clientStateChange: function(evt) {
        if (this.____1648.stateInfo.getAttackCommon() || !this.____1615.attackTester.selfCanDoAttack()) {
            ____654.____678.____299(this.tick, this)
        } else {
            this.____828 = false;
            ____654.____678.____298(this.tick, this)
        }
    },
    tick: function(delta, tickCount) {
        var this_ = this;

        function walkCB() {
            this_.____828 = false
        }
        this._frameCount++;
        if (this._frameCount % 2 != 0) return;
        if (this.____828) return;
        if (!this.____1615.attackTester.selfCanDoAttack()) return;
        var selfP = this.____1648.____355();
        var skill = this.getASkill();
        if (skill == null) return;
        var skillTemplate = skill.template;
        if (skillTemplate.isToSelf()) {
            this.____1615.attackTester.doAttack(skill, this.____1648, selfP)
        } else if (skillTemplate.isForeword()) {
            this.____1615.attackTester.doAttack(skill, this.____1648, this.____1648.findPointForeword(skillTemplate.distance - 40))
        } else {
            var target = this.getATarget(skill);
            if (target != null) {
                this._sceneInfo.setCurrentSelectObjInfo(target, true);
                var dis = skillTemplate.distance - 25;
                if (dis < 75) dis = 75;
                if (____654.____674.____179(selfP, target.____355()) < dis + 8) {
                    this.____1615.attackTester.doAttack(skill, target, null)
                } else {
                    var mapInfo = this._sceneInfo.sceneMapList.getMap(____655.currentMapId);
                    if (mapInfo.getValue(selfP.x, selfP.y) == ____655.____659.commonStaticType.mapBlock_empty) {
                        return
                    }
                    this.____828 = true;
                    this.____1615.walkTester.____431(____655.currentMapId, target.____355(), dis - 8, walkCB)
                }
            } else {
                if (this.____1648.stateInfo.getAFK()) {
                    var p = this._sceneInfo.getAFKPointAndSetToNextIndex();
                    if (p != null) {
                        if (p.x != 0 || p.y != 0) {
                            this.____828 = true;
                            var selfP = this.____1615.scenePlayerController.selfPlayer;
                            if (selfP != null) selfP.stopAttack();
                            this.____1615.walkTester.____431(____655.currentMapId, p, 0, walkCB)
                        }
                    } else {
                        var mp = this.getAMonsterTemplatePoint();
                        if (mp != null) {
                            this.____828 = true;
                            this.____1615.walkTester.____431(____655.currentMapId, mp, 0, walkCB)
                        }
                    }
                }
            }
        }
    },
    sendSkillOnce: function(evt) {
        var skill = evt.data;
        if (!this.____1615.attackTester.selfCanDoAttack()) return;
        var selfP = this.____1648.____355();
        if (!skill.getCanUse()) return;
        var skillTemplate = skill.template;
        if (skillTemplate.isToSelf()) {
            this.____1615.attackTester.doAttack(skill, this.____1648, selfP)
        } else if (skillTemplate.isForeword()) {
            this.____1615.attackTester.doAttack(skill, this.____1648, this.____1648.findPointForeword(skillTemplate.distance - 40))
        }
    },
    getASkill: function() {
        var skill = this._sceneInfo.getCurrentSkill();
        if (skill != null && skill.getCanUse()) {
            return skill
        }
        if (____655.allTemplates.copyTemplateList.canUseCommonAFKSkill(____655.copyInfo.currentId)) {
            if (this.____1648.stateInfo.getAFK()) {
                skill = ____655.skillItemList.getAFKSkill();
                if (skill != null) {
                    return skill
                }
            }
        }
        if (____655.allTemplates.copyTemplateList.canUseDefaultSkill(____655.copyInfo.currentId)) {
            skill = ____655.skillItemList.getDefaultSkillByCopyId(____655.copyInfo.currentId);
            if (skill != null && skill.getCanUse()) {
                return skill
            }
        }
        return null
    },
    getATarget: function(skill) {
        var target = this._sceneInfo.getCurrentSelectObjInfo();
        if (target != null && this.____1615.attackTester.targetCanBeAttack(target, false)) {
            return target
        }
        if (this.____1648.stateInfo.getAFK()) {
            target = this._sceneInfo.sceneMonsterList.getAFKMonsterNearPoint(this.____1648.____355());
            return target
        }
        return null
    },
    selectAttackTargetHandler: function(evt) {
        var target = this._sceneInfo.getCurrentSelectObjInfo();
        if (target != null && this.____1615.attackTester.targetCanBeAttack(target, false)) return;
        this._sceneInfo.setCurrentSelectObjInfo(this._sceneInfo.sceneMonsterList.getAFKMonsterNearPoint(this.____1648.____355()))
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        ____654.____672.removeEventListener(____655.____661.sceneInfo_sendSkillOnce, this.sendSkillOnce, this);
        ____654.____672.removeEventListener(____655.____661.sceneInfo_selectAttackTarget, this.selectAttackTargetHandler, this);
        this.____1648.stateInfo.removeEventListener(____655.____661.____709, this.clientStateChange, this);
        this.____1648 = null;
        this.____1614 = null;
        this._sceneInfo = null;
        this.____1615 = null;
        this.____1320 = null
    },
});
var ____2408 = cc.Class.extend({
    _roleInfo: null,
    ____1614: null,
    _sceneInfo: null,
    ____1712: 0,
    _totalTime: 0,
    ____990: -1,
    ____991: null,
    ____861: null,
    ____862: null,
    ____863: null,
    _tickCount: 0,
    ctor: function(roleInfo, controller) {
        this._roleInfo = roleInfo;
        this.____1614 = controller;
        this._sceneInfo = controller.sceneInfo;
        this.____862 = ____654.____673.newKYSprite();
        this.____862.setFrame("bar/ui_readingBarBg.png");
        this.____861 = ____654.____673.newKYSprite();
        this.____861.setFrame("bar/ui_readingBar.png");
        this.____863 = ____654.____673.newKYLabel(20, true);
        this.____861.setAnchorPoint(____654.____673.anchorPoints[4]);
        this.____862.setPosition(____655.____656 / 2, 210);
        this.____861.setPosition(____655.____656 / 2 - 89, 210);
        this.____863.setPosition(____655.____656 / 2, 240)
    },
    init: function(id) {
        if (this._roleInfo == null) return;
        this.____990 = id;
        if (this.____990 == -1) {
            this.stop()
        } else {
            var collectInfo = this._sceneInfo.sceneCollectList.getCollect(this.____990);
            if (collectInfo != null && (collectInfo.warState == 0 || collectItem.warState != this._roleInfo.warState)) {
                this.____991 = collectInfo.template;
                this._totalTime = this.____991.collectTime;
                this.____1712 = ____655.____662.getSystemTime();
                this.____861.setScaleX(0);
                this.showBar(this.____991.barDescript);
                this.____1614.sceneModule.sceneMessageSender.sendCollectStart(id, this.____991.id);
                ____654.____678.____298(this.tick, this)
            }
        }
    },
    showBar: function(descript) {
        if (this.____862.getParent() == null) {
            ____654.____676.____799.addChild(this.____862)
        }
        if (this.____861.getParent() == null) {
            ____654.____676.____799.addChild(this.____861)
        }
        if (this.____863 != null && this.____863.getParent() == null) {
            ____654.____676.____799.addChild(this.____863)
        }
        this.____863.setString(descript)
    },
    hideBar: function() {
        if (this.____862.getParent() != null) {
            this.____862.getParent().removeChild(this.____862, false)
        }
        if (this.____861.getParent() != null) {
            this.____861.getParent().removeChild(this.____861, false)
        }
        if (this.____863 != null && this.____863.getParent() != null) {
            this.____863.getParent().removeChild(this.____863, false)
        }
    },
    stop: function(isSend) {
        if (isSend != false) {
            this.____1614.sceneModule.sceneMessageSender.sendCollectStart(0, 0)
        }
        this.hideBar();
        ____654.____678.____299(this.tick, this);
        this._tickCount = 0
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount % 3 != 0) return;
        var leftTime = (____655.____662.getSystemTime() - this.____1712) / this._totalTime;
        if (leftTime < 1.0) {
            this.____861.setScaleX(leftTime)
        } else {
            var collectInfo = this._sceneInfo.sceneCollectList.getCollect(this.____990);
            if (collectInfo != null) {
                this.____1614.sceneModule.sceneMessageSender.sendPlayerCollect();
                collectInfo.setClientFlag(1)
            }
            if (this.____991 != null && this.____991.canAFK) {
                var item = this._sceneInfo.sceneCollectList.getNearlyCollectByTemplateId(this._roleInfo.____355(), this.____991.id);
                if (item != null) {
                    this.____1614.sceneModule.walkTester.walkToCollect(item)
                } else {
                    this.____1614.sceneModule.walkTester.walkToCollectByTemplateId(this.____991.id)
                }
            } else {
                this.stop()
            }
        }
    },
    dispose: function() {
        this.stop(false);
        if (this.____862 != null) {
            this.____862.dispose();
            this.____862 = null
        }
        if (this.____861 != null) {
            this.____861.dispose();
            this.____861 = null
        }
        if (this.____863 != null) {
            this.____863.dispose();
            this.____863 = null
        }
        this._roleInfo = null;
        this.____1614 = null;
        this._sceneInfo = null;
        this.____991 = null
    },
});
var ____2409 = cc.Class.extend({
    ____1721: null,
    ____1647: null,
    ____1615: null,
    _sceneInfo: null,
    ____1614: null,
    _tickCount: 0,
    ctor: function(selfPetInfo, controller, selfStateInfo) {
        this.____1721 = selfStateInfo;
        this.____1647 = selfPetInfo;
        this.____1614 = controller;
        this.____1615 = controller.sceneModule;
        this._sceneInfo = controller.sceneInfo;
        this.____1721.addEventListener(____655.____661.____709, this.clientStateChange, this);
        this._sceneInfo.addEventListener(____655.____661.sceneInfo_selectChange, this.selectChange, this)
    },
    ____17: function() {
        this.____1721.removeEventListener(____655.____661.____709, this.clientStateChange, this);
        this._sceneInfo.removeEventListener(____655.____661.sceneInfo_selectChange, this.selectChange, this)
    },
    clientStateChange: function(evt) {
        this.check()
    },
    selectChange: function(evt) {
        this.check()
    },
    check: function() {
        var roleInfo = this._sceneInfo.getCurrentSelectObjInfo();
        var ____667 = this._sceneInfo.scenePlayerList.selfPlayer;
        if (roleInfo != null && this.____1615.attackTester.targetCanBeAttack(roleInfo, false) && (____667.stateInfo.getAttacking() || ____667.stateInfo.getAFK())) {
            this.startAttack()
        } else {
            this.stopAttack()
        }
    },
    startAttack: function() {
        this.____1647.walkStop();
        ____654.____678.____298(this.tick, this)
    },
    stopAttack: function() {
        ____654.____678.____299(this.tick, this)
    },
    tick: function(delta, count) {
        this._tickCount++;
        if (this._tickCount % 3 != 0) return;
        var selfPlayer = this._sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null || !this.____1615.attackTester.selfCanDoAttack()) return;
        var skill = this.getASkill();
        if (skill == null) return;
        var selfP = selfPlayer.____355();
        if (skill.template.isToSelf()) {
            this.____1615.attackTester.petDoAttack(skill, selfPlayer, ____654.____673.____159(selfP.x, selfP.y))
        } else if (skill.template.isForeword()) {
            this.____1615.attackTester.petDoAttack(skill, selfPlayer, selfPlayer.findPointForeword(skill.template.distance - 40))
        } else {
            var target = this._sceneInfo.getCurrentSelectObjInfo();
            if (!this.____1615.attackTester.targetCanBeAttack(target, false)) return;
            var dis = skill.template.distance - 25;
            if (dis < 75) dis = 75;
            if (____654.____674.____179(selfP, target.____355()) < dis + 8) {
                this.____1615.attackTester.petDoAttack(skill, target, null)
            }
        }
    },
    getASkill: function() {
        var list = ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Pet).afkSkillList;
        var len = list.length;
        for (var i = 0; i < len; i++) {
            var skill = list[i];
            if (skill != null && skill.getCanUse()) {
                return skill
            }
        }
        return null
    },
    dispose: function() {
        this.____17();
        this.stopAttack();
        this.____1721 = null;
        this.____1647 = null;
        this.____1615 = null;
        this._sceneInfo = null;
        this.____1614 = null
    },
});
var ____2411 = ____2412.extend({
    ____876: null,
    ____875: true,
    ____6: function() {
        this._super();
        this._roleInfo.stateInfo.addEventListener(____655.____661.____708, this.stateChangeHandler, this);
        this._roleInfo.addEventListener(____655.____661.playerInfo_move, this.____358, this)
    },
    ____17: function() {
        this._super();
        this._roleInfo.stateInfo.removeEventListener(____655.____661.____708, this.stateChangeHandler, this);
        this._roleInfo.removeEventListener(____655.____661.playerInfo_move, this.____358, this)
    },
    stateChangeHandler: function(evt) {
        this.____875 = true;
        this.____1535 = true
    },
    ____358: function(evt) {
        if (this.____876 != null) {
            this.____876.move(this.____1539 + this._roleInfo.____355().x, this.____1540 - this._roleInfo.____355().y)
        }
    },
    updateLabels: function() {
        this._super();
        this.updateBloodLabel()
    },
    updateBloodLabel: function() {
        if (this.____875 == false) return;
        this.____875 = false;
        if (this._roleInfo.stateInfo.getIsFight() && this._roleInfo.sceneModule.attackTester.targetCanBeAttack(this._roleInfo)) {
            if (this.____876 == null) {
                this.____876 = new ____2416(this._roleInfo, ____654.____676.nameContainer)
            }
            this.____876.show()
        } else {
            if (this.____876 != null) {
                this.____876.hide()
            }
        }
    },
    ____344: function() {
        var currentY = 0;
        if (this.____876 != null) {
            this.____876.move(this.____1539 + this._roleInfo.____355().x, this.____1540 - this._roleInfo.____355().y);
            currentY += 20
        }
        if (this._nameLabel != null) {
            this._nameLabel.setPosition(this.____1539, currentY + this.____1540)
        }
    },
    dispose: function() {
        if (this.____876 != null) {
            this.____876.dispose();
            this.____876 = null
        }
        this._super()
    },
});
var ChatPopView = cc.Class.extend({
    ____1539: -1,
    ____1540: -1,
    _container: null,
    _label: null,
    _bg: null,
    _time: 0,
    ctor: function(container, posX, posY) {
        this._container = container;
        this.____1539 = posX;
        this.____1540 = posY;
        this.____5()
    },
    ____5: function() {
        this._bg = ____654.____673.newKYImageView();
        this._bg.setFrame("board/ui_peChatBoard.png");
        this._bg.setScale9Enabled(true);
        this._bg.setCapInsets(____654.____673.____161(40, 25, 1, 1));
        this._bg.setSize(____654.____673.____160(180, 100));
        this._bg.setPosition(____654.____673.____159(this.____1539, this.____1540));
        this._label = ____654.____673.newKYLabel(18, false, ____654.____673.____160(160, 60));
        this._label.setHorizontalAlignment(1);
        this._label.setVerticalAlignment(1);
        this._label.setPosition(____654.____673.____159(this.____1539, this.____1540 + 14))
    },
    show: function(content) {
        this._time = 180;
        ____654.____678.____298(this.tick, this);
        this._label.setString(content);
        if (this._bg.getParent() == null) {
            this._container.addChild(this._bg, 100)
        }
        if (this._label.getParent() == null) {
            this._container.addChild(this._label, 200)
        }
    },
    hide: function() {
        this._bg.removeFromParent(false);
        this._label.removeFromParent(false);
        ____654.____678.____299(this.tick, this)
    },
    tick: function(delta, count) {
        this._time--;
        if (this._time <= 0) {
            this.hide()
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        if (this._label != null) {
            this._label.dispose();
            this._label = null
        }
        if (this._bg != null) {
            this._bg.dispose();
            this._bg = null
        }
        this._container = null
    },
});
var ____2414 = ____2411.extend({
    ____973: null,
    ____1802: null,
    _campIcon: null,
    _marryIcon: null,
    _oathIcon: null,
    ____974: true,
    ____1796: true,
    _campFlag: true,
    _marryFlag: true,
    _oathFlag: true,
    ____5: function() {
        this._super()
    },
    ____6: function() {
        this._super();
        this._roleInfo.figureInfo.addEventListener(____655.____661.playerInfo_club, this.clubNameHandler, this);
        this._roleInfo.addEventListener(____655.____661.playerInfo_titleChange, this.titleChangeHandler, this)
    },
    ____17: function() {
        this._super();
        this._roleInfo.figureInfo.removeEventListener(____655.____661.playerInfo_club, this.clubNameHandler, this);
        this._roleInfo.removeEventListener(____655.____661.playerInfo_titleChange, this.titleChangeHandler, this)
    },
    clubNameHandler: function(evt) {
        this.____974 = true;
        this.____1535 = true
    },
    titleChangeHandler: function(evt) {
        this.____1796 = true;
        this.____1535 = true
    },
    updateLabels: function() {
        this._super();
        this.updateClubName();
        this.updateTitle();
        this.updateCampIcon();
        this.updateMarryIcon();
        this.updateOathIcon()
    },
    updateClubName: function() {
        if (this.____974 == false) return;
        this.____974 = false;
        var show = true;
        if (!____655.allTemplates.copyTemplateList.isShowClubName(____655.copyInfo.currentCopyId)) show = false;
        if (this._roleInfo.figureInfo.clubName == "") show = false;
        if (show) {
            var clubStr = ____654.yuyanbaoManager.getYuyanbao("scene.nameWord1") + this._roleInfo.figureInfo.clubName;
            if (this.____973 == null) {
                this.____973 = ____654.____673.newKYLabel(null, true);
                this.____973.setColor(____655.____659.____688.lightGreen)
            }
            this.____973.setString(clubStr);
            if (this.____973.getParent() == null) {
                this._container.addChild(this.____973)
            }
        } else {
            if (this.____973 != null) {
                this.____973.removeFromParent(false)
            }
        }
    },
    updateTitle: function() {
        if (this.____1796 == false) return;
        this.____1796 = false;
        var show = true;
        if (!____655.allTemplates.copyTemplateList.isShowTitle(____655.copyInfo.currentCopyId)) show = false;
        if (this._roleInfo.currentTitleId <= 0) show = false;
        if (show) {
            if (this.____1802 == null) {
                this.____1802 = new ____2147(this._roleInfo.currentTitleId, this._container)
            } else {
                this.____1802.setTitileId(this._roleInfo.currentTitleId)
            }
            this.____1802.show()
        } else {
            if (this.____1802 != null) {
                this.____1802.hide()
            }
        }
    },
    updateCampIcon: function() {
        if (this._campFlag == false) return;
        this._campFlag = false;
        if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.DALUANDOU_COPYID) {
            if (this._campIcon == null) {
                this._campIcon = ____654.____673.newKYSprite();
                ____654.____676.nameContainer.addChild(this._campIcon);
                this._campIcon.setScale(0.6)
            }
            if (this._roleInfo.warState > 0 && this._roleInfo.warState < 4) {
                this._campIcon.setFrame("flag/ui_campFlag" + this._roleInfo.warState + ".png")
            }
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID) {
            if (this._campIcon == null) {
                this._campIcon = ____654.____673.newKYSprite();
                ____654.____676.nameContainer.addChild(this._campIcon);
                this._campIcon.setScale(0.6)
            }
            if (this._roleInfo.warState == 1) {
                this._campIcon.setFrame("flag/ui_campFlag1.png")
            } else if (this._roleInfo.warState == 2) {
                this._campIcon.setFrame("flag/ui_campFlag3.png")
            }
        } else {
            if (this._campIcon != null) {
                this._campIcon.dispose();
                this._campIcon = null
            }
        }
    },
    updateMarryIcon: function() {
        if (this._marryFlag == false) return;
        this._marryFlag = false;
        if (this._roleInfo.figureInfo.isMarry != 0) {
            if (this._marryIcon == null) {
                this._marryIcon = ____654.____673.newKYSprite();
                ____654.____676.nameContainer.addChild(this._marryIcon);
                this.____344()
            }
            if (this._roleInfo.figureInfo.marryType == 1) {
                this._marryIcon.setFrame("sceneIcon/ui_marryNameIcon1.png")
            } else {
                this._marryIcon.setFrame("sceneIcon/ui_marryNameIcon2.png")
            }
        } else {
            if (this._marryIcon != null) {
                this._marryIcon.dispose();
                this._marryIcon = null
            }
        }
    },
    updateOathIcon: function() {
        if (this._oathFlag == false) return;
        this._oathFlag = false;
        if (this._roleInfo.figureInfo.isOath != 0) {
            if (this._oathIcon == null) {
                this._oathIcon = ____654.____673.newKYSprite();
                ____654.____676.nameContainer.addChild(this._oathIcon);
                this.____344()
            }
            if (this._roleInfo.figureInfo.oathType == 3) {
                this._oathIcon.setFrame("sceneIcon/ui_oathNameIcon1.png")
            } else {
                this._oathIcon.setFrame("sceneIcon/ui_oathNameIcon2.png")
            }
        } else {
            if (this._oathIcon != null) {
                this._oathIcon.dispose();
                this._oathIcon = null
            }
        }
    },
    ____358: function(evt) {
        var currentY = 0;
        if (this.____876 != null) {
            this.____876.move(this.____1539 + this._roleInfo.____355().x, this.____1540 - this._roleInfo.____355().y);
            currentY += 22
        }
        if (this._nameLabel != null) {
            if (this._campIcon != null) {
                this._campIcon.setPosition(this.____1539 + this._roleInfo.____355().x - this._nameLabel.getContentSize().width * 0.5 - 10, currentY + this.____1540 - this._roleInfo.____355().y)
            } else {
                if (this._marryIcon != null) {
                    this._marryIcon.setPosition(this.____1539 + this._roleInfo.____355().x - this._nameLabel.getContentSize().width * 0.5 - 20, currentY + this.____1540 - this._roleInfo.____355().y)
                }
                if (this._oathIcon != null) {
                    this._oathIcon.setPosition(this.____1539 + this._roleInfo.____355().x + this._nameLabel.getContentSize().width * 0.5 + 20, currentY + this.____1540 - this._roleInfo.____355().y)
                }
            }
        }
    },
    ____344: function() {
        var currentY = 0;
        if (this.____876 != null) {
            this.____876.move(this.____1539 + this._roleInfo.____355().x, this.____1540 - this._roleInfo.____355().y);
            currentY += 22
        }
        if (this._nameLabel != null) {
            this._nameLabel.setPosition(this.____1539, currentY + this.____1540);
            if (this._campIcon != null) {
                this._campIcon.setPosition(this.____1539 + this._roleInfo.____355().x - this._nameLabel.getContentSize().width * 0.5 - 10, currentY + this.____1540 - this._roleInfo.____355().y)
            } else {
                if (this._marryIcon != null) {
                    this._marryIcon.setPosition(this.____1539 + this._roleInfo.____355().x - this._nameLabel.getContentSize().width * 0.5 - 20, currentY + this.____1540 - this._roleInfo.____355().y)
                }
                if (this._oathIcon != null) {
                    this._oathIcon.setPosition(this.____1539 + this._roleInfo.____355().x + this._nameLabel.getContentSize().width * 0.5 + 20, currentY + this.____1540 - this._roleInfo.____355().y)
                }
            }
            currentY += 22
        }
        if (this.____973 != null) {
            this.____973.setPosition(this.____1539, currentY + this.____1540);
            currentY += 22
        }
        if (this.____1802 != null) {
            this.____1802.move(this.____1539, currentY + 15 + this.____1540);
            currentY += 40
        }
    },
    setOpacity: function(value) {
        this._super(value);
        if (this.____1802 != null) {
            this.____1802.setOpacity(value)
        }
    },
    show: function() {
        if (this._campIcon != null && this._campIcon.getParent() == null) {
            ____654.____676.nameContainer.addChild(this._campIcon)
        }
        if (this._marryIcon != null && this._marryIcon.getParent() == null) {
            ____654.____676.nameContainer.addChild(this._marryIcon)
        }
        if (this._oathIcon != null && this._oathIcon.getParent() == null) {
            ____654.____676.nameContainer.addChild(this._oathIcon)
        }
        this._super()
    },
    hide: function() {
        if (this._campIcon != null) {
            this._campIcon.removeFromParent(false)
        }
        if (this._marryIcon != null) {
            this._marryIcon.removeFromParent(false)
        }
        if (this._oathIcon != null) {
            this._oathIcon.removeFromParent(false)
        }
        this._super()
    },
    dispose: function() {
        this._super();
        if (this.____973 != null) {
            this.____973.dispose();
            this.____973 = null
        }
        if (this._campIcon != null) {
            this._campIcon.dispose();
            this._campIcon = null
        }
        if (this._marryIcon != null) {
            this._marryIcon.dispose();
            this._marryIcon = null
        }
        if (this._oathIcon != null) {
            this._oathIcon.dispose();
            this._oathIcon = null
        }
        if (this.____1802 != null) {
            this.____1802.dispose();
            this.____1802 = null
        }
    },
});
var ____2416 = cc.Class.extend({
    _bg: null,
    ____861: null,
    _info: null,
    _container: null,
    ____1539: -1,
    ____1540: -1,
    showing: false,
    ctor: function(roleInfo, container) {
        this._container = container;
        this._bg = ____654.____673.newKYSprite();
        this._bg.setFrame("bar/ui_sceneHpBg.png");
        this._bg.setScaleX(0.8);
        this._container.addChild(this._bg);
        this.____861 = ____654.____673.newKYSprite();
        this.____861.setFrame("bar/ui_sceneHpBar.jpg");
        this.____861.setAnchorPoint(____654.____673.anchorPoints[4]);
        this._container.addChild(this.____861);
        this._info = roleInfo;
        this._info.addEventListener(____655.____661.playerInfo_hpUpdate, this.hpUpdateHandler, this);
        this.hpUpdateHandler(null)
    },
    hpUpdateHandler: function(evt) {
        if (this._info.____384() == 0) {
            print("+++++++++++++最大生命值为0！+++++++++++++");
            return
        }
        this.____861.setScaleX(this._info.____386() / this._info.____384() * 3.536)
    },
    ____344: function() {
        if (this._bg != null && this._bg.getParent() != null) {
            this._bg.setPosition(this.____1539, this.____1540)
        }
        if (this.____861 != null && this.____861.getParent() != null) {
            this.____861.setPosition(this.____1539 - 30, this.____1540)
        }
    },
    move: function(x, y) {
        this.____1539 = x;
        this.____1540 = y;
        this.____344()
    },
    show: function() {
        this.showing = true;
        if (this._bg != null && this._bg.getParent() == null) {
            this._container.addChild(this._bg)
        }
        if (this.____861 != null && this.____861.getParent() == null) {
            this._container.addChild(this.____861)
        }
        this.____344();
        this.hpUpdateHandler(null)
    },
    hide: function() {
        this.showing = false;
        if (this._bg != null) {
            this._bg.removeFromParent(false)
        }
        if (this.____861 != null) {
            this.____861.removeFromParent(false)
        }
    },
    dispose: function() {
        this._info.removeEventListener(____655.____661.playerInfo_hpUpdate, this.hpUpdateHandler, this);
        this._container = null;
        this._info = null;
        if (this._bg != null) {
            this._bg.dispose();
            this._bg = null
        }
        if (this.____861 != null) {
            this.____861.dispose();
            this.____861 = null
        }
    },
});
var ____606 = cc.Class.extend({
    _frameCount: 0,
    _numView: null,
    ____1886: 0,
    ____1887: 0,
    ____1619: 0,
    ____1620: 0,
    ____1260: false,
    ____1272: 1,
    _tmpType: 0,
    ____1837: "",
    _container: null,
    ____1274: false,
    ctor: function(container, isScene) {
        this._container = container;
        this.____1274 = isScene
    },
    ____18: function(value, resultType, hitType) {
        if (hitType == 1) {
            this._tmpType = 103;
            this.____1837 = Math.abs(value).toString()
        } else if (hitType == 2) {
            this._tmpType = 104;
            this.____1837 = Math.abs(value).toString()
        } else if (hitType == 4) {
            this._tmpType = 101;
            this.____1837 = value.toString()
        } else if (hitType == 5) {
            this._tmpType = 102;
            this.____1837 = "+" + value.toString()
        }
        if (resultType == ____655.____659.commonStaticType.attackResult_miss) {
            this.____1837 = "m";
            this.____1272 = 1.5
        } else if (resultType == ____655.____659.commonStaticType.attackResult_powerHit) {
            this.____1837 = "b" + this.____1837;
            this.____1272 = 1.5
        }
        this.____1886 = Math.random() * 8 - 4;
        this.____1887 = Math.random() * -3
    },
    play: function() {
        this._numView = new NumberView();
        this._numView.setType(this._tmpType);
        this._container.addChild(this._numView);
        this._numView.setNumber(this.____1837);
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        if (this.____1260 == true) {
            this.dispose();
            return
        }
        this._frameCount++;
        if (this._frameCount < 10) {
            this.move(this.____1619 + this.____1886, this.____1620 + this.____1887 - 4);
            this.setScale(0.4 * this.____1272 + this._frameCount * 0.06)
        } else if (this._frameCount < 20) {
            this.setScale(1 * this.____1272 + (this._frameCount - 10) * 0.03)
        } else if (this._frameCount < 35) {
            this.move(this.____1619 + this.____1886, this.____1620 - 1);
            this.setScale(1.3 * this.____1272 - (this._frameCount - 20) * 0.035)
        }
        if (this._frameCount >= 40) {
            this.dispose()
        }
    },
    move: function(x, y) {
        this.____1619 = x;
        this.____1620 = y;
        if (this._numView != null) this._numView.setPosition(this.____1619, -this.____1620)
    },
    setScale: function(value) {
        if (this._numView != null) {
            this._numView.setScale(value)
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        this.____1260 = true;
        this.____1274 = null;
        if (this._numView != null) {
            this._numView.dispose();
            this._numView = null
        }
    },
});
SceneChenZhu = ____2431.extend({
    _shadowPath: null,
    _chatPopView: null,
    _popTime: 0,
    updateContentSize: function() {
        this.____1003 = ____654.____673.____160(80, 170)
    },
    ____5: function(info, controller) {
        this._super(info, controller);
        this.____1666 = ____654.____673.newKYSprite();
        this._shadowPath = ____654.____675.____139("outPic/cityKing_bg.png");
        ____654.____677.____146(this.____1666, this._shadowPath);
        ____654.____676.mapEffContainer.addChild(this.____1666, 0);
        this.____1666.setPosition(this._info.____355().x, -this._info.____355().y + 38);
        this._chatPopView = new ChatPopView(this, 0, 245);
        ____654.____678.____298(this.chatPopTick, this)
    },
    chatPopTick: function() {
        this._popTime++;
        if (this._popTime >= 900) {
            this._popTime = 0;
            this._chatPopView.show(____654.yuyanbaoManager.getYuyanbao("CityKingChatPop.text" + Math.floor(Math.random() * 6)))
        }
    },
    showShadow: function() {
        return false
    },
    updateCharacterPos: function() {
        if (this.character != null) {
            if (this._info.figureInfo.getHorseFigure()) {
                this.character.move(this._info.____355().x, -(this._info.____355().y - this._info.figureInfo.characterInfo.getYOffset() - 68))
            } else {
                this.character.move(this._info.____355().x, -(this._info.____355().y - 88))
            }
        }
    },
    createFabao: function() {
        this._super();
        this._fabaoBehavior.move(this._info.____355().x + 100, this._info.____355().y - 188)
    },
    createShenJian: function() {
        this._super();
        this._shenjianBehavior.move(this._info.____355().x - 100, this._info.____355().y - 188)
    },
    createZhengLing: function() {
        this._super();
        this.____1889.move(this._info.____355().x, this._info.____355().y - 68)
    },
    ____348: function() {
        if (this.character != null) {
            if (this._info.figureInfo.characterInfo != null) {
                return this._info.figureInfo.characterInfo.getFigureHeight() + 68
            }
        }
        return 203
    },
    dispose: function() {
        ____654.____678.____299(this.chatPopTick, this);
        if (this._shadowPath != null) {
            ____654.____677.removeImageQuote(this._shadowPath, this.____1666);
            this._shadowPath = null
        }
        if (this._chatPopView != null) {
            this._chatPopView.dispose();
            this._chatPopView = null
        }
        this._super()
    },
});
var SceneCollect = ____2428.extend({
    ____1127: null,
    ____349: function() {
        this._super();
        if (this._info.template.picPath != "") {
            this.____1127 = ____654.effectManager.create(parseInt(this._info.template.picPath), true, null, false);
            this.____1127.addTo(____654.____676.characterContainer, 2);
            this.____1127.play()
        }
        this.updateCharacterPos()
    },
    updateCharacterPos: function() {
        if (!!this.____1127) {
            this.____1127.move(this._info.____355().x, this._info.____355().y)
        }
    },
    updateContentSize: function() {
        if (this._info.template.picPath == "") {
            this.____1003 = ____654.____673.____160(0, 0)
        } else {
            this.____1003 = ____654.____673.____160(this._info.template.width, this._info.template.height)
        }
    },
    updateZIndex: function() {
        this._super();
        if (!!this.____1127) {
            this.____1127.setLocalZOrder(this._zIndex)
        }
    },
    ____352: function() {
        this._super();
        if (this.____1127 != null) {
            this.____1127.addToContainer()
        }
    },
    ____353: function() {
        this._super();
        if (this.____1127 != null) {
            this.____1127.removeFromContainer()
        }
    },
    ____348: function() {
        return this._info.template.height + 12
    },
    showShadow: function() {
        if (this._info.template.picPath == "") return false;
        return true
    },
    doMouseClick: function() {
        this._super();
        this._controller.sceneModule.sceneCollectController.collectClick(this)
    },
    dispose: function() {
        this._super();
        if (this.____1127 != null) {
            this.____1127.dispose();
            this.____1127 = null
        }
    },
});
var ____2419 = cc.Class.extend({
    collectList: null,
    sceneController: null,
    sceneInfo: null,
    sceneModule: null,
    ctor: function(sceneModule) {
        this.collectList = {};
        this.sceneModule = sceneModule;
        this.sceneInfo = sceneModule.sceneInfo;
        this.sceneController = sceneModule.sceneController;
        this.sceneInfo.sceneCollectList.addEventListener(____655.____661.sceneInfo_addCollect, this.addCollectHandler, this);
        this.sceneInfo.sceneCollectList.addEventListener(____655.____661.sceneInfo_removeCollect, this.removeCollectHandler, this)
    },
    addCollectHandler: function(evt) {
        var collectInfo = evt.data;
        var collect = new SceneCollect();
        collect.____5(collectInfo, this.sceneController);
        collect.____350(this.sceneModule.roleVisibleTester.checkCollectShow(collectInfo));
        this.collectList[collectInfo.____357()] = collect
    },
    removeCollectHandler: function(evt) {
        this.removeCollect(evt.data["id"], evt.data["playEffect"])
    },
    removeCollect: function(id, playEffect) {
        var collect = this.collectList[id];
        if (collect != null) {
            if (playEffect) {}
            collect.dispose();
            this.collectList[id] = null
        }
    },
    collectClick: function(collect) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        if (collect.____356().canCollect(selfPlayer, true)) {
            this.sceneModule.walkTester.walkToCollect(collect.____356())
        }
    },
    clear: function() {
        for (var i in this.collectList) {
            var c = this.collectList[i];
            if (c != null) {
                c.dispose()
            }
        }
        this.collectList = {}
    },
});
var SceneDrop = ____2428.extend({
    ____1118: null,
    ____1692: -18,
    ____1075: 0,
    _currentR: 0,
    _currentS: 0.2,
    ____349: function() {
        this._super();
        var effectId = ____655.allTemplates.____789.DROP_OTHER;
        if (this._info.itemTemplate.categoryId == ____655.____659.categoryType.COPPER || this._info.itemTemplate.categoryId == ____655.____659.categoryType.DIAOLUOCOPPER) {
            effectId = ____655.allTemplates.____789.DROP_COPPER
        } else if (this._info.itemTemplate.categoryId == ____655.____659.categoryType.XUNBAO_GOLD) {
            effectId = ____655.allTemplates.____789.DROP_XUNBAO_GOLD
        }
        this.____1118 = ____654.effectManager.create(effectId, true, null, false, this._info.itemTemplate.scale);
        this.____1118.addTo(____654.____676.characterContainer);
        this.____1118.play();
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, count) {
        this.____1075 += this.____1692;
        var x = this._info.____355().x,
            y = this._info.____355().y;
        if (this.____1075 >= 0) {
            ____654.____678.____299(this.tick, this);
            this.____1118.move(x, y);
            this.____1118.setRotate(0);
            this.____1118.setScale(1.6);
            return
        }
        this.____1692 += 1;
        this._currentR += 10 + Math.floor(Math.random() * 10);
        if (this._currentS < 1.6) {
            this._currentS += 0.1
        }
        this.____1118.move(x, y + this.____1075);
        this.____1118.setRotate(this._currentR);
        this.____1118.setScale(this._currentS)
    },
    doMouseClick: function() {
        this.____1615.sceneDropController.doDropClick(this)
    },
    ____347: function() {
        return false
    },
    dispose: function() {
        if (this.____1118 != null) {
            this.____1118.dispose();
            this.____1118 = null
        }
        ____654.____678.____299(this.tick, this);
        this._super()
    },
});
var ____2421 = ____591.extend({
    sceneController: null,
    sceneInfo: null,
    dropList: null,
    ctor: function(controller) {
        this._super();
        this.sceneController = controller;
        this.sceneInfo = controller.sceneInfo;
        this.sceneInfo.sceneDropList.addEventListener(____655.____661.sceneInfo_addDrop, this.addDropHandler, this);
        this.sceneInfo.sceneDropList.addEventListener(____655.____661.sceneInfo_removeDrop, this.removeDropHandler, this)
    },
    addDropHandler: function(evt) {
        var dropInfo = evt.data;
        var sceneDrop = new SceneDrop();
        sceneDrop.____5(dropInfo, this.sceneController);
        sceneDrop.____350(true);
        this.dropList[dropInfo.____357()] = sceneDrop
    },
    removeDropHandler: function(evt) {
        var dropInfo = evt.data;
        var dropId = dropInfo.____357();
        var drop = this.dropList[dropId];
        if (drop != null) {
            drop.dispose()
        }
        this.dropList[dropId] = null;
        delete this.dropList[dropId]
    },
    doDropClick: function(drop) {
        this.sceneController.sceneModule.walkTester.walkToDrop(drop.____356())
    },
    clear: function() {
        for (var i in this.dropList) {
            if (this.dropList[i] != null) {
                this.dropList[i].dispose()
            }
        }
        this.dropList = {}
    },
});
var SceneGate = ____2428.extend({
    ____1183: null,
    ____349: function() {
        var id = ____655.allTemplates.____789.gate;
        this.____1183 = ____654.effectManager.create(id, true, null, false);
        this.____1183.addTo(this);
        this.____1183.play()
    },
    doMouseClick: function() {
        this.____1615.sceneGateController.gateClick(this)
    },
    ____347: function() {
        return true
    },
    ____348: function() {
        return 120
    },
    dispose: function() {
        if (this.____1183 != null) {
            this.____1183.dispose();
            this.____1183 = null
        }
        this._super()
    },
});
var ____2423 = cc.Class.extend({
    sceneController: null,
    sceneInfo: null,
    ____1184: null,
    ctor: function(controller) {
        this.sceneController = controller;
        this.sceneInfo = controller.sceneInfo;
        this.____1184 = {};
        this.sceneInfo.sceneGateList.addEventListener(____655.____661.sceneInfo_addGate, this.addGateHandler, this);
        this.sceneInfo.sceneGateList.addEventListener(____655.____661.sceneInfo_removeGate, this.removeGateHandler, this)
    },
    addGateHandler: function(evt) {
        var gateInfo = evt.data;
        if (gateInfo.____55().isHide) return;
        var sceneGate = new SceneGate();
        sceneGate.____5(gateInfo, this.sceneController);
        sceneGate.____350(this.sceneController.sceneModule.roleVisibleTester.checkGateShow(gateInfo));
        this.____1184[gateInfo.____357()] = sceneGate
    },
    removeGateHandler: function(evt) {
        var gateInfo = evt.data;
        var gateId = gateInfo.____357();
        var gate = this.____1184[gateId];
        if (gate != null) {
            gate.dispose()
        }
        this.____1184[gateId] = null
    },
    gateClick: function(gate) {
        this.sceneController.sceneModule.walkTester.walkToGate(gate.____357())
    },
    updateVisibleByPos: function(targetPos) {
        for (var i in this.____1184) {
            var g = this.____1184[i];
            if (g != null) {
                g.____350(this.sceneController.sceneModule.roleVisibleTester.checkGateShow(g.____356(), targetPos))
            }
        }
    },
    clear: function() {
        if (____655.preMapId == ____655.currentMapId) return;
        for (var i in this.____1184) {
            if (this.____1184[i] != null) {
                this.____1184[i].dispose()
            }
        }
        this.____1184 = {}
    },
});
var SceneMonster = ____335.extend({
    ____1127: null,
    ____349: function() {
        this._super();
        if (this._info.characterInfo != null) {
            var figureTemplate = this._info.figureTemplate;
            this.character = new ____545(this._info.characterInfo, this.____209, this);
            this.character.setScale(figureTemplate.getScale());
            var dir = ____655.____659.____686.____95();
            if (this._info.template.face == 1) dir = ____655.____659.____686.rightBottom;
            else if (this._info.template.face == 2) dir = ____655.____659.____686.leftBottom;
            else if (this._info.template.face == 3) dir = ____655.____659.____686.rightTop;
            else if (this._info.template.face == 4) dir = ____655.____659.____686.leftTop;
            this.character.init(dir, ____654.____676.characterContainer, 2)
        } else if (this._info.template.characterType == 2) {
            this.____1127 = ____654.effectManager.create(parseInt(this._info.template.figureId), true, null, false);
            this.____1127.addTo(____654.____676.characterContainer, 2);
            this.____1127.play()
        }
        this.updateCharacterPos()
    },
    ____352: function() {
        this._super();
        if (this.____1127 != null) {
            this.____1127.addToContainer()
        }
    },
    ____353: function() {
        this._super();
        if (this.____1127 != null) {
            this.____1127.removeFromContainer()
        }
    },
    updateCharacterPos: function() {
        if (!!this.character) {
            this.character.move(this._info.____355().x + this._info.figureTemplate.getOffsetX(), -(this._info.____355().y - this._info.figureTemplate.getOffsetY()))
        } else if (!!this.____1127) {
            var info = this.____1127.info;
            if (!!info) {
                this.____1127.move(this._info.____355().x, this._info.____355().y)
            }
        }
    },
    updateZIndex: function() {
        this._super();
        if (!!this.____1127) {
            this.____1127.setLocalZOrder(this._zIndex)
        }
    },
    ____209: function() {
        this.cancelAnima()
    },
    cancelAnima: function() {
        if (this.character != null) {
            if (this._info.isWalking) this.playWalk();
            else this.playStand()
        }
    },
    doMouseClick: function() {
        this.____1615.sceneMonsterController.doMonsterClick(this)
    },
    ____347: function() {
        if (this.____356().template.____347) return true;
        if (this._info.stateInfo.getIsFight()) return true;
        if (this.____1615.sceneInfo.getCurrentSelectObjInfo() == this.____356()) return true;
        return false
    },
    playWalk: function() {
        this.____203(____655.____659.____687.walk)
    },
    playStand: function() {
        this.____203(____655.____659.____687.stand)
    },
    playBehit: function() {},
    playAttack: function() {
        this.____203(____655.____659.____687.attack)
    },
    ____348: function() {
        if (!!this._info && !!this._info.template) {
            if (this._info.template.characterType == 2) {
                if (!!this.____1127 && !!this.____1127.info && this.____1127.info.pHeight > 0) {
                    return this.____1127.info.pHeight
                }
            } else {
                if (!!this._info && !!this._info.figureTemplate) return this._info.figureTemplate.getPicHeight()
            }
        }
        return this._super()
    },
    updateContentSize: function() {
        if (!!this._info && !!this._info.figureTemplate) {
            return this.____1003 = ____654.____673.____160(this._info.figureTemplate.getPicWidth(), this._info.figureTemplate.getPicHeight())
        }
        return this._super()
    },
    selectHandler: function(evt) {
        this._super(evt);
        this.____345()
    },
    inFightState: function() {
        this._super();
        this.____345()
    },
    outFightState: function() {
        this._super();
        this.____345()
    },
    showSelectImg: function() {
        return true
    },
    getSelectViewPath: function() {
        return "ui_redBottom.png"
    },
    dispose: function() {
        if (this.____1127 != null) {
            this.____1127.dispose();
            this.____1127 = null
        }
        this._super()
    },
});
var ____2425 = cc.Class.extend({
    sceneModule: null,
    sceneController: null,
    sceneInfo: null,
    ____1426: null,
    ctor: function(module) {
        this.sceneModule = module;
        this.sceneController = module.sceneController;
        this.sceneInfo = module.sceneInfo;
        this.____1426 = [];
        this.sceneInfo.sceneMonsterList.addEventListener(____655.____661.sceneInfo_addMonster, this.addMonsterHandler, this);
        this.sceneInfo.sceneMonsterList.addEventListener(____655.____661.sceneInfo_removeMonster, this.removeMonsterHandler, this)
    },
    addMonsterHandler: function(evt) {
        var monsterInfo = evt.data;
        var sceneMonster = new SceneMonster();
        sceneMonster.____5(monsterInfo, this.sceneController);
        this.____1426.push(sceneMonster);
        sceneMonster.____350(this.sceneModule.roleVisibleTester.checkMonsterShow(monsterInfo))
    },
    removeMonsterHandler: function(evt) {
        var monsterInfo = evt.data;
        var len = this.____1426.length;
        var monster = null;
        for (var i = 0; i < len; i++) {
            if (this.____1426[i].____356() == monsterInfo) {
                monster = this.____1426[i];
                this.____1426.splice(i, 1);
                break
            }
        }
        if (monster != null) {
            monster.dispose()
        }
    },
    getMonster: function(id) {
        var len = this.____1426.length;
        for (var i = 0; i < len; i++) {
            var monster = this.____1426[i];
            if (monster.____357() == id) return monster
        }
        return null
    },
    doMonsterClick: function(monster) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        this.sceneInfo.setCurrentSelectObjInfo(monster.____356());
        if (!selfPlayer.stateInfo.getAFK()) {
            this.sceneModule.attackTester.startAttack()
        }
    },
    clear: function() {
        var len = this.____1426.length;
        for (var i = 0; i < len; i++) {
            var m = this.____1426[i];
            if (m != null) m.dispose()
        }
        this.____1426 = []
    },
});
var SceneNpc = ____609.extend({
    ____1719: null,
    ____5: function(info, controller) {
        this._super(info, controller);
        this.____1719 = ____654.____673.newKYSprite();
        this.____1719.setPositionY(this.____348() + 50);
        this.taskStateUpdate(null)
    },
    updateContentSize: function() {
        if (this._info.figureTemplate != null) {
            this.____1003 = ____654.____673.____160(this._info.figureTemplate.getPicWidth(), this._info.figureTemplate.getPicHeight())
        } else {
            this._super()
        }
    },
    ____348: function() {
        if (this._info.figureTemplate != null) {
            return this._info.figureTemplate.getPicHeight() + 12
        }
        return this._super()
    },
    ____352: function() {
        this._super();
        if (this.character == null) {
            if (this._info.getCharacterInfo() != null) {
                var figureTemplate = this._info.figureTemplate;
                var template = this._info.____55();
                this.character = new ____545(this._info.getCharacterInfo(), this.____209, this);
                this.updateCharacterPos();
                this.character.setScale(figureTemplate.getScale());
                var dir = ____655.____659.____686.____95();
                if (template.face == 1) dir = ____655.____659.____686.rightBottom;
                else if (template.face == 2) dir = ____655.____659.____686.leftBottom;
                else if (template.face == 3) dir = ____655.____659.____686.rightTop;
                else if (template.face == 4) dir = ____655.____659.____686.leftTop;
                this.character.init(dir, ____654.____676.characterContainer, 2)
            }
        }
        this.____1719.setPositionY(this.____348() + 50)
    },
    updateCharacterPos: function() {
        if (this.character != null) {
            this.character.move(this._info.____355().x + this._info.figureTemplate.getOffsetX(), -(this._info.____355().y - this._info.figureTemplate.getOffsetY()))
        }
    },
    doMouseClick: function() {
        this._super();
        this._controller.sceneModule.sceneNpcController.npcClick(this)
    },
    ____6: function() {
        this._super();
        this._info.addEventListener(____655.____661.sceneInfo_npcState, this.taskStateUpdate, this)
    },
    ____17: function() {
        this._super();
        this._info.removeEventListener(____655.____661.sceneInfo_npcState, this.taskStateUpdate, this)
    },
    taskStateUpdate: function(evt) {
        if (this._info.____1747 == 0) {
            this.____1719.removeFromParent(false)
        } else {
            if (this.____1719.getParent() == null) {
                this.addChild(this.____1719)
            }
            if (this._info.____1747 == 1) {
                this.____1719.setFrame("icon/ui_npcTaskIcon3.png")
            } else if (this._info.____1747 == 2) {
                this.____1719.setFrame("icon/ui_npcTaskIcon2.png")
            } else {
                this.____1719.setFrame("icon/ui_npcTaskIcon1.png")
            }
        }
    },
    showSelectImg: function() {
        return true
    },
    getSelectViewPath: function() {
        return "ui_greenBottom.png"
    },
    dispose: function() {
        if (this.____1719 != null) {
            this.____1719.dispose();
            this.____1719 = null
        }
        this._super()
    },
});
var ____2427 = cc.Class.extend({
    _controller: null,
    sceneInfo: null,
    sceneModule: null,
    ____1465: null,
    ctor: function(sceneController) {
        this._controller = sceneController;
        this.sceneInfo = sceneController.sceneInfo;
        this.sceneModule = sceneController.sceneModule;
        this.____1465 = {};
        this.____6()
    },
    ____6: function() {
        this.sceneInfo.sceneNpcList.addEventListener(____655.____661.sceneInfo_addNpc, this.addNpc, this);
        this.sceneInfo.sceneNpcList.addEventListener(____655.____661.sceneInfo_removeNpc, this.removeNpc, this)
    },
    addNpc: function(evt) {
        var npcInfo = evt.data;
        var sceneNpc = new SceneNpc();
        sceneNpc.____5(npcInfo, this._controller);
        sceneNpc.____350(this._controller.sceneModule.roleVisibleTester.checkNpcShow(npcInfo, this.sceneInfo.scenePlayerList.selfPlayer.____355()));
        this.____1465[npcInfo.____357()] = sceneNpc
    },
    removeNpc: function(evt) {
        var npcInfo = evt.data;
        var npcId = npcInfo.____357();
        var npc = this.____1465[npcId];
        if (npc != null) {
            npc.dispose();
            npc = null
        }
        this.____1465[npcId] = null
    },
    updateVisibleByPos: function(targetPos) {
        for (var i in this.____1465) {
            var n = this.____1465[i];
            if (n != null) {
                n.____350(this._controller.sceneModule.roleVisibleTester.checkNpcShow(n.____356(), targetPos))
            }
        }
    },
    npcClick: function(npc) {
        this.sceneInfo.setCurrentSelectObjInfo(npc.____356());
        this.sceneModule.walkTester.walkToNPC(npc.____357())
    },
    clear: function() {
        if (____655.preMapId == ____655.currentMapId) return;
        for (var i in this.____1465) {
            if (this.____1465[i] != null) {
                this.____1465[i].dispose()
            }
        }
        this.____1465 = {}
    },
});
var ____2429 = ____335.extend({
    ____349: function() {
        this._super();
        if (this._info.characterInfo != null) {
            var figureTemplate = this._info.figureTemplate;
            this.character = new ____545(this._info.characterInfo, this.____209, this);
            this.updateCharacterPos();
            this.character.setScale(figureTemplate.getScale());
            this.character.init(____655.____659.____686.____95(), ____654.____676.characterContainer, 2)
        }
    },
    ____6: function() {
        this._super();
        this._info.addEventListener(____655.____661.sceneInfo_petUpdate, this.petUpdateHandler, this)
    },
    ____17: function() {
        this._super();
        this._info.removeEventListener(____655.____661.sceneInfo_petUpdate, this.petUpdateHandler, this)
    },
    updateCharacterPos: function() {
        if (this.character != null) {
            this.character.move(this._info.____355().x + this._info.figureTemplate.getOffsetX(), -(this._info.____355().y - this._info.figureTemplate.getOffsetY()))
        }
    },
    createNameLabel: function() {
        return new ____2412(this.____356(), this)
    },
    ____348: function() {
        if (this.character != null) {
            if (this._info.characterInfo != null) {
                return this._info.characterInfo.getFigureHeight()
            }
        }
        return 135
    },
    ____209: function() {
        this.cancelAnima()
    },
    playWalk: function() {
        this.____203(____655.____659.____687.walk)
    },
    playStand: function() {
        this.____203(____655.____659.____687.stand)
    },
    playAttack: function() {
        this.____203(____655.____659.____687.attack)
    },
    cancelAnima: function() {
        if (this.character != null) {
            if (this._info.isWalking) this.playWalk();
            else this.playStand()
        }
    },
    petUpdateHandler: function(evt) {
        if (this.____1437 != null) {
            this.____1437.nameChangeHandler(null)
        }
        this.____345(null);
        if (this.character != null) {
            this.character.setScale(this._info.figureTemplate.getScale())
        }
        this.updateCharacterPos()
    },
});
var ____2430 = cc.Class.extend({
    sceneModule: null,
    sceneController: null,
    sceneInfo: null,
    ____1511: null,
    selfPet: null,
    ctor: function(module) {
        this.sceneModule = module;
        this.sceneController = module.sceneController;
        this.sceneInfo = module.sceneInfo;
        this.____1511 = {};
        this.sceneInfo.scenePetList.addEventListener(____655.____661.sceneInfo_addPet, this.addPetHandler, this);
        this.sceneInfo.scenePetList.addEventListener(____655.____661.sceneInfo_removePet, this.removePetHandler, this)
    },
    addPetHandler: function(evt) {
        var petInfo = evt.data;
        var pet = null;
        if (petInfo.ownerId == ____655.____667.userId) {
            this.selfPet = new SelfScenePet();
            pet = this.selfPet
        } else {
            pet = new ____2429()
        }
        pet.____5(petInfo, this.sceneController);
        this.____1511[petInfo.____357()] = pet;
        pet.____350(this.sceneModule.roleVisibleTester.checkPetShow(petInfo))
    },
    removePetHandler: function(evt) {
        var petInfo = evt.data;
        var id = petInfo.____357();
        var pet = this.____1511[id];
        if (pet == this.selfPet) {
            this.selfPet = null
        }
        if (pet != null) {
            pet.dispose()
        }
        this.____1511[id] = null
    },
    getPet: function(id) {
        return this.____1511[id]
    },
    updateFigureList: function() {
        for (var i in this.____1511) {
            var pet = this.____1511[i];
            if (pet != null) {
                pet.____350(this.sceneModule.roleVisibleTester.checkPetShow(pet.____356()))
            }
        }
    },
    clear: function() {
        for (var i in this.____1511) {
            var p = this.____1511[i];
            if (p != null) {
                p.dispose()
            }
        }
        this.____1511 = {};
        this.selfPet = null
    },
});
var ____2432 = cc.Class.extend({
    _controller: null,
    sceneModule: null,
    sceneInfo: null,
    ____1525: null,
    selfPlayer: null,
    chenZhuPlayer: null,
    ctor: function(sceneController) {
        this._controller = sceneController;
        this.sceneModule = sceneController.sceneModule;
        this.sceneInfo = sceneController.sceneInfo;
        this.____1525 = {};
        this.____6()
    },
    ____6: function() {
        this.sceneInfo.scenePlayerList.addEventListener(____655.____661.sceneInfo_addPlayer, this.____420, this);
        this.sceneInfo.scenePlayerList.addEventListener(____655.____661.sceneInfo_removePlayer, this.____421, this);
        this.sceneInfo.scenePlayerList.addEventListener(____655.____661.sceneInfo_chenZhuUpdate, this.chenZhuUpdateHandler, this);
        ____654.____672.addEventListener(____655.____661.setting_showPlayerChange, this.showOtherChangeHandler, this)
    },
    ____422: function(id) {
        return this.____1525[id]
    },
    ____420: function(evt) {
        var info = evt.data;
        var player = null;
        if (info.____357() == ____655.____667.userId) {
            player = new ____2435();
            this.selfPlayer = player
        } else {
            player = new ____2431()
        }
        this.____1525[info.____357()] = player;
        player.____5(info, this._controller);
        player.____350(this.sceneModule.roleVisibleTester.checkPlayerShow(info))
    },
    ____421: function(evt) {
        var info = evt.data;
        var id = info.____357();
        var player = this.____1525[id];
        if (player != null) {
            player.dispose()
        }
        this.____1525[id] = null;
        delete this.____1525[id];
        if (id == ____655.____667.userId) this.selfPlayer = null
    },
    playerClick: function(player) {
        if (player == this.chenZhuPlayer) {
            this.sceneModule.scenePanelController.showCityKingPanel()
        } else {
            var info = player.____356();
            if (this.sceneInfo.getCurrentSelectObjInfo() == info) {
                if (!this.selfPlayer.____356().stateInfo.getAFK()) {
                    this.sceneModule.attackTester.startAttack()
                }
            } else {
                this.sceneInfo.setCurrentSelectObjInfo(info, false)
            }
        }
    },
    chenZhuUpdateHandler: function(evt) {
        if (____655.currentMapId != ____655.allTemplates.mapTemplateList.CITY_ID) return;
        this.createChenZhu()
    },
    createChenZhu: function() {
        if (this.chenZhuPlayer != null) {
            this.chenZhuPlayer.dispose();
            this.chenZhuPlayer = null
        }
        if (this.sceneInfo.scenePlayerList.chenZhuPlayer == null) {
            return
        }
        this.chenZhuPlayer = new SceneChenZhu();
        this.chenZhuPlayer.____5(this.sceneInfo.scenePlayerList.chenZhuPlayer, this._controller);
        this.chenZhuPlayer.____350(true)
    },
    showOtherChangeHandler: function(evt) {
        for (var i in this.____1525) {
            var p = this.____1525[i];
            if (p != null) p.____350(this.sceneModule.roleVisibleTester.checkPlayerShow(p.____356()))
        }
        this.sceneModule.scenePetController.updateFigureList()
    },
    clear: function() {
        for (var i in this.____1525) {
            var p = this.____1525[i];
            if (p != null) p.dispose()
        }
        this.____1525 = {};
        this.selfPlayer = null;
        if (____655.currentMapId != ____655.allTemplates.mapTemplateList.CITY_ID) {
            if (this.chenZhuPlayer != null) {
                this.chenZhuPlayer.dispose();
                this.chenZhuPlayer = null
            }
        }
    },
});
var SelfScenePet = ____2429.extend({
    ____827: null,
    ctor: function() {
        this._super()
    },
    ____5: function(info, controller) {
        this._super(info, controller);
        this.____827 = new ____2409(info, controller, controller.sceneInfo.scenePlayerList.selfPlayer.stateInfo)
    },
    dispose: function() {
        this._super();
        if (this.____827 != null) {
            this.____827.dispose();
            this.____827 = null
        }
    },
});
var ____2435 = ____2431.extend({
    ____1373: null,
    _frameCount: 0,
    ____1377: null,
    ____1220: false,
    ____821: false,
    ____1733: false,
    ____827: null,
    ____989: null,
    ____1263: false,
    ____1652: false,
    ____1120: null,
    ____5: function(info, controller) {
        this._super(info, controller);
        this.____827 = new ____2407(info, controller);
        this.____989 = new ____2408(info, controller);
        this.____1373 = controller.sceneModule.mapController;
        this.____1377 = controller.sceneInfo.sceneMapList.getMap(____655.currentMapId);
        ____655.____667.scenePos = this._info.____355();
        this.____1120 = {};
        ____654.____678.____298(this.tick, this)
    },
    ____6: function() {
        this._super();
        ____655.____667.addEventListener(____655.____661.____703, this.levelUpdateHandler, this);
        this._info.addEventListener(____655.____661.playerInfo_collect, this.collectUpdateHandler, this);
        ____654.____672.addEventListener(____655.____661.common_taskSubmit, this.taskSubmitHandler, this);
        ____654.____672.addEventListener(____655.____661.common_taskAccept, this.taskAcceptHandler, this)
    },
    ____17: function() {
        this._super();
        ____655.____667.removeEventListener(____655.____661.____703, this.levelUpdateHandler, this);
        this._info.removeEventListener(____655.____661.playerInfo_collect, this.collectUpdateHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_taskSubmit, this.taskSubmitHandler, this);
        ____654.____672.removeEventListener(____655.____661.common_taskAccept, this.taskAcceptHandler, this)
    },
    doDead: function() {
        this._super();
        this._info.setCollectId(-1);
        this._info.walkStop();
        this._controller.sceneModule.scenePanelController.showRelivePanel()
    },
    taskSubmitHandler: function(evt) {
        this.____1733 = true
    },
    taskAcceptHandler: function(evt) {
        this.____821 = true
    },
    responseMouse: function() {
        return false
    },
    ____358: function(evt) {
        this._super(evt);
        this.____1373.setFocus();
        ____655.____667.scenePos = this.____355()
    },
    doDrop: function() {
        var delList = [];
        for (var i in this.____1120) {
            this.____1120[i]++;
            if (this.____1120[i] > 30) delList.push(i)
        }
        for (var i = 0; i < delList.length; i++) {
            this.____1615.sceneMessageSender.sendPickup(delList[i]);
            delete this.____1120[delList[i]]
        }
    },
    getADrop: function() {
        return this.____1373.sceneInfo.sceneDropList.getNearlyCanPickup(this.____355())
    },
    tick: function(delta, count) {
        if (this._controller == null) return;
        this._frameCount++;
        if (this.____1220) {
            this.____1220 = false;
            ____654.effectManager.setEffect(____655.allTemplates.____789.UPGRADE, false, null, this, true).setLocalZOrder(10)
        }
        if (this.____821) {
            this.____821 = false;
            ____654.effectManager.setEffect(____655.allTemplates.____789.TASK_ACCEPT, false, null, this, true).setLocalZOrder(10)
        }
        if (this.____1733) {
            this.____1733 = false;
            ____654.effectManager.setEffect(____655.allTemplates.____789.TASK_SUBMIT, false, null, this, true).setLocalZOrder(10)
        }
        this.doDrop();
        if (this._frameCount % 2 == 0) {
            if (!this._info.stateInfo.getIsDead()) {
                var dropItem = this.getADrop();
                if (dropItem != null) {
                    if (____655.itemInfoList.getHasPos(1)) {
                        dropItem.localPickEnable = false;
                        this.____1120[dropItem.____357()] = 0
                    }
                }
            }
        }
        if (this._frameCount % 7 == 0) {
            if (____655.touchWalkValue != 1000) {
                if (this._controller.sceneModule.walkTester.____460()) {
                    if (this._controller.sceneModule.walkTester.fixToNearlyCanwalk()) {
                        var p = ____654.____674.astar.getForeworkCanwalkPoint(this.____355(), ____655.touchWalkValue, 2);
                        if (p != null) {
                            this._controller.sceneModule.walkTester.walkToPoint(____655.currentMapId, p, 0, null, null, false)
                        }
                    }
                }
            }
        }
        if (this._frameCount % 15 == 0) {
            var gate = this._controller.sceneInfo.sceneGateList.getNearlyGate(this._info.____355());
            if (gate != null) {
                if (this.____1263 == true) {
                    if (this.____1652 == false) {
                        this._controller.gotoMap(gate.____357());
                        this.____1652 = true
                    }
                }
            } else {
                this.____1263 = true
            }
            if (!this._info.isWalking && !this._info.stateInfo.getAFK()) {
                this.selectAtarget()
            }
        }
    },
    clearSelectTarget: function() {
        var scobj = this._controller.sceneInfo.getCurrentSelectObjInfo();
        if (scobj != null) {
            var clearDistance = 300;
            if (scobj.____402() == ____655.____659.commonStaticType.soType_monster) {
                clearDistance = 300
            } else if (scobj.____402() == ____655.____659.commonStaticType.soType_player) {
                if (!this._controller.sceneInfo.autoChangeSelect) clearDistance = 1500
            }
            if (____654.____674.____179(this._info.____355(), scobj.____355()) > clearDistance) {
                this._controller.sceneInfo.setCurrentSelectObjInfo(null)
            }
        }
    },
    selectAtarget: function() {
        this.clearSelectTarget();
        var scobj = this._controller.sceneInfo.getCurrentSelectObjInfo();
        if (scobj == null) {
            var select = this._controller.sceneInfo.getNearlySelectRole(this._info.____355());
            this._controller.sceneInfo.setCurrentSelectObjInfo(select);
            if (this._info.stateInfo.getAttacking()) {
                this._controller.sceneModule.attackTester.stopAttack()
            }
        }
    },
    walkCompleteHandler: function(evt) {
        this._super(evt);
        this.clearSelectTarget()
    },
    collectUpdateHandler: function(evt) {
        this.____989.init(this._info.getCollectId())
    },
    levelUpdateHandler: function(evt) {
        this.____1220 = true
    },
    dispose: function() {
        this._super();
        ____654.____678.____299(this.tick, this);
        if (this.____827 != null) {
            this.____827.dispose();
            this.____827 = null
        }
        if (this.____989 != null) {
            this.____989.dispose();
            this.____989 = null
        }
        this.____1373 = null;
        this.____1377 = null
    },
});
var ____2410 = cc.Class.extend({
    _bg: null,
    _pos: null,
    ____1441: null,
    _tickCount: 0,
    ____1611: 1,
    ____1612: null,
    ctor: function(skillId, pos, type) {
        this.____1612 = [6, 6, 6, 6, 6, 6, 5, 5, 5, 5, 4, 4, 4, 3, 3, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
        this._pos = pos;
        this._tickCount = 0;
        this.____1611 = 1.2;
        this._bg = ____654.____673.newKYSprite();
        this._bg.setFrame("scene/ui_skillBg.png");
        ____654.____676.sceneBloodNode.addChild(this._bg);
        var path = "scene/" + ____655.allTemplates.skillTemplateList.getSkillIconPath(skillId, ____655.furnaceInfo.getUseGodWeaponType()) + ".png";
        this.____1441 = ____654.____673.newKYSprite();
        this.____1441.setFrame(path);
        ____654.____676.sceneBloodNode.addChild(this.____1441);
        this.____1441.setOpacity(0);
        var p = ____654.____673.____159(this._pos.x + Math.random() * 60, -this._pos.y + 20 + Math.random() * 100);
        this._bg.setPosition(p);
        this.____1441.setPosition(p);
        ____654.____678.____298(this.tick, this)
    },
    tick: function(deltaTime, tickCount) {
        var len = this.____1612.length;
        if (len > 0) {
            var scale = this.____1612.splice(0, 1)[0];
            this.____1441.setScale(scale * this.____1611);
            var op = this._tickCount / 20 * 255;
            this.____1441.setOpacity(op);
            this._tickCount++
        } else {
            this.dispose()
        }
    },
    dispose: function() {
        ____654.____678.____299(this.tick, this);
        if (this._bg != null) {
            this._bg.dispose();
            this._bg = null
        }
        if (this.____1441 != null) {
            this.____1441.dispose();
            this.____1441 = null
        }
    },
});
var SceneInfo = ____591.extend({
    sceneMapList: null,
    sceneNpcList: null,
    scenePlayerList: null,
    sceneMonsterList: null,
    sceneDropList: null,
    sceneCollectList: null,
    sceneGateList: null,
    scenePetList: null,
    sceneModule: null,
    ____1639: null,
    autoChangeSelect: false,
    ____1061: null,
    afkPathIndex: 0,
    ctor: function(module) {
        this._super();
        this.sceneModule = module;
        this.sceneMapList = new ____2445(this);
        this.sceneNpcList = new ____2449(this);
        this.scenePlayerList = new ____628(this);
        this.sceneMonsterList = new ____2447(this);
        this.sceneDropList = new ____625(this);
        this.sceneCollectList = new ____2439(this);
        this.sceneGateList = new ____2443(this);
        this.scenePetList = new ____2452(this)
    },
    getCurrentSelectObjInfo: function() {
        return this.____1639
    },
    setCurrentSelectObjInfo: function(objInfo, autoChange) {
        if (this.____1639 == objInfo) return;
        if (objInfo != null && objInfo.____357() == ____655.____667.userId && objInfo.____402() == ____655.____659.commonStaticType.soType_player) return;
        if (autoChange == null) autoChange = false;
        this.autoChangeSelect = autoChange;
        if (this.____1639 != null) this.____1639.____408(false);
        this.____1639 = objInfo;
        if (this.____1639 != null) this.____1639.____408(true);
        this.dispatchEvent(new ____590(____655.____661.sceneInfo_selectChange, this, null))
    },
    clearSelectObjWhenDead: function(objInfo) {
        if (this.____1639 != null && this.____1639 == objInfo) {
            this.setCurrentSelectObjInfo(null)
        }
    },
    getCurrentSkill: function() {
        return this.____1061
    },
    setCurrentSkill: function(value) {
        if (this.____1061 == value) return;
        this.____1061 = value
    },
    clearCurrentSkill: function() {
        this.____1061 = null
    },
    getAFKPointAndSetToNextIndex: function() {
        var mapTemp = ____655.allTemplates.mapTemplateList.getMap(____655.currentMapId);
        if (mapTemp.afkPath.length == 0) return null;
        var len = mapTemp.afkPath.length;
        if (this.afkPathIndex < len) {
            var p = mapTemp.afkPath[this.afkPathIndex];
            this.afkPathIndex++;
            return p
        }
        return mapTemp.afkPath[len - 1]
    },
    getAttackableRoleInfo: function(type, id) {
        var role = null;
        if (____655.____659.commonStaticType.soType_player == type) {
            role = this.scenePlayerList.____422(id)
        } else if (____655.____659.commonStaticType.soType_monster == type) {
            role = this.sceneMonsterList.getMonster(id)
        } else if (____655.____659.commonStaticType.soType_pet == type) {
            role = this.scenePetList.getPet(id)
        }
        return role
    },
    getNearlySelectRole: function(p) {
        if (____655.allTemplates.copyTemplateList.walkCompleteSelectPlayer(____655.copyInfo.currentId)) {
            return this.getNearlySelectable(p, true, true, true, true)
        }
        return this.getNearlySelectable(p, false, true, true, false)
    },
    getNearlySelectable: function(p, selectPlayer, selectMonster, selectNpc, selectCollect) {
        var dis = 299;
        var result = null;
        var playerResult = null;
        var monsterResult = null;
        var npcResult = null;
        var collectResult = null;
        if (selectPlayer == true) {
            playerResult = this.scenePlayerList.getNearlyCanattack(p)
        }
        if (selectMonster == true) {
            monsterResult = this.sceneMonsterList.getNearlyCanattack(p)
        }
        if (selectNpc == true) {
            npcResult = this.sceneNpcList.getNearlyNpc(p)
        }
        if (selectCollect == true) {
            collectResult = this.sceneCollectList.getNearlyCanCollect(p)
        }
        var d = 0;
        if (playerResult != null) {
            d = ____654.____674.____179(playerResult.____355(), p);
            if (d < dis) {
                dis = d;
                result = playerResult;
                return result
            }
        }
        if (monsterResult != null) {
            d = ____654.____674.____179(monsterResult.____355(), p);
            if (d < dis) {
                dis = d;
                result = monsterResult
            }
        }
        if (npcResult != null) {
            d = ____654.____674.____179(npcResult.____355(), p);
            if (d < dis) {
                dis = d;
                result = npcResult
            }
        }
        if (collectResult != null) {
            d = ____654.____674.____179(collectResult.____355(), p);
            if (d < dis) {
                dis = d;
                result = collectResult
            }
        }
        return result
    },
    ____145: function() {
        this.clear()
    },
    clear: function() {
        this.afkPathIndex = 0;
        this.setCurrentSelectObjInfo(null);
        this.setCurrentSkill(null);
        this.sceneNpcList.clear();
        this.scenePlayerList.clear();
        this.sceneMonsterList.clear();
        this.sceneDropList.clear();
        this.sceneCollectList.clear();
        this.sceneGateList.clear();
        this.scenePetList.clear()
    },
});
var ____2438 = ____626.extend({
    templateId: 0,
    template: null,
    clientFlag: 0,
    warState: 0,
    count: 1,
    _leftCount: -1,
    ____54: function(templateId) {
        this.templateId = templateId;
        this.template = ____655.allTemplates.collectTemplateList.getCollect(templateId)
    },
    getName: function() {
        if (this._leftCount == -1) return this.template.name;
        return this.template.name + "(" + this._leftCount + ")"
    },
    setCollectLeftCount: function(count) {
        if (this._leftCount == count) return;
        this._leftCount = count;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_nameChange, this, null))
    },
    ____410: function() {
        return ____655.____659.____688.lightGreen
    },
    ____402: function() {
        return ____655.____659.commonStaticType.soType_collect
    },
    setClientFlag: function(value) {
        if (this.template.resetTime > 0) {
            this.clientFlag = value
        }
    },
    canCollect: function(playerInfo, showTip) {
        var flag = 0;
        if (this.clientFlag != 0) flag = 1;
        if (playerInfo.____411() < this.template.minLevel || playerInfo.____411() > this.template.maxLevel) {
            flag = 2
        }
        if (this._leftCount == 0) flag = 3;
        if (!playerInfo.buffInfo.getCanCollect()) flag = 4;
        if (flag == 0) return true;
        if (showTip) {}
        return false
    },
    dispose: function() {
        this.template = null;
        this._super()
    },
});
var ____2439 = ____591.extend({
    collectList: null,
    ____1853: null,
    _frameCount: 0,
    _sceneInfo: null,
    ctor: function(sceneInfo) {
        this._super();
        this._sceneInfo = sceneInfo;
        this.collectList = {};
        this.____1853 = [];
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        this._frameCount++;
        if (this._frameCount == 2) {
            this._frameCount = 0;
            if (this.____1853.length > 0) {
                var collect = this.____1853.splice(0, 1)[0];
                this.dispatchEvent(new ____590(____655.____661.sceneInfo_addCollect, this, collect))
            }
        }
    },
    addCollect: function(item) {
        if (this.collectList[item.____357()] == null) {
            this.collectList[item.____357()] = item;
            this.____1853.push(item)
        }
    },
    removeCollect: function(id, playEffect) {
        if (playEffect == null) playEffect = false;
        var collect = this.collectList[id];
        if (collect != null) {
            ____654.____674.removeItemInArray(this.____1853, collect);
            this.collectList[id] = null;
            if (this._sceneInfo.getCurrentSelectObjInfo() == collect) {
                this._sceneInfo.setCurrentSelectObjInfo(null)
            }
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_removeCollect, this, {
                "id": collect.____357(),
                "playEffect": playEffect
            }));
            collect.dispose()
        }
    },
    removeOutBrost: function(startX, endX, startY, endY) {
        for (var i in this.collectList) {
            var m = this.collectList[i];
            if (m != null) {
                var p = m.____355();
                var tmpx = Math.floor(p.x / ____655.BROAD_WIDTH);
                var tmpy = Math.floor(p.y / ____655.BROAD_HEIGHT);
                if (tmpx < startX || tmpx > endX || tmpy < startY || tmpy > endY) {
                    this.removeCollect(i)
                }
            }
        }
    },
    getCollect: function(id) {
        return this.collectList[id]
    },
    getNearlyCollectByTemplateId: function(pos, templateId) {
        var ____667 = this._sceneInfo.scenePlayerList.selfPlayer;
        if (____667 == null) {
            return null
        }
        var dis = 1000000;
        var result = null;
        for (var i in this.collectList) {
            var collectInfo = this.collectList[i];
            if (collectInfo == null) continue;
            if (templateId != null && collectInfo.templateId != templateId) continue;
            if (!collectInfo.canCollect(____667, false)) continue;
            var d = ____654.____674.____179(collectInfo.____355(), pos);
            if (d < dis) {
                dis = d;
                result = collectInfo
            }
        }
        return result
    },
    getNearlyCanCollect: function(targetPos) {
        var ____667 = this._sceneInfo.scenePlayerList.selfPlayer;
        if (____667 == null) {
            return null
        }
        var dis = 1000000;
        var result = null;
        for (var i in this.collectList) {
            var p = this.collectList[i];
            if (p != null && p.canCollect(____667, false)) {
                var d = ____654.____674.____179(p.____355(), targetPos);
                if (d < dis) {
                    dis = d;
                    result = p
                }
            }
        }
        return result
    },
    clear: function() {
        for (var i in this.collectList) {
            if (this.collectList[i] != null) {
                this.collectList[i].dispose()
            }
        }
        this.collectList = {};
        this.____1853 = []
    },
});
var ____624 = ____626.extend({
    templateId: 0,
    ownerId: 0,
    localPickEnable: true,
    itemTemplate: null,
    ____54: function(templateId) {
        this.templateId = templateId;
        this.itemTemplate = ____655.allTemplates.____794.getItem(this.templateId)
    },
    canPick: function(teamList) {
        if (!this.localPickEnable) return false;
        if (this.ownerId == 0 || this.ownerId == ____655.____667.userId) return true;
        if (teamList != null) {
            for (var i = 0; i < teamList.length; i++) {
                if (this.ownerId == teamList[i].____357()) {
                    return true
                }
            }
        }
        return false
    },
    dispose: function() {
        this.itemTemplate = null;
        this._super()
    },
});
var ____625 = ____591.extend({
    sceneInfo: null,
    sceneModule: null,
    dropList: null,
    ctor: function(sceneInfo) {
        this._super();
        this.sceneInfo = sceneInfo;
        this.sceneModule = sceneInfo.sceneModule;
        this.dropList = {}
    },
    addDrop: function(item) {
        if (this.dropList[item.____357()] == null) {
            this.dropList[item.____357()] = item;
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_addDrop, this, item))
        }
    },
    removeDrop: function(id) {
        var item = this.dropList[id];
        if (item != null) {
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_removeDrop, this, item));
            this.dropList[id] = null;
            item.dispose()
        }
    },
    getDrop: function(id) {
        return this.dropList[id]
    },
    getNearlyCanPickup: function(targetPos) {
        var dis = 1000000;
        var item = null;
        for (var i in this.dropList) {
            var drop = this.dropList[i];
            if (drop != null && drop.canPick()) {
                var d = ____654.____674.____179(drop.____355(), targetPos);
                if (d < dis) {
                    dis = d;
                    item = drop
                }
            }
        }
        return item
    },
    removeOutBrost: function(startX, endX, startY, endY) {
        for (var i in this.dropList) {
            var d = this.dropList[i];
            if (d != null) {
                var p = d.____355();
                var tmpx = Math.floor(p.x / ____655.BROAD_WIDTH);
                var tmpy = Math.floor(p.y / ____655.BROAD_HEIGHT);
                if (tmpx < startX || tmpx > endX || tmpy < startY || tmpy > endY) {
                    this.removeDrop(i)
                }
            }
        }
    },
    clear: function() {
        for (var i in this.dropList) {
            var drop = this.dropList[i];
            if (drop != null) {
                drop.dispose()
            }
        }
        this.dropList = {}
    },
});
var ____2442 = ____626.extend({
    _template: null,
    ctor: function(template) {
        this._super();
        this._template = template
    },
    getName: function() {
        return this._template.getNextMapName()
    },
    ____357: function() {
        return this._template.id
    },
    ____402: function() {
        return ____655.____659.commonStaticType.soType_gate
    },
    ____410: function() {
        return ____655.____659.____688.yellow
    },
    ____55: function() {
        return this._template
    },
    dispose: function() {
        this._template = null;
        this._super()
    },
});
var ____2443 = ____591.extend({
    sceneInfo: null,
    gateList: null,
    ____1084: false,
    ctor: function(sceneInfo) {
        this._super();
        this.sceneInfo = sceneInfo;
        this.gateList = {};
        this.sceneInfo.sceneMapList.addEventListener(____655.____661.sceneInfo_mapData, this.mapDataComplete, this)
    },
    mapDataComplete: function(evt) {
        var mapPath = evt.data;
        if (mapPath != ____655.currentMapDataPath) return;
        if (this.____1084 == true) return;
        this.____1084 = true;
        var tmpList = ____655.allTemplates.gateTemplateList.sceneGateList[____655.currentMapId];
        if (tmpList != null) {
            var len = tmpList.length;
            for (var i = 0; i < len; i++) {
                this.addGate(tmpList[i])
            }
        }
    },
    addGate: function(gateTemplate) {
        var gateInfo = new ____2442(gateTemplate);
        gateInfo.____354(gateTemplate.pos);
        this.gateList[gateInfo.____357()] = gateInfo;
        this.dispatchEvent(new ____590(____655.____661.sceneInfo_addGate, this, gateInfo))
    },
    removeGate: function(id) {
        var gateInfo = this.gateList[id];
        if (gateInfo != null) {
            this.gateList[id] = null;
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_removeGate, this, gateInfo));
            gateInfo.dispose()
        }
    },
    getNearlyGate: function(targetPos) {
        for (var i in this.gateList) {
            var gate = this.gateList[i];
            if (gate != null) {
                var d = ____654.____674.____179(gate.____355(), targetPos);
                if (d < 150) {
                    return gate
                }
            }
        }
        return null
    },
    clear: function() {
        if (____655.preMapId == ____655.currentMapId) return;
        this.____1084 = false;
        for (var i in this.gateList) {
            if (this.gateList[i] != null) {
                this.gateList[i].dispose()
            }
        }
        this.gateList = {}
    },
});
var ____2444 = cc.Class.extend({
    path: 0,
    mapName: "",
    width: 0,
    height: 0,
    maxBroadCountX: 0,
    maxBroadCountY: 0,
    gridSource: null,
    initData: function(data) {
        this.path = data.readInt();
        this.width = data.readInt();
        this.height = data.readInt();
        var gridCountX = data.readShort();
        var gridCountY = data.readShort();
        this.maxBroadCountX = Math.ceil(this.width / ____655.BROAD_WIDTH);
        this.maxBroadCountY = Math.ceil(this.height / ____655.BROAD_HEIGHT);
        this.gridSource = [];
        for (var i = 0; i < gridCountY; i++) {
            var values = [];
            this.gridSource.push(values);
            for (var j = 0; j < gridCountX; j++) {
                values.push(data.readUByte())
            }
        }
    },
    getValue: function(sceneX, sceneY) {
        var gridX = Math.floor(sceneX / ____655.GRID_SIZE);
        var gridY = Math.floor(sceneY / ____655.GRID_SIZE);
        if (gridY >= this.gridSource.length || gridY < 0) return ____655.____659.commonStaticType.mapBlock_empty;
        if (this.gridSource[gridY][gridX] == null) return ____655.____659.commonStaticType.mapBlock_empty;
        return this.gridSource[gridY][gridX]
    },
});
var ____2445 = ____591.extend({
    _sceneInfo: null,
    ____1378: null,
    ctor: function(sceneInfo) {
        this._super();
        this._sceneInfo = sceneInfo;
        this.____1378 = {}
    },
    loadData: function(id) {
        var path = ____655.allTemplates.mapTemplateList.getMap(id).mapDataPath;
        var mapInfo = this.getMap(id);
        var this_ = this;

        function mapConfigComplete(loader) {
            if (this_.____1378[path] != null) {
                ____654.____677.removeBinaryQuote(path, this_);
                return
            }
            var bytes = new ByteArray();
            bytes.____284(loader.data);
            bytes = ____654.____674.____182(bytes);
            var mapInfo = new ____2444();
            mapInfo.initData(bytes);
            this_.____1378[path] = mapInfo;
            if (path == ____655.currentMapDataPath) {
                ____654.____674.astar.____291(mapInfo.gridSource)
            }
            this_.loadMapComplete(path);
            ____654.____677.removeBinaryQuote(path, this_)
        };
        if (mapInfo == null) {
            ____654.____677.loadBinary(____654.____675.getMapConfigPath(path), mapConfigComplete, this)
        } else {
            if (path == ____655.currentMapDataPath) {
                ____654.____674.astar.____291(mapInfo.gridSource)
            }
            this.loadMapComplete(path)
        }
    },
    getMap: function(id) {
        var path = ____655.allTemplates.mapTemplateList.getMap(id).mapDataPath;
        return this.____1378[path]
    },
    loadMapComplete: function(path) {
        this.dispatchEvent(new ____590(____655.____661.sceneInfo_mapData, this, path))
    },
});
var ____2446 = ____621.extend({
    templateId: 0,
    template: null,
    figureTemplate: null,
    characterInfo: null,
    ____1088: 0,
    ____107: function(templateId) {
        this.templateId = templateId;
        this.template = ____655.allTemplates.monsterTemplateList.getMonster(templateId);
        if (this.template == null) print("____2446 找不到怪物ID", this.templateId);
        if (this.template.characterType == 0 || this.template.characterType == 1 || this.template.characterType == 3) {
            this.figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(this.template.figureId);
            this.characterInfo = ____654.getCharacterInfo(this.template.figureId, ____655.____659.____687.stand)
        }
    },
    getHitPos: function() {
        if (this.figureTemplate != null) {
            return ____654.____673.____159(this.____355().x, this.____355().y + this.figureTemplate.getHitPosY())
        }
        return this.____355()
    },
    ____402: function() {
        return ____655.____659.commonStaticType.soType_monster
    },
    ____410: function() {
        if (this.template != null && this.template.isBoss()) {
            return ____655.____659.____688.namePurple
        }
        return ____655.____659.____688.white
    },
    getName: function() {
        if (this.template != null) return this.template.name;
        return ""
    },
    ____411: function() {
        if (this.template != null) return this.template.level;
        return 1
    },
    canBeSelect: function() {
        if (this.template == null) return false;
        if (this._super() == false) return false;
        return this.template.canBeSelect
    },
    ____398: function() {
        if (this.template == null) return false;
        if (this._super() == false) return false;
        return this.template.canBeAttack
    },
    addDeadTickCount: function(count) {
        this.____1088 += count
    },
    ifDeadRemove: function() {
        return this.____1088 >= ____655.monsterDeadRemoveCount
    },
    setHP: function(current, total) {
        this._super(current, total);
        if (this.____1041 <= 0) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.sceneInfo_monsterDead, this, this.____357()))
        }
    },
    getObjServerId: function() {
        return this.sceneModule.sceneInfo.sceneMonsterList.changeMonsterId(this.____357())
    },
    dispose: function() {
        this.template = null;
        this.figureTemplate = null;
        if (this.characterInfo != null) {
            this.characterInfo.dispose();
            this.characterInfo = null
        }
        this._super()
    },
});
var ____2447 = ____591.extend({
    sceneInfo: null,
    sceneModule: null,
    monsterList: null,
    ____1853: null,
    ____1087: null,
    _frameCount: 0,
    ctor: function(sceneInfo) {
        this._super();
        this.sceneInfo = sceneInfo;
        this.sceneModule = sceneInfo.sceneModule;
        this.monsterList = {};
        this.____1853 = [];
        this.____1087 = [];
        ____654.____678.____298(this.tick, this);
        ____654.____672.addEventListener(____655.____661.sceneInfo_monsterDead, this.monsterDeadUpdate, this)
    },
    monsterDeadUpdate: function(evt) {
        var id = evt.data;
        if (id > 0) {
            var select = this.sceneInfo.getCurrentSelectObjInfo();
            if (select != null && select.____357() == id) {
                this.sceneInfo.setCurrentSelectObjInfo(null)
            }
            this.addToDeadList(id)
        }
    },
    tick: function(delta, tickCount) {
        var len = this.____1087.length;
        var monster = null;
        for (var i = len - 1; i >= 0; i--) {
            monster = this.____1087[i];
            monster.addDeadTickCount(tickCount);
            if (monster.ifDeadRemove()) {
                this.monsterList[monster.____357()] = null;
                delete this.monsterList[monster.____357()];
                this.dispatchEvent(new ____590(____655.____661.sceneInfo_removeMonster, this, monster));
                this.____1087.splice(i, 1);
                monster.dispose()
            }
        }
        this._frameCount++;
        if (this._frameCount >= 5) {
            this._frameCount = 0;
            len = this.____1853.length;
            if (len > 0) {
                monster = this.____1853.splice(0, 1)[0];
                if (monster.____386() > 0) {
                    this.dispatchEvent(new ____590(____655.____661.sceneInfo_addMonster, this, monster))
                }
            }
        }
    },
    addMonster: function(info) {
        if (info.____386() <= 0) return;
        this.monsterList[info.____357()] = info;
        this.____1853.push(info)
    },
    removeMonster: function(id) {
        var len = this.____1853.length;
        for (var i = 0; i < len; i++) {
            if (this.____1853[i].____357() == id) {
                this.____1853.splice(i, 1);
                break
            }
        }
        var monterInfo = this.monsterList[id];
        if (monterInfo != null) {
            if (this.sceneInfo.getCurrentSelectObjInfo() == monterInfo) {
                this.sceneInfo.setCurrentSelectObjInfo(null)
            }
            this.removeFromDeadList(monterInfo);
            this.monsterList[id] = null;
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_removeMonster, this, monterInfo));
            monterInfo.dispose()
        }
    },
    removeFromDeadList: function(monsterInfo) {
        for (var i = 0; i < this.____1087.length; i++) {
            if (this.____1087[i] == monsterInfo) {
                this.____1087.splice(i, 1);
                break
            }
        }
    },
    getMonster: function(id) {
        return this.monsterList[id]
    },
    getAFKMonsterNearPoint: function(targetPos) {
        var dis = 1000000;
        var result = null;
        for (var i in this.monsterList) {
            var m = this.monsterList[i];
            if (m != null && m.template.canBeAFKSelect && this.sceneModule.attackTester.monsterCanBeAttack(m, false)) {
                var d = ____654.____674.____179(m.____355(), targetPos);
                if (d < dis) {
                    dis = d;
                    result = m
                }
            }
        }
        if (result != null && !____655.allTemplates.copyTemplateList.isAllBrost(____655.copyInfo.currentId) && dis > ____655.afkRadius) {
            return null
        }
        return result
    },
    getNearlyCanattack: function(targetPos) {
        var dis = 1000000;
        var result = null;
        for (var i in this.monsterList) {
            var p = this.monsterList[i];
            if (p != null && this.sceneModule.attackTester.monsterCanBeAttack(p, false)) {
                var d = ____654.____674.____179(p.____355(), targetPos);
                if (d < dis) {
                    dis = d;
                    result = p
                }
            }
        }
        return result
    },
    addToDeadList: function(id) {
        var t = this.monsterList[id];
        if (t != null) {
            ____654.____674.removeItemInArray(this.____1853, t);
            this.____1087.push(t)
        }
    },
    removeOutBrost: function(startX, endX, startY, endY) {
        for (var i in this.monsterList) {
            var m = this.monsterList[i];
            if (m != null) {
                var p = m.____355();
                var tmpx = Math.floor(p.x / ____655.BROAD_WIDTH);
                var tmpy = Math.floor(p.y / ____655.BROAD_HEIGHT);
                if (tmpx < startX || tmpx > endX || tmpy < startY || tmpy > endY) {
                    this.removeMonster(i)
                }
            }
        }
    },
    changeMonsterId: function(id) {
        return id % 100000000
    },
    clear: function() {
        for (var i in this.monsterList) {
            if (this.monsterList[i] != null) {
                this.monsterList[i].dispose()
            }
        }
        this.monsterList = {};
        this.____1853 = [];
        this.____1087 = []
    },
});
var ____2448 = ____626.extend({
    _template: null,
    _characterInfo: null,
    figureTemplate: null,
    ____1747: 0,
    ____107: function(template) {
        this._template = template;
        if (this._template.characterType == 0 || this._template.characterType == 1 || this._template.characterType == 3) {
            this.figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(this._template.figureId).getFigureTemplate();
            this._characterInfo = ____654.getCharacterInfo(this._template.figureId, ____655.____659.____687.stand)
        }
    },
    ____55: function() {
        return this._template
    },
    getCharacterInfo: function() {
        return this._characterInfo
    },
    getName: function() {
        return this._template.name
    },
    ____410: function() {
        return ____655.____659.____688.lightGreen
    },
    ____357: function() {
        return this._template.templateId
    },
    ____402: function() {
        return ____655.____659.commonStaticType.soType_npc
    },
    setTaskState: function(value) {
        if (this.____1747 == value) {
            return
        }
        this.____1747 = value;
        this.dispatchEvent(new ____590(____655.____661.sceneInfo_npcState, this))
    },
    dispose: function() {
        this._template = null;
        this.figureTemplate = null;
        if (this._characterInfo != null) {
            this._characterInfo.dispose();
            this._characterInfo = null
        }
        this._super()
    },
});
var ____2449 = ____591.extend({
    _sceneInfo: null,
    _frameCount: 0,
    ____1465: null,
    ____1855: null,
    ____1084: false,
    ctor: function(sceneInfo) {
        this._super();
        this._sceneInfo = sceneInfo;
        this.____1465 = {};
        this.____1855 = [];
        this.____6();
        ____654.____678.____298(this.tick, this)
    },
    ____6: function() {
        this._sceneInfo.sceneMapList.addEventListener(____655.____661.sceneInfo_mapData, this.mapDataComplete, this);
        ____654.____672.addEventListener(____655.____661.common_taskSubmit, this.fleshNpcState, this);
        ____654.____672.addEventListener(____655.____661.common_taskStateUpdate, this.taskStateUpdate, this)
    },
    mapDataComplete: function(evt) {
        var mapPath = evt.data;
        if (mapPath != ____655.currentMapDataPath) return;
        if (this.____1084 == true) return;
        this.____1084 = true;
        var list = ____655.allTemplates.npcTemplateList.getNpcByScene(____655.currentMapId);
        if (list != null) {
            var len = list.length;
            for (var i = 0; i < len; i++) {
                this.addNpc(list[i])
            }
        }
        this.fleshNpcState(null)
    },
    tick: function(delta, tickCount) {
        this._frameCount++;
        if (this._frameCount >= 2) {
            this._frameCount = 0;
            if (this._sceneInfo.scenePlayerList.selfPlayer == null) return;
            var len = this.____1855.length;
            if (len > 0) {
                var npcInfo = this.____1855.splice(0, 1)[0];
                this.dispatchEvent(new ____590(____655.____661.sceneInfo_addNpc, this, npcInfo))
            }
        }
    },
    addNpc: function(npcTemplate) {
        var npcInfo = new ____2448();
        npcInfo.____107(npcTemplate);
        npcInfo.____354(____654.____673.____159(npcTemplate.sceneX, npcTemplate.sceneY));
        this.____1855.push(npcInfo);
        this.____1465[npcInfo.____357()] = npcInfo
    },
    removeNpc: function(id) {
        var len = this.____1855.length;
        for (var i = 0; i < len; i++) {
            if (this.____1855[i].____357() == id) {
                this.____1855.splice(i, 1);
                break
            }
        }
        var npcInfo = this.____1465[id];
        if (npcInfo != null) {
            this.____1465[id] = null;
            delete this.____1465[id];
            if (this._sceneInfo.getCurrentSelectObjInfo() == npcInfo) {
                this._sceneInfo.setCurrentSelectObjInfo(null)
            }
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_removeNpc, this, npcInfo));
            npcInfo.dispose()
        }
    },
    getNpcs: function() {
        return this.____1465
    },
    getNearlyNpc: function(targetPos) {
        var dis = 1000000;
        var result = null;
        for (var i in this.____1465) {
            var p = this.____1465[i];
            if (p != null) {
                var d = ____654.____674.____179(p.____355(), targetPos);
                if (d < dis) {
                    dis = d;
                    result = p
                }
            }
        }
        return result
    },
    taskStateUpdate: function(evt) {
        var taskInfo = evt.data;
        if (taskInfo.isNewAccept) {
            this.npcStateChange(this.____1465[taskInfo.____55().acceptNpc]);
            this.npcStateChange(this.____1465[taskInfo.____55().finishNpc])
        } else if (taskInfo.state == ____655.____659.commonStaticType.task_finishNotSubmit) {
            this.npcStateChange(this.____1465[taskInfo.____55().finishNpc])
        }
    },
    npcStateChange: function(npcInfo) {
        var list = null;
        if (npcInfo != null) {
            list = ____655.____670.getNotSumbitByNpcId(npcInfo.____357());
            if (list[0].length > 0) {
                npcInfo.setTaskState(1)
            } else {
                var taskList = ____655.____670.getCanAcceptByNpcId(npcInfo.____357());
                if (taskList.length > 0) {
                    npcInfo.setTaskState(2)
                } else if (list[1].length > 0) {
                    npcInfo.setTaskState(3)
                } else {
                    npcInfo.setTaskState(0)
                }
            }
        }
    },
    fleshNpcState: function(evt) {
        if (evt != null && evt.data != null) {
            var taskComplateInfo = ____655.____670.getCompleteTask(evt.data);
            if (taskComplateInfo == null || (taskComplateInfo.____55().acceptNpc == 0 && taskComplateInfo.____55().finishNpc == 0)) {
                return
            }
        }
        var npcDataList = {};
        var taskList = ____655.____670.currentList;
        for (var k in taskList) {
            var taskInfo = taskList[k];
            if (taskInfo == null) {
                continue
            }
            if (taskInfo.____55().finishNpc != null) {
                var npcInfo = this.____1465[taskInfo.____55().finishNpc];
                if (npcInfo != null) {
                    if (taskInfo.state == ____655.____659.commonStaticType.task_finishNotSubmit) {
                        npcDataList[taskInfo.____55().finishNpc] = 1
                    } else if (taskInfo.state == ____655.____659.commonStaticType.task_acceptNotFinish) {
                        npcDataList[taskInfo.____55().finishNpc] = 2
                    }
                }
            }
        }
        for (var l in this.____1465) {
            var npcInfo = this.____1465[l];
            if (npcInfo != null) {
                if (npcDataList[l] == 1) {
                    npcInfo.setTaskState(1)
                } else {
                    var taskList = ____655.____670.getCanAcceptByNpcId(l);
                    if (taskList.length > 0) {
                        npcInfo.setTaskState(2)
                    } else if (npcDataList[l] == 2) {
                        npcInfo.setTaskState(3)
                    } else {
                        npcInfo.setTaskState(0)
                    }
                }
            }
        }
    },
    clear: function() {
        if (____655.preMapId == ____655.currentMapId) return;
        this.____1084 = false;
        for (var i in this.____1465) {
            if (this.____1465[i] != null) {
                this.____1465[i].dispose()
            }
        }
        this.____1465 = {};
        this.____1855 = []
    },
});
var ____2451 = ____621.extend({
    template: null,
    figureTemplate: null,
    ownerId: 0,
    ____1170: null,
    ____1858: null,
    ____1171: 0,
    characterInfo: null,
    ctor: function(sceneModule) {
        this._super(sceneModule);
        this.____1858 = sceneModule.walkTester
    },
    ____54: function(petId, petFashionId) {
        if (petFashionId != 0 && petFashionId != null) {
            this.template = ____655.allTemplates.fashionTemplateList.getFashion(petFashionId)
        } else if (petId != 0 && petId != null) {
            this.template = ____655.allTemplates.advanceTemplateList.getStageInfo(____655.____659.commonStaticType.style_Pet, petId)
        }
        if (this.template != null) {
            this.figureTemplate = ____655.allTemplates.figureTemplateList.getFigure(this.template.figureId);
            if (this.characterInfo == null) {
                this.characterInfo = new CharacterInfo(this.figureTemplate.getType(), ____655.____659.____687.stand)
            }
            var tmp = this.characterInfo.getStyleList();
            if (tmp == null || tmp[this.figureTemplate.getType()] != this.template.figureId) {
                var styleList = {};
                styleList[this.figureTemplate.getType()] = this.template.figureId;
                this.characterInfo.updateStyle(styleList)
            }
        }
        this.dispatchEvent(new ____590(____655.____661.sceneInfo_petUpdate, this, null))
    },
    getName: function() {
        if (this.template != null) return this.template.name;
        return ""
    },
    ____410: function() {
        return ____655.____659.____688.nameBlue
    },
    ____402: function() {
        return ____655.____659.commonStaticType.soType_pet
    },
    ____411: function() {
        if (this.____1170 == null) return 0;
        return this.____1170.____411()
    },
    canBeSelect: function() {
        return false
    },
    setFollower: function(follower) {
        if (this.____1170 == follower) return;
        if (this.____1170 != null) {
            this.____1170.removeEventListener(____655.____661.playerInfo_move, this.followerMoveHandler, this);
            this.____1170.removeEventListener(____655.____661.playerInfo_dispose, this.followerDisposeHandler, this)
        }
        this.____1170 = follower;
        if (this.____1170 != null) {
            this.____1170.addEventListener(____655.____661.playerInfo_move, this.followerMoveHandler, this);
            this.____1170.addEventListener(____655.____661.playerInfo_dispose, this.followerDisposeHandler, this)
        }
    },
    followerMoveHandler: function(evt) {
        this.____1171 = this.____1171 + 1;
        if (this.____1171 % 4 == 0) {
            var dis = ____654.____674.____179(this.____355(), this.____1170.____355());
            if (dis > ____655.petFollowMaxDistance) {
                var path = [];
                path.push(this.____355());
                var t = this.____1170.____355();
                path.push(____654.____673.____159(t.x, t.y));
                path = this.____1858.cutPathEnd(path, ____655.petFollowDistance);
                this.setPath(path, null, 0)
            }
        }
    },
    followerDisposeHandler: function(evt) {
        this.setFollower(null)
    },
    dispose: function() {
        this.setFollower(null);
        this.template = null;
        this.figureTemplate = null;
        this.____1858 = null;
        if (this.characterInfo != null) {
            this.characterInfo.dispose();
            this.characterInfo = null
        }
        this._super()
    },
});
var ____2452 = ____591.extend({
    sceneInfo: null,
    sceneModule: null,
    selfPet: null,
    ____1511: null,
    ____1855: null,
    _frameCount: 0,
    ctor: function(sceneInfo) {
        this._super();
        this.sceneInfo = sceneInfo;
        this.sceneModule = sceneInfo.sceneModule;
        this.____1511 = {};
        this.____1855 = [];
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        this._frameCount++;
        if (this._frameCount > 6) {
            this._frameCount = 0;
            var pet = this.getSceneHasAdd();
            if (pet != null) {
                this.dispatchEvent(new ____590(____655.____661.sceneInfo_addPet, this, pet))
            }
        }
    },
    addPet: function(petInfo) {
        if (!____655.allTemplates.copyTemplateList.isShowPet(____655.copyInfo.currentId)) {
            petInfo.dispose();
            return
        }
        this.____1511[petInfo.____357()] = petInfo;
        if (petInfo.ownerId == ____655.____667.userId) {
            this.selfPet = petInfo;
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_addPet, this, petInfo))
        } else {
            this.____1855.push(petInfo)
        }
    },
    removePet: function(id) {
        var len = this.____1855.length;
        for (var i = 0; i < len; i++) {
            if (this.____1855[i].____357() == id) {
                this.____1855.splice(i, 1);
                break
            }
        }
        var petInfo = this.____1511[id];
        if (petInfo != null) {
            this.____1511[id] = null;
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_removePet, this, petInfo));
            petInfo.dispose()
        }
    },
    getPet: function(id) {
        return this.____1511[id]
    },
    getSceneHasAdd: function() {
        var len = this.____1855.length;
        for (var i = 0; i < len; i++) {
            var pet = this.____1855[i];
            if (this.sceneInfo.scenePlayerList.playerNotInWaiting(pet.ownerId)) {
                this.____1855.splice(i, 1)[0];
                return pet
            }
        }
        return null
    },
    clear: function() {
        for (var i in this.____1511) {
            var p = this.____1511[i];
            if (p != null) {
                p.dispose()
            }
        }
        this.____1511 = {};
        this.____1855 = [];
        this.selfPet = null
    },
});
var ____628 = ____591.extend({
    sceneInfo: null,
    sceneModule: null,
    ____1525: null,
    ____1855: null,
    _frameCount: 0,
    selfPlayer: null,
    ____1672: 0,
    ____1813: 10,
    chenZhuPlayer: null,
    ctor: function(sceneInfo) {
        this._super();
        this.sceneInfo = sceneInfo;
        this.sceneModule = sceneInfo.sceneModule;
        this.____1525 = {};
        this.____1855 = [];
        ____654.____678.____298(this.tick, this);
        this.____6()
    },
    ____6: function() {},
    updateTotalShowCount: function() {
        if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.DALUANDOU_COPYID || ____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID) {
            this.____1813 = 20
        } else {
            this.____1813 = 10
        }
    },
    tick: function(delta, tickCount) {
        this._frameCount++;
        if (this._frameCount >= 20) {
            this._frameCount = 0;
            var player = this.getAPlayerShowInWaiting();
            if (player != null) {
                this.____1672++;
                this.dispatchEvent(new ____590(____655.____661.sceneInfo_addPlayer, this, player))
            }
        }
    },
    setChenZhuPlayer: function(player) {
        this.chenZhuPlayer = player;
        this.chenZhuPlayer.____354(____654.____673.____159(1841, 1493));
        this.dispatchEvent(new ____590(____655.____661.sceneInfo_chenZhuUpdate, this, player))
    },
    getAPlayerShowInWaiting: function() {
        var result = null;
        if (this.____1672 >= this.____1813) return result;
        var index = -1;
        var len = this.____1855.length;
        for (var i = 0; i < len; i++) {
            if (this.sceneModule.roleVisibleTester.checkPlayerShow(this.____1855[i])) {
                if (this.sceneModule.attackTester.playerCanBeAttack(this.____1855[i], false)) {
                    index = i;
                    break
                } else {
                    if (index == -1) index = i
                }
            }
        }
        if (index > -1) {
            result = this.____1855.splice(index, 1)[0]
        }
        return result
    },
    ____422: function(id) {
        return this.____1525[id]
    },
    ____420: function(player) {
        this.____1525[player.____357()] = player;
        if (player.____357() == ____655.____667.userId) {
            this.updateTotalShowCount();
            this.____1672++;
            this.selfPlayer = player;
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_addPlayer, this, player));
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_selfInfo, this, null))
        } else {
            this.____1855.push(player)
        }
    },
    ____421: function(id) {
        var len = this.____1855.length;
        var inWaiting = false;
        for (var i = 0; i < len; i++) {
            if (this.____1855[i].____357() == id) {
                inWaiting = true;
                this.____1855.splice(i, 1);
                break
            }
        }
        var playerInfo = this.____1525[id];
        if (playerInfo != null) {
            if (!inWaiting) {
                this.____1672--
            }
            this.____1525[id] = null;
            delete this.____1525[id];
            if (this.sceneInfo.getCurrentSelectObjInfo() == playerInfo) {
                this.sceneInfo.setCurrentSelectObjInfo(null)
            }
            this.dispatchEvent(new ____590(____655.____661.sceneInfo_removePlayer, this, playerInfo));
            playerInfo.dispose()
        }
        if (id == ____655.____667.userId) {
            this.selfPlayer = null
        }
    },
    getNearlyCanattack: function(targetPos) {
        var dis = 1000000;
        var result = null;
        for (var i in this.____1525) {
            var p = this.____1525[i];
            if (p != null && p != this.selfPlayer && this.sceneModule.attackTester.targetCanBeAttack(p)) {
                var d = ____654.____674.____179(p.____355(), targetPos);
                if (d < dis) {
                    dis = d;
                    result = p
                }
            }
        }
        return result
    },
    playerNotInWaiting: function(id) {
        var player = this.____1525[id];
        if (player != null && this.____1855.indexOf(player) == -1) {
            return true
        }
        return false
    },
    clear: function() {
        for (var i in this.____1525) {
            if (this.____1525[i] != null) {
                this.____1525[i].dispose()
            }
        }
        this.____1525 = {};
        this.____1855 = [];
        this.____1672 = 0;
        this.selfPlayer = null
    },
});
var ____2456 = ____2451.extend({
    ____410: function() {
        return ____655.____659.____688.yellow
    },
});
var ____632 = ____627.extend({
    ____990: -1,
    ctor: function(figurePlayer, sceneModule) {
        this._super(figurePlayer, sceneModule);
        this.____1856.setSender(sceneModule.sceneMessageSender)
    },
    ____384: function() {
        return this.figureInfo.maxHP
    },
    ____386: function() {
        return this.figureInfo.currentHp
    },
    setHP: function(current, total) {
        this.figureInfo.currentHp = current;
        this.figureInfo.maxHP = total;
        if (this.figureInfo.currentHp > this.____384()) this.figureInfo.currentHp = this.____384();
        if (this.figureInfo.currentHp < 0) this.figureInfo.currentHp = 0;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_hpUpdate, this, null))
    },
    setCollectId: function(id) {
        if (this.____990 == id) return;
        this.____990 = id;
        this.dispatchEvent(new ____590(____655.____661.playerInfo_collect, this, null))
    },
    getCollectId: function() {
        return this.____990
    },
    ____410: function() {
        return ____655.____659.____688.yellow
    },
    findPointForeword: function(dis) {
        var p = this.____355();
        var mapInfo = this.sceneModule.sceneInfo.sceneMapList.getMap(____655.currentMapId);
        if (mapInfo == null) return p;
        var tmpx = Math.cos(this.currentAngle);
        var tmpy = Math.sin(this.currentAngle);
        var mostX = tmpx * dis + p.x;
        var mostY = tmpy * dis + p.y;
        var dx = tmpx * ____655.GRID_SIZE;
        var dy = tmpy * ____655.GRID_SIZE;
        for (var i = 0; i < dis; i += ____655.GRID_SIZE) {
            if (mapInfo.getValue(mostX, mostY) != ____655.____659.commonStaticType.mapBlock_empty) {
                break
            }
            mostX -= dx;
            mostY -= dy
        }
        return ____654.____673.____159(mostX, mostY)
    },
    clearFigureInfo: function() {
        this.figureInfo = null
    },
    dispose: function() {
        print("selfScenePlayerInfo dispose");
        this._super()
    },
});
var FirstPreLoad = cc.Class.extend({
    _hadCall: false,
    _paths: null,
    _tickCount: 0,
    _totalPath: 0,
    _startProgress: 30,
    _heightProgress: 0,
    _addProgress: 0,
    _itemComplete: true,
    loadStart: function() {
        if (this._paths == null) {
            var weaponEffect = ____655.allTemplates.____789.getEffect(____655.allTemplates.____789.WEAPON_TOP_EFFECT);
            this._paths = [
                [weaponEffect.getLoadPath(), ____655.____659.commonStaticType.source_neverClear]
            ];
            this._totalPath = this._paths.length;
            this._addProgress = 60 / this._totalPath
        }
        if (this.isComplete()) return;
        ____654.____678.____298(this.tick, this);
        this.loadNext()
    },
    isComplete: function() {
        if (this._paths == null) return false;
        return this._paths.length <= 0
    },
    loadNext: function() {
        this._tickCount = 10;
        this._itemComplete = false;
        var item = this._paths.splice(0, 1)[0];
        var hasComplete = this._totalPath - this._paths.length;
        this._startProgress = hasComplete * this._addProgress + 30;
        this._heightProgress = (hasComplete + 1) * this._addProgress + 30;
        ____654.____677.____147(item[0], this.loadItemComplate, this, item[1]);
        print(item[0])
    },
    loadItemComplate: function() {
        this._itemComplete = true
    },
    ____307: function() {
        this.setLoadingProgress(98);
        ____654.____678.____299(this.tick, this)
    },
    setLoadingProgress: function(value) {
        ____654.panelQuote.setLoadingPercent(value)
    },
    tick: function(delta, count) {
        this._tickCount--;
        if (this._tickCount > 0) return;
        if (this._startProgress < this._heightProgress) {
            this._startProgress += 0.1;
            this.setLoadingProgress(this._startProgress)
        }
        if (this.isComplete()) {
            this.____307()
        } else {
            if (this._itemComplete) {
                this.loadNext()
            }
        }
    },
});
var ____633 = cc.Class.extend({
    ____1372: null,
    ____1686: null,
    ____1378: null,
    ____1841: null,
    sceneModule: null,
    sceneInfo: null,
    ____1703: 0,
    ____1644: false,
    ____1371: false,
    ____1116: false,
    _frameCount: 0,
    ____1211: false,
    ____1048: null,
    ____1315: -1,
    ____1316: -1,
    _memoryTest: null,
    _percentAdd: 1,
    _hadCallPreLoadMap: false,
    ctor: function(sceneModule) {
        this.sceneModule = sceneModule;
        this.sceneInfo = sceneModule.sceneInfo;
        this.____1372 = ____654.____676.____796;
        this.____1378 = new ____2459(this.____1372, this.sceneInfo);
        this.____1841 = new ____634(____654.____673.____159(0, 0), ____654.____673.____159(0, 0), ____654.____673.____159(100, 80), ____654.____673.____159(____655.____656, ____655.____657));
        this.____1687 = new ____2462(____654.____676.____797);
        ____654.____678.____298(this.tick, this);
        var this_ = this;

        function touchBegan(touch, event) {
            var touchPoint = touch.getLocation();
            this_.____1703 = touchPoint.y;
            return true
        }

        function touchEnded(touch, event) {
            var touchPoint = touch.getLocation();
            var tmpY = touchPoint.y - this_.____1703;
            if (tmpY > 100) {
                this_.sceneModule.walkTester.doRider(true, true)
            } else if (tmpY < -100) {
                this_.sceneModule.walkTester.doRider(false, false)
            } else {
                this_.stageClick(Math.ceil(touchPoint.x), Math.ceil(touchPoint.y))
            }
        }
        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: touchBegan,
            onTouchEnded: touchEnded
        }, this.____1372);
        this.sceneInfo.sceneMapList.addEventListener(____655.____661.sceneInfo_mapData, this.mapDataComplete, this);
        this.sceneInfo.scenePlayerList.addEventListener(____655.____661.sceneInfo_selfInfo, this.setSelfComplete, this)
    },
    getSoController: function() {
        return this.____1687
    },
    stageClick: function(x, y) {
        if (____655.currentMapId == -1) return;
        if (!this.____1644 || !this.____1371) return;
        var p = ____654.____673.____159(x, y);
        p.x = p.x - this.____1372.getPositionX();
        p.y = -(p.y - this.____1372.getPositionY());
        var selectObj = this.____1687.____459(p);
        if (selectObj != null) {
            selectObj.doMouseClick();
            return
        }
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        if (selfPlayer.isWalking && this.sceneModule.walkTester.doubleClickCancel == true && this.sceneModule.walkTester.clickCount == 0) {
            this.sceneModule.walkTester.clickCount++
        } else {
            this.sceneModule.walkTester.walkToPoint(____655.currentMapId, p);
            ____654.effectManager.setEffect(____655.allTemplates.____789.stageClick, true, p, ____654.____676.____798, true)
        }
    },
    tick: function(delta, tickCount) {
        if (____655.currentMapId == -1) return;
        if (!this.____1644 || !this.____1371) return;
        var currentEnterPercent = ____654.panelQuote.getLoadingPercent();
        if (!this._hadCallPreLoadMap && currentEnterPercent > 24) {
            this._hadCallPreLoadMap = true;
            this.____1378.preLoad();
            if (!____654.firstPreLoad.isComplete()) {
                this._percentAdd = 0
            } else this._percentAdd = 1
        }
        if (currentEnterPercent > 0) {
            currentEnterPercent += this._percentAdd;
            ____654.panelQuote.setLoadingPercent(Math.ceil(currentEnterPercent));
            if (currentEnterPercent > 95) {
                currentEnterPercent = 0;
                ____654.panelQuote.setLoadingPercent(currentEnterPercent);
                ____654.panelQuote.hideLoadingPanel();
                this.sceneModule.mapTester.enterMapComplate()
            }
        }
        this.____1687.update();
        if (this.____1116 == true) {
            this.update();
            this._frameCount++;
            if (this._frameCount >= 5) {
                this._frameCount = 0;
                var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
                var currentMapInfo = this.sceneInfo.sceneMapList.getMap(____655.currentMapId);
                if (selfPlayer != null && selfPlayer.stateInfo != null && !selfPlayer.stateInfo.jumping && currentMapInfo != null) {
                    var p = selfPlayer.____355();
                    this.sceneModule.sceneNpcController.updateVisibleByPos(p);
                    this.sceneModule.sceneGateController.updateVisibleByPos(p);
                    if (____655.allTemplates.copyTemplateList.isAllBrost(____655.copyInfo.currentId) == false) {
                        var currentGridX = Math.floor(p.x / ____655.BROAD_WIDTH);
                        var currentGridY = Math.floor(p.y / ____655.BROAD_HEIGHT);
                        if (currentGridX != this.____1315 || currentGridY != this.____1316) {
                            var maxGridX = currentMapInfo.maxBroadCountX;
                            var maxGridY = currentMapInfo.maxBroadCountY;
                            var startX = Math.max(currentGridX - 1, 0);
                            var endX = Math.min(currentGridX + 1, maxGridX);
                            var startY = Math.max(currentGridY - 1, 0);
                            var endY = Math.min(currentGridY + 1, maxGridY);
                            this.sceneInfo.sceneMonsterList.removeOutBrost(startX, endX, startY, endY);
                            this.sceneInfo.sceneCollectList.removeOutBrost(startX, endX, startY, endY);
                            this.sceneInfo.sceneDropList.removeOutBrost(startX, endX, startY, endY)
                        }
                    }
                }
            }
            this.____1116 = false
        }
    },
    update: function() {
        this.____1378.updateMaps(this.____1841.____449(), this.____1841.____447());
        var tmpx = Math.floor(-this.____1841.____447().x + 0.5);
        var tmpy = Math.floor(this.____1841.____447().y + 0.5);
        var p = ____654.____673.____159(tmpx, tmpy + ____655.____657);
        ____654.____676.____354(p)
    },
    mapDataComplete: function(evt) {
        var mapPath = evt.data;
        if (mapPath == ____655.currentMapDataPath && this.____1211 == false) {
            this.____1211 = true;
            this.____1371 = true;
            this.____1048 = this.sceneInfo.sceneMapList.getMap(____655.currentMapId);
            this.____1841.____450(____654.____673.____161(0, 0, this.____1048.width, this.____1048.height));
            this.sceneModule.sceneMessageSender.sendRoundInfo();
            this.checkSelfAndMapComplete();
            ____654.soundManager.updateBackgroundMusic()
        }
    },
    setSelfComplete: function(evt) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        this.____1644 = true;
        this.setFocus();
        this.setFocus();
        this.checkSelfAndMapComplete()
    },
    checkSelfAndMapComplete: function() {
        if (this.____1644 && this.____1371) {
            ____654.panelQuote.setLoadingPercent(15)
        }
    },
    setFocus: function() {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer != null) {
            var tmp = selfPlayer.____355();
            this.____1841.____454(____654.____673.____159(tmp.x, tmp.y - 60));
            this.____1116 = true
        }
    },
    resetScene: function() {
        this.clear();
        this.____1644 = false;
        this.____1371 = false;
        this.____1211 = false;
        this._hadCallPreLoadMap = false;
        this._percentAdd = 1;
        this.loadData()
    },
    loadData: function() {
        if (____655.currentMapId != -1) {
            this.sceneInfo.sceneMapList.loadData(____655.currentMapId)
        }
    },
    clear: function() {
        if (this.____1378 != null) {
            this.____1378.clear()
        }
        this.____1687.clear()
    },
});
var ____2459 = cc.Class.extend({
    _container: null,
    ____1541: null,
    ____1517: null,
    ____1358: null,
    _sceneInfo: null,
    ctor: function(container, sceneInfo) {
        this._container = container;
        this._sceneInfo = sceneInfo;
        this.____1541 = ____654.____673.____161(0, 0, 0, 0);
        this.____1517 = {};
        this.____1358 = [];
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        if (this.____1358.length > 0) {
            var piece = this.____1358[0];
            piece.load();
            this.____1358.splice(0, 1)
        }
    },
    preLoad: function() {
        var mapInfo = this._sceneInfo.sceneMapList.getMap(____655.currentMapId);
        var mapWidth = mapInfo.width;
        var mapHeight = mapInfo.height;
        var endRow = Math.max(Math.floor(mapHeight / ____655.MAP_TILE_SIZE) - 2, 0);
        var endCol = Math.max(Math.floor(mapWidth / ____655.MAP_TILE_SIZE) - 2, 0);
        for (var i = 1; i < endRow; i++) {
            for (var j = 1; j < endCol; j++) {
                var rc = i + "_" + j;
                var pieceData = this.____1517[rc];
                if (pieceData == null) {
                    pieceData = new ____2460(i, j, this._container);
                    this.____1517[rc] = pieceData;
                    this.____1358.push(pieceData)
                }
            }
        }
    },
    updateMaps: function(maxRect, viewRect) {
        if (this.____1541 != null) {
            if ((cc.rectGetMinX(this.____1541) <= cc.rectGetMinX(viewRect)) && (cc.rectGetMaxX(this.____1541) >= cc.rectGetMaxX(viewRect)) && (cc.rectGetMinY(this.____1541) <= cc.rectGetMinY(viewRect)) && (cc.rectGetMaxY(this.____1541) >= cc.rectGetMaxY(viewRect))) return;
            var startRow = Math.floor((viewRect.y - maxRect.y) / ____655.MAP_TILE_SIZE);
            var startCol = Math.floor((viewRect.x - maxRect.x) / ____655.MAP_TILE_SIZE);
            if (startRow < 0) startRow = 0;
            if (startCol < 0) startCol = 0;
            var endRow = Math.ceil((viewRect.y + viewRect.height - maxRect.y) / ____655.MAP_TILE_SIZE);
            var endCol = Math.ceil((viewRect.x + viewRect.width - maxRect.x) / ____655.MAP_TILE_SIZE);
            this.____1541.x = startCol * ____655.MAP_TILE_SIZE;
            this.____1541.y = startRow * ____655.MAP_TILE_SIZE;
            this.____1541.width = (endCol - startCol) * ____655.MAP_TILE_SIZE;
            this.____1541.height = (endRow - startRow) * ____655.MAP_TILE_SIZE;
            for (var key in this.____1517) {
                this.____1517[key].isCurrentShow = false
            }
            for (var i = startRow; i < endRow; i++) {
                for (var j = startCol; j < endCol; j++) {
                    var rc = i + "_" + j;
                    var pieceData = this.____1517[rc];
                    if (pieceData != null) {
                        var index = this.____1358.indexOf(pieceData);
                        if (index > -1) {
                            this.____1358.splice(index, 1);
                            this.____1358.unshift(pieceData)
                        }
                    } else if (pieceData == null) {
                        pieceData = new ____2460(i, j, this._container);
                        this.____1517[rc] = pieceData;
                        this.____1358.unshift(pieceData)
                    }
                    pieceData.isCurrentShow = true
                }
            }
            for (var key in this.____1517) {
                this.____1517[key].flesh()
            }
        }
    },
    clear: function() {
        if (____655.preMapPath == ____655.currentMapPath) return;
        for (var key in this.____1517) {
            this.____1517[key].dispose()
        }
        this.____1517 = {};
        this.____1541 = ____654.____673.____161(0, 0, 0, 0);
        this.____1358 = []
    },
});
var ____2460 = cc.Class.extend({
    row: 0,
    col: 0,
    container: null,
    path: "",
    sprite: null,
    isCurrentShow: false,
    textPath: null,
    ____211: false,
    ctor: function(row, col, container) {
        this.row = row;
        this.col = col;
        this.container = container;
        this.path = this.row + "_" + this.col;
        this.sprite = ____654.____673.newKYSprite();
        this.sprite.setPosition(____655.MAP_TILE_SIZE * (this.col + 0.5), -____655.MAP_TILE_SIZE * (this.row + 0.5));
        this.sprite.setScale((____655.MAP_TILE_SIZE + 1) / 358);
        this.isCurrentShow = false
    },
    load: function() {
        if (this.____211) return;
        this.____211 = true;
        this.textPath = ____654.____675.getMapPiecePath(____655.currentMapPath, this.row, this.col);
        ____654.____677.____146(this.sprite, this.textPath, null, ____655.____659.commonStaticType.source_clearImmedia)
    },
    flesh: function() {
        if (this.isCurrentShow) {
            if (this.sprite.getParent() == null) {
                this.container.addChild(this.sprite)
            }
        } else {
            if (this.sprite.getParent() != null) {
                this.sprite.removeFromParent(false)
            }
        }
    },
    dispose: function() {
        this.container = null;
        if (this.textPath != null) {
            ____654.____677.removeImageQuote(this.textPath, this.sprite);
            this.textPath = null
        }
        if (this.sprite != null) {
            this.sprite.dispose();
            this.sprite = null
        }
    },
});
var ____634 = cc.Class.extend({
    ____1401: null,
    ____1430: null,
    ____1842: null,
    ____1169: null,
    ctor: function(mapSize, focusPoint, movPoint, viewSize) {
        this.____1401 = ____654.____673.____161(0, 0, mapSize.x, mapSize.y);
        this.____1430 = ____654.____673.____161(0, 0, movPoint.x, movPoint.y);
        this.____1842 = ____654.____673.____161(0, 0, viewSize.x, viewSize.y);
        this.____1169 = focusPoint
    },
    ____446: function(w, h) {
        this.____1401.width = w;
        this.____1401.height = h
    },
    ____447: function() {
        return this.____1842
    },
    resetViewRect: function() {
        this.____1842.x = Math.max(this.____1842.x, this.____1401.x);
        this.____1842.x = Math.min(this.____1842.x, this.____1401.x + this.____1401.width - this.____1842.width);
        this.____1842.y = Math.max(this.____1842.y, this.____1401.y);
        this.____1842.y = Math.min(this.____1842.y, this.____1401.y + this.____1401.height - this.____1842.height);
        this.____1430.x = this.____1842.x + (this.____1842.width - this.____1430.width) * 0.5;
        this.____1430.y = this.____1842.y + (this.____1842.height - this.____1430.height) * 0.5
    },
    ____449: function() {
        return this.____1401
    },
    ____450: function(rect) {
        this.____1401 = rect
    },
    ____451: function() {
        return this.____1430
    },
    ____452: function(rect) {
        this.____1430.width = rect.width;
        this.____1430.height = rect.height;
        this.____1430.x = Math.floor(this.____1842.x + (this.____1842.width - this.____1430.width) * 0.5 + 0.5);
        this.____1430.y = Math.floor(this.____1842.y + (this.____1842.height - this.____1430.height) * 0.5 + 0.5)
    },
    ____453: function() {
        return this.____1169
    },
    ____454: function(p) {
        this.____1169 = p;
        var ldx = this.____1169.x - this.____1430.x;
        if (ldx < 0) {
            this.____1842.x = this.____1842.x + ldx
        }
        var rdx = this.____1169.x - (this.____1430.x + this.____1430.width);
        if (rdx > 0) {
            this.____1842.x = this.____1842.x + rdx
        }
        var udy = this.____1169.y - this.____1430.y;
        if (udy < 0) {
            this.____1842.y = this.____1842.y + udy
        }
        var ddy = this.____1169.y - (this.____1430.y + this.____1430.height);
        if (ddy > 0) {
            this.____1842.y = this.____1842.y + ddy
        }
        this.resetViewRect()
    },
});
var ____2462 = cc.Class.extend({
    _container: null,
    _frameCount: 0,
    ____1432: null,
    ____1890: null,
    ____1117: false,
    ctor: function(container) {
        this._container = container;
        this.____1432 = {};
        this.____1890 = [];
        ____654.____678.____298(this.tick, this)
    },
    tick: function(delta, tickCount) {
        for (var key in this.____1432) {
            var so = this.____1432[key];
            if (so != null) {
                var p1 = so.____355();
                var p = ____654.____673.____159(Math.ceil(p1.x), -Math.ceil(p1.y));
                so.setPosition(p)
            }
        }
        this.____1432 = {}
    },
    update: function() {
        this._frameCount++;
        if (this._frameCount >= 5) {
            this._frameCount = 0;
            if (this.____1117 == false) return;
            this.doSort()
        }
    },
    addSceneObj: function(so) {
        this.____457(so)
    },
    ____457: function(so) {
        if (so.getParent() == null && so.____351() == true) {
            this._container.addChild(so);
            this.____1890.push(so)
        }
        this.____1432[so.getObjTypeId()] = so;
        this.____1117 = true
    },
    removeSceneObj: function(so) {
        if (so.getParent() != null) {
            so.removeFromParent(false)
        }
        delete this.____1432[so.getObjTypeId()];
        var index = ____654.____674.____181(this.____1890, so);
        if (index > -1) {
            this.____1890.splice(index, 1)
        }
    },
    doSort: function() {
        var len = this.____1890.length;
        if (len < 2) return;

        function sortFunc(so1, so2) {
            var y1 = so1.____355().y;
            var y2 = so2.____355().y;
            if (y1 != y2) return y1 > y2;
            return so1.____357() > so2.____357()
        }
        this.____1890 = this.____1890.sort(sortFunc);
        for (var i = 0; i < len; i++) {
            this.____1890[i].setZIndex(i * 5)
        }
    },
    ____459: function(pos) {
        var len = this.____1890.length;
        for (var i = len - 1; i >= 0; i--) {
            var childObj = this.____1890[i];
            if (childObj != null && childObj.responseMouse()) {
                var size = childObj.getContentSize();
                var tempPos = childObj.____355();
                var rect = ____654.____673.____161(tempPos.x - size.width / 2, tempPos.y - size.height, size.width, size.height);
                if (cc.rectContainsPoint(rect, pos)) {
                    return childObj
                }
            }
        }
        return null
    },
    clear: function() {},
});
var ____2463 = cc.Class.extend({
    ____1212: false,
    ____1615: null,
    _sceneInfo: null,
    ____1327: -1,
    ____1328: -1,
    ctor: function(module) {
        this.____1615 = module;
        this._sceneInfo = module.sceneInfo;
        this.____1119 = [];
        var this_ = this;

        function mapEnterReturn(bytes) {
            var mapId = bytes.readInt();
            var playerX = bytes.readInt();
            var playerY = bytes.readInt();
            ____655.preMapId = ____655.currentMapId;
            ____655.preMapPath = ____655.currentMapPath;
            ____655.preMapDataPath = ____655.currentMapDataPath;
            ____655.currentMapId = mapId;
            var tmp = ____655.allTemplates.mapTemplateList.getMap(mapId);
            ____655.currentMapPath = tmp.mapPath;
            ____655.currentMapDataPath = tmp.mapDataPath;
            this_.____1212 = false;
            this_.____1615.intoMap(playerX, playerY)
        };

        function mapUserAddReturn(bytes) {
            var len = bytes.readShort();
            for (var mm = 0; mm < len; mm++) {
                var userId = bytes.readNumber();
                if (this_._sceneInfo.scenePlayerList.selfPlayer == null && userId != ____655.____667.userId) return;
                var player = this_._sceneInfo.scenePlayerList.____422(userId);
                var figure = null;
                var isAdd = false;
                if (player == null) {
                    if (userId != ____655.____667.userId) {
                        figure = new ____499();
                        player = new ____627(figure, this_.____1615);
                        figure.userId = userId
                    } else {
                        player = new ____632(____655.____667, this_.____1615);
                        figure = player.figureInfo
                    }
                    isAdd = true
                } else {
                    figure = player.figureInfo
                }
                player.____407(userId);
                player.warState = bytes.readInt();
                var totalHp = bytes.readNumber();
                var currentHp = bytes.readNumber();
                player.setHP(currentHp, totalHp);
                ____654.____685.____188(figure, bytes, player.warState);
                player.speed = bytes.readUByte() / ____655.speedOffset;
                var playerX = bytes.readShort();
                var playerY = bytes.readShort();
                if (bytes.readNumber() > 0) {
                    player.figureInfo.isMarry = 1
                }
                player.figureInfo.marryType = bytes.readByte();
                player.figureInfo.isOath = bytes.readByte();
                player.figureInfo.oathType = bytes.readByte();
                player.setCurrentTitle(bytes.readInt());
                if (isAdd == true) {
                    player.____354(____654.____673.____159(playerX, playerY));
                    this_._sceneInfo.scenePlayerList.____420(player)
                }
                player.stateInfo.____91(bytes.readUInt());
                var buffLen = bytes.readByte();
                for (var i = 0; i < buffLen; i++) {
                    player.buffInfo.addBuffStateItem(bytes.readInt())
                }
                if (buffLen > 0) {
                    player.buffInfo.____83()
                }
                var pathIndex = bytes.readShort();
                var pathLen = bytes.readShort();
                if (pathLen > 0) {
                    var pathList = [];
                    var lastX = 0;
                    var lastY = 0;
                    for (var i = 0; i < pathLen; i++) {
                        lastX = bytes.readShort();
                        lastY = bytes.readShort();
                        if (i > pathIndex) {
                            pathList.push(____654.____673.____159(lastX, lastY))
                        }
                    }
                    if ((lastX != playerX || lastY != playerY) && userId != ____655.____667.userId) {
                        player.setPath(pathList, null, 0)
                    }
                }
                setPet(player)
            }
        };

        function setPet(player) {
            var userId = player.____357();
            if (player.figureInfo.characterInfo.hasPet()) {
                var pet = this_._sceneInfo.scenePetList.getPet(userId);
                var add = false;
                if (pet == null) {
                    if (userId == ____655.____667.userId) {
                        pet = new ____2456(this_.____1615)
                    } else {
                        pet = new ____2451(this_.____1615)
                    }
                    add = true
                }
                var playerStyleList = player.figureInfo.characterInfo.getStyleList();
                pet.____54(playerStyleList[____655.____659.commonStaticType.style_Pet], playerStyleList[____655.____659.commonStaticType.style_fashion_pet]);
                pet.ownerId = userId;
                pet.speed = player.speed;
                pet.____407(userId);
                pet.setFollower(player);
                if (add) {
                    var p = player.____355();
                    pet.____354(____654.____673.____159(p.x - 120 + Math.random() * 240, p.y - 120 + Math.random() * 240));
                    this_._sceneInfo.scenePetList.addPet(pet)
                }
            } else {
                this_._sceneInfo.scenePetList.removePet(userId)
            }
        };

        function playerClubUpdateReturn(bytes) {
            var userId = bytes.readNumber();
            var player = this_._sceneInfo.scenePlayerList.____422(userId);
            if (player != null) {
                player.figureInfo.initClub(bytes)
            }
        };

        function playerNameChangeReturn(bytes) {
            var id = bytes.readNumber();
            var player = this_._sceneInfo.scenePlayerList.____422(id);
            if (player != null) {
                if (bytes.readNumber() > 0) {
                    player.figureInfo.isMarry = 1
                } else {
                    player.figureInfo.isMarry = 0
                }
                player.figureInfo.marryType = bytes.readByte();
                player.figureInfo.isOath = bytes.readByte();
                player.figureInfo.oathType = bytes.readByte();
                player.figureInfo.setNick(bytes.readString())
            }
        };

        function playerStyleReturn(bytes) {
            var id = bytes.readNumber();
            var player = this_._sceneInfo.scenePlayerList.____422(id);
            if (player != null) {
                player.warState = bytes.readInt();
                ____654.____685.____187(player.figureInfo, bytes, player.warState);
                player.speed = bytes.readUByte() / ____655.speedOffset;
                setPet(player)
            }
        };

        function playerTitleReturn(bytes) {
            var id = bytes.readNumber();
            var player = this_._sceneInfo.scenePlayerList.____422(id);
            if (player != null) {
                player.setCurrentTitle(bytes.readUInt())
            }
        };

        function mapUserRemoveReturn(bytes) {
            var len = bytes.readShort();
            for (var mm = 0; mm < len; mm++) {
                var userId = bytes.readNumber();
                if (userId != ____655.____667.userId) {
                    this_._sceneInfo.scenePlayerList.____421(userId);
                    this_._sceneInfo.scenePetList.removePet(userId)
                }
            }
        };

        function monsterUpdateReturn(bytes) {
            var len = bytes.readInt();
            for (var mm = 0; mm < len; mm++) {
                var isAdd = false;
                var id = bytes.readInt();
                var monster = this_._sceneInfo.sceneMonsterList.getMonster(id);
                var templateId = bytes.readInt();
                if (monster == null || monster.____386() <= 0) {
                    monster = new ____2446(this_.____1615);
                    monster.____407(id);
                    isAdd = true
                }
                monster.warState = bytes.readInt();
                monster.____107(templateId);
                var monsterX = bytes.readInt();
                var monsterY = bytes.readInt();
                var totalHp = bytes.readNumber();
                var currentHp = bytes.readNumber();
                monster.setHP(currentHp, totalHp);
                monster.speed = bytes.readByte() / ____655.speedOffset;
                monster.____91(bytes.readUInt());
                var pathLen = bytes.readShort();
                var pathList = [];
                if (pathLen > 0) {
                    var lastX = 0;
                    var lastY = 0;
                    for (var j = 0; j < pathLen; j++) {
                        lastX = bytes.readShort();
                        lastY = bytes.readShort();
                        pathList.push(____654.____673.____159(lastX, lastY))
                    }
                    if (lastX != monsterX || lastY != monsterY) {} else {
                        pathList = []
                    }
                }
                var buffStateLen = bytes.readByte();
                monster.buffInfo.clearBuffStateItems();
                for (var i = 0; i < buffStateLen; i++) {
                    monster.buffInfo.addBuffStateItem(bytes.readUInt())
                }
                monster.buffInfo.____83();
                if (monster.____386() > 0) {
                    if (isAdd) {
                        monster.____354(____654.____673.____159(monsterX, monsterY));
                        this_._sceneInfo.sceneMonsterList.addMonster(monster)
                    }
                    monster.setPath(pathList, null, 0)
                }
            }
        };

        function monsterMoveReturn(bytes) {
            var id = bytes.readInt();
            var monster = this_._sceneInfo.sceneMonsterList.getMonster(id);
            if (monster != null) {
                var currentX = bytes.readShort();
                var currentY = bytes.readShort();
                monster.speed = bytes.readUByte() / ____655.speedOffset;
                var pathLen = bytes.readShort();
                var pathList = [];
                pathList.push(____654.____673.____159(currentX, currentY));
                if (pathLen > 0) {
                    var lastX = 0;
                    var lastY = 0;
                    for (var j = 0; j < pathLen; j++) {
                        lastX = bytes.readShort();
                        lastY = bytes.readShort();
                        pathList.push(____654.____673.____159(lastX, lastY))
                    }
                    if (lastX != currentX || lastY != currentY) {} else {
                        pathList = []
                    }
                }
                if (monster.____386() > 0) {
                    monster.setPath(pathList, null, 0)
                }
            } else {
                this_.sendMonsterMove(id)
            }
        };

        function monsterRemoveReturn(bytes) {
            var id = bytes.readInt();
            print("删除怪物", id);
            this_._sceneInfo.sceneMonsterList.removeMonster(id)
        };

        function buffUpdateReturn(bytes) {
            var type = bytes.readUByte();
            var id = bytes.readNumber();
            var roleInfo = this_._sceneInfo.getAttackableRoleInfo(type, id);
            if (roleInfo != null) {
                var len = bytes.readUShort();
                for (var i = 0; i < len; i++) {
                    var buffId = Math.floor(bytes.readUInt() / 100);
                    if (bytes.readBoolean()) {
                        var buff = roleInfo.buffInfo.____85(buffId);
                        if (buff == null) {
                            buff = new ____515();
                            buff.____107(buffId);
                            roleInfo.buffInfo.addBuff(buff)
                        }
                    } else {
                        roleInfo.buffInfo.____82(buffId)
                    }
                }
                roleInfo.buffInfo.____83()
            }
        };

        function buffStateUpdateReturn(bytes) {
            var type = bytes.readUByte();
            var id = bytes.readNumber();
            var roleInfo = this_._sceneInfo.getAttackableRoleInfo(type, id);
            if (roleInfo != null) {
                var len = bytes.readByte();
                print("收到buff状态更新", len);
                roleInfo.buffInfo.clearBuffStateItems();
                for (var i = 0; i < len; i++) {
                    roleInfo.buffInfo.addBuffStateItem(bytes.readUInt())
                }
                roleInfo.buffInfo.____83()
            }
        };

        function playerMoveReturn(bytes) {
            var userId = bytes.readNumber();
            if (userId == ____655.____667.userId) return;
            var player = this_._sceneInfo.scenePlayerList.____422(userId);
            if (player != null) {
                var pathIndex = bytes.readShort();
                var len = bytes.readShort();
                var path = [];
                for (var i = 0; i < len; i++) {
                    var tmpx = bytes.readShort();
                    var tmpy = bytes.readShort();
                    if (i > pathIndex) {
                        path.push(____654.____673.____159(tmpx, tmpy))
                    }
                }
                if (path.length == 1) {
                    var tarPos = path[0],
                        p = player.____355();
                    if (!!tarPos) {
                        var distance = ____654.____674.____179(tarPos, p);
                        if (distance > 100) {
                            var playerView = this_.____1615.scenePlayerController.____422(userId);
                            if (playerView != null) {
                                playerView.stopAttack()
                            }
                        }
                    }
                }
                player.setPath(path)
            }
        };

        function collectUpdateReturn(bytes) {
            var len = bytes.readShort();
            for (var mm = 0; mm < len; mm++) {
                var id = bytes.readInt();
                var state = bytes.readByte();
                if (state != 0) {
                    var warState = bytes.readInt();
                    var item = this_._sceneInfo.sceneCollectList.getCollect(id);
                    var templateId = bytes.readInt();
                    if (item == null) {
                        item = new ____2438();
                        item.____407(id);
                        item.____54(templateId)
                    }
                    item.warState = warState;
                    item.____354(____654.____673.____159(bytes.readUShort(), bytes.readUShort()));
                    this_._sceneInfo.sceneCollectList.addCollect(item)
                } else {
                    this_._sceneInfo.sceneCollectList.removeCollect(id, true)
                }
            }
        };

        function targetAttackReturn(bytes) {
            if (this_._sceneInfo.scenePlayerList.selfPlayer == null) return;
            var roleList = [];
            var behaviorInfo = new ____2399();
            behaviorInfo.attackType = bytes.readByte();
            behaviorInfo.attackId = bytes.readNumber();
            behaviorInfo.skillId = bytes.readInt();
            behaviorInfo.skillLevel = bytes.readUByte();
            behaviorInfo.targetId = bytes.readNumber();
            behaviorInfo.targetType = bytes.readUByte();
            behaviorInfo.skillX = bytes.readInt();
            behaviorInfo.skillY = bytes.readInt();
            behaviorInfo.attackState = bytes.readUInt();
            var attackRoleInfo = this_._sceneInfo.getAttackableRoleInfo(behaviorInfo.attackType, behaviorInfo.attackId);
            if (attackRoleInfo != null) {
                behaviorInfo.attackName = attackRoleInfo.getName();
                var skillTemp = ____655.allTemplates.skillTemplateList.getSkill(behaviorInfo.skillId);
                if (behaviorInfo.attackId != ____655.____667.userId || ____655.allTemplates.____789.isFlash(skillTemp.attackEffect)) {
                    attackRoleInfo.doAttackBehavior(behaviorInfo)
                }
                attackRoleInfo.____91(behaviorInfo.attackState)
            }
            var behitLen = bytes.readInt();
            for (var mm = 0; mm < behitLen; mm++) {
                var behitInfo = new ____2403();
                behitInfo.behitId = bytes.readNumber();
                behitInfo.behitType = bytes.readByte();
                var behitRole = this_._sceneInfo.getAttackableRoleInfo(behitInfo.behitType, behitInfo.behitId);
                var tmpHp = 0;
                if (behitRole != null) {
                    tmpHp = behitRole.____386();
                    behitInfo.behitName = behitRole.getName();
                    roleList.push(behitRole)
                }
                var bloodLen = bytes.readShort();
                for (var j = 0; j < bloodLen; j++) {
                    behitInfo.currentHp = bytes.readNumber();
                    var dp = 0;
                    if (behitRole != null) {
                        dp = behitInfo.currentHp - tmpHp
                    }
                    tmpHp = behitInfo.currentHp;
                    behitInfo.dHps.push(dp);
                    behitInfo.behitResult.push(bytes.readShort())
                }
                if (behitRole != null) {
                    behitRole.setHP(behitInfo.currentHp, behitRole.____384())
                }
                behitInfo.isHitBack = bytes.readByte();
                if (behitInfo.isHitBack > 0) {
                    behitInfo.hitBackPos = ____654.____673.____159(bytes.readShort(), bytes.readShort())
                }
                behitInfo.serverState = bytes.readUInt();
                behaviorInfo.behitRoles.push(behitInfo)
            }
            for (var i = 0; i < roleList.length; i++) {
                roleList[i].doBehitBehavior(behaviorInfo)
            }
        };

        function serverStateReturn(bytes) {
            var id = bytes.readNumber();
            var type = bytes.readByte();
            var state = bytes.readUInt();
            var attackRole = this_._sceneInfo.getAttackableRoleInfo(type, id);
            if (attackRole != null) {
                attackRole.stateInfo.____91(state)
            }
        };

        function targetUpdateBloodReturn(bytes) {
            var type = bytes.readByte();
            var id = bytes.readNumber();
            var roleInfo = this_._sceneInfo.getAttackableRoleInfo(type, id);
            var showAction = bytes.readBoolean();
            var currentHp = bytes.readNumber();
            var totalHp = bytes.readNumber();
            if (roleInfo != null && roleInfo == this_._sceneInfo.scenePlayerList.selfPlayer && showAction) {
                var hp = currentHp - roleInfo.____386();
                if (hp != 0) {
                    var bloodBehavior = new ____2404(roleInfo, this_.____1615.sceneController);
                    bloodBehavior.init([hp], [____655.____659.commonStaticType.attackResult_common], 5)
                }
            }
            if (roleInfo != null) {
                roleInfo.setHP(currentHp, totalHp)
            }
        };

        function playerUpgradeReturn(bytes) {
            var id = bytes.readNumber();
            var level = bytes.readShort();
            var totalHp = bytes.readNumber();
            var currentHp = bytes.readNumber();
            var levelUpTime = bytes.readInt() * 1000;
            var player = this_._sceneInfo.scenePlayerList.____422(id);
            if (player == null) return;
            if (id == ____655.____667.userId) {
                ____655.____667.levelUpTime = levelUpTime;
                player.setHP(currentHp, totalHp);
                ____655.____667.____64(level)
            } else {
                player.figureInfo.____64(level)
            }
        };

        function dropItemAddReturn(bytes) {
            var len = bytes.readInt();
            for (var mm = 0; mm < len; mm++) {
                var id = bytes.readInt();
                var item = this_._sceneInfo.sceneDropList.getDrop(id);
                if (item == null) {
                    item = new ____624(this_.____1615);
                    item.____407(id)
                }
                item.____54(bytes.readInt());
                item.ownerId = bytes.readNumber();
                item.____354(____654.____673.____159(bytes.readInt(), bytes.readInt()));
                this_._sceneInfo.sceneDropList.addDrop(item)
            }
        };

        function dropItemRemoveReturn(bytes) {
            var len = bytes.readInt();
            for (var mm = 0; mm < len; mm++) {
                var id = bytes.readInt();
                this_._sceneInfo.sceneDropList.removeDrop(id)
            }
        };

        function dropItemUpdateReturn(bytes) {
            var id = bytes.readInt();
            var drop = this_._sceneInfo.sceneDropList.getDrop(id);
            if (drop != null) {
                drop.ownerId = bytes.readNumber()
            }
        };

        function playerHorseUpReturn(bytes) {
            var id = bytes.readNumber();
            var player = this_._sceneInfo.scenePlayerList.____422(id);
            if (player != null) {
                player.figureInfo.setIsHorse(bytes.readBoolean());
                player.speed = bytes.readByte() / ____655.speedOffset;
                var pet = this_._sceneInfo.scenePetList.getPet(id);
                if (pet != null) {
                    pet.speed = player.speed
                }
            }
        };

        function playerReliveReturn(bytes) {
            var userId = bytes.readNumber();
            var currentX = bytes.readInt();
            var currentY = bytes.readInt();
            var currentHp = bytes.readNumber();
            var player = this_._sceneInfo.scenePlayerList.____422(userId);
            if (player != null) {
                player.setHP(currentHp, player.____384());
                player.walkStop();
                player.____354(____654.____673.____159(currentX, currentY), true);
                var pet = this_._sceneInfo.scenePetList.getPet(userId);
                if (pet != null) {
                    pet.____354(____654.____673.____159(currentX - 120 + Math.random() * 240, currentY - 120 + Math.random() * 240))
                }
                player.stateInfo.setServerCommon();
                if (userId == ____655.____667.userId) {
                    this_.____1615.scenePanelController.hideRelivePanel()
                }
            }
        };

        function playerJumpReturn(bytes) {
            var userId = bytes.readNumber();
            var type = bytes.readByte();
            var jumpType = bytes.readByte();
            var p = ____654.____673.____159(bytes.readShort(), bytes.readShort());
            var roleView = this_.____1615.getAttackableRole(type, userId);
            if (roleView != null) {
                roleView.doJump(p, jumpType)
            } else {
                var roleInfo = this_._sceneInfo.getAttackableRoleInfo(type, userId);
                if (roleInfo != null) {
                    roleInfo.____354(p)
                }
            }
        };

        function sceneWordReturn(bytes) {
            var desId = bytes.readInt();
            ____654.tipsManager.quickTip.showScene(____654.____682.____108(desId))
        };

        function lianZhanReturn(bytes) {
            this_.____1615.scenePanelController.setLianZhan(bytes.readShort())
        };

        function collectStateReturn(bytes) {
            var len = bytes.readShort();
            for (var i = 0; i < len; i++) {
                var id = bytes.readNumber();
                var player = this_._sceneInfo.scenePlayerList.____422(id);
                if (player != null) {
                    var collectTemplateId = bytes.readInt();
                    player.setCollectTemplateId(collectTemplateId);
                    if (player == this_._sceneInfo.scenePlayerList.selfPlayer && collectTemplateId == 0) {
                        player.setCollectId(-1)
                    }
                }
            }
        };

        function cityKingReturn(bytes) {
            var serverId = bytes.readShort();
            var userId = bytes.readNumber();
            var player = this_._sceneInfo.scenePlayerList.chenZhuPlayer;
            var figure = null;
            if (player == null) {
                figure = new ____499();
                player = new ____627(figure, this_.____1615)
            } else {
                figure = player.figureInfo
            }
            figure.userId = userId;
            player.____407(userId);
            figure.serverId = serverId;
            figure.nick = bytes.readString();
            player.currentTitleId = bytes.readInt();
            figure.career = bytes.readByte();
            figure.vipLevel = bytes.readByte();
            figure.level = bytes.readShort();
            figure.xianwei = bytes.readByte();
            figure.combat = bytes.readUInt();
            ____654.____685.____187(figure, bytes);
            figure.clubName = bytes.readString();
            figure.marryType = bytes.readByte();
            figure.oathType = bytes.readByte();
            if (figure.marryType > 0) {
                figure.isMarry = 1
            }
            if (figure.oathType > 0) {
                figure.isOath = 1
            }
            this_._sceneInfo.scenePlayerList.setChenZhuPlayer(player)
        };

        function cityKingMobaiReturn(bytes) {
            ____655.statInfo.mobaiCount = bytes.readByte()
        };

        function playerFixPosReturn(bytes) {
            var playerId = bytes.readNumber();
            var posX = bytes.readShort();
            var posY = bytes.readShort();
            var player = this_._sceneInfo.scenePlayerList.____422(playerId);
            if (player != null) {
                player.____354(____654.____673.____159(posX, posY))
            }
        };
        ____654.____680.addSocketHandler(____655.____659.____691.MAP_ENTER, mapEnterReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MAP_USER_ADD, mapUserAddReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MAP_USER_REMOVE, mapUserRemoveReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MAP_MONSTER_UPDATE, monsterUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MAP_MONSTER_MOVE, monsterMoveReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.MAP_MONSTER_REMOVE, monsterRemoveReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_MOVE, playerMoveReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COLLECT_UPDATE, collectUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TARGET_ATTACK, targetAttackReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.TARGET_UPDATE_BLOOD, targetUpdateBloodReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_UPGRADE, playerUpgradeReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.DROPITEM_ADD, dropItemAddReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.DROPITEM_REMOVE, dropItemRemoveReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.DROPITEM_UPDATE, dropItemUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.SERVERSTATE_UPDATE, serverStateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_STYLE_UPDATE, playerStyleReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_NAME_CHANGE, playerNameChangeReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_MAP_TITLE, playerTitleReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_CLUB_UPDATE, playerClubUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.HORSE_UP, playerHorseUpReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_RELIVE, playerReliveReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_JUMP, playerJumpReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.SCENE_WORD_SHOW, sceneWordReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.BUFF_STATE_UPDATE, buffStateUpdateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.COLLECT_STATE, collectStateReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.LIANZHAN, lianZhanReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CITYKING_INFO, cityKingReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.CITYKING_MOBAI, cityKingMobaiReturn);
        ____654.____680.addSocketHandler(____655.____659.____691.PLAYER_FIX_POS, playerFixPosReturn);
        ____654.____672.addEventListener(____655.____661.global_socketClose, this.socketCloseHandler, this)
    },
    socketCloseHandler: function(evt) {
        this.____1212 = false
    },
    sendPickup: function(id) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PLAYER_GET_DROP);
        messOut.writeInt(id);
        ____654.____680.send(messOut)
    },
    sendMapEnter: function(gateId) {
        if (this.____1212) {
            return
        }
        this.____1212 = true;
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MAP_ENTER);
        messOut.writeInt(gateId);
        ____654.____680.send(messOut)
    },
    sendRoundInfo: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MAP_ROUND_INFO);
        ____654.____680.send(messOut)
    },
    sendWalk: function(pathList) {
        var len = pathList.length;
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PLAYER_MOVE);
        messOut.writeNumber(____655.____667.userId);
        messOut.writeShort(len);
        for (var i = 0; i < len; i++) {
            var p = pathList[i];
            messOut.writeShort(p.x);
            messOut.writeShort(p.y)
        }
        ____654.____680.send(messOut)
    },
    sendWalkStep: function(x, y, index) {
        if (this.____1327 == x && this.____1328 == y) return;
        this.____1327 = x;
        this.____1328 = y;
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PLAYER_MOVE_STEP);
        messOut.writeShort(Math.ceil(x));
        messOut.writeShort(Math.ceil(y));
        messOut.writeShort(index);
        ____654.____680.send(messOut)
    },
    sendCollectStart: function(id, templateId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.COLLECT_START);
        messOut.writeInt(id);
        messOut.writeInt(templateId);
        ____654.____680.send(messOut)
    },
    sendPlayerCollect: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PLAYER_COLLECT);
        ____654.____680.send(messOut)
    },
    sendPlayerAttack: function(targetServerId, targetType, skillId, targetX, targetY, targetId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PLAYER_ATTACK);
        messOut.writeNumber(targetServerId);
        messOut.writeByte(targetType);
        messOut.writeInt(skillId);
        messOut.writeInt(targetX);
        messOut.writeInt(targetY);
        messOut.writeInt(targetId);
        ____654.____680.send(messOut)
    },
    sendMonsterMove: function(monsterId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MAP_MONSTER_MOVE);
        messOut.writeInt(this._sceneInfo.sceneMonsterList.changeMonsterId(monsterId));
        ____654.____680.send(messOut)
    },
    sendPetAttack: function(targetServerId, targetType, skillId, targetX, targetY, targetId) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PET_ATTACK);
        messOut.writeNumber(targetServerId);
        messOut.writeByte(targetType);
        messOut.writeInt(skillId);
        messOut.writeInt(targetX);
        messOut.writeInt(targetY);
        messOut.writeInt(targetId);
        ____654.____680.send(messOut)
    },
    sendRiderUp: function(value) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.HORSE_UP);
        messOut.writeBoolean(value);
        ____654.____680.send(messOut)
    },
    sendFlyToMap: function(mapId) {
        print("#发送地图传送", mapId);
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.MAP_FLY);
        messOut.writeInt(mapId);
        ____654.____680.send(messOut)
    },
    sendPlayerRelive: function(type) {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PLAYER_RELIVE);
        messOut.writeByte(type);
        ____654.____680.send(messOut)
    },
    sendCitykingMobai: function() {
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.CITYKING_MOBAI);
        ____654.____680.send(messOut)
    },
    sendFixPlayerPos: function(fixX, fixY) {
        print("发送修正玩家位置");
        var messOut = ____654.____680.getMessageOut(____655.____659.____691.PLAYER_FIX_POS);
        messOut.writeShort(fixX);
        messOut.writeShort(fixY);
        ____654.____680.send(messOut)
    },
});
var ____618 = cc.Class.extend({
    sceneModule: null,
    sceneInfo: null,
    _roleSelectViews: null,
    ctor: function(sceneModule) {
        this.sceneModule = sceneModule;
        this.sceneInfo = sceneModule.sceneInfo;
        this._roleSelectViews = {};
        this.____6()
    },
    ____6: function() {
        ____654.____672.addEventListener(____655.____661.trigger_walkToNpc, this.walkToNpcHandler, this);
        ____654.____672.addEventListener(____655.____661.trigger_walkToMonster, this.walkToMonsterHandler, this);
        ____654.____672.addEventListener(____655.____661.trigger_walkToCollect, this.walkToCollectHandler, this);
        ____654.____672.addEventListener(____655.____661.trigger_walkToPoint, this.walkToPointHandler, this);
        ____654.____672.addEventListener(____655.____661.trigger_flyToMap, this.flyToMapHandler, this);
        ____654.____672.addEventListener(____655.____661.sceneInfo_afkUpdate, this.afkUpdateHandler, this);
        ____654.____672.addEventListener(____655.____661.trigger_walkStop, this.walkStopHandler, this)
    },
    gotoMap: function(gateId) {
        if (gateId == -1) {
            this.sceneModule.sceneMessageSender.sendMapEnter(gateId)
        } else {
            var gate = ____655.allTemplates.gateTemplateList.getGate(gateId);
            var map = ____655.allTemplates.mapTemplateList.getMap(gate.nextMapId);
            if (____655.____667.level < map.minLevel || ____655.____667.level > map.maxLevel) {
                ____654.tipsManager.quickTip.show(____654.yuyanbaoManager.getYuyanbao("worldmap.text1", map.minLevel))
            } else {
                this.sceneModule.sceneMessageSender.sendMapEnter(gateId)
            }
        }
    },
    walkToNpcHandler: function(evt) {
        this.sceneModule.walkTester.walkToNPC(evt.data)
    },
    walkToMonsterHandler: function(evt) {
        var monsterInfo = ____655.allTemplates.monsterTemplateList.getMonster(evt.data);
        if (monsterInfo == null) {
            return
        }
        this.sceneModule.walkTester.walkToAFK(monsterInfo.sceneId, monsterInfo.rndPoints)
    },
    walkToCollectHandler: function(evt) {
        this.sceneModule.walkTester.walkToCollectByTemplateId(evt.data)
    },
    walkToPointHandler: function(evt) {
        var list = evt.data;
        if (list == null || list.length < 3) {
            return
        }
        this.sceneModule.walkTester.walkToPoint(list[0], ____654.____673.____159(list[1], list[2]))
    },
    flyToMapHandler: function(evt) {
        this.sceneModule.flyTester.doFly(evt.data)
    },
    afkUpdateHandler: function(evt) {
        var isAfk = evt.data;
        if (isAfk == true) {
            this.sceneModule.attackTester.startAFK()
        } else {
            this.sceneModule.attackTester.stopAFK()
        }
    },
    walkStopHandler: function(evt) {
        this.sceneModule.walkTester.walkStop()
    },
    showRoleSelectView: function(path) {
        var selectView = this._roleSelectViews[path];
        if (selectView == null) {
            selectView = ____654.____673.newKYSprite();
            selectView.setFrame(path);
            this._roleSelectViews[path] = selectView
        }
        if (selectView.getParent() == null) {
            ____654.____676.mapEffContainer.addChild(selectView, 1)
        }
        return selectView
    },
    hideRoleSelectView: function(path) {
        var selectView = this._roleSelectViews[path];
        if (selectView != null) selectView.removeFromParent(false)
    },
    clear: function() {},
});
var ____596 = ____537.extend({
    sceneInfo: null,
    sceneController: null,
    mapController: null,
    scenePlayerController: null,
    sceneNpcController: null,
    sceneCollectController: null,
    sceneMonsterController: null,
    sceneGateController: null,
    sceneDropController: null,
    scenePetController: null,
    scenePanelController: null,
    roleVisibleTester: null,
    walkTester: null,
    mapTester: null,
    flyTester: null,
    attackTester: null,
    pickupTester: null,
    jumpTester: null,
    sceneMessageSender: null,
    mapShakeBehavior: null,
    newlyBehavior: null,
    setup: function(data) {
        this.sceneInfo = new SceneInfo(this);
        ____655.warDatas.setSceneInfo(this.sceneInfo);
        this.sceneController = new ____618(this);
        this.scenePanelController = new ____2244(this);
        this.scenePanelController.init();
        this.mapController = new ____633(this);
        this.sceneMessageSender = new ____2463(this);
        this.scenePlayerController = new ____2432(this.sceneController);
        this.sceneNpcController = new ____2427(this.sceneController);
        this.sceneCollectController = new ____2419(this);
        this.sceneMonsterController = new ____2425(this);
        this.sceneGateController = new ____2423(this.sceneController);
        this.sceneDropController = new ____2421(this.sceneController);
        this.scenePetController = new ____2430(this);
        this.roleVisibleTester = new ____2469(this);
        this.walkTester = new ____2470(this);
        this.mapTester = new ____2467(this);
        this.flyTester = new ____2465(this);
        this.attackTester = new ____2464(this);
        this.pickupTester = new ____2468(this);
        this.jumpTester = new ____2466(this);
        this.mapShakeBehavior = new ____2400();
        ____654.____672.addEventListener(____655.____661.common_clearAllData, this.____61, this);
        this.____151(data);
        this.sceneController.gotoMap(-1)
    },
    ____151: function(data) {
        this.sceneController.gotoMap(-1)
    },
    intoMap: function(playerX, playerY) {
        ____654.panelQuote.showLoadingPanel();
        ____654.panelQuote.setLoadingPercent(10);
        ____654.____676.____145();
        this.scenePlayerController.clear();
        this.sceneNpcController.clear();
        this.sceneMonsterController.clear();
        this.sceneGateController.clear();
        this.sceneDropController.clear();
        this.scenePetController.clear();
        this.sceneCollectController.clear();
        this.scenePanelController.clear();
        this.sceneInfo.____145();
        this.mapController.resetScene()
    },
    getNewlyBehavior: function() {
        if (this.newlyBehavior == null) {
            this.newlyBehavior = new NewlyBehavior(this)
        }
        return this.newlyBehavior
    },
    getAttackableRole: function(type, id) {
        var role = null;
        if (type == ____655.____659.commonStaticType.soType_player) {
            role = this.scenePlayerController.____422(id)
        } else if (type == ____655.____659.commonStaticType.soType_monster) {
            role = this.sceneMonsterController.getMonster(id)
        } else if (type == ____655.____659.commonStaticType.soType_pet) {
            role = this.scenePetController.getPet(id)
        }
        return role
    },
    ____61: function(evt) {
        this.scenePlayerController.clear();
        this.sceneNpcController.clear();
        this.sceneMonsterController.clear();
        this.sceneGateController.clear();
        this.sceneDropController.clear();
        this.scenePetController.clear();
        this.sceneCollectController.clear();
        this.scenePanelController.____61();
        this.sceneInfo.clear()
    },
});
var ____2464 = cc.Class.extend({
    sceneModule: null,
    sceneInfo: null,
    ctor: function(module) {
        this.sceneModule = module;
        this.sceneInfo = module.sceneInfo
    },
    selfCanDoAttack: function() {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return false;
        if (____655.allTemplates.mapTemplateList.getMap(____655.currentMapId).isInSafeArea(selfPlayer.____355())) {
            return false
        }
        return selfPlayer.____397()
    },
    targetCanBeAttack: function(target, showTip) {
        var p = target.____355();
        if (____655.allTemplates.mapTemplateList.getMap(____655.currentMapId).isInSafeArea(p)) {
            return false
        }
        if (target.____402() == ____655.____659.commonStaticType.soType_player) {
            return this.playerCanBeAttack(target, showTip)
        } else if (target.____402() == ____655.____659.commonStaticType.soType_monster) {
            return this.monsterCanBeAttack(target, showTip)
        }
        return false
    },
    playerCanBeAttack: function(target, showTip) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return false;
        if (target == selfPlayer) return true;
        var result = "";
        if (target.____398() == false) {
            result = "对象不能被攻击"
        } else if (____655.allTemplates.mapTemplateList.____462(____655.currentMapId) == false || ____655.copyInfo.currentId == 0 || ____655.allTemplates.copyTemplateList.____462(____655.copyInfo.currentId) == false) {
            result = "当前场景不能攻击"
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID || ____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.DALUANDOU_COPYID) {
            if (target.warState == selfPlayer.warState) {
                result = "同阵营不能攻击"
            }
        }
        if (result != "") {
            if (showTip == true) {}
            return false
        }
        return true
    },
    monsterCanBeAttack: function(target, showTip) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return false;
        var result = "";
        if (target.____398() == false) {
            result = "对象不能被攻击"
        } else if (____655.copyInfo.currentId == ____655.allTemplates.copyTemplateList.JIAZUWAR_COPYID) {
            if (target.warState == selfPlayer.warState) {
                result = "同阵营不能攻击"
            }
        }
        if (result != "") {
            if (showTip == true) {}
            return false
        }
        return true
    },
    doAttack: function(skill, target, targetPos) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null || skill == null) return;
        this.sceneModule.walkTester.doRider(false, false);
        selfPlayer.setCollectId(-1);
        var tmpX = -1;
        var tmpY = -1;
        if (targetPos != null) {
            tmpX = targetPos.x;
            tmpY = targetPos.y
        } else {
            var p = target.____355();
            tmpX = p.x;
            tmpY = p.y
        }
        var skillList = ____655.skillItemList.skillList;
        if (skill.template.commonCD) {
            for (var i in skillList) {
                var tmpS = skillList[i];
                if (tmpS.template.commonCD) {
                    tmpS.setCommonCD()
                }
            }
        }
        this.doSkill(skill, target.getObjServerId(), target.____402(), tmpX, tmpY, target.____357());
        ____655.skillItemList.moveAFKSkillToBack(skill.id)
    },
    doSkill: function(skill, targetServerId, targetType, targetX, targetY, targetId) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null || skill == null) return;
        if (!____655.allTemplates.____789.isFlash(skill.template.attackEffect)) {
            var behaviorInfo = new ____2399();
            behaviorInfo.attackId = selfPlayer.____357();
            behaviorInfo.attackType = selfPlayer.____402();
            behaviorInfo.attackName = selfPlayer.getName();
            behaviorInfo.skillId = skill.id;
            behaviorInfo.skillLevel = skill.level;
            behaviorInfo.skillX = targetX;
            behaviorInfo.skillY = targetY;
            behaviorInfo.targetId = targetServerId;
            behaviorInfo.targetType = targetType;
            selfPlayer.doAttackBehavior(behaviorInfo)
        }
        if (skill.template.showSkillName) {
            var p = ____654.____673.____159(selfPlayer.____355().x, selfPlayer.____355().y);
            if (____655.____659.____686.isLeft(selfPlayer.____96())) {
                p.x += 80
            } else {
                p.x -= 120
            }
            var skillName = new ____2410(skill.id, p, 1)
        }
        if (!!skill.template && skill.template.sound > 0) {
            ____654.soundManager.playSound(skill.template.sound)
        }
        this.sceneModule.sceneMessageSender.sendPlayerAttack(targetServerId, targetType, skill.id, targetX, targetY, targetId);
        skill.setLastUseTime(____655.____662.getSystemTime());
        if (skill == this.sceneInfo.getCurrentSkill()) {
            this.sceneInfo.setCurrentSkill(null)
        }
    },
    petDoAttack: function(skill, target, targetPos) {
        var selfPet = this.sceneInfo.scenePetList.selfPet;
        if (selfPet == null) return;
        var tmpX = -1;
        var tmpY = -1;
        if (targetPos != null) {
            tmpX = targetPos.x;
            tmpY = targetPos.y
        } else {
            var p = target.____355();
            tmpX = p.x;
            tmpY = p.y
        }
        var behaviorInfo = new ____2399();
        behaviorInfo.attackId = selfPet.____357();
        behaviorInfo.attackType = selfPet.____402();
        behaviorInfo.attackName = selfPet.getName();
        behaviorInfo.skillId = skill.id;
        behaviorInfo.skillLevel = skill.level;
        behaviorInfo.skillX = tmpX;
        behaviorInfo.skillY = tmpY;
        behaviorInfo.targetId = target.____357();
        behaviorInfo.targetType = target.____402();
        selfPet.doAttackBehavior(behaviorInfo);
        this.sceneModule.sceneMessageSender.sendPetAttack(target.getObjServerId(), target.____402(), skill.id, tmpX, tmpY, target.____357());
        skill.setLastUseTime(____655.____662.getSystemTime());
        ____655.advanceItemList.getItemByType(____655.____659.commonStaticType.style_Pet).moveAFKSkillToBack(skill.id)
    },
    startAFK: function() {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        if (!____655.allTemplates.mapTemplateList.canAFK(____655.currentMapId)) return;
        selfPlayer.walkStop();
        selfPlayer.stateInfo.setAttackCommon();
        selfPlayer.stateInfo.setAFK();
        ____654.____672.dispatchEvent(new ____590(____655.____661.playerInfo_afkChange, ____654.____672, true))
    },
    stopAFK: function() {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        selfPlayer.stateInfo.setAttackCommon();
        ____654.____672.dispatchEvent(new ____590(____655.____661.playerInfo_afkChange, ____654.____672, false))
    },
    startAttack: function() {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        selfPlayer.walkStop();
        selfPlayer.stateInfo.setAttackCommon();
        selfPlayer.stateInfo.setAttacking()
    },
    stopAttack: function() {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        selfPlayer.stateInfo.setAttackCommon()
    },
});
var ____2465 = cc.Class.extend({
    sceneModule: null,
    sceneController: null,
    sceneInfo: null,
    ctor: function(module) {
        this.sceneModule = module;
        this.sceneInfo = module.sceneInfo;
        this.sceneController = module.sceneController
    },
    doFly: function(mapId) {
        if (!this.canFly()) {
            return
        }
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        var mapInfo = ____655.allTemplates.mapTemplateList.getMap(mapId);
        if (____655.____667.level < mapInfo.minLevel) {
            ____654.tipsManager.quickTip.show("等级不足");
            return
        }
        this.sceneModule.sceneMessageSender.sendFlyToMap(mapId)
    },
    canFly: function(mapId) {
        return true
    }
});
var ____2466 = cc.Class.extend({
    sceneModule: null,
    sceneController: null,
    ctor: function(sceneModule) {
        this.sceneModule = sceneModule;
        this.sceneController = sceneModule.sceneController
    },
    otherDoJump: function(type, id, pos, jumpType) {
        var role = this.sceneModule.getAttackableRole(type, id);
        if (role != null && role.____356().stateInfo.jumping == false) {
            role.____356().setPath(null);
            role.doJump(pos, jumpType)
        } else {
            var roleInfo = this.sceneModule.sceneInfo.getAttackableRoleInfo(type, id);
            if (roleInfo != null) {
                roleInfo.setPath(null);
                roleInfo.____354(pos)
            }
        }
    },
});
var ____2467 = cc.Class.extend({
    sceneModule: null,
    sceneController: null,
    sceneInfo: null,
    ctor: function(module) {
        this.sceneModule = module;
        this.sceneInfo = module.sceneInfo;
        this.sceneController = module.sceneController
    },
    enterMapComplate: function() {
        print("地图数据加载完成", ____655.currentMapId);
        if (____655.____667.exp == 0 && ____655.statInfo.welcomeState == 2) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.welcome_awardPanel, ____654.____672, null))
        }
        if (____655.copyInfo.lastId > 0 && ____655.copyInfo.currentId <= 0) {
            if (____655.____667.outCopyTrigger != null) {
                ____654.triggerManager.handlerList([____655.____667.outCopyTrigger]);
                ____655.____667.outCopyTrigger = null
            }
            ____655.copyInfo.lastId = ____655.copyInfo.currentId
        }
        var scenePath = ____655.____667.scenePath;
        if (scenePath != null && scenePath.length > 0) {
            scenePath.shift();
            if (scenePath.length > 0) {
                this.sceneModule.walkTester.walkToGate(scenePath[0])
            } else {
                if (____655.____667.scenePathTarget != null) {
                    this.sceneModule.walkTester.____431(____655.currentMapId, ____655.____667.scenePathTarget, ____655.____667.scenePathStopAtDistance, ____655.____667.scenePathCallback)
                }
            }
        }
        if (____655.____667.flyCallback != null) {
            var callBack = ____655.____667.flyCallback;
            ____655.____667.flyCallback = null;
            callBack()
        }
        if (____655.allTemplates.mapTemplateList.canAFK(____655.currentMapId) == false || ____655.allTemplates.copyTemplateList.canAFK(____655.copyInfo.currentId) == false) {} else {}
        if (____655.allTemplates.copyTemplateList.canHidePlayer(____655.copyInfo.currentId)) {} else {}
        if (____655.copyInfo.currentId > 0) {
            if (____655.allTemplates.copyTemplateList.isAutoAFK(____655.copyInfo.currentId)) {
                this.sceneModule.attackTester.startAFK()
            } else {
                this.sceneModule.attackTester.stopAFK()
            }
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_exitBtn, ____654.____672, true))
        } else {
            this.sceneModule.attackTester.stopAFK();
            if (____655.allTemplates.mapTemplateList.isShowCityBtn(____655.currentMapId)) {
                ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_exitBtn, ____654.____672, true))
            } else {
                ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_exitBtn, ____654.____672, false))
            }
        }
        if (____655.currentMapId == ____655.allTemplates.mapTemplateList.CITY_ID) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_fightMode, ____654.____672, 0));
            this.sceneModule.scenePlayerController.createChenZhu()
        } else if (____655.copyInfo.currentId <= 0) {
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_fightMode, ____654.____672, 1))
        } else {
            ____654.____672.dispatchEvent(new ____590(____655.____661.mainmenu_fightMode, ____654.____672, 2))
        }
        ____654.____672.dispatchEvent(new ____590(____655.____661.common_showFollowPanel, ____654.____672, null))
    },
});
var ____2468 = cc.Class.extend({
    sceneController: null,
    sceneModule: null,
    ctor: function(module) {
        this.sceneModule = module;
        this.sceneController = module.sceneController
    },
    canPickup: function(dropInfo, showTip) {
        var result = -1;
        if (!dropInfo.localPickEnable) {
            result = 0
        } else if (!____655.itemInfoList.getHasPos(1)) {
            result = 1
        } else if (!dropInfo.canPick()) {
            result = 2
        }
        if (result != -1) {
            if (showTip) {}
            return false
        }
        return true
    },
});
var ____2469 = cc.Class.extend({
    sceneModule: null,
    sceneInfo: null,
    ctor: function(sceneModule) {
        this.sceneModule = sceneModule;
        this.sceneInfo = sceneModule.sceneInfo
    },
    checkPlayerShow: function(info) {
        if (this.sceneInfo.scenePlayerList.selfPlayer == null) return false;
        if (info.____357() == ____655.____667.userId) return true;
        if (info.buffInfo.getIsHide()) return false;
        if (this.sceneModule.attackTester.playerCanBeAttack(info, false)) return true;
        return ____655.gameSetting.showOtherPlayer
    },
    checkNpcShow: function(info, targetPos) {
        if (targetPos != null) {
            if (____654.____674.____179(targetPos, info.____355()) > 500) {
                return false
            }
        }
        return true
    },
    checkMonsterShow: function(monsterInfo) {
        return true
    },
    checkPetShow: function(petInfo) {
        if (!____655.allTemplates.copyTemplateList.isShowPetCharacter(____655.copyInfo.currentId)) {
            return false
        }
        var owner = this.sceneModule.scenePlayerController.____422(petInfo.ownerId);
        if (owner != null) {
            return owner.____351()
        }
        return false
    },
    checkGateShow: function(info, targetPos) {
        if (targetPos != null) {
            if (____654.____674.____179(targetPos, info.____355()) > 500) {
                return false
            }
        }
        return true
    },
    checkCollectShow: function(collectInfo) {
        return true
    },
});
var ____2470 = cc.Class.extend({
    sceneModule: null,
    sceneController: null,
    sceneInfo: null,
    doubleClickCancel: false,
    clickCount: 0,
    ctor: function(module) {
        this.sceneModule = module;
        this.sceneInfo = module.sceneInfo;
        this.sceneController = module.sceneController
    },
    setDoubleClickCancel: function(value) {
        this.doubleClickCancel = value;
        this.clickCount = 0
    },
    getAStarPath: function(p1, p2, stopAtDistance) {
        var result = [];
        if (stopAtDistance == null) stopAtDistance = 0;
        if (stopAtDistance > 0) {
            if (____654.____674.____179(p1, p2) <= stopAtDistance) {
                result.push(p1);
                return result
            }
        }
        var startP = ____654.____673.____159(p1.x, p1.y);
        var endP = ____654.____673.____159(p2.x, p2.y);
        result = ____654.____674.astar.findPath(startP, endP);
        if (result != null && result.length > 0) {
            if (stopAtDistance > 0) {
                result = this.cutPathEnd(result, stopAtDistance)
            }
            return result
        }
        return []
    },
    getAroundPath: function(selfPos, targetPos) {
        var p = ____654.____674.astar.getAroundPoint(selfPos, targetPos, 2);
        if (p != null) {
            var path = [];
            path.push(____654.____673.____159(selfPos.x, selfPos.y));
            path.push(____654.____673.____159(targetPos.x, targetPos.y));
            return path
        }
        return []
    },
    cutPathEnd: function(path, distance) {
        var len = path.length;
        if (distance > 0 && len >= 2) {
            var p1 = path[len - 2];
            var p2 = path[len - 1];
            if (____654.____674.____179(p1, p2) > distance) {
                var mapInfo = this.sceneInfo.sceneMapList.getMap(____655.currentMapId);
                if (mapInfo != null) {
                    var angle = ____655.____659.____686.____98(p1, p2);
                    var dx = Math.cos(angle) * distance;
                    var dy = Math.sin(angle) * distance;
                    var tmpx = p2.x - dx;
                    var tmpy = p2.y - dy;
                    if (mapInfo.getValue(tmpx, tmpy) != ____655.____659.commonStaticType.mapBlock_empty) {
                        p2.x = tmpx;
                        p2.y = tmpy
                    }
                }
            } else {
                path.splice(len - 1, 1)
            }
        }
        return path
    },
    ____460: function() {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null || !selfPlayer.isCanMove()) return false;
        return true
    },
    ____431: function(mapId, targetP, stopAtDistance, cb, useAstar) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (this.____460() == false) return;
        if (useAstar == null) useAstar = true;
        var tmpCB = cb;
        var selfPos = selfPlayer.____355();
        var path = [];
        selfPlayer.setCollectId(-1);
        if (stopAtDistance == null) stopAtDistance = 0;
        if (mapId != ____655.currentMapId) {
            ____655.____667.setScenePath([0], targetP, tmpCB, stopAtDistance);
            this.sceneModule.flyTester.doFly(mapId)
        } else {
            if (targetP == null || ____654.____674.____179(selfPos, targetP) < 2) {
                var tmpP = [];
                tmpP.push(selfPos);
                selfPlayer.setPath(tmpP, tmpCB)
            } else {
                if (useAstar) path = this.getAStarPath(selfPos, targetP, stopAtDistance);
                else {
                    path = [selfPos, targetP]
                }
            }
        }
        var pathLen = path.length;
        if (pathLen > 0) {
            var dis = ____654.____674.____179(selfPos, path[pathLen - 1]);
            if (dis < 2) {
                var tmpPP = [];
                tmpPP.push(selfPos);
                selfPlayer.setPath(tmpPP, tmpCB)
            } else {
                if (dis > 600) {
                    this.doRider(true, false)
                }
                this.sceneModule.sceneMessageSender.sendWalk(path);
                selfPlayer.setPath(path, tmpCB)
            }
        }
    },
    doRider: function(value, tip) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        var current = selfPlayer.figureInfo.characterInfo.getIsHorse();
        if (value == current) return;
        if (tip == null) tip = true;
        if (value) {
            var tipStr = "";
            if (selfPlayer.stateInfo.getIsFight()) {
                tipStr = "战斗状态无法乘骑"
            } else if (!____655.allTemplates.copyTemplateList.canRider(____655.copyInfo.currentId)) {
                tipStr = "当前场景无法乘骑"
            } else if (selfPlayer.figureInfo.characterInfo.getIsBuffChange()) {
                tipStr = "变身状态无法乘骑"
            }
            if (tipStr == "") {
                this.sceneModule.sceneMessageSender.sendRiderUp(true)
            } else if (tip) {
                ____654.tipsManager.quickTip.show(tipStr)
            }
        } else {
            this.sceneModule.sceneMessageSender.sendRiderUp(false)
        }
    },
    walkToPoint: function(mapId, p, stopAtDistance, cb, doubleClickCancel, useAstar) {
        if (stopAtDistance == null) stopAtDistance = 0;
        if (doubleClickCancel == null) doubleClickCancel = false;
        if (useAstar == null) useAstar = true;
        this.sceneModule.attackTester.stopAFK();
        this.setDoubleClickCancel(doubleClickCancel);
        var selfP = this.sceneModule.scenePlayerController.selfPlayer;
        if (selfP != null) {
            selfP.stopAttack()
        }
        if (this.fixToNearlyCanwalk()) {
            this.____431(mapId, p, stopAtDistance, cb, useAstar)
        }
    },
    walkToNPC: function(npcId) {
        var npc = ____655.allTemplates.npcTemplateList.getNpc(npcId);
        if (npc == null) return;
        var this_ = this;

        function showNpcPanel() {
            ____654.____676.showNpcPanel(npcId);
            if (npc != null && this_.sceneInfo.scenePlayerList.selfPlayer != null) {
                this_.sceneInfo.scenePlayerList.selfPlayer.faceToPoint(____654.____673.____159(npc.sceneX, npc.sceneY))
            }
        }
        this.walkToPoint(npc.mapId, npc.rndPoints, 0, showNpcPanel, true)
    },
    walkToGate: function(gateId) {
        var gate = ____655.allTemplates.gateTemplateList.getGate(gateId);
        if (gate == null) return;
        var this_ = this;

        function gotoScene() {
            this_.sceneController.gotoMap(gateId)
        }
        this.walkToPoint(gate.mapId, gate.pos, 0, gotoScene)
    },
    walkToDrop: function(dropInfo) {
        var this_ = this;

        function doPickup() {
            if (!this_.sceneModule.pickupTester.canPickup(dropInfo, true)) return;
            dropInfo.localPickEnable = false;
            this_.sceneModule.sceneMessageSender.sendPickup(dropInfo.____357())
        }
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer != null) {
            if (!this.sceneModule.pickupTester.canPickup(dropInfo, true)) return;
            var p2 = dropInfo.____355();
            var p1 = selfPlayer.____355();
            if (____654.____674.____179(p1, p2) <= ____655.pickupRadius) {
                doPickup()
            } else {
                this.walkToPoint(____655.currentMapId, p2, ____655.pickupRadius, doPickup)
            }
        }
    },
    walkToCollect: function(collectInfo) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        if (!collectInfo.canCollect(selfPlayer, true)) return;
        var collectId = collectInfo.____357();
        var this_ = this;

        function doCollect() {
            var selfPlayer = this_.sceneInfo.scenePlayerList.selfPlayer;
            if (selfPlayer != null) {
                selfPlayer.setCollectId(collectId)
            }
        }
        this.walkToPoint(____655.currentMapId, collectInfo.____355(), 60, doCollect)
    },
    walkToCollectByTemplateId: function(templateId) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        var collectTemplateInfo = ____655.allTemplates.collectTemplateList.getCollect(templateId);
        if (collectTemplateInfo == null) {
            return
        }
        var this_ = this;

        function doCollect() {
            selfPlayer = this_.sceneInfo.scenePlayerList.selfPlayer;
            if (selfPlayer == null) return;
            var collect = this_.sceneInfo.sceneCollectList.getNearlyCollectByTemplateId(selfPlayer.____355(), templateId);
            if (collect != null) {
                selfPlayer.setCollectId(collect.____357())
            }
        }
        var mapId = collectTemplateInfo.mapId;
        if (mapId == 0) {
            mapId = ____655.currentMapId
        }
        this.walkToPoint(mapId, collectTemplateInfo.pos, 0, doCollect)
    },
    walkToAFK: function(mapId, p) {
        var selfPlayer = this.sceneInfo.scenePlayerList.selfPlayer;
        if (selfPlayer == null) return;
        var this_ = this;

        function startAfk() {
            this_.sceneModule.attackTester.startAFK()
        }
        this.walkToPoint(mapId, p, 60, startAfk)
    },
    walkStop: function() {
        if (this.sceneInfo.scenePlayerList.selfPlayer != null) {
            this.sceneInfo.scenePlayerList.selfPlayer.walkStop()
        }
    },
    fixToNearlyCanwalk: function() {
        if (this.____460() && this.sceneInfo.scenePlayerList.selfPlayer.isWalking == false) {
            var p = this.sceneInfo.scenePlayerList.selfPlayer.____355();
            if (this.sceneInfo.sceneMapList.getMap(____655.currentMapId).getValue(p.x, p.y) == ____655.____659.commonStaticType.mapBlock_empty) {
                var result = ____654.____674.astar.getAroundNotEmpty(p.x, p.y);
                this.sceneModule.sceneMessageSender.sendFixPlayerPos(result.x, result.y);
                return false
            }
        }
        return true
    },
});
var ____2471 = cc.Class.extend({
    parent: null,
    g: 0,
    h: 0,
    f: 0,
    openIndex: 0,
    ctor: function(parent, g, h, f, openIndex) {
        this.init(parent, g, h, f, openIndex)
    },
    reset: function() {
        this.parent = null;
        this.g = 0;
        this.h = 0;
        this.f = 0;
        this.openIndex = 0
    },
    init: function(parent, g, h, f, openIndex) {
        this.parent = parent;
        this.g = g;
        this.h = h;
        this.f = f;
        this.openIndex = openIndex
    }
});
var AStar = cc.Class.extend({
    MAX_COUNT: 50000,
    G_COST: 10,
    H_COST: 10,
    ____1083: null,
    ____1380: null,
    ____1492: null,
    ____965: 0,
    ____1594: 0,
    ____968: 0,
    ____1708: 0,
    ____1711: null,
    ____1133: null,
    endIndex: null,
    ____1114: 0.707,
    init: function() {
        this.____1492 = [];
        this.____1380 = []
    },
    ____238: function(row, col) {
        return this.____1380[row][col]
    },
    sortOpenList: function(index) {
        var middle = 0,
            firstP, middleP, firstInfo, middleInfo;
        while (index > 1) {
            middle = Math.floor(index * 0.5);
            firstP = this.____1492[index - 1];
            middleP = this.____1492[middle - 1];
            firstInfo = this.____238(firstP.y, firstP.x);
            middleInfo = this.____238(middleP.y, middleP.x);
            if (firstInfo.f < middleInfo.f) {
                this.____1492[index - 1] = middleP;
                this.____1492[middle - 1] = firstP;
                middleInfo.openIndex = index - 1;
                firstInfo.openIndex = middle - 1;
                index = middle
            } else {
                break
            }
        }
    },
    ____291: function(data) {
        this.____1083 = data;
        this.____1594 = data.length;
        this.____968 = data[0].length
    },
    isOpen: function(row, col) {
        var t = this.____1380[row];
        if (!!t) {
            var info = t[col];
            return (!!info && info.openIndex != -1)
        }
        return false
    },
    isClose: function(row, col) {
        var t = this.____1380[row];
        if (!!t) {
            var info = t[col];
            return (!!info && info.openIndex == -1)
        }
        return false
    },
    shiftOpenList: function() {
        if (this.____1492.length == 1) {
            this.____1492.length = 0;
            return
        };
        this.____1492[0] = this.____1492.pop();
        this.____1380[this.____1492[0].y][this.____1492[0].x].openIndex = 0;
        var first = 1,
            tFirst = 0,
            middle = 0;
        while (true) {
            tFirst = first;
            middle = first * 2;
            if (middle <= this.____1492.length) {
                if (this.____1380[this.____1492[first - 1].y][this.____1492[first - 1].x].f > this.____1380[this.____1492[middle - 1].y][this.____1492[middle - 1].x].f) first = middle;
                if (middle + 1 <= this.____1492.length && this.____1380[this.____1492[first - 1].y][this.____1492[first - 1].x].f > this.____1380[this.____1492[middle].y][this.____1492[middle].x].f) first = middle + 1
            };
            if (tFirst == first) break;
            var t = this.____1492[tFirst - 1];
            this.____1492[tFirst - 1] = this.____1492[first - 1];
            this.____1492[first - 1] = t;
            this.____1380[this.____1492[tFirst - 1].y][this.____1492[tFirst - 1].x].openIndex = tFirst - 1;
            this.____1380[this.____1492[first - 1].y][this.____1492[first - 1].x].openIndex = first - 1
        }
    },
    trans: function(t) {
        for (var a in t) {
            t[a].x = ____655.GRID_SIZE * (t[a].x + 0.5);
            t[a].y = ____655.GRID_SIZE * (t[a].y + 0.5)
        }
    },
    posToIndex: function(pos) {
        pos.x = Math.floor(pos.x / ____655.GRID_SIZE);
        pos.y = Math.floor(pos.y / ____655.GRID_SIZE);
        return pos
    },
    indexToPos: function(index) {
        index.x = (index.x + 0.5) * ____655.GRID_SIZE;
        index.y = (index.y + 0.5) * ____655.GRID_SIZE;
        return index
    },
    findPath: function(start, end, stopAtDispatch, maxCount) {
        stopAtDispatch = stopAtDispatch || 0;
        maxCount = maxCount || 3000;
        if (stopAtDispatch > 0) {
            if (____654.____674.____179(start, end) <= stopAtDispatch) return [start]
        }
        this.____1711 = this.cp(start);
        this.____1133 = this.cp(end);
        start = this.cp(start);
        start = this.posToIndex(start);
        this.endIndex = this.posToIndex(end);
        this.____1708 = this.____1083[start.y][start.x] % 10;
        if (this.isEmpty(this.endIndex.y, this.endIndex.x)) {
            stopAtDispatch = 0;
            this.endIndex = this.getAroundNotEmpty1(this.endIndex, 1);
            this.____1133 = this.indexToPos(this.cp(this.endIndex))
        }
        this.init();
        var row = 0,
            col = 0,
            tg = 0,
            th = 0;
        this.____1492.push(start);
        this.____1380[start.y] = [];
        this.____1380[start.y][start.x] = new ____2471(null, 0, 0, 0, 0);
        this.____965 = 1;
        var current = null,
            minRow = 0,
            maxRow = 0,
            minCol = 0,
            maxCol = 0;
        while ((this.____1492.length > 0) && (!(this.isClose(this.endIndex.y, this.endIndex.x)))) {
            current = this.____1492[0];
            this.____1380[current.y][current.x].openIndex = -1;
            this.shiftOpenList();
            minRow = Math.max(0, current.y - 1);
            maxRow = Math.min(current.y + 1, this.____1594 - 1);
            row = minRow;
            minCol = Math.max(0, current.x - 1);
            maxCol = Math.min(current.x + 1, this.____968 - 1);
            row = minRow;
            while (row <= maxRow) {
                col = minCol;
                while (col <= maxCol) {
                    if (!((row == current.y) && (col == current.x)) && (row == current.y || col == current.x || !(this.isEmpty(row, current.x)) && (!this.isEmpty(current.y, col)))) {
                        if (!this.isEmpty(row, col)) {
                            if (!this.isClose(row, col)) {
                                tg = parseInt(this.____1380[current.y][current.x].g, 10) + this.G_COST;
                                if (this.isOpen(row, col)) {
                                    if (tg < this.____1380[row][col].g) {
                                        this.____1380[row][col].parent = current;
                                        this.____1380[row][col].f = (tg + this.____1380[row][col].h);
                                        this.sortOpenList((this.____1380[row][col].openIndex + 1))
                                    }
                                } else {
                                    th = ((Math.abs((row - this.endIndex.y)) + Math.abs((col - this.endIndex.x))) * this.H_COST);
                                    this.____1492.push(cc.p(col, row));
                                    if (!this.____1380[row]) {
                                        this.____1380[row] = []
                                    }
                                    this.____1380[row][col] = new ____2471(current, tg, th, tg + th, this.____1492.length - 1);
                                    this.sortOpenList(this.____1492.length)
                                }
                            }
                        }
                    }
                    col++
                }
                row++
            }
            this.____965++;
            if (this.____965 > maxCount) {
                break
            }
        }
        if (this.isClose(this.endIndex.y, this.endIndex.x)) {
            var result = [],
                tp = this.endIndex;
            while (((!((tp.y == start.y))) || (!((tp.x == start.x))))) {
                result.push(tp);
                tp = this.____1380[tp.y][tp.x].parent
            };
            tp.x = start.x;
            tp.y = start.y;
            result.push(tp);
            result.reverse();
            result = this.optimizePath(result);
            for (var index = result.length - 1; index > 0; index--) {
                if (result[index] == result[index - 1]) result.splice(index, 1)
            }
            this.trans(result);
            result[0] = this.____1711;
            return this.cutPathEnd(result, stopAtDispatch, this.____1133)
        };
        return null
    },
    isEmpty: function(row, col) {
        if (row < 0 || row >= this.____1083.length || col >= this.____1083[0].length || col < 0) return false;
        return this.____1083[row][col] < 100
    },
    posIsEmpty: function(pos) {
        var p = this.posToIndex(____654.____673.____159(pos.x, pos.y));
        return this.isEmpty(p.y, p.x)
    },
    getAroundNotEmpty: function(sceneX, sceneY) {
        var pIndex = this.posToIndex(____654.____673.____159(sceneX, sceneY));
        var resultIndex = this.getAroundNotEmpty1(pIndex);
        if (resultIndex == null) return null;
        return this.indexToPos(resultIndex)
    },
    getAroundNotEmpty1: function(center, i) {
        i = i || 1;
        var startRow = Math.max(center.y - i, 0),
            endRow = Math.min(center.y + i, this.____1594 - 1),
            startCol = Math.max(center.x - i, 0),
            endCol = Math.min(center.x + i, this.____968 - 1);
        var result = null,
            j = 0;
        for (j = startCol; j <= endCol; j++) {
            if (!this.isEmpty(startRow, j)) {
                result = cc.p(j, startRow);
                return result
            }
        }
        for (j = startCol; j <= endCol; j++) {
            if (!this.isEmpty(endRow, j)) {
                result = cc.p(j, endRow);
                return result
            }
        }
        for (j = startRow; j <= endRow; j++) {
            if (!this.isEmpty(j, startCol)) {
                result = cc.p(startCol, j);
                return result
            }
        }
        for (j = startRow; j <= endRow; j++) {
            if (!this.isEmpty(j, endCol)) {
                result = cc.p(endCol, j);
                return result
            }
        }
        if (result == null) return this.getAroundNotEmpty1(center, i + 1);
        return result
    },
    optimizePath: function(path) {
        if (path.length == 0) {
            return []
        }
        var ____809 = path.length,
            ____816 = [],
            ____1106 = [],
            ____808 = 0,
            ____805 = true,
            ____806 = path[0];
        ____816.push(path[0]);
        for (var i = 1; i < ____809; i++) {
            ____1106 = this.diagonalFind(____806, path[i]);
            ____808 = ____1106.length;
            ____805 = true;
            for (var j = 0; j < ____808; j++) {
                if (this.____1083[____1106[j].y][____1106[j].x] == 0) {
                    ____805 = false;
                    break
                }
            }
            if (!____805) {
                if (i > 1) {
                    ____806 = path[(i - 1)];
                    ____816.push(path[(i - 1)])
                }
            }
        }
        ____816.push(path[(____809 - 1)]);
        path = ____816;
        return path
    },
    diagonalFind: function(start_point, end_point) {
        var w = 0,
            h = 0,
            ____814 = 0,
            ____815 = 0,
            ____818 = [],
            ____817 = 0,
            ____812 = 0,
            ____813 = 0,
            ____803 = false,
            ____804 = false,
            ____810 = 0,
            ____811 = 0,
            ____807 = (start_point.x < end_point.x) == (start_point.y < end_point.y);
        if (start_point.x < end_point.x) {
            ____814 = start_point.x;
            ____815 = start_point.y;
            w = end_point.x - ____814;
            h = Math.abs(end_point.y - ____815)
        } else {
            ____814 = end_point.x;
            ____815 = end_point.y;
            w = start_point.x - ____814;
            h = Math.abs(start_point.y - ____815)
        }
        if (w == h) {
            for (____810 = 0; ____810 <= w; ____810++) {
                ____807 ? ____818.push(cc.p(____814 + ____810, ____815 + ____810)) : ____818.push(cc.p(____814 + ____810, ____815 - ____810));
                if (____810 > 0) {
                    ____807 ? ____818.push(cc.p(____814 + ____810 - 1, ____815 + ____810)) : ____818.push(cc.p(____814 + ____810 - 1, ____815 - ____810))
                }
                if (____810 < w) {
                    ____807 ? ____818.push(cc.p(____814 + ____810 + 1, ____815 + ____810)) : ____818.push(cc.p(____814 + ____810 + 1, ____815 - ____810))
                }
            }
        } else if (w > h) {
            ____817 = h / w;
            ____818.push(cc.p(____814, ____815));
            for (____810 = 1; ____810 <= w; ____810++) {
                ____812 = (____810 - .5) * ____817;
                ____813 = (____810 + .5) * ____817;
                ____803 = ____812 > ____811 - .5 && ____812 < ____811 + .5;
                ____804 = ____813 > ____811 - .5 && ____813 < ____811 + .5;
                if (____803 || ____804) {
                    ____807 ? ____818.push(cc.p(____814 + ____810, ____815 + ____811)) : ____818.push(cc.p(____814 + ____810, ____815 - ____811));
                    if (!____804) {
                        ____811++;
                        ____807 ? ____818.push(cc.p(____814 + ____810, ____815 + ____811)) : ____818.push(cc.p(____814 + ____810, ____815 - ____811))
                    }
                }
            }
        } else if (w < h) {
            ____817 = w / h;
            ____818.push(cc.p(____814, ____815));
            for (____810 = 1; ____810 <= h; ____810++) {
                ____812 = (____810 - .5) * ____817;
                ____813 = (____810 + .5) * ____817;
                ____803 = ____812 > ____811 - .5 && ____812 < ____811 + .5;
                ____804 = ____813 > ____811 - .5 && ____813 < ____811 + .5;
                if (____803 || ____804) {
                    ____807 ? ____818.push(cc.p(____814 + ____811, ____815 + ____810)) : ____818.push(cc.p(____814 + ____811, ____815 - ____810));
                    if (!____804) {
                        ____811++;
                        ____807 ? ____818.push(cc.p(____814 + ____811, ____815 + ____810)) : ____818.push(cc.p(____814 + ____811, ____815 - ____810))
                    }
                }
            }
        }
        return ____818
    },
    cutPathEnd: function(paths, distance, targetPos) {
        var path = paths.slice(0);
        if (path.length > 0) path[path.length - 1] = targetPos;
        if (distance > 0 && paths.length >= 2) {
            if (____654.____674.____179(path[path.length - 2], targetPos) > distance) {
                var angle = ____655.____659.____686.____98(path[path.length - 2], path[path.length - 1]);
                var dx = parseInt(Math.cos(angle) * distance, 10);
                var dy = parseInt(Math.sin(angle) * distance, 10);
                var target = this.cp(path[path.length - 1]);
                target.x -= dx;
                target.y -= dy;
                path[path.length - 1] = target
            } else {
                path = path.slice(0, path.length - 1)
            }
        }
        return path
    },
    cp: function(point) {
        return ____654.____673.____159(point.x, point.y)
    },
    getForeworkCanwalkPoint: function(selfPos, dirValue, cellCount) {
        var result = null;
        var p = this.posToIndex(____654.____673.____159(selfPos.x, selfPos.y));
        if (this.isEmpty(p.y, p.x) == true) {
            return null
        }
        var dirType = 0;
        var dirType2 = 0;
        var dirType3 = 0;
        var degrees = dirValue;
        if (degrees < 0) degrees += 360;
        if ((degrees >= 0 && degrees <= 20) || (degrees >= 340)) {
            dirType = 1;
            if (degrees >= 0 && degrees <= 20) {
                dirType2 = 2;
                dirType3 = 3
            } else {
                dirType2 = 8;
                dirType3 = 7
            }
        } else if (degrees > 20 && degrees < 70) {
            dirType = 2;
            if (degrees > 45) {
                dirType2 = 3;
                dirType3 = 4
            } else {
                dirType2 = 1;
                dirType3 = 8
            }
        } else if (degrees >= 70 && degrees <= 110) {
            dirType = 3;
            if (degrees > 90) {
                dirType2 = 4;
                dirType3 = 5
            } else {
                dirType2 = 2;
                dirType3 = 1
            }
        } else if (degrees > 110 && degrees < 160) {
            dirType = 4;
            if (degrees > 135) {
                dirType2 = 5;
                dirType3 = 6
            } else {
                dirType2 = 3;
                dirType3 = 2
            }
        } else if (degrees >= 160 && degrees <= 200) {
            dirType = 5;
            if (degrees > 180) {
                dirType2 = 6;
                dirType3 = 7
            } else {
                dirType2 = 4;
                dirType3 = 3
            }
        } else if (degrees > 200 && degrees < 250) {
            dirType = 6;
            if (degrees > 225) {
                dirType2 = 7;
                dirType3 = 8
            } else {
                dirType2 = 5;
                dirType3 = 4
            }
        } else if (degrees >= 250 && degrees <= 290) {
            dirType = 7;
            if (degrees > 270) {
                dirType2 = 8;
                dirType3 = 1
            } else {
                dirType2 = 6;
                dirType3 = 5
            }
        } else if (degrees > 290 && degrees < 340) {
            dirType = 8;
            if (degrees > 315) {
                dirType2 = 1;
                dirType3 = 2
            } else {
                dirType2 = 7;
                dirType3 = 6
            }
        }
        var resultX = p.x;
        var resultY = p.y;
        for (var i = 1; i <= cellCount; i++) {
            var result1 = this.getPosByDirType(dirType, p, i);
            if (this.isEmpty(result1.y, result1.x) == false) {
                resultX = result1.x;
                resultY = result1.y
            } else {
                if (i == 1) {
                    var result2 = this.getPosByDirType(dirType2, p, i);
                    if (this.isEmpty(result2.y, result2.x) == false) {
                        resultX = result2.x;
                        resultY = result2.y
                    } else {
                        var result3 = this.getPosByDirType(dirType3, p, i);
                        if (this.isEmpty(result3.y, result3.x) == false) {
                            resultX = result3.x;
                            resultY = result3.y
                        }
                    }
                }
                break
            }
        }
        if (resultX == p.x && resultY == p.y) return null;
        return this.indexToPos(____654.____673.____159(resultX, resultY))
    },
    getPosByDirType: function(dirType, p, i) {
        var tmpx = 0;
        var tmpy = 0;
        if (dirType == 1) {
            tmpx = p.x + i;
            tmpy = p.y
        } else if (dirType == 2) {
            tmpx = p.x + i;
            tmpy = p.y - i
        } else if (dirType == 3) {
            tmpx = p.x;
            tmpy = p.y - i
        } else if (dirType == 4) {
            tmpx = p.x - i;
            tmpy = p.y - i
        } else if (dirType == 5) {
            tmpx = p.x - i;
            tmpy = p.y
        } else if (dirType == 6) {
            tmpx = p.x - i;
            tmpy = p.y + i
        } else if (dirType == 7) {
            tmpx = p.x;
            tmpy = p.y + i
        } else if (dirType == 8) {
            tmpx = p.x + i;
            tmpy = p.y + i
        }
        return ____654.____673.____159(tmpx, tmpy)
    },
});